-- This file:
--   http://angg.twu.net/AGDA/2022Cats5.agda.html
--   http://angg.twu.net/AGDA/2022Cats5.agda
--           (find-angg "AGDA/2022Cats5.agda")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
-- Version: 20220129
-- Public domain.
--
-- ;; (find-angg "AGDA/find-agdatype.el")
-- (load       "~/AGDA/find-agdatype.el")
--
-- (find-eev "eev-pdflike.el" "change-default-viewer")
-- (defalias 'find-pdf-page 'find-pdftoolsr-page)
-- (defalias 'find-pdf-page 'find-xpdf-page)
--
-- (defun a () (interactive) (find-angg "AGDA/2022Cats5.agda"))
-- (find-es "agda" "category-theory")
-- (find-agdacatsfile "src/Categories/Category/Core.agda")
-- (find-agdacatsfile "src/Categories/Functor/Core.agda")

-- (find-agdaprimfile "Agda/Builtin/Equality.agda")
-- (find-agdaprimfile "Agda/Builtin/Bool.agda")
-- (find-agdaprimfile "Agda/Builtin/Unit.agda")
-- (find-agdaprimfile "Agda/Builtin/Strict.agda")
-- (find-agdaprimfile "Agda/Builtin/Sigma.agda")
-- (find-agdastdlibsrcfile "Data/Empty.agda")
-- (find-agdastdlibsrcfile "Data/Empty/Irrelevant.agda")
-- (find-agdastdlibsrcfile "Level.agda")
-- (find-agdastdlibsrcfile "Relation/Nullary.agda")
-- (find-agdastdlibsrcfile "Data/Unit/Base.agda")
-- (find-agdastdlibsrcfile "Data/Bool/Base.agda")
-- (find-agdastdlibsrcfile "Relation/Nullary/Reflects.agda")
-- (find-agdastdlibsrcfile "Strict.agda")
-- (find-agdastdlibsrcfile "Function/Base.agda")
-- (find-agdastdlibsrcfile "Data/Sum/Base.agda")
-- (find-agdastdlibsrcfile "Data/These/Base.agda")
-- (find-agdastdlibsrcfile "Data/Product.agda")
-- (find-agdastdlibsrcfile "Data/Maybe/Base.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Core.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Definitions.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/PropositionalEquality/Core.agda")
-- (find-agdastdlibsrcfile "Relation/Nullary/Decidable/Core.agda")
-- (find-agdastdlibsrcfile "Relation/Unary.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Consequences.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Structures.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Bundles.agda")
-- (find-agdastdlibsrcfile "Relation/Binary.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Reasoning/Base/Single.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Reasoning/Setoid.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Indexed/Heterogeneous/Core.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Indexed/Heterogeneous/Definitions.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Indexed/Heterogeneous/Structures.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Indexed/Heterogeneous/Bundles.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Indexed/Heterogeneous.agda")
-- (find-agdastdlibsrcfile "Algebra/Core.agda")
-- (find-agdastdlibsrcfile "Algebra/Definitions.agda")
-- (find-agdastdlibsrcfile "Algebra/Consequences/Base.agda")
-- (find-agdastdlibsrcfile "Algebra/Consequences/Setoid.agda")
-- (find-agdastdlibsrcfile "Algebra/Structures.agda")
-- (find-agdastdlibsrcfile "Algebra/Bundles.agda")
-- (find-agdastdlibsrcfile "Algebra.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/PropositionalEquality/Properties.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/PropositionalEquality/Algebra.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/Indexed/Heterogeneous/Construct/Trivial.agda")
-- (find-agdastdlibsrcfile "Function/Equality.agda")
-- (find-agdastdlibsrcfile "Axiom/UniquenessOfIdentityProofs.agda")
-- (find-agdastdlibsrcfile "Axiom/Extensionality/Propositional.agda")
-- (find-agdastdlibsrcfile "Relation/Binary/PropositionalEquality.agda")

module 2022Cats5 where

open import Level
open import Function.Base   using (flip)
open import Relation.Binary using (Rel; IsEquivalence; Setoid)
open import Relation.Binary.PropositionalEquality as ≡ using (_≡_)
import      Relation.Binary.Reasoning.Setoid as SetoidR

record Category (o ℓ e : Level) : Set (suc (o ⊔ ℓ ⊔ e)) where
  eta-equality
  infix  4 _⇒_
  -- infix  4 _≈_
  infixr 9 _∘_

  field
    Obj : Set o
    _⇒_ : Rel Obj ℓ
    -- _≈_ : ∀ {A B} → Rel (A ⇒ B) e
    id  : ∀ {A} → (A ⇒ A)
    _∘_ : ∀ {A B C} → (B ⇒ C) → (A ⇒ B) → (A ⇒ C)
    assoc     : ∀ {A B C D} {f : A ⇒ B} {g : B ⇒ C} {h : C ⇒ D} → (h ∘ g) ∘ f ≡ h ∘ (g ∘ f)
    sym-assoc : ∀ {A B C D} {f : A ⇒ B} {g : B ⇒ C} {h : C ⇒ D} → h ∘ (g ∘ f) ≡ (h ∘ g) ∘ f
    identityˡ : ∀ {A B} {f : A ⇒ B} → id ∘ f ≡ f
    identityʳ : ∀ {A B} {f : A ⇒ B} → f ∘ id ≡ f

  o-level : Level
  o-level = o
  ℓ-level : Level
  ℓ-level = ℓ
  e-level : Level
  e-level = e

  -- -- Reasoning combinators.  _≈⟨_⟩_ and _≈˘⟨_⟩_ from SetoidR.
  -- -- Also some useful combinators for doing reasoning on _∘_ chains
  -- module HomReasoning {A B : Obj} where
  --   open SetoidR (hom-setoid {A} {B}) public
  --   -- open Equiv {A = A} {B = B} public

  --   infixr 4 _⟩∘⟨_ refl⟩∘⟨_
  --   infixl 5 _⟩∘⟨refl
  --   _⟩∘⟨_ : ∀ {M} {f h : M ⇒ B} {g i : A ⇒ M} → f ≡ h → g ≡ i → f ∘ g ≡ h ∘ i
  --   _⟩∘⟨_ = ∘-resp-≡

  --   -- refl⟩∘⟨_ : ∀ {M} {f : M ⇒ B} {g i : A ⇒ M} → g ≡ i → f ∘ g ≡ f ∘ i
  --   -- refl⟩∘⟨_ = Equiv.refl ⟩∘⟨_

  --   -- _⟩∘⟨refl : ∀ {M} {f h : M ⇒ B} {g : A ⇒ M} → f ≡ h → f ∘ g ≡ h ∘ g
  --   -- _⟩∘⟨refl = _⟩∘⟨ Equiv.refl

  --   -- -- convenient inline versions
  --   -- infix 2 ⟺
  --   -- infixr 3 _○_
  --   -- ⟺ : {f g : A ⇒ B} → f ≡ g → g ≡ f
  --   -- ⟺ = Equiv.sym
  --   -- _○_ : {f g h : A ⇒ B} → f ≡ g → g ≡ h → f ≡ h
  --   -- _○_ = Equiv.trans






-- private
--   variable
--     o ℓ e o′ ℓ′ e′ : Level

-- record Functor (C : Category o ℓ e) (D : Category o′ ℓ′ e′) : Set (o ⊔ ℓ ⊔ e ⊔ o′ ⊔ ℓ′ ⊔ e′) where
--   eta-equality
--   private module C = Category C
--   private module D = Category D

--   field
--     F₀ : C.Obj → D.Obj
--     F₁ : ∀ {A B} (f : C [ A , B ]) → D [ F₀ A , F₀ B ]

--     identity     : ∀ {A} → D [ F₁ (C.id {A}) ≈ D.id ]
--     homomorphism : ∀ {X Y Z} {f : C [ X , Y ]} {g : C [ Y , Z ]} →
--                      D [ F₁ (C [ g ∘ f ]) ≈ D [ F₁ g ∘ F₁ f ] ]
--     F-resp-≈     : ∀ {A B} {f g : C [ A , B ]} → C [ f ≈ g ] → D [ F₁ f ≈ F₁ g ]

--   -- nice shorthands
--   ₀ = F₀
--   ₁ = F₁



{-
-- (find-es "agda" "agda-user-manual")
-- (find-efunctiondescr 'agda2-mode)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
export LC_ALL=en_GB.UTF-8
agda -v 2 2022Cats5.agda  | tee /tmp/o

# (find-es "agda" "loading-process")

stack exec --       agda --compile 2022Cats5.agda
./2022Cats5
                    agda --compile 2022Cats5.agda
agda --ghc-dont-call-ghc --compile 2022Cats5.agda

agda  --help
stack --help
# agda -i. -i/usr/share/agda-stdlib --interactive 2022Cats5.agda
# :load 2022Cats5.agda
# :?

-}





-- Local Variables:
-- coding:  utf-8-unix
-- End:
