-- This file:
--   http://angg.twu.net/AGDA/2022HuC4.agda.html
--   http://angg.twu.net/AGDA/2022HuC4.agda
--           (find-angg "AGDA/2022HuC4.agda")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
-- Version: 20220314
-- Public domain.
--
-- ;; (find-angg "AGDA/find-agdatype.el")
-- (load       "~/AGDA/find-agdatype.el")
--
-- (find-eev "eev-pdflike.el" "change-default-viewer")
-- (defalias 'find-pdf-page 'find-pdftoolsr-page)
-- (defalias 'find-pdf-page 'find-xpdf-page)
--
-- (defun a2 () (interactive) (find-angg "AGDA/2022HuC2.agda"))
-- (defun a3 () (interactive) (find-angg "AGDA/2022HuC3.agda"))
-- (defun a4 () (interactive) (find-angg "AGDA/2022HuC4.agda"))
-- (defun a5 () (interactive) (find-angg "AGDA/2022HuC5.agda"))
-- (defun a  () (interactive) (find-angg "AGDA/2022HuC4.agda"))
-- (defun a45 () (interactive) (find-2a '(a4) '(a5)))

module 2022HuC4 where

open import Level
open import Function.Base using (flip)
open import Relation.Binary using (Rel; IsEquivalence)
open import Relation.Binary.PropositionalEquality as ≡ using (_≡_)
open import Categories.Category
open import Categories.Category.Core
open import Categories.Category.Instance.Sets
open import Categories.Category.Product
open import Categories.Functor using (Functor; _∘F_)
open import Categories.Functor.Bifunctor
open import Categories.Functor.Construction.Constant
open import Categories.Functor.Core
open import Categories.Functor.Hom
open import Categories.NaturalTransformation
import Categories.Yoneda

Carrier = Relation.Binary.Setoid.Carrier

-- (find-agdacatscfile "Category.agda" "_[_,_]")

module RB  = Relation.Binary
module RBS = Relation.Binary.Setoid


SmallCategory = Category zero zero zero

module Y0 (catA : SmallCategory)
          (catB : SmallCategory)
          (R    : Functor catB catA)
          (A    : Category.Obj catA)
          (C    : Category.Obj catB)
  where
    S0 = Sets zero
    ObjsA = Category.Obj catA
    ObjsB = Category.Obj catB
    module HomA = Hom catA
    module HomB = Hom catB
    module HomS = Hom S0
    infix 10  A[_,_] A[_≈_] A[_∘_]
    infix 10  B[_,_] B[_≈_] B[_∘_]
    A[_,_] = _[_,_] catA
    B[_,_] = _[_,_] catB
    A[_≈_] = _[_≈_] catA
    B[_≈_] = _[_≈_] catB
    A[_∘_] = _[_∘_] catA
    B[_∘_] = _[_∘_] catB
    --
    -- Define the functor [C,-], i.e., Hom_catB(C,-):
    [C,-]  = HomB.Hom[ C ,-]
    [C,-]0 = Functor.₀ [C,-]
    [C,-]1 = Functor.₁ [C,-]
    --
    -- Define the functor [A,R-], i.e., Hom_catA(A,R-):
    catAop     = Category.op catA
    D↦*↦Aop    : Functor catB catAop
    D↦*↦Aop    = const A
    D↦RD       = R
    D↦<Aop,RD> = D↦*↦Aop ※ D↦RD
    D↦[Aop,RD] = (Hom.Hom[-,-] catA) ∘F D↦<Aop,RD>
    [A,R-]     = D↦[Aop,RD]
    [A,R-]0    = Functor.₀ [A,R-]
    --
    [D] = ObjsB
    [E] = ObjsB
    [F] = ObjsB
    R0  = Functor.₀ R
    --
    -- Define the space of "T"s, i.e., Nat([C,-],[A,R-]):
    [T]        = NaturalTransformation [C,-] [A,R-]
    --
    [C,C]      = Carrier ([C,-]0 C)
    fooo       = B[ C , C ]
    -- waa        : [C,C] → [C,C]
    -- waa f = f
    --
    -- [T0]       = (D : [D]) → HomS.Hom[ [C,-]0 D , [A,R-]0 D ]
    --
    -- Define the space of "η"s:
    --
    --
    -- (find-agdatype "Y0.foo")
    -- (find-agdatype "RBS.Carrier Y0.foo")
    -- (find-agdatype "Y0.fooo")
    -- (find-agdatype "Y0.[C,C]")
    -- (find-agdatype "Y0.D↦<Aop,RD>")
    -- (find-agdatype "Y0.D↦*↦Aop")
    -- (find-agdatype "Y0.D↦*↦Aop")
    -- (find-agdatype "Y0.catAop")
    -- (find-agdatype "catAop")
    -- (find-agdanorm "Y0.foo3")
    -- (find-agdanorm "Y0.foo4")
    -- bar = Hom.Hom[-,-] ∘F D↦<Aop,RD>
    -- const : (d : Category.Obj D) → Functor C D


-- D |-> A1op
-- D |-> RD
-- D |-> (A1op,RD)
-- (A1op,A2) |-> Hom[A1,A2]
-- [A,R-]

-- Local Variables:
-- coding:  utf-8-unix
-- End:
