-- This file:
--   http://angg.twu.net/AGDA/Cats2.agda.html
--   http://angg.twu.net/AGDA/Cats2.agda
--           (find-angg "AGDA/Cats2.agda")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
--
-- (defun e1 () (interactive) (find-angg "AGDA/Cats1.agda"))
-- (defun e  () (interactive) (find-angg "AGDA/Cats2.agda"))
--
-- ;; (find-angg "AGDA/find-agdatype.el")
-- (load       "~/AGDA/find-agdatype.el")
--
-- (find-eev "eev-pdflike.el" "change-default-viewer")
-- (defalias 'find-pdf-page 'find-pdftools-page)
-- (defalias 'find-pdf-page 'find-xpdf-page)
-- (favp 33 "basic-example-full")
-- (fava    "basic-example-full")
-- (defun fa1 () (favp 33 "basic-example-full"))
-- (defun fa2 () (interactive) (find-2a nil '(fa1)))

open import Level
open import Relation.Binary.PropositionalEquality as Eq
open Eq.≡-Reasoning

module Cats2 where



record Cat {ℓ₀ ℓ₁ : Level}
     : Set (suc (ℓ₀ ⊔ ℓ₁))  where
  field
    Objs  : Set ℓ₀
    Hom   : Objs -> Objs -> Set ℓ₁
    id    : (A : Objs) -> (Hom A A)
    _◦_   : {A B C : Objs}
            -> (g : Hom B C)
            -> (f : Hom A B)
            ->     (Hom A C)
    idL   : {A B : Objs}
            -> (f : Hom A B)
            -> (f ≡ f ◦ (id A))
    idR   : {A B : Objs}
            -> (f : Hom A B)
            -> (f ≡ (id B) ◦ f)
    assoc : {A B C D : Objs}
            -> (f : Hom A B)
            -> (g : Hom B C)
            -> (h : Hom C D)
            -> (h ◦ (g ◦ f) ≡ (h ◦ g) ◦ f)

-- catSet : {ℓ₀ ℓ₁ : Level} → Cat {ℓ₀} {ℓ₁}

catSet : Cat
Cat.Objs  catSet = Set
Cat.Hom   catSet = λ A B → (A → B)
Cat.id    catSet = λ A → (λ a → a)
Cat._◦_   catSet = λ g f → (λ a → g (f a))
Cat.idL   catSet = λ f → refl
Cat.idR   catSet = λ f → refl
Cat.assoc catSet = λ f g h → refl

record Functor {ℓ₀ ℓ₁ ℓ₂ ℓ₃ : Level}
               (catA : Cat {ℓ₀} {ℓ₁})
               (catB : Cat {ℓ₂} {ℓ₃})
             : Set (suc (ℓ₀ ⊔ ℓ₁ ⊔ ℓ₂ ⊔ ℓ₃)) where
  field
    ac0      : (Cat.Objs catA) -> (Cat.Objs catB)
    ac1      : {C D : Cat.Objs catA}
               -> (Cat.Hom catA C D)
               -> (Cat.Hom catB (ac0 C) (ac0 D))
    respids  : {C : Cat.Objs catA}
               -> (ac1 (Cat.id catA C) ≡ Cat.id catB (ac0 C))
    respcomp : {C D E : Cat.Objs catA}
               -> {f : Cat.Hom catA C D}
               -> {g : Cat.Hom catA D E}
               -> (ac1 (Cat._◦_ catA g f) ≡ (Cat._◦_ catB (ac1 g) (ac1 f)))


postulate ℓₐ ℓₘ : Level
postulate catX catY : Cat {ℓₐ} {ℓₘ}
postulate F : Functor catX catY
postulate G : Functor catSet catY
postulate H : Functor catX catSet


makefunctor[C,-] : {ℓ₀ ℓ₁ ℓ₂ ℓ₃ : Level}
                   → (catB : Cat {ℓ₀} {ℓ₁})
                   → (C : Cat.Objs catB)
                   → Functor {ℓ₀} {ℓ₁} catB catSet
Functor.ac0      (makefunctor[C,-] catB C) = λ D → {!!}
Functor.ac1      (makefunctor[C,-] catB C) = {!!}
Functor.respids  (makefunctor[C,-] catB C) = {!!}
Functor.respcomp (makefunctor[C,-] catB C) = {!!}


-- module Y0 {catA catB : Cat}
--           {R : Functor catB catA}
--           {A : Cat.Objs catA}
--           {C : Cat.Objs catB}
--           {η : Cat.Hom catA A (Functor.ac0 R C)}
--   where
--     [C,-] : Functor catB catSet
--     Functor.ac0      [C,-] = {!λ D → ?!}
--     Functor.ac1      [C,-] = {!!}
--     Functor.respids  [C,-] = {!!}
--     Functor.respcomp [C,-] = {!!}



-- module Test where
--   postulate A : Set


-- module MB11 {ra : RA} (rb : RB1 ra) where



-- Local Variables:
-- coding:  utf-8-unix
-- End:

