-- This file:
--   http://angg.twu.net/AGDA/RecordOpen1.agda.html
--   http://angg.twu.net/AGDA/RecordOpen1.agda
--           (find-angg "AGDA/RecordOpen1.agda")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
--
-- (find-angg ".emacs.agda" "recordstutorial")
--
-- (defun e () (interactive) (find-angg "AGDA/RecordOpen1.agda"))

open import Data.Bool
open import Data.Nat
open import Data.Vec hiding (map)
open import Data.Product

module RecordOpen1 where







record Example : Set where
  field 
    bool : Bool
    nat  : ℕ

ex : Example
ex = record { bool = true ; nat = 3 }

-- this won't work here - nat is not in scope
-- bad : ℕ
-- bad = nat ex

-- correct way - fully qualified projection
correct : ℕ
correct = Example.nat ex

module Open1 where
  open Example

  -- here we have:
  -- bool : (r' : Example) → Bool
  -- nat  : (r' : Example) → ℕ

  test : ℕ
  test = nat ex

test2 : ℕ
test2 = nat ex where open Example


module Open2 where
  open Example ex

  -- here we have:
  -- bool ≡ true : Bool
  -- nat  ≡ 3    : ℕ

  test : ℕ
  test = nat

test2' : ℕ
test2' = nat where open Example ex



--------------------

-- variable A₁ A₂ B₁ B₂ C₁ C₂ : Set
-- -- variable a₁ : A₁
-- -- variable a₂ : A₂
-- -- variable b₁ : B₁
-- -- variable b₂ : B₂
-- -- variable c₁ : C₁
-- -- variable c₂ : C₂


-- record Ra : Set where
--   field
--     a₁ a₂ : ℕ

-- record Rb : Set where
--   field
--     b₁ b₂ : ℕ

-- module Rab where
--   open Ra
--   open Rb
--   -- (agt "a₁")



-- Local Variables:
-- coding:  utf-8-unix
-- End:
