-- This file:
--   http://angg.twu.net/AGDA/RecordsTut1.agda.html
--   http://angg.twu.net/AGDA/RecordsTut1.agda
--           (find-angg "AGDA/RecordsTut1.agda")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>


open import Data.Bool
open import Data.Nat
open import MyLevels

module RecordsTut1 where

-- (find-recordstutorialpage 12 "General Syntax and Meaning")
-- (find-recordstutorialtext 12 "General Syntax and Meaning")
-- (find-recordstutorialpage 13 "This declaration introduces")
-- (find-recordstutorialtext 13 "This declaration introduces")
-- (find-recordstutorialpage 13 "Opening a record")
-- (find-recordstutorialtext 13 "Opening a record")
-- (find-recordstutorialtext 13 "Opening a record" "module R")

-- From:
-- https://wiki.portal.chalmers.se/agda/pmwiki.php?n=ReferenceManual.RecordsTutorial#syntax
--
--   General Syntax and Meaning
--   A record type in general is declared in the following way.
--   
--     record R Δ : Set where
--       field
--         x₁ : A₁[y₁, ..., yₘ₋₁]
--         x₂ : A₁[y₁, ..., yₘ₋₁, x₁]
--         ...
--         xₙ : A₁[y₁, ..., yₘ₋₁, x₁, ..., xₙ₋₁]
--   
--   Here, Δ represents a 'telescope', which is of the following form
--   
--     (y₁ : B₁) (y₂ : B₂[y₁]) ... (yₘ : Bₘ[y₁, ..., yₘ₋₁])
--
-- Idea: make m:=2 and n:=2,
--       make B₂[y₁]             := B₂ y₁ ,
--       make A₁[y₁, ..., yₘ₋₁]  := A₁ y₁ ,



postulate B₁ :                                              Set
postulate B₂ : (y₁ : B₁) →                                  Set
postulate A₁ : (y₁ : B₁) → (y₂ : B₂ y₁) →                   Set
postulate A₂ : (y₁ : B₁) → (y₂ : B₂ y₁) → (x₁ : A₁ y₁ y₂) → Set

-- postulate y₁ : B₁
-- postulate y₂ : B₂ y₁
-- postulate x₁ : A₁ y₁ y₂
-- postulate x₂ : A₂ y₁ y₂ x₁

record R (y₁ : B₁) (y₂ : B₂ y₁) : MySet1 where
  field
    x₁ : A₁ y₁ y₂
    x₂ : A₂ y₁ y₂ x₁

postulate ay₁ : B₁
postulate ay₂ : B₂ ay₁
postulate ax₁ : A₁ ay₁ ay₂
postulate ax₂ : A₂ ay₁ ay₂ ax₁
postulate ar  : R  ay₁ ay₂

-- (find-recordstutorialpage 13 "This declaration introduces")
-- (find-recordstutorialtext 13 "This declaration introduces")
-- (eek "C-a C-c C-d  R     RET")
-- (eek "C-a C-c C-d  R.x₁  RET")
-- (eek "C-a C-c C-d  R.x₂  RET")
-- (eek "C-a C-c C-d  ar    RET")


--   module R {Δ} (r : R Δ) where
--       x1 : A1[y1, ..., ym-1]
--       x1 = ...
--       x2 : A2[y1, ..., ym-1, x1]
--       x2 = ...
--       ...
--       xn : An[y1, ..., ym-1, x1, ..., xn-1]
--       xn = ...





