/* (find-node "(bison)Multi-function Calc")
 * (find-node "(bison)Token Decl")
 * (find-bisonnode "Union Decl")
 * (find-bisonnode "Index")
 * (find-angg "BISON/calc.h")
 * (find-angg "BISON/mfcalc.y")
 * (defun c () (interactive) (find-sh "cd ~/BISON/ && bison foo2.y && gcc foo2.tab.c -lm -o foo2 && ls -l ."))
 * (defun c () (interactive) (find-sh "cd ~/BISON/ && bison foo2.y && gcc foo2.tab.c -lm -o foo2 && ls -l . && ./foo2"))
 * (defun cc () (interactive) (find-sh "cd ~/BISON/ && bison foo2.y && gcc -DYYDEBUG=1 foo2.tab.c -lm -o foo2 && ls -l . && ./foo2"))
 * (defun fy0 (s) (find-fline "foo2.tab.c" s))
 * (defun fy  (s) (fy0 (format "(fy \"%s\")" s)))
 * (find-bisonnode "Grammar Layout")
 * (find-node "(libc)Formatted Output")
 * (find-man "3 printf")
 * (find-books "__comp/__comp.el" "hopcroft")
 */

/*
%token  <star>  STAR   "*"
%token  <plus>  PLUS   "+"
%token  END  0  "end of file"
*/


%{
#include <stdio.h> /* (find-man "3 printf") */
int nline = 0;     /* global */

                               /* printf("_%d: _%d A->B\n",   ++nline, $1); $$ = nline; */
#define PPROD1(d1,dd, pstr)       printf("_%d: _%d "pstr"\n", ++nline, d1); dd = nline;
                               /* printf("_%d: _%d _%d AM->A\n",  ++nline, $1, $2); $$ = nline; */
#define PPROD2(d1,d2,dd, pstr)    printf("_%d: _%d _%d "pstr"\n", ++nline, d1, d2); dd = nline;
                               /* printf("_%d: _%d _%d _%d A+M->A\n", ++nline, $1, $2, $3); $$ = nline; */
#define PPROD3(d1,d2,d3,dd, pstr) printf("_%d: _%d _%d _%d "pstr"\n", ++nline, d1, d2, d3); dd = nline;

                     /* printf("_%d: %d %d N\n",      ++nline, yypos, yypos+1); ++yypos; yylval.nline = nline; return N; */
#define TOK1(tstr, tok) printf("_%d: %d %d "tstr"\n", ++nline, yypos, yypos+1); ++yypos; yylval.nline = nline; return tok;

%}
%union {
  /* (find-bisonnode "Union Decl")
   * (find-bisonnode "Type Decl")
   */
  int nline;
}

/* (find-bisonnode "Mfcalc Declarations")
 */

%token <nline> N '+' '*'
%type  <nline> A M

%% /* The grammar follows.  */
 /* (find-bisonnode "Mfcalc Rules")
  */
A:	  M		{ PPROD1($1, $$,           "M->A"); }
	| A '+' M	{ PPROD3($1, $2, $3, $$, "A+M->A"); }
;
M:	  N		{ PPROD1($1, $$,           "N->M"); }
	| N '*' M	{ PPROD3($1, $2, $3, $$, "N*M->M"); }
;

/* End of grammar.  */
%%

/* Called by yyparse on error.
 * (find-bisonnode "Error Reporting")
*/
void yyerror (char const *msg) {
  printf ("%s\n", msg);
}

char  yylex_input[] = "2*3*4+5*6";
char *yylex_ptr = yylex_input;

int yypos = 0;

int yylex (void) {
  int c = yylex_input[yypos];
  if (c == EOF) { return 0; }
  if (c == '*') { TOK1("*", '*'); }
  if (c == '+') { TOK1("+", '+'); }
  if ('0' <= c && c <= '9') { TOK1("N", N); }
  /* no error-handling code yet */
  /* (find-bisonnode "Mfcalc Symbol Table" "&yylval.val")
   */
}


int main (void) {
  return yyparse();
}

/*

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
foo = [[
  _1: 0 1 N
  _2: 1 2 *
   _3: 2 3 N
   _4: 3 4 *
    _5: 4 5 N
   _7: _5 N->M
  _8: _3 _4 _7 N*M->M
 _9: _1 _2 _8 N*M->M
_10: _9 M->A
_6: 5 6 +
  _11: 6 7 N
  _12: 7 8 *
   _13: 8 9 N
  _14: _13 N->M
 _15: _11 _12 _14 N*M->M
_16: _10 _6 _15 A+M->A
]]

foo = [[
 _1: 0 1 N
 _2: 1 2 *
 _3: 2 3 N
 _4: 3 4 *
 _5: 4 5 N
 _6: 5 6 +
 _7: _5 N->M
 _8: _3 _4 _7 N*M->M
 _9: _1 _2 _8 N*M->M
_10: _9 M->A
_11: 6 7 N
_12: 7 8 *
_13: 8 9 N
_14: _13 N->M
_15: _11 _12 _14 N*M->M
_16: _10 _6 _15 A+M->A
]]

lines = {}
for _,line in ipairs(splitlines(foo)) do
  -- line = "_1: 0 1 N"
  local spl = split(line)
  local T = { nline = spl[1]:match("^_([0-9]+):$") + 0, cmd = spl[#spl] }
  for i=2,#spl-1 do
    local _,n = spl[i]:match("^(_?)([0-9]+)$")
    if _ == "" then T[i-1] = n + 0 else T[i-1] = lines[n + 0] end
  end
  lines[T.nline] = T
end
PP(T)
PP(lines)
PP(lines[16])

pline = function (prefix, n)
    local T = lines[n]
    -- PP(T)
    if type(T[1]) == "number" then
      -- print(prefix .. "_"..n..": "..T.cmd.." ("..T[1].." to "..T[2]..")")
      print(prefix .. T[1].." "..T[2].." "..T.cmd)
    else
      for i=1,#T do pline(prefix.." ", T[i].nline) end
      -- print(prefix .. "_"..n..": "..T.cmd)
      print(prefix..T.cmd)
    end
  end

pline("", 16)

ordinals = {"one", "two", "three"}
yylex_input = "2*3*4+5*6"
yylex_c = function (n) return yylex_input:sub(n+1, n+1) end
ptex = function (prefix, n)
    local T = lines[n]
    if type(T[1]) == "number" then
      -- print(prefix .. T[1].." "..T[2].." "..T.cmd)
      printf("%s{\\ptok{%s}{%s}{%d}}\n", prefix, yylex_c(T[1]), T.cmd, T.nline)
    else
      printf("%s{\\pprod%s\n", prefix, ordinals[#T])
      for i=1,#T do ptex(prefix.." ", T[i].nline) end
      printf("%s {%s}{%d}}\n", prefix, T.cmd:match("%->(.*)"), T.nline)
    end
  end

ptex("", 16)

 */





/*
#  Local Variables:
#  coding:               raw-text-unix
#  ee-anchor-format:     "%s"
#  modes: (fundamental-mode emacs-lisp-mode lua-mode c-mode)
#  End:
*/
