/* (find-angg "BISON/calc.h")
 * (find-angg "BISON/mfcalc.y")
 * (defun c () (interactive) (find-sh "cd ~/BISON/ && bison foo3.y && gcc foo3.tab.c -lm -o foo3 && ls -l ."))
 * (defun c () (interactive) (find-sh "cd ~/BISON/ && bison foo3.y && gcc foo3.tab.c -lm -o foo3 && ls -l . && ./foo3"))
 * (defun fy0 (s) (find-fline "foo3.tab.c" s))
 * (defun fy  (&optional s) (interactive) (fy0 (if s (format "(fy \"%s\")" s))))
 * (find-node "(libc)Formatted Output")
 * (find-man "3 printf")
 * (find-books "__comp/__comp.el" "hopcroft")
 * (find-bisonnode "Multi-function Calc")
 * (find-bisonnode "Token Decl")
 * (find-bisonnode "Token Decl" "%token END")
 * (find-bisonnode "Union Decl")
 * (find-bisonnode "Index")
 * (find-bisonnode "Grammar Layout")
 * (find-bisonnode "Union Decl")
 * (find-bisonnode "Type Decl")
 * (find-bisonnode "Mfcalc Declarations")
 * (find-bisonnode "Mfcalc Rules")
 * (find-bisonnode "Mfcalc Symbol Table" "&yylval.val")
 * (find-bisonnode "Error Reporting")
 * (setq c-electric-flag nil)
 */

%{
#include <stdio.h>  /* (find-man "3 printf") */
#include <stdlib.h> /* (find-man "3 malloc") */
int nline = 0;      /* global */

struct myobj {
  int   nline;
  char  subexps; /* tokens have 0 subexps, nonterminals have >0 */
  char *name;
  int   pos[2];  /* for tokens */
  struct myobj *subexp[3]; /* for nonterminals */
};
typedef struct myobj myobj;

/* All this mess with myobjs is just because we want
 * to be able to print them (in the right order)
 * after creating the whole parse tree...
*/
void printmyobj(myobj *o) {
  int i;
  if (o->subexps == 0) {
    printf("  ");
    // printf("_%d: ", o->nline);
    printf("%d %d %s\n", o->pos[0], o->pos[1], o->name);
  } else {
    for (i=0; i<o->subexps; i++)
      printmyobj(o->subexp[i]);
    // printf("_%d: ", o->nline);
    printf("%d ", o->subexps);
    printf("%s\n", o->name);
  }
}

/* By calling this on the top myobj
 * all the memory used by all of them
 * will be freed (recursively).
*/
void freemyobj(myobj *o) {
  int i;
  for(i=0; i<o->subexps; ++i)
    freemyobj(o->subexp[i]);
  free(o);
}

/* Two ways to create myobjs. */
myobj *newtokenobj(char *name, int pos0, int pos1) {
  myobj *o = malloc(sizeof(myobj));
  o->nline = ++nline;
  o->subexps = 0;
  o->name = name;
  o->pos[0] = pos0;
  o->pos[1] = pos1;
  return o;
}
myobj *newnonterminalobj(char *name, int subexps,
        myobj *sub0, myobj *sub1, myobj *sub2) {
  myobj *o = malloc(sizeof(myobj));
  o->nline = ++nline;
  o->subexps = subexps;
  o->name = name;
  o->subexp[0] = sub0;
  o->subexp[1] = sub1;
  o->subexp[2] = sub2;
  return o;
}

/* This is how things are called from the C program. */
#define PPROD1(dd,d1, pstr) dd = newnonterminalobj(pstr, 1, d1, NULL, NULL)
#define PPROD2(dd,d1,d2, pstr) dd = newnonterminalobj(pstr, 2, d1,d2, NULL)
#define PPROD3(dd,d1,d2,d3, pstr) dd = newnonterminalobj(pstr, 3, d1,d2,d3)
#define TOK1(tstr, tok) yylval.myobj = newtokenobj(tstr, yypos, yypos+1); yypos++; return tok 

%}
%union {
  int nline;
  myobj *myobj;
}
%token <myobj> N '+' '*'
%type  <myobj> A M

%% /* The grammar follows.  */
START:    A             { printmyobj($1); freemyobj($1); }
A:	  M		{ PPROD1($$, $1,           "M->A"); }
	| A '+' M	{ PPROD3($$, $1, $2, $3, "A+M->A"); }
;
M:	  N		{ PPROD1($$, $1,           "N->M"); }
	| N '*' M	{ PPROD3($$, $1, $2, $3, "N*M->M"); }
;

/* End of grammar.  */
%%

/* Called by yyparse on error.
*/
void yyerror (char const *msg) {
  printf ("%s\n", msg);
}

char  yylex_input[] = "2*3*4+5*6";
char *yylex_ptr = yylex_input;

int yypos = 0;

int yylex (void) {
  int c = yylex_input[yypos];
  if (c == '*') { TOK1("*", '*'); }
  if (c == '+') { TOK1("+", '+'); }
  if ('0' <= c && c <= '9') { TOK1("N", N); }
  /* if (c == EOF) { return 0; } */
  /* no error-handling code yet */
  return 0;
}


int main (void) {
  yyparse();
  /* return yyparse(); */
}

/*

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
foo = [[
  _1: 0 1 N
  _2: 1 2 *
   _3: 2 3 N
   _4: 3 4 *
    _5: 4 5 N
   _7: _5 N->M
  _8: _3 _4 _7 N*M->M
 _9: _1 _2 _8 N*M->M
_10: _9 M->A
_6: 5 6 +
  _11: 6 7 N
  _12: 7 8 *
   _13: 8 9 N
  _14: _13 N->M
 _15: _11 _12 _14 N*M->M
_16: _10 _6 _15 A+M->A
]]

foo = [[
 _1: 0 1 N
 _2: 1 2 *
 _3: 2 3 N
 _4: 3 4 *
 _5: 4 5 N
 _6: 5 6 +
 _7: _5 N->M
 _8: _3 _4 _7 N*M->M
 _9: _1 _2 _8 N*M->M
_10: _9 M->A
_11: 6 7 N
_12: 7 8 *
_13: 8 9 N
_14: _13 N->M
_15: _11 _12 _14 N*M->M
_16: _10 _6 _15 A+M->A
]]

lines = {}
for _,line in ipairs(splitlines(foo)) do
  -- line = "_1: 0 1 N"
  local spl = split(line)
  local T = { nline = spl[1]:match("^_([0-9]+):$") + 0, cmd = spl[#spl] }
  for i=2,#spl-1 do
    local _,n = spl[i]:match("^(_?)([0-9]+)$")
    if _ == "" then T[i-1] = n + 0 else T[i-1] = lines[n + 0] end
  end
  lines[T.nline] = T
end
PP(T)
PP(lines)
PP(lines[16])

pline = function (prefix, n)
    local T = lines[n]
    -- PP(T)
    if type(T[1]) == "number" then
      -- print(prefix .. "_"..n..": "..T.cmd.." ("..T[1].." to "..T[2]..")")
      print(prefix .. T[1].." "..T[2].." "..T.cmd)
    else
      for i=1,#T do pline(prefix.." ", T[i].nline) end
      -- print(prefix .. "_"..n..": "..T.cmd)
      print(prefix..T.cmd)
    end
  end

pline("", 16)

ordinals = {"one", "two", "three"}
yylex_input = "2*3*4+5*6"
yylex_c = function (n) return yylex_input:sub(n+1, n+1) end
ptex = function (prefix, n)
    local T = lines[n]
    if type(T[1]) == "number" then
      -- print(prefix .. T[1].." "..T[2].." "..T.cmd)
      printf("%s{\\ptok{%s}{%s}{%d}}\n", prefix, yylex_c(T[1]), T.cmd, T.nline)
    else
      printf("%s{\\pprod%s\n", prefix, ordinals[#T])
      for i=1,#T do ptex(prefix.." ", T[i].nline) end
      printf("%s {%s}{%d}}\n", prefix, T.cmd:match("%->(.*)"), T.nline)
    end
  end

ptex("", 16)

 */





/*
#  Local Variables:
#  coding:               raw-text-unix
#  ee-anchor-format:     "%s"
#  modes: (fundamental-mode emacs-lisp-mode lua-mode c-mode)
#  End:
*/
