-- This file:
--   http://angg.twu.net/LATEX/2021-2-C2-MT2.lua.html
--   http://angg.twu.net/LATEX/2021-2-C2-MT2.lua
--           (find-angg "LATEX/2021-2-C2-MT2.lua")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
--
-- (defun e () (interactive) (find-angg "LATEX/2021-2-C2-MT2.tex"))
-- (defun l () (interactive) (find-angg "LATEX/2021-2-C2-MT2.lua"))



-- (find-fline "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/")
-- (find-fline "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/")
-- (find-fline "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/messages.html")

FileLines = Class {
  type = "FileLines",
  from = function (fname, fmt)
      local fname_  = fname:gsub("^~/", "")
      local fname   = "~/"..fname_
      local bigstr = ee_readfile(fname)
      local lines = {}
      local inits = {}
      local postoline = {}
      local linen = 1
      for pos,line in bigstr:gmatch("()([^\n]*)\n") do
        table.insert(inits, pos)
        table.insert(lines, line)
        postoline[pos] = linen
        linen = linen + 1
      end
      return FileLines {fname=fname, bigstr=bigstr, fmt=fmt,
                        inits=inits, lines=lines, postoline=postoline}
    end,
  __tostring = function (fl)
      return format("%s: %d lines", fl.fname, #fl.lines)
    end,
  __index = {
    link0 = function (fl, str)
        local fmt = fl.fmt or ('(find-fline "' .. fl.fname .. '"%s)')
        return format(fmt, str)
      end,
    printcodecd = function (fl)
        if fl.codecd then print(fl.codecd) end
        if fl.linkd  then print(fl.linkd)  end
        print(fl:link0(""))
      end,
    printmessagesanddates = function (fl)
        print(fl.codecd)
        --
        local pat = '<div class="from_name">\n()([^\n]+)\n *</div>'
        for pos,name in fl.bigstr:gmatch(pat) do
          local posspec = format('%06s "%s"', fl.postoline[pos], name)
          print(fl:link0(posspec))
        end
        --
        local pat = '<div class="body details">\n()([^\n]+)\n *</div>'
        for pos,stuff in fl.bigstr:gmatch(pat) do
          if stuff:match("202.$") then
            local posspec = format('%06s "%s"', fl.postoline[pos], stuff)
            print(fl:link0(posspec))
          end
        end
      end,
  },
}

BinarySeach = Class {
  type     = "BinarySeach",
  midpoint = function (a, b)
      if b-a <= 1 then return nil end
      return math.floor((a+b)/2)
    end,
  __index = {
  },
}



--[[
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
dofile "2021-2-C2-MT2.lua"

-- Turma C1:
fl        = FileLines.from         "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/messages.html"
fl:printcodecd()

fl        = FileLines.from         "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/messages.html"
fl.codecd = '(code-c-d "20212C2C1" "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/")'
fl.linkd  =      '(find-20212C2C1file "" "messages.html")'
fl.fmt    =      '(find-20212C2C1file "messages.html"%s)'
fl:printcodecd()
fl:printmessagesanddates()

fl        = FileLines.from         "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/messages2.html"
fl.codecd = '(code-c-d "20212C2C1" "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/")'
fl.linkd  =      '(find-20212C2C1file "" "messages2.html")'
fl.fmt    =      '(find-20212C2C1file "messages2.html"%s)'
fl:printcodecd()
fl:printmessagesanddates()

-- Turma E1:
fl        = FileLines.from         "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/messages.html"
fl:printcodecd()

fl        = FileLines.from         "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/messages.html"
fl.codecd = '(code-c-d "20212C2E1" "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/")'
fl.linkd  =      '(find-20212C2E1file "" "messages.html")'
fl.fmt    =      '(find-20212C2E1file "messages.html"%s)'
fl:printcodecd()
fl:printmessagesanddates()

fl        = FileLines.from         "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/messages2.html"
fl.codecd = '(code-c-d "20212C2E1" "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/")'
fl.linkd  =      '(find-20212C2E1file "" "messages2.html")'
fl.fmt    =      '(find-20212C2E1file "messages2.html"%s)'
fl:printcodecd()
fl:printmessagesanddates()

fl        = FileLines.from         "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/messages3.html"
fl.codecd = '(code-c-d "20212C2E1" "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/")'
fl.linkd  =      '(find-20212C2E1file "" "messages3.html")'
fl.fmt    =      '(find-20212C2E1file "messages3.html"%s)'
fl:printcodecd()
fl:printmessagesanddates()

--]]


-- Participação nas aulas de 24 a 26/nov:

-- (code-c-d "20212C2C1" "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/")
-- (find-20212C2C1file "messages.html" 18783 "23 November 2021")
-- (find-20212C2C1file "messages.html" 18831 "25 November 2021")
-- (find-20212C2C1file "messages.html" 22195 "26 November 2021")
-- (find-20212C2C1file "messages.html" 19081 "Ayla Rodrigues")
-- (find-20212C2C1file "messages.html" 20387 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 20507 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 20613 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 20781 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 21235 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 21329 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 21429 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 21493 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 21611 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 21731 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 21971 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 22035 "Bernardi(o) Ramos")
-- (find-20212C2C1file "messages.html" 19677 "Fabrício ")
-- (find-20212C2C1file "messages.html" 20165 "Fabrício ")
-- (find-20212C2C1file "messages.html" 20239 "Fabrício ")
-- (find-20212C2C1file "messages.html" 23617 "Fabrício ")
-- (find-20212C2C1file "messages.html" 23729 "Fabrício ")
-- (find-20212C2C1file "messages.html" 23797 "Fabrício ")
-- (find-20212C2C1file "messages.html" 23861 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24005 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24111 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24179 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24263 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24417 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24511 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24579 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24651 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24747 "Fabrício ")
-- (find-20212C2C1file "messages.html" 24815 "Fabrício ")
-- (find-20212C2C1file "messages.html" 18889 "Igor Monárdez")
-- (find-20212C2C1file "messages.html" 21547 "Igor Monárdez")
-- (find-20212C2C1file "messages.html" 21659 "Igor Monárdez")
-- (find-20212C2C1file "messages.html" 21763 "Igor Monárdez")
-- (find-20212C2C1file "messages.html" 21887 "Igor Monárdez")
-- (find-20212C2C1file "messages.html" 22253 "Igor Monárdez")
-- (find-20212C2C1file "messages.html" 19145 "João Guilherme Mendes")
-- (find-20212C2C1file "messages.html" 19513 "João Guilherme Mendes")
-- (find-20212C2C1file "messages.html" 19581 "João Guilherme Mendes")
-- (find-20212C2C1file "messages.html" 19725 "João Guilherme Mendes")
-- (find-20212C2C1file "messages.html" 18953 "Juliana Marys")
-- (find-20212C2C1file "messages.html" 19241 "Juliana Marys")
-- (find-20212C2C1file "messages.html" 19385 "Juliana Marys")
-- (find-20212C2C1file "messages.html" 22317 "Luis Filipe L. S. Caliman")
-- (find-20212C2C1file "messages.html" 19209 "Mateus ")
-- (find-20212C2C1file "messages.html" 24879 "Mateus ")
-- (find-20212C2C1file "messages.html" 19177 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 19889 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 19969 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 20065 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 20419 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 20667 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 20983 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 21079 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 22285 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 22513 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 22593 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 22703 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 22767 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 22831 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 22927 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 23079 "Matheus citeli")
-- (find-20212C2C1file "messages.html" 19017 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 19321 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 19481 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 19645 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 19757 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 20539 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 21111 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 21203 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 21361 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 22381 "Rafael Tiribás")
-- (find-20212C2C1file "messages.html" 18985 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 19449 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 19825 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 20883 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 22083 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 22445 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 22671 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 23015 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 23195 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 23281 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 23361 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 23447 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 23957 "Ricardo Soares C2")
-- (find-20212C2C1file "messages.html" 24963 "2 December 2021")

-- (code-c-d "20212C2E1" "~/2021.2-C2/C2-E1-RCN-PURO-2021.2/")
-- Bruna Oliveira: max 0.3
-- Bruno Martins:  max 0.3
-- Flavia Melo:    max 0.3
-- Jean Nery:      max 0.3
-- (find-20212C2E1file "messages.html" 18203 "23 November 2021")
-- (find-20212C2E1file "messages.html" 18275 "24 November 2021")
-- (find-20212C2E1file "messages.html" 20683 "25 November 2021")
-- (find-20212C2E1file "messages.html" 24961 "26 November 2021")
-- (find-20212C2E1file "messages.html" 20981 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 21077 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 21913 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 22077 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 22315 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 22383 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 22447 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 22559 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 22661 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 22725 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 23493 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 23611 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 24919 "Alice Mendes")
-- (find-20212C2E1file "messages.html" 19951 "André Fernandes")
-- (find-20212C2E1file "messages.html" 20069 "André Fernandes")
-- (find-20212C2E1file "messages.html" 20133 "André Fernandes")
-- (find-20212C2E1file "messages.html" 20443 "André Fernandes")
-- (find-20212C2E1file "messages.html" 21285 "André Fernandes")
-- (find-20212C2E1file "messages.html" 22949 "André Fernandes")
-- (find-20212C2E1file "messages.html" 23083 "André Fernandes")
-- (find-20212C2E1file "messages.html" 19415 "Bruna Oliveira")
-- (find-20212C2E1file "messages.html" 19479 "Bruna Oliveira")
-- (find-20212C2E1file "messages.html" 19663 "Bruna Oliveira")
-- (find-20212C2E1file "messages.html" 19759 "Bruna Oliveira")
-- (find-20212C2E1file "messages.html" 21157 "Bruno Martins")
-- (find-20212C2E1file "messages.html" 18333 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 18513 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 18593 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 18737 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 18927 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 19189 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 19267 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 19335 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 19595 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 20585 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 20669 "Fernanda França C2")
-- (find-20212C2E1file "messages.html" 18301 "Flávia Melo ")
-- (find-20212C2E1file "messages.html" 21221 "Jean Nery")
-- (find-20212C2E1file "messages.html" 18261 "L Machado C2")
-- (find-20212C2E1file "messages.html" 18413 "L Machado C2")
-- (find-20212C2E1file "messages.html" 18673 "L Machado C2")
-- (find-20212C2E1file "messages.html" 18895 "L Machado C2")
-- (find-20212C2E1file "messages.html" 19029 "L Machado C2")
-- (find-20212C2E1file "messages.html" 19093 "L Machado C2")
-- (find-20212C2E1file "messages.html" 19157 "L Machado C2")
-- (find-20212C2E1file "messages.html" 19511 "L Machado C2")
-- (find-20212C2E1file "messages.html" 19791 "L Machado C2")
-- (find-20212C2E1file "messages.html" 19865 "L Machado C2")
-- (find-20212C2E1file "messages.html" 19997 "L Machado C2")
-- (find-20212C2E1file "messages.html" 20181 "L Machado C2")
-- (find-20212C2E1file "messages.html" 20299 "L Machado C2")
-- (find-20212C2E1file "messages.html" 20391 "L Machado C2")
-- (find-20212C2E1file "messages.html" 20757 "L Machado C2")
-- (find-20212C2E1file "messages.html" 20821 "L Machado C2")
-- (find-20212C2E1file "messages.html" 20901 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21045 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21353 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21443 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21507 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21623 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21697 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21781 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21881 "L Machado C2")
-- (find-20212C2E1file "messages.html" 21945 "L Machado C2")
-- (find-20212C2E1file "messages.html" 22009 "L Machado C2")
-- (find-20212C2E1file "messages.html" 22149 "L Machado C2")
-- (find-20212C2E1file "messages.html" 22227 "L Machado C2")
-- (find-20212C2E1file "messages.html" 22837 "L Machado C2")
-- (find-20212C2E1file "messages.html" 22917 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23011 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23169 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23233 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23297 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23377 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23461 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23747 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23811 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23917 "L Machado C2")
-- (find-20212C2E1file "messages.html" 23981 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24065 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24177 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24257 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24321 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24401 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24497 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24561 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24641 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24743 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24807 "L Machado C2")
-- (find-20212C2E1file "messages.html" 24887 "L Machado C2")





--  (eepitch-lua51)
--  (eepitch-kill)
--  (eepitch-lua51)
-- fname = "~/2021.2-C2/C2-C1-RCN-PURO-2021.2/messages.html"
-- bigstr = ee_readfile(fname)
-- pat = '<div class="from_name">\n([^\n]+)\n *</div>'
-- for name in bigstr:gmatch(pat) do print(name) end





-- Local Variables:
-- coding:  utf-8-unix
-- End:
