;; This file: (find-LATEX "istanbulglyphs.el")
;; This will replace: (find-eev "eev-compose.el")
;;                in: (find-eev "eev3-compose.el")
;; «.eewrap-anchor-new»	(to "eewrap-anchor-new")


;;;                                                
;;;   ___ ___  _ __ ___  _ __   ___  ___  ___  ___ 
;;;  / __/ _ \| '_ ` _ \| '_ \ / _ \/ __|/ _ \/ __|
;;; | (_| (_) | | | | | | |_) | (_) \__ \  __/\__ \
;;;  \___\___/|_| |_| |_| .__/ \___/|___/\___||___/
;;;                     |_|                        
;;
(defun ee-tocomposes (str)
  (ee-tocomposes0 (split-string str)))
(defun ee-tocomposes0 (list)
  (if list
      (let* ((a (car list))
	     (b (string-to-char (cadr list)))
	     (rest (cddr list)))
	(cons a (cons b (ee-tocomposes0 rest))))))
(setq eev-uc-accents "
  `A À  `E È  `I Ì  `O Ò  `U Ù
  `a à  `e è  `i ì  `o ò  `u ù
  'A Á  'E É  'I Í  'O Ó  'U Ú
  'a á  'e é  'i í  'o ó  'u ú
  ^A Â  ^E Ê  ^I Î  ^O Ô  ^U Û
  ^a â  ^e ê  ^i î  ^o ô  ^u û
  ~A Ã              ~O Õ
  ~a ã              ~o õ
 \"A Ä \"E Ë \"I Ï \"O Ö \"U Ü
 \"a ä \"e ë \"i ï \"o ö \"u ü
  'C Ç  CC Ç  ~N Ñ
  'c ç  cc ç  ~n ñ
")
(setq eev-uc-otheriso "
  _a ª  _o º  AE Æ  ae æ  ss ß
  !! ¡  ?? ¿  SS §  << «  >> »
  00 °  11 ¹  22 ²  33 ³
  14 ¼  12 ½  34 ¾
  +- ±  :- ÷  cd ·  xx ×  nt ¬
")
(setq eev-uc-math "
  DD Δ  GG Γ  Th Θ  La Λ  Pi Π  Si Σ  Ph Φ  Ps Ψ  Om Ω
  aa α  bb β  gg γ  dd δ  ee ε  ze ζ  et η  io ι  kk κ  ll λ
  pi π  th θ  om ω  mu μ  nu ν  xi ξ  ro ρ  si σ  ta τ  vp ϕ  ph φ
  ch χ  ps ψ
  in ∈  le ≤  ge ≥  != ≠  -~ ≃  =~ ≅  mt ↦  >t ↣ mo ↤   ~1 ∼ ~~ ≈ == ≡
  la ∧  lo ∨  -> →  to →  <> ↔  => ⇒  <= ⇐  TT ⊤  BO ⊥  Do ⋅
  <- ←  up ↑  dn ↓  |- ⊢  -| ⊣  |= ⊨  ud ↕  NW ↖  NE ↗  SE ↘  SW ↙  LR ⇔

  su ⊂  se ⊆  Se ⊇  Su ⊃ Pa ∂ Na ∇  em ∅
  .. …  bu •  sq √  

  ca ∩  cu ∪  CA ⋂  CU ⋃  LO ⋁  LA ⋀  sm ∖
  qa ⊓  qu ⊔  && ⅋  [[ ⟦  ]] ⟧  -o ⊸  li ✀

  fa ∀  ex ∃  Bo □  nc ◻  po ⋄  fl ♭  na ♮  sh ♯
  -1 ¹  11 ¹  22 ²  33 ³  oo ∘  88 ∞  In ∫  el ℓ

  hu ⇀ <1 〈 1> 〉  o. ⊙ o- ⊖ o+ ⊕ o/ ⊘ ox ⊗   __ ▁ :: ⠆

  bf 𝐛  it 𝐢  rm 𝐫  tx 𝐭  sf 𝐬
")


;; (find-equailfile "sgml-input.el")
;; (find-equailfile "latin-ltx.el")
;; ∈  ⊂ ⊆ ⊇ ⊃   ≤ ≥
;;
;; (find-elnode "Creating Buffer-Local")
;; (find-eev "eev-compose.el")
;; (find-evardescr 'eev-composes-all)
;;

(defun eev-uc-set-composes ()
  (make-local-variable 'eev-composes-all)
  (setq eev-composes-all
    `(
      ,@ (ee-tocomposes eev-uc-accents)
      ,@ (ee-tocomposes eev-uc-otheriso)
      ,@ (ee-tocomposes eev-uc-math)
     )
  )
)


;; Greek: (find-einsert '((900 1000)))
;; (find-einsert '((8592 9000)))
;; (find-einsert '((8900 9000)))
;; (find-einsert '((8900 10000)))
;; Braille: (find-einsert '((10240 10495)))
;; Bold:    (find-einsert '((119808 120831)))
;; Music:   (find-einsert '((119040 119238)))



;;;        _             _         
;;;   __ _| |_   _ _ __ | |__  ___ 
;;;  / _` | | | | | '_ \| '_ \/ __|
;;; | (_| | | |_| | |_) | | | \__ \
;;;  \__, |_|\__, | .__/|_| |_|___/
;;;  |___/   |___/|_|              
;;
(defun eev-uc-set-face (face str)
  (mapcar (lambda (s1)
            (let ((pos (string-to-char s1)))
              (eepitch-set-glyph0 pos pos face)))
          (split-string str nil t)))
(eev-uc-set-face 'eev-glyph-face-Greek "Δ Γ Θ Λ Π Σ Φ Ψ Ω")
(eev-uc-set-face 'eev-glyph-face-greek "α β γ δ ε ζ η ι θ   κ λ π ω   μ ν ξ ρ σ τ   ϕ φ χ ψ")
(eev-uc-set-face 'eev-glyph-face-math  "∈   ⊂ ⊆ ⊇ ⊃   ≤ ≥ ≠   ≃ ≅ ↦ ↤ ↣   ∼ ≈ ≡   … • √ ∂ ∇ ⊸ ✀")
(eev-uc-set-face 'eev-glyph-face-math  "∧ ∨ ∩ ∪ ⋂ ⋃ ⋁ ⋀ ∅ ∖ ⊓ ⊔ ⅋ ⟦ ⟧     → ⊤ ⊥ ↔ ⇒ ⇐ ← ↑ ↓   ↕ ↖ ↗ ↘ ↙ ⇔   ⋄ ⋅ ◻")
(eev-uc-set-face 'eev-glyph-face-math  "∀ ∃ □ ♭ ♮ ♯   ⊢ ⊣ ⊨ ¹ ² ³ ∘ ∞ ∫ ℓ   ⇀ 〈 〉 ⊙ ⊖ ⊕ ⊘ ⊗   ▁ ⠆")
(eev-uc-set-face 'eev-glyph-face-yellow-on-red  "𝐛 𝐢 𝐫 𝐭 𝐬")





(eepitch-set-glyph0 ? ?b 'eev-glyph-face-yellow-on-red)
(eepitch-set-glyph0 ? ?s 'eev-glyph-face-yellow-on-red)
(eepitch-set-glyph0 ? ?P 'eev-glyph-face-yellow-on-red)
(eepitch-set-glyph0 ? ?N 'eev-glyph-face-yellow-on-red)



;;;                                                            _                
;;;   ___  _____      ___ __ __ _ _ __         __ _ _ __   ___| |__   ___  _ __ 
;;;  / _ \/ _ \ \ /\ / / '__/ _` | '_ \ _____ / _` | '_ \ / __| '_ \ / _ \| '__|
;;; |  __/  __/\ V  V /| | | (_| | |_) |_____| (_| | | | | (__| | | | (_) | |   
;;;  \___|\___| \_/\_/ |_|  \__,_| .__/       \__,_|_| |_|\___|_| |_|\___/|_|   
;;;                              |_|                                            
;; «eewrap-anchor-new» (to ".eewrap-anchor-new")

;; (find-efunction 'eewrap-anchor)
(defun  eewrap-anchor-new () (interactive)
  (ee-this-line-wrapn 1 'ee-wrap-anchor-new))
(defun ee-wrap-anchor-new (line)
  "An internal function used by `eewrap-anchor'."
  (if (string-match "^\\(.*\\)<\\([^<>]*\\)>" line)
      (ee-wrap-anchor-new0 (match-string 1 line) (match-string 2 line))
    (error "Does not match")))
(defun ee-wrap-anchor-new0 (prefix anchor)
  "An internal function used by `ee-wrap-anchor'."
  (if (eq buffer-file-coding-system 'utf-8-unix)
      (ee-template0 "\
{prefix}«.{anchor}»\t(to \"{anchor}\")
{prefix}«{anchor}» (to \".{anchor}\")")
    (ee-wrap-anchor0 prefix anchor)))

;; (find-eevfile "eev-mode.el" "eewrap-anchor")
' (define-key eev-mode-map "\M-A" 'eewrap-anchor-new)




;; Local Variables:
;; coding: utf-8-unix
;; ee-anchor-format:     "«%s»"
;; End:
