-- This file:
--   http://angg.twu.net/SRF/srfc.lua.html
--   http://angg.twu.net/SRF/srfc.lua
--           (find-angg "SRF/srfc.lua")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
--
-- (defun a () (interactive) (find-angg "SRF/srfa.lua"))
-- (defun b () (interactive) (find-angg "SRF/srfb.lua"))
-- (defun c () (interactive) (find-angg "SRF/srfc.lua"))
--
-- See:
-- (find-angg "SRF/srfa.lua" "Toknz")
-- (find-angg "SRF/srfa.lua" "Toknz" "parselpegpat =")

-- «.re-grammar»	(to "re-grammar")



--                                                            
--  _ __ ___    __ _ _ __ __ _ _ __ ___  _ __ ___   __ _ _ __ 
-- | '__/ _ \  / _` | '__/ _` | '_ ` _ \| '_ ` _ \ / _` | '__|
-- | | |  __/ | (_| | | | (_| | | | | | | | | | | | (_| | |   
-- |_|  \___|  \__, |_|  \__,_|_| |_| |_|_| |_| |_|\__,_|_|   
--             |___/                                          
--
-- «re-grammar»  (to ".re-grammar")
-- A parser for srfx tokens written as a grammar in lpeg.re.
-- It has bugs.

re = require "re"

srf_gram = [=[
  s   <- ' '
  eol <- !.
  eow <- &s / !.
  c   <- [^ ]

  b   <- {:b: {} :}
  e   <- {:e: {} :}

  dqliteral0 <-  '"' {:body: { [^"]* } :} '"'
  sqliteral0 <-  "'" {:body: { [^']* } :} "'"
  decnumber0 <-      {:body: { [-+]? [0-9]+ ('.' [0-9]+)? } :} {:base: "" -> "10" :}
  hexnumber0 <- "0x" {:body: { [0-9A-Fa-f]+ }               :} {:base: "" -> "16" :}
  octnumber0 <-  "o" {:body: { [0-7]+ }                     :} {:base: "" ->  "8" :}
  knownword0 <-      {:body: { c+ } => known :}
  word0      <-      {:body: { c+ }          :}

  strlit1 <- {:kind: "" -> "strlit" :} (dqliteral0 / sqliteral0)
  number1 <- {:kind: "" -> "numlit" :} (decnumber0 / hexnumber0 / octnumber0)
  kword1  <- {:kind: "" -> "word"   :} knownword0
  word1   <- {:kind: "" -> "word"   :} word0
  rest1   <- {:kind: "" -> "word"   :} word0

  token <- {| s* b (strlit1 eow / number1 eow / kword1 eow) e |}

]=]

srf_defs = {
  known = function (subj, pos, body) return true end,
}

srf_reP = Re { grammar = srf_gram, defs = srf_defs, print = PP }
srf_re0 = Re { grammar = srf_gram, defs = srf_defs }
srf_parsetoken = srf_re0:cc "top <- token"
srf_parseword  = srf_re0:cc "top <- token"
srf_parserest  = srf_re0:cc "top <- token"





