'\"
'\" Copyright (c) 1993 The Regents of the University of California.
'\" Copyright (c) 1994-1996 Sun Microsystems, Inc.
'\"
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" RCS: @(#) $Id: Tcl.n,v 1.3 1999/04/16 00:46:33 stanton Exp $
'\"
'\" Translation by Eduardo Ochs, http://angg.twu.net/
'\"
.so man.macros
.TH Tcl n "8.1" Tcl "Tcl Built-In Commands"
.BS
.SH NOME
Tcl \- Sumrio da sintaxe da linguagem Tcl.
.BE

.SH DESCRIO
.PP
As regras abaixo definem a sintaxe e a semntica da linguagem Tcl:
.IP [1]
Um script Tcl  um string contendo um ou mais comandos.
Pontos-e-vrgulas e newlines so separadores de comandos, a menos que
estejam "quotados" por chaves, aspas ou contrabarras, como vai ser
descrito abaixo. Durante uma "substituio de comando" (veja abaixo)
um colchete fechando (``]'') marca o fim de um comando, a no ser que
ele esteja quotado.
.IP [2]
Um comando  avaliado em dois passos. Primeiro o interpretador do Tcl
separa o comando em palavras e aplica as substituies descritas
abaixo; essas substituies so aplicadas do mesmo modo em todo os
comandos. A primeira palavra  usada para determinar a funo que vai
executar o comando, e todas as outras palavras do comando so passadas
como parmetros para essa funo. A funo  livre para interpretar as
palavras que recebe como parmetros do modo que quiser, por exemplo
como inteiros, nomes de variveis, listas ou scripts de Tcl. Comandos
diferentes interpretam seus parmetros de modos diferentes.
.IP [3]
As palavras de um comando so separadas por espao em branco (exceto
por newlines, que so separadores de comandos).
.IP [4]
Se o primeiro caracter de uma palavra  aspas (``"'') ento a palavra
 terminada pelas prximas aspas. Se pontos-e-vrgulas,
fecha-colchetes, ou caracters de espao (incluindo newlines)
aparecerem dentro de aspas eles so tratados como caracteres normais e
includos na palavra. Substituies de comandos, substituies de
variveis e substituies de contrabarras so aplicadas nos caracteres
entre aspas como descrito abaixo. As aspas no so consideradas como
parte da palavra.
.IP [5]
Se o primeiro caracter de uma palavra  uma chave abrindo (``{'')
ento a palavra  terminada pela prxima chave fechando. Chaves podem
ocorrer aninhadas: para cada ``{'' extra deve ocorrer um ''}''
correspondente para fech-lo; mas chaves que ocorram quotadas por
contrabarras no so contadas por essa regra. Nenhum tipo de
substituio ocorre entre chaves, exceto pelas subtituies de pares
contrabarra-newline descritas abaixo. Pontos-e-vrgulas, newlines,
fecha-colchetes e espao em branco no recebem nenhum tipo de
interpretao especial. A palavra resultante vai ser exatamente os
caracteres entre o ``{'' inicial e o ``}'' correspondente, excluindo o
``{'' e o ``}'' das extremidades.
.IP [6]
Se uma palavra contm um abre-colchetes (``['') ento o Tcl aplica uma
\fIsubstituio de comando\fR. Para isto o interpretador Tcl invoca a
si mesmo recursivamente para processar os caracteres que vem depois do
``['' como um script Tcl. O script pode conter qualquer nmero de
comandos e deve ser terminado por um fecha-colchetes (``]''). O
resultado do script (isto , o resultado do seu ltimo comando) 
substitudo na palavra no lugar dos colchetes e de todos os caracteres
dentro deles. Substituio de comandos no  aplicada em palavras
entre chaves.
.IP [7]
Se uma palavra contm um ``$'' ("dlar") o Tcl aplica uma
\fIsubstituio de varivel\fR: o dlar e todos os caracteres
seguintes so substitudos na palavra pelo valor da varivel.
Substituies de variveis podem ser de qualquer uma das formas
abaixo:
.RS
.TP 15
\fB$\fIname\fR
\fIName\fR  o nome de uma "varivel escalar"; o nome  terminado por
qualquer caracter que no seja uma letra, dgito ou um sublinhado
(``_'').
.TP 15
\fB$\fIname\fB(\fIindex\fB)\fR
\fIName\fR d o nome de uma varivel de array e \fIindex\fR d o nome
de um elemento do array. \fIName\fR deve conter somente letras,
dgitos e sublinhados. Substituies de comandos, de variveis e de
contrabarras so aplicadas nos caracteres de \fIindex\fR.
.TP 15
\fB${\fIname\fB}\fR
\fIName\fR  o nome de uma varivel escalar. Ele pode conter qualquer
caracter exceto por ``}''s.
.LP
Pode haver qualquer nmero de substituies de variveis numa palavra.
Substituies de comandos no so aplicadas em palavras entre chaves.
.RE
.IP [8]
Se uma contrabarra (``\e'') aparece numa palavra ocorre uma
\fIsubstituio de contrabarra\fR. Em todos os casos exceto os
descritos abaixo a contrabarra  descartada e o caracter seguinte 
tratado como caracter ordinrio e includo na palavra. O mecanismo de
substituio de contrabarras permite que caracteres como aspas,
fecha-colchetes e dlares sejam includos numa palavra literalmente,
sem que eles faam o interpretador entrar em nenhum dos modo especiais
de interpretao. A tabela seguinte lista as seqncias de caracteres
comeadas com contrabarras que so interpretadas de modo especial, e o
resultado de suas substituies.
.RS
.TP 7
\e\fBa\fR
Audible alert (bell) (0x7).
.TP 7
\e\fBb\fR
Backspace (0x8).
.TP 7
\e\fBf\fR
Form feed (0xc).
.TP 7
\e\fBn\fR
Newline (0xa).
.TP 7
\e\fBr\fR
Carriage-return (0xd).
.TP 7
\e\fBt\fR
Tab (0x9).
.TP 7
\e\fBv\fR
Vertical tab (0xb).
.TP 7
\e\fB<newline>\fIespaoEmBranco\fR
.
A contrabarra, o newline e todos os caracteres de espao no comeo da
linha seguinte (isto , espaos e tabs) so substitudos por um nico
espao. Ao contrrio de todas as outras substuies, essas (chamadas
de subtituies contrabarras-newlines) so aplicadas numa espcie de
estgio de pr-processamento que vem antes do parsing normal, e em que
s essas seqncias so consideradas; isso quer dizer que elas so
substitudas mesmo quando ocorrem entre chaves, e que o espao
resultante vai ser tratado como separador de palavras se ocorrer fora
de chaves e aspas.
.TP 7
\e\e
Contrabarra (``\e'').
.VS 8.1 br
.TP 7
\e\fIooo\fR 
.
Os dgitos \fIooo\fR (um, dois ou trs deles) so interpretados como
um valor em octal de oito bits, e a seqncia  substituda pelo
caracter Unicode correspondente. Os bits mais significantes desse
caracter octal vo ser 0.
.TP 7
\e\fBx\fIhh\fR 
.
Os dgitos hexadecimais \fIhh\fR so interpretados como o cdigo de um
caracter Unicode, que  substitudo pela seqncia. Qualquer nmero de
dgitos hexadecimais pode estar presente, mas s os dois ltimos vo
ser considerados; o resultado sempre corresponde a um byte. Os bytes
mais significantes do caracter Unicode vo ser 0.
.TP 7
\e\fBu\fIhhhh\fR 
.
Os dgitos hexadecimais \fIhhhh\fR (um, dois, trs ou quatro dgitos)
do um valor de 16 bits, e o caracter Unicode correspondente 
substitudo pela seqncia.
.VE
.LP
Substituio de contrabarras no  aplicada em palavras entre chaves,
exceto pelas substituies de contrabarra-newlines, como descrito
acima.
.RE
.IP [9]
Se uma lasanha (``#'') aparece numa posio em que o Tcl esteja
esperando o primeiro caracter da primeira palavra de um comando, ento
a lasanha e todos os caracteres a seguir, at o fim da linha, so
tratados como um comentrio e ignorados. A lasanha s  interpretada
especialmente, como incio de comentrio, quando aparece no incio de
um comando.
.IP [10]
Cada caracter  processado exatamente uma vez pelo interpretador do
Tcl durante a fase de obteno das palavras de um comando; por
exemplo, num trecho onde ocorre uma substituio de varivel nenhuma
outra substituio  aplicada, e o resultado da substituio de
varivel  concatenado literalmente  palavra que est sendo formada.
Um trecho em que ocorre uma substituio de comando  inteiramente
processado pela chamada recursiva ao interpretador do Tcl; nenhuma
substituio  aplicada nesse trecho antes da chamada recursiva ao
interpretador, e nenhuma substituio adicional  feita sobre o
resultado da substituio de comando nesse trecho.
.IP [11]
As substituies no afetam as separaes entre
palavras. Por exemplo, durante uma substituio de
varivel todo o string que corresponde ao valor da
varivel se torna parte da palavra em que essa varivel
estava, mesmo que o valor da varivel contenha espaos.
