
# (fooi "{\\al" "[$L" "{\\hlist" "[$hlist" "}" "]")
# (fooi "<ul>\n" "" "</ul>\n" "" "<li><a href=\"ch-" "" "</a>" "" ".html" "" "\">" "\t\t")

#
# Stuff to let me point to specific
# sections in some manuals
#
proc chsec {str} {
  foreach {ch sec} [split $str \#] {}
  return [expr {$ch==""?"index":"ch-$ch"}].html[section $sec]
}
proc pfind {x pairs} {
  foreach {key val} $pairs {
    if {$x==$key} { return $val }
  }
  error "section $x not found"
}
proc ddplink {sec txt baseurl list} {
  if [regexp {^\^(([0-9])+\.(.*))} $sec -> sec s ss] {
    set urlsuffix "[chsec [pfind $s $list]]#s$sec"
  } else {
    set urlsuffix [chsec [pfind $sec $list]]
  }
  if {$txt==""} {set txt $sec}
  L1 "$baseurl$urlsuffix" $txt
}

procj NMG1 {sec txt} {
  ddplink $sec $txt \
    http://www.debian.org/~elphick/manuals.html/maint-guide/ \
    { toc {}
	1   start
	1.1 start#s-needprogs
	1.2 start#s-otherinfo
	2   first
	2.1 first#s-choose
	2.2 first#s-getsrc
	2.3 first#s-naming
	2.4 first#s-dh_make
	3   modify
	3.1 modify#s-destdir
	3.2 modify#s-nolibs
	4   crules
	4.1 crules#s-control
	4.2 crules#s-rules
	5   dother
	5.1 dother#s-copyright
	5.2 dother#s-readdeb
	5.3 dother#s-changelog
	5.4 dother#s-conffiles
	5.5 dother#s-dirs
	5.6 dother#s-manpage
	5.7 dother#s-menu
	5.8 dother#s-watch
	5.9 dother#s-maintscripts
	6   final
	6.1 final#s-build
	6.2 final#s-errcheck
	6.3 final#s-upload
	6.4 final#s-whereishelp
    }
}

procj DDR1 {sec txt} {
  ddplink $sec $txt \
    http://www.debian.org/~elphick/manuals.html/developers-reference/ \
    { toc {}
	1       scope
	2       new-maintainer
	2.1     new-maintainer#s2.1
	2.2     new-maintainer#s-registering
	2.3     new-maintainer#s-mentors
	3       user-maint
	3.1     user-maint#s3.1
	3.2     user-maint#s3.2
	4       servers
	4.1     servers#s-mailing-lists
	4.2     servers#s-servers-master
	4.3     servers#s-servers-ftp
	4.4     servers#s-servers-www
	4.5     servers#s-servers-cvs
	4.6     servers#s-servers-mirrors
	5       archive
	5.1     archive#s5.1
	5.2     archive#s5.2
	5.3     archive#s5.3
	5.4     archive#s5.4
	5.5     archive#s5.5
	5.6     archive#s5.6
	5.6.1   archive#s5.6.1
	5.6.2   archive#s5.6.2
	5.7     archive#s-codenames
	6       upload
	6.1     upload#s6.1
	6.2     upload#s-uploading
	6.2.1   upload#s6.2.1
	6.2.2   upload#s-upload-dist
	6.2.2.1 upload#s-upload-frozen
	6.2.3   upload#s-upload-checking
	6.2.4   upload#s-upload-master
	6.2.5   upload#s6.2.5
	6.2.6   upload#s6.2.6
	6.2.7   upload#s6.2.7
	6.3     upload#s-upload-announce
	6.4     upload#s-upload-notification
	6.4.1   upload#s-override-file
	7       nmu
	7.1     nmu#s-nmu-terms
	7.2     nmu#s-nmu-who
	7.3     nmu#s-nmu-when
	7.4     nmu#s-nmu-guidelines
	7.4.1   nmu#s-nmu-version
	7.4.2   nmu#s-nmu-changelog
	7.4.3   nmu#s-nmu-patch
	7.4.4   nmu#s-nmu-build
	8       porting
	8.1     porting#s-kind-to-porters
	8.2     porting#s-porter-guidelines
	8.2.1   porting#s-source-nmu-when-porter
	8.3     porting#s8.3
	8.3.1   porting#s-quinn-diff
	8.3.2   porting#s-buildd
	8.3.3   porting#s-dpkg-cross
	9       archive-manip
	9.1     archive-manip#s9.1
	9.2     archive-manip#s9.2
	9.2.1   archive-manip#s9.2.1
	9.3     archive-manip#s9.3
	9.4     archive-manip#s-orphaning
	9.5     archive-manip#s-adopting
	10      bug-handling
	10.1    bug-handling#s10.1
	10.2    bug-handling#s10.2
	10.3    bug-handling#s10.3
	10.4    bug-handling#s10.4
	10.5    bug-handling#s-lintian-reports
	10.6    bug-handling#s10.6
	11      tools
	11.1    tools#s-dpkg-dev
	11.2    tools#s-lintian
	11.3    tools#s-debhelper
	11.4    tools#s-debmake
	11.5    tools#s-cvs-buildpackage
	11.6    tools#s-dupload
	11.7    tools#s-fakeroot
	11.8    tools#s-devscripts
    }
}

procj DPM1 {sec txt} {
  ddplink $sec $txt \
    http://www.debian.org/~elphick/manuals.html/packaging-manual/ \
    { toc {}
	1    scope
	2    binarypkg
	2.1  binarypkg#s-bincreating
	2.2  binarypkg#s-controlarea
	2.3  binarypkg#s-controlfile
	3    sourcepkg
	3.1  sourcepkg#s-sourcetools
	3.2  sourcepkg#s-sourcetree
	3.3  sourcepkg#s-sourcearchives
	3.4  sourcepkg#s3.4
	4    controlfields
	5    versions
	6    maintainerscripts
	6.1  maintainerscripts#s6.1
	6.2  maintainerscripts#s-mscriptsinstact
	6.3  maintainerscripts#s-unpackphase
	6.4  maintainerscripts#s6.4
	6.5  maintainerscripts#s6.5
	7    descriptions
	7.1  descriptions#s7.1
	7.2  descriptions#s7.2
	7.3  descriptions#s7.3
	8    relationships
	8.1  relationships#s-depsyntax
	8.2  relationships#s8.2
	8.3  relationships#s-conflicts
	8.4  relationships#s-virtual
	8.5  relationships#s-replaces
	8.6  relationships#s8.6
	9    conffiles
	9.1  conffiles#s9.1
	9.2  conffiles#s9.2
	10   alternatives
	11   diversions
	12   sharedlibs
	12.1 sharedlibs#s-shlibs
	12.2 sharedlibs#s12.2
	13   methif
	13.1 methif#s13.1
	13.2 methif#s13.2
	14   conversion
    }
}

proc DPG0 {t {ch {}} {sec {}}} {
  set url2 [expr {$ch==""?"index.html":"ch-$ch.html"}][section $sec]
  L1 /usr/doc/debian-policy/policy.html/$url2 $t
}



set ignore_this {

  cp $S/http/www.debian.org/~elphick/manuals.html/maint-guide/index.html /tmp/nmg.html
  cp $S/http/www.debian.org/~elphick/manuals.html/developers-reference/index.html /tmp/ddr.html
  cp $S/http/www.debian.org/~elphick/manuals.html/packaging-manual/index.html /tmp/dpm.html
  (find-fline "/tmp/nmg.html")
  (find-fline "/tmp/ddr.html")
  (find-fline "/tmp/dpm.html")

}



# (eeman "3tcl switch" "examples")
