
# This script is sourced by every .th file that needs to know which
# files go into my site. After sourcing it we can issue the command
# "makemakefile" to output the "Makefile.auto".

# It checks the boolean environment variables DOMINIMAKEFILE and
# DOANGGDEPS.

# (find-fline "~/.zshrc" "makeL")
# (find-es "page" "makefile")
# (find-node "(make)Multiple Rules")

# .lists_of_files	(to "lists_of_files")
#   .translate	(to "translate")
#   .do_not_translate	(to "do_not_translate")
#   .escripts		(to "escripts")
#   .thfiles		(to "thfiles")
#   .thdeps		(to "thdeps")
#   .blogme		(to "blogme")
# .makefile_template	(to "makefile_template")
# .makeautomakefile	(to "makeautomakefile")



# $(HOME)/anggnt       -> anggnt
# $(HOME)/anggt        -> anggt
# $(HOME)/TH/thnt      -> TH/thnt
# $(HOME)/TH/tht       -> TH/tht
# $(HOME)/TH/thstem.th -> TH/thstem.th
# $(HOME)/e/estem.e    -> e/estem.e
#
#		          TH/thstem.th -> thstem.html
#
#                         anggt        -> anggt.html
#                         TH/tht       -> TH/tht.html
#                         e/estem.e    -> e/estem.e.html



proc key_and_dests {key dests} {
  global keys_and_dests DESTS
  lappend keys_and_dests $key $dests
  set DESTS($key) $dests
}



#%%%%
#
# Which files the makefile will refer to
#
#%%%%

# lists_of_files  (to ".lists_of_files")

set keys_and_dests {}

# Pairs of keys/dests that generate
# the real (big!) "Makefile.auto".
#
# translate  (to ".translate")
key_and_dests anggt {
  .emacs
  .emacs-tex.el
  .zshrc
  .bashrc
  .gdbinit
  .irbrc
  .cshrc
  .xinitrc.debian
  .xinitrc.redhat
  .xinitrc.cdd
  .emacs.local.bsd
  .emacs.local.debian
  .emacs.local.w32
  .fvwm/.fvwm2rc
  .fvwm/.fvwm2rc0
  .fvwm/.fvwm2rc1
  .fvwm/keys.fvwm
  .fvwm/nokeys.fvwm
  .fvwm/withkeys.fvwm

  .fvwm/all.fvwm
  .fvwm/edrx-menus.fvwm
  .fvwm/edrx-system.fvwm
  .fvwm/edrx.fvwm
  .fvwm/main-menu.hook
  .fvwm/post.hook.old

  .lua50/PP.c
  .lua50/PP.gdb
  .ruby/edrxinit.rb

  .zshrc.local.bsd
  .zshrc.local.cdd
  .zshrc.local.puc
  .zshrc.local.debian
  .zshrc.local.hurd
  .zshrc.local.mcgill
  .zshrc.local.sweetjane
  .zshrc.root
  .screenrc.hurd
  .a2ps/a2psrc
  .passwds.tcl-
  bin/Xscreenshot
  bin/Xscreenshot-rect
  bin/Xscreenshot-window
  bin/_psne
  bin/eeg
  bin/eeg4
  bin/fastcmp.lua
  bin/gsub.lua
  bin/pump.lua
  bin/sshot-uniq.lua
  bin/gs-640c-bw
  bin/intermail
  bin/mytcl
  bin/mywish
  bin/mysetxkb
  bin/netbsdman
  bin/lpdj-tmp
  compose-old.el
  eev-extras.el
  eev.el
  lynx.cfg
  run-zsh
  run-bash
  4NT/4start.btm
  4NT/hh.btm
  CRIM1/crim1a-lib.tcl
  CRIM1/crim1a-prims.tcl
  CRIM1/crim1a-demo0.tcl
  CRIM1/crim1a.tcl
  CRIM1/tclstuff2
  CV/cv-edrx-2006-pt-.tex
  EEG/gdbk.eeg
  EEG/gdbk.eeg3
  EEG/emacs1.eeg3
  ETC/README
  ETC/fstab.persephone
  ETC/fstab.persephone.guest
  ETC/gpm.conf.persephone-26
  ETC/inittab.persephone
  ETC/menu.lst.persephone
  ETC/sudoers.persephone
  ETC/wvdial.conf.persephone
  EXPECT/autopasswd
  EXPECT/Scp
  EXPECT/Sucuri
  EXPECT/Twu
  EXPECT/readfifo
  EXPECT/player
  ICON/debrepository.icn
  ICON/debreputil.icn
  ICON/vcsa2pnm.icn
  ICON/header.icn
  ICON/zinc.icn
  ICON/zlib.icn
  ICON/lslR2find2.icn
  ICON/tmp.icn
  FISL/README
  FISL/eev.tex
  LATEX/Makefile
  LATEX/catsem.bib
  LATEX/catsembibtest.tex
  LATEX/dednat.icn
  LATEX/desenhos.014
  LATEX/diaglib.014
  LATEX/tese2.sty
  LATEX/edrx.sty
  LATEX/poep.tex
  LATEX/yogphi.tex
  LATEX/reinhab.tex
  LATEX/dynkin.tcl
  LATEX/testdynkin.tex
  LFORTH/DNC
  LFORTH/README
  LFORTH/dbg.lua
  LFORTH/inner-mini.lua
  LFORTH/kernel.lua
  LFORTH/lforth
  LFORTH/outer-mini.lua
  LFORTH/stdlib.lua
  LFORTH/stdlib.lforth
  LFORTH/yoneda.lforth
  LILYPOND/minuet1.ly
  LILYPOND/roundmidnight.ly
  LUA/apt-move.lua
  LUA/blogme.lua
  LUA/brackets.lua
  LUA/call7777.lua
  LUA/debs.lua
  LUA/debs2.lua
  LUA/dednat.lua
  LUA/inc.lua
  LUA/index.blogme
  LUA/interactive.lua
  LUA/lh.lua
  LUA/loadlib/README.loadlib
  LUA/loadlib/lloadlib.c
  LUA/ldb/ldb.lua
  LUA/lstoindexhtml.lua
  LUA/lua50beta-argpatch.sh
  LUA/lua50init.lua
  LUA/lua50ref.r2
  LUA/luatclbridge.c
  LUA/math.blogme
  LUA/port7777.lua
  LUA/rectxpm.lua
  LUA/quickdiff.lua
  LUA/tinyftp.lua
  LUA/tinyftplib.lua
  LUA/tlbridge.c
  MTA/Makefile
  MTA/pio_fontx.c
  MTA/vtutil
  MTA/vtutilsh.c
  PHP/ip.php
  README
  edrx1
  SWIG/demo_luaClua.c
  TCL/attachgdb
  TCL/dragTs.tcl
  TCL/inc.tcl
  TCL/lstoindexhtml
  dednat/README
  dednat/Makefile
  dednat/inc.lua
  dednat/dednat.lua
  dednat/dednat2.lua
  dednat/dednat3.lua
  dednat/diagxy.lua
  dednat/experimental.lua
  dednat/example.tex

  blogme/README
  blogme/blogme.lua
  blogme/edrxlib.lua
  blogme/index.blogme
  blogme/css.lua
  blogme/withdef.lua
  blogme/INTERNALS
  blogme/blogme2.lua
  blogme/blogme2-inner.lua
  blogme/blogme2-middle.lua
  blogme/blogme2-outer.lua
  blogme/blogme2-extras.lua
  blogme/blogme2-cgi.lua

  blogme3/blogme3.txt
  blogme3/miniforth3.abs.txt
  blogme3/miniforth3.lua
  blogme3/anggdefs.lua
  blogme3/anggmake.lua
  blogme3/angglisp.lua
  blogme3/rumilisp.lua
  blogme3/rumimake.lua
  blogme3/brackets.lua
  blogme3/charset.lua
  blogme3/definers.lua
  blogme3/escripts.lua
  blogme3/elisp.lua
  blogme3/makefile.lua
  blogme3/blogme3.lua
  blogme3/notes.e.lua

  dednat4/Makefile
  dednat4/README
  dednat4/dednat4.lua
  dednat4/edrxlib.lua
  dednat4/experimental.lua
  dednat4/regex-lua-etags

  dednat4/downloads/Makefile
  dednat4/examples/Makefile
  dednat4/examples/demodefs.tex
  dednat4/examples/eqfibs.metatex
  dednat4/examples/edrxarrows.tex
  dednat4/examples/edrxdednat.tex
  dednat4/examples/edrxdefs.tex
  dednat4/examples/edrxdnt.tex
  dednat4/examples/edrxglyphs.tex
  dednat4/examples/edrxheadfoot.tex
  dednat4/examples/edrxmain.tex

  dednat4/examples/edrxdiagflags.tex
  dednat4/examples/edrxslides.tex

  dnc/NOTES
  dnc/ee-goto.el
  dynkin/Makefile
  dynkin/README
  dynkin/dyd-defs.tex
  dynkin/dyd-ex.tex
  dynkin/dynkin.tcl

  elisp/README
  elisp/emacs-wiki-edrx.el
  elisp/staff-mode.el
  elisp/stareval.el
  elisp/rpn.el
  elisp/geometria.el
  elisp/graficos.el
  elisp/rpn-geom.el
  elisp/plot.tcl
  elisp/tprops.el
  elisp/ttp.el
  elisp/ttp-1.el
  elisp/ttp-2.el
  elisp/ttp-qref.el
  elisp/eeimage.el
  elisp/math-glyphs.el
  elisp/w3m-e22.el
  elisp/cheap-face.el

  elisp/hisex.el
  elisp/myxpm.el

  flua/Makefile
  flua/README
  flua/demo1.flua
  flua/demo2.flua
  flua/demo3.flua
  flua/demo4.flua
  flua/demo6-lib
  flua/demo6.flua
  flua/demo7-lib
  flua/demo7.flua
  flua/flua-comp.lua
  flua/flua-prims.lua
  flua/flua.lua
  flua/inc.lua
  flua/skel.bytecode.asm
  flua/skel.engine.c
  lua-4.0/README.other
  lua-4.0/src/libdllua/lrexlib-new.c
  miniforth/TECHREP
  miniforth/cube1.mflua
  miniforth/miniforth1.lua
  miniforth/miniforth2.lua
  miniforth/miniforth3.abs.txt
  miniforth/miniforth3.lua
  miniforth/macro1.lua
  miniforth/macro2.lua
  miniforth/test1.mflua
  miniforth/test2.mflua
  miniforth/yoneda.mflua
  miniforth/mylua
  miniforth/lcode.e
  miniforth/crim/Makefile
  miniforth/crim/NOTES
  miniforth/crim/crim.lua
  miniforth/crim/crimextras.lua
  miniforth/crim/crimlabels.lua
  miniforth/crim/demo1.mflua
  miniforth/crim/demo2.mflua
  miniforth/crim/demo3.mflua
  miniforth/crim/demo4.mflua
  miniforth/crim/skel.bytecode.asm
  miniforth/crim/skel.engine.c
  vtutil/README
  vtutil/Makefile
  vtutil/pio_fontx.c
  vtutil/inc.lua
  vtutil/vtutil.lua
  vtutil/mathchars.lua
  vtutil/makefonts_8.lua
  vtutil/vtscreenshot

  vtutil4/Makefile
  vtutil4/README
  vtutil4/inc.lua
  vtutil4/lbitlib.c
  vtutil4/mathchars.lua
  vtutil4/piofontx.c
  vtutil4/regex-lua-etags
  vtutil4/vtfontlib.lua
  vtutil4/vtutil.lua

  eev/.files
  eev/Makefile
  eev/INSTALL
  eev/README
  eev/README.pt
  eev/TODO
  eev/debian/README.debian
  eev/debian/50eev.el
  eev/debian/packages
  eev/demo/.bashrc
  eev/demo/.emacs
  eev/demo/.gdbinit
  eev/demo/.profile
  eev/demo/.zshrc
  eev/demo/dlopen.e
  eev/demo/dlopen.eeg4
  eev/demo/emacs0.eeg4
  eev/e/debian-chroot.e
  eev/e/debian-pkg.e
  eev/e/debian.e
  eev/e/debootstrap.e
  eev/e/keys.e
  eev/e/links.e
  eev/e/tutorial.e
  eev/e/tutorial.pt.e
  eev/eeg
  eev/eeg4

  eev/eev.el
  eev/eev-vars.el
  eev/eev-misc.el
  eev/eev-links.el
  eev/eev-mklinks.el
  eev/eev-save.el
  eev/eev-hybrids.el
  eev/eev-menu-bar.el

  eev/eev-gud.el
  eev/glyphs.el
  eev/libeeg/k
  eev/libeeg/msg
  eev/libeeg/term
  eev/libeeg/glue
  eev/libeeg/fast
  eev/libeeg/all
  eev/libeeg/term-linux.auto.tcl
  eev/libeeg/term-xterm.auto.tcl
  eev/libeeg/term-screen.auto.tcl
  eev/texts/brave-gnu-world-13.txt
  eev/texts/eev-manifesto.txt
  eev/texts/informal.txt
  eev/texts/tourism.txt
  eev/texts/why-users.txt
  eev/changer.awk
  eev/changer.sh
  eev/rcfiles/.bashrc
  eev/rcfiles/.cshrc
  eev/rcfiles/.zshrc
  eev/rcfiles/.gdbinit
  eev/rcfiles/.emacs

  eev-current/.favicon.el
  eev-current/Makefile
  eev-current/BUGS
  eev-current/CHANGELOG
  eev-current/DEDICATION
  eev-current/DEDICATION.c-r
  eev-current/DEDICATION.c-r.orig
  eev-current/TODO
  eev-current/anim/.favicon.el
  eev-current/article/.favicon.el
  eev-current/article/Makefile
  eev-current/article/README
  eev-current/article/eev.tex
  eev-current/article/eev.txt
  eev-current/doc/EEVMANIFESTO
  eev-current/doc/HISTORY
  eev-current/doc/NAO_pt
  eev-current/doc/README
  eev-current/doc/README-0.93
  eev-current/doc/TOURISM
  eev-current/doc/eev.texi
  eev-current/doc/keys.e
  eev-current/doc/tutorial.e
  eev-current/examples/.favicon.el
  eev-current/examples/README
  eev-current/examples/anim.e
  eev-current/examples/awk.e
  eev-current/examples/busybox.e
  eev-current/examples/c.e
  eev-current/examples/debian.e
  eev-current/examples/demos.e
  eev-current/examples/debs2.lua
  eev-current/examples/eev-tests.e
  eev-current/examples/emacs.e
  eev-current/examples/gtk.e
  eev-current/examples/iskidip.e
  eev-current/examples/iskidip2.e
  eev-current/examples/lua.e
  eev-current/examples/make.e
  eev-current/examples/mgp.e
  eev-current/examples/perl.e
  eev-current/examples/php.e
  eev-current/examples/ps.e
  eev-current/examples/python.e
  eev-current/examples/qemu.e
  eev-current/examples/ruby.e
  eev-current/examples/screenshots.e
  eev-current/examples/sh.e
  eev-current/examples/svn.e
  eev-current/examples/tcltk.e
  eev-current/examples/tex.e
  eev-current/examples/escript-mode.el
  eev-current/examples/infoindex.rb
  eev-current/rcfiles/README
  eev-current/rcfiles/tmp/README
  eev-current/tmp/README
  eev-current/tmp/tmp-pst.tex
  eev-current/tmp/tmp.c
  eev-current/tmp/tmp.mp
  eev-current/tmp/tmp.tex

  eev-current/slides/dec2006-pt.txt

  .eev/HELP
  .eev/HELP-html
  .eev/HELP-gtk
  .eev/HELP-lua
  .eev/HELP-howm

  windows-emacs/make-iso.e
  FundComp/etc
  FundComp/trabalho-eval
  FundComp/trabalho-geometria
  FundComp/trabalho-graficos
  FundComp/trabalho-rpn
  FundComp/trabalho-tabelas

  taro.txt
  tecido

  MARCOS/foo.lua

}
# do_not_translate  (to ".do_not_translate")
key_and_dests anggnt {
  .mapleinit
  .tclshrc
  .psne.carry
  glyphbug
  .Xdefaults

  HOWM/MainTasks
  HOWM4/Installation

  BUSYBOX/config-1.00
  BUSYBOX/config-1.2.0
  C/Makefile
  C/fontimage.c
  C/fontimage.icn
  C/math.extras
  CRIM1/Crim-0.01.tar.gz
  CRIM1/Crim-0.02.tar.gz
  CRIM1/Makefile
  CRIM1/README
  CRIM1/crim1-2000jul07.txt
  CRIM1/demo0a.tf
  CRIM1/demo0a.lst
  CRIM1/demo0b.tf
  CRIM1/demo0b.lst
  CRIM1/demo1.tf
  CRIM1/demo1.lst
  CRIM1/demo2.tf
  CRIM1/demo2.lst
  CRIM1/demo2.engine.c
  CRIM1/demo3a.tf
  CRIM1/demo3a.lst
  CRIM1/demo3b.tf
  CRIM1/demo3b.lst
  CRIM1/engine0.c
  CRIM1/engine1.c
  CRIM1/engine2.c
  CRIM1/engine3a.c
  CRIM1/engine3b.c
  CRIM1/tclstuff
  DANIEL/daniel.png
  DANIEL/engrac-p173.png
  EDRXPAGE/README
  EDRXPAGE/copyright
  EDRXPAGE/packages
  EXPECT/anonftp
  EXPECT/eheaders
  EXPECT/emaple
  EXPECT/seefonts
  EXPECT/sshsucuri
  ICON/tron.icn
  ICON/tron.icn.html
  ICON/tron.icn.png
  IMAGES/emacsllded.png
  IMAGES/emacsvtutil.png
  IMAGES/gawk.png
  IMAGES/kaoya.png
  IMAGES/preslim.png
  IMAGES/rrj.png
  IMAGES/stpkys_vsm_notxt.gif
  IMAGES/exists-shot.png
  IMAGES/exists-xdvi.png
  IMAGES/trans.png
  IMAGES/powered-by-anger.png
  IMAGES/powered-by-anger.svg
  IMAGES/hyperdoctrine.png
  IMAGES/Atimes.png
  IMAGES/Atimes-dnt.png
  IMAGES/TfromFtoG.png
  IMAGES/lccc-bcc.png
  IMAGES/lccc-frob.png
  IMAGES/eqfib-trans.png
  IMAGES/forth.png
  IMAGES/littlelangs.png
  IMAGES/transparent-fav.png
  LATEX/bussproofs.sty
  LATEX/zinc.icn
  LATEX/zlib.icn
  LATEX/proof.edrx.sty
  LATEX/mar99a.dn
  LATEX/mar99a.dnt
  LATEX/mar99b.dn
  LATEX/mar99b.dnt
  LATEX/vgatim.sty
  LATEX/gray50.bmp
  LATEX/gray50xx.bmp
  LINUX/2.4.26-initrd.conf
  LINUX/2.6.28-persephone1.conf
  LUA/toposort.lua
  LUA/loadlib/loadlib.patch
  MTA/defkeymap850b.map
  MTA/128
  MTA/128b
  MTA/math850.map
  MTA/fonts.dir
  MTA/math1.8.bdf
  MTA/math1.8b.bdf
  MTA/math1.8c.bdf
  PFORTH/Makefile
  PFORTH/mtamacros.h
  PFORTH/tclpforth.c
  PFORTH/tclpforth.tcl
  PFORTH/tclpf_custom.c
  PFORTH/tclpf_hook.c
  PYTHON/debs.py
  SQL/mysqltutor-1
  SQL/mysqltutor-2
  TCL/dednames
  TCL/httpwiki-old
  TCL/httpwiki
  TCL/fix-eheaders
  TCL/font2bdf
  TCL/piano.tcl
  TCL/tcl.ttp
  TCL/Tcl-pt.n
  TEXINFO/eev.texi

  bin/emacs-c.cmd
  bin/gravis-up
  bin/inx-up
  bin/inx.dip-nopwds
  bin/kbrequest
  bin/sendemail
 crim/index.html
 crim/1-autod.4th.txt
 crim/1.4th.txt
 crim/1.aud.txt
 crim/2-autod.4th.txt
 crim/2.4th.txt
 crim/2.aud.txt
 crim/ETC.txt
 crim/announce.txt
 crim/autodoc.4th.txt
 crim/crim.c.txt
 crim/crimcomp.4th.txt
 crim/letter.txt
 crim/patchpfe.txt
  davidwest.txt
  dednat/bussproofs.sty
  dednat/proof.edrx.sty
  dednat/example_tex.png
  dednat/example_dvi.png
  diaglib/godement1.png
  diaglib/godement2.png
  diaglib/godement3.png
  eev/dlopen.png

  dednat4/dednat4-icon.png
  blogme/blogme-icon.png
  blogme3/.favicon.png
  icon-tourism.png

  eev-current/.files
  eev-current/COPYING
  eev-current/INSTALL-0.95.0
  eev-current/README-0.95.0
  eev-current/README-0.95.1
  eev-current/THANKS
  eev-current/VERSION
  eev-current/doc/shot-f3.png
  eev-current/doc/shot-f9.png
  eev-current/doc/shot-eev-ttp.png
  eev-current/doc/diag-save.svg
  eev-current/doc/diag-save.jpg
  eev-current/doc/diag-links.svg
  eev-current/doc/diag-links.jpg

  eev-current/ChangeLog
  eev-current/ChangeLog.html
  eev-current/EMACS
  eev-current/EMACS.html
  eev-current/INSTALL
  eev-current/INSTALL.html
  eev-current/NEWS
  eev-current/NEWS.html
  eev-current/README
  eev-current/README.html
  eev-current/eev.el
  eev-current/eev.el.html
  eev-current/eev-bounded.el
  eev-current/eev-bounded.el.html
  eev-current/eev-bounded-old.el
  eev-current/eev-bounded-old.el.html
  eev-current/eev-compose.el
  eev-current/eev-compose.el.html
  eev-current/eev-glyphs.el
  eev-current/eev-glyphs.el.html
  eev-current/eev-steps.el
  eev-current/eev-steps.el.html
  eev-current/eev-browse-url.el
  eev-current/eev-browse-url.el.html
  eev-current/eev-insert.el
  eev-current/eev-insert.el.html
  eev-current/eev-langs.el
  eev-current/eev-langs.el.html
  eev-current/eev-mini.el
  eev-current/eev-mini.el.html
  eev-current/eev-mini-steps.el
  eev-current/eev-mini-steps.el.html
  eev-current/eev-sshot.el
  eev-current/eev-sshot.el.html
  eev-current/compose.el
  eev-current/compose.el.html
  eev-current/glyphs.el
  eev-current/glyphs.el.html
  eev-current/htmlize-eev.el
  eev-current/htmlize-eev.el.html
  eev-current/htmlize-all.el
  eev-current/htmlize-all.el.html
  eev-current/eeg
  eev-current/eeg4
  eev-current/eeg4.html
  eev-current/eegchannel
  eev-current/eegchannel.html

  eev-current/eev-math-glyphs.el
  eev-current/eev-math-glyphs.el.html

  eev-current/eev-dev.el
  eev-current/eev-dev.el.html
  eev-current/eev-walk.el
  eev-current/eev-walk.el.html
  eev-current/eev-ttp.el
  eev-current/eev-ttp.el.html
  eev-current/eev-insert-old.el
  eev-current/eev-insert-old.el.html

  eev-current/eev-glyph-icon.png
  eev-current/eev-icon.png

  eev-current/.favicon.png
  eev-current/anim/.favicon.png
  eev-current/anim/README
  eev-current/anim/channels.anim
  eev-current/anim/channels.anim.html
  eev-current/anim/gdb.anim
  eev-current/anim/gdb.anim.html
  eev-current/article/.favicon.png
  eev-current/article/ss-f9.png
  eev-current/article/ss-gdbtall.png
  eev-current/article/ss-gdbwide.png
  eev-current/article/ss-lua.png
  eev-current/article/ss-m-h.png
  eev-current/article/ss-modular.png
  eev-current/article/iskidip.eps
  eev-current/article/iskidip.svg
  eev-current/examples/.favicon.png

  eev-current/rcfiles/.bashrc
  eev-current/rcfiles/.bashrc.html
  eev-current/rcfiles/.bashrc-psne
  eev-current/rcfiles/.bashrc-psne.html
  eev-current/rcfiles/.fvwmrc
  eev-current/rcfiles/.fvwmrc.html
  eev-current/rcfiles/.pythonrc.py
  eev-current/rcfiles/.pythonrc.py.html
  eev-current/rcfiles/.tclshrc
  eev-current/rcfiles/.tclshrc.html
  eev-current/rcfiles/.vimrc
  eev-current/rcfiles/.vimrc.html
  eev-current/rcfiles/.zshrc
  eev-current/rcfiles/.zshrc.html
  eev-current/rcfiles/.zshrc-psne
  eev-current/rcfiles/.zshrc-psne.html
  eev-current/rcfiles/change
  eev-current/rcfiles/change.html
  eev-current/rcfiles/change.awk
  eev-current/rcfiles/change.awk.html
  eev-current/rcfiles/channel.py
  eev-current/rcfiles/channel.py.html
  eev-current/rcfiles/channel.tcl
  eev-current/rcfiles/channel.tcl.html

  eev-current/eev-rctool
  eev-current/eev-rctool.html

  elisp/tron.el
  elisp/tron.el.html
  elisp/tron.el.png
  elisp/scrshot-plot.png
  elisp/sshot.el
  elisp/sshot.el.html
  kconf2220-cdrw
  lua-4.0/Makefile.patch
  lua-4.0/README.rttpatch
  lua-4.0/README.yada
  lua-4.0/_NEWFILES
  lua-4.0/_PATCHES
  lua-4.0/config.patch
  lua-4.0/debian/changelog
  lua-4.0/debian/packages

  lua-4.0/debian/control
  lua-4.0/debian/dirs
  lua-4.0/debian/docs
  lua-4.0/debian/rules

  lua-4.0/doc/lua.texi
  lua-4.0/include/dllua.h
  lua-4.0/src/libdllua/Makefile
  lua-4.0/src/libdllua/dllua_open.c
  lua-4.0/src/libdllua/lbitlib.c
  lua-4.0/src/libdllua/loadlib.c
  lua-4.0/src/libdllua/loadlib.h
  lua-4.0/src/libdllua/lrexlib.c
  lua-4.0/src/lua/Makefile.patch
  lua-4.0/src/lua/lua.c.patch
  mktclapp-3.9/.files
  mktclapp-3.9/Makefile
  mktclapp-3.9/README.debian
  mktclapp-3.9/debian/README.debian
  mktclapp-3.9/debian/changelog
  mktclapp-3.9/debian/control
  mktclapp-3.9/debian/copyright
  mktclapp-3.9/debian/dirs
  mktclapp-3.9/debian/docs
  mktclapp-3.9/debian/examples
  mktclapp-3.9/debian/rules
  mktclapp-3.9/debian/substvars
  mktclapp-3.9/examples/Makefile
  mktclapp-3.9/examples/README
  mktclapp-3.9/examples/factor.c
  mktclapp-3.9/examples/factor.tcl
  mktclapp-3.9/examples/factor2.tcl
  mktclapp-3.9/examples/hello.c
  mktclapp-3.9/examples/hello0.tcl
  mktclapp-3.9/examples/hello1.tcl
  mktclapp-3.9/examples/hello2.tcl
  mktclapp-3.9/examples/hellob.tcl
  mktclapp-3.9/mktclapp.pod
  mktclapp-3.9/xmktclapp.pod
  p.txt
  s.txt
  greenliv1.txt
  rumi1.txt
  replace/defkeymap-iso.map
  replace/defkeymap850b.map
  replace/iso01.f08
  replace/TextConfig.angg
  the_hurd_links.html
  l4-hurd.html
  vtutil/editing-font.png
  vtutil/ega0.8
  vtutil/ega1.8
  vtutil/ega0.16
  vtutil/ega1.16
  vtutil/defkeymap.map.edrx

  vtutil4/ega0.16
  vtutil4/ega0.8
  vtutil4/ega1.16
  vtutil4/ega1.8

  windows-emacs/abre-c.bat
  windows-emacs/copia-d.bat
  windows-emacs/copia-e.bat
  windows-emacs/emacs-c.bat
  windows-emacs/emacs-d.bat
  windows-emacs/emacs-e.bat
  windows-emacs/bats.zip

  usrc/rcirc/rcirc.el
  usrc/rcirc/rcirc-x.el

WebWiki/AleisterCrowley.html
WebWiki/BodyMods.html
WebWiki/CategoryTheory.html
WebWiki/ChurchOfEuthanasia.html
WebWiki/CompCs.html
WebWiki/DakiniDeck.html
WebWiki/DebianGnu.html
WebWiki/DebianVsRedHat.html
WebWiki/Dictionaries.html
WebWiki/DistanciaPontoReta.html
WebWiki/DosAndWindows.html
WebWiki/Eev.html
WebWiki/EevInterface.html
WebWiki/EevToDo.html
WebWiki/ElispHyperlinks.html
WebWiki/Emacs.html
WebWiki/EmacsParaWindows.html
WebWiki/EmacsWiki.html
WebWiki/EmacsWikiEl.html
WebWiki/EmacsWikiMode.html
WebWiki/Estatistica.html
WebWiki/EstatisticaAulas.html
WebWiki/EstatisticaQuestionarios.html
WebWiki/FCBibliografia.html
WebWiki/FCHistoria.html
WebWiki/FCTeoriaDaComputacao.html
WebWiki/Forth.html
WebWiki/FundComp.html
WebWiki/FundCompEmacs.html
WebWiki/FundCompTrabalhos.html
WebWiki/Games.html
WebWiki/GarySnyder.html
WebWiki/Geometria.html
WebWiki/Hurd.html
WebWiki/Icon.html
WebWiki/LacqueredDuck.html
WebWiki/LambdaCalculo.html
WebWiki/LilyPond.html
WebWiki/Linux.html
WebWiki/LispMemoria.html
WebWiki/LispOrdemDeAvaliacao.html
WebWiki/Lua.html
WebWiki/MudancaDeEscala.html
WebWiki/Music.html
WebWiki/NetBsd.html
WebWiki/NewTags.html
WebWiki/Personal.html
WebWiki/Politics.html
WebWiki/PostScript.html
WebWiki/SchemeVersusLisp.html
WebWiki/Silk.html
WebWiki/SlackWare.html
WebWiki/TclTkExpect.html
WebWiki/ToDo.html
WebWiki/Translacoes.html
WebWiki/VariaveisLivres.html
WebWiki/VeganPage.html
WebWiki/Vetores.html
WebWiki/Viola.html
WebWiki/WelcomePage.html
WebWiki/WikiIndex.html
WebWiki/pitagoras.fig.html
Wiki/AleisterCrowley
Wiki/BodyMods
Wiki/CategoryTheory
Wiki/ChurchOfEuthanasia
Wiki/CompCs
Wiki/DakiniDeck
Wiki/DebianGnu
Wiki/DebianVsRedHat
Wiki/Dictionaries
Wiki/DistanciaPontoReta
Wiki/DosAndWindows
Wiki/Eev
Wiki/EevInterface
Wiki/EevToDo
Wiki/ElispHyperlinks
Wiki/Emacs
Wiki/EmacsParaWindows
Wiki/EmacsWikiMode
Wiki/Estatistica
Wiki/EstatisticaAulas
Wiki/EstatisticaQuestionarios
Wiki/FCBibliografia
Wiki/FCHistoria
Wiki/FCTeoriaDaComputacao
Wiki/Forth
Wiki/FundComp
Wiki/FundCompEmacs
Wiki/FundCompTrabalhos
Wiki/Games
Wiki/GarySnyder
Wiki/Geometria
Wiki/Hurd
Wiki/Icon
Wiki/LacqueredDuck
Wiki/LambdaCalculo
Wiki/LilyPond
Wiki/Linux
Wiki/LispMemoria
Wiki/LispOrdemDeAvaliacao
Wiki/Lua
Wiki/MudancaDeEscala
Wiki/Music
Wiki/NetBsd
Wiki/Personal
Wiki/Politics
Wiki/PostScript
Wiki/SchemeVersusLisp
Wiki/Silk
Wiki/SlackWare
Wiki/TclTkExpect
Wiki/ToDo
Wiki/Translacoes
Wiki/VariaveisLivres
Wiki/VeganPage
Wiki/Vetores
Wiki/Viola
Wiki/WelcomePage
Wiki/pitagoras.fig
}

# (eev "rm ~/TH/L/Makefile.auto; WIKIFILES=$(cd; echo Wiki/* WebWiki/*) makeL")
# (find-sh "cd; print -l Wiki/* WebWiki/* | grep -v '~' | sort")


# escripts  (to ".escripts")
# (find-fline "$ES/")
# (find-sh "cd $ES; ls -C *.e | expand | sed s/\\\\.e//g")

key_and_dests estem \
  [without1 {cartas contas corresp secret locz linhadir} [lsort {

04dia-d        diagrams     howm        mgp            rest
04lua          dict         hsforth     mini           rpm
21             doc          html        mktclapp       ruby
anatocc        dos          http        ml             scheme
angg           dpkg         hurd-old    modelcheck     screen
anggsmil       dual         hurd        modem          slink
apache         e2fs         hw-eth      modula3        smalltalk
apt            eeg          hw-parport  mouse          snarf
awk            eev          hw-sound    mp3            sound
bash           emacs        icon        multiterminal  sql
bis            escripts     icq         music          squeak
bootcd         ethernet     index       mysql          ssh
bsd            ewiki        init        net            sudo
busybox        exim         initrd      netbasics      tcl-cipsga
cdd            expect       inkscape    netbsd         tcl
cdrom          fl           interbase   netscape       tcsh
cfengine       float        ion         news           tese
charsets       floppy       irc         nonfree        tex
chinese        flua         k22         octal          texinfo
chroot         forth        kernel      oldpage        todo
cipsga         fortho       latest      oskit          tomsrtbt
clock          ftpd         lexyacc     page           tourism
conf           fvwm         licenses    pam            transp
console        games        lilo        perl           usermodelinux
coq            gdb          lilypond    perl1          vi
crim           general      livecd      php            vnc
cron           gimp         locale      planner        wget
cvs            gnome        localnet    postgres       wiki
dbootstrap     gnuplot      lua-old     potato         x
debian-by-ex   gpg          lua         potatocds      xxx-server
debian-cd      greenmatrix  lua5        print          xypic
debian-net     groff        lynx        ps             yard
debian         grub         mail        python         zsh       gforth
debian0        gtk          make        qemu             oracle     gaim
debiandev      hardware     man         raven10          swig       openoffice
debrepository  haskell      maple       raven10b         dialog     figlet
dednat         hd           math        redhat           sweetjane  dvd   lisp

}]]

# thfiles  (to ".thfiles")
# (find-fline "~/TH/")
# (shell-command "cd ~/TH/; ls -C *.th" t)
# (shell-command "cd ~/TH/; ls -C *.th | expand | sed s/\\\\.th//g" t)
key_and_dests thstem \
  [lsort {

01jul14      eev-mails      html       movies   to-do
arafat       eev-manifesto  hurd                tourism-old
cipsga       eev-notes                 other    unclassified
contact-old  eev-2004       index-old  perl     unclassified2
crashco      emacs-tutor    index-th   python   unclassified3
crim1        emacs-old      index2     redhat0  vegan-old
             escripts       linux      search   vtutil
debug        files          logic      snarf    why-users
dednat       forth          lua-old    tcltk    zsh
diaglib-old  gnu            map        tese
             grub           math       test
duallinux    hacks          mktclapp   tex
dvis         haskell        montreal   thl
  Estatistica Geometria FundComp

}]

# thdeps  (to ".thdeps")
# (find-fline "~/TH/")
key_and_dests tht {
  Generate
  Htmllib.tcl
  Files.tcl
  Debiandocs.tcl

  Makefile
}

key_and_dests thnt {
}

# ?? key_and_dests ahtml [join $DESTS(anggt)]

# blogme  (to ".blogme")
# (shell-command "cd ~/TH/; ls -C *.blogme" t)
# (find-sh "cd ~/TH/; ls -C *.blogme | expand | sed s/\\\\.blogme//g")
#
key_and_dests bmstem {

blogme           heroes         snyder
bookmarks        icon           speedbar
contact          index          tcl
cv-edrx-2005-pt  iskidip        tmp-b
dba              iskidip0       tmp
debian           littlelangs             index2007
dednat4          luaforth       tourism
desarmamento     luasocket      vegan
eev-article      math-b         vegan1
emacs            music          w32
floreser         personal       webcomics  blogme3
friends          politics                  blog   unibanco  ruby
fvwm             seminar-notes             rrj  rrj2  rrj3  rrj4  smalltalk
  leatavora                                eev  desalojados  minilangs
  oficinadasemente

}








#%%%%
#
# The template for the makefile
#
#%%%%

# makefile_template  (to ".makefile_template")
# (find-angg "TH/Generate" "makefile_functions")

set template {

TH_HTMLS =  thstem.html  bmstem.html

A_HTMLS =  anggt.html  TH/tht.html

E_HTMLS =  e/estem.e.html

TGZFILES =  anggt  \
	    anggnt \
	    e/estem.e    \
	    TH/thstem.th \
	    TH/tht \
	    TH/thnt \
	    TH/bmstem.blogme

ifeq ($(COPYING),1)
COPIES = $(TGZFILES)

anggt: $(HOME)/anggt
	$(CP) $< $@ && touch -c $@

anggnt: $(HOME)/anggnt
	$(CP) $< $@ && touch -c $@

e/estem.e: $(ES)/estem.e
	$(CP) $< $@ && touch -c $@

TH/tht: $(THDIR)/tht
	$(CP) $< $@ && touch -c $@

TH/thnt: $(THDIR)/thnt
	$(CP) $< $@ && touch -c $@

TH/thstem.th: $(THDIR)/thstem.th
	$(CP) $< $@ && touch -c $@

TH/bmstem.blogme: $(THDIR)/bmstem.blogme
	$(CP) $< $@ && touch -c $@

else
COPIES =
endif

#Extra deps:
files.html: $(THDIR)/Files.tcl
debian.html: $(THDIR)/Debiandocs.tcl
escripts.html: $(THDIR)/Files.tcl

bmstem.html: TH/bmstem.blogme
	$(BLOGME3) -o $@ -i $<

thstem.html: TH/thstem.th
	$(GENERATE) $@ $<

anggt.html: anggt
	$(BLOGME3) -o $@ -a2html $<

TH/tht.html: TH/tht
	$(BLOGME3) -o $@ -a2html $<

e/estem.e.html: e/estem.e
	$(BLOGME3) -o $@ -a2html $<

}


# makeautomakefile  (to ".makeautomakefile")
proc makeautomakefile {} {
  global keys_and_dests template
  outputs [replicate_all $keys_and_dests $template]
}




#  Local Variables:
#  coding:               raw-text-unix
#  ee-anchor-format:     "%s"
#  ee-charset-indicator: ""
#  End:
