-- angglisp.lua:
-- This file:
--   http://angg.twu.net/blogme4/angglisp.lua.html
--   http://angg.twu.net/blogme4/angglisp.lua
--                    (find-blogme4 "angglisp.lua")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
-- Version: 2011aug03
-- License: GPL3
--

require "elisp"         -- (find-blogme4 "elisp.lua")


ewords["find-angg"] = Eword {
    help = eevarticle.."#shorter-hyperlinks",
    base = "http://angg.twu.net/",
    ext  = ".html",
  }
ewords["find-image"] = Eword {
    sexphtml = function (eword, sexp) return "[image]" end,
  }


-- These functions will be moved to somewhere else at some point...
-- This is a port of: (find-blogme3 "angglisp.lua")
-- See also: (find-blogme3 "anggdefs.lua" "-anggat")
--           (find-blogme3 "angglisp.lua" "code_c_d_angg")

code_c_d_angg = function (c, d)
    ewords["find-"..c.."file"] = Eword {
        help = eevarticle.."#shorter-hyperlinks",
        base = pathto(d),
        ext  = "",       -- wrong; the correct would be no anchor
      }
    ewords["find-"..c] = Eword {
        help = eevarticle.."#shorter-hyperlinks",
        base = pathto(d),
        ext  = ".html",
      }
    ewords["find-"..c.."w3m"] = Eword {
        help = eevarticle.."#shorter-hyperlinks",
        base = pathto(d),
        ext  = "",       -- wrong; the correct would be no anchor
      }
  end

code_c_d_angg("angg",    "")                  -- (find-angg "blogme4/")
code_c_d_angg("es",      "e/")                -- (find-es "lua5")
code_c_d_angg("dednat4", "dednat4/")          -- (find-dednat4 "")
code_c_d_angg("dn4",     "dednat4/")
code_c_d_angg("dn4ex",   "dednat4/examples/")
code_c_d_angg("dn5",     "dednat5/")
code_c_d_angg("blogme",  "blogme/")
code_c_d_angg("blogme3", "blogme3/")
code_c_d_angg("blogme4", "blogme4/")
code_c_d_angg("eev",     "eev-current/")
code_c_d_angg("flua",    "flua/")
code_c_d_angg("rubyforth", "rubyforth/")
code_c_d_angg("vtutil",  "vtutil/")
code_c_d_angg("vtutil4", "vtutil4/")
code_c_d_angg("RETRO",   "RETRO/")

ewords["find-es"].ext = ".e.html"




-- dump-to: tests
--[==[
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
require "angglisp"   -- (find-blogme4 "angglisp.lua")

--]==]

-- Local Variables:
-- coding:             raw-text-unix
-- ee-anchor-format:   "%s"
-- End:
