#!/bin/sh
# This is the file ".files.sh" of blogme3,
#   based on: (find-dn4 ".files.sh")
# Author: Eduardo Ochs <eduardoochs@gmail.com>
# Version: 2008jul21
# Public domain.
#   http://angg.twu.net/blogme3/.files.sh
#   http://angg.twu.net/blogme3/.files.sh.html

# (find-eevfile "Makefile" "(TZ=GMT date; date) > VERSION")

# (find-blogme3file "")
# (find-blogme3ex "")
# (find-blogme3file "anggmake.lua")
# (find-es "dednat" "tex-src-tgz")
# (find-sh "~/dednat4/.files.sh tarballfiles")
# (find-angg ".emacs" "dednat4-setup")

# (find-blogme3sh "./.files.sh")
# (find-blogme3sh "./.files.sh    tarballfiles")
# (find-blogme3sh "./.files.sh -n rmtexinputs")
# (find-blogme3sh "./.files.sh -n cpdemos")
# (find-blogme3sh "./.files.sh -n cptexinputs")
# (find-blogme3sh "./.files.sh -n rmtexinputs")
# (find-sh "rm -Rv /tmp/dt/; mkdir /tmp/dt/")
# (find-sh "cd /tmp/dt/ && pwd && ~/dednat4/.files.sh -n cpdemos")
# (find-sh "cd /tmp/dt/ && pwd && ~/dednat4/.files.sh    cpdemos")
# (find-sh "cd /tmp/dt/ && pwd && ~/dednat4/.files.sh -n cptexinputs")
# (find-sh "cd /tmp/dt/ && pwd && ~/dednat4/.files.sh    cptexinputs")
# (find-sh "cd /tmp/dt/ && pwd && ~/dednat4/.files.sh -n rmtexinputs")
# (find-sh "cd /tmp/dt/ && pwd && ~/dednat4/.files.sh    rmtexinputs")

function main () {
  echo .files.sh			;# (find-blogme3 ".files.sh")
  echo Makefile				;# (find-blogme3 "Makefile")
  echo edrxlib.lua			;# (find-blogme3 "edrxlib.lua")
  echo brackets.lua			;# (find-blogme3 "brackets.lua")
  echo definers.lua			;# (find-blogme3 "definers.lua")
  echo charset.lua			;# (find-blogme3 "charset.lua")
  echo escripts.lua			;# (find-blogme3 "escripts.lua")
  echo elisp.lua			;# (find-blogme3 "elisp.lua")
  echo makefile.lua			;# (find-blogme3 "makefile.lua")
  echo options.lua			;# (find-blogme3 "options.lua")
  echo blogme3.lua			;# (find-blogme3 "blogme3.lua")
}
function anggrumi () {
  echo lstoindexhtml.lua		;# (find-blogme3 "lstoindexhtml.lua")
  echo anggdefs.lua			;# (find-blogme3 "anggdefs.lua")
  echo anggmake.lua			;# (find-blogme3 "anggmake.lua")
  echo angglisp.lua			;# (find-blogme3 "angglisp.lua")
  echo rumilisp.lua			;# (find-blogme3 "rumilisp.lua")
  echo rumimake.lua			;# (find-blogme3 "rumimake.lua")
  echo youtube.lua			;# (find-blogme3 "youtube.lua")
}
function extras () {
  echo blogme3.txt			;# (find-blogme3 "blogme3.txt")
  echo miniforth3.abs.txt		;# (find-blogme3 "miniforth3.abs.txt")
  echo miniforth3.lua			;# (find-blogme3 "miniforth3.lua")
  echo notes.e.lua			;# (find-blogme3 "notes.e.lua")
}

function basenames () { for i in $(cat); do basename $i; done; }
function prepends  () { for i in $(cat); do echo $(dirname $0)/$i; done; }
function run () { echo $1; if [ "$DUMMY" == "no" ]; then eval $1; fi; }
function cps  () { for i in $(prepends);  do run "cp -v $i .";  done; }
function cpss () { for i in $(prepends);  do run "cp -sv $i ."; done; }
function rms  () { for i in $(basenames); do run "rm -v $i";    done; }

function tarballfiles () { echo VERSION; main; anggrumi; extras; }
function cpdemos      () { { texedrx; texdemos; texother; } | cps; }
function rmdemos      () { { texedrx; texdemos; texother; } | rms; }
function cptexinputs  () { texedrx | cpss; texother | cps; }
function rmtexinputs  () { { texedrx; texother; } | rms; }

DUMMY=no
if [ "$1" == "-n" ]; then
  # Inspired by: (find-node "(make)Echoing")
  echo "# dummy mode, not executing"
  DUMMY=yes
  shift
fi
if [ "$1" == "" ]; then
  echo "Usage: $0 [-n] cpdemos|rmdemos|cptexinputs|rmtexinputs|tarballfiles"
  echo "With '-n' just print the 'cp' and 'rm' commands, do not execute them."
  echo "  cptexinputs: copy some LaTeX files to the current directory."
  echo "  rmtexinputs: remove those files."
  echo "  cpdemos: copy some LaTeX files (for demos) to the current dir."
  echo "  rmdemos: remove those files."
  echo "  tarballfiles: list the files that should go in the tarball."
else
  $*
fi
