-- -*- coding: raw-text -*-
-- angglisp.lua - See: (find-blogme3 "elisp.lua")
-- This is part of blogme3.
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
-- Version: 2019feb28
-- <http://anggtwu.net/blogme3/makefile.lua>
-- <http://anggtwu.net/blogme3/makefile.lua.html>
-- License: GPL.

-- See: (find-blogme3 "escripts.lua")
--      (find-blogme3 "elisp.lua")

-- This files uses relative links *a lot*, and it can only be loaded
-- after the variabless

-- We can only load this file when the variables "pathtoroot" and
-- "eevarticle" are set; usually they are set by the "-o" option.
--   (find-blogme3 "elisp.lua" "relative-links")
--   (find-blogme3 "options.lua" "basic-options")

-- Quick index:
-- .code_c_d_angg	(to "code_c_d_angg")
-- .cruft-jan2024	(to "cruft-jan2024")
-- .set_EHELP_intros	(to "set_EHELP_intros")
-- .code_c_d_remotes	(to "code_c_d_remotes")
-- .find_node		(to "find_node")
-- .code_c_m_b_s	(to "code_c_m_b_s")
-- .code_ps		(to "code_ps")
-- .find-LATEX	(to "find-LATEX")
-- .find-LTX		(to "find-LTX")
-- .haskell		(to "haskell")
-- .ghcdoc		(to "ghcdoc")
-- .lilypond		(to "lilypond")
-- .find_xxx_intros	(to "find_xxx_intros")


--------[ Links to "find-*-intro"s ]--------
-- (find-blogme3 "options.lua" "basic-options" "eevintrosdir")
eevintro = function (stem)
    return eevintrosdir.."find-"..stem.."-intro.html"
  end
eevintr = function (sexp)
    return eevintrosdir..sexp:sub(2,-2)..".html"
  end
set_EHELP_intro = function (str)
    local symbol, sexp = str:match("(%S+)%s+(%S+)")
    set_EHELP(symbol, eevintr(sexp)) 
  end
-- Use like this:
-- set_EHELP      ("eepitch", eevintro "eepitch")
-- set_EHELP_intro "eepitch       (find-eepitch-intro)"


--------[ Elisp hyperlinks that are not angg-specific ]--------
-- (find-eev-quick-intro "8.1. Introduction: `to'")

-- _EHELP["to"] = eevarticle.."#anchors"
-- _EHELP["to"] = "http://anggtwu.net/eev-intros/find-eev-quick-intro.html#8"
_EHELP["to"] = "eev-intros/find-eev-quick-intro.html#8"
_E    ["to"] = function (all, funname, qtag)
    local tag = dequote(qtag)
    --return makesexphtml(all, funname, eevarticle.."#anchors", tag and "#"..tag)
    --return makesexphtml(all, funname, eevintro "anchors", tag and "#"..tag)
    return makesexphtml(all, funname, "eev-intros/find-eev-quick-intro.html#8",
                        tag and "#"..tag)
  end

-- 2015aug31, experimental, for dednat6
_EHELP["ex"] = eevintro "anchors"
_E    ["ex"] = function (all, funname, qtag)
    local tag = dequote(qtag)
    return makesexphtml(all, funname, eevintro "anchors", tag and "ex/"..tag..".html")
  end

--------[ Lots of hyperlinks (angg-specific) ]--------

-- Some tests (should work in the htmlized version):
--   first_anchor   (to "second_anchor")
--   second_anchor  (to "first_block")
--   (find-angg "TH/eev-article.blogme" "anchors")
--   (find-dednat4 "")
--   (find-dednat4file "dednat4-icon.png")

-- code_c_d_angg  (to ".code_c_d_angg")
-- (find-blogme3 "elisp.lua" "code_c_d_local")
-- (find-blogme3 "anggdefs.lua" "-anggat")
code_c_d_angg = function (c, d)
    if pathtoangg
    then code_c_d_remote(c, pathtoangg..d)
    else code_c_d_local (c, d)
    end
  end

code_c_d_angg("angg",       "")
code_c_d_angg("es",         "e/")
code_c_d_angg("dednat4",    "dednat4/")
code_c_d_angg("dn4",        "dednat4/")
code_c_d_angg("dn4ex",      "dednat4/examples/")
code_c_d_angg("dn5",        "dednat5/")
code_c_d_angg("dn6",        "LATEX/dednat6/")
code_c_d_angg("dednat6",    "dednat6/")
code_c_d_angg("dednat6lua", "dednat6/dednat6/")
code_c_d_angg("blogme",     "blogme/")
code_c_d_angg("blogme3",    "blogme3/")
code_c_d_angg("blogme4",    "blogme4/")
code_c_d_angg("eev",        "eev-current/")
code_c_d_angg("flua",       "flua/")
code_c_d_angg("rubyforth",  "rubyforth/")
code_c_d_angg("vtutil",     "vtutil/")
code_c_d_angg("vtutil4",    "vtutil4/")
code_c_d_angg("RETRO",      "RETRO/")
code_c_d_angg("gab",        "gab/")
code_c_d_angg("eevvideos",  "eev-videos/")
code_c_d_angg("quadr",      "quadradinho/")
code_c_d_angg("ydb",        "youtube-db/")
code_c_d_angg("fbcache",    "fbcache/")
code_c_d_angg("clg",        "2019-CLG/")
code_c_d_angg("books",      "books/")

code_c_d_angg("twus",    "")
code_c_d_angg("twup",    "")

-- code_c_d_remote("eevarticlesection", eevarticle)
set_E4("find-eevarticlesection", _E_remoteanchor,
       eevarticle.."#shorter-hyperlinks", eevarticle.."#", "")

-- (find-blogme3file "rumilisp.lua")

-- PP(_E)
-- PP(_EBASE)

-- Fix for a fossil "feature" of find-es.
_ESUFFIX["find-es"] = ".e.html"

-- http://www.gnu.org/software/bash/manual/bash.html
-- http://www.gnu.org/software/gdb/gdb.html
-- http://www.gnu.org/software/emacs/emacs-faq.html
-- http://lilypond.org/doc/v2.10/Documentation/
-- http://lilypond.org/doc/v2.10/Documentation/user/lilypond/

for _,xxx in ipairs(split [[ efaq exp gcc lily lua ]]) do
  set_EHELP("find-"..xxx.."node", "NOT_YET")
end
for _,funname in ipairs(split [[ find-angghtml find-shttpfile ]]) do
  set_EHELP(funname, "NOT_YET")
end

-- (find-eevarticlesection "delimited-regions")
-- (find-eev "eepitch.readme" "red-star-lines")

-- set_EHELP("find-fline",      eevarticle.."#hyperlinks")
-- set_EHELP("find-node",       eevarticle.."#hyperlinks")
-- set_EHELP("eev-bounded",     eevarticle.."#delimited-regions")
-- set_EHELP("eelatex-bounded", eevarticle.."#delimited-regions")
-- set_EHELP("find-sh",         eevarticle.."#dangerous-hyperlinks")
-- set_EHELP("find-sh0",        eevarticle.."#dangerous-hyperlinks")
-- set_EHELP("eeman",           eevarticle.."#splitting-eev.el")
-- set_EHELP("find-man",        eevarticle.."#splitting-eev.el")
-- set_EHELP("eevnow-at",       eevarticle.."#big-modular-e-scripts")
-- set_EHELP("eepitch",         eevarticle.."#eepitch")
-- set_EHELP("eepitch-shell",   eevarticle.."#eepitch")
-- set_EHELP("eepitch-lua51",   eevarticle.."#eepitch")

-- 2012feb11:
-- set_EHELP("eepitch",         eepitchreadme.."#red-star-lines")
-- set_EHELP("eepitch-kill",    eepitchreadme.."#eepitch-blocks")
-- set_EHELP("eepitch-shell",   eepitchreadme.."#red-star-lines")
-- set_EHELP("eepitch-lua51",   eepitch_el.."#eepitch-lua51")


-- (eepitch)
--  file:///home/edrx/TH/L/blogme3/angglisp.lua.html

-- set_EHELP_intro "eelatex-bounded (find-bounded-intro)"
-- set_EHELP_intro "eeman           (find-links-intro)"
-- set_EHELP_intro "eepitch         (find-eepitch-intro)"
-- set_EHELP_intro "eepitch-lua51   (find-eepitch-intro)"
-- set_EHELP_intro "eepitch-shell   (find-eepitch-intro)"
-- set_EHELP_intro "eev-bounded     (find-bounded-intro)"
-- set_EHELP_intro "find-fline      (find-eval-intro)"
-- set_EHELP_intro "find-man        (find-eval-intro)"
-- set_EHELP_intro "find-node       (find-eval-intro)"
-- set_EHELP_intro "find-sh         (find-links-intro)"
-- set_EHELP_intro "find-sh0        (find-links-intro)"
-- set_EHELP_intro "eepitch         (find-eepitch-intro)"
-- set_EHELP_intro "eepitch-kill    (find-eepitch-intro)"
-- set_EHELP_intro "eepitch-shell   (find-eepitch-intro)"
-- set_EHELP_intro "eepitch-lua51   (find-eepitch-intro)"
-- set_EHELP_intro "code-c-d        (find-code-c-d-intro)"
-- set_EHELP_intro "code-audio      (find-audiovideo-intro)"
-- set_EHELP_intro "code-video      (find-audiovideo-intro)"


-- cruft-jan2024  (to ".cruft-jan2024")
require "cruft-jan2024"    -- (find-blogme3 "cruft-jan2024.lua")

-- set_EHELP_intros (to ".set_EHELP_intros")
-- Experimental, 2019feb20

set_EHELP_intros = function (bigstr)
    for li in bigstr:gmatch "([^\n]+)" do
      local head, sexp = li:match"^%s*(%S+)%s*(.*)$"
      local url = EevIntro.fromsexp(sexp):url()
      -- print(head, url)
      set_EHELP(head, url)
    end
  end

set_EHELP_intros [[
  eelatex-bounded (find-bounded-intro)
  eev-bounded     (find-bounded-intro)
  eek             (find-eev-quick-intro "3. Elisp hyperlinks")
  find-efunction  (find-eev-quick-intro "3. Elisp hyperlinks")
  find-efunctiondescr  (find-eev-quick-intro "3. Elisp hyperlinks")
  find-elongkey-links  (find-eev-quick-intro "4.2. `find-ekey-links' and friends")
  find-fline      (find-eev-quick-intro "3. Elisp hyperlinks")
  find-man        (find-eev-quick-intro "3. Elisp hyperlinks")
  find-node       (find-eev-quick-intro "3. Elisp hyperlinks")
  find-sh         (find-eev-quick-intro "3. Elisp hyperlinks")
  find-sh0        (find-eev-quick-intro "3. Elisp hyperlinks")
  eepitch         (find-eev-quick-intro "6. Controlling shell-like programs")
  eepitch-kill    (find-eev-quick-intro "6. Controlling shell-like programs")
  eepitch-shell   (find-eev-quick-intro "6. Controlling shell-like programs")
  eepitch-lua51   (find-eev-quick-intro "6. Controlling shell-like programs")
  eepitch         (find-eepitch-intro "2.3. `eepitch'")
  eepitch-kill    (find-eepitch-intro "2.2. `(eepitch-kill)'")
  code-c-d        (find-eev-quick-intro "9. Shorter hyperlinks")
  find-xpdfpage   (find-eev-quick-intro "9.3. Hyperlinks to PDF files")
  find-pdf-page   (find-pdf-like-intro "4. Hyperlinks to pages of PDF files")
  find-pdf-text   (find-pdf-like-intro "4. Hyperlinks to pages of PDF files")
  code-pdf-page   (find-pdf-like-intro "7. Shorter hyperlinks to PDF files")
  code-pdf-text   (find-pdf-like-intro "7. Shorter hyperlinks to PDF files")
  code-audio      (find-audiovideo-intro "4. Short hyperlinks to audio and video files")
  code-video      (find-audiovideo-intro "4. Short hyperlinks to audio and video files")
]]



--------[ Experimental, 2007apr17 ]--------
-- code_c_d_remotes  (to ".code_c_d_remotes")

code_c_d_remote("wdgref", "http://www.htmlhelp.com/reference/")
code_c_d_remote("wdg40",  "http://www.htmlhelp.com/reference/html40/")
code_c_d_remote("wdgcss", "http://www.htmlhelp.com/reference/css/")
code_c_d_remote("luamanual",   "http://www.lua.org/manual/5.1/manual.html")
code_c_d_remote("lua51manual", "http://www.lua.org/manual/5.1/manual.html")
code_c_d_remote("lua50manual", "http://www.lua.org/manual/5.0/manual.html")
code_c_d_remote("lua40manual", "http://www.lua.org/manual/4.0/manual.html")
code_c_d_remote("lua52manual", "http://www.lua.org/manual/5.2/manual.html")
code_c_d_remote("pil",       "http://www.lua.org/pil/")
code_c_d_remote("lpeg",      "http://www.inf.puc-rio.br/~roberto/lpeg/")
code_c_d_remote("apachedoc", "http://httpd.apache.org/docs/2.2/")
code_c_d_remote("learningJ", "http://www.jsoftware.com/help/primer/")

code_c_d_remote("phpdoc", "http://www.php.net/manual/en/")

-- (find-zsh "touch ~/e/html.e; makeL")
-- (find-es "html")
-- file:///root/edrx/TH/L/e/html.e.html
-- (find-luamanualw3m "#6")
-- (find-lua50manualw3m "#6")
-- (find-pilw3m "7.1.html")

--------[ Experimental, 2007jun07 ]--------
-- find_node  (to ".find_node")
-- (find-es "blogme" "find_node")
-- (find-angg "LUA/lua50init.lua" "translatechars")

infonodehtmlname_re    = "([-'/ &])"
infonodehtmlname_table = {[" "] = "-",     ["&"] = "-",
                          ["'"] = "_0027", ["-"] = "_002d", ["/"] = "_002f"}
infonodehtmlname       = function (str)
    return translatechars(str, infonodehtmlname_re, infonodehtmlname_table)
  end

find_elnode = function (nodename)
    return "http://www.gnu.org/software/emacs/elisp-manual/html_node/" ..
           infonodehtmlname(nodename) .. ".html"
  end
find_enode = function (nodename)
    return "http://www.gnu.org/software/emacs/manual/html_node/" ..
           infonodehtmlname(nodename) .. ".html"
  end

infomanual_basedir = {}
-- infomanual_basedir["emacs"] = "http://www.gnu.org/software/emacs/manual/html_node/"
-- infomanual_basedir["elisp"] = "http://www.gnu.org/software/emacs/elisp-manual/html_node/"

find_node2 = function (manual, section)
    if not manual or not section then return end
    -- print(manual, section)
    basedir = infomanual_basedir[manual]
    -- print(basedir)
    if not basedir then return end
    return basedir ..
           infonodehtmlname(string.gsub(section, "%s+", " ")) ..
           ".html"
  end
find_node = function (nodename)
    if not nodename then return end
    local manual, section = string.match(nodename, "^%(([^()]+)%)(.*)$")
    -- print(nodename, manual, section)
    return find_node2(manual, section)
  end

-- file:///home/edrx/TH/L/blogme3/angglisp.lua.html
-- (find-node "(elisp)Symbols")
-- (find-node "(elisp)Symbols")
-- (find-elnode "Symbols")
-- (find-elnode "Backups and Auto-Saving" "auto-")
-- (find-elinode "More Complex")
-- (find-node "(libc)Sockets")
-- (find-node "(libc)I/O Overview")
-- (find-node "(make)")
-- (find-node "(grub)Naming convention")
-- (find-node "(gawk)")

set_E4("find-node",
       function (all, funname, qnode)
           return makesexphtml(all, funname, _EHELP[funname],
                               find_node(dequote(qnode)))
         end,
       "eev-intros/find-eev-quick-intro.html#3",
       -- was: eevintro "eval",   -- eevarticle.."#hyperlinks",
       "")

_E_remotenode = function (all, funname, qnode)
    local node = dequote(qnode)
    return makesexphtml(all, funname, _EHELP[funname],
        find_node2(_EBASE[funname], node))
  end

code_c_m_b = function (c, manual, basedir)
    infomanual_basedir[manual] = basedir
    set_E4("find-"..c.."node", _E_remotenode,
	   "eev-intros/find-eev-quick-intro.html#9.2",
           -- was: eevintro "code-c-d", -- eevarticle.."#shorter-hyperlinks",
           manual, "")
  end

-- code_c_m_b_s (to ".code_c_m_b_s")
code_c_m_b("e",   "emacs", "http://www.gnu.org/software/emacs/manual/html_node/emacs/")
code_c_m_b("el",  "elisp", "http://www.gnu.org/software/emacs/manual/html_node/elisp/")
code_c_m_b("eli", "eintr", "http://www.gnu.org/software/emacs/emacs-lisp-intro/html_node/")
code_c_m_b("efaq", "efaq", "https://www.gnu.org/software/emacs/manual/html_node/efaq/")
code_c_m_b("cl",   "cl",   "http://www.gnu.org/software/emacs/manual/html_node/cl/")
code_c_m_b("gnus", "gnus", "http://www.gnu.org/software/emacs/manual/html_node/gnus/")
code_c_m_b("message",  "message",  "http://www.gnu.org/software/emacs/manual/html_node/message/")
code_c_m_b("woman",    "woman",    "http://www.gnu.org/software/emacs/manual/html_node/woman/")
code_c_m_b("rcirc",    "rcirc",    "http://www.gnu.org/software/emacs/manual/html_node/rcirc/")
code_c_m_b("org",      "org",      "http://www.gnu.org/software/emacs/manual/html_node/org/")

code_c_m_b("gst",      "gst",      "http://www.gnu.org/software/smalltalk/manual/html_node/")
code_c_m_b("gstbase",  "gst-base", "http://www.gnu.org/software/smalltalk/manual-base/html_node/")
code_c_m_b("gstlibs",  "gst-libs", "http://www.gnu.org/software/smalltalk/manual-libs/html_node/")

code_c_m_b("pclcvs",   "pcl-cvs",  "http://www.gnu.org/software/emacs/manual/html_node/pcl-cvs/")
code_c_m_b("autotype", "autotype", "http://www.gnu.org/software/emacs/manual/html_node/autotype/")
code_c_m_b("libc", "libc", "http://www.gnu.org/software/libc/manual/html_node/")
code_c_m_b("make", "make", "http://www.gnu.org/software/make/manual/html_node/")
code_c_m_b("grub", "grub", "http://www.gnu.org/software/grub/manual/html_node/")
code_c_m_b("gawk", "gawk", "http://www.gnu.org/software/gawk/manual/html_node/")
code_c_m_b("texi", "texinfo", "http://www.gnu.org/software/texinfo/manual/texinfo/html_node/")
code_c_m_b("gcc",  "gcc-4.1", "http://gcc.gnu.org/onlinedocs/gcc-4.2.2/gcc/")
code_c_m_b("coreutils", "coreutils", "http://www.gnu.org/software/coreutils/manual/html_node/")
code_c_m_b("bash", "bash",    "http://www.gnu.org/software/bash/manual/html_node/")
code_c_m_b("bash", "bashref", "http://www.gnu.org/software/bash/manual/html_node/")
code_c_m_b("wget", "wget",    "http://www.gnu.org/software/wget/manual/html_node/")
code_c_m_b("slime", "slime",  "http://common-lisp.net/project/slime/doc/html/")
code_c_m_b("slime", "slime",  "https://slime.common-lisp.dev/doc/html/")
code_c_m_b("bison", "bison",  "http://www.gnu.org/software/bison/manual/html_node/")
code_c_m_b("octave", "octave",  "http://www.gnu.org/software/octave/doc/interpreter/")
code_c_m_b("rcirc",  "rcirc",   "http://www.gnu.org/software/emacs/manual/html_node/rcirc/")
code_c_m_b("binutils", "binutils", "http://sourceware.org/binutils/docs/binutils/")
code_c_m_b("gdb", "gdb", "http://sourceware.org/gdb/download/onlinedocs/gdb/")
code_c_m_b("parted", "parted",  "https://www.gnu.org/software/parted/manual/html_node/")





-- http://common-lisp.net/project/slime/doc/html/
-- http://common-lisp.net/project/slime/doc/html/Installation.html


-- (find-womannode "Introduction")
-- (find-pclcvsnode "")

-- http://directory.fsf.org/
--
-- http://www.gnu.org/software/emacs/manual/index.html
-- http://sourceware.org/gdb/current/onlinedocs/gdb.html
-- http://www.gnu.org/software/gdb/documentation/
-- http://www.gnu.org/software/gdb/gdb.html
-- http://www.gnu.org/software/hurd/doc/hurd_toc.html
-- http://www.gnu.org/software/hurd/gnumach-doc/index.html

--------[ Experimental, 2007jun10 ]--------
-- code_ps  (to ".code_ps")

eevcurrent = "http://anggtwu.net/eev-current/"

_E_remoteps = function (all, funname)
    return makesexphtml(all, funname, _EHELP[funname], _EBASE[funname])
  end

code_ps = function (c, psurl)
    set_E4("find-"..c.."page", _E_remoteps,
           eevcurrent.."eev.el.html#code-ps", psurl)
    set_E4("find-"..c.."text", _E_remoteps,
           eevcurrent.."eev.el.html#code-ps", psurl)
  end

code_ps("luaimp",      "http://www.tecgraf.puc-rio.br/~lhf/ftp/doc/jucs05.pdf")
code_ps("luanofrills", "http://luaforge.net/docman/view.php/83/98/ANoFrillsIntroToLua51VMInstructions.pdf")

-- This needs an explanation...
-- In emacs, (find-TH "index" "math")
--  becomes: (find-angg "TH/index.blogme" "math")
-- but in the htmlization, (find-TH "index" "math")
--      becomes: http://anggtwu.net/index.html#math
--
-- See: (find-angg ".emacs" "find-TH")
--
code_c_d_angg("TH",    "")

-- find-LATEX  (to ".find-LATEX")
-- set_E4("find-LATEX", _E_localanchor, eevarticle.."#shorter-hyperlinks", "LATEX/", ".pdf")
set_E4("find-LATEX", _E_localanchor, eevarticle.."#shorter-hyperlinks", "LATEX/", ".html")

-- find-LTX  (to ".find-LTX")
-- (find-angg ".emacs" "find-LTX")
set_E4("find-LTX",   _E_localanchor, eevarticle.."#shorter-hyperlinks", "LATEX/", ".html")

-- (find-luaimppage 1)
-- (find-luanofrillstext)

-- haskell  (to ".haskell")
-- ghcdoc  (to ".ghcdoc")
-- (find-angg ".emacs" "haskell")
-- (find-es "haskell" "ghc6")
code_c_d_remote("ghcdoc",  "http://www.haskell.org/ghc/docs/latest/html/")
code_c_d_remote("ghcusrh", "http://www.haskell.org/ghc/docs/latest/html/users_guide/")
code_c_d_remote("hask98report",  "http://www.haskell.org/onlinereport/")
code_c_d_remote("hask98tut",     "http://www.haskell.org/tutorial/")
code_c_d_remote("hugsuserguide", "http://cvs.haskell.org/Hugs/pages/users_guide/")


code_c_d_remote("doxygendoc", "http://www.stack.nl/~dimitri/doxygen/")
code_c_d_remote("qt3doc",     "http://doc.trolltech.com/3.3/")
code_c_d_remote("qt4doc",     "http://doc.trolltech.com/4.3/")
code_c_d_remote("sqlitedoc",  "http://www.sqlite.org/")
code_c_d_remote("apthowto",   "http://www.debian.org/doc/manuals/apt-howto/")

code_c_d_remote("zumbipage", "http://zumbi/~edrx/")
code_c_d_remote("zumbiwiki", "http://zumbi/wiki/")
code_c_d_remote("profsoftdevel", "http://zumbi/~edrx/professional_software_engineering/")

code_c_d_remote("ramroot", "http://iki.fi/lindi/darcs/ramroot/")
code_c_d_remote("hugsuserguide", "http://cvs.haskell.org/Hugs/pages/users_guide/")
code_c_d_remote("xfigdoc", "http://xfig.org/userman/")
code_c_d_remote("xfigref", "http://xfig.org/userman/")
code_c_d_remote("coqv81",  "http://coq.inria.fr/V8.1/")
code_c_d_remote("webercap", "http://www.ne.jp/asahi/moriyuki/abukuma/weber/world/ethic/")

code_c_d_remote("coqlibdoc",  "http://coq.inria.fr/coq/distrib/current/stdlib/")
code_c_d_remote("coqtut1",    "http://coq.inria.fr/node/9")
code_c_d_remote("coqtut2",    "http://coq.inria.fr/node/10")
code_c_d_remote("coqtut3",    "http://coq.inria.fr/node/11")
code_c_d_remote("coqref",     "http://coq.inria.fr/coq/distrib/current/refman/")

code_c_d_remote("lua51src",   "http://www.lua.org/source/5.1/")

code_c_d_remote("learningJ",   "http://www.jsoftware.com/help/learning/")
code_c_d_remote("Jprimer",     "http://www.jsoftware.com/help/primer/")
code_c_d_remote("Jhelp",       "http://www.jsoftware.com/help/")


-- lilypond  (to ".lilypond")
-- http://lilypond.org/doc/v2.14/Documentation/learning/index
-- http://lilypond.org/doc/v2.14/Documentation/learning/i_0027m-hearing-voices
-- (find-lilylearnnode "I'm hearing Voices" "\\\\")
-- code_c_m_b("lilylearn", "lilylearn",  "http://lilypond.org/doc/v2.14/Documentation/learning/")



-- find_xxx_intros (to ".find_xxx_intros")
-- See: (find-blogme3 "eevintros.lua" "listofintros")
find_xxx_intros = [[
  find-anchors-intro
  find-audiovideo-intro
  find-bounded-intro
  find-brxxx-intro
  find-channels-intro
  find-code-c-d-intro
  find-debootstrap-intro
  find-defun-intro
  find-dot-emacs-intro
  find-edit-index-intro
  find-eejump-intro
  find-eepitch-intro
  find-eev-exercises-intro
  find-eev-install-intro
  find-eev-intro
  find-eev-levels-intro
  find-eev-quick-intro
  find-elisp-intro
  find-emacs-intro
  find-emacs-keys-intro
  find-escripts-intro
  find-eval-intro
  find-git-intro
  find-here-links-intro
  find-kl-here-intro
  find-kla-intro
  find-lean4-intro
  find-lexical-intro
  find-links-intro
  find-links-conv-intro
  find-lua-tutorial-intro
  find-multiwindow-intro
  find-org-intro
  find-pdf-like-intro
  find-prepared-intro
  find-psne-intro
  find-rcirc-intro
  find-rstdoc-intro
  find-saving-links-intro
  find-show2-intro
  find-strange-functions-intro
  find-templates-intro
  find-three-main-keys-intro
  find-videos-intro
  find-video-links-intro
  find-refining-intro
  find-windows-beginner-intro
  find-wrap-intro
]]
for i,funname in ipairs(split(find_xxx_intros)) do
  -- set_EHELP(funname, "eev-intros/"..funname..".html")
  -- 2019feb28:
  _E[funname] = _E_intro
end




-- file:///home/edrx/TH/L/blogme3/angglisp.lua.html
