-- -*- coding: raw-text -*-
-- anggmake.lua - generate the makefiles for the pages at anggtwu.net.
-- This is part of blogme3.
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
-- Version: 2018mar21
-- <http://anggtwu.net/blogme3/makefile.lua>
-- <http://anggtwu.net/blogme3/makefile.lua.html>
-- License: GPL.

-- Note: this is a replacement for my old way of generating makefiles
-- for angg, that was based on TH:
-- (find-angg "TH/Files.tcl")



-- .eev_intros	(to "eev_intros")
-- .anggtranslate	(to "anggtranslate")
-- .anggdonttranslate	(to "anggdonttranslate")
-- .escriptstems	(to "escriptstems")
-- .thstems		(to "thstems")
-- .blogmestems	(to "blogmestems")
-- .find_xxx_intros	(to "find_xxx_intros")
-- .almanaq		(to "almanaq")
-- .otherblogmestems  (to "otherblogmestems")
-- .makefileauto_template	(to "makefileauto_template")

require "makefile"      -- (find-blogme3 "makefile.lua")

-- eev_intros  (to ".eev_intros")
-- See: (find-blogme3 "eevintros.lua" "listofintros")
eev_intros = splitandsort [[
  eev-intros/find-anchors-intro
  eev-intros/find-audiovideo-intro
  eev-intros/find-bounded-intro
  eev-intros/find-brxxx-intro
  eev-intros/find-channels-intro
  eev-intros/find-code-c-d-intro
  eev-intros/find-debootstrap-intro
  eev-intros/find-defun-intro
  eev-intros/find-dot-emacs-intro
  eev-intros/find-edit-index-intro
  eev-intros/find-eejump-intro
  eev-intros/find-eepitch-intro
  eev-intros/find-eev-exercises-intro
  eev-intros/find-eev-install-intro
  eev-intros/find-eev-intro
  eev-intros/find-eev-levels-intro
  eev-intros/find-eev-quick-intro
  eev-intros/find-elisp-intro
  eev-intros/find-emacs-intro
  eev-intros/find-emacs-keys-intro
  eev-intros/find-escripts-intro
  eev-intros/find-eval-intro
  eev-intros/find-git-intro
  eev-intros/find-here-links-intro
  eev-intros/find-kl-here-intro
  eev-intros/find-kla-intro
  eev-intros/find-lean4-intro
  eev-intros/find-lexical-intro
  eev-intros/find-links-conv-intro
  eev-intros/find-links-intro
  eev-intros/find-lua-tutorial-intro
  eev-intros/find-multiwindow-intro
  eev-intros/find-org-intro
  eev-intros/find-pdf-like-intro
  eev-intros/find-prepared-intro
  eev-intros/find-psne-intro
  eev-intros/find-rcirc-intro
  eev-intros/find-refining-intro
  eev-intros/find-rstdoc-intro
  eev-intros/find-saving-links-intro
  eev-intros/find-show2-intro
  eev-intros/find-strange-functions-intro
  eev-intros/find-templates-intro
  eev-intros/find-three-main-keys-intro
  eev-intros/find-videos-intro
  eev-intros/find-video-links-intro
  eev-intros/find-windows-beginner-intro
  eev-intros/find-wrap-intro
]]

eev_with_htmls = [[
  eev-current/ChangeLog           eev-current/ChangeLog.html
  eev-current/EMACS               eev-current/EMACS.html
  eev-current/NEWS                eev-current/NEWS.html
  eev-current/README-20070720     eev-current/README-20070720.html
  eev-current/eev-2012.el         eev-current/eev-2012.el.html
  eev-current/eev-all.el          eev-current/eev-all.el.html
  eev-current/eev-bounded.el      eev-current/eev-bounded.el.html
  eev-current/eev-compose.el      eev-current/eev-compose.el.html
  eev-current/eev-glyphs.el       eev-current/eev-glyphs.el.html
  eev-current/eev-math-glyphs.el  eev-current/eev-math-glyphs.el.html
  eev-current/eev-steps.el        eev-current/eev-steps.el.html
  eev-current/eev-browse-url.el   eev-current/eev-browse-url.el.html
  eev-current/eev-insert.el       eev-current/eev-insert.el.html
  eev-current/eev-langs.el        eev-current/eev-langs.el.html
  eev-current/eev-mini.el         eev-current/eev-mini.el.html
  eev-current/eev-mini-steps.el   eev-current/eev-mini-steps.el.html
  eev-current/eev-sshot.el        eev-current/eev-sshot.el.html
  eev-current/htmlize-eev.el      eev-current/htmlize-eev.el.html
  eev-current/htmlize-all.el      eev-current/htmlize-all.el.html
  eev-current/eeg                 eev-current/eeg.html
  eev-current/eeg4                eev-current/eeg4.html
  eev-current/eegchannel          eev-current/eegchannel.html
  eev-current/eev-rctool          eev-current/eev-rctool.html
  eev-current/eepitch.el          eev-current/eepitch.el.html
  eev-current/eev-template-old.el eev-current/eev-template.el-old.html
  eev-current/eev-intro.el        eev-current/eev-intro.el.html
  eev-current/eev-pdfpages.el     eev-current/eev-pdfpages.el.html
  eev-current/eechannel.el        eev-current/eechannel.el.html
  eev-current/eev-multiwindow.el  eev-current/eev-multiwindow.el.html
  eev-current/eev-readme.el       eev-current/eev-readme.el.html

  eev-current/eev-code.el         eev-current/eev-code.el.html
  eev-current/eev-brurl.el        eev-current/eev-brurl.el.html

  eev-current/anim/channels.anim  eev-current/anim/channels.anim.html
  eev-current/anim/gdb.anim       eev-current/anim/gdb.anim.html
]]

eev_without_htmls = [[
  eev-current/ChangeLog
  eev-current/EMACS
  eev-current/NEWS
  eev-current/README-20070720
  eev-current/eev-2012.el
  eev-current/eev-all.el
  eev-current/eev-bounded.el
  eev-current/eev-compose.el
  eev-current/eev-compose-hash.el
  eev-current/eev-glyphs.el
  eev-current/eev-math-glyphs.el
  eev-current/eev-steps.el
  eev-current/eev-browse-url.el
  eev-current/eev-insert.el
  eev-current/eev-langs.el
  eev-current/eev-mini.el
  eev-current/eev-mini-steps.el
  eev-current/eev-sshot.el
  eev-current/htmlize-eev.el
  eev-current/htmlize-all.el
  eev-current/eeg
  eev-current/eeg4
  eev-current/eegchannel
  eev-current/eev-rctool
  eev-current/eepitch.el
  eev-current/eev-template-old.el
  eev-current/eev-intro.el
  eev-current/eev-pdfpages.el
  eev-current/eechannel.el
  eev-current/eev-multiwindow.el
  eev-current/eev-readme.el

  eev-current/eev-code.el
  eev-current/eev-brurl.el

  eev-current/anim/channels.anim
  eev-current/anim/gdb.anim
]]

-- anggtranslate  (to ".anggtranslate")
anggtranslate = splitandsort (eev_without_htmls .. [[

  .Xdefaults
  .emacs
  .emacs.agda
  .emacs.audios
  .emacs.custom
  .emacs.erc
  .emacs.fvwm
  .emacs.hydras
  .emacs.lean.el
  .emacs.mini
  .emacs.papers
  .emacs.templates
  .emacs.u8
  .emacs.unibyte
  .emacs.videos
  .emacs-tex.el
  .zshrc
  .zshenv
  .bashrc
  .bashrc.local.aspi
  .cshrc
  .dir-locals.el
  .gdbinit
  .ghci
  .irbrc
  .sbclrc
  .tclshrc
  .tclshrc-old
  .xinitrc.debian
  .xinitrc.redhat
  .xinitrc.cdd
  .xzgvrc
  .wgetrc
  .emacs.local.aspi
  .emacs.local.bsd
  .emacs.local.debian
  .emacs.local.labinfo
  .emacs.local.mac
  .emacs.local.w32
  .fvwm/.fvwm2rc
  .fvwm/.fvwm2rc0
  .fvwm/.fvwm2rc1
  .fvwm/keys.fvwm
  .fvwm/nokeys.fvwm
  .fvwm/withkeys.fvwm

  .fvwm/all.fvwm
  .fvwm/edrx-menus.fvwm
  .fvwm/edrx-system.fvwm
  .fvwm/edrx.fvwm
  .fvwm/main-menu.hook
  .fvwm/post.hook.old
  .fvwm/doc_Makefile

  .files
  .timestamps

  .SciTEUser.properties
  .lua50/PP.c
  .lua50/PP.gdb
  .lua51/PP.c
  .lua51/PP.gdb
  .lua51/README

  .a2ps/a2psrc
  .asoundrc
  .doom.d/packages.el
  .maxima/maxima-init.lisp
  .maxima/maxima-init.mac
  .maxima/startsly.lisp
  .passwds.tcl-
  .pythonrc.py
  .ruby/edrxinit.rb
  .screenrc.hurd
  .stalonetrayrc
  .sympyrc.py
  .xmonad/xmonad.hs
  .xpdfrc

  .zshrc.local.bsd
  .zshrc.local.cdd
  .zshrc.local.puc
  .zshrc.local.debian
  .zshrc.local.hurd
  .zshrc.local.mcgill
  .zshrc.local.sweetjane
  .zshrc.root

  2012-greve/README
  2011-dec-13/README

  2012.1-GA/Makefile
  2012.2-GA/Makefile
  2013.1-GA/Makefile
  2013.2-GA/Makefile
  2014.1-GA/Makefile
  2014.1-GA/20140409-atividade.txt
  2014.2-GA/Makefile
  2014.2-FM/Makefile
  2015.1-GA/Makefile
  2015.1-C2/Makefile
  2015.2-GA/Makefile
  2015.2-C2/Makefile
  2016.1-C2/Makefile
  2016.1-GA/Makefile
  2016.1-LA/Makefile
  2016.2-C2/Makefile
  2016.2-GA/Makefile
  2016.2-LA/Makefile
  2017.2-C2/Makefile
  2017.2-GA/Makefile
  2017.2-LA/Makefile
  2018.1-C2/Makefile
  2018.1-GA/Makefile
  2018.1-LA/Makefile
  2018.2-C2/Makefile
  2018.2-MD/Makefile
  2019-CLG/README
  2019-CLG/NOTES
  2019-CLG/.emacs.clg
  2019.1-C2/Makefile
  2019.1-C3/Makefile
  2019.1-TD/Makefile
  2019.1-TD/NOTES
  2019.2-C2/Makefile
  2019.2-C3/Makefile
  2020.1-C2/Makefile
  2020.1-C3/Makefile
  2020.2-C3/Makefile
  2020-2-C2-C3/README.org
  2021-1-C2-C3/README.org
  2021.2-C2/README
  2022.1-C3/Makefile
  2022.1-C2/Makefile
  2022-1-C2-C3/README.org
  2022-1-C2-C3/Makefile
  2022-1-C2-C3/Apresentacao_julho.e
  2022.2-C2/Makefile
  2022.2-C3/Makefile
  2022-2-C2-C3/README.org
  2022-2-C2-C3/Makefile

  2023.1-C2/Makefile
  2023.1-C4/Makefile
  2023.1-LA/Makefile
  2023.1-ES/Makefile
  2023.1-GA/Makefile
  2023-1-C2-C4-ES/README.org
  2023-1-C2-C4-ES/Makefile

  2023-caepro/README

  2023.2-C2/Makefile
  2023.2-C3/Makefile

  2020-1-C2-C3/Makefile
  2020-2-C2-C3/Makefile
  2021-1-C2-C3/Makefile
  2021-2-C2-C3/Makefile

  2021-oficina/README
  2021-org-for-non-users/2021-org-for-non-users.org
  2021-ffll/foo.el
  2021-ffll/title

  acker/README

  fsoliveira/README

  bin/Xscreenshot
  bin/Xscreenshot-rect
  bin/Xscreenshot-window
  bin/_psne
  bin/dednat5
  bin/djvuize
  bin/edit-pr.sh
  bin/edit.sh
  bin/eechannel
  bin/eeg
  bin/eeg4
  bin/eev-cabal
  bin/eev-quicklisp
  bin/eev-wconfig
  bin/eevgitlib1.sh
  bin/emacs-default
  bin/emacs-default-x
  bin/etc.lua
  bin/fastcmp.lua
  bin/favstella
  bin/git-defs
  bin/git-set-head
  bin/gs-640c-bw
  bin/gsub.lua
  bin/gvpage.sh
  bin/hpprint
  bin/intermail
  bin/lpdj-tmp
  bin/lua51-e
  bin/mypygments.sh
  bin/mysetxkb
  bin/mytcl
  bin/mywish
  bin/myxsettings
  bin/netbsdman
  bin/patch-lua-5.1.3
  bin/patch-lua-5.2
  bin/pump.lua
  bin/run-latex
  bin/scast
  bin/scrxpp
  bin/setenved-metalua
  bin/ssh-xterm
  bin/sshot-uniq.lua
  bin/startstuff
  bin/whiteboard
  bin/textcleaner
  bin/withgodi
  bin/ydb
  bin/yelp4kde
  bin/youtube-dl

  contact.txt
  compose-old.el
  eev-extras.el
  eev.el
  lynx.cfg
  run-zsh
  run-bash
  4NT/4start.btm
  4NT/hh.btm
  AGDA/Cats1.agda
  AGDA/Cats2.agda
  AGDA/Cats3.agda
  AGDA/2022Cats3.agda
  AGDA/2022Cats4.agda
  AGDA/2022Cats5.agda
  AGDA/2022Cats6.agda
  AGDA/2022HuC2.agda
  AGDA/2022HuC3.agda
  AGDA/2022HuC4.agda
  AGDA/2022HuC5.agda
  AGDA/Equality1.agda
  AGDA/GLT.agda
  AGDA/Hu1.agda
  AGDA/Logic1.agda
  AGDA/Logic2.lagda.tex
  AGDA/MyLevels.agda
  AGDA/Postulate1.agda
  AGDA/Postulate2.agda
  AGDA/RecordOpen1.agda
  AGDA/RecordsTut1.agda
  AGDA/Sieve1.agda
  AGDA/Split1.agda
  AGDA/TestMods.agda
  AGDA/TestStrings.agda
  AGDA/TestModInfix.agda
  AGDA/TestPreviousGoal.agda
  AGDA/TestPublic.agda
  AGDA/Types1.agda
  AGDA/Variable1.agda
  AGDA/find-agdatype-2021.el
  AGDA/find-agdatype.el
  AGDA/ha.agda
  BISON/calc.h
  BISON/mfcalc.y
  BISON/foo1.y
  BISON/foo2.y
  BISON/foo3.y
  BIBER/minimal.tex
  C/pointer-to-function.c
  C/tipos.c
  CLUA/dummy2.c
  CLUA/foo.c
  COQ/dnc-0.el
  CRIM1/crim1a-lib.tcl
  CRIM1/crim1a-prims.tcl
  CRIM1/crim1a-demo0.tcl
  CRIM1/crim1a.tcl
  CRIM1/tclstuff2
  CV/cv-edrx-2006-pt-.tex
  CV/cv-edrx-2008-pt.tex
  CV/cv-edrx-2008-pt-short.tex
  CV/cv-edrx-2010-pt.tex
  CV/cv-edrx-2012-pt.tex
  EEG/gdbk.eeg
  EEG/gdbk.eeg3
  EEG/emacs1.eeg3
  DAVINCI/tcmd.tcl
  DAVINCI/intro.lua
  DAVINCI/peek.c
  DAVINCI/peek.lua
  DAVINCI/peek-luadecls-1.txt
  DAVINCI/peek-luadecls-2.txt
  DAVINCI/ldb-edrx.lua
  DAVINCI/iup3_iupgtk_drv_patch1.h
  DAVINCI/iup3_iupgtk_status_icon_hack1.c
  DAVINCI/tec_uname.outvars
  DAVINCI/tec_uname.outvars.iupluas
  ETC/README
  ETC/fstab.persephone
  ETC/fstab.persephone.guest
  ETC/gpm.conf.persephone-26
  ETC/inittab.persephone
  ETC/menu.lst.persephone
  ETC/sudoers.persephone
  ETC/wvdial.conf.persephone
  ETC/sources.list
  EXPECT/autopasswd
  EXPECT/Scp
  EXPECT/Sucuri
  EXPECT/Twu
  EXPECT/readfifo
  EXPECT/player
  FENNEL/test0.fnl
  FENNEL/test1.fnl
  GDB/test.c
  GELADEIRA/geladeira.txt
  GIT/eevgitlib1.sh
  GNUPLOT/a.dem
  GNUPLOT/b.dem
  GNUPLOT/barranco.dem
  GNUPLOT/2022-1-C3-VS.dem
  GNUPLOT/2022-1-C3-VSB.dem
  GNUPLOT/2022-2-C3-P1.dem
  GNUPLOT/2023-2-C3-P1.dem
  GNUPLOT/barranco-1.dem
  GNUPLOT/barranco-2.dem
  GNUPLOT/piramide-1.dem
  GNUPLOT/piramide-2.dem
  GNUPLOT/surface1.8.gnuplot
  GNUPLOT/surface1.9.gnuplot
  HASKELL/2021excuse.hs
  HASKELL/Applicative1.hs
  HASKELL/Classes1.hs
  HASKELL/Comprehensions1.hs
  HASKELL/DoNotation1.hs
  HASKELL/LuaTree1.hs
  HASKELL/MonadDiagrams1.hs
  HASKELL/MyMonad1.hs
  HASKELL/Process1.hs
  HASKELL/State1.hs
  HASKELL/Tac1.hs
  HASKELL/mergesort.hs
  HASKELL/readwritefile.hs
  HASKELL/testpipes.hs
  HASKELL/twod-1.hs
  HASKELL/RW/README
  HELP/sb-reminders
  ICON/debrepository.icn
  ICON/debreputil.icn
  ICON/vcsa2pnm.icn
  ICON/header.icn
  ICON/zinc.icn
  ICON/zlib.icn
  ICON/lslR2find2.icn
  ICON/tmp.icn
  IDRIS/HAJ.idr
  IDRIS/Tut.idr
  IDRIS/Logic.idr
  IDRIS/Protocats.idr
  IDRIS/brady/02/Average.idr
  IDRIS/brady/02/AveMain.idr
  INKSCAPE/README
  FISL/README
  FISL/eev.tex
  HTML/local-videos.js
  LATEX/README
  LATEX/Makefile
  LATEX/2002fmcs.tex
  LATEX/2007dnc-sets.tex
  LATEX/2008bcc.tex
  LATEX/2008comprcat.tex
  LATEX/2008comprcat-utf8.tex
  LATEX/2008dclosed.tex
  LATEX/2008dnc-sets.tex
  LATEX/2008filterp-abs.tex
  LATEX/2008filterp-slides.tex
  LATEX/2008filterp.tex
  LATEX/2008gf.tex
  LATEX/2008graphs.tex
  LATEX/2008hyp.tex
  LATEX/2008hyp-utf8.tex
  LATEX/2008induction.tex
  LATEX/2008kocknsext.tex
  LATEX/2008lcccs.tex
  LATEX/2008modallogic.tex
  LATEX/2008monads.tex
  LATEX/2008natded.tex
  LATEX/2008natded-utf8.tex
  LATEX/2008notations.tex
  LATEX/2008notations-utf8.tex
  LATEX/2008projeto.tex
  LATEX/2008quotypes.tex
  LATEX/2008sdg.tex
  LATEX/2008sdg-utf8.tex
  LATEX/2008sheaves.tex
  LATEX/2008sheaves-abs1.tex
  LATEX/2008topos-str.tex
  LATEX/2008typesystems.tex
  LATEX/2009-1-C1-prova-1.tex
  LATEX/2009-1-C1-prova-2.tex
  LATEX/2009-1-C1-prova-VR1.tex
  LATEX/2009-1-C1-prova-VR2.tex
  LATEX/2009-1-C1-prova-VS.tex
  LATEX/2009-1-C2-plano.tex
  LATEX/2009-1-C2-prova-1.tex
  LATEX/2009-1-C2-prova-1-gab.tex
  LATEX/2009-1-C2-prova-2.tex
  LATEX/2009-1-C2-prova-VR.tex
  LATEX/2009-1-C2-prova-VS.tex
  LATEX/2009-1-MD-prova-2.tex
  LATEX/2009-1-MD-prova-VR.tex
  LATEX/2009-1-MD-prova-VS.tex
  LATEX/2009-2-C2-lista-1.tex
  LATEX/2009-2-C2-prova-1.tex
  LATEX/2009-2-C2-prova-1-notas.tex
  LATEX/2009-2-C2-prova-2.tex
  LATEX/2009-2-C4-prova-1.tex
  LATEX/2009-2-C4-prova-1-notas.tex
  LATEX/2009-2-C4-prova-2.tex
  LATEX/2009-2-C4-theorems.tex
  LATEX/2009-2-C4-lista-P2.tex
  LATEX/2009-2-MD-prova-1.tex
  LATEX/2009-2-MD-prova-1-notas.tex
  LATEX/2009-2-MD-comparacao.tex
  LATEX/2009-2-MD-prova-2.tex
  LATEX/2009-2-MD-criterios.tex
  LATEX/2009-planodetrabalho.tex
  LATEX/2009-defesa.tex
  LATEX/2009-proj-monitoria-MD.tex
  LATEX/2009-micropol.tex
  LATEX/2009abcats.tex
  LATEX/2009apr29-C1.tex
  LATEX/2009apr29-MD.tex
  LATEX/2009dnc-in-coq.tex
  LATEX/2009dnc-monads.tex
  LATEX/2009may08-C2.tex
  LATEX/2009may12-MD-gab.tex
  LATEX/2009may13-MD.tex
  LATEX/2009jun05.tex
  LATEX/2009jul02-C2-exercicios.tex
  LATEX/2009fractions.tex
  LATEX/2009integration.tex
  LATEX/2009projections.tex
  LATEX/2009unilog-abs0.tex
  LATEX/2009unilog-abs1.tex
  LATEX/2009unilog-dnc.tex
  LATEX/2009unilog-obso.tex
  LATEX/2009-nd-in-hyps.tex
  LATEX/2010diags.tex
  LATEX/2010diags-body.tex
  LATEX/2010diags-outer.tex
  LATEX/2010hyps.tex
  LATEX/2010kockdiff.tex
  LATEX/2010kockdiff-new.tex
  LATEX/2010kockdiff-utf8.tex
  LATEX/2010lcccs.tex
  LATEX/2010luayacc.tex
  LATEX/2010reducao.tex
  LATEX/2010rings.tex
  LATEX/2010sheaves.tex
  LATEX/2010unilog-current.tex
  LATEX/2010-1-C2-plano-de-aulas.tex
  LATEX/2010-1-C2-prova-1.tex
  LATEX/2010-1-C2-prova-mini-1.tex
  LATEX/2010-1-C2-exercs-P2.tex
  LATEX/2010-1-C2-prova-2.tex
  LATEX/2010-1-C2-exercs-P3.tex
  LATEX/2010-1-C2-prova-3.tex
  LATEX/2010-1-C2-prova-VR.tex
  LATEX/2010-1-C2-prova-VS.tex
  LATEX/2010-1-C2-exercs-P4.tex
  LATEX/2010-1-C2-prova-VS2a.tex
  LATEX/2010-1-C2-prova-VS2b.tex

  LATEX/2010-1-MD-aulas.tex
  LATEX/2010-1-MD-esquemas.tex
  LATEX/2010-1-MD-hanoi.tex
  LATEX/2010-1-MD-plano-de-aulas.tex
  LATEX/2010-1-MD-plano-de-curso.tex
  LATEX/2010-1-MD-prova-1.tex
  LATEX/2010-1-MD-prova-1-body.tex
  LATEX/2010-1-MD-prova-2.tex
  LATEX/2010-1-MD-prova-3.tex
  LATEX/2010-1-MD-prova-VS.tex
  LATEX/2010-1-MD-prova-VS2.tex
  LATEX/2010-1-MD-exercs-P4.tex
  LATEX/2010-2-MD-exercs-VR.tex
  LATEX/2010-edital-monit-MD.tex
  LATEX/2010-proj-inic.tex
  LATEX/2010-proj-pesq.tex
  LATEX/2010-proj-gma.tex
  LATEX/2010-semanact.tex
  LATEX/2010-valenca.tex
  LATEX/2010comprcats.tex
  LATEX/2013-montreal.tex
  LATEX/2013sheaves-for-children.tex

  LATEX/2011-1-GA-regras.tex
  LATEX/2011-rel-est-prob-2.tex
  LATEX/2011-rel-est-prob-3.tex
  LATEX/2011-justificativa.tex
  LATEX/2011-ata-monitoria.tex
  LATEX/2012-rel-prog-func.tex
  LATEX/2012-ata-rfm-dez.tex
  LATEX/2013-GA-criterios.tex
  LATEX/2013-1-GA-prova-P2-A.tex
  LATEX/2013-2-GA-P1A.tex
  LATEX/2013-2-GA-P1A.lua
  LATEX/ata.cls

  LATEX/tmp.tex

  LATEX/2011sheaves-2d.tex
  LATEX/2011ebl-abs.tex
  LATEX/2011ebl-slides.tex
  LATEX/2012minicats.tex
  LATEX/2012unb-abril.tex
  LATEX/2013idct-changes.tex
  LATEX/2013-ict-salas.tex
  LATEX/2013-abaixo-assinado-DE.tex
  LATEX/2014-resposta.tex
  LATEX/2014-rfm-rcn-tabela.tex
  LATEX/2014sfc-abstract.tex
  LATEX/2014sfc-slides.tex
  LATEX/2014sfc-slides2.tex
  LATEX/2014istanbul-a.tex
  LATEX/2014istanbul-a.lua
  LATEX/2014-1-GA-P1.tex
  LATEX/2014-1-GA-P2.tex
  LATEX/2014-1-GA-P2-gab.lua
  LATEX/2014-1-GA-P2-gab.tex
  LATEX/2014-1-GA-VR.tex
  LATEX/2014-1-GA-VS.tex
  LATEX/2014-1-GA-metodos.tex
  LATEX/2014-2-GA-lista1.tex
  LATEX/2014depoimento-ci.tex
  LATEX/2015-1-C2-figuras1.lua
  LATEX/2015-1-C2-figuras1.tex
  LATEX/2015-1-GA-lista-edrx-1.tex
  LATEX/2015-1-GA-lista-edrx-1.lua
  LATEX/2015-1-C2-lista-edrx-1.tex
  LATEX/2015-1-C2-lista-edrx-1.lua
  LATEX/2015-2-C2-material.tex
  LATEX/2015-2-GA-material.tex
  LATEX/2015-2-GA-P1-gab.tex
  LATEX/2015-2-C2-P1.tex
  LATEX/2015-2-C2-P2.tex
  LATEX/2015-2-GA-P2.tex
  LATEX/2015-2-C2-VR.tex
  LATEX/2015-2-GA-VR.tex
  LATEX/2015-2-GA-VS.tex
  LATEX/2015logicandcats.lua
  LATEX/2015logicandcats.tex
  LATEX/2015planar-has.tex
  LATEX/2016planar-has.tex
  LATEX/2017planar-has.tex
  LATEX/2017planar-has-deleted.tex
  LATEX/2017planar-has-defs.tex
  LATEX/2017planar-has-1.mk
  LATEX/2017planar-has-1.tex
  LATEX/2017planar-has-2.tex
  LATEX/2017planar-has-3.tex
  LATEX/2017sajl-mini.tex
  LATEX/2017repl-test-1.tex
  LATEX/2016optativa-1.tex
  LATEX/2016-1-C2-material.tex
  LATEX/2016-1-GA-material.tex
  LATEX/2016-1-LA-material.tex
  LATEX/2016-1-GA-P1.tex
  LATEX/2016-1-C2-P1.tex
  LATEX/2016-1-GA-P2.tex
  LATEX/2016-1-C2-P2.tex
  LATEX/2016-1-GA-VR.tex
  LATEX/2016-1-C2-VR.tex
  LATEX/2016-1-GA-VS.tex
  LATEX/2016-1-C2-VS.tex
  LATEX/2016-2-GA-algebra.tex
  LATEX/2016-2-GA-conicas.tex
  LATEX/2016-2-LA-lambda.tex
  LATEX/2016-2-LA-cats.tex
  LATEX/2016-2-LA-logic.tex
  LATEX/2016-2-LA-zhas.tex
  LATEX/2016-2-C2-integral.tex
  LATEX/2016-2-GA-P1.tex
  LATEX/2016-2-GA-P2.tex
  LATEX/2016-2-C2-P1.tex
  LATEX/2016-2-C2-P2.tex
  LATEX/2016-2-GA-VR.tex
  LATEX/2016-2-GA-VS.tex
  LATEX/2017-1-GA-material.tex
  LATEX/2017-1-LA-material.tex
  LATEX/2017-1-C2-material.tex
  LATEX/2017-1-GA-P1.tex
  LATEX/2017-1-GA-P2.tex
  LATEX/2017-1-GA-VR.tex
  LATEX/2017-1-GA-VS.tex
  LATEX/2017-1-C2-P1.tex
  LATEX/2017-1-C2-P2.tex
  LATEX/2017-1-C2-VS.tex
  LATEX/2017-2-GA-material.tex
  LATEX/2017-2-LA-material.tex
  LATEX/2017-2-C2-material.tex
  LATEX/2017-2-C2-P1.tex
  LATEX/2017-2-C2-P2.tex
  LATEX/2017-2-C2-VS.tex
  LATEX/2017-2-GA-P1.tex
  LATEX/2017-2-GA-P2.tex
  LATEX/2017-2-GA-VR.tex
  LATEX/2017-2-GA-VS.tex
  LATEX/2017-music-paper.tex
  LATEX/2018-rad2017.tex
  LATEX/2018-monitoria.tex
  LATEX/2018-1-LA-material.tex
  LATEX/2018-1-GA-material.tex
  LATEX/2018-1-GA-conicas.tex
  LATEX/2018-1-GA-R3.tex
  LATEX/2018-2-MD-material.tex
  LATEX/2018-2-MD-ordem-prop.tex
  LATEX/2018-2-MD-P1A.tex
  LATEX/2018-2-MD-P1B.tex
  LATEX/2018-2-MD-P2A.tex
  LATEX/2018-2-MD-P2B.tex
  LATEX/2018-2-MD-VR.tex
  LATEX/2018-2-MD-VS.tex
  LATEX/2018-2-MD-sequentes.tex
  LATEX/2018-2-MD-demonstracoes.tex
  LATEX/2018-2-MD-regras-inad.tex
  LATEX/2018-2-MD-set-compr.tex
  LATEX/2018-2-MD-defs-recursivas.tex
  LATEX/2018-2-MD-resposta.tex
  LATEX/2018-2-C2-P1fake.tex
  LATEX/2018-2-C2-P1.tex
  LATEX/2018-2-C2-P2.tex
  LATEX/2018-2-C2-VS.tex
  LATEX/2019-1-C2-material.tex
  LATEX/2019-1-C3-material.tex
  LATEX/2019-1-C3-P1.tex
  LATEX/2019-1-C3-P2.tex
  LATEX/2019-1-C3-VR.tex
  LATEX/2019-1-C3-VS.tex
  LATEX/2019-1-C2-P1.tex
  LATEX/2019-1-C2-P2.tex
  LATEX/2019-1-C2-VR.tex
  LATEX/2019-1-C2-VS.tex
  LATEX/2019-1-C2-tudo.tex
  LATEX/2019-1-C3-tudo.tex
  LATEX/2019-2-C2-material.tex
  LATEX/2019-2-C3-material.tex
  LATEX/2019-2-C3-tudo.tex
  LATEX/2019-2-C2-provas-antigas.tex
  LATEX/2019-2-C2-P1.tex
  LATEX/2019-2-C2-P2.tex
  LATEX/2019-2-C2-VR.tex
  LATEX/2019-2-C2-VS.tex
  LATEX/2019-2-C2-tudo.tex
  LATEX/2019-2-C3-P1.tex
  LATEX/2019-2-C3-P2.tex
  LATEX/2019-2-C3-VR.tex
  LATEX/2019-2-C3-VS.tex
  LATEX/2018-projeto-monitoria-MD.tex
  LATEX/2018pict2e.tex
  LATEX/2018vichy-vgms-slides.tex
  LATEX/2018vichy-video.tex
  LATEX/2018vichy-abstracts.tex
  LATEX/2018tug-dednat6-abs.tex
  LATEX/2018tug-dednat6-abs2.tex
  LATEX/2018tug-dednat6.lua
  LATEX/2018tugboat.tex
  LATEX/2018tugboat-rev1.tex
  LATEX/2018dednat6-extras.tex
  LATEX/2018dednat6-minimal.tex
  LATEX/2018dednat6-preproc.tex
  LATEX/2018dednat6-preproc.dnt
  LATEX/2018dednat6-repl.tex
  LATEX/2018dednat6-no-lua.tex
  LATEX/2018dednat6-zhas.tex
  LATEX/2018planar-has-new-intro.tex
  LATEX/2018marciopalmares.tex
  LATEX/2018pergola.tex
  LATEX/2019-rad2018.tex
  LATEX/2019-rad2019.tex
  LATEX/2019logicday.tex
  LATEX/2019ebl-abs.tex
  LATEX/2019ebl-five-appls.tex
  LATEX/2019ebl-mesa-disc-logica-grad.tex
  LATEX/2019ebl-mesa-slides.tex
  LATEX/2019ebl-relatorio.tex
  LATEX/2019xysyntax.tex
  LATEX/2019barr1.tex
  LATEX/2019barr2.tex
  LATEX/2019diagxyhack.tex
  LATEX/2019clg-slides-1.tex
  LATEX/2019clg-slides-2.tex
  LATEX/2019clg-slides-3.tex
  LATEX/2019clg-slides-4.tex
  LATEX/2019clg-slides-5.tex
  LATEX/2019clg-slides-6.tex
  LATEX/2019notes-types.tex
  LATEX/2019notes-adjunctions.tex
  LATEX/2019notes-monads.tex
  LATEX/2019notes-monads-tys.tex
  LATEX/2019notes-yoneda.tex
  LATEX/2019notes-yoneda.bib
  LATEX/2019notes-kleisli.tex
  LATEX/2019oxford-abs.tex
  LATEX/2019oxford-abs-noc.tex
  LATEX/2019oxford-chars.tex
  LATEX/2019oxford-diags.tex
  LATEX/2019oxford-intro.tex
  LATEX/2019oxford-relatorio.tex
  LATEX/2019compttest.tex
  LATEX/2019asy-test.tex
  LATEX/2019planar-has-2-slashings.tex
  LATEX/2019planar-has-2-logic.tex
  LATEX/2019derived-rules.tex
  LATEX/2019elephant-poster.tex
  LATEX/2019elephant-poster-y.tex
  LATEX/2019elephant-poster-z.tex
  LATEX/2019jacobs.tex
  LATEX/2019newton-abs.tex
  LATEX/2019newton-slides.tex
  LATEX/2019ilha-grande-abs.tex
  LATEX/2019ilha-grande-slides.tex
  LATEX/2019ilha-grande-poster-a4.tex
  LATEX/2019ilha-grande-poster.tex
  LATEX/2019brute-force.tex
  LATEX/2019eev-puro-cartaz.tex
  LATEX/2019seminario-hermann.tex
  LATEX/2019modalities-in-S4.tex
  LATEX/2019douglas.tex
  LATEX/2019J-ops.tex
  LATEX/2019J-ops-arxiv.tex
  LATEX/2019J-ops-defs.tex
  LATEX/2019J-ops-slashings.tex
  LATEX/2019J-ops-logic.tex
  LATEX/2019J-ops-cubes.tex
  LATEX/2019J-ops-valuations.tex
  LATEX/2019J-ops-midway.tex
  LATEX/2019J-ops-algebra.tex
  LATEX/2019J-ops-categories.tex
  LATEX/2019J-ops-classifier.tex
  LATEX/2019J-ops-kan.tex
  LATEX/2019emacsconf.tex
  LATEX/2019emacsconf-long.tex
  LATEX/2019planar-has-1-main.tex
  LATEX/2019sajl-test.tex
  LATEX/2019kan-extensions.tex
  LATEX/2019classifier.tex
  LATEX/2019.mk
  LATEX/mynewunicodechar.sty
  LATEX/2020adjunctions.tex
  LATEX/2020bibtex-test.tex
  LATEX/2020list-test.tex
  LATEX/2020tikz-test.tex
  LATEX/2020mathabx.tex
  LATEX/2020luatex-catcodes.tex
  LATEX/2020homecare.tex
  LATEX/2020hyp.tex
  LATEX/2020tallinn-abstract.bib
  LATEX/2020tallinn-abstract.tex
  LATEX/2020lawvere-notation.tex
  LATEX/2020pullback-lemmas.tex
  LATEX/2020quotient-types.tex
  LATEX/2020closure-operator.tex
  LATEX/2020closures-and-J-ops.tex
  LATEX/2020clops-and-tops.tex
  LATEX/2020clops-and-tops-garbage.tex
  LATEX/2020draw-on-tree.tex
  LATEX/2020thermidor.tex
  LATEX/2020sheaves.tex
  LATEX/2020dn6-error-handling.lua
  LATEX/2021dn6-error-handling.lua
  LATEX/2022throw-1.lua
  LATEX/2020ats.tex
  LATEX/2020pythontex.tex
  LATEX/2020quiver.tex
  LATEX/2020chinese.tex
  LATEX/2020dednat6-video.tex
    LATEX/2020notes-on-notation.tex
    LATEX/2020abramsky-tzevelekos.tex
    LATEX/2020awodey.tex
    LATEX/2020badiou-mt.tex
    LATEX/2020badiou-low.tex
    LATEX/2020barrwellsctcs.tex
    LATEX/2020bell-lst.tex
    LATEX/2020borceux1.tex
    LATEX/2020caccamo.tex
    LATEX/2020caccamo-winskel.tex
    LATEX/2020cwm.tex
    LATEX/2022cwm.tex
    LATEX/2020dialectica.tex
    LATEX/2020genericfigures.tex
    LATEX/2020hosgood.tex
    LATEX/2020institutions.tex
    LATEX/2020internal-cats.tex
    LATEX/2020jacobs.tex
    LATEX/2020kockdiff.tex
    LATEX/2020lambek86.tex
    LATEX/2020lambek-scott.tex
    LATEX/2020lawvere-adjfo.tex
    LATEX/2020lawvere-equahyp.tex
    LATEX/2020lindenhovius.tex
    LATEX/2020loregian.tex
    LATEX/2020macdonaldsobral.tex
    LATEX/2020maclane-moerdijk.tex
    LATEX/2020mclarty.tex
    LATEX/2020prawitz.tex
    LATEX/2020riehl.tex
    LATEX/2020seelyhyp.tex
    LATEX/2020seelyhyp-poster.tex
    LATEX/2020seelylccc.tex
    LATEX/2020seelyplc.tex
    LATEX/2020topostheory.tex
    LATEX/2021zhang.tex
  LATEX/2020gaina-kowalski.tex
  LATEX/2020J-ops-new.tex
  LATEX/2020on-a-broken-dnc.tex
  LATEX/2020on-a-broken-dnc.bib
  LATEX/2020-1-C2-intro.tex
  LATEX/2020-1-C2-somas-1.tex
  LATEX/2020-1-C2-somas-2.tex
  LATEX/2020-1-C2-def-integral.tex
  LATEX/2020-1-C2-TFCs.tex
  LATEX/2020-1-C2-TFC2.tex
  LATEX/2020-1-C2-TFC2-2.tex
  LATEX/2020-1-C2-int-subst.tex
  LATEX/2020-1-C2-miniteste-1.tex
  LATEX/2020-1-C2-fracs-parcs.tex
  LATEX/2020-1-C2-int-pots-sen-cos.tex
  LATEX/2020-1-C2-P1.tex
  LATEX/2020-1-C2-subst-trig-1.tex
  LATEX/2020-1-C2-P2.tex
  LATEX/2020-1-C2-MT2.tex
  LATEX/2020-1-C2-MT3.tex
  LATEX/2020-1-C2-VS.tex
  LATEX/2020-1-C2.tex
  LATEX/2020-1-C3.tex
  LATEX/2020-1-C2-material.tex
  LATEX/2020-1-C3-material.tex
  LATEX/2020-1-C3-intro.tex
  LATEX/2020-1-C3-vetor-tangente.tex
  LATEX/2020-1-C3-taylor-1.tex
  LATEX/2020-1-C3-taylor-2.tex
  LATEX/2020-1-C3-taylor-3.tex
  LATEX/2020-1-C3-superficies-1.tex
  LATEX/2020-1-C3-superficies-2.tex
  LATEX/2020-1-C3-derivs-parciais.tex
  LATEX/2020-1-C3-plano-tang.tex
  LATEX/2020-1-C3-derivs-alta-ordem.tex
  LATEX/2020-1-C3-aprox-2a-ordem-R2.tex
  LATEX/2020-1-C3-miniteste-2.tex
  LATEX/2020-1-C3-dicas-p1.tex
  LATEX/2020-1-C3-abertos-e-fechados.tex
  LATEX/2020-1-C3-P1.tex
  LATEX/2020-1-C3-P2.tex

  LATEX/2020-1-C2-tudo.tex
  LATEX/2020-1-C3-tudo.tex

  LATEX/2020-2-C2-tudo.tex
  LATEX/2020-2-C3-tudo.tex

  LATEX/2020-2-CN-template.tex
  LATEX/2020-2-C2-intro.tex
  LATEX/2020-2-C2-somas-1.tex
  LATEX/2020-2-C2-somas-2.tex
  LATEX/2020-2-C2-escadas.tex
  LATEX/2020-2-C2-MT1.tex
  LATEX/2020-2-C2-TFC.tex
  LATEX/2020-2-C2-int-subst.tex
  LATEX/2020-2-C2-subst-trig.tex
  LATEX/2020-2-C2-MT2.tex
  LATEX/2020-2-C2-fracs-parcs.tex
  LATEX/2020-2-C2-P1.tex
  LATEX/2020-2-C2-edovs.tex
  LATEX/2020-2-C2-P2.tex
  LATEX/2020-2-C2-ids-trigs.tex
  LATEX/2020-2-C3-intro.tex
  LATEX/2020-2-C3-vetor-tangente.tex
  LATEX/2020-2-C3-aceleracao.tex
  LATEX/2020-2-C3-taylor.tex
  LATEX/2020-2-C3-rcadeia1.tex
  LATEX/2020-2-C3-MT1.tex
  LATEX/2020-2-C3-plano-tang.tex
  LATEX/2020-2-C3-plano-tang.lua
  LATEX/2020-2-C3-MT2.tex
  LATEX/2020-2-C3-P1.tex
  LATEX/2020-2-C3-P2.tex
  LATEX/2021-1-CN-template.tex
  LATEX/2021-1-C2-intro.tex
  LATEX/2021-1-C2-subst.tex
  LATEX/2021-1-C2-somas-1.tex
  LATEX/2021-1-C2-somas-1-dicas.tex
  LATEX/2021-1-C2-somas-2.tex
  LATEX/2021-1-C2-somas-2-4.tex
  LATEX/2021-1-C2-critical-points.lua
  LATEX/2021-1-C2-integral-figuras.tex
  LATEX/2021-1-C2-funcoes-conjs-infinitos.tex
  LATEX/2021-1-C2-propriedades-da-integral.tex
  LATEX/2021-1-C2-os-dois-TFCs.tex
  LATEX/2021-1-C2-int-subst.tex
  LATEX/2021-1-C2-edovs.tex
  LATEX/2021-1-C2-MT1.tex
  LATEX/2021-1-C2-MT2.tex
  LATEX/2021-1-C2-P1.tex
  LATEX/2021-1-C2-P2.tex
  LATEX/2021-1-C2-contas-em-C2.tex
    LATEX/2021-1-C2-integrais-escadas.tex
    LATEX/2021-1-C2-coisas-antigas.tex
  LATEX/2021-1-C2-tudo.tex

  LATEX/2021-1-C3-intro.tex
  LATEX/2021-1-C3-vetor-tangente.tex
  LATEX/2021-1-C3-visualizar-limites.tex
  LATEX/2021-1-C3-taylor.tex
  LATEX/2021-1-C3-cortes.tex
  LATEX/2021-1-C3-curvas-de-nivel.tex
  LATEX/2021-1-C3-notacao-de-fisicos.tex
  LATEX/2021-1-C3-3D.lua
  LATEX/2021-1-C3-planos.tex
  LATEX/2021-1-C3-MT1.tex
  LATEX/2021-1-C3-derivadas-parciais.tex
  LATEX/2021-1-C3-funcoes-quadraticas.tex
  LATEX/2021-1-C3-matriz-jacobiana.tex
  LATEX/2021-1-C3-MT2.tex
  LATEX/2021-1-C3-gradiente.tex
  LATEX/2021-1-C3-P1.tex
  LATEX/2021-1-C3-abertos-e-fechados.tex
  LATEX/2021-1-C3-P2.tex
  LATEX/2021-1-C3-tudo.tex

  LATEX/2021-2-CN-template.tex
  LATEX/2021-2-C2-intro.tex
  LATEX/2021-2-C2-somas-1.tex
  LATEX/2021-2-C2-MT1.tex
  LATEX/2021-2-C2-MT2.tex
  LATEX/2021-2-C2-MT2.lua
  LATEX/2021-2-C2-somas-2.tex
  LATEX/2021-2-C2-somas-2-4.tex
  LATEX/2021-2-C2-infs-e-sups.tex
  LATEX/2021-2-C2-def-integral.tex
  LATEX/2021-2-C2-def-integral.lua
  LATEX/2021-2-C2-props-int.tex
  LATEX/2021-2-C2-MT3.tex
  LATEX/2021-2-C2-TFC1.tex
  LATEX/2021-2-C2-int-subst.tex
  LATEX/2021-2-C2-P1.tex
  LATEX/2021-2-C2-mud-var-gamb.tex
  LATEX/2021-2-C2-edovs.tex
  LATEX/2021-2-C2-revisao-pra-P2.tex
  LATEX/2021-2-C2-P2.tex
  LATEX/2021-2-C2-fracoes-parciais.tex
  LATEX/2021-2-C2-VS.tex
  LATEX/2021-2-C2-tudo.tex
  LATEX/2021-2-C2-tudo.gnumake

  LATEX/2021-2-C3-intro.tex
  LATEX/2021-2-C3-vetor-tangente.tex
  LATEX/2021-2-C3-bezier.tex
  LATEX/2021-2-C3-MT1.tex
  LATEX/2021-2-C3-tipos.tex
  LATEX/2021-2-C3-notacao-de-fisicos.tex
  LATEX/2021-2-C3-diag-nums.tex
  LATEX/2021-2-C3-diag-nums.lua
  LATEX/2021-2-C3-diag-nums.gnuplot
  LATEX/2021-2-C3-MT2.tex
  LATEX/2021-2-C3-funcoes-homogeneas.tex
  LATEX/2021-2-C3-funcoes-quadraticas.tex
  LATEX/2021-2-C3-taylor.tex
  LATEX/2021-2-C3-P1.tex
  LATEX/2021-2-C3-taylor-R2.tex
  LATEX/2021-2-C3-P2.tex
  LATEX/2021-2-C3-VS.tex
  LATEX/2021-2-C3-tudo.tex
  LATEX/2022-C2-projeto-de-monitoria.tex

  LATEX/2022-1-CN-template.tex
  LATEX/2022-1-C2-intro.tex
  LATEX/2022-1-C2-intro.lua
  LATEX/2022-1-C2-somas-3.tex
  LATEX/2022-1-C2-infs-e-sups.tex
  LATEX/2022-1-C2-TFC1.tex
  LATEX/2022-1-C2-fini.tex
  LATEX/2022-1-C2-der-fun-inv.tex
  LATEX/2022-1-C2-MT1.tex
  LATEX/2022-1-C2-algumas-t-ints.tex
  LATEX/2022-1-C2-formulas-defs.tex
  LATEX/2022-1-C2-formulas-test.tex
  LATEX/2022-1-C2-MT2.tex
  LATEX/2022-1-C2-primitivas.tex
  LATEX/2022-1-apresentacao-C2.tex
  LATEX/2022-1-C2-dicas-pra-P1.tex
  LATEX/2022-1-C2-P1.tex
  LATEX/2022-1-C2-dicas-pra-P2.tex
  LATEX/2022-1-C2-P2.tex
  LATEX/2022-1-C2-P2.lua
  LATEX/2022-1-C2-VR.tex
  LATEX/2022-1-C2-dicas-pra-VSA.tex
  LATEX/2022-1-C2-VSA.tex

  LATEX/2022-1-C2-VSB.tex
  LATEX/2022-1-C3-VSB.tex
  LATEX/2022-1-C2-VSB-rodada.tex
  LATEX/2022-1-C3-VSB-rodada.tex
  LATEX/2022-plano-de-atividades-C2.tex
  LATEX/2022-plano-de-atividades-C3.tex
  LATEX/2022-termo-de-compromisso.tex

  LATEX/2022-1-C2-tudo.tex
  LATEX/2022-1-C3-orbita.tex
  LATEX/2022-1-C3-notacao-de-fisicos.tex
  LATEX/2022-1-C3-MT1.tex
  LATEX/2022-1-C3-funcoes-homogeneas.tex
  LATEX/2022-1-C3-MT2.tex
  LATEX/2022-1-C3-P1.tex
  LATEX/2022-1-C3-P2.tex
  LATEX/2022-1-C3-VR.tex
  LATEX/2022-1-C3-VS.tex
  LATEX/2022-1-C3-tudo.tex

  LATEX/2022-2-CN-template.tex
  LATEX/2022-2-C2-intro.tex
  LATEX/2022-2-C2-mathologermovel.tex
  LATEX/2022-2-C2-buraco.tex
  LATEX/2022-2-C2-int-por-partes.tex
  LATEX/2022-2-C2-fracoes-parciais.tex
  LATEX/2022-2-C2-mudanca-de-variaveis.tex
  LATEX/2022-2-C2-subst-trig.tex
  LATEX/2022-2-C2-somas-de-riemann.tex
  LATEX/2022-2-C2-TFC1-e-TFC2.tex
  LATEX/2022-2-C2-areas-e-volumes.tex
  LATEX/2022-2-C2-edovs.tex
  LATEX/2022-2-C2-edos-lineares.tex
  LATEX/2022-2-C2-dicas-pra-P1.tex
  LATEX/2022-2-C2-P1.tex
  LATEX/2022-2-C2-edos-exatas.tex
  LATEX/2022-2-C2-dicas-pra-P2.tex
  LATEX/2022-2-C2-P2.tex
  LATEX/2022-2-C2-VR.tex
  LATEX/2022-2-C2-dicas-pra-VS.tex
  LATEX/2022-2-C2-VS.tex
  LATEX/2022-2-C2-plano-de-curso.tex
  LATEX/2022-2-C2-tudo.tex

  LATEX/2022-2-C3-intro.tex
  LATEX/2022-2-C3-tipos.tex
  LATEX/2022-2-C3-taylor.tex
  LATEX/2022-2-C3-superficies.tex
  LATEX/2022-2-C3-plano-tangente.tex
  LATEX/2022-2-C3-derivadas-parciais.tex
  LATEX/2022-2-C3-funcoes-homogeneas.tex
  LATEX/2022-2-C3-regra-da-cadeia.tex
  LATEX/2022-2-C3-dicas-pra-P1.tex
  LATEX/2022-2-C3-P1.tex
  LATEX/2022-2-C3-funcoes-difs.tex
  LATEX/2022-2-C3-topologia.tex
  LATEX/2022-2-C3-maximos-e-minimos.tex
  LATEX/2022-2-C3-dicas-pra-P2.tex
  LATEX/2022-2-C3-P2.tex
  LATEX/2022-2-C3-VR.tex
  LATEX/2022-2-C3-VS.tex
  LATEX/2022-2-C3-plano-de-curso.tex
  LATEX/2022-2-C3-tudo.tex

  LATEX/2022-2-C2-C3-ajuda.tex
  LATEX/2022-2-C2-C3-ajuda.mytoc
  LATEX/2022-reclamacoes.tex
  LATEX/2022-arthur.tex
  LATEX/2023-caepro.tex
  LATEX/2023-caepro-reclamacoes.tex
  LATEX/2023-caepro-didatica.tex
  LATEX/2023-caepro-VR.tex
  LATEX/2023-caepro-plano.tex
  LATEX/2023-caepro-hist.tex
  LATEX/2023-caepro-nplcs.tex

  LATEX/2023-C3-projeto-de-monitoria.tex
  LATEX/2023-C2-monitoria-edital.tex
  LATEX/2023-1-CN-template.tex
  LATEX/2023-1-MM-template.tex
  LATEX/2023-1-MM-tudo-template.tex
  LATEX/2023-1-MM-plano-de-curso.tex

  LATEX/2023-1-C2-intro.tex
  LATEX/2023-1-C2-carro.tex
  LATEX/2023-1-C2-macaco.tex
  LATEX/2023-1-C2-mudanca-de-variaveis.tex
  LATEX/2023-1-C2-fracoes-parciais.tex
  LATEX/2023-1-C2-somas-de-riemann.tex
  LATEX/2023-1-C2-dicas-pra-P1.tex
  LATEX/2023-1-C2-P1.tex
  LATEX/2023-1-C2-edovs.tex
  LATEX/2023-1-C2-edos-lineares.tex
  LATEX/2023-1-C2-dicas-pra-P2.tex
  LATEX/2023-1-C2-volumes.tex
  LATEX/2023-1-C2-P2.tex
  LATEX/2023-1-C2-VR.tex
  LATEX/2023-1-C2-abaixo-assinado.tex
  LATEX/2023-1-C2-prova-monitor.tex
  LATEX/2023-1-C2-plano-de-curso.tex
  LATEX/2023-1-C2-tudo.tex

  LATEX/2023-1-C3-intro.tex
  LATEX/2023-1-C3-plano-de-curso.tex
  LATEX/2023-1-C3-tudo.tex

  LATEX/2023-1-C4-intro.tex
  LATEX/2023-1-C4-dicas-pra-P1.tex
  LATEX/2023-1-C4-P1.tex
  LATEX/2023-1-C4-dicas-pra-P2.tex
  LATEX/2023-1-C4-P2.tex
  LATEX/2023-1-C4-plano-de-curso.tex
  LATEX/2023-1-C4-tudo.tex

  LATEX/2023-1-LA-intro.tex
  LATEX/2023-1-LA-plano-de-curso.tex
  LATEX/2023-1-LA-tudo.tex

  LATEX/2023-1-ES-P1.tex
  LATEX/2023-1-ES-P2.tex
  LATEX/2023-1-ES-VR.tex
  LATEX/2023-1-ES-tudo.tex

  LATEX/2023-2-MM-template.tex
  LATEX/2023-2-MM-template-defs.tex
  LATEX/2023-2-MM-tudo-template.tex
  LATEX/2023-2-MM-plano-de-curso.tex

  LATEX/2023-2-C2-C3-termo.tex

  LATEX/2023-2-C2-intro.tex
  LATEX/2023-2-C2-carro.tex
  LATEX/2023-2-C2-justificativas.tex
  LATEX/2023-2-C2-integracao-por-partes.tex
  LATEX/2023-2-C2-teste-niv.tex
  LATEX/2023-2-C2-mudanca-de-variaveis.tex
  LATEX/2023-2-C2-mv-defs.tex
  LATEX/2023-2-C2-DFI.tex
  LATEX/2023-2-C2-fracoes-parciais.tex
  LATEX/2023-2-C2-somas-de-riemann.tex
  LATEX/2023-2-C2-TFC1.tex
  LATEX/2023-2-C2-dirichlet.tex
  LATEX/2023-2-C2-dicas-pra-P1.tex
  LATEX/2023-2-C2-volumes.tex
  LATEX/2023-2-C2-P1.tex
  LATEX/2023-2-C2-comprimento-de-arco.tex
  LATEX/2023-2-C2-edovs.tex
  LATEX/2023-2-C2-edovs-defs.tex
  LATEX/2023-2-C2-edolccs.tex
  LATEX/2023-2-C2-numeros-complexos.tex
  LATEX/2023-2-C2-edos-lineares.tex
  LATEX/2023-2-C2-edos-exatas.tex
  LATEX/2023-2-C2-edos-exatas-defs.tex
  LATEX/2023-2-C2-coefs-a-determinar.tex
  LATEX/2023-2-C2-taylor.tex
  LATEX/2023-2-C2-dicas-pra-P2.tex
  LATEX/2023-2-C2-series-formais.tex
  LATEX/2023-2-C2-P2.tex
  LATEX/2023-2-C2-VRP1.tex
  LATEX/2023-2-C2-VRP2.tex
  LATEX/2023-2-C2-dicas-pra-VS.tex
  LATEX/2023-2-C2-ref-subst.tex
  LATEX/2023-2-C2-VS.tex

  LATEX/2023-2-C2-edos-series.tex
  LATEX/2023-2-C2-var-params.tex
  LATEX/2023-2-C2-areas-de-srs.tex
  LATEX/2023-2-C2-ints-improprias.tex
  LATEX/2023-2-C2-maxima.tex
  LATEX/2023-2-C2-plano-de-curso.tex
  LATEX/2023-2-C2-tudo.tex

  LATEX/2023-2-C3-intro.tex
  LATEX/2023-2-C3-geogebra.tex
  LATEX/2023-2-C3-trajetorias.tex
  LATEX/2023-2-C3-tipos.tex
  LATEX/2023-2-C3-taylor.tex
  LATEX/2023-2-C3-notacao-de-fisicos.tex
  LATEX/2023-2-C3-gradiente.tex
  LATEX/2023-2-C3-funcoes-homogeneas.tex
  LATEX/2023-2-C3-dicas-pra-P1.tex
  LATEX/2023-2-C3-P1.tex
  LATEX/2023-2-C3-matrizes-definidas.tex
  LATEX/2023-2-C3-topologia.tex
  LATEX/2023-2-C3-teorema-de-weierstrass.tex
  LATEX/2023-2-C3-P2.tex
  LATEX/2023-2-C3-bezier.tex
  LATEX/2023-2-C3-polis-2o-grau.tex
  LATEX/2023-2-C3-polis-2o-grau-defs.tex
  LATEX/2023-2-C3-dicas-pra-P2.tex
  LATEX/2023-2-C3-plano-de-curso.tex
  LATEX/2023-2-C3-tudo.tex

  LATEX/2024-C3-projeto-de-monitoria.tex
  LATEX/2024-C2-monitoria-edital.tex
  LATEX/2024-C3-monitoria-edital.tex
  LATEX/2024-C2-monitoria-edital-ac.tex
  LATEX/2024-C3-monitoria-edital-ac.tex
  LATEX/2024-1-MM-template.tex
  LATEX/2024-1-C2-C3-termo.tex
  LATEX/2024-1-C2-plano-de-curso.tex
  LATEX/2024-1-C3-plano-de-curso.tex
  LATEX/2024-1-C2-tudo.tex
  LATEX/2024-1-C3-tudo.tex

  LATEX/2024-1-C2-intro.tex
  LATEX/2024-1-C2-expressoes.tex
  LATEX/2024-1-C2-carro.tex
  LATEX/2024-1-C2-ex-subst.tex
  LATEX/2024-1-C2-teste-niv.tex
  LATEX/2024-1-C2-int-indefinida.tex
  LATEX/2024-1-C2-int-partes.tex
  LATEX/2024-1-C2-mv-defs.tex
  LATEX/2024-1-C2-diferenciais.tex
  LATEX/2024-1-C2-mudanca-de-variaveis.tex
  LATEX/2024-1-C2-dicas-pra-greve.tex
  LATEX/2024-1-C2-dicas-pra-P1.tex
  LATEX/2024-1-C2-DFI.tex

  LATEX/2024-1-C3-intro.tex
  LATEX/2024-1-C3-trajetorias.tex
  LATEX/2024-1-C3-tipos.tex
  LATEX/2024-1-C3-notacao-de-fisicos.tex
  LATEX/2024-1-C3-intro-superficies.tex
  LATEX/2024-1-C3-dicas-pra-greve.tex
  LATEX/2024-1-C3-derivadas-parciais.tex
  LATEX/2024-1-C3-diferenciais.tex
  LATEX/2024-1-C3-anim-underbraces.tex
  LATEX/2024-1-C3-teste-niv.tex

  2024.1-C2/Makefile
  2024.1-C3/Makefile
  2024.1-GA/Makefile

  LATEX/2021-plano-remoto-C2.tex
  LATEX/2021-plano-remoto-C3.tex
  LATEX/2021pict2e.tex
  LATEX/2021pict2e.lua
  LATEX/2022pict2e.lua
  LATEX/2022pict2e.tex
  LATEX/Pict2e1.lua
  LATEX/Pict2e1-1.lua
  LATEX/2022repl.tex
  LATEX/2020-rad2019.tex
  LATEX/2020-ace.tex
  LATEX/2020notes-yoneda.tex
  LATEX/2020favorite-conventions.tex
  LATEX/2020groth-tops.tex
  LATEX/2021haskell.tex
  LATEX/2021excuse.tex
  LATEX/2021excuse.lua
  LATEX/2021excuse-abs.tex
  LATEX/2021logicday.tex
  LATEX/2021ski.tex
  LATEX/2021repl-pict.tex
  LATEX/2021repl-pict.lua
  LATEX/2021groth-tops-children.tex
  LATEX/2021groth-tops-children.lua
  LATEX/2021groth-tops-defs.tex
  LATEX/2021groth-tops-children-slides.tex
  LATEX/2021lindenhovius-june.tex
  LATEX/2021lindenhovius-j-to-X.tex
  LATEX/2021other-bijections.tex
  LATEX/2021-rad2020.tex
  LATEX/2022-rad2021.tex
  LATEX/2023-rad2022.tex
  LATEX/2024-rad2023.tex
  LATEX/2021sobre-aulas-por-telegram.tex
  LATEX/2021planar-HAs-2.tex
  LATEX/2021ArtDecoN.tex
  LATEX/2021standalone.tex
  LATEX/2021burghardt.tex
  LATEX/2021lean-nng.tex
  LATEX/2021lean.lua
  LATEX/2021sgl.tex
  LATEX/2021fitch.tex
  LATEX/2021fitch.lua
  LATEX/2021fitch-old.lua
  LATEX/2021verbatim.tex
  LATEX/2021verbatim.lua
  LATEX/2021emacsconf.tex
  LATEX/2021resposta-daniela.tex
  LATEX/2022chat-walter.tex
  LATEX/2021yoneda.tex
  LATEX/2021rrj.tex
  LATEX/2021composes-hash.tex
  LATEX/2021-deptypes-for-children.tex
  LATEX/2021systemF.tex
  LATEX/2022dep-vars.tex
  LATEX/2022hissa.tex
  LATEX/2022ebl-abs.tex
  LATEX/2022ebl.tex
  LATEX/2022ebl-relatorio.tex
  LATEX/2022emacsconf-py.tex
  LATEX/2022emacsconf-kla.tex
  LATEX/2022lacombe.tex
  LATEX/2022sula.tex
  LATEX/2022tikzwd-1.tex
  LATEX/2022tikzwd-2.tex
  LATEX/2022tikz-repl.tex
  LATEX/2022pgf-test.tex
  LATEX/2023headfoot.lua
  LATEX/2023lpegcaptures.tex
  LATEX/2023emacsconf-repls.tex
  LATEX/2023loeliger.tex
  LATEX/2024eev-git.tex
  LATEX/2024visualizing-captures.tex
  LATEX/2024panic-at-equalities.tex
  LATEX/2024panic-teresopolis.tex
  LATEX/2024type-inference.tex
  LATEX/2024type-inferences.tex
  LATEX/2024pts.tex
  LATEX/2024coreo.tex
  LATEX/2024leantt.tex

  LATEX/2022on-the-missing.tex
  LATEX/2022on-the-missing-agda.tex
  LATEX/2022on-the-missing-b.tex
  LATEX/2022missing-diags-yoneda.tex
  LATEX/2022yoneda-pseudocode.tex
  LATEX/2022meteor-test1.tex
  LATEX/2022meteor-test1.pre.bib
  LATEX/2022ochs-meteor1.tex
  LATEX/2022missing-changes-1.tex

  LATEX/2022agda-logic-1.tex
  LATEX/2022AgdaYoneda1.lagda.tex
  LATEX/2022Cats3.lagda.tex
  LATEX/2022Cats4.lagda.tex
  LATEX/2022Cats5.lagda.tex
  LATEX/2022Cats6.lagda.tex

  LATEX/2023ends-and-coends.tex

  LATEX/istanbul1.org
  LATEX/istanbulall.lua
  LATEX/istanbulglyphs.el
  LATEX/istanbulquotes.tex
  LATEX/istanbuldefs.tex
  LATEX/istanbul1.tex
  LATEX/istanbul-handouts.tex
  LATEX/istanbul-july.tex
  LATEX/2015oppositions.tex
  LATEX/2015children.tex
  LATEX/2016lucatelli.tex
  LATEX/2017ebl-abs.tex
  LATEX/2017ebl-slides.tex
  LATEX/2017ebl-handouts.tex
  LATEX/2017ebl-proceedings.tex
  LATEX/2017adjunctions.tex
  LATEX/2017vichy-abs.tex
  LATEX/2017vichy-slides-1.tex
  LATEX/2017vichy-slides-2.tex
  LATEX/2017vichy-slides-3.tex
  LATEX/2017vichy-slides-4.tex
  LATEX/2017visualizing-gms.tex
  LATEX/2017vichy-workshop.tex
  LATEX/2017bell.tex
  LATEX/2017puc-abstract.tex
  LATEX/2017cwm.tex
  LATEX/2017elephant.tex
  LATEX/2017yoneda.tex
  LATEX/2017biblatex.tex
  LATEX/2017distributivity.tex
  LATEX/2017lucatelli-fibs.tex
  LATEX/2017idarct.tex
  LATEX/2018jacobs.tex
  LATEX/2018kockdiff.tex
  LATEX/2018repl-test.tex
  LATEX/edrxtikz.lua
  LATEX/edrxpict.lua
  LATEX/emaxima.sty

  LATEX/beamer-template.tex
  LATEX/lualoader.lua
  LATEX/myrepl.lua
  LATEX/edrxrepl.tex

  LATEX/twot.tex
  LATEX/twot-boxes.lua
  LATEX/twot-pages.lua
  LATEX/twot-paragraph.lua

  LATEX/edrx17.sty
  LATEX/edrx17defs.tex
  LATEX/edrx15.sty
  LATEX/edrx15defs.tex
  LATEX/edrx15chars.tex
  LATEX/edrx20chars.tex
  LATEX/edrx20limp.tex
  LATEX/edrx21.sty
  LATEX/edrx21defs.tex
  LATEX/edrx21chars.tex
  LATEX/edrx21chars-d.tex
  LATEX/edrxaccents.tex
  LATEX/edrxchars.tex
  LATEX/edrxheadfoot.tex
  LATEX/edrxgac2.tex
  LATEX/maira.tex
  LATEX/chapa1-pressao.tex
  LATEX/chapa1-regric.tex
  LATEX/rrj.tex
  LATEX/whipping-girl.tex
  LATEX/personas-sexuais-cap-1.tex

  LATEX/material-para-GA.tex
  LATEX/material-para-GA.md

  LATEX/falta-misandria-a5.tex
  LATEX/falta-misandria-body.tex
  LATEX/falta-misandria-cats.tex
  LATEX/falta-misandria-corpo.tex
  LATEX/falta-misandria-daniel.tex
  LATEX/falta-misandria-hdt.tex
  LATEX/falta-misandria-homens.tex
  LATEX/falta-misandria-intro.tex
  LATEX/falta-misandria-nismos.tex
  LATEX/falta-misandria-print.tex
  LATEX/falta-misandria-rh.tex
  LATEX/falta-misandria-tf.tex
  LATEX/falta-misandria-tf0.tex

  LATEX/falta-misandria-v.tex
  LATEX/falta-misandria-scr.tex
  LATEX/falta-misandria-scr-print.tex

  LATEX/falta-misandria-f-fm.tex
  LATEX/falta-misandria-f-main.tex
  LATEX/falta-misandria-f-scr.tex
  LATEX/falta-misandria-f-xs.tex
  LATEX/falta-misandria-f-g.tex
  LATEX/falta-misandria-f-haz.tex
  LATEX/falta-misandria-f-etc.tex

  LATEX/tmppgf.tex
  LATEX/beamertest.tex
  LATEX/activist.bib
  LATEX/catsem.bib
  LATEX/catsem-u.bib
  LATEX/catsem-slides.bib
  LATEX/catsem-ab.bib
  LATEX/catsembibtest.tex
  LATEX/filters.bib
  LATEX/passo-a-passo-concurso.tex
  LATEX/phil.bib
  LATEX/dednat.icn
  LATEX/desenhos.014
  LATEX/diaglib.014
  LATEX/tese2.sty
  LATEX/edrx.sty
  LATEX/poep.tex
  LATEX/yogphi.tex
  LATEX/reinhab.tex
  LATEX/forest.tex
  LATEX/chaui-hch.tex
  LATEX/kaplansky.tex
  LATEX/dynkin.tcl
  LATEX/testdynkin.tex

  MONTREAL/cv
  MONTREAL/letter_of_intent
  MONTREAL/sexophobic_as_answer
  MONTREAL/short_bio

  ORG/istanbul.org
  ORG/istanbul-meta.org
  ORG/genero.org
  ORG/testinfo.org
  ORG/emacsconf2022-py.org
  ORG/emacsconf2022-kla.org

  JS/test1.js
  JS/test2.js

  LEAN/README
  LEAN/fpl_067.lean
  LEAN/fpl_071.lean
  LEAN/checksyntax.lean
  LEAN/comprehensions1.lean
  LEAN/constrexprs1.lean
  LEAN/distributivity1.lean
  LEAN/exprs1.lean
  LEAN/feline1.lean
  LEAN/ioprocess1.lean
  LEAN/luatree.lean
  LEAN/luatree1.lean
  LEAN/luatree2.lean
  LEAN/macro1.lean
  LEAN/metam.lean
  LEAN/overloaded1.lean
  LEAN/propositional1.lean
  LEAN/propsandproofs1.lean
  LEAN/propsandproofs2.lean
  LEAN/structures1.lean
  LEAN/syntax.lean
  LEAN/telescopes1.lean
  LFORTH/DNC
  LFORTH/README
  LFORTH/dbg.lua
  LFORTH/inner-mini.lua
  LFORTH/kernel.lua
  LFORTH/lforth
  LFORTH/outer-mini.lua
  LFORTH/stdlib.lua
  LFORTH/stdlib.lforth
  LFORTH/yoneda.lforth
  LILYPOND/atirei_o_pau_no_gato_1.ly
  LILYPOND/minuet1.ly
  LILYPOND/roundmidnight.ly
  LILYPOND/schumann_68_1.ly
  LILYPOND/purcell-minuet.ly
  LILYPOND/repl.ly
  LILYPOND/invention-01.ly
  LILYPOND/invention-03.ly
  LILYPOND/invention-04.ly
  LILYPOND/a_new_ground.ly
  LISP/debugging-1.lisp
  LISP/emacs-cl-1.lisp
  LISP/seibel-02.lisp
  LISP/seibel-03.lisp
  LISP/seibel-04.lisp
  LISP/seibel-05.lisp
  LISP/seibel-06.lisp
  LOVE2D/old-conf.lua
  LOVE2D/1.lua
  LUA/README.e
  LUA/2013.2-ES-diags
  LUA/2022-t.lua
  LUA/8queens.lua
  LUA/Abbrevs1.lua
  LUA/Actions1.lua
  LUA/AnyOf1.lua
  LUA/Arith1.lua
  LUA/Arith2.lua
  LUA/Arith3.lua
  LUA/Arith4.lua
  LUA/Arith5.lua
  LUA/Arith6.lua
  LUA/Ast1.lua
  LUA/Ast2.lua
  LUA/Ast3.lua
  LUA/Ast4.lua
  LUA/Ast5.lua
  LUA/Ast6.lua
  LUA/Basic1.lua
  LUA/BinarySearch1.lua
  LUA/BlogMe3.lua
  LUA/C2Subst1.lua
  LUA/C2Formulas1.lua
  LUA/CLua1.lua
  LUA/CME2.lua
  LUA/CME3.lua
  LUA/CabosNaDiagonal.lua
  LUA/Cabos1.lua
  LUA/Cabos2.lua
  LUA/Cabos3.lua
  LUA/Caepro1.lua
  LUA/Caepro2.lua
  LUA/Caepro3.lua
  LUA/Caepro4.lua
  LUA/Caepro5.lua
  LUA/Caepro5-blogme.lua
  LUA/CaeproLisp1.lua
  LUA/Calendar1.lua
  LUA/Calendar2.lua
  LUA/Capts1.lua
  LUA/Capts2.lua
  LUA/Co1.lua
  LUA/Code.lua
  LUA/Code2.lua
  LUA/CodeEtexTla.lua
  LUA/Comissao1.lua
  LUA/CoroRepl1.lua
  LUA/CoroRepl2.lua
  LUA/Dang1.lua
  LUA/DangBlogme1.lua
  LUA/Dednat7.lua
  LUA/DednatRequire1.lua
  LUA/DeleteComments1.lua
  LUA/DeleteComments2.lua
  LUA/Deps1.lua
  LUA/DFS.lua
  LUA/DFS-old.lua
  LUA/DFSTriangle.lua
  LUA/DGetInfo1.lua
  LUA/ELLua1.lua
  LUA/ELpeg1.lua
  LUA/ELpeg2.lua
  LUA/ELpeg3.lua
  LUA/ELpeg-cme1.lua
  LUA/ELpeg-lambda1.lua
  LUA/EmacsClient1.lua
  LUA/EmacsConf2023.lua
  LUA/EScript.lua
  LUA/Escadas1.lua
  LUA/Estatistica1.lua
  LUA/ExprDxDy1.lua
  LUA/Fitch.lua
  LUA/Fitch-old.lua
  LUA/Fold1.lua
  LUA/Freeze1.lua
  LUA/GetInfo.lua
  LUA/GetInfo2.lua
  LUA/GetOpt1.lua
  LUA/Globals1.lua
  LUA/Gram1.lua
  LUA/Gram2.lua
  LUA/Gram3.lua
  LUA/Gram4.lua
  LUA/ImagensDeIntervalos1.lua
  LUA/Indent1.lua
  LUA/Indent2.lua
  LUA/Interpret.lua
  LUA/LPex1.lua
  LUA/Lazy1.lua
  LUA/Lazy2.lua
  LUA/Lazy3.lua
  LUA/Lazy4.lua
  LUA/Lazy5.lua
  LUA/LeanMetaDoc1.lua
  LUA/Lisp1.lua
  LUA/Lisp2.lua
  LUA/Lisp3.lua
  LUA/Lisp4.lua
  LUA/Loeliger1.lua
  LUA/LogsPdfizados1.lua
  LUA/Lpeg1.lua
  LUA/Lpeg2.lua
  LUA/Lpeg3.lua
  LUA/Lpeg4.lua
  LUA/LpegDebugMode1.lua
  LUA/LpegRex1.lua
  LUA/LpegRex2.lua
  LUA/LpegRex3.lua
  LUA/LsQuadros1.lua
  LUA/LsQuadros1-cache.lua
  LUA/LuaBlocks.lua
  LUA/LuaTex1.lua
  LUA/MapAST1.lua
  LUA/MapAST2.lua
  LUA/Match1.lua
  LUA/Maxima1.lua
  LUA/Maxima2.lua
  LUA/MiniV1.lua
  LUA/Monkey1.lua
  LUA/MyRe1.lua
  LUA/Numerozinhos1.lua
  LUA/Parenthesize1.lua
  LUA/Parenthesize2.lua
  LUA/ParseTikz1.lua
  LUA/ParseTimeline1.lua
  LUA/ParseTree1.lua
  LUA/ParseTree2.lua
  LUA/Path.lua
  LUA/PathTo1.lua
  LUA/PCall1.lua
  LUA/PegDebug1.lua
  LUA/PercPush1.lua
  LUA/Pict2e1.lua
  LUA/Pict2e1-1.lua
  LUA/Pict2e2.lua
  LUA/Pict3.lua
  LUA/Pict3D1.lua
  LUA/PictShow1.lua
  LUA/Piecewise1.lua
  LUA/Piecewise2.lua
  LUA/Pis1.lua
  LUA/Prad1.lua
  LUA/PradPict2e1.lua
  LUA/PradTest1.lua
  LUA/Pratt1.lua
  LUA/PreTraceback1.lua
  LUA/PrecParser1.lua
  LUA/PrintFunction1.lua
  LUA/Prosody1.lua
  LUA/QPDFMerge.lua
  LUA/Quadros1.lua
  LUA/QVis1.lua
  LUA/RAng1.lua
  LUA/RAngFormulas1.lua
  LUA/Re.lua
  LUA/Re2.lua
  LUA/Re-infix.lua
  LUA/Rect.lua
  LUA/Repl1.lua
  LUA/Repl2.lua
  LUA/Repl3.lua
  LUA/Set.lua
  LUA/SetL.lua
  LUA/SexpAtEol1.lua
  LUA/SmallTalk1.lua
  LUA/Show1.lua
  LUA/Show2.lua
  LUA/Show2-outer.tex
  LUA/Socket1.lua
  LUA/SortedKeys1.lua
  LUA/Stack1.lua
  LUA/StrGrid1.lua
  LUA/Subst1.lua
  LUA/SubstInSteps1.lua
  LUA/Subtitles.lua
  LUA/Subtitles2.lua
  LUA/Surface1.lua
  LUA/SynTreeV1.lua
  LUA/TProps1.lua
  LUA/ThisDir1.lua
  LUA/Tikz2.lua
  LUA/TikzTrees1.lua
  LUA/ToTeX1.lua
  LUA/TocLines1.lua
  LUA/TocLines2.lua
  LUA/Tos.lua
  LUA/Tos2.lua
  LUA/Tos3.lua
  LUA/Tracinhos1.lua
  LUA/Tree1.lua
  LUA/Tudos1.lua
  LUA/UbExpr1.lua
  LUA/UbExpr2.lua
  LUA/Und1.lua
  LUA/Und2D1.lua
  LUA/Und2D2.lua
  LUA/Verbatim1.lua
  LUA/Verbatim2.lua
  LUA/Verbatim3.lua
  LUA/Verbatim4.lua
  LUA/VideoIndex.lua
  LUA/VisCapts1.lua
  LUA/Xpcall1.lua
  LUA/XPCall1.lua
  LUA/WithFakePrint1.lua

  LUA/tikz1.lua
  LUA/tikz1.el

  LUA/ZHA1.lua

  LUA/addoverrides1.lua
  LUA/anchors.lua
  LUA/apt-move.lua
  LUA/arithfbs.lua
  LUA/badchars-unibyte.lua
  LUA/begriff.lua
  LUA/bib.lua
  LUA/binops-re.lua
  LUA/boxchars.lua
  LUA/book-index.lua
  LUA/blogme.lua
  LUA/blogme2021.lua
  LUA/brackets.lua
  LUA/call7777.lua
  LUA/canvas.lua
  LUA/canvas2.lua
  LUA/canvas3.lua
  LUA/complex.lua
  LUA/composechars-u8.lua
  LUA/ctemplate.lua
  LUA/debtemplate.lua
  LUA/debs.lua
  LUA/debs2.lua
  LUA/dednat.lua
  LUA/defwithmanyargs.lua
  LUA/distributivity.lua
  LUA/djview-hack.lua
  LUA/eev-upload-files.lua
  LUA/elispwt.lua
  LUA/emacs-weekly-news.lua
  LUA/emaxima.lua
  LUA/eoo.lua
  LUA/exifdatetime.lua
  LUA/fbcomments.lua
  LUA/flsfiles.lua
  LUA/forall_0.lua
  LUA/horarios.lua
  LUA/inc.lua
  LUA/index.blogme
  LUA/integration.lua
  LUA/integrate-2015.lua
  LUA/interactive.lua
  LUA/latexdags.lua
  LUA/lh.lua
  LUA/loadlib/README.loadlib
  LUA/loadlib/lloadlib.c
  LUA/lowerdiag.lua
  LUA/lpeg-minitut.lua
  LUA/lstoindexhtml.lua
  LUA/lua50init.lua
    LUA/edrxlib.lua
  LUA/lua50beta-argpatch.sh
  LUA/lua50ref.r2
  LUA/luaforth.lua
  LUA/luarocks-extra.lua
  LUA/luatclbridge.c
  LUA/lvalue.lua
  LUA/math.blogme
  LUA/microlisp-2017.lua
  LUA/middle-c.lua
  LUA/miniforth2021.lua
  LUA/modal.lua
  LUA/mygetstack.c
  LUA/myxpcall.lua
  LUA/oldglyphs.lua
  LUA/parsechangelog.lua
  LUA/peek.lua
  LUA/picture.lua
  LUA/pil3_16.lua
  LUA/port7777.lua
  LUA/precedenceparser.lua
  LUA/preproc.lua
  LUA/puro-calendario.lua
  LUA/puro-calendario2.lua
  LUA/rectxpm.lua
  LUA/redirect.lua
  LUA/quickdiff.lua
  LUA/square-cube.lua
  LUA/syntrees.lua
  LUA/texcatcodes.lua
  LUA/texinfo.lua
  LUA/texpage.lua
  LUA/tictactoetree.lua
  LUA/timestamps.lua
  LUA/tinyftp.lua
  LUA/tinyftplib.lua
  LUA/tlbridge.c
  LUA/tmp.lua
  LUA/tos.lua
  LUA/tos2.lua
  LUA/tos3.lua
  LUA/tostring.lua
  LUA/truthtables.lua
  LUA/vector-demo.lua
  LUA/vectors.lua
  LUA/vectors.tcl
  LUA/vtable.lua
  LUA/youtube.lua
  LUA/youtube-tags.lua
  LUA/youtube-tags-2.lua
  LUA/youtube-db.lua
  LUA/zdags.lua
  LUATEX/video1.e
  LuaC/README
  LuaC/Makefile
  LuaC/lua-foo.c

  LuaTreeLean/.gitignore
  LuaTreeLean/LuaTree.lean
  LuaTreeLean/Makefile
  LuaTreeLean/README.org
  LuaTreeLean/Test1.lean
  LuaTreeLean/Test2.lean
  LuaTreeLean/Test3.lean
  LuaTreeLean/ToPrettier1.lean
  LuaTreeLean/lakefile.lean
  LuaTreeLean/luatree.lua

  MAKE/demo-1.gnumake
  MAKE/demo-2.gnumake
  MAKE/2023.1-MM-template
  MANIM/jovane1.py
  MARKDOWN/dednat6-baez.txt
  MARKDOWN/d.md
  MARKDOWN/test1.md
  MAXIMA/eepitch-maxima.el
  MAXIMA/findchanges1.mac
  MAXIMA/to-fermin-1.el
  MAXIMA/traverse.mac
  MAXIMA/matrixify.mac
  MAXIMA/luatree.lua
  MAXIMA/luatree.lisp
  MAXIMA/luatree.mac
  MAXIMA/step_by_step.mac
  MAXIMA/laurent1.mac
  MAXIMA/laurent2.mac
  MAXIMA/mysubst.mac
  MAXIMA/pn1.mac
  MAXIMA/crossproduct1.mac
  MAXIMA/3-changevars1.mac
  MAXIMA/barematrix1.mac
  MAXIMA/barematrix1.lisp
  MAXIMA/eigshow1.mac
  MAXIMA/mac1.mac
  MAXIMA/LI_split1.mac
  MAXIMA/LI_Axb1.mac
  MAXIMA/gabmv1.mac
  MP/test1.mp
  MTA/Makefile
  MTA/pio_fontx.c
  MTA/vtutil
  MTA/vtutilsh.c
  MINICATS/README
  OMNISYS/TODO
  OCAML/firsthour.ml
  OCAML/calc0.ml
  OCAML/PipeTest1.ml
  PHP/ip.php
  PIC/1.pic
  PLURALL/linuxrc
  PLURALL/linuxrc2
  PLURALL/menu.lst
  PLURALL/hddimg
  PLURALL/asciidump.c
  PLURALL/plurall-inst
  PURO/2009-edital-mat-disc.tex
  PS/psbluebookops.txt
  PYTHON/onepagepdftopng.py
  PYTHON/testpypi1.py
  PYTHON/flatten_iterable.py
  RACKET/test1.rkt
  README
  REXX/pig.rexx
  REXX/sc.rexx
  SCHEME/square-cube.rkt
  SQUEAK/README
  SRF/srfx.lua
  SRF/srfx-interpreter.lua
  SRF/srfx-basics.lua
  SRF/srfx.el
  SRF/test1.srf
  SRF/test2.srf
  SRF/srfa.lua
  SRF/srfb.lua
  SRF/srfc.lua
  edrx1
  SCANS/Makefile
  SCANS/univ_form_cid/chaui.txt
  SDL/1.c
  SDL/2.c
  SDL/cga-tron.c
  WHISPER/test1.py

  SUBTITLES/2020-list-packages-eev-nav.lua
  SUBTITLES/2020-some-template-based.lua
  SUBTITLES/2020-find-here-links.lua
  SUBTITLES/2021-oficina-1.lua
  SUBTITLES/2021-org-for-non-users.lua
  SUBTITLES/2021-workshop-1.lua
  SUBTITLES/2021-workshop-2.lua
  SUBTITLES/2021-workshop-3.lua
  SUBTITLES/2021-workshop-4.lua
  SUBTITLES/2021-workshop-5.lua
  SUBTITLES/2021-workshop-6.lua
  SUBTITLES/2022-eev-make-0.lua
  SUBTITLES/2022-eev-tikz.lua
  SUBTITLES/2022-eev-wconfig.lua
  SUBTITLES/2022-find-eev-angg.lua
  SUBTITLES/2022-find-elisp-intro.lua
  SUBTITLES/2022-pict2e-lua.lua
  SUBTITLES/2022-yttranscript.lua
  SUBTITLES/emacsconf2019.lua
  SUBTITLES/emacsconf2020.lua
  SUBTITLES/emacsconf2021-dednat6.lua
  SUBTITLES/emacsconf2021.lua
  SUBTITLES/emacsconf2022-kla.lua
  SUBTITLES/emacsconf2022-py.lua
  SUBTITLES/emacsconf2023-repls.lua
  SUBTITLES/emacsconf2023-repls-b.lua
  SUBTITLES/2021-ffll.lua
  SUBTITLES/2024-eev-git.lua
  SUBTITLES/2024-find-luaso-links.lua

  SUBTITLES/2023-caepro0.lua
  SUBTITLES/2023-caepro-VR.lua
  SUBTITLES/2023-caepro-o-que-sobra.lua
  SUBTITLES/2021-1-C2-somas-1-dicas.lua
  SUBTITLES/2021aulas-por-telegram.lua
  SUBTITLES/mathologer-calculus-easy.lua
  SUBTITLES/2021-1-C3-curvas-de-nivel.lua
  SUBTITLES/2021-1-C3-curvas-de-nivel-2.lua
  SUBTITLES/2021-2-c3-cabos-na-diagonal.lua
  SUBTITLES/2023mar07_didatica_ensaio.lua
  SUBTITLES/2023-visual-vs-auditivo.lua
  SUBTITLES/2023-precisamos-de-mais-slogans.lua

  SWIG/demo_luaClua.c
  TCL/attachgdb
  TCL/drag2022.tcl
  TCL/dragTs.tcl
  TCL/geometry.tcl
  TCL/inc.tcl
  TCL/list-edit.tcl
  TCL/lstoindexhtml
  TCL/piano.tcl
  TCL/placer.tcl
  TCL/resizer.tcl
  TCL/scrollingcanvas.tcl
  TCL/tclmagick-patch.sh
  TEXINFO/eev-2005.texi
  TEXINFO/eev-2006.texi
  TEXINFO/eev.texi.lua
  TEXINFO/eev.texi
  TEXINFO/shortsample.texi
  TIKZ/test1.tex
  VIDEOS/Makefile
  dednat/README
  dednat/Makefile
  dednat/inc.lua
  dednat/dednat.lua
  dednat/dednat2.lua
  dednat/dednat3.lua
  dednat/diagxy.lua
  dednat/experimental.lua
  dednat/example.tex

  blogme/README
  blogme/blogme.lua
  blogme/edrxlib.lua
  blogme/index.blogme
  blogme/css.lua
  blogme/withdef.lua
  blogme/INTERNALS
  blogme/blogme2.lua
  blogme/blogme2-inner.lua
  blogme/blogme2-middle.lua
  blogme/blogme2-outer.lua
  blogme/blogme2-extras.lua
  blogme/blogme2-cgi.lua

  blogme3/.files.sh
  blogme3/Makefile
  blogme3/edrxlib.lua
  blogme3/blogme3.txt
  blogme3/blogme3.el
  blogme3/miniforth3.abs.txt
  blogme3/miniforth3.lua
  blogme3/anggdefs.lua
  blogme3/anggmake.lua
  blogme3/angglisp.lua
  blogme3/rumilisp.lua
  blogme3/rumimake.lua
  blogme3/brackets.lua
  blogme3/charset.lua
  blogme3/definers.lua
  blogme3/defs-2022.lua
  blogme3/escripts.lua
  blogme3/elisp.lua
  blogme3/makefile.lua
  blogme3/options.lua
  blogme3/blogme3.lua
  blogme3/notes.e.lua
  blogme3/lstoindexhtml.lua
  blogme3/eevintros.lua
  blogme3/detect-encoding.lua
  blogme3/htmlize-utf8.lua
  blogme3/videoindex.lua

  blogme3/cruft-jan2024.lua

  blogme3/sexpskeleton.c
  blogme3/local-videos.js
  blogme3/local-videos-mini.js
  blogme3/local-videos.blogme
  blogme3/localvideos.lua
  blogme3/youtube.lua
  blogme3/html5-audio.js
  blogme3/html5-audio-mini.js
  blogme3/facebook.lua
  blogme3/sexp.lua
  blogme3/sexpdefs.lua
  blogme3/sandwiches.lua
  blogme3/sandwiches-defs.lua
  blogme3/sandwiches-all.lua
  blogme3/sandwiches-videos.lua
  blogme3/maxima.lua
  blogme3/maxima-index-html.lua
  blogme3/maxima-index-html.lisp

  blogme3/blogme4.lua

  local-videos.js

  blogme4/common.lua
  blogme4/eoo.lua
  blogme4/def.lua
  blogme4/eval.lua
  blogme4/brackets.lua
  blogme4/anggdefs.lua
  blogme4/demo.lua
  blogme4/demo_i.blogme
  blogme4/etc.lua
  blogme4/README
  blogme4/Makefile
  blogme4/build.lua
  blogme4/blogme4.lua
  blogme4/elisp.lua
  blogme4/elisp2.lua
  blogme4/angglisp.lua
  blogme4/options.lua

  blogme4/blogme4-repl

  blogme4/texinfo.lua
  blogme4/doc/blogme4.b4texi
  blogme4/doc/eev.b4texi

  duoforths/forth.lua
  peek/peek.c
  peek/peek-0.0.1-0.rockspec
  peek/ctypes.lua
  peek/ctypes2.lua
  peek/Makefile

  rcirc/README

  RETRO/README
  RETRO/VERSION
  RETRO/Makefile
  RETRO/libretro.c
  RETRO/luaretro.c
  RETRO/test.lua
  RETRO/retro-0.0.1-0.rockspec

  snake.txt

  books/__alg/__alg.el
  books/__analysis/__analysis.el
  books/__cats/__cats.el
  books/__chomsky/__chomsky.el
  books/__comp/__comp.el
  books/__discrete/__discrete.el
  books/__etc/__etc.el
  books/__frege/__frege.el
  books/__gaiman/__gaiman.el
  books/__gardner/__gardner.el
  books/__gender/__gender.el
  books/__habermas/__habermas.el
  books/__logic/__logic.el
  books/__modal/__modal.el
  books/__music/__music.el
  books/__peirce/__peirce.el
  books/__phil/__phil.el
  books/__physics/__physics.el
  books/__anime/__anime.el
  books/__piaget/__piaget.el
  books/__pichacoes/__pichacoes.el
  books/__politics/__politics.el
  books/__small/__small.el
  books/__shibari/__shibari.el
  books/__tantra/__tantra.el

  dednat4/.files.sh
  dednat4/Makefile
  dednat4/Makefile.base
  dednat4/VERSION
  dednat4/TODO
  dednat4/README
  dednat4/README.ee
  dednat4/README.interact
  dednat4/README.phantoms
  dednat4/README.windows
  dednat4/dednat4.lua
  dednat4/dednat40.lua
  dednat4/edrxlib.lua
  dednat4/experimental.lua
  dednat4/dednames.lua
  dednat4/dednat4.el

  dednat4/dednat5.lua
  dednat4/dednat5-shadow.lua
  dednat4/newtrees.lua

  dednat4/downloads/Makefile
  dednat4/examples/README
  dednat4/examples/Makefile
  dednat4/examples/demodefs.tex
  dednat4/examples/eqfibs.metatex
  dednat4/examples/edrxarrows.tex
  dednat4/examples/edrxdednat.tex
  dednat4/examples/edrxdefs.tex
  dednat4/examples/edrxdnt.tex
  dednat4/examples/edrxglyphs.tex
  dednat4/examples/edrxheadfoot.tex
  dednat4/examples/edrxmain.tex
  dednat4/examples/edrxmain41.tex
  dednat4/examples/edrxmain41a.tex
  dednat4/examples/edrx08.sty
  dednat4/examples/eedemo1.tex
  dednat4/examples/eedemo2.tex

  dednat4/examples/demo1.dnt
  dednat4/examples/demo2.dnt

  dednat4/examples/edrxdiagflags.tex
  dednat4/examples/edrxslides.tex

  dednat4/debian/control
  dednat4/debian/rules

  dednat5/Makefile
  dednat5/README
  dednat5/build.lua
  dednat5/common.lua
  dednat5/eoo.lua
  dednat5/errors.lua
  dednat5/parse.lua
  dednat5/prefixes.lua
  dednat5/preamble.lua
  dednat5/process.lua
  dednat5/options.lua
  dednat5/treesegs.lua
  dednat5/treetex.lua
  dednat5/treehead.lua
  dednat5/diagstacks.lua
  dednat5/diagtex.lua
  dednat5/diagforth.lua
  dednat5/diagmiddle.lua
  dednat5/diagbox.lua
  dednat5/tests/Makefile
  dednat5/tests/test1.tex
  dednat5/tests/test1.dnt
  dednat5/tests/test2.tex
  dednat5/tests/test2.dnt
  dednat5/tests/test2.mp
  dednat5/tests/test3.tex
  dednat5/tests/test3.dnt
  dednat5/tests/testbegr.tex
  dednat5/tests/testbegr.dnt
  dednat5/tests/testpgf.tex
  dednat5/tests/testpgf.lua
  dednat5/tests/testpgf.dnt
  dednat5/dednat-eev.el
  dednat5/begriff.lua
  dednat5/zdags.lua
  dednat5/repl-old.lua
  dednat5/repl.lua
  dednat5/tos.lua

  dednat5/dednat5.lua

  dednat5/gabriela.lua
  dednat5/gabriela-app.lua
  dednat5/gab.lua
  dednat5/gab-tests.lua
  dednat5/gab-oldparser.lua
  dednat5/gab-lpeg.lua

  dednat5/dednat6.lua
  dednat5/options6.lua
  dednat5/preamble6.lua
  dednat5/heads6.lua
  dednat5/picture.lua
  dednat5/zrect.lua
  dednat5/wrap.lua
  dednat5/zha.lua
  dednat5/texfile.lua
  dednat5/lualoader.lua
  dednat5/binloader.lua
  dednat5/newrect.lua
  dednat5/rect.lua
  dednat5/stacks.lua

  LATEX/dednat6load.lua
  LATEX/dednat6/abbrevs.lua
  LATEX/dednat6/bbox.lua
  LATEX/dednat6/binloader.lua
  LATEX/dednat6/block.lua
  LATEX/dednat6/dednat6.lua
  LATEX/dednat6/diagforth.lua
  LATEX/dednat6/diagmiddle.lua
  LATEX/dednat6/diagstacks.lua
  LATEX/dednat6/diagtex.lua
  LATEX/dednat6/diagtikz.lua
  LATEX/dednat6/eoo.lua
  LATEX/dednat6/edrxlib.lua
  LATEX/dednat6/errors.lua
  LATEX/dednat6/heads6.lua
  LATEX/dednat6/lualoader.lua
  LATEX/dednat6/luarects.lua
  LATEX/dednat6/options6.lua
  LATEX/dednat6/output.lua
  LATEX/dednat6/parse.lua
  LATEX/dednat6/picture.lua
  LATEX/dednat6/preamble6.lua
  LATEX/dednat6/rect.lua
  LATEX/dednat6/stacks.lua
  LATEX/dednat6/tcgs.lua
  LATEX/dednat6/texfile.lua
  LATEX/dednat6/treesegs.lua
  LATEX/dednat6/treetex.lua
  LATEX/dednat6/underbrace.lua
  LATEX/dednat6/underbrace2d.lua
  LATEX/dednat6/zhas.lua
  LATEX/dednat6/zhaspecs.lua
  LATEX/dednat6/zquotients.lua

  LATEX/dednat6/lua-repl/repl/sync.lua
  LATEX/dednat6/lua-repl/repl/compat.lua
  LATEX/dednat6/lua-repl/repl/init.lua
  LATEX/dednat6/lua-repl/repl/utils.lua
  LATEX/dednat6/lua-repl/rep.lua
  LATEX/dednat6/luarepl.lua



  dednat6/VERSION
  dednat6/README.md
  dednat6/Makefile
  dednat6/ChangeLog
  dednat6/dednat6.el

  dednat6/dednat6load.lua
  dednat6/dednat6/dednat6.lua
  dednat6/dednat6/lualoader.lua
  dednat6/dednat6/binloader.lua
  dednat6/dednat6/edrxlib.lua

  dednat6/dednat6/abbrevs.lua
  dednat6/dednat6/block.lua
  dednat6/dednat6/diagforth.lua
  dednat6/dednat6/diagmiddle.lua
  dednat6/dednat6/diagstacks.lua
  dednat6/dednat6/diagtex.lua
  dednat6/dednat6/diagtikz.lua
  dednat6/dednat6/eoo.lua
  dednat6/dednat6/errors.lua
  dednat6/dednat6/heads6.lua
  dednat6/dednat6/luarects.lua
  dednat6/dednat6/options6.lua
  dednat6/dednat6/output.lua
  dednat6/dednat6/parse.lua
  dednat6/dednat6/preamble6.lua
  dednat6/dednat6/rect.lua
  dednat6/dednat6/stacks.lua
  dednat6/dednat6/texfile.lua
  dednat6/dednat6/treesegs.lua
  dednat6/dednat6/treetex.lua

  dednat6/dednat6/minimalcore.lua

  dednat6/dednat6/picture.lua
  dednat6/dednat6/tcgs.lua
  dednat6/dednat6/underbrace.lua
  dednat6/dednat6/zhas.lua
  dednat6/dednat6/zhaspecs.lua

  dednat6/dednat6/underbrace2d.lua
  dednat6/dednat6/zquotients.lua

  dednat6/dednat6/luarepl.lua
  dednat6/dednat6/lua-repl/repl/compat.lua
  dednat6/dednat6/lua-repl/repl/init.lua
  dednat6/dednat6/lua-repl/repl/sync.lua
  dednat6/dednat6/lua-repl/repl/utils.lua

  dednat6/tugboat-rev2.tex
  dednat6/demo-minimal.tex
  dednat6/demo-core.tex
  dednat6/demo-preproc.tex
  dednat6/demo-repl.tex
  dednat6/demo-tikz.tex
  dednat6/demo-underbrace.tex
  dednat6/demo-write-dnt.tex
  dednat6/demo-write-single.tex
  dednat6/extra-comparisons.tex
  dednat6/extra-features.tex
  dednat6/extra-modules.tex
  dednat6/extra-modules.txt

  dednat6/2018dednat6-extras.tex

  dednat6/tug-slides.tex
  dednat6/myverbatim.lua

  dednat6/demo-minimal-abilio.tex


  dednat6-old/abbrevs.lua
  dednat6-old/binloader.lua
  dednat6-old/common.lua
  dednat6-old/dednat6.lua
  dednat6-old/diagforth.lua
  dednat6-old/diagmiddle.lua
  dednat6-old/diagstacks.lua
  dednat6-old/diagtex.lua
  dednat6-old/eoo.lua
  dednat6-old/errors.lua
  dednat6-old/heads6.lua
  dednat6-old/lualoader.lua
  dednat6-old/luarects.lua
  dednat6-old/newrect.lua
  dednat6-old/options6.lua
  dednat6-old/output.lua
  dednat6-old/parse.lua
  dednat6-old/picture.lua
  dednat6-old/preamble6.lua
  dednat6-old/prefixes.lua
  dednat6-old/process.lua
  dednat6-old/rect.lua
  dednat6-old/stacks.lua
  dednat6-old/texfile.lua
  dednat6-old/treehead.lua
  dednat6-old/treesegs.lua
  dednat6-old/treetex.lua
  dednat6-old/underbrace.lua
  dednat6-old/wrap.lua
  dednat6-old/zha.lua
  dednat6-old/zhas.lua
  dednat6-old/zhaspecs.lua
  dednat6-old/zquotients.lua
  dednat6-old/zrect.lua
  dednat6-old/tests/README
  dednat6-old/tests/0.tex
  dednat6-old/tests/2.tex
  dednat6-old/tests/3.tex
  dednat6-old/tests/4.tex
  dednat6-old/tests/diagxy.tex
  dednat6-old/tests/proof.sty

  dednat6-old/ex/Rect-tests
  dednat6-old/ex/abbrevs
  dednat6-old/ex/asciipicture
  dednat6-old/ex/copyopts
  dednat6-old/ex/diagtex-0
  dednat6-old/ex/diagtex-1
  dednat6-old/ex/eoo
  dednat6-old/ex/lpicture
  dednat6-old/ex/luawithrects-1
  dednat6-old/ex/luawithrects-2
  dednat6-old/ex/luawithrects-3
  dednat6-old/ex/mixedpic-1
  dednat6-old/ex/mixedpic-2
  dednat6-old/ex/mixedpic-3
  dednat6-old/ex/mixedpic-J-1
  dednat6-old/ex/mixedpic-cubes
  dednat6-old/ex/mixedpic-threefour
  dednat6-old/ex/mixedpic-zsets-1
  dednat6-old/ex/parse
  dednat6-old/ex/rect-0
  dednat6-old/ex/rect-ded
  dednat6-old/ex/rect-synt
  dednat6-old/ex/stacks
  dednat6-old/ex/treetex-1
  dednat6-old/ex/treetex-2
  dednat6-old/ex/ubs-1
  dednat6-old/ex/ubs-2
  dednat6-old/ex/ubs-def
  dednat6-old/ex/v-1
  dednat6-old/ex/v-2
  dednat6-old/ex/v-3
  dednat6-old/ex/zha-connectives
  dednat6-old/ex/zha-fromspec
  dednat6-old/ex/zha-generators
  dednat6-old/ex/zha-shortoperators
  dednat6-old/ex/zha-tostring
  dednat6-old/ex/zha-walls
  dednat6-old/ex/zhafrompoints

  edrxrepl/edrxpcall.lua
  edrxrepl/edrxrepl.lua
  edrxrepl/edrxrepltest.tex
  edrxrepl/README.org

  eev-wconfig/README-wconfig.el
  eev-wconfig/README-rainer-koenig-playlist

  fbcache/README
  fbcache/all-fb-urls.lst
  fbcache/fbcache.lua
  fbcache/fbcache2.lua

  fbcache/fbcache3.lua
  fbcache/fbcurl.lua
  fbcache/fbjson.lua
  fbcache/fbkinds.lua
  fbcache/fbmemget.lua
  fbcache/fbnameid.lua
  fbcache/fbpp.lua
  fbcache/fbtext.lua
  fbcache/fbtoken.lua
  fbcache/nameids

  fbcache/urls-by-kind.txt
  fbcache/fburls_bad.lst
  fbcache/fburls_good.lst
  fbcache/fburls_noid.lst

  fbcache/urls.lua
  fbcache/p.py
  fbcache/q.py
  fbcache/testids.py

  faceutils/README

  gab/README
  gab/gabriela.lua
  gab/gabriela-app.lua
  gab/gab.lua
  gab/gab-tests.lua
  gab/gab-oldparser.lua
  gab/gab-lpeg.lua

  gabp/README
  gabp/gab.lua
  gabp/gab-tests.lua

  grub/mygrub.cfg
  grub/GRUBNOTES

  dnc/NOTES
  dnc/ee-goto.el

  doria/README
  dynkin/Makefile
  dynkin/README
  dynkin/dyd-defs.tex
  dynkin/dyd-ex.tex
  dynkin/dynkin.tcl

  elisp/README
  elisp/2022-test-use-package.el
  elisp/2022-find-elisp-intro.el
  elisp/advogados.el
  elisp/captions.el
  elisp/cheap-face.el
  elisp/cl-glyphs.el
  elisp/derawify.el
  elisp/doom-test-0.el
  elisp/echo-server.el
  elisp/ee-keymaps.el
  elisp/eeimage.el
  elisp/eepitch-vterm.el
  elisp/eeqtree.el
  elisp/elinks.el
  elisp/elinks0.el
  elisp/eepitch-pl-tools.el
  elisp/eev-eat.el
  elisp/eev-eeb.el
  elisp/eev-inspect.el
  elisp/eev-peg.el
  elisp/eev-rcd-tap-1.el
  elisp/eev-telega.el
  elisp/eev-vagner.el
  elisp/eev-wconfig-video.el
  elisp/emacs-wiki-edrx.el
  elisp/emacsconf2021.el
  elisp/find-ealias.el
  elisp/find-erainbowgrid.el
  elisp/find-lgrep-links.el
  elisp/find-luatb.el
  elisp/find-man.el
  elisp/find-advicebefore-links.el
  elisp/find-subs-links.el
  elisp/find-wget-jan-2024.el
  elisp/frames.el
  elisp/geometria.el
  elisp/graficos.el
  elisp/glyph-bug.el
  elisp/help-ipa.el
  elisp/hisex.el
  elisp/klapt.el
  elisp/lively.el
  elisp/lua-mode-0.el
  elisp/math-glyphs.el
  elisp/menu.el
  elisp/menu0.el
  elisp/myxpm.el
  elisp/my-engrave-faces.el
  elisp/plot.tcl
  elisp/query-replace-list-1.el
  elisp/rcd-paps.el
  elisp/rpn-geom.el
  elisp/rpn.el
  elisp/staff-mode.el
  elisp/stareval.el
  elisp/test.el
  elisp/tprops.el
  elisp/ttp-1.el
  elisp/ttp-2.el
  elisp/ttp-qref.el
  elisp/ttp.el
  elisp/w3m-e22.el
  elisp/several-templated-functions-2020.el
  elisp/find-here-links-2020.el
  elisp/video-links-2021.el
  elisp/projeto-de-ensino-2021.el
  elisp/url-retrieve-test.el
  elisp/waveform.el
  elisp/yaca.el
  elisp/pcase-tests.el

  emacs-lua/README.org
  emacs-lua/EdrxPcall.lua
  emacs-lua/EdrxRepl.lua
  emacs-lua/emlua.cpp
  emacs-lua/emlua.el
  emacs-lua/tests.e

  emlua/README.org
  emlua/Makefile
  emlua/emlua.cpp
  emlua/emlua-data.el
  emlua/emlua-init.el
  emlua/emlua-repl.el
  emlua/emlua-buttons.el
  emlua/edrxlib.lua
  emlua/Repl1.lua
  emlua/.gitignore

  flua/Makefile
  flua/README
  flua/demo1.flua
  flua/demo2.flua
  flua/demo3.flua
  flua/demo4.flua
  flua/demo6-lib
  flua/demo6.flua
  flua/demo7-lib
  flua/demo7.flua
  flua/flua-comp.lua
  flua/flua-prims.lua
  flua/flua.lua
  flua/inc.lua
  flua/skel.bytecode.asm
  flua/skel.engine.c

  genericfigures/README

  manifs/README
  linkdasruas.txt
  linkdasruas.lst
  linkdasruas2.txt
  linkdasruas2.lst
  linkdasruas3.org

  live-build/install0
  live-build/install1

  logs-pdfizados/README

  lua-4.0/README.other
  lua-4.0/src/libdllua/lrexlib-new.c
  luatex/luamplibtest.tex
  luatree/README.org
  luatree/luatree.lua
  luatree/luatree.lisp
  luatree/luatree.mac
  luatree/luatree.py
  miniforth/TECHREP
  miniforth/cube1.mflua
  miniforth/miniforth1.lua
  miniforth/miniforth2.lua
  miniforth/miniforth3.abs.txt
  miniforth/miniforth3.lua
  miniforth/miniforth4.lua
  miniforth/miniforth5.lua
  miniforth/miniforth5.out
  miniforth/miniforth6.lua
  miniforth/macro1.lua
  miniforth/macro2.lua
  miniforth/test1.mflua
  miniforth/test2.mflua
  miniforth/yoneda.mflua
  miniforth/mylua
  miniforth/lcode.e
  miniforth/crim/Makefile
  miniforth/crim/NOTES
  miniforth/crim/crim.lua
  miniforth/crim/crimextras.lua
  miniforth/crim/crimlabels.lua
  miniforth/crim/demo1.mflua
  miniforth/crim/demo2.mflua
  miniforth/crim/demo3.mflua
  miniforth/crim/demo4.mflua
  miniforth/crim/skel.bytecode.asm
  miniforth/crim/skel.engine.c

  packages-el/archive-contents

  pict2e-lua/README.org

  quadradinho/README
  quadradinho/quadradinho-a5.tex
  quadradinho/quadradinho-texto.tex
  quadradinho/quadradinho-print.tex
  quadradinho/Makefile
  quadradinho/quadradinho-2020.tex
  quadradinho/quadradinho-2020-booklet.tex
  quadradinho/quadradinho-texto-u8.tex

  rubyforth/README.too

  rubyforth/GLOSSARY
  rubyforth/LICENSE
  rubyforth/README
  rubyforth/USAGE
  rubyforth/demos/hello.rb
  rubyforth/demos/tests.fs
  rubyforth/file.rb
  rubyforth/forth.rb
  rubyforth/high-level.fs
  rubyforth/inspector.rb
  rubyforth/install.sh
  rubyforth/kernel.rb
  rubyforth/primitives.rb
  rubyforth/rubyforth
  rubyforth/stack.rb
  rubyforth/tools/case.fs
  rubyforth/tools/deblock.fs
  rubyforth/tools/forget.rb
  rubyforth/tools/inline.fs
  rubyforth/tools/ip.fs
  rubyforth/tools/laforth.fs
  rubyforth/tools/postpone.fs
  rubyforth/tools/relocatable.fs
  rubyforth/tools/repl.fs
  rubyforth/tools/system.fs
  rubyforth/tools/whereis.fs
  rubyforth/vocabulary.rb

  sheavesforchildren/Makefile
  sheavesforchildren/latex.lua
  sheavesforchildren/modal.c
  sheavesforchildren/rect.lua
  sheavesforchildren/zdags.lua
  sheavesforchildren/zhas.lua
  sheavesforchildren/zhas.tex
  sheavesforchildren/sfc-0.0.1-0.rockspec

  vtutil/README
  vtutil/Makefile
  vtutil/pio_fontx.c
  vtutil/inc.lua
  vtutil/vtutil.lua
  vtutil/mathchars.lua
  vtutil/makefonts_8.lua
  vtutil/vtscreenshot

  vtutil4/Makefile
  vtutil4/Makefile-old
  vtutil4/README
  vtutil4/inc.lua
  vtutil4/lbitlib.c
  vtutil4/mathchars.lua
  vtutil4/piofontx.c
  vtutil4/piofontx51.c
  vtutil4/regex-lua-etags
  vtutil4/vtfontlib.lua
  vtutil4/vtutil.lua
  vtutil4/vtutil51.lua

  eev-old/.files
  eev-old/Makefile
  eev-old/INSTALL
  eev-old/README
  eev-old/README.pt
  eev-old/TODO
  eev-old/debian/README.debian
  eev-old/debian/50eev.el
  eev-old/debian/packages
  eev-old/demo/.bashrc
  eev-old/demo/.emacs
  eev-old/demo/.gdbinit
  eev-old/demo/.profile
  eev-old/demo/.zshrc
  eev-old/demo/dlopen.e
  eev-old/demo/dlopen.eeg4
  eev-old/demo/emacs0.eeg4
  eev-old/e/debian-chroot.e
  eev-old/e/debian-pkg.e
  eev-old/e/debian.e
  eev-old/e/debootstrap.e
  eev-old/e/keys.e
  eev-old/e/links.e
  eev-old/e/tutorial.e
  eev-old/e/tutorial.pt.e
  eev-old/eeg
  eev-old/eeg4

  eev-old/eev.el
  eev-old/eev-vars.el
  eev-old/eev-misc.el
  eev-old/eev-links.el
  eev-old/eev-mklinks.el
  eev-old/eev-save.el
  eev-old/eev-hybrids.el
  eev-old/eev-menu-bar.el

  eev-old/eev-gud.el
  eev-old/glyphs.el
  eev-old/libeeg/k
  eev-old/libeeg/msg
  eev-old/libeeg/term
  eev-old/libeeg/glue
  eev-old/libeeg/fast
  eev-old/libeeg/all
  eev-old/libeeg/term-linux.auto.tcl
  eev-old/libeeg/term-xterm.auto.tcl
  eev-old/libeeg/term-screen.auto.tcl
  eev-old/texts/brave-gnu-world-13.txt
  eev-old/texts/eev-manifesto.txt
  eev-old/texts/informal.txt
  eev-old/texts/tourism.txt
  eev-old/texts/why-users.txt
  eev-old/changer.awk
  eev-old/changer.sh
  eev-old/rcfiles/.bashrc
  eev-old/rcfiles/.cshrc
  eev-old/rcfiles/.zshrc
  eev-old/rcfiles/.gdbinit
  eev-old/rcfiles/.emacs

  debian/README

  eev-current/.favicon.el
  eev-current/.files
  eev-current/.files-html
  eev-current/.files-0.95.2
  eev-current/BUGS
  eev-current/CHANGELOG
  eev-current/COPYING
  eev-current/DEDICATION
  eev-current/DEDICATION.c-r
  eev-current/INSTALL
  eev-current/INSTALL-0.95.0
  eev-current/Makefile
  eev-current/README-0.95.0
  eev-current/README-0.95.1
  eev-current/README-0.95.2
  eev-current/README
  eev-current/THANKS
  eev-current/TODO
  eev-current/VERSION

  eev-current/find-eev-update-links

  eev-current/anim/.favicon.el
  eev-current/anim/README
  eev-current/article/.favicon.el
  eev-current/article/Makefile
  eev-current/article/README
  eev-current/article/eev.tex
  eev-current/article/eev.txt
  eev-current/doc/EEVMANIFESTO
  eev-current/doc/HISTORY
  eev-current/doc/NAO_pt
  eev-current/doc/README
  eev-current/doc/README-0.93
  eev-current/doc/TOURISM
  eev-current/doc/eev.info
  eev-current/doc/eev.texi
  eev-current/doc/keys.e
  eev-current/doc/tutorial.e
  eev-current/examples/.favicon.el
  eev-current/examples/README
  eev-current/examples/anim.e
  eev-current/examples/awk.e
  eev-current/examples/busybox.e
  eev-current/examples/c.e
  eev-current/examples/debian.e
  eev-current/examples/demos.e
  eev-current/examples/debs2.lua
  eev-current/examples/eev-tests.e
  eev-current/examples/emacs.e
  eev-current/examples/gtk.e
  eev-current/examples/iskidip.e
  eev-current/examples/iskidip2.e
  eev-current/examples/lua.e
  eev-current/examples/make.e
  eev-current/examples/mgp.e
  eev-current/examples/perl.e
  eev-current/examples/php.e
  eev-current/examples/ps.e
  eev-current/examples/python.e
  eev-current/examples/qemu.e
  eev-current/examples/ruby.e
  eev-current/examples/screenshots.e
  eev-current/examples/sh.e
  eev-current/examples/svn.e
  eev-current/examples/tcltk.e
  eev-current/examples/tex.e
  eev-current/examples/escript-mode.el
  eev-current/examples/infoindex.rb
  eev-current/rcfiles/README
  eev-current/rcfiles/tmp/README
  eev-current/rcfiles/.bashrc
  eev-current/rcfiles/.bashrc-psne
  eev-current/rcfiles/.fvwmrc
  eev-current/rcfiles/.pythonrc.py
  eev-current/rcfiles/.tclshrc
  eev-current/rcfiles/.vimrc
  eev-current/rcfiles/.zshrc
  eev-current/rcfiles/.zshrc-psne
  eev-current/rcfiles/channel.py
  eev-current/rcfiles/channel.tcl
  eev-current/tmp/README
  eev-current/tmp/tmp-pst.tex
  eev-current/tmp/tmp.c
  eev-current/tmp/tmp.mp
  eev-current/tmp/tmp.tex

  eev-current/eejump.el

  eev-current/debian/emacs-eev
  eev-current/debian/control.sh
  eev-current/debian/90eev.el
  eev-current/debian/Makefile
  eev-current/debian/rules
  eev-current/debian/README.Debian
  eev-current/debian/eev.xpm
  eev-current/debian/eev_16.xpm
  eev-current/debian/eev.menu
  eev-current/debian/eev.desktop

  eev-current/slides/dec2006-pt.txt

  eev-current/eepitch.readme

  eev-current/eev-blinks.el
  eev-current/eev-plinks.el
  eev-current/eev-elinks.el
  eev-current/eev-tlinks.el
  eev-current/eev-hlinks.el
  eev-current/eev-htests.el
  eev-current/eev-anchors.el
  eev-current/eev-audiovideo.el
  eev-current/eev-brxxx.el
  eev-current/eev-channels.el
  eev-current/eev-codings.el
  eev-current/eev-edit.el
  eev-current/eev-env.el
  eev-current/eev-eval.el
  eev-current/eev-explain.el
  eev-current/eev-flash.el
  eev-current/eev-helpful.el
  eev-current/eev-hydras.el
  eev-current/eev-kla.el
  eev-current/eev-kl-here.el
  eev-current/eev-lean4.el
  eev-current/eev-mode.el
  eev-current/eev-on-windows.el
  eev-current/eev-pdflike-old.el
  eev-current/eev-pdflike.el
  eev-current/eev-pkg.el
  eev-current/eev-prepared.el
  eev-current/eev-qrl.el
  eev-current/eev-rcirc.el
  eev-current/eev-rstdoc.el
  eev-current/eev-strange-functions.el
  eev-current/eev-aliases.el
  eev-current/eev-template0.el
  eev-current/eev-wrap.el
  eev-current/eev-testblocks.el
  eev-current/eev-videolinks.el
  eev-current/eev-tla.el
  eev-current/eev-wconfig.el
  eev-current/eev-load.el
  eev-current/eev-beginner.el
  eev-current/eev.el
  eev-current/eev2-all.el
  eev-current/.dir-locals.el
  eev-current/.gitignore
  eev-current/README-old.md
  eev-current/README.org

  eev-intros/README

  eev-videos/0.sh
  eev-videos/1.sh
  eev-videos/2.sh
  eev-videos/2.el
  eev-videos/README
  eev-videos/4-bare.el
  eev-videos/4-eepitch
  eev-videos/4a-script
  eev-videos/4b-explan-1
  eev-videos/4c-explan-2
  eev-videos/4d-explan-3
  eev-videos/4e-explan-4
  eev-videos/video-eev-quick-0.sh
  eev-intro/README

  eev-puro/.emacs
  eev-puro/90eev-puro.el
  eev-puro/HELP
  eev-puro/Makefile
  eev-puro/debian/Makefile
  eev-puro/debian/README.Debian
  eev-puro/debian/control
  eev-puro/debian/rules
  eev-puro/menu/emacs-puro
  eev-puro/menu/emacs-puro.desktop
  eev-puro/mini-lua-intro.e
  eev-puro/notas.txt

  eev-lua-extras/debian/rules
  eev-lua-extras/debian/control
  eev-lua-extras/Makefile
  eev-lua-extras/90eev-lua-extras.el

  eev-deb-old/debian/control
  eev-deb-old/debian/rules
  eev-deb-old/Makefile

  .eev/HELP
  .eev/HELP-html
  .eev/HELP-gtk
  .eev/HELP-lua
  .eev/HELP-howm

  markdown-dednat6/README.org
  markdown-dednat6/test.tex
  markdown-dednat6/minimalcore.lua

  windows-emacs/make-iso.e
  FundComp/etc
  FundComp/trabalho-eval
  FundComp/trabalho-geometria
  FundComp/trabalho-graficos
  FundComp/trabalho-rpn
  FundComp/trabalho-tabelas

  2009.1/MD/hanoi.lua
  2009.1/MD/dominoes.lua

  taro.txt
  tecido

  MARCOS/foo.lua

  LOGS/2008apr28.aloph
  LOGS/2008jan29.omnisys

  question-to-piratebay-staff.txt

  youtube-db/README
  youtube-db/db.lua
  youtube-db/dbu.lua
  youtube-db/scripts.lua
  youtube-db/template-dynamic.html
  youtube-db/edrxlib.lua
  youtube-db/ydbtoolbox.lua
  youtube-db/ydb

  youtube-db/ydb2.lua

  show2-elpeg1/README.org

]])



--[[
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# Pack into /tmp/sisrot-{text,e}-files.tgz:
A=(
  LATEX/sisrot-da-1.tex
  LATEX/sisrot-pdsw-1.tex
  LATEX/sisrot-pdsw-2.tex
  LATEX/sisrot-pdsw-3.tex
  LATEX/sisrot-pdsw-3.txt
  LATEX/sisrot-pdsw-4.tex
  LATEX/sisrot-pdsw-5.tex
  LATEX/sisrot-pdsw-workplan.txt
  LATEX/sisrot-pdsw-3-duvidas.txt
  LOGS/2008apr28.aloph
  LOGS/2008jan29.omnisys
  sisrot/.files
  sisrot/Makefile
  sisrot/VERSION
  sisrot/sc.lua
  sisrot/ssrt.lua
  sisrot/switch.lua
  sisrot/trajetoria.lua
  sisrot/unidades.txt
  sisrot/imgheader.tcl
  sisrot/create_images.lua
  sisrot/ssrt_msgs.lua
  sisrot/ihm_msgs.lua
  sisrot/textual.lua
  sisrot/meta.lua
  sisrot/structs.h
  sisrot/structs_pd.h
  sisrot/structs_pd.txt
  sisrot/structs_pd_simp.h
)
E=(
  e/omnisys.e
  e/sisrot.e
)
cd
tar -cvzf /tmp/sisrot-text-files.tgz $A
tar -cvzf /tmp/sisrot-e-files.tgz    $E

# Pack into ~/sisrot/sisrot-LATEX-files.tgz:

 (eepitch-Twu)
 (eepitch-kill)
 (eepitch-Twu)
cd ~/slow_html/LATEX/
laf
tar -cvzf ~/sisrot/sisrot-LATEX-files.tgz sisrot*
laf       ~/sisrot/sisrot-LATEX-files.tgz
# (ee-cp (ee-twufile "sisrot/sisrot-LATEX-files.tgz") "~/sisrot/sisrot-LATEX-files.tgz" 'over)
# (find-fline "~/sisrot/")
# (find-twufile "sisrot/")
# (find-twufile "sisrot/" "sisrot-LATEX-files.tgz")
# (find-twupfile "sisrot/")
# (find-twupfile "LATEX/")

# Delete the pdfs and such stuff from twu/slow_html/LATEX/:
 (eepitch-Twu)
cd ~/slow_html/LATEX/
# Double check:
laf       ~/slow_html/LATEX/sisrot*
tar -tvzf ~/sisrot/sisrot-LATEX-files.tgz
# Remove:
rm -v ~/slow_html/LATEX/sisrot*
laf       ~/slow_html/LATEX/

# Big mess (copy the tgzs between the local machine and twu):

tar -cvzf ~/sisrot/sisrot-text-files.tgz $A
# (find-fline     "/tmp/sisrot-text-files.tgz")
# (find-fline     "/tmp/sisrot-e-files.tgz")
# (find-fline     "/tmp/sisrot-LATEX-files.tgz")
# (find-fline "~/sisrot/sisrot-text-files.tgz")
# (find-fline "~/sisrot/")
# (find-twufile "sisrot/")
# (find-twusfile "")
# (ee-cp "~/sisrot/sisrot-text-files.tgz" (ee-twufile "sisrot/sisrot-text-files.tgz") 'over)
# (ee-cp "~/sisrot/sisrot-e-files.tgz"    (ee-twufile "sisrot/sisrot-e-files.tgz") 'over)
# (ee-cp (ee-twufile "sisrot/sisrot-text-files.tgz") "~/sisrot/sisrot-text-files.tgz" 'over)
# (find-TH "omnisys" "sisrot-pdsw")
# (find-twusfile "LATEX/")

--]]



-- anggdonttranslate  (to ".anggdonttranslate")
anggdonttranslate = splitandsort [[

  eev

  fbcache/huge.txt
  fbcache/huge.txt.html

  .mapleinit
  .psne.carry
  glyphbug

  HOWM/MainTasks
  HOWM4/Installation

  BUSYBOX/config-1.00
  BUSYBOX/config-1.2.0
  C/Makefile
  C/fontimage.c
  C/fontimage.icn
  C/math.extras
  CRIM1/Crim-0.01.tar.gz
  CRIM1/Crim-0.02.tar.gz
  CRIM1/Makefile
  CRIM1/README
  CRIM1/crim1-2000jul07.txt
  CRIM1/demo0a.tf
  CRIM1/demo0a.lst
  CRIM1/demo0b.tf
  CRIM1/demo0b.lst
  CRIM1/demo1.tf
  CRIM1/demo1.lst
  CRIM1/demo2.tf
  CRIM1/demo2.lst
  CRIM1/demo2.engine.c
  CRIM1/demo3a.tf
  CRIM1/demo3a.lst
  CRIM1/demo3b.tf
  CRIM1/demo3b.lst
  CRIM1/engine0.c
  CRIM1/engine1.c
  CRIM1/engine2.c
  CRIM1/engine3a.c
  CRIM1/engine3b.c
  CRIM1/tclstuff
  DANIEL/daniel.png
  DANIEL/engrac-p173.png
  EDRXPAGE/README
  EDRXPAGE/copyright
  EDRXPAGE/packages
  EXPECT/anonftp
  EXPECT/eheaders
  EXPECT/emaple
  EXPECT/seefonts
  EXPECT/sshsucuri
  ICON/tron.icn
  ICON/tron.icn.html
  ICON/tron.icn.png

  PURO/chapa1-debates.jpg
  PURO/chapa1.jpg

  GELADEIRA/output.pdf
  IMAGES/exclam.png
  IMAGES/bananas.jpg
  IMAGES/black_pawns_moves.eps
  IMAGES/black_pawns_moves.svg

  IMAGES/two_non-tautologies.png

  IMAGES/logo_ict_martelo.png
  IMAGES/logo_ict_martelo.jpg
  IMAGES/logo_ict_martelo.svg
  IMAGES/logo_ict_martelo_orig.svg
  IMAGES/logo_ict_placa.jpg
  IMAGES/hanoi1.svg

  IMAGES/2017cwm.png
  IMAGES/omega-kite.png
  IMAGES/and_commutes_shrink4.png
  IMAGES/and_commutes_shrink6.png
  IMAGES/imp_trans_shrink4.png
  IMAGES/imp_trans_shrink6.png
  IMAGES/PP.gdb.png
  IMAGES/eepitch-gdb.png
  IMAGES/emacsllded.png
  IMAGES/emacsvtutil.png
  IMAGES/gawk.png
  IMAGES/palette.png
  IMAGES/kaoya.png
  IMAGES/preslim.png
  IMAGES/rrj.png
  IMAGES/stpkys_vsm_notxt.gif
  IMAGES/exists-shot.png
  IMAGES/exists-xdvi.png
  IMAGES/trans.png
  IMAGES/powered-by-anger.png
  IMAGES/powered-by-anger.svg
  IMAGES/hyperdoctrine.png
  IMAGES/Atimes.png
  IMAGES/Atimes-dnt.png
  IMAGES/TfromFtoG.png
  IMAGES/Pandf.png
  IMAGES/lccc-bcc.png
  IMAGES/lccc-frob.png
  IMAGES/eqfib-trans.png
  IMAGES/forth.png
  IMAGES/forthlua.png
  IMAGES/forthluawhite.png
  IMAGES/forthsun.png
  IMAGES/littlelangs.png
  IMAGES/transparent-fav.png
  IMAGES/filterp-maps.png
  IMAGES/downcasing_Ax.png
  IMAGES/tg-black-and-white.png
  IMAGES/tg-color.png
  IMAGES/bittersweet.jpg
  IMAGES/eu_quero_uma_policia_que.jpg
  IMAGES/zhasforchildren.png
  IMAGES/sintese_das_discussoes_com_pos_modernos_1.png
  IMAGES/sintese_das_discussoes_com_pos_modernos_2.png
  IMAGES/street_fighter.png
  IMAGES/a_vida_dos_animais.jpg
  IMAGES/peppa_telefone_1.jpg
  IMAGES/planar-has-2CGs.png
  IMAGES/ebl2017.png
  IMAGES/idarct.png
  IMAGES/new-girl-from-ipanema-mini.png
  IMAGES/2014-evil-presheaf.png
  IMAGES/lclt.png
  IMAGES/tug-2018.png
  IMAGES/2018vichy-vgms.png
  IMAGES/planar-has-qms.png
  IMAGES/vichy-video-pentominos.png
  IMAGES/entrada-PURO.jpg
  IMAGES/oxford2019.png
  IMAGES/oxford2019.svg
  IMAGES/yoneda-2019.png
  IMAGES/dednat6-TFG.png
  IMAGES/material-para-GA.png
  IMAGES/BCCL-std.png
  IMAGES/intro-tys-lfc.png
  IMAGES/2019-viipl.png
  IMAGES/2020favorite-conventions.png
  IMAGES/2020clops-and-tops.png
  IMAGES/2020clops-and-tops-4-1.png
  IMAGES/2020clops-and-tops-4-2.png
  IMAGES/2020clops-and-tops-4-2-small.png
  IMAGES/2020-find-here-links.png
  IMAGES/2020-find-here-links-small.png
  IMAGES/2021-excuse-tt.png
  IMAGES/2021-groth-tops.png
  IMAGES/2021-square-cube.png
  IMAGES/2021-square-cube-3.png
  IMAGES/2021projeto-de-ensino-small.png
  IMAGES/2021emacsconf-small.png
  IMAGES/2021emacsconf-p03-small.png
  IMAGES/2021emacsconf-p04-small.png
  IMAGES/2021emacsconf-p05-small.png
  IMAGES/2021emacsconf-p06-small.png
  IMAGES/2021emacsconf-p10-small.png
  IMAGES/2021-oficina-1-small.png
  IMAGES/2021-oficina-2-small.png
  IMAGES/2021-workshop-0.png
  IMAGES/2021-workshop-1-small.png
  IMAGES/2021-workshop-2-small.png
  IMAGES/2021-workshop-3-small.png
  IMAGES/2021-workshop-4-small.png
  IMAGES/2021-workshop-5-small.png
  IMAGES/2021-workshop-6-small.png
  IMAGES/2021-emacs-tcl-bridge.png
  IMAGES/2021-org-for-non-users-small.png
  IMAGES/2021-ffll-small.png
  IMAGES/2021-find-agdatype-small.png
  IMAGES/2022-agda-logic-simple-1-2.png
  IMAGES/2022-agda-logic-simple-1-2-small.png
  IMAGES/2022-agda-logic-distrib-1.png
  IMAGES/2022-agda-logic-distrib-1-small.png
  IMAGES/2022-emaxima-1.png
  IMAGES/2022-emaxima-1-small.png
  IMAGES/2022-emaxima-2.png
  IMAGES/2022-emaxima-2-small.png
  IMAGES/2022-eev-make-0-small.png
  IMAGES/2022-eev-make-2.png
  IMAGES/2022-eev-make-2-small.png
  IMAGES/2022-maxima-doeval.png
  IMAGES/2022-maxima-doeval-small.png
  IMAGES/2022-find-eev-angg-small.png
  IMAGES/2022-find-eev-angg-redef.png
  IMAGES/2022-find-eev-angg-redef-small.png
  IMAGES/2022-find-eev-angg-demo-small.png
  IMAGES/2022-find-elisp-intro-small.png
  IMAGES/2022-find-agdanorm.png
  IMAGES/2022-find-agdanorm-small.png
  IMAGES/find-advicebefore-links.png
  IMAGES/2022on-the-missing.png
  IMAGES/2022eepitch-emlua-0-small.png
  IMAGES/2022eepitch-emlua-0.png
  IMAGES/2022agda-mode-prop-small.png
  IMAGES/2022agda-mode-prop.png
  IMAGES/2022find-yttranscript-links.png
  IMAGES/2022find-yttranscript-links-small.png
  IMAGES/2022find-pip3-links.png
  IMAGES/2022find-pip3-links-small.png
  IMAGES/2022find-pypi-links.png
  IMAGES/2022find-pypi-links-small.png
  IMAGES/2022find-importlib-links.png
  IMAGES/2022find-importlib-links-small.png
  IMAGES/2022-yttranscript-video-small.png
  IMAGES/2022-tikz-video-small.png
  IMAGES/2022eev-tik1-shape-rect.png
  IMAGES/2022eev-tik1-shape-rect-small.png
  IMAGES/2022tikz-pdftoolsr.png
  IMAGES/2022tikz-pdftoolsr-small.png
  IMAGES/2022tikz-showtex.png
  IMAGES/2022tikz-showtex-small.png
  IMAGES/2022tikz-show.png
  IMAGES/2022tikz-show-small.png
  IMAGES/2022tikz-exercises.png
  IMAGES/2022tikz-exercises-small.png
  IMAGES/2022tikz-texrun.png
  IMAGES/2022tikz-texrun-small.png
  IMAGES/2022tikz-magnetic.png
  IMAGES/2022tikz-magnetic-small.png
  IMAGES/2022find-git-links.png
  IMAGES/2022find-git-links-small.png
  IMAGES/2022eev-videos-not-found.png
  IMAGES/2022eev-videos-not-found-small.png
  IMAGES/2022eev-videos-psne-ing.png
  IMAGES/2022eev-videos-psne-ing-small.png
  IMAGES/2022eev-videos-1c.png
  IMAGES/2022eev-videos-1c-small.png
  IMAGES/2022-smaller-fullscreen-yes-small.png
  IMAGES/2022-smaller-fullscreen-no-small.png
  IMAGES/2022find-mpv-links.png
  IMAGES/2022find-mpv-links-small.png

  IMAGES/2022find-1stclassvideos.png
  IMAGES/luatree-small.png
  IMAGES/luatree.png
  IMAGES/luatree-sympy-small.png
  IMAGES/luatree-sympy.png

  IMAGES/2022eev-svg-img-interval.png
  IMAGES/2022eev-svg-img-interval-small.png
  IMAGES/2022eev-svg-def-integral.png
  IMAGES/2022eev-svg-def-integral-small.png
  IMAGES/2022eev-svg-sela.png
  IMAGES/2022eev-svg-sela-small.png
  IMAGES/2022eev-svg-script-0.png
  IMAGES/2022eev-svg-script-0-small.png
  IMAGES/2022eev-calc-0.png
  IMAGES/2022eev-calc-0-small.png
  IMAGES/2022-pict2e-lua.png
  IMAGES/2022-pict2e-lua-small.png
  IMAGES/2022-pict2e-lua-video.png
  IMAGES/2022-pict2e-lua-video-small.png
  IMAGES/2022-sitio-a-cuca-vai-pegar-EP01.jpg

  IMAGES/2022ee-hyperlink-prefix.png
  IMAGES/2022ee-hyperlink-prefix-small.png
  IMAGES/2022-find-red-star-links.png
  IMAGES/2022-find-red-star-links-small.png
  IMAGES/2022-find-newbrowser-links.png
  IMAGES/2022-find-newbrowser-links-small.png
  IMAGES/2022-find-newpdfviewer-links.png
  IMAGES/2022-find-newpdfviewer-links-small.png

  IMAGES/2022-eev-wconfig-pt-1.png
  IMAGES/2022-eev-wconfig-pt-1-small.png
  IMAGES/2022-eev-wconfig-pt-2.png
  IMAGES/2022-eev-wconfig-pt-2-small.png
  IMAGES/2022-eev-wconfig-main.png
  IMAGES/2022-eev-wconfig-main-small.png
  IMAGES/2022-eev-wconfig-init-file.png
  IMAGES/2022-eev-wconfig-init-file-small.png
  IMAGES/2022-eev-wconfig-gwen.png
  IMAGES/2022-eev-wconfig-gwen-small.png
  IMAGES/2022-eshell-tut-foo.png
  IMAGES/2022-eshell-tut-foo-small.png
  IMAGES/eev-mode-help-and-M-2-M-j.png
  IMAGES/eev-mode-help-and-M-2-M-j-small.png
  IMAGES/2022-eev-cabal.png
  IMAGES/2022-eev-cabal-small.png
  IMAGES/2022-find-ghc-links.png
  IMAGES/2022-find-ghc-links-small.png
  IMAGES/2022tikz-objects.png
  IMAGES/2022tikz-objects-small.png
  IMAGES/2022tikz-h-and-v.png
  IMAGES/2022tikz-h-and-v-small.png
  IMAGES/2022tiks-h-and-v.png
  IMAGES/2022tiks-h-and-v-small.png
  IMAGES/dednat6-slides-07.png
  IMAGES/dednat6-slides-09.png
  IMAGES/dednat6-slides-10.png
  IMAGES/2022-eev-download-video.png
  IMAGES/2022-eev-download-video-small.png
  IMAGES/2022-eev-download-video-2.png
  IMAGES/2022-eev-download-video-2-small.png
  IMAGES/emacsconf2022-kla.png
  IMAGES/emacsconf2022-kla-small.png
  IMAGES/emacsconf2022-py.png
  IMAGES/emacsconf2022-py-small.png
  IMAGES/emacsconf2023-repls.jpg
  IMAGES/emacsconf2023-repls-small.jpg
  IMAGES/emacsconf2023-repls-b.jpg
  IMAGES/emacsconf2023-repls-b-small.jpg

  IMAGES/2023find-try-sly-links-0.png
  IMAGES/2023find-try-sly-links-0-small.png
  IMAGES/2023-squeak-item1ctsa.png
  IMAGES/2023-squeak-item1ctsa-small.png
  IMAGES/2023-blogme-class-print-defs.png
  IMAGES/2023-blogme-class-print-defs-small.png
  IMAGES/2023-blogme-class-parsers.png
  IMAGES/2023-blogme-class-parsers-small.png
  IMAGES/2023-tk-pack.png
  IMAGES/2023-tk-pack-small.png
  IMAGES/2023-Gram1.png
  IMAGES/2023-Gram1-small.png
  IMAGES/2023-Gram3.png
  IMAGES/2023-Gram3-small.png
  IMAGES/2023-Ast1.png
  IMAGES/2023-Ast1-small.png
  IMAGES/2023-ELpeg2.png
  IMAGES/2023-ELpeg2-small.png
  IMAGES/2023-ELpeg1-assoc.png
  IMAGES/2023-ELpeg1-assoc-small.png
  IMAGES/2023-ELpeg1-Gram-tests.png
  IMAGES/2023-ELpeg1-Gram-tests-small.png
  IMAGES/2023-qdraw-lissajous.png
  IMAGES/2023-qdraw-lissajous-small.png
  IMAGES/2023-qdraw-parabola.png
  IMAGES/2023-qdraw-parabola-small.png
  IMAGES/2023-pn1-folium.png
  IMAGES/2023-pn1-folium-small.png
  IMAGES/2023-find-sandwichsexp-links.png
  IMAGES/2023-find-sandwichsexp-links-small.png
  IMAGES/2023-lua-repl-prefix.png
  IMAGES/2023-lua-repl-prefix-small.png

  IMAGES/2023loeliger.gif
  IMAGES/2023loeliger-gitk.png
  IMAGES/2023loeliger-gitk-mini.png
  IMAGES/2024-eev-git.jpg
  IMAGES/2024-eev-git-small.jpg

  IMAGES/2024-find-luaso-links-1.png
  IMAGES/2024-find-luaso-links-1-small.png
  IMAGES/2024-find-luaso-links-2.png
  IMAGES/2024-find-luaso-links-2-small.png
  IMAGES/2024-find-luaso-links-3.png
  IMAGES/2024-find-luaso-links-3-small.png
  IMAGES/2024-Repl3-debug-debug.png
  IMAGES/2024-Repl3-debug-debug-small.png
  IMAGES/2024-Repl3-find-luatb.png
  IMAGES/2024-Repl3-find-luatb-small.png
  IMAGES/2024-Repl3-Prosody.png
  IMAGES/2024-Repl3-Prosody-small.png
  IMAGES/2024-Repl3-Repl-tests-1.png
  IMAGES/2024-Repl3-Repl-tests-1-small.png
  IMAGES/2024-Repl3-Repl-tests-2.png
  IMAGES/2024-Repl3-Repl-tests-2-small.png
  IMAGES/2024-Repl3-Repl-tests-3.png
  IMAGES/2024-Repl3-Repl-tests-3-small.png
  IMAGES/2024-find-lgreps-1.png
  IMAGES/2024-find-lgreps-1-small.png
  IMAGES/2024-find-lgreps-2.png
  IMAGES/2024-find-lgreps-2-small.png
  IMAGES/2024-find-lgreps-3.png
  IMAGES/2024-find-lgreps-3-small.png
  IMAGES/2024-rdd.png
  IMAGES/2024-rdd-small.png

  IMAGES/2024-find-subed-mpv-links-1.png
  IMAGES/2024-find-subed-mpv-links-1-small.png
  IMAGES/2024-ParseTikz1-1.png
  IMAGES/2024-ParseTikz1-1-small.png
  IMAGES/2024-rcd-createuser.png
  IMAGES/2024-rcd-createuser-small.png
  IMAGES/2024-LuaTreeLean-1.png
  IMAGES/2024-LuaTreeLean-1-small.png
  IMAGES/2024-LuaTreeLean-2.png
  IMAGES/2024-LuaTreeLean-2-small.png
  IMAGES/2024-import-problem.png
  IMAGES/2024-import-problem-small.png
  IMAGES/2024type-inference-bind.png
  IMAGES/2024type-inference-bind-small.png

  IMAGES/2024-maxima-mini.png
  IMAGES/2024panic-teresopolis.png

  IMAGES/2021-emacsconf2021-dednat6.png
  IMAGES/2021-emacsconf2021-dednat6-small.png

  IMAGES/2021aulas-por-telegram-small.png
  IMAGES/2021-1-C2-somas-1-dicas-small.png
  IMAGES/2021-2-c3-cabos-na-diagonal-small.png
  IMAGES/2023-caepro0-small.png
  IMAGES/2023-caepro-VR-small.png
  IMAGES/2023-caepro-o-que-sobra-small.png
  IMAGES/2023-visual-vs-auditivo-small.png
  IMAGES/2023-precisamos-de-mais-slogans-small.png

  LATEX/2019eev-puro-cartaz.png

  IMAGES/frob-sketch.svg
  LATEX/frob-sketch.eps

  IMAGES/queremos_184x190.png
  IMAGES/queremos_small.jpg
  IMAGES/puvis_de_chavannes_young_girls_by_the_seaside_r4.jpg
  IMAGES/puvis_de_chavannes_young_girls_by_the_seaside.jpg
  IMAGES/personas-sexuais-camille-paglia-capa.jpg
  IMAGES/bingo_acefobia.jpg

  emacs-lua/emlua-2021may12.png

  LuaTreeLean/screenshot.png
  LuaTreeLean/screenshot-Test3.png

  ORG/didatica.org
  ORG/genero.html

  SDL/black.xpm
  SDL/red.xpm
  SDL/yellow.xpm

  SQUEAK/See.st
  SQUEAK/See.st.html
  SQUEAK/Category-Edrx.st
  SQUEAK/Category-Edrx.st.html

  glyphs/2010diags.tex.png
  glyphs/2011.2-GA.blogme.png
  glyphs/edrx08.sty.png
  glyphs/eepitch-demo.png
  glyphs/eepitch-explan1.png
  glyphs/eepitch-explan2.png
  glyphs/eev-glyphs.el.png
  glyphs/eev-math-glyphs.el.png
  glyphs/eev-math-glyphs.el.bug.png
  glyphs/find-anchors-intro.png
  glyphs/find-anchors-intro-bug.png

  pendrive.jpg

  quadradinho/quadradinho-a5.pdf
  quadradinho/quadradinho-print.pdf
  quadradinho/quadradinho.png
  quadradinho/qrcode.png

  quadradinho/25-50-25.pdf
  quadradinho/25-50-25.svg
  quadradinho/filtros.pdf
  quadradinho/filtros.svg
  quadradinho/front.pdf
  quadradinho/front.svg
  quadradinho/greve-full.pdf
  quadradinho/greve-full.svg
  quadradinho/greve-simplificado.pdf
  quadradinho/greve-simplificado.svg
  quadradinho/queremos4.pdf

  2013-rfm-rcn/2013dec10_complemento_do_rfm.txt

  LATEX/bussproofs.sty
  LATEX/zinc.icn
  LATEX/zlib.icn
  LATEX/proof.edrx.sty
  LATEX/mar99a.dn
  LATEX/mar99a.dnt
  LATEX/mar99b.dn
  LATEX/mar99b.dnt
  LATEX/vgatim.sty
  LATEX/gray50.bmp
  LATEX/gray50xx.bmp
  LINUX/2.4.26-initrd.conf
  LINUX/2.6.28-persephone1.conf
  LUA/toposort.lua
  LUA/loadlib/loadlib.patch
  MTA/defkeymap850b.map
  MTA/128
  MTA/128b
  MTA/math850.map
  MTA/fonts.dir
  MTA/math1.8.bdf
  MTA/math1.8b.bdf
  MTA/math1.8c.bdf
  PFORTH/Makefile
  PFORTH/mtamacros.h
  PFORTH/tclpforth.c
  PFORTH/tclpforth.tcl
  PFORTH/tclpf_custom.c
  PFORTH/tclpf_hook.c
  PYTHON/debs.py
  SQL/mysqltutor-1
  SQL/mysqltutor-2
  TCL/dednames
  TCL/httpwiki-old
  TCL/httpwiki
  TCL/fix-eheaders
  TCL/font2bdf
  TCL/tcl.ttp
  TCL/Tcl-pt.n

  RETRO/retroImage
  RETRO/luaretro.tgz

  bin/emacs-c.cmd
  bin/gravis-up
  bin/inx-up
  bin/inx.dip-nopwds
  bin/kbrequest
  bin/sendemail
 crim/index.html
 crim/1-autod.4th.txt
 crim/1.4th.txt
 crim/1.aud.txt
 crim/2-autod.4th.txt
 crim/2.4th.txt
 crim/2.aud.txt
 crim/ETC.txt
 crim/announce.txt
 crim/autodoc.4th.txt
 crim/crim.c.txt
 crim/crimcomp.4th.txt
 crim/letter.txt
 crim/patchpfe.txt
  davidwest.txt
  dednat/bussproofs.sty
  dednat/proof.edrx.sty
  dednat/example_tex.png
  dednat/example_dvi.png
  diaglib/godement1.png
  diaglib/godement2.png
  diaglib/godement3.png
  eev-old/dlopen.png

  dednat4/dednat4-icon.png
  blogme/blogme-icon.png
  blogme3/.favicon.png
  icon-tourism.png

  blogme4/blogme4.tgz

  dednat5/dednat5.tgz
  dednat5/tests/test1.pdf
  dednat5/tests/test2.pdf
  dednat5/tests/test3.pdf
  dednat5/tests/testbegr.pdf

  dednat6/tug-slides-ss1.png
  dednat6/tug-slides-sslr2.png

  eev-current/doc/shot-f3.png
  eev-current/doc/shot-f8.png
  eev-current/doc/shot-f9.png
  eev-current/doc/shot-eev-ttp.png
  eev-current/doc/diag-save.svg
  eev-current/doc/diag-save.jpg
  eev-current/doc/diag-links.svg
  eev-current/doc/diag-links.jpg

  eev-current/eev-glyph-icon.png
  eev-current/eev-icon.png
  eev-current/.favicon.png
  eev-current/anim/.favicon.png
  eev-current/article/.favicon.png
  eev-current/article/ss-f9.png
  eev-current/article/ss-gdbtall.png
  eev-current/article/ss-gdbwide.png
  eev-current/article/ss-lua.png
  eev-current/article/ss-m-h.png
  eev-current/article/ss-modular.png
  eev-current/article/iskidip.eps
  eev-current/article/iskidip.svg
  eev-current/examples/.favicon.png

  elisp/tron.el
  elisp/tron.el.html
  elisp/tron.el.png
  elisp/scrshot-plot.png
  elisp/sshot.el
  elisp/sshot.el.html
  gab/gab.png
  kconf2220-cdrw
  lua-4.0/Makefile.patch
  lua-4.0/README.rttpatch
  lua-4.0/README.yada
  lua-4.0/_NEWFILES
  lua-4.0/_PATCHES
  lua-4.0/config.patch
  lua-4.0/debian/changelog
  lua-4.0/debian/packages

  lua-4.0/debian/control
  lua-4.0/debian/dirs
  lua-4.0/debian/docs
  lua-4.0/debian/rules

  lua-4.0/doc/lua.texi
  lua-4.0/include/dllua.h
  lua-4.0/src/libdllua/Makefile
  lua-4.0/src/libdllua/dllua_open.c
  lua-4.0/src/libdllua/lbitlib.c
  lua-4.0/src/libdllua/loadlib.c
  lua-4.0/src/libdllua/loadlib.h
  lua-4.0/src/libdllua/lrexlib.c
  lua-4.0/src/lua/Makefile.patch
  lua-4.0/src/lua/lua.c.patch
  mktclapp-3.9/.files
  mktclapp-3.9/Makefile
  mktclapp-3.9/README.debian
  mktclapp-3.9/debian/README.debian
  mktclapp-3.9/debian/changelog
  mktclapp-3.9/debian/control
  mktclapp-3.9/debian/copyright
  mktclapp-3.9/debian/dirs
  mktclapp-3.9/debian/docs
  mktclapp-3.9/debian/examples
  mktclapp-3.9/debian/rules
  mktclapp-3.9/debian/substvars
  mktclapp-3.9/examples/Makefile
  mktclapp-3.9/examples/README
  mktclapp-3.9/examples/factor.c
  mktclapp-3.9/examples/factor.tcl
  mktclapp-3.9/examples/factor2.tcl
  mktclapp-3.9/examples/hello.c
  mktclapp-3.9/examples/hello0.tcl
  mktclapp-3.9/examples/hello1.tcl
  mktclapp-3.9/examples/hello2.tcl
  mktclapp-3.9/examples/hellob.tcl
  mktclapp-3.9/mktclapp.pod
  mktclapp-3.9/xmktclapp.pod
  p.txt
  s.txt
  greenliv1.txt
  rumi1.txt
  replace/defkeymap-iso.map
  replace/defkeymap850b.map
  replace/iso01.f08
  replace/TextConfig.angg
  the_hurd_links.html
  l4-hurd.html
  vtutil/editing-font.png
  vtutil/ega0.8
  vtutil/ega1.8
  vtutil/ega0.16
  vtutil/ega1.16
  vtutil/defkeymap.map.edrx

  vtutil4/ega0.16
  vtutil4/ega0.8
  vtutil4/ega1.16
  vtutil4/ega1.8

  windows-emacs/abre-c.bat
  windows-emacs/copia-d.bat
  windows-emacs/copia-e.bat
  windows-emacs/emacs-c.bat
  windows-emacs/emacs-d.bat
  windows-emacs/emacs-e.bat
  windows-emacs/bats.zip

  usrc/rcirc/rcirc.el
  usrc/rcirc/rcirc-x.el

  WebWiki/AleisterCrowley.html
  WebWiki/BodyMods.html
  WebWiki/CategoryTheory.html
  WebWiki/ChurchOfEuthanasia.html
  WebWiki/CompCs.html
  WebWiki/DakiniDeck.html
  WebWiki/DebianGnu.html
  WebWiki/DebianVsRedHat.html
  WebWiki/Dictionaries.html
  WebWiki/DistanciaPontoReta.html
  WebWiki/DosAndWindows.html
  WebWiki/Eev.html
  WebWiki/EevInterface.html
  WebWiki/EevToDo.html
  WebWiki/ElispHyperlinks.html
  WebWiki/Emacs.html
  WebWiki/EmacsParaWindows.html
  WebWiki/EmacsWiki.html
  WebWiki/EmacsWikiEl.html
  WebWiki/EmacsWikiMode.html
  WebWiki/Estatistica.html
  WebWiki/EstatisticaAulas.html
  WebWiki/EstatisticaQuestionarios.html
  WebWiki/FCBibliografia.html
  WebWiki/FCHistoria.html
  WebWiki/FCTeoriaDaComputacao.html
  WebWiki/Forth.html
  WebWiki/FundComp.html
  WebWiki/FundCompEmacs.html
  WebWiki/FundCompTrabalhos.html
  WebWiki/Games.html
  WebWiki/GarySnyder.html
  WebWiki/Geometria.html
  WebWiki/Hurd.html
  WebWiki/Icon.html
  WebWiki/LacqueredDuck.html
  WebWiki/LambdaCalculo.html
  WebWiki/LilyPond.html
  WebWiki/Linux.html
  WebWiki/LispMemoria.html
  WebWiki/LispOrdemDeAvaliacao.html
  WebWiki/Lua.html
  WebWiki/MudancaDeEscala.html
  WebWiki/Music.html
  WebWiki/NetBsd.html
  WebWiki/NewTags.html
  WebWiki/Personal.html
  WebWiki/Politics.html
  WebWiki/PostScript.html
  WebWiki/SchemeVersusLisp.html
  WebWiki/Silk.html
  WebWiki/SlackWare.html
  WebWiki/TclTkExpect.html
  WebWiki/ToDo.html
  WebWiki/Translacoes.html
  WebWiki/VariaveisLivres.html
  WebWiki/VeganPage.html
  WebWiki/Vetores.html
  WebWiki/Viola.html
  WebWiki/WelcomePage.html
  WebWiki/WikiIndex.html
  WebWiki/pitagoras.fig.html
  Wiki/AleisterCrowley
  Wiki/BodyMods
  Wiki/CategoryTheory
  Wiki/ChurchOfEuthanasia
  Wiki/CompCs
  Wiki/DakiniDeck
  Wiki/DebianGnu
  Wiki/DebianVsRedHat
  Wiki/Dictionaries
  Wiki/DistanciaPontoReta
  Wiki/DosAndWindows
  Wiki/Eev
  Wiki/EevInterface
  Wiki/EevToDo
  Wiki/ElispHyperlinks
  Wiki/Emacs
  Wiki/EmacsParaWindows
  Wiki/EmacsWikiMode
  Wiki/Estatistica
  Wiki/EstatisticaAulas
  Wiki/EstatisticaQuestionarios
  Wiki/FCBibliografia
  Wiki/FCHistoria
  Wiki/FCTeoriaDaComputacao
  Wiki/Forth
  Wiki/FundComp
  Wiki/FundCompEmacs
  Wiki/FundCompTrabalhos
  Wiki/Games
  Wiki/GarySnyder
  Wiki/Geometria
  Wiki/Hurd
  Wiki/Icon
  Wiki/LacqueredDuck
  Wiki/LambdaCalculo
  Wiki/LilyPond
  Wiki/Linux
  Wiki/LispMemoria
  Wiki/LispOrdemDeAvaliacao
  Wiki/Lua
  Wiki/MudancaDeEscala
  Wiki/Music
  Wiki/NetBsd
  Wiki/Personal
  Wiki/Politics
  Wiki/PostScript
  Wiki/SchemeVersusLisp
  Wiki/Silk
  Wiki/SlackWare
  Wiki/TclTkExpect
  Wiki/ToDo
  Wiki/Translacoes
  Wiki/VariaveisLivres
  Wiki/VeganPage
  Wiki/Vetores
  Wiki/Viola
  Wiki/WelcomePage
  Wiki/pitagoras.fig

]]

thdeps = splitandsort [[
  Generate
  Htmllib.tcl
  Files.tcl
  Debiandocs.tcl

  Makefile
]]

-- escriptstems  (to ".escriptstems")
-- (find-fline "$ES/")
-- (find-sh "cd $ES; ls -C *.e | expand | sed s/\\\\.e//g")
-- without([[ cartas contas corresp locz linhadir ]], ...)
--
escriptstems = splitandsort [[

04dia-d        diagrams     howm        mgp            rest
04lua          dict         hsforth     mini           rpm
21             doc          html        mktclapp       ruby
anatocc        dos          http        ml             scheme
angg           dpkg         hurd-old    modelcheck     screen
anggsmil       dual         hurd        modem          slink
apache         e2fs         hw-eth      modula3        smalltalk
apt            eeg          hw-parport  mouse          snarf
awk            eev          hw-sound    mp3            sound
bash           emacs        icon        multiterminal  sql
bis            escripts     icq         music          squeak
bootcd         ethernet     index       mysql          ssh
bsd            ewiki        init        net            sudo
busybox        exim         initrd      netbasics      tcl-cipsga
cdd            expect       inkscape    netbsd         tcl
cdrom          fl           interbase   netscape       tcsh
cfengine       float        ion         news           tese
charsets       floppy       irc         nonfree        tex
chinese        flua         k22         octal          texinfo
chroot         forth        kernel      oldpage        todo
cipsga         fortho       latest      oskit          tomsrtbt
clock          ftpd         lexyacc     page           tourism
conf           fvwm         licenses    pam            transp
console        games        lilo        perl           usermodelinux  java
coq            gdb          lilypond    perl1          vi        javascript
crim           general      livecd      php            vnc       iup-old   gnus
cron           gimp         locale      planner        wget      iup  scintilla
cvs            gnome        localnet    postgres       wiki      blogme
dbootstrap     gnuplot      lua-old     potato         x         plurall   w32
debian-by-ex   gpg          lua         potatocds      xxx-server   lua-intro
debian-cd      greenmatrix  lua5        print          xypic     pic   kepler
debian-net     groff        lynx        ps             yard      expat  davinci
debian         grub         mail        python         zsh       gforth   sqlite
debian0        gtk          make        qemu             oracle     gaim
debiandev      hardware     man         raven10          swig       openoffice
debrepository  haskell      maple       raven10b         dialog     figlet  qt
dednat         hd           math        redhat           sweetjane  dvd   lisp
  doxygen   adwin   maxima    xen    rubyforth    plan9    ubuntu    luatex
  isabelle  flash   firefox   joomla   r   puro   ndiswrapper   lenny
  alsa      hol     octave    pendrive     pascal wine          ppp  scan
  virtua    p2p     metapost  erlang   eee agda   imagemagick   projeto
  scala     highlight   sage  diagxy   retro   clojure   wordpress   cad
  geometry  apl     skype     chrome   csound  org       rcirc       mtp
  love      factor  vlc       joy      obj     backup    rexx        autoconf
  htmlize   video   moodle    sdl      slackware    archlinux        css
  rebol     mplayer  puredata blender  android      git  yad         telegram
  teamspeak ffmpeg   qrcode   wifi     op-1         graphviz   rst   bluetooth
  apt-cacher   scribus   samba   sympy     youtube  osx    tramp     isolinux
  localvideos  chomsky   live    networkmanager     dbus   unix      loop
  quadradinho  pidgin    suspend  beamer   loomio   tikz   ferramentas
  non          calibre   facebook diaspora snobol4  twitter netsurf  xfce
  paste        markdown  ocaml    fbcmd    trisquel ipython lean     syslinux
  tumblr       googlegroups       musescore         luarepl u        mate
  libreboot    sh   ksh  jupyter  linux    debootstrap      td       docker
  cabal  ghc   idris     hyperbole   gettext   eshell  screencasts   circe  erc
  bat   prolog tmp       yelp        geany     julia   speech        strace
  ios   sphinx emacsconf2019   rust  arduino   arxiv   travis-ci     dropbox
  fossil       opera     luarocks    idarct    tallin  plzoo         recutils
  pulseaudio   systemd   types       reddit    snap    instagram     penrose
  context      ead       shibari     xml       doom    pitivi    magit
  emacsconf2020   basic  snd   stackexchange   calc    mikmod    elpa  pandoc
  srf  overleaf   racket chalktalk   zulip     zig     stack     ghcup pharo
  mathologer   andre     minted      manim     auctex  pict2e    bullseye
  texlive      xournal   devuan      lpeg      abella  js        fennel
  svg     2021-oficina   terra  0x0  self      emacsconf2021     srht
  geogebra     awesome   xmpp   poke  asciidoc flutter fengari   oberon  vpn
  nim  textadept  subtitles  elm  rss emlua    stumpwm matplotlib   oauth
  fortran  telega matrix     emacsconf2022     luakit  exwm      color
  treesit  lsp    rcd    netcat  perl6  rsync  dns     cuis      prince
  mint     groovy   labinfo  godot    bookworm  mbe    mqtt      show2
  termux   emacsconf2023  eat    jammy   drawtree   ikiwiki  ohm  npm
  golang   sixel    asymptote    pygments   tesevictor  nix  mmdebstrap
  dhcp

]]

--[[
  omnisys
  sisrot
--]]




-- thstems  (to ".thstems")
-- (find-sh "cd ~/TH/; ls -C *.th")
-- (find-sh "cd ~/TH/; ls -C *.th | expand | sed s/\\\\.th//g")
thstems = splitandsort [[

01jul14      dvis                      montreal  thl
Estatistica  eev-2004       html                 to-do
FundComp     eev-mails      hurd                 tourism-old
Geometria                              other
arafat       eev-notes                 perl      
cipsga       emacs-old      index-th   python    
contact-old  emacs-tutor    index2     redhat0   vegan-old
crashco                     linux      search    vtutil
crim1        files          logic      snarf
debug        forth          lua-old    tcltk     zsh
dednat                      map        tese
duallinux    grub-old       math       test      hacks

]]
--     eev-manifesto

-- blogmestems  (to ".blogmestems")
-- (find-sh "cd ~/TH/; ls -C *.blogme")
-- (find-sh "cd ~/TH/; ls -C *.blogme | expand | sed s/\\\\.blogme//g")
blogmestems = splitandsort [[

blogme           heroes         snyder     2007dnc-sets  2007dnc-halfdnc
bookmarks        icon           speedbar   2007dnc-cats  2007lcccs  2007dnc-lst
contact          index          tcl        2007dnc-bcc   2007dnc-etc    diaglib-old
cv-edrx-2005-pt  iskidip        tmp-b      2007semantics   2007mesa     mktclapp
dba              iskidip0       tmp        2007hyperdoctrines
debian           littlelangs             index2007    wilimlj   2007diffcats
dednat4 dednat6  luaforth       tourism    2007dnc-monads  2007sheaves
desarmamento     luasocket      vegan      coe  crowley    j2tech
eev-article      math-b         vegan1     plurall   latex  blogme3-angg
emacs     music  math-old-links w32        dnc2007   iup    peek    gaiman
floreser         personal       webcomics  blogme3   gender davinci  michel
friends          politics                  blog   unibanco  ruby   smalltalk
fvwm             seminar-notes             rrj  rrj2  rrj3  rrj4   rrj5   rrj6
  leatavora                                eev  desalojados  minilangs    rrj7
  oficinadasemente   miniforth-article   miniforth   2007dnc-sdg    todo
    unclassified     why-users           anaisnin     middle-c      glyphs
    unclassified2    movies              literature   repl       carburadores
    unclassified3    gnu                 prestesjoao  orides  dednat4-log  coq
    moreabout        omnisys             concurso     galdino  orlovsky
    eev-manifesto    videos              iggy  harry  rcirc    sistersally
    haskell          aupairs             puro  romano meinhof-judg  rrj-intro
    2009.1    2009.1-C1  2009.1-C2  2009.1-MD   2009workshop
    2009.2    2009.2-C2  2009.2-C4  2009.2-MD   llarc    rrjs
    2010.1    2010.1-C2  2010.1-MD
    2010.2    2010.2-C2  2010.2-MD  2010-conseq  2010-den
    2011.1    2011.1-C2  2011.1-MD  2011.1-GA
    2011.2               2011.2-MD  2011.2-GA
    2012.1               2012.1-MD  2012.1-GA  2012.1-BE
    2012.2                          2012.2-GA  2012.2-ES
    2013.1                          2013.1-GA  2013.1-ES
    2013.2                          2013.2-GA  2013.2-ES
    2014.1                          2014.1-GA  2014.1-FM
    2014.2                          2014.2-GA  2014.2-FM
    2015.1               2015.1-C2  2015.1-GA
    2015.2               2015.2-C2  2015.2-GA
    2016.1               2016.1-C2  2016.1-GA  2016.1-LA   2016-optativa
    2016.2               2016.2-C2  2016.2-GA  2016.2-LA
    2017.1               2017.1-C2  2017.1-GA  2017.1-LA
    2017.2               2017.2-C2  2017.2-GA  2017.2-LA
    2018.1               2018.1-C2  2018.1-GA  2018.1-LA
    2018.2    2018.2-MD  2018.2-C2 
    2019.1    2019.1-TD  2019.1-C2  2019.1-C3
    2019.2               2019.2-C2  2019.2-C3
    2020.1               2020.1-C2  2020.1-C3
    2020.2               2020.2-C2  2020.2-C3
    2021.1               2021.1-C2  2021.1-C3  2021.1-projeto
    2021.2               2021.2-C2  2021.2-C3  2021.2-C2-C3-Geogebra
    2022.1               2022.1-C2  2022.1-C3
    2022.2               2022.2-C2  2022.2-C3
    2023.1    2023.1-LA  2023.1-C2  2023.1-C3  2023.1-C4
              2023.1-ES  2023.1-GA             2023.1-C4-email
    2023.2               2023.2-C2  2023.2-C3
    2024.1               2024.1-C2  2024.1-C3  2024-C3-projeto
                         2024.1-GA

    2023-monitoria  2023-caepro
    2022-apresentacao-sobre-C2

    2021-1-C2-somas-1-dicas
    2021-2-c3-cabos-na-diagonal
    2021aulas-por-telegram
    2023-caepro0
    2023-caepro-VR
    2023-caepro-o-que-sobra
    2023-visual-vs-auditivo
    2023-precisamos-de-mais-slogans
    2023-causas-institucionais
    2023-aplicacoes

    2021-oficina-1
    2022-eev-make-0
    2022-eev-tikz
    2022-eev-wconfig
    2022-find-eev-angg
    2022-find-elisp-intro
    2022-pict2e-lua
    2022-yttranscript
    2024-eev-git
    2024-find-luaso-links
    emacsconf2021-dednat6

    2023-fusaro-tall
    2023-links-curtos

    2011-eleicoes        2011-ufrrj     material-para-GA
    amazon-diane-arbus-problem      2009-cola    criterios
    muros     spp-2010   zamm-13      virtua    igor   resp-sel
    logo-ict  empty-ps2  sequestros   monep     dinamarca     tattoo
    tclmagick __mt       javascript   comint    desnevizacao
    psi-cor   2011-ufrj   2011-maio
    2011-cuv-quorum      2011-meios-e-fins  2011-bctp
    queremos   chapa1    punf-2011dec07     bodymods    historia-de-T
    ltcltk     social    2011-rext          luatex      bittersweet
    a-vida-dos-animais   sobre-o-pixo-e-a-multidao      uma-policia-que
    daniel-e-iniciativa  horas-bunda        s-c-r       coiote
    2011-alice-e-bob     2015-vaca          personas-sexuais-1
    2011-4perguntas      fernanda-torres    sjw-1  sjw-2   logica-l
    2011-problemas       2016-carioques     queermuseu     nem-todo-evangelico
    2011-smil            haz                duas-camadas   belly-dance
    2011-solucao         homem-nu-no-MAM    logic-for-children-2018
    2011-visita-guiada   categories-2017may02    shibari   davidjay   pergola
    2012-cabofrio        2012-sindicancia   intervencao    grub    live-build
    2012-unb             links      find-xpdfpage    htmlize   escripts
    cosmevelho                      find-pdf-page    idris     2019oficina
    e-mails              emacsconf2019  notacao-de-fisicos     luarocks
    eev-puro             installing-eev-on-windows             ace-links
    gatos                Freyd76    livros   emacsconf2020  emacsconf2019-subtitles
    genericfigures       carrefour  2020-some-template-based   2020-find-here-links
    queremos-lote2                  2020-list-packages-eev-nav 2021-ssr
    templates            2021-test-blocks    test-blocks       2021-video-links
    2021projeto-de-ensino    2021-oficina    2021-workshop     emacsconf2021
    2022-oficina-focus       2022-oficina-caepro   2021-2022-workshops
    emacsconf2022-py     emacsconf2022-kla
    2012-debate-PURO-PUNF
    2012-greve
    2012-rede
    2012-eliana-assedio
    magini
    2012-greve-fontes-primarias
    2012-delpupo
    2012-ict
    2012-sentar-e-conversar
    2012-gravacoes
    2012-carta-ao-ict
    2012-reestruturacao

2012-estagios
2012-installfests
2012-out-04
2012-iniciativa
2013-assedios
2013-textos
2013-videos
2013-irina
2013-rfm-rcn
2013-petropolis
2014-vancouver

chapa1-oestudante
chapa1-funcionarios
chapa1-pressao
chapa1-cv-eblin
chapa1-sirelli
chapa1-ramiro
chapa1-anacristina
chapa1-democracia
chapa1-waltermag
chapa1-anaisabel
chapa1-sandro
chapa1-romulo
chapa1-fernando
chapa1-formarap
chapa1-aduff-04agosto2011
chapa1-spp-email

crpc-tresmentalidades
crpc-naturalorder
crpc-iraqigovt
crpc-cathcorr
crpc-etica
crpc-obrasilque
crpc-ordemesp

eev-debian eev-videos blergh quadradinho manufacturing.srt emacsconf
html5-audio rads bambole bambole-old hoop-videos poledance fbcache
2019-curso-latex

audios/2011dec13-ict
audios/2012mai17-assembleia-gragoata
audios/2012set20-ict
audios/2012sep20-ict
audios/2012nov22-ict
audios/2012dez13-ict
audios/2012dec13-ict
audios/2013jun20-ict
audios/2013jun27_espaco_fisico
audios/2013ago01-ict
audios/2013oct17-ict
audios/2013dec04-aduff
audios/2013dec04-EP
audios/2013dec05-EP
audios/2013dec05-rfm
audios/2013dec12-ict
audios/2014feb20-ict
audios/2014mar13-debate-macae
audios/2014mar27-palharini-puro
audios/2014mar28-defesa-rhea
audios/2014may07-prefeito-e-reitor
audios/2014may08-petropolis-parte
audios/2014may08-petropolis2
audios/2014may22-ict
audios/2014may30-xs
audios/2014jun05-rfm
audios/2014jun11-ict
audios/2014sep10-ernani-zelaya
audios/2014sep11-audiencia-reitor
audios/perna_2014jan18
audios/perna-2015jan18
audios/2015feb26-rhs
audios/2015mar26-rhs
audios/2015jan30-luis-capucho
audios/2015apr26-luis-capucho
audios/2015may06-pronunciamento
horta-do-anfiteatro
GA-criterios
2013-ProtestoRJ
2013-espaco-fisico
parabens-edwin
local-videos
videos-locais
linksdasruas
linkdasruas
linkdasruas2
linkdasruas3
file-urls-android
manufacturing-consent
consensofabricado
i-conecta
este-post-e-sobre-black-blocs
uma-policia-que-faca-coisas-uteis
tools-for-activists
sheavesforchildren
quebrandogenero
boicote-aos-anunciantes
falta-misandria
falta-misandria-0
falta-misandria-2   heleonora
falta-misandria-scr
trans-links         pqnf  porque-nao-sou-mais
cunha-links
forest

2013-picuinha
onde-tudo-e-apagado
uso-do-tempo
2013-nao-aguento-mais
2014-notas-sobre-processos
ferramentas-para-ativistas
ferramentas/ferramentas-a
ferramentas/ferramentas-v
2014-xs
xerecas-satanicas
2014-tr
moving-out
2014-ci
2016-v  2016-t   2016-m   2017-m   2017-v   2017-f  2017-s  2018-h
2020-a  2017vichy   ter-a-ver      2018-t   2022-t  2018-r  2021-r
2022-w

processing     yoga   costura    kristi   all-the-madmen   fancy
remocoes       estantes     turtle-song   viola            purcell
ee       povos-indigenas    clima  cedae  bowie-amsterdam  bolsa-familia
links-sobre-gaza  covid-19  bozo   george-floyd    xs      jacarezinho
index-old      emlua   h    albatross     agda  test-utf8  2021-lean
sda5    2021-org-for-non-users  2021-ffll  eev-agda   eev-maxima
lua-obj-notation   eev-make  eev-find-angg  find-elisp-intro  noh
nazism-zunger  mamaefalei   2022caneca   2022eev-svg  eev-calc
eev-customize  pict2e-lua   eev-wconfig  2022-oficina-maio  hyperbole
eepitch        mathologer-calculus-easy  eev-haskell  eev-tikz
find-yttranscript-links     eev-doom     eev-telega   eev-mode
find-git-links   eev-for-longtime-emacs-users     2022-reclamacoes-1
2022-reclamacoes-2   2022-reclamacoes-3  2022-reclamacoes-4
2021-eev-exercises   eev-sly   angg   2021-cifuentes  2016-decio
eev-squeak     material-para-C2   material-para-C2-e-C3
blogme-class   2023-hacking-lpegrex   2023-quinet     Show2
labinfo   campanha   que-bobagem  brincadeira   eev-lpeg
emacsconf2023  find-maximanode  find-maximamsg  eev-emaxima
blogme3-sandwiches   Repl3    lua-repl-prefix   2023-palestine
emacsconf2023-repls    eepitch-and-org-sessions
emacsconf2023-repls-b  2023-eev-git  find-luaso-links
2024-emacs-windows     2024-monitoria   2024-find-lgreps
2024-emacs-windows-2   2024-oficina-maio
2024-freaks  2024-rcd  2024-emacsconf-wiki      alc-o-fim-de-israel
2024-rdd     2024-forumppg-1   2024-find-subed-mpv-links   eev-lean4
2024-lean4-oficina-0

]]


-- find_xxx_intros (to ".find_xxx_intros")
-- (find-blogme3 "angglisp.lua" "find_xxx_intros")


-- almanaq  (to ".almanaq")
-- Almanaq  Capa  Editorial  Amfp  Artigos   Lapin  Sergio
--[[
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
A=(Almanaq Capa Editorial Amfp Artigos Lapin Sergio)
AB=(Almanaq.blogme Capa.blogme Editorial.blogme Amfp.blogme Artigos.blogme Lapin.blogme Sergio.blogme)
AH=(Almanaq.html   Capa.html   Editorial.html   Amfp.html   Artigos.html   Lapin.html   Sergio.html  )
cd ~/TH/   && laf $AB
cd ~/TH/L/ && laf $AH
cd ~/TH/   && zip /tmp/pen/almanaq-blogmes.zip $AB
cd ~/TH/L/ && zip /tmp/pen/almanaq-htmls.zip   $AH
# (find-man "zip")

--]]



-- otherblogmestems	(to ".otherblogmestems")
otherblogmestems = splitandsort [[
  blogme3/blogme3
]]


-- makefileauto_template  (to ".makefileauto_template")
makefileauto_template = [[

# TH_HTMLS = thstems     | _.html blogmestems| _.html otherblogmestems| _.html

TH_HTMLS = blogmestems| _.html otherblogmestems| _.html

A_HTMLS = anggtranslate| _.html thdeps     | TH/_.html

E_HTMLS = escriptstems | e/_.e.html

EI_HTMLS = eev_intros | _.html

TGZFILES = anggtranslate    | _   \
	   anggdonttranslate| _    \
	   eev_intros       | _ \
	   escriptstems     | e/_.e \
	   thdeps           | TH/_   \
	   thstems          | TH/_.th \
	   blogmestems      | TH/_.blogme \
	   otherblogmestems | _.blogme

ifeq ($(COPYING),1)
COPIES = $(TGZFILES)

anggtranslate|
_: $(HOME)/_
	$(CP) $< $@ && touch -c $@
anggdonttranslate|
_: $(HOME)/_
	$(CP) $< $@ && touch -c $@
eev_intros|
_: $(HOME)/_
	$(CP) $< $@ && touch -c $@
escriptstems|
e/_.e: $(ES)/_.e
	$(CP) $< $@ && touch -c $@
thdeps|
TH/_: $(THDIR)/_
	$(CP) $< $@ && touch -c $@
thstems|
TH/_.th: $(THDIR)/_.th
	$(CP) $< $@ && touch -c $@
blogmestems|
TH/_.blogme: $(THDIR)/_.blogme
	$(CP) $< $@ && touch -c $@
otherblogmestems|
_.blogme: $(HOME)/_.blogme
	$(CP) $< $@ && touch -c $@

else
COPIES =
endif

#Extra deps:
files.html: $(THDIR)/Files.tcl
debian.html: $(THDIR)/Debiandocs.tcl
escripts.html: $(THDIR)/Files.tcl

thstems|
_.html: TH/_.th
	$(GENERATE) $@ $<
blogmestems|
_.html: TH/_.blogme
	$(BLOGME3) -o $@ -i $<
otherblogmestems|
_.html: _.blogme
	$(BLOGME3) -o $@ -i $<
anggtranslate|
_.html: _
	$(BLOGME3) -o $@ -a2html $<
thdeps|
TH/_.html: TH/_
	$(BLOGME3) -o $@ -a2html $<
eev_intros|
_.html: _
	$(BLOGME3) -o $@ -ei2html $<
escriptstems|
e/_.e.html: e/_.e
	$(BLOGME3) -o $@ -a2html $<

]]

--[[
blogmestems|
TH/_.blogme.html: TH/_.blogme
	$(BLOGME3) -o $@ -a2html $<
--]]

if not QUIET then
  print(expandguillemets(makefileauto_template))
end

-- (find-angg "RUMI/")
-- (find-sh "cd ~/blogme3/; lua51 ~/blogme3/blogme3.lua -e 'require\"anggmake\"'")
-- (find-sh "cd ~/blogme3/; lua51 ~/blogme3/blogme3.lua -e 'require\"anggmake\"' | tee /tmp/Makefile.auto2")
-- (find-anggfile "LUA/lua50init.lua" 344)
-- (find-blogme3file "makefile.lua")
-- (find-man "tkdiff")

-- (find-anggfile "TH/Makefile")
-- (find-anggfile "TH/Makefile" "$(HOME)/blogme3/anggmake.lua")



--[[
 (eepitch-shell)
touch -c ~/blogme3/anggmake.lua
makeL

 (eepitch-shell)

cd ~/blogme3/; lua51 ~/blogme3/blogme3.lua -e 'require\"anggmake\"' \
  | tee /tmp/Makefile.auto2
sort ~/TH/L/TH/Makefile.auto | cut -b-80 > /tmp/Makefile.auto.sort
sort /tmp/Makefile.auto2     | cut -b-80 > /tmp/Makefile.auto2.sort
tkdiff /tmp/Makefile.auto.sort /tmp/Makefile.auto2.sort

--]]


--[[
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
QUIET = 1
dofile "anggmake.lua"
PPV(anggtranslate)

--]]
