-- preamble.lua: functions about the TeX definitions in the .dnt file.
-- This file:
--   http://angg.twu.net/dednat5/preamble.lua.html
--   http://angg.twu.net/dednat5/preamble.lua
--                    (find-dn5 "preamble.lua")
-- Author: Eduardo Ochs <eduardoochs@gmail.com>
-- Version: 2011may12
-- License: GPL3
--
-- Adapted from:
--   (find-dn4ex "edrx08.sty")
--   (find-dn4ex "edrxdnt.tex" "defded")
--   (find-dn4ex "edrxdnt.tex" "defdiag")
-- See also:
--   (find-dn4ex "edrxmain.tex")
--   (find-dn4ex "edrxmain41.tex")
--   (find-dn4ex "edrxmain41a.tex")

preamble = [==[
% These definitions - the "preamble" of a .dnt file - are from:
%   http://angg.twu.net/dednat5/preamble.lua.html
%   http://angg.twu.net/dednat5/preamble.lua
%                    (find-dn5 "preamble.lua")
%
\usepackage{proof}   % For derivation trees ("%:" lines)
\input diagxy        % For 2D diagrams ("%D" lines)
\xyoption{curve}     % For the ".curve=" feature in 2D diagrams
%
\def\defded#1#2{\expandafter\def\csname ded-#1\endcsname{#2}}
\def\ifdedundefined#1{\expandafter\ifx\csname ded-#1\endcsname\relax}
\def\ded#1{\ifdedundefined{#1}
    \errmessage{UNDEFINED DEDUCTION: #1}
  \else
    \csname ded-#1\endcsname
  \fi
}
\def\defdiag#1#2{\expandafter\def\csname diag-#1\endcsname{\bfig#2\efig}}
\def\defdiagprep#1#2#3{\expandafter\def\csname diag-#1\endcsname{{#2\bfig#3\efig}}}
\def\ifdiagundefined#1{\expandafter\ifx\csname diag-#1\endcsname\relax}
\def\diag#1{\ifdiagundefined{#1}
    \errmessage{UNDEFINED DIAGRAM: #1}
  \else
    \csname diag-#1\endcsname
  \fi
}
% End of the preamble.

]==]




-- dump-to: tests
--[==[
--]==]

-- Local Variables:
-- coding:             raw-text-unix
-- ee-anchor-format:   "%s"
-- End:
