-- My modifications to Marc's first version of forth.lua


--                   
--   ___  ___   ___  
--  / _ \/ _ \ / _ \ 
-- |  __/ (_) | (_) |
--  \___|\___/ \___/ 
--                   
-- (find-blogme4 "eoo.lua")
Class = {
    type   = "Class",
    __call = function (class, o) return setmetatable(o, class) end,
  }
setmetatable(Class, Class)
otype = function (o)
    local mt = getmetatable(o)
    return mt and mt.type or type(o)
  end


--  ____  _             _    
-- / ___|| |_ __ _  ___| | __
-- \___ \| __/ _` |/ __| |/ /
--  ___) | || (_| | (__|   < 
-- |____/ \__\__,_|\___|_|\_\
--                           
Stack = Class {
  type    = "Stack",
  __index = {
    push = function(s, c) s[#s + 1] = c end,
    pop  = function(s) local c = s[#s]; s[#s] = nil; return c end,
    peek = function(s) return s[#s] end,
    show = function(s)
      local length = #s
      io.write("<" .. tostring(length) .. "> ")
      for _,v in ipairs(s) do io.write(tostring(v) .. " ") end
      io.write("\n")
    end,
    swap = function(s)
      local a,b = s[#s], s[#s-1]
      s[#s] = b; s [#s-1] = a
    end
  },
}
new_stack  = function() return Stack {} end


-- From Marc's code
forth.memory.stack  = new_stack()
forth.memory.rstack = new_stack()
stack, rstack = forth.memory.stack, forth.memory.rstack




--  _____          _   _     ____       _           
-- |  ___|__  _ __| |_| |__ |  _ \ _ __(_)_ __ ___  
-- | |_ / _ \| '__| __| '_ \| |_) | '__| | '_ ` _ \ 
-- |  _| (_) | |  | |_| | | |  __/| |  | | | | | | |
-- |_|  \___/|_|   \__|_| |_|_|   |_|  |_|_| |_| |_|
--                                                  
-- (find-blogme4 "def.lua" "undollar" "wrap_f")
-- (find-blogme4 "def.lua" "BlogmeWord")
ForthPrim = Class {
  type    = "ForthPrim",
  __index = {
    wrap = function (FP) return "function ()\n"..FP.body.."\nend" end,
  },
}
ForthPrimFrom = function (primspec, wrap)
    local name, body = primspec:match("^%s*(%S+)%s(.*)")
    local FP = ForthPrim {name=name, body=body}
    FP.fun = assert(loadstring("return "..FP:wrap(), name))()
    return FP
  end


--      _       __            _           
--   __| | ___ / _|_ __  _ __(_)_ __ ___  
--  / _` |/ _ \ |_| '_ \| '__| | '_ ` _ \ 
-- | (_| |  __/  _| |_) | |  | | | | | | |
--  \__,_|\___|_| | .__/|_|  |_|_| |_| |_|
--                |_|                     
--
-- (find-blogme4 "def.lua" "def")
defprim = function (primspec) return ForthPrimFrom(primspec) end

--[[
defprim = function (primspec)
    local name, body = primspec:match("^%s*(%S+)%s(.*)")
    local code = "function ()\n"..body.."\nend"
    local fun = assert(loadstring("return "..code, name))()
    _F[name] = fun
  end
--]]





--             _           _ _   _                
--  _ __  _ __(_)_ __ ___ (_) |_(_)_   _____  ___ 
-- | '_ \| '__| | '_ ` _ \| | __| \ \ / / _ \/ __|
-- | |_) | |  | | | | | | | | |_| |\ V /  __/\__ \
-- | .__/|_|  |_|_| |_| |_|_|\__|_| \_/ \___||___/
-- |_|                                            

defprim [[ bye    forth.bye = true                                    ]]
defprim [[ .      print(stack:pop())                                  ]]
defprim [[ .s     stack:show()                                        ]]
defprim [[ +      stack:push(stack:pop() + stack:pop())               ]]
defprim [[ *      stack:push(stack:pop() * stack:pop())               ]]
defprim [[ -      stack:swap(); stack:push(stack:pop() - stack:pop()) ]]
defprim [[ /      stack:swap(); stack:push(stack:pop() / stack:pop()) ]]
defprim [[ ,      heap.comma(stack:pop())                             ]]
defprim [[ dup    stack:push(stack:peek())                            ]]
defprim [[ drop   stack:pop()                                         ]]
defprim [[ swap   stack:swap()                                        ]]
defprim [[ :      forth.prim.colon()                                  ]]
defmacro [[ ;     forth.prim.scolon()                                 ]]

defprim [[ doNext  forth.memory.ip = rstack:pop()                     ]]
defprim [[ lit     local literal_cell = forth.memory.ip + 1
                   stack:push(heap.fetch(literal_cell))
                   forth.memory.ip = literal_cell                     ]]
defprim [[ jmp     local target_address = heap.fetch(forth.memory.ip + 1)
                   forth.memory.ip = target_address - 1               ]]






--[[
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
userocks()
chdir "~/duoforths/"
require "forth"

--]]



print "(return)"
do return end
print "(after return)"

------------- the rest is ignored ------------------




