#######
#
# E-scripts e notas sobre o curso de Lua em Curitiba
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/04lua.e>
#           or at <http://angg.twu.net/e/04lua.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######







#####
#
# eelua
# 2004aug02
#
#####

(find-stringw "str!" "bufn!")

-- (find-angg ".emacs" "eeb-luaw")

--
-- (eeb-luaw)
print("Hello", 2)
print("Hello" .. 2)
--



# (find-es "lua")
# (find-es "lua5")
# (find-lua50ref "")







#####
#
# ementa
# 2004aug02
#
#####





mail -s 'curso sobre Lua (atrasadissimo!)' email@dvalois.net <<'%%%'
Oi Djalma,

Eu estourei o prazo que vocÃª me deu em quase uma semana e imagino que
as chances de eu ainda poder dar o curso em Curitiba sÃ£o
pequenas... eu sÃ³ consegui terminar toda a parte cabeluda dos cursos
que eu dei na UERJ (correÃ§Ãµes, notas de quem nÃ£o ficou em prova final,
etc) na sexta, Ã s 3:00hs da manhÃ£...

De qualquer modo aqui vÃ£o os dados do curso. Tomara que role. ZilhÃµes
de desculpas pelo atraso, abraÃ§Ã£o,

  Edrx

--snip--snip--


TÃ­tulo: Curso de Lua

Resumo:

Uma "introduÃ§Ã£o em profundidade" Ã  linguagem de programaÃ§Ã£o Lua. Como
a linguagem Ã© bastante simples (o manual de referÃªncia completo,
incluindo descriÃ§Ã£o de todas as funÃ§Ãµes e da API em C, tem 65
pÃ¡ginas), serÃ¡ possÃ­vel abordar todos os aspectos principais da
linguagem, e mais algumas extensÃµes, ferramentas, e vÃ¡rias tÃ©cnicas de
uso.

Ementa:

* Instalando e rodando o Lua
* O nÃºcleo do Lua:
  * Tipos de dados; expressÃµes e statements. Sintaxe. ";"s implÃ­citos.
  * VariÃ¡veis globais e locais; escopo.
  * Tabelas associativas; como arrays, classes e variÃ¡veis globais sÃ£o
    implementados via tabelas.
  * FunÃ§Ãµes como objetos; closures; blocos de cÃ³digo; propagaÃ§Ã£o de
    erros.
* Bibliotecas padrÃ£o:
  * Suporte a I/O e arquivos.
  * dofile, dostring e require.
  * OperaÃ§Ãµes sobre tabelas; modos de percorrer tabelas.
  * OperaÃ§Ãµes sobre strings; regexps em Lua.
  * Carregando bibliotecas extras com loadlib.
* Algumas bibliotecas e extensÃµes: bitlib, pcre, posixlib, cgilua.
* As entranhas do Lua:
  * A biblioteca "debug".
  * Byte-compilaÃ§Ã£o, a mÃ¡quina virtual interna do Lua, a pilha.
  * Rodando o Lua passo a passo com gdb; examinando o conteÃºdo da
    pilha. Seguindo passo a passo algumas funÃ§Ãµes Lua definidas em C.
    A API do Lua.
  * Executando scripts e funÃ§Ãµes Lua a partir de C.
* Uma ferramenta para ligar Lua e C mais facilmente: tolua.

PrÃ©-requisitos (aluno): inglÃªs tÃ©cnico bÃ¡sico (para entender a
documentaÃ§Ã£o), alguma familiaridade com C (para quem quiser acompanhar
a parte final do curso).

PrÃ©-requisitos (sala): nenhum.

Carga horÃ¡ria: mÃ­nimo de 9hs, mÃ¡ximo de 16hs.


Bibliografia:

http://www.lua.org/ftp/refman-5.0.ps.gz
http://www.lua.org/pil/
http://umn.dl.sourceforge.net/sourceforge/lua-users/shortref-d2.pdf
http://umn.dl.sourceforge.net/sourceforge/lua-users/luaapiref-d1.pdf


(Obs: se for possÃ­vel colocar um link para
<http://www.lua.org/ftp/refman-5.0.ps.gz> no resumo do curso vai ser
otimo).

--snip--snip--

P.S.: depois eu mando a url de onde eu estou pondo o material do curso
(scripts de compilaÃ§Ã£o, programas-exemplo, etc). Por enquanto tem
pouca coisa lÃ¡, o material antigo que eu vou reciclar estÃ¡ espalhado,
e o novo, Ã³bvio, estÃ¡ sendo feito... [], Edrx
%%%




# http://www.gnus.com.br/




As grandes esquisitices do Lua:
* funÃ§Ãµes podem retornar vÃ¡rios valores
* tabelas podem ser indexadas por qualquer coisa
* arrays e classes sÃ£o implementados usando tabelas
* funÃ§Ãµes capturam variÃ¡veis locais e viram closures

Esquisitices mÃ©dias:
* o nÃºcleo bÃ¡sico da linguagem Ã© mÃ­nimo e nÃ£o inclui nem mesmo suporte
  a arquivos, o interpretador, ou operaÃ§Ãµes bit a bit.
* muitos usuÃ¡rios sabem como o Lua funciona por dentro - vide cÃ³digo
  em C, power patches, virtual machines, debug interface.


cd $ES
anonftp angg.twu.net 'cd ~/public_html/e/' 'put 04lua.e' quit
# http://angg.twu.net/e/04lua.e





  Lista final de pacotes (2004aug20):
emacs21 zsh lua50 lua50-doc
liblua50-dev liblualib50-dev
erc w3m-el
expect
emacs21-el elisp-manual
libreadline4-dev
build-essential
mgp

(code-ps "luarefcard"
  "$S/http/umn.dl.sourceforge.net/sourceforge/lua-users/shortref-d2.pdf")
(code-ps "luaapirefcard"
  "$S/http/umn.dl.sourceforge.net/sourceforge/lua-users/luaapiref-d1.pdf")

(find-luarefcardpage 1)



#  Local Variables:
#  coding:               utf-8-unix
#  End:
