#######
#
# E-scripts sobre a oficina "Introdução ao Software Livre" (2021).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/2021-oficina.e>
#           or at <http://angg.twu.net/e/2021-oficina.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.M-3-M-e»		(to "M-3-M-e")
# «.emacs-lisp-mode»	(to "emacs-lisp-mode")
# «.wget.exe»		(to "wget.exe")
# «.mateus-marques»	(to "mateus-marques")
# «.julha»		(to "julha")
# «.daison»		(to "daison")
# «.2021-oficina-2»	(to "2021-oficina-2")



  http://angg.twu.net/2021-oficina.html
  http://angg.twu.net/2021-oficina/setup.el
  http://angg.twu.net/2021-oficina/wget.exe
  http://angg.twu.net/2021-oficina/README.html
  http://angg.twu.net/2021-oficina/README
          (find-angg "2021-oficina/README")



#####
#
# M-3 M-e
# 2021oct06
#
#####

# «M-3-M-e»  (to ".M-3-M-e")
# Moved to:
# (find-escripts-intro "7. Sequences of links")
# (find-escripts-intro "7. Sequences of links" "(find-eev-quick-intro")



  (find-eev-quick-intro "2. Evaluating Lisp")
  (find-eev-quick-intro "2. Evaluating Lisp" "M-0 M-e")
  (find-eev-quick-intro "4.2. `find-ekey-links' and friends")
       (eek "M-h M-k  M-e")
       (eek "M-h M-k  M-e  ;; ee-eval-sexp-eol")
  (find-eek "M-h M-k  M-e  ;; ee-eval-sexp-eol")
  (find-eek "M-h M-k  M-e  ;; ee-eval-sexp-eol" "(find-efunction ')")
             (find-efunction 'ee-eval-sexp-eol)
             (find-efunction 'ee-eval-sexp-eol "3:")
             (eek "2*<up> M-3 M-e")

  (find-emacs-keys-intro "6. Windows")
  (find-emacs-keys-intro "6. Windows" "L|R")

  (find-eev-intro)
  (find-eev-intro "M-5 M-0 M-j")
  (find-eev-intro "(find-multiwindow-intro)")
  (find-multiwindow-intro)

  (find-wset "13o_2o2o23oo33ooo"  '(find-ebuffer "B"))
  (find-wset "13o_2o2o23oo33ooo+" '(find-ebuffer "B"))
  (find-2a nil '(find-efunction 'ee-eval-sexp-eol))
  (find-2b nil '(find-efunction 'ee-eval-sexp-eol))




#####
#
# emacs-lisp-mode
# 2021oct06
#
#####

# «emacs-lisp-mode»  (to ".emacs-lisp-mode")

  (find-emacs-keys-intro)
  (find-emacs-keys-intro "More about modes:")
  (find-enode "Major Modes")
  (find-enode "Choosing Modes")
  (find-enode "Choosing Modes" "based on the file name")
  (find-enode "Programs" "Highlight program syntax")
  (find-enode "Programs" "Highlight program syntax" "Font Lock")
  (find-enode "Font Lock" "comments, strings, and function names")

  (find-enode "Choosing Modes" "auto-mode-alist")
  (eek "M-h M-v    auto-mode-alist")
  (find-evardescr 'auto-mode-alist)
  (find-evardescr 'auto-mode-alist "emacs-lisp-mode")
  (find-evariable 'auto-mode-alist)
  (find-elnode "Index" "* auto-mode-alist:")

  (eek "M-h M-v    major-mode")
  (find-evardescr 'major-mode)
  (find-enode "Variable Index" "* major-mode:")




#####
#
# wget.exe
# 2021oct07
#
#####

# «wget.exe»  (to ".wget.exe")
# (find-es "w32" "wget-1.21.2-win64")
# (find-twusfile "2021-oficina/")
# (find-twupfile "2021-oficina/")

• (eepitch-shell)
• (eepitch-kill)
• (eepitch-shell)
mkdir -p ~/bin/
cd       ~/bin/
wget http://angg.twu.net/2021-oficina/wget.exe
# Downloaded 5221816 bytes
./wget.exe --help


firefox --help
google-chrome --help
mpv --help
wget --help




#####
#
# Settings pro Mateus Marques 
# 2021nov02
#
#####

# «mateus-marques»  (to ".mateus-marques")
# https://github.com/emanuelep57/ArchoLinux-Bspwm

;; (find-eev "eev-beginner.el")
(require     'eev-beginner)
;; (find-eev "eev-on-windows.el")
(require     'eev-on-windows)

(setq ee-googlechrome-program "google-chrome-stable")
(ee-use-find-youtube-video)
(ee-use-find-angg-es-remote)

;; Tests:
;; (find-eev-quick-intro "3.1. Non-elisp hyperlinks")
;; (find-googlechrome "http://www.lua.org/start.html")
;; (find-eev-quick-intro "6. Controlling shell-like programs")
;; (find-eev-quick-intro "6. Controlling shell-like programs" "[Video links:]")

;; (find-fline "~/elisp/")
;; (find-fline "~/elisp/" "rcirc.el")
(load "~/elisp/rcirc.el")
;; (find-rcirc-intro "1. The example that I use in workshops")



• (eepitch-shell)
• (eepitch-kill)
• (eepitch-shell)
mkdir -p ~/elisp/
cd       ~/elisp/
rm -fv rcirc.el
wget http://angg.twu.net/2021-oficina/rcirc.el




#####
#
# Settings pra julha
# 2021nov02
#
#####

# «julha»  (to ".julha")
# (find-es "eev" "eev-on-windows-julha")
# (find-eev "eev-on-windows.el" "how-to-test-this")
# (find-eev "eev-on-windows.el" "basic-tests")
# (find-eev "eev-on-windows.el" "ee-use-windows")
# (find-eev "eev-audiovideo.el" "ee-use-find-youtube-video")

(require 'eev-beginner)
(require 'eev-on-windows)
(setenv "FIREFOXDIR"      "c:/Program Files/Mozilla Firefox")
(setenv "MPVDIR"          "c:/Users/User/Desktop")
(defalias 'find-pdf-page 'find-firefox-page)
(setq ee-find-youtube-video-program 'find-firefox)




#####
#
# Settings pro daison
# 2021nov06
#
#####

# «daison»  (to ".daison")

(require 'eev-beginner)
(require 'eev-on-windows)
(setenv "FIREFOXDIR" "c:/Users/Daison/AppData/Local/Mozilla Firefox")
(setq ee-find-youtube-video-program 'find-firefox)


(find-escripts-intro "6. Tutorials")
(find-escripts-intro "7. Sequences of links")

(find-eev-quick-intro "6. Controlling shell-like programs")




#####
#
# Material pro video "2021-oficina-1"
# 2021nov11
#
#####

# «2021-oficina-1»  (to ".2021-oficina-1")

    Como instalar o eev no Emacs
    ============================
     Eduardo Ochs
     5/nov/2021




         Este é um vídeo para a:
        
        Oficina de Software Livre
        do sábado, 6/nov/2021
        
         que na verdade vai ser uma:
        
        Oficina de Emacs e Eev
         principalmente para
          usuários de Windows

        Dicas: C-tecla = control-tecla
               M-tecla = alt-tecla
                         (pronúncia: meta-tecla)




#####
#
# Material pro video "2021-oficina-2"
# 2021nov11
#
#####

# «2021-oficina-2»  (to ".2021-oficina-2")
# (find-angg "elisp/emacsconf2021.el")
# (find-angg ".emacs.videos" "oficina2021b")
# (find-eev-exercises-intro)

    Criar e guardar links (1)
    =========================
    (^ exercícios de)
    
      Eduardo Ochs
      9/nov/2021
    
    
       Este é um vídeo para a:
    
      Oficina de Software Livre
      do sábado, 6/nov/2021
    
       que na verdade foi uma:
    
      Oficina de Emacs e eev
       principalmente para
        usuários de Windows




    
    
      Exercícios:
        1. copiar alguns links do M-j
        2. copiar alguns links do M-2 M-j
        3. copiar alguns (eek "M-h M-k ...")s
        4. ir pro tutorial sobre o M-h M-3
        5. copiar um dos links pro vídeo
        6. ir pro código fonte
        7. copiar o link pro código fonte






#  Local Variables:
#  coding:               utf-8-unix
#  End:
