#######
#
# E-scripts on MuP21/F21 simulators & emulators.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/21.e>
#           or at <http://angg.twu.net/e/21.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





#####
#
# P21intro
# 2000may30
#
#####

# (code-c-d "ultrat" "$S/http/www.ultratechnology.com/")

# (find-ultratfile "")
# (find-ultratw3 "p21fch12.html" "MINIMAL FORTH METACOMPILER")
# (find-ultratw3 "p21fchp9.html" "P21Forth Assembler.")

# (find-ultratw3 "")




######
#
# F21 simulator
# 1999????
#
######

mkdir /D/zip/
cp -iv /snarf/http/www.dnai.com/~jfox/*.zip /D/zip
cp -iv /snarf/http/www.ultratechnology.com/f21emu/f21emu12.zip /D/zip

mkdir \4th_1970 ^ cd \4th_1970 ^ pu \zip\4th_1970.zip
mkdir \emubmp1  ^ cd \emubmp1  ^ pu \zip\emubmp1.zip
mkdir \emudemo1 ^ cd \emudemo1 ^ pu \zip\emudemo1.zip
mkdir \emudemo2 ^ cd \emudemo2 ^ pu \zip\emudemo2.zip
mkdir \emudemo4 ^ cd \emudemo4 ^ pu \zip\emudemo4.zip
mkdir \f21emu12 ^ cd \f21emu12 ^ pu \zip\f21emu12.zip
mkdir \ok101    ^ cd \ok101    ^ pu \zip\ok101.zip
mkdir \s21      ^ cd \s21      ^ pu \zip\s21.zip
mkdir \usersman ^ cd \usersman ^ pu \zip\usersman.zip

cp 

# (find-fline "/D/")
# (find-fline "/D/f21emu12/f21emu.htm" "V key")
# (find-fline "/D/f21emu12/f21emu.htm" "F21.ROM")
# (find-fline "/D/ok101/ok16a.seq")

cd /D/f21emu12/
agrep LOAD * | l

# (find-fline "/D/f21emu12/sim-f21.seq" "No file to LOAD!")

cd /D/usersman/
for i in apendix1 apendix2 apendix3 intro intro2 p21forth suplemnt; do
  catdoc $i.doc > $i.txt
done
# (find-fline "/D/usersman/")



cd /snarf/http/www.dnai.com/~jfox/
for i in *.zip; do unzip -L -d /D $i; done

/snarf/http/www.ultratechnology.com/f21emu/f21emu12.zip





#####
#
# GForth's MISC simulator
# 2000jun29
#
#####

# (find-es "forth" "gforth-0.4")

pdsc $SDEBIAN/dists/potato/main/source/interpreters/gforth_0.4.0-2.dsc
find * -type f | sort > .files
grep '\.fs$' .files   > .files.fs

# (find-gfsrcfile "")
# (find-gfsrcfile "arch/")
# (find-gfsrcfile "arch/misc/")
# (find-gfsrcfile "arch/misc/README")

# Seems to be for another chip



#####
#
# savant
# 2000aug20
#
#####

Pgrepp m/vhdl/i |& l

# (find-status "savant")
# (find-vldifile "savant.list")
# (find-fline "/usr/doc/savant/")

gv /usr/doc/savant/simulationManual.ps.gz

# (find-shttpw3 "www.ultratechnology.com/p16vhdl.htm")
# (find-fline "~/tmp/cpu24.vhd")

# (find-status "tyvis1")
# (find-vldifile "tyvis1.list")
# (find-fline "/usr/doc/tyvis1/")

# (find-status "tyvis1-dev")
# (find-vldifile "tyvis1-dev.list")
# (find-fline "/usr/doc/tyvis1-dev/")

gv /usr/doc/tyvis1-dev/tyvis.ps.gz


#
rm -Rv ~/tmp/vhdl/
mkdir  ~/tmp/vhdl/
cd     ~/tmp/vhdl/
cp -iv ~/tmp/cpu24.vhd .

#




#  Local Variables:
#  coding:               utf-8-unix
#  End:
