#######
#
# E-scripts about my account at angg.twu.net
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/angg.e>
#           or at <http://angg.twu.net/e/angg.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.very-old-notes»		(to "very-old-notes")
# «.timestamps»			(to "timestamps")
# «.anggpage-git»		(to "anggpage-git")
# «.angg-repo-xargs-test»	(to "angg-repo-xargs-test")
# «.angg-repo-xargs»		(to "angg-repo-xargs")
# «.twu-will-shut-down»		(to "twu-will-shut-down")
# «.other-files-on-twu»		(to "other-files-on-twu")





#####
#
# Notas antiquíssimas de quando o angg era a minha máquina de casa
# 1999? / 2021jan16
#
#####

# «very-old-notes»  (to ".very-old-notes")

I always keep at least two bootable partitions and loads of other
partitions with ... copies of CDs and some important backups (/big),
/usr/src, and local copies of things gathered from the internet
(/snarf).

Basic slink setting:

smail ao invés de exim,
zsh,
emacs19 (em geral sem emacs20),
expect,

patched wget,
agrep/glimpse,
slink netscape,
fetchmail,
updated apt,

# (find-es "debian0")




#####
#
# Partições no angg
#
#####

# (find-fline "/etc/fstab")

fdisk -l | sort | grep '^/dev/hd' | grep native
df | sort | grep '^/dev/hd'
cat /etc/fstab | sort | grep '^/dev/hd' | grep ext2
mount | sort | grep ext2

mount /hdc2
mount /hdc5
mount /hdd6






#####
#
# timestamps
# 2021jan17
#
#####

# «timestamps»  (to ".timestamps")
# (find-es "lua5" "luaposix-stat-hr")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
posix_sys_stat = require("posix.sys.stat")
posix          = require("posix")
stat      = posix_sys_stat.stat
mktime    = posix.mktime
strptime  = posix.strptime

-- "hr": "human-readable"
mtime_int = function (fname) return stat(fname).st_mtime end
mtime_hr  = function (fname) return int_to_hr(mtime_int(fname)) end
int_to_hr = function (timeint) return os.date("%F %T %z", timeint) end
ht_to_int = function (timehr) return mktime((posix.strptime(timehr, "%F %T %z"))) end

chdir "~/"
bigstr = ee_readfile "/tmp/.files"
for _,fname in ipairs(split(bigstr)) do
  printf("%-40s %s\n", fname, mtime_hr(fname))
end



#####
#
# anggpage-git
# 2021jan16
#
#####

# «anggpage-git»  (to ".anggpage-git")
# (find-angg "TH/Makefile" "echo-tgzfiles")
# (find-angg ".zshrc" "makeL")

# (find-fline "~/bigsrc/anggpage/")
# (code-c-d "anggpage" "~/bigsrc/anggpage/")
# (find-anggpagefile "")

# (find-angg "LUA/timestamps.lua" "files-and-timestamps")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/bigsrc/anggpage/
mkdir  ~/bigsrc/anggpage/
cd     ~/bigsrc/anggpage/

make -f ~/TH/Makefile echo-tgzfiles > /tmp/.files
make -f ~/TH/Makefile NEEDMAKEFILEAUTO=1 echo-tgzfiles > /tmp/.files

# (find-fline "/tmp/.files")

make -f ~/TH/Makefile COPYING=1 dirs
make -f ~/TH/Makefile COPYING=1 copies


alias makeR='mkdir ~/TH/R/; cd ~/TH/R/ &&
	               make -f ~/TH/Makefile COPYING=1'
alias makeL1='mkdir ~/TH/R/; cd ~/TH/R/ &&





#####
#
# angg-repo-xargs-test
# 2021feb04
#
#####

# «angg-repo-xargs-test»  (to ".angg-repo-xargs-test")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
makeLedrxtgz

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/angg-a/
mkdir  /tmp/angg-a/
cd     /tmp/angg-a/
tar -xvzf ~/TH/L/edrx.tgz

rm -Rv /tmp/angg-b/
mkdir  /tmp/angg-b/
cd     /tmp/angg-b/

cd     /tmp/angg-a/
cp -v --parents --update LUA/8queens.lua /tmp/angg-b/
cp -v --parents --update LUA/8queens.lua /tmp/angg-b/
touch                    LUA/8queens.lua
cp -v --parents --update LUA/8queens.lua /tmp/angg-b/

# (find-fline "/tmp/angg-b/")
# (find-es "unix" "xargs")

cat ~/.files \
  | xargs -L 100 \
  | xargs -d '\n' -I '{}' -- \
      echo cp -av --parents --update '{}' /tmp/angg-b/ \
  | tee /tmp/o

# (find-fline "/tmp/o")

cd /tmp/angg-a/
sh /tmp/o




#####
#
# angg-repo-xargs
# 2021feb04
#
#####

# «angg-repo-xargs»  (to ".angg-repo-xargs")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/angg-repo/")
rm -Rv ~/usrc/angg-repo/
mkdir  ~/usrc/angg-repo/
cd     ~/usrc/angg-repo/

cd ~/usrc/angg-repo/
make -f ~/TH/Makefile dirs

# (find-man "1 cp")




#####
#
# twu-will-shut-down
# 2023jan17
#
#####

# «twu-will-shut-down»  (to ".twu-will-shut-down")
# https://mail.google.com/mail/u/0/#search/jessica/FMfcgzGrcFbggmhdVNwGgGgrmBLLPxvg
# (find-fline "~/LOGS/2023jan16.sr.ht")

Just wanted to make sure you saw this...

---------- Forwarded message ----------
Date: Sat, 14 Jan 2023 03:15:11 -0500 (EST)
From: jblank@twu.net
To: Edrx <edrx@twu.net>, Mrr <mrr@twu.net>, otto@twu.net,
     fly747 <fly747@twu.net>
Subject: TWU IS BEING PERMANENTLY SHUT DOWN. Please respond.

Hello old friends.

It's been 25 years now (yes, TWU was founded in 1998), and I'm finally ready to
hang up my hat.

TWU will be terminated at the end of its next billing cycle: FEBRUARY 15.

I will, of course, provide any necessary assistance in migration.

Please do respond to let me know this message has been received. I'll chase
down anyone who hasn't responded in a day or two... I want to make
sure you have time to make plans to move your stuff.

Best,

Jessica/Tinker



#####
#
# other-files-on-twu
# 2023jan30
#
#####

# «other-files-on-twu»  (to ".other-files-on-twu")

 (eepitch-Twu)
 (eepitch-kill)
 (eepitch-Twu)
cd ~/slow_html/
ls
find .* * | sort | tee ~/ofiles_slow | wc

cd ~/public_html/
ls
find .* * | sort | tee ~/ofiles_public | wc

cd ~/
ls
find .* * | sort | tee ~/ofiles | wc

tar -tf ~/edrx.tar | head -n 20
tar -tf ~/edrx.tar | sort | tee ~/ofiles_tar | wc

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/twufiles/")
rm -Rv /tmp/twufiles/
mkdir  /tmp/twufiles/
cd     /tmp/twufiles/
Scp-np \
  edrx@angg.twu.net:ofiles \
  edrx@angg.twu.net:ofiles_slow \
  edrx@angg.twu.net:ofiles_public \
  edrx@angg.twu.net:ofiles_tar \
  .

cd
ls


 (eepitch-Twu)
 (eepitch-kill)
 (eepitch-Twu)
rm -Rfv ~/tmp/emacs-cvs/
rm -Rfv ~/tmp/ulocal/
rm -Rfv ~/usrc/lpeg*
rm -Rfv ~/usrc/lua*
rm -Rfv ~/usrc/rcirc/
rm -Rfv ~/usrc/zsh/
rm -Rfv ~/www.debian.org/
rm -Rfv ~/hurdwiki/





#  Local Variables:
#  coding:               utf-8-unix
#  End:
