#######
#
# E-scripts on arduino.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/arduino.e>
#           or at <http://angg.twu.net/e/arduino.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.debian»		(to "debian")
# «.debian-examples»	(to "debian-examples")
# «.IDE»		(to "IDE")
# «.ttyACM0»		(to "ttyACM0")
# «.forths-for-arduino»	(to "forths-for-arduino")
# «.amforth»		(to "amforth")
# «.asforth»		(to "asforth")
# «.myforth-arduino»	(to "myforth-arduino")


# https://www.arduino.cc/
# https://m.youtube.com/watch?v=QX1OS7p98kU
# https://www.arduino.cc/en/Main/FAQ






#####
#
# debian
# 2019nov18
#
#####

# «debian» (to ".debian")
# https://wiki.debian.org/Arduino
# (find-zsh "installeddebs | sort | grep arduino")
# (find-zsh "availabledebs | sort | grep arduino")
# https://linuxhint.com/install_arduino_debian_ubuntu/
# https://www.circuidipity.com/arduino-ide-debian/
# https://playground.arduino.cc/linux/debian/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti arduino arduino-mk

# (find-status   "arduino")
# (find-vldifile "arduino.list")
# (find-udfile   "arduino/")
# (find-status   "arduino-core")
# (find-vldifile "arduino-core.list")
# (find-udfile   "arduino-core/")
# (find-status   "arduino-mk")
# (find-vldifile "arduino-mk.list")
# (find-udfile   "arduino-mk/")




#####
#
# Examples coming in the Debian packages
# 2019nov18
#
#####

# «debian-examples» (to ".debian-examples")
# (find-udfile "arduino-core/examples/")
# (find-udfile "arduino-core/examples/01.Basics/")
# (find-udfile "arduino-core/examples/01.Basics/Blink/Blink.ino")

# (find-sh "find /usr/share/arduino/libraries -type d")
# (find-sh "find /usr/share/arduino/libraries -type d | grep examples")
# (find-sh "find /usr/share/doc/arduino-core -type d | grep examples")
# (find-sh "find /usr/share/doc/arduino-mk -type d | grep examples")

# https://www.arduino.cc/en/Reference.PinMode
# https://www.arduino.cc/reference/en/language/functions/digital-io/digitalwrite/



#####
#
# ttyACM0
# 2019nov24
#
#####

# «ttyACM0» (to ".ttyACM0")
# https://arduino.stackexchange.com/questions/19648/difference-between-dev-ttyacm0-and-dev-ttys0-arduino-ide-ports-under-linux
# https://askubuntu.com/questions/646254/arduino-serial-port-com1-problem
# After plugging the arduino board lsusb and dmesg show this:

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
lsusb
sudo dmesg

Bus 006 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 008 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 007 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 004 Device 004: ID 2341:0043 Arduino SA Uno R3 (CDC ACM)
Bus 004 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 005 Device 001: ID 1d6b:0002 Linux Foundation 2.0 root hub
Bus 003 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 002 Device 003: ID 0a5c:2145 Broadcom Corp. BCM2045B (BDC-2.1) [Bluetooth Controller]
Bus 002 Device 002: ID 08ff:2810 AuthenTec, Inc. AES2810
Bus 002 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub
Bus 001 Device 001: ID 1d6b:0001 Linux Foundation 1.1 root hub

[490838.956280] usb 4-1: new full-speed USB device number 2 using uhci_hcd
[490839.169575] usb 4-1: New USB device found, idVendor=2341, idProduct=0043
[490839.169584] usb 4-1: New USB device strings: Mfr=1, Product=2, SerialNumber=220
[490839.169589] usb 4-1: Manufacturer: Arduino (www.arduino.cc)
[490839.169594] usb 4-1: SerialNumber: 55632313738351103142
[490839.391232] cdc_acm 4-1:1.0: ttyACM0: USB ACM device
[490839.392522] usbcore: registered new interface driver cdc_acm
[490839.392524] cdc_acm: USB Abstract Control Model driver for USB modems and ISDN adapters
[490931.036356] IPv6: ADDRCONF(NETDEV_UP): wlp2s0: link is not ready
[491246.028887] IPv6: ADDRCONF(NETDEV_UP): wlp2s0: link is not ready
[491318.412132] usb 4-1: USB disconnect, device number 2
[491329.920289] usb 4-1: new full-speed USB device number 3 using uhci_hcd
[491330.133187] usb 4-1: New USB device found, idVendor=2341, idProduct=0043
[491330.133195] usb 4-1: New USB device strings: Mfr=1, Product=2, SerialNumber=220
[491330.133200] usb 4-1: Manufacturer: Arduino (www.arduino.cc)
[491330.133205] usb 4-1: SerialNumber: 55632313738351103142
[491330.135376] cdc_acm 4-1:1.0: ttyACM0: USB ACM device

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

# Here's how to let my user (edrx) have access to ttyACM0:
# (find-man "8 usermod" "-a, --append")
# (find-man "8 usermod" "-G, --groups")

# sudo usermod -a -G dialout <username>
sudo usermod -a -G dialout edrx
groups

sudo chmod a+rw /dev/ttyUSB0
sudo chmod a+rw /dev/ttyACM0

# The easiest way to make sure that my user can access the new group
# after the "usermod" is by logging out from Mate and then logging in
# again.

# (find-fline "/dev/")
# (find-fline "/dev/" "ttyS0")
# (find-fline "/dev/" "ttyACM0")
# (find-sh "ls -lAF /dev/tty*" "ttyS0")




#####
#
# IDE
# 2019nov24
#
#####

# «IDE» (to ".IDE")
# (find-fline "/usr/bin/arduino")
# (find-man "1 arduino")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
arduino

# processing.app.SerialNotFoundException: Serial port 'COM1' not
# found. Did you select the right one from the Tools > Serial Port
# menu?

# File -> Examples -> 01.Basics -> Blink
# Tools -> Serial port -> ttyACM0
# (find-fline "~/.arduino/preferences.txt")
# (find-fline "~/.arduino/preferences.txt" "serial.port=" "/dev/ttyACM0")
# (find-fline "~/sketchbook/libraries/readme.txt")





#####
#
# forths-for-arduino
# 2019dec08
#
#####

# «forths-for-arduino» (to ".forths-for-arduino")
# https://forum.arduino.cc/index.php?topic=72103.0 several implementations
# https://forum.arduino.cc/index.php?topic=8838.0 finf
# https://github.com/lpereira/finf
# https://forth-standard.org/systems
# https://github.com/ForthHub/wiki/wiki/Forth-Systems

# https://github.com/doy/sonnet a Forth in Lua
# (find-sonnetfile "src/forth.lua")
# (find-sonnetfile "test/")
# (find-sonnetfile "test/test.snt")
# (find-sonnetfile "test/test2.snt")

https://learn.adafruit.com/alternative-languages-for-programming-SAMD-boards/forth



#####
#
# amforth
# 2019dec08
#
#####

# «amforth» (to ".amforth")
# http://amforth.sourceforge.net/
# https://sourceforge.net/p/amforth/code/HEAD/tree/trunk/
# https://github.com/search?p=2&q=amforth&s=updated&type=Repositories
# https://github.com/hickey/amforth
# https://github.com/lowfatcomputing/amforth
# https://github.com/bewest/amforth



#####
#
# asforth
# 2019dec08
#
#####

# «asforth» (to ".asforth")
# https://github.com/jeffmd/asforth
# https://www.reddit.com/r/arduino/comments/29e1mf/asforth_a_new_atmega_forth_for_speed_demons/



#####
#
# myforth-arduino
# 2019dec08
#
#####

# «myforth-arduino» (to ".myforth-arduino")
# https://github.com/CharleyShattuck/myforth-arduino
# (find-git-links "https://github.com/CharleyShattuck/myforth-arduino" "myfortharduino")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/myforth-arduino/
cd      ~/usrc/
git clone https://github.com/CharleyShattuck/myforth-arduino
cd      ~/usrc/myforth-arduino/

git branch --list -a
git for-each-ref
PAGER=cat git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/myforth-arduino/")
# (find-gitk  "~/usrc/myforth-arduino/")

# (code-c-d "myfortharduino" "~/usrc/myforth-arduino/")
# (find-myfortharduinofile "")
# (find-myfortharduinofile "HOWTO")




https://arduino-forth.com/
https://arduino-forth.com/article/FORTH_index
https://arduino-forth.com/article/FORTH_FlashForth_installerFlashForth
https://arduino-forth.com/article/FORTH_FlashForth_communiquerAvecFlashForth

https://www.arduino.cc/en/hacking/programmer

https://www.fsf.org/resources/hw/single-board-computers




#  Local Variables:
#  coding:               utf-8-unix
#  End:
