#######
#
# E-scripts on using Arxiv.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/arxiv.e>
#           or at <http://angg.twu.net/e/arxiv.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.jop-arxiv-zip»		(to "jop-arxiv-zip")
# «.jop-arxiv»			(to "jop-arxiv")
# «.ph1-arxiv»			(to "ph1-arxiv")
# «.biber»			(to "biber")
# «.texlive-2016»		(to "texlive-2016")
# «.texlive-2017»		(to "texlive-2017")
# «.texlive-2016-2017-email»	(to "texlive-2016-2017-email")
# «.texlive-2019»		(to "texlive-2019")
# «.texlive-2020»		(to "texlive-2020")
# «.pdflatex»			(to "pdflatex")
# «.mathjax»			(to "mathjax")
# «.orcid»			(to "orcid")
# «.hyperref»			(to "hyperref")
# «.biblatex-git»		(to "biblatex-git")
# «.biblatex-git-uninstall»	(to "biblatex-git-uninstall")
# «.biblatex-git-3.6»		(to "biblatex-git-3.6")
# «.biblatex-git-3.7»		(to "biblatex-git-3.7")
# «.biber-git»			(to "biber-git")
# «.biber-git-uninstall»	(to "biber-git-uninstall")
# «.biber-git-2.6»		(to "biber-git-2.6")
# «.biber-git-2.7»		(to "biber-git-2.7")
# «.biber-git-2.8»		(to "biber-git-2.8")
# «.favorite-conventions»	(to "favorite-conventions")
# «.trackbacks»			(to "trackbacks")
# «.j-to-X»			(to "j-to-X")
# «.arxiv-collector»		(to "arxiv-collector")


# (find-esgrep "grep --color -niH --null -e arxiv *.e")
# (find-es "dednat" "arxiv-yoneda")
# (find-es "luatex" "arxiv")
# (find-es "tex" "arxiv")




#####
#
# Producing a .zip file with all files needed to compile 2019J-ops.tex with pdflatex
# 2019dec03
#
#####

# «jop-arxiv-zip» (to ".jop-arxiv-zip")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/
ls 2019J-ops* | cat
ls 2019J-ops.* | cat

# (find-LATEXfile "2019.mk")
rm -rfv 2019J-ops.{aux,fls,log,out,toc,bbl,bcf,blg,run.xml}
lualatex 2019J-ops.tex
rm -rfv 2019J-ops.{aux,fls,log,out,toc,bbl,bcf,blg,run.xml}
pdflatex -record 2019J-ops.tex
pdflatex -record 2019J-ops.tex

# (find-latex-upload-links "2019J-ops" "/tmp/edrx-latex/")
#
cd ~/LATEX/
flsfiles-zip 2019J-ops.fls 2019J-ops.zip
#
rm -rfv /tmp/2019J-ops.zip
rm -rfv /tmp/edrx-latex/
cd /tmp/
cp -v ~/LATEX/2019J-ops.zip .
mkdir    /tmp/edrx-latex/
unzip -d /tmp/edrx-latex/ /tmp/2019J-ops.zip
cd       /tmp/edrx-latex/
pdflatex 2019J-ops.tex
pdflatex 2019J-ops.tex

# (find-xpdfpage "/tmp/edrx-latex/2019J-ops.pdf")




#####
#
# Submitting my paper J-operators (PH2) to arxiv
# 2019dec01
#
#####

# «jop-arxiv» (to ".jop-arxiv")
# (find-dednat6grep "grep --color -nH --null -e ifluatex *.tex")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/
# (find-LATEX "2019J-ops.tex" "make")
# (find-angg ".zshrc" "texlive-2017")
export PATH=/usr/local/texlive/2017/bin/x86_64-linux:$PATH
which lualatex
which biber

make -f 2019.mk STEM=2019J-ops veryclean
lualatex         2019J-ops.tex
biber            2019J-ops
pdflatex -record 2019J-ops.tex

# (find-LATEX "2019J-ops.tex")
# (find-LATEX "2019J-ops-arxiv.tex")
# (find-pdf-page "~/LATEX/2019J-ops.pdf")
# (find-pdf-text "~/LATEX/2019J-ops.pdf")
# (find-latex-upload-links "2019J-ops")

flsfiles-zip 2019J-ops.fls 2019J-ops.zip

# Test the .zip.
#
rm -rfv /tmp/2019J-ops.zip
rm -rfv /tmp/edrx-latex/
cd /tmp/
cp -v ~/LATEX/2019J-ops.zip .
mkdir    /tmp/edrx-latex/
unzip -d /tmp/edrx-latex/ /tmp/2019J-ops.zip
cd       /tmp/edrx-latex/

cp -v ~/LATEX/2019J-ops-arxiv.tex /tmp/edrx-latex/2019J-ops.tex

rm -rfv /tmp/2019J-ops-arxiv.zip
zip     /tmp/2019J-ops-arxiv.zip *

pdflatex 2019J-ops.tex
pdflatex 2019J-ops.tex

# (find-xpdfpage "/tmp/edrx-latex/2019J-ops.pdf")
# (find-fline    "/tmp/edrx-latex/2019J-ops.bbl" "2.7")
# (find-fline "/tmp/2019J-ops-arxiv.zip")




#####
#
# Submitting PH1 to arxiv
# 2020feb21
#
#####

# «ph1-arxiv» (to ".ph1-arxiv")
# (find-math-b-links "zhas-for-children-2" "2017planar-has-1")
# (find-LATEX "2019planar-has-1-main.tex" "2019planar-has-1-main.zip")
# (ph1p)
# (ph1)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/
# (find-LATEX "2019J-ops.tex" "make")
# (find-angg ".zshrc" "texlive-2017")
export PATH=/usr/local/texlive/2017/bin/x86_64-linux:$PATH
which lualatex
which biber

make -f 2019.mk STEM=2019J-ops veryclean
lualatex         2019J-ops.tex
biber            2019J-ops
pdflatex -record 2019J-ops.tex



# (find-LATEXfile "2017planar-has-1.mk")
# (find-latex-upload-links "2017planar-has-1")
# (find-anggfile "LATEX/" "2017planar-has-1.tgz")

# Test the .zip.
# The e-script below downloads, unpacks and compiles the .zip in /tmp/edrx-latex/
#
rm -rfv /tmp/2017planar-has-1.zip
rm -rfv /tmp/edrx-latex/
cd /tmp/
cp -v ~/LATEX/2017planar-has-1.zip .
mkdir    /tmp/edrx-latex/
unzip -d /tmp/edrx-latex/ /tmp/2017planar-has-1.zip
cd       /tmp/edrx-latex/
lualatex 2017planar-has-1.tex
# (find-xpdfpage "/tmp/edrx-latex/2017planar-has-1.pdf")

% (defun u () (interactive) (find-latex-upload-links "2017planar-has-1"))







#####
#
# Using biber in papers submitted to arxiv
# 2019dec03
#
#####

# «biber» (to ".biber")

# https://tex.stackexchange.com/questions/181169/publishing-to-arxiv-using-biblatex-biber
# https://tex.stackexchange.com/questions/181169/publishing-to-arxiv-using-biblatex-biber/467471#467471 use texlive 2017
# https://tex.stackexchange.com/questions/358831/biblatex-and-arxiv-error
# https://tex.stackexchange.com/questions/380343/biblatex-and-biber-best-practice-for-submitting-to-arxiv?noredirect=1&lq=1
# https://twiki.cern.ch/twiki/bin/view/CLIC/ArXivNotes

https://lpetrov.cc/2017/12/tex-distributions-again/
https://lpetrov.cc/2017/12/tex-distributions/
https://tex.stackexchange.com/questions/320974/manual-install-of-previous-version-of-biber-biblatex-in-mactex-2016
https://tex.stackexchange.com/questions/472001/how-can-you-get-the-correct-bbl-version-for-arxiv-in-mactex
https://github.com/plk/biblatex/issues/663
https://github.com/plk/biblatex/wiki/biblatex-and-the-arXiv 
https://tex.stackexchange.com/questions/438449/distribute-latex-projects-with-correct-biber-version
https://tex.stackexchange.com/questions/410512/matching-biblatex-in-two-machines





#####
#
# texlive-2016
# 2020jan19
#
#####

# «texlive-2016» (to ".texlive-2016")
# (find-es "texlive" "texlive-from-isos")
# (find-angg ".zshrc" "texlive-2016")

# https://arxiv.org/help/faq/texlive
# -> "arXiv is now running under TeXLive 2016"

# https://www.tug.org/texlive/acquire.html
# https://www.tug.org/historic/
# http://ftp.math.utah.edu/pub/tex/historic/
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso.md5

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
export S=$HOME/snarf
mkdir -p $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/
cd       $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/
wget -nc  http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso
wget -nc  http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso.md5


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "$S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/")
cd $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/
md5sum -c texlive2016.iso.md5

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mkdir -p /tmp/loop
sudo umount /tmp/loop
sudo mount -o loop,ro \
  $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso \
  /tmp/loop

# (find-fline "/tmp/loop/")

cd /tmp/loop/
sudo ./install-tl
D
2
/usr/local/texlive/2016/texmf-local
7
~/.texlive2016/texmf
R
O
Y
R

# <D> directories:
#   TEXDIR (the main TeX directory):
#     /usr/local/texlive/2016
#   TEXMFLOCAL (directory for site-wide local files):
#     /usr/local/texlive/2016/texmf-local
#   TEXMFSYSVAR (directory for variable and automatically generated data):
#     /usr/local/texlive/2016/texmf-var
#   TEXMFSYSCONFIG (directory for local config):
#     /usr/local/texlive/2016/texmf-config
#   TEXMFVAR (personal directory for variable and automatically generated data):
#     ~/.texlive2016/texmf-var
#   TEXMFCONFIG (personal directory for local config):
#     ~/.texlive2016/texmf-config
#   TEXMFHOME (directory for user-specific files):
#     ~/.texlive2016/texmf
#
# <O> options:
#   [ ] use letter size instead of A4 by default
#   [X] allow execution of restricted list of programs via \write18
#   [X] create all format files
#   [X] install macro/font doc tree
#   [X] install macro/font source tree
#   [ ] create symlinks to standard directories
#   [ ] after install, use tlnet on CTAN for package updates

sudo umount /tmp/loop




#####
#
# texlive-2017
# 2020jan22
#
#####

# «texlive-2017» (to ".texlive-2017")
# (find-es "texlive" "texlive-from-isos")
# (find-fline "/usr/local/texlive/")
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2017/texlive2017.iso
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2017/texlive2017.iso.md5

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "$S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2017/")
cd $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2017/
md5sum -c texlive2017.iso.md5

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mkdir -p /tmp/loop
sudo umount /tmp/loop
sudo mount -o loop,ro \
  $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2017/texlive2017.iso \
  /tmp/loop

# (find-fline "/tmp/loop/")

cd /tmp/loop/
sudo ./install-tl
D
2
/usr/local/texlive/2017/texmf-local
7
~/.texlive2017/texmf
R
O
Y
R
I




#####
#
# texlive-2019
# 2021aug16
#
#####

# «texlive-2019»  (to ".texlive-2019")
# (find-es "texlive" "texlive-from-isos")
# (to "texlive-2016")
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2019/
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2019/texlive2019.iso
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2019/texlive2019.iso.md5

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "$S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2019/")
cd $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2019/
md5sum -c texlive2019.iso.md5

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mkdir -p /tmp/loop
sudo umount /tmp/loop
sudo mount -o loop,ro \
  $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2019/texlive2019.iso \
  /tmp/loop

# (find-fline "/tmp/loop/")

cd /tmp/loop/
sudo ./install-tl
D
2
/usr/local/texlive/2019/texmf-local
7
~/.texlive2019/texmf
R
O
Y
R
I

# (find-fline "/usr/local/texlive/2019/install-tl.log")




#####
#
# texlive-2020
# 2021aug16
#
#####

# «texlive-2020»  (to ".texlive-2020")
# (find-es "texlive" "texlive-from-isos")
# (to "texlive-2016")
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2020/
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2020/texlive2020.iso
# http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2020/texlive2020.iso.md5

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "$S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2020/")
cd $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2020/
md5sum -c texlive2020.iso.md5

 (eepitch-shell3)
 (eepitch-kill)
 (eepitch-shell3)
mkdir -p /tmp/loop
sudo umount /tmp/loop
sudo mount -o loop,ro \
  $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2020/texlive2020.iso \
  /tmp/loop

# (find-fline "/tmp/loop/")

cd /tmp/loop/
sudo ./install-tl
D
2
/usr/local/texlive/2020/texmf-local
7
~/.texlive2020/texmf
R
O
Y
R
I

# (find-fline "/usr/local/texlive/2020/install-tl.log")




#####
#
# My e-mail to the tex-live mailing list about installing texlive 2016 and 2017
# 2020apr15
#
#####

# «texlive-2016-2017-email» (to ".texlive-2016-2017-email")
# https://tug.org/pipermail/tex-live/2020-April/045392.html
# (find-esgrep "grep --color -nH --null -e 'export PATH=/usr/local/texlive/2017/' *.e")

A few months ago I had to install Texlive 2016 and Texlive 2017 in my
Debian box for a paper that uses biber and that I needed to upload to
arxiv... arxiv wouldn't run biber on it itself, so I had to generate a
.bbl using the right version of Texlive.

I took "executable notes" of everything that I did - in the sense of
<http://angg.twu.net/emacsconf2019.html> - and the commands that I
gave for Texlive 2016 were these (note that some lines are sent to the
shell and some others to install-tl):

--snip--snip--

export S=$HOME/snarf
mkdir -p $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/
cd       $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/
wget -nc  http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso
wget -nc  http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso.md5
md5sum -c  texlive2016.iso.md5

mkdir -p    /tmp/loop
sudo umount /tmp/loop
sudo mount -o loop,ro \
  $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/texlive2016.iso \
  /tmp/loop

cd /tmp/loop/
sudo ./install-tl
D
2
/usr/local/texlive/2016/texmf-local
7
~/.texlive2016/texmf
R
O
Y
R
I

--snip--snip--

To compile my paper with the old Texlive, what I did was:

  export PATH=/usr/local/texlive/2017/bin/x86_64-linux:$PATH
  which lualatex
  which biber

  # Some kind of "make clean", then:
  lualatex         2019J-ops.tex
  biber            2019J-ops
  pdflatex -record 2019J-ops.tex

I think that if half a dozen people could share their recipes for
installing old Texlives then we can consider that we've done our part,
and we can delegate the next steps to people who are more web-savvy
and more end-user-savvy than us...

  Cheers,
    Eduardo Ochs
    http://angg.twu.net/dednat6.html
    http://angg.twu.net/math-b.html
    http://angg.twu.net/emacsconf2019.html



#####
#
# Telling arxiv to process my .tex with pdflatex
# 2020jan22
#
#####

# «pdflatex» (to ".pdflatex")
# (find-LATEXfile "2019J-ops-arxiv.tex" "\\pdfoutput=1")
# https://arxiv.org/help/submit_tex

# Considerations for PDFLaTeX submissions
#
# arXiv fully supports and automatically recognizes PDFLaTeX. You can
# ensure pdflatex processing by setting the flag \pdfoutput=1 within
# the first 5 lines of the preamble of the main .tex file. You should
# not need any other special flag.




#####
#
# MathJax (for abstracts)
# 2020jan22
#
#####

# «mathjax» (to ".mathjax")
# https://meta.mathoverflow.net/questions/2314/using-mathjax-for-formating-bold-italics
# https://arxiv.org/help/mathjax
# https://arxiv.org/help/prep




#####
#
# orcid
# 2020feb06
#
#####

# «orcid» (to ".orcid")
# https://orcid.org/register
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgxwGDDrtMJMJzcLVQqBNKZNbVQzm
# https://orcid.org/my-orcid
# https://orcid.org/0000-0003-3854-9181

Add:
PH1,
Lua Gem,

Add:
https://tug.org/TUGboat/tb39-3/
http://www.lua.org/gems/





#####
#
# hyperref problems
# 2020jun28
#
#####

# «hyperref» (to ".hyperref")
# (find-LATEX "2020favorite-conventions.tex" "make-for-arxiv")
# (find-LATEXfile "2020favorite-conventions.tex" "{hyperref}")




#####
#
# biblatex-git
# 2020jun29
#
#####

# «biblatex-git» (to ".biblatex-git")
# (find-es "tex" "biblatex-git")
# https://github.com/plk/biblatex/wiki/biblatex-and-the-arXiv#bbl-files-in-arxiv-uploads
# (find-fline "~/texmf/tex/latex/biblatex/")
# (find-fline "~/texmf/tex/latex/biblatex/biblatex.sty" "\\def\\abx@version")

# «biblatex-git-uninstall»  (to ".biblatex-git-uninstall")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/texmf/biber/
rm -Rfv ~/texmf/bibtex/
rm -Rfv ~/texmf/doc/latex/biblatex/
rm -Rfv ~/texmf/tex/latex/biblatex/
cd      ~/usrc/biblatex/
obuild/build.sh uninstall   ~/texmf/

# «biblatex-git-3.6» (to ".biblatex-git-3.6")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biblatex/

export PAGER=cat
git for-each-ref
git checkout v3.6
git reset

obuild/build.sh help
obuild/build.sh build   3.6
obuild/build.sh install 3.6 ~/texmf/

# «biblatex-git-3.7» (to ".biblatex-git-3.7")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biblatex/

export PAGER=cat
git for-each-ref
git checkout v3.7
git reset

obuild/build.sh help
obuild/build.sh build   3.7
obuild/build.sh install 3.7 ~/texmf/

# (find-fline "~/usrc/")
# (find-fline "~/usrc/biblatex/")
# (find-gitk  "~/usrc/biblatex/")

# (code-c-d "biblatex" "~/usrc/biblatex/")
# (find-biblatexfile "")
# (find-biblatexsh "find * | sort")
# (find-biblatexfile "README.md" "obuild/build.sh")
# (find-biblatexfile "obuild/build.sh")
# (find-biblatexfile "obuild/test/examples/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biblatex/






#####
#
# biber-git
# 2020jun29
#
#####

# «biber-git» (to ".biber-git")
# (find-es "tex" "biber-2.8-from-git")
# (code-pdf-page "biber" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/biber/biber.pdf")
# (code-pdf-text "biber" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/biber/biber.pdf")
# (find-biberpage 5 "Biber version   Biblatex version")
# (find-bibertext 5 "Biber version   Biblatex version")
# (find-biberpage 5 "2.8             3.8")
# (find-bibertext 5 "2.8             3.8")

# «biber-git-uninstall»  (to ".biber-git-uninstall")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo rm -Rfv /usr/local/bin/biber
sudo rm -Rfv /usr/local/share/perl/5.28.1/Biber*
sudo rm -Rfv /usr/local/man/man3/Biber*

# «biber-git-2.6»  (to ".biber-git-2.6")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biber/
export PAGER=cat
git branch --list -a
git for-each-ref

git reset
git checkout v2.6

perl ./Build.PL          |& tee opb
./Build help
sudo ./Build fakeinstall |& tee obfi
sudo ./Build install     |& tee obi

w biber
export PATH=/usr/local/bin:$PATH
w biber
biber --version

# «biber-git-2.7»  (to ".biber-git-2.7")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biber/
export PAGER=cat
git branch --list -a
git for-each-ref

git reset
git checkout v2.7

perl ./Build.PL          |& tee opb
./Build help
sudo ./Build fakeinstall |& tee obfi
sudo ./Build install     |& tee obi

w biber
export PATH=/usr/local/bin:$PATH
w biber
biber --version

# «biber-git-2.8»  (to ".biber-git-2.8")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biber/
export PAGER=cat
git branch --list -a
git for-each-ref

git reset
git checkout v2.8

perl ./Build.PL          |& tee opb
./Build help
sudo ./Build fakeinstall |& tee obfi
sudo ./Build install     |& tee obi

w biber
export PATH=/usr/local/bin:$PATH
w biber
biber --version





#####
#
# The paper "On my favorite conventions..." on Arxiv
# 2020jun29
#
#####

# «favorite-conventions»  (to ".favorite-conventions")
# https://arxiv.org/submit/3247896/preview
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgxwJWXbnqLZBQkcXJgCbXdsldzdG
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgxwJWXbqFpFbVsHZFDsnQKgCfljv
# (find-LATEX "2020favorite-conventions.tex" "make-for-arxiv")



#####
#
# trackbacks
# 2020jul10
#
#####

# «trackbacks»  (to ".trackbacks")
# https://arxiv.org/help/trackback
# https://arxiv.org/abs/1612.09375



#####
#
# j-to-X
# 2021jul17
#
#####

# «j-to-X»  (to ".j-to-X")
# (find-LATEX "2021lindenhovius-j-to-X.tex")
# (find-LATEX "2021lindenhovius-j-to-X.tex" "arxiv")
# https://arxiv.org/submit/3842941
# https://arxiv.org/submit/3842941/view
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgzGkZQNNWTRJRHkPGqTzWWvMfKdK
# (linfp 1 "title")
# (linfa   "title")
# (linfa   "arxiv")



#####
#
# arxiv-collector - A small script to collect your LaTeX files for submission to the arXiv
# 2021dec11
#
#####

# «arxiv-collector»  (to ".arxiv-collector")
https://github.com/djsutherland/arxiv-collector



Ahmed Khaled:
"Managing a research workflow (bibliographies, note-taking, and arXiv)"
https://emacsconf.org/2021/talks/research/





https://tex.stackexchange.com/questions/450933/biblatex-v3-11-with-arxiv-how-fix-wrong-format-version-error
https://tex.stackexchange.com/questions/415703/which-biblatex-biber-version-produces-bbl-format-2-8?noredirect=1&lq=1
https://github.com/plk/biblatex/issues/663
https://github.com/plk/biblatex/wiki/biblatex-and-the-arXiv

http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/
http://ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/tlnet-final/install-tl-unx.tar.gz

# (find-texlive-links "20190809")
# (find-texlive-links "20170413")
# (find-fline "$S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/tlnet-final/")
# (find-fline "$S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/tlnet-final/install-tl-unx.tar.gz")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

rm -Rfv ~/usrc/install-tl-20170413/
mkdir   ~/usrc/
tar  -C ~/usrc/ -xvzf   $S/http/ftp.math.utah.edu/pub/tex/historic/systems/texlive/2016/tlnet-final/install-tl-unx.tar.gz
cd      ~/usrc/install-tl-20170413/
# sudo ./install-tl
sudo ./install-tl -select-repository







#  Local Variables:
#  coding:               utf-8-unix
#  End:
