#######
#
# E-scripts on asymptote.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://anggtwu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://anggtwu.net/e/asymptote.e>
#           or at <http://anggtwu.net/e/asymptote.e.html>.
#        See also <http://anggtwu.net/emacs.html>,
#                 <http://anggtwu.net/.emacs[.html]>,
#                 <http://anggtwu.net/.zshrc[.html]>,
#                 <http://anggtwu.net/escripts.html>,
#             and <http://anggtwu.net/>.
#
#######




# «.debian»		(to "debian")
# «.asymptote-git»	(to "asymptote-git")
# «.apexv4»		(to "apexv4")



https://github.com/vectorgraphics/asymptote/blob/master/base/asy-mode.el
https://tex.stackexchange.com/questions/688987/how-to-configure-emacs-for-asymptote
https://github.com/vectorgraphics/asymptote/blob/master/base/asy-mode.el



#####
#
# debian
# 2024apr18
#
#####

# «debian»  (to ".debian")
# (find-angg ".emacs" "asymptote")
# (find-status   "asymptote")
# (find-vldifile "asymptote.list")
# (find-udfile   "asymptote/")
# (find-status   "asymptote-doc")
# (find-vldifile "asymptote-doc.list")
# (find-udfile   "asymptote-doc/")
# file:////usr/share/doc/asymptote/html/index.html
# file:////usr/share/doc/asymptote/html/Index.html
# file:///usr/share/doc/asymptote/faq/index.html

# (find-node "(asymptote)Top")
# (find-node "(asymptote)Tutorial")
# (find-node "(asy-faq)Top")

(code-c-d      "asymptote" "/usr/share/doc/asymptote/" "asymptote")
(code-pdf-page "asymptote" "/usr/share/doc/asymptote/asymptote.pdf")
(code-pdf-text "asymptote" "/usr/share/doc/asymptote/asymptote.pdf")
;; (find-asymptotefile "")
;; (find-asymptotenode "")
;; (find-asymptotepage)
;; (find-asymptotetext)




#####
#
# asymptote-git
# 2024apr18
#
#####

# «asymptote-git»  (to ".asymptote-git")
# https://github.com/vectorgraphics/asymptote
# (find-git-links "https://github.com/vectorgraphics/asymptote" "asymptote")
# (code-c-d "asymptote" "~/usrc/asymptote/")
# (find-asymptotefile "doc/")

# (find-sh "locate asy-mode")

# (find-fline "/usr/local/texlive/2019/texmf-dist/asymptote/asy-mode.el")
# (load       "/usr/local/texlive/2019/texmf-dist/asymptote/asy-mode.el")
# (code-c-d "asymode" "/usr/local/texlive/2019/texmf-dist/asymptote/")
# (find-asymodefile "")
# (find-asymodefile "asy-mode.el")
# (find-eaproposf "^asy")





#####
#
# apexv4
# 2024apr18
#
#####

# «apexv4»  (to ".apexv4")
# (find-git-links "https://github.com/APEXCalculus/APEXCalculusV4" "apexv4")
# (code-c-d "apexv4" "~/usrc/APEXCalculusV4/")
# (find-apexv4file "")
# (find-apexv4file "text/10_Space_Intro.tex" "Quadric Surfaces")
# (find-apexv4file "figures/figquadric_parbBW.pdf")
# (find-apexv4file "figures/" "figquadric_parbBW.pdf")
# (find-fline "~/usrc/APEXCalculusV4/figures/" "figquadric_parb_3DBW.pdf")
# (find-fline "~/usrc/APEXCalculusV4/figures/figquadric_parb_3DBW.pdf")
# (find-apexv4file "figures/figquadric_par_3D.asy")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cp -v ~/usrc/APEXCalculusV4/figures/figquadric_parb_3DBW.pdf ~/LATEX/2024-1-C3/apex-paraboloid.pdf




#  Local Variables:
#  coding:               utf-8-unix
#  End:
