#######
#
# E-scripts on autoconf, automake, and M4.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/autoconf.e>
#           or at <http://angg.twu.net/e/autoconf.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.debian»		(to "debian")
# «.autoconf-doc»	(to "autoconf-doc")
# «.autoreconf»		(to "autoreconf")
# «.automake»		(to "automake")
# «.aclocal»		(to "aclocal")
# «.automake-git»	(to "automake-git")
# «.M4»			(to "M4")
# «.m4_pattern_allow»	(to "m4_pattern_allow")
# «.autoconf-git»	(to "autoconf-git")




#####
#
# autoconf in debian
# 2017ago10
#
#####

# «debian» (to ".debian")

# (find-zsh "installeddebs | sort | grep autoconf")
# (find-zsh "availabledebs | sort | grep autoconf")
# (find-status   "autoconf")
# (find-vldifile "autoconf.list")
# (find-udfile   "autoconf/")
# (find-man "1 autoconf")
# (find-man "1 autoheader")
# (find-man "1 autom4te")
# (find-man "1 autoreconf")
# (find-man "1 autoscan")
# (find-man "1 autoupdate")
# (find-man "1 config.guess")
# (find-man "1 config.sub")
# (find-man "1 ifnames")



#####
#
# autoconf-doc
# 2021dec12
#
#####

# «autoconf-doc»  (to ".autoconf-doc")
# (find-status   "autoconf-doc")
# (find-vldifile "autoconf-doc.list")
# (find-udfile   "autoconf-doc/")
# (find-autoconfnode "Top")
# (find-autoconfnode "autoconf Invocation")

# (find-status   "gnu-standards")
# (find-vldifile "gnu-standards.list")
# (find-udfile   "gnu-standards/")
# (find-node "(standards)Top")
# (find-node "(maintain)Top")



#####
#
# autoreconf
# 2019jul09
#
#####

# «autoreconf» (to ".autoreconf")
# (find-node "(autoconf)autoreconf Invocation")
# (find-autoconfnode "autoreconf Invocation")
# (find-autoconfnode "autoreconf Invocation" "--add-missing")



#####
#
# automake
# 2017ago10
#
#####

# «automake» (to ".automake")
# «aclocal» (to ".aclocal")
# https://en.wikipedia.org/wiki/Automake
# https://en.wikipedia.org/wiki/Autoconf
# https://en.wikipedia.org/wiki/GNU_Build_System
# (find-zsh "apt-file search automake")
# (find-zsh "apt-file search aclocal")
# (find-zsh "installeddebs | sort | grep automake")
# (find-zsh "availabledebs | sort | grep automake")
# (find-status   "automake")
# (find-vldifile "automake.list")
# (find-udfile   "automake/")
# (find-man "1 automake-1.15")
# (find-man "1 aclocal-1.14")
# (find-man "1 automake")
# (find-man "1 aclocal")
# (find-automakenode "")
# (find-automakenode "configure")
# (find-automakenode "aclocal Invocation")



#####
#
# automake-git
# 2021dec12
#
#####

# «automake-git»  (to ".automake-git")
# https://savannah.gnu.org/git/?group=automake
# https://git.savannah.gnu.org/cgit/automake.git
# (find-git-links "https://git.savannah.gnu.org/cgit/automake.git" "automake")
# (find-git-links "https://git.savannah.gnu.org/git/automake.git" "automakegit")
# (code-c-d "automakegit" "~/usrc/automake/")
# (find-automakegitfile "")
# (find-automakegitfile "INSTALL")
# (find-automakegitfile "bootstrap")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/automake/
cd      ~/usrc/
git clone https://git.savannah.gnu.org/git/automake.git
cd      ~/usrc/automake/

export PAGER=cat
git branch --list -a
git for-each-ref
git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/automake/")
# (find-gitk  "~/usrc/automake/")

# (code-c-d "automakegit" "~/usrc/automake/")
# (find-automakegitfile "")
# (find-automakegitfile "omi")
# (find-automakegitfile "omi" "ln '/usr/local/bin/automake'")

cd      ~/usrc/automake/
./bootstrap
./configure          |& tee oc
make                 |& tee om
sudo make install    |& tee omi

cd      ~/usrc/automake/
sudo make uninstall  |& tee omu

rehash
which automake
automake --version







#####
#
# M4
# 2019jul09
#
#####

# «M4» (to ".M4")
# https://en.wikipedia.org/wiki/M4_(computer_language)
# https://www.gnu.org/software/m4/
# (find-status   "m4")
# (find-vldifile "m4.list")
# (find-udfile   "m4/")




#####
#
# m4_pattern_allow
# 2017ago10
#
#####

# «m4_pattern_allow» (to ".m4_pattern_allow")

# configure.ac:6: error: possibly undefined macro: AM_INIT_AUTOMAKE
#       If this token and others are legitimate, please use m4_pattern_allow.
#       See the Autoconf documentation.
# configure.ac:8: error: possibly undefined macro: AM_SILENT_RULES
# configure.ac:18: error: possibly undefined macro: AC_DEFINE
# 
# https://unix.stackexchange.com/questions/18673/some-m4-macros-dont-seem-to-be-defined
# https://lists.gnu.org/archive/html/autoconf/2004-09/msg00215.html You should run aclocal first

# (find-autoconfnode "Forbidden Patterns")
# (find-autoconfnode "Automake")




#####
#
# Autoconf from git
# 2019jul09
#
#####

# «autoconf-git»  (to ".autoconf-git")
# https://www.gnu.org/software/autoconf/#downloading
# http://git.sv.gnu.org/r/autoconf.git
# https://askubuntu.com/questions/27677/cannot-find-install-sh-install-sh-or-shtool-in-ac-aux
# https://github.com/openstreetmap/Nominatim/issues/217
#   sudo apt-get install automake autoconf autoconf-archive pkg-config
    apti help2man

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/autoconf/
cd      ~/usrc/
git clone http://git.sv.gnu.org/r/autoconf.git
cd      ~/usrc/autoconf/

cd      ~/usrc/autoconf/
git reset
aclocal
automake --add-missing

./configure         |& tee oc
# Makefile.am:67: error: MAKE_CASE_SENSITIVE does not appear in AM_CONDITIONAL

make                |& tee om
sudo make uninstall |& tee omui
sudo make install   |& tee omi

# (find-fline "~/usrc/")
# (find-fline "~/usrc/autoconf/")
# (find-gitk  "~/usrc/autoconf/")

# (code-c-d "autoconf" "~/usrc/autoconf/")
# (find-autoconffile "")
# (find-autoconfgrep "grep --color -nH -e uninstall Makefile")






# (find-es "mtp" "simple-mtpfs")

# (find-fline "~/usrc/simple-mtpfs/")
# (find-fline "~/usrc/simple-mtpfs/configure")

https://autotools.info/index.html
https://news.ycombinator.com/item?id=39913905 Autoconf makes me think we stopped evolving too soon (rachelbythebay.com)





#  Local Variables:
#  coding:               utf-8-unix
#  End:
