#######
#
# E-scripts on blender.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/blender.e>
#           or at <http://angg.twu.net/e/blender.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.webm-support»	(to "webm-support")
# «.editing-videos»	(to "editing-videos")
# «.manual»		(to "manual")
# «.output-formats»	(to "output-formats")
# «.ffmpeg-video»	(to "ffmpeg-video")
# «.sintel»		(to "sintel")


apti blender

# (find-status   "blender")
# (find-vldifile "blender.list")
# (find-udfile   "blender/")
# (find-zsh "installeddebs | sort | grep blender")
# (find-zsh "availabledebs | sort | grep blender")

http://projects.blender.org/projects/bf-blender
http://www.blender.org/education-help
http://www.blender.org/education-help/quickstart/
http://www.blender.org/education-help/tutorials/
http://cgcookie.com/blender/get-started-with-blender/
http://cgcookie.com/blender/2010/08/31/blender-interface-and-navigation/
http://cgcookie.com/blender/2010/08/31/blender-intro-to-modeling/
  http://www.youtube.com/watch?v=fopTSrkSDv0 Getting started in Modeling with Blender

# (find-youtubedl-links "/sda5/videos/blender/" "{title}" "fopTSrkSDv0" "{ext}" "{stem}")

# (find-youtubedl-links "/sda5/videos/blender/" "Getting_started_in_Modeling_with_Blender_-_By_Blender_Cookie" "fopTSrkSDv0" ".mp4" "cookiemodeling")
# (code-mplayer "cookiemodelingvideo" "/sda5/videos/blender/Getting_started_in_Modeling_with_Blender_-_By_Blender_Cookie-fopTSrkSDv0.mp4")
# (find-cookiemodelingvideo)
# (find-cookiemodelingvideo "0:44" "select by right-clicking")
# (find-cookiemodelingvideo "0:56" "shift-click")
# (find-cookiemodelingvideo "1:25" "A to select or deselct everything")
# (find-cookiemodelingvideo "2:15" "the default translate or grab manipulator is enabled")


http://wiki.blender.org/index.php/Doc:2.6/Manual

http://www.katsbits.com/tutorials/blender/useful-keyboard-shortcuts.php
http://www.katsbits.com/files/blender/katsbits-blender-shortcut-chart.pdf
http://www.mrdeyo.com/wp-content/uploads/2009/09/blender-hot-keys.png
http://en.wikibooks.org/wiki/Blender_3D:_Noob_to_Pro/Hot_Keys

http://forums.blendernewbies.com/viewtopic.php?f=16&t=4063
http://animacaosa.blogspot.com.br/2015/05/por-que-o-blender-ou-seria-melhor-dizer.html




#####
#
# webm-support
# 2019aug11
#
#####

# «webm-support» (to ".webm-support")
# https://wiki.blender.org/wiki/Reference/Release_Notes/2.80/Import_Export




#####
#
# Videos about editing videos
# 2019aug11
#
#####

# «editing-videos» (to ".editing-videos")

# https://www.youtube.com/watch?v=Zcj4onvP06w
# (code-video "blendergsvvideo" "/sda5/videos/Learn_Video_Editing_in_Blender_-_Getting_started_with_the_VSE_and_Power_Sequencer-Zcj4onvP06w.mp4")
# (find-blendergsvvideo)
# (find-blendergsvvideo "0:00")

# https://www.youtube.com/watch?v=0Pe_u8zd2e0
# (find-fline "/sda5/videos/" "Blender_Beginners_Tutorial")
# (code-video "blenderbvevideo" "/sda5/videos/Blender_Beginners_Tutorial_-_Basic_Video_Editing_Using_The_Video_Editor.-0Pe_u8zd2e0.mp4")
# (find-blenderbvevideo)
# (find-blenderbvevideo "0:00")
# (find-blenderbvevideo "0:09" "Where it says default left click on choose screen layout")
# (find-blenderbvevideo "0:14" "video editing")
# (find-blenderbvevideo "0:23" "button to the left of view that says graph editor")
# (find-blenderbvevideo "0:32" "left click properties")
# (find-blenderbvevideo "0:46" "two choices - click on add")
# (find-blenderbvevideo "0:57" "shift folllowed by A")
# (find-blenderbvevideo "1:22" "if you want to see thumbnails - to the left of normal")
# (find-blenderbvevideo "1:36" "to input a video")
# (find-blenderbvevideo "1:45" "everything disappears")
# (find-blenderbvevideo "1:50" "roll your middle mouse")
# (find-blenderbvevideo "2:02" "blue video strip is shorter than the green video strip")
# (find-blenderbvevideo "2:08" "green audio strip")
# (find-blenderbvevideo "2:16" "audio FPS")
# (find-blenderbvevideo "2:24" "underneath frame rate")
# (find-blenderbvevideo "2:30" "left click 25 FPS")
# (find-blenderbvevideo "2:43" "by default you only get 250 frames in this view")
# (find-blenderbvevideo "3:08" "come down to the bottom of the screen where it says 250")
# (find-blenderbvevideo "3:28" "increase or decrease the view")
# (find-blenderbvevideo "3:35" "when you click on the screen line here it will stick terrible")
# (find-blenderbvevideo "3:50" "to the right of the sequence editor")
# (find-blenderbvevideo "4:02" "look for the box that says proxy timecode")
# (find-blenderbvevideo "4:10" "25%")
# (find-blenderbvevideo "4:52" "rebuild proxy")
# (find-blenderbvevideo "5:13" "over the video type n on the keyboard")
# (find-blenderbvevideo "6:10" "start from")
# (find-blenderbvevideo "6:23" "end frame")
# (find-blenderbvevideo "6:30" "current frame")
# (find-blenderbvevideo "6:51" "anything lower than the starting frame won't get rendered")
# (find-blenderbvevideo "7:14" "click to finish here")
# (find-blenderbvevideo "7:22" "put a mark where this line is - press m")
# (find-blenderbvevideo "7:37" "button to the left that says marker")
# (find-blenderbvevideo "7:50" "apparent when I bring my next video in")
# (find-blenderbvevideo "8:02" "a and click movie")
# (find-blenderbvevideo "8:07" "icons button")
# (find-blenderbvevideo "8:16" "add movie strip")
# (find-blenderbvevideo "8:22" "gonna stick - terrible")
# (find-blenderbvevideo "8:27" "left click on the box next to proxy timecode")
# (find-blenderbvevideo "8:33" "rebuild proxy and timecode indices")
# (find-blenderbvevideo "8:42" "proxy indicates finish")
# (find-blenderbvevideo "8:56" "where I'm gonna start this clip from")
# (find-blenderbvevideo "9:08" "and I want to come from this point here")
# (find-blenderbvevideo "9:14" "I want to cut this bit away")
# (find-blenderbvevideo "9:17" "press k")
# (find-blenderbvevideo "9:23" "right click on the audio")
# (find-blenderbvevideo "9:28" "press x, left click delete")
# (find-blenderbvevideo "9:38" "bring this back to my marker")
# (find-blenderbvevideo "9:52" "hold on shift, right click on audio and video")
# (find-blenderbvevideo "9:59" "then press g")
# (find-blenderbvevideo "10:15" "(drag)")
# (find-blenderbvevideo "10:21" "rendering from this point")
# (find-blenderbvevideo "10:33" "let's stop this")
# (find-blenderbvevideo "10:38" "leave this marker here")
# (find-blenderbvevideo "11:00" "with my pointer on the sequence editor")
# (find-blenderbvevideo "11:04" "shift followed by a, left click video")
# (find-blenderbvevideo "11:20" "this will come down below")
# (find-blenderbvevideo "11:25" "I don't want this so just press g")
# (find-blenderbvevideo "11:29" "and move my mouse so it's above")
# (find-blenderbvevideo "11:43" "left click to release")
# (find-blenderbvevideo "12:20" "I want to start this video here")
# (find-blenderbvevideo "12:25" "press k, right click on the audio, then x, delete")
# (find-blenderbvevideo "12:38" "shift-click on audio and video")
# (find-blenderbvevideo "12:42" "then g, slide this back")
# (find-blenderbvevideo "12:45" "I don't remember where I want to")
# (find-blenderbvevideo "12:50" "all I do is come back to this marker")
# (find-blenderbvevideo "12:55" "left click on jump to previous marker and g again")
# (find-blenderbvevideo "13:00" "and I can roll this backwards and forwards")
# (find-blenderbvevideo "13:06" "then left click to release")
# (find-blenderbvevideo "13:09" "now I got my video clips pretty well sorted")
# (find-blenderbvevideo "13:20" "and basically that's the simple bit of video editing")
# (find-blenderbvevideo "13:26" "you can cut the middle of these same as the end")
# (find-blenderbvevideo "13:31" "and then join them back together")
# (find-blenderbvevideo "13:35" "there's transitions")
# (find-blenderbvevideo "13:52" "too much time - slide this across")
# (find-blenderbvevideo "13:59" "make a note of the last frame")
# (find-blenderbvevideo "14:04" "the end frame")
# (find-blenderbvevideo "14:18" "that's gonna render from frame 1004 to 1080")
# (find-blenderbvevideo "14:40" "make something easy - slide this panel down")
# (find-blenderbvevideo "14:50" "folder - decide where you're gonna save")
# (find-blenderbvevideo "15:10" "click and give it a title")
# (find-blenderbvevideo "15:28" "slide it down further")
# (find-blenderbvevideo "15:33" "a box that says PNG")
# (find-blenderbvevideo "15:45" "under movie decide which format")
# (find-blenderbvevideo "15:58" "left click encoding")
# (find-blenderbvevideo "16:20" "I won't get any sound")
# (find-blenderbvevideo "16:28" "decide what audio you can use")
# (find-blenderbvevideo "16:39" "drag this slider up")
# (find-blenderbvevideo "16:48" "and under resolution")
# (find-blenderbvevideo "17:14" "if you made your video any other size")
# (find-blenderbvevideo "17:25" "make sure the x and y pixels match")
# (find-blenderbvevideo "17:42" "your framerate is the same")
# (find-blenderbvevideo "17:55" "left click on animation")
# (find-blenderbvevideo "18:20" "if you want to go back to the sequence ditor")
# (find-blenderbvevideo "18:26" "left click on this button")
# (find-blenderbvevideo "18:31" "video sequence editor")
# (find-blenderbvevideo "18:42" "more than three clips")
# (find-blenderbvevideo "18:52" "move your pointer up")

  (eev-avadj-mode 0)
  (eev-avadj-mode)


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/ble/
mkdir  /tmp/ble/
cd     /tmp/ble/
# cp -iv ~/eev-videos/three-keys-2-* .
cp -iv /sda5/videos/Pu* pu.mp4
cp -iv /sda5/videos/Sa* sa.mp4

cd     /tmp/ble/
blender &

# (find-fline "/tmp/ble/")
# (find-fline "~/eev-videos/")

cd     /tmp/ble/
cp -iv ~/eev-videos/three-keys-1-pt-audio.wav pt-audio.wav
cp -iv ~/eev-videos/three-keys-1-pt-video.mp4 pt-video.mp4
cd     /tmp/ble/
blender &




#####
#
# manual
# 2019aug26
#
#####

# «manual» (to ".manual")
# https://docs.blender.org/manual/en/dev/video_editing/index.html
# https://docs.blender.org/manual/en/dev/video_editing/sequencer/strips/introduction.html
# https://docs.blender.org/manual/en/latest/
# https://docs.blender.org/manual/en/latest/blender_manual.zip
# (find-fline "$S/https/docs.blender.org/manual/en/latest/")
# (find-fline "$S/https/docs.blender.org/manual/en/latest/blender_manual.zip")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/html-en-dev-r5700/
rm -Rv ~/usrc/blender_manual/
unzip -d ~/usrc/ $S/https/docs.blender.org/manual/en/latest/blender_manual.zip
cd     ~/usrc/
mv html-en-dev-r5700 blender_manual
cd     ~/usrc/blender_manual/

# (find-fline "~/usrc/blender_manual/")
# file:///home/edrx/usrc/blender_manual/index.html
# file:///home/edrx/usrc/blender_manual/editors/index.html
# file:///home/edrx/usrc/blender_manual/video_editing/index.html
# file:///home/edrx/usrc/blender_manual/animation/markers.html?highlight=marker

# file:///home/edrx/usrc/blender_manual/animation/markers.html
#  g / marker -> move marker

# file:///home/edrx/usrc/blender_manual/video_editing/sequencer/editing.html
#  g / strip -> transform -> move
#  k / strip -> cut
#  delete / strip -> delete

# file:///home/edrx/usrc/blender_manual/video_editing/sequencer/selecting.html




#####
#
# output-formats
# 2019sep01
#
#####

# «output-formats» (to ".output-formats")
# https://en.wikibooks.org/wiki/Blender_3D:_Noob_to_Pro/Output_Format_Options
# https://en.wikibooks.org/wiki/Blender_3D:_Noob_to_Pro/Creating_Ogg-Theora_movies_using_Blender




#####
#
# The "ffmpeg video" option in the output file formats
# 2019oct24
#
#####

# «ffmpeg-video» (to ".ffmpeg-video")
# https://blender.stackexchange.com/questions/82962/i-only-get-four-video-output-options
# https://wiki.blender.org/wiki/Dev:Ref/Release_Notes/2.79/More_Features




#####
#
# sintel
# 2020may11
#
#####

# «sintel» (to ".sintel")
# http://www.sintel.org/
# https://durian.blender.org/download/
# https://durian.blender.org/about/




https://news.ycombinator.com/item?id=33845291 Blockbench – A low-poly 3D model editor (blockbench.net)
https://www.blockbench.net/



https://en.wikipedia.org/wiki/Godot_(game_engine)
https://www.udemy.com/course/godot/

https://store.steampowered.com/app/365670/Blender/
https://www.quora.com/Is-Blender-a-good-video-editing-tool
https://www.anymp4.com/video-editing/blender-video-editing.html
https://danielpocock.com/quick-start-blender-video-editing/

https://blender.stackexchange.com

article about Sintel:
https://download.blender.org/documentation/pdf/LXF204.feat_3d.5cjt.pdf
https://www.pressreader.com/australia/linux-format/20151027/282321088853408

https://odysee.com/@barbaratostes:7/debianopolis001:5
https://odysee.com/@barbaratostes:7/Debianopolis002:a

https://news.ycombinator.com/item?id=30617723 Blender 3.1 (blender.org) - Doughnut tutorial
https://www.blender.org/support/tutorials
https://www.blender.org/download/releases/3-3/

https://news.ycombinator.com/item?id=33273022 Ask HN: Recommend me a Blender course

https://www.mltframework.org/
https://blender.stackexchange.com/questions/296536/keep-a-fixed-distance-between-two-bevelled-surfaces

# (find-status   "melt")
# (find-vldifile "melt.list")
# (find-udfile   "melt/")




#  Local Variables:
#  coding:               utf-8-unix
#  End:
