#######
#
# E-scripts on bookworm.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://anggtwu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://anggtwu.net/e/bookworm.e>
#           or at <http://anggtwu.net/e/bookworm.e.html>.
#        See also <http://anggtwu.net/emacs.html>,
#                 <http://anggtwu.net/.emacs[.html]>,
#                 <http://anggtwu.net/.zshrc[.html]>,
#                 <http://anggtwu.net/escripts.html>,
#             and <http://anggtwu.net/>.
#
#######



# «.prepare-pen-drive»	(to "prepare-pen-drive")
# «.2024feb11»		(to "2024feb11")
# «.emacs-packages»	(to "emacs-packages")
# «.emacs-from-git»	(to "emacs-from-git")
# «.maxima-from-git»	(to "maxima-from-git")
# «.maxima-qdraw»	(to "maxima-qdraw")
# «.fstab»		(to "fstab")
# «.pip3»		(to "pip3")
# «.timezone»		(to "timezone")


(find-es "bullseye")
(find-es "bullseye" "prepare-pen-drive")
https://cdimage.debian.org/debian-cd/current/amd64/iso-cd/
https://cdimage.debian.org/debian-cd/current/amd64/iso-cd/debian-12.0.0-amd64-netinst.iso
https://cdimage.debian.org/debian-cd/current-live/
https://cdimage.debian.org/debian-cd/current-live/amd64/iso-hybrid/
https://cdimage.debian.org/debian-cd/current-live/amd64/iso-hybrid/debian-live-12.4.0-amd64-xfce.iso
https://cdimage.debian.org/debian-cd/current-live/amd64/iso-hybrid/debian-live-12.4.0-amd64-xfce.iso.packages
https://cdimage.debian.org/debian-cd/current-live/amd64/iso-hybrid/debian-live-12.4.0-amd64-xfce.iso.contents




#####
#
# prepare-pen-drive
# 2024feb06
#
#####

# «prepare-pen-drive»  (to ".prepare-pen-drive")
# (find-es "bullseye" "prepare-pen-drive")
# (find-fline "/dev/")
# (find-fline "/dev/" "sdb")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd $S/https/cdimage.debian.org/debian-cd/current-live/amd64/iso-hybrid/
laf        debian-live-12.4.0-amd64-xfce.iso
sudo cp -v debian-live-12.4.0-amd64-xfce.iso /dev/sdb
sudo sync

sudo fdisk -l /dev/sdb


# (find-sh "sudo mount")
# (find-es "bullseye" "inspect-pen-drive")


(find-es "grub" "update-grub")





#####
#
# (Roughly) the commands that I ran in 2024feb11 after installation
# 2024feb11
#
#####

# «2024feb11»    (to ".2024feb11")
# (find-es "bullseye" "2021aug16")
# (find-es "jammy"    "2024jan14")
# (find-es "chrome" "download")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

sudo apt-get install -y zsh emacs xterm wget
chsh edrx

# (find-es "sudo" "sudo")

sudo apt-get update
sudo apt-get upgrade

mkdir -p ~/usrc/
mkdir -p ~/bigsrc/
mkdir -p $S/https/

{
sudo apt-get install -y mpv
sudo apt-get install -y build-essential
sudo apt-get install -y lightdm xfce4
sudo apt-get install -y lua5.1 luarocks
sudo apt-get install -y lua-lpeg lua-lpeg-dev lua-posix
sudo apt-get install -y expect rsync
sudo apt-get install -y xpdf recode figlet

# See:  (find-es "apt" "apt-file")
sudo apt-get install -y apt-file
sudo                    apt-file update
sudo apt-get install -y locate
sudo                    updatedb

sudo apt-get install -y dctrl-tools
sudo apt-get install -y lua5.1 lua5.1-dev lua5.1-doc
sudo apt-get install -y lua5.2 lua5.2-dev lua5.2-doc
sudo apt-get install -y lua5.3 lua5.3-dev
sudo apt-get install -y lua5.4 lua5.4-dev
sudo apt-get install -y lua-lpeg lua-lpeg-dev
sudo apt-get install -y texlive-latex-extra
sudo apt-get install -y scrot gimp simplescreenrecorder
sudo apt-get install -y tkdiff
sudo apt-get install -y curl
sudo apt-get install -y bc potrace imagemagick djvulibre-bin
sudo apt-get install -y dict dictd dict-foldoc dict-gcide dict-jargon dict-vera dict-wn
sudo apt-get install -y gitk git-doc
sudo apt-get install -y xournal
sudo apt-get install -y unicode-data
sudo apt-get install -y ncal
sudo apt-get install -y fossil
sudo apt-get install -y gparted dosfstools mtools
sudo apt-get install -y transmission-gtk
sudo apt-get install -y python3-pip
sudo apt-get install -y python3-doc python3-examples python3-tk
sudo apt-get install -y lsscsi
sudo apt-get install -y isympy3 ipython3
sudo apt-get install -y calibre
sudo apt-get install -y inkscape inkscape-tutorials
sudo apt-get install -y maxima gnuplot
sudo apt-get install -y sbcl sbcl-doc sbcl-source
sudo apt-get install -y qpdf
sudo apt-get install -y aptitude

# Add: contrib non-free non-free-firmware
# (find-fline "$ASROOT/etc/apt/sources.list")

sudo apt-get update
sudo apt-get upgrade

sudo apt-get install -y     gcc-doc
sudo apt-get install -y gdb gdb-doc
sudo apt-get install -y glibc-doc-reference
sudo apt-get install -y make-doc

sudo apt-get build-dep -y emacs
sudo apt-get build-dep -y maxima
}




#####
#
# emacs-packages
# 2024feb12
#
#####

# «emacs-packages»  (to ".emacs-packages")
# (find-epackage-links '0x0)
# (find-epackage-links 'hydra)
# (find-epackage-links 'lua-mode)
# (find-epackage-links 'magit)
# (find-epackage-links 'pdf-tools)



#####
#
# emacs-from-git
# 2024feb12
#
#####

# «emacs-from-git»  (to ".emacs-from-git")
# (find-es "git" "emacs30-from-git")
# (find-es "emacs" "xwidgets")
# (find-es "treesit" "tree-sitter.git")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo apt-get install -y libwebkit2gtk-4.0
sudo apt-get install -y libwebkit2gtk-4.0-dev
sudo apt-get install -y libtree-sitter0
sudo apt-get install -y libtree-sitter-dev



#####
#
# maxima-from-git
# 2024feb12
#
#####

# «maxima-from-git»  (to ".maxima-from-git")
# (find-es "maxima" "maxima-git")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/bigsrc/maxima/")
rm -Rv ~/bigsrc/maxima/
cd     ~/bigsrc/
cp -av /sda4/home/edrx/bigsrc/maxima .
cd     ~/bigsrc/maxima/
git pull

# (find-es "maxima" "maxima-git")




#####
#
# maxima-qdraw
# 2024feb12
#
#####

# «maxima-qdraw»  (to ".maxima-qdraw")
# (find-es "mbe" "download")
# (find-es "maxima" "eev-demo")
# (find-angg "MAXIMA/eigshow1.mac")




#####
#
# fstab
# 2024feb12
#
#####

# «fstab»  (to ".fstab")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo mount /dev/sda4 /sda4/

# (find-fline   "/sda4/etc/fstab")
# (find-fline        "/etc/fstab")
# (find-fline "$ASROOT/etc/fstab")



#####
#
# pip3
# 2024feb12
#
#####

# «pip3»  (to ".pip3")
# (find-ydb "scripts.lua" "update-youtube-dl")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti python3-pip
pip3 install yt-dlp
pip3 install --upgrade yt-dlp

error: externally-managed-environment

× This environment is externally managed
╰─> To install Python packages system-wide, try apt install
    python3-xyz, where xyz is the package you are trying to
    install.
    
    If you wish to install a non-Debian-packaged Python package,
    create a virtual environment using python3 -m venv path/to/venv.
    Then use path/to/venv/bin/python and path/to/venv/bin/pip. Make
    sure you have python3-full installed.
    
    If you wish to install a non-Debian packaged Python application,
    it may be easiest to use pipx install xyz, which will manage a
    virtual environment for you. Make sure you have pipx installed.
    
    See /usr/share/doc/python3.11/README.venv for more information.

note: If you believe this is a mistake, please contact your Python
installation or OS distribution provider. You can override this, at
the risk of breaking your Python installation or OS, by passing
--break-system-packages.

hint: See PEP 668 for the detailed specification.






# «timezone»  (to ".timezone")
# (find-es "clock" "tzconfig")








#  Local Variables:
#  coding:               utf-8-unix
#  End:
