#######
#
# E-scripts on CAD software.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/cad.e>
#           or at <http://angg.twu.net/e/cad.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




https://opensource.com/alternatives/autocad

https://en.wikipedia.org/wiki/OpenSCAD
https://github.com/openscad/openscad


# «.qcad»	(to "qcad")
# «.librecad»	(to "librecad")
# «.freecad»	(to "freecad")
# «.openscad»	(to "openscad")





#####
#
# qcad
# 2017ago07
#
#####

# «qcad» (to ".qcad")
# http://www.qcad.org/en/
# https://packages.debian.org/wheezy/qcad
# QCad has been removed from wheezy for depending on qt3 and containing
# non- distributable fonts, patterns, libraries, and documentation.







#####
#
# librecad
# 2017ago07
#
#####

# «librecad» (to ".librecad")
# http://librecad.org/cms/home.html
# (find-zsh "installeddebs | sort | grep librecad")
# (find-zsh "availabledebs | sort | grep librecad")
# (find-status   "librecad")
# (find-vldifile "librecad.list")
# (find-udfile   "librecad/")
# (find-status   "librecad-data")
# (find-vldifile "librecad-data.list")
# (find-udfile   "librecad-data/")
# http://wiki.librecad.org/index.php/Main_Page
# http://blog.librecad.org/
# http://wiki.librecad.org/index.php/LibreCAD_Brief_Overview
# http://wiki.librecad.org/index.php/LibreCAD_users_Manual
# http://wiki.librecad.org/index.php/A_short_manual_for_use_from_the_command_line



#####
#
# freecad
# 2021may28
#
#####

# «freecad»  (to ".freecad")
# (find-status   "freecad")
# (find-vldifile "freecad.list")
# (find-udfile   "freecad/")
# (find-status   "freecad-common")
# (find-vldifile "freecad-common.list")
# (find-udfile   "freecad-common/")

https://wiki.freecadweb.org/Getting_started
https://wiki.freecadweb.org/Tutorials
https://wiki.freecadweb.org/Video_tutorials
https://wiki.freecadweb.org/Basic_modeling_tutorial 
https://www.youtube.com/user/microelly/videos




#####
#
# openscad
# 2022apr02
#
#####

# «openscad»  (to ".openscad")
# (find-status   "openscad")
# (find-vldifile "openscad.list")
# (find-udfile   "openscad/")
# (find-fline "/usr/share/emacs/site-lisp/scad-mode.el")
# https://en.wikibooks.org/wiki/OpenSCAD_User_Manual/General
# https://openscad.org/documentation.html#language-reference
# https://openscad.org/documentation.html#user-manual
# https://en.m.wikibooks.org/wiki/OpenSCAD_User_Manual/Using_OpenSCAD_in_a_command_line_environment

# (find-man "1 openscad")

# https://www.thingiverse.com/ayrtoncavalieri/designs
# (find-fline "/tmp/TheDNA.stl")

# (find-epackage-links 'scad-mode "scadmode" t)
# (find-epackage       'scad-mode)
# (code-c-d "scadmode" "~/.emacs.d/elpa/scad-mode-20200830.301/")
# (find-scadmodefile "")
# (find-scadmodefile "scad-mode.el")

# (find-epackage-links 'scad-preview "scadpreview" t)
# (find-epackage       'scad-preview)
# (code-c-d "scadpreview" "~/.emacs.d/elpa/scad-preview-20211212.1128/")
# (find-scadpreviewfile "")

# https://zk-phi.github.io/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/OPENSCAD/
# openscad -o staircase.stl staircase.scad
openscad -o cubes.stl cubes.scad
openscad cubes.scad

staircase.scad

apti openscad

# (find-fline "~/OPENSCAD/")




sudo apt autoremove



https://news.ycombinator.com/item?id=28817102 GraphSCAD – A User Friendly Nodal Editor for OpenSCAD (2018) (graphscad.blogspot.com)
This is a bit of a tangent but I wish I could find a tool for designing houses that was graphical but underneath based on a programming language.

https://news.ycombinator.com/item?id=29823642 KiCad 6 (revk.uk)

https://news.ycombinator.com/item?id=30825429 Fornjot – The world needs another CAD program (github.com/hannobraun)
https://news.ycombinator.com/item?id=30597061 Fornjot: A next-generation Code-CAD application (fornjot.app)
https://news.ycombinator.com/item?id=31175472 Google Scanned Objects: A High-Quality Dataset of 3D Scanned Household Items (arxiv.org)
https://news.ycombinator.com/item?id=31462563 QCAD – Open Source CAD System (qcad.org)
https://news.ycombinator.com/item?id=31468017 SolveSpace – Parametric 2D/3D CAD (solvespace.com)
https://news.ycombinator.com/item?id=31470482 Constraint-based geometry (CAD) sketcher for Blender (github.com/hlorus)















#  Local Variables:
#  coding:               utf-8-unix
#  End:
