#######
#
# E-scripts on cfengine.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/cfengine.e>
#           or at <http://angg.twu.net/e/cfengine.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######






#####
#
# cfengine
# 99dec11
#
#####

apti cfengine
# (find-vldifile "cfengine.list")
# (find-fline "/usr/doc/cfengine/")

pdsc /big/slinks1/dists/slink/main/source/admin/cfengine_1.4.12-4.dsc
cd /usr/src/cfengine-1.4.12/

# (find-cfnode "Top")
# (find-cfnode "What you must have")

# (find-cfnode "cfengine.conf")
# (find-cfnode "Concept Index")
# (find-cfnode "Variable Index")
# (find-cfnode "Command reference")
# (find-cfnode "Invoking cfengine")
# (find-cfnode "Single links")

cd /tmp
rm -fv /tmp/{file,link}
echo Oi! > file
#
cat > /tmp/test.cf <<'--%%--'
control:
  actionsequence = ( links )
links:
  any::
    /tmp/link -> /tmp/file  type=relative
--%%--
strace -f -o ~/s cfengine -f /tmp/test.cf
laf


%
links:
  any::
    /tmp/link -> /tmp/file
%

(defun eecf (s e) (interactive "r")
  (write-ee s e "cat > ~/tmp/emacs.cf <<'--%%%--'
"
"
--%%%--
set -v
cfengine -v -n -f ~/tmp/emacs.cf
set +v"))

(defun eecf-bounded () (interactive)
  (ee-strbounded 'eecf "\n%\n" "\n%\n"))
(global-set-key [f3] 'eecf-bounded)





#####
#
# cfengine examples in /usr/doc/
# 99dec10
#
#####

# Some docs are gzipped, and they have loads of comments and blank
# lines and seem to use tab stops at every 4 chars. We "fix" all this
# and produce a single big file.

rm -Rv /tmp/cfexamples/
mkdir  /tmp/cfexamples/
cd /usr/doc/cfengine/examples/
cp -v * /tmp/cfexamples/
cd /tmp/cfexamples/
gzip -dv *.gz
for i in *; do
  echo "\n\n\n#---- $i :\n"
  egrep -v '^[ 	]*(#|$)' < cf.debian.conf
done > o0

icone 'write(detab(fname2string("o0"), 5, 9))' > o

# (find-fline "/tmp/cfexamples/o")
# (find-fline "/tmp/cfexamples/o")

cd /tmp/cfexamples/
cd /tmp/cfexamples/
a2ps -o o.ps -X ibmpc \
  --columns=2 --rows=1 --major=columns --portrait --medium=A4dj \
  --stdin='cfengine examples' \
  < o

gv o.ps
make -f ~/LATEX/Makefile o.p01

# (find-cfnode "Concept Index")
# (find-cfnode "Variable Index")
# (find-cfnode "Command reference")




#####
#
# Coisas pra pr na minha configurao do cfengine
#
#####

/dev/modem -> ... dependendo da mquina
/dev/mouse -> ... idem
/usr/X11 -> /usr/X11R6  (e no modo estrito remover esse link)

/usr/src -> ...
Tirar a linha do "auth" do pppd.conf
Linhas do broot e de outros usuarios com senhas conhecidas

Vrios terminais extras em /etc/inittab
kbupdate aponta prum cara em /home/root/bin/...

/usr/src/.debs/
apt-config





#  Local Variables:
#  coding:               utf-8-unix
#  End:
