#######
#
# E-scripts on editing documents in Chinese.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/chinese.e>
#           or at <http://angg.twu.net/e/chinese.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.half»  			(to "half")
# «.chinese_and_fontset»	(to "chinese_and_fontset")
# «.lacquered-duck»		(to "lacquered-duck")
# «.cjk-latex»			(to "cjk-latex")
# «.lacquered-duck-latex»	(to "lacquered-duck-latex")
# «.sweet-sour-pork»		(to "sweet-sour-pork")
# «.lua-pinyin»			(to "lua-pinyin")




#####
#
# notes for half@somewhere.china
# 2000nov02
#
#####

# «half»  (to ".half")
#
cat > /tmp/chinese <<'---'
(set-frame-font "fontset-standard")
(set-input-method "chinese-tonepy")

(find-e20file "../leim/quail/TONEPY.el")
---
#
# (find-fline "/tmp/chinese")





apti task-chinese-s

# (find-status "task-chinese-s")
# (find-vldifile "task-chinese-s.list")
# (find-fline "/usr/doc/task-chinese-s/")

# (find-status "task-chinese-t")
# (find-vldifile "task-chinese-t.list")
# (find-fline "/usr/doc/task-chinese-t/")

# (find-status "xcin")
# (find-vldifile "xcin.list")
# (find-fline "/usr/doc/xcin/")

# (find-htetfile "Chinese-HOWTO.txt.gz")

# (find-status "freewnn-cserver")
# (find-vldifile "freewnn-cserver.list")
# (find-fline "/usr/doc/freewnn-cserver/")

# (find-status "freewnn-common")
# (find-vldifile "freewnn-common.list")
# (find-fline "/usr/doc/freewnn-common/")

aptrm freewnn-common bg5ps doc-linux-zh doc-linux-zh-s freewnn-cserver libtabe0
aptrm locale-zh task-chinese-s task-chinese-t

apti cjk-latex
# (find-status "cjk-latex")
# (find-vldifile "cjk-latex.list")
# (find-fline "/usr/doc/cjk-latex/")

Pgrepp m/libtabe-db/
Pgrepp m/arphic/

apti tfm-arphic-gkai00mp ttf-arphic-gkai00mp xfonts-arphic-gkai00mp

# (find-status "tfm-arphic-gkai00mp")
# (find-status "ttf-arphic-gkai00mp")
# (find-status "xfonts-arphic-gkai00mp")

# (find-vldifile "tfm-arphic-gkai00mp.list")
# (find-vldifile "ttf-arphic-gkai00mp.list")
# (find-vldifile "xfonts-arphic-gkai00mp.list")

# (find-fline "/usr/doc/xfonts-arphic-gkai00mp/")
cd /usr/share/fonts/truetype/arphic/
ftview 12 gkai00mp.ttf

# (find-vldifile "tfm-arphic-gkai00mp.postinst")
# (find-vldifile "tfm-arphic-gkai00mp.postrm")
# (find-vldifile "tfm-arphic-gkai00mp.prerm")
# (find-vldifile "xfonts-arphic-gkai00mp.conffiles")
# (find-vldifile "xfonts-arphic-gkai00mp.list")
# (find-vldifile "xfonts-arphic-gkai00mp.postinst")
# (find-vldifile "xfonts-arphic-gkai00mp.postrm")
# (find-fline "/usr/sbin/update-fonts-scale")

# (find-fline "/usr/lib/X11/fonts/TrueType/")
xfd -fn -default-kai-medium-r-normal--56-560-72-72-c-560-big5-0

# (find-fline "/etc/X11/XF86Config")
    FontPath   "/usr/X11R6/lib/X11/fonts/TrueType/"

(set-frame-font "-adobe-helvetica-bold-o-normal--24-240-75-75-p-138-iso8859-1")
(set-frame-font "-default-kai-bold-i-normal--24-240-72-72-c-240-gb2312.1980-0")



#####
#
# Chinese and Emacs fontsets
# 2000oct12
#
#####

# «chinese_and_fontset»  (to ".chinese_and_fontset")
# (find-es "emacs" "fontsets")

# (find-eetcfile "")
# (find-eetcfile "HELLO")

# (set-frame-font "fontset-standard")
# (let ((default-enable-multibyte-characters t)) (find-eetcfile "HELLO"))

cp /usr/share/emacs/20.7/etc/HELLO ~/tmp/HELLO
# (let ((default-enable-multibyte-characters t)) (find-fline "~/tmp/HELLO"))

# (find-elnode "Fontsets")
# (find-enode "International")
# (find-enode "Fontsets")
# (find-efile "international/")
# (find-efile "international/fontset.el")
# (find-efile "international/mule-diag.el")
# (find-efile "language/")

# enable-multibyte-characters
# (set-frame-font "fontset-standard")
# (fontset-list)
# (describe-fontset nil)
# (describe-fontset t)

# (find-efile "")
# (find-efile "international/")
# (find-efile "international/fontset.el")



#####
#
# Emacs and chinese-tonepy
# 2000oct22
#
#####

# (find-e20file "international/titdic-cnv.el" "chinese-tonepy")
# (find-e20file "leim-list.el" "chinese-tonepy")

# (find-e20file "../leim/quail/TONEPY.el")

# (find-enode "Input Methods" "Keys such as")
# (find-fline "~/tmp/chinese-notes")




Pgrepp 'm/Package: xfonts-intl/' |& l -S

# (find-status "xfonts-intl-arabic")
# (find-status "xfonts-intl-asian")
# (find-status "xfonts-intl-chinese-big")
# (find-status "xfonts-intl-phonetic")
# (find-vldifile "xfonts-intl-arabic.list")
# (find-vldifile "xfonts-intl-asian.list")
# (find-vldifile "xfonts-intl-phonetic.list")

# (find-vldifile "xfonts-intl-chinese-big.list")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.dir" "cc48s.pcf.gz")



#####
#
# lacquered duck
# 2004apr09
#
#####

# «lacquered-duck»  (to ".lacquered-duck")

<ayrnieu> at a first guess, qi1ya1 in pinyin.
<ayrnieu> Emacs has a pinyin IM, but you'd probably still need to know the
          characters.
<ayrnieu> and it probably actually looks like yong4qi1zuo4deya1
<ayrnieu> and I don't have a culinary dictionary, here.  Sorry.

According to Zu Jian it's kao3 ya1 in tonepy.
(insert 40894 43196)
(find-efile "leim/quail/TONEPY.el")
(find-efile "leim/quail/TONEPY.el" "kao3")
(find-efile "leim/quail/TONEPY.el" "ya1")
(find-eimage0 "~/IMAGES/kaoya.png")
(find-fline   "~/IMAGES/kaoya.png")

(find-fline "/usr/share/emacs/21.2/leim/quail/")
(find-fline "/usr/share/emacs/21.2/leim/quail/TONEPY.el")
(find-fline "/usr/share/emacs/21.2/leim/quail/TONEPY.el")

(find-fline "/usr/share/emacs/21.2/leim/quail/TONEPY.el" "yong4")
(find-fline "/usr/share/emacs/21.2/leim/quail/TONEPY.el" "qi1")
(find-fline "/usr/share/emacs/21.2/leim/quail/TONEPY.el" "zuo4")
(find-fline "/usr/share/emacs/21.2/leim/quail/TONEPY.el" "deya1") ;; not found

(find-fline "/usr/share/emacs/21.2/leim/quail/TONEPY.el" "ya1")

(set-input-method 'chinese-tonepy)
(toggle-input-method)

(find-efunction 'quail-lookup-key)
(find-efunction 'quail-map)
(quail-lookup-key "qi1")
(find-eevalread "(quail-lookup-key \"qi1\")")

(insert 43459 41823)

(progn (find-fline "/tmp/duck")
       (set-input-method 'chinese-tonepy)
       )

(quail-lookup-key "qi1")
(cdr (car (quail-lookup-key "qi1")))
(aref (cdr (car (quail-lookup-key "qi1"))) 6)

(insert 43459 41823)

(read-input-method-name "(Prompt) ")
(find-efunction 'read-input-method-name)
(find-efunctiondescr 'minibuffer-complete)
(find-elnode "Completion Commands")

(find-eevalread "input-method-alist")

(find-elnode "Creating Buffer-Local")
(find-elnode "Creating Buffer-Local" "permanent")
(find-elnode "Creating Buffer-Local" "permanent-local")

#
expect -c 'puts "\xff\xfe\xe4\x70\x2d\x9e"' > /tmp/duck
od -h /tmp/duck
#
;; (insert (format "%c%c" 40894 43196))

(defmacro with-multibyte (bool &rest body)
  `(let ((default-enable-multibyte-characters ,bool))
     . ,body))

(defmacro with-coding (cs &rest body)
  `(let ((default-enable-multibyte-characters t)
	 (coding-system-for-read ',cs))
     . ,body))

(with-coding utf-8 (find-file "/tmp/duck"))

(setq default-enable-multibyte-characters t)
(find-eleimfile "quail/")
(with-coding iso-2022-7bit (find-eleimfile "quail/TONEPY.el"))


# Here's how to write it:
# (find-eleimfile "quail/TONEPY.el" "kao3" (format "%c" 40894))
# (find-eleimfile "quail/TONEPY.el" "ya1" (format "%c" 43196))

#
cat > /tmp/duck <<'%%%'
(insert (format "%c%c" 40894 43196))
%%%
# (find-fline "/tmp/duck")
#




#####
#
# cjk-latex
# 2004may12
#
#####

# «cjk-latex»  (to ".cjk-latex")
# (find-availablegrep "-i chinese")
# (find-availablegrep "-i chinese-t")
# (find-availablegrep "-i chinese-s")
# (find-availablegrep "-i arphic")
# (find-availablegrep "-i ttf-arphic")

apti cjk-latex

# (find-status "cjk-latex")
# (find-vldifile "cjk-latex.list")
# (find-fline "/usr/doc/cjk-latex/")
# (find-fline "/usr/doc/cjk-latex/CJK.doc.gz" "simplified Chinese")
# (find-fline "/usr/doc/cjk-latex/README.Debian")

apti freetype1-tools \
  tfm-arphic-bsmi00lp tfm-arphic-bkai00mp \
  tfm-arphic-gbsn00lp tfm-arphic-gkai00mp

#
rm -Rv /tmp/doc-cjk-latex/
mkdir  /tmp/doc-cjk-latex/
cd /usr/share/doc/cjk-latex/
cp -rv * /tmp/doc-cjk-latex/
cd     /tmp/doc-cjk-latex/
gunzip -rv *

#
cd     /tmp/doc-cjk-latex/examples/
latex Arphic_test.tex
latex Big5.tex
latex Big5vert.tex
# latex CEF_test.tex
latex GB.tex

#
cd     /tmp/doc-cjk-latex/examples/
# latex JIS.tex
# latex KS.tex
# latex SJIS.tex
# latex UTF8.tex
# latex muletest.tex
latex py_test.tex
latex rubytest.tex

#
# (find-fline "/tmp/doc-cjk-latex/")
# (find-fline "/tmp/doc-cjk-latex/examples/")




#####
#
# lacquered-duck-latex
# 2004may12
#
#####

# «lacquered-duck-latex»  (to ".lacquered-duck-latex")
#
cat > /tmp/duck.tex <<'%%%'
% (find-fline "/usr/doc/cjk-latex/examples/GB.tex")
% (find-fline "/usr/doc/cjk-latex/examples/py_test.tex")
\documentclass[12pt]{article}
\usepackage{CJK}
\usepackage{pinyin}
\begin{document}

\huge
\begin{CJK*}{GB}{song}
\CJKtilde
% (insert 40894 43196)
??
\end{CJK*}

\normalsize

\PYactivate \Kao3 \Ya1
\PYdeactivate

Kao3 ya1

40894 43196

Lacquered duck

\end{document}
% (eev "cd /tmp/; latex duck.tex && rexdvi duck.dvi")
% Local Variables:
% coding: gb2312-unix
% End:
%%%

# (find-fline "/tmp/duck.tex" "insert")
#
cd /tmp/
latex duck.tex
rexdvi duck.dvi
#

# (find-status   "latex-cjk-chinese")
# (find-vldifile "latex-cjk-chinese.list")
# (find-udfile   "latex-cjk-chinese/")
# (find-status   "latex-cjk-common")
# (find-vldifile "latex-cjk-common.list")
# (find-udfile   "latex-cjk-common/")
# (find-udfile "latex-cjk-common/examples/")
# (find-udfile "latex-cjk-common/examples/UTF8.tex")

# http://angg.twu.net/IMAGES/kaoya.png
# (find-anggfile "IMAGES/kaoya.png")
# (find-equailfile "TONEPY.el")
# (find-equailfile "TONEPY.el" "kao3")
# (find-equailfile "TONEPY.el" "kao3" '(eek "5*<right>"))
# (find-equailfile "TONEPY.el" "ya1"  '(eek "6*<right>"))
# (find-einsert '(28900 40493))


# «sweet-sour-pork»  (to ".sweet-sour-pork")
# Sweet-sour pork (with thanks to the people at #debian-zh)
# http://www.hlyt.com/cihui-2.htm
(progn (find-estring "")
       (insert 58108 63308 58233))

(progn (find-estring "")
       (insert (format "Yummy! %c%c%c" 58108 63308 58233)))

# (find-eleimfile "quail/TONEPY.el" "kao3" (format "%c" 40894))
# (find-eleimfile "quail/TONEPY.el" "ya1" (format "%c" 43196))

(insert-file "4Corner.el")
(insert-file "ARRAY30.el")
(insert-file "CCDOSPY.el")
(insert-file "CTLau-b5.el")
(insert-file "CTLau.el")
(insert-file "ECDICT.el")
(insert-file "ETZY.el")
(insert-file "PY-b5.el")
(insert-file "PY.el")
(insert-file "Punct-b5.el")
(insert-file "Punct.el")
(insert-file "QJ-b5.el")
(insert-file "QJ.el")
(insert-file "SW.el")
(insert-file "TONEPY.el")
(insert-file "ZIRANMA.el")
(insert-file "ZOZY.el")
(insert-file "croatian.el")
(insert-file "cyril-jis.el")
(insert-file "cyrillic.el")
(insert-file "czech.el")
(insert-file "ethiopic.el")
(insert-file "georgian.el")
(insert-file "greek.el")
(insert-file "hangul.el")
(insert-file "hangul3.el")
(insert-file "hanja-jis.el")
(insert-file "hanja.el")
(insert-file "hanja3.el")
(insert-file "hebrew.el")
(insert-file "indian.el")
(insert-file "ipa.el")
(insert-file "japanese.el")
(insert-file "lao.el")
(insert-file "latin-alt.el")
(insert-file "latin-ltx.el")
(insert-file "latin-post.el")
(insert-file "latin-pre.el")
(insert-file "lrt.el")
(insert-file "py-punct.el")
(insert-file "pypunct-b5.el")
(insert-file "quick-b5.el")
(insert-file "quick-cns.el")
(insert-file "rfc1345.el")
(insert-file "sgml-input.el")
(insert-file "sisheng.el")
(insert-file "slovak.el")
(insert-file "symbol-ksc.el")
(insert-file "thai.el")
(insert-file "tibetan.el")
(insert-file "tsang-b5.el")
(insert-file "tsang-cns.el")
(insert-file "uni-input.el")
(insert-file "viqr.el")
(insert-file "vntelex.el")
(insert-file "welsh.el")




#####
#
# pinyin in lua
# 2009feb21
#
#####

# «lua-pinyin»  (to ".lua-pinyin")
# (find-equailfile "")
# (find-equailfile "TONEPY.el")
# (find-equailfile "TONEPY.el" "\n(quail-define-rules\n")
#
# Create /tmp/tonepylines.utf8:
#   (find-equailfile "TONEPY.el" "\n(quail-define-rules\n" '(eek "C-SPC M-> <up> M-w"))
#   (eev "-- -*- coding: utf-8 -*-" nil "/tmp/tonepylines.utf8")
#   (find-fline "/tmp/tonepylines.utf8" 2)
#     ^ do a M-y by hand there
#
# (find-fline "/tmp/tonepylines.utf8" 2)
# (find-angg "LUA/lua50init.lua" "split")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
unicodes = function (str) return split(str, "([\192-\255][\128-\191]*)") end
pinyinchars = function (str) return str:match('^%("([a-z0-9]+)" "([\128-\255]+)"%)') end
fname    = "/tmp/tonepylines.utf8"
lines    = split(readfile(fname), "([^\n]+)")
charsfor_  = {}
charsfor   = {}
pinyinsfor = {}
for _,li in ipairs(lines) do
  pinyin, chars = pinyinchars(li)
  if pinyin then
    charsfor_[pinyin] = chars
    charsfor [pinyin] = unicodes(chars)
    for _,char in ipairs(unicodes(chars)) do
      -- print(pinyin, char)
      pinyinsfor[char] = pinyinsfor[char] or {}
      table.insert(pinyinsfor[char], pinyin)
    end
  end
end
print(charsfor_["zuo4"])
PP(charsfor["zuo4"])
PP(charsfor["zuo4"][1])
PP(pinyinsfor[charsfor["zuo4"][1]])



Bel e Fernando:
2265-9937 (mãe da Bel) e mais o celular




https://github.com/LingDong-/rrpl












#  Local Variables:
#  coding:               utf-8-unix
#  End:
