#######
#
# E-scripts on Google Chrome.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/chrome.e>
#           or at <http://angg.twu.net/e/chrome.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.download»			(to "download")
# «.download-wget»		(to "download-wget")
# «.high-ram-usage»		(to "high-ram-usage")
# «.keys»			(to "keys")
# «.language»			(to "language")
# «.console»			(to "console")
# «.debs»			(to "debs")
# «.chromium-vs-chrome»		(to "chromium-vs-chrome")
# «.could-not-load-flash»	(to "could-not-load-flash")
# «.auto-update»		(to "auto-update")
# «.extensions»			(to "extensions")
# «.cached-videos»		(to "cached-videos")
# «.safe-mode»			(to "safe-mode")
# «.adblock»			(to "adblock")
# «.flash»			(to "flash")
# «.shareaholic»		(to "shareaholic")
# «.sync-tabs»			(to "sync-tabs")
# «.profile-locked»		(to "profile-locked")
# «.new-windows»		(to "new-windows")
# «.installing-chrome-lubuntu»	(to "installing-chrome-lubuntu")
# «.cookies»			(to "cookies")
# «.fill-out-forms»		(to "fill-out-forms")
# «.inspect-images»		(to "inspect-images")
# «.redirect-sumicity»		(to "redirect-sumicity")
# «.link-to-text-fragment»	(to "link-to-text-fragment")
# «.link-to-pdf-page»		(to "link-to-pdf-page")
# «.puppeteer»			(to "puppeteer")
# «.promnesia»			(to "promnesia")
# «.multiple-profiles»		(to "multiple-profiles")
# «.gtk-bookmarks»		(to "gtk-bookmarks")
# «.ctrl-shift-I»		(to "ctrl-shift-I")
# «.extension-samples»		(to "extension-samples")
# «.disable-javascript»		(to "disable-javascript")
# «.reader-mode»		(to "reader-mode")
# «.bookmarks-bar»		(to "bookmarks-bar")
# «.caret-browsing-f7»		(to "caret-browsing-f7")




#####
#
# download
# 2021aug16
#
#####

# «download»  (to ".download")
# https://www.google.com/chrome/
# (find-status   "google-chrome-stable")
# (find-vldifile "google-chrome-stable.list")
# (find-udfile   "google-chrome-stable/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
sudo dpkg -i google-chrome-stable_current_amd64.deb
apti -f


(let ((default-directory "/etc/apt/"))
  (grep "grep --color=auto -niRH --null -e chrome *")
  )
# (find-fline "/etc/apt/")
# (find-fline "/etc/apt/sources.list.d/google-chrome.list")




#####
#
# download-wget
# 2024may04
#
#####

# «download-wget»  (to ".download-wget")
# (find-fline "~/LOGS/2024may04.emacs" "<e1f> edrx: wget")
# (find-windows-beginner-intro "3. Install Google Chrome")
# (find-windows-beginner-intro    "Install Google Chrome")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
wget https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
sudo dpkg -i google-chrome-stable_current_amd64.deb
sudo apt-get install -y -f

# (find-man "dpkg")




#####
#
# high-ram-usage
# 2024may30
#
#####

# «high-ram-usage»  (to ".high-ram-usage")

https://support.google.com/chrome/thread/252045457/chrome-shows-aw-snap-not-enough-memory-error-without-even-opening-any-tabs-or-other-applications?hl=en




#####
#
# keys
# 2012dec27
#
#####

# «keys» (to ".keys")
# https://support.google.com/chrome/bin/answer.py?hl=en&answer=157179&topic=25799&rd=2      W$
# https://support.google.com/chrome/bin/answer.py?hl=en&answer=171571&topic=25799&ctx=topic Linux

Linux keyboard shortcuts
========================

Tab and window shortcuts
========================
Ctrl+N                                                                                        Opens a new window.                                                    
Ctrl+T                                                                                        Opens a new tab.                                                       
Ctrl+Shift+N                                                                                  Opens a new window in incognito mode.                                  
Press Ctrl+O, then select file.                                                               Opens a file from your computer in Google Chrome.                      
Press Ctrl and click a link. Or click a link with your middle mouse button (or mousewheel).   Opens the link in a new tab in the background .                        
Press Ctrl+Shift and click a link. Or press Shift and click a link with your middle mouse     Opens the link in a new tab and switches to the newly opened tab.      
button (or mousewheel).                                                                                                                                              
Press Shift and click a link.                                                                 Opens the link in a new window.                                        
Ctrl+Shift+T                                                                                  Reopens the last tab you've closed. Google Chrome remembers the last 10
                                                                                              tabs you've closed.                                                    
Drag a link to a tab.                                                                         Opens the link in the tab.                                             
Drag a link to a blank area on the tab strip.                                                 Opens the link in a new tab.                                           
Drag a tab out of the tab strip.                                                              Opens the tab in a new window.                                         
Drag a tab out of the tab strip and into an existing window.                                  Opens the tab in the existing window.                                  
Press Esc while dragging a tab.                                                               Returns the tab to its original position.                              
Ctrl+1 through Ctrl+8                                                                         Switches to the tab at the specified position number on the tab strip. 
Ctrl+9                                                                                        Switches to the last tab.                                              
Ctrl+Tab or Ctrl+PgDown                                                                       Switches to the next tab.                                              
Ctrl+Shift+Tab or Ctrl+PgUp                                                                   Switches to the previous tab.                                          
Ctrl+Shift+Q                                                                                  Closes Google Chrome.                                                  
Ctrl+W or Ctrl+F4                                                                             Closes the current tab or pop-up.                                      
Click a tab with your middle mouse button (or mousewheel).                                    Closes the tab you clicked.                                            
Right-click, or click and hold either the Back or Forward arrow in the browser toolbar.       Displays your browsing history in the tab.                             
Press Alt and the left arrow together.                                                        Goes to the previous page in your browsing history for the tab.        
Press Alt and the right arrow together.                                                       Goes to the next page in your browsing history for the tab.            
Click either the Back arrow, Forward arrow, or Go button in the toolbar with your middle      Opens the button destination in a new tab in the background.           
mouse button (or mousewheel).                                                                                                                                        
Double-click the blank area on the tab strip.                                                 Maximizes or minimizes the window.                                     

Google Chrome feature shortcuts
===============================
Alt+F             Opens the Tools menu, which lets you customize and control settings in Google Chrome. 
Ctrl+Shift+B      Toggles the bookmarks bar on and off.                                                 
Ctrl+H            Opens the History page.                                                               
Ctrl+J            Opens the Downloads page.                                                             
Shift+Esc         Opens the Task Manager.                                                               
Ctrl+Shift+J      Opens Developer Tools.                                                                
Ctrl+Shift+Delete Opens the Clear Browsing Data dialog.                                                 
F1                Opens the Help Center in a new tab (our favorite).                                    
Ctrl+Shift+M      Switch between multiple users.                                                        

Address bar shortcuts
=====================
Use the following shortcuts in the address bar:

Type a search term, then press Enter.                                    Performs a search using your default search engine.                                         
Type a search engine keyword, press Space, type a search term, and press Performs a search using the search engine associated with the keyword.                      
Enter.                                                                                                                                                               
Begin typing a search engine URL, press Tab when prompted, type a search Performs a search using the search engine associated with the URL.                          
term, and press Enter.                                                                                                                                               
Ctrl+L                                                                   Highlights the URL.                                                                         
Ctrl+K or Ctrl+E                                                         Places a '?' in the address bar. Type a search term after the question mark to perform a    
                                                                         search using your default search engine.                                                    
Press Ctrl+Shift and the left arrow together.                            Moves your cursor to the preceding key term in the address bar                              
Press Ctrl+Shift and the right arrow together.                           Moves your cursor to the next key term in the address bar                                   
Ctrl+Backspace                                                           Deletes the key term that precedes your cursor in the address bar                           
Select an entry in the address bar drop-down menu with your keyboard     Deletes the entry from your browsing history, if possible.                                  
arrows, then press Shift+Delete.                                                                                                                                     
Click an entry in the address bar drop-down menu with your middle mouse  Opens the entry in a new tab in the background.                                             
button (or mousewheel).                                                                                                                                              
Press Page Up or Page Down when the address bar drop-down menu is        Selects the first or last entry in the drop-down menu.                                      
visible.                                                                                                                                                             

Webpage shortcuts
=================
Ctrl+P                                                     Prints your current page.                                                
Ctrl+S                                                     Saves your current page.                                                 
Ctrl+R                                                     Reloads your current page.                                               
Esc                                                        Stops the loading of your current page.                                  
Ctrl+F                                                     Opens the find bar.                                                      
Ctrl+G or Enter                                            Finds the next match for your input in the find bar.                     
Ctrl+Shift+G or Shift+Enter                                Finds the previous match for your input in the find bar.                 
Press Alt and click a link.                                Downloads the target of the link.                                        
Ctrl+U                                                     Opens the source of your current page.                                   
Drag a link to bookmarks bar                               Saves the link as a bookmark.                                            
Ctrl+D                                                     Saves your current webpage as a bookmark.                                
Ctrl+Shift+D                                               Saves all open pages as bookmarks in a new folder.                       
F11                                                        Opens your page in full-screen mode. Press F11 again to exit full-screen.
Ctrl and +, or press Ctrl and scroll your mousewheel up.   Enlarges everything on the page.                                         
Ctrl and -, or press Ctrl and scroll your mousewheel down. Makes everything on the page smaller.                                    
Ctrl+0                                                     Returns everything on the page to normal size.                           
Space bar                                                  Scrolls down the web page.                                               
Home                                                       Goes to the top of the page.                                             
End                                                        Goes to the bottom of the page.                                          

Text shortcuts
==============
Ctrl+C                 Copies highlighted content to the clipboard.                    
Ctrl+V or Shift+Insert Pastes content from the clipboard.                              
Ctrl+Shift+V           Paste content from the clipboard without formatting.            
Ctrl+X or Shift+Delete Deletes the highlighted content and copies it to the clipboard. 
Linux keyboard shortcuts

Tab and window shortcuts
========================
Ctrl+N                                                                                        Opens a new window.                                                    
Ctrl+T                                                                                        Opens a new tab.                                                       
Ctrl+Shift+N                                                                                  Opens a new window in incognito mode.                                  
Press Ctrl+O, then select file.                                                               Opens a file from your computer in Google Chrome.                      
Press Ctrl and click a link. Or click a link with your middle mouse button (or mousewheel).   Opens the link in a new tab in the background .                        
Press Ctrl+Shift and click a link. Or press Shift and click a link with your middle mouse     Opens the link in a new tab and switches to the newly opened tab.      
button (or mousewheel).                                                                                                                                              
Press Shift and click a link.                                                                 Opens the link in a new window.                                        
Ctrl+Shift+T                                                                                  Reopens the last tab you've closed. Google Chrome remembers the last 10
                                                                                              tabs you've closed.                                                    
Drag a link to a tab.                                                                         Opens the link in the tab.                                             
Drag a link to a blank area on the tab strip.                                                 Opens the link in a new tab.                                           
Drag a tab out of the tab strip.                                                              Opens the tab in a new window.                                         
Drag a tab out of the tab strip and into an existing window.                                  Opens the tab in the existing window.                                  
Press Esc while dragging a tab.                                                               Returns the tab to its original position.                              
Ctrl+1 through Ctrl+8                                                                         Switches to the tab at the specified position number on the tab strip. 
Ctrl+9                                                                                        Switches to the last tab.                                              
Ctrl+Tab or Ctrl+PgDown                                                                       Switches to the next tab.                                              
Ctrl+Shift+Tab or Ctrl+PgUp                                                                   Switches to the previous tab.                                          
Ctrl+Shift+Q                                                                                  Closes Google Chrome.                                                  
Ctrl+W or Ctrl+F4                                                                             Closes the current tab or pop-up.                                      
Click a tab with your middle mouse button (or mousewheel).                                    Closes the tab you clicked.                                            
Right-click, or click and hold either the Back or Forward arrow in the browser toolbar.       Displays your browsing history in the tab.                             
Press Alt and the left arrow together.                                                        Goes to the previous page in your browsing history for the tab.        
Press Alt and the right arrow together.                                                       Goes to the next page in your browsing history for the tab.            
Click either the Back arrow, Forward arrow, or Go button in the toolbar with your middle      Opens the button destination in a new tab in the background.           
mouse button (or mousewheel).                                                                                                                                        
Double-click the blank area on the tab strip.                                                 Maximizes or minimizes the window.                                     

Google Chrome feature shortcuts
===============================
Alt+F             Opens the Tools menu, which lets you customize and control settings in Google Chrome. 
Ctrl+Shift+B      Toggles the bookmarks bar on and off.                                                 
Ctrl+H            Opens the History page.                                                               
Ctrl+J            Opens the Downloads page.                                                             
Shift+Esc         Opens the Task Manager.                                                               
Ctrl+Shift+J      Opens Developer Tools.                                                                
Ctrl+Shift+Delete Opens the Clear Browsing Data dialog.                                                 
F1                Opens the Help Center in a new tab (our favorite).                                    
Ctrl+Shift+M      Switch between multiple users.                                                        

Address bar shortcuts
=====================
Use the following shortcuts in the address bar:

Type a search term, then press Enter.                                    Performs a search using your default search engine.                                         
Type a search engine keyword, press Space, type a search term, and press Performs a search using the search engine associated with the keyword.                      
Enter.                                                                                                                                                               
Begin typing a search engine URL, press Tab when prompted, type a search Performs a search using the search engine associated with the URL.                          
term, and press Enter.                                                                                                                                               
Ctrl+L                                                                   Highlights the URL.                                                                         
Ctrl+K or Ctrl+E                                                         Places a '?' in the address bar. Type a search term after the question mark to perform a    
                                                                         search using your default search engine.                                                    
Press Ctrl+Shift and the left arrow together.                            Moves your cursor to the preceding key term in the address bar                              
Press Ctrl+Shift and the right arrow together.                           Moves your cursor to the next key term in the address bar                                   
Ctrl+Backspace                                                           Deletes the key term that precedes your cursor in the address bar                           
Select an entry in the address bar drop-down menu with your keyboard     Deletes the entry from your browsing history, if possible.                                  
arrows, then press Shift+Delete.                                                                                                                                     
Click an entry in the address bar drop-down menu with your middle mouse  Opens the entry in a new tab in the background.                                             
button (or mousewheel).                                                                                                                                              
Press Page Up or Page Down when the address bar drop-down menu is        Selects the first or last entry in the drop-down menu.                                      
visible.                                                                                                                                                             

Webpage shortcuts
=================
Ctrl+P                                                     Prints your current page.                                                
Ctrl+S                                                     Saves your current page.                                                 
Ctrl+R                                                     Reloads your current page.                                               
Esc                                                        Stops the loading of your current page.                                  
Ctrl+F                                                     Opens the find bar.                                                      
Ctrl+G or Enter                                            Finds the next match for your input in the find bar.                     
Ctrl+Shift+G or Shift+Enter                                Finds the previous match for your input in the find bar.                 
Press Alt and click a link.                                Downloads the target of the link.                                        
Ctrl+U                                                     Opens the source of your current page.                                   
Drag a link to bookmarks bar                               Saves the link as a bookmark.                                            
Ctrl+D                                                     Saves your current webpage as a bookmark.                                
Ctrl+Shift+D                                               Saves all open pages as bookmarks in a new folder.                       
F11                                                        Opens your page in full-screen mode. Press F11 again to exit full-screen.
Ctrl and +, or press Ctrl and scroll your mousewheel up.   Enlarges everything on the page.                                         
Ctrl and -, or press Ctrl and scroll your mousewheel down. Makes everything on the page smaller.                                    
Ctrl+0                                                     Returns everything on the page to normal size.                           
Space bar                                                  Scrolls down the web page.                                               
Home                                                       Goes to the top of the page.                                             
End                                                        Goes to the bottom of the page.                                          

Text shortcuts
==============
Ctrl+C                 Copies highlighted content to the clipboard.                    
Ctrl+V or Shift+Insert Pastes content from the clipboard.                              
Ctrl+Shift+V           Paste content from the clipboard without formatting.            
Ctrl+X or Shift+Delete Deletes the highlighted content and copies it to the clipboard. 






#####
#
# Changing the browser interface language (on W$)
# 2012dec27
#
#####

# «language» (to ".language")
# http://support.google.com/chrome/bin/answer.py?hl=en&answer=95416
#   -> Browser interface language

Windows
=======

The browser interface language is used for browser menus and dialogs
and it's based on the language you selected when you first downloaded
Google Chrome.

In Windows, follow these steps to change this setting:

Click Languages and spell-checker settings to open the "Language and
Input" dialog.

Select the language you'd like to use from the list. If the language
isn't listed, first add it as one of your preferred webpage languages.

On the right panel, click Display Google Chrome in this language.

Restart the browser to apply the changes.






#####
#
# The Javascript console
# 2012dec15
#
#####

# «console» (to ".console")
# https://developers.google.com/chrome-developer-tools/docs/console
# https://developers.google.com/chrome-developer-tools/docs/scripts-breakpoints
# http://www.chromium.org/devtools/google-chrome-developer-tools-tutorial
# http://stackoverflow.com/questions/45965/how-do-i-use-the-javascript-console-in-google-chrome/4867133
# http://www.codeproject.com/Articles/273129/Beginner-Guide-to-Page-and-Script-Debugging-with-C






#####
#
# Chrome on Debian
# 2013feb02
#
#####

# «debs» (to ".debs")

# (find-zsh "installeddebs | sort | grep google")
# (find-zsh "availabledebs | sort | grep google")
# (find-zsh "availabledebs | sort | grep chrom")
# (find-status   "google-chrome-stable")
# (find-vldifile "google-chrome-stable.list")
# (find-udfile   "google-chrome-stable/")
# (find-vldifile "google-chrome-stable.postinst")
# (find-vldifile "google-chrome-stable.prerm")
# (find-vldifile "google-chrome-stable.postrm")
# http://www.google.com/linuxrepositories/

# (find-status   "google-chrome-beta")
# (find-vldifile "google-chrome-beta.list")
# (find-udfile   "google-chrome/")
# (find-udfile   "google-chrome/changelog.gz")
# (find-vldifile "google-chrome-beta.postinst")
# (find-vldifile "google-chrome-beta.prerm")
# (find-vldifile "google-chrome-beta.postrm")

# http://googlechromereleases.blogspot.com.br/search/label/Beta%20updates

# (find-fline "/etc/default/google-chrome")
sudo touch /etc/default/google-chrome

http://www.google.com/chrome/eula.html?platform=linux
http://www.google.com/linuxrepositories/apt.html&quot
http://www.google.com/linuxrepositories/apt.htm
http://www.google.com/chrome/eula.html?platform=linux_ubuntu_i386l
http://www.google.com/support/chrome/bin/topic.py?topic=14658&tab=Features&hl=en-GB

# http://www.google.com/linuxrepositories/
# (find-fline "/etc/apt/sources.list.d/")
# (find-fline "/etc/apt/sources.list.d/google-chrome.list")
# http://dl.google.com/linux/chrome/deb/

# (find-man "1 google-chrome")
# http://www.google.com/support/chrome/

# http://code.google.com/chrome/extensions/docs.html
# http://www.chromium.org/Home
# http://www.google.com/googlebooks/chrome/index.html
# http://packages.qa.debian.org/c/chromium-browser.html
# http://ftp.de.debian.org/debian/pool/main/c/chromium-browser/

chromium-browser

 (eepitch-varda)
 (eepitch-kill)
 (eepitch-varda)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
R
apt-get install chromium-browser
y
apt-get install chromium-browser-inspector
y
apt-get install google-chrome-stable


# http://www.chromium.org/
# (find-status   "chromium-browser")
# (find-vldifile "chromium-browser.list")
# (find-udfile   "chromium-browser/")
# (find-status   "chromium-browser-inspector")
# (find-vldifile "chromium-browser-inspector.list")
# (find-udfile   "chromium-browser-inspector/")

# (find-man "1 chromium-browser")




#####
#
# chromium-browser versus google-chrome
# 2013feb02
#
#####

# «chromium-vs-chrome» (to ".chromium-vs-chrome")
# (find-zsh "availabledebs | sort | grep chrom")
# (find-zsh "installeddebs | sort | grep chrom")
# (find-available "chromium-browser")
# (find-available "google-chrome-beta")
# (find-available "google-chrome-stable")
# (find-available "google-chrome-unstable")
# (find-fline "/var/cache/apt/archives/" "google-chrome")
# (find-fline "/var/cache/flashplugin-nonfree/")

# Google Chrome is no longer updating because your operating system is obsolete.
# Learn more ->
#   http://support.google.com/chrome/bin/answer.py?hl=en&answer=95411




#####
#
# Could not load Shockwave Flash
# 2013feb02
#
#####

# «could-not-load-flash» (to ".could-not-load-flash")
# (find-status   "flashplugin-nonfree")
# (find-vldifile "flashplugin-nonfree.list")
# (find-udfile   "flashplugin-nonfree/")

# (find-fline "/usr/sbin/update-flashplugin-nonfree")
# (find-fline "/usr/share/bug/flashplugin-nonfree/script")
# (find-fline "/usr/share/lintian/overrides/flashplugin-nonfree")
# (find-man "8 update-flashplugin-nonfree")
# (find-fline "/usr/lib/mozilla/plugins/")

# (find-fline "/var/cache/flashplugin-nonfree/")

https://code.google.com/p/chromium/issues/detail?id=173790#c31
https://code.google.com/p/chromium/issues/detail?id=173790#c31
https://productforums.google.com/forum/#!msg/chrome/PEgELQH5zcg/c5lHKwslBcwJ
http://productforums.google.com/forum/#!topic/chrome/eVhuCUgmSzY
https://bbs.archlinux.org/viewtopic.php?id=157365
http://forums.debian.net/viewtopic.php?f=6&t=95269
http://askubuntu.com/questions/250448/youtube-couldnt-load-plug-in

# (find-fline "~/.config/google-chrome/")
# (find-fline "~/.config/google-chrome/PepperFlash/")






#####
#
# Auto-update
# 2013feb02
#
#####

# «auto-update» (to ".auto-update")
# http://support.google.com/chrome/bin/answer.py?hl=en&answer=95411
# http://support.google.com/chrome/bin/answer.py?hl=en&answer=95414&topic=14660&ctx=topic




#####
#
# Extensions
# 2013feb02
#
#####

# «extensions» (to ".extensions")
# (find-fline "~/.config/google-chrome/")
# http://developer.chrome.com/extensions/getstarted.html
# chrome://
# chrome://extensions
# https://chrome.google.com/webstore/category/extensions?hl=en-GB

https://chrome.google.com/webstore/detail/tampermonkey/dhdgffkkebhmkfjojejmpbldmpobfkfo?hl=en-GB
https://chrome.google.com/webstore/detail/awesome-new-tab-page/mgmiemnjjchgkmgbeljfocdjjnpjnmcg?hl=en-GB
https://chrome.google.com/webstore/detail/tineye-reverse-image-sear/haebnnbpedcbhciplfhjjkbafijpncjl?hl=en-GB
https://chrome.google.com/webstore/detail/black-menu/eignhdfgaldabilaaegmdfbajngjmoke?hl=en-GB
https://chrome.google.com/webstore/detail/readability/oknpjjbmpnndlpmnhmekjpocelpnlfdi?hl=en-GB
https://chrome.google.com/webstore/detail/edit-this-cookie/fngmhnnpilhplaeedifhccceomclgfbg?hl=en-GB
https://chrome.google.com/webstore/detail/html5ify/jikbjpjgjmmdhcmlagappehlpiljoaop?hl=en-GB
https://chrome.google.com/webstore/detail/shortcuts-for-google/baohinapilmkigilbbbcccncoljkdpnd?hl=en-GB
https://chrome.google.com/webstore/detail/pacman/palgcoflnoaklkflllnmheiollkgkipm?hl=en-GB
https://chrome.google.com/webstore/detail/note-board/goficmpcgcnombioohjcgdhbaloknabb?hl=en-GB
https://chrome.google.com/webstore/detail/ip-address/gjndloejlcbpkholmagjbddfkjmmploh?hl=en-GB
https://chrome.google.com/webstore/detail/autopagerize/igiofjhpmpihnifddepnpngfjhkfenbp?hl=en-GB
https://chrome.google.com/webstore/detail/cloudy-calculator/acgimceffoceigocablmjdpebeodphgc?hl=en-GB

http://www.sitepoint.com/create-chrome-extension-10-minutes-flat/




#####
#
# cache (esp. for videos)
# 2012aug29
#
#####

# «cached-videos»  (to ".cached-videos")
# http://unix.stackexchange.com/questions/7373/google-chrome-cache
# (find-sh "sudo ~/bin/flashget.sh")
# (find-angg "bin/flashget.sh")
# (find-fline "~/.cache/google-chrome/Default/")
# (find-fline "~/.cache/chromium/")

# (find-sh "ps ax")
# (find-sh "ps ax | grep chrome")
# (find-sh "ps ax | grep chrome | awk '{print $1}'")
# (find-sh "ps ax | grep chrome | awk '{print \"/proc/\" $1 \"/fd/\"}'")
# (find-sh "ps ax | grep chrome | awk '{print \"/proc/\" $1 \"/fd/\"}' | tee /tmp/o")
# (find-sh "ps ax | grep chrome | awk '{print \"$ASROOT/proc/\" $1 \"/fd/\"}'")
# (find-fline "/proc/16279/")
# (find-sh "sudo ls -lAF $(cat /tmp/o)")
# (find-sh "sudo find $(cat /tmp/o) | grep -v '/$'")
# (find-sh  "sudo find $(ps ax | grep chrome | awk '{print \"/proc/\" $1 \"/fd/\"}')")
# (find-zsh "sudo find $(ps ax | grep chrome | awk '{print \"/proc/\" $1 \"/fd/\"}') |& egrep '[0-9]$' | tee /tmp/o")
# (find-sh "sudo ls -lAF $(cat /tmp/o)")
# (find-sh "sudo ls -lAF $(cat /tmp/o) | grep home")
# (find-sh "sudo ls -lAF $(cat /tmp/o) | grep Pepper")
(defun foo () (interactive)
  (find-fline (concat "$ASROOT" (ee-stuff-around-point "[a-z0-9/]"))))

/proc/27638/fd/22

# (find-man "find")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
R
for i in $(ps ax | grep chrome | awk '{print $1}'); do
  laf /proc/$i/fd/*
done | grep deleted | tee /tmp/o | awk '{print $9}' | tee /tmp/o2
for i in $(cat /tmp/o2); do
  printf "%s %-8s %s " $i $(cat $i | wc -c); cat $i | file -
done

# (find-youtubedl-links "/sda5/videos/" "Dinosaur_Jr_-_Just_Like_Heaven" "G1SNaDZYDTY" ".flv" "justlikeheaven")
# http://www.youtube.com/watch?v=G1SNaDZYDTY

# (find-efunction 'dired-do-chmod)

(defun bar () (interactive)
  (ee-write-with-nl (ee-unsplit (dired-get-marked-files t nil))
		    nil nil nil "/tmp/o2"))

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/chrome/")
rm -Rv /tmp/chrome/
mkdir  /tmp/chrome/
cd     /tmp/chrome/
for i in $(cat /tmp/o2); do
  sudo cat   /proc/26319/fd/$i > /tmp/chrome/$i
  sudo ls -l /proc/26319/fd/$i   /tmp/chrome/$i
done





# (find-status   "google-talkplugin")
# (find-vldifile "google-talkplugin.list")
# (find-udfile   "google-talkplugin/")



google-talkplugin




#####
#
# Safe mode
# 2013jan06
#
#####

# «safe-mode» (to ".safe-mode")
# https://www.google.com.br/interstitial?url=http://www.uff.br/cppd/
# http://www.google.com/chrome/intl/en/privacy.html
# chrome://settings/
#   advanced settings -> privacy -> Enable phishing and malware protection
# http://www.uff.br/cppd/



#####
#
# AdBlock
# 2013may26
#
#####

# «adblock» (to ".adblock")
# chrome://extensions/
# (find-sh "locate -i adblock")
# (find-status   "xul-ext-adblock-plus")
# (find-vldifile "xul-ext-adblock-plus.list")
# (find-udfile   "xul-ext-adblock-plus/")
# (find-fline "/usr/share/xul-ext/adblock-plus/")




#####
#
# Flash lag in wheezy
# 2013may28
#
#####

# «flash» (to ".flash")

https://support.google.com/chrome/answer/142064?hl=en Plug-ins
http://helpx.adobe.com/flash-player/kb/flash-player-google-chrome.html
http://helpx.adobe.com/flash-player/kb/find-version-flash-player.html
http://www.labnol.org/software/google-chrome-flash-crashes/27753/

  Run the Flash Player On-demand inside Chrome
  A better alternative is that instead of completely blocking the
  Flash plugin, you configure Chrome such that the plugin loads only
  when required.

  Enable Flash on-demandIn this case, the plugin stays inactive by
  default but if you happen to visit a web page that requires Flash,
  you can load the plugin on-demand.

  Go to the address bar and type chrome://settings to open the Chrome
  Settings windows. Choose Show Advanced Settings -> Content Settings
  (under Privacy) and then choose Click to Play under the Plug-ins
  group.

  If a YouTube video or an audio clip on the Soundcloud requires
  Flash, you can click the plug-in icon to temporarily enable the
  Flash Player for that page. This obviously isnt a permanent fix
  but just a workaround to deal with a very frustrating and common
  problem of Google Chrome.

  Also see: Why is your Flash Player Green?

http://get.adobe.com/flashplayer/?no_redirect
https://developers.google.com/native-client/

Customize -> Settings -> Show advanced settings ->
  Privacy -> Content Settings -> Plug-ins ->
    Disable individual plug-ins ->
      Adobe Flash Player
      Shockwave Flash

chrome://plugins/
about://plugins/

# (find-fline "/opt/google/chrome/PepperFlash/")
# (find-status   "gnash")
# (find-vldifile "gnash.list")
# (find-udfile   "gnash/")




#####
#
# Shareaholic
# 2015may01
#
#####

# «shareaholic» (to ".shareaholic")
# https://shareaholic.com/tools/chrome/
# https://www.youtube.com/watch?v=8ZM13ap4x9A




#####
#
# Sync tabs
# 2014dec29
#
#####

# «sync-tabs» (to ".sync-tabs")
# https://support.google.com/chrome/answer/2591582?hl=en
# chrome://history
# chrome://history-frame
# (find-fline "~/LOGS/2015jan03.javascript")
# (find-fline "~/LOGS/2015jan03.javascript" "access the list of tabs")

<edrx> done: if I start in "chrome://history-frame/" instead of in
       "chrome://history/" I can access the list of tabs in my
       other device running chrome with
       "document.children[0].children[1].children[1].children[0].children[1].children[0].children[0].children[1]"...
       now a question that should be more interesting =) : how can
       I save that into a file? My guess is that from Javascript
       being run from a page I can't write to the

document.children[0].children[1].children[1].children[0].children[1].children[0].children[0].children[1]

// (find-blogme3file "html5-audio-mini.js" "to_pre")
mytabs = document.children[0].children[1].children[1].children[0].children[1].children[0].children[0].children[1];
mytabs.innerHTML = 'Hello';

// (find-blogme3file "html5-audio-mini.js" "time_re =")
mytabs = document.children[0].children[1].children[1].children[0].children[1].children[0].children[0].children[2];
myre    = /[<>]/g;
mytext  = mytabs.innerHTML;
mytext2 = mytext.replace(myre, ' ');


str.replace(time_re, f);




#####
#
# Profile locked
# 2016jul31
#
#####

# «profile-locked» (to ".profile-locked")
# Your profile could not be opened correctly.
#
# Some features may be unavailable. Please chekc that the profile
# exists and you have permission to read and write its contents.
#
# History sqlite error 5, errno 0: database is locked, sql: PRAGMA journal_mode = TRUNCATE
# History sqlite error 5, errno 0: database is locked, sql: PRAGMA cache_size=1000
# History sqlite error 5, errno 0: database is locked, sql: CREATE
#   TABLE meta(key LONGVARCHAR NOT NULL UNIQUE PRIMARY KEY, value
#   LONGVARCHAR)
#
# http://askubuntu.com/questions/368279/your-profile-could-not-be-opened-correctly-while-opening-chromeium
# (find-fline "~/.config/google-chrome/Default/" "Web Data")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
killall chrome
killall chrome




#####
#
# Creating new windows from the command line
# 2016oct08
#
#####

# «new-windows» (to ".new-windows")
# (find-man "1 google-chrome")




#####
#
# Installing chrome in (L)Ubuntu
# 2017jan15
#
#####

# «installing-chrome-lubuntu» (to ".installing-chrome-lubuntu")
# http://askubuntu.com/questions/510056/how-to-install-google-chrome
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
wget https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb
sudo dpkg -i google-chrome-stable_current_amd64.deb
apti -f

# (find-status   "google-chrome-stable")
# (find-vldifile "google-chrome-stable.list")
# (find-udfile   "google-chrome-stable/")





#####
#
# Delete specific cookies
# 2017jul21
#
#####

# «cookies» (to ".cookies")
# https://support.google.com/chrome/answer/95647



#####
#
# fill-out-forms
# 2018mai19
#
#####

# «fill-out-forms» (to ".fill-out-forms")
# https://support.google.com/chrome/answer/142893




#####
#
# inspect-images
# 2020mar19
#
#####

# «inspect-images» (to ".inspect-images")
# https://www.quora.com/How-do-I-view-a-list-of-image-files-used-on-a-site-when-inspecting-element-in-chrome
# https://www.wikihow.com/Inspect-Element-on-Chrome

Open Google Chrome Console (F12)
Go to Network tab
Enable Filter, if it's not enabled
Filter by "Img" and refresh the page to see a list of all images




#####
#
# Chrome redirects http://angg.twu.net/2020.1-C3.html to a Sumicity page
# 2020sep24
#
#####

# «redirect-sumicity»  (to ".redirect-sumicity")
# https://www.techwalla.com/articles/how-do-i-stop-links-from-redirecting-me-to-different-sites
# https://support.google.com/chrome/thread/17710849?hl=en Chrome keeps redirecting page to local country
# https://support.google.com/chrome/thread/27749024?hl=en prevent redirect for specific websites
# https://superuser.com/questions/784891/some-pages-in-chrome-always-redirect-to-ransom-page-at-http-system-check-fyelt

# http://cp.sumicity.com.br/2020.1-C3.html
# http://angg.twu.net/2020.1-C3.html

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
wget http://angg.twu.net/2020.1-C3.html
# file:///tmp/2020.1-C3.html
opera file:///tmp/2020.1-C3.html
opera http://angg.twu.net/2020.1-C3.html
rm -v    /tmp/2020.1-C3.html*




#####
#
# link-to-text-fragment
# 2020oct11
#
#####

# «link-to-text-fragment»  (to ".link-to-text-fragment")
# https://www.theverge.com/2020/6/18/21295300/google-link-to-text-fragment-chrome-extension-chromium-highlight-scroll-down
# https://chrome.google.com/webstore/detail/link-to-text-fragment/pbcodcjpfjdpcineamnnmbkkmkdpajjg

https://pt.wikipedia.org/wiki/Acantose_nigricans#:~:text=A%20acantose%20nigricans%20%C3%A9%20uma,que%20d%C3%A3o%20um%20aspecto%20verrugoso%20).

https://addons.mozilla.org/en-US/firefox/addon/link-to-text-fragment/



#####
#
# link-to-pdf-page
# 2020oct11
#
#####

# «link-to-pdf-page»  (to ".link-to-pdf-page")
# https://helpx.adobe.com/acrobat/kb/link-html-pdf-page-acrobat.html



#####
#
# puppeteer
# 2021jan03
#
#####

# «puppeteer»  (to ".puppeteer")
# https://developers.google.com/web/tools/puppeteer




#####
#
# promnesia
# 2021apr25
#
#####

# «promnesia»  (to ".promnesia")
# https://github.com/karlicoss/promnesia





#####
#
# multiple-profiles
# 2021jul29
#
#####

# «multiple-profiles»  (to ".multiple-profiles")
# https://linuxhint.com/use_multiple_profiles_simultaneously_google_chrome/




#####
#
# ~/.config/gtk-3.0/bookmarks
# 2021oct29
#
#####

# «gtk-bookmarks»  (to ".gtk-bookmarks")
# (find-fline "~/.config/gtk-3.0/")
# (find-fline "~/.config/gtk-3.0/bookmarks")

Gente, ha' um tempo atras a interface pra subir arquivos do Chrome
mudou pra essa dai' do screenshot... antes toda vez que eu queria
subir um arquivo no Chrome eu copiava ele pro /tmp/ e o Chrome listava
o conteudo do /tmp/ por default, mas agora eu nem sei como por o /tmp/
na lista de "default locations"... e ai' por enquanto o melhor modo -
que e' bem ruim - que eu achei pra listar o conteudo do /tmp/ na
interface atual e' abrir o home, a partir dele abrir o /, a e partir
do / eu abro o /tmp/...

Dica do Blau Araújo:
Essa interface não é do Chrome, mas um diálogo do Gtk, tanto que é a
mesma que abre no Firefox. Pra incluir novos locais, no seu
gerenciador de arquivos, vc deve procurar como incluir "marcadores
gtk". No meu, basta arrastar as pastas para o painel lateral.
Alternativamente, você pode incluir caminhos no arquivo
~/.config/gtk-3.0/bookmarks (pode criar se não existir). O formato tem
que ser:

file:///home/blau/docs Documentos
file:///home/blau/downloads Downloads
file:///home/blau/gits Gits
file:///home/blau/imgs Imagens
file:///home/blau/templates Modelos
file:///home/blau/music Música
file:///home/blau/docs/notes Notas
file:///home/blau/projetos Projetos
file:///home/blau/videos Vídeos
file:///home/blau/public_html Public HTML
... outros caminhos ...





#####
#
# Developer tools: ctrl-shift-I
# 2023oct16
#
#####

# «ctrl-shift-I»  (to ".ctrl-shift-I")
# https://gist.github.com/danfinlay/7357098
# https://www.youtube.com/watch?v=_eZeBg0jLy4
# (find-youtubedl-links "/sda5/videos/" nil "_eZeBg0jLy4" nil "{stem}")
# (code-video "dlvideovideo" "/sda5/videos/Download_any_YouTube_video_without_any_tool_just_the_Chrome_Developer_Tools-_eZeBg0jLy4.webm")
# (find-dlvideovideo)
# (find-dlvideovideo "0:00")




#####
#
# extension-samples
# 2023oct18
#
#####

# «extension-samples»  (to ".extension-samples")
# https://github.com/GoogleChrome/chrome-extensions-samples



#####
#
# disable-javascript
# 2023nov11
#
#####

# «disable-javascript»  (to ".disable-javascript")
# http://www.technipages.com/google-chrome-enable-or-disable-javascript
# chrome://settings/content?search=javascript




#####
#
# reader-mode
# 2023nov11
#
#####

# «reader-mode»  (to ".reader-mode")
# (find-fline "~/LOGS/2023nov11.emacs" "b) try reader mode")
# chrome://flags
# chrome://flags/#read-anything

Type chrome:flags into the browser's address bar. Type reading mode into the search box at the top of the screen that comes up. See the line labeled "Reading Mode"? Click the box next to it and change its setting from "Default" to "Enabled."




#####
#
# bookmarks-bar
# 2023dec14
#
#####

# «bookmarks-bar»  (to ".bookmarks-bar")
# https://support.google.com/chrome/search?q=bookmarks+bar



#####
#
# caret-browsing-f7
# 2024feb01
#
#####

# «caret-browsing-f7»  (to ".caret-browsing-f7")



 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
tr ' "' "\n\n" < o
tr ' "' "\n\n" < o | sort | uniq | grep http
# (find-sh "tr ' \"' \"\\n\\n\" < /tmp/o | sort | uniq | grep http")









# (find-fline       "/etc/apt/sources.list.d/google-chrome.list")
# (find-zsh "dmissing etc/apt/sources.list.d/google-chrome.list")
# (find-vldifile "")
# (find-vldigrep "grep -nH -e google-chrome *")







http://ctrlq.org/screenshots/

  Full Screen Capture
  You don't need any software or browser extensions to capture the
  image of any web page. And it works with lengthy web pages too that
  extend below the fold.





chrome://plugins
chrome://downloads

https://developers.google.com/chrome-developer-tools/
https://developers.google.com/chrome-developer-tools/docs/elements


https://productforums.google.com/forum/?fromgroups=#!topic/chrome/82hKRdhRr5A%5B1-25-false%5D

chrome://adblockplus/content/ui/firstRun.xhtml


https://www.symantec.com/connect/blogs/google-chrome-keyboard-shortcuts

https://chrome.google.com/webstore/detail/taco-cat-delicious-youtub/iegmpfdipklbjmceponeleminmonboob

https://peter.sh/experiments/chromium-command-line-switches/
https://www.howtoforge.com/tutorial/linux-swappiness/ 

<edrx> sometimes google chrome takes all memory and practically all
       the swap memory here, and the system becomes so sluggish
       that even switching to VT5 and issuing a "killall chrome"
       takes more that 30 seconds. would this become better if I
       start to run chrome with "nice"? any suggestions of
       command-line options?
<twb> oni-on-ion: (setq mu4e-msg2pdf "open") ?
<twb> oni-on-ion: I don't think that will Just Work because of
      mu4e's bad design
<oni-on-ion> also down at "HTML Mails" (cant link the anchor):
             (add-to-list 'mu4e-view-actions '("ViewInBrowser" .
             mu4e-action-view-in-browser) t)
<twb> oni-on-ion: I assume msg2pdf(1mu4e) reads in an entire
      message/rfc822 rather than just a text/plain part
<oni-on-ion> jasoer92, you are either trying to do what the guy
             did, or doing your own thing now.
<jasoer92> I already have that. I want pdf too
<jasoer92> I have the browser part
<jasoer92> I am trying to (setq mu4e-msg2pdf
           "/usr/local/bin/msg2pdf")
<Viking667> okay. What's the reason for rendering to pdf?
<oni-on-ion> edrx, this is my main issue as well. on firefox with
             4gb ram. basically i close the browser often because
             it never cleans up, otherwise it locks the system for
             several minutes
<twb> Viking667: they won't tell us because it's a secret
<edrx> oni-on-ion: =(
<twb> Viking667: so I guess the reason must be porn or apostacy
<Viking667> jasoer92: why do you want to render emails to pdf?
<oni-on-ion> edrx, i have tried this :
             https://www.howtoforge.com/tutorial/linux-swappiness/ 
<oni-on-ion> maybe he himself does not know why
<jasoer92> You folks don't know how to use msg2pdf like that guy ?
           So should I just ask him?
<twb> parsnip: out of curiosity, what happens on MacOS if you just
      run "open fuck.eml" ?
<edrx> oni-on-ion: (I guessed that twb knows a lot about how "nice"
       works, that's why I asked without mentioning him)
<oni-on-ion> edrx, its a swap/memory/disk thing, not cpu priority 
<twb> edrx: is chrome still using /dev/shm?
<parsnip> twb: it attempts to open Mail.app, which is not
          configured
<twb> edrx: and no nice won't help because chrome is setuid
<oni-on-ion> i complain about slow browser in here at least
             biweekly
<twb> parsnip: ah bummer
<Viking667> jasoer92: if you're asking me, no I don't ever render
            emails in emacs. But that seems to be a slightly weird
            request when you already have the html rendered.
<twb> You can try this but it won't help
<twb> ff () { oomnice nice ionice -c3 chrt --idle 0 with-temp-dir
      sh -xec 'HOME=$PWD exec "$@"' -- firefox-esr "$@"; }
<twb> Where oomnice is
<parsnip> note they still haven't answered question
<twb> http://cyber.com.au/~twb/.bin/oomnice
<oni-on-ion> eh for me the browser is a swappiness thing. 
<edrx> twb: about /dev/shm: no idea. about setuid root: OUCH, I
       didn't know that!!!
<oni-on-ion> just saying. fighting this demon for 2years
<twb> You can also try sysctl proc.vm.swappiness=0 to reduce swap
      thrash
<oni-on-ion> 10 might be better
<twb> edrx: technically it's not setuid anymore but it's...
      whatever bubblewrap uses nowadays
<oni-on-ion> also for me its only two websites. 1) reddit 2) any
             news article


# (find-status   "bubblewrap")
# (find-vldifile "bubblewrap.list")
# (find-udfile   "bubblewrap/")
# (find-udfile "bubblewrap/README.md.gz")

https://linuxhint.com/use_multiple_profiles_simultaneously_google_chrome/

https://news.ycombinator.com/item?id=29071700 Web developer tool secrets that shouldn’t be secrets (christianheilmann.com) - Developer Tools

https://news.ycombinator.com/item?id=29199004 Show HN: Stringmark – Chrome extension that makes online research easier (stringmark.com)
chrome text fragment extension

https://news.ycombinator.com/item?id=29296642 Automa: A Chrome extension for automating the browser (chrome.google.com)
https://news.ycombinator.com/item?id=29299140 Functorio (bartoszmilewski.com)

https://github.com/gorhill/uBlock

https://news.ycombinator.com/item?id=29621642 Against 3x Speed (perell.com)
https://github.com/igrigorik/videospeed






#  Local Variables:
#  coding:               utf-8-unix
#  End:
