#######
#
# E-scripts on debootstrap.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/debootstrap.e>
#           or at <http://angg.twu.net/e/debootstrap.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.install-other-distro»	(to "install-other-distro")




# (find-esgrep "grep --color -nH -e debootstrap *.e")
# (find-es "debrepository" "debootstrap")
# (find-es "debrepository" "debootstrap-2018")

# (find-status   "debootstrap")
# (find-vldifile "debootstrap.list")
# (find-udfile   "debootstrap/")
# (find-man "8 debootstrap")
# (find-man "8 debootstrap" "--no-check-gpg")
# (find-udfile "debootstrap/README.Debian")
# (find-fline "/usr/lib/debootstrap/")




#####
#
# Using debootstrap to install another distro
# 2019apr21
#
#####

# «install-other-distro» (to ".install-other-distro")
# Hints from klys from #grub...

<edrx> hi all. I am using a ThinkPad T400 with LibreBoot, and with
       a single partition with Trisquel that got some bugs with
       time (long story). I am trying to shrink that partition and
       create a Debian partition in the rest of the HD, but I'm
       stumbling on several difficulties - please advise =(
<edrx> First: I've been able to read the contents of the flash
       memory to inspect its grub config, but flashrom says that it
       may be dangerous to try to overwrite the flash memory. My
       script to read the flash and the relevant part of the
       (verbose) output are here:
<edrx> http://angg.twu.net/e/libreboot.e.html#libreboot-util
<edrx> Second: I downloaded an ISO of an Debian install CD and
       dd'ed it to a pen drive, following this:
       https://www.debian.org/CD/faq/#write-usb
<edrx> but when I insert that pen drive and boot into libreboot
       then SOME things break...
<klys> trisquel has a kernel, no?
<klys> I am accustomed to using debian with custom kernel
<edrx> I can run the option 'Search ISOLINUX menu (USB)  [u]' in
       the grub from libreboot. The background image changes, which
       indicates that it is able to access the pen drive... but TAB
       completion on device names now freezes grub...
<edrx> klys: yes, it's a debian derivative
<klys> in that case, perhaps the best way to install will be:
       debootstrap
<klys> granted, you seem to need some help with your new kernel
<edrx> yep, that looks good, but does that work well to install a
       different distro?
<klys> yes
<klys> I've used it to install old and new debians
<edrx> ooooooo =)
<edrx> did you keep notes of what you did, or do you have a link
       that explains how to use that to install a different distro?
       (I'm googling for that)
<klys> so, debootstrap --arch=amd64 stretch /mnt
       https://mirrors.edge.kernel.org/debian
<klys> or buster if you want a frozen stable
<edrx> one second, I'm trying to take notes in an organized way...
       I'll show them to you in a second
<klys> it seems buster isn't quite released yet; when it is, jessie
       will go here: http://archive.debian.org/debian
<klys> one option that i've used on some debootstrap commands was:
       --no-check-gpg


# https://www.debian.org/releases/
# The current stable distribution of Debian is version 9, codenamed
# stretch. It was initially released as version 9 on June 17th, 2017
# and its latest update, version 9.8, was released on February 16th,
# 2019.
# The current testing distribution is buster.

# (find-man "8 debootstrap")
# (find-man "8 debootstrap" "--arch=ARCH")
# (find-man "8 debootstrap" "SUITE TARGET [MIRROR [SCRIPT]]")

debootstrap --arch=amd64 stretch /mnt
debootstrap --arch=amd64 stretch /mnt https://mirrors.edge.kernel.org/debian






#  Local Variables:
#  coding:               utf-8-unix
#  End:
