#######
#
# E-scripts on drawing diagrams (mainly for categories).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/diagrams.e>
#           or at <http://angg.twu.net/e/diagrams.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.xfig»			(to "xfig")
# «.transfig»			(to "transfig")
# «.pstricks-old»		(to "pstricks-old")
# «.pstricks»			(to "pstricks")
# «.formulas-with-links»	(to "formulas-with-links")
# «.tikz»			(to "tikz")

# (find-fline "~/TH/Files.tcl" "diaglib")
# (find-fline "~/LATEX/diaglib.014")




#####
#
# diaglib stuff left from old versions
# 2000sep23
#
#####

(defun eediag-bounded2 (n) (interactive "p")
  (ee-write-bounded
   "----------\n" "\n#----------"
   "cd ~/LATEX; cat > tmpdiag <<'--%%--'\nsource diaglib.013\n"
   (concat (if n "blackify; output_o.ps; exit" "")
	   "\n--%%--\nwish tmpdiag &\n")))
;(global-set-key [f3] 'eediag-bounded2)





#####
#
# xfig
# 2001aug15
#
#####

# «xfig»  (to ".xfig")
# (find-status "xfig")
# (find-vldifile "xfig.list")
# (find-fline "/usr/doc/xfig/")

# (find-status "xfig-doc")
# (find-vldifile "xfig-doc.list")
# (find-fline "/usr/doc/xfig-doc/")
# (find-w3 "/usr/doc/xfig-doc/html/attributes.html#text-flags")

edrxnetscape /usr/doc/xfig-doc/html/index.html &





#####
#
# transfig
# 2001aug15
#
#####

# «transfig»  (to ".transfig")
# (find-status "transfig")
# (find-vldifile "transfig.list")
# (find-fline "/usr/doc/transfig/")
# (find-man "1x fig2dev")
# (find-man "1x fig2dev" "PSTEX OPTIONS")
# (find-man "1x fig2dev" "POSTSCRIPT, ENCAPSULATED POSTSCRIPT (EPS)")
# (find-man "1x fig2dev" "Valid  languages")
# (find-man "1x fig2ps2tex")
# (find-man "1x pic2tpic")
# (find-man "1x transfig")
#
rm -Rv /tmp/fig/
mkdir  /tmp/fig/
cd     /tmp/fig/
cat > a.fig <<'---'
#FIG 3.2
Landscape
Center
Metric
A4      
100.00
Single
-2
1200 2
1 3 0 1 0 7 50 0 -1 0.000 1 0.0000 1350 1800 443 443 1350 1800 1755 1980
1 3 0 1 0 7 50 0 -1 0.000 1 0.0000 2250 3600 450 450 2250 3600 2250 3150
1 2 0 1 0 7 50 0 -1 0.000 1 0.0000 4050 1957 450 293 3600 2250 4500 1665
3 0 0 1 0 7 50 0 -1 0.000 0 0 0 3
	 1350 2295 1350 2700 1935 3285
	 0.000 1.000 0.000
4 0 0 50 0 0 12 0.0000 4 135 510 1080 2025 abcdef\001
4 0 0 50 0 0 20 0.0000 4 195 645 1980 3735 lower\001
4 0 0 50 0 0 20 0.0000 4 195 600 3825 2070 rm20\001
---

# (find-man "1x fig2dev" "Valid  languages")
# (find-man "1x transfig")

# Transfig recognizes a subset of the languages that fig2dev recognizes...
# It doesn't like any of these:
#
for LANG in \
   cgm gif ibmgl jpeg map mf pcx pdf png ppm pstex_t sld tiff tk xbm xpm
do transfig -L $LANG a.fig && echo $LANG
done

# And it knows how to deal with all of these:
#
for LANG in box eepic eepicemu epic eps latex pic pictex ps pstex textyl tpic
do transfig -L $LANG -M Makefile-$LANG -T a-$LANG.tex a.fig && echo $LANG
done

#
# (find-fline "/tmp/fig/")
# (find-node "(make)Double-Colon")




#####
#
# pstricks
# 2001aug16
#
#####

# «pstricks-old»  (to ".pstricks-old")
# (find-status "tetex-doc")
# (find-vldifile "tetex-doc.list" "/pstricks/")
# (code-c-d "pstdoc" "/usr/share/doc/texmf/generic/pstricks/")
# (find-pstdocfile "")
# (find-pstdocfile "obsolete/")
# (find-pstdocfile "obsolete/pst-doc.err")
#
cd /usr/share/doc/texmf/generic/pstricks/obsolete/
gv betadoc1.ps.gz
gv betadoc2.ps.gz
gv pst-doc.err
gv pst-quik.ps.gz
gv pst-usr1.ps.gz
gv pst-usr2.ps.gz
gv pst-usr3.ps.gz
gv pst-usr4.ps.gz
#

# (find-fline "/usr/doc/tetex-doc/")

rm -Rv $CTAN/graphics/pstricks/
cd $CTAN/graphics/
tar -xvzf pstricks.tar.gz
gzip -dv $(find pstricks -name '*.gz')

gv $CTAN/graphics/pstricks/origdoc/pst-quik.ps &
gv $CTAN/graphics/pstricks/origdoc/pst-usr1.ps &
gv $CTAN/graphics/pstricks/origdoc/pst-usr2.ps &
gv $CTAN/graphics/pstricks/origdoc/pst-usr3.ps &
gv $CTAN/graphics/pstricks/origdoc/pst-usr4.ps &

cd $CTAN/graphics/pstricks/origdoc/

# (find-pstfile "src.old/pst-user.tex")
# (find-pstfile "src.old/pst-user.sty" 199)
# (find-pstfile "src.old/pstricks.doc")
# (find-pstfile "src.old/pst-make.tex")
# (find-pstfile "src.old/pst-code.tex")

# (find-fline "~/PS/pst1.tex")

# (find-lsrcfile "base/doc.dtx" "abstract")
# (find-lsrcfile "base/doc.dtx" "produce the documentation")
# (find-lsrcfile "base/ltxdoc.dtx" 82)
# (find-fline "/usr/lib/texmf/texmf/tex/latex/base/doc.sty")




# «pstricks»  (to ".pstricks")
# (find-zsh "installeddebs | sort" "texlive")
# (find-zsh "dmissing pstricks")
# (find-zsh "dmissing pdftricks")

# (find-status   "texlive-pictures-doc")
# (find-vldifile "texlive-pictures-doc.list")
# (find-udfile   "texlive-pictures-doc/")
# (find-status   "texlive-pictures")
# (find-vldifile "texlive-pictures.list")
# (find-udfile   "texlive-pictures/")
# (find-status   "texlive-pstricks-doc")
# (find-vldifile "texlive-pstricks-doc.list")
# (find-udfile   "texlive-pstricks-doc/")
# (find-status   "texlive-pstricks")
# (find-vldifile "texlive-pstricks.list")
# (find-udfile   "texlive-pstricks/")

# (find-fline "/usr/share/doc/texlive-pstricks-doc/generic/")





#####
#
# links between parts of a formula
# 2009jun14
#
#####

# «formulas-with-links»  (to ".formulas-with-links")
# http://www.dimap.ufrn.br/pipermail/logica-l/2009-June/003689.html
# Note that the pst-node block below doesn't work...
# The error (when it is uncommented) is:
#   ! Undefined control sequence.
#   <recently read> \c@lor@to@ps 
#   l.16 \nccurve[angleA=90,angleB=90]{1}{3}

#

rm -Rv /tmp/testlinks/
mkdir  /tmp/testlinks/
cd     /tmp/testlinks/

cat >  /tmp/testlinks/testlinks.tex <<'---'
\documentclass[a4paper,10pt]{article}
%\usepackage[latin1]{inputenc}
%\usepackage[brazilian]{babel}
%\usepackage{amssymb}
%\usepackage{fontenc}
\usepackage{graphicx}
\usepackage{pst-node}
\usepackage[all]{xy}
\usepackage{tikz}
\usetikzlibrary{matrix}
\begin{document}

%pst-node:
%$$
%(\Rnode{1}{A} \wedge \Rnode{2}{B}) \vee (\Rnode{3}{C} \wedge \Rnode{4}{D})
%\nccurve[angleA=90,angleB=90]{1}{3}
%\nccurve[angleA=90,angleB=90]{2}{4}
%$$

xypic:
 \[
       \xymatrix@C=-4pt{
         ( &
         A \ar@(u,u)@{-}[rrrrrr] &
         \land &
         B \ar@(d,d)@{-}[rrrrrr]&
         ) &
         \lor &
         ( &
         C &
         \land &
         D &
         )
       }
     \]

tikz:
 \[
       \begin{tikzpicture}
         \matrix(m)[matrix of math nodes, column sep=-5pt]{
           (& A & \land & B & ) & \lor & ( & C & \land & D & ) \\
         };
         \draw (m-1-2) to [out=90, in=90] (m-1-8);
         \draw (m-1-4) to [out=270, in=270] (m-1-10);
       \end{tikzpicture}
     \]

\end{document}
---

#  latex testlinks.tex
pdflatex testlinks.tex

#
# (find-fline   "/tmp/testlinks/")
# (find-pspage "/tmp/testlinks/testlinks.pdf")




#####
#
# Tikz
# 2012feb12
#
#####

# «tikz»  (to ".tikz")
# (find-es "xypic" "pgf")
# (find-angg ".emacs.papers" "pgf")
# (find-zsh "installeddebs | sort | grep texlive-pictures")
# (find-zsh "availabledebs | sort | grep texlive-pictures")
# (find-status   "texlive-pictures")
# (find-vldifile "texlive-pictures.list")
# (find-udfile   "texlive-pictures/")
# (find-status   "texlive-pictures-doc")
# (find-vldifile "texlive-pictures-doc.list")
# (find-udfile   "texlive-pictures-doc/")
# (find-status   "pgf")
# (find-vldifile "pgf.list")
# (find-udfile   "pgf/")
# (find-zsh "dmissing tikz")
# (find-angg "MINICATS/")
# (find-fline "~/MINICATS/categoria66.tex" "tikzcd")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/MINICATS/
latex categoria66.tex

# ! LaTeX Error: File `tikz-cd.sty' not found.

# http://ctan.org/pkg/tikz-cd
# http://ctan.org/tex-archive/graphics/pgf/contrib/tikz-cd
# http://mirror.ctan.org/graphics/pgf/contrib/tikz-cd.zip
# http://www.ctan.org/pkg/pgf

rm -Rv   ~/usrc/tikz-cd/
mkdir    ~/usrc/tikz-cd/
unzip -d ~/usrc/ $S/http/mirror.ctan.org/graphics/pgf/contrib/tikz-cd.zip
cd       ~/usrc/tikz-cd/

# http://ctan.org/tex-archive/graphics/pgf/base/doc/generic/pgf

;; (find-sh "locate pgfmanual")
/usr/share/doc/texmf/pgf/pgfmanual.pdf.gz



http://www.dimap.ufrn.br/pipermail/logica-l/2013-May/019281.html
http://www.dimap.ufrn.br/pipermail/logica-l/2013-May/019288.html
https://www.writelatex.com/201971gzmchf





#  Local Variables:
#  coding:               utf-8-unix
#  End:
