#######
#
# E-scripts on dict.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/dict.e>
#           or at <http://angg.twu.net/e/dict.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.unpacking-jargon»		(to "unpacking-jargon")
# «.english-to-portuguese»	(to "english-to-portuguese")
# «.selecting_a_dictionary»	(to "selecting_a_dictionary")
# «.external-servers»		(to "external-servers")
# «.dict-on-etch»		(to "dict-on-etch")
# «.dict-on-trisquel»		(to "dict-on-trisquel")
# «.dict-on-bullseye»		(to "dict-on-bullseye")
# «.translate-shell»		(to "translate-shell")


#
apt-get install dict dictd dict-gcide dict-jargon
apt-get install     dict-wn dict-foldoc dict-vera
#

# (find-progoutput "dpkg -l" "dict-")
# (find-available "dictd" "dictionary databases")
# (find-udfile    "dictd/README.Debian.gz")
# (find-udfile    "dictd/README.Debian.gz" "`dict-gcide'")
# (find-available "dict-gcide")
# (find-available "dict-wn")
# (find-available "dict-jargon")
# (find-available "dict-foldoc")
# (find-available "dict-vera")

# (find-status   "dict-gcide")
# (find-vldifile "dict-gcide.list")
# (find-udfile   "dict-gcide/")
cd /usr/share/dictd/

#
cd $SDEBIAN
agrep dict ls-lR.i > ~/o
#
# (find-fline "~/o")

#  1149228 dict-easton
#    21736 dict-elements
#  2149144 dict-foldoc
#  2213548 dict-gazetteer
#    59874 dict-hitchcock
#   580140 dict-jargon
# 13001354 dict-web1913
#  8469070 dict-wn
#    49504 dict
#   158382 dictd

# (find-available "dict-easton")
# (find-available "dict-elements")
# (find-available "dict-foldoc")
# (find-available "dict-gazetteer")
# (find-available "dict-hitchcock")
# (find-available "dict-jargon")
# (find-available "dict-web1913")
# (find-available "dict-wn")
# (find-available "dict")
# (find-available "dictd")
# (find-available "wordinspect")

# (find-available "diction")

# (find-status   "dict")
# (find-vldifile "dict.list")
# (find-udfile   "dict/")

# (find-udfile "dict/examples/example.dictrc.gz")
# (find-udfile "dict/README.Debian.gz")
# (find-udfile "dict/NEWS.Debian.gz")
# (find-udfile "dict/NEWS.gz")
# (find-udfile "dict/changelog.Debian.gz")
# (find-udfile "dict/copyright")
# (find-man "1 colorit")
# (find-man "1 dict")
# (find-man "1 dictl")
# (find-fline "/usr/bin/dict")
# (find-fline "/usr/bin/dictl")
# (find-fline "/usr/bin/colorit")
# (find-fline "/etc/dictd/dict.conf")
# (find-udfile "dict/changelog.gz")





#####
#
# Unpacking the Jargon dictionary into a single text file
# 2003jul01
#
#####

# «unpacking-jargon»  (to ".unpacking-jargon")
# (find-status "dict-jargon")
# (find-vldifile "dict-jargon.list")
# (find-fline "/usr/doc/dict-jargon/")
#
zcat /usr/share/dictd/jargon.dict.dz > /tmp/jargon.dict
#
# (find-fline "/tmp/jargon.dict")

# (find-available "leksbot")

# 2015may27:
# (find-fline "/usr/share/dictd/jargon.dict.dz")





####
#
# English -> Portuguese
# 2004apr04
#
####

# «english-to-portuguese»  (to ".english-to-portuguese")

# (find-status "dictd")
# (find-vldifile "dictd.list")
# (find-fline "/usr/doc/dictd/")
# (find-fline "/usr/doc/dictd/README.Debian.gz" "/etc/dictd.order")
# (find-man "1 dictzip")
# (find-man "1 dictunzip")
# (find-man "1 dictzcat")

# (find-status "dictfmt")
# (find-vldifile "dictfmt.list")
# (find-fline "/usr/doc/dictfmt/")
# (find-man "1 dictfmt")

# http://www.freedict.de/How_make_dictionaries.html
# http://me.in-berlin.de/~myrkr/dictionary/index.html

# The "eng-por" dictionary in freedict.sf is empty! Weird...
# http://freedict.sourceforge.net/download/linux/eng-por.tar.gz
# http://freedict.sourceforge.net/download/linux/swe-eng.tar.gz

# This one is ok:
# http://ftp.debian.org/debian/pool/main/f/freedict/

#
rm -Rv /tmp/eng-por/
mkdir  /tmp/eng-por/
cd     /tmp/eng-por/
debtarxvzf $S/http/ftp.debian.org/debian/pool/main/f/freedict/dict-freedict-eng-por_1.1-4_all.deb

cd /tmp/eng-por/usr/share/dictd/
zcat freedict-eng-por.dict.dz > /tmp/eng-por/eng-por.dict

#
# (find-fline "/tmp/eng-por/eng-por.dict")

(defun ascstr (i lasti &optional default)
  (while (<= i lasti)
    (insert (cond ((char-valid-p i) i)
		  (default default)
		  (t i)))
    (setq i (+ i 1))))

(ascstr 332000 333000 " ")






####
#
# adding a dictionary by hand
# 2004apr06
#
####

# (find-status "dictd")
# (find-vldifile "dictd.list")
# (find-fline "/usr/doc/dictd/")

# (find-status "dict-jargon")
# (find-vldifile "dict-jargon.list")
# (find-vldifile "dict-jargon.postinst")
# (find-fline "/usr/doc/dict-jargon/")

# (find-man "8 dictdconfig")
# (find-fline "/etc/dict.conf")
# (find-fline "/etc/dictd.conf")
# (find-fline "/var/lib/dictd/db.list")



#####
#
# selecting a dictionary
# 2005jun26
#
#####

# «selecting_a_dictionary»  (to ".selecting_a_dictionary")
# (find-man "1 dict")
# (find-sh "dict            evil")
# (find-sh "dict -d jargon  evil")
# (find-sh "dict -d jargon 'evil and rude'")

# (find-man "1 dict" "-c file")





#####
#
# external servers
# 2007may21
#
#####

# «external-servers»  (to ".external-servers")
# (find-vldifile "dict.conffiles")
# (find-fline "/etc/dictd/dict.conf")
# Hmm, it seems that in the default config for dict is this...
# server localhost 
# server dict.org
# server dict0.us.dict.org
# server alt0.dict.org

 (eepitch-shell)
sudo dselect update

# (find-zsh "installeddebs | sort")
# (find-zsh "availabledebs | sort" "\ndict-")
# (find-angg ".zshrc" "installeddebs")
# (find-angg ".zshrc" "prep-apti")
# (find-angg ".zshrc" "prep-apti" "prep-apti-dict")

apti dict dictd dict-gcide dict-jargon
apti dict-wn
apti dict-foldoc

# (find-sh "dict dawn")

# (find-status   "dict")
# (find-vldifile "dict.list")
# (find-udfile   "dict/")
# (find-fline "/etc/dictd/dict.conf")





#####
#
# dict on etch
# 2008aug15
#
#####

# «dict-on-etch»  (to ".dict-on-etch")
# The default dictd.conf specifies external servers...
# How do I install all dictionaries locally?
# Which dictionaries are searched?
# (find-fline "/etc/dictd/dict.conf")
#   server localhost 
#   server dict.org
#   server dict0.us.dict.org
#   server alt0.dict.org

# (find-man "dict")





#####
#
# dict on trisquel
# 2018dec23
#
#####

# «dict-on-trisquel» (to ".dict-on-trisquel")
# (find-zsh "installeddebs | sort | grep dict")
# (find-zsh "availabledebs | sort | grep dict")
# (find-zsh "availabledebs | sort | grep ^dict | grep -v freedict")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti dict dictd dict-gcide dict-jargon
apti     dict-wn dict-foldoc dict-vera

# (find-fline "/etc/default/dictd")

dict




#####
#
# dict-on-bullseye
# 2021aug17
#
#####

# «dict-on-bullseye»  (to ".dict-on-bullseye")
# (find-zsh "installeddebs | sort | grep dict")
# (find-zsh "availabledebs | sort | grep dict")
# (find-zsh "availabledebs | sort | grep ^dict | grep -v freedict")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti dict dictd dict-foldoc dict-gcide dict-jargon dict-vera dict-wn
apti dict-devil






#####
#
# translate-shell
# 2021aug15
#
#####

# «translate-shell»  (to ".translate-shell")
# (find-status   "translate-shell")
# (find-vldifile "translate-shell.list")
# (find-udfile   "translate-shell/")




http://www.hyperdictionary.com/dictionary/gray


# (find-zsh "installeddebs | sort | grep dict")
# (find-zsh "availabledebs | sort | grep dict")

apti dict-gcide dict-jargon dict-foldoc dict-vera

dict-wn dict-foldoc
serpento
wordtrans-dict

# (find-available "serpento")
# (find-available "wordtrans-dict")




# http://www.ietf.org/rfc/rfc2229.txt
# (find-rfcfile "rfc2229.txt")


2020sep30:
https://hewgill.com/dict/

What is missing in dictionary.el?  It is implemented in Emacs Lisp, I just
tried it (apt-get install elpa-dictionary), and it seems to work fine.
The default server is dict.org, port 2628, which gives access to all
dictionaries available in Debian.


  https://github.com/cheusov/dictem
  https://sourceforge.net/projects/dictem/files/dictem/dictem-1.0.4/

<incal> hello, I just installed iamerican-insane on Debian, does
        that thereafter work in Emacs? (ispell-change-dictionary
        "american-insane") says "ispell-change-dictionary:
        Undefined dictionary: american-insane" but "american" works
*** bilegeek QUIT Quit: Leaving
*** random-nick QUIT Ping timeout: 260 seconds
<aidalgol> wtf is the american-insane dictionary?
<incal> "This is an even larger dictionary than the one installed
        by iamerican-huge, and possibly contains invalid words (as
        well as words that are very uncommon)."

https://irreal.org/blog/?p=10815 Webster’s 1913 Redux 
http://jsomers.net/blog/dictionary 
https://irreal.org/blog/?p=10824 Webster 1913 and dictionary.el
https://janusworx.com/blog/noahs-in-emacs/
https://www.masteringemacs.org/article/wordsmithing-in-emacs




#  Local Variables:
#  coding:               utf-8-unix
#  End:
