#######
#
# E-scripts on writing documentation (docbook, sgml, etc).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/doc.e>
#           or at <http://angg.twu.net/e/doc.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.psgml»	(to "psgml")




dmissingp docbook | tee ~/o
awk '{print $2}' < ~/o | sort | uniq | tee ~/o2

Pgrepp m/docbook/ |& l -S
Pgrepp m/psgml/ |& l -S

# (find-fline "~/o")
# (find-fline "~/o2")

apti task-sgml
apti psgml perlsgml tdtd

# (find-status "task-sgml")
# (find-vldifile "task-sgml.list")
# (find-fline "/usr/doc/task-sgml/")





#####
#
# psgml (a sgml mode for emacs)
# 2001feb01
#
#####

# «psgml»  (to ".psgml")
# (find-status "psgml")
# (find-vldifile "psgml.list")
# (find-fline "/usr/doc/psgml/")
# (find-w3 "/usr/doc/psgml/psgml_toc.html")

# (find-fline "/usr/doc/psgml/example-customization.el.gz")
# (find-fline "/etc/emacs20/site-start.d/50psgml-init.el")
# (find-sitelispfile "psgml/")

# (find-node "(psgml)Top")

#
# Reading in-place will break because common.ent will be gzipped...
# (find-fline "/usr/doc/developers-reference/developers-reference.sgml.gz")
# So we do this:
rm -Rv /tmp/sgmltest/
mkdir  /tmp/sgmltest/
cd     /tmp/sgmltest/
cp -v /usr/doc/developers-reference/* .
gzip -dv *.gz

# And now this works fine:
# (find-fline "/tmp/sgmltest/developers-reference.sgml")

#





# (find-status "tdtd")
# (find-vldifile "tdtd.list")
# (find-fline "/usr/doc/tdtd/")

# (find-status "perlsgml")
# (find-vldifile "perlsgml.list")
# (find-fline "/usr/doc/perlsgml/")




cygnus-stylesheets
docbk-xml2x
docbook
docbook-doc
docbook-stylesheets
docbook-stylesheets-doc
docbook-to-man
docbook-xml
docbook2man
docbook2texi
docbook2x-doc
lyx


# (find-status "cygnus-stylesheets")
# (find-vldifile "cygnus-stylesheets.list")
# (find-fline "/usr/doc/cygnus-stylesheets/")

# (find-status "docbk-xml2x")
# (find-vldifile "docbk-xml2x.list")
# (find-fline "/usr/doc/docbk-xml2x/")

# (find-status "docbook")
# (find-vldifile "docbook.list")
# (find-fline "/usr/doc/docbook/")

# (find-status "docbook-doc")
# (find-vldifile "docbook-doc.list")
# (find-fline "/usr/doc/docbook-doc/")
# (find-w3 "/usr/doc/docbook-doc/index.html")


# (find-status "docbook-stylesheets")
# (find-vldifile "docbook-stylesheets.list")
# (find-fline "/usr/doc/docbook-stylesheets/")

# (find-status "docbook-stylesheets-doc")
# (find-vldifile "docbook-stylesheets-doc.list")
# (find-fline "/usr/doc/docbook-stylesheets-doc/")

# (find-status "docbook-to-man")
# (find-vldifile "docbook-to-man.list")
# (find-fline "/usr/doc/docbook-to-man/")

# (find-status "docbook-xml")
# (find-vldifile "docbook-xml.list")
# (find-fline "/usr/doc/docbook-xml/")

# (find-status "docbook2man")
# (find-vldifile "docbook2man.list")
# (find-fline "/usr/doc/docbook2man/")

# (find-status "docbook2texi")
# (find-vldifile "docbook2texi.list")
# (find-fline "/usr/doc/docbook2texi/")

# (find-status "docbook2x-doc")
# (find-vldifile "docbook2x-doc.list")
# (find-fline "/usr/doc/docbook2x-doc/")


# (find-status "lyx")
# (find-vldifile "lyx.list")
# (find-fline "/usr/doc/lyx/")


# (find-node "(linuxdoc-sgml)Top")








#  Local Variables:
#  coding:               utf-8-unix
#  End:
