#######
#
# E-scripts on Doom Emacs.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/doom.e>
#           or at <http://angg.twu.net/e/doom.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.DOOMDIR»		(to "DOOMDIR")
# «.evil-mode»		(to "evil-mode")
# «.disable-evil-mode»	(to "disable-evil-mode")
# «.workspaces»		(to "workspaces")
# «.eev-from-git»	(to "eev-from-git")
# «.bin_doom»		(to "bin_doom")
# «.test-doom-2»	(to "test-doom-2")
# «.test-doom-3»	(to "test-doom-3")
# «.M-h-and-M-n»	(to "M-h-and-M-n")
# «.M-e-M-k-bug»	(to "M-e-M-k-bug")
# «.chemacs»		(to "chemacs")
# «.M-x-eeit-bug»	(to "M-x-eeit-bug")
# «.fake-home-dir»	(to "fake-home-dir")
# «.bug-with-glyphs»	(to "bug-with-glyphs")
# «.kla-symlink-bug»	(to "kla-symlink-bug")
# «.problems»		(to "problems")


# (find-es "emacs" "straight")
# (find-es "emacs" "doom-emacs")
# (find-es "emacs" "doom-emacs-1")

# https://github.com/doomemacs/doomemacs
# https://github.com/hlissner/doom-emacs
# https://github.com/hlissner/doom-emacs/blob/develop/docs/faq.org
# https://github.com/hlissner/doom-emacs/blob/develop/modules/editor/evil/README.org
# https://github.com/hlissner/doom-emacs/blob/develop/modules/editor/evil/README.org#removing-evil-mode





#####
#
# DOOMDIR
# 2020oct24
#
#####

# «DOOMDIR»  (to ".DOOMDIR")
# (find-fline "~/.emacs.d/docs/")
# (find-fline "~/.emacs.d/docs/index.org")
# (find-fline "~/.emacs.d/docs/getting_started.org")
# (find-fline "~/.emacs.d/docs/getting_started.org" "* Configure")
# (find-fline "~/.emacs.d/docs/getting_started.org" "DOOMDIR")
# (find-fline "~/.doom.d/")
# (find-fline "~/.doom.d/init.el")
# (find-fline "~/.doom.d/config.el")
# (find-fline "~/.doom.d/packages.el")

# (eek "M-h M-k  C-h d h  ;; doom/help")
# (find-efunctiondescr      'doom/help)
# (find-efunction           'doom/help)

# (find-evardescr 'doom-docs-dir)
# (find-evariable 'doom-emacs-dir)
# (find-evardescr 'doom-emacs-dir)
# (find-evardescr 'doom-local-dir)




#####
#
# evil-mode
# 2020oct24
#
#####

# «evil-mode»  (to ".evil-mode")
# (find-fline "~/.doom.d/init.el" "(evil +everywhere)")
# (find-efunction-links 'turn-off-evil-mode)
# (find-efunctiondescr  'turn-off-evil-mode)
# (find-efunction       'turn-off-evil-mode)
# (turn-off-evil-mode)





#####
#
# workspaces
# 2020oct24
#
#####

# «workspaces»  (to ".workspaces")
# (eek "M-h M-k  M-1  ;; +workspace/switch-to-0")
# (find-fline "~/.emacs.d/modules/ui/workspaces/autoload/workspaces.el")
# (find-fline "~/.emacs.d/modules/ui/workspaces/README.org")
# (find-fline "~/.emacs.d/modules/ui/workspaces/")




#####
#
# Disable evil-mode and some other things
# 2020oct24
#
#####

# «disable-evil-mode»  (to ".disable-evil-mode")
# Things that I've disabled to make Doom usable for me:
# (find-fline "~/.doom.d/init.el" "workspaces")
# (find-fline "~/.doom.d/init.el" "file-templates")
# (find-fline "~/.doom.d/init.el" "modeline")
# (find-fline "~/.doom.d/init.el" "(evil +everywhere)")
# (find-fline "~/.doom.d/init.el" "dired")










#####
#
# Make Doom use eev from git
# 2020oct24
#
#####

# «eev-from-git»  (to ".eev-from-git")
# (find-angg ".doom.d/packages.el" "eev-from-git")
# (find-es "emacs" "straight")
# (find-fline "~/.emacs.d/docs/getting_started.org" "Changing a recipe")
# (find-fline "~/.doom.d/packages.el")
# (find-fline "~/.doom.d/packages.el" "doom sync")

  ;; Put this in: (find-fline "~/.doom.d/packages.el")
  ;; From: (find-es "doom" "eev-from-git")
  (package! eev :recipe (:host github :repo "edrx/eev" :branch "UTF-8"))
  ;;
  ;; To check the version of eev, see its ChangeLog:
  ;; (find-eevfile "")
  ;; (find-fline "~/.emacs.d/.local/straight/build/eev/")
  ;; (find-fline "~/.emacs.d/.local/straight/repos/eev/")
  ;; (find-fline "~/.emacs.d/.local/straight/repos/eev/ChangeLog")


# Where is the upstream version of ~/.doom.d/packages.el?
# How can I tkdiff my  ~/.doom.d/packages.el against it?

# Big mess:

;; (package! eev)
(package! eev :recipe (:host github :repo "edrx/eev"))

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
~/.emacs.d/bin/doom sync

# (find-fline "~/.emacs.d/")
# (find-fline "~/.doom.d/")
# (code-c-d "dotemacsd" "~/.emacs.d/")
# (find-dotemacsdfile "")
# (find-dotemacsdsh "find * | sort")
# (find-dotemacsdsh "find * | sort | grep packages.el")


  




#####
#
# ~/.emacs/bin/doom
# 2020oct24
#
#####

# «bin_doom»  (to ".bin_doom")
# (find-fline "~/.emacs.d/docs/getting_started.org" "*** The ~bin/doom~ utility")
# (find-fline "~/.emacs.d/bin/doom")






#####
#
# My attempt #2 to test Doom alongside Emacs
# 2020oct24
#
#####

# «test-doom-2»  (to ".test-doom-2")
# (find-es "unix" "mv-T")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

# (find-fline "~/.emacs")
# (find-fline "~/.emacs.d/")
# (find-fline "~/.emacs.d/elpa/")
# (find-fline "~/.emacs-orig")
# (find-fline "~/.emacs-orig.d/")
# (find-fline "~/.emacs-orig.d/elpa/")
# (find-fline "~/.emacs-doom")
# (find-fline "~/.emacs-doom.d/")
# (find-fline "~/.emacs-doom.d/elpa/")

cd; mv -ivT .emacs        .emacs-orig
cd; mv -ivT .emacs.d      .emacs-orig.d
cd; mv -ivT .emacs-doom   .emacs
cd; mv -ivT .emacs-doom.d .emacs.d

git clone --depth 1 https://github.com/hlissner/doom-emacs ~/.emacs.d
~/.emacs.d/bin/doom install

emacs

cd; mv -ivT .emacs        .emacs-doom
cd; mv -ivT .emacs.d      .emacs-doom.d
cd; mv -ivT .emacs-orig   .emacs  
cd; mv -ivT .emacs-orig.d .emacs.d




#####
#
# test-doom-3
# 2020oct24
#
#####

# «test-doom-3»  (to ".test-doom-3")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

# (find-fline "~/.emacs")
# (find-fline "~/.emacs.d/")
# (find-fline "~/.emacs.d/elpa/")
# (find-fline "~/.emacs-orig")
# (find-fline "~/.emacs-orig.d/")
# (find-fline "~/.emacs-orig.d/elpa/")
# (find-fline "~/.emacs-doom")
# (find-fline "~/.emacs-doom.d/")
# (find-fline "~/.emacs-doom.d/elpa/")

cd; mv -ivT .emacs        .emacs-orig
cd; mv -ivT .emacs.d      .emacs-orig.d
cd; mv -ivT .emacs-doom   .emacs
cd; mv -ivT .emacs-doom.d .emacs.d

# git clone --depth 1 https://github.com/hlissner/doom-emacs ~/.emacs.d
# ~/.emacs.d/bin/doom install

emacs

cd; mv -ivT .emacs        .emacs-doom
cd; mv -ivT .emacs.d      .emacs-doom.d
cd; mv -ivT .emacs-orig   .emacs  
cd; mv -ivT .emacs-orig.d .emacs.d





#####
#
# Make the keys of eev that begin with M-h become accessible with M-n
# 2020oct29
#
#####

# «M-h-and-M-n»  (to ".M-h-and-M-n")
# (find-TH "eev-doom" "M-h")

;; See: (find-eev "eev-mode.el" "eev-mode-map-set")
;;      (find-ekeymapdescr eev-mode-map)
;;
(define-key eev-mode-map (kbd "M-n M-a") 'find-code-audiovideo-links)
(define-key eev-mode-map (kbd "M-n M-d") 'find-debpkg-links)
(define-key eev-mode-map (kbd "M-n M-e") 'find-extra-file-links)
(define-key eev-mode-map (kbd "M-n M-f") 'find-efunction-links)
(define-key eev-mode-map (kbd "M-n M-g") 'find-grep-links)
(define-key eev-mode-map (kbd "M-n M-h") 'find-here-links)
(define-key eev-mode-map (kbd "M-n M-i") 'find-eintro-or-einfo-links)
(define-key eev-mode-map (kbd "M-n M-k") 'find-ekey-links)
(define-key eev-mode-map (kbd "M-n M-n") 'find-eunicodeucs)
(define-key eev-mode-map (kbd "M-n M-p") 'find-pdf-links)
(define-key eev-mode-map (kbd "M-n M-v") 'find-evariable-links)
(define-key eev-mode-map (kbd "M-n f")   'find-file-links)
(define-key eev-mode-map (kbd "M-n M")   'find-ekbmacro-links)

(define-key eev-mode-map (kbd "M-n M-c") 'find-echardescr)
(define-key eev-mode-map (kbd "M-n M-s") 'find-eface-links)
(define-key eev-mode-map (kbd "M-n M-t") 'find-etpat)
(define-key eev-mode-map (kbd "M-n t")   'find-etpat0)
(define-key eev-mode-map (kbd "M-n c")   'find-ecolor-links)

(define-key eev-mode-map (kbd "M-n M-1") 'find-here-links-1)
(define-key eev-mode-map (kbd "M-n M-2") 'ee-duplicate-this-line)
(define-key eev-mode-map (kbd "M-n M-3") 'find-here-links-3)
(define-key eev-mode-map (kbd "M-n M-y") 'ee-yank-pos-spec)
(define-key eev-mode-map (kbd "M-n M-w") 'ee-copy-this-line-to-kill-ring)
(define-key eev-mode-map (kbd "M-n M--") 'ee-shrink-hyperlink-at-eol)





#####
#
# M-e-M-k-bug
# 2020oct30
#
#####

# «M-e-M-k-bug»  (to ".M-e-M-k-bug")

# (find-refining-intro "(find-sh \"seq 2095 2115\")")

so' pra confirmar porque a minha mensagem foi meio ambigua... aqui
esse link aponta pra linha 36 do (find-refining-intro), que tem o link
(find-sh "seq 2095 2115"). Se a gente segue o (find-sh "seq 2095
2115") com M-e e tenta voltar com M-k o M-k "volta" pro lugar
errado... e' isso, ne'?




#####
#
# chemacs
# 2022apr05
#
#####

# «chemacs»  (to ".chemacs")
# https://github.com/plexus/chemacs2
# https://www.reddit.com/r/emacs/comments/j5f1xq/chemacs_2_now_with_earlyinitel_suport/

# (find-git-links "https://github.com/plexus/chemacs2" "chemacs2")
# (find-gitk           "~/usrc/chemacs2/")
# (code-c-d "chemacs2" "~/usrc/chemacs2/")
# (find-chemacs2file "")
# (find-chemacs2file "README.org" "** Differences from Chemacs 1")
# (find-chemacs2file "README.org" "emacs --with-profile")
# (find-chemacs2file "chemacs.el" "(defun chemacs-handle-command-line ")
# (find-chemacs2grep "grep --color=auto -nRH --null -e with-profile *")
# (find-chemacs2grep "grep --color=auto -nRH --null -e user-emacs-directory *")
# (find-enode "Find Init" "user-emacs-directory")
# (find-elnode "Init File" "early-init.el")

# (find-fline "~/bin/emacspers-gui.sh")
# (find-fline "~/bin/scimax.sh")
# (find-fline "~/bin/emacspers-Term.sh")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
emacs --with-profile personal &

# (find-elisp





#####
#
# M-x-eeit-bug
# 2022apr06
#
#####

# «M-x-eeit-bug»  (to ".M-x-eeit-bug")
# https://github.com/hlissner/doom-emacs/issues/6251

(call-interactively 'eeit) works but "M-x eeit" says "No match"

Hi, I need some hints and help to produce a "minimal broken example"
that demonstrates a bug...

I am the author of a package called eev, and one of its main features
is usually invoked by typing `M-x eeit', where eeit is an alias to
ee-insert-test. Here are links to my presentation about that feature
at the EmacsConf2021 and to the source code of eeit:

http://angg.twu.net/eev-current/eev-testblocks.el.html#eeit
http://angg.twu.net/LATEX/2021emacsconf.pdf

A friend of mine has a setting in which it is easy to run Doom Emacs,
Scimax Emacs, and Vanilla Emacs. This quirk only happens in Doom
Emacs.

If he tries to run M-x eeit the completion package - company, it seems
- doesn't show eeit among the options, and when he types a RET after
the "M-x eeit" he gets a "No match"... however, if he puts the sexps
(eeit) or (call-interactively 'eeit) in a buffer and executes them
with (his favorite variant of) C-x C-e, they work.

My guess is that one, or several, of the backends for company have
stored the data about the available commands in a way in which "eeit"
looks like something that is not a command, and also like something
that doesn't have a completion.

Any hints on how to call low-level functions of company to inspect its
data structures, and to inspect what it thinks that are the
completions and expansions of "eeit", would probably save me hours of
work... there's a big chance that I won't be able to reproduce the bug
in my machine, and that I will have to send sexps to my friend, and
ask him to send back their results...

Btw: I type slowly, I commit many mistakes, and my memory is quite
bad. The way that I found to cope with that is by using sexps for
everything - and my package, eev, is exactly about that... so hints
like "thry to execute these sexps here, inspect their results, and
figure out by yourself if the results are right or wrong" would be
much more useful to me than hints like "type these key sequences"...
=/

Thanks in advance!
Eduardo Ochs
http://angg.twu.net/#eev


The bug happens in a machine with Debian, a recent Doom Emacs, and
chemacs2. That machine belongs to a friend, and I am trying to 1)
reproduce the bug in my machine, 2) prepare sexps with tests that my
friend can execute in his machine. See the section "Describe your
attempts"... for the full info.

In a Doom Emacs with the package eev installed typing `M-x eeit'
should run eeit.

Typing `M-x eeit' indicates that eeit isn't a command, and doesn't
have a completion; typing RET after that yields "No match".





#####
#
# fake-home-dir
# 2022apr06
#
#####

# «fake-home-dir»  (to ".fake-home-dir")
# (find-angg "elisp/doom-test-0.el")




#####
#
# bug-with-glyphs
# 2022oct16
#
#####

# «bug-with-glyphs»  (to ".bug-with-glyphs")
# (find-TH "eev-doom" "standard-display-table")

# (find-efunctiondescr 'whitespace-mode)
# (find-efunction      'whitespace-mode)
# (find-evardescr 'whitespace-global-modes)
# (find-evariable 'whitespace-global-modes)
# (find-evardescr 'whitespace-style)
# (find-evariable 'whitespace-style)

(global-whitespace-mode 0)
      whitespace-global-modes
(setq whitespace-global-modes nil)


(add-hook 'after-change-major-mode-hook
          #'doom-highlight-non-default-indentation-h
          
(add-hook 'prog-mode-hook (lambda () (whitespace-mode -1)))

(global-set-key [f11] 'hippie-expand)
(setq hippie-expand-try-functions-list
  '(try-complete-file-name-partially
    try-complete-file-name
    try-complete-lisp-symbol-partially
    try-complete-lisp-symbol
    try-expand-all-abbrevs
    try-expand-list
    try-expand-line
    try-expand-dabbrev
    try-expand-dabbrev-all-buffers
    try-expand-dabbrev-from-kill
    ))

https://github.com/DarthFennec/highlight-indent-guides

<MysteriousSilver> edrx:
                   https://github.com/DarthFennec/highlight-indent-guides
                   ?
*** michaelrose QUIT Quit: Leaving
<parsnip> edrx: i suspect it's display-line-numbers-mode
          https://github.com/hlissner/doom-emacs/search?q=display-line-numbers-mode&type=code

(display-line-numbers-mode 0)
(global-display-line-numbers-mode 0)




#####
#
# kla-symlink-bug
# 2022oct16
#
#####

# «kla-symlink-bug»  (to ".kla-symlink-bug")
# (find-es "eev" "kla-symlink-bug")



#####
#
# problems
# 2022oct16
#
#####

# «problems»  (to ".problems")
# (find-TH "eev-doom" "completion")

In vertico M-x eeit doesn't appear (in an obvious way)
The major mode is not clearly visible in the modeline





# (find-eminormodes-links)
# (find-eppp minor-mode-list)

(global-flycheck-mode 0)
(ws-butler-global-mode 0)
(ws-butler-mode 0)
(volatile-highlights-mode 0)

(company-mode 0)

(show-paren-mode 0)
(smartparens-global-mode 0)
(display-line-numbers-mode 0)

(global-vi-tilde-fringe-mode 0)
(vi-tilde-fringe-mode 0)

(gcmh-mode 0)

# (find-eevfile "eejump.el")
# (find-eevfile "eepitch.el")







https://github.com/hlissner/doom-emacs/blob/develop/core/core-ui.el





# (find-sh "~/.emacs.d/bin/doom help")
# (find-sh "~/.emacs.d/bin/doom help env")

# (find-fline "~/.emacs.d/modules/ui/doom/README.org" "Fira Mono")

https://www.reddit.com/r/emacs/comments/jfb1x7/migrating_from_doom_emacs_to_vanilla/
https://www.reddit.com/r/emacs/comments/jf8kjn/your_thoughts_about_doom_emacs/

https://www.youtube.com/watch?v=37H7bD-G7nE Doom Emacs On Day One (Learn These Things FIRST!)
https://www.youtube.com/watch?v=7EpdPtt29Aw

<parsnip> ,spacemacs-humor
<fsbot> spacemacs-humor is [0] In Spacemacs, no one can hear you
        scream. -- Alien
<fsbot> [1] https://i.imgflip.com/6lrvca.jpg

https://ismailefe.org/blog/eye_candy/




#  Local Variables:
#  coding:               utf-8-unix
#  End:
