#######
#
# E-scripts on DOS stuff.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/dos.e>
#           or at <http://angg.twu.net/e/dos.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.dosemu-0»			(to "dosemu-0")
# «.testdos»			(to "testdos")
# «.boot_lredir»		(to "boot_lredir")
# «.dosemu-0.97.5»		(to "dosemu-0.97.5")
# «.EXPANDing»			(to "EXPANDing")
# «.format»			(to "format")
# «.dosemu_slink_4dos»		(to "dosemu_slink_4dos")
# «.dosemu_slink_long»		(to "dosemu_slink_long")
# «.dosemu-1.0.2»		(to "dosemu-1.0.2")
# «.dosemu2-debian»		(to "dosemu2-debian")
# «.dosemu2»			(to "dosemu2")
# «.fdpp»			(to "fdpp")
# «.comcom2»			(to "comcom2")
# «.binutils-djgpp»		(to "binutils-djgpp")
# «.dosemu2-build-debian»	(to "dosemu2-build-debian")
# «.wine-sarge»			(to "wine-sarge")
# «.dosbox»			(to "dosbox")
# «.dosbox-apt-get-source»	(to "dosbox-apt-get-source")
# «.tese-lea»			(to "tese-lea")
# «.takecommand»		(to "takecommand")
# «.sidekick»			(to "sidekick")
# «.virtualbox»			(to "virtualbox")




#####
#
# dosemu (potato)
# 2000may31
#
#####

# «dosemu-0»  (to ".dosemu-0")

# (find-status "dosemu")
# (find-vldifile "dosemu.list")
# (find-fline "/usr/doc/dosemu/")

# «testdos»  (to ".testdos")
# (find-fline "/usr/doc/dosemu/changelog.gz" "booting _directly_ from")
# (find-fline "/etc/dosemu/conf" "hdimages under /var/lib/dosemu")
# (find-fline "/etc/dosemu/dosemu.conf" "$_hdimage =")
# $_hdimage = "testdos"

#
rm -Rv /var/lib/dosemu/testdos
ln -s /tmp/testdos /var/lib/dosemu/testdos

rm -Rv /tmp/testdos/
mkdir  /tmp/testdos/
cd     /tmp/testdos/

# Pick some 4dos files.
# (find-fline "$S/ftp/jpsoft.com/4dos/4dos601.zip")
#
rm -Rv /tmp/4dos/
mkdir  /tmp/4dos/
cd     /tmp/4dos/
unzip -L $S/ftp/jpsoft.com/4dos/4dos601.zip
(cd /tmp/4dos/; cp -iv $(<<'---'
  4dos.com
  4dos.hlp
  4help.exe
  helpcfg.exe
  insthelp.exe
  kstack.com
---) /tmp/testdos/)

# Pick the boot sector and io.sys, msdos.sys and command.com from the
# image of the first dos6.22 floppy.
#
umount /A
dd if=/big/nonfree/dos622-1.cqmi of=/tmp/testdos/boot.blk bs=512 count=1
mount -t msdos -o ro,loop /big/nonfree/dos622-1.cqmi /A
(cd /A/; cp -iv $(<<'---'
  io.sys
  msdos.sys
  command.com
---) /tmp/testdos/)

# Some dosemu utilities: exitemu and (in a near future) lredir.
# (find-fline "/usr/lib/dosemu/commands/")
# (find-demufile "src/commands/")
# (find-demufile "src/commands/lredir.readme")
# (find-demufile "debian/dosemu/usr/lib/dosemu/commands/")
#
(cd /usr/lib/dosemu/commands/; cp -iv $(<<'---'
  exitemu.com
  lredir.com
  ems.sys
---) /tmp/testdos/)

# This is to use 4dos.com as the default shell; it should make
# command.com unnecessary.
# Note that we also insert a 
#
crlf > /tmp/testdos/config.sys <<'---'
device=ems.sys
dos=high
shell=c:\4dos.com /P
---

#
# Now for something really funny.
# (find-fline "/big/nonfree/hsforth/")
# (find-es "hsforth")
#
unzip -L /big/nonfree/hsforth/hs5-2.zip hsforth.exe -d /tmp/testdos/
unzip -L /big/nonfree/hsforth/hs5-1.zip toolbox     -d /tmp/testdos/

# enter hs-forth, then:
# FLOAD TOOLBOX WORDS BYE

cat > $EEG <<'---'
hsforth
FLOAD TOOLBOX
WORDS
BYE
exitemu
---
#was: eeg dos
eeg dosemu.bin

#
# (find-fline "/cdbup1/home98jul22/4dos/")
# (find-fline "/cdbup1/home98jul22/4dos/v50.com")





#####
#
# Testing some arjed files
# 2001sep24
#
#####

#
cp -v /cdbup1/home98jul22/4dos/arj.exe /tmp/testdos/
mkdir /tmp/testdos/2001/
cp -v /home/lea/*.00* /tmp/testdos/2001/

cat > $EEG <<'---'
arj t 2001\c-f.*
arj t 2001\n-u.*
exitemu
---
eeg dos

#




#####
#
# Other notes on potato's dosemu
# 2000jun02
#
#####

# (find-fline "/A/")
# (find-fline "/snarf/ftp/jpsoft.com/4dos/4dos601.zip")
# (find-fline "/tmp/4dos/")
# (find-demufile "")

# (find-es "dos" "boot_lredir")

# (eeman "1 dos")
# (eeman "1 dosexec")
# (eeman "1 dosdebug")
# (eeman "1 xdos")
# (eeman "1 dosctrl")
# (eeman "1 xtermdos")
# (eeman "1 mkfatimage16")
# (eeman "1 dexeconfig")
# (eeman "1 scsicheck")
# (find-fline "/etc/dosemu/")
# (find-fline "/etc/dosemu/conf" "$_hdimage")
# (find-fline "/usr/lib/dosemu/global.conf")
# (find-fline "/usr/lib/dosemu/etc/")

pdsc $SPOTATO/main/source/otherosfs/dosemu_0.98.8-2.dsc
debian/rules binary	|& tee odrb

# (find-demufile "")

# (eeman "1 dos" "Even pointless")
# (eeman "1 dos" "^ *-u")
# (eeman "1 dos" "^ *-I")

# (find-fline "/snarf/ftp/jpsoft.com/4dos/4dos601.zip")
# (find-fline "/tmp/4dos/")
# (find-fline "/tmp/4dos/4dos.txt")

# (find-fline "/usr/lib/dosemu/commands/config.sys")
mcopy -ot - g:/config.sys <<'---'
device=c:\emufs.sys /D
device=c:\ems.sys
shell=c:\4dos\4dos.com /p @c:\4dos\4dos.ini
---
#
mcopy -ot - g:/autoexec.bat <<'---'
set four=c:\4dos
set dos=d:\dos
%four%\4start0.btm
---

# (find-fline "/usr/lib/dosemu/global.conf")
# (find-fline "/etc/dosemu/conf")
# (find-fline "/home/root/.dosemurc")

# (find-fline "/big/home/4dos/")





#####
#
# dosemu 0.98.8 from potato, on slink
# 00feb17
#
#####

pdsc $SDEBIAN/dists/potato/main/source/otherosfs/dosemu_0.98.8-2.dsc
cd /usr/src/dosemu-0.98.8/
debian/rules binary	|& tee odrb

# Builds cleanly on Slink!!!

mv -v /usr/src/dosemu*deb /usr/src/.debs/
# apt-update
apti dosemu

# (find-vldifile "dosemu.list")
# (find-fline "/usr/doc/dosemu/")
# (find-fline "/usr/doc/dosemu/changelog.gz" "booting _directly_ from a (lredir'ed) Linux directory.")



mountloop0L /big/nonfree/dos622-1.cqmi
# laf /L
rm -Rv /tmp/dos/
mkdir  /tmp/dos/
cp -dipvR /L/* /tmp/dos/
cd /tmp/dos/
rm -v *_ *\# autoexec.bat

dd if=/big/nonfree/dos622-1.cqmi of=/tmp/dos/boot.blk bs=512 count=1


# (eeman "dos" "-I *Parse")
# (find-fline "/etc/dosemu/")
# (find-fline "/etc/dosemu/conf" "$_hdimage =")

# (find-vldifile "dosemu.list")
# (find-fline "/usr/doc/dosemu/changelog.gz" "booting _directly_ from a (lredir'ed) Linux directory.")
# (find-fline "/usr/lib/dosemu/")
# (find-fline "/usr/share/doc/dosemu/")


# "-I" does not work...

dos -I '$_hdimage = "/tmp/dos/"'
strace-to ~/s dos -I '$_hdimage = "/tmp/dos/"'
getstrings < ~/s | l
getstrings < ~/s | sort | uniq | l


# But a direct change works.

# (find-fline "/usr/lib/dosemu/global.conf")
# (find-fline "/etc/dosemu/conf")
# (find-angg "/etc/dosemu/conf" "edrx")
#
# $_hdimage = "edrxdos"

rm /var/lib/dosemu/edrxdos
ln -s /tmp/dos /var/lib/dosemu/edrxdos


dos


cd /usr/lib/dosemu/




#####
#
# dosemu: booting from a lredired Linux directory
# 2000may31
#
#####

# «boot_lredir»  (to ".boot_lredir")

# (find-fline "/usr/doc/dosemu/changelog.gz" "booting _directly_ from a (lredir'ed) Linux directory.")

# (find-demufile "src/base/misc/")
# (find-demufile "src/base/misc/disks.c")
# (find-demufile "src/base/misc/fatfs.c")
# (find-demufile "src/base/misc/fatfs.h")
# (find-demufile "src/base/misc/fatfs_boot.S")
# (find-demufile "src/base/async/int.c")
# (find-fline "/usr/lib/dosemu/global.conf")
# (find-demufile "src/base/init/config.c")
# (find-demufile "src/base/init/parser.y")
# (find-demufile "src/dosext/mfs/")
# (find-demufile "src/include/disks.h")
# (find-demufile "src/include/int.h")
# (find-demufile "")

	  src/base/misc/{disks.c,fatfs.c,fatfs.h,fatfs_boot.S}
	  etc/global.conf, async/int.c, init/config.c, init/parser.y
	  mfs/mfs.c, include/{disks.h,int.h}
	  How it works:
	  - in $_hdimage a directory can be given containing atleast
	    IO.SYS, MSDOS.SYS (or what the appropriate DOS has as system
	    files). It also may (but need not) conatin a non-standard
	    bootsector file (name: boot.blk).
	  - This directory is partially converted (on-the-fly) to a FAT type
	    emulated disk (no data, only the directory enrties). A default
	    bootsector also is faked, and if boot.blk exists
	    this one is taken. From this emulated disk a boot attempt is done.
	    When the first _file_ access happens, the redirector is called
	    and from this point on (if the DOS supports a redirector) it
	    becomes an lredir'ed drive.
	  - In principal the emulated drive also works with the DosC kernel
	    (which not yet has a redirector), but the emulated FAT-FS remains
	    active and is readonly (writes are ignored).
	From Hans
	- fix for dosemu crashing on floppy access with no disk inserted
	  and not able to read writeprotected floppies (broken in 0.98.5.2).
	- wrote some minimum docs for Steffens 'bootdir' stuff.













#######
#
# dosemu (potato)
#
#######

# pdsc $SDEBIAN/dists/potato/main/source/otherosfs/dosemu_0.98.2-1.dsc
# debian/rules binary	|& tee odrb

dpkg -i $SDEBIAN/dists/potato/main/binary-i386/otherosfs/dosemu_0.98.2-1.deb
# (find-fline "/usr/doc/dosemu/")
# (find-vldifile "dosemu.list")
# (find-fline "/usr/lib/dosemu/setup-hdimage")
# (find-fline "/usr/lib/dosemu/dexe/mkdexe")

# (find-fline "/usr/lib/dosemu/commands/autoexec.bat")

# (find-fline "~/.mtoolsrc")
# drive g: file="/var/lib/dosemu/hdimage.first" offset=8832


###
### msdos622/4dos hdimage:
###

insmod $MODULES/loop.o
umount /A
losetup -d /dev/loop0
#
losetup /dev/loop0 /big/nonfree/dos622-1.cqmi
mount -t msdos -o ro /dev/loop0 /A

cd /usr/lib/dosemu/dexe/
./mkdexe hdimage.first -b /dev/loop0 -i io.sys -m msdos.sys -C command.com \
  -o noapp

cd /big/home/4dos/
mmd g:/4dos
mcopy [4klpqv]* g:/4dos/

# (find-fline "/usr/lib/dosemu/commands/config.sys")
mcopy -ot - g:/config.sys <<'---'
device=c:\emufs.sys /D
device=c:\ems.sys
shell=c:\4dos\4dos.com /p @c:\4dos\4dos.ini
---
#
mcopy -ot - g:/autoexec.bat <<'---'
set four=c:\4dos
set dos=d:\dos
%four%\4start0.btm
---

# (find-fline "/usr/lib/dosemu/global.conf")
# (find-fline "/etc/dosemu/conf")
# (find-fline "/home/root/.dosemurc")

# (find-fline "/big/home/4dos/")


dos -ckV



mkdir /D/dos/
tar -xvzf /big/nonfree/dos622-1.tgz -C /D/dos/





#####
#
# ?
#
#####

cd /usr/lib/dosemu/dexe/
mycat * | sort | uniq

# (hexl-find-file "/var/lib/dosemu/hdimage.first")

rm -Rv /usr/src/dos-c
cd /usr/src/
unzip -L /snarf/ftp/ftp.iop.com/pub/freedos/dos-c.zip
cd /usr/src/dos-c

http://www.freedos.org/files.html





######
#
# wine
#
######

cd ~/HASH
dpkg -iE libwine0.0.971116 wine

# (find-fline "/usr/doc/wine/")
lynx /usr/doc/wine/wine-FAQ/wine-content.html
lynx /usr/doc/wine/wine-FAQ/wine-content.html#ques4.6

# (find-fline "/etc/wine.conf")

cd /
ar p ~/HASH/wine-doc data.tar.gz | tar -xvzf - usr/doc/wine'*'



#####
#
# dosemu (hamm)
#
#####

# (find-esfile "dos.e" "dosemu (hamm)")
# (find-fline "/etc/dosemu/conf")

dos -c -k -V

video { vga  console  graphics  chipset trident  memsize 1024 }




#####
#
# Loop device partitions
#
#####

# (find-k2file "Documentation/devices.txt")
# (find-k2file "Documentation/Configure.help")
# (find-k2file "drivers/block/loop.c")
# (find-k2file "fs/vfat/namei.c")

# This is a message I found via dejanews, with keywords "mkdosfs" and
# "loop".
# (find-fline "~/makeboot")

# (find-fline "/snarf/ftp/ftp.mi.us.debian.org/debian/ls-lR")

export LOOPF=/home/LOOP
export LOOPDEV=/dev/loop0
losetup -d $LOOPDEV
dd if=/dev/zero of=$LOOPF bs=1024 count=1440
losetup $LOOPDEV $LOOPF
mke2fs $LOOPDEV

# mke2fs is ok, but mkdosfs doesn't run, as it is addicted to disk
# geometry parameters and loop devices don't seem to have geometry. As
# for vfat, I don't even know if there is a "mkvfatfs".

# How can I create a loopback file with "holes" corresponding to bad
# sectors and write it to the floppy avoiding the holes?

# It would be nice to have some gzipped images of formated floppies.

# (find-fline "/usr/src/boot-floppies/rescue.sh" "-t msdos")
# (find-node "(Yard_doc)Using a Loopback Device")





#####
#
# umsdos
#
#####

# (find-k2file "Documentation/Configure.help" "umsdos:")
# (find-k2file "Documentation/filesystems/umsdos.txt")
# (find-fline "/usr/doc/umsdos_progs-0.9-2/README")
# (find-fline "/usr/doc/HOWTO/UMSDOS-HOWTO")

rpm -qpl $RP/umsdos_progs-0.9-2.i386.rpm
rpm -iv  $RP/umsdos_progs-0.9-2.i386.rpm





#####
#
# Formatting a loop partition via dosemu
#
#####

C=306
H=4
S=17
( /usr/src/dosemu-0.97.5/src/tools/periph/mkhdimage \
    -c $C -h $H -s $S
  dd if=/dev/zero bs=512 count=$[$C*$H*$S]
) > /home/hd.$C.$H.$S
#
# Now enter dos to fdisk and format the loop device (currently D:),
# then pack a clean version of it for later use.
# (find-fline    "~/98jun26.pucmail" "Subject: images")
# (find-fline "~/DOSEMU/config.edrx")
# disk { cylinders 306 heads 4 sectors 17 image "/home/hd.306.4.17" }
# A floppy has CHS=80/2/18.
#
gzip -c /home/hd.306.4.17 > ~/DOSEMU/hd.306.4.17.gz
gzip -cd ~/DOSEMU/hd.306.4.17.gz > /home/hd.306.4.17

# Mounting as /dev/loop0:
#
C=306
H=4
S=17
insmod $MODULES/loop.o
umount /L
losetup -d /dev/loop0
losetup -o 8832 /dev/loop0 /home/hd.$C.$H.$S
mount -t umsdos /dev/loop0 /L
#
# Copy the yard disk contents:
umssync /L
cp -dipvR /mnt/* /L/
#
# Go to msdos mode to zip the files:
umount /L
mount -t msdos /dev/loop0 /L

# Use the small swap partition as a dos partition:
#
# (find-fline "/etc/fstab")
free
swapoff /dev/hdd2
free
# mkdosfs -c /dev/hdd2
mkdosfs /dev/hdd2
mkdir /S
mount -t umsdos /dev/hdd2 /S
mkdir /S/linux
umssync /S/linux
cp -dipvR /mnt/* /S/linux
umount /S

# O próximo passo é pôr tudo dentro do diretório "/linux".

# (find-demufile "QuickStart" "generate a bootable")
# (find-demufile "doc/README.txt" "$_vbootfloppy = \"f")
# http://std.world.com/~bochs/
# (find-demufile "src/tools/periph/mkhdimage.c")
# (find-fline "/usr/doc/HOWTO/UMSDOS-HOWTO")

#
# Why 8832? 8832 = 128 + 8192 + 512 (=2280h), but?
# Using dd and hexl-mode, we see this "signature":
#
# 00002280: eb3c 904d 5344 4f53 352e 3000 0208 0100  .<.MSDOS5.0.....
#
# (find-k2tag "msdos_boot_sector")
# (find-k2file "fs/fat/inode.c")
# (find-k2tag "fat_read_super")
# (find-k2tag "msdos_read_super")
# (find-k2tag "UMSDOS_read_super")
# (find-k2file "fs/umsdos/inode.c" "install its linux stuff in c:\\linux")
# (find-k2file "fs/umsdos/dir.c"   "directory /DOS which points to")
# (find-enode "Display Vars" "tab-width")
# (setq tab-width 4)
#
# (find-k2file "Documentation/filesystems/umsdos.txt")
# (find-fline "/usr/doc/umsdos_progs-0.9-2/README")


cd
dd if=/home/hd.306.4.17	of=/home/root/o bs=1024 count=64
dd if=/dev/hdc		of=/home/root/o bs=1024 count=64
dd if=/dev/hdc1		of=/home/root/o bs=1024 count=64
dd if=/dev/loop0	of=/home/root/o bs=1024 count=64
# (hexl-find-file "~/o")
# (hexl-find-file "/home/hdcini")
# (find-k2file "include/






#########
#
# dosemu 0.97.5
#
#########

# «dosemu-0.97.5»  (to ".dosemu-0.97.5")

###
### Compiling and installing
###

rm -Rv /usr/src/dosemu-0.97.5/
cd /usr/src/
tar -xvzf /snarf/ftp/ftp.suse.com/pub/dosemu/Development/dosemu-0.97.5.tgz
cd /usr/src/dosemu-0.97.5/
#
etags $(find -name '*.[ch]')
./default-configure |& tee odc
make WAIT=no |& tee om
#
cd /usr/src/dosemu-0.97.5/
make install |& tee omi
#
cp -v /usr/src/dosemu-0.97.5/etc/dosemu.users.secure /etc/dosemu.users

# (find-demufile "etc/dosemu.users.secure")
# (find-fline "/home/4dos/config.sys")
# (find-node "(zsh)Concept Index" "array")
# (find-demufile "om" "mkfatimage16 -b")
# (find-demufile "src/tools/periph/")
# (find-demufile "doc/README.txt")
# (find-demufile "doc/dosemu-HOWTO.txt")
# (find-demufile "QuickStart")

###
### Tiny bootable hdimage
###
# (find-demufile "doc/README.txt" "device=c:\\emufs.sys /dosc")
# (find-demufile "doc/README.txt" "vbootfloppy")
# (find-fline "~/DOSEMU/floppy.config")
# (find-fline "~/DOSEMU/floppy.config.sys")
# (find-fline "~/DOSEMU/floppy.4dos.ini")
# (find-fline "~/DOSEMU/floppy.files")
#
cd /usr/src/dosemu-0.97.5/
cat > config.sys <<'EOF'
device=emufs.sys /C
shell=4dos.com /p @4dos.ini
EOF

cd /usr/src/dosemu-0.97.5/
/usr/src/dosemu-0.97.5/src/tools/periph/mkfatimage16	\
  $(grep '^/' ~/DOSEMU/floppy.files)
  > /usr/src/dosemu-0.97.5/myhdimage

dos -F ~/DOSEMU/config.floppy

# (find-fline "~/DOSEMU/622.config")
dos -F ~/DOSEMU/622.config

/bin/kill dos

dd if=/dev/zero of=/home/floppy bs=1024 count=1440




###
### Preparing a (decent) bootable hdimage
###

cd /usr/src/dosemu-0.97.5/
cat > config.sys <<'EOF'
device=emufs.sys /home/root/DOS
shell=4dos.com /p @4dos.ini
EOF

A=(/big/home/root/DOS622/1/io.sys
   /big/home/root/DOS622/1/msdos.sys
   /usr/src/dosemu-0.97.5/config.sys
   /home/4dos/4alias
   /home/4dos/4dos.com
   /home/4dos/4dos.hlp
   /home/4dos/4help.exe
   /home/4dos/EMU/4dos.ini
   /home/4dos/EMU/4start.btm
   /home/4dos/l.com
   /home/4dos/pu.exe
   /home/4dos/pz.exe
   /home/4dos/q.exe
   /home/4dos/v25.com
   /home/4dos/v50.com
   /usr/src/dosemu-0.97.5/commands/[b-x]*
   /big/home/root/DOS622/1/fdisk.exe
   /big/home/root/DOS622/1/format.com
)
cd /usr/src/dosemu-0.97.5/
/usr/src/dosemu-0.97.5/src/tools/periph/mkfatimage16	\
  -b /home/root/DOS622/bootsector.622.b	$A	\
  > /usr/src/dosemu-0.97.5/myhdimage

# (find-fline "~/DOSEMU/config.edrx")
# (find-fline "/var/lib/dosemu/global.conf")
# (find-fline "/etc/dosemu.conf")
# (find-demufile "first-test")
#
dos -F ~/DOSEMU/config.edrx

# install=c:\lredir.exe e: LINUX\FS\home/root/DOS
# (find-demufile "src/commands/")
# (find-demufile "src/commands/lredir.c")
# (find-demufile "src/commands/lredir.readme")

##
## Mtools configuration
##
#
# Insert these lines manually.
# (find-demufile "doc/dosemu-HOWTO.txt" "drive g:  file=")
# (find-fline "/etc/mtools.conf")
# (find-fline "~/.mtoolsrc")
# Edrx:
drive g: file="/usr/src/dosemu-0.97.5/etc/hdimage.dist" offset=8832
drive h: file="/usr/src/dosemu-0.97.5/etc/hdimage.test" offset=8832
drive i: file="/usr/src/dosemu-0.97.5/myhdimage" offset=8832

# (find-demufile "setup-hdimage")

# (find-demufile "etc/xinstallvgafont")
# (find-demufile "etc/vga.bdf")

# (find-demufile "src/base/init/parser.y")
# (find-demufile "src/base/init/lexer.l" "keywords")
# (find-demufile "src/dosext/mfs/mfs.c")
# (find-demufile "src/dosext/mfs/mfs.h")
# (find-demufile "src/commands/emufs.S")
# (find-demufile "contrib/dosC/readme.dosemu")
# (find-demufile "dexe/")

# floppy-device bootA bootB device






#######
#
# Packing large files for dos with dosemu
#
#######

e:
arj -? > o
arj a -v1000K -m0 -y traba.arj trab.zip

cd /home/root/DOS/
mcopy traba.arj arj.exe a:
mcopy traba.a01 /home/4dos/pu.exe a:

# (find-fline "~/DOS/o")





#######
#
# making dos floppies
#
#######

mkdosfs -c /dev/fd0

mcopy \
 /D/games/acao/beast.zip	\
 /D/games/acao/blockade.zip	\
 /D/games/acao/cat.zip	\
 /D/games/acao/hhm.zip	\
 /D/games/acao/pango.zip	\
 /D/games/acao/rampage.zip	\
 /D/games/amaze/\$electro.zip	\
 /D/games/amaze/_1agent_.zip	\
 /D/games/amaze/trsisteg.zip	\
 /D/games/fbc-pboy.zip	\
 a:

cd /home/4dos/
zip ../4.zip *
mcopy ../4.zip pu.exe a:
rm ../4.zip

# How to make them bootable?

# Acho que eu guardei uma cópia de um boot sector adequado em algum
# lugar.




#######
#
# 4.zip
#
#######

cd /b1/0home/4dos
zip ~/4.zip [4adklpqv]*
mcopy pu.exe ~/4.zip a:

mkdir /home/4dos6/
cd /home/4dos6/
unzip -L /snarf/ftp/jpsoft.com/4dos/4dos601.zip

cd /home/4dos6/
zip ~/46.zip \
  4dos.com	\
  4dos.hlp	\
  4dos.ico	\
  4dos.pif	\
  4dos.txt	\
  4help.exe	\
  _4inst.btm	\
  batcomp.exe	\
  examples.btm	\
  helpcfg.exe	\
  insthelp.exe	\
  internat.txt	\
  kstack.com	\
  option.exe




#####
#
# EXPANDing the files in the dos622 floppies
# 2001dec10
#
#####

# «EXPANDing»  (to ".EXPANDing")
# (find-fline "/nonfree/dos622-1.tgz")

#
rm -Rv /tmp/dos622-1/
mkdir  /tmp/dos622-1/
cd     /tmp/dos622-1/
tar -xvzf /nonfree/dos622-1.tgz

#
# (find-node "(gawk)Ranges")
# (find-fline "/tmp/dos622-1/")
# (find-fline "/tmp/dos622-1/packing.lst")

cd     /tmp/dos622-1/
cat packing.lst | awk '/ATTRIB.EXE/,/XCOPY.EX_/' \
  | tr -d \\r | awk '($1!=$2) {print "expand",$1,$2; print "del   ",$1}' \
  | crlf | tee /tmp/expand1.bat

cat packing.lst | awk '/ANSI.SY_/,/XBIOS.OV_/' \
  | tr -d \\r | awk '($1!=$2) {print "expand",$1,$2; print "del   ",$1}' \
  | crlf | tee /tmp/expand2.bat

cat packing.lst | awk '/AV.GR_/,/WNTOOLS.GR_/' \
  | tr -d \\r | awk '($1!=$2) {print "expand",$1,$2; print "del   ",$1}' \
  | crlf | tee /tmp/expand3.bat

#





#####
#
# dos622 from .cqms
#
#####

# Falta: count=1, silent, algo assim, e falta dar ao DOS o acesso ao
# floppy

copyqm a: playback=dos622-1.cqm
copyqm a: playback=dos622-2.cqm
copyqm a: playback=dos622-3.cqm

dd if=/dev/fd0 of=dos622-1.cqmi bs=1024 count=1440
dd if=/dev/fd0 of=dos622-2.cqmi bs=1024 count=1440

# (find-fline "/etc/mtools.conf")
# (find-fline "~/.mtoolsrc")
# drive a: file="/big/nonfree/dos622-1.cqmi"
# drive a: file="/big/nonfree/dos622-2.cqmi"

insmod $MODULES/loop.o
umount /A
losetup -d /dev/loop0

losetup /dev/loop0 /big/nonfree/dos622-1.cqmi
mount -t msdos -o ro /dev/loop0 /A


mountloop0L /big/nonfree/dos622-1.cqmi
laf --full-time /L
# (find-fline "/L/packing.lst")



mountloop0L /big/nonfree/dos622-1.cqmi
rm -Rv /D/dos/
mkdir  /D/dos/
cp -dipv /L/* /D/dos/

mountloop0L /big/nonfree/dos622-2.cqmi
rm -Rv /D/dos2/
mkdir  /D/dos2/
cp -dipv /L/* /D/dos2/

mount /big -o rw,remount
cd /D/dos/
tar -cvzf /big/nonfree/dos622-1.tgz *
cd /D/dos2/
tar -cvzf /big/nonfree/dos622-2.tgz *
mount /big -o ro,remount




#####
#
# fips20
#
#####

rm -Rv /usr/src/fips20/
mkdir  /usr/src/fips20/
cd     /usr/src/fips20/
unzip /snarf/http/www.igd.fhg.de/~aschaefe/fips/fips20.zip





#####
#
# baixando coisas de windows e zipando-as
#
#####

# «receita_zip»

edrxnetscape http://www.receita.fazenda.gov.br/ &
lynx $S/http/www.receita.fazenda.gov.br/PessoaJuridica/dctf/programa.htm

psne http://www.receita.fazenda.gov.br/publico/programas/DCTF/Dctf10.exe
psne http://www.receita.fazenda.gov.br/publico/programas/DCTF/Dctf10.w02
psne http://www.receita.fazenda.gov.br/publico/programas/DCTF/Dctf10.w03
psne http://www.receita.fazenda.gov.br/publico/programas/DCTF/Dctf10.w04

cd $S/http/www.receita.fazenda.gov.br/publico/programas/DCTF/
zip /tmp/d.zip Dctf*
cd /tmp/
laf
splzip d.zip 1400 00 01 02 03 04 05 06 07 08
rm <00-08>
laf

mcopy 00.zip 01.zip a:
mcopy 02.zip 03.zip a:
mcopy 04.zip 05.zip a:
mcopy 06.zip 07.zip a:
mcopy 08.zip gruda.bat a:




#####
#
# formating floppies
#
#####

# «format»  (to ".format")

# (find-fline "/usr/doc/dosfstools/")
# (eeman "mkdosfs")

mkdosfs -c -v /dev/fd0

# (find-fline "/usr/doc/fdutils/")
lynx /usr/doc/fdutils/FAQ.html





#####
#
# dosemu on slink: preparing a 4dos hdimage
# 99nov??
#
#####

# «dosemu_slink_4dos»  (to ".dosemu_slink_4dos")
# (find-es "dos" "dosemu_slink_long")

apti dosemu

DEB=/big/slinkb1/dists/slink/main/binary-i386/otherosfs/dosemu_0.98.1-3.deb
ar p $DEB data.tar.gz \
  | tar -xvzOf - var/lib/dosemu/hdimage.first \
  > /tmp/hdimage.test

# (find-fline "~/.mtoolsrc")
# drive t: file="/tmp/hdimage.test" partition=1 offset=128

rm -Rv /tmp/dosemuprogs/
mkdir  /tmp/dosemuprogs/
cd     /tmp/dosemuprogs/
mcopy t:'*' .
for i in *; do mv -v $i $(echo $i | tr A-Z a-z); done

rm -Rv /tmp/dos622-1/
mkdir  /tmp/dos622-1/
cd     /tmp/dos622-1/
tar -xvzf /big/nonfree/dos622-1.tgz

rm -Rv /tmp/4dos601/
mkdir  /tmp/4dos601/
cd     /tmp/4dos601/
unzip -L $S/ftp/jpsoft.com/4dos/4dos601.zip

rm -Rv /tmp/dos/
mkdir  /tmp/dos/
cd     /tmp/dos/
ln -s ../4dos601 4dos
ln -s ../dos622-1 dos
ln -s ../dosemuprogs dosemu

crlf > /tmp/config.sys <<'---'
shell=d:\4dos\4dos.com d:\4dos\ /P
device=c:\emufs.sys /tmp/dos
device=c:\ems.sys
---
cd /tmp/dos/4dos/
crlf > 4dos.ini <<'---'
[4DOS]
InstallPath = D:\4DOS\
---
mv -v _4inst.btm _4inst0.btm
#
mkfatimage16 -b /big/home/root/DOS622/bootsector.622 \
  /tmp/dos622-1/{io.sys,msdos.sys,command.com}	\
  /tmp/config.sys		\
  /tmp/dosemuprogs/{exitemu.com,emufs.sys,ems.sys}	\
  > /var/lib/dosemu/hdimage.first



# (find-fline "/etc/dosemu/conf" "$_term_char_set")
# (find-fline "/usr/lib/dosemu/global.conf")
# (eeman "dos" "  -I")
# Seems that the $_ variables are changing nothing...

dos -c
dos -c -I '$_term_char_set = "ibm"'
dos -c -I '$_term_char_set = "latin"'

dos -I '$_term_char_set = "ibm"'
dos -I '$_term_char_set = "latin"'
dos -I '$_term_color = (off)'

dos -c -e 4096
dos -c -e 8192 -I '$_ems = (4096)' 
dos -c -h -M 8192 -I '$_ems = (4096)'	|& l





# Older version, simpler and works to a certain extent

crlf > /tmp/config.sys <<'---'
rem shell=c:\command.com
shell=c:\4dos.com /P
---
#
cd /tmp/dos622-1/
mkfatimage16 -b /big/home/root/DOS622/bootsector.622 \
  io.sys msdos.sys command.com	\
  /tmp/config.sys		\
  /tmp/dosemuprogs/{exitemu.com}	\
  /tmp/4dos601/*.{com,exe}	\
  > /var/lib/dosemu/hdimage.first

laf /var/lib/dosemu/hdimage.first

 /tmp/config.sys


# (find-fline "/big/home/root/DOS622/")
# (find-fline "/big/junhome/dosboot/")
# (find-fline "/big/junhome/dosboot/config.sys")



# (find-vldifile "dosemu.list")
# (find-fline "/usr/doc/dosemu/")


unzip -l $S/ftp/jpsoft.com/4dos/4dos601.zip



cd /usr/src/dosemu-0.98.1/
DOSC=contrib/dosC/dist
mkfatimage16 -b $DOSC/boot.bin -l DOSEMU \
	$DOSC/ipl.sys $DOSC/kernel.exe $DOSC/command.com \
	0.98.1.0/commands/* >/tmp/hdimage.test








# (find-demufile "src/tools/periph/bootsect.S")









#####
#
# dosemu on slink; lots of notes
# 99nov27
#
#####

# «dosemu_slink_long»  (to ".dosemu_slink_long")
# (find-es "dos" "dosemu_slink_4dos")

apti dosemu

# (find-vldifile "dosemu.list")
# (find-fline "/usr/doc/dosemu/")
# (find-fline "/usr/doc/dosemu/README.Debian")
# (find-fline "/usr/doc/dosemu/QuickStart.gz")
# (find-fline "/usr/doc/dosemu/QuickStart.gz" "drive g:")
# (find-fline "/usr/doc/dosemu/README-tech.txt.gz")
# (find-fline "/usr/doc/dosemu/README.txt.gz")
# (find-fline "/etc/dosemu/")
# (find-fline "/etc/dosemu/conf")
# (find-fline "/etc/mtools.conf" "hdimage.first")
# (find-fline "/var/lib/dosemu/")
# (eeman "5 mtools")
# (eeman "dos")
# (eeman "dos" "OPTIONS")



# (find-es "dos" "dosemu-0.97.5")

strace-to ~/s dos
getstrings < ~/s | sort | uniq | tee ~/o
# (find-fline "~/o")

pdsc /big/slinks2/dists/slink/main/source/otherosfs/dosemu_0.98.1-3.dsc
cd /usr/src/dosemu-0.98.1/
find * -type f | glimpseindex -H . -F

cd /usr/src/dosemu-0.98.1/
debian/rules binary	|& tee odrb
# (find-demufile "odrb")
# (find-demufile "odrb" "lib_hdd5")
# (find-demufile "src/env/video/Makefile")
# (find-demufile "src/env/video/")

alias dosglimpse='cd /usr/src/dosemu-0.98.1/; glimpse -y -H .'
dosglimpse -il hdimage
dosglimpse -il hdimage.first
dosglimpse -il hdimage.test	| tee ~/o


# (find-demufile "ChangeLog"			"hdimage.test")
# (find-demufile "contrib/dosC/readme.dosemu"	"hdimage.test")
# (find-demufile "etc/config.test"		"hdimage.test")
# (find-demufile "first-test"			"hdimage.test")
# (find-demufile "src/tools/periph/Makefile"	"hdimage.test")
# (find-demufile "src/tools/mkbindist"		"hdimage.test")


# (find-demufile "debian/rules"			"hdimage.test")
# (find-demufile "src/tools/periph/Makefile"	"hdimage.test:")
# (eeman "mkfatimage16")

cd /usr/src/dosemu-0.98.1/
DOSC=contrib/dosC/dist
mkfatimage16 -b $DOSC/boot.bin -l DOSEMU \
	$DOSC/ipl.sys $DOSC/kernel.exe $DOSC/command.com \
	0.98.1.0/commands/* >/tmp/hdimage.test


ar p dosemu data.tar.gz | tar -tvzf -

# (find-fline "/etc/mtools.conf")
# edrx:
drive t: file="/tmp/hdimage.test" partition=1 offset=128


DEB=/big/slinkb1/dists/slink/main/binary-i386/otherosfs/dosemu_0.98.1-3.deb
ar p $DEB data.tar.gz \
  | tar -xvzOf - var/lib/dosemu/hdimage.first \
  > /tmp/hdimage.test

rm -Rv /tmp/dosemuprogs/
mkdir  /tmp/dosemuprogs/


# (find-demufile "src/tools/periph/bootsect.S")



# (find-demufile "src/doc/README/")
# (find-demufile "src/doc/")
sort ~/s | uniq | getstrings | sort | uniq | l


apti dosfstools
# (find-vldifile "dosfstools.list")
# (find-fline "/usr/doc/dosfstools/")




#####
#
# dosemu 1.0.2.1 (sid, on potato)
# 2001dec15
#
#####

# «dosemu-1.0.2»  (to ".dosemu-1.0.2")
# (code-c-d "demu" "/usr/src/dosemu-1.0.2.1/")
# (find-demufile "")
# (find-demufile "debian/rules")

#
pdsc $SDEBIAN/pool/contrib/d/dosemu/dosemu_1.0.2.1-2.dsc
cd /usr/src/dosemu-1.0.2.1/
# debian/rules binary	|& tee odrb
debian/rules build	|& tee odrb

#
cd /usr/src/dosemu-1.0.2.1/
rm -Rf debian/tmp debian/dosemu
ln -snf tmp debian/dosemu
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	install bin/dosemu.bin bin/dosdebug dist/dosemu debian/dosemu/usr/bin
	ln debian/dosemu/usr/bin/dosemu debian/dosemu/usr/bin/xdosemu
	cp -pr etc/keymap etc/global.conf debian/dosemu/usr/lib/dosemu
	rm -rf debian/dosemu/usr/lib/dosemu/keymap/CVS
	cp -p etc/dosemu.xpm debian/dosemu/usr/X11R6/include/X11/pixmaps
	cp -p etc/dosemu.conf debian/dosemu/etc/dosemu
	cp -p etc/dosemu.users.secure debian/dosemu/etc/dosemu/dosemu.users
	(SLIST=(aspi.sys cdrom.sys ems.sys emufs.sys fossil.com mgarrot.com)
	 cd commands; cp $SLIST ../../debian/dosemu/usr/lib/dosemu/commands
	)
	# (find-node "(zsh-beta)Parameter Expansion")
	# (find-node "(zsh-beta)Array Parameters")
	(cd src/plugin/commands; \
		install -m 644 generic.com comcom.com \
			../../../debian/dosemu/usr/lib/dosemu/commands; \
		LINKLIST=($(for i in *.com; do [ -L $i ] && echo $i; done)); \
		cd ../../../debian/dosemu/usr/lib/dosemu/commands; \
		for i in $LINKLIST; do \
			ln -s generic.com $i; \
		done
	)
	(cd debian/dosemu/usr/lib/freedos/dosemu; \
		ln -s ../../dosemu/commands/* .
	)
	cp debian/autoexec.bat debian/dosemu/usr/lib/freedos
	cp src/tools/tools86 debian/dosemu/usr/bin

	cp -p debian/dosemu.alias debian/xfonts-dosemu/etc/X11/fonts/misc
	bdftopcf etc/vga.bdf | gzip --best \
		> debian/xfonts-dosemu/usr/X11R6/lib/X11/fonts/misc/vga.pcf.gz

	dh_installdebconf
	dh_installdocs
	dh_installmenu

	# dh_installman
	# (eev "zless ~edrx/tmp/dh_installman.1.gz")
	# (find-demufile "debian/")
	mkdir -p debian/dosemu/usr/man/man1/
	cp $(<debian/dosemu.manpages) debian/dosemu/usr/man/man1/
	gzip -6f debian/dosemu/usr/man/man1/*.1
	# (find-demufile "debian/dosemu/usr/man/man1/")

	dh_installchangelogs ChangeLog
	dh_installxfonts
	dh_strip

	dh_compress	>& odh_compress
	# (find-fline "/usr/bin/dh_compress" 113)
	# (find-demufile "odh_compress")

	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

#
dpkg -i /usr/src/dosemu_1.0.2.1-2_i386.deb

# (find-fline "/etc/dosemu/")
# (find-fline "/etc/dosemu/dosemu.conf" "$_hdimage =")
# (find-demufile "debian/dosemu/usr/lib/dosemu/commands/")

 = "testdos"



# (code-c-d "demu" "/usr/src/dosemu-1.0.2.1/")
# (find-demufile "")
# (find-demufile "odrb" "touch build-stamp")
# (find-demufile "debian/rules" "dh_clean -k")
# (find-demufile "debian/")

dosemu_1.0.2.1-2_i386.deb




#####
#
# dosemu2-debian
# 2023jan14
#
#####

# «dosemu2-debian»  (to ".dosemu2-debian")
# https://mail.google.com/mail/u/0/#inbox/FMfcgzGrbvMBwRGLTJGBJfLwQZrvsNnH
# https://github.com/dosemu2/dosemu2/wiki/Building-packages-for-Debian





#####
#
# dosemu2
# 2023jan12
#
#####

# «dosemu2»  (to ".dosemu2")
# https://en.wikipedia.org/wiki/DOSEMU
# https://github.com/dosemu2/dosemu2
# https://github.com/dosemu2/dosemu2/wiki/Building-packages-for-Debian
# http://dosemu2.github.io/dosemu2/

# (find-git-links "https://github.com/dosemu2/dosemu2" "dosemu2")
# (code-c-d "dosemu2" "~/usrc/dosemu2/")
# (find-dosemu2file "")
# (find-dosemu2file "README.md")
# (find-dosemu2file "INSTALL")
# (find-dosemu2file "INSTALL" "comcom32.zip")
# (find-dosemu2grep "grep --color=auto -niRH --null -e fdpp *")
# (find-dosemu2file "ci_build.sh" "fdpp.git")
# (find-dosemu2file "oa")
# (find-dosemu2file "odc")
# (find-dosemu2file "odc" "checking for SDL...")
# (find-dosemu2file "omi")
# (find-zsh "availabledebs | sort | grep sdl")
# (find-zsh "availabledebs | sort | grep sdl | grep dev")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/dosemu2/
cd      ~/usrc/
git clone https://github.com/dosemu2/dosemu2
cd      ~/usrc/dosemu2/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/dosemu2/
git pull
git clean -dfx
git reset --hard

export CROSS_LD=ld.lld-13

cd      ~/usrc/dosemu2/
./ci_build.sh          |& tee oci

cd      ~/usrc/dosemu2/
./autogen.sh           |& tee oa
./default-configure    |& tee odc
make                   |& tee om
sudo make install      |& tee omi
make deb               |& tee omd

dosemu2
dosemu

sudo dpkg -i ~/usrc/dosemu2_*.deb




make                   |& tee om

fdpp
apti dosemu2

sudo dpkg -i dosemu2-build-deps*.deb
apti -f

A=(
  binutils-dev
  binutils-i686-linux-gnu
  fdpp-dev
  ladspa-sdk
  libao-dev
  libfluidsynth-dev
  libieee1284-3-dev
  libsdl2-dev
  libsdl2-image-dev
  libsdl2-ttf-dev
  libslirp-dev
  linuxdoc-tools
)
apti $A
sudo apt-get --fix-broken install


 dosemu2-build-deps depends on binutils-dev; however:
 dosemu2-build-deps depends on binutils-i686-linux-gnu; however:
 dosemu2-build-deps depends on fdpp-dev; however:
 dosemu2-build-deps depends on ladspa-sdk; however:
 dosemu2-build-deps depends on libao-dev; however:
 dosemu2-build-deps depends on libfluidsynth-dev; however:
 dosemu2-build-deps depends on libieee1284-3-dev; however:
 dosemu2-build-deps depends on libsdl2-dev; however:
 dosemu2-build-deps depends on libsdl2-image-dev; however:
 dosemu2-build-deps depends on libsdl2-ttf-dev; however:
 dosemu2-build-deps depends on libslirp-dev; however:
 dosemu2-build-deps depends on linuxdoc-tools; however:



# (find-status   "fdpp")
# (find-vldifile "fdpp.list")
# (find-udfile   "fdpp/")

# (find-zsh "installeddebs | sort | grep dosemu")
# (find-zsh "availabledebs | sort | grep dosemu")




#####
#
# fdpp - needed by dosemu2, doesn't build
# 2023jan12
#
#####

# «fdpp»  (to ".fdpp")
# (find-git-links "https://github.com/dosemu2/fdpp.git" "fdpp")
# (code-c-d "fdpp" "~/usrc/fdpp/")
# (find-fdppfile "")
# (find-fdppfile "omd")
# (find-fdppfile "omd" "/usr/bin/ld.lld")
# (find-fdppsh "find * | sort")
# (find-fdppgrep "grep --color=auto -nRH --null -e lld *")
# (find-fdppgrep "grep --color=auto -nRH --null -e ld.lld *")
# (find-fdppgrep "grep --color=auto -niRH --null -e runpath *")
# (find-fdppfile "debian/control" "lld (>= 13~)")
# (find-fdppfile "makefile")
# (find-fdppfile "makefile" "deb")
# (find-fdppfile "fdpp/makefile")
# (find-fdppfile "fdpp/makefile" "deb:")

# https://github.com/dosemu2/fdpp/issues/209 ->
# linker error: section .ptext virtual address range overlaps with .note.gnu.build-id #209
# https://github.com/dosemu2/fdpp/issues/209#issuecomment-1382649882 my question

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/fdpp/
cd      ~/usrc/
git clone https://github.com/dosemu2/fdpp.git
cd      ~/usrc/fdpp/

# (kill-new "export CROSS_LD=ld.lld-13")
# (find-fline "~/usrc/fdpp/debian/rules")

export CROSS_LD=ld.lld-13

./configure               |& tee oc
make                      |& tee om
make deb                  |& tee omd

# (find-fline "~/usrc/" "fdpp_1.6-1_amd64.deb")
sudo dpkg -i \
  ~/usrc/fdpp_*.deb \
  ~/usrc/fdpp-dev_*.deb





# (kill-new "LLD = /usr/bin/ld.lld-13")
# (find-fdppfile "fdpp/clang.mak" "LLD = $(shell which ld.lld)")

make deb       |& tee omd



 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv /tmp/fdpp/
cd      /tmp/
git clone https://github.com/dosemu2/fdpp.git
cd      /tmp/fdpp/

./configure

# (find-fline "/tmp/fdpp/fdpp/clang.mak")
# Now change the line 5 in /tmp/fdpp/fdpp/clang.mak from:
#   LLD = $(shell which ld.lld)
# to:
#   LLD = $(shell which ld.lld-13)

make  |& tee om


# 




# (find-zsh "installeddebs | sort | grep lld")
# (find-zsh "availabledebs | sort | grep lld")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti lld-13

# (find-status   "lld-13")
# (find-vldifile "lld-13.list")
# (find-udfile   "lld-13/")



#####
#
# comcom2
# 2023jan14
#
#####

# «comcom2»  (to ".comcom2")
# https://github.com/dosemu2/comcom32
# (find-git-links "https://github.com/dosemu2/comcom32" "comcom32")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/comcom32/
cd      ~/usrc/
git clone https://github.com/dosemu2/comcom32
cd      ~/usrc/comcom32/

# (find-fline "~/usrc/comcom32/debian/control")
# (find-comcom32file "debian/control")

make deb |& tee omd

apti djgpp-dev gcc-djgpp
apti gcc-djgpp
apti binutils-djgpp
aptrm dosemu2

apti fluid-soundfont-gm install-freedos

i586-pc-msdosdjgpp-gcc


# (code-c-d "comcom32" "~/usrc/comcom32/")
# (find-comcom32file "")
# (find-comcom32file "omd")
# (find-comcom32file "omd" "i586-pc-msdosdjgpp-gcc")
# (find-sh "apt-file search i586-pc-msdosdjgpp")




#####
#
# binutils-djgpp
# 2023jan14
#
#####

# «binutils-djgpp»  (to ".binutils-djgpp")
# (find-status   "binutils-djgpp")
# (find-vldifile "binutils-djgpp.list")
# (find-udfile   "binutils-djgpp/")
# (find-apt-get-source-links "binutils-djgpp")
# (code-c-d "djgpp" "/tmp/d/binutils-djgpp-2.35.1+dfsg/")
# (find-djgppfile "")
# (find-djgppsh "find * | sort")
# (find-fline "/tmp/d/" "osourceb")
# (find-fline "/tmp/d/osourceb")

https://packages.debian.org/source/sid/binutils-djgpp
https://packages.debian.org/source/bullseye/binutils-djgpp



#####
#
# dosemu2-build-debian
# 2023jan17
#
#####

# «dosemu2-build-debian»  (to ".dosemu2-build-debian")
# https://mail.google.com/mail/u/0/#search/dosemu2/FMfcgzGrbvMBwRGLTJGBJfLwQZrvsNnH
# https://github.com/dosemu2/fdpp/issues/209#issuecomment-1382714689
# https://github.com/dosemu2/dosemu2/wiki/Building-packages-for-Debian

 (eepitch-shell3)
 (eepitch-kill)
 (eepitch-shell3)
sudo apt-get install devscripts equivs git wget unzip checkinstall

# (find-fline "~/usrc/fdpp/")
rm -Rfv ~/usrc/fdpp/
mkdir   ~/usrc/fdpp/
cd      ~/usrc/fdpp/
git clone https://github.com/dosemu2/fdpp.git .

# Figure out and install the build tools we need to build the package
mk-build-deps --install --root-cmd sudo --remove    |& tee ombd

# (find-fline "~/usrc/fdpp/fdpp/clang.mak")
cd ~/usrc/fdpp/fdpp/
# diff    clang.mak.orig clang.mak
# diff -e clang.mak.orig clang.mak
patch clang.mak <<'%%%'
5c5
< LLD ?= $(shell which ld.lld)
---
> LLD ?= $(shell which ld.lld-13)
%%%

cd ~/usrc/fdpp/

# then initiate the build
make deb    |& tee omd

# after it finishes the debs are in the directory above
cd ..

# you should install them now, as we require the development package to build Dosemu2
sudo apt-get install ./fdpp*.deb



# (find-fline "~/usrc/comcom32/")
rm -Rfv ~/usrc/comcom32/
mkdir   ~/usrc/comcom32/
cd      ~/usrc/comcom32/
git clone https://github.com/dosemu2/comcom32.git .

# Get the latest build from the master site
wget https://dosemu2.github.io/comcom32/files/comcom32.zip
unzip comcom32.zip

# (find-fline "/usr/share/comcom32/")
sudo mkdir -p /usr/share/comcom32/

# Install it
sudo make checkinstall    |& tee omc

# Leave this directory for further steps
cd ..
sudo apt-get install ~/usrc/comcom32/comcom32*.deb


# (find-fline "~/usrc/dosemu2/")
rm -Rfv ~/usrc/dosemu2/
mkdir   ~/usrc/dosemu2/
cd      ~/usrc/dosemu2/
git clone https://github.com/dosemu2/dosemu2.git .

# Figure out and install the build tools we need to build the package
mk-build-deps --install --root-cmd sudo --remove   |& tee ombd

# then initiate the build
make deb     |& tee omd

# after it finishes the debs are in the directory above
cd ..

# you can install them now.
sudo apt-get install ./dosemu*.deb

cd /tmp/
dosemu2
dosemu
# (find-man "1 dosemu")

# (find-status   "fdpp")
# (find-vldifile "fdpp.list")
# (find-udfile   "fdpp/")
# (find-status   "comcom32")
# (find-vldifile "comcom32.list")
# (find-udfile   "comcom32/")
# (find-status   "dosemu2")
# (find-vldifile "dosemu2.list")
# (find-udfile   "dosemu2/")

# (find-fline "/usr/lib/fdpp/" "libfdpp.so")
# (find-sh "find /usr/lib/ | grep so")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
dosemu
ls -lAF /usr/lib/fdpp/

strace-to /tmp/s dosemu
strace -o /tmp/s dosemu
# (find-fline "/tmp/s")

ldd dosemu
ldd $(w dosemu)

/tmp(edrx:sc)# dosemu2
zsh: command not found: dosemu2
/tmp(edrx:sc)# dosemu
ERROR: libfdpp.so: cannot open shared object file: No such file or directory
ERROR: can't load fdpp
ERROR: userspace pings are disabled.
	To enable them, do as root:
	echo 0 65535 > /proc/sys/net/ipv4/ping_group_range
ERROR: Bootable drive not found, exiting
/tmp(edrx:sc)# 




#####
#
# Wine on Sarge
# 2006oct13
#
#####

# «wine-sarge»  (to ".wine-sarge")
# (find-org "index.org" "wine-sarge")

# (find-sh "locate -i winword")
# (find-fline "/big/hdd2/bupcdmay2000/LEA2/winword.zip")
# (find-fline "/big/hdd2/bupcdmay2000/LEA2/winword6.zip")
# (find-status   "wine")
# (find-vldifile "wine.list")
# (find-udfile   "wine/")




#####
#
# dosbox
# 2007apr01 / 2023jan12
#
#####

# «dosbox»  (to ".dosbox")
# (find-status   "dosbox")
# (find-vldifile "dosbox.list")
# (find-udfile   "dosbox/")
# (find-man "1 dosbox")
# (find-man "1 dosbox" "INTERNAL COMMANDS")
# (find-fline "~/.dosbox/")
# (find-fline "~/.dosbox/dosbox-0.74-3.conf")

# (find-fline "/home/angg_slow_html/HSFORTH/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/hsforth/")
rm -Rv /tmp/hsforth/
mkdir  /tmp/hsforth/
cd     /tmp/hsforth/
unzip /home/angg_slow_html/HSFORTH/hsforth2.zip

# (find-sh "strings /tmp/hsforth/HSFORTH.EXE")




#####
#
# dosbox-apt-get-source
# 2023jan12
#
#####

# «dosbox-apt-get-source»  (to ".dosbox-apt-get-source")
# (find-1stclassvideolsubs "eev2019")
# (find-es "emacsconf2019" "short")
# (find-apt-get-source-links "dosbox")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-sh "apt-cache show    dosbox")
# (find-sh "apt-cache showsrc dosbox")
rm -Rv /tmp/d/
mkdir  /tmp/d/
cd     /tmp/d/
sudo apt-get build-dep -y   dosbox
     apt-get source         dosbox   2>&1 | tee osource
     apt-get source --build dosbox   2>&1 | tee osourceb

# (code-c-d "dosbox" "/tmp/d/dosbox-0.74-3/")
# (find-dosboxfile "")
# (find-dosboxfile "src/hardware/keyboard.cpp")

https://salsa.debian.org/debian/dosbox.git
https://en.wikipedia.org/wiki/DOSBox
https://www.dosbox.com/
https://sourceforge.net/projects/dosbox/files/dosbox/0.74-3/dosbox-0.74-3.tar.gz/download



dosbox

# (code-c-d "dosbox" "~/usrc/dosbox-0.70/")
# (find-dosboxfile "")




#####
#
# teselea
# 2006jul17
#
#####

# outra possibilidade que eu ainda nao tentei: antiword
#
rm -Rv /tmp/teselea/
mkdir  /tmp/teselea/
cd "/home/edrx/LEA/unpacked/Meus Documentos/Docs antigos do cd/"
cp -v tese/todates*.doc /tmp/teselea/
cd     /tmp/teselea/
# (find-fline "/tmp/teselea/")
wvHtml  todates3.doc todates3.html
wvLatex todates3.doc todates3.tex
wvCleanLatex todates3.doc todates3-c.tex
latex todates3-c.tex

#
# (find-fline "/tmp/teselea/todates3.tex" 70)
# ! Use of \@icentercr doesn't match its definition.
# <argument> \def 
# l.70 no pensamento de }}
cd /tmp/teselea/
latex todates3.tex

#
# (find-fline   "/tmp/teselea/")
# (find-fline   "/tmp/teselea/todates3-c.tex")
# (find-dvipage "/tmp/teselea/todates3-c.dvi")
# file:///tmp/teselea/todates3.html




#####
#
# tese-lea
# 2006oct13
#
#####

# «tese-lea»  (to ".tese-lea")
# (find-org "index.org" "tese-lea")

# (find-fline "/big/hdd2/bupcdmay2000/LEA2/tese.zip")
#
# (find-man "1 unzip")
rm -Rv /tmp/tese/
unzip -L -d /tmp/ /big/hdd2/bupcdmay2000/LEA2/tese.zip

#
cd /tmp/tese/
wvLatex todatese.doc todatese.tex
# (find-fline "/tmp/tese/")

# (find-man "1 catdoc")
# (find-sh "catdoc -l")
# (find-sh "catdoc -s 8859-1 -f tex   /tmp/tese/todatese.doc")
# (find-sh "catdoc -s 8859-1 -f ascii /tmp/tese/todatese.doc")

# (find-sh "wvText /tmp/tese/todatese.doc /tmp/t.doc && cat /tmp/t.doc")

#
word2x

# (find-status   "catdoc")
# (find-vldifile "catdoc.list")
# (find-udfile   "catdoc/")
# (find-man "1 xls2csv")
# (find-man "1 xlsview")
# (find-man "1 catdoc")
# (find-man "1 wordview")

# (find-status   "wv")
# (find-vldifile "wv.list")
# (find-udfile   "wv/")
# (find-man "1 wvWare")
# (find-man "1 wvHtml")
# (find-man "1 wvLatex")
# (find-man "1 wvCleanLatex")
# (find-man "1 wvDVI")
# (find-man "1 wvPS")
# (find-man "1 wvPDF")
# (find-man "1 wvText")
# (find-man "1 wvWml")
# (find-man "1 wvAbw")
# (find-man "1 wvRTF")
# (find-man "1 wvMime")
# (find-man "1 wvVersion")
# (find-man "1 wvSummary")




#####
#
# TakeCommand (successor of 4DOS)
# 2015dec21
#
#####

# «takecommand» (to ".takecommand")
# https://jpsoft.com/help/whats-new-in-version-19_0.htm




#####
#
# Borland Sidekick
# 2021may19
#
#####

# «sidekick»  (to ".sidekick")
# https://vetusware.com/download/Sidekick/?id=3353
# (find-fline "~/DOS/")
# (find-fline "~/DOS/" "sidekick2.zip")



#####
#
# virtualbox
# 2023jan12
#
#####

# «virtualbox»  (to ".virtualbox")
# https://en.wikipedia.org/wiki/VirtualBox
# https://packages.debian.org/sid/virtualbox



antidoc







#  Local Variables:
#  coding:               utf-8-unix
#  End:
