#######
#
# E-scripts on my Asus Eee 1005PE netbook.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/eee.e>
#           or at <http://angg.twu.net/e/eee.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.manual»			(to "manual")
# «.updating-the-bios»		(to "updating-the-bios")
# «.bluetooth»			(to "bluetooth")
# «.usb-install-2011»		(to "usb-install-2011")
# «.usb-installer»		(to "usb-installer")
# «.kernel-and-drivers»		(to "kernel-and-drivers")
# «.models-page»		(to "models-page")
# «.no-wifi-access-points»	(to "no-wifi-access-points")
# «.mailing-list»		(to "mailing-list")
# «.nm-tool»			(to "nm-tool")
# «.fn-f-keys»			(to "fn-f-keys")
# «.synaptics»			(to "synaptics")
# «.sound-problems»		(to "sound-problems")
# «.eee-1015-pem»		(to "eee-1015-pem")
# «.repository»			(to "repository")
# «.powertop»			(to "powertop")
# «.eeepc-acpi-scripts»		(to "eeepc-acpi-scripts")




#####
#
# User's manual
# 2011mar27
#
#####

# «manual»  (to ".manual")
# (find-angg ".emacs.papers" "eee")
# http://www.retrevo.com/support/Asus-1005PE-Laptops-manual/id/23611bh639/t/2/
# (code-xpdf      "eee1005manual" "~/EEE/E5255_1005_1001_series_Win7_English.pdf")
# (code-pdftotext "eee1005manual" "~/EEE/E5255_1005_1001_series_Win7_English.pdf")
# (code-xpdf      "eee1005manual" "~/tmp/E5255_1005_1001_series_Win7_English.pdf")
# (code-pdftotext "eee1005manual" "~/tmp/E5255_1005_1001_series_Win7_English.pdf")
(find-eee1005manualpage 1)




#####
#
# Updating the Eee BIOS
# 2010oct11
#
#####

# «updating-the-bios»  (to ".updating-the-bios")
# (find-eee1005manualpage 32 "Updating the BIOS through the Internet\n")
# (find-eee1005manualtext    "Updating the BIOS through the Internet\n")

I ran the updater from Windows, as:
  Start > All Programs > ASUS > ASUSUpdate for Eee PC > ASUSUpdate.
It installed this BIOS:
  BIOS Image Information:
    File name: 1005P-ASUS-1103.ROM
    Model:     1005P
    Version:   1103
    Date:      04/29/2010

It was easier to update the BIOS from Windows than using these
instructions:
  http://wiki.debian.org/DebianEeePC/HowTo/UpgradeBIOS

Note that the BIOS upgrade thingy retrieved a BIOS file with "1005P"
in its name when I asked for a BIOS for the 1005PE - I will consider
this as evidence that the 1005PE should be reasonably similar to the
1005P.


# «bluetooth»  (to ".bluetooth")
# (find-es "hardware" "bluetooth")
# Bluetooth:
# (find-eee1005manualpage 34 "Bluetooth Connection\n ")
# (find-eee1005manualtext    "Bluetooth Connection\n ")
# (find-sh "dmesg")
# (find-sh "dmesg" "Bluetooth:")





#####
#
# USB install, 2011
# 2011nov19
#
#####

# «usb-install-2011»  (to ".usb-install-2011")
# http://wiki.debian.org/DebianEeePC/HowTo/InstallUsingStandardInstaller
# http://wiki.debian.org/DebianEeePC/HowTo/InstallUsingStandardInstaller#Preparation
# http://www.debian.org/CD/netinst/
# http://d-i.debian.org/daily-images/i386/daily/hd-media/boot.img.gz
# http://cdimage.debian.org/debian-cd/6.0.3/i386/iso-cd/
# http://cdimage.debian.org/debian-cd/6.0.3/i386/iso-cd/debian-6.0.3-i386-netinst.iso

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -v  /tmp/boot.img
# cp -v $S/http/d-i.debian.org/daily-images/i386/daily/hd-media/boot.img.gz /tmp/
  cp -v $S/http/ftp.nl.debian.org/debian/dists/squeeze/main/installer-i386/current/images/hd-media/boot.img.gz /tmp/
laf    /tmp/boot.img.gz
gunzip /tmp/boot.img.gz
laf    /tmp/boot.img
sudo dd if=/tmp/boot.img of=/dev/sdb

mkdir /tmp/pen/
sudo umount /dev/sdb1
sudo mount -o uid=$UID -t vfat /dev/sdb /tmp/pen/
ls -l /tmp/pen/
df
cd $S/http/cdimage.debian.org/debian-cd/6.0.3/i386/iso-cd/
cp -v debian-6.0.3-i386-netinst.iso /tmp/pen/
sudo umount /tmp/pen/

# http://www.debian.org/distrib/netinst
# http://ftp.nl.debian.org/debian/dists/squeeze/main/installer-i386/current/images/
# http://www.debian.org/releases/stable/i386/
# http://ftp.nl.debian.org/debian/dists/squeeze/main/installer-i386/current/images/MANIFEST
# http://ftp.nl.debian.org/debian/dists/squeeze/main/installer-i386/current/images/hd-media/boot.img.gz
# http://ftp.nl.debian.org/debian/dists/squeeze/main/installer-i386/current/images/hd-media/initrd.gz
# http://ftp.nl.debian.org/debian/dists/squeeze/main/installer-i386/current/images/hd-media/vmlinuz

sudo umount /tmp/pen/
cd $S/http/cdimage.debian.org/debian-cd/6.0.3/i386/iso-cd/
dd if=debian-6.0.3-i386-netinst.iso of=/dev/sdb



# cd $S/http/cdimage.debian.org/cdimage/daily-builds/daily/arch-latest/i386/iso-cd/
# cp -v debian-testing-i386-netinst.iso /tmp/pen/
# md5sum /tmp/pen/debian-testing-i386-netinst.iso
# umount /dev/sdb




#####
#
# Preparing the USB installer
# 2010oct11
#
#####

# «usb-installer»  (to ".usb-installer")
# http://wiki.debian.org/DebianEeePC/HowTo/InstallUsingStandardInstaller
# http://wiki.debian.org/DebianEeePC/HowTo/InstallUsingStandardInstaller#Preparation
# http://wiki.debian.org/DebianEeePC/Models
# http://wiki.debian.org/DebianEeePC/Model/1005P
#   Ethernet: Atheros L1C
#       WLAN: Atheros AR928X or AR2427
#               module: ath9k  802.11 b,g,n-draft?  min ker 2.6.32-9

# http://d-i.alioth.debian.org/manual/en.i386/apa.html

# http://people.debian.org/~joeyh/d-i/images/daily/hd-media/boot.img.gz
# http://d-i.debian.org/daily-images/i386/daily/
# http://d-i.debian.org/daily-images/i386/daily/hd-media/boot.img.gz
# http://www.debian.org/devel/debian-installer/
# http://cdimage.debian.org/cdimage/daily-builds/daily/arch-latest/i386/iso-cd/
# http://cdimage.debian.org/cdimage/daily-builds/daily/arch-latest/i386/iso-cd/debian-testing-i386-netinst.iso
# http://cdimage.debian.org/cdimage/daily-builds/daily/arch-latest/i386/iso-cd/MD5SUMS.small

# 2011nov14:
# http://cdimage.debian.org/debian-cd/6.0.3/i386/bt-cd/debian-6.0.3-i386-netinst.iso.torrent
# http://cdimage.debian.org/debian-cd/6.0.3/i386/iso-cd/debian-6.0.3-i386-netinst.iso
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-sh "dmesg")
cd /tmp/
sudo dd if=debian-6.0.3-i386-netinst.iso of=/dev/sdb

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-sh "dmesg | tail")
sudo umount /dev/sdb1
# cd $S/http/people.debian.org/~joeyh/d-i/images/daily/hd-media/
  cd $S/http/d-i.debian.org/daily-images/i386/daily/hd-media/
# zcat boot.img.gz > /dev/sdb
# zcat boot.img.gz > /tmp/boot.img
cp -v  boot.img.gz /tmp/
laf    /tmp/boot.img.gz
gunzip /tmp/boot.img.gz
sudo dd if=/tmp/boot.img of=/dev/sdb

# (find-node "(coreutils)dd invocation")

# (find-man "dd")
#
cd $S/http/cdimage.debian.org/cdimage/daily-builds/daily/arch-latest/i386/iso-cd/
md5sum -c MD5SUMS.small
cat       MD5SUMS.small
md5sum d*
mkdir /tmp/pen/
sudo mount -o uid=$UID -t vfat /dev/sdb /tmp/pen/
cd $S/http/cdimage.debian.org/cdimage/daily-builds/daily/arch-latest/i386/iso-cd/
cp -v debian-testing-i386-netinst.iso /tmp/pen/
md5sum /tmp/pen/debian-testing-i386-netinst.iso
umount /dev/sdb

# (find-fline "/tmp/pen/")
# (find-man "md5sum")

# 2010nov27:
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd $S/http/cdimage.debian.org/cdimage/daily-builds/daily/arch-latest/i386/iso-cd/
laf
cp -v debian-testing-i386-netinst.iso /hda5/




#####
#
# Kernel version and drivers detected
# 2010oct11
#
#####

# «kernel-and-drivers»  (to ".kernel-and-drivers")
# From the Debian Installer (note - I had no way to cut and paste
# these messages, so I transcribed them by hand):

+--------------------------| [!!] Configure the network |--------------------------------+
|                                                                                        |
| Your system has multiple network interfaces. Choose the one to use as the primary      |
| interface during the installation. If possible, the first connected network found      |
| has been selected.                                                                     |
|                                                                                        |
| Primary network interface:                                                             |
|                                                                                        |
|  eth0: Atheros Communications AR8132 Fast Ethernet                                     |
|  wlan0: Atheros Communications Inc. AR9285 Wireless Network Adapter (PCI-Express) (wir |
|                                                                                        |
|     <Go Back>                                                                          |
|                                                                                        |
+----------------------------------------------------------------------------------------+

I went to the Debian-Installer shell (with alt-F2) and ran some
commands to obtain more details...

"lspci" said:
  01:00.0 Atheros Communications AR8132 Fast Ethernet (rev c0)
  02:00.0 Atheros Communications Inc. AR9285 Wireless Network Adapter (PCI-Express) (rev 01)

"uname -a" said:
  Linux (none) 2.6.32-5-486 #1 Thu Aug 12 12:59:56 UTC 2010 i686 GNU/Linux

"lsmod" reported that the ath9k module has been loaded (and that
  led_class uses it).





#####
#
# The "Models" pages on the wiki
# 2010oct11
#
#####

# «models-page»  (to ".models-page")
# http://wiki.debian.org/DebianEeePC/Models
# http://wiki.debian.org/DebianEeePC/Model/1005P

The "Models" page on the wiki has this table:

         +---------------------------------------------------+---------------+---------+
         |                 Networking 			     | 	 Input 	     |         |
         +-------------+--------------------------+-----+----+----+----------+Graphics |
         |             |                          |     |    |Silv|          |         |
         |  Ethernet   |         WLAN             | Bt  | 3G |Hotk| Touchpad |         |
+--------+-------------+--------------------------+-----+----+---+-----------+---------+
| 32-bit (i386)                                                                        |
|   (...)                                                                              |
+--------------------------------------------------------------------------------------+
| 64-bit (i386, amd64)                                                                 |
+--------+-------------+--------------------------+-----+----+---+-----------+---------+
| 1001P  |             | Atheros AR928X or AR2427 |     |    |   |           |         |
+--------+             +--------------------------+     |    |   | Synaptics |         |
| 1005P  | Atheros L1C | Atheros AR2427           | Yes | No | 1 |           | GMA3150 |
+--------+             +--------------------------+     |    |   +-----------+         |
| 1005PE |             | Atheros AR928X or AR2427 |     |    |   |    ???    |         |
+--------+-------------+--------------------------+-----+----+---+-----------+---------+

And this one:

+----------------+-----------+------------------+----------------+------------------------------+
| WLAN           | Module    | Interface        | 802.11         | Min. kernel version          |
+----------------+-----------+------------------+----------------+------------------------------+
|                | madwifi   | ath0             |                | 2.6.26-1 (lenny)             |
| Atheros AR2425 +-----------+------------------+                +------------------------------+
|                | ath5k     |                  | b, g           | 2.6.32                       |
+----------------+-----------+                  |                +------------------------------+
| Atheros AR2427 | ath9k     | wlan0            |                | 2.6.32-9                     |
+----------------+-----------+                  +----------------+------------------------------+
| Atheros AR928X | ath9k     |                  | b, g, n-draft? | 2.6.28-1?                    |
+----------------+-----------+------------------+----------------+------------------------------+
|                |           | ra0 (< 2.6.32)   |                |                              |
|                + rt2860sta +------------------+                | 2.6.29-1                     |
| Ralink RT2860  |           | wlan0 (e 2.6.32) | b, g, n-draft  |                              |
|                +-----------+------------------+                +------------------------------+
|                | rt2800pci | wlan0            |                | in development (2.6.35-rc*)  |
+----------------+-----------+------------------+----------------+------------------------------+
|                | rt3090sta | wlan0            |                | 2.6.32-6                     |
| Ralink RT3090  +-----------+------------------+ b, g, n?       +------------------------------+
|                | rt2800pci |                  |                | in development (2.6.35-rc*?) |
+----------------+-----------+ wlan0            +----------------+------------------------------+
| Realtek 8187   | rtl8187se |                  | b, g?          | 2.6.29-1                     |
+----------------+-----------+------------------+----------------+------------------------------+
| Realtek 8192SE | rtl8192se | wlan0            | b, g?          | ???                          |
+----------------+-----------+------------------+----------------+------------------------------+

The "1005P" page on the wiki has some extra instructions - use Squeeze
instead of Lenny; acpi_osi="Linux"; "to fix a problem with the wrong
bus being used to hotplug ethernet/wifi, you will need to upgrade your
BIOS, otherwise ethernet will not show up in lspci and no wifi access
points will be visible" -, and AFAICT I have followed them all.

The "1005P" page also has links to a full dump of a "cpuinfo", a
"dmesg", and an "lspci".







#####
#
# Problem: no WiFi access points detected
# 2010oct11
#
#####

# «no-wifi-access-points»  (to ".no-wifi-access-points")

The problem: the DebianEee-PC installer (in the pen drive) does not
list any WiFi access points. It says, in a box:

  Searching for wireless access points...
  [::::progress bar:::::]

Then:

  +-----------------| [!!] Configure the network |----------------------+
  |     Attempting to find an available wireless network failed.        |
  |                                                                     |
  | wlan0 is a wireless network interface. Please enter the name (the   |
  | ESSID) of the wireless network you would like wlan0 to use. To skip |
  | wireless configuration and continue, leave this field blank.        |
  |                                                                     |
  | Wireless ESSID for wlan0:                                           |
  | _________________________                                           |
  |     (...)                                                           |
  +---------------------------------------------------------------------+

Then I tried to fill in my router's ESSID ("Birdland") and its
password - supposing that the problem could be just with the detection
of yet-unnamed wifi routers - but that didn't work; no connection was
established.

I have several reasons to believe that the access point _should_ have
been detected - that my problem is with the drivers:

  * I have another laptop (an Acer) that has both Ubuntu 10.04 and
    Debian Lenny. The network-manager applet in Ubuntu lists my router
    and the ones of two of my neighbors; however the "same" applet in
    the Debian Lenny partition doesn't list anything.

  * The "Birdland" router has not been configured to stay hidden.

  * The "Models" pages are slightly less clear about the 1005PE than
    on other models - it says that the Atheros AR928X needs kernel
    "2.6.28-1?" - so I may be using an old revision of the kernel, and
    it may be that the driver works well with the amd64 compile but
    not as i386, which is what I am using.

I am going to ask for help in at least these two directions:

  1) what are the commands that I can run on a shell to list the
     available access points? (I know shamefully little about wifi...
     I don't even know what to run on Ubuntu to accomplish "manually"
     what the network-manager is doing...)

  2) How can I upgrade to another "boot.img.gz" that has a newer
     kernel?

----

I asked about that in the #debian-eeepc channel at irc.oftc.net and
someone there told me that (s)he didn't think that the
debian-installer could use a wifi connection... so I tried to do the
basic installation using an ethernet cable, and everything went fine -
and the installed system was able to use the wifi.

# A good way to check the version:
# (find-fline      "/etc/apt/sources.list" "Ubuntu 10.04")
# (find-fline      "/etc/apt/sources.list" "Debian GNU/Linux testing _Squeeze_")
# (find-fline "/sda3/etc/apt/sources.list" "Debian GNU/Linux 5.0.0 _Lenny_")




#####
#
# Mailing list
# 2010oct11
#
#####

# «mailing-list»  (to ".mailing-list")
# http://lists.alioth.debian.org/pipermail/debian-eeepc-devel/




#####
#
# nm-tool
# 2010oct11
#
#####

# «nm-tool»  (to ".nm-tool")
# On a system with lots of stuff installed - e.g., an Ubuntu -
# "nm-tool" lists the available access points. But the scripts on the
# Debian-Installer use something more low-level... what do they use?

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
R
nm-tool
# Wireless Access Points (* = current AP)
#   linksys:    Infra, 00:1E:E5:5D:C2:54, Freq 2462 MHz, Rate 54 Mb/s, Strength 12
#   casa:       Infra, 00:1B:11:90:03:74, Freq 2427 MHz, Rate 54 Mb/s, Strength 24 WEP
#   *Birdland:  Infra, 00:25:86:D6:5B:92, Freq 2437 MHz, Rate 54 Mb/s, Strength 60 WPA

# (find-zsh "dmissing nm-tool")

# (find-fline "/usr/bin/nm-tool")
# (find-man "1 nm-tool")

iwlist wlan0 scan




#####
#
# The "touchpad on/off" key and friends
# 2010oct14
#
#####

# «fn-f-keys»  (to ".fn-f-keys")
# Each of the keys F1-F12 has a blue symbol below it.
# In theory it should be possible to run the associated action by
# typing the key combos Fn-F1, ..., Fn-F12, but some of the actions -
# like "touchpad on/off" - are currently doing nothing.

# If I type these key combos when Emacs is in focus some of them are
# received by Emacs, and generate messages like "<XF86Sleep> in
# undefined" in the echo area. XF86MonBrightnessDown and
# XF86MonBrightnessUp change the brightness of the display _and_ are
# passed to Emacs, who says that their bindings are undefined.

# These key names should be standard, and should be present both in
# Emacs's sources (I guess) and in xkb's data directories. Here are
# the names of the ones that are reported as undefined by Emacs, and
# some notes about the other ones.

# Fn-F1 = XF86Sleep
# Fn-F2 =   (wifi on/off;      works)
# Fn-F3 =   (touchpad on/off;  doesn't work)
# Fn-F4 =   (expand screen?    doesn't work)
# Fn-F5 = XF86MonBrightnessDown
# Fn-F6 = XF86MonBrightnessUp
# Fn-F7 =   (crossed monitor sign; doesn't work)
# Fn-F8 = XF86Display
# Fn-F9 =   (heartbeat sign;       doesn't work)
# Fn-F10 =  (no sound;             doesn't work)
# Fn-F11 =  (low volume sound;     doesn't work)
# Fn-F12 =  (high volume sound;    doesn't work)

# These names should be useful for grepping and googling for
# information.

# No matches in the Emacs sources... why, and how?
#   (find-emacscvsgrep "grep -nrH -e XF86Sleep .")

# In xkb-data:

# (find-sh "locate -i /xkb")
# (find-status   "xkb-data")
# (find-vldifile "xkb-data.list")
# (find-udfile   "xkb-data/")

# (code-c-d "xkbsymbols" "/usr/share/X11/xkb/symbols/")
# (find-xkbsymbolsfile "")
# (find-xkbsymbolsgrep "grep -nrH -e XF86MonBrightness .")
# (find-xkbsymbolsfile "inet" "ACPI Standard")




#####
#
# The Synaptics touchpad
# 2010oct14
#
#####

# «synaptics»  (to ".synaptics")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
locate synaptics

# (find-sh "locate -i synaptics")
# (find-zsh "dmissing synaptics")
# (find-udfile "gpm/README.synaptics.gz")

# (find-status   "xserver-xorg-input-synaptics")
# (find-vldifile "xserver-xorg-input-synaptics.list")
# (find-udfile   "xserver-xorg-input-synaptics/")

# (find-fline "/usr/share/bug/xserver-xorg-input-synaptics")
# (find-udfile "xserver-xorg-input-synaptics/trouble-shooting.txt.gz")
# (find-udfile "xserver-xorg-input-synaptics/README.gz")
# (find-udfile "xserver-xorg-input-synaptics/README.gz" "xev")
# (find-udfile "xserver-xorg-input-synaptics/README.Debian")
# (find-udfile "xserver-xorg-input-synaptics/NEWS.Debian.gz")
# (find-fline "/usr/share/X11/xorg.conf.d/50-synaptics.conf")
# (find-fline "/usr/share/bug/xserver-xorg-input-synaptics/script")
# (find-man "4 synaptics")
# (find-man "1 syndaemon")
# (find-man "1 synclient")

# X doesn't seem to support the touchpad of the 1005PE well...

# (find-fline "/proc/bus/input/devices")
# (find-fline "/proc/bus/input/devices" "SynPS/2 Synaptics TouchPad")
# (find-fline "/var/log/Xorg.0.log")
# (find-fline "/var/log/Xorg.0.log" "SynPS/2 Synaptics TouchPad")
# (find-fline "/var/log/Xorg.0.log" "no supported touchpad found")

# There's a much shorter log that appears in the virtual console where
# X was started:
# (find-man "4 vcs")
# (find-fline "/dev/" "vcs")
# (setq last-kbd-macro (kbd "M-128 <right> RET <left> M-\\ C-a <down>"))
# (find-sh "sudo cat /dev/vcs5")
#   SynPS/2 Synaptics TouchPad no synaptics event device found
#   Query no Synaptics: 6003C8
#   (EE) SynPS/2 Synaptics TouchPad Unable to query/initialize Synaptics hardware.
#   (EE) PreInit failed for input device "SynPS/2 Synaptics TouchPad"




#####
#
# Sound problems
# 2010oct14
#
#####

# «sound-problems»  (to ".sound-problems")
# I cannot get any sounds...
# Sound worked in the Windows 7 partition (and the mic and the camera
# too - I tested in Skype), so it's not the hardware.

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
locate sounds
locate ogg
cd /usr/share/sounds/gnome/default/alerts/
totem bark.ogg
# (find-fline    "/usr/share/sounds/gnome/default/alerts/")
# (find-nautilus "/usr/share/sounds/gnome/default/alerts/")





#####
#
# Valeria's Asus Eee 1015PEM
# 2011nov14
#
#####

# «eee-1015-pem»  (to ".eee-1015-pem")
# (find-es "hardware" "asus-1005pem")
# http://wiki.debian.org/DebianEeePC/Model/1015PEM
# Actuale Info e Games
# Endereço: Av Rio Branco 156 loja 306 a 308 st 08
# Telefone1: (21) 2524-1033
#   Asus EEE PEM comprado em 2011nov08
#   com o João

http://www.amazon.com/ASUS-1015PEM-PU17-BU-10-1-Inch-Netbook-Blue/dp/B0042TS7GE





#####
#
# debian repository
# 2013aug07
#
#####

# «repository» (to ".repository")
# (find-fline "/etc/apt/sources.list")

http://vincent.stehle.free.fr/1015b/ 

There is an eeepc-acpi-scripts package, which seems to be doing good
to my EeePC. It "repaired" the HDA audio power management, which was
busy 100% of the time before (as reported by powertop). I wonder if
this did not have an effect on the HDD led as well :)

deb http://eeepc.debian.net/debian sid main contrib non-free
# ^offline

# (find-zsh "installeddebs | sort | grep eee")
# (find-zsh "availabledebs | sort | grep eee")




#####
#
# powertop
# 2013aug08
#
#####

# «powertop» (to ".powertop")
# (find-status   "powertop")
# (find-vldifile "powertop.list")
# (find-udfile   "powertop/")
# (find-man "8 powertop")
# https://01.org/powertop/




#####
#
# eeepc-acpi-scripts
# 2013aug08
#
#####

# «eeepc-acpi-scripts» (to ".eeepc-acpi-scripts")
# (find-status   "eeepc-acpi-scripts")
# (find-vldifile "eeepc-acpi-scripts.list")
# (find-udfile   "eeepc-acpi-scripts/")
# (find-fline "/etc/modprobe.d/eeepc.conf")

# (find-sh "dmesg")

# https://www.google.com.br/search?q=asus+eee+debian+suspend+problems
# http://lists.debian.org/debian-user/2012/03/msg01426.html
# https://wiki.archlinux.org/index.php/ASUS_Eee_PC
# http://packages.debian.org/stable/eeepc-acpi-scripts
# http://lists.alioth.debian.org/cgi-bin/mailman/listinfo/debian-eeepc-devel
# http://lists.alioth.debian.org/pipermail/debian-eeepc-devel/
# http://lists.alioth.debian.org/pipermail/debian-eeepc-devel/2013-July/004354.html

# (find-status   "eeepc-acpi-scripts")
# (find-vldifile "eeepc-acpi-scripts.list")
# (find-udfile   "eeepc-acpi-scripts/")
# (find-status   "rfkill")
# (find-vldifile "rfkill.list")
# (find-udfile   "rfkill/")
http://wireless.kernel.org/en/users/Documentation/rfkill
https://wiki.debian.org/DebianEeePC/Repository

# 2013sep03:
# http://linuxpoison.blogspot.com.br/2010/06/acpi-related-linux-kernel-parameters.html
# http://askubuntu.com/questions/28848/what-does-the-kernel-boot-parameter-set-acpi-osi-linux-do
# http://www.mjmwired.net/kernel/Documentation/kernel-parameters.txt
# http://www.thinkwiki.org/wiki/How_to_make_ACPI_work
# http://support.asus.com/Troubleshooting/detail.aspx?SLanguage=en&m=Eee%20PC%201025C&os=&no=1001
# https://wiki.archlinux.org/index.php/Asus_EEE_PC_1025c







http://debian-eeepc.alioth.debian.org/
http://wiki.debian.org/DebianEeePC/HowTo/GetNativeConsoleResolution
http://wiki.debian.org/DebianEeePC/HowTo/Install
http://wiki.debian.org/DebianEeePC/HowTo/InstallLennyOnOldModels
http://wiki.debian.org/DebianEeePC/HowTo/UseUpstreamAtherosModules

http://forum.eeeuser.com/viewforum.php?id=10
http://reviews.cnet.com/laptops/asus-eee-pc-1005pe/4505-3121_7-33911686.html
http://www.engadget.com/2009/12/21/asus-eee-pc-1005pe-review/

# (find-man "8 pm-suspend")

# 2013aug09:
Discussion takes place on the IRC channel #debian-eeepc and the
mailing list.
# (find-freenode "#debian-eeepc")

http://www.tuxmobil.org/asus.html
http://www.linux-on-laptops.com/asus.html
https://wiki.debian.org/DebianEeePC
https://wiki.debian.org/DebianEeePC/Models
https://wiki.debian.org/InstallingDebianOn/Asus
http://lists.alioth.debian.org/pipermail/debian-eeepc-devel/2013-July/004356.html








#  Local Variables:
#  coding:               utf-8-unix
#  End:
