#######
#
# E-scripts on the EmacsConf 2019.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/emacsconf2019.e>
#           or at <http://angg.twu.net/e/emacsconf2019.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.short»		(to "short")
# «.screencasting.el»	(to "screencasting.el")
# «.all-videos»		(to "all-videos")


# http://angg.twu.net/emacsconf2019.html
# (find-TH "emacsconf2019")
# (find-es "emacs" "emacsconf-2019")







#####
#
# Patching xpdf (demo for the short talk)
# 2019oct24
#
#####

# «short» (to ".short")
# From: (find-es "ps" "xpdf-touchpad-scroll")
# Problem: xpdf was PgUp-ing/PgDn-ing in annoying way
# Why: movement up/down at the right side of the touchpad
#      -> interpreted as mousewheel scroll
#      -> interpreted as PgUp/PgDn
# Quick fix: disable the support for mousewheel scroll in xpdf

# (find-man "1 xpdf")
# (find-man "1 xpdf" "The default mouse bindings")
# (find-man "1 xpdf" "bind mousePress4" "scrollUpPrevPage(16)")
# (find-man "1 xpdf" "scrollUpPrevPage(n)" "previous page")

# Download (and compile) the debian source package for xpdf:
# (find-apt-get-source-links "xpdf")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/d/
mkdir  /tmp/d/
cd     /tmp/d/
sudo apt-get build-dep -y   xpdf
     apt-get source         xpdf   2>&1 | tee osource
     #
     apt-get source --build xpdf   2>&1 | tee osourceb

ls -F   | cat
ls -lAF      xpdf_*.deb
sudo dpkg -i xpdf_*.deb

# (find-fline "/tmp/d/")
# (find-fline "/tmp/d/xpdf-3.04/")
# (code-c-d "xpdf" "/tmp/d/xpdf-3.04/")
# (find-xpdffile "")
# (find-xpdfsh "find * | sort")
# (find-xpdfgrep "grep --color -nRH -e mousePress4 *")
# (find-xpdfgrep "grep --color -nRH -e scrollUpPrevPage *")
# (find-xpdffile "xpdf/GlobalParams.cc" "xpdfKeyCodeMousePress4")






#####
#
# screencasting.el
# 2019oct27
#
#####

# «screencasting.el» (to ".screencasting.el")
# https://emacsconf.org/2019/tips
# https://gist.github.com/DamienCassou
# https://gist.github.com/DamienCassou/0e3663ce3bdb710a44eeb7122870f621
# https://gist.githubusercontent.com/DamienCassou/0e3663ce3bdb710a44eeb7122870f621/raw/4a580456bfee951a41ef70785371d82c7e75044a/screencasting.el
# https://lists.gnu.org/archive/html/emacsconf-discuss/2019-10/
# https://lists.gnu.org/archive/html/emacsconf-discuss/2019-10/msg00004.html

# (find-es "screencasts" "simplescreenrecorder")

# https://github.com/nibrahim/showkeys
# https://github.com/lewang/command-log-mode
# https://www.thregr.org/~wavexx/software/screenkey/




#####
#
# all-videos
# 2019nov25
#
#####

# «all-videos» (to ".all-videos")
# https://lists.gnu.org/r/emacsconf-discuss/2019-11/msg00002.html
# https://emacsconf.org/2019/videos
# https://emacsconf.org/2019/pad
# https://toobnix.org/video-channels/emacsconf




https://emacsconf.org/2019/Organizers'_notebook

https://twitter.com/preek?lang=en
https://github.com/munen



# (find-es "screencasts" "obsstudio")


















#  Local Variables:
#  coding:               utf-8-unix
#  End:
