#######
#
# E-scripts on emacsconf2021.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/emacsconf2021.e>
#           or at <http://angg.twu.net/e/emacsconf2021.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.wiki»	(to "wiki")
# «.ikiwiki»	(to "ikiwiki")
# «.short»	(to "short")

# (find-es "eev" "quick-load")




#####
#
# wiki
# 2021oct24
#
#####

# «wiki»  (to ".wiki")
# https://emacsconf.org/edit/
# (find-git-links "https://git.emacsconf.org/emacsconf-wiki" "emacsconfwiki")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
wget https://emacsconf.org/id_rsa_anon_git_emacsconf
mkdir -p ~/.ssh/
mv id_rsa_anon_git_emacsconf ~/.ssh/
chmod 600      ~/.ssh/id_rsa_anon_git_emacsconf
ssh-keygen -lf ~/.ssh/id_rsa_anon_git_emacsconf
# (find-fline "~/.ssh/config")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/emacsconf-wiki/
cd      ~/usrc/
git clone anon@git.emacsconf.org:emacsconf-wiki
cd      ~/usrc/emacsconf-wiki/

export PAGER=cat
git branch --list -a
git for-each-ref
git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/emacsconf-wiki/")
# (find-gitk  "~/usrc/emacsconf-wiki/")
# (magit-status "~/usrc/emacsconf-wiki/")

# (code-c-d "emacsconfwiki" "~/usrc/emacsconf-wiki/")
# (find-emacsconfwikifile "")
# (find-emacsconfwikifile "edit.md")
# (find-emacsconfwikifile "2021/talks/test.md")
#    https://emacsconf.org/2021/talks/test/



#####
#
# ikiwiki
# 2021oct24
#
#####

# «ikiwiki»  (to ".ikiwiki")
# https://ikiwiki.info/

https://emacsconf.org/2021/
https://emacsconf.org/2021/schedule/
https://etherpad.wikimedia.org/p/emacsconf-2021
https://live.emacsconf.org/main.html
https://status.emacsconf.org/

mpv https://live0.emacsconf.org/main.webm

the absorbing mind

https://www.aaai.org/Papers/Workshops/1998/WS-98-08/WS98-08-024.pdf Recommender Systems
for Problem Solving Environments




#####
#
# short
# 2021nov28
#
#####

# «short»  (to ".short")



(defun find-4a (a b c d) (find-wset "13_o22+_o_o_o"  a b c d))

(defun c3 () (interactive)
(find-3a nil
 ' (find-ebuffer "#emacsconf@irc.libera.chat")
 ' (find-ebuffer "#emacsconf-questions@irc.libera.chat")
 )
)

(defun c4 () (interactive)
(find-4a nil
 ' (find-ebuffer "#emacsconf@irc.libera.chat")
 ' (find-ebuffer "#emacsconf-questions@irc.libera.chat")
 ' (find-ebuffer "#eev@irc.libera.chat")
 )
)


mpv https://live0.emacsconf.org/main.webm

ex    Scott Anderson   https://github.com/scottanderson42





#  Local Variables:
#  coding:               utf-8-unix
#  End:
