#######
#
# E-scripts on figlet.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/figlet.e>
#           or at <http://angg.twu.net/e/figlet.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.awk»		(to "awk")
# «.default-font»	(to "default-font")
# «.shorter-dash»	(to "shorter-dash")


# (find-zsh "installeddebs | sort | grep figlet")
# (find-zsh "availabledebs | sort | grep figlet")
# (find-status   "figlet")
# (find-vldifile "figlet.list")
# (find-udfile   "figlet/")
# (find-udfile   "figlet/figfont.txt.gz")
# (find-fline "/usr/share/figlet/")
# (find-fline "/usr/share/figlet/standard.flf")
# (find-fline "/tmp/stan.flf")




# (find-man "6 figlet")
# (find-man "6 figlet" "    -w outputwidth")



#####
#
# The default font
# 2012jan15
#
#####

# «default-font»  (to ".default-font"
# (find-man "6 figlet" "default" "-I3")
# (find-sh0   "figlet -I3")
# (find-fline "/usr/share/figlet/standard.flf")
# (find-man "6 figlet" "    -I infocode")




#####
#
# awk
# 2021dec17
#
#####

# «awk»  (to ".awk")
# (find-es "awk" "figlet")




#####
#
# Shorter dashes
# 2012jan15
#
#####

# «shorter-dash»  (to ".shorter-dash")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
cp -v /usr/share/figlet/standard.flf .
cp -v standard.flf standard.flf.orig
# (find-fline "/tmp/standard.flf")
# (find-fline "/tmp/standard.flf" 91)
# (find-angg ".zshrc" "mydiff")
mydiff standard.flf
# (find-fline "~/o")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
cp -v /usr/share/figlet/standard.flf .
cp -v standard.flf standard.flf.orig
patch -p0 standard.flf <<'%%%'
91,96c91,96
<         @
<         @
<   _____ @
<  |_____|@
<     $   @
<         @@
---
>        @
>        @
>   ____ @
>  |____|@
>    $   @
>        @@
%%%
laf standard*
echo foo-bar | figlet -f standard
echo foo-bar | figlet -f /tmp/stan







# (find-fline "~/MEDIADOR/")
# (find-fline "~/MEDIADOR/mediador.e")

* figlet and figfonts
# http://ftp.debian.org/debian/pool/non-free/f/figlet/figlet_2.2.1-4_i386.deb
# http://ftp.uk.debian.org/debian/pool/non-free/f/figfonts/figfonts_2.2-4_all.deb

dpkg -i $S/http/ftp.debian.org/debian/pool/non-free/f/figlet/figlet_2.2.1-4_i386.deb \
        $S/http/ftp.uk.debian.org/debian/pool/non-free/f/figfonts/figfonts_2.2-4_all.deb

# (find-status   "figlet")
# (find-vldifile "figlet.list")
# (find-udfile   "figlet/")
# (find-status   "figfonts")
# (find-vldifile "figfonts.list")
# (find-udfile   "figfonts/")



# (find-fline "/usr/share/figlet/ogre.flf")
# (find-man "1 unzip")
# (find-sh           "unzip -l /usr/share/figlet/ogre.flf")
# (find-sh "cd /tmp/; unzip -p /usr/share/figlet/ogre.flf")




#####
#
# edrx.flf
# 2006aug23
#
#####

# (find-fline "~/tmp/edrx.flf")
# (find-fline "/usr/share/figlet/big.flf")







/usr/share/man/man6
# (find-man "6 chkfont")
# (find-man "6 figlet")
# (find-man "6 figlist")
# (find-man "6 showfigfonts")


# (find-sh   "figlet -I0")
# (find-sh   "figlet -I1")
# (find-sh   "figlet -I5")


# (find-angg ".emacs" "figlet")
# (find-sh "figlet -f standard pos-spec-list")
# (find-sh "figlet -f standard pos_spec-list")
# (find-sh "figlet -f big pos_spec-list")


for i in basic big ogre nancyj roman; do echo "$i :"; figlet -f $i "pos-spec-list"; done

figlet -f

# (find-sh "showfigfonts 'Word foo'")



/.
# (find-fline "/usr/bin/figlet")
# (find-fline "/usr/bin/chkfont")
# (find-fline "/usr/bin/figlist")
# (find-fline "/usr/bin/showfigfonts")
# (find-fline "/usr/share/figlet/big.flf")
# (find-fline "/usr/share/figlet/block.flf")
# (find-fline "/usr/share/figlet/bubble.flf")
# (find-fline "/usr/share/figlet/digital.flf")
# (find-fline "/usr/share/figlet/ivrit.flf")
# (find-fline "/usr/share/figlet/lean.flf")
# (find-fline "/usr/share/figlet/mini.flf")
# (find-fline "/usr/share/figlet/mnemonic.flf")
# (find-fline "/usr/share/figlet/script.flf")
# (find-fline "/usr/share/figlet/shadow.flf")
# (find-fline "/usr/share/figlet/slant.flf")
# (find-fline "/usr/share/figlet/small.flf")
# (find-fline "/usr/share/figlet/smscript.flf")
# (find-fline "/usr/share/figlet/smshadow.flf")
# (find-fline "/usr/share/figlet/smslant.flf")
# (find-fline "/usr/share/figlet/standard.flf")
# (find-fline "/usr/share/figlet/term.flf")
# (find-fline "/usr/share/figlet/646-ca2.flc")
# (find-fline "/usr/share/figlet/646-ca.flc")
# (find-fline "/usr/share/figlet/646-cn.flc")
# (find-fline "/usr/share/figlet/646-cu.flc")
# (find-fline "/usr/share/figlet/646-de.flc")
# (find-fline "/usr/share/figlet/646-dk.flc")
# (find-fline "/usr/share/figlet/646-es2.flc")
# (find-fline "/usr/share/figlet/646-es.flc")
# (find-fline "/usr/share/figlet/646-fr.flc")
# (find-fline "/usr/share/figlet/646-gb.flc")
# (find-fline "/usr/share/figlet/646-hu.flc")
# (find-fline "/usr/share/figlet/646-irv.flc")
# (find-fline "/usr/share/figlet/646-it.flc")
# (find-fline "/usr/share/figlet/646-jp.flc")
# (find-fline "/usr/share/figlet/646-kr.flc")
# (find-fline "/usr/share/figlet/646-no2.flc")
# (find-fline "/usr/share/figlet/646-no.flc")
# (find-fline "/usr/share/figlet/646-pt2.flc")
# (find-fline "/usr/share/figlet/646-pt.flc")
# (find-fline "/usr/share/figlet/646-se2.flc")
# (find-fline "/usr/share/figlet/646-se.flc")
# (find-fline "/usr/share/figlet/646-yu.flc")
# (find-fline "/usr/share/figlet/8859-2.flc")
# (find-fline "/usr/share/figlet/8859-3.flc")
# (find-fline "/usr/share/figlet/8859-4.flc")
# (find-fline "/usr/share/figlet/8859-5.flc")
# (find-fline "/usr/share/figlet/8859-7.flc")
# (find-fline "/usr/share/figlet/8859-8.flc")
# (find-fline "/usr/share/figlet/8859-9.flc")
# (find-fline "/usr/share/figlet/frango.flc")
# (find-fline "/usr/share/figlet/hz.flc")
# (find-fline "/usr/share/figlet/ilhebrew.flc")
# (find-fline "/usr/share/figlet/jis0201.flc")
# (find-fline "/usr/share/figlet/koi8r.flc")
# (find-fline "/usr/share/figlet/moscow.flc")
# (find-fline "/usr/share/figlet/upper.flc")
# (find-fline "/usr/share/figlet/ushebrew.flc")
# (find-fline "/usr/share/figlet/uskata.flc")
# (find-fline "/usr/share/figlet/utf8.flc")
# (find-fline "/usr/share/emacs/site-lisp/figlet.el")
# (find-udfile "figlet/README.Debian")
# (find-udfile "figlet/copyright")
# (find-udfile "figlet/README.gz")
# (find-udfile "figlet/figfont.txt.gz")
# (find-udfile "figlet/changelog.Debian.gz")
# (find-udfile "figlet/changelog.gz")
# (find-man "6 chkfont")
# (find-man "6 figlet")
# (find-man "6 figlist")
# (find-man "6 showfigfonts")






#  Local Variables:
#  coding:               utf-8-unix
#  End:
