#######
#
# E-scripts on Firefox
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/firefox.e>
#           or at <http://angg.twu.net/e/firefox.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.iceweasel»			(to "iceweasel")
# «.greasemonkey»		(to "greasemonkey")
# «.dive-into-greasemonkey»	(to "dive-into-greasemonkey")
# «.monospaced-gmail»		(to "monospaced-gmail")
# «.java-plugin»		(to "java-plugin")
# «.flash-10»			(to "flash-10")
# «.dom-inspector»		(to "dom-inspector")
# «.cookies»			(to "cookies")
# «.cache»			(to "cache")
# «.smooth-scrolling»		(to "smooth-scrolling")
# «.mozrepl»			(to "mozrepl")
# «.google-talkplugin»		(to "google-talkplugin")
# «.treestyletab»		(to "treestyletab")
# «.buku»			(to "buku")
# «.downloadhelper»		(to "downloadhelper")
# «.video-downloadhelper»	(to "video-downloadhelper")
# «.play-video-starting-at»	(to "play-video-starting-at")
# «.pdf-displayed-incorrectly»	(to "pdf-displayed-incorrectly")
# «.firefox-javascript-repl»	(to "firefox-javascript-repl")


# (find-es "javascript")





#####
#
# iceweasel (points to firefox-esr)
# 2021jul11
#
#####

# «iceweasel»  (to ".iceweasel")
# https://stackoverflow.com/questions/60487538/where-can-i-find-iceweasel-in-debian
# https://en.wikipedia.org/wiki/Mozilla_software_rebranded_by_Debian
# https://en.wikipedia.org/wiki/Category:Web_browsers_based_on_Firefox
# https://wiki.debian.org/Firefox#Iceweasel
# https://www.howtogeek.com/335712/update-why-you-shouldnt-use-waterfox-pale-moon-or-basilisk/
# (find-newbrowser-links "g" "googlechrome" "google-chrome")

# (find-status   "iceweasel")
# (find-vldifile "iceweasel.list")
# (find-udfile   "iceweasel/")
# (find-fline "/usr/bin/" "iceweasel")

# (find-status   "firefox-esr")
# (find-vldifile "firefox-esr.list")
# (find-udfile   "firefox-esr/")

# (find-anggsh "find -mtime 0 | sort | grep -v google-chrome")
# (find-fline "~/.cache/mozilla/firefox/")
# (find-fline "~/.mozilla/firefox/")
# (find-fline "/usr/lib/firefox-esr/")




#####
#
# greasemonkey
# 2008nov17
#
#####

# «greasemonkey»  (to ".greasemonkey")
# http://www.greasespot.net/
# http://en.wikipedia.org/wiki/Greasemonkey
# https://addons.mozilla.org/en-US/firefox/addon/748

# http://userscripts.org/

# (find-zsh "installeddebs | sort | grep grease")
# (find-zsh "availabledebs | sort | grep grease")
# (find-status   "firefox-greasemonkey")
# (find-vldifile "firefox-greasemonkey.list")
# (find-udfile   "firefox-greasemonkey/")
# (find-status   "iceweasel-greasemonkey")
# (find-vldifile "iceweasel-greasemonkey.list")
# (find-udfile   "iceweasel-greasemonkey/")

# (code-c-d "gmonkey" "/usr/share/iceweasel-extensions/greasemonkey/")
# (code-c-d "gmonkeyen"      (ee-gmonkeyfile "chrome/chromeFiles/locale/en-US/"))
# (code-c-d "gmonkeycontent" (ee-gmonkeyfile "chrome/chromeFiles/content/"))
# (find-gmonkeyfile "")
# (find-gmonkeyenfile "")
# (find-gmonkeycontentfile "")







#####
#
# dive into greasemonkey
# 2008nov17
#
#####

# «dive-into-greasemonkey»  (to ".dive-into-greasemonkey")
# http://diveintogreasemonkey.org/
# http://diveintogreasemonkey.org/download/book/diveintogreasemonkey-pdf-2005-05-09.zip
# http://diveintogreasemonkey.org/download/book/diveintogreasemonkey-text-2005-05-09.zip
# http://diveintogreasemonkey.org/download/book/diveintogreasemonkey-html-2005-05-09.zip
# http://www.oreillynet.com/pub/a/network/2005/11/01/avoid-common-greasemonkey-pitfalls.html
# http://www.oreillynet.com/pub/a/network/2005/11/01/avoid-common-greasemonkey-pitfalls.html?page=1
#
rm -Rv ~/usrc/diveintogreasemonkey-2005-05-09/
unzip -d ~/usrc/    $S/http/diveintogreasemonkey.org/download/book/diveintogreasemonkey-pdf-2005-05-09.zip
unzip -d ~/usrc/ -o $S/http/diveintogreasemonkey.org/download/book/diveintogreasemonkey-text-2005-05-09.zip
unzip -d ~/usrc/ -o $S/http/diveintogreasemonkey.org/download/book/diveintogreasemonkey-html-2005-05-09.zip
cd     ~/usrc/diveintogreasemonkey-2005-05-09/

#
# (code-c-d "digmonkey" "~/usrc/diveintogreasemonkey-2005-05-09/")
# (find-digmonkeyfile "")
# (find-digmonkeyw3m "toc/index.html")




#####
#
# monospaced font in e-mails in gmail (by fnaufel)
# 2008nov17
#
#####

# «monospaced-gmail»  (to ".monospaced-gmail")
# http://userscripts.org/scripts/show/17869
# http://userscripts.org/scripts/review/17869

Olá,

É só uma opinião minha, mas achei que devia compartilhar com vcs.

Decidi que  e-mail deve ser lido  e escrito, sempre  que possível, com
fonte  monoespaçado  (fixed  width).  Então,  fiz o  seguinte  no  meu
Firefox:

* Instalei a extensão Greasemonkey.

* Instalei, no Greasemonkey, o script que está em

             http://userscripts.org/scripts/show/17869

* Na linha do fonte do script que diz

 var css = ".ArwC7c, .iE5Yyc  { font: .9em monospace !important; }";

 mudei o tamanho do fonte para 1.2em.

* Na janela de composição de msgs do GMail, troquei para "plain text".

Daí em diante, todas as msgs que escrevo ou leio no GMail aparecem com
fonte monoespaçado.  Quando a  msg é grande  ou importante,  escrevo o
texto no emacs, com justificação,  indentação etc etc e depois colo na
janela de composição do GMail.





#####
#
# The Java plugin (JRE) for Firefox/Iceweasel
# 2009aug10
#
#####

# «java-plugin»  (to ".java-plugin")
# (find-zsh "availabledebs | sort | grep jre")
# (find-zsh "availabledebs | sort | grep iceweasel")
# (find-zsh "availabledebs | sort | grep firefox")
# (find-zsh "availabledebs | sort | grep mozilla")
# (find-zsh "availabledebs | sort | grep java")
# http://packages.debian.org/sun-java6-jre
# http://packages.debian.org/sun-java6-plugin
  nspluginwrapper

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
R
apti sun-java7-jre sun-java7-plugin
apti sun-java6-jre sun-java6-plugin

apt-get update && apt-get install sun-java6-jre sun-java6-plugin
  [or -jdk, for dev-work]
then do:
  update-alternatives --config java
 : older version can then be removed

If the above doesn't work try deleting the plugin.dat file in your
~mozilla directory.


# (find-man "unzip")

# 2014feb15:
# http://forums.debian.net/viewtopic.php?f=30&t=106108
# https://wiki.debian.org/Java/





#####
#
# Flash 10 plugin
# 2010sep19
#
#####

# «flash-10»  (to ".flash-10")
# http://get.adobe.com/flashplayer/
# http://www.adobe.com/products/flashplayer/productinfo/instructions/
# http://support.mozilla.com/en-US/kb/Installing+the+Flash+plugin
# Tools > Add-Ons > Get Add-Ons > unplug

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/.mozilla/
laf
laf plugins/
rm -Rv ~/.mozilla/plugins/

cd /usr/lib/mozilla/plugins/
laf
laf flash-mozilla.so
laf /etc/alternatives/flash-mozilla.so
sudo tar -xvzf /tmp/install_flash_player_10_linux.tar.gz

# (find-status   "flashplugin-nonfree-extrasound")
# (find-vldifile "flashplugin-nonfree-extrasound.list")
# (find-udfile   "flashplugin-nonfree-extrasound/")
# (find-status   "flashplugin-nonfree")
# (find-vldifile "flashplugin-nonfree.list")
# (find-udfile   "flashplugin-nonfree/")





#####
#
# DOM inspector
# 2009sep21
#
#####

# «dom-inspector»  (to ".dom-inspector")
# (find-status   "iceweasel-dom-inspector")
# (find-vldifile "iceweasel-dom-inspector.list")
# (find-udfile   "iceweasel-dom-inspector/")

apti iceweasel-dom-inspector





#####
#
# Cookies
# 2009oct10
#
#####

# «cookies»  (to ".cookies")
# (find-es "javascript" "cookies")
# http://support.mozilla.com/en-US/kb/Cookies?style_mode=inproduct&s=cookies
# _E_dit -> Prefere_n_ces -> Privacy -> Cookies -> _S_how cookies



#####
#
# cache
# 2010apr27
#
#####

# «cache»  (to ".cache")
# (find-anggfile ".mozilla/firefox/ftc9fs06.default/Cache/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/.mozilla/firefox/ftc9fs06.default/Cache/
file $('ls' -t) | tee /tmp/ocache
cat /tmp/ocache | egrep 'JPEG|PNG|GIF' | cut -b 1-11 | tee /tmp/oimgs
cat /tmp/ocache | grep JPEG | cut -b 1-11 | tee /tmp/ojpegs
cat /tmp/ocache | grep PNG  | cut -b 1-11 | tee /tmp/opngs
cat /tmp/ocache | grep GIF  | cut -b 1-11 | tee /tmp/ogifs

cat /tmp/ocache | grep PNG | grep ' 800 ' | cut -b 1-11 | tee /tmp/opngs



 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cat /tmp/oimgs \
  | awk '{printf "cp -v %s /tmp/imgs/%03d_%s\n", $1, n, $1; n=n+1}' \
  | tee /tmp/oimgs2
cat /tmp/opngs \
  | awk '{printf "cp -v %s /tmp/pngs/%03d_%s.png\n", $1, n, $1; n=n+1}' \
  | tee /tmp/opngs2
cat /tmp/ojpgs \
  | awk '{printf "cp -v %s /tmp/jpgs/%03d_%s.jpg\n", $1, n, $1; n=n+1}' \
  | tee /tmp/o2

rm -R /tmp/jpgs/
mkdir /tmp/jpgs/
cd ~/.mozilla/firefox/ftc9fs06.default/Cache/
. /tmp/o2

rm -R /tmp/pngs/
mkdir /tmp/pngs/
cd ~/.mozilla/firefox/ftc9fs06.default/Cache/
. /tmp/opngs2

rm -R /tmp/imgs/
mkdir /tmp/imgs/
cd ~/.mozilla/firefox/ftc9fs06.default/Cache/
. /tmp/oimgs2


# (find-fline "/tmp/jpgs/")
# (find-fline "/tmp/pngs/")
# (find-fline "/tmp/imgs/")

# (find-fline "~/FREGE/")



#####
#
# Smooth scrooling on Firefox 3
# 2010aug08
#
#####

# «smooth-scrolling»  (to ".smooth-scrolling")

Smooth Scrolling (CSS trick - does not work):
http://thenonhacker.deviantart.com/journal/18918994/

# (find-fline "~/.mozilla/firefox/glw5nubm.default/")
# (find-fline "~/.mozilla/firefox/f2xg25xx.default/")
# (find-fline "~/.mozilla/firefox/f2xg25xx.default/chrome/")
# (find-fline "~/.mozilla/firefox/f2xg25xx.default/chrome/userContent.css")

/* Smooth Scrolling Fix: Disable Fixed Background Images on Pages */
body {
background-attachment: scroll !important;
}


Yet another smooth scrolling (works well):
https://addons.mozilla.org/en-US/firefox/addon/5846/




#####
#
# MozRepl
# 2010aug31
#
#####

# «mozrepl»  (to ".mozrepl")
# (find-es "javascript" "mozrepl")




#####
#
# google-talkplugin
# 2011mar01
#
#####

# «google-talkplugin»  (to ".google-talkplugin")

# (find-status   "google-talkplugin")
# (find-vldifile "google-talkplugin.list")
# (find-udfile   "google-talkplugin/")
# http://www.google.com/chat/voice/
# http://www.google.com/chat/voice/compare.html
# http://www.google.com/googlevoice/about.html#
# https://www.google.com/voice/b/0/rates/
# http://www.google.com/chat/video/
# http://www.google.com/chat/video/download.html

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
wget http://dl.google.com/linux/direct/google-talkplugin_current_i386.deb
sudo dpkg -i google-talkplugin_current_i386.deb




#####
#
# Tree-style tab
# 2013jan01
#
#####

# «treestyletab» (to ".treestyletab")
<rend> edrx: http://piro.sakura.ne.jp/xul/_treestyletab.html.en
<ameliabot> XUL Apps &gt; Tree Style Tab - outsider reflex





#####
#
# buku
# 2021jul30
#
#####

# «buku»  (to ".buku")

# (find-status   "buku")
# (find-vldifile "buku.list")
# (find-udfile   "buku/")

# (find-fline "/usr/bin/buku")
# (find-fline "/usr/share/bash-completion/completions/buku-completion.bash")
# (find-udfile "buku/README.Debian")
# (find-udfile "buku/README.md.gz")
# (find-udfile "buku/changelog.Debian.gz")
# (find-udfile "buku/changelog.gz")
# (find-udfile "buku/copyright")
# (find-man "1 buku")




#####
#
# Downloadhelper (obsolete)
# 2013jan01
#
#####

# «downloadhelper» (to ".downloadhelper")
# http://www.downloadhelper.net/
# http://www.downloadhelper.net/welcome.php?version=4.9.12
# http://www.downloadhelper.net/faq.php





#####
#
# video-downloadhelper
# 2021sep08
#
#####

# «video-downloadhelper»  (to ".video-downloadhelper")
# https://addons.mozilla.org/pt-BR/firefox/addon/video-downloadhelper/
# https://www.downloadhelper.net/welcome?browser=firefox&version=7.6.0
# https://www.downloadhelper.net/support
# https://www.youtube.com/watch?v=mZT8yI60k_4

# (find-status   "net.downloadhelper.coapp")
# (find-vldifile "net.downloadhelper.coapp.list")
# (find-udfile   "net.downloadhelper.coapp/")
# (find-fline "~/dwhelper/")




#####
#
# play-video-starting-at
# 2021sep22
#
#####

# «play-video-starting-at»  (to ".play-video-starting-at")
# (find-fline "~/LOGS/2021sep22.firefox")

<edrx> I know that I can use things like the "#page=42" here to
       open a PDF on a specific page -
       https://tannerlectures.utah.edu/_resources/documents/a-to-z/c/Coetzee99.pdf#page=42
       - and this works on file:/// urls too. Anyone knows if there
       is something similar that lets me open an .mp4 file and play
       it from the position 1:23 instead of from the beginning?
<edrx> (I mean, without JavaScript)




#####
#
# pdf-displayed-incorrectly
# 2021oct06
#
#####

# «pdf-displayed-incorrectly»  (to ".pdf-displayed-incorrectly")
# pdf.js: Many pdf documents "might not be displayed correctly"

https://www.google.com/search?q=firefox+this+pdf+document+might+not+be+displayed+correctly&oq=firefox+this+pdf+document+might+not+be+displayed+correctly&aqs=chrome..69i57.597j0j7&sourceid=chrome&ie=UTF-8
https://support.mozilla.org/en-US/questions/1289615
https://bugzilla.mozilla.org/show_bug.cgi?id=767455
https://support.mozilla.org/en-US/questions/1111562



#####
#
# firefox-javascript-repl
# 2023jun07
#
#####

# «firefox-javascript-repl»  (to ".firefox-javascript-repl")
# https://www.fitzsim.org/blog/?p=669 firefox-javascript-repl




# (find-zsh "availabledebs | sort | grep iceweasel")
https://developer.mozilla.org/en/docs/Debugging_JavaScript
https://developer.mozilla.org/en-US/docs/Tools/Debugger
http://webmasters.stackexchange.com/questions/8525/how-to-open-the-javascript-console-in-different-browsers

# (find-fline "/usr/share/iceweasel/defaults/preferences/" "firefox")






Other interesting plugins:

Adblock:
http://www.youtube.com/watch?v=oNvb2SjVjjI
https://addons.mozilla.org/en-US/firefox/addon/1865?collection_uuid=463aaf21-0469-3886-2f90-f07c62786cc9

Sitelanucher:
https://addons.mozilla.org/en-US/firefox/addon/10127?collection_uuid=463aaf21-0469-3886-2f90-f07c62786cc9

FastestFox
https://addons.mozilla.org/en-US/firefox/addon/9825?collection_uuid=463aaf21-0469-3886-2f90-f07c62786cc9

CtrlTab
https://addons.mozilla.org/en-US/firefox/addon/5244?collection_uuid=463aaf21-0469-3886-2f90-f07c62786cc9

ReadItLater
https://addons.mozilla.org/en-US/firefox/addon/7661?collection_uuid=463aaf21-0469-3886-2f90-f07c62786cc9

Boss Key and Buttons
https://addons.mozilla.org/en-US/firefox/addon/46553?collection_uuid=cca22a9a-ffab-e660-defa-d302cc263a37

iMacros
https://addons.mozilla.org/en-US/firefox/addon/3863?collection_uuid=cca22a9a-ffab-e660-defa-d302cc263a37

URL lister
https://addons.mozilla.org/en-US/firefox/addon/7192?collection_uuid=cca22a9a-ffab-e660-defa-d302cc263a37

Classic Compact
https://addons.mozilla.org/en-US/firefox/addon/3699/?collection_uuid=cca22a9a-ffab-e660-defa-d302cc263a37



F7: caret browsing

http://alexeev.org/gmailtex.html



<dale> Praise the gods I have figured out how to get Firefox to
       just display a PDF in a browser tab without downloading it.
       I had pdfjs.enabledCache.state=false set in FF prefs
       somehow.  Google searching this leads me to zero useful
       explanation for how it got into that state.


https://news.ycombinator.com/item?id=28071494 Firefox Lost Almost 50M Users: Here’s Why It Is Concerning (itsfoss.com)

https://news.ycombinator.com/item?id=28071494 average user is a fictitious entity
https://www.thestar.com/news/insight/2016/01/16/when-us-air-force-discovered-the-flaw-of-averages.html
https://ruzkuku.com/texts/moz-rel.html

https://news.ycombinator.com/item?id=31625804 StopTheMadness – Take back your web browser (underpassapp.com)
https://news.ycombinator.com/item?id=34369560 History of Web Browser Engines from 1990 until today (2022) (eylenburg.github.io)
https://news.ycombinator.com/item?id=34367284 Firefox lost ~16M users since last year (firefox.com)
https://news.ycombinator.com/item?id=34704948 Browsers are essential and how operating systems are holding them back (2022) [pdf] (2022) (research.mozilla.org)
https://news.ycombinator.com/item?id=38806270 In 2024, please switch to Firefox (roytanck.com)



https://research.mozilla.org/files/2022/10/Mozilla-Five-Walled-Gardens.pdf
Why Browsers are Essential to the Internet and How Operating Systems are Holding Them Back

https://xn--ime-zza.eu/3 Why I use Firefox




#  Local Variables:
#  coding:               utf-8-unix
#  modes:                (fundamental-mode emacs-lisp-mode)
#  End:
