#######
#
# E-scripts on FTP daemons.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/ftpd.e>
#           or at <http://angg.twu.net/e/ftpd.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.ftp-to-us»		(to "ftp-to-us")
# «.wu-ftpd-manpages»	(to "wu-ftpd-manpages")
# «.proftpd»		(to "proftpd")
# «.mkdir-p»		(to "mkdir-p")
# «..netrc»		(to ".netrc")



# (find-zsh "installeddebs | sort | grep ftpd")
# (find-zsh "availabledebs | sort | grep ftpd")
# (find-status   "ftpd")
# (find-vldifile "ftpd.list")
# (find-udfile   "ftpd/")





#####
#
# Which addresses can ftp to us?
# 2000may24
#
#####

# «ftp-to-us»  (to ".ftp-to-us")
# (find-es "pam" "pam-zsh30-bug")

# (find-status   "wu-ftpd")
# (find-vldifile "wu-ftpd.list")
# (find-udfile   "wu-ftpd/")
# (find-vldifile "wu-ftpd.templates" "anonymous ftp")

# (find-status "wu-ftpd")
# (find-fline "/etc/wu-ftpd/ftpaccess")
# (find-fline "/etc/pam.d/wu-ftpd")

debtartvzf $POTATO/$MI386/net/wu-ftpd_2.6.0-5.deb

# (eeman "ftpd")
# (eeman "ftpaccess")
# (find-vldifile "" "wu-ftpd.list")
# (find-vldifile "wu-ftpd.list")
# (find-vldifile "wu-ftpd.preinst")
# (find-vldifile "wu-ftpd.postinst")
# (find-vldifile "wu-ftpd.prerm")
# (find-vldifile "wu-ftpd.postrm")
# (find-fline "/usr/doc/wu-ftpd/")
# (find-fline "/usr/doc/wu-ftpd/FAQ.gz" "        20. Running wu-ftpd")
# (find-fline "/usr/doc/wu-ftpd/FAQ.gz" '* 2 "now nobody can log in")
# (find-fline "/usr/doc/wu-ftpd/examples/")
# (find-fline "/usr/doc/wu-ftpd/examples/ftpaccess")

# (find-fline "/etc/wu-ftpd/")
# (find-fline "/etc/wu-ftpd/ftpaccess" "passwd-check")
egrep -v '^(#|$)' /etc/wu-ftpd/ftpaccess \
  |& tee ~/o
# (find-fline "~/o")

# (eeman "ftpaccess" "real")
# (eeman "ftpaccess" "real entry")

# (find-fline "/var/log/auth.log" "(uid=0) -> edrx")
# (find-fline "/etc/passwd")





#####
#
# wu-ftpd - manpages
# 2000may29
#
#####

# «wu-ftpd-manpages»  (to ".wu-ftpd-manpages")

#General info:
# (eeman "8 wu-ftpd")

#Configuration files:
# (eeman "5 ftpaccess")
# (eeman "5 ftphosts")

#Shutting down and restarting the ftp server:
# (eeman "8 ftpshut")
# (eeman "8 ftprestart")

#?:
# (eeman "5 ftpconversions")

#Adding and removing anonymous ftp users:
# (eeman "8 addftpuser")
# (eeman "8 rmftpuser")

#Users presently logged:
# (eeman "1 ftpwho")
# (eeman "1 ftpcount")

#Log files:
# (eeman "5 xferlog")
# (eeman "8 xferstats")
# (eeman "8 xferstats.wu-ftpd")






#####
#
# proftpd
# 2000jul14
#
#####

# «proftpd»  (to ".proftpd")
# (find-status   "proftpd")
# (find-vldifile "proftpd.list")
# (find-udfile   "proftpd/")
# (find-fline "/usr/doc/proftpd/")

# (find-vldifile "proftpd.postinst" "Enable anonymous ftp access [y/N]?")
dpkg --purge proftpd
apti proftpd
# Enable anonymous ftp access [y/N]? y

#
cat > $EEG <<'---'
ftp 127.0.0.1
anonymous
edrx@angg.popolvuh
dir
quit

exit
---
eeg su - beth
# eeg done
#




#####
#
# ftp has no mkdir -p
# 2001jan17
#
#####

# «mkdir-p»  (to ".mkdir-p")
#
cat > $EEG <<'---'
edrx
edrx
 cd /tmp/
 dir
 mkdir -p foo/bar
 mkdir foo/bar
 dir
 rmdir -p
 quit
---
eeg ftp 127.0.0.1
#




#####
#
# The .netrc file
# 2012jun13
#
#####

# «.netrc»  (to "..netrc")
# (find-man "5 netrc")
# (find-fline "~/.netrc")
# (find-sh "cat ~/.netrc")




#  Local Variables:
#  coding:               utf-8-unix
#  End:
