#######
#
# E-scripts on fvwm.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/fvwm.e>
#           or at <http://angg.twu.net/e/fvwm.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.wiki»			(to "wiki")
# «.forums»			(to "forums")
# «.mailing-lists»		(to "mailing-lists")
# «.init-file»			(to "init-file")
# «.AddToFunc»			(to "AddToFunc")
# «.virtual-desktop»		(to "virtual-desktop")
# «.stalonetray»		(to "stalonetray")
# «.fvwm-generic-mode»		(to "fvwm-generic-mode")
# «.fvwm3-git»			(to "fvwm3-git")
# «.pdfs-and-txts»		(to "pdfs-and-txts")
# «.fvwm-upstream»		(to "fvwm-upstream")
# «.woody-fvwm-config»		(to "woody-fvwm-config")
# «.fvwm-2.5»			(to "fvwm-2.5")
# «.FvwmConsole»		(to "FvwmConsole")
# «.FvwmConsole-in-emacs»	(to "FvwmConsole-in-emacs")
# «.fwvm-menu-directory»	(to "fwvm-menu-directory")
# «.no-borders»			(to "no-borders")
# «.exec-xterm-256color»	(to "exec-xterm-256color")
# «.Style»			(to "Style")
# «.style:bare»			(to "style:bare")
# «.gnudoit»			(to "gnudoit")
# «.numlock»			(to "numlock")
# «.fvwm-netbsd»		(to "fvwm-netbsd")
# «.fvwm2rc7»			(to "fvwm2rc7")
# «.menus-with-hot-keys»	(to "menus-with-hot-keys")
# «.fvwm-gnome-wm»		(to "fvwm-gnome-wm")
# «.xinerama»			(to "xinerama")
# «.schedule»			(to "schedule")
# «.knuths-fvwm2rc»		(to "knuths-fvwm2rc")
# «.fullscreen»			(to "fullscreen")
# «.resize»			(to "resize")
# «.fvwm-lua»			(to "fvwm-lua")
# «.fvwm-edrx»			(to "fvwm-edrx")
# «.fvwm-xfce4»			(to "fvwm-xfce4")
# «.FvwmCommand»		(to "FvwmCommand")
# «.asciidoctor»		(to "asciidoctor")
# «.forum-post-2022jan07»	(to "forum-post-2022jan07")





#####
#
# wiki
# 2022jan07
#
#####

# «wiki» (to ".wiki")
# https://www.fvwm.org/Wiki/




#####
#
# forums
# 2022jan07
#
#####

# «forums»  (to ".forums")
# https://fvwmforums.org/
# https://fvwmforums.org/t/struggling-since-a-debian-upgrade-changed-practically-everything-in-fvwm/2513

S4+++



#####
#
# mailing-lists
# 2022jan07
#
#####

# «mailing-lists»  (to ".mailing-lists")
# (find-fvwm3grep "grep --color=auto -niRH --null -e mailing *")
# (find-fvwm3grep "grep --color=auto -niRH --null -e workers *")
# (find-fvwm3grep "grep --color=auto -niRH --null -e subscribe *")
# https://www.fvwm.org/
# https://www.fvwm.org/Community/#fvwm-mailing-lists
# https://www.mail-archive.com/fvwm@fvwm.org/
# https://www.mail-archive.com/fvwm-workers@fvwm.org/



#####
#
# init-file
# 2022jan07
#
#####

# «init-file»  (to ".init-file")
# (find-fvwmdoc-links             "INITIALIZATION")
# (find-fvwm3file "doc/fvwm3.txt" "INITIALIZATION")
# (find-fvwm3page 8             "\nINITIALIZATION\n")
# (find-fvwm3text 8             "\nINITIALIZATION\n")
# (find-angg ".fvwm/config")
# (find-angg ".fvwm/.fvwm2rc")





#####
#
# DestroyFunc and AddToFunc
# 2022jan07
#
#####

# «AddToFunc»  (to ".AddToFunc")
# (find-fvwmdoc-links                     "AddToFunc")
# (find-fvwm3file "doc/fvwm3commands.txt" "AddToFunc [name [I | J | M | C | H | D action]]")
# (find-fvwm3commandspage 38              "AddToFunc [name [I | J | M | C | H | D action]]")
# (find-fvwm3commandstext 38              "AddToFunc [name [I | J | M | C | H | D action]]")
# (find-fvwmdoc-links                     "DestroyFunc")
# (find-fvwm3file "doc/fvwm3commands.txt" "DestroyFunc function")
# (find-fvwm3commandspage 40              "DestroyFunc function")
# (find-fvwm3commandstext 40              "DestroyFunc function")

# Old:
# (find-man "1 fvwm3all" "DestroyFunc function")
# (find-man "1 fvwm3all" "AddToFunc [name [I | J | M | C | H | D action]]")
# (find-fvwm3file "doc/fvwm3_commands.ad" "*DestroyFunc* _function_::")
# (find-fvwm3file "doc/fvwm3_commands.ad" "*AddToFunc* [_name_ [I | J | M | C | H | D _action_]]::")
# (find-fvwm3allpage)
# (find-fvwm3alltext)

;; (find-fvwm3commandspage)
;; (find-fvwm3commandstext)





#####
#
# virtual-desktop
# 2022jan07
#
#####

# «virtual-desktop»  (to ".virtual-desktop")
# (find-angg ".fvwm/config" ".desktop")
# (find-fvwm3page 1 "large virtual desktop")
# (find-fvwm3text 1 "large virtual desktop")
# (find-fvwm3page 5 "THE VIRTUAL DESKTOP")
# (find-fvwm3text 5 "THE VIRTUAL DESKTOP")
# (find-fvwm3page 7 "EdgeScroll 0 0")
# (find-fvwm3text 7 "EdgeScroll 0 0")
# (find-fvwm3page 27 "DesktopSize")
# (find-fvwm3text 27 "DesktopSize")
# (find-fvwm3file "doc/fvwm3_manpage_source.adoc")

# (find-fvwm3grep "grep --color=auto -niRH --null -e edgeresistance *")
# (find-fvwm3grep "grep --color=auto -niRH --null -e edgemoveresistance *")
# (find-fvwm3file "NEWS" "obsolete commands EdgeResistance")

       EdgeMoveResistance
       EdgeMoveDelay
       EdgeResizeDelay
       SnapGrid
       SnapAttraction

# (find-man "fvwm3all")




#####
#
# stalonetray
# 2017fev06
#
#####

# «stalonetray» (to ".stalonetray")
# Passwords: (find-es "networkmanager" "connections")
# http://prgnsh.blogspot.com.br/2013/01/fvwm-and-network-manager.html
# http://stalonetray.sourceforge.net/
# http://stalonetray.sourceforge.net/wmhints.html
# (find-status   "stalonetray")
# (find-vldifile "stalonetray.list")
# (find-udfile   "stalonetray/")
# (find-udfile "stalonetray/README")
# (find-udfile "stalonetray/README" "~/.stalonetrayrc")
# (find-udfile "stalonetray/examples/stalonetrayrc.sample.gz")
# (find-man "1 stalonetray")
# (find-man "1 stalonetray" "--log-level level")
# (find-multiwindow-intro "Several eepitch targets")
# (find-multiwindow-intro "Several eepitch targets" "find-3ee")
# (find-fline "~/.fvwm/.fvwm2rc" "pager-to-top")

 (eepitch-shell3)
 (eepitch-kill)
 (eepitch-shell3)
stalonetray --log-level trace &
sudo nm-applet


# (find-angg ".stalonetrayrc")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
zcat /usr/share/doc/stalonetray/examples/stalonetrayrc.sample.gz > ~/.stalonetrayrc
stalonetray &
nm-applet

 (find-3EE '(eepitch-shell) '(eepitch-shell2))
 (find-3ee '(eepitch-shell) '(eepitch-shell2))
 (eepitch-shell)
# stalonetray &
stalonetray --log-level trace
 (eepitch-shell2)
sudo nm-applet

https://wiki.debian.org/Fvwm
https://packages.debian.org/buster/nodm
https://packages.debian.org/search?keywords=trayer
https://packages.debian.org/search?keywords=stalonetray









#####
#
# the fvwm config from woody that I used as a basis for my config files
# 2007dec26
#
#####

# «woody-fvwm-config»  (to ".woody-fvwm-config")
# These links are broken...
# (find-fline "/hdd1/etc/X11/fvwm/system.fvwm2rc")
# (code-c-d "woodyfvwm" "/big/hdd1/etc/X11/fvwm/")
# (find-woodyfvwmfile "")
# (find-woodyfvwmfile "" "system.fvwm2rc")

# Something more recent:
# (find-fline "/usr/share/doc/menu/examples/system.fvwm2rc.gz")
# (find-udfile "menu/examples/system.fvwm2rc.gz")





#####
#
# fvwm-generic-mode
# 2007dec26
#
#####

# «fvwm-generic-mode»  (to ".fvwm-generic-mode")
# (find-angg ".fvwm/.fvwm2rc" nil "mode: fvwm-generic")
# (find-efile "generic-x.el")
# (progn (require 'generic-x) (fvwm-generic-mode) (font-lock-mode 1))




#####
#
# fvwm3-git
# 2022jan06
#
#####

# «fvwm3-git»  (to ".fvwm3-git")
# (find-angg ".emacs" "fvwm")

# https://github.com/fvwmorg/fvwm3
# (find-git-links "https://github.com/fvwmorg/fvwm3" "fvwm3")
# (code-c-d "fvwm3" "~/usrc/fvwm3/")
# (find-fvwm3file "")
# (find-fvwm3file "README.md")
# (find-fvwm3file "dev-docs/INSTALL.md")
# (find-fvwm3file "omi")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/fvwm3/
cd      ~/usrc/
git clone https://github.com/fvwmorg/fvwm3
cd      ~/usrc/fvwm3/

# (find-fvwm3file "dev-docs/INSTALL.md")
#
apti libevent-dev libx11-dev libxrandr-dev libxrender-dev libxt-dev
apti asciidoctor libfontconfig-dev libfreetype6-dev libfribidi-dev
apti libncurses5-dev libpng-dev libreadline-dev libsm-dev
apti libxcursor-dev libxext-dev libxft-dev libxi-dev libxpm-dev sharutils
apti librsvg2-dev

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/fvwm3/
./autogen.sh                  |& tee oag
./configure --enable-mandoc   |& tee oc
make                          |& tee om
sudo make install             |& tee omi




#####
#
# Convert the manpages of fvwm3 to .pdfs and .txts
# 2022jan08
#
#####

# «pdfs-and-txts»  (to ".pdfs-and-txts")
# (find-angg ".fvwm/doc_Makefile")
# (find-angg ".emacs.fvwm")
#
cd ~/usrc/fvwm3/doc/
make -f ~/.fvwm/doc_Makefile clean
make -f ~/.fvwm/doc_Makefile all
make -f ~/.fvwm/doc_Makefile man1_PDFS.showvar | sort | tee /tmp/opdfs

# (find-fvwm3sh "find * | grep pdf | sort")
# (find-fvwm3sh "find * | grep pdf | sort | tee /tmp/opdfs")
# (find-fvwm3file "doc/")
# (find-fline "/tmp/opdfs")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
bigstr = ee_readfile "/tmp/opdfs"
replacement = [[
(code-pdf-page "%1" "~/usrc/fvwm3/doc/%1.pdf")
(code-pdf-text "%1" "~/usrc/fvwm3/doc/%1.pdf")
;; (find-%1page)
;; (find-%1text)
]]
for _,li in ipairs(splitlines(bigstr)) do
  print((li:gsub("doc/(.*).pdf", replacement)))
end

# (find-fline "/usr/local/share/fvwm3/")
# (find-man "1 fvwm3")
# (find-man "1 fvwm3" "$HOME/.fvwm/.fvwm2rc")






#####
#
# fvwm from the upstream source (squeeze)
# 2011dec25
#
#####

# «fvwm-upstream»  (to ".fvwm-upstream")
# http://fvwm.org/
# http://fvwm.org/download/
# http://fvwm.org/contact/
# ftp://ftp.fvwm.org/pub/fvwm/version-2/fvwm-2.6.3.tar.gz
# http://packages.debian.org/source/squeeze/fvwm
# http://ftp.de.debian.org/debian/pool/main/f/fvwm/
# http://ftp.de.debian.org/debian/pool/main/f/fvwm/fvwm_2.5.30.ds-1.dsc
# sudo apt-get build-dep fvwm
#
rm -Rv ~/usrc/fvwm-2.6.3/
tar -C ~/usrc/ -xvzf \
  $S/ftp/ftp.fvwm.org/pub/fvwm/version-2/fvwm-2.6.3.tar.gz
cd     ~/usrc/fvwm-2.6.3/

#
rm -Rv ~/usrc/fvwm/
mkdir  ~/usrc/fvwm/
tar -C ~/usrc/fvwm/ -xvzf \
  $S/ftp/ftp.fvwm.org/pub/fvwm/version-2/fvwm-2.6.3.tar.gz
cd     ~/usrc/fvwm/fvwm-2.6.3/

./configure |& tee oc
make        |& tee om

#
# (code-c-d "fvwm" "~/usrc/fvwm-2.6.3/")
# (code-c-d "fvwm" "~/usrc/fvwm/fvwm-2.6.3/")
# (find-fvwmfile "")
# (find-fvwmfile "oc")
# (find-fvwmfile "om")

# (find-fvwmfile "modules/FvwmCommand/")
# (find-fvwmfile "modules/FvwmConsole/")

# (find-efunction 'eefvwm0)
# (find-efunction 'find-fvwm0)
# (find-fline "~/usrc/fvwm/fvwm-2.6.3/fvwm/")
# (find-fline "~/usrc/fvwm/fvwm-2.6.3/modules/FvwmCommand/FvwmCommand")

(defun find-fvwm0 (str)
  (eefvwm str)
  ;; (find-sh0 "FvwmCommand ee")
  (find-sh0 "~/usrc/fvwm/fvwm-2.6.3/modules/FvwmCommand/FvwmCommand ee")
  )





#####
#
# fvwm from the upstream source
# 2004jul11
#
#####

# «fvwm-2.5»  (to ".fvwm-2.5")
# (find-fline "~/.fvwm/.fvwm2rc")

# http://www.igs.net/~tril/fvwm/
# http://www.plig.org/xwinman/fvwm.html
# http://www.zensites.net/fvwm/guide/

# ftp://ftp.fvwm.org/pub/fvwm/version-2/fvwm-2.5.12.tar.gz

# (code-c-d "fvwm" "~/usrc/fvwm-2.5.10/")
# (find-fvwmfile "")
# (find-fvwmfile "sample.fvwmrc/")
# (find-fvwmfile "modules/FvwmPager/")

#
rm -Rv ~/usrc/fvwm-2.5.12/
tar -C ~/usrc/ \
  -xvzf $S/ftp/ftp.fvwm.org/pub/fvwm/version-2/fvwm-2.5.12.tar.gz
cd ~/usrc/fvwm-2.5.12/
./configure --prefix=$HOME/ulocal	|& tee oc
make		|& tee om
make install	|& tee omi

#
~/ulocal/bin/fvwm -replace &

#
fvwm -replace &

#
# (find-fvwmfile "sample.fvwmrc/")
# (find-fvwmfile "sample.fvwmrc/system.fvwm2rc-sample-95")
# (find-fvwmfile "sample.fvwmrc/system.fvwm2rc-sample-95" "Showing Settings")


xkill



#
# (eeb-fvwm)
# (eebd-function-is 'eeb-fvwm)
#
# (find-man "1 FvwmPager")
FvwmPager 0 1
#
FvwmPager 0 0
#
# (find-fvwmhelp "Pick [(conditions)] command")
Pick Destroy
#
WindowList
#
GotoPage 1 0
#



115 letf windows key
64 left alt
113 right alt
116 right windows keys
117 menu key
109 right ctrl




# (find-progoutput "FvwmCommand 'WindowList'")

DestroyFunc ee
AddToFunc ee i read ee.fvwm

(ee-write "GotoPage 1 1" nil "" "" "~/.fvwm/ee.fvwm")




#####
#
# FvwmConsole
# 2004aug15
#
#####

# «FvwmConsole»  (to ".FvwmConsole")
# (find-status   "fvwm")
# (find-vldifile "fvwm.list")
# (find-udfile   "fvwm/")

# (find-man "1 FvwmCommand")
# (find-man "1 FvwmConsole")
# (find-man "1 FvwmConsoleC.pl")
# (find-man "1 FvwmCpp")
# (find-man "1 FvwmDebug")

# (find-man "1 FvwmAnimate")
# (find-man "1 FvwmAuto")
# (find-man "1 FvwmBacker")
# (find-man "1 FvwmBanner")
# (find-man "1 FvwmButtons")
# (find-man "1 FvwmCommand")
# (find-man "1 FvwmConsole")
# (find-man "1 FvwmConsoleC.pl")
# (find-man "1 FvwmCpp")
# (find-man "1 FvwmDebug")
# (find-man "1 FvwmDragWell")
# (find-man "1 FvwmEvent")
# (find-man "1 FvwmForm")
# (find-man "1 FvwmGtk")
# (find-man "1 FvwmIconBox")
# (find-man "1 FvwmIconMan")
# (find-man "1 FvwmIdent")
# (find-man "1 FvwmM4")
# (find-man "1 FvwmPager")
# (find-man "1 FvwmRearrange")
# (find-man "1 FvwmSave")
# (find-man "1 FvwmSaveDesk")
# (find-man "1 FvwmScript")
# (find-man "1 FvwmScroll")
# (find-man "1 FvwmTaskBar")
# (find-man "1 FvwmTheme")
# (find-man "1 FvwmWharf")
# (find-man "1 FvwmWinList")
# (find-man "1 fvwm-config")
# (find-man "1 fvwm-menu-desktop")
# (find-man "1 fvwm-menu-directory")
# (find-man "1 fvwm-menu-headlines")
# (find-man "1 fvwm-menu-xlock")
# (find-man "1 fvwm-update-menu")
# (find-man "1 fvwm2")
# (find-man "1 fvwm24_convert")
# (find-man "1 fvwmbug")
# (find-man "1 fvwmrc_convert")
# (find-man "1 xpmroot")
# (find-man "1x setup-background")



#
# (eeb-fvwm)
# (find-fvwmhelp "Pick [(conditions)] command")
# (find-fvwmhelp "Style stylename options")
# (find-fvwmhelp "Recapture")
# Style emacs NoTitle, BorderWidth 12
Style emacs NoTitle, FvwmBorder

#
Style emacs Title, BorderWidth 32

#
# (eeb-fvwm)
Pick WindowStyle NoTitle
#
Pick WindowStyle Title
#
Pick WindowStyle !Title
#
Pick WindowStyle BorderWidth 20
#
Pick WindowStyle NoBorder
#
Recapture
#
# (eeb-fvwm)
# (find-angg ".fvwm/edrx.fvwm")
# (find-man "fvwm")
# (find-man "fvwm" "Modifiers is any combination")
Key F12 A C  Echo Mod4
Key F12 A S  Echo Shift
Key F12 A M  Echo Meta
Key F12 A L  Echo CapsLock
Key F12 A A  Echo Alt

#
Key F12 A 1  Echo Mod1   # left or right alt key
Key F12 A 2  Echo Mod2
Key F12 A 3  Echo Mod3
Key F12 A 4  Echo Mod4   # left or right windows key
Key F12 A 5  Echo Mod5
Key F12 A 6  Echo Mod6
Key F12 A 7  Echo Mod7   # bad modifier
Key F12 A 8  Echo Mod8   # bad modifier; "\e[29~"; menu key

#





#####
#
# FvwmConsole in a terminal in Emacs
# 2012nov16
#
#####

# «FvwmConsole-in-emacs» (to ".FvwmConsole-in-emacs")
# (find-man "1 FvwmCommand")
# (find-man "1 FvwmConsole")

Idea: if I can run something like FvwmConsole in an arbitrary terminal
then I should be able to create an `eepitch-fwvm', like these things:

  (find-eev "eepitch.el" "eepitch-bash")

and then send commands to its REPL-ish interface interactively from
Emacs, like what is shown in this video here:

  http://www.youtube.com/watch?v=doeyn5MOaB8&t=43m20s
  (find-angg "eev-videos/README")
  (find-eev2introvideo "43:20" "shell and python")

It is easy to do - as a simple hack - something much more primitive
than an FvwmConsole, by improvising a REPL and using FvwmCommand to
execute each line of input given in it... but how to make it handle
cleanly multi-line commands like these?

  # (find-angg ".fvwm/.fvwm2rc" "KeyboardMenu")
  DestroyMenu KeyboardMenu
  AddToMenu KeyboardMenu "Mod4-K: Keyboard" Title
  + "xset mouse 0 0"     Exec exec xset mouse 0 0
  + "xset mouse default" Exec exec xset mouse default
  + "mysetxkb us"        Exec exec mysetxkb us
  + "mysetxkb us_intl"   Exec exec mysetxkb us_intl
  + "mysetxkb abnt2"     Exec exec mysetxkb abnt2
  + "mysetxkb xkbprint"  Exec exec mysetxkb xkbprint

and would that give me all the niceties of FvwmConsole?...




 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
fvwmfile = ee_expand "~/.eev/ee.fvwm"
fvwmsave = function (str) writefile(fvwmfile, str) end
fvwmrun0 = function ()
    return getoutput("cat "..fvwmfile.." | FvwmCommand -i 1 -c")
  end
f = function (str) fvwmsave(str); print(fvwmrun0()) end

f [[ CursorMove +0 +100 ]]
f [[ badCursorMove +0 +100 ]]


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
echo 'BadCommand' | FvwmCommand -i 0 -c
echo 'BadCommand' | FvwmCommand -i 1 -c
tail ~/.xsession-errors
# (find-fline "~/.xsession-errors")

# (find-fline "~/LOGS/2012nov16.fvwm")



# (find-fvwmfile "modules/")
# (find-sh "locate FvwmConsole")
# (find-fline "~/.fvwm/.FvwmConsole-History")
# (find-fline "/usr/lib/fvwm/2.5.30/FvwmConsole")
# (find-fline "/usr/lib/fvwm/2.5.30/FvwmConsoleC")
# (find-fline "/usr/lib/fvwm/2.5.30/FvwmConsoleC.pl")
# (find-udfile "fvwm/html/modules/FvwmConsole.html")
# (find-man "1 FvwmConsole")
# (find-man "1 FvwmConsoleC.pl")











#####
#
# debian menus (on Sarge)
# 2004aug17
#
#####

# (find-status "menu")
# (find-vldifile "menu.list")
# (find-fline "/usr/share/doc/menu/")
# (find-fline "/usr/share/doc/menu/menu.txt.gz")

sudo update-menus -v
sudo update-menus --stdout
sudo update-menus --stdout > /tmp/fvwmmenus

sudo update-menus -v
update-menus[2863]: Dpkg is not locking dpkg status area, good.
update-menus[2863]: Reading installed packages list...
update-menus[2863]: Reading menu-entry files in /etc/menu/.
update-menus[2863]: 0 menu entries found (0 total).
update-menus[2863]: Reading menu-entry files in /usr/lib/menu/.
update-menus[2863]: 229 menu entries found (229 total).
update-menus[2863]: Reading menu-entry files in /usr/share/menu/.
update-menus[2863]: 0 menu entries found (229 total).
update-menus[2863]: Reading menu-entry files in /usr/share/menu/default/.
update-menus[2863]: 3 menu entries found (232 total).
update-menus[2863]: Running menu-methods in /etc/menu-methods/.
update-menus[2863]: Running method: /etc/menu-methods/twm
update-menus[2863]: Running method: /etc/menu-methods/fvwm

# (find-man "1 update-menus")
# (find-man "1 update-menus" "\nFILES")
# (find-fline "~/.menu/")
# (find-fline "/etc/menu/")
# (find-fline "/usr/lib/menu/")
# (find-fline "/usr/share/menu/default/")

# (find-fline "/etc/menu-methods/")
# (find-fline "/etc/menu-methods/fvwm")

#   Read /etc/X11/fvwm/menudefs.hook
#   Popup /Debian
# (find-fline "/usr/share/doc/fvwm/sample.fvwmrc/manoj/menudefs.hook.gz")


# (find-man "1 install-menu")
# (find-man "5 menufile")

# (find-man "5 menufile")
# (find-fline "/usr/share/doc/menu/examples/system.fvwm2rc.gz")
# (find-fline "/etc/X11/fvwm/")



# (find-status "fvwm")
# (find-vldifile "fvwm.list")
# (find-fline "/usr/doc/fvwm/")

sudo update-menus -v




#####
#
# fwvm-menu-directory
# 2004aug29
#
#####

# «fwvm-menu-directory»  (to ".fwvm-menu-directory")
# (find-man "1 fvwm" "MissingSubmenuFunction")
# (find-man "1 fvwm-menu-directory")
# (find-fline "/usr/bin/fvwm-menu-directory")
# http://www.zensites.net/fvwm/guide/advanced_menu.html
# (find-angg ".zshrc" "strace")
# (find-fline "/etc/menu-methods/")
# (find-fline "/etc/menu-methods/README")
# (find-fline "/usr/share/doc/menu/html/")
# file:///usr/share/doc/menu/html/ch3.html#s3.1
# (find-fline "/usr/share/menu/")
# (find-fline "/usr/lib/menu/")
# (find-fline "/etc/menu/")
# (find-fline "~/.menu/")
# (find-sh "locate menudefs")
# (find-fline "/sda1/old-usr/share/doc/fvwm/examples/manoj/menudefs.hook.gz")

# (find-status   "menu")
# (find-vldifile "menu.list")
# (find-udfile   "menu/")
# (find-fline "/etc/menu/README")
# (find-fline "/usr/share/menu/")
# (find-fline "/etc/X11/")

# (find-sh "locate fvwm")
# (find-fvwm3file "bin/" "fvwm-menu")

sudo update-menus

Read /etc/X11/fvwm/menudefs.hook

# (find-sh "locate menudefs")
# (find-fline "/sda1/old-usr/share/doc/fvwm/examples/manoj/menudefs.hook.gz")



# (find-man "update-menus")
# (eev "sudo update-menus -v")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
alias strace-to='strace -f -etrace=open,stat,fork,_exit,execve,wait4,chdir -o'
alias strace-to='strace -f -etrace=open,stat,fork,execve,wait4,chdir -o'

strace-to /tmp/s update-menus -v

# (find-fline "/tmp/s")
# (find-progoutput "sort /tmp/s | uniq")
#
# (find-fline "/etc/X11/fvwm/menudefs.hook")
# (find-fline "menudefs.hook")
# (find-fline "main-menu.hook")

# file:///usr/share/doc/menu/html/index.html
# file:///usr/share/doc/menu/html/ch2.html
# (find-fline "/etc/menu-methods/fvwm")
# (find-fline "/etc/menu-methods/")


# (find-man "1 fvwm-menu-directory" "+ I PipeRead")
#
AddToFunc FuncFvwmMenuDirectory
+ I PipeRead "fvwm-menu-directory -d '$0'"




# (find-status   "fvwm")
# (find-vldifile "fvwm.list")
# (find-udfile   "fvwm/")

# (find-udfile "fvwm/sample.fvwmrc/system.fvwm2rc-sample-1.gz")
# (find-udfile "fvwm/sample.fvwmrc/system.fvwm2rc-sample-2.gz")
# (find-udfile "fvwm/sample.fvwmrc/system.fvwm2rc.gz")



zcat /usr/share/doc/menu/examples/system.fvwm2rc.gz > /tmp/lw.fvwm2rc
fvwm -replace -f /tmp/lw.fvwm2rc -f edrx.fvwm

# (find-fvwmfile "fvwm/events.c" "_cdim")



# (find-angg ".fvwm/")
# (find-angg ".fvwm/edrx.fvwm" "restart-pager")
#
# (ee-once (eeb-fvwm))
KillModule FvwmPager
# Style "FvwmPager"   Sticky, StaysOnTop, Handles, HandleWidth 5
Style "FvwmPager"   Sticky, StaysOnBottom, Handles, HandleWidth 5
Module FvwmPager

#
# (ee-once (eeb-fvwm))
KillModule FvwmPager
Style "FvwmPager" StaysOnBottom
Module FvwmPager

#
# (ee-once (eeb-fvwm))

DestroyFunc PagerToBottom
AddToFunc   PagerToBottom
+ "I" KillModule FvwmPager
+ "I" Style "FvwmPager" StaysOnBottom
+ "I" Module FvwmPager

DestroyFunc PagerToTop
AddToFunc   PagerToTop
+ "I" KillModule FvwmPager
+ "I" Style "FvwmPager" StaysOnTop
+ "I" Module FvwmPager

Key p  A   4 PagerToBottom
Key p  A  S4 PagerToTop

#


# (find-angg ".fvwm/edrx.fvwm" "ee")
# (find-angg ".fvwm/edrx.fvwm" "restart-pager")
# (find-anggfile ".fvwm/" "ee.fvwm")



# (find-eev "eev-langs.el")
# (find-man "1 fvwm" "\nCOMMAND EXPANSION\n")
# (find-man "1 fvwm" "\n       Borders\n")



#####
#
# removing the borders and title bar
# 2004dec30
#
#####

# «no-borders»  (to ".no-borders")
# (find-fvwmhelp "       Current [(conditions)] command")
# (find-fvwmhelp "Key [(window)] Keyname Context Modifiers Function")
# (find-angg ".fvwm/")
# (find-angg ".fvwm/edrx-system.fvwm")
# (find-angg ".fvwm/edrx.fvwm")
#
# (eeb-fvwm0)
Key f  A  4 WindowStyle Title, Borders
Key g  A  4 WindowStyle NoTitle, !Borders
#
# (eeb-fvwm0)
Current WindowStyle NoTitle, !Borders
NoPager
#
# (eeb-fvwm0)
Current WindowStyle Title, Borders
PagerOnBottom
#




#####
#
# waddletron2k's xterm-256color problem
# 2006sep04
#
#####

# «exec-xterm-256color»  (to ".exec-xterm-256color")
#
# (eeb-fvwm0)
# (find-efunction 'eeb-fvwm0)
# (find-anggfile ".fvwm/nokeys.fvwm")
# (find-anggfile ".fvwm/keys.fvwm")

DestroyMenu Waddletron
AddToMenu Waddletron "Waddletron xterm stuff" Title
+ "Exec"         Exec      xterm -tn xterm-256color
+ "Exec exec"    Exec exec xterm -tn xterm-256color
 
Key w   A   4 Popup Waddletron

#



#####
#
# Style
# 2022jan11
#
#####

# «Style»  (to ".Style")
# (find-fvwm3file "doc/fvwm3styles.txt" "DestroyStyle style")
# (find-fvwm3file "doc/fvwm3styles.txt" "Style stylename options ...")
# (find-fvwm3stylespage 2               "Style stylename options ...")
# (find-fvwm3stylestext 2               "Style stylename options ...")
# (find-fvwm3file "doc/fvwm3styles.txt" "Color takes two arguments")
# (find-fvwmdoc-links "MenuStyle")
# (find-fvwmdoc-links "ButtonStyle")
# (find-fvwmdoc-links "AddButtonStyle")
# (find-fvwm3file "doc/fvwm3styles.txt" "AddButtonStyle button [state] [style] flag ...]")
# (find-fvwm3file "doc/fvwm3styles.txt"  "\nButtonStyle button [state] [style] flag ...]")
# (find-fvwm3file "doc/fvwm3menus.txt"       "MenuStyle stylename [options]")

https://fvwmforums.org/t/fvwm2rc-20130814/2246




#####
#
# style: bare
# 2006sep05
#
#####

# «style:bare»  (to ".style:bare")
# (find-angg ".fvwm/.fvwm2rc" "style-bare")
# (find-angg ".fvwm/nokeys.fvwm" "style-bare")
# (find-angg "ICON/tron.icn")
# (find-anggfile "LOGS/2006sep05.fvwm")
# (find-anggfile "LOGS/2006sep05.fvwm" "<thomas_adam> Style bare !Title,")
# (find-man "X" "-xrm resourcestring")
# http://linuxgazette.net/127/adam1.html
# http://linuxgazette.net/127/adam.html
# Problem: I don't know how to pass "-class Bare" to Icon programs yet.

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xterm &
xterm -class Bare &
xterm -class Bare -bg yellow -fg red &
xterm -class Bare -bg tan1 -fg red3 &
xterm -class Bare -bg yellow -fg red3 &
xterm -class Bare -bg lightyellow -fg red3 &
xterm -class Bare -bg '#fbf352' -fg red3 &

function setmsg () {
  echo '#!/bin/sh' > /tmp/msg
  cat             >> /tmp/msg
  chmod 777          /tmp/msg
}
setmsg <<'%%%'
  echo Foo bar
  sleep 2
%%%
xterm -class Bare -bg yellow -fg red3 -e /tmp/msg &


#
# (eeb-fvwm0)
# (find-angg ".fvwm/keys.fvwm")
# (find-angg ".fvwm/nokeys.fvwm")
# (find-angg ".fvwm/nokeys.fvwm" "window-styles")

Style bare       !Title, !Borders
Style baremanual UseStyle bare, ManualPlacement
Style Bare       !Title, !Borders
Style BareManual UseStyle Bare, ManualPlacement

#
 (eepitch-shell)
xterm -class Bare &
xterm -class BareManual &
xterm -class Baremanual &
xterm &





#####
#
# PrintScreen calling gnudoit
# 2006oct16
#
#####

# «gnudoit»  (to ".gnudoit")
# (find-es "emacs" "gnuserv")







#####
#
# strokes (from nibtip)
# 2005apr21
#
#####

#Mouse Strokes
Stroke 32147   0 A	N	Exec exec firefox
Stroke 3574159 0 A	N	Exec exec xterm -fg white -bg black
Stroke 14789   0 A  N   Exec exec anjuta

# C for Close
Stroke 3214789 0 A  N   Close

#Down-Right to Iconify
Stroke 357     0 A  N   Iconify
Stroke 32547   0 A  N   Iconify
Stroke 36587   0 A  N   Iconify
Stroke 3657    0 A  N   Iconify
Stroke 3547    0 A  N   Iconify





#####
#
# when NumLock is on clicking on another window doesn't change focus
# 2007jan14
#
#####

# «numlock»  (to ".numlock")
# (find-es "x" "no-capslock")
# (find-angg ".fvwm/.fvwm2rc" "numlock")
# (find-angg ".fvwm/keys.fvwm" "numlock")
# (find-status   "fvwm")
# (find-vldifile "fvwm.list")
# (find-udfile   "fvwm/")
# (find-udfile   "fvwm/docs/")
# (find-udfile   "fvwm/docs/FAQ.gz")
# (find-udfile   "fvwm/docs/FAQ.gz" "NumLock, CapsLock or ScrollLock key is pressed")
# (find-udfile   "fvwm/docs/FAQ.gz" "IgnoreModifiers L25")

# (find-fvwmhelp "IgnoreModifiers [Modifiers]")

(find-fvwm0 "IgnoreModifiers L25")






#####
#
# fvwm-2.5.18 on NetBSD
# 2007dec28
#
#####

# «fvwm-netbsd»  (to ".fvwm-netbsd")
# (find-angg ".zshrc" "fvwm-netbsd")
# http://ftp.de.debian.org/debian/pool/main/f/fvwm/fvwm_2.5.18.orig.tar.gz
#
rm -Rv ~/usrc/fvwm-2.5.18/
tar -C ~/usrc/ -xvzf \
  $S/http/ftp.de.debian.org/debian/pool/main/f/fvwm/fvwm_2.5.18.orig.tar.gz
cd     ~/usrc/fvwm-2.5.18/

mkdir usr/
./configure --prefix=$PWD/usr/ |& tee oc
make                           |& tee om
make install                   |& tee omi

#
# (code-c-d "fvwm" "~/usrc/fvwm-2.5.18/")
# (code-c-d "fvwm" "~/usrc/fvwm-2.5.18/" :woman)
# (find-fvwmfile "")
# (find-fvwmfile "INSTALL" "`--prefix=PATH'")
# (find-fvwmsh "find usr | sort")
# (find-fvwmsh "find * | sort")
# (find-fvwmsh "find * | sort | grep -i module")
# (find-fvwmfile "fvwm/fvwm.1")
# (find-fvwmwoman "fvwm/fvwm.1" "FVWM_MODULEDIR")
# (find-fvwmwoman "fvwm/fvwm.1" "ModulePath path")
# (find-fvwmfile "")
# (find-fvwmfile "usr/bin/")
# (find-fvwmsh "find * | grep Comm")

 (eepitch-shell)
cd ~/bin/
ln -sf ../usrc/fvwm-2.5.18/usr/bin/FvwmCommand .
ln -sf ../usrc/fvwm-2.5.18/usr/bin/fvwm .
ln -sf fvwm-netbsd fvwm
# (find-angg "bin/fvwm-netbsd")
# (find-angg ".zshrc" "fvwm-netbsd")

 (eepitch-shell)
cd ~/bin/
cat > fvwm-netbsd <<'%%%'
#!/bin/sh
# (find-es  "fvwm"    "fvwm-netbsd")
# (find-angg ".zshrc" "fvwm-netbsd")
FVWM_MODULEDIR=$HOME/usrc/fvwm-2.5.18/usr/libexec/fvwm/2.5.18 \
 LD_LIBRARY_PATH=/usr/X11R6/lib \
   exec ~/usrc/fvwm-2.5.18/fvwm/fvwm $*
%%%
chmod 755 fvwm-netbsd

# (find-fline "~/bin/")
# (find-fline "~/bin/fvwm-netbsd")
# (find-angg ".zshrc" "fvwm-replace")





#####
#
# .fvwm2rc7
# 2007dec28
#
#####

# «fvwm2rc7»  (to ".fvwm2rc7")
# (find-angg ".fvwm/")
# (find-angg ".fvwm/.fvwm2rc")
# (find-angg ".fvwm/withkeys.fvwm")
# (find-angg ".fvwm/nokeys.fvwm")
# (find-angg ".fvwm/keys.fvwm")
# (find-angg ".fvwm/.fvwm2rc7")

# -*- mode: fvwm-generic; coding: raw-text-unix -*-
# (progn (require 'generic-x) (fvwm-generic-mode) (font-lock-mode 1))
# (find-angg ".fvwm/.fvwm2rc")
# (find-angg ".fvwm/.fvwm2rc0")
# (find-angg ".fvwm/.fvwm2rc1")
# This file:
# (find-angg ".fvwm/.fvwm2rc7")
# (find-angg ".zshrc" "fvwm-replace")
# (eev "fvwm-replace 7")
# (find-sh "cat nokeys.fvwm")
# (find-sh "cat keys.fvwm")
# (find-sh "cat nokeys.fvwm keys.fvwm")
# (insert (find-sh00 "cat nokeys.fvwm keys.fvwm"))

# (find-sh0 "fvwm -replace -f ~/.fvwm/.fvwm2rc")

# Old notes:
# (eev "fvwm-replace 7")
# (eev "fvwm -replace -f ~/.fvwm/.fvwm2rc7 &")

;; (find-angg "bin/mysetxkb")
;; (find-sh "~/bin/mysetxkb us")

;; Tests:
;; (find-fvwm0 "KillModule FvwmPager")
;; (find-fvwm0 "Module FvwmPager")
;; (find-fvwm0 "Key F1 A M    Popup Window-Ops")
;; (find-fvwm0 "Key F2 A M    Popup KeyboardMenu")
;; (find-fvwm0 "Key F4 A M    Popup /Debian")

;; (find-fvwm0 "Key F5 A M WindowStyle NoTitle, !Borders # no borders")
;; (find-fvwm0 "Key F6 A M WindowStyle Title, Borders    # borders")
;; (find-fvwm0 "Key F7 A M Maximize   0 100  # maximize vertically (toggle)")
;; (find-fvwm0 "Key F8 A M Maximize 100 100  # maximize both ways (toggle)")
;; (global-set-key (kbd "C-M-s") 'toggle-scroll-bar)
;; (global-set-key (kbd "C-M-d") 'display-time-mode)
;; (find-sh "~/bin/mysetxkb us")




#####
#
# menus with hot-keys
# 2008may31
#
#####

# «menus-with-hot-keys»  (to ".menus-with-hot-keys")
# (find-angg ".fvwm/.fvwm2rc" "Mod4Menu")
# (find-fvwmhelp "AddToMenu menu-name [menu-label action]")
# (find-fvwmhelp "AddToMenu menu-name [menu-label action]" "&")
# (find-eev "eev-langs.el" "fvwm")
# (find-angg ".fvwm/.fvwm2rc")
# (find-angg ".fvwm/.fvwm2rc" "4-v,h,b")
#
# (eefvwm0-bounded)

DestroyMenu Mod4Menu
AddToMenu   Mod4Menu "Mod4-keys" Title
+ "4-&v: maximize vertically (toggle)"   Maximize 0 100
+ "4-&h: maximize horizontally (toggle)" Maximize 100 0
+ "4-&b: maximize both ways (toggle)"    Maximize 100 100
+ "4-&f: full (no borders or title bar)" WindowStyle NoTitle, !Borders
+ "4-&g: put back borders and title bar" WindowStyle Title, Borders
+ "" Nop
+ "4-&k: KeyboardMenu"                   Popup KeyboardMenu
+ "4-&u: UnclutterMenu"                  Popup UnclutterMenu

# Meta-F1, anywhere
Key F1    A    M    Popup Mod4Menu

#




#####
#
# Fvwm one Gnome: starting as default wm
# 2010aug08
#
#####

# «fvwm-gnome-wm»  (to ".fvwm-gnome-wm")
# (find-es "gnome" "saving-sessions")
# (find-man "1 gnome-wm")
# (find-man "1 gnome-wm" "WINDOW_MANAGER environment variable")
# http://ubuntuforums.org/archive/index.php/t-463928.html
# http://doc.gwos.org/index.php/Xfwm4

# (find-fline "~/.gnomerc")
export WINDOW_MANAGER=/usr/bin/fvwm

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
gconf-editor &
# /desktop/gnome/session/required_components/filemanager
# /desktop/gnome/session/required_components/panel
# /desktop/gnome/session/required_components/windowmanager

# http://linuxgazette.net/100/adam.html
#   killall [wm] && sleep 5s && fvwm &

# http://linuxgazette.net/104/tag/4.html
# http://linuxidx.com/linux.php?q=Fvwm





#####
#
# xinerama
# 2011dec25
#
#####

# «xinerama»  (to ".xinerama")
# (find-fvwmhelp "XINERAMA SUPPORT")
# http://www.fvwm.org/doc/unstable/commands/Xinerama.html
# http://www.fvwm.org/doc/unstable/commands/XineramaPrimaryScreen.html
# http://fvwmforums.org/phpBB3/viewtopic.php?f=33&t=2758

# (find-fvwmhelp "Xinerama [bool]")
# (find-fvwmhelp "XineramaPrimaryScreen [primary-screen]")
# (find-fvwmhelp "XineramaSls [bool]")
# (find-fvwmhelp "XineramaSlsSize Horizontal Vertical")
# (find-fvwmhelp "XineramaSlsScreens number-of-screens [screen-spec ...]")

# (find-sh "fvwm -V" "Xinerama")
# (find-fvwm0 "Xinerama on")

# http://wiki.linuxquestions.org/wiki/Using_multiple_monitors_with_XFree86
# http://sourceforge.net/projects/xinerama/




#####
#
# Schedule (to remove borders and maximize with a single key)
# 2012mar12
#
#####

# «schedule»  (to ".schedule")
# (find-angg ".fvwm/.fvwm2rc" "no-super-key")
# (find-man "1 fvwm" "Schedule [Periodic] delay_ms [command_id] command")




#####
#
# Knuth's .fvwm2rc
# 2012mar27
#
#####

# «knuths-fvwm2rc»  (to ".knuths-fvwm2rc")
# http://www-cs-faculty.stanford.edu/~uno/programs.html
# http://www-cs-faculty.stanford.edu/~uno/programs/.fvwm2rc





#####
#
# A full-screen mplayer should not use manual placement
# 2012sep15
#
#####

# «fullscreen»  (to ".fullscreen")
# (find-angg ".fvwm/.fvwm2rc" "style-fullscreen")
# (find-man "1 fvwm" "-r | --replace")
# (find-man "1 fvwm" "     Window Manager placement")

(setq ee-mplayer-options '("-fs" "-title" "mplayer-fullscreen" "-osdlevel" "2"))
(setq ee-mplayer-options '("-fs"                               "-osdlevel" "2"))

<ruskie> edrx, you could just exclude it from manual placement?
<edrx> ruskie: how do I do that? 8-|
<ruskie> set a different placement model for mplayer
<ruskie> Style urxvt PositionPlacement UnderMouse, MiniIcon
         term.png, Icon term.png <-- example I use that for urxvt
<ruskie> while everything else is set to: Style *
         MinOverlapPercentPlacement




#####
#
# resize
# 2012nov03
#
#####

# «resize» (to ".resize")
# (find-angg ".fvwm/.fvwm2rc")
# (find-angg ".fvwm/.fvwm2rc" "window-ops-menu")
# (find-angg ".fvwm/.fvwm2rc" "window-ops-menu" "Mod4-F8:  Resize")
# (find-man "1 fvwm")
# (find-man "1 fvwm" "DestroyMenu MenuFvwmWindowOps")
# (find-man "1 fvwm" "DestroyMenu MenuFvwmWindowOps" "  Resize")
# (find-man "1 fvwm" "Current [(conditions)] command")
# (find-man "1 fvwm" "Resize [[frame]")
# (find-man "1 fvwm" "Resize [[frame]" "NorthWest")

# Use this
# ========
# Use with: (find-eval-intro "`M-e'")
# width--:  (find-sh0 "FvwmCommand 'Current Resize w-1c keep'")
# width++:  (find-sh0 "FvwmCommand 'Current Resize w+1c keep'")
# height--: (find-sh0 "FvwmCommand 'Current Resize keep w-1c'")
# height++: (find-sh0 "FvwmCommand 'Current Resize keep w+1c'")

# (find-angg ".fvwm/.fvwm2rc")
# (find-angg "eev-videos/0.sh")




#####
#
# fvwm-lua
# 2014sep17
#
#####

# «fvwm-lua» (to ".fvwm-lua")
# http://box-look.org/content/show.php?content=127229
# http://box-look.org/CONTENT/content-files/127229-fvwm-lua-0.4.tar.gz
# (find-angg ".emacs" "auto-mode-alist")
# (add-to-alist 'auto-mode-alist '("\\.fvwm2rc$" . fvwm-generic-mode))

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
#
rm -Rv ~/usrc/fvwm-lua-0.4/
tar -C ~/usrc/ -xvzf \
  /home/edrx/snarf/http/box-look.org/CONTENT/content-files/127229-fvwm-lua-0.4.tar.gz
cd     ~/usrc/fvwm-lua-0.4/

#
# (code-c-d "fvwmlua"   "~/usrc/fvwm-lua-0.4/")
# (code-c-d "fvwmluaw"  "~/usrc/fvwm-lua-0.4/widgets/")
# (code-c-d "fvwmluawc" "~/usrc/fvwm-lua-0.4/widgets/configs/")
# (find-fvwmluafile "")
# (find-fvwmluawcfile "examples-complete.fvwm2rc")

# (find-fvwmluawcfile "examples-complete.fvwm2rc")





#####
#
# fvwm-edrx
# 2014oct09
#
#####

# «fvwm-edrx» (to ".fvwm-edrx")
# (find-man "fvwm")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -v ~/.fvwm/.fvwm2rc.edrx
wget -O ~/.fvwm/.fvwm2rc.edrx http://angg.twu.net/.fvwm/.fvwm2rc
fvwm --replace -f ~/.fvwm/.fvwm2rc.edrx &
rm -v ~/.fvwm/.fvwm2rc.edrx


fvwm --replace


config-command
           Causes fvwm to use config-command instead of 'Read config' (or 'Read
           .fvwm2rc') as its initialization command.  (Note that up to 10 -f and




#####
#
# Alternating between fvwm and xfce4
# 2020sep20
#
#####

# «fvwm-xfce4»  (to ".fvwm-xfce4")
# (find-es "xfce" "xfc4e-session")
# (find-zsh "installeddebs | sort | grep fvwm")
# (find-zsh "availabledebs | sort | grep fvwm")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti fvwm
fvwm-replace

# (find-angg ".fvwm/.fvwm2rc")

# (find-sh "ps ax")
# (find-sh "pstree")




#####
#
# FvwmCommand
# 2022jan07
#
#####

# «FvwmCommand»  (to ".FvwmCommand")
# (find-angg ".fvwm/.fvwm2rc" "FvwmCommand")
# (find-fvwm3file "")
# (find-fvwm3sh "find * | sort")
# (find-fvwm3sh "find * | sort | grep FvwmCommand")
# (find-fvwm3sh "find * | sort | grep FvwmMFL")
# (find-fvwm3sh "find * | sort | grep FvwmPrompt")
# (find-fvwm3file "bin/" "FvwmCommand")
# (find-fvwm3file "bin/FvwmCommand")
# (find-fvwm3file "modules/FvwmMFL/")
# (find-fvwm3file "modules/FvwmMFL/FvwmCommandS")
# (find-fvwm3file "modules/FvwmMFL/FvwmMFL.c")
# (find-fvwm3grep "grep --color=auto -nRH --null -e FVWMMFL_SOCKET *")

# (find-man "1 FvwmMFL")
# (find-man "1 FvwmMFL" "$TMPDIR/fvwm_mfl.sock")
# (find-fline "/tmp/" "fvwm_mfl.sock")
# (find-man "1 FvwmCommand")
# (find-man "1 FvwmPrompt")
doc/FvwmCommand.adoc

https://www.fvwm.org/Wiki/Modules/FvwmCommandS/
https://www.fvwm.org/Wiki/Modules/FvwmCommandS/





#####
#
# asciidoctor
# 2022jan08
#
#####

# «asciidoctor»  (to ".asciidoctor")
# (find-es "asciidoc" "asciidoctor")

# (find-fvwm3sh "find * | sort | grep adoc")
# (find-fvwm3file "doc/fvwm3.adoc")
# (find-fvwm3file "doc/fvwm3_manpage_source.adoc")
# (find-fvwm3file "doc/fvwm3all.adoc")
# (find-fvwm3file "om")
# (find-fvwm3file "om" ".adoc")
# (find-fvwm3file "doc/Makefile")
# (find-fvwm3file "doc/Makefile" "%.1: %.adoc")
# (find-fvwm3file "doc/Makefile.am")

# (find-fline "~/usrc/fvwm3/doc/")
# (find-sh "asciidoctor")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/usrc/fvwm3/doc/
  "asciidoctor" -b manpage -a "fvwm3" "fvwm3.adoc" -o "fvwm3.1"
  "asciidoctor"            -a "fvwm3" "fvwm3.adoc" -o "fvwm3.html"
  "asciidoctor" -b pdf     -a "fvwm3" "fvwm3.adoc" -o "fvwm3.tex"
asciidoctor-pdf            -a "fvwm3" "fvwm3.adoc" -o "fvwm3.pdf"
asciidoctor-pdf            -a "fvwm3" "fvwm3all.adoc" -o "fvwm3all.pdf"

# (find-man "1 fvwm3")



#####
#
# forum-post-2022jan07
# 2022jan07
#
#####

# «forum-post-2022jan07»  (to ".forum-post-2022jan07")
# https://fvwmforums.org/top?period=yearly
# https://fvwmforums.org/t/fvwmcommand-fails-with-cannot-find-fvwmmfl-socket-none/3632/1
# FvwmCommand fails with "Cannot find FvwmMFL socket None"

Hi all,

I spent several years being forced to use only other window managers,
and I am returning to Fvwm now... but I am not being able to make
FvwmCommand work. Hints, please?

I am on Debian 11 and I downloaded and compiled Fvwm3 from the git
repository yesterday. Here is a minimal working example - with a
~/.fvwm/config that is just 3 lines long - that shows the bug. If I
execute this in a terminal in a plain X session created with "xinit --
:1.0",

  killall fvwm3
  sudo ps ax | grep -i fvwm
  ls -lAF /tmp/fvwm*
  cat ~/.fvwm/config
  fvwm3 &
  sudo ps ax | grep -i fvwm
  ls -lAF /tmp/fvwm*
  FvwmCommand 'CursorMove +5 +2'

I get this log:

  $ killall fvwm3
  fvwm3: no process found
  $ sudo ps ax | grep -i fvwm
   155512 pts/5    SN+    0:00 grep -i fvwm
  $ ls -lAF /tmp/fvwm*
  ls: cannot access '/tmp/fvwm*': No such file or directory
  $ cat ~/.fvwm/config
  DestroyFunc StartFunction
  AddToFunc   StartFunction
   + I Module FvwmMFL
  $ fvwm3 &
  $ loaded [0]: /home/edrx/.fvwm/config
  sudo ps ax | grep -i fvwm
   155516 pts/5    SN     0:00 fvwm3
   155517 pts/5    SN     0:00 /usr/local/libexec/fvwm3/1.0.5/FvwmMFL 7 4 none 0 8
   155519 pts/5    SN+    0:00 grep -i fvwm
  $ ls -lAF /tmp/fvwm*
  srwxrwx--- 1 edrx edrx 0 Jan  7 15:08 /tmp/fvwm_mfl.sock=
  $ FvwmCommand 'CursorMove +5 +2'
  Cannot find FvwmMFL socket None.
  Please start FvwmMFL module from your fvwm configuration.
  $ 

I ran the shell inside Emacs to be able to use the trick described in
these slides to send the commands one by one:

  http://angg.twu.net/LATEX/2021emacsconf.pdf

In that shell I have TERM=dumb and DISPLAY=:1.0.

Thanks in advance!
  Eduardo Ochs
  http://angg.twu.net/#eev








gnome-session-save
gnome-session

# (find-man "1 gnome-session-save")
# (find-man "1 gnome-session")
# (find-fline "~/.config/gnome-session/saved-session/")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
w fvwm
xwininfo
# xwininfo: Window id: 0x2000020 "x-nautilus-desktop"
# xwininfo: Window id: 0x2200003 "Bottom Expanded Edge Panel"
# xwininfo: Window id: 0x2200049 "Top Expanded Edge Panel"

# (find-man "fvwm" "EXTENDED WINDOW MANAGER HINTS")



After some searching, I found the gconf entry
/desktop/gnome/session/required_components/windowmanager, which
pointed to gnome-wm on my system. That scripts contains the following
comment:

# NOTE: DON'T USE THIS. Please have your window manager install
# a desktop file and change the gconf key
# /desktop/gnome/session/required_components/windowmanager

Setting the windowmanager key in gconf-editor in fact fixed my
problem, and I now get metacity when logging into a Gnome session.
Shouldn't there be a entry in the System menu for doing this?

# (find-fline "~/.gconf/desktop/gnome/applications/window_manager/%gconf.xml")
# (find-fline "~/.gconf/system/networking/connections/1/connection/%gconf.xml")








# (find-vldifile "fvwm.list")
# (find-udfile "fvwm/html/commands/")

# (find-udfile "fvwm/README.gz")
# (find-udfile "fvwm/docs/ANNOUNCE.gz")
# (find-udfile "fvwm/docs/BUGS.gz")
# (find-udfile "fvwm/docs/COMMANDS.gz")
# (find-udfile "fvwm/docs/CONVENTIONS.gz")
# (find-udfile "fvwm/docs/ChangeLog.gz")
# (find-udfile "fvwm/docs/DEVELOPERS.gz")
# (find-udfile "fvwm/docs/FAQ.gz")
# (find-udfile "fvwm/docs/TODO")
# (find-udfile "fvwm/docs/error_codes.gz")
# (find-udfile "fvwm/docs/fvwm.lsm.gz")


# (find-man "1 fvwm-perllib")

fvwm-perllib man
fvwm-perllib man FVWM::Module
fvwm-perllib --help
fvwm-perllib --version


# (find-man "1 fvwm" "AutomaticHotkeys")
# (find-man "1 fvwm" "AddToMenu StartMenu@linux-menu.xpm@")
# (find-man "1 fvwm" "AddToMenu StartMenu@linux-menu.xpm@^blue^")
# (find-man "1 fvwm" "AddToMenu   MenuFvwmWindowOps")
# (find-man "1 fvwm" "hot-key")

https://www.fvwm.org/Wiki/Panels/SimpleButtons/
https://www.fvwm.org/Wiki/Panels/FvwmTaskBar/

https://fvwmforums.org/t/fvwm-configs-with-xfce/3735
https://github.com/NsCDE/NsCDE






#  Local Variables:
#  coding:               utf-8-unix
#  End:
