#######
#
# E-scripts for making games
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/games.e>
#           or at <http://angg.twu.net/e/games.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.cgoban»			(to "cgoban")
# «.xaster»			(to "xaster")
# «.xaster_yada»		(to "xaster_yada")
# «.stella»			(to "stella")
# «.stella_roms»		(to "stella_roms")
# «.mgt»			(to "mgt")
# «.historicalsource»		(to "historicalsource")
# «.frotz»			(to "frotz")
# «.Zork1»			(to "Zork1")
# «.malyon»			(to "malyon")
# «.inform»			(to "inform")
# «.ztools»			(to "ztools")
# «.gnugo2»			(to "gnugo2")
# «.gnu-go»			(to "gnu-go")
# «.xlife»			(to "xlife")
# «.pingus»			(to "pingus")
# «.thrust»			(to "thrust")
# «.sgt-puzzles»		(to "sgt-puzzles")
# «.sgt-puzzles-deb-src»	(to "sgt-puzzles-deb-src")
# «.robotfindskitten»		(to "robotfindskitten")
# «.xmame»			(to "xmame")
# «.stencyl»			(to "stencyl")
# «.passage»			(to "passage")
# «.infocom-graphics»		(to "infocom-graphics")
# «.notgames»			(to "notgames")
# «.qix»			(to "qix")






#####
#
# Go recorders/editors (slink): cgoban/mgt
# 99sep16
#
#####

# «cgoban»  (to ".cgoban")
# (find-es "games" "gnugo2")
# (find-vldifile "cgoban.list")
# (find-fline "/usr/doc/cgoban/")

apti cgoban

rm -Rv /tmp/go
mkdir  /tmp/go
cd     /tmp/go
unzip /snarf/http/www.geocities.com/Tokyo/Flats/3603/honinbo.zip
# (find-fline "/snarf/http/www.geocities.com/Tokyo/Flats/3603/honinbo.zip")

cd     /tmp/go
cgoban -edit Hon-45-1.sgf
cgoban -edit Hon-41-1.mgt

# «mgt»  (to ".mgt")
# "mgt" = "my Go teacher"?

# (find-vldifile "mgt.list")
# (find-fline "/usr/doc/mgt/")

# (find-fline "/usr/lib/games/mgt/Rules")
# (find-fline "/usr/lib/games/mgt/")
cgoban -edit /usr/lib/games/mgt/Rules
cgoban -edit /usr/lib/games/mgt/Sample.01
cgoban -edit /usr/lib/games/mgt/Sample.02






#####
#
# mess
#
#####

rm -Rv /usr/src/xmess-0.2b4.1/
cd /usr/src/
tar -xvzf /snarf/http/internetter.com/titan/mess/unix02b4.tgz
cd /usr/src/xmess-0.2b4.1/
# (find-fline "/usr/src/xmess-0.2b4.1/makefile.unix")
make -f makefile.unix DISPLAY_METHOD=svgalib




#####
#
# xaster-1.00
#
#####

cd /usr/src/
rm -Rv xaster-1.00
tar -xvzf /home/xaster-1.00.tar.gz
cd /usr/src/xaster-1.00/
echo '*/' >> plot.xwin.h
makedepend \
  alien.c asteroids.c control.c cordic.c debris.c extras.c game.c \
  ghost.c high.c input.c linefont.c main.c missile.c mlist.c plot.c \
  score.c shape.c ship.c sound.c sprite.c text.c updlist.c

make LIBS='-L/usr/X11/lib -lX11'




#####
#
# xaster-1.00
#
#####

# «xaster»  (to ".xaster")
#
cd /usr/src/
rm -Rv xaster-1.00
tar -xvzf ~/xaster-1.00.tar.gz
cd /usr/src/xaster-1.00/
echo '*/' >> plot.xwin.h
patch -p0 util.h <<'%%%'
90c90
< extern char *sys_errlist[];
---
> /* extern char *sys_errlist[]; */
%%%

makedepend \
  alien.c asteroids.c control.c cordic.c debris.c extras.c game.c \
  ghost.c high.c input.c linefont.c main.c missile.c mlist.c plot.c \
  score.c shape.c ship.c sound.c sprite.c text.c updlist.c

#sleep 1
#echo -n > .compilation-start
#sleep 1
#
make CFLAGS='-g -O6 -DXWINDOWS' LIBS='-L/usr/X11R6/lib -lX11' |& tee om
#
#find * -name '*.[ch]' -and -anewer .compilation-start > .files.ch.used

# (find-fline "/usr/src/xaster-1.00/")
# (find-fline "/usr/src/xaster-1.00/input.xwin.c")
# (find-fline "/usr/src/xaster-1.00/param.h" 31)
# (find-xastfile "ship.c" 197)

# The program is showing a nasty bug: "q" generally does not exit,
# just restarts. It bothered my so much I added the following line to
# my .fvwmrc, somewhere between `Popup "Utilities"' and `EndPopup':
#
# 	Exec    "Kill Asteroids" exec kill $(pidof asteroids) &
#
# (without the leading "#", of course).
#
# Without this you'll have to switch to a terminal and kill it
# manually.
#




#####
#
# debianizing xaster with yada
# 2001feb07
#
#####

# «xaster_yada»  (to ".xaster_yada")
#
rm -Rv /usr/src/xaster-1.00*
cd     /usr/src/
tar -xvzf ~/xaster-1.00.tar.gz
mv -v xaster-1.00 xaster-1.00.orig
tar -xvzf ~/xaster-1.00.tar.gz

cd     /usr/src/xaster-1.00/

echo '*/' >> plot.xwin.h
patch -p0 util.h <<'%%%'
90c90
< extern char *sys_errlist[];
---
> /* extern char *sys_errlist[]; */
%%%

mkdir debian/

cat > debian/packages <<'---'
Source: xaster
Section: games
Priority: optional
Maintainer: Eduardo Ochs <edrx@mat.puc-rio.br>
Standards-Version: 3.0.1
Home-Page: <URL:http://angg.twu.net/>
Description: Faithful Asteroids clone, written around 1990
Copyright: No copyright notice found - situation undefined
Major-Changes:
Build: sh
 make CFLAGS='-g -O6 -DXWINDOWS' LIBS='-L/usr/X11R6/lib -lX11'
Clean: sh
 #make distclean || true

Package: xaster
Architecture: any
Depends: [/usr/bin/*]
Description: Faithful Asteroids clone, written around 1990
Menu:
 ?package(xaster):needs=x11 section=Games/Arcade \
   title="asteroids (kill)" command="kill $(pidof asteroids)"
Install: sh
 # (find-fline "/usr/doc/yada/yada.txt.gz" "yada install")
 yada install -bin  asteroids
---

yada yada
debian/yada rebuild rules
# debian/rules binary		|& tee odrb
dpkg-buildpackage -us -uc	|& tee odbp

ar p /usr/src/xaster_1.00-1_i386.deb data.tar.gz | tar -tvzf -
(cd /usr/src/; laf -d xaster*)
#

dpkg -i /usr/src/xaster_1.00-1_i386.deb
# (find-status "xaster")
# (find-vldifile "xaster.list")
# (find-fline "/usr/doc/xaster/")

# (find-es "lua" "lua-packagesfile")
# (find-fline "/usr/src/xaster-1.00/debian/tmp-xaster/usr/lib/menu/xaster")









#####
#
# galaxis
#
#####

cd /usr/src/
rm -Rv galaxis-1.1
tar -xvzf /snarf/http/www.ccil.org/~esr/galaxis-1.1.tar.gz
cd galaxis-1.1



#####
#
# xscavenger 1.3
#
#####

cd /usr/src/
rm -Rv xscavenger-1.3/
tar -xvzf /snarf/http/www.geocities.com/TimesSquare/Arcade/4567/scavenger-13.tgz
cd /usr/src/xscavenger-1.3/src/
xmkmf
make




#####
#
# Stella 0.7
#
#####

cd /usr/src/
tar -xvzf /snarf/ftp/ftp.ncsu.edu/pub/eos/pub/bsvc/st/stella-0.7-src.tar.gz
cd /usr/src/stella-0.7/src/
make linux-i386-svga |& tee om

cd /usr/src/stella-0.7/
ln -s /snarf/http/www.general.uwa.edu.au/u/darrins/2600/ 2600
ln -s src/stella src/stella.vcs .

cd /usr/src/stella-0.7/
unzip -l 2600/'*.zip' | sort +3
unzip -oL 2600/ijk.zip Joust.bin
unzip -oL 2600/opq.zip Pengo.bin Popeye.bin 'Qb*.bin' Quickstp.bin
unzip -oL 2600/s.zip Spidrftr.bin

cd /usr/src/stella-0.7/
stella Spidrftr.bin

unzip /snarf/http/www.general.uwa.edu.au/u/darrins/2600/c.zip Cryscast.bin
stella Cryscast.bin




#####
#
# stella 0.7 (slink)
#
#####

mkdir -p /lib/modules/2.0.37/
cd /lib/modules/2.0.37/
cp -v /usr/src/linux-2.0/modules/*.o .
depmod *.o > modules.dep

apti svgalibg1-dev joystick


pdsc $SDEBIAN/dists/slink/non-free/source/otherosfs/stella_0.7-2.dsc
cd /usr/src/stella-0.7/
debian/rules CXX=g++ binary	|& tee odrb

cd /usr/src/
mv -v stella*deb .debs/

apt-update
apti stella

# (find-vldifile "stella.list")
# (find-fline "/usr/doc/stella/")
# (find-fline "/usr/src/stella-0.7/")





#######
#
# Stella 1.0
#
#######

rm -Rv /usr/src/stella-1.0/
cd /usr/src/
tar -xvzf $S/ftp/ftp.eos.ncsu.edu/pub/bsvc/stella/1.0/stella-1.0-src.tar.gz
cd /usr/src/stella-1.0/src/
cd /usr/src/stella-1.0/src/build/
make CXX=g++ linux-x	|& tee ../../om

cd /usr/src/stella-1.0/src/build/
xstella /tmp/stella/mnr2049r.bin

cd /tmp/stella/
/usr/src/stella-1.0/src/build/xstella -fps 60 mnr2049r.bin

# (find-fline "/usr/src/stella-1.0/")
# (find-fline "/usr/src/stella-1.0/om")
# (find-fline "/usr/src/stella-1.0/src/emucore/stella.pro")
# (find-fline "/usr/src/stella-1.0/src/build/DefProps.def")
# (find-fline "/usr/src/stella-1.0/docs/Stella.txt" "-fps")




#####
#
# stella 1.4.1 (sarge)
# 2007mar22
#
#####

# «stella»  (to ".stella")
# (find-status   "stella")
# (find-vldifile "stella.list")
# (find-udfile   "stella/")
# (find-udfile "stella/changelog.gz" "Supercharger")
# (find-man "6 stella")
# (find-angg "bin/favstella")
#
rm -Rv /tmp/stella
mkdir  /tmp/stella
cd     /tmp/stella
cp -v /oldfs/6/snarf/http/www.general.uwa.edu.au/u/darrins/2600/*.zip .
for i in *.zip; do unzip -LL $i; done

#
 (eepitch-shell)
locate /2600/

# (find-fline "/tmp/stella/")



#####
#
# stella ROMs
# 2011dec15 / 2000aug09
#
#####

# «stella_roms»  (to ".stella_roms")
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/Downloads/Atari 2600 All 2548 Games/roms/")
cd "$HOME/Downloads/Atari 2600 All 2548 Games/roms/"
stella .



# Old:
#
rm -Rv /tmp/stella
mkdir /tmp/stella
cd /snarf/http/www.general.uwa.edu.au/u/darrins/2600/
for i in *.zip; do unzip $i -d /tmp/stella; done
cd /tmp/stella
heredoc /tmp/mvlower -m 777 <<'---'
#!/usr/bin/tclsh
foreach Bin $argv {
  set bin [string tolower $Bin]
  if {$bin!=$Bin} {
    exec mv -iv $Bin $bin
  }
}
---
/tmp/mvlower *
#

tar -cvzf /usr/src/stella-1.0/cartridges.tgz *
laf /usr/src/stella-1.0/cartridges.tgz


# Or, when we already have the .tgz,
rm -Rv /tmp/stella
mkdir /tmp/stella
cd /tmp/stella
tar -xvzf /usr/src/stella-1.0/cartridges.tgz





#####
#
# xpat2
#
#####

rm -Rv /usr/src/xpat2-1.04/
cd /usr/src/
tar -xvzf /snarf/ftp/uiarchive.cso.uiuc.edu/pub/systems/linux/sunsite/games/solitaires/xpat2-1.04-src.tar.gz
cd /usr/src/xpat2-1.04/
make |& tee om
make install |& tee omi

# (find-fline "/usr/src/xpat2-1.04/lib/")





#####
#
# LinCity 1.09
#
#####

rm -Rv /usr/local/lib/lincity/
rm -v /usr/local/bin/lincity

rm -Rv /usr/src/lincity109/
cd /usr/src/
tar -xvzf /snarf/ftp/sunsite.unc.edu/pub/Linux/games/strategy/lincity109-src.tar.gz
cd /usr/src/lincity109/
make lincity	|& tee om
make install	|& tee omi

cd /usr/src/lincity109/
agrep mousetype.mes $(find *) | l

# (find-fline "/usr/src/lincity109/messages/mousetype.mes")
# (find-fline "~/.lincityrc")
# gpm's -mman is #6 (Logiman).




#####
#
# freeciv
#
#####

# (find-fline "/usr/doc/freeciv/")
dpkg -i ~/HASH/xaw-wrappers ~/HASH/freeciv
civserver --nometa

export FREECIV_DATADIR=/usr/lib/games/freeciv/data
civclient                                        

dpkg -r freeciv

http://freeciv.ultraviolet.org/


cd /usr/src/
rm -Rv freeciv-1.7.1/
tar -xvIf /snarf/ftp/www.freeciv.org/pub/freeciv/freeciv-1.7.1.tar.bz2
cd /usr/src/freeciv-1.7.1/
./configure |& tee oc
make |& tee om
make install |& tee omi


/usr/src/freeciv-1.7.1/ser --nometa

export FREECIV_DATADIR=/usr/src/freeciv-1.7.1
/usr/src/freeciv-1.7.1/server/civserver --nometa

export FREECIV_DATADIR=/usr/src/freeciv-1.7.1
/usr/src/freeciv-1.7.1/client/civclient

# Bichado.





#####
#
# freeciv (slink)
#
#####

apt-get install freeciv

dpkg --purge freeciv

# (find-fline "/usr/doc/freeciv/")
# (find-vldifile "freeciv.list")




#######
#
# mame (potato) & roms
#
#######

# (find-fline "/usr/doc/xmame/")
# (find-fline "~/0-20k.tgz")
# (find-fline "~/20-50k.tgz")

# (find-fline "/snarf/ftp/ftp.byte.com/pub/gamepower/mame/index.size")

cd /snarf/ftp/ftp.byte.com/pub/gamepower/mame/
cd /snarf/ftp/ftp.byte.com/pub/gamepower/mame/sample/
lynx /snarf/ftp/ftp.byte.com/pub/gamepower/mame/index.hmtl
lynx /snarf/ftp/ftp.byte.com/pub/gamepower/mame/sample/index.hmtl

cd /snarf/ftp/ftp.byte.com/pub/gamepower/mame/
tar -xvzf ~/0-20k.tgz
cp *.zip /usr/lib/games/xmame/roms/

(cd /usr/lib/games/xmame/roms/; ls *.zip)
tar -tvzf ~/20-50k.tgz

cd /usr/lib/games/xmame/roms/
tar -xvzf ~/20-50k.tgz -C /usr/lib/games/xmame/roms/





#####
#
# Nethack
#
#####

apt-get install nethack

# (find-fline "/usr/doc/nethack/")
# (find-vldifile "nethack.list")
# (find-fline "/usr/doc/nethack/Guidebook.gz" "4.  Commands")

a2ps -o ~/o.ps -X ibmpc \
  --columns=2 --rows=1 --major=columns --portrait --medium=A4dj \
  ~/o

cd
rm o.p[0-9][0-9]
gs -sDEVICE=djet500 -r300 -sOutputFile=o.p%02d -dNOPAUSE -dBATCH o.ps

cat o.p0? > /dev/lp1


# (find-fline "~/ICON/nethack-keys.icn")

cd ~/ICON/
icont nethack-keys.icn
nethack-keys < ~/NETHACK/commands 'w ) [ A T W R P = " ('
nethack-keys < ~/NETHACK/commands 'r Z x + \'

# (find-fline "/var/lib/games/nethack/")

# (find-fline "~/.zshrc" "nhagrep")
nhagrep 'glows blue'


cd /var/lib/games/nethack/
tar -cvzf ~/NETHACK/$HOJE.tgz *
laf ~/NETHACK/

find /var/lib/games/nethack/

cd /var/lib/games/nethack/
rm -Rv *
tar -xvzf ~/NETHACK/$HOJE.tgz




#####
#
# nethack-spoilers
# 2000jun15
#
#####

# (find-status "nethack-spoilers")
# (find-vldifile "nethack-spoilers.list")
# (find-fline "/usr/doc/nethack-spoilers/")

rm -Rv /tmp/spoilers/
mkdir  /tmp/spoilers/
cd     /tmp/spoilers/
cp -iv /usr/doc/nethack-spoilers/* .
gzip -dv *.gz

cd /tmp/spoilers/
agrep -i pacifist *

# (find-fline "/usr/doc/nethack/")
# (find-fline "/usr/doc/nethack/Guidebook.gz")





#####
#
# Pingus
#
#####

rm -Rv /usr/src/Hermes-1.2.4/
cd /usr/src/
tar -xvzf $S/http/hermes.terminal.at/files/Hermes-1.2.4.tar.gz
cd /usr/src/Hermes-1.2.4/
./configure |& tee oc
make |& tee om
make install |& tee omi

rm -Rv /usr/src/pingus-0.0.12/
cd /usr/src/
tar -xvzf $S/http/privat.schlund.de/g/grumbel/pingus/pingus-0.0.12.tar.gz
cd /usr/src/pingus-0.0.12/
./configure |& tee oc




#####
#
# pingus 0.3 (woody, on potato)
# 2000nov02
#
#####

# «pingus»  (to ".pingus")

pdsc $SDEBIAN/dists/woody/main/source/libs/hermes1_1.3.1-1.dsc
cd /usr/src/hermes1-1.3.1/
debian/rules binary	|& tee odrb
# "No package to build"?

apti hermes1-dev libggi2-dev libmagick4-dev

pdsc $SDEBIAN/dists/woody/main/source/libs/clanlib0_0.4.3-1.dsc
cd /usr/src/clanlib0-0.4.3/
debian/rules binary	|& tee odrb

# (code-c-d "clan" "/usr/src/clanlib0-0.4.3/")
# (find-clanfile "")

pdsc $SDEBIAN/dists/woody/main/source/games/pingus_0.3.1.dsc
cd /usr/src/pingus-0.3.1/
debian/rules binary	|& tee odrb

# (code-c-d "pingus" "/usr/src/pingus-0.3.1/")
# (find-pingusfile "")

psnedeb <<'---'
    41741 dists/woody/main/source/libs/hermes1_1.3.1-1.diff.gz
      586 dists/woody/main/source/libs/hermes1_1.3.1-1.dsc
   247734 dists/woody/main/source/libs/hermes1_1.3.1.orig.tar.gz
---

     5971 dists/woody/main/source/libs/clanlib0_0.2.3-3.diff.gz
      681 dists/woody/main/source/libs/clanlib0_0.4.3-1.dsc
   803668 dists/woody/main/source/libs/clanlib0_0.4.3-1.tar.gz
---




#####
#
# xearth
#
#####

pdsc /debian/non-free/source/games/xearth_1.0-13.dsc
cd /usr/src/xearth-1.0/
debian/rules binary	|& tee odrb

cd /usr/src/
mv -v xearth*.deb .debs

cd /usr/src/.debs/
dpkg-scanpackages . /dev/null | tee Packages
apt-get update

apt-get install xearth
# (find-fline "/usr/doc/xearth/")
# (find-vldifile "xearth.list")
# (find-fline "$S/http/www.debian.org/devel/developers.xearth")

xearth -markerfile $S/http/www.debian.org/devel/developers.xearth
xearth -markerfile $S/http/www.debian.org/devel/developers.xearth -proj merc -pos random
xearth -markerfile $S/http/www.debian.org/devel/developers.xearth -proj merc -noshade





#####
#
# historicalsource
# 2019dec04
#
#####

# «historicalsource» (to ".historicalsource")
# https://kryptonradio.com/2019/04/18/zork-source-code-presumed-lost-forever-has-been-uploaded-to-github/
# https://www.facebook.com/groups/retrocomputers/permalink/3021835164513011/
# https://github.com/historicalsource/zork1

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/zork1/
cd      ~/usrc/
git clone https://github.com/historicalsource/zork1
cd      ~/usrc/zork1/

git branch --list -a
git for-each-ref
PAGER=cat git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/zork1/")
# (find-gitk  "~/usrc/zork1/")

# (code-c-d "zork1" "~/usrc/zork1/")
# (find-zork1file "")






#####
#
# Frotz + Zork I
# 99sep15
#
#####

# «frotz»  (to ".frotz")
# http://www.csd.uwo.ca/Infocom/

pdsc $SDEBIAN/dists/slink/non-free/source/games/frotz_2.32r2-12.dsc
cd /usr/src/frotz-2.32r2/
debian/rules binary	|& tee odrb
mv -v /usr/src/frotz*deb /usr/src/.debs/
apt-update
apti frotz

# (find-vldifile "frotz.list")
# (find-fline "/usr/doc/frotz/")
# (find-fline "/usr/doc/frotz/Readme.unix.gz" "http://")
# (find-fline "/usr/doc/frotz/Readme.unix.gz" "Alt-P")

# (code-c-d "frotz" "/usr/src/frotz-2.32r2/")
# (find-frotzfile "")
# (find-frotzfile "hotkey.c" "Alt-P")

# «Zork1»  (to ".Zork1")
# http://www.csd.uwo.ca/Infocom/
# http://www.csd.uwo.ca/Infocom/Download/zork1.zip
# http://www.csd.uwo.ca/Infocom/interp.html
#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/zork1/
mkdir   ~/usrc/zork1/
cd      ~/usrc/zork1/
unzip -l $S/http/www.csd.uwo.ca/Infocom/Download/zork1.zip
unzip -L $S/http/www.csd.uwo.ca/Infocom/Download/zork1.zip

#
# (find-man "unzip")
# (code-c-d "zork1" "~/usrc/zork1/")
# (find-zork1file "")
# (find-zork1file "data/")

~/usrc/zork1/data/zork1.dat
# (find-fline "~/usrc/zork1/data/zork1.dat")

# (find-zork1file "")
# (find-zork1file "data/")



lynx $S/http/www.csd.uwo.ca/Infocom/
unzip -l $S/http/www.csd.uwo.ca/Infocom/Download/zork1.zip
# (find-fline "$S/http/www.csd.uwo.ca/Infocom/Download/zork1.zip")

rm -Rv ~/tmp/zork
mkdir  ~/tmp/zork
cd     ~/tmp/zork
unzip -Lj $S/http/www.csd.uwo.ca/Infocom/Download/zork1.zip data/zork1.dat
unzip -La $S/http/www.csd.uwo.ca/Infocom/Download/zork1.zip readme.txt
# (find-fline "~/tmp/zork/readme.txt" "Gameplay notes")

cd ~/tmp/zork/
frotz zork1.dat

# (find-fline "~/TK/zork1.diags")

# verbose brief superbrief diagnose quit restart save restore



#####
#
# Malyon - a Z-machine interpreter for Emacs
# 2010sep04
#
#####

# «malyon»  (to ".malyon")
# http://www.emacswiki.org/emacs/MalyonMode
# http://www.ifarchive.org/if-archive/infocom/interpreters/emacs/malyon.el
# http://www.ifarchive.org/indexes/if-archiveXgamesXzcode.html
# http://www.ifarchive.org/if-archive/games/zcode/Advent.z5
# http://www.wurb.com/if/game/2
# http://mirror.ifarchive.org/if-archive/games/zcode/zdungeon.z5
# http://mirror.ifarchive.org/if-archive/solutions/dungeon.ps
# http://mirror.ifarchive.org/if-archive/solutions/dungeon.sol

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/malyon/
mkdir  ~/usrc/malyon/
cp -v $S/http/www.ifarchive.org/if-archive/infocom/interpreters/emacs/malyon.el ~/usrc/malyon/
cp -v $S/http/www.ifarchive.org/if-archive/games/zcode/Advent.z5 ~/usrc/malyon/
cp -v ~/usrc/zork1/data/zork1.dat ~/usrc/malyon/zork1.z3
cp -v $S/http/mirror.ifarchive.org/if-archive/games/zcode/zdungeon.z5 ~/usrc/malyon/

# (find-fline "~/usrc/malyon/")

 (byte-compile-file "~/usrc/malyon/malyon.el")
cd     ~/usrc/malyon/
file *

 (load "~/usrc/malyon/malyon.elc")
# (find-efunction 'malyon)
# (find-efunction 'malyon-initialize-faces)

 (malyon-quit)
 (malyon "~/usrc/malyon/Advent.z5")
 (malyon "~/usrc/malyon/zdungeon.z5")
 (malyon "~/usrc/malyon/zork1.z3")






#####
#
# inform, a Z-code compiler
#
#####

# «inform»  (to ".inform")
# A recent link to the T-removing machine (2007):
# http://www.inform-fiction.org/manual/html/s48.html

# Inform's manual is fantastic - look for the description of the
# "T-Removing Machine", for example.
# Recent link (oct2000) to its homepage:
# (find-shttpw3 "www.gnelson.demon.co.uk/inform/index.html")

# Summer 98 Archive, CD 3...
# (find-fline "/cdrom/games/textrpg/inform-r5-linux.tar.gz")

Pgrep 'm/ckage: inform/'

# I'm trying to find a recent link (2005apr12)... maybe this?
# http://www.geocities.com/aetus_kane/writing/coa.html
# (find-w3m "$S/http/www.geocities.com/aetus_kane/writing/coa.html" "rabbi")
T-Removing Machine
rabbit






#####
#
# ztools (include txd, a Z-code decompiler)
# 2000oct18
#
#####

# «ztools»  (to ".ztools")

#
rm -Rv /usr/src/ztools/
mkdir  /usr/src/ztools/
cd     /usr/src/ztools/
tar -xvzf $S/ftp/ftp.gmd.de/if-archive/infocom/tools/ztools/ztools731.tar.gz
make	|& tee om
#

# (find-fline "/usr/src/ztools/")
# (find-fline "/usr/src/ztools/om")
# (find-fline "/usr/src/ztools/txd.man")

cd /usr/src/ztools/
./txd    ~/tmp/zork/zork1.dat	> /tmp/zork1.txd
./txd -a ~/tmp/zork/zork1.dat	> /tmp/zork1.txda

# (find-fline "/tmp/zork1.txd")
# (find-fline "/tmp/zork1.txda")

#




#####
#
# gnugo-2.6
# 2000jun16
#
#####

# «gnugo2»  (to ".gnugo2")

# (find-fline "$S/ftp/ftp.gnu.org/gnu/gnugo/")
# (code-c-d "gnugo" "/usr/src/gnugo-2.6/")
# (find-gnugofile "")

pdsc $SDEBIAN/dists/woody/main/source/games/gnugo_2.6-2.dsc
debian/rules binary	|& tee odrb

dpkg -i /usr/src/gnugo*.deb

# (find-status "gnugo")
# (find-vldifile "gnugo.list")
# (find-fline "/usr/doc/gnugo/")
# (find-fline "/usr/share/emacs/site-lisp/gnugo.el")
# (find-fline "/usr/share/emacs/site-lisp/gnugo.el" "(defun gnugo ()")
# (find-node "(gnugo)Top")

# (find-fline "$S/ftp/match.stanford.edu/pub/")
# (find-fline "$S/ftp/match.stanford.edu/pub/usgo-mfgo.sgf")

# (find-es "games" "cgoban")

# (find-status "cgoban")
# (find-vldifile "cgoban.list")
# (find-fline "/usr/doc/cgoban/")

# To play against gnugo, or to make two gnugos play against each
# other: go to the dir with the gnugo binary, start cgoban, select "Go
# Modem", and use "./gnugo" as the program.

cd /usr/games/
cgoban




#####
#
# GNU Go
# 2012jan17
#
#####

# «gnu-go»  (to ".gnu-go")
# (find-status   "gnugo")
# (find-vldifile "gnugo.list")
# (find-udfile   "gnugo/")

# (find-status   "cgoban")
# (find-vldifile "cgoban.list")
# (find-udfile   "cgoban/")
# (find-status   "qgo")
# (find-vldifile "qgo.list")
# (find-udfile   "qgo/")






#####
#
# MAME ROMs
# 99jan24
#
#####

getlinks < $S/http/www.geocities.com/TimesSquare/Arena/7193/in_roms.htm

lynx $S/http/www.geocities.com/TimesSquare/Arena/7193/in_roms.htm




#####
#
# xlife
# 00feb08
#
#####

# «xlife»  (to ".xlife")
# (find-status "xlife")
# (find-vldifile "xlife.list")
# (find-fline "/usr/doc/xlife/")
# (find-fline "/usr/doc/xlife/README" "The help key is `?'.")

# (eeman "6 xlife")
# (eeman "6 collect")
# (eeman "6 lifesearchdumb")
# (eeman "6 lifeconv")
# (eeman "6 lifesearch")
#
rm -Rv /tmp/life/
mkdir  /tmp/life/
cd /usr/doc/xlife/examples/
cp -diPpvR * /tmp/life/
cd /tmp/life
gzip -dr *

#





#####
#
# smame
#
#####

smame -h |& l
smame -listroms dkong

*** Vector Games ***
 -beam                    Set the beam size for vector games
 -flicker                 Set the flicker for vector games
 -[no]antialias           Disable/enable antialiasing
 -[no]translucency        Disable/enable translucency

smame -antialias asteroid
smame -noantialias asteroid
smame -translucency asteroid
smame -notranslucency asteroid
smame -beam 1.5 asteroid
smame -beam 2 asteroid

smame -flicker 4 asteroid

 -ident       <filename>  Identify unknown romdump <filename>, or unknown
                          romdumps in dir/zip <filename>.
 -list          [regexp]  List supported games matching regexp, or all
 -listfull      [regexp]  List supported games with full description
 -listgames     [regexp]  List supported games with manufacturer and year
 -listclones    [regexp]  List clones of games matching regexp, or all
 -listdetails   [regexp]  Detailed list of supported games
 -listroms      [regexp]  List used ROMS
 -listsamples   [regexp]  List used audio samples
 -listsamdir    [regexp]  List dir where samples are taken from
 -listcrc       [regexp]  List used ROMS with crc
 -listdupcrc    [regexp]  List ROMS with identical crc
 -verifyroms    [regexp]  Verify ROMS for games matching regexp
 -verifysamples [regexp]  Verify audio samples for games matching regexp
 [regexp]                 Optional, May contain * and ? wildcards
 -noclones                Don't show bootlegs/clones in list commands
 -showconfig              Display Running parameters in rc style

cd /usr/lib/games/xmame/roms/
smame -ident PEEKB/donkey_k.zip

smame -list         |& l
smame -listfull     |& l
smame -listgames    |& l
smame -listclones   |& l
smame -listdetails  |& l
smame -listroms     |& l
smame -listsamples  |& l
smame -listsamdir   |& l
smame -listcrc      |& l
smame -listdupcrc   |& l
smame -verifyroms   |& l
smame -verifysamples|& l

smame -listsamples dkong




#####
#
# freesweep
# 2000jun25
#
#####

# (find-status "freesweep")
# (find-vldifile "freesweep.list")
# (find-fline "/usr/doc/freesweep/")

# (eeman "6 freesweep")





#####
#
# Stella 1.1 on potato
# 2000aug01
#
#####

# (find-status "stella")
# (find-vldifile "stella.list")
# (find-fline "/usr/doc/stella/")

#
rm -Rv ~/tmp/stella/
mkdir ~/tmp/stella/
cd /snarf/http/www.general.uwa.edu.au/u/darrins/2600/
for i in *.zip; do unzip $i -d ~/tmp/stella; done
cd ~/tmp/stella/
A=(*)
expect -c 'foreach Bin [glob *] {
  set bin [string tolower $Bin]
  set c [string range $bin 0 0]
  file mkdir $c
  file rename $Bin $c/$bin
}'
#
# (find-fline "/tmp/stella/")

# Keys:
gv -page 13 /usr/doc/stella/Stella.pdf.gz





#####
#
# casse-tete
# 2000aug19
#
#####

#
rm -Rv /usr/src/casse-tete/
cd /usr/src/
tar -xvzf $S/http/sed.free.fr/casse-tete/casse-tete-modified.tar.gz
cd /usr/src/casse-tete/
make
./casse-tete

#




#####
#
# doom
# 2000aug21
#
#####

# (find-status "lxdoom")
# (find-vldifile "lxdoom.list")
# (find-fline "/usr/doc/lxdoom/")

# (find-status "lxdoom-svga")
# (find-vldifile "lxdoom-svga.list")
# (find-fline "/usr/doc/lxdoom-svga/")

# (find-status "doom-wad-shareware")
# (find-vldifile "doom-wad-shareware.list")
# (find-fline "/usr/doc/doom-wad-shareware/")

# (find-fline "~/.lxdoom/")




#####
#
# bsdgames
# 2000oct13
#
#####

# (find-status "bsdgames")
# (find-vldifile "bsdgames.list")
# (find-fline "/usr/doc/bsdgames/")

# (find-fline "/usr/share/misc/acronyms")




#####
#
# xmame (potato)
# 2000oct14
#
#####

# (find-status "xmame")
# (find-vldifile "xmame.list")
# (find-fline "/usr/share/doc/xmame/")

# (find-status "xmame-x")
# (find-vldifile "xmame-x.list")
# (find-fline "/usr/doc/xmame-x/")

# (find-status "xmame-svga")
# (find-vldifile "xmame-svga.list")
# (find-fline "/usr/doc/xmame-svga/")

edrxnetscape http://www.mame.dk/

# (find-fline "/usr/lib/games/xmame/roms/")
# (find-fline "/usr/lib/games/xmame/samples/")
# (find-fline "/usr/lib/games/xmame/artwork/")

cd /tmp/
unzip /usr/lib/games/xmame/artwork/llander.zip

#
cd /usr/lib/games/xmame/
rm -v /tmp/roms.zip
zip -r /tmp/roms.zip roms samples artwork
laf /tmp/roms.zip
#
scp /tmp/roms.zip edrx@sucuri:



bumpnjump
burger time
tutankham
xevious
zaxxon

berzerk
combat
crystal castles
digger
haunted castle
marble madness
missile command
mouse trap
mr do!
rescue
simpsons

enduro racer (KFC london!)

# (find-fline "/etc/vga/libvga.config")





#####
#
# xmame 0.37b7 (woody, on potato)
# 2000nov01
#
#####

apti svgalibg1-dev mesag-dev libglide2-dev
apti glutg3-dev

#
pdsc $SDEBIAN/dists/woody/non-free/source/games/xmame_0.37b7.1-1.dsc
cd /usr/src/xmame-0.37b7.1/
debian/rules binary	|& tee odrb
#

# (code-c-d "xmame37" "/usr/src/xmame-0.37b7.1/")
# (find-xmame37file "debian/control" "Build-Depends")
# (find-xmame37file "src/cpu/pdp1/")
# (find-xmame37file "src/cpu/t11/")
# (find-xmame37file "src/cpu/")
# (find-xmame37file "")



#####
#
# thrust
# 2002oct28
#
#####

# «thrust»  (to ".thrust")
# (find-status "thrust")
# (find-vldifile "thrust.list")
# (find-fline "/usr/doc/thrust/")

# (find-man "thrust" "CONTROLS")

/usr/games/thrust





#####
#
# sgt-puzzles
# 2008apr12
#
#####

# «sgt-puzzles»  (to ".sgt-puzzles")
# http://www.chiark.greenend.org.uk/~sgtatham/puzzles/
# http://www.chiark.greenend.org.uk/~sgtatham/puzzles/devel/
# http://www.chiark.greenend.org.uk/~sgtatham/puzzles/devel/drawing.html
# http://www.chiark.greenend.org.uk/~sgtatham/bugs.html
# (find-status   "sgt-puzzles")
# (find-vldifile "sgt-puzzles.list")
# (find-udfile   "sgt-puzzles/")

# (code-c-d "puzzleshelp" "/usr/share/sgt-puzzles/gnome/help/C/")
# (find-puzzleshelpfile "")
# (find-puzzleshelpw3m "index.html")

# (find-bgprocess "blackboxgame")
# (find-bgprocess "bridges")
# (find-bgprocess "cube")
# (find-bgprocess "dominosa")
# (find-bgprocess "fifteen")
# (find-bgprocess "flipgame")
# (find-bgprocess "guess")
# (find-bgprocess "inertia")
# (find-bgprocess "lightup")
# (find-bgprocess "loopy")
# (find-bgprocess "map")
# (find-bgprocess "mines")
# (find-bgprocess "netgame")
# (find-bgprocess "netslide")
# (find-bgprocess "pattern")
# (find-bgprocess "pegs")
# (find-bgprocess "rect")
# (find-bgprocess "samegame")
# (find-bgprocess "sixteen")
# (find-bgprocess "slant")
# (find-bgprocess "solo")
# (find-bgprocess "tents")
# (find-bgprocess "twiddle")
# (find-bgprocess "untangle")




#####
#
# sgt-puzzles (from the debian sources)
# 2012feb11
#
#####

# «sgt-puzzles-deb-src»  (to ".sgt-puzzles-deb-src")
# http://ftp.de.debian.org/debian/pool/main/s/sgt-puzzles/
# http://ftp.de.debian.org/debian/pool/main/s/sgt-puzzles/sgt-puzzles_8853-3.dsc
# http://ftp.de.debian.org/debian/pool/main/s/sgt-puzzles/sgt-puzzles_8853-3.diff.gz
# http://ftp.de.debian.org/debian/pool/main/s/sgt-puzzles/sgt-puzzles_8853.orig.tar.gz
#
rm -Rv ~/usrc/sgt-puzzles/
mkdir  ~/usrc/sgt-puzzles/
cd $S/http/ftp.de.debian.org/debian/pool/main/s/sgt-puzzles/
cp -v sgt-puzzles_8853* ~/usrc/sgt-puzzles/
cd     ~/usrc/sgt-puzzles/
dpkg-source -sn -x sgt-puzzles_8853-3.dsc
cd     ~/usrc/sgt-puzzles/sgt-puzzles-8853/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/sgt-puzzles/")
 (eepitch-shell)
cd ~/usrc/sgt-puzzles/
sudo dpkg -i *.deb

#
# (code-c-d "sgtpuzzles" "~/usrc/sgt-puzzles/sgt-puzzles-8853/")
# (find-sgtpuzzlesfile "")
# (find-sgtpuzzlesfile "README")
# (find-sgtpuzzlesfile "HACKING")
# (find-sgtpuzzlesfile "Recipe")
# (find-sgtpuzzlesfile "nullgame.c")
# (find-sgtpuzzlesfile "drawing.c")
# (find-sgtpuzzlesfile "odb")







#####
#
# robotfindskitten and sl
# 2007jul21
#
#####

# «robotfindskitten»  (to ".robotfindskitten")
# (find-node "(robotfindskitten)")
# (find-available "robotfindskitten")
# (find-available "sl")
# (find-sh "strings `which robotfindskitten`")

http://robotfindskitten.org/





#####
#
# xmame on squeeze
# 2011nov28
#
#####

# «xmame»  (to ".xmame")
# (find-status   "xmame-x")
# (find-vldifile "xmame-x.list")
# (find-udfile   "xmame-x/")
# (find-udfile   "xmame-x/README.Debian" "PATHs")
# (find-status   "xmame-common")
# (find-vldifile "xmame-common.list")
# (find-udfile   "xmame-common/")
# (find-status   "xmame-tools")
# (find-vldifile "xmame-tools.list")
# (find-udfile   "xmame-tools/")
# (find-fline "/etc/xmame/xmamerc")




#####
#
# Stencyl
# 2011dec12
#
#####

# «stencyl»  (to ".stencyl")
# http://www.stencyl.com/
# http://www.stencyl.com/stencylworks/get/
# (find-fline "~/tmp/" "StencylWorks-1.3.0.tar.gz")
#
rm -Rv ~/bigsrc/stencylworks-linux/
tar -C ~/bigsrc/ -xvzf \
  ~/tmp/StencylWorks-1.3.0.tar.gz
cd     ~/bigsrc/stencylworks-linux/

#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd     ~/bigsrc/stencylworks-linux/
bash StencylWorks

# (code-c-d "stencyl" "~/bigsrc/stencylworks-linux/")
# (code-c-d "stencylhelp" (ee-stencylfile "help/help/en/html/main/"))
# (find-stencylfile "")
# (find-stencylsh "find * | sort")
# (find-stencylhelpfile "")




#####
#
# passage
# 2013feb13
#
#####

# «passage» (to ".passage")
# (find-status   "passage")
# (find-vldifile "passage.list")
# (find-udfile   "passage/")
# (find-man "6 passage")
# http://hcsoftware.sourceforge.net/passage/
# http://hcsoftware.sourceforge.net/passage/statement.html





#####
#
# Infocom ad about graphics
# 2012nov24
#
#####

# «infocom-graphics» (to ".infocom-graphics")
# http://mit.edu/6.933/www/Fall2000/infocom/
# http://mit.edu/6.933/www/Fall2000/infocom/infocom-paper.pdf
# http://mit.edu/6.933/www/Fall2000/infocom/images/ads/BrainAd2.jpg
# https://ifarchive.org/indexes/if-archive/infocom/adverts/
# https://ifarchive.org/if-archive/infocom/adverts/ad1.jpeg





#####
#
# notgames
# 2020apr07
#
#####

# «notgames» (to ".notgames")

Loneliness:
https://www.necessarygames.com/my-games/loneliness/flash

We Become What We Behold:
https://ncase.itch.io/wbwwb

https://bluemaxima.org/flashpoint/

mas se ja quiser uma previa, essa e minha game designer favorita!
https://ncase.me/




#####
#
# qix algorithm
# 2024jun15
#
#####

# «qix»  (to ".qix")
https://www.idogendel.com/en/archives/738 HOW THE ALGORITHM KNOWS WHERE THE QIX IS: A (FUL)FILLING SOLUTION
https://forum.unity.com/threads/qix-game-logic.452628/
https://retrocomputing.stackexchange.com/questions/16916/how-was-the-main-mechanic-of-the-game-qix-implemented
https://gamedev.stackexchange.com/questions/128905/how-to-calculate-area-to-fill-in-this-snake-qix-game-variant
https://github.com/cschladetsch/xiq SDL, one weekend





https://www.google.com/url?sa=t&rct=j&q=&esrc=s&source=web&cd=8&cad=rja&uact=8&ved=2ahUKEwjStbK2iNXoAhWGHbkGHcNRBwcQFjAHegQIARAB&url=https%3A%2F%2Fwww.pcgamer.com%2Fgametrekking-interview-i-released-a-new-notgame-from-cambodia-today%2F&usg=AOvVaw0yxDJXIOHQ-34IKxE6uKqd

https://news.ycombinator.com/item?id=28902666 Before Pong, There Was Computer Space (mitpress.mit.edu)






https://medium.com/@jakeout/map-of-zzt-ee8e0b80d04e


http://www.nickm.com/if/adverbum.html

https://github.com/joemck/oscilloscope-asteroids

<parsnip> ,dark
<fsbot> dark is no echo It is pitch black. You are likely to be
        eaten by a GNU.

https://news.ycombinator.com/item?id=34087740 Inform is a programming language for creating interactive fiction (ganelson.github.io)
https://arstechnica.com/gaming/2022/05/after-30-years-the-world-can-now-play-the-lost-marble-madness-ii/
https://en.wikipedia.org/wiki/Zork

https://news.ycombinator.com/item?id=34469154 Ask HN: Great text based games to play?
https://acko.net/blog/teardown-frame-teardown/
https://news.ycombinator.com/item?id=35166874 Show HN: Learn Python with Minecraft (github.com/gilesknap)
https://arstechnica.com/gaming/2023/06/50-years-of-text-games-parses-the-rich-history-of-a-foundational-genre/
https://github.com/bobeff/open-source-games
https://news.ycombinator.com/item?id=40345250 A list of open source games (github.com/bobeff)
https://arstechnica.com/gaming/2024/06/from-infocom-to-80-days-an-oral-history-of-text-games-and-interactive-fiction/ 
https://news.ycombinator.com/item?id=40749426 From Infocom to 80 Days: An oral history of text games and interactive fiction (arstechnica.com) - A photo of a brain and a statement
https://web.archive.org/web/20230117073114/http://web.mit.edu/6.933/www/Fall2000/infocom/images/ads/BrainAd2.jpg
https://www.inform-fiction.org/manual/html/s46.html A short history of interactive fiction





#  Local Variables:
#  coding:               utf-8-unix
#  End:
