#######
#
# E-scripts for things that didn't fit anywhere else.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/general.e>
#           or at <http://angg.twu.net/e/general.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.lcc»	(to "lcc")
# «.lilo»	(to "lilo")
# «.lilo-src»	(to "lilo-src")
# «.lsof»	(to "lsof")




#####
#
# lilo
# 2000may07
#
#####

# «lilo»  (to ".lilo")

# (find-vldifile "lilo.list")
# (find-fline "/usr/doc/lilo/")
# (find-fline "/usr/doc/lilo/examples/")
# (find-fline "/usr/doc/lilo/examples/conf.sample")
# (find-es "floppy" "syslinux.cfg")

# (find-fline "/usr/doc/lilo/Manual.txt.gz" "PROMPT  Forces entering")
# (find-fline "/usr/doc/lilo/Manual.txt.gz" "0x00   \"Internal error\"")

mkdir /hda1/boot/angg22/
cp -v /boot/angg22/k22xx /hda1/boot/angg22/

cat > /tmp/lilo.conf <<'---'
boot=/dev/hda
compact
# install=/boot/boot.b
# map=/boot/map
prompt
timeout=50
image=/hda1/boot/angg22/k22xx
	root=/dev/hda6
	label=a6
	read-only
	vga=1
image=/hda1/boot/angg22/k22xx
	root=/dev/hda6
	label=a6ask
	read-only
	vga=ask
---

# cp /tmp/lilo.conf /etc/lilo.conf

lilo -v -v -C /tmp/lilo.conf


# (eeman "lilo")
# (eeman "keytab-lilo")
# (eeman "liloconfig")
# (eeman "activate")




#####
#
# lilo source (potato)
# 2000oct14
#
#####

# «lilo-src»  (to ".lilo-src")
#
pdsc $SDEBIAN/dists/potato/main/source/base/lilo_21.4.3-2.dsc
#
cd /usr/src/lilo-21.4.3/
agrep -i initrd $(find *)	|& tee ~/o

cd /usr/src/lilo-21.4.3/
agrep 13 $(find *)		|& tee ~/o2
#

# (code-c-d "lilo" "/usr/src/lilo-21.4.3/")
# (find-lilofile "")
# (find-fline "~/o")
# (find-fline "~/o2")
# (find-lilofile "doc/tech.tex")
# (find-lilofile "doc/tech.tex" "initial RAM disk")
# (find-lilofile "lilo.c" "Initial RAM disk is %ld bytes")




#####
#
# lsof
# 2012may02
#
#####

# «lsof»  (to ".lsof")
# (find-status   "lsof")
# (find-vldifile "lsof.list")
# (find-udfile   "lsof/")
# (find-udfile "lsof/00FAQ.gz")
# (find-man "8 lsof")
# (find-man "8 lsof" "\nOUTPUT FOR OTHER PROGRAMS")
# (find-man "8 lsof" "-i [i]")
# https://www.howtoforge.com/linux-lsof-command/#-find-out-which-program-is-using-a-port

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
ps ax | grep mix
lsof 7632
lsof -h
# (find-sh "lsof -h")
lsof -p 7632

sudo lsof -i :80

# (find-sh "ps ax | grep alsamixer; pgrep alsamixer")
# (find-man "pgrep")
# (find-sh "lsof -p $(pgrep alsamixer)")
# (find-fline "/dev/snd/")
# (find-fline "/proc/asound/")

# (find-sh "lsof")
# (find-sh "lsof | grep -i listen")






######
#
# lsof (on slink?)
#
######

# (find-fline "/usr/doc/lsof/")
# (find-fline "/usr/doc/lsof/00QUICKSTART")

lsof | cut -b1-9,12-15,18-36,40-42,45-47,51-58,64-

#         111111111122222222223333333333444444444455555555556666666666
#123456789012345678901234567890123456789012345678901234567890123456789012345678
#COMMAND     PID     USER   FD   TYPE     DEVICE   SIZE/OFF      INODE NAME
#init          1     root  cwd    DIR    22,   1       1024          2 /

pdsc /big/slinks2/dists/slink/main/source/utils/lsof_4.37-3.dsc
# (find-fline "/usr/src/lsof-4.37/dialects/linux/")

# cd /usr/src/lsof-4.37/
cd /usr/src/lsof-4.37/dialects/linux/

kmem/Mksrc
kmem/dproc.c
kmem/machine.h





####
#
# lsof on the kernel 2.0.37 (on slink)
# 99oct24
#
####

# «lsof-2.0.37»

pdsc /big/slinks2/dists/slink/main/source/utils/lsof_4.37-3.dsc
cd /usr/src/lsof-4.37/
# (code-c-d "lsof" "/usr/src/lsof-4.37/")
# (find-lsoffile "")
# (find-lsoffile "odrb")
# (find-lsoffile "debian/control-2.0.35")

cat > debian/control-2.0.37 <<'---'
Source: lsof
Section: utils
Priority: standard
Maintainer: Jim Mintha <jmintha@debian.org>
Standards-Version: 2.4.1

Package: lsof-2.0.37
Architecture: any
Depends: ${shlibs:Depends}
Description: List open files.
 Lsof is a Unix-specific diagnostic tool.  It's name stands
 for LiSt Open Files, and it does just that.  It lists
 information about any files that are open by processes
 current running on the system.  
 Only work on kernel version 2.0.37
Replaces: lsof, lsof-2.0.34, lsof-2.0.35
Conflicts: lsof, lsof-2.0.34, lsof-2.0.35
---

debian/rules binary	|& tee odrb

mv -v /usr/src/lsof*.deb /usr/src/.debs/
apt-update
apti lsof-2.0.37


# If we're not running the kernel corresponding to
# /boot/System.map-2.0.37 (which in my case is a link to
# /usr/src/linux-2.0/System.map) we need to reboot with the new
# kernel, and to do that I need to put it on my boot floppy...

# (find-es "floppy" "syslinux")

/usr/sbin/lsof -i :771,776,818,823,842,847,2017




####
#
# lsof on potato
# 2000may09
#
####

# «lsof-2.2»

Pgrepp m/lsof-2.2/ |& l

# (find-vldifile "lsof-2.2.list")
# (find-fline "/usr/doc/lsof-2.2/")

# The same binary works for all 2.2.x kernels.







#######
#
# cipe
#
#######

# (code-c-d "cipe" "/usr/src/cipe-0.5.6/" "cipe")
# (w3-open-local "/snarf/http/sites.inka.de/sites/bigred/devel/cipe.html")

rm -Rv /usr/src/cipe-0.5.6
cd     /usr/src/
tar -xvzf /snarf/http/sites.inka.de/sites/bigred/sw/cipe-0.5.6.tar.gz
cd     /usr/src/cipe-0.5.6/

# (find-cipefile "")
# (find-cipefile "README")
# (find-cipefile "Makefile")

make MODVERSIONS= |& tee om
make install |& tee omi

# (find-node "(cipe)Top")
# (find-node "(cipe)Prerequisites")

# Not working at all!




#########
#
# Making patches
#
#########

# (find-node "(diff)Making Patches" 59)

cd /usr/src/teTeX-0.9/texk/web2c/
rm -Rv o orig
mkdir o orig
cp -dipv Makefile.in~ orig/Makefile.in
cp -dipv Makefile.in~    o/Makefile.in
diff -C 2 orig/ Makefile.in	|& tee o/p

cd /usr/src/teTeX-0.9/texk/web2c/o/
patch < p

#

# (find-web2cfile "tex.ch" "extra_mem_top :=")
cd /usr/src/teTeX-0.9/texk/web2c/
diff -C 2 tex.ch~ tex.ch |& tee ~/o
mv -v tex.ch~ tex.ch
patch tex.ch < ~/o




#####
#
# doc: "The Linux Kernel"
#
#####

cd /usr/src/
rm -Rv tlk
tar -xvzf /snarf/ftp/sunsite.unc.edu/pub/Linux/docs/linux-doc-project/linux-kernel/tlk-0.1-13-19.tar.gz
cd /usr/src/tlk/
make all |& tee oma
#
# precisa do fig2dev




#####
#
# Duel (very old notes!)
#
#####

rpm -iv /big/rh41b/SRPMS/gdb-4.16-5.src.rpm
rpm -bp /usr/src/redhat/SPECS/gdb-4.16.spec
rm -v	/usr/src/redhat/SOURCES/binutils-2.7.0.2.tar.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16.tar.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16axp-2.diff.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16axp-3.diff.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16axp.patch.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16sparc.patch.gz
cd /usr/src/redhat/BUILD/gdb-4.16/
cp -iv /home/root/config.cache .
./configure |& tee oc
cd /usr/src/redhat/BUILD/gdb-4.16/
make |& tee om

#
# Parte nova
#
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
mkdir duel/
cd duel/
tar -xvzf /snarf/ftp/ftp.cs.princeton.edu/pub/duel/duel-1.10.4.tar.gz
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/duel/src/
make |& tee om
#
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
ln -s duel/duelgdb.c duelgdb.c
cp main.c duel_main.c

# (find-fline "/usr/src/redhat/BUILD/gdb-4.16/duel/INSTALL" 150)

cd /usr/src/redhat/BUILD/gdb-4.16/

# (find-fline "/usr/src/redhat/BUILD/gdb-4.16/gdb/top.c" 1529)

mgolan@ibm.net

Michael Golan mgolan@ibm.net  or  talsoft@ibm.net  or mg@cs.princeton.edu

http://www.math.tau.ac.il/~frangy/duel_man.html





########
#
# xduel (very old notes)
#
########

rpm -iv $RS/gdb-4.16-6.src.rpm
cd /usr/src/redhat/SPECS/
rpm -bc gdb-4.16.spec |& tee orbc-gdb

rpm -iv $RS/xxgdb-1.12-1.src.rpm
cd /usr/src/redhat/SPECS/
rpm -bc xxgdb-1.12.spec |& tee orbc-xxgdb

# (find-xdfile "INSTALL" 87)

# These patches must by applied (by hand):
#
# (find-xdfile "xduel_gdb_patch" 35)
# (find-gdbfile "gdb/Makefile" 186)
#
# (find-xdfile "xduel_gdb_patch" 52)
# (find-gdbfile "gdb/Makefile" 349)
#
# (find-xdfile "xduel_gdb_patch" 69)
# (find-gdbfile "gdb/Makefile" 474)

cd /usr/src/
rm -Rv xduel-2.14/
mkdir xduel-2.14/
cd xduel-2.14/
tar -xvZf /snarf/ftp/ftp.math.tau.ac.il/pub/amiram/xduel/xduel-2.14.tar.Z

cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
rm duel
rm duelgdb.c
ln -s /usr/src/xduel-2.14 duel
ln -s /usr/src/xduel-2.14/duelgdb.c .
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/duel/src/
make |& tee om
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/duel/
etags *.[ch] src/*.[ch]

cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
mv init.c init.c.0
make CFLAGS='-O2 -m486 -fno-strength-reduce' |& tee om2

# Problema 1: fazer o xduel não imprimir os drawing commands.
#
# (find-xdfile "src/Makefile" 14)
# (find-xdfile "src/xduel.c" 81)
# (find-xdtag "xdlbd_draw")
#
# Tenho que fazer os drawing commands não rodarem mas sem fazer com
# que o xduel chame os xdlbd_...'s.

# Problema 2: aparece por exemplo em
#
cd /usr/src/linux-2.0.30/
echo 'quit' | gdb -m vmlinux /proc/kcore
echo -e 'dl console_driver\nquit' | gdb vmlinux /proc/kcore
#
# (find-k2file "drivers/char/console.c" 121)
# e, pô, long long ints são importantes e deveriam estar sendo aceitos:
# (find-xdtag "duel_fatal")
# (find-xdfile "duelgdb.c" 490)
# (find-xdfile "duelgdb.c" 391)







# gcc -c xduel.c -o xduel.o
# make |& tee om2

# (find-xdfile "INSTALL")
# (find-xdfile "src/Makefile")
# (find-xdfile "xduelins.pl")

# I don't apply the '#' patch, but I keep the references anyway:
#     (find-xdfile "INSTALL" 244)
#     (find-xdfile "MANUAL" 139)
#     (find-xdfile "xduel_gdb_patch" 16)
#     (find-gdbfile "gdb/top.c" 2078)
#     (find-gdbfile "gdb/top.c" 2167)

# But I'd like to disable the output lines that control drawing...
# (find-xdfile "src/xduel.c" 209)
# (find-node "(gcc)Preprocessor Options" 143)

# (find-xdtag "main")





#############
#
# glibc docs
#
#############

mkdir glibc-2.0.5
ln -s /usr/info glibc-2.0.5/manual
tar -xvzf /snarf/ftp/prep.ai.mit.edu/pub/gnu/glibc-2.0.5.tar.gz \
  'glibc-2.0.5/manual/libc.info*'
rm glibc-2.0.5/manual
rmdir glibc-2.0.5

# (find-node "(libc)Top")




###########
#
# TXL 7.4
#
###########

cd /usr/src/
rm -Rv TXL7.4/
tar -xvzf /snarf/ftp/ftp.qucis.queensu.ca/pub/txl/7.4/TXL7.4.tar.Z
cd /usr/src/TXL7.4/csrc
make |& tee om




##########
#
# Yard 1.12a
#
##########

cd /usr/src/
rm -Rv yard-1.12a/
tar -xvzf /snarf/http/www.cs.umass.edu/~fawcett/yard/yard-1.12a.tar.gz
cd yard-1.12a/
tar -xvzf /snarf/http/www.cs.umass.edu/~fawcett/code/yard-prefabs-2.tar.gz
./configure |& tee oc
make |& tee om
make install |& tee omi





##################
#
# pcmcia-cs-2.9.7
#
##################

cd /usr/src/
rm -Rv pcmcia-cs-2.9.7/
tar -xvzf /snarf/ftp/hyper.stanford.edu/pub/pcmcia/pcmcia-cs-2.9.7.tar.gz
cd pcmcia-cs-2.9.7/
make config |& tee oc




############
#
# LATOS
#
#########

rm -Rv /usr/src/latos/
mkdir  /usr/src/latos/
cd     /usr/src/
tar -xvzf /snarf/http/www.ecs.soton.ac.uk/~phh/latos.tar.gz
cd     /usr/src/latos/
. make.sh |& tee om




##############
#
# Tunes (doc)
#
##############

rm -Rv /usr/src/Tunes
mkdir  /usr/src/Tunes
cd     /usr/src/Tunes/
tar -xvzf /snarf/http/www.eleves.ens.fr/home/rideau/Tunes/files/tgz/tunes.0.0.0.34.doc.tgz
cd /usr/src/Tunes/www/




#########
#
# X docs on redhat (old notes)
#
#########

rpm -iv $RS/XFree86-3.2-9.src.rpm
rpm -bp $RSP/XFree86-3.2.spec

XC=/usr/src/redhat/BUILD/XFree86-3.2/xc
imake -I$XC/config/cf/
make TOP=$XC PEXlib.txt

cd $XC/doc/specs/Xt/
imake -I$XC/config/cf/
rm intrinsics.txt
make TOP=$XC intrinsics.txt |& tee o

(find-xcfile "doc/specs/Xt/Makefile" "intrinsics.txt")

O diretório xc/config/cf/ fica no início do xc-1.tgz.
O xc-2 é principalmente fontes e specs.
O xc-3 tem doc/hardcopy e umas coisas tipo
xc/test/xsuite/xtest/tset/CH08/bttnprss/bttnprss.m que eu não
sei se são docs ou não.

make -f xmakefile  Makefiles
cd $RBU/XFree86-3.2/xc/doc/misc/
groff -Tascii -ms INSTALL.ms

make TOP=/usr/src/redhat/BUILD/XFree86-3.2/xc ddx.txt

(find-xcfile "INSTALL.TXT" 757)
(find-xcfile "config/cf/Project.tmpl" 1424)

(find-xcfile "Makefile")
(find-xcfile "xmakefile" 720)
(find-xcfile "doc/misc/INSTALL.ms")




#########
#
# fvwm configuration
#
#########

# (find-fline "~/.fvwmrc" "Now the title bar buttons")
# (find-fline "~/.fvwmrc" "move the pointer by 1% of a page")





#########
#
# lout docs
#
#########

rpm -iv $RP/lout-doc-3.08-1.i386.rpm
cd /usr/doc/lout/
cd design
lout all > outfile.ps
lout all > outfile.ps
lout all > outfile.ps
ps2v pngmono outfile.ps o%02d.png




############
#
# ascii->rtf (850)
#
############

cd ~
{
  echo '{\\rtf1\\pc'
  ~/ICON/codepages < paula1
  echo '}'
} > paula1.rtf

mcopy -ot paula1.rtf a:

# (find-fline "/S5/ed/word5/cena1.rtf")
# (find-fline "~/paula1.rtf")




#############
#
# lf -> cr+lf (with ffs)
#
#############

cd ~
for i (CARTAS/paula21 276 CARTAS/ze1 PERSONAL/98feb19)
do cat $i | \
   awk '{printf "  %s\r\n", $0}
        END {printf "\014"}'
done >& ~/o





#############
#
# XF86Config (automatic version)
#
#############

# (find-es "x" "auto-xf86config")

# (find-fline "~/NOTES/angg0" "xf86config <<EOF")

cp -ivs /usr/X11R6/bin/XF86_SVGA /usr/X11R6/bin/X
# (o próprio xf86config faz esse symlink).

# mouse 1 y n
# hsync 4
# vsync 2
# card 279

# RH42:
echo '\n1\ny\nn\n\ny\n\n1\n\n4\n2\n\n\n\ny\n279\n\n5\ny\n3\n\n\n\nq\n\ny\n\n5\ny' | xf86config

echo '
6
y
n

y

1

4
2



y
382

3
y
3



q

y




5
y' | strace -o s xf86config |& tee ~/o


\ny\n\n1\n\n4\n2\n\n\n\ny\n279\n\n5\ny\n3\n\n\n\nq\n\ny\n\n5\ny' | xf86config








#############
#
# XF86Config (my version)
#
#############

grep -v '^#' /etc/X11/XF86Config | l -s
# then save it manually as ~/XF86Config. No, it's better to:

awk 'BEGIN {this=""}
     $0 !~ /^[ \t]*#/ {
	prev=this;
	if((this=$0)=="" && prev=="")
	  {}
	else print $0;
     }'	\
  /etc/X11/XF86Config > ~/XF86Config

cd /usr/X11R6/bin/
for i (*); do man $i ; done

xdpyinfo -display :0.0 -ext XFree86-VidModeExtension | tail -n 3

# (find-node "(gawk)Regexp Operators" "`*'")
# (find-fline "~/XF86Config")

cp -iv ~/XF86Config ~/XF86Config.angg



################
#
# glimpse/agrep
#
################

rpm -iv /snarf/ftp/ftp.redhat.com/pub/contrib/SRPMS/glimpse-4.0-4.src.rpm
rpm -bi $RSP/glimpse-4.0.spec

cd $RBU
rm -Rv glimpse-4.0.src/
tar -xvzf $RSO/glimpse-4.0.src.tar.Z
cd $RBU/glimpse-4.0.src/
./configure |& tee oc
make |& tee om
#
cd $RBU/glimpse-4.0.src/
cp -v index/glimpseindex glimpse agrep/agrep bin/
strip bin/*
cd $RBU/glimpse-4.0.src/bin/
cp -v agrep glimpse glimpseindex /usr/local/bin/
cd $RBU/glimpse-4.0.src/
cp -v agrep/agrep.1 glimpse.1 glimpseindex.1 /usr/local/man/man1/

# (find-fline "$RBU/glimpse-4.0.src/Makefile.in" "install:")





########
#
# siag
#
########

rpm -iv -h	\
	$RP/db-1.85-10.i386.rpm	\
	$RP/db-devel-1.85-10.i386.rpm	\
	$RP/xpm-3.4i-1.i386.rpm	\
	$RP/xpm-devel-3.4i-1.i386.rpm	\
	$RP/Xaw3d-devel-1.3-6.i386.rpm	\

cd /usr/src/
rm -Rv siag/
tar -xvzf /snarf/ftp/ftp.edu.stockholm.se/pub/siag/siag-2.71.tar.gz
tar -xvzf /snarf/ftp/ftp.edu.stockholm.se/pub/siag/tsiag-2.70.tar.gz
tar -xvzf /snarf/ftp/ftp.edu.stockholm.se/pub/siag/gsiag-2.70.tar.gz
cd /usr/src/siag/
xmkmf
make Makefiles
make depend |& tee od
make all

cd /usr/src/siag/siod/
xmkmf
make |& tee o
cd /usr/src/siag/common/
xmkmf
make |& tee o
cd /usr/src/siag/siag/
xmkmf
make |& tee o
cd /usr/src/siag/tsiag/
xmkmf
make |& tee o


rpm -iv /snarf/ftp/ftp.redhat.com/pub/contrib/SRPMS/guile-1.2-2.src.rpm
cd $RSP
rpm -bb guile-1.2-2.spec |& tee obbguile

# (find-node "(guile-ref)Top")
# (find-node "(guile-tut)Top")

lynx /usr/src/siag/siag/docs/siag.html
lynx /usr/src/siag/siod/siod.html
lynx /usr/src/siag/common/docs/siaghelp.html
lynx /usr/src/siag/pw/docs/intro.html
lynx /usr/src/siag/egon/docs/intro.html




#####
#
# gcc hacking: intermediate rtl code
#
#####

# (find-node "(gcc)Option Summary")
# (find-node "(gcc)Option Summary" "-dD")
# (find-node "(gcc)Preprocessor Options" "-H")

# (find-node "(gcc)Debugging Options" "-dLETTERS")

# (find-fline "~/C/fontimage.c")
cd /tmp
cp ~/C/fontimage.c .
gcc -I/usr/lib/icon/ipl/packs/loadfunc/ -da -c fontimage.c

cd /tmp
cp ~/C/fontimage.c .
strace-to ~/s gcc -I/usr/lib/icon/ipl/packs/loadfunc/ -da fontimage.c
grep fontimage ~/s

cd /tmp/
for i in rtl jump cse loop cse2 flow combine sched lreg greg sched2 \
  jump2 dbr stack; do laf fontimage.c.$i; done

function diffc () {
  diff fontimage.c.$1 fontimage.c.$2
}
diffc	rtl	jump
diffc	jump	cse
diffc	cse	loop
diffc	loop	cse2
diffc	cse2	flow
diffc	flow	combine
diffc	combine	sched
diffc	sched	lreg
diffc	lreg	greg

# diffc	greg	sched2
# diffc	sched2	jump2
diffc	greg	jump2

# diffc	jump2	dbr
# diffc	dbr	stack
diffc	jump2	stack




#####
#
# lcc 4.1
#
#####

# «lcc»  (to ".lcc")
#
rm -Rv /usr/src/lcc-4.1/
mkdir /usr/src/lcc-4.1/
cd /usr/src/lcc-4.1/
tar -xvzf /snarf/ftp/ftp.cs.princeton.edu/pub/packages/lcc/4.1.tar.gz

(cd doc; lynx -dump install.html > install.txt)

export BUILDDIR=build/linux-i386

mkdir -p $BUILDDIR/include/
cp -Rv include/x86/linux/* $BUILDDIR/include/
ln -s /usr/lib/gcc-lib/i386-linux/2.95.2 $BUILDDIR/gcc

# (find-lccfile "etc/linux.c" "LCCDIR")
# rm -fv $BUILDDIR/host.o
make HOSTFILE=etc/linux.c CFLAGS="-g -DLCCDIR=\\\"$BUILDDIR/\\\"" all \
  |& tee oma

#
cat > x.c <<'---'
/* #include <stdio.h> */
int printf(char *, ...);
int main() {
  printf("Hello!\n");
  return 0;
}
---
$BUILDDIR/lcc -v -o x x.c
./x

#

# (code-c-d "lcc" "/usr/src/lcc-4.1/")
# (find-lccfile "")
# (find-lccfile "doc/install.txt")
# (find-lccfile "doc/install.txt" "1. Create the build directory")
# (find-lccfile "makefile")
# (find-lccfile "etc/linux.c")





########
#
# lcc 4.0
#
########

rm -Rv /usr/local/lib/lcc-4.0 /usr/bin/{bprint,lburg,lcc}
ln -s  /usr/src/lcc-4.0/locallib /usr/local/lib/lcc-4.0

cd /usr/src/
rm -Rv lcc-4.0/
mkdir lcc-4.0/
cd /usr/src/lcc-4.0/
tar -xvzf /snarf/ftp/ftp.cs.princeton.edu/pub/packages/lcc/4.0.tar.gz
tar -xvzf /snarf/ftp/ftp.cs.princeton.edu/pub/packages/lcc/contrib/lcc-4.0-linux-i386.tar.gz

# (find-fline "/usr/src/lcc-4.0/README.linux")
# (find-fline "/usr/src/lcc-4.0/makefile")
# (find-fline "/usr/src/lcc-4.0/etc/lcc.c")
# (find-fline "/usr/src/lcc-4.0/etc/linux.c")

cd /usr/src/lcc-4.0/
mkdir locallib

export BUILDDIR=x86/linux-libc
make HOSTFILE=etc/linux.c all	|& tee om

mkdir -p /usr/local/lib/lcc-4.0/include
cp -r include/x86/linux-libc/* /usr/local/lib/lcc-4.0/include
cp -v x86/linux-libc/{rcc,cpp,liblcc.a} /usr/local/lib/lcc-4.0/
ln -s /usr/src/lcc-4.0/x86/linux-libc/lcc	/usr/bin/lcc
ln -s /usr/src/lcc-4.0/x86/linux-libc/lburg	/usr/bin/lburg
ln -s /usr/src/lcc-4.0/x86/linux-libc/bprint	/usr/bin/bprint


# Tests:

cd ~/C
lcc -o - -S type.c
lcc -o type type.c

agrep /usr/local $(find * -name '*.[ch]')




#####
#
# peep
# 2000apr11
#
#####

# «peep»

rm -Rv /usr/src/peep-0.5.2/
cd /usr/src/
tar -xvzf $S/http/sdf.lonestar.org/~bholdr/peep/peep-0.5.2.tar.gz
cd /usr/src/peep-0.5.2/
# make linux-gcc-dynamic			|& tee oml
make CFLAGS.GCC="-g -Wall" linux-gcc-dynamic	|& tee oml


# (code-c-d "peep" "/usr/src/peep-0.5.2/")
# (find-peepfile "")
# (find-peepfile "peep-0.5.2.ReadMe")
# (find-peepfile "peep-0.5.2.ReadMe" "File fds are opened")
# (find-peepfile "peep-0.5.2.ReadMe" "while logging")
# (find-peepfile "peep-0.5.2.ReadMe" "sniff")
# (gdb "gdb /usr/src/peep-0.5.2/peep")

%
set args -fC 0 -fC 1 -fC 2 -e /bin/echo
#br main
br 202
run
%


cd /usr/src/peep-0.5.2/
peep -c sSe -e /usr/bin/expect

cd /usr/src/peep-0.5.2/
peep -fC 0 -fC 1 -fC 2 -e expect

cd /usr/src/peep-0.5.2/
peep -fC 0 -fC 1 -fC 2 -io f1/s:f2/S:f3/e -e expect


# (find-peepfile "peep-0.5.2.ReadMe" "while logging")




#  Local Variables:
#  coding:               utf-8-unix
#  End:
