#######
#
# E-scripts on interactive geometry programs.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/geometry.e>
#           or at <http://angg.twu.net/e/geometry.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.drgeo»		(to "drgeo")
# «.geogebra»		(to "geogebra")
# «.fnaufel-ggtex»	(to "fnaufel-ggtex")

# http://en.wikipedia.org/wiki/Interactive_geometry_software
# http://en.wikipedia.org/wiki/Interactive_geometry_software#Dr._Geo
# http://en.wikipedia.org/wiki/Interactive_geometry_software#GeoGebra




#####
#
# DrGeo
# 2013jan02
#
#####

# «drgeo» (to ".drgeo")
# (find-available "drgeo")

# (find-status   "drgeo")
# (find-vldifile "drgeo.list")
# (find-udfile   "drgeo/")
# (find-status   "drgeo-doc")
# (find-vldifile "drgeo-doc.list")
# (find-udfile   "drgeo-doc/")
# file:///usr/share/drgeo/help/c/contents.html

# (find-fline "/usr/share/drgeo/examples/")
# (find-fline "/usr/share/drgeo/examples/figures/")
# (find-fline "/usr/share/drgeo/examples/macros/")
# (find-fline "/usr/share/drgeo/examples/scheme/")



#####
#
# Geogebra
# 2012oct24 / 2021sep19
#
#####

# «geogebra» (to ".geogebra")
# (find-es "geogebra")





#####
#
# fnaufel-ggtex
# 2021aug25
#
#####

# «fnaufel-ggtex»  (to ".fnaufel-ggtex")
# https://github.com/fnaufel/ggtex
# https://github.com/fnaufel?tab=repositories




#  Local Variables:
#  coding:               utf-8-unix
#  End:
