#######
#
# E-scripts on gnuplot.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/gnuplot.e>
#           or at <http://angg.twu.net/e/gnuplot.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.gnuplot-doc»	(to "gnuplot-doc")
# «.examples»		(to "examples")
# «.test-blocks»	(to "test-blocks")
# «.mailing-lists»	(to "mailing-lists")
# «.gnuplot-mode»	(to "gnuplot-mode")
# «.ploticus»		(to "ploticus")
# «.gnuplot-4.0»	(to "gnuplot-4.0")
# «.parabola»		(to "parabola")
# «.noraise»		(to "noraise")
# «.gnuplottex»		(to "gnuplottex")
# «.gnuplot-git»	(to "gnuplot-git")
# «.pager-cat»		(to "pager-cat")
# «.gnuplotlatexdemo»	(to "gnuplotlatexdemo")
# «.tikz»		(to "tikz")

# (find-es "lua5" "lua-gnuplot")
# (find-es "maxima")
# (find-esgrep "grep -nH -e gnuplot *.e")







# (find-zsh "installeddebs | sort | grep gnuplot")
# (find-zsh "availabledebs | sort | grep gnuplot")

gnuplot-doc
gnuplot-mode
gnuplot-nox
gnuplot-x11
gnuplot

apti gnuplot-doc gnuplot-mode gnuplot-nox gnuplot-x11 gnuplot

# (find-status   "gnuplot-doc")
# (find-vldifile "gnuplot-doc.list")
# (find-udfile   "gnuplot-doc/")
# (find-status   "gnuplot-mode")
# (find-vldifile "gnuplot-mode.list")
# (find-udfile   "gnuplot-mode/")
# (find-status   "gnuplot-nox")
# (find-vldifile "gnuplot-nox.list")
# (find-udfile   "gnuplot-nox/")
# (find-status   "gnuplot-x11")
# (find-vldifile "gnuplot-x11.list")
# (find-udfile   "gnuplot-x11/")
# (find-status   "gnuplot")
# (find-vldifile "gnuplot.list")
# (find-udfile   "gnuplot/")

# (find-udfile "gnuplot-doc/htmldocs/")
# (find-fline "/usr/share/doc/gnuplot-doc/examples/")




#####
#
# gnuplot-doc
# 2021dec12
#
#####

# «gnuplot-doc»  (to ".gnuplot-doc")
# (find-status   "gnuplot-doc")
# (find-vldifile "gnuplot-doc.list")
# (find-udfile   "gnuplot-doc/")
# (find-node "(gnuplot)Top")
# (find-udfile "gnuplot/examples/")
# (find-udfile "gnuplot/examples/airfoil.dem")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/usr/share/doc/gnuplot/examples/")
cd /usr/share/doc/gnuplot/examples/

gnuplot airfoil.dem

# (find-udfile "gnuplot/examples/dgrid3d.dem")
cd /usr/share/doc/gnuplot/examples/
gnuplot dgrid3d.dem

# (find-fline "/usr/share/doc/gnuplot/examples/kdensity2d.dem")
gnuplot        /usr/share/doc/gnuplot/examples/kdensity2d.dem

# (find-fline "/usr/share/doc/gnuplot/examples/scatter.dem")
gnuplot        /usr/share/doc/gnuplot/examples/scatter.dem

# (find-fline "/usr/share/doc/gnuplot/examples/complex_trig.dem")
gnuplot        /usr/share/doc/gnuplot/examples/complex_trig.dem



#####
#
# examples
# 2021dec15
#
#####

# «examples»  (to ".examples")
# (find-fline "/usr/share/doc/gnuplot/examples/")
# (code-c-d "gnuplotex" "/usr/share/doc/gnuplot/examples/")
# (find-gnuplotexfile "")


# (find-man "gnuplot")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /usr/share/doc/gnuplot/examples/
for i in *.dem; do
  printf 'rank 0; gnuplot %-30s;# (find-gnuplotex "%s")\n' $i $i
done

cd /usr/share/doc/gnuplot/examples/
function rank () { }

rank 2; gnuplot prob.dem                      ;# (find-gnuplotexfile "prob.dem")
rank 2; gnuplot scatter.dem                   ;# (find-gnuplotexfile "scatter.dem")
rank 2; gnuplot short_vector.dem              ;# (find-gnuplotexfile "short_vector.dem")
rank 2; gnuplot projection.dem                ;# (find-gnuplotexfile "projection.dem")

rank 3; gnuplot surface1.dem                  ;# (find-gnuplotexfile "surface1.dem")
rank 3; gnuplot surface2.dem                  ;# (find-gnuplotexfile "surface2.dem")
rank 5; gnuplot polygons.dem                  ;# (find-gnuplotexfile "polygons.dem")

rank 0; gnuplot airfoil.dem                   ;# (find-gnuplotexfile "airfoil.dem")
rank 0; gnuplot all.dem                       ;# (find-gnuplotexfile "all.dem")
rank 0; gnuplot animate.dem                   ;# (find-gnuplotexfile "animate.dem")
rank 0; gnuplot approximate.dem               ;# (find-gnuplotexfile "approximate.dem")
rank 0; gnuplot array.dem                     ;# (find-gnuplotexfile "array.dem")
rank 0; gnuplot arrowstyle.dem                ;# (find-gnuplotexfile "arrowstyle.dem")
rank 0; gnuplot autoscale.dem                 ;# (find-gnuplotexfile "autoscale.dem")
rank 0; gnuplot azimuth.dem                   ;# (find-gnuplotexfile "azimuth.dem")
rank 0; gnuplot barchart_art.dem              ;# (find-gnuplotexfile "barchart_art.dem")
rank 0; gnuplot bins.dem                      ;# (find-gnuplotexfile "bins.dem")
rank 0; gnuplot bivariat.dem                  ;# (find-gnuplotexfile "bivariat.dem")
rank 0; gnuplot bolditalic.dem                ;# (find-gnuplotexfile "bolditalic.dem")
rank 0; gnuplot borders.dem                   ;# (find-gnuplotexfile "borders.dem")
rank 0; gnuplot boxes3d.dem                   ;# (find-gnuplotexfile "boxes3d.dem")
rank 0; gnuplot boxplot.dem                   ;# (find-gnuplotexfile "boxplot.dem")
rank 0; gnuplot break_continue.dem            ;# (find-gnuplotexfile "break_continue.dem")
rank 0; gnuplot callargs.dem                  ;# (find-gnuplotexfile "callargs.dem")
rank 0; gnuplot candlesticks.dem              ;# (find-gnuplotexfile "candlesticks.dem")
rank 0; gnuplot charset.dem                   ;# (find-gnuplotexfile "charset.dem")
rank 0; gnuplot circles.dem                   ;# (find-gnuplotexfile "circles.dem")
rank 0; gnuplot cities.dem                    ;# (find-gnuplotexfile "cities.dem")
rank 0; gnuplot clip_radial.dem               ;# (find-gnuplotexfile "clip_radial.dem")
rank 0; gnuplot clipobject.dem                ;# (find-gnuplotexfile "clipobject.dem")
rank 0; gnuplot colorscheme.dem               ;# (find-gnuplotexfile "colorscheme.dem")
rank 0; gnuplot colorwheel.dem                ;# (find-gnuplotexfile "colorwheel.dem")
rank 0; gnuplot columnhead.dem                ;# (find-gnuplotexfile "columnhead.dem")
rank 0; gnuplot complex_trig.dem              ;# (find-gnuplotexfile "complex_trig.dem")
rank 0; gnuplot contours.dem                  ;# (find-gnuplotexfile "contours.dem")
rank 0; gnuplot controls.dem                  ;# (find-gnuplotexfile "controls.dem")
rank 0; gnuplot custom_contours.dem           ;# (find-gnuplotexfile "custom_contours.dem")
rank 0; gnuplot custom_key.dem                ;# (find-gnuplotexfile "custom_key.dem")
rank 0; gnuplot dashcolor.dem                 ;# (find-gnuplotexfile "dashcolor.dem")
rank 0; gnuplot dashtypes.dem                 ;# (find-gnuplotexfile "dashtypes.dem")
rank 0; gnuplot datastrings.dem               ;# (find-gnuplotexfile "datastrings.dem")
rank 0; gnuplot electron.dem                  ;# (find-gnuplotexfile "electron.dem")
rank 0; gnuplot ellipse.dem                   ;# (find-gnuplotexfile "ellipse.dem")
rank 0; gnuplot ellipses_style.dem            ;# (find-gnuplotexfile "ellipses_style.dem")
rank 0; gnuplot enhanced_utf8.dem             ;# (find-gnuplotexfile "enhanced_utf8.dem")
rank 0; gnuplot enhancedtext.dem              ;# (find-gnuplotexfile "enhancedtext.dem")
rank 0; gnuplot errorbars.dem                 ;# (find-gnuplotexfile "errorbars.dem")
rank 0; gnuplot fenceplot.dem                 ;# (find-gnuplotexfile "fenceplot.dem")
rank 0; gnuplot fillbetween.dem               ;# (find-gnuplotexfile "fillbetween.dem")
rank 0; gnuplot fillcrvs.dem                  ;# (find-gnuplotexfile "fillcrvs.dem")
rank 0; gnuplot fillstyle.dem                 ;# (find-gnuplotexfile "fillstyle.dem")
rank 0; gnuplot finance.dem                   ;# (find-gnuplotexfile "finance.dem")
rank 0; gnuplot fit.dem                       ;# (find-gnuplotexfile "fit.dem")
rank 0; gnuplot gantt.dem                     ;# (find-gnuplotexfile "gantt.dem")
rank 0; gnuplot heatmaps.dem                  ;# (find-gnuplotexfile "heatmaps.dem")
rank 0; gnuplot hidden_compare.dem            ;# (find-gnuplotexfile "hidden_compare.dem")
rank 0; gnuplot histograms.dem                ;# (find-gnuplotexfile "histograms.dem")
rank 0; gnuplot histograms2.dem               ;# (find-gnuplotexfile "histograms2.dem")
rank 0; gnuplot hypertext.dem                 ;# (find-gnuplotexfile "hypertext.dem")
rank 0; gnuplot image.dem                     ;# (find-gnuplotexfile "image.dem")
rank 0; gnuplot image2.dem                    ;# (find-gnuplotexfile "image2.dem")
rank 0; gnuplot imageNaN.dem                  ;# (find-gnuplotexfile "imageNaN.dem")
rank 0; gnuplot int64.dem                     ;# (find-gnuplotexfile "int64.dem")
rank 0; gnuplot iterate.dem                   ;# (find-gnuplotexfile "iterate.dem")
rank 0; gnuplot jitter.dem                    ;# (find-gnuplotexfile "jitter.dem")
rank 0; gnuplot kdensity2d.dem                ;# (find-gnuplotexfile "kdensity2d.dem")
rank 0; gnuplot key.dem                       ;# (find-gnuplotexfile "key.dem")
rank 0; gnuplot keyentry.dem                  ;# (find-gnuplotexfile "keyentry.dem")
rank 0; gnuplot label_stacked_histograms.dem  ;# (find-gnuplotexfile "label_stacked_histograms.dem")
rank 0; gnuplot layout.dem                    ;# (find-gnuplotexfile "layout.dem")
rank 0; gnuplot lines_arrows.dem              ;# (find-gnuplotexfile "lines_arrows.dem")
rank 0; gnuplot linked_autoscale.dem          ;# (find-gnuplotexfile "linked_autoscale.dem")
rank 0; gnuplot logscale_clipping.dem         ;# (find-gnuplotexfile "logscale_clipping.dem")
rank 0; gnuplot macros.dem                    ;# (find-gnuplotexfile "macros.dem")
rank 0; gnuplot margins.dem                   ;# (find-gnuplotexfile "margins.dem")
rank 0; gnuplot matrix_every.dem              ;# (find-gnuplotexfile "matrix_every.dem")
rank 0; gnuplot matrix_index.dem              ;# (find-gnuplotexfile "matrix_index.dem")
rank 0; gnuplot mgr.dem                       ;# (find-gnuplotexfile "mgr.dem")
rank 0; gnuplot molecule.dem                  ;# (find-gnuplotexfile "molecule.dem")
rank 0; gnuplot monotonic_spline.dem          ;# (find-gnuplotexfile "monotonic_spline.dem")
rank 0; gnuplot mouselabels.dem               ;# (find-gnuplotexfile "mouselabels.dem")
rank 0; gnuplot mousevariables.dem            ;# (find-gnuplotexfile "mousevariables.dem")
rank 0; gnuplot multiaxis.dem                 ;# (find-gnuplotexfile "multiaxis.dem")
rank 0; gnuplot multipalette.dem              ;# (find-gnuplotexfile "multipalette.dem")
rank 0; gnuplot multiplt.dem                  ;# (find-gnuplotexfile "multiplt.dem")
rank 0; gnuplot named_var.dem                 ;# (find-gnuplotexfile "named_var.dem")
rank 0; gnuplot nokey.dem                     ;# (find-gnuplotexfile "nokey.dem")
rank 0; gnuplot nonlinear1.dem                ;# (find-gnuplotexfile "nonlinear1.dem")
rank 0; gnuplot nonlinear2.dem                ;# (find-gnuplotexfile "nonlinear2.dem")
rank 0; gnuplot nonlinear3.dem                ;# (find-gnuplotexfile "nonlinear3.dem")
rank 0; gnuplot nonlinear5.dem                ;# (find-gnuplotexfile "nonlinear5.dem")
rank 0; gnuplot nonlinear6.dem                ;# (find-gnuplotexfile "nonlinear6.dem")
rank 0; gnuplot orbits.dem                    ;# (find-gnuplotexfile "orbits.dem")
rank 0; gnuplot overflow.dem                  ;# (find-gnuplotexfile "overflow.dem")
rank 0; gnuplot parallel.dem                  ;# (find-gnuplotexfile "parallel.dem")
rank 0; gnuplot param.dem                     ;# (find-gnuplotexfile "param.dem")
rank 0; gnuplot pm3d_lighting.dem             ;# (find-gnuplotexfile "pm3d_lighting.dem")
rank 0; gnuplot pointsize.dem                 ;# (find-gnuplotexfile "pointsize.dem")
rank 0; gnuplot polar.dem                     ;# (find-gnuplotexfile "polar.dem")
rank 0; gnuplot polar_quadrants.dem           ;# (find-gnuplotexfile "polar_quadrants.dem")
rank 0; gnuplot poldat.dem                    ;# (find-gnuplotexfile "poldat.dem")
rank 0; gnuplot prob2.dem                     ;# (find-gnuplotexfile "prob2.dem")
rank 0; gnuplot probably_tux.dem              ;# (find-gnuplotexfile "probably_tux.dem")
rank 0; gnuplot rainbow.dem                   ;# (find-gnuplotexfile "rainbow.dem")
rank 0; gnuplot random.dem                    ;# (find-gnuplotexfile "random.dem")
rank 0; gnuplot rectangle.dem                 ;# (find-gnuplotexfile "rectangle.dem")
rank 0; gnuplot rgb_variable.dem              ;# (find-gnuplotexfile "rgb_variable.dem")
rank 0; gnuplot rgbalpha.dem                  ;# (find-gnuplotexfile "rgbalpha.dem")
rank 0; gnuplot rugplot.dem                   ;# (find-gnuplotexfile "rugplot.dem")
rank 0; gnuplot running_avg.dem               ;# (find-gnuplotexfile "running_avg.dem")
rank 0; gnuplot sampling.dem                  ;# (find-gnuplotexfile "sampling.dem")
rank 0; gnuplot smooth_splines.dem            ;# (find-gnuplotexfile "smooth_splines.dem")
rank 0; gnuplot smooth_zsort.dem              ;# (find-gnuplotexfile "smooth_zsort.dem")
rank 0; gnuplot solar_path.dem                ;# (find-gnuplotexfile "solar_path.dem")
rank 0; gnuplot special_chars.dem             ;# (find-gnuplotexfile "special_chars.dem")
rank 0; gnuplot spiderplot.dem                ;# (find-gnuplotexfile "spiderplot.dem")
rank 0; gnuplot spline.dem                    ;# (find-gnuplotexfile "spline.dem")
rank 0; gnuplot stats.dem                     ;# (find-gnuplotexfile "stats.dem")
rank 0; gnuplot steps.dem                     ;# (find-gnuplotexfile "steps.dem")
rank 0; gnuplot textbox.dem                   ;# (find-gnuplotexfile "textbox.dem")
rank 0; gnuplot textcolor.dem                 ;# (find-gnuplotexfile "textcolor.dem")
rank 0; gnuplot tics.dem                      ;# (find-gnuplotexfile "tics.dem")
rank 0; gnuplot timedat.dem                   ;# (find-gnuplotexfile "timedat.dem")
rank 0; gnuplot unicode.dem                   ;# (find-gnuplotexfile "unicode.dem")
rank 0; gnuplot using.dem                     ;# (find-gnuplotexfile "using.dem")
rank 0; gnuplot utf8.dem                      ;# (find-gnuplotexfile "utf8.dem")
rank 0; gnuplot varcolor.dem                  ;# (find-gnuplotexfile "varcolor.dem")
rank 0; gnuplot vector.dem                    ;# (find-gnuplotexfile "vector.dem")
rank 0; gnuplot violinplot.dem                ;# (find-gnuplotexfile "violinplot.dem")
rank 0; gnuplot voxel.dem                     ;# (find-gnuplotexfile "voxel.dem")
rank 0; gnuplot vplot.dem                     ;# (find-gnuplotexfile "vplot.dem")
rank 0; gnuplot world.dem                     ;# (find-gnuplotexfile "world.dem")
rank 0; gnuplot world2.dem                    ;# (find-gnuplotexfile "world2.dem")
rank 0; gnuplot zerror.dem                    ;# (find-gnuplotexfile "zerror.dem")

rank 1; gnuplot animate2.dem                  ;# (find-gnuplotexfile "animate2.dem")
rank 1; gnuplot armillary.dem                 ;# (find-gnuplotexfile "armillary.dem")
rank 1; gnuplot boxclusters.dem               ;# (find-gnuplotexfile "boxclusters.dem")
rank 1; gnuplot dgrid3d.dem                   ;# (find-gnuplotexfile "dgrid3d.dem")
rank 1; gnuplot discrete.dem                  ;# (find-gnuplotexfile "discrete.dem")
rank 1; gnuplot hidden.dem                    ;# (find-gnuplotexfile "hidden.dem")
rank 1; gnuplot hidden2.dem                   ;# (find-gnuplotexfile "hidden2.dem")
rank 1; gnuplot isosurface.dem                ;# (find-gnuplotexfile "isosurface.dem")
rank 1; gnuplot map_projection.dem            ;# (find-gnuplotexfile "map_projection.dem")
rank 1; gnuplot nonlinear4.dem                ;# (find-gnuplotexfile "nonlinear4.dem")
rank 1; gnuplot piecewise.dem                 ;# (find-gnuplotexfile "piecewise.dem")
rank 1; gnuplot pixmap.dem                    ;# (find-gnuplotexfile "pixmap.dem")
rank 1; gnuplot pm3d.dem                      ;# (find-gnuplotexfile "pm3d.dem")
rank 1; gnuplot pm3d_clip.dem                 ;# (find-gnuplotexfile "pm3d_clip.dem")
rank 1; gnuplot pm3dcolors.dem                ;# (find-gnuplotexfile "pm3dcolors.dem")
rank 1; gnuplot pm3dgamma.dem                 ;# (find-gnuplotexfile "pm3dgamma.dem")
rank 1; gnuplot rgba_lines.dem                ;# (find-gnuplotexfile "rgba_lines.dem")
rank 1; gnuplot rotate_labels.dem             ;# (find-gnuplotexfile "rotate_labels.dem")
rank 1; gnuplot sampling2.dem                 ;# (find-gnuplotexfile "sampling2.dem")
rank 1; gnuplot simple.dem                    ;# (find-gnuplotexfile "simple.dem")
rank 1; gnuplot singulr.dem                   ;# (find-gnuplotexfile "singulr.dem")
rank 1; gnuplot smooth.dem                    ;# (find-gnuplotexfile "smooth.dem")
rank 1; gnuplot stringvar.dem                 ;# (find-gnuplotexfile "stringvar.dem")
rank 1; gnuplot textrotate.dem                ;# (find-gnuplotexfile "textrotate.dem")
rank 1; gnuplot transparent.dem               ;# (find-gnuplotexfile "transparent.dem")
rank 1; gnuplot transparent_solids.dem        ;# (find-gnuplotexfile "transparent_solids.dem")
rank 1; gnuplot ttics.dem                     ;# (find-gnuplotexfile "ttics.dem")
rank 1; gnuplot volatile.dem                  ;# (find-gnuplotexfile "volatile.dem")
rank 1; gnuplot walls.dem                     ;# (find-gnuplotexfile "walls.dem")

rank err; gnuplot binary.dem                    ;# (find-gnuplotexfile "binary.dem")
rank err; gnuplot cerf.dem                      ;# (find-gnuplotexfile "cerf.dem")
rank err; gnuplot epslatex.dem                  ;# (find-gnuplotexfile "epslatex.dem")
rank err; gnuplot fitmulti.dem                  ;# (find-gnuplotexfile "fitmulti.dem")
rank err; gnuplot fontfile.dem                  ;# (find-gnuplotexfile "fontfile.dem")
rank err; gnuplot fontfile_latex.dem            ;# (find-gnuplotexfile "fontfile_latex.dem")
rank err; gnuplot linkedaxes.dem                ;# (find-gnuplotexfile "linkedaxes.dem")
rank err; gnuplot mouselab_1.dem                ;# (find-gnuplotexfile "mouselab_1.dem")
rank err; gnuplot mouselab_2.dem                ;# (find-gnuplotexfile "mouselab_2.dem")
rank err; gnuplot solar_params.dem              ;# (find-gnuplotexfile "solar_params.dem")




#####
#
# test-blocks
# 2021dec16
#
#####

# «test-blocks»  (to ".test-blocks")
# (code-c-d "gnuplotex" "/usr/share/doc/gnuplot/examples/")
# (find-gnuplotexfile "")
# (find-fline "/usr/share/doc/gnuplot/examples/polygons.dem")
# (find-gnuplotexfile "polygons.dem")

# (find-angg "GNUPLOT/a.dem")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
laf   /usr/share/doc/gnuplot/examples/*.dat
A=(
  /usr/share/doc/gnuplot/examples/icosahedron.dat
  /usr/share/doc/gnuplot/examples/truncated_cube.dat
  /usr/share/doc/gnuplot/examples/dodecahedron.dat
  /usr/share/doc/gnuplot/examples/whale.dat
)
cp -v $A ~/GNUPLOT/




#####
#
# mailing-lists
# 2021dec12
#
#####

# «mailing-lists»  (to ".mailing-lists")
# http://sourceforge.net/mail/?group_id=2055



#####
#
# gnuplot
# 2004may05
#
#####

# (find-status   "gnuplot")
# (find-vldifile "gnuplot.list")
# (find-fline "/usr/doc/gnuplot/")
# (find-fline "/usr/doc/gnuplot/examples/")

# (find-status   "gnuplot-doc")
# (find-vldifile "gnuplot-doc.list")
# (find-udfile   "gnuplot-doc/")

# (find-status   "gnuplot-nox")
# (find-vldifile "gnuplot-nox.list")
# (find-udfile   "gnuplot-nox/")
# (find-status   "gnuplot-x11")
# (find-vldifile "gnuplot-x11.list")
# (find-udfile   "gnuplot-x11/")

# (find-fline "/usr/share/gnuplot/gnuplot.gih")
# (find-man "1 gnuplot")
# (find-man "1 lasergnu")

#
rm -Rv  /tmp/gnuplot-doc/
mkdir   /tmp/gnuplot-doc/
cp -ivR /usr/share/doc/gnuplot-doc/examples/* /tmp/gnuplot-doc
gunzip -rv /tmp/gnuplot-doc/
cd      /tmp/gnuplot-doc/

#
# (find-fline "/tmp/gnuplot-doc/")

# Avoid repetitions and avoid a demo that never ends
# (find-node "(gnuplot)Top")
# (find-node "(gnuplot)x11")
# (find-node "(gnuplot)terminal")

cd /tmp/gnuplot-doc/examples/
mv -v all.dem all.demos
mv -v borders.dem borders.evildemo

echo 'set terminal x11' > x11
for i in *.dem; do
  echo $i
  gnuplot x11 $i
done

#

(defun find-gnuplothelp (tag &rest rest)
  (apply 'find-fline "/usr/share/gnuplot/gnuplot.gih"
         (if tag (format "\n?%s\n" tag))
         rest))

(find-gnuplothelp "title")
(find-gnuplothelp "set xrange")
(find-gnuplothelp "plot datafile using")

#
cd /tmp/
cat > L.dat <<'%%%'
2 1
1 1
1 2
1 3
%%%
cat > sqrt.dat <<'%%%'
1.5 2.5
2   1.5
2.5 2.5
3.5 2.5
%%%

#
cd /tmp/
PAGER=cat gnuplot
set terminal 11
set xrange [-5:+5]
set yrange [-5:+5]
set xzeroaxis 1
set yzeroaxis 1
set grid
plot "L.dat" with linespoints
replot "sqrt.dat" with linespoints



set trange [0: 2*pi]

set xrange [-5:+5]
set yrange [-5:+5]



set title ""
set xlab ""
set key box
set parametric
set samples 100
set isosamples 10
set data style lines
set function style lines
pause 0  "Joukowski Airfoil using Complex Variables" 
set title "Joukowski Airfoil using Complex Variables" 0,0
set time
set yrange [-.2 : 1.8]
set trange [0: 2*pi]
set xrange [-.6:.6]
zeta(t) = -eps + (a+eps)*exp(t*{0,1})
eta(t) = zeta(t) + a*a/zeta(t)
eps = 0.06
a =.250
set xlabel "eps = 0.06 real"
plot real(eta(t)),imag(eta(t))
pause -1 "Press Return"
eps = 0.06*{1,-1}
set xlabel "eps = 0.06 + i0.06"
plot real(eta(t)),imag(eta(t))
pause -1 "Press Return"
reset





#####
#
# gnuplot-mode
# 2009oct21
#
#####

# «gnuplot-mode»  (to ".gnuplot-mode")
# (find-status "gnuplot-mode")
# (find-vldifile "gnuplot-mode.list")
# (find-fline "/usr/doc/gnuplot-mode/")



# «ploticus»  (to ".ploticus")
# (find-status "ploticus")
# (find-vldifile "ploticus.list")
# (find-fline "/usr/doc/ploticus/")
# (find-status "ploticus-doc")
# (find-vldifile "ploticus-doc.list")
# (find-fline "/usr/doc/ploticus-doc/")





#####
#
# gnuplot 4.0 source
# 2004may05
#
#####

# «gnuplot-4.0»  (to ".gnuplot-4.0")
#
rm -Rv ~/usrc/gnuplot-4.0.0/
tar -C ~/usrc/ \
  -xvzf $S/ftp/ftp.gnuplot.info/pub/gnuplot/gnuplot-4.0.0.tar.gz

cd     ~/usrc/gnuplot-4.0.0/
./configure	|& tee oc
make		|& tee om
make install	|& tee omi

#
cd ~/usrc/gnuplot-4.0.0/demo/
echo 'set terminal x11' > x11
for i in *.dem; do
  echo $i
  gnuplot x11 $i
done

#


# (code-c-d "gnuplot" "~/usrc/gnuplot-4.0.0/")
# (find-gnuplotfile "")
# (find-gnuplotfile "oc")

(defun find-gnuplothelp (tag &rest rest)
  (apply 'find-gnuplotfile "doc/gnuplot.gih"
         (if tag (format "\n?%s\n" tag))
         rest))



# (find-node "(gnuplot)plotting_styles" "-- DOTS --")




#####
#
# parabola
# 2008dec05
#
#####

# «parabola»  (to ".parabola")
# Parábola:   y(x) = a x^2 + b x + c
# Derivada:  y'(x) = 2 a x + b
# 
# Se x = p, a parábola passa pelo ponto:
#   (p, y(p)) = (p, a p^2 + b p + c)
# 
# Queremos uma reta r(x) que passe por esse ponto e
# que tenha inclinação y'(p) = 2 a p + b...
# Ou seja, r(p) = y(p), r'(p) = y'(p).
# Como r(x) é constante (= y'(p)) vamos ter
# 
#   r(x) = y'(p) x + _
# 
# falta descobrirmos o valor do "_". A solução mais
# fácil é esta:
# 
#   r(x) = y'(p) (x - p) + y(p)
#   r(x) = (2 a p + b) (x - p) + (a p^2 + b p + c)
# 
# que se você quiser simplificar isso vira:
# 
#   r(x) = (2 a p + b) x - (2 a p + b) p + (a p^2 + b p + c)
#        = (2 a p + b) x - (2 a p^2 + b p) + (a p^2 + b p + c)
#        = (2 a p + b) x + (- 2 a + a) p^2 + (- b + b) p + c
#        = (2 a p + b) x - a p^2 + c

 (eepitch-gnuplot)
 (eepitch-kill)
 (eepitch-gnuplot)

# set terminal x11 noraise
set terminal x11
set xrange [-6:6]
y(x) = a*x**2 + b*x + c
yp(x) = 2*a*x + b
r(x) = (2*a*p + b) * x + (a*p**2 + b*p + c)
r(x) = yp(p) * (x - p) + y(p) 
r2(x) = (2*a*p + b)*x - a*p**2 + c
a = .5
b = -4
c = -6
p = 2
plot 0, y(x), yp(x), r(x)
plot 0, y(x), yp(x), r(x), r2(x)-.2



#####
#
# terminal types and noraise
# 2009oct21
#
#####

# «noraise»  (to ".noraise")
# (find-node "(gnuplot)be" "-noraise")
# (find-node "(gnuplot)texdraw")
# (find-node "(gnuplot)tkcanvas")
# (find-node "(gnuplot)tpic")
# (find-node "(gnuplot)x11" "{no}raise")






#####
#
# gnuplottex
# 2009oct21
#
#####

# «gnuplottex»  (to ".gnuplottex")
# (find-zsh "dmissing gnuplottex")
# (find-status   "texlive-pictures")
# (find-vldifile "texlive-pictures.list")
# (find-udfile   "texlive-pictures/")
# (find-fline "/usr/share/doc/texlive-doc/latex/gnuplottex/README")
# (find-fline "/usr/share/doc/texlive-doc/latex/gnuplottex/example.tex")
# (find-fline "/usr/share/texmf-texlive/tex/latex/gnuplottex/gnuplottex.sty")
# (find-xpdfpage "/usr/share/doc/texlive-doc/latex/gnuplottex/gnuplottex.pdf" 1)

# (find-tlsh "find * | sort | grep gnuplottex")

(code-c-d "gnuplottex" "/usr/local/texlive/2019/texmf-dist/doc/latex/gnuplottex/")
;; (find-gnuplottexfile "")
(code-pdf-page "gnuplottex" "/usr/local/texlive/2019/texmf-dist/doc/latex/gnuplottex/gnuplottex.pdf")
(code-pdf-text "gnuplottex" "/usr/local/texlive/2019/texmf-dist/doc/latex/gnuplottex/gnuplottex.pdf")
;; (find-gnuplottexpage)
;; (find-gnuplottextext)




#####
#
# gnuplot from git
# 2021dec12
#
#####

# «gnuplot-git»  (to ".gnuplot-git")

# http://www.gnuplot.info/
# http://gnuplot.sourceforge.net/demo_5.5/
# https://sourceforge.net/p/gnuplot/gnuplot-main/ci/master/tree/
# https://sourceforge.net/p/gnuplot/gnuplot-main

cd ~/usrc/
git clone https://git.code.sf.net/p/gnuplot/gnuplot-main gnuplot-gnuplot-main

# (code-c-d "gnuplotgit" "~/usrc/gnuplot-gnuplot-main/")
# (find-gnuplotgitfile "")
# (find-gnuplotgitfile "demo/")
# (find-gnuplotgitfile "INSTALL")
# (find-gnuplotgitfile "INSTALL.gnu")
# (find-gnuplotgitfile "configure.ac")
# (find-gnuplotgitfile "README")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
~/usrc/gnuplot-gnuplot-main/

autoconf
./configure    |& tee oc
make           |& tee om
make check     |& tee omc
make install   |& tee omi




#####
#
# pager-cat
# 2022nov20
#
#####

# «pager-cat»  (to ".pager-cat")
# (find-eevgrep "grep --color=auto -nH --null -e ee-with-pager-cat *.el")
# (find-efunction   'ee-with-pager-cat)
# (find-efunctionpp 'ee-with-pager-cat)
# (find-node "(gnuplot)Top")
# (find-node "(gnuplot)Environment" "PAGER")
# (find-efunction 'eepitch-gnuplot)

#                     (find-sh0 "echo $PAGER")
# (ee-with-pager-cat '(find-sh0 "echo $PAGER"))

(defun eepitch-gnuplot () (interactive) (eepitch-comint "gnuplot" "gnuplot"))
(defun eepitch-gnuplot () (interactive)
  (eepitch '(ee-with-pager-cat '(find-comintprocess "gnuplot" "gnuplot"))))

 (eepitch-gnuplot)
 (eepitch-kill)
 (eepitch-gnuplot)
help set term tikz
help set term lua
set term tikz help
help
set
term
tikz

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
PAGER=cat gnuplot
help
set term tikz help




#####
#
# gnuplotlatexdemo
# 2022nov22
#
#####

# «gnuplotlatexdemo»  (to ".gnuplotlatexdemo")
# http://www.gnuplot.info/docs/latex_demo.pdf
# (find-psne-article-links "http://www.gnuplot.info/docs/latex_demo.pdf" "gnuplotlatexdemo")
# (code-pdf-page "gnuplotlatexdemo" "$S/http/www.gnuplot.info/docs/latex_demo.pdf")
# (code-pdf-text "gnuplotlatexdemo" "$S/http/www.gnuplot.info/docs/latex_demo.pdf")
# (find-gnuplotlatexdemopage)
# (find-gnuplotlatexdemotext)
# (find-gnuplotlatexdemotext "\\usepackage{gnuplot-lua-tikz}")

# (find-sh "locate gnuplot-lua-tikz.sty")
# (find-fline "/usr/share/texmf/tex/")
# (find-fline "/usr/share/texmf/tex/gnuplot-lua-tikz.sty")
# (find-fline "/usr/share/texmf/tex/")
# (find-sh "apt-file search gnuplot-lua-tikz")
# (find-status   "gnuplot-data")
# (find-vldifile "gnuplot-data.list")
# (find-vldifile "gnuplot-data.list" "/usr/share/texmf/tex")
# (find-udfile   "gnuplot-data/")



#####
#
# tikz
# 2022nov20
#
#####

# «tikz»  (to ".tikz")
# (to "gnuplotlatexdemo")
# (find-es "maxima" "plotting-contours-2")
# https://stackoverflow.com/questions/40565959/gnuplot-tikz-terminal-how-to-add-commands-to-the-picture
# (find-fline "/usr/share/texmf/tex/" "gnuplot-lua-tikz")

 (eepitch-gnuplot)
 (eepitch-kill)
 (eepitch-gnuplot)
set terminal eps
set terminal tikz
set terminal pict2e
help

 (eepitch-maxima)
 (eepitch-kill)
 (eepitch-maxima)
F(x,y) := 2*x^2 - x*y - y^2;
set_plot_option ([gnuplot_term,     "tikz"]);
set_plot_option ([gnuplot_out_file, "/tmp/myplot.tikz"]);
plot2d([contour, F(x, y)], [x, -2, 2], [y, -2, 2]);
set_plot_option ([gnuplot_term,     "pict2e"]);
set_plot_option ([gnuplot_out_file, "/tmp/myplot.pict2e"]);
plot2d([contour, F(x, y)], [x, -2, 2], [y, -2, 2]);

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /usr/share/texmf/tex/
cp -v gnuplot-lua-tikz-common.tex /tmp/
cp -v gnuplot-lua-tikz.sty        /tmp/

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
ee_dofile "~/LUA/tikz1.lua"  -- (find-anchor "~/LUA/tikz1.lua")
--            (find-fline "/tmp/myplot.pict2e")
--            (find-fline "/tmp/myplot.tikz")
-- tikzplot = ee_readfile "/tmp/myplot.tikz"
tikzplot = [=[ \input myplot.tikz ]=]
texbody = tikz [=[
  \documentclass{article}
  \usepackage{tikz}
  \usepackage{gnuplot-lua-tikz}
  \begin{document}
    <<tikzplot>>
    <<saysuccess>>
  \end{document}
]=]
show()
= Show.log
 (tikz-show)

texbody = tikz [=[
  \documentclass{article}
  \usepackage{pict2e}
  \usepackage{xcolor}
  \usepackage{graphicx}
  \begin{document}
  \input myplot.pict2e
  <<saysuccess>>
  \end{document}
]=]
show()
= Show.log
 (tikz-show)










https://thearjunmdas.github.io/entries/plot-graphs-in-emacs-org-mode/

labplot
scidavis
https://ctioga2.sourceforge.net/
https://gnuplot.sourceforge.net/demo_4.6/
https://gnuplot.sourceforge.net/demo_4.6/surface1.html
https://gnuplot.sourceforge.net/demo_4.6/surface1.8.gnu

http://www.gnuplot.info/ReleaseNotes_6_0_0.html
https://github.com/dkogan/gnuplotlib




#  Local Variables:
#  coding:               utf-8-unix
#  End:
