#######
#
# E-scripts on hardware - mainly configuration and autodetection
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/hardware.e>
#           or at <http://angg.twu.net/e/hardware.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.all-autodetections»		(to "all-autodetections")
# «.discover»			(to "discover")
# «.monitors»			(to "monitors")
# «.AOC-712Sa»			(to "AOC-712Sa")
# «.SyncMaster_551v»		(to "SyncMaster_551v")
# «.read-edid»			(to "read-edid")
# «.als0110»			(to "als0110")
# «.als0110.actn»		(to "als0110.actn")
# «.als0110.peek»		(to "als0110.peek")
# «.als0110.conf»		(to "als0110.conf")
# «.als0110-modules»		(to "als0110-modules")
# «.find-k22configoption»	(to "find-k22configoption")
# «.sensors»			(to "sensors")
# «.temperature»		(to "temperature")
# «.linuxprinting.org»		(to "linuxprinting.org")
# «.HP640C»			(to "HP640C")
# «.hdparm»			(to "hdparm")
# «.pci-slots-persephone»	(to "pci-slots-persephone")
# «.lspci»			(to "lspci")
# «.asus-1005pe»		(to "asus-1005pe")
# «.asus-1005pem»		(to "asus-1005pem")
# «.asus-1025C»			(to "asus-1025C")
# «.philips-cd245»		(to "philips-cd245")
# «.nokia-5000»			(to "nokia-5000")
# «.nokia-6700-slide»		(to "nokia-6700-slide")
# «.nokia-E63»			(to "nokia-E63")
# «.samsung-duos»		(to "samsung-duos")
# «.bluetooth»			(to "bluetooth")
# «.video-camera»		(to "video-camera")
# «.seagate-freeagent»		(to "seagate-freeagent")
# «.ipod»			(to "ipod")
# «.gtkpod»			(to "gtkpod")
# «.songbird»			(to "songbird")
# «.akg-480-nc»			(to "akg-480-nc")
# «.sennheiser-cx400ii»		(to "sennheiser-cx400ii")
# «.beyerdynamic-dt880»		(to "beyerdynamic-dt880")
# «.phillips-she9000»		(to "phillips-she9000")
# «.yamaha-E323»		(to "yamaha-E323")
# «.yamaha-P95»			(to "yamaha-P95")
# «.yamaha-p95-fonte»		(to "yamaha-p95-fonte")
# «.modem-3G-vivo»		(to "modem-3G-vivo")
# «.modem-3G-claro»		(to "modem-3G-claro")
# «.contrato-3G-claro»		(to "contrato-3G-claro")
# «.contrato-3G-vivo»		(to "contrato-3G-vivo")
# «.contrato-3G-tim»		(to "contrato-3G-tim")
# «.tp-link»			(to "tp-link")
# «.lorenzetti-jet-4»		(to "lorenzetti-jet-4")
# «.hp-deskjet-1000»		(to "hp-deskjet-1000")
# «.olympus-D395»		(to "olympus-D395")
# «.gps-6135»			(to "gps-6135")
# «.battery»			(to "battery")
# «.bat»			(to "bat")
# «.powertop»			(to "powertop")
# «.converse»			(to "converse")
# «.nokia-x2-01»		(to "nokia-x2-01")
# «.nokia-e63»			(to "nokia-e63")
# «.nikon-d5100»		(to "nikon-d5100")
# «.nikon-sd-card»		(to "nikon-sd-card")
# «.huawei-e5830»		(to "huawei-e5830")
# «.hp-cp2025dn»		(to "hp-cp2025dn")
# «.sony-voice-recorder»	(to "sony-voice-recorder")
# «.OP-1»			(to "OP-1")
# «.sony-dvp-sr320»		(to "sony-dvp-sr320")
# «.tda-tw150u»			(to "tda-tw150u")
# «.hp-642»			(to "hp-642")
# «.sony-dcr-hc52»		(to "sony-dcr-hc52")
# «.dlink-llarc»		(to "dlink-llarc")
# «.smartlan-iconecta»		(to "smartlan-iconecta")
# «.X200»			(to "X200")
# «.T400»			(to "T400")
# «.T400-wifi»			(to "T400-wifi")
# «.T400-webcam»		(to "T400-webcam")
# «.T400-screen-tearing»	(to "T400-screen-tearing")
# «.T400-brightness»		(to "T400-brightness")
# «.T400-keyboard»		(to "T400-keyboard")
# «.atheros-AR5B95»		(to "atheros-AR5B95")
# «.zoom-F1-SP»			(to "zoom-F1-SP")
# «.limpa-contatos»		(to "limpa-contatos")
# «.mcelog»			(to "mcelog")
# «.memtest»			(to "memtest")
# «.touchpad»			(to "touchpad")
# «.dmd-gs-3030»		(to "dmd-gs-3030")
# «.pioneer-x-cm56»		(to "pioneer-x-cm56")
# «.choosing-a-tablet»		(to "choosing-a-tablet")
# «.samsung-galaxy-tab-s3»	(to "samsung-galaxy-tab-s3")
# «.belkin-qode»		(to "belkin-qode")
# «.samsung-m20»		(to "samsung-m20")
# «.samsung-inverter»		(to "samsung-inverter")
# «.LG-inverter»		(to "LG-inverter")
# «.one-by-wacom»		(to "one-by-wacom")
# «.happy-hacking-keyboard»	(to "happy-hacking-keyboard")
# «.fonte-T400-grasep»		(to "fonte-T400-grasep")
# «.banheiros»			(to "banheiros")
# «.universal-ac-remote»	(to "universal-ac-remote")




#####
#
# all autodetections
# 2004dec22 / 2013aug12
#
#####

# «all-autodetections»  (to ".all-autodetections")
#
discover    |& tee /tmp/od
kudzu -s -p |& tee /tmp/ok
# (find-fline "/tmp/od")
# (find-fline "/tmp/ok")
#
# (find-sh "sudo get-edid | parse-edid" "HorizSync"   "30-55")
# (find-man "1 mdetect")

# 2013aug12:
# (find-man "1 discover")
# (find-sh "sudo discover")
# (find-sh "sudo discover -v -b -t")
# (find-sh "sudo discover -v -b -t | sort | uniq")




#####
#
# understanding discover
# 2004dec22
#
#####

# «discover»  (to ".discover")
# (find-status   "discover")
# (find-vldifile "discover.list")
# (find-udfile   "discover/")
# (find-fline "/etc/init.d/discover" "discover-modprobe -v")
#
sudo discover-modprobe -n -v
#

# (find-man "1 discover")
# (find-man "1 discover-config")
# (find-man "5 discover-modprobe.conf")
# (find-man "8 discover-modprobe")

# (find-status   "libdiscover2")
# (find-vldifile "libdiscover2.list")
# (find-udfile   "libdiscover2/")

# (find-fline "/usr/share/discover/dtd/discover.dtd")
# (find-fline "/usr/share/discover/dtd/conffile.dtd")
# (find-udfile "discover/guide.html")
# (find-udfile "discover/guide.txt.gz")
# (find-udfile "libdiscover2/README")
# (find-udfile "libdiscover2/RELEASE")
# (find-udfile "libdiscover2/copyright")
# (find-udfile "libdiscover2/changelog.Debian.gz")
# (find-man "5 discover.conf")
# (find-fline "/lib/libdiscover.so.2.0.0")
# (find-fline "/etc/discover.conf")
# (find-fline "/lib/libdiscover.so.2")

# (find-status   "discover-data")
# (find-vldifile "discover-data.list")
# (find-udfile   "discover-data/")
# (find-fline "/usr/share/discover/pci.lst")
# (find-fline "/usr/share/discover/pci.lst" "CS 4614/22/24")
# (find-fline "/lib/discover/")
# (find-fline "/lib/discover/pci.lst")
# (find-fline "/lib/discover/pci.lst" "cs46xx")
# (find-fline "/lib/discover/pci-device.xml")
# (find-fline "/lib/discover/pci-device.xml" "cs46xx")



#####
#
# Monitores:
#
#####

# «monitors»  (to ".monitors")

Section "Monitor"
    Identifier  "Philips 104s"
    VendorName  "Philips"
    ModelName   "104s"
#   HorizSync   31.5 - 48.5
    HorizSync   31.5, 35.2, 35.5, 37.8, 48.1, 48.3
    VertRefresh 50-100
...
endsection

Section "Monitor"
    Identifier  "Samsung SyncMaster 3"
    VendorName  "Samsung"
    ModelName   "SyncMaster 3"
    HorizSync   31.5, 35.15, 35.5
    VertRefresh 50-90
Modeline "1024x768"    44.9  1024 1048 1208 1264   768  776  784  817 Interlace
Modeline "640x480"     25.175 640  664  760  800   480  491  493  525
Modeline "800x600"     36     800  824  896 1024   600  601  603  625
EndSection

Section "Monitor"
    Identifier  "ProView 15in"
    VendorName  "ProView"
    ModelName   "PV-1564A"
    VertRefresh 50-90
    HorizSync   30-64         # multisync
...
EndSection

# «AOC-712Sa»  (to ".AOC-712Sa")
# (find-sh "sudo get-edid | parse-edid" "HorizSync" "30-83")
# VBE string at 0x11110 "ATI MOBILITY RADEON 7500"  <- dekooning (thinkpad)
# EDID version 1 revision 3
Section "Monitor"
	Identifier "712Sa"
	VendorName "AOC"
	ModelName "712Sa"
	HorizSync 30-83
	VertRefresh 55-75
	# Max dot clock (video bandwidth) 140 MHz
	# Block type: 2:0 3:fc
	# DPMS capabilities: Active off:yes  Suspend:no  Standby:no
	Mode 	"1280x1024"	# vfreq 75.025Hz, hfreq 79.976kHz
		DotClock	135.000000
		HTimings	1280 1296 1440 1688
		VTimings	1024 1025 1028 1066
		Flags	"+HSync" "+VSync"
	EndMode
EndSection

# «SyncMaster_551v»  (to ".SyncMaster_551v")
# «read-edid»  (to ".read-edid")

# (find-status   "read-edid")
# (find-vldifile "read-edid.list")
# (find-udfile   "read-edid/")
# (find-sh "sudo get-edid | parse-edid" "HorizSync"   "30-55")
# (find-sh "sudo get-edid | parse-edid" "VertRefresh" "50-120")






#####
#
# S3Virge/DX problems on X (potato/PIII500)
# 2000may06
#
#####

# «s3v_problems»

# After I changed my CPU to a PIII500 and motherboard to some ASUS my
# S3Virge no longer loses pixels on scrolls, but now X often freezes
# the machine -- sometimes to the point that not even Ctrl-Alt-Del or
# the sysrqs work.

# (find-vldifile "xserver-common.list")
# (find-fline "/usr/doc/xserver-common/")
# (find-fline "/usr/doc/xserver-common/README.S3V.gz")
# (find-fline "/usr/doc/xserver-common/README.S3V.gz" "375")
# (find-fline "/usr/doc/xserver-common/README.S3V.gz" "slow_edodram")
# (find-fline "/etc/X11/XF86Config")
# (find-fline "/etc/X11/XF86Config.S3Virge" "375")

# (find-vldifile "xserver-svga.list")
# (find-fline "/usr/doc/xserver-svga/")





#####
#
# Trident 9680:
#
#####

(find-fline "~/xfaq.html" "Subject: Q.G10- Problems with TGUI <B>9680</B>")



#####
#
# Trident 9680 crashing with smame, 99jan30
#
#####

Chega de Trident, vou tentar comprar outra placa. ATI Mach64?

# (find-fline "/usr/doc/HOWTO/Hardware-HOWTO.gz" "Video cards")
# (find-fline "/usr/doc/HOWTO/Hardware-HOWTO.gz")





#####
#
# X modelines
#
#####

# (find-esfile "general.e" "xdpyinfo")
# (find-fline "/etc/X11/XF86Config")

xdpyinfo -display :0.0 -ext XFree86-VidModeExtension | tail -n 40

     Clock   Hdsp Hbeg Hend Httl   Vdsp Vbeg Vend Vttl  Flags
     31.50    640  656  720  840    480  481  484  500  -hsync -vsync
     60.75    800  864  928 1088    600  616  621  657  -hsync -vsync
     85.00   1024 1032 1152 1360    768  784  787  823




#####
#
# svgalib-1.2.13
#
#####

rm -Rv	/usr/src/svgalib-1.2.13.orig
rm -Rv	/usr/src/svgalib-1.2.13
cd	/usr/src/
tar -xvzf $DEBIAN/hamm/hamm/source/libs/svgalib_1.2.13.orig.tar.gz
mv	svgalib-1.2.13.orig svgalib-1.2.13
cd	/usr/src/svgalib-1.2.13/

mv et4000.regs src/

find * -name '*.[ch]'	> .files.ch
ls src/*.regs		>> .files.ch
etags $(<.files.ch)

# make SVGALIB_CONFIG_FILE=/etc/vga/libvga.config \
#   DEFINES=-DDEBUG install |& tee omi

# (find-svgalibfile "src/vga.c" "__svgalib_driverspecslist[c]->init(1, par1, par2);")

make install |& tee omi
make demoprogs


# Inútil por enquanto:

# (find-fline "/etc/vga/libvga.config")
# (find-svgalibfile "libvga.config")
# (find-fline "~/replace/libvga.config")

[ -f /etc/vga/libvga.config.orig ] ||
  mv -iv /etc/vga/libvga.config /etc/vga/libvga.config.orig
cp -v ~/replace/libvga.config /etc/vga/libvga.config

man svgalib
man libvga.config





#####
#
#
#
#####

# To test which modes work:
#
cd	/usr/src/svgalib-1.2.13/demos/
/usr/src/svgalib-1.2.13/demos/vgatest

# Not working: 14 15 16 19 20 29 30 31 44
# 14: 320x200, 32K colors (5-5-5 RGB, blue at LSB, banked, interlaced)
# 15: 320x200, 64K colors (5-6-5 RGB, blue at LSB, banked, interlaced)
# 16: 320x200, 16M colors (8-8-8 RGB, blue byte first, banked, interlaced)
# 19: 640x480, 16M colors (8-8-8 RGB, blue byte first, banked, interlaced)
# 20: 800x600, 32K colors (5-5-5 RGB, blue at LSB, banked, interlaced)
# 29: 800x600, 16 colors (4 bitplanes, interlaced)
# 30: 1024x768, 16 colors (4 bitplanes, interlaced)
# 31: 1280x1024, 16 colors (4 bitplanes, interlaced)
# 44: 1600x1200, 16 colors (4 bitplanes, interlaced)

# ...so I fed these lines (without the leading "#", of course) to
# ~/.zgvrc:
# (find-fline "~/.zgvrc")
#
# # (find-esfile "hardware.e" "badmode")
# badmode 320 200 15
# badmode 320 200 16
# badmode 320 200 24
# badmode 640 480 24
# badmode 800 600 15
# badmode 800 600 4
# badmode 1024 768 4
# badmode 1280 1024 4
# badmode 1600 1200 4

# Tests:
cd /c5/S6/jpg/
zgv -m"320 200 16" i1b.jpg
zgv -m"640 480 16" i1b.jpg
zgv -m"1024 768 16" i1b.jpg
zgv -m"1024 768 256" i1b.jpg
zgv -m"1024 768 256" andreia.jpg
zgv -m"640 480 16M" andreia.jpg

# (code-c-d "svgalib" "/usr/src/svgalib-1.2.13/")
# (find-svgalibfile "0-INSTALL")
# (find-svgalibfile "Makefile.cfg")





# I can force TVGA9680 1024K RAM with:
chipset TVGA 1024 4	# TVGA 9680 (detected automatically)

# Monitor:
HorizSync 30 64
VertRefresh 50 100


# (find-fline "/etc/vga/libvga.config" "chipset TVGA")
# (find-svgalibfile "src/vga.c")
# (find-svgalibfile "src/tvga8900.c")
# (find-svgalibfile "src/tvga8900.c" "tvga_model")
# (find-svgalibfile "src/tvga8900.c" "case 4: tvga_model=9680;")
# (find-svgalibtag "DriverSpecs")
# (find-svgalibfile "src/vga.c" "__svgalib_driverspecslist[c]->init(1, par1, par2);")
# (find-svgalibfile "src/vga.c" "vga_setchipsetandfeatures(i, j, atoi(ptr));")

# chipset TVGA 1024 4





#####
#
# zgv-2.8-4
#
#####

zsnedeb hamm/hamm/source/graphics zgv_2.8-4.diff.gz
zsnedeb hamm/hamm/source/graphics zgv_2.8-4.dsc
zsnedeb hamm/hamm/source/graphics zgv_2.8.orig.tar.gz
zcat $DEBIAN/hamm/hamm/source/graphics/zgv_2.8-4.diff.gz

rm -Rv /usr/src/zgv-2.8.orig
rm -Rv /usr/src/zgv-2.8
cd /usr/src/
tar -xvzf $DEBIAN/hamm/hamm/source/graphics/zgv_2.8.orig.tar.gz
mv -iv zgv-2.8.orig zgv-2.8
cd     /usr/src/zgv-2.8/

make |& tee om

# Better:

rm -Rv	/usr/src/zgv-2.8
cd	/usr/src/
dpkg-source -x $DEBIAN/hamm/hamm/source/graphics/zgv_2.8-4.dsc
cd	/usr/src/zgv-2.8

dpkg-buildpackage -us -uc |& tee odb







#####
#
# kbrequest
#
#####

# (find-fline "/etc/inittab" "kbrequest")
# kb::kbrequest:/home/root/bin/kbrequest

# (find-fline "/home/root/bin/kbrequest")
#!/bin/sh
stm -t /home/root/bin/9680+proview.stmconf -o -a > /dev/null
setfont /home/root/replace/ega1.8

# (find-fline "/home/root/bin/9680+proview.stmconf")
ChipSet "tgui"
clockchip "tgui9440"	# For the TGUI9440AGi, TGUI9660XGi, TGUI9680
Option "ClockDiv2"
DefaultMode "80x50"	# Grabbed from the tgui9680+ProView 15in setting:
"80x50"  28.286  640 680 776 800  400 412 414 449  -Hsync +Vsync  font 9x8

# (find-fline "~/t.cnf")

man SVGATextMode
man grabmode

# (find-fline "/var/lib/dpkg/info/svgatextmode.list")
# (find-fline "/usr/doc/svgatextmode/")

dpkg -i ~/HASH/svgatextmode
rm -v /etc/rc?.d/???svgatextmode

stm -d -d -v -s |& l
stm -o -a 80x50x9





#####
#
# sound
#
#####

# (find-esfile "general.e")
# (find-fline "~/.config2035")

# (find-fline "/usr/doc/HOWTO/Sound-HOWTO.gz" 209)
# (find-fline "/usr/doc/HOWTO/Sound-HOWTO.gz" 824)
# (find-fline "/usr/doc/HOWTO/Sound-Playing-HOWTO.gz")
# (find-k2file "drivers/sound/Readme.cards")
# (find-fline "/etc/soundconf")

# (find-fline "/usr/doc/HOWTO/NET-3-HOWTO.gz" "10.0.0.0")
# (find-fline "/etc/init.d/netbase")
# (find-fline "/etc/init.d/")



rmmod sound
cd $MODULES
insmod $MODULES/sound.o trace_init=1
cat /proc/devices
cat /dev/sndstat
cat /proc/interrupts
cat /proc/ioports

# (find-k2file "Documentation/devices.txt" "Sound card")
laf /dev | grep audio

# ls >/dev/dsp
cat crash.au >/dev/audio

cd /usr/src/linux-2.0.35/drivers/sound/
make clean
make config

./configure

cd /usr/src/linux-2.0.35/
make modules	|& tee omms

cat /usr/src/pcsnd-kit/enterpri.raw > /dev/dsp

# (find-k2file "drivers/sound/configure.c" ".soundconf")
# (find-k2file "drivers/sound/configure.c" "oldconf")
# (find-k2file "drivers/sound/Makefile" "oldconfig")
# (find-k2file "drivers/sound/Readme.cards" 412)
# (find-k2file "drivers/sound/Readme.cards" 576)
# (find-k2file "drivers/sound/Readme.modules")
# (find-k2file "drivers/sound/Readme.v30")
# (find-fline "/usr/doc/HOWTO/unmaintained/mini/Gravis-Ultra-Sound.gz")






#####
#
# alsa
#
#####

http://home.pf.jcu.cz/~perex/ultra/
http://alsa.jcu.cz/
ftp://alsa.jcu.cz/pub/driver/alsa-driver-0.2.0-pre8.tar.gz
ftp://alsa.jcu.cz/pub/driver/stable/alsa-driver-0.1.4.tar.gz
ftp://alsa.jcu.cz/pub/lib/alsa-lib-0.1.1.tar.gz
ftp://alsa.jcu.cz/pub/lib/stable/alsa-lib-0.0.9.tar.gz
ftp://alsa.jcu.cz/pub/tests/osstest.tar.gz
ftp://alsa.jcu.cz/pub/utils/alsa-utils-0.0.6.tar.gz



# (code-c-d "alsa" "/usr/src/alsa-driver-0.2.0-pre8/")

function untgzsrc () {
  cd /usr/src/ && (
    rm -Rv $1
    tar -xvzf $2
  )
  cd /usr/src/$1
}

untgzsrc alsa-driver-0.2.0-pre8 \
  /snarf/ftp/alsa.jcu.cz/pub/driver/alsa-driver-0.2.0-pre8.tar.gz

#   --with-major=14	\

./configure	\
  --with-debug=full	\
  |& tee oc
find * -type f | glimpseindex -H . -F
etags $(find * -name '*.[ch]')
make |& tee om

# (find-alsafile "doc/alsa.txt" 50)
# (find-k2file "Documentation/devices.txt")
# (find-k2file "drivers/sound/sound_config.h" "sndstat")
# (find-k2file "drivers/sound/sound_switch.c")
# (find-alsatag "snd_printk")
# (find-alsafile "kernel/info_oss.c" "NOT ENABLED IN CONFIG")
# (find-alsafile "detect/detect.c")
# (find-alsafile "detect/gus.c")

kglimpse SND_DEV_STATUS

cd /var/log
for i in *.log; do
  echo "\n $i:"
  perl -nle 'm/... (..) (..):(..):(..) .*/ &&
    "$1$2$3$4" > 20230000 && print $_' < $i
done



cat /proc/modules

for i in $(cat /proc/modules | awk '{print $1, "\n"}'); do rmmod $i; done
cat /proc/modules

cd /usr/src/alsa-driver-0.2.0-pre8/modules/
insmod snd.o
insmod snd-detect.o
insmod snd-mixer.o
insmod snd-pcm.o
insmod snd-synth.o
insmod snd-midi.o
insmod snd-pcm-mix.o
insmod snd-pcm1.o
insmod snd-pcm1-oss.o
insmod snd-timer.o
insmod snd-gus.o

cat /proc/devices
cat /proc/modules | awk '{print $1}'

cat /dev/sndstat

cd /usr/src/alsa-driver-0.2.0-pre8/kernel/

/usr/src/alsa-driver-0.2.0-pre8/modules/

cd /snarf/ftp/alsa.jcu.cz/

# (find-fline "/alsa.jcu.cz:/pub/")
# (find-fline "/snarf/ftp/alsa.jcu.cz/pub/")

ftp://alsa.jcu.cz/pub/others/guspnp
psne ftp://alsa.jcu.cz/pub/others/guspnp/linux1.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/linux2.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/linux3.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/linux4.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/linuxX1.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/linuxX2.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/linuxX3.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/linuxX4.map ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/pnpmap.exe ;\
psne ftp://alsa.jcu.cz/pub/others/guspnp/readme.txt

1st/2nd DMA: 3
1st IRQ: 12
2nd IRQ: 5 (emu)
Base address: 0x220

  __ sound    Opt abcmidi      A converter from abc to MIDI format and back
  __ sound    Opt ascd         AfterStep CD player
  __ sound    Opt ascdc        AfterStep CD changer
  __ sound    Opt asmixer      AfterStep audio mixer
  __ sound    Opt aumix        Simple text-based mixer control program
  __ sound    Opt bplay        Buffered audio file player/recorder
  __ sound    Opt cam          Cpu's Audio Mixer for Linux
  __ sound    Opt cdtool       some text-based commands for managing a CD
  __ sound    Opt gom          A generic audio mixer (Base versions)
  __ sound    Opt gom-x        A generic audio mixer (X version)
  __ sound    Opt maplay       An MPEG Audio Player.
  __ sound    Opt mctools-lite A CD player and audio mixer for X
  __ sound    Opt mixviews     MixViews is a powerful soundfile editor.
  __ sound    Opt nas          The Network Audio System (NAS).
  __ sound    Opt playmidi     MIDI player
  __ sound    Opt s3mod        Player for MOD and S3M music files
  __ sound    Opt saytime      Speaks the current time through your sound card
  __ sound    Opt sox          A universal sound sample translator.
  __ sound    Opt synaesthesia A program for representing sounds visually
  __ sound    Opt timidity     Software-only MIDI sequencer.
  __ sound    Opt timidity-pat Instrument files for software-only MIDI sequence
  __ sound    Opt tkmixer      An audio mixer with Tk interface
  __ sound    Opt wmmixer      A mixer application designed for WindowMaker
 *** sound    Opt workbone     A simple text-based CD player
  __ sound    Opt workman      Graphical tool for playing audio CDs on a CD-ROM
  __ sound    Opt xmcd         X11/Motif based CD player
  __ sound    Opt xmix         An X11 based interface to the Linux sound driver
  __ sound    Opt xwave        Wave sound file editor





######
#
# kernel 2.1.132 + sound: rascunhos
#
######

cd /boot/angg21/
depmod *.o

# (find-node "(zsh)Array Parameters")
A=(soundcore sound mpu401 uart401 uart6850 v_midi opl3 ad1848)
Arev=($(echo ${(j:\n:)A} | tac))

cat /proc/modules

cd /boot/angg21/
for i in $A; do echo $i; insmod $i; done
cat /proc/modules

for i in $Arev; do echo $i; rmmod $i; done
cat /proc/modules

# (find-k21file "Documentation/devices.txt" "Sound card")
# (find-k21file "Documentation/sound/")
# (find-k21file "Documentation/sound/Introduction")
# (find-k21file "Documentation/sound/OPL3")
# (find-k21file "drivers/sound/")
# (find-k21file "drivers/sound/README.CONFIG")
# (find-k21file "drivers/sound/README.FIRST")
# (find-k21file "drivers/sound/README.blurb")
# (find-k21file "drivers/sound/README.wavefront")
# (find-k21file "drivers/sound/Readme")
# (find-k21file "drivers/sound/Readme.cards")
# (find-k21file "drivers/sound/Readme.linux")
# (find-k21file "drivers/sound/Readme.modules")

# (find-k21file "/usr/doc/HOWTO/mini/Soundblaster-AWE.gz")
# (find-k21file "/usr/doc/HOWTO/Sound-HOWTO.gz")
# (find-k21file "/usr/doc/HOWTO/Sound-HOWTO.gz" "4.5.  Troubleshooting")
# (find-k21file "/usr/doc/HOWTO/Sound-HOWTO.gz" "cat /dev/sndstat")
# (find-k21file "/usr/doc/HOWTO/Sound-Playing-HOWTO.gz")
# (find-k21file "/usr/doc/HOWTO/unmaintained/mini/Gravis-Ultra-Sound.gz")
# (find-k21file "/usr/doc/HOWTO/unmaintained/mini/Soundblaster-16.gz")

# (find-k21file "drivers/sound/soundcard.c" "proc/sound")
# (find-k21file "drivers/sound/soundcard.c" "proc_root_sound")
# (find-k21file "drivers/sound/soundcard.c" "sound_proc_get_info")

# (find-k21file "drivers/sound/sound_config.h")
# (find-k21file "drivers/sound/sound_core.c")

cat /dev/sndstat
cat /proc/sound

cat /usr/lib/tkdesk/sounds/door_open.au > /dev/audio
cat /usr/lib/tkdesk/sounds/door_open.au > /dev/dsp

# (find-k21file "drivers/sound/opl3sa2.c")
# (find-k21file "drivers/sound/opl3sa2.c" "MODULE_PARM")
# (find-vldifile "modutils.list")
strings < opl3sa2.o
objdump -xsT opl3sa2.o
objdump --section=.modinfo -xsT opl3sa2.o

grep MODULE_PARM /usr/src/linux-2.1.132/drivers/sound/opl3sa2.c

pnpdump > ~/o
# (find-fline "~/o")
man isapnp.conf

pnpdump | grep '(\|)'

MODULE_PARM(io, "i");
MODULE_PARM(mss_io, "i");
MODULE_PARM(mpu_io, "i");
MODULE_PARM(irq, "i");
MODULE_PARM(dma, "i");
MODULE_PARM(dma2,"i");

io:	Set i/o base of OPL3-SA2 or SA3 card (usually 0x370)
mss_io:	Set MSS (audio) I/O base (0x530, 0xE80, or other. Address
	must end in 0 or 4 and must be from 0x530 to 0xF48)
mss_irq:Set MSS (audio) IRQ (5, 7, 9, 10, 11, 12)
dma:	Set MSS (audio) first DMA channel (0, 1, 3)
dma2:	Set MSS (audio) second DMA channel (0, 1, 3)

mpu_io:	Set MIDI I/O base (0x330 or other. Address must be on 4
	location boundaries and must be from 0x300 to 0x334)

io=0x370
mss_io=0x530
irq=5
dma=0
dma2=1

mpu_io=0x330





#######
#
# kernel 2.1.132 + sound, versão que funciona
#
#######

cd /boot/angg21/
depmod *.o

# (find-node "(zsh)Array Parameters")
A=(soundcore sound ad1848 mpu401)
Arev=($(echo ${(j:\n:)A} | tac))

cat /proc/modules

cd /boot/angg21/
for i in $A; do echo $i; insmod $i; done
cat /proc/modules

for i in $Arev; do echo $i; rmmod $i; done
cat /proc/modules

# (find-fline "/usr/doc/isapnptools/")

isapnp - <<'---'
# (DEBUG)
(READPORT 0x0203)
(VERIFYLD Y)
(ISOLATE)
(IDENTIFY *)
(CONFIGURE YMH0020/-1
  (LD 0
    (IO 0 (BASE 0x0220))
    (IO 1 (BASE 0x0530))
    (IO 2 (BASE 0x0388))
    (IO 3 (BASE 0x0330))
    (IO 4 (BASE 0x0370))
    (INT 0 (IRQ 5 (MODE +E)))
    (DMA 0 (CHANNEL 0))
    (DMA 1 (CHANNEL 1))
    (ACT Y))
  (LD 1
    (IO 0 (BASE 0x0201))
    (ACT Y)))
(WAITFORKEY)
---

cd /boot/angg21/
insmod opl3sa2.o io=0x370 mss_io=0x530 irq=5 dma=0 dma2=1 mpu_io=0x330
cat /proc/sound

# A gente precisa fazer um patchzinho no kernel pra placa que eu tenho
# funcionar; ela se indentifica como 3 ao invés de 1, 2 ou 4.

# (find-fline "/var/log/kern.log" "opl3sa2.c: chipset version = 3")
# (find-k21file "drivers/sound/opl3sa2.c" "No Yamaha audio controller found")
		case CHIPSET_OPL3SAX:
		case 3:		/* edrx */
			printk(KERN_INFO "Found OPL3-SAx (YMF719)\n");

cd /812.C/ultrapnp/mids/
playmidi barimyst.mid

cd /812.C/ultrapnp/mids/
mftext barimyst.mid
midi2abc -f barimyst.mid

# (find-k21file "Documentation/sound/")
# (find-k21file "Documentation/sound/ultrasound")






######
#
# isa ne2000, angg, pnp disabled, 99jan10
#
######

cd /boot/angg
insmod 8390.o

function ne () {
  echo "\nne $1"
  grep ne /proc/modules > /dev/null && rmmod ne
  insmod ne.o io=0x3a0 irq=$1
}

# for i in 1 2 3 4 5 6 7 8; do ne $i; done
# for i in 9 10 11 12 13 14 15 16; do ne $i; done
# (find-fline "~/one")
# Quando a gente pede irq 2 ele diz "using irq 9". Esses aqui estão ok:

ne 3
ne 5
ne 6
ne 7
ne 9
ne 10
ne 11
ne 12
ne 14




#########
#
# ne2000 support (tentativas mais antigas)
#
#########

# ISA PnP:
#
isapnp ~/ne2000pnp.conf
cd /usr/src/linux-2.0.35/modules/
insmod 8390.o
insmod ne.o io=0x320 irq=10

# pnpdump > ~/ne2000pnp.conf
# (find-fline "/etc/isapnp.conf")
# Eu usei esses valores daqui:
#   (IO 0 (BASE 0x0220))
#   (INT 0 (IRQ 10 (MODE +E)))
#   (ACT Y)
# isapnp /etc/isapnp.conf

# PCI:
#
cd /usr/src/linux-2.0.35/modules/
insmod 8390.o
insmod ne.o

# (find-k2file "drivers/net/ne.c")
# (find-k2file "drivers/net/8390.c")
# (find-k2file "Documentation/Configure.help" "NE2000")
# (find-k2file "Documentation/networking/net-modules.txt" "ne.c")
# (find-k2file "/usr/doc/isapnptools/")
debsource /debian/main/source/admin isapnptools 1.13 -3.1
# (find-fline "/usr/src/isapnptools-1.13/README.modules")
mycat /proc/ioports /proc/interrupts

# (find-bfsrcfile "utilities/dinstall/lang_C.h" "BROADCAST")
# (find-bfsrcfile "utilities/dinstall/netconfig.c")

# (find-fline "/usr/doc/HOWTO/")
# (find-fline "/usr/doc/HOWTO/NET-3-HOWTO.gz")
# (find-fline "/usr/doc/HOWTO/Ethernet-HOWTO.gz")

# Donald Becker ethernet diag progs page:
lynx http://cesdis.gsfc.nasa.gov/linux/diag/diagnostic.html

# (find-fline "/snarf/http/cesdis.gsfc.nasa.gov/linux/diag/ne2k.c")
cd /snarf/http/cesdis.gsfc.nasa.gov/linux/diag/
gcc -Wall -O6 -N -o ~/bin/ne2k ne2k.c

cd /usr/src/linux-2.0.35/modules/
insmod 8390.o
insmod ne.o io=0x360 irq=10
insmod ne.o io=0x340 irq=10
insmod ne.o io=0x320 irq=10
rmmod ne; insmod ne.o io=0x300 irq=10
rmmod ne; insmod ne.o io=0x300 irq=11
rmmod ne; insmod ne.o io=0x300 irq=12
rmmod ne; insmod ne.o io=0x300 irq=10
rmmod ne; insmod ne.o io=0x300 irq=11
rmmod ne; insmod ne.o io=0x300 irq=12
rmmod ne; insmod ne.o io=0x300 irq=13
rmmod ne; insmod ne.o io=0x300 irq=14
rmmod ne; insmod ne.o io=0x300 irq=15
rmmod ne; insmod ne.o io=0x300 irq=16

rmmod ne; insmod ne.o io=0x300 irq=10


ne2k -p3a0

rmmod ne
insmod ne.o io=0x300 irq=11
rmmod ne
insmod ne.o io=0x300 irq=12
rmmod ne





#######
#
# irq do modem no kernel 2.1.132
#
#######

psne $FDEBIAN/dists/slink/main/binary-i386/base/setserial_2.14-3.deb
psne $FDEBIAN/dists/slink/main/source/base/setserial_2.14-3.diff.gz
psne $FDEBIAN/dists/slink/main/source/base/setserial_2.14-3.dsc
psne $FDEBIAN/dists/slink/main/source/base/setserial_2.14.orig.tar.gz

dpkg -i $SDEBIAN/dists/slink/main/binary-i386/base/setserial_2.14-3.deb

(find-vldifile "setserial.list")
(find-fline "/usr/doc/setserial")

# (find-k21file "drivers/char/serial.c" "Change the IRQ detection")
# (find-fline "~/bin/rc.local")
setserial  /dev/ttyS2  irq 5  uart 16550A

# (find-fline "/usr/doc/HOWTO/BootPrompt-HOWTO.gz")

setserial /dev/ttyS2  irq 5  uart 16550A
setserial -g /dev/ttyS2

setserial /dev/ttyS2  irq 3  uart 16550
setserial -g /dev/ttyS2

setserial /dev/ttyS2  autoconfig
setserial -g /dev/ttyS2

# (find-k21file "drivers/char/serial.c")
# (find-k21file "drivers/char/serial.c" "ttyS%02d%s")
# (find-k21file "drivers/char/serial.c" "rs_table")

# (find-k21file "include/linux/serial.h")
# (find-k21file "include/linux/serial_reg.h")

# (find-k21file "include/asm-i386/serial.h" "ttyS2")
# change "4" to "5".






######
#
# setserial 2.15
#
######

# (find-k21file "Documentation/Changes" "setserial-2.15")
# (find-fline "/snarf/ftp/tsx-11.mit.edu/pub/linux/sources/sbin/setserial-2.15.tar.gz")

rm -Rv /usr/src/setserial-2.15/
cd /usr/src/
tar -xvzf /snarf/ftp/tsx-11.mit.edu/pub/linux/sources/sbin/setserial-2.15.tar.gz
cd /usr/src/setserial-2.15/
./configure	|& tee oc
make		|& tee om

cd /usr/src/setserial-2.15/
./setserial /dev/ttyS2  irq 5  uart 16550A
./setserial -g /dev/ttyS2



#######
#
# pci
#
#######

# (find-k22file "drivers/pci/")





#######
#
# Gravis PNP
#
#######

pnpdump > ~/o
pnpdump | grep '^$\|[()]' > ~/o1
# (find-fline "~/o1")

# (find-fline "~/bin/gravis-up")

isapnp - <<'---'
(DEBUG)
(VERIFYLD Y)
(IGNORECRC)
(READPORT 0x0203)
(ISOLATE)
(IDENTIFY *)
(CONFIGURE GRV0001/10164 (LD 0
  # (INT 0 (IRQ 11 (MODE +E)))
  # (DMA 0 (CHANNEL 5))
  # (DMA 1 (CHANNEL 7))
  (INT 0 (IRQ 5 (MODE +E)))
  (DMA 0 (CHANNEL 1))
  (DMA 1 (CHANNEL 1))
  (IO 0 (BASE 0x0220))
  (IO 1 (BASE 0x0320))
  (IO 2 (BASE 0x032c))
  (ACT Y)
))
(CONFIGURE GRV0001/10164 (LD 1
  (ACT Y)
))
(CONFIGURE GRV0001/10164 (LD 2
  (IO 0 (BASE 0x0201))
  (ACT Y)
))
(CONFIGURE GRV0001/10164 (LD 3
  (ACT Y)
))
(CONFIGURE GRV0001/10164 (LD 4
  (ACT Y)
))
(WAITFORKEY)
---




#####
#
# Placa de som Union EDO micro
# 99nov19
#
#####

# «als0110»  (to ".als0110")
# (find-fline "~/_root/bin/als-up")
# (find-progoutput "pnpdump" "ALS0110")

# O cabo que vem do CD encaixa em JP2 Sony (acho).
# Identificação no pnpdump:
# "ALS0110/-1[3]{PnP Sound Chip      }"

# (find-es "kernel" "compile22")
# (find-es "kernel" ".strings")

# (find-k22file "Documentation/")
# (find-k22file "Documentation/Configure.help")
# (find-k22file "Documentation/sound/")
# (find-k22file "Documentation/sound/Introduction" "debug")
# (find-k22file "drivers/sound/sound_config.h" "DEB")
# (find-k22file "drivers/sound/")

k22glimpse -w DEB; echo
k22glimpse -w DDB; echo
k22glimpse -w MDB; echo

# (find-fline "~/bin/als-up")




#####
#
# ALS0110 sound card: PNP configurations
# 2002oct23
#
#####

#
# «als0110.actn»  (to ".als0110.actn")
# (find-man "8 isapnp" "IO range check attempted while device activated")
# (find-fline "/usr/doc/isapnptools/isapnpfaq.txt.gz" "(ACT N)")
# (find-progoutput "zcat /usr/doc/isapnptools/isapnpfaq.txt.gz | col -b" "(ACT N)")

cat > ~/tmp/als0110.actn <<'---'
# (find-es "hardware" "als0110.actn")
(DEBUG)
(READPORT 0x0273)
(ISOLATE PRESERVE)
(IDENTIFY *)
(VERBOSITY 2)
(CONFLICT (IO FATAL)(IRQ FATAL)(DMA FATAL)(MEM FATAL)) # or WARNING
(CONFIGURE ALS0110/-1 (LD 0 (ACT N)))
(CONFIGURE ALS0110/-1 (LD 1 (ACT N)))
(CONFIGURE ALS0110/-1 (LD 2 (ACT N)))
(CONFIGURE ALS0110/-1 (LD 3 (ACT N)))
(WAITFORKEY)
---
isapnp ~/tmp/als0110.actn

#
# «als0110.peek»  (to ".als0110.peek")
# (find-fline "/usr/doc/isapnptools/README.gz" "(PEEK)")

cat > ~/tmp/als0110.peek <<'---'
# (find-es "hardware" "als0110.peek")
#(DEBUG)
(READPORT 0x0273)
(ISOLATE PRESERVE)
(IDENTIFY *)
#(VERBOSITY 2)
(CONFLICT (IO FATAL)(IRQ FATAL)(DMA FATAL)(MEM FATAL)) # or WARNING
(CONFIGURE ALS0110/-1 (LD 0
 (IO 0 (PEEK))
 (INT 0 (PEEK))
 (DMA 0 (PEEK))
 (DMA 1 (PEEK))
 (ACT Y)
))
(CONFIGURE ALS0110/-1 (LD 1
 (IO 0 (PEEK))
 (ACT Y)
))
(CONFIGURE ALS0110/-1 (LD 2
 (IO 0 (PEEK))
 (ACT Y)
))
(CONFIGURE ALS0110/-1 (LD 3
 (IO 0 (PEEK))
 (INT 0 (PEEK))
 (ACT Y)
))
(WAITFORKEY)
---
isapnp ~/tmp/als0110.peek

#
# «als0110.conf»  (to ".als0110.conf")
# THIS PART NEEDS REORDERING AND COMMENTS!

pnpdump > ~/tmp/isapnp.conf.tmpl

# Then I marked manually the "DEBUG" and "ACT" lines with "d"s and
# "a"s, the alternatives for for LD 0 with 0a, 0b, the only
# alternative for LD 1 with "1", etc, and ran the perl script below to
# make an isapnp.conf out of that:

#
# (find-man "perlrequick" "Extracting matches")
perl -nle '
  if (m/^#([^ ]*)(.*)/) { $code=$1; $rest=$2;
    if ($code =~ m/^(d|a|0a|1|2|3a)$/) { print $rest; } 
  } else {
    print;
  }
' < ~/tmp/isapnp.conf.tmpl | grep -v '^$' | tee ~/tmp/isapnp.conf

#
# (find-fline "~/tmp/isapnp.conf.tmpl")
# (find-fline "~/tmp/isapnp.conf")
isapnp ~/tmp/isapnp.conf

#
# (find-fline "~/tmp/isapnp.reconf")
isapnp ~/tmp/isapnp.reconf

#




#####
#
# ALS0110 modules
# 2002oct23
#
#####

# «als0110-modules»  (to ".als0110-modules")
# (find-es "hardware" "als0110")
#
# From: (find-fline "~/_root/bin/als-up")
rmmod sb
rmmod opl3
rmmod v_midi
rmmod uart401
rmmod sound
rmmod soundcore

# (find-fline "~/tmp/isapnp.reconf")
isapnp ~/tmp/isapnp.reconf

insmod soundcore
insmod sound traceinit=1   ;# or trace_init?
insmod uart401
insmod v_midi
insmod opl3 io=0x388
insmod sb io=0x220 irq=5 dma=0 mpu_io=0x330

#
cat /proc/devices
cat /dev/sndstat
cat /proc/interrupts
cat /proc/ioports

#

# «find-k22configoption»  (to ".find-k22configoption")
# (find-angg ".emacs" "k22")
#
(code-c-d "k22" "/hdd7/tmp/kernel-source-2.2.20/")
(defun find-k22configoption (tag &rest rest)
  (apply 'find-k22file "Documentation/Configure.help"
    (format "\n%s\n" tag) rest))

# (find-k22configoption "")

# (find-es "hardware" "als0110")

# (find-progoutput "pnpdump" "ALS0110")
# (find-k22file "Documentation/sound/")
# (find-k22file "Documentation/sound/ALS")
# (find-k22file "Documentation/sound/OPL3")
# (find-k22file "drivers/sound/")
# (find-k22file "drivers/sound/Makefile" "+= soundcore.o")
# (find-k22file "drivers/sound/Makefile" "+= sb.o uart401.o")
# (find-k22file "drivers/sound/Makefile" "+= adlib_card.o opl3.o")
# (find-k22file "drivers/sound/Makefile" "+= sound.o")
# (find-k22file "drivers/sound/Makefile" "+= v_midi.o")
# (find-k22configoption "CONFIG_SOUND")
# (find-k22configoption "CONFIG_SOUND_SB")
# (find-k22configoption "CONFIG_SOUND_YM3812")
# (find-k22configoption "CONFIG_SOUND_OSS")
# (find-k22configoption "CONFIG_SOUND_VMIDI")

# (find-k22file "Documentation/sound/OPL3-SA")
# (find-k22file "Documentation/sound/OPL3-SA2")

# (find-fline "/usr/doc/isapnptools/README.modules")
# (find-fline "/usr/doc/isapnptools/examples/")

# (find-status "isapnptools")
# (find-vldifile "isapnptools.list")
# (find-fline "/usr/doc/isapnptools/")
# (find-progoutput "zcat /usr/doc/isapnptools/isapnpfaq.txt.gz | col -b")

# (find-man "5 isapnp.conf")
# (find-man "5 isapnp.conf" "isapnp does ISOLATION")
# (find-man "8 isapnp")
# (find-progoutput "pnpdump")






(cd ~/ICON/; icont -s toposort.icn)
cd /boot/angg22/
depmod *.o | ~/ICON/toposort | tee ~/o
tr -d ',[]"' < ~/o | tee ~/o2

# (find-fline "~/o2")


for m in $(cat /proc/modules | awk '{print $1}'); do echo $m; rmmod $m; done


# (find-fline "/usr/doc/HOWTO/mini/Soundblaster-AWE.gz")
# (find-fline "/usr/doc/HOWTO/Sound-HOWTO.gz")
# (find-fline "/usr/doc/HOWTO/Sound-HOWTO.gz" "cat /dev/sndstat")
# (find-fline "/usr/doc/HOWTO/Sound-Playing-HOWTO.gz")

lynx /usr/doc/HOWTO/mini/Soundblaster-AWE.html
lynx /usr/doc/HOWTO/Sound-HOWTO.html
lynx /usr/doc/HOWTO/Sound-Playing-HOWTO.html



k22glimpse MODULE_PARM | grep sound
# (find-k22file "include/linux/module.h" "character is a type specifier:")
# (find-k22file "omm" "-o sound.o")
# (find-k22file "")

apti aumix cam gom

# (find-vldifile "aumix.list")
# (find-fline "/usr/doc/aumix/")
# (find-vldifile "cam.list")
# (find-fline "/usr/doc/cam/")
# (find-vldifile "gom.list")
# (find-fline "/usr/doc/gom/")

k22glimpse 'Synth devices:'
# (find-k22file ".strings" "synth")


# insmod adlib_card.o
# insmod gus.o
# insmod opl3sa2.o
# insmod sb.o

insmod nvram.o




#####
#
# Pentium3 health sensors - temperature, fan, etc
# 2005feb06
#
#####

# «sensors»  (to ".sensors")
# (find-status   "lm-sensors")
# (find-vldifile "lm-sensors.list")
# (find-udfile   "lm-sensors/")
# (find-status   "xsensors")
# (find-vldifile "xsensors.list")
# (find-udfile   "xsensors/")

modprobe i2c-piix4
modprobe w83781d
sensors





#####
#
# Pentium3 health sensors - temperature, fan, etc
# 2003mar07
#
#####

# «temperature»  (to ".temperature")

# (find-progoutput "grep-available -i temperature")
# (find-progoutput "grep-available -i temperature -s Package -n | sort")
# (find-progoutput "grep-available -i temperature -s Package -n | sort | awk '{printf(\"# (find-available \\\"%s\\\" \\\"temperature\\\")\\n\", $1)}'")

# (find-available "apcd" "temperature")
# (find-available "gkrellweather" "temperature")
# (find-available "i2c-source" "temperature")
# (find-available "i8kutils" "temperature")
# (find-available "kweather" "temperature")
# (find-available "librrd0" "temperature")
# (find-available "librrd0-dev" "temperature")
# (find-available "librrdp-perl" "temperature")
# (find-available "librrds-perl" "temperature")
# (find-available "libsensors-dev" "temperature")
# (find-available "libsensors1" "temperature")
# (find-available "lm-sensors" "temperature")
# (find-available "lm-sensors-source" "temperature")
# (find-available "rrdtool" "temperature")
# (find-available "rrdtool-tcl" "temperature")
# (find-available "sensord" "temperature")
# (find-available "set6x86" "temperature")
# (find-available "units" "temperature")
# (find-available "wmgtemp" "temperature")

apti lm-sensors lm-sensors-source i2c-source

# (find-vldifile "lm-sensors.list")
# (find-fline "/usr/doc/lm-sensors/")
# (find-fline "/usr/doc/lm-sensors/FAQ.gz")

# (find-vldifile "lm-sensors-source.list")
# (find-fline "/usr/doc/lm-sensors-source/")
# (find-fline "/usr/src/lm-sensors.tar.gz")

# (find-status "i2c-source")
# (find-vldifile "i2c-source.list")
# (find-fline "/usr/doc/i2c-source/")
# (find-fline "/usr/doc/i2c-source/INSTALL.gz" "\nSeparate from kernel")
# (find-fline "/usr/src/i2c.tar.gz")
# (code-c-d "i2c" "$usr_src/modules/i2c/")
# (find-i2cfile "")
# (find-i2cfile "Makefile")
#
rm -Rv $usr_src/modules/i2c/
cd     $usr_src/
tar -xvzf /usr/src/i2c.tar.gz
cd $usr_src/modules/i2c/
make LINUX=/hdd7/tmp/kernel-source-2.2.20	|& tee om
#


# (find-man "sensors-detect")
# (find-man "sensors.conf")
# (find-man "sensors")

# I still don't know how to build the modules; it seems that the
# standard way is related to make-kpkg.

# (find-es "kernel" "kpkg")



#####
#
# Choosing a printer: linuxprinting.org
# 2003mar07
#
#####

# «linuxprinting.org»  (to ".linuxprinting.org")
lynx http://www.linuxprinting.org/



#####
#
# HP DeskJet 640C
# 2003mar12
#
#####

# «HP640C»  (to ".HP640C")
# (find-angg "bin/gs-640c")
# (find-angg "bin/gs-640c-bw")
# (find-angg "LATEX/Makefile")
# (find-available "hpijs")

lynx 'http://www.linuxprinting.org/show_printer.cgi?recnum=HP-DeskJet_640C'
lynx 'http://hpinkjet.sourceforge.net/printmodedescr.php#DJ6xxPhoto'
lynx 'http://hpinkjet.sourceforge.net/printmodedescr_pre10.php'




#####
#
# hdparm
# 2004oct15
#
#####

# «hdparm»  (to ".hdparm")
# (find-status   "hdparm")
# (find-vldifile "hdparm.list")
# (find-udfile   "hdparm/")

# (find-udfile "hdparm/README.acoustic")
# (find-udfile "hdparm/README.Debian")
# (find-udfile "hdparm/README.Debian" "To get the best performance")
# (find-udfile "hdparm/copyright")
# (find-udfile "hdparm/changelog.gz")
# (find-udfile "hdparm/contrib/idectl")
# (find-udfile "hdparm/contrib/README")
# (find-udfile "hdparm/contrib/ultrabayd")
# (find-udfile "hdparm/changelog.Debian.gz")
# (find-man "8 hdparm")

# (find-sh "sudo hdparm -i /dev/hda")
# (find-sh "sudo hdparm -i /dev/hdb")




#####
#
# PCI slots at persephone
# 2006sep28
#
#####

# «pci-slots-persephone»  (to ".pci-slots-persephone")

It is possible to set at the BIOS config program ("press
DEL", etc) the IRQ that the PCI cards will use. The PCI
slots are numbered like this:

                                   currently with:
              AGP -> slot 6 (???)    Riva TNT2
    (topmost) PCI -> slot 1          -
              PCI -> slot 2          eth0  (Via Rhine, a.k.a. D-Link)
              PCI -> slot 3          -
              PCI -> slot 4          sound (CS46XX)
  (lowermost) PCI -> slot 5          -
              ISA
              ISA

and the configuration that I'm using is:

  Slot  1  IRQ: auto
  Slot  2  IRQ:  11
  Slot 3/6 IRQ: auto
  Slot 4/5 IRQ: auto

Note that some slots are forced to use the same IRQ.





#####
#
# lspci
# 2007jul16
#
#####

# «lspci»  (to ".lspci")
# (find-man "8 lspci")
# (find-sh "lspci -vvv")
# (find-sh "lspci -x")
# (find-sh "lspci -b")
# (find-sh "lspci -nn")
# (find-sh "lspci -t")




#####
#
# ASUS EEE 1005 PE PC 
# 2010oct08 / 2012mar05
#
#####

# «asus-1005pe»  (to ".asus-1005pe")
# Comprado em: 08/out/2010
# Na: InfoLipe - www.infolipe44.com.br
# S/N: A50AAS246625

# «asus-1005pem»  (to ".asus-1005pem")
# (find-es "eee" "eee-1015-pem")
# Comprado em: 2011nov08
# Na: Actuale Info e Games
#     Av Rio Branco 156 loja 306 a 308 st 08
# S/N: 15G29L000720

# (find-sh "dmesg")
# DMI: ASUSTeK Computer INC. 1015PEM/1015PE, BIOS 0904    11/16/2010
# CPU0: Intel(R) Atom(TM) CPU N550   @ 1.50GHz stepping 0a
# http://en.wikipedia.org/wiki/N550




#####
#
# ASUS Eee PC 1025C
# 2013aug09
#
#####

# «asus-1025C» (to ".asus-1025C")
# Comprado em: 5/ago/2013
# Na D&V Informática (13 de maio 33/503)
# S/N C8OAB2020885
# https://account.asus.com/product_list.aspx?lang=en-us

# http://forums.gentoo.org/viewtopic-t-955812-start-0.html
# https://01.org/linuxgraphics/node/110
# http://lists.debian.org/debian-kernel/2013/04/msg00144.html

# (find-fline "/var/log/Xorg.0.log")

#
# Bios/select boot key: F2
#






#####
#
# Philips CD245 cordless phone
# 2010dec28
#
#####

# «philips-cd245»  (to ".philips-cd245")
# http://www.p4c.philips.com/files/d/dctg6251s_93/dctg6251s_93_qsg_eng.pdf
# http://www.p4c.philips.com/files/d/dctg6251s_93/philips_cd245_user_manual_eng.pdf

(code-xpdf      "cd245qsg" "$S/http/www.p4c.philips.com/files/d/dctg6251s_93/dctg6251s_93_qsg_eng.pdf")
(code-pdftotext "cd245qsg" "$S/http/www.p4c.philips.com/files/d/dctg6251s_93/dctg6251s_93_qsg_eng.pdf")
(code-xpdf      "cd245ug" "$S/http/www.p4c.philips.com/files/d/dctg6251s_93/philips_cd245_user_manual_eng.pdf")
(code-pdftotext "cd245ug" "$S/http/www.p4c.philips.com/files/d/dctg6251s_93/philips_cd245_user_manual_eng.pdf")
;; (find-cd245qsgpage      1  "Contents")
;; (find-cd245qsgpage (+ 1 1) "Index")
;; (find-cd245qsgtext "")
;; (find-cd245ugpage       1  "Contents")
;; (find-cd245ugpage (+ 2 14) "3.4 Menu structure")
;; (find-cd245ugpage (+ 2 28) "6.3 Activate/Deactivate Auto Answer")
;; (find-cd245ugpage (+ 2 34) "7.12 Default settings" "number of rings before answer")
;; (find-cd245ugpage (+ 2 35) "8. Telephone Answering Machine")
;; (find-cd245ugpage (+ 2 37) "8.5. Record your Personalized Outgoing Message")
;; (find-cd245ugtext "")




#####
#
# Celular da Valéria: Nokia 5000
# 2011mar30
#
#####

# «nokia-5000»  (to ".nokia-5000")
# Nokia 5000 - uses a BL-4B battery
# http://www.nokia.com.br/produtos/celulares/nokia-5000
# http://www.nokia.com.br/produtos/celulares/nokia-5000/acessorios
# http://www.nokiausa.com/find-products/accessories/all-accessories/power/batteries/nokia-battery-bl-4b
# http://en.wikipedia.org/wiki/List_of_Nokia_products#Nokia_5000_series_.E2.80.93_Active_series
# http://discussions.europe.nokia.com/t5/Other-Nokia-Phones/The-mystery-of-the-5000-USB-cable/td-p/473342
# http://www.gsmarena.com/nokia_5000-2336.php



#####
#
# Celular da Valéria: Nokia 6700 slide
# 2011may28
#
#####

# «nokia-6700-slide»  (to ".nokia-6700-slide")
# http://www.nokia.com.br/produtos/celulares/nokia-6700-slide




#####
#
# Celular da Valeria: Nokia E63
# 2013jan27
#
#####

# «nokia-E63» (to ".nokia-E63")
# http://nds4.nokia.com/phones/files/guides/Nokia_E63-1_UG_en.pdf
# http://en.wikipedia.org/wiki/Autocomplete
# http://en.wikipedia.org/wiki/Predictive_text

;; (find-fline "$S/http/nds4.nokia.com/phones/files/guides/")
(code-xpdf     "nokiae63" "$S/http/nds4.nokia.com/phones/files/guides/Nokia_E63-1_UG_en.pdf")
(code-pdf-text "nokiae63" "$S/http/nds4.nokia.com/phones/files/guides/Nokia_E63-1_UG_en.pdf")
;; (find-nokiae63page)
;; (find-nokiae63text)
;; (find-nokiae63text "Predictive text input")
# (find-nokiae63page 112 "Language settings")
# (find-nokiae63text 112 "Language settings")

Menu > Ferramentas > Configurações > Geral > Personalização > Idioma > Previsão de texto
Menu > Ferramentas > Configurações > Geral > Personalização > Idioma > Idioma do telefone
Menu > Tools > Settings > General > Personalization > Language > Predictive text
Menu > Tools > Settings > General > Personalization > Language > Phone language




#####
#
# Samsung Galaxy Y Duos (aka GT-B5512B)
# 2012aug04
#
#####

# «samsung-duos»  (to ".samsung-duos")
# (find-es "android" "2.3.4")
# http://www.google.com/help/hc/pdfs/mobile/AndroidUsersGuide-2.3.4.pdf
# http://androinica.com/category/androidguide/

# http://www.samsung.com/br/support/model/GT-B5512HKBZTO (?)
# http://pamandroid.blogspot.com.br/2012/07/root-samsung-galaxy-y-pro-duos-gt-b5512.html
# http://www.gsmarena.com/samsung_galaxy_y_pro_duos_b5512-4371.php

(code-xpdf      "android" "$S/http/www.google.com/help/hc/pdfs/mobile/AndroidUsersGuide-2.3.4.pdf")
(code-pdftotext "android" "$S/http/www.google.com/help/hc/pdfs/mobile/AndroidUsersGuide-2.3.4.pdf" 0)
;; (ee-page-parameters "android" 0)
;; (find-androidpage      3  "Contents")
;; (find-androidtext "")
;; (find-androidpage (+ 0 11) "About this guide")
;; (find-androidpage (+ 0 15) "Android basics")
;; (find-androidpage (+ 0 27)   "Monitoring your phone's status")
;; (find-androidpage (+ 0 57) "Connecting to networks and devices")
;; (find-androidpage (+ 0 61) "Connecting to Wi-Fi networks")
;; (find-androidtext (+ 0 61) "Connecting to Wi-Fi networks")
;; (find-androidpage (+ 0 67)   "Connecting to a computer via USB")
;; (find-androidpage (+ 0 79) "Placing and receiving calls")
;; (find-androidpage (+ 0 95) "Searching by text and voice")
;; (find-androidpage (+ 0 109) "Contacts")
;; (find-androidpage (+ 0 127) "Accounts")
;; (find-androidpage (+ 0 135) "Gmail")
;; (find-androidpage (+ 0 162)   "Using keyboard shortcuts")
;; (find-androidpage (+ 0 165) "Calendar")
;; (find-androidpage (+ 0 181) "Google Voice")
;; (find-androidpage (+ 0 195) "Google Talk")
;; (find-androidpage (+ 0 209) "Email")
;; (find-androidpage (+ 0 229) "Messaging")
;; (find-androidpage (+ 0 239) "Browser")
;; (find-androidpage (+ 0 255) "Maps, Navigation, Places, and Latitude")
;; (find-androidpage (+ 0 273) "Camera")
;; (find-androidpage (+ 0 281) "Gallery")
;; (find-androidpage (+ 0 295) "YouTube")
;; (find-androidpage (+ 0 307) "Music")
;; (find-androidpage (+ 0 317) "News & Weather")
;; (find-androidpage (+ 0 323) "Clock")
;; (find-androidpage (+ 0 329) "Car Home")
;; (find-androidpage (+ 0 337) "Calculator")
;; (find-androidpage (+ 0 339) "Tags")
;; (find-androidpage (+ 0 345) "Market")
;; (find-androidpage (+ 0 357) "Settings")
;; (find-androidpage (+ 0 362)   "Tethering")

# http://code.google.com/p/android-scripting/

 (eepitch-shell)
# (find-sh "dmesg | tail")
mkdir /tmp/pen/
sudo mount -o uid=$UID  /dev/sdd /tmp/pen/
# (find-fline "/tmp/pen/")
# (find-sh "cd /tmp/pen/ && find * | sort")
sudo umount /tmp/pen

http://androidforums.com/htc-hero/23894-back-up-playlists.html
http://android.stackexchange.com/questions/15045/where-and-how-does-android-store-music-playlists
http://android.stackexchange.com/questions/289/music-transfer-and-playlists

http://code.google.com/p/hackerskeyboard/




#####
#
# Samsung GT-I8190L (Galaxy S3 mini)
# 2015oct09
#
#####

# «galaxy-s3-mini» (to ".galaxy-s3-mini")
# (find-es "android" "galaxy-s3-mini")

IMEI
*#06#



#####
#
# BlueTooth
# 2011mar30
#
#####

# «bluetooth»  (to ".bluetooth")
# (find-es "eee" "bluetooth")

# http://www.bluez.org/
# (find-status   "bluetooth")
# (find-vldifile "bluetooth.list")
# (find-udfile   "bluetooth/")

# (find-other-debian-links "bluetooth")
# (find-zsh "dmissing bluetooth")
# (find-zsh "installeddebs | sort")
# (find-zsh "installeddebs | sort" "bluetooth")
# (find-zsh "installeddebs | sort | grep bluetooth")
# (find-zsh "availabledebs | sort")
# (find-zsh "availabledebs | sort" "bluetooth")
# (find-zsh "availabledebs | sort | grep bluetooth")
# (find-zsh "acse bluetooth | sort")
# (find-zsh "acse -i bluetooth | sort")
# (find-zsh "grep-available bluetooth")
# (find-zsh "grep-status bluetooth")

# (find-zsh "dmissing bluez")
# (find-udfile "bluez/examples/list-devices")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
/usr/share/doc/bluez/examples/list-devices

# (find-sh "dmesg")





#####
#
# Panasonic SDR-SW21 Video camera
# 2011jan18
#
#####

# «video-camera»  (to ".video-camera")
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mkdir /tmp/camera/
sudo mount /dev/sdb1 /tmp/camera/
# (find-fline "/tmp/camera/")

sudo umount /dev/sdb1

;; (find-fline "~/tmp/receita_federal/")
(code-xpdf      "regrasalfp28" "~/tmp/receita_federal/dou1_03ago2010_p28.pdf")
(code-pdftotext "regrasalfp28" "~/tmp/receita_federal/dou1_03ago2010_p28.pdf")
;; (find-regrasalfp28page 1)
;; (find-regrasalfp28text "")

(find-sh "dmesg")
# (find-fline "/proc/bus/input/devices")



[ 4827.277722] hub 1-0:1.0: over-current change on port 1
[ 4827.620120] usb 1-1: new high speed USB device using ehci_hcd and address 3
[ 4827.753858] usb 1-1: New USB device found, idVendor=04da, idProduct=0912
[ 4827.753872] usb 1-1: New USB device strings: Mfr=1, Product=2, SerialNumber=3
[ 4827.753882] usb 1-1: Product: SD Video Camera
[ 4827.753890] usb 1-1: Manufacturer: Panasonic
[ 4827.753897] usb 1-1: SerialNumber: 000011C46079
[ 4827.754184] usb 1-1: configuration #1 chosen from 1 choice
[ 4827.755222] hub 1-0:1.0: over-current change on port 2
[ 4827.856079] hub 1-0:1.0: over-current change on port 3
[ 4829.213795] Initializing USB Mass Storage driver...
[ 4829.214066] scsi4 : SCSI emulation for USB Mass Storage devices
[ 4829.214304] usbcore: registered new interface driver usb-storage
[ 4829.214313] USB Mass Storage support registered.
[ 4829.215895] usb-storage: device found at 3
[ 4829.215902] usb-storage: waiting for device to settle before scanning
[ 4834.212512] usb-storage: device scan complete
[ 4834.213582] scsi 4:0:0:0: Direct-Access     MATSHITA SD VIDEO CAMERA  1.06 PQ: 0 ANSI: 4
[ 4834.218710] sd 4:0:0:0: [sdb] 63135744 512-byte logical blocks: (32.3 GB/30.1 GiB)
[ 4834.220800] sd 4:0:0:0: [sdb] Write Protect is on
[ 4834.220819] sd 4:0:0:0: [sdb] Mode Sense: 18 00 80 08
[ 4834.220831] sd 4:0:0:0: [sdb] Assuming drive cache: write through
[ 4834.229297] sd 4:0:0:0: [sdb] Assuming drive cache: write through
[ 4834.229315]  sdb: sdb1
[ 4834.244397] sd 4:0:0:0: [sdb] Assuming drive cache: write through
[ 4834.244416] sd 4:0:0:0: [sdb] Attached SCSI removable disk





#####
#
# Seagate FreeAgent GoFlex (external HD)
# 2011may06
#
#####

# «seagate-freeagent»  (to ".seagate-freeagent")
# http://www.amazon.com/Seagate-FreeAgent-Ultra-Portable-External-STAA1000100/dp/B003ELOSI2
# I partitioned it in two partitions, one with 100GB, another with 900GB.
# They're both with ext3 right now (type 83 in fdisk) but it seems
# that I should reformat the small one as NTFS (type 7 in fdisk) to
# make it readable from W$s and Macs.




#####
#
# iPod Nano
# 2011feb01
#
#####

# «ipod»  (to ".ipod")
# http://en.wikipedia.org/wiki/IPod_Nano
# http://support.apple.com/fr_FR/manuals/
# http://manuals.info.apple.com/en_US/iPod_nano_6thgen_User_Guide.pdf
(code-xpdf      "ipodnanouser" "$S/http/manuals.info.apple.com/en_US/iPod_nano_6thgen_User_Guide.pdf")
(code-pdftotext "ipodnanouser" "$S/http/manuals.info.apple.com/en_US/iPod_nano_6thgen_User_Guide.pdf")
;; (find-ipodnanouserpage      1  "Contents")
;; (find-ipodnanouserpage      6  "Icons")
;; (find-ipodnanouserpage     18  "Language")
;; (find-ipodnanouserpage (+ 1 1) "Index")
;; (find-ipodnanousertext "")

# http://www.macworld.com/article/44960/2005/05/julygeekfactor.html



#####
#
# gtkpod
# 2011feb06
#
#####

# «gtkpod»  (to ".gtkpod")
# http://en.wikipedia.org/wiki/Gtkpod
# http://gtkpod.wikispaces.com/Supported+iPods
# http://www.gtkpod.org/wiki/Libgpod
# http://sourceforge.net/projects/fusepod/
# (find-status   "gtkpod")
# (find-vldifile "gtkpod.list")
# (find-udfile   "gtkpod/")
# (find-status   "gtkpod-data")
# (find-vldifile "gtkpod-data.list")
# (find-udfile   "gtkpod-data/")
# (find-fline "/usr/share/gtkpod/")
# (code-c-d "gtkpoddoc" "/usr/share/gtkpod/doc/")
# (find-gtkpoddocfile "")
# (find-gtkpoddocw3m "gtkpod.html")
# file:///usr/share/gtkpod/doc/gtkpod.html

# (find-sh "dmesg")
# (find-sh "lsusb")
# Bus 001 Device 004: ID 05ac:1266 Apple, Inc. 



#####
#
# Songbird
# 2011mar27
#
#####

# «songbird»  (to ".songbird")
# http://en.wikipedia.org/wiki/Songbird_(software)
# http://wiki.songbirdnest.com/Docs/IPod_Device_Support




#####
#
# AKG 480 NC
# 2011may17
#
#####

# «akg-480-nc»  (to ".akg-480-nc")
# http://www.amazon.co.uk/AKG-480-NC-Headphones-cancelling/dp/B002B7QN6U




#####
#
# Sennheiser CX 400 II
# 2011mar15
#
#####

# «sennheiser-cx400ii»  (to ".sennheiser-cx400ii")
# http://www.headphone.com/headphones/sennheiser-cx-300-ii-black.php
# http://www.amazon.com/Sennheiser-CX-400-II-Ear-Canal-Headphones/dp/B001EZWO5O




#####
#
# Beyerdynamic DT-880
# 2011mar15
#
#####

# «beyerdynamic-dt880»  (to ".beyerdynamic-dt880")
# http://www.headphone.com/headphones/beyerdynamic-dt-880.php
# http://www.headphone.com/headphones/beyerdynamic-dt-880---32-ohm.php
# http://www.headphone.com/headphones/beyerdynamic-dt-880---600-ohm.php
# Which model do I have?




#####
#
# Phillips SHE9000
# 2015jan09
#
#####

# «phillips-she9000» (to ".phillips-she9000")
# http://www.trustedreviews.com/philips-she9000-review (shitty)
# http://www.trustedreviews.com/soundmagic-e10-review
# http://www.trustedreviews.com/hifiman-re0-review 
# http://www.trustedreviews.com/headphones
# http://www.trustedreviews.com/reviews/nocs-ns500 
# http://www.trustedreviews.com/reviews/nocs-ns800 
# http://www.trustedreviews.com/phonak-audeo-pfe-112-earphones-review 
# http://www.trustedreviews.com/sennhesier-cx-3-00-review
# http://www.trustedreviews.com/best-headphones_round-up
# http://www.trustedreviews.com/best-in-ear-headphones_round-up
# http://www.phonak.com/com/b2c/en/home.html
# http://www.phonak.com/com/b2c/en/hearing/tinnitus.html




#####
#
# Yamaha PSR-E323
# 2011apr13
#
#####

# «yamaha-E323»  (to ".yamaha-E323")
product id PSR-E323%B2-B7YS-LKT6-BFEE
http://member.yamaha.com/
http://music.yamaha.com/homekeyboard/
http://www.yamaha.co.jp/manual/
back: PSR-E323
     cod 086792899480
  serial YBQZ06681



#####
#
# Yamaha P95 (P-95B)
# 2012mar06
#
#####

# «yamaha-P95»  (to ".yamaha-P95")
# Comprado em 02mar2012
# Na www.sonicsom.com.br
back: P-95B
     cod 086792939414
  serial YBRN01607

# http://www.tomzaptheband.com/equipment/p95UserManual.pdf
# (find-fline "$S/http/www.tomzaptheband.com/equipment/")
# (code-xpdf     "p95" "$S/http/www.tomzaptheband.com/equipment/p95UserManual.pdf")
# (code-pdf-text "p95" "$S/http/www.tomzaptheband.com/equipment/p95UserManual.pdf" 0)
# (find-p95page)
# (find-p95text)
# (find-p95page 14 "Using the Metronome")
# (find-p95text 14 "Using the Metronome")
# (find-p95page 19 "Fine tuning of the Pitch")
# (find-p95text 19 "Fine tuning of the Pitch")
# (find-p95text 19 "Fine tuning of the Pitch" "442Hz")
# (find-p95page 31 "Power supply")
# (find-p95text 31 "Power supply")

http://www.justanswer.com/electronic-musical-instruments/7m7lr-yamaha-p95-sound-normal-piano.html




#####
#
# Yamaha P95: fonte
# 2018fev05
#
#####

# «yamaha-p95-fonte» (to ".yamaha-p95-fonte")

A fonte que queimou no vazamento em RdO em 2017 diz:

Yamaha
External AC Power Adaptor
Model No: PA-150
Input: 120V-60Hz 0.5A
Output: 12.0V - 1.5A

A descrição da PA-150 na Amazon diz 1.0A:
  https://www.amazon.com/Yamaha-PA150-Keyboard-Power-Adapter/dp/B000WS3GRE

O PA-130 também é 12V, 1.0A:
  https://www.amazon.com/Yamaha-PA130-Keyboard-Power-Adaptor/dp/B000WS1QC6

https://lista.mercadolivre.com.br/adaptador-fonte-yamaha-pa-150
https://lista.mercadolivre.com.br/adaptador-fonte-yamaha-pa-130



#####
#
# Modem 3G Vivo (suzana)
# 2011mar17
#
#####

# «modem-3G-vivo»  (to ".modem-3G-vivo")
# (find-sh "dmesg")

hub 1-0:1.0: over-current change on port 1
usb 1-2: new high speed USB device using ehci_hcd and address 4
usb 1-2: New USB device found, idVendor=12d1, idProduct=1446
usb 1-2: New USB device strings: Mfr=3, Product=2, SerialNumber=0
usb 1-2: Product: HUAWEI Mobile
usb 1-2: Manufacturer: HUAWEI Technology
usb 1-2: configuration #1 chosen from 1 choice
scsi5 : SCSI emulation for USB Mass Storage devices
usb-storage: device found at 4
usb-storage: waiting for device to settle before scanning
scsi6 : SCSI emulation for USB Mass Storage devices
hub 1-0:1.0: over-current change on port 3
usb-storage: device found at 4
usb-storage: waiting for device to settle before scanning
usb 1-2: USB disconnect, address 4

usb 1-2: new high speed USB device using ehci_hcd and address 5
usb 1-2: New USB device found, idVendor=12d1, idProduct=1001
usb 1-2: New USB device strings: Mfr=3, Product=2, SerialNumber=0
usb 1-2: Product: HUAWEI Mobile
usb 1-2: Manufacturer: HUAWEI Technology
usb 1-2: configuration #1 chosen from 1 choice
scsi10 : SCSI emulation for USB Mass Storage devices
usb-storage: device found at 5
usb-storage: waiting for device to settle before scanning
scsi11 : SCSI emulation for USB Mass Storage devices
usb-storage: device found at 5
usb-storage: waiting for device to settle before scanning
usbcore: registered new interface driver usbserial
USB Serial support registered for generic
usbcore: registered new interface driver usbserial_generic
usbserial: USB Serial Driver core
USB Serial support registered for GSM modem (1-port)
option 1-2:1.0: GSM modem (1-port) converter detected
usb 1-2: GSM modem (1-port) converter now attached to ttyUSB0
option 1-2:1.1: GSM modem (1-port) converter detected
usb 1-2: GSM modem (1-port) converter now attached to ttyUSB1
option 1-2:1.2: GSM modem (1-port) converter detected
usb 1-2: GSM modem (1-port) converter now attached to ttyUSB2
usbcore: registered new interface driver option
option: v0.7.2:USB Driver for GSM modems

usb-storage: device scan complete
scsi 10:0:0:0: CD-ROM            HUAWEI   Mass Storage     2.31 PQ: 0 ANSI: 2
usb-storage: device scan complete
scsi 11:0:0:0: Direct-Access     HUAWEI   MMC Storage      2.31 PQ: 0 ANSI: 2
sr0: scsi-1 drive
sr 10:0:0:0: Attached scsi CD-ROM sr0
sr 10:0:0:0: Attached scsi generic sg1 type 5
sd 11:0:0:0: Attached scsi generic sg2 type 0
sd 11:0:0:0: [sdb] Attached SCSI removable disk

Mobile broadband connection 'Vivo Default' active (22%)

Test: wget http://angg.twu.net/edrx.tgz
Speed at PURO (at the lounge, with Vivo): 5KB/s
Speed at PURO (at the lounge, with Livre): 7KB/s

# http://www.portal-sva.vivo.com.br/vivo-captive/?n=552171310455
# file:///home/edrx/tmp/vivo_limite.html




#####
#
# Modem 3G Claro
# 2011mar30
#
#####

# «modem-3G-claro»  (to ".modem-3G-claro")
# (find-sh "dmesg")

[139845.907511] composite sync not supported
[139857.136473] hub 1-0:1.0: over-current change on port 1
[139857.240135] hub 1-0:1.0: over-current change on port 2
[139857.584079] usb 1-2: new high speed USB device using ehci_hcd and address 6
[139857.719630] usb 1-2: New USB device found, idVendor=19d2, idProduct=2000
[139857.719648] usb 1-2: New USB device strings: Mfr=3, Product=2, SerialNumber=4
[139857.719662] usb 1-2: Product: ZTE WCDMA Technologies MSM
[139857.719674] usb 1-2: Manufacturer: ZTE,Incorporated
[139857.719686] usb 1-2: SerialNumber: MF1900ZTED010000
[139857.722098] usb 1-2: configuration #1 chosen from 1 choice
[139857.728402] scsi7 : SCSI emulation for USB Mass Storage devices
[139857.728947] hub 1-0:1.0: over-current change on port 3
[139857.739245] usb-storage: device found at 6
[139857.739253] usb-storage: waiting for device to settle before scanning
[139860.604186] usb 1-2: USB disconnect, address 6
[139860.968161] usb 1-2: new high speed USB device using ehci_hcd and address 7
[139861.102383] usb 1-2: New USB device found, idVendor=19d2, idProduct=0031
[139861.102397] usb 1-2: New USB device strings: Mfr=3, Product=2, SerialNumber=4
[139861.102408] usb 1-2: Product: ZTE WCDMA Technologies MSM
[139861.102416] usb 1-2: Manufacturer: ZTE,Incorporated
[139861.102424] usb 1-2: SerialNumber: MF1900ZTED010000
[139861.102717] usb 1-2: configuration #1 chosen from 1 choice
[139861.106815] scsi8 : SCSI emulation for USB Mass Storage devices
[139861.108006] usb-storage: device found at 7
[139861.108017] usb-storage: waiting for device to settle before scanning
[139861.157119] usbcore: registered new interface driver usbserial
[139861.157165] USB Serial support registered for generic
[139861.157271] usbcore: registered new interface driver usbserial_generic
[139861.157279] usbserial: USB Serial Driver core
[139861.174890] USB Serial support registered for GSM modem (1-port)
[139861.175073] option 1-2:1.0: GSM modem (1-port) converter detected
[139861.175449] usb 1-2: GSM modem (1-port) converter now attached to ttyUSB0
[139861.175513] option 1-2:1.1: GSM modem (1-port) converter detected
[139861.175951] usb 1-2: GSM modem (1-port) converter now attached to ttyUSB1
[139861.176036] option 1-2:1.3: GSM modem (1-port) converter detected
[139861.176496] usb 1-2: GSM modem (1-port) converter now attached to ttyUSB2
[139861.176544] usbcore: registered new interface driver option
[139861.176551] option: v0.7.2:USB Driver for GSM modems
[139866.108756] usb-storage: device scan complete
[139866.109542] scsi 8:0:0:0: CD-ROM            ZTE      USB SCSI CD-ROM  2.31 PQ: 0 ANSI: 2
[139866.110263] scsi 8:0:0:1: Direct-Access     ZTE      MMC Storage      2.31 PQ: 0 ANSI: 2
[139866.128787] sd 8:0:0:1: [sdb] Attached SCSI removable disk
[139866.154965] sr0: scsi-1 drive
[139866.154973] Uniform CD-ROM driver Revision: 3.20
[139866.155252] sr 8:0:0:0: Attached scsi CD-ROM sr0
[139866.175065] sd 0:0:0:0: Attached scsi generic sg0 type 0
[139866.177214] sr 8:0:0:0: Attached scsi generic sg1 type 5
[139866.179286] sd 8:0:0:1: Attached scsi generic sg2 type 0
[139880.959330] ISO 9660 Extensions: Microsoft Joliet Level 1
[139880.961124] ISOFS: changing to secondary root
[140008.470529] composite sync not supported

# (find-fline "/media/ZTEMODEM/Linux/")
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /media/ZTEMODEM/Linux/
cp -v claro-3g-1-6.i386.deb /tmp/
cd /tmp/
sudo dpkg -i claro-3g-1-6.i386.deb

# (find-status   "claro-3g")
# (find-vldifile "claro-3g.list")
# (find-udfile   "claro-3g/")

# claro-3g depends on libqt3-mt; however:
#  Package libqt3-mt is not installed.
# claro-3g depends on wvdial; however:
#  Package wvdial is not installed.

apti -f

# file:///opt/BCLARO/Data/help/help.html
# (find-fline "/opt/BCLARO/Data/help/")






#####
#
# Contratos de 3G
# 2011mar17
#
#####

# «contrato-3G-claro»  (to ".contrato-3G-claro")

11.h: Declara o conhecimento que, para os Planos de Serviço de
Franquia, fica garantido ao ASSINANTE o mínimo de 10% da velocidade
nominal contratada de acordo com a tecnologia da área de cobertura,
sendo: (i): GSM GPRS: até 60kbps; (ii) GSM EDGE: até 120 kbps; e (iii)
3G HSDPA: até 1Mbps, por se tratar de ambiente restrito.

11.k: Declara ter avaliado suas necessidades de tráfego de dados e
velocidade de conexão, e optado pelo plano escolhido, estando ciente,
desde já, que a utilização além da franquia estabelecida em seu Plano
de Acesso ilimitado (quando for o caso) implicará na cobrança do
tráfego de dados excedente, assim como no direito da CLARO de reduzir
a velocidade de transmissão de dados para o limite de até 128 Kbps,
oermanecendo neste estado até o final do respectivo ciclo de
faturamento, quando a velocidade originalmente contratada será
restaurada.

(No papelzinho diz que a "velocidade" nos planos 1GB, 3GB, 5GB, 10GB é
1 mega).



Para contratar a TIM (ou outra), consiga que eles te digam por escrito a
viabilidade técnica do 3G (eu costumo pedir que me mandem as informações por
e-mail, e peço nome do funcionário que informa). Avise que se não for bom vc
vai devolver o serviço. Normalmente, eles deixam para enrolar o cliente mais
bobo, e tomam mais cuidados com os mais espertos e informados. Veja antes se
algum vizinho tem o serviço, e se está satisfeito.
Se não atender suas expectativas, provavelmente vc vai ter que brigar um
pouquinho, mas eles são obrigados por lei a cancelar o serviço.




# «contrato-3G-vivo»  (to ".contrato-3G-vivo")

Vivo:

Limite temporário de utilização

1. Valor: A partir desta data, será atribuído um limite de utilização,
não inferior a R$50,00 ("valor"), conforme condições técnicas e/ou
operacionais. O valor será aplicado após a utilização do pacote de
minutos contratado (após a "franquia") e sobre débitos não incluídos
na "franquia". 2. Bloqueio: Ultrapassado o "valor", poderá ser
efetuado o bloqueio total ou parcial para qualquer uso que gere ônus
(ressalvados os serviços de emergência definidos em regulamentação).
3. Desbloqueio: Caso o Cliente opte por desbloquear os serviços,
deverá ligar para a Central de Relacionamento com o Cliente (*8486) de
seu Vivo ou para 1058 de outro telefone, para obter

[A Vivo não tem garantia de velocidade mínima - não copiei mais]



# «contrato-3G-tim»  (to ".contrato-3G-tim")







#####
#
# TP-Link router
# 2011?
#
#####

# «tp-link»  (to ".tp-link")
# http://192.168.1.1/
# (find-es "net" "nmap")
# http://www.tp-link.com/support/download.asp

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
nmap -sP 192.168.1.0-255

# Starting Nmap 5.00 ( http://nmap.org ) at 2011-03-01 13:52 BRT
# Host 192.168.1.1 is up (0.0028s latency).
# Host gwen (192.168.1.101) is up (0.029s latency).
# Host 192.168.1.103 is up (0.00028s latency).
# Nmap done: 256 IP addresses (3 hosts up) scanned in 15.35 seconds

# TP-LINK Wireless Lite N Router WR741N
# http://192.168.1.1/




# 4004-7777 Net virtua
# Testing the speed:
# http://megaflash.virtua.com.br/
# http://megaflash.rjo.virtua.com.br/FilmesMegaflash/10Mb/net_raio.mov
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# megaflash.virtua.com.br
wget http://megaflash.rjo.virtua.com.br/FilmesMegaflash/10Mb/net_raio.mov





#####
#
# Lorenzetti Jet 4
# 2011jun19
#
#####

# «lorenzetti-jet-4»  (to ".lorenzetti-jet-4")
# http://www.lorenzetti.com.br/produto.asp?id=DC0010
# http://www.lorenzetti.com.br/admin/upload/pdf/DC0010_arq1.pdf
# (xz "~/tmp/lorenzetti-jet-4.jpg")



#####
#
# HP Deskjet 1000
# 2011oct03
#
#####

# «hp-deskjet-1000»  (to ".hp-deskjet-1000")
# (find-es "print" "hplip-upstream")
# http://www.amazon.com/HP-Deskjet-Printer-CH340A-B1H/dp/B003YGZIY0/
# http://hplipopensource.com/hplip-web/models/deskjet/deskjet_2000_j210_series.html
# http://hplipopensource.com/hplip-web/models/deskjet/deskjet_1000_j110_series.html

http://bizsupport2.austin.hp.com/bc/docs/support/SupportManual/c02484379/c02484379.pdf
http://h20000.www2.hp.com/bizsupport/TechSupport/DocumentIndex.jsp?lang=pt&cc=br&prodClassId=-1&contentType=SupportManual&docIndexId=66964&prodTypeId=18972&prodSeriesId=4066042#2
http://www.resethp.com.br/manual-service.html



#####
#
# Olympus D-395 (C-160?)
# 2011oct03
#
#####

# «olympus-D395»  (to ".olympus-D395")
# http://www.dpreview.com/products/olympus/compacts/oly_d395
# http://reviews.cnet.com/digital-cameras/olympus-camedia-d-395/4852-6501_7-30792417.html
# http://www.olympus.co.jp/en/support/imsg/digicamera/download/manual/compact/man_c160_e.pdf
# (find-sh "dmesg")
# (find-pen-links)

 (eepitch-shell)
mkdir /tmp/pen/
sudo mount -o uid=$UID         /dev/sdb1 /tmp/pen/
# (find-fline "/tmp/pen/")
# (find-fline "/tmp/pen/DCIM/100OLYMP/")
sudo umount /tmp/pen

df

(code-xpdf      "olympman" "$S/http/www.olympus.co.jp/en/support/imsg/digicamera/download/manual/compact/man_c160_e.pdf")
(code-pdftotext "olympman" "$S/http/www.olympus.co.jp/en/support/imsg/digicamera/download/manual/compact/man_c160_e.pdf")
;; (find-olympmanpage        4  "Contents")
;; (find-olympmanpage (+ 1 126) "Index")
;; (find-olympmantext "")




#####
#
# GPS automotivo leadership 6135
# 2011nov01
#
#####

# «gps-6135»  (to ".gps-6135")
# (find-pen-links)
# (find-fline "/tmp/pen/")

(code-xpdf      "gpsmanual" "~/tmp/gps/Manual_do_usuario/6135_manual_PT-BR.pdf")
(code-pdftotext "gpsmanual" "~/tmp/gps/Manual_do_usuario/6135_manual_PT-BR.pdf")
;; (find-gpsmanualpage      1  "Contents")
;; (find-gpsmanualpage     13  "Music")
;; (find-gpsmanualpage (+ 1 1) "Index")
;; (find-gpsmanualtext "")

(code-xpdf      "gpsndrivemanual" "~/tmp/gps/Manual_do_usuario/NDrive_manual_PT-BR.pdf")
(code-pdftotext "gpsndrivemanual" "~/tmp/gps/Manual_do_usuario/NDrive_manual_PT-BR.pdf")
;; (find-gpsndrivemanualpage      1  "Contents")
;; (find-gpsndrivemanualpage (+ 1 1) "Index")
;; (find-gpsndrivemanualtext "")

(find-2
  ' (find-fline "~/NICOTINE/AU_PAIRS/")
  ' (find-fline "/tmp/pen/NDrive/")
  )




#####
#
# Battery status
# 2011oct25
#
#####

# «battery»  (to ".battery")
# (find-zsh "availabledebs | sort | grep battery")
# (find-zsh "availabledebs | sort | grep power")
# (find-zsh "availabledebs | sort | grep applet")
# http://live.gnome.org/BatteryStatus
# http://library.gnome.org/users/battstat/
# http://developer.gnome.org/hig-book/2.32/desktop-notification-area.html.en
# (find-zsh "dmissing battery")
# (find-status   "gnome-power-manager")
# (find-vldifile "gnome-power-manager.list")
# (find-udfile   "gnome-power-manager/")
# (xz "/usr/share/gnome-power-manager/icons/hicolor/22x22/status/")
# (find-man "1 gnome-power-preferences")
# (find-man "1 gnome-power-manager")
# (find-man "1 gnome-power-statistics")
# http://gnome.org/projects/gnome-power-manager/
# https://upower.freedesktop.org/
# https://upower.freedesktop.org/docs/
# (find-status   "upower")
# (find-vldifile "upower.list")
# (find-udfile   "upower/")
# (find-man "1 upower")
# (find-man "8 upowerd")
# (find-man "7 UPower")
# (find-sh "upower --help")
# (find-sh "upower --help-all")
# (find-sh "upower -d")

# «bat» (to ".bat")
# (find-angg ".emacs" "bat")
# https://askubuntu.com/questions/69556/how-to-check-battery-status-using-terminal

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
            upower -e
            upower -e | grep 'BAT'
upower -i $(upower -e | grep 'BAT')
upower -i $(upower -e | grep 'BAT') | grep -E "state|to\ full|percentage"
upower -i $(upower -e | grep 'BAT') | grep -E 'state|to full|percentage'





#####
#
# PowerTop
# 2011nov16
#
#####

# «powertop»  (to ".powertop")
# (find-available "powertop")




#####
#
# Converse
# 2011dec13
#
#####

# «converse»  (to ".converse")
# My size:
  eur 44
  uk 9 1/2



#####
#
# Nokia X2-01
# 2011dec13
#
#####

# «nokia-x2-01»  (to ".nokia-x2-01")
# http://europe.nokia.com/find-products/devices/nokia-x2-01
# http://nds1.nokia.com/files/support/apac/phones/guides/Nokia_X2-01_UG_en.pdf
# http://www.amazon.com/Nokia-X2-01-Unlocked-Phone-U-S-Warranty/dp/B004P8JL76
# http://www.gsmarena.com/glossary.php3?term=sar
# http://www.gsmarena.com/nokia_x2_01-3610.php
# (find-pen-links)

# /dev/sdb on /media/0000-EAF4 type vfat (rw,nosuid,nodev,uhelper=udisks,uid=1000,gid=1000,shortname=mixed,dmask=0077,utf8=1,showexec,flush)

sudo umount /dev/sdb

(code-xpdf      "nokiax201" "$S/http/nds1.nokia.com/files/support/apac/phones/guides/Nokia_X2-01_UG_en.pdf")
(code-pdftotext "nokiax201" "$S/http/nds1.nokia.com/files/support/apac/phones/guides/Nokia_X2-01_UG_en.pdf")
;; (find-nokiax201page  1 "Contents")
;; (find-nokiax201page  5 "Keys and parts")
;; (find-nokiax201page 10 "SD")
;; (find-nokiax201page 11 "USB")
;; (find-nokiax201page 16 "Keypad lock")
;; (find-nokiax201text "")

http://static.guim.co.uk/sys-images/Guardian/Pix/pictures/2011/11/18/1321583520339/Scientists-working-at-the-007.jpg

Kalimba.aac
Signum.aac





#####
#
# Nokia E63 (Valeria)
# 2011dec26
#
#####

# «nokia-e63»  (to ".nokia-e63")
# http://nds4.nokia.com/phones/files/guides/Nokia_E63-1_UG_en.pdf
(code-xpdf      "nokiae63" "$S/http/nds4.nokia.com/phones/files/guides/Nokia_E63-1_UG_en.pdf")
(code-pdftotext "nokiae63" "$S/http/nds4.nokia.com/phones/files/guides/Nokia_E63-1_UG_en.pdf")
;; (find-nokiae63page      4  "Contents")
;; (find-nokiae63page     15  "Charging the battery")
;; (find-nokiae63page    135  "Index")
;; (find-nokiae63page (+ 1 1) "Index")
;; (find-nokiae63text "")




#####
#
# Nikon D5100
# 2012jan02
#
#####

# «nikon-d5100»  (to ".nikon-d5100")
# http://en.wikipedia.org/wiki/Nikon_D5100
# http://www.amazon.com/Nikon-D5100-Digital-18-55mm-3-5-5-6/dp/B004V4IWKG
# http://www.digitalcameratracker.com/nikon-d5100-reviews/
# http://www.dcviews.com/_nikon/d5100.htm
# http://en.wikipedia.org/wiki/Focusing_screen

# On autofocus and other things, very clearly explained:
# http://www.imaging-resource.com/PRODS/D5100/D5100A4.HTM

# My mini-tripod: Targus TGT
# http://www.amazon.com/Targus-Digital-TG-CT7-6-Inch-Aluminum/dp/B000FPH3SM

# http://lenshero.com/lens/Nikon-10-24mm-f3.5-4.5G-ED-AF-S-DX-lens
# http://lenshero.com/lens/Sigma-10-20mm-f4-5.6D-EX-DC-HSM-Nikon-f-lens
# http://www.amazon.com/Nikon-10-24mm-3-5-4-5G-Wide-Angle-Digital/dp/B0026FCKC8

# http://www.amazon.co.uk/Nikon-18-55mm-VR-Lens-Kit/dp/B004U4UHTQ/
# http://www.amazon.co.uk/Nikon-D5100-Digital-Field-Guide/dp/0470633522/
# http://www.amazon.co.uk/Nikon-D5100-Dummies-Computers/dp/1118118197/
# http://www.amazon.co.uk/gp/product/B004V2HE9I/ref=noref
# http://www.amazon.com/David-Buschs-Nikon-Digital-Photography/dp/1435460855/

# http://www.google.com/search?q=comparing+the+canon+eos+rebel+and+the+nikon+d5100
# http://www.digitalreview.ca/content/Canon-Rebel-T3i-EOS-600D-Compared-to-Nikon-D5100.shtml
# http://www.cameralabs.com/reviews/Nikon_D5100/
# http://www.cameralabs.com/reviews/Canon_EOS_600D_Rebel_T3i/verdict.shtml
# http://www.youtube.com/watch?v=zsLsOjeRkAg
# http://vimeo.com/24758135
# http://www.photoguia.com.br/ProdNikonD5100.asp

# microphone: rode videomic pro ??
# http://www.google.com/products/catalog?q=rode+videomic+pro&cid=12293063786886679167
# https://www.google.com/search?q=microphone&tbm=shop

# http://www.amazon.com/Nikon-Digital-18-55mm-3-5-5-6G-Zoom-Nikkor/dp/B000KJQ1DG
# http://www.amazon.com/Nikon-Digital-18-55mm-3-5-5-6G-Zoom-Nikkor/dp/B000NOEDGK
# http://www.digital-photography-school.com/how-to-buy-a-dslr-camera
# http://photo.net/equipment/choosing-a-dslr-camera/
# http://www.rickdenney.com/bokeh_test.htm
# http://www.rickdenney.com/mother_lens_test.htm
# http://www.luminous-landscape.com/reviews/lenses/600mm.shtml
# http://www.taunusreiter.de/Cameras/Zeiss_Fakes.html
# http://en.wikipedia.org/wiki/Canon_EOS
# http://en.wikipedia.org/wiki/Focusing_screen
# http://en.wikipedia.org/wiki/Rangefinder_camera
# http://en.wikipedia.org/wiki/Carl_Zeiss

# (find-pen-links)
# (find-sh "mount")
# /dev/sdb1 on /tmp/pen type vfat (rw,uid=1000)
# (find-sh "echo p | sudo fdisk /dev/sdb")
# (find-sh "echo 'p\nq' | sudo fdisk /dev/sdb")
# Id: b System: W95 FAT32
# Encoding: UTF-8 ("Warning: file names will be case-sensitive"...)
# How do I format an id b w95 fat32 and set it to utf-8?
# (find-man "8 mkdosfs")
# (find-man "8 dosfslabel")
# (find-man "8 mkfs")
# (find-man "8 mkfs.vfat")

# (find-fline "/tmp/pen/DCIM/100D5100/")
# (find-fline "/tmp/fotos/")
# (find-fline "~/FOTOS/muito_bem_lilo_laptop.jpg")

# S/N:
# Nikon D5100:                6303514
# AF-S DX 18-55/3.5-5.6G VR: 50353678

;; http://www.nikonsupport.eu/europe/Manuals/D5100/D5100RM_En_02.pdf
(code-xpdf      "d5100refman" "$S/http/www.nikonsupport.eu/europe/Manuals/D5100/D5100RM_En_02.pdf")
(code-pdftotext "d5100refman" "$S/http/www.nikonsupport.eu/europe/Manuals/D5100/D5100RM_En_02.pdf" 18)
;; (ee-page-parameters "d5100refman" 18)
;; (find-d5100refmanpage         3  "Where to find it")
;; (find-d5100refmanpage         4  "Q&A Index")
;; (find-d5100refmanpage         6  "Table of Contents")
;; (find-d5100refmantext         6  "Table of Contents")
;; (find-d5100refmanpage (+ 18 237) "Index")
;; (find-d5100refmantext (+ 18 237) "Index")
;; (find-d5100refmanpage (+ 18   1) "Getting to Know the Camera")
;; (find-d5100refmantext (+ 18   1) "Getting to Know the Camera")
;; (find-d5100refmanpage (+ 18 207) "ME-1 stereo microphone")
;; (find-d5100refmanpage (+ 18 207) "Approved memory cards")
;; (find-d5100refmanpage (+ 18 218) "Memory card capacity")
;; (find-d5100refmanpage (+ 18 237) "Index")
;; (find-d5100refmanpage (+ 18  11) "Camera Menus")
;; (find-d5100refmanpage (+ 18  22) "Format the Memory Card")
;; (find-d5100refmanpage (+ 18  25) "Battery level and card capacity")
;; (find-d5100refmanpage (+ 18  26) "Point and shoot photography")
;; (find-d5100refmanpage (+ 18  39) "AF-Area mode" "Single-point AF")
;; (find-d5100refmanpage (+ 18  42) "AF-Area Mode")
;; (find-d5100refmantext (+ 18  42) "AF-Area Mode")
;; (find-d5100refmanpage (+ 18  43) "Focus point selection")
;; (find-d5100refmanpage (+ 18  44) "Focus Lock")
;; (find-d5100refmantext (+ 18  44) "Focus Lock")
;; (find-d5100refmanpage (+ 18  46) "focus indicator")
;; (find-d5100refmanpage (+ 18  50) "Using the Built-in Flash")
;; (find-d5100refmantext (+ 18  50) "Using the Built-in Flash")

;; (find-d5100refmanpage (+ 18  35) "Self-timer")
;; (find-d5100refmantext (+ 18  35) "Self-timer")
;; (find-d5100refmanpage (+ 18  37) "Self-Timer and Remote Control Modes")
;; (find-d5100refmantext (+ 18  37) "Self-Timer and Remote Control Modes")
;; (find-d5100refmanpage (+ 18  38) "number of shots taken")
;; (find-d5100refmantext (+ 18  38) "number of shots taken")
;; (find-d5100refmanpage (+ 18  39) "Focus Mode")
;; (find-d5100refmantext (+ 18  39) "Focus Mode")
;; (find-d5100refmanpage (+ 18  56) "Interval Timer Photography")
;; (find-d5100refmantext (+ 18  56) "Interval Timer Photography")
;; (find-d5100refmanpage (+ 18  58) "Restoring Default Settings")
;; (find-d5100refmantext (+ 18  58) "Restoring Default Settings")
;; (find-d5100refmanpage (+ 18 165) "Self-timer")
;; (find-d5100refmantext (+ 18 165) "Self-timer")
;; (find-d5100refmanpage (+ 18 237) "Continuous")
;; (find-d5100refmantext (+ 18 237) "Continuous")

;; (find-d5100refmanpage (+ 18  61) "P, S, A, and M modes")
;; (find-d5100refmanpage (+ 18  62) "Mode P (Programmed Auto)")
;; (find-d5100refmantext (+ 18  62) "Mode P (Programmed Auto)")
;; (find-d5100refmanpage (+ 18  63) "Mode S (Shutter-Priority Auto)")
;; (find-d5100refmanpage (+ 18  64) "Mode A (Aperture-Priority Auto)")
;; (find-d5100refmanpage (+ 18  65) "Mode M (Manual)")
;; (find-d5100refmantext (+ 18  65) "Mode M (Manual)")
;; (find-d5100refmanpage (+ 18  69) "Autoexposure Lock")
;; (find-d5100refmantext (+ 18  69) "Autoexposure Lock")
;; (find-d5100refmanpage (+ 18  68) "Exposure\n     Metering")
;; (find-d5100refmantext (+ 18  68) "Exposure\n     Metering")
;; (find-d5100refmanpage (+ 18  81) "Fluorescent")
;; (find-d5100refmantext (+ 18  81) "Fluorescent")
;; (find-d5100refmanpage (+ 18  82) "Color Temperature")
;; (find-d5100refmantext (+ 18  82) "Color Temperature")
;; (find-d5100refmanpage (+ 18  96) "text-entry")
;; (find-d5100refmantext (+ 18  96) "text-entry")
;; (find-d5100refmanpage (+ 18 100) "Choosing a Focus Mode")
;; (find-d5100refmantext (+ 18 100) "Choosing a Focus Mode")
;; (find-d5100refmanpage (+ 18 101) "Choosing an AF-Area Mode")
;; (find-d5100refmantext (+ 18 101) "Choosing an AF-Area Mode")
;; (find-d5100refmanpage (+ 18 103) "The Live View Display")
;; (find-d5100refmantext (+ 18 103) "The Live View Display")
;; (find-d5100refmanpage (+ 18 107) "Recording and viewing movies")
;; (find-d5100refmanpage (+ 18 109) "Movie settings")
;; (find-d5100refmantext (+ 18 109) "Movie settings")
;; (find-d5100refmanpage (+ 18 155) "ISO-AUTO")
;; (find-d5100refmantext (+ 18 155) "ISO-AUTO")
;; (find-d5100refmanpage (+ 18 157) "Custom Settings")
;; (find-d5100refmantext (+ 18 157) "Custom Settings")
;; (find-d5100refmanpage (+ 18 170) "Date and time")
;; (find-d5100refmanpage (+ 18 109) "microphone" "sensitivity")
;; (find-d5100refmantext (+ 18 109) "microphone" "sensitivity")
;; (find-d5100refmanpage (+ 18 221) "Sound is not recorded with movies")
;; (find-d5100refmantext (+ 18 221) "Sound is not recorded with movies")
;; (find-d5100refmanpage (+ 18 237) "Index")
;; (find-d5100refmantext (+ 18 237) "Index")
;; (find-d5100refmantext "")

# http://www.nikondigitutor.com/eng/d5100/index.html
# http://kenrockwell.com/nikon/d5100/users-guide/index.htm
# http://www.cameratips.com/d5100/settings-modes-nikon-d5100#self-timer
# http://www.cameratips.com/d5100/how-tos-tricks-nikon-d5100
# http://www.d5100dslr.com/tutorials/interval-timer-shooting/
# http://michaeltraining.com/time-lapsed/

# http://www.warehouseexpress.com/buy-kood-52mm-flat-glass-uv-loose/p1023902
# http://en.wikipedia.org/wiki/Secure_Digital#Speed_Class_Rating
# http://www.amazon.co.uk/Integral-SDHC-Class-Memory-Card/dp/B0047T6XME




#####
#
# Nikon SD card
# 2012jan18
#
#####

# «nikon-sd-card»  (to ".nikon-sd-card")
# Mounting via SD adapter:
# /dev/sdb1 on /media/70C5-5397 type vfat (rw,nosuid, nodev,
#   uhelper=udisks, uid=1000, gid=1000, shortname=mixed, dmask=0077,
#   utf8=1, showexec, flush)

# http://askubuntu.com/questions/77843/cant-mount-sd-card-dev-sdc-is-ok-but-cant-seed-dev-sdc1

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mount

# (find-fline "/media/70C5-5397/")
# (find-fline "/media/70C5-5397/DCIM/100D5100/")
# (find-fline "/sda7/nikon/")






#####
#
# Huawei E5830 (Lilian / Alexandre)
# 2012jan05
#
#####

# «huawei-e5830»  (to ".huawei-e5830")
# SSID:     3Wireless-Modem-36
# Wifi key: 2C55F60D
# http://three.co.uk/my3
# http://three.co.uk/wirelesshelp




#####
#
# HP Color LaserJet cp2025dn
# 2012apr13
#
#####

# «hp-cp2025dn»  (to ".hp-cp2025dn")
# At LLaRC
# http://www.google.com/search?q=hp+cp2025dn+manual
# http://www.manualowl.com/p/Hewlett-Packard/Color-LaserJet-CP2025/Manual/107951
# http://www.retrevo.com/support/HP-CP2025dn-Printers-manual/id/23210ci655/t/2/

;; (find-fline "~/tmp/")
(code-xpdf     "hpcp2025media" "~/tmp/LJCP2020_media_enww.pdf")
(code-pdf-text "hpcp2025media" "~/tmp/LJCP2020_media_enww.pdf")
(code-xpdf     "hpcp2025user" "~/tmp/LJCP2020_use_enww.pdf")
(code-pdf-text "hpcp2025user" "~/tmp/LJCP2020_use_enww.pdf")
;; (find-hpcp2025mediapage)
;; (find-hpcp2025mediatext)
;; (find-hpcp2025userpage)
;; (find-hpcp2025usertext)





gsm chips

895531 0229 9885 91845: 8788-2389 laranja, sem internet
                     ?: 8880-2389?
895531 0229 9065 53406: 8884-2389 branco, com internet




#####
#
# Sony ICD-PX312F voice recorder
# 2012sep20
#
#####

# «sony-voice-recorder» (to ".sony-voice-recorder")
# http://www.sony.co.uk/support/en/product/ICD-PX312F
# http://pdf.crse.com/manuals/4274079111.pdf
# http://pdf.crse.com/manuals/4267067112.pdf

(code-xpdf      "sonyrecintro" "$S/http/pdf.crse.com/manuals/4274079111.pdf")
(code-pdftotext "sonyrecintro" "$S/http/pdf.crse.com/manuals/4274079111.pdf")
(code-xpdf      "sonyrec"      "$S/http/pdf.crse.com/manuals/4267067112.pdf")
(code-pdftotext "sonyrec"      "$S/http/pdf.crse.com/manuals/4267067112.pdf")

;; (find-sonyrecintropage      1  "Contents")
;; (find-sonyrecintropage (+ 1 1) "Index")
;; (find-sonyrecintrotext "")
;; (find-sonyrecpage      1)
;; (find-sonyrecpage      5  "Contents")
;; (find-sonyrecpage     30  "Erasing")
;; (find-sonyrecpage (+ 1 1) "Index")
;; (find-sonyrectext "")

# (find-sonyrecpage 16 "Step 4: Setting the Clock")
# (find-sonyrectext 16 "Step 4: Setting the Clock")
# (find-sonyrecpage 17 "To display the current date and" "  time")
# (find-sonyrectext 17 "To display the current date and" "  time")
# (find-sonyrecpage 29 "Recording date/time")
# (find-sonyrectext 29 "Recording date/time")

Table of Contents
Getting Started
Step 1: Checking the Contents of the
Package ................................................ 8
   Index to parts and controls ......................... 9
   Preventing unintentional operations
   (HOLD) ............................................. 11
   Maintaining the moderate volume
   level (AVLS) ....................................... 12
Step 2: Preparing a Power Source ...................... 13
   When to replace the batteries ...................... 14
Step 3: Turning the IC Recorder On .................... 15
   Turning the power on ............................... 15
   Turning the power off .............................. 15
Step 4: Setting the Clock ............................. 16
Step 5: Setting the Language to Be
   Used in the Display Window ......................... 18

   Basic Operations
   Recording .......................................... 20
   Listening .......................................... 25
   Erasing ............................................ 30

Other Recording Operations
Changing the Recording Settings ....................... 32
  Selecting a recording scene for
  each situation ...................................... 32
  Adding a recording to a previously
  recorded file ....................................... 35
  Adding an overwrite recording
  during playback ..................................... 37
  Starting to record automatically in
  response to sound
  - the VOR function .................................. 39

Recording on a Memory Card ............................ 41

Recording via Other Devices ........................... 45
  Recording with an external
  microphone .......................................... 45
  Recording from other equipment ...................... 47

Operation during Recording ............................ 49
  Monitoring the recording ............................ 49

Other Playback Operations
Changing the Playback Settings ........................ 50
  Convenient playback methods ......................... 50
  Reducing noise in the playback
  sound and making the human voice
  clearer - the noise cut function .................... 51
  Adjusting the playback speed
  - the DPC (Digital Pitch Control)
  function ............................................ 52

    Selecting the playback mode ....................... 54
Playing Back a File at a Desired
Time with an Alarm .................................... 57
Playback via Other Devices ............................ 60
   Recording with other equipment ..................... 60


Editing Files
Arranging Files in a Folder ........................... 61
  Moving a file to a different folder ................. 61
  Copying a file to the other
  memory .............................................. 62
  Erasing all files in a folder ....................... 64

Using a Track Mark .................................... 65
  Adding a track mark ................................. 65
  Erasing a track mark ................................ 66
  Erasing all the track marks in
  the selected file at one time ....................... 67

Dividing a File ....................................... 69
  Dividing a file at the current
  position ............................................ 69
  Dividing a file at all the track mark
  positions ........................................... 70

Protecting a File ..................................... 73

Listening to the FM Radio (for
ICD-PX312F only)

Tuning in an FM Radio Station ......................... 75
  Tuning in a radio station by
  scanning frequencies ................................ 75
  Tuning in a preset radio station .................... 76

   Recording FM broadcasts ............................ 77
Presetting FM Radio Stations .......................... 78
  Presetting FM radio stations
  automatically ....................................... 78
  Presetting FM radio stations
  manually ............................................ 79
  Erasing preset FM radio stations .................... 79
Changing the FM Radio Reception
Settings .............................................. 81
  Switching the receiver sensitivity of
  the FM radio ........................................ 81
  Switching the scanning sensitivity .................. 82
  Switching the FM radio output
  between speaker and headphones ...................... 83


About the Menu Function
Making Settings for the Menu .......................... 84

Menu Settings ......................................... 86


Utilizing Your Computer

Using the IC Recorder with Your
Computer ............................................. 100

  Connecting the IC recorder to your
  computer ........................................... 100
  Structure of folders and files ..................... 101
  Disconnecting the IC recorder
  from your computer ................................. 105
Copying Files from the IC Recorder to
Your Computer ........................................ 107

Copying MP3 Files from Your
Computer to the IC Recorder and
Playing Them Back .................................... 108
   Copying an MP3 file from your
   computer to the IC recorder
   (drag and drop) ................................... 108

   Playing back MP3 files copied
   from your computer using the
   IC recorder ....................................... 108
Using the IC Recorder as USB
Memory ............................................... 110
Using the Supplied Sound Organizer
Software ............................................. 111
   What you can do using Sound
   Organizer ......................................... 111
   System requirements for your
   computer .......................................... 112
   Installing Sound Organizer ........................ 113
   The Sound Organizer window ........................ 115


Additional Information
Using a USB AC Adaptor ............................... 116
  Disconnecting the IC recorder from
  the AC outlet ...................................... 116
Precautions .......................................... 118
Specifications ....................................... 121
  System requirements ................................ 121
  Design and specifications .......................... 122
  Battery life ....................................... 125

Troubleshooting
Troubleshooting ...................................... 126
Message List ......................................... 135
System Limitations ................................... 140

Display Window Guide ................................. 141

Index ................................................ 146




#####
#
# OP-1
# 2012dec04
#
#####

# «OP-1» (to ".OP-1")
# (find-es "op-1")
# (find-angg ".emacs" "OP-1")
# (find-fline "~/tmp/" "OP-1_Manual_1.2_(EN).pdf")
(code-xpdf     "op1manual" "~/tmp/OP-1_Manual_1.2_(EN).pdf")
(code-djvu     "op1manual" "~/tmp/OP-1_Manual_1.2_(EN).djvu")
(code-pdf-text "op1manual" "~/tmp/OP-1_Manual_1.2_(EN).pdf")
;; (find-op1manualpage  3 "TOC")
;; (find-op1manualpage 41 "Reference")
;; (find-op1manualtext  3 "TOC")
;; (find-op1manualtext)

# (find-es "scan" "repacking-djvus")
# (find-man "1 pdf2djvu")
pdf2djvu -v --lossy \
         -o "$HOME/tmp/OP-1_Manual_1.2_(EN).djvu" \
            "$HOME/tmp/OP-1_Manual_1.2_(EN).pdf"

http://en.wikipedia.org/wiki/FM_synthesis
http://op-101.blogspot.com.br/2011/09/cluster-description.html

http://www.youtube.com/watch?v=-ZdO9zxkPZE Teenage Engineering OP-1 ChopLifter Game
http://www.youtube.com/watch?v=grPSaSGxtYY Teenage Engineering OP-1 Synth Review and Beatmaking
http://www.youtube.com/watch?v=MJwRBOTWeTY "Theme", new OP-1 track
http://www.youtube.com/watch?v=F_zvFP1SeE4 Destroying a Greek Party (Teenage engineering OP-1)
http://www.youtube.com/watch?v=_ZABb1qFV_c Teenage Engineering OP-1 Demo by Mazmoneth



#####
#
# TDA TW150U (wireless USB adapter)
# 2013jun27
#
#####

# «tda-tw150u» (to ".tda-tw150u")
# (find-sh "dmesg")
# (find-sh "lsusb")

http://www.boadica.com.br/
redes -> wireless -> usb
http://www.encore-usa.com/mz/taxonomy/term/466/all
http://www.tda.net.br/br/produtos/redes/adaptadores/usb-sem-fio/tw150u.html Realtek RTL8188CUS (2.6.39)
http://www.2flex.com.br/adaptador-usb-wireless.php 

http://www.boadica.com.br/pesquisa/rede_wire/precos?ClasseProdutoX=9&CodCategoriaX=49&XT=8&XE=4
http://linuxplained.com/linux-compatible-usb-wireless-adapters-2012/

[ 9181.333391] usb 1-2: USB disconnect, device number 7
[ 9181.333614] rndis_host 1-2:2.0: usb0: unregister 'rndis_host' usb-0000:00:1d.7-2, RNDIS device
[ 9198.048123] usb 1-2: new high-speed USB device number 8 using ehci_hcd
[ 9198.182812] usb 1-2: New USB device found, idVendor=0bda, idProduct=8172
[ 9198.182827] usb 1-2: New USB device strings: Mfr=1, Product=2, SerialNumber=3
[ 9198.182838] usb 1-2: Product: RTL8191S WLAN Adapter 
[ 9198.182846] usb 1-2: Manufacturer: Manufacturer Realtek 
[ 9198.182855] usb 1-2: SerialNumber: 00e04c000001
[ 9198.760756] r8712u: module is from the staging directory, the quality is unknown, you have been warned.
[ 9198.766111] r8712u: DriverVersion: v7_0.20100831
[ 9198.766158] r8712u: register rtl8712_netdev_ops to netdev_ops
[ 9198.766165] r8712u: USB_SPEED_HIGH with 4 endpoints
[ 9198.766777] r8712u: Boot from EFUSE: Autoload OK
[ 9199.455864] r8712u: CustomerID = 0x000a
[ 9199.455877] r8712u: MAC Address from efuse = 00:0a:eb:3d:e0:47
[ 9199.455885] r8712u: Loading firmware from "rtlwifi/rtl8712u.bin"
[ 9199.456560] usbcore: registered new interface driver r8712u
[ 9199.844389] composite sync not supported
[ 9200.332570] r8712u: 1 RCR=0x153f00e
[ 9200.333314] r8712u: 2 RCR=0x553f00e
[ 9200.440983] ADDRCONF(NETDEV_UP): wlan1: link is not ready
[ 9204.892457] composite sync not supported

http://wiki.debian.org/rtl819x
http://wiki.debian.org/WiFi/HowToUse






#####
#
# Sony DVP SR320 (multi-region DVD player)
# 2013apr27
#
#####

# «sony-dvp-sr320» (to ".sony-dvp-sr320")
# http://compare.buscape.com.br/sony-dvp-sr320.html
# http://www.bondfaro.com.br/dvd-player--sony-dvp-sr320.html
# http://www.amazon.com/Sony-DVP-SR320-Multi-Region-Player/dp/B007Y76JAM
# http://www.docs.sony.com/release/DVPSR320_PT.pdf

# http://www.videohelp.com/dvdhacks




#####
#
# HP G42 (Stephanie)
# 2013jun27
#
######

# «hp-642» (to ".hp-642")
# http://h30487.www3.hp.com/t5/Hardware-para-notebooks/N%C3%A3o-consigo-entrar-no-Setup-Bios-do-HP-G42-214BR-Notebook-PC/td-p/198500
# http://www.google.com/search?q=how+to+enable+boot+from+usb+in+bios
# http://www.howtogeek.com/howto/16822/boot-from-a-usb-drive-even-if-your-bios-wont-let-you/




#####
#
# Sony DCR-HC52 (digital video camera - uses "Mini DV" tapes)
# 2013jun28
#
#####

# «sony-dcr-hc52» (to ".sony-dcr-hc52")
# http://store.sony.com/p/DCR-HC52/en/p/DCRHC52/1
# http://en.wikipedia.org/wiki/Mini_dv#MiniDV
# cabo: saida rca branca, vermelha, amarela, NTSC




#####
#
# Roteador D-Link do LLaRC (DIR-635)
# 2013sep25
#
#####

# «dlink-llarc» (to ".dlink-llarc")
# http://192.168.0.1/
# http://192.168.0.1/Basic/Wireless.shtml
# http://192.168.0.1/Tools/Admin.shtml
# (find-xpdfpage "~/tmp/DIR635B3_235EU_FW_ReleaseNote.pdf")

Setup -> Wireless settings -> Manual config -> pre-shared key



#####
#
# Roteador SmartLan Speed Route (I-Conecta)
# 2013dec14 / 2018nov20
#
#####

# «smartlan-iconecta» (to ".smartlan-iconecta")
# http://192.168.1.254/
# https://192.168.1.254/
# admin / admin

# http://powernetwork.com.br/assets/manuais/2222011102820.pdf

;; (find-fline "$S/http/powernetwork.com.br/assets/manuais/")
(code-xpdf     "smartlan" "$S/http/powernetwork.com.br/assets/manuais/2222011102820.pdf")
(code-pdf-text "smartlan" "$S/http/powernetwork.com.br/assets/manuais/2222011102820.pdf")
;; (find-smartlanpage)
;; (find-smartlantext)

# (find-smartlanpage 24 "192.168.1.254")
# (find-smartlantext 24 "192.168.1.254")



#####
#
# Gluglug X200 (Lenovo)
# 2015apr12
#
#####

# «X200» (to ".X200")
# (find-es "grub" "libreboot-x200")
# https://mail.google.com/mail/ca/u/0/#search/x200/14be999f87b2a87b (2015mar05)
# https://blogs.transparent.com/english/differences-between-the-us-and-uk-computer-keyboard/



#####
#
# Libreboot T400 (Lenovo)
# 2018nov18
#
#####

# «T400» (to ".T400")
# ThinkPad T400 and R400 Hardware Maintenance Manual:
# https://images10.newegg.com/UploadFilesForNewegg/itemintelligence/Lenovo/43y6629_021400130551905.pdf
;; (find-fline "$S/https/images10.newegg.com/UploadFilesForNewegg/itemintelligence/Lenovo/")
(code-pdf-page "t400maint" "$S/https/images10.newegg.com/UploadFilesForNewegg/itemintelligence/Lenovo/43y6629_021400130551905.pdf")
(code-pdf-text "t400maint" "$S/https/images10.newegg.com/UploadFilesForNewegg/itemintelligence/Lenovo/43y6629_021400130551905.pdf" 8)
;; (find-t400maintpage)
;; (find-t400maintpage 5 "Contents")
;; (find-t400maintpage (+ 8 47) "ThinkPad T400 and R400")
;; (find-t400maintpage (+ 8 51) "Status indicators")
;; (find-t400maintpage (+ 8 54) "FRU Tests")
;; (find-t400maintpage (+ 8 56) "Fn key combinations")
;; (find-t400maintpage (+ 8 56) "Fn+F5")
;; (find-t400mainttext (+ 8 56) "Fn+F5")
;; (find-t400maintpage (+ 8 56) "Fn+F5" "Enable or disable the built-in wireless")
;; (find-t400mainttext (+ 8 56) "Fn+F5" "Enable or disable the built-in wireless")
;; (find-t400mainttext)
;; (find-t400maintpage (+ 8 127) "Integrated camera")
;; (find-t400mainttext (+ 8 127) "Integrated camera")
;; (find-t400maintpage (+ 8 127) "Volume control buttons")
;; (find-t400mainttext (+ 8 127) "Volume control buttons")
;; (find-t400maintpage (+ 8 129) "Wireless radio switch")
;; (find-t400mainttext (+ 8 129) "Wireless radio switch")
;; (find-t400maintpage (+ 8 234) "AC adapters")
;; (find-t400mainttext (+ 8 234) "AC adapters")


It has a list of batteries in pages 156-163.
I am trying to check which ones from this list of results from local sellers,

Problems:
  wifi
  webcam
  speakers

# (find-sh "apt-file search webcam")
# (find-sh "locate webcam")
# (find-fline "/usr/src/linux-headers-4.4.0-140-generic/include/config/usb/")
# (find-fline "/usr/src/linux-headers-4.4.0-140-generic/drivers/media/usb/")
# (find-fline "/usr/src/linux-headers-4.4.0-140-generic/drivers/media/usb/Kconfig")
# (find-fline "/usr/src/linux-headers-4.4.0-140-generic/drivers/media/usb/Kconfig" "Webcam devices")
# (find-status   "cheese")
# (find-vldifile "cheese.list")
# (find-vldifile "cheese.list" "/usr/lib/cheese/gnome-camera-service")
# (find-udfile   "cheese/")

# (find-sh "apt-file search usb")
# (find-sh "apt-file search usb | grep bin")
# (find-status   "usbutils")
# (find-vldifile "usbutils.list")
# (find-udfile   "usbutils/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
/usr/bin/lsusb
/usr/bin/usb-devices
/usr/bin/usbhid-dump
/usr/sbin/update-usbids
usbview: /usr/bin/usbview
# (find-sh "/usr/bin/usb-devices")
# (find-sh "/usr/bin/usb-devices | grep -i product")





#####
#
# The wifi card on the T400
# 2019jan02
#
#####

# «T400-wifi» (to ".T400-wifi")
# (find-sh "sudo dmesg" "ath9k" "wlp2s0: renamed from wlan0")
# (find-sh "sudo lspci" "Qualcomm Atheros AR9285 Wireless")
# (find-fline "~/tmp/odmesg" "ath9k" "wlp2s0: renamed from wlan0")
# (find-fline "~/tmp/olspci" "Qualcomm Atheros AR9285 Wireless")
# (find-fline "/sda1/home/old-edrx/tmp/odmesg" "ath9k" "wlp2s0: renamed from wlan0")
# (find-fline "/sda1/home/old-edrx/tmp/olspci" "Qualcomm Atheros AR9285 Wireless")

# (find-sh "locate odmesg")

# (find-sh "journalctl --no-pager")

# (find-sh "sudo dmesg")
# (find-sh "sudo dmesg | grep wi")
# (find-sh "sudo dmesg | grep fi")
# (find-sh "sudo ifconfig")
# (find-sh "sudo ipconfig")
# (find-sh "sudo iwconfig")
# (find-sh "journalctl -b -gkernel")
# (find-sh "journalctl --no-pager")
# (find-sh "journalctl --no-pager | grep -i wi")
# (find-sh "export PAGER=cat journalctl")
# (find-sh "sudo journalctl | cat")
# (find-sh "sudo lspci")
# (find-man "1 journalctl")

# https://libreboot.org/faq.html

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo service network-manager restart




#####
#
# The webcam on the T400
# 2019jan02
#
#####

# «T400-webcam» (to ".T400-webcam")
# (find-fline "~/LOGS/2019jan02.libreboot")
# (find-sh "lsusb")
# (find-sh "lspci")

<swiftgeek> edrx: first check in lspci whether you have wifi card
            at all
<swiftgeek> and in lsusb for webcam
<swiftgeek> webcam would be like > Lenovo Integrated Webcam




#####
#
# Screen tearing  on the T400 (mainly in Chrome)
# 2019mar05
#
#####

# «T400-screen-tearing» (to ".T400-screen-tearing")
# https://en.wikipedia.org/wiki/Screen_tearing
# https://www.maketecheasier.com/get-rid-screen-tearing-linux/




#####
#
# T400-brightness
# 2019mar22
#
#####

# «T400-brightness» (to ".T400-brightness")
# (find-es "mate" "brightness")
# https://help.ubuntu.com/stable/ubuntu-help/display-brightness.html.en
# https://askubuntu.com/questions/149054/how-to-change-lcd-brightness-from-command-line-or-via-script
# https://www.ostechnix.com/how-to-adjust-monitor-brightness-from-command-line-in-linux/
# https://forums.linuxmint.com/viewtopic.php?t=244209 Brightness adjustable in MATE?
# (find-status   "x11-xserver-utils")
# (find-vldifile "x11-xserver-utils.list")
# (find-udfile   "x11-xserver-utils/")
# (find-man "1 xrandr")
# (find-status   "xbacklight")
# (find-vldifile "xbacklight.list")
# (find-udfile   "xbacklight/")

x11-xserver-utils: /usr/bin/xrandr
x11-xserver-utils: /usr/share/man/man1/xrandr.1.gz
xdiagnose: /usr/bin/xrandr-tool
xdiagnose: /usr/share/apport/package-hooks/libxrandr-lts-quantal.py
xdiagnose: /usr/share/apport/package-hooks/source_libxrandr.py
xdiagnose: /usr/share/apport/package-hooks/source_xrandr.py
xserver-xorg: /usr/share/doc/xorg/howto/use-xrandr.html
xserver-xorg: /usr/share/doc/xorg/howto/use-xrandr.txt.gz
zsh-common: /usr/share/zsh/functions/Completion/X/_xrandr




#####
#
# T400-keyboard
# 2024may15
#
#####

# «T400-keyboard»  (to ".T400-keyboard")
# (find-angg ".emacs" "ee-setxkbmap-show")
# https://askubuntu.com/questions/1466336/thinkpad-t440-keyboard-not-listed-in-lxqt-settings-keyboard-and-mouse
# https://wiki.archlinux.org/title/Lenovo_ThinkPad_T400







#####
#
# Atheros AR5B95
# 2022mar29
#
#####

# «atheros-AR5B95»  (to ".atheros-AR5B95")
# https://wiki.debian.org/ath9k
# https://wireless.wiki.kernel.org/en/users/Drivers/ath9k
# https://wireless.wiki.kernel.org/en/users/drivers/ath9k/devices
# https://trisquel.info/en/forum/will-atheros-9285-ar5b95-ar9285-work-free-software

Atheros AR5B97 linux

https://ubuntuforums.org/showthread.php?t=1751134 Thread: 11.04 wireless issue AR9287/AR5B97
https://wiki.debian.org/ath5k



#####
#
# zoom-F1-SP
# 2019oct24
#
#####

# «zoom-F1-SP» (to ".zoom-F1-SP")
# https://www.thomann.de/gb/zoom_f1_sp.htm
# https://www.thomann.de/gb/zoom.html
# https://en.wikipedia.org/wiki/Zoom_Corporation
# https://en.wikipedia.org/wiki/Zoom_Corporation#Digital_recorders
# https://www.zoom.co.jp/
# https://www.zoom.co.jp/products/field-video-recording/field-recording/f1-field-recordershotgun-mic#downloads
# https://www.zoom.co.jp/sites/default/files/products/downloads/pdfs/E_F1_QuickGuide_0.pdf
# https://www.zoom.co.jp/sites/default/files/products/downloads/pdfs/E_F1_2.pdf
# https://mail.google.com/mail/ca/u/0/#search/zoom+recorder/FMfcgxvwzcHKkrHdlGdMZsSGQXDjDhJF

# (code-pdf-page "zoomop" "$S/https/www.zoom.co.jp/sites/default/files/products/downloads/pdfs/E_F1_2.pdf")
# (code-pdf-text "zoomop" "$S/https/www.zoom.co.jp/sites/default/files/products/downloads/pdfs/E_F1_2.pdf" 1)
# (find-zoomoppage)
# (find-zoomoptext)
# (find-zoomoppage (+ 1 44) "Using as an audio interface")
# (find-zoomoptext (+ 1 44) "Using as an audio interface")
# (find-zoomoppage (+ 1 59) "Setting the type of battery used")
# (find-zoomoptext (+ 1 59) "Setting the type of battery used")
# (find-zoomoppage (+ 1 72) "microUSB")
# (find-zoomoptext (+ 1 72) "microUSB")
# (find-zoomoppage (+ 1 72) "AC adapter (ZOOM AD-17): DC 5V/1A")
# (find-zoomoptext (+ 1 72) "AC adapter (ZOOM AD-17): DC 5V/1A")
# https://en.wikipedia.org/wiki/USB_hardware#Micro_connectors USB micro B?
# https://www.hrebos.com.br/cabos-usb?&sort=%2Bnome

# https://unix.stackexchange.com/questions/465915/how-exactly-usb-audio-will-be-detected-in-linux
# https://unix.stackexchange.com/questions/404684/figuring-out-usb-devices
# (find-sh "lsusb -v")
# (find-sh "lsusb -v" "ZOOM Corporation")
# (find-sh "dmesg")
# (find-sh "lspci")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo dmesg

# usb 3-1: new full-speed USB device number 2 using uhci_hcd
# usb 3-1: New USB device found, idVendor=1686, idProduct=03f5
# usb 3-1: New USB device strings: Mfr=1, Product=2, SerialNumber=3
# usb 3-1: Product: F1
# usb 3-1: Manufacturer: ZOOM Corporation
# usb 3-1: SerialNumber: 000000000000
# usb 3-1: Warning! Unlikely big volume range (=4294967295), cval->res is probably wrong.
# usb 3-1: [2] FU [Mic Capture Volume] ch = 2, val = 1/0/1
# usbcore: registered new interface driver snd-usb-audio

[24724.239841] usb 6-1: new full-speed USB device number 18 using uhci_hcd
[24724.375834] usb 6-1: device descriptor read/64, error -71
[24725.247840] usb 6-1: device descriptor read/64, error -71
[24731.871844] usb 6-1: new full-speed USB device number 20 using uhci_hcd
[24732.058129] usb 6-1: New USB device found, idVendor=1686, idProduct=03f5, bcdDevice= 0.00
[24732.058140] usb 6-1: New USB device strings: Mfr=1, Product=2, SerialNumber=3
[24732.058146] usb 6-1: Product: F1
[24732.058151] usb 6-1: Manufacturer: ZOOM Corporation
[24732.058155] usb 6-1: SerialNumber: 000000000000
[24736.911148] retire_capture_urb: 8 callbacks suppressed
[24737.040003] usb 6-1: USB disconnect, device number 20
[24747.031737] usb 6-1: new full-speed USB device number 21 using uhci_hcd
[24747.215135] usb 6-1: New USB device found, idVendor=1686, idProduct=03f5, bcdDevice= 0.00
[24747.215145] usb 6-1: New USB device strings: Mfr=1, Product=2, SerialNumber=3
[24747.215151] usb 6-1: Product: F1
[24747.215156] usb 6-1: Manufacturer: ZOOM Corporation
[24747.215160] usb 6-1: SerialNumber: 000000000000




#####
#
# limpa-contatos
# 2022may17
#
#####

# «limpa-contatos»  (to ".limpa-contatos")
Kaol polidor de metais
Alcool isopropilico
alguma coisa 18



#####
#
# 2016jul21
# mcelog
#
#####

# «mcelog» (to ".mcelog")
# (find-status   "mcelog")
# (find-vldifile "mcelog.list")
# (find-udfile   "mcelog/")
# (find-man "8 mcelog")
# (find-sh "sudo mcelog --ascii")




#####
#
# memtest
# 2017set08
#
#####

# «memtest» (to ".memtest")
# (find-zsh "installeddebs | sort | grep memtest")
# (find-zsh "availabledebs | sort | grep memtest")
# https://packages.debian.org/stretch/memtest86+
# https://packages.debian.org/stretch/memtester
# (find-status   "memtest86+")
# (find-vldifile "memtest86+.list")
# (find-udfile   "memtest86+/")
# (find-status   "memtester")
# (find-vldifile "memtester.list")
# (find-udfile   "memtester/")

Setting up memtest86+ (4.20-1.1ubuntu8) ...
Generating grub configuration file ...
Found linux image: /boot/vmlinuz-3.13.0-39-lowlatency
Found initrd image: /boot/initrd.img-3.13.0-39-lowlatency
Found memtest86+ image: /boot/memtest86+.elf
Found memtest86+ image: /boot/memtest86+.bin
File descriptor 3 (pipe:[15882]) leaked on lvs invocation. Parent PID 3000: /bin/sh
  No volume groups found
Found Trisquel GNU/Linux 7.0, Belenos (7.0) on /dev/sda1
done
Setting up memtester (4.3.0-3) ...




#####
#
# touchpad
# 2018nov13
#
#####

# «touchpad» (to ".touchpad")
# (find-angg ".emacs" "no-mouse-mode")
# https://en.wikipedia.org/wiki/Touchpad
# https://wiki.debian.org/SynapticsTouchpad
# Tap-to-click
# (find-es "eee" "fn-f-keys")

System -> Preferences -> Hardward -> Mouse -> Touchpad




#####
#
# Cabo de áudio DMD GS-3030 (3 metros)
# 2019feb19
#
#####

# «dmd-gs-3030» (to ".dmd-gs-3030")
# Cabo Áudio Estéreo P2 x P2 Diamond Cable DMD GS3030 3m




#####
#
# Pioneer X-cm56 Micro System Bluetooth Usb Nfc Mp3
# 2020nov03
#
#####

# «pioneer-x-cm56»  (to ".pioneer-x-cm56")
# https://mail.google.com/mail/ca/u/0/#search/pioneer/FMfcgxwCgLsZGHmdLVpbdKvltlSxrhJL
# https://www.pioneerelectronics.com/ephox/StaticFiles/PUSA/Files/Home/X-CM56_56D_EnFrEs_170303_web.pdf
# https://intl.pioneer-audiovisual.com/manuals/docs/YOM200173-001.pdf
# https://www.manualslib.com/products/Pioneer-X-Cm56-5143882.html



#####
#
# Choosing a tablet
# 2019may22
#
#####

# «choosing-a-tablet» (to ".choosing-a-tablet")
# https://www.youtube.com/watch?v=lbJQQG2_OOQ
# https://www.youtube.com/watch?v=4hZxo96x48A
# https://www.toptenselect.com/best-10-inch-tablets/
# https://www.amazon.co.uk/Samsung-SM-T820NZKABTU-Snapdragon-Processor-Android/dp/B07358KSVN/ref=sr_1_3

# https://www.androidcentral.com/3-great-keyboards-your-samsung-galaxy-tab-s3



#####
#
# samsung-galaxy-tab-s3
# 2019jul16
#
#####

# «samsung-galaxy-tab-s3» (to ".samsung-galaxy-tab-s3")
# (find-es "android" "galaxy-s3-tablet")




#####
#
# Belkin QODE Slim Style Universal Keyboard Case (F5L179)
# 2019jul16
#
#####

# «belkin-qode» (to ".belkin-qode")
# https://www.belkin.com/uk/p/P-F5L179/
# https://www.belkin.com/uk/support-product?rnId=01t80000003ohwUAAQ
# https://www.belkin.com/uk/support-article?articleNum=8310

Belkin QODE SlimStyle Universal Keyboard Case, F5L179 Frequently Asked Questions

NOTE:  A red LED lights up if it is charging and will turn blue when fully charged.
NOTE:  The indicator light will be solid orange while charging.  The indicator light will turn OFF when charging is complete.





#####
#
# samsung-m20
# 2019nov07
#
#####

# «samsung-m20» (to ".samsung-m20")
# (find-es "android" "galaxy-m20")




#####
#
# samsung split inverter
# 2021jan11
#
#####

# «samsung-inverter»  (to ".samsung-inverter")
# https://mail.google.com/mail/ca/u/0/#search/samsung+inverter/FMfcgxmQGqqhhMvXBqTMFWHqNCjbWRpk
# https://www.samsung.com/br/support/model/AR09HSSPBSN/AZ/
# https://www.webarcondicionado.com.br/manual-do-usuario-samsung
# (code-pdf-page "inverter" "~/tmp/Digital_Inverter_Manual_do_Usuario_DB68-06211_02.pdf")
# (code-pdf-text "inverter" "~/tmp/Digital_Inverter_Manual_do_Usuario_DB68-06211_02.pdf")
# (find-inverterpage)
# (find-invertertext)

Procurar no whatsapp por "split inverter"



#####
#
# LG split inverter
# 2023jul25
#
#####

# «LG-inverter»  (to ".LG-inverter")
# https://mail.google.com/mail/u/0/#inbox/FMfcgzGtwDFjGzqFkhGfBdCstzSDcgKq
# https://mail.google.com/mail/u/0/#search/from%3Acentralar.com/FMfcgzGtwDFjGzqFkhGfBdCstzSDcgKq
# https://blog.leveros.com.br/ar-condicionado-gasta-muita-energia/
# https://www.frigelar.com.br/calculadora-de-btus

Ar Condicionado Split Hw Lg Dual Voice Inverter 18.000 Frio 220V
Monofásico S4NQ18KL31B.EB2GAMZ





#####
#
# one-by-wacom
# 2020jul27
#
#####

# «one-by-wacom»  (to ".one-by-wacom")
# https://linuxwacom.github.io/
# https://github.com/linuxwacom/input-wacom/wiki/Installing-input-wacom-from-source
# https://github.com/linuxwacom/xf86-input-wacom/wiki/Building-The-Driver
# https://github.com/linuxwacom/libwacom/wiki
# https://www.mercadolivre.com.br/mesa-digitalizadora-wacom-one-small-blackred/p/MLB9339514
# https://www.wacom.com/en-us/products/pen-tablets/one-by-wacom

# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgxwJXCCfBXKhCsQzkLxhtdJvqmXs compra Zeta TI
# https://mail.google.com/mail/ca/u/0/#search/wacom/FMfcgxwJXCKXnZcQdDhlpFCDQWfZLmZC devolvido Zeta TI
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgxwJXCKZbHtvrpQjvtXkzvvBTfDz compra Matron
# https://myaccount.mercadolivre.com.br/purchases/2591506293/detail_legacy

# https://github.com/linuxwacom/libwacom
# (find-git-links "https://github.com/linuxwacom/libwacom" "libwacom")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/libwacom/
cd      ~/usrc/
git clone https://github.com/linuxwacom/libwacom
cd      ~/usrc/libwacom/

# (find-fline "~/usrc/")
# (find-fline "~/usrc/libwacom/")
# (find-gitk  "~/usrc/libwacom/")

# (code-c-d "libwacom" "~/usrc/libwacom/")
# (find-libwacomfile "")
# (find-libwacomfile "data/")
# (find-libwacomfile "data/one-by-wacom-s-p.tablet")
# (find-libwacomfile "data/one-by-wacom-s-p2.tablet")

 http://www.youtube.com/watch?v=hQl6ZQFDiJ4 How to Use GIMP Pressure Sensitivity With Tablet Input Devices

edit -> preferences -> input devices -> configure extended input devices





#####
#
# Happy Hacking Keyboard Lite2 USB (Black)
# 2013 / 2021nov19
#
#####

# «happy-hacking-keyboard»  (to ".happy-hacking-keyboard")
# https://news.ycombinator.com/item?id=29282401 Why Are Topre Keyboards So Expensive? (switchandclick.com)



#####
#
# fonte-T400-grasep
# 2023feb14
#
#####

# «fonte-T400-grasep»  (to ".fonte-T400-grasep")
# https://mail.google.com/mail/u/0/#search/mercado+/FMfcgzGrcXnxlKpwjqLPZtbShxHPKJnF
# https://myaccount.mercadolivre.com.br/my_purchases/2000005097353708/status



#####
#
# banheiros
# 2023may04
#
#####

# «banheiros»  (to ".banheiros")

Registros do banheiro do meu quarto:
privada / /



#####
#
# VIX KT-9018E: universal A/C remote
# 2023sep22
#
#####

# «universal-ac-remote»  (to ".universal-ac-remote")
# https://www.refrigeracaomota.com.br/loja/controle-remoto-universal-para-ar-condicionado-kt-9018e/
# http://www.youtube.com/watch?v=nzfyoQayplM Como Programar Controle Remoto Universal Ar Condicionado KT-9018E (Configuração e Manual Instruções)
# http://www.youtube.com/watch?v=w4eSdZIzmSM Como mudar de Fahrenheit para Celsius, controle universal Vix KT 9018E ar split

Consul	0463, 0975, 2511
LG	0197-0200, 0514, 2050, 3730

Aparentemente o Consul da sala 5 usa o código 169





maxtrava
https://produto.mercadolivre.com.br/MLB-1673363317-cadeado-espiral-bike-maxtrava-mxtra0007-22mmx120cm-com-chave-_JM
https://www.timbobikestore.com.br/acessorios/cadeados/cadeado-espiral-bike-maxtrava-mxtra0007-22mmx120cm-com-chave

www.boadica.com.br
  multifuncional: HP photosmart C4780  280-290

https://www.pcmag.com/picks/the-best-usb-microphones
https://www.pcmag.com/reviews/blue-snowball-ice

https://blog.adacore.com/an-embedded-usb-device-stack-in-ada


barbara: samsung galaxy note3

https://www.quora.com/Is-it-okay-if-my-laptop-is-always-plugged-in-so-that-my-battery-is-charged-100-Must-I-allow-it-to-drain-periodically-by-unplugging-to-increase-battery-life/answer/Arunachalam-Muthupalaniappan
https://news.ycombinator.com/item?id=35324961 The ThinkPad X1 Carbon Gen 10 as a Linux Laptop (theregister.com) - always check the Arch Linux wiki first
https://news.ycombinator.com/item?id=35496651 GNU+Linux laptops with Libreboot preinstalled, based on coreboot (minifree.org)





#  Local Variables:
#  coding:               utf-8-unix
#  End:
