#######
#
# E-scripts on Highlight.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/highlight.e>
#           or at <http://angg.twu.net/e/highlight.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.debian»		(to "debian")
# «.highlight-3.49»	(to "highlight-3.49")
# «.wiki»		(to "wiki")
# «.highlight-deb-src»	(to "highlight-deb-src")
# «.debian-package»	(to "debian-package")
# «.custom-themes»	(to "custom-themes")
# «.upstream»		(to "upstream")
# «.jslight»		(to "jslight")
# «.lxsh»		(to "lxsh")
# «.mailing-list»	(to "mailing-list")









http://packages.debian.org/highlight
http://packages.debian.org/src:highlight
http://ftp.debian.org/debian/pool/main/h/highlight/



#####
#
# Highlight in Debian (2019, version 3.18)
# 2019mar02
#
#####

# «debian» (to ".debian")
# (find-zsh "installeddebs | sort | grep highlight")
# (find-zsh "availabledebs | sort | grep highlight")
# (find-status   "highlight-common")
# (find-vldifile "highlight-common.list")
# (find-udfile   "highlight-common/")
# (find-status   "highlight")
# (find-vldifile "highlight.list")
# (find-udfile   "highlight/")
# (find-fline "/usr/share/highlight/langDefs/")
# (find-fline "/usr/share/highlight/langDefs/lua.lang")




#####
#
# highlight-3.49
# 2019mar02
#
#####

# «highlight-3.49» (to ".highlight-3.49")
# http://www.andre-simon.de/
# http://www.andre-simon.de/zip/download.php
# http://www.andre-simon.de/zip/highlight-3.49.tar.bz2

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/highlight-3.49/
mkdir  ~/usrc/highlight-3.49/
cd     ~/usrc/highlight-3.49/
tar -C ~/usrc/ -xvjf $S/http/www.andre-simon.de/zip/highlight-3.49.tar.bz2

# (code-c-d "highlight" "~/usrc/highlight-3.49/")
# (find-highlightfile "")
# (find-highlightfile "langDefs/")
# (find-highlightfile "langDefs/lisp.lang")
# (find-highlightfile "extras/langs-examples/")
# (find-highlightfile "extras/langs-examples/CONTRIBUTING.md")
# (find-highlightfile "plugins/")



#####
#
# wiki
# 2019mar02
#
#####

# «wiki» (to ".wiki")
# https://github.com/tajmone/highlight/wiki
# https://github.com/tajmone/highlight/wiki/LangDefs-Debugging




#####
#
# highlight (from the debian sources)
# 2011apr15 / 2012jun10 / 2013sep06
#
#####

# «highlight-deb-src» (to ".highlight-deb-src")
# http://ftp.debian.org/debian/pool/main/h/highlight/
# http://ftp.debian.org/debian/pool/main/h/highlight/highlight_3.12+svn83-1.dsc
# http://ftp.debian.org/debian/pool/main/h/highlight/highlight_3.12+svn83-1.diff.gz
# http://ftp.debian.org/debian/pool/main/h/highlight/highlight_3.12+svn83-1.debian.tar.gz
# http://ftp.debian.org/debian/pool/main/h/highlight/highlight_3.12+svn83.orig.tar.bz2
#
rm -Rv ~/usrc/highlight/
mkdir  ~/usrc/highlight/
cd $S/http/ftp.debian.org/debian/pool/main/h/highlight/
cp -v highlight_3.12+svn83* ~/usrc/highlight/
cd     ~/usrc/highlight/
dpkg-source -sn -x highlight_3.12+svn83-1.dsc
cd     ~/usrc/highlight/highlight-3.12+svn83/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/highlight/")
 (eepitch-shell)
cd ~/usrc/highlight/
sudo dpkg -i *.deb

#
# (code-c-d "highlight" "~/usrc/highlight/highlight-3.12+svn83/")
# (find-highlightfile "")
# (find-highlightgrep "grep -nriH -e background-color *")
# (find-highlightfile "src/core/htmlgenerator.cpp" "background-color:")
# (find-highlightgrep "grep -nrH -e getBgColour *")
# (find-highlightgrep "grep -nrH -e getColour *")
# (find-highlightfile "src/core/syntaxreader.cpp" "SyntaxReader::luaAddKeyword")
# (find-highlightfile "src/core/syntaxreader.cpp" "lua")

# old:
# (find-highlightfile "")
# (find-highlightfile "examples/web_plugins/")
# (find-highlightfile "examples/web_plugins/wordpress/")
# (find-highlightfile "plugins/")
# (find-highlightfile "plugins/bash_ref_linuxmanpages_com.lua" ".linuxmanpages")
# (find-highlightfile "src/core/")
# (find-highlightfile "src/core/ansigenerator.cpp")
# (find-highlightfile "src/core/htmlgenerator.cpp")
# (find-highlightfile "src/core/latexgenerator.cpp")
# (find-highlightfile "examples/swig/")
# (find-highlightfile "examples/swig/README_SWIG")
# (find-highlightfile "examples/swig/highlight.i")
# (find-highlightfile "examples/swig/makefile")
# (find-highlightfile "odb")
# (find-highlightfile "odb" "swig -c++")
# (find-highlightfile "src/core/syntaxreader.cpp")
# (find-highlightsh "find * | sort")





#####
#
# Highlight: Debian Package (and usage)
# 2011aug04
#
#####

# «debian-package»  (to ".debian-package")
# (find-status   "highlight")
# (find-vldifile "highlight.list")
# (find-udfile   "highlight/")
# (find-status   "highlight-common")
# (find-vldifile "highlight-common.list")
# (find-udfile   "highlight-common/")
# (find-fline "/usr/share/highlight/langDefs/")
# (find-fline "/usr/share/highlight/langDefs/lua.lang")
# (find-fline "/usr/share/highlight/themes/")
# (find-fline "/usr/share/highlight/themes/emacs.style")
# (find-man "1 highlight")
# (find-man "1 highlight" "-o, --output=<file>")
# (find-man "1 highlight" "-O, --out-format=<format>")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/highl/
mkdir  /tmp/highl/
cd     /tmp/highl/
cp -v ~/blogme4/elisp.lua .
highlight -I -o elisp.lua.html elisp.lua

highlight    -O . elisp.lua
highlight -L -O . elisp.lua

# (find-fline "/tmp/highl/elisp.lua.tex" 1 '(eek "C-x h") '(fooi "" "." "«" "<" "»" ">"))

latex elisp.lua.tex

# (find-fline "/tmp/highl/")
# (find-fline "/tmp/highl/elisp.lua.tex")
# (find-fline "/tmp/highl/elisp.lua.html")
# (find-fline "/tmp/highl/highlight.css")
# file:///tmp/highl/elisp.lua.html

# (find-sh "highlight --help")
# (find-sh "highlight --help" "-H, --html")
# (find-sh "highlight --help" "-s, --style=<style>")
# (find-sh "highlight --help" "-I, --include-style")
# (find-sh "highlight --help" "-i, --input=<file>")
# (find-sh "highlight --help" "-o, --output=<file>")
# (find-sh "highlight --list-langs")
# (find-sh "highlight --list-themes")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/hi/
mkdir  /tmp/hi/
cd     /tmp/hi/
A=( acid bipolar blacknblue bright contrast darkblue darkness desert
easter emacs golden greenlcd ide-anjuta ide-codewarrior ide-eclipse
ide-kdev ide-msvs2008 ide-xcode jedit kwrite lucretia matlab moe navy
nedit neon night orion pablo peachpuff print rand01 seashell the
typical vampire vim-dark vim whitengrey zellner )
for i in $A; do
  echo highlight -I -O html -s $i -o o.$i.html ~/dednat5/dednat5.lua
       highlight -I -O html -s $i -o o.$i.html ~/dednat5/dednat5.lua
done

#       file:///tmp/hi/
# (find-fline "/tmp/hi/")
# http://softwaremaniacs.org/media/soft/highlight/test.html

highlight -H -o /tmp/o.html ~/dednat5/dednat5.lua
highlight -H -o /tmp/o.html ~/dednat5/dednat5.lua
# file:///tmp/o.html
emacs




#####
#
# Custom themes
# 2012jun12
#
#####

# «custom-themes»  (to ".custom-themes")
# (find-angg "HIGHLIGHT/")
# (find-angg "HIGHLIGHT/edrx-emacs.theme")
# (find-man "1 highlight")
# (find-man "1 highlight" "README")
# (find-status   "highlight")
# (find-vldifile "highlight.list")
# (find-udfile   "highlight/")
# (find-udfile "highlight/README.gz")
# (find-udfile "highlight/README.gz" "prints only the CSS")
# (find-udfile "highlight/README.gz" "--config-file yyy.theme")
# (find-udfile "highlight/README.gz" "to display the Lua and syntax data")

# (find-sh "highlight --help" "-s, --style=<style>")
# (find-sh "highlight --help" "-I, --include-style")
# (find-sh "highlight --verbose --syntax Lisp")
# (find-fline "/usr/share/highlight/themes/")
# (find-fline "/usr/share/highlight/themes/edit-emacs.theme")
# (find-eevfile "eepitch.el.html")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cp -v ~/eev-current/eepitch.el /tmp/
cd /tmp/
highlight -I -o eepitch.el.html eepitch.el
highlight -I -s edit-emacs -o eepitch.el.html eepitch.el
highlight --config-file ~/HIGHLIGHT/edrx-emacs.theme \
          -I -o eepitch.el.html eepitch.el

# (defun c () (interactive) (find-sh0 "cd /tmp/; highlight --config-file ~/HIGHLIGHT/edrx-emacs.theme -I -o eepitch.el.html eepitch.el"))
# (defun eejump-9 () (find-angg "HIGHLIGHT/edrx-emacs.theme"))

# (find-angg "HIGHLIGHT/edrx-emacs.theme")
# (find-fline "/tmp/eepitch.el.html")
# file:///tmp/eepitch.el.html
# file:///home/edrx/TH/L/eev-current/eepitch.el.html

# (find-fline "/usr/share/highlight/themes/edit-emacs.theme")
#
Default        = { Colour="#000000" }
Canvas         = { Colour="#ffffff" }
Number         = { Colour="#000000" }
Escape         = { Colour="#bd8d8b" }
String         = { Colour="#bd8d8b" }
StringPreProc  = { Colour="#bd8d8b" }
BlockComment   = { Colour="#ac2020", Italic=true }
PreProcessor   = { Colour="#000000" }
LineNum        = { Colour="#555555" }
Operator       = { Colour="#000000" }
LineComment = BlockComment
#
Keywords = {
  { Colour= "#9c20ee", Bold=true },
  { Colour= "#208920" },
  { Colour= "#0000ff" },
  { Colour= "#000000" },
}

# (find-fline "/tmp/eepitch.el.html")
#
body.hl	{ background-color:#ffffff; }
pre.hl	{ color:#000000; background-color:#ffffff; font-size:10pt; font-family:'Courier New';}
.hl.num { color:#000000; }
.hl.esc { color:#bd8d8b; }
.hl.str { color:#bd8d8b; }
.hl.pps { color:#bd8d8b; }
.hl.slc { color:#ac2020; font-style:italic; }
.hl.com { color:#ac2020; font-style:italic; }
.hl.ppc { color:#000000; }
.hl.opt { color:#000000; }
.hl.lin { color:#555555; }
.hl.kwa { color:#9c20ee; font-weight:bold; }
.hl.kwb { color:#208920; }
.hl.kwc { color:#0000ff; }
.hl.kwd { color:#000000; }


# (find-eevfile "eepitch.el.html")
#
body                { color: #ffe4c4; background-color: #000000; }
.builtin            { /* font-lock-builtin-face */ color: #b0c4de; }
.comment            { /* font-lock-comment-face */ color: #ff7f24; }
.comment-delimiter  { /* font-lock-comment-delimiter-face */ color: #ff7f24; }
.constant           { /* font-lock-constant-face */ color: #7fffd4; }
.doc                { /* font-lock-doc-face */ color: #ffa07a; }
.eev-glyph-face-red { /* eev-glyph-face-red */ color: #ff0000; }
.function-name      { /* font-lock-function-name-face */ color: #87cefa; }
.keyword            { /* font-lock-keyword-face */ color: #00ffff; }
.regexp-grouping-backslash { /* font-lock-regexp-grouping-backslash */ font-weight: bold; }
.regexp-grouping-construct { /* font-lock-regexp-grouping-construct */ font-weight: bold; }
.string             { /* font-lock-string-face */ color: #ffa07a; }
.type               { /* font-lock-type-face */ color: #98fb98; }
.variable-name      { /* font-lock-variable-name-face */ color: #eedd82; }
.warning            { /* font-lock-warning-face */ color: #ffc0cb; font-weight: bold; }
a       { color: inherit; background-color: inherit; font: inherit; text-decoration: inherit; }
a:hover { text-decoration: underline; }








#####
#
# Highlight from the upstream tarball
# 2011jan04
#
#####

# «upstream»  (to ".upstream")
# http://www.andre-simon.de/
# http://www.andre-simon.de/zip/highlight-3.3.tar.gz
#
rm -Rv ~/usrc/highlight-3.3/
tar -C ~/usrc/ -xvzf \
  $S/http/www.andre-simon.de/zip/highlight-3.3.tar.gz
cd     ~/usrc/highlight-3.3/

#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd     ~/usrc/highlight-3.3/
make help
make cli |& tee omc

# (code-c-d "highlight" "~/usrc/highlight-3.3/")
# (find-highlightfile "")
# (find-highlightfile "README")
# (find-highlightfile "INSTALL" "make help")
# (find-highlightfile "README_PLUGINS")
# (find-highlightfile "plugins/")
# (find-highlightfile "makefile")
# (find-highlightfile "src/makefile")




#####
#
# Rici Lake's jslight
# 2011jan10
#
#####

# «jslight»  (to ".jslight")
# http://code.google.com/p/jslight/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/jslight-read-only/
cd     ~/usrc/
svn checkout http://jslight.googlecode.com/svn/trunk/ jslight-read-only
cd     ~/usrc/jslight-read-only/

# (code-c-d "jslight" "~/usrc/jslight-read-only/")
# (find-jslightfile "")

cd /tmp/
# Non-members may check out a read-only working copy anonymously over HTTP.

http://softwaremaniacs.org/soft/highlight/en/





#####
#
# lxsh
# 2011jan14
#
#####

# «lxsh»  (to ".lxsh")
http://peterodding.com/code/lua/lxsh/
http://peterodding.com/code/lua/lxsh/examples/earendel/prompt.lua.html
http://peterodding.com/code/lua/lxsh/styleswitcher.js

luarocks install http://peterodding.com/code/lua/lxsh/downloads/lxsh-0.5-1.rockspec




#####
#
# Mailing list
# 2013sep18
#
#####

# «mailing-list» (to ".mailing-list")

Hi Andre,

I am trying to stop using my heavily hacked version of an Emacs
package called "htmlize.el" - I use it to create htmlized versions of
some elisp files to put in my page, but it is buggy -, and start using
Highlight instead... I have just learned how to create and use my own
themes - I am trying to reproduce the colors that I use in Emacs -,
and my next goal is to modify "lisp.lang", to get something like this:

  http://angg.twu.net/eev-current/eev-glyphs.el.html

I can't find any references to a mailing list, or to any document on
how to write new language files... Is tehre a mailing list? Where is
the right place for posting hacks and doubts? The wiki?

http://www.andre-simon.de/
http://www.andre-simon.de/dokuwiki/doku.php
http://www.andre-simon.de/dokuwiki/doku.php?id=upload:files








#  Local Variables:
#  coding:               utf-8-unix
#  modes: (fundamental-mode lua-mode c-mode)
#  End:
