#######
#
# E-scripts on howm and org (packages for Emacs)
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/howm.e>
#           or at <http://angg.twu.net/e/howm.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.howm»		(to "howm")
# «.keymaps»		(to "keymaps")
# «.reminders»		(to "reminders")
# «.org-upstream»	(to "org-upstream")
# «.notes-on-org»	(to "notes-on-org")




#####
#
# howm
# 2005jun28
#
#####

# «howm»  (to ".howm")
# (find-angg ".emacs" "howm")
# http://howm.sourceforge.jp/a/howm-1.3.0rc3.tar.gz
# http://howm.sourceforge.jp/a/howm-1.3.2.tar.gz
# http://howm.sourceforge.jp/a/howm-test.tar.gz

#
# (find-node "(tar)Option Summary" "`--strip-path=NUMBER'")
rm -Rv ~/usrc/howm-test/
mkdir  ~/usrc/howm-test/
tar -C ~/usrc/howm-test/ --strip-path=1 -xvzf \
  $S/http/howm.sourceforge.jp/a/howm-test.tar.gz

cd ~/usrc/howm-test/
./configure  2>&1 | tee oc
make         2>&1 | tee om

#

#
cd ~/usrc/
# rm -rf howm*
tar -xvzf $S/http/howm.sourceforge.jp/a/howm-1.3.2.tar.gz
cd ~/usrc/howm-1.3.2/

./configure  2>&1 | tee oc
make         2>&1 | tee om

#
# (progn (eev-bounded) (find-zsh "ee"))
#
rm -Rv /tmp/howm/
mkdir  /tmp/howm/
cd     /tmp/howm/
cat > .howm <<'%%%'
= howm menu page
<<< CategoryMenu

;; [New] Search([String] [Regexp]) 
;; [Dup] [<Title] [<Name] [Date>] [Key>] [Update]
;; [All] [Recent] 
;; [Schedule] [Todo]

>>> http://howm.sourceforge.jp/
>>> ~/DTO/howm/
  (find-howmfile "")
  (find-howmfile "doc/README.rd")

%%%

#
(code-c-d "howm" "~/usrc/howm-1.3.0rc2/")
(require 'howm)
(setq howm-directory "/tmp/howm/")
(setq howm-file-name-format "%Y-%m-%d.howm")
(setq howm-menu-file ".howm")
(howm-menu)

;; (find-efunction 'action-lock-magic-return)

;; (find-fline "~/DTO/howm/config-snips.el")

# (find-efunction 'action-lock-regexp-range)
# (find-efunction 'action-lock-get-action/range)
# (find-efunction 'action-lock-get-action)
# (find-efunction 'action-lock-invoke)
# (find-efunction 'action-lock-magic-return)

# (find-evariable 'howm-menu-command-table-en)




#####
#
# howm keymaps
# 2005jul05
#
#####

# «keymaps»  (to ".keymaps")
# Howm has several similar sub-modes, possibly with slightly
# different keymaps. What are the differences between them?
# (find-eapropos "howm.*mode")
# (find-eapropos "howm.*mode-map")
#
cd ~/usrc/howm-1.3.0rc2/
grep howm-menu-mode-map          *.el
grep howm-mode-map               *.el
grep howm-view-contents-mode-map *.el
grep howm-view-summary-mode-map  *.el

#
# (find-evariable 'howm-default-key-table)
# (find-efunction 'howm-set-keymap)
# (find-howmfile "howm-mode.el" "define-minor-mode howm-mode")
# (find-efunctiondescr 'howm-mode)

# (progn (find-estring "") (howm-mode) (eek "C-c , C-h"))
# (find-evariable 'howm-menu-mode-map)
# (find-howmfile "howm-view.el" "let ((m howm-view-summary-mode-map))")
# (find-howmfile "howm-view.el" "let ((m howm-view-contents-mode-map))")

# (find-howmfile "")
# (find-evardescr 'home-menu-mode-map)




#####
#
# reminders
# 2005jul05
#
#####

# «reminders»  (to ".reminders")

  From: (find-howmfile "doc/README.rd" "== Fifth day")
        (find-howmfile "howm-reminder.el")
        (find-howmfile "howm-reminder.el" "howm-reminder-font-lock-keywords")

(progn (find-estring "
    [2003-09-10]- howm-reminder-normal-face
    [2003-09-10]+ howm-reminder-todo-face
    [2003-09-10]! howm-reminder-deadline-face
    [2003-09-10]~ howm-reminder-defer-face
    [2003-09-10]. howm-reminder-done-face
    [2003-09-10]@ howm-reminder-schedule-face
        ")
       (howm-mode))

What are the operations on reminders?




#####
#
# howm keywords (<<<)
# 2005jul05
#
#####

  (find-howmfile "")
  (find-howmfile "doc/README.rd")
Keymap:
Howm menu actions:
  (find-es "howm")
  (find-evariable 'howm-menu-command-table-en "[Todo]")

  (find-evariable 'howm-ref-header ">>>")
  (find-evariable 'howm-keyword-header "<<<")
  (find-howmfile  "howm-mode.el" "'howm-keyword-search")
  (find-efunction 'howm-action-lock-setup)
  (find-efunction 'action-lock-add-rules)

  (howm-mode)
  (fundamental-mode)
  (find-evardescr 'action-lock-rules)
  (find-evardescr 'action-lock-rules "<<<")
  (find-evardescr 'action-lock-rules ">>>")
  (find-evardescr 'action-lock-rules "howm-keyword-search")

  (insert "foo")

  (howm-list-related "~/DTO/howm/")

  (find-efunction 'howm-list-todo)
  (howm-list-todo)
  (find-howmfile "howm-date.el")




#####
#
# stuff
#
#####

# (find-howmfile "")
# (find-howmfile "doc/")
# (find-howmfile "doc/README.rd")
# (find-efunctiondescr 'howm-mode)

# (find-fline "~/DTO/")
# (find-fline "~/DTO/howm/")
# (find-fline "~/DTO/howm/.howm")
# (find-fline "~/DTO/howm/config-snips.el")


;; (find-dtofile ".emacs" "howm")

# (find-howmfile "doc/")
# (find-howmfile "doc/README.rd")

# (find-evariable 'howm-directory)
# (find-evardescr 'howm-directory)
# (find-evardescr 'howm-menu-file)
# (find-efunction 'howm-menu)
# (howm-keyword-search howm-menu-top)
# (find-efunction 'howm-menu-name)
# (find-evardescr 'howm-menu-name-format)

(howm-menu-name nil)




;; (setq howm-directory "~/DTO/howm")
;; (find-efunction 'howm-menu)

(setq howm-view-use-grep t)

(setq howm-file-name-format "%Y/%m/%Y-%m-%d.howm")
;(define-key howm-mode-map (kbd "s-]") 'action-lock-goto-next-link)
;(define-key howm-mode-map (kbd "s-[") 'action-lock-goto-previous-link)

(setq howm-list-recent-title t)
(setq howm-list-all-title t)

; howm-view config
(setq howm-view-summary-persistent nil)
(setq howm-view-summary-name "*howm SUMMARY:%s*")
(setq howm-view-contents-name "*howm CONTENTS:%s*")

; howm-menu config
(setq howm-menu-top nil)
(setq howm-menu-file "menu.howm")
;; cache menu file
;(setq howm-menu-expiry-hours 2)
(setq howm-menu-refresh-after-save t)
(setq howm-menu-name-format "*howm MENU:%s*")
(setq howm-menu-schedule-days-before 1)
(setq howm-menu-schedule-days 3)
(setq howm-menu-recent-num 15)
(setq howm-menu-todo-priority-format nil)




(setq howm-menu-file "menu.howm")
(howm-menu)


(howm-menu t)
(howm-menu nil t)
(howm-menu-initialize-skel nil)
;; (find-efunction 'howm-menu-initialize-skel)

(howm-menu-initialize-skel nil)

(setq howm-directory "/tmp/howm")
(find-fline "/tmp/howm/foo.howm")
(find-howmfile "action-lock.el")





#####
#
# org (from upstream)
# 2006oct01
#
#####

# «org-upstream»  (to ".org-upstream")
# http://staff.science.uva.nl/~dominik/Tools/org/
# http://staff.science.uva.nl/~dominik/Tools/org/org-4.51.tar.gz
# http://dto.freeshell.org/e/org-publish.el
# http://dto.freeshell.org/e/
# http://dto.freeshell.org/e/org-publish-escript.el
# (code-c-d "org" "~/usrc/org-4.51/")
# (find-orgfile "")
# (find-orgfile "org.texi" "@section Installation and Activation")
#
rm -Rv ~/usrc/org-4.51/
tar -C ~/usrc/ -xvzf \
  $S/http/staff.science.uva.nl/~dominik/Tools/org/org-4.51.tar.gz
cd     ~/usrc/org-4.51/
# cp -av $S/http/dto.freeshell.org/e/org-publish.el .

# (byte-compile-file (ee-orgfile "org.el"))
# (byte-compile-file (ee-orgfile "org-publish.el"))
#
# Bytecompiling from the shell:
# (find-howmfile "")
# (find-howmfile "om")
# (find-howmfile "elisp-comp")
#

# (info "(emacs)Option Index")
# (describe-function   'batch-byte-compile)
# (find-efunctiondescr 'batch-byte-compile)
cd ~/rlx/
~/bigsrc/emacs/src/emacs --batch -f batch-byte-compile rlx.el






#####
#
# Org: notes from ~/ORG/index.org
# 2006oct01
#
#####


* Org:
  (find-fline "~/LOGS/2006may18.emacs" "C-c a t")
** TODO: learn more org
 (find-node "(org)Top")
 (find-sh0 "xzgv ~/ORG/shot-2.png")
** TODO: how to use cross-links?
** TODO: org-publish - how to use?

* Org: e-script to install the current version
#
# http://staff.science.uva.nl/~dominik/Tools/org/
# http://staff.science.uva.nl/~dominik/Tools/org/org-4.34.tar.gz
# http://dto.freeshell.org/e/org-publish.el
# (code-c-d "org" "~/usrc/org-4.34/")
# (find-orgfile "")
# (find-orgfile "org.texi" "@section Installation and Activation")

rm -Rv ~/usrc/org-4.34/
tar -C ~/usrc/ -xvzf \
  $S/http/staff.science.uva.nl/~dominik/Tools/org/org-4.34.tar.gz
cd     ~/usrc/org-4.34/
cp -av $S/http/dto.freeshell.org/e/org-publish.el .

# (byte-compile-file (ee-orgfile "org.el"))
# (byte-compile-file (ee-orgfile "org-publish.el"))
#
# Bytecompiling from the shell:
# (find-howmfile "")
# (find-howmfile "om")
# (find-howmfile "elisp-comp")
#

* Org: org-publish
;;
(setq org-publish-project-alist
      (list
       '("orgfiles"
	 :base-directory "~/ORG/"
	 :base-extension "org"
	 ;; :publishing-directory "~/TH/L/ORG"
	 :publishing-directory "~/ORG"
	 ;; :auto-index t
	 :auto-index nil
	 )))

(require 'org-publish)
(org-publish-all)
;;

* Org: org-publish encoding bug

;; (find-efunction 'ee-write)

(let ((str (concat
            " -*- encoding: raw-text-unix -*-\n"
	    "* Some accented chars: áéíóú\n"
	    "* Some accented chars: \341\351\355\363\372\n"))
      (coding-system-for-write 'raw-text-unix))
  (write-region str nil "/tmp/foo"))

(find-fline "/tmp/foo")

* Org: org-publish-escript
  http://dto.freeshell.org/e/org-publish-escript.el
  (find-fline "$S/http/dto.freeshell.org/e/org-publish-escript.el")

* Org: org-export-visible
* Org: ee-goto-position

(find-fline "index.org" "McCarty")
(find-evariable 'search-invisible)
(find-efunction 'reveal-mode)
(find-efunction 'ee-goto-position)

(require 'reveal)

(autoload 'reveal-post-command "reveal")

(let ((search-invisible t))
  (find-fline "index.org" "McCarty")
  (reveal-post-command))  

<edrx> a question about org-mode/outline-mode... suppose that I search
       for the first occurrence of a certain string in an org/outline
       buffer and this happens to be inside a hidden part, that is
       shown just as "..."...
<edrx> "search" meaning (search-forward "string")
<forcer> edrx: Yep.
<edrx> what should I do to make that part of the buffer visible?
<forcer> edrx: M-x outline-up-heading TAB TAB, go to the respective
         heading again, TAB.
<forcer> edrx: Yes, that sucks. Yes, I think it's a bug. Yes, I want
         it to be fixed, too. ;-)
<kensanata> hm, in org-mode, when i use C-s to search, it opens the
            appropriate locations for me.
<offby1> i thought that when you searched, the hidden part around the
         cursor became temporarily visible, so that you could see the
         context

I'm trying to 


Hi list,

I have several functions 

I'm trying to make 


* Org: keys

  sort:
  M-up: (find-efunction 'org-metaup)
  (find-efunctiondescr 'org-mode)

  (find-efunctiondescr 'help-mode)
  (find-node "(org)Motion")





#####
#
# notes on learning Org
# 2007jan14
#
#####

# «notes-on-org»  (to ".notes-on-org")
# (find-node "(org)Headlines" "whitespace followed by a single star")
# (find-evardescr 'org-cycle-emulate-tab)
# (find-node "(org)Motion")
# (find-node "(org)Structure editing")
# (find-node "(org)Moving subtrees" "_archive")
# (find-node "(org)Checkboxes")
# (find-node "(org)Built-in table editor")
# (find-node "(org)Built-in table editor" "(setq org-enable-table-editor nil)")
# (find-node "(org)Formula syntax")
# (find-node "(org)Hyperlinks")

# (find-node "(org)Handling links")
# (find-node "(org)Handling links" "Open link at point")

# (find-node "(org)Moving subtrees")





  [HLIST2 [J Howm:]
    [R http://www.emacswiki.org/cgi-bin/wiki/HowmMode
      emacswiki page]
    [R http://www.emacswiki.org/cgi-bin/wiki/PlannerAndHowmComparison
      planner and howm comparison]
    [R http://howm.sourceforge.jp/ home page]
    [J [R http://dto.freeshell.org/HowmTutorial.howm.html tutorial] by dto]
    [ES howm my e-scripts about it]
    [AL .emacs#howm howm stuff in my .emacs]
  ]



https://leahneukirchen.org/blog/archive/2022/03/note-taking-in-emacs-with-howm.html
https://www.reddit.com/r/emacs/comments/tpx95w/note_taking_in_emacs_with_howm/
https://a-blog-with.relevant-information.com/weblog/2024-01-28-howm/







#  Local Variables:
#  coding:               utf-8-unix
#  modes:                (fundamental-mode emacs-lisp-mode)
#  End:
