#######
#
# E-scripts on htmlize.el.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/htmlize.e>
#           or at <http://angg.twu.net/e/htmlize.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.htmlize»		(to "htmlize")
# «.engrave-faces»	(to "engrave-faces")
# «.engrave-faces-git»	(to "engrave-faces-git")



# (find-es "highlight")
# (find-es "emacs" "htmlfontify")




#####
#
# htmlize
# 2021oct30
#
#####

# «htmlize»  (to ".htmlize")

# (find-esgrep  "grep -nH -e htmlize *.e")
# (find-eevgrep "grep -nH -e htmlize *")
# (find-eev "Makefile" "htmlize.el")
# https://elpa.nongnu.org/nongnu/htmlize.html
# http://elpa.nongnu.org/nongnu/htmlize.html

# (find-epackage-links 'htmlize "htmlize" t)
# (find-epackage       'htmlize)
# https://github.com/hniksic/emacs-htmlize




#####
#
# engrave-faces
# 2021oct30
#
#####

# «engrave-faces»  (to ".engrave-faces")
# (find-es "emacs" "color-name-to-rgb")
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00096.html 
# https://mail.google.com/mail/u/0/#search/htmlize/KtbxLzFvPkgTpVQqPMbctpfSBpjBBQpDGV
# https://github.com/tecosaur/engrave-faces

# (find-epackage-links 'engrave-faces "engravefaces" t)
# (find-epackages      'engrave-faces)
# (find-epackage       'engrave-faces)
# (code-c-d "engravefaces" "~/.emacs.d/elpa/engrave-faces-0.3.1/")
# (find-engravefacesfile "")
# (find-engravefacesfile "engrave-faces-html.el")
# (find-engravefacesfile "engrave-faces-html.el" "engrave-faces-html-make-standalone")
# (find-engravefacesfile "engrave-faces.el" "(defcustom engrave-faces-current-preset-style")
# (find-engravefacesfile "engrave-faces.el" "Theme `%s' is not found")

(find-estring (engrave-faces-html-gen-stylesheet))

# (find-angg "elisp/my-engrave-faces.el")

(require 'engrave-faces)
(require 'engrave-faces-html)

;; (find-efunction 'engrave-faces-file)
;; (find-evardescr 'engrave-faces-preset-styles)
;; (find-evariable 'engrave-faces-preset-styles)




#####
#
# engrave-faces from git
# 2023jan28
#
#####

# «engrave-faces-git»  (to ".engrave-faces-git")
# (find-es "emacs" "package-vc-install")
# (package-vc-install "https://github.com/tecosaur/engrave-faces")
# (find-epackage-links 'engrave-faces "engravefaces" t)
# (find-epackages      'engrave-faces)
# (find-epackage       'engrave-faces)
# (code-c-d "engravefaces" "~/.emacs.d/elpa/engrave-faces/")
# (find-engravefacesfile "")
# (find-gitk "~/.emacs.d/elpa/engrave-faces/")






(defun engrave-faces-file (file extension backend &optional postprocessor)

(engrave-faces-file "/tmp/square-cube.lua" ".html0" "html")
(find-fline         "/tmp/square-cube.lua.html0")



(defun engrave-faces-file-to-html (file)
  (with-temp-buffer
    (setq buffer-file-name file)
    (insert-file-contents file)
    (normal-mode)
    (font-lock-fontify-buffer)
    (with-current-buffer (engrave-faces-html-buffer-standalone)
      (write-file (concat file ".html"))
      (setq buffer-modified-p nil)
      (kill-buffer))))

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cp -v ~/LUA/square-cube.lua /tmp/

(engrave-faces-file-to-html "/tmp/square-cube.lua")

cp -v ~/LUA/square-cube.lua /tmp/

# (find-fline "~/LUA/square-cube.lua")
# (find-angg "LUA/square-cube.lua")

# (find-fline "~/tmp/h.tgz")
~/tmp/h.tgz




# (find-status   "htmlize")
# (find-vldifile "htmlize.list")
# (find-udfile   "htmlize/")





#  Local Variables:
#  coding:               utf-8-unix
#  End:
