#######
#
# E-scripts on hardware: the parallel port
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/hw-parport.e>
#           or at <http://angg.twu.net/e/hw-parport.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





#####
#
# plip: ifigenia to angg
# 00jan30
#
#####

cd /lib/modules/2.0.36/
find | grep par
find | grep plip
depmod $(find * -name '*.o') | sort | uniq | tee ~/o | l
# (find-fline "~/o")

cd /lib/modules/2.0.36/
insmod net/plip.o
ifconfig plip1 10.0.1.3 up pointopoint 10.0.1.1
ifconfig
route add 10.0.1.1 dev plip1

# Mas no funciona porque a porta paralela do ifigenia no est se
# comunicando com ningum (eu testei com a impressora). Obs: o
# ifigenia s tem lp1; lp0 e lp2 do "device not configured".

# 00jan30: Eu virei o conector da sada paralela na placa-me pra
# testar e no desvirei; talvez agora ele esteja na posio errada.


cd /lib/modules/2.0.36/
insmod misc/lp.o






#####
#
# plip from angg to ifigenia and tosh
# 00jan30
#
#####

# plip_from_angg
# 00feb16: angg<->tosh working
# (find-es "mini" "plin")

# On angg:
# (kernel 2.2.xx)

rmmod lp
rmmod parport_pc
rmmod parport

cd /boot/angg22/
depmod *.o | sort | uniq
insmod $MODULES/parport.o
insmod $MODULES/parport_pc.o io=0x3bc,0x378,0x278 irq=none,7,none
# insmod $MODULES/lp.o parport=0,1,2
insmod $MODULES/plip.o

# To tosh:

ifconfig plip0 down
ifconfig plip0 10.0.1.1 up pointopoint 10.0.1.4
ifconfig
route

ping 10.0.1.4


# To ifigenia:

ifconfig plip0 down
ifconfig plip0 10.0.1.1 up pointopoint 10.0.1.3
ifconfig
# route add 10.0.1.3 dev plip0
route






# O plip no angg tem que o usar o endereo da lp1, que  0x378. Ser
# que ele  esperto? (Sim).

# (find-k22file "drivers/char/")
# (find-k22file "drivers/char/lp.c" "0x378")
# (find-k22file "omm" "-o parport.o")
# (find-k22file "drivers/misc/" "parport")
# (find-k22file "Documentation/Configure.help" "PARPORT")
# (find-k22file "Documentation/Configure.help" "CONFIG_PLIP")


# Essa parte  porque eu estou testando a porta paralela do ifigenia
# com a impressora.

# (find-k2file "drivers/char/lp.c")








#  Local Variables:
#  coding:               utf-8-unix
#  End:
