#######
#
# E-scripts on /sbin/init and sysvinit.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/init.e>
#           or at <http://angg.twu.net/e/init.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.init-order»		(to "init-order")
# «.runlevels»		(to "runlevels")
# «.console-font»	(to "console-font")
# «.init-FQDN»		(to "init-FQDN")
# «.initrd»		(to "initrd")
# «.initrd-mkcramfs»	(to "initrd-mkcramfs")
# «.initrd-delay»	(to "initrd-delay")
# «.initrd-mkinitrd»	(to "initrd-mkinitrd")
# «.real-root-dev»	(to "real-root-dev")
# «.pivot_root»		(to "pivot_root")
# «.invoke-rc.d»	(to "invoke-rc.d")
# «.update-rc.d»	(to "update-rc.d")
# «.daemontools»	(to "daemontools")




#####
#
# init
# 2004sep06 / 2019dec31
#
#####

# «init-order»  (to ".init-order")
# «runlevels»  (to ".runlevels")

# 2019dec31:
# https://wiki.debian.org/RunLevel
# (find-es "systemd")
# (find-es "init" "runlevels")
# (find-man "8 runlevel")
# (find-man "7 runlevels")
# (find-sh "apt-file search runlevel")
# (find-fline "/lib/systemd/system/" "runlevel0.target")
# (find-fline "/etc/rc1.d/")
# (find-fline "/etc/rc2.d/")
# (find-fline "/etc/rc3.d/")
# (find-fline "/etc/rc3.d/" "S03lightdm")

# (find-k24file "init/main.c" "/sbin/init")
# (find-status   "sysvinit")
# (find-vldifile "sysvinit.list")
# (find-udfile   "sysvinit/")
# (find-man "8 init")
# (find-man "8 init" "BOOTING")
# (find-man "5 inittab")
# (find-man "5 initscript")
# (find-fline "/etc/inittab")
# (find-fline "/etc/inittab" "initdefault")
# (find-fline "/etc/rc2.d/")
# (find-fline "/etc/init.d/")
# (find-fline "/etc/init.d/README")

# (find-dpolfile "policy.txt.gz" "9.3. System run levels and `init.d' scripts")

# (find-man "5 rcS")
# (find-fline "/etc/rcS.d/")
# (find-fline "/etc/rcS.d/README")
# (find-fline "/etc/init.d/rcS")
# (find-fline "/etc/default/" "rcS")

# (find-status   "sysv-rc")
# (find-vldifile "sysv-rc.list")
# (find-udfile   "sysv-rc/")
# (find-udfile "sysv-rc/README.runlevels.gz")
# (find-udfile "sysv-rc/README.runlevels.gz" "default runlevel")
# (find-udfile "sysv-rc/README.runlevels.gz" "/etc/init.d/rcS")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
runlevel --help
runlevel
# (find-man "8 runlevel")

# https://www.cyberciti.biz/tips/linux-changing-run-levels.html




#####
#
# a table of S/K scripts for all runlevels
# 2004dec26
#
#####

#
cd /etc/
for i in 0 1 2 3 4 5 6 S; do 'ls' rc$i.d/*; done |& tee ~/o
#
# (find-fline "~/o")

lua50 -e '
  HOME = os.getenv("HOME")
  for li in io.lines(HOME.."/o") do
    _, __, r, s, t, p = string.find(li,
     "^rc(.).d/([SK])([0-9][0-9])(.*)")
    if not _ then
      -- print("# Error: " .. li)
    else
      print(t .. p)
    end
  end
' | sort | uniq
#


(find-propertized BUFNAME LISPFILE)

      print("<" ..li.. ">", name)


columns = bla(split("SS SK 1S 1K 2S 2K 3S 3K 4S 4K 5S 5K 6S 6K"))
rows = bla(readlines(


for k in sort(table.keys(A)


ddname .." ".. 

indexa por 



"%5s

0/S 0/K
0/K90 

0000000  1111111
S90 K90


S/S S/K


"0S", "0K",

rc2.d/
2K20 2S20

0/K90 sysklogd
0K91 apache
0S20 sendsigs
0S30 urandom
0S31 umountnfs.sh
0S32 portmap
0S35 networking
0S40 umountfs
0S90 halt
1K01 xdm
1K11 cron
1K15 fetchmail
1K19 aumix





#####
#
# the default console font
# 2004sep06
#
#####

# «console-font»  (to ".console-font")
# (find-fline "/etc/rcS.d/" "console-screen.sh")
# (find-fline "/etc/init.d/console-screen.sh")
# (find-fline "/etc/console-tools/config")
# (find-fline "/etc/console-tools/config" "SCREEN_FONT=lat0-sun16")
# (find-fline "/usr/share/consolefonts/lat0-sun16.psf.gz")
# (find-fline "/usr/share/consolefonts/")
# (find-fline "/etc/init.d/console-screen.sh" "-f ${SCREEN_FONT}")
# (find-man "8 consolechars")
# (find-man "8 consolechars" "-f --font=file")

# (find-fline "/etc/init.d/console-screen.sh" ". /etc/console-tools/config")
# (find-fline "/etc/console-tools/config")
# (find-fline "/etc/console-tools/config.d/")

# Add at: (find-fline "/etc/console-tools/config")
#         (find-fline "/etc/console-tools/config" "Edrx")
# Edrx: use the default hardware font
# (find-es "init" "console-font")
SCREEN_FONT=

# (find-fline "/etc/init.d/keymap.sh")
# (find-fline "/etc/rcS.d/" "keymap.sh")
# (find-fline "/etc/rc2.d/")




#####
#
# init - setting the FQDN
# 2000may28
#
#####

# «init-FQDN»  (to ".init-FQDN")

# (find-fline "/etc/init.d/hostname.sh")
# (find-fline "/etc/rcS.d/" "hostname.sh")
# (find-fline "/etc/hostname")
#
function showsystemname () {
  cd /proc/sys/kernel/
  echo "  /proc/sys/kernel/domainname: $(cat domainname)"
  echo "  /proc/sys/kernel/hostname:   $(cat hostname)"
  echo "  hostname:                    $(hostname)"
  echo "  hostname --fqdn:             $(hostname --fqdn)"
  echo "  domainname:                  $(domainname)"
  echo "  dnsdomainname:               $(dnsdomainname)"
}
showsystemname

#
hostname angg2; domainname popolvuh
showsystemname

hostname angg; domainname popolvuh
showsystemname

# (find-status   "hostname")
# (find-vldifile "hostname.list")
# (find-udfile   "hostname/")
# (find-man "1 hostname")
# (find-man "1 hostname" "\n   THE FQDN")
# (find-man "1 hostname" "-d, --domain")
# (find-man "1 dnsdomainname")
# (find-man "3 resolver")

# (find-man "2 gethostname")
# (find-man "2 sethostname")
# (find-man "2 getdomainname")
# (find-man "2 setdomainname")
# (find-man "2 uname")

# (find-node "(libc)Internet Namespace")
# (find-node "(libc)Host Names")






# (find-status "debianutils")
# (find-vldifile "debianutils.list")
# (find-fline "/usr/doc/debianutils/")
# (eeman "8 run-parts")



# (eeman "5 inittab" "kbrequest")




#####
#
# update-rc.d
# 2000jun14
#
#####

# (find-fline "/usr/sbin/update-rc.d")
# (eeman "update-rc.d")

# (find-status "dpkg")
# (find-vldifile "dpkg.list")
# (find-fline "/usr/doc/dpkg/")




# (find-htetfile "From-PowerUp-To-Bash-Prompt-HOWTO.gz")
# (find-htetfile "")




#####
#
# invoke-rc.d
# 2004dec01
#
#####

# «invoke-rc.d»  (to ".invoke-rc.d")
# (find-man "8 invoke-rc.d")
# (find-fline "/usr/sbin/invoke-rc.d")

# (find-status   "sysv-rc")
# (find-vldifile "sysv-rc.list")
# (find-udfile   "sysv-rc/")
# (find-udfile "sysv-rc/README.invoke-rc.d.gz")
# (find-udfile "sysv-rc/README.policy-rc.d.gz")
# (find-udfile "sysv-rc/README.runlevels.gz")




#####
#
# update-rc.d
# 2004dec02
#
#####

# «update-rc.d»  (to ".update-rc.d")

# (find-vldifile "ntpdate.postinst" "update-rc.d ntpdate start 51 S .")
# (find-man "8 update-rc.d")
# (find-man "8 update-rc.d" "-n" "just show what we would do")
# (find-fline "/usr/sbin/update-rc.d")

update-rc.d -n    ntpdate start 51 S .
update-rc.d -n -f ntpdate remove

# (find-udfile "debian-policy/policy.txt.gz" "using `update-rc.d'")




#####
#
# DaemonTools
# 2011nov21
#
#####

# «daemontools»  (to ".daemontools")
# Thread about an init system in Lua:
#   http://lua-users.org/lists/lua-l/2011-11/msg00626.html
#   http://lua-users.org/lists/lua-l/2011-11/msg00685.html
#   http://lua-users.org/lists/lua-l/2011-11/msg00704.html
# http://smarden.org/runit/
# http://www.skarnet.org/software/s6/
# http://cr.yp.to/daemontools.html




https://blog.dave.tf/post/linux-pid0/ What is PID 0?
https://news.ycombinator.com/item?id=40613287 What Is PID 0? (dave.tf)






#  Local Variables:
#  coding:               utf-8-unix
#  End:
