#######
#
# E-scripts on inkscape.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/inkscape.e>
#           or at <http://angg.twu.net/e/inkscape.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.A4»				(to "A4")
# «.business-card»		(to "business-card")
# «.clone»			(to "clone")
# «.group»			(to "group")
# «.inkscape-git»		(to "inkscape-git")
# «.inkscape-git-pull»		(to "inkscape-git-pull")
# «.inkscape-git-remove»	(to "inkscape-git-remove")
# «.reset-settings»		(to "reset-settings")
# «.compacted-bug»		(to "compacted-bug")
# «.copy-style»			(to "copy-style")
# «.preferences»		(to "preferences")
# «.inkmacs»			(to "inkmacs")
# «.export-to-eps-of-pdf»	(to "export-to-eps-of-pdf")
# «.bezier-select-nodes»	(to "bezier-select-nodes")
# «.manual»			(to "manual")
# «.square-cube»		(to "square-cube")
# «.save-tutorials-to-pdfs»	(to "save-tutorials-to-pdfs")
# «.blobs»			(to "blobs")
# «.square-cube-svg»		(to "square-cube-svg")
# «.inkscape-latex-castel»	(to "inkscape-latex-castel")



# http://www.inkscape.org/
# (find-zsh "installeddebs | sort | grep inkscape")
# (find-zsh "availabledebs | sort | grep inkscape")

# (find-status   "inkscape")
# (find-vldifile "inkscape.list")
# (find-udfile   "inkscape/")
# (find-fline "/usr/share/inkscape/extensions/")
# (find-fline "/usr/share/inkscape/extensions/" "webbrowser")
# (find-fline "/usr/share/inkscape/extensions/txt2svg.pl")
# (find-fline "/usr/share/inkscape/tutorials/")
# (find-fline "/usr/share/inkscape/templates/")
# (find-fline "/usr/share/inkscape/templates/README")
# (find-man "1 inkview")
# (find-man "1 inkscape")

# (find-eetcfile "schema/")

# (find-available "skencil")
# (find-status   "skencil")
# (find-vldifile "skencil.list")
# (find-udfile   "skencil/")




#####
#
# A4
# 2024may10
#
#####

# «A4»  (to ".A4")
# https://en.wikipedia.org/wiki/ISO_216#A_series
# 210x297 mm
# File -> Document Properties (shift-ctrl-D) -> Page size -> A4




#####
#
# business-card
# 2024may10
#
#####

# «business-card»  (to ".business-card")
# 89x49 mm




#####
#
# clone
# 2024may10
#
#####

# «clone»  (to ".clone")
# https://inkscape-manuals.readthedocs.io/en/latest/cloning-objects.html
# Edit -> Clone -> Create Clone
# Edit -> Clone -> Create Tiled Clones




#####
#
# group
# 2024may10
#
#####

# «group»  (to ".group")
# Object -> Group (ctrl-G)
# Object -> Ungroup (shift-ctrl-G)





#####
#
# Inkscape from git
# 2021sep12
#
#####

# «inkscape-git»  (to ".inkscape-git")
# (code-c-d "inkscape" "~/bigsrc/inkscape/")
# https://gitlab.com/inkscape/inkscape
# https://gitlab.com/inkscape/inkscape/-/blob/master/INSTALL.md
# (find-git-links "https://gitlab.com/inkscape/inkscape" "inkscape")
# (find-apt-get-source-links "inkscape")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo apt-get build-dep -y   inkscape
sudo apt-get install -y  libboost-filesystem-dev

# rm -Rfv ~/bigsrc/inkscape/
cd      ~/bigsrc/
git clone https://gitlab.com/inkscape/inkscape
cd      ~/bigsrc/inkscape/

# https://gitlab.com/inkscape/inkscape/-/blob/master/INSTALL.md
git submodule init
git submodule update

# (find-fline "~/bigsrc/")
# (find-fline "~/bigsrc/inkscape/")
# (find-gitk  "~/bigsrc/inkscape/")

# (code-c-d "inkscape" "~/bigsrc/inkscape/")
# (find-inkscapefile "")
# (find-inkscapefile "INSTALL.md")
# (find-inkscapefile "INSTALL.md" "Basic Installation")
# (find-inkscapesh "find * | sort")
# (find-inkscapesh "find * | sort")

 (eepitch-shell2)
 (eepitch-kill)
 (eepitch-shell2)
cd      ~/bigsrc/inkscape/
git clean -dfx
git reset --hard

 (eepitch-shell2)
 (eepitch-kill)
 (eepitch-shell2)
cd      ~/bigsrc/inkscape/
mkdir build
cd build
cmake ..           |& tee ocm
make               |& tee om
make install       |& tee omi
sudo make install  |& tee osmi

# (find-inkscapefile "build/ocm")
# (find-inkscapefile "build/CMakeFiles/")
# (find-inkscapefile "build/CMakeFiles/CMakeError.log")
# (find-inkscapefile "build/CMakeFiles/CMakeOutput.log")
# (find-inkscapefile "build/CMakeFiles/CMakeError.log" "ieeefp.h")

# https://inkscape.org/splash/contribute/




#####
#
# Do a git pull and rebuild inkscape
# 2021sep14
#
#####

# «inkscape-git-pull»  (to ".inkscape-git-pull")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/bigsrc/inkscape/
git pull
mkdir -p build
cd       build
make               |& tee om2
sudo make install  |& tee osmi2

cd      ~/bigsrc/inkscape/
export PAGER=cat
git branch --list -a
git for-each-ref
git log --oneline --graph --all -20

# (find-gitk "~/bigsrc/inkscape/")
# (find-inkscapesh "git show")




#####
#
# inkscape-git-remove
# 2024may10
#
#####

# «inkscape-git-remove»  (to ".inkscape-git-remove")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/usr/local/share/inkscape/")
sudo rm -Rfv   /usr/local/share/inkscape/

# (find-fline "/usr/local/bin/" "inkscape")
# (find-fline "/usr/local/bin/inkscape")
sudo rm -Rfv   /usr/local/bin/inkscape
sudo rm -Rfv   /usr/local/bin/inkview







#####
#
# reset-settings
# 2021sep13
#
#####

# «reset-settings»  (to ".reset-settings")
# (find-fline "~/LOGS/2021sep12.inkscape")
# (find-fline "~/.config/inkscape/")
# (find-fline "~/.config/inkscape/preferences.xml")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/.config/inkscape*
rm -Rv ~/.cache/inkscape*
inkscape &

# Quick Setup -> Appearance -> Compacted (small screens)
# Time to draw -> Screen -> Desktop SD

# Edit -> Preferences -> System -> Reset Preferences

"rm -Rv ~/.config/inkscape*; rm -Rv ~/.cache/inkscape*; inkscape &"




#####
#
# compacted-bug
# 2021sep14
#
#####

# «compacted-bug»  (to ".compacted-bug")
# (find-fline "~/LOGS/2021sep13.inkscape")

<edrx> hi! I think that I have a bug to report, but I also think
       that with what I know at this moment the bug report would be
       a bit silly, so I am looking for pointers on where to learn
       more...
<edrx> what happens is this: I am on Debian, running an Inkscape
       from git that was downloaded and compiled yesterday. If I do
       this - "rm -Rv ~/.config/inkscape*; rm -Rv
       ~/.cache/inkscape*; inkscape &" - I enter the Quick Setup, and
       if I choose "Quick Setup -> Appearance -> Compacted (small
       screens)"
<edrx> and then enter inkscape, do some stuff, and leave, then when
       I start again: 1) I get colored icons bigger than the ones
       from the "Compacted (small screens)" setting, 2) double
       clicking on the tool icons doesn't work; for example, double
       clicking on the icon whose label says "Create rectangles and
       squares (R)" should have an effect similar to Edit ->
       Preferences -> Tool -> Shapes -> Rectangle, but it does
       nothing...
<edrx> I am telling this because I guess that the people here would
       be able to give me a couple of links on how to transforms
       these infos into something more useful as a bug report... so
       thanks in advance =)

Shortcut::read: invalid verb: DialogSpellcheck

https://inkscape.org/contribute/testing/
https://gitlab.com/inkscape/inkscape/-/issues


# (find-fline "~/LOGS/2021sep13.inkscape")





#####
#
# copy-style
# 2021sep13
#
#####

# «copy-style»  (to ".copy-style")

# https://inkscape.org/doc/keys100.html
# Double click on the tool buttons opens the Preferences dialog
# showing the page of the corresponding tool.

# Preferences -> Tools -> Pencil -> Style of new objects -> Last used style





#####
#
# preferences
# 2010sep27
#
#####

# «preferences»  (to ".preferences")





#####
#
# Inkmacs
# 2013jan06
#
#####

# «inkmacs» (to ".inkmacs")
# http://old.nabble.com/inkmacs.el----Inkscape-Emacs-fusion-p31003983.html
# https://github.com/jave/inkmacs
# https://github.com/jave/inkmacs/blob/master/inkmacs.el
# http://emacswiki.org/emacs/JoakimVerona




#####
#
# export-to-eps-of-pdf
# 2020may28
#
#####

# «export-to-eps-of-pdf» (to ".export-to-eps-of-pdf")
# (find-es "tex" "svg")
# (find-man "1 inkscape")
# (find-man "1 inkscape" "-D, --export-area-drawing")
# (find-man "1 inkscape" "-z, --without-gui")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/
inkscape -D -z --file=2020notes-yoneda-frob.svg --export-pdf=2020notes-yoneda-frob.pdf

# (find-pdf-page "~/LATEX/2020notes-yoneda-frob.pdf")





#####
#
# bezier-select-nodes
# 2020sep06
#
#####

# «bezier-select-nodes»  (to ".bezier-select-nodes")
# https://www.tutorviacomputer.com/inkscape/node-tool-and-paths/
# https://design.tutsplus.com/tutorials/quick-tip-using-layers-and-blend-modes-in-inkscape--vector-25907



#####
#
# manual
# 2020sep09
#
#####

# «manual»  (to ".manual")
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/index.php
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Snapping.html#Snapping-Grid
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Trace.html
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Trace-Options.html
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Paths-Editing.html
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Tiles.html

File -> Document properties -> 




#####
#
# square-cube
# 2021sep12
#
#####

# «square-cube»  (to ".square-cube")

Ctrl-shift-D: Document properties
  size, background

http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Anatomy.html
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Layers.html#Layers-Dialog
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Attributes.html
http://tavmjong.free.fr/INKSCAPE/MANUAL/html/Attributes.html There are a number of ways to change attributes:

# (find-status   "inkscape-tutorials")
# (find-vldifile "inkscape-tutorials.list")
# (find-udfile   "inkscape-tutorials/")
# (find-fline "/usr/share/inkscape/tutorials/" "tutorial-basic.svg")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/.config/inkscape*
rm -Rv ~/.cache/inkscape*
inkscape &

# Quick Setup -> Appearance -> Compacted (small screens)
# Time to draw -> Screen -> Desktop SD

# Edit -> Preferences -> System -> Reset Preferences

"rm -Rv ~/.config/inkscape*; rm -Rv ~/.cache/inkscape*; inkscape &"




#####
#
# save-tutorials-to-pdfs
# 2021oct02
#
#####

# «save-tutorials-to-pdfs»  (to ".save-tutorials-to-pdfs")
# (find-angg ".emacs" "inkscape")
# (find-man "1 mutool" "mutool poster")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/.config/inkscape*
rm -Rv ~/.cache/inkscape*
inkscape &

Help -> Tutorials -> Inkscape: Basic
Help -> Tutorials -> Inkscape: Shapes
Edit -> Select all in all layers
Edit -> Resize page to selection

# (find-fline "~/INKSCAPE/")
cd ~/INKSCAPE/
mutool poster -x 1 -y 20 tut_inkscape_basic_onepage.pdf    tut_inkscape_basic.pdf
mutool poster -x 1 -y 20 tut_inkscape_shapes_onepage.pdf   tut_inkscape_shapes.pdf
mutool poster -x 1 -y 20 tut_inkscape_advanced_onepage.pdf tut_inkscape_advanced.pdf

# (code-pdf-page   "inkscapetut1" "~/INKSCAPE/tut_inkscape_basic.pdf")
# (code-mupdf-page "inkscapetut1" "~/INKSCAPE/tut_inkscape_basic.pdf")
# (code-pdf-text   "inkscapetut1" "~/INKSCAPE/tut_inkscape_basic.pdf")
# (code-pdf-page   "tutinkscape2" "~/INKSCAPE/tut_inkscape_shapes.pdf")
# (code-mupdf-page "tutinkscape2" "~/INKSCAPE/tut_inkscape_shapes.pdf")
# (code-pdf-text   "tutinkscape2" "~/INKSCAPE/tut_inkscape_shapes.pdf")
# (find-inkscapetut1page)
# (find-inkscapetut1text)
# (find-inkscapetut1page 2 "Panning the canvas")
# (find-inkscapetut1text 2 "Panning the canvas")
# (find-inkscapetut1page 10 "Grouping")
# (find-inkscapetut1text 10 "Grouping")
# (find-inkscapetut1page 12 "Fill and stroke")
# (find-inkscapetut1text 12 "Fill and stroke")
# (find-tutinkscape2page)
# (find-tutinkscape2text)
# (find-tutinkscape2page 2 "Rectangles")
# (find-tutinkscape2text 2 "Rectangles")
# (find-tutinkscape2page 4 "Scale rounded corners")
# (find-tutinkscape2text 4 "Scale rounded corners")

tut_inkscape_basic_onepage.pdf




#####
#
# blobs
# 2021oct02
#
#####

# «blobs»  (to ".blobs")

# (find-tutinkscape2page 2 "Rectangles")
# (find-tutinkscape2text 2 "Rectangles")
# (find-tutinkscape2page 4 "Scale rounded corners")
# (find-tutinkscape2text 4 "Scale rounded corners")
# (find-tutinkscape3page 2 "Paste Style (Shift+Ctrl+V)")
# (find-tutinkscape3text 2 "Paste Style (Shift+Ctrl+V)")




#####
#
# square-cube-svg
# 2021oct01
#
#####

# «square-cube-svg»  (to ".square-cube-svg")

;; (find-fline "~/2021.1-projeto/apresentacao-1.org")
;; (find-fline "~/LUA/square-cube.lua")
;; (find-fline "~/INKSCAPE/" "square-cube-4.svg")
;; (find-es "emacs" "screenshot-svg")
;;
(defun ssvg (&optional fname)
  (interactive)
  (ee-write-string
   (x-export-frames nil 'svg)
   (or fname "~/INKSCAPE/screenshot.svg"))
  (find-fline "~/INKSCAPE/" "screenshot.svg"))

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/.config/inkscape*
rm -Rv ~/.cache/inkscape*
cd ~/INKSCAPE/
inkscape &

Quick Setup -> Appearance -> Compacted (small screens)
Time to draw -> Screen -> Desktop SD

File -> Import -> ~/INKSCAPE/ -> square-cube-4.svg
(Ctrl-Shift-L) Layers
(Ctrl-U) Ungroup
(R) Create rectangles and squares
View -> Zoom -> Zoom selection

(S) Select and transform objects
 In the toolbar for "Select", turn off these two buttons:
  When scaling objects, scale the stroke width bythe same proportion
  When scaling rectangles, scale the radii of rounded corners

(P) Pencil: Draw freehand lines
 Double click on Pencil,
  or: Edit -> Preferences -> Tools -> Shapes -> Pen
  or: (Ctrl-Shift-P) -> Tools -> Shapes -> Pen
   -> Style of new objects -> Last used style

(Ctrl-C) Copy
(Shift-Ctrl-V) Paste style

# (find-fline "~/LUA/square-cube.lua")

# (find-eface-links 'default)
# (find-efaces      'default)
# (find-ecolors     "bisque" "#ffe4c4")
# (find-eface-links 'font-lock-comment-face)
# (find-efaces      'font-lock-comment-face)
# (find-ecolors     "chocolate1" "#ff7f24")
# (find-eface-links 'eepitch-star-face)
# (find-eface       'eepitch-star-face)
# (find-ecolors     "red" "#ff0000")

# (find-eface-links 'eepitch-star-face)
# (find-efaces    "\neepitch-star-face ")

# (find-efunction 'find-efaces)



# Edit -> Preferences -> System -> Reset Preferences

# (find-fline "~/LOGS/2021oct18.inkscape" "very small lines get simplified")
# (find-fline "~/LOGS/2021oct18.inkscape" "Click/drag threshold")
Preferences -> Input/output -> Input devices -> Click/drag threshold





#####
#
# Gilles Castel's notes on using Inscape and Latex together
# 2024feb09
#
#####

# «inkscape-latex-castel»  (to ".inkscape-latex-castel")

https://castel.dev/notes/
https://castel.dev/post/research-workflow/
https://castel.dev/post/lecture-notes-1/ 
https://castel.dev/post/lecture-notes-2/ inkscape and LaTeX 
https://news.ycombinator.com/item?id=39259316 How I'm able to take notes in mathematics lectures using LaTeX and Vim (2019) (castel.dev) - and "inverted" their classes - inkscape - TikZ 
https://karthinks.com/software/latex-input-for-impatient-scholars/ 






Fill and Stroke... Shift+Ctrl+F




Miscellaneous:
  break apart
  simplify





Inkscape keys and mouse reference:
  https://inkscape.org/doc/keys100.html


Using the grid to draw icons:
  http://inkscape.org/doc/tips/tutorial-tips.html

http://wiki.inkscape.org/wiki/index.php/Tricks_and_tips#PDF.2FEPS_bounding_boxes

https://news.ycombinator.com/item?id=33873311 Inkscape 1.2.2 (inkscape.org)
https://inkscape.org/develop/about-svg/ section "How does Inkscape implement SVG?"
https://inkscape.org/news/2023/07/23/inkscape-launches-version-13-focus-organizing-work/




# (find-status   "googletest")
# (find-vldifile "googletest.list")
# (find-udfile   "googletest/")




#  Local Variables:
#  coding:               utf-8-unix
#  End:
