#######
#
# E-scripts on Ubuntu 22.04 LTS (Jammy Jellyfish).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://anggtwu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://anggtwu.net/e/jammy.e>
#           or at <http://anggtwu.net/e/jammy.e.html>.
#        See also <http://anggtwu.net/emacs.html>,
#                 <http://anggtwu.net/.emacs[.html]>,
#                 <http://anggtwu.net/.zshrc[.html]>,
#                 <http://anggtwu.net/escripts.html>,
#             and <http://anggtwu.net/>.
#
#######



# «.2024jan14»		(to "2024jan14")




#####
#
# (Roughly) the commands that I ran in 2024jan14 after installation
# 2024jan14
#
#####

# «2024jan14»  (to ".2024jan14")
# Based on: (find-es "bullseye" "2021aug16")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

sudo apt-get install -y zsh emacs xterm
chsh edrx

# (find-asrootfile "/etc/sudoers")

# (find-fline        "/etc/apt/sources.list")
# (find-fline "$ASROOT/etc/apt/sources.list")
# deb     http://archive.ubuntu.com/ubuntu/ jammy universe
# deb-src http://archive.ubuntu.com/ubuntu/ jammy universe

sudo apt-get install -y mpv
sudo apt-get install -y build-essential
sudo apt-get install -y lightdm xfce4

# (find-es "chrome" "download")

# See: (find-es "u" "every-boot")
#      (find-es "bullseye" "2021aug16")
sudo apt-get install -y lua5.1 luarocks
sudo apt-get install -y lua-lpeg lua-lpeg-dev lua-posix
sudo apt-get install -y expect rsync
sudo apt-get install -y xpdf recode figlet

# See: (find-es "apt"  "apt-file")
sudo apt-get install -y apt-file
sudo                    apt-file update
sudo apt-get install -y locate
sudo                    updatedb

sudo apt-get install -y dctrl-tools
sudo apt-get install -y lua5.1 lua5.1-dev lua5.1-doc
sudo apt-get install -y lua5.2 lua5.2-dev lua5.2-doc
sudo apt-get install -y lua5.3 lua5.3-dev
sudo apt-get install -y lua5.4 lua5.4-dev
sudo apt-get install -y lua-lpeg lua-lpeg-dev
sudo apt-get install -y texlive-latex-extra

sudo apt-get install -y scrot gimp simplescreenrecorder
sudo apt-get install -y tkdiff
sudo apt-get install -y curl
sudo apt-get install -y bc potrace imagemagick djvulibre-bin
sudo apt-get install -y dict dictd dict-foldoc dict-gcide dict-jargon dict-vera dict-wn
sudo apt-get install -y gitk git-doc
sudo apt-get install -y xournal
sudo apt-get install -y unicode-data
sudo apt-get install -y ncal
sudo apt-get install -y fossil
sudo apt-get install -y gparted dosfstools mtools
sudo apt-get install -y transmission-gtk
sudo apt-get install -y python3-pip
sudo apt-get install -y python3-doc python3-examples python3-tk
sudo apt-get install -y lsscsi
sudo apt-get install -y isympy3 ipython3
sudo apt-get install -y calibre
sudo apt-get install -y inkscape inkscape-tutorials
sudo apt-get install -y maxima gnuplot
sudo apt-get install -y sbcl-doc sbcl-source
sudo apt-get install -y qpdf

# Add: contrib non-free?
# (find-fline "$ASROOT/etc/apt/sources.list")
#
sudo apt-get install -y     gcc-doc
sudo apt-get install -y gdb gdb-doc
sudo apt-get install -y glibc-doc-reference
sudo apt-get install -y make-doc

sudo apt-get build-dep -y emacs
sudo apt-get build-dep -y maxima

# Compile emacs30:
#  (find-es "git" "emacs-from-git-2020")
#  (find-es "git" "emacs30-from-git")

# Compile maxima:
#  (find-es "maxima" "maxima-git")

# Qdraw:
#  (find-es "mbe" "download")
#  (find-es "mbe" "glue-chapters")
#  (find-es "maxima" "qdraw")
#  (find-angg ".maxima/maxima-init.mac" "load_qdraw")



# (find-fline  "/old-etc/fstab")
# (find-asrootfile "/etc/fstab")

# (find-es "chrome" "download")
# (find-es "clock" "tzconfig")






# (find-es "git" "github-cli")
# (find-es "html" "princexml")







#  Local Variables:
#  coding:               utf-8-unix
#  End:
