#######
#
# E-scripts on jupyter notebooks.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/jupyter.e>
#           or at <http://angg.twu.net/e/jupyter.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.notebook»			(to "notebook")
# «.running-a-server»		(to "running-a-server")
# «.matplotlib-notebook»	(to "matplotlib-notebook")
# «.nbviewer»			(to "nbviewer")
# «.kernels»			(to "kernels")
# «.nb-lua-kernel»		(to "nb-lua-kernel")
# «.ein»			(to "ein")
# «.emacs-ipython-notebook»	(to "emacs-ipython-notebook")
# «.emacs-jupyter»		(to "emacs-jupyter")
# «.elpy»			(to "elpy")
# «.maxima-jupyter»		(to "maxima-jupyter")




# https://jupyter.org/
# https://jupyter.org/install.html
# https://en.wikipedia.org/wiki/Project_Jupyter


# (find-es "python" "pip")

https://www.datacamp.com/community/tutorials/markdown-in-jupyter-notebook

# (find-pip3-links      "jupyterlab")
# (find-importlib-links "jupyterlab")
# (find-pypi-links      "jupyterlab")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo pip3 install jupyterlab
rehash
jupyter notebook
jupyter server

file:///home/edrx/.local/share/jupyter/runtime/jpserver-443410-open.html

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
pip3 install jupyterlab
rehash

# (find-fline "~/.local/bin/" "jupyter-lab")
# Requirement already satisfied: notebook>=4.3.1 in /usr/lib/python3/dist-packages (from jupyterlab) (5.7.8)
# (find-fline "/usr/lib/python3/dist-packages/")
# (find-fline "/usr/lib/python3/dist-packages/notebook/")
# (find-fline "/usr/lib/python3/dist-packages/notebook-5.7.8.egg-info/")

# (find-sh "pip3")
# (find-sh "pip3 list")
# (find-sh "pip3 show")
# (find-sh "pip3 show --help")
# (find-sh "pip3 show jupyterlab")
# (find-sh "pip3 show jupyterlab" "Location:")
# (find-pip3spfile "jupyterlab/")
# (find-pip3spfile "jupyterlab-2.2.9.dist-info/")
# (find-pip3spfile "jupyterlab-2.2.9.dist-info/METADATA" "thetimezoneconverter")

jupyter-client
jupyter-console
jupyter-core
jupyterlab
jupyterlab-server





mkdir ~/JUPYTER/
cd    ~/JUPYTER/
jupyter notebook

# (find-fline "~/JUPYTER/")


https://www.youtube.com/watch?v=-mR-gz9EFO8



#####
#
# notebook
# 2020nov08
#
#####

# «notebook»  (to ".notebook")
# (find-zsh "installeddebs | sort | grep jupyter")
# (find-zsh "availabledebs | sort | grep jupyter")
# (find-zsh "installeddebs | sort | grep notebook")
# (find-zsh "availabledebs | sort | grep notebook")
# (find-status   "jupyter-notebook")
# (find-vldifile "jupyter-notebook.list")
# (find-udfile   "jupyter-notebook/")
# (find-status   "python3-notebook")
# (find-vldifile "python3-notebook.list")
# (find-udfile   "python3-notebook/")

# https://github.com/jupyter/notebook
# https://github.com/jupyter/notebook#jupyter-notebook
# https://github.com/jupyter/notebook#installation
# https://jupyter.readthedocs.io/en/latest/install.html
# https://docs.jupyter.org/en/latest/
# https://docs.jupyter.org/en/latest/start/index.html
# https://docs.jupyter.org/en/latest/install.html#install

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
pip3 install --upgrade pip
pip3 install jupyter
jupyter notebook

# (find-sh "locate ipynb")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/2023.1-C4/reginaldo/
jupyter notebook Teorema-Green.ipynb
/home/edrx/2023.1-C4/reginaldo/Teorema-Green.ipynb



#####
#
# running-a-server
# 2020nov08
#
#####

# «running-a-server»  (to ".running-a-server")
# https://jupyter.readthedocs.io/en/latest/running.html#running
# https://jupyter-notebook.readthedocs.io/en/stable/public_server.html




#####
#
# Rotate plot
# 2023jun08
#
#####

# «matplotlib-notebook»  (to ".matplotlib-notebook")
# https://stackoverflow.com/questions/47311632/jupyter-how-to-rotate-3d-graph




#####
#
# nbviewer
# 2023jun08
#
#####

# «nbviewer»  (to ".nbviewer")
# https://nbviewer.org/




#####
#
# kernels
# 2023jun08
#
#####

# «kernels»  (to ".kernels")
# https://github.com/jupyter/jupyter/wiki/Jupyter-kernels
# https://jupyter-client.readthedocs.io/en/latest/kernels.html




#####
#
# nb-lua-kernel
# 2020oct08
#
#####

# «nb-lua-kernel»  (to ".nb-lua-kernel")
# https://pypi.org/project/nb-lua-kernel/
# https://github.com/neomantra/lua_ipython_kernel
# https://github.com/guysv/ilua
# https://github.com/pakozm/IPyLua
# https://github.com/scrapinghub/splash/tree/master/splash/kernel

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
pip3 install lua_kernel
python -m lua_kernel.install

# Could not install packages due to an EnvironmentError: 404 Client
# Error: Not Found for url: https://pypi.org/simple/lua-kernel/


https://www.reddit.com/r/IPython/comments/3kjv6x/how_do_i_get_a_lua_interpreter_in_jupyter/




#####
#
# ein
# 2020oct15
#
#####

# «ein»  (to ".ein")
# (find-epackage-links 'ein)
# (find-epackage       'ein)
# (code-c-d "ein" "~/.emacs.d/elpa/ein-20201028.1857/")
# (find-einfile "")
# (find-einfile "ein-worksheet.el")
# (find-einfile "ein-notebook.el" "ein:worksheet-execute-cell")

# (find-efunctiondescr 'ein:jupyter-server-start)
# (find-efunction      'ein:jupyter-server-start)
# (executable-find ein:jupyter-server-command)

# (find-efunctiondescr 'ein:worksheet-insert-cell-below)
# (find-efunction      'ein:worksheet-insert-cell-below)
# (find-efunctiondescr 'ein:worksheet-insert-cell-above)
# (find-efunction      'ein:worksheet-insert-cell-above)
# (find-efunctiondescr 'ein:worksheet-execute-cell)
# (find-efunction      'ein:worksheet-execute-cell)

# (find-ebuffer "*ein: http://127.0.0.1:8888/Untitled.ipynb*")



mkdir /tmp/notebook/

"/usr/bin/jupyter"

o "ein:jupyter-server-start" inicia o server do jupyter pelo emacs

"ein:worksheet-insert-cell-below" cria uma célula abaixo da celula atual
"ein:worksheet-insert-cell-above" cria uma célula acima




#####
#
# emacs-ipython-notebook
# 2021feb20
#
#####

# «emacs-ipython-notebook»  (to ".emacs-ipython-notebook")
# (find-es "python" "emacs-ipython-notebook")
# https://github.com/millejoh/emacs-ipython-notebook

<dale> glyph: I can't help but notice the last commit to master on
       EIN was 2014, and the latest issue closed was 2018. :)
<glyph> dale: so, "give up" is what you're saying ;)
<dale> glyph: You should become the new maintainer.
<dale> glyph: Hm,
       https://github.com/millejoh/emacs-ipython-notebook

# (find-esgrep "grep --color -nH --null -e emacs-ipython-notebook *.e")





#####
#
# emacs-jupyter
# 2021sep08
#
#####

# «emacs-jupyter»  (to ".emacs-jupyter")
# https://lists.gnu.org/archive/html/emacs-orgmode/2021-09/msg00051.html

I am using emacs-jupyter (https://github.com/nnicandro/emacs-jupyter),
and I have just noticed that results from a block are not sent to
another block. I think it has to do with this issue
https://github.com/nnicandro/emacs-jupyter/issues/222. Can somebody
suggest a workaround? (I actually want to use the output from a kernel
different from python, but since the problem happens also with the python
kernel I'm using it as an example).

# (find-epackage-links 'jupyter "jupyter" t)
# (find-epackage       'jupyter)
# (code-c-d "jupyter" "~/.emacs.d/elpa/jupyter-20210422.1451/")
# (find-jupyterfile "")


https://news.ycombinator.com/item?id=29181033 Pretty inline symbolic mathematics in Org-mode (skh.am)





#####
#
# elpy (que o Othon Oliveira está usando)
# 2021nov19
#
#####

# «elpy»  (to ".elpy")

# (find-epackage-links 'elpy "elpy" t)
# (find-epackage       'elpy)
# (code-c-d "elpy" "~/.emacs.d/elpa/elpy-20210630.2317/")
# (find-elpyfile "")

# (find-epackage-links 'pyvenv "pyvenv" t)
# (find-epackage       'pyvenv)
# (code-c-d "pyvenv" "~/.emacs.d/elpa/pyvenv-20211014.707/")
# (find-pyvenvfile "")




#####
#
# maxima-jupyter
# 2023jun08
#
#####

# «maxima-jupyter»  (to ".maxima-jupyter")
# https://github.com/robert-dodier/maxima-jupyter
# (code-c-d "maximajupyter" "~/usrc/maxima-jupyter/")
# (find-maximajupyterfile "")



https://www.kaggle.com/

https://news.ycombinator.com/item?id=32723766 Launch HN: Mito (YC S20) – Edit a spreadsheet, generate Python
https://gist.github.com/rain-1/4af9cad7941e5999e44a22e8cd368494 Linear Least Squares Problem

https://www.reddit.com/r/emacs/comments/14g96co/jupyterlab_shortcuts_configuration/
https://news.ycombinator.com/item?id=36629055 Git and Jupyter Notebooks Guide (reviewnb.com) - jupitext







#  Local Variables:
#  coding:               utf-8-unix
#  End:
