#######
#
# E-scripts on labinfo.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://anggtwu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://anggtwu.net/e/labinfo.e>
#           or at <http://anggtwu.net/e/labinfo.e.html>.
#        See also <http://anggtwu.net/emacs.html>,
#                 <http://anggtwu.net/.emacs[.html]>,
#                 <http://anggtwu.net/.zshrc[.html]>,
#                 <http://anggtwu.net/escripts.html>,
#             and <http://anggtwu.net/>.
#
#######




# «.edrx.tgz»			(to "edrx.tgz")
# «.melpa-0x0»			(to "melpa-0x0")
# «.sources.list-deb-src»	(to "sources.list-deb-src")
# «.build-dep-emacs»		(to "build-dep-emacs")
# «.invisible-text»		(to "invisible-text")
# «.setxkbmap»			(to "setxkbmap")




#####
#
# edrx.tgz
# 2023may17
#
#####

# «edrx.tgz»  (to ".edrx.tgz")
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/edrx/")
mkdir  ~/edrx/
cd     ~/edrx/
wget -N http://anggtwu.net/edrx.tgz
tar -xvzf edrx.tgz
./run-zsh
echo $HOME

cd ~/edrx/
./run-zsh




#####
#
# melpa-0x0
# 2023may17
#
#####

# «melpa-0x0»  (to ".melpa-0x0")
# (find-melpa-links)
# (find-epackage-links '0x0)




#####
#
# sources.list-deb-src
# 2023may17
#
#####

# «sources.list-deb-src»  (to ".sources.list-deb-src")
# (find-es "apt" "sources.list" "deb-src")




#####
#
# build-dep-emacs
# 2023may17
#
#####

# «build-dep-emacs»  (to ".build-dep-emacs")
# (find-apt-get-source-links "emacs")
# (find-es "git" "emacs-from-git-2020")
# (find-es "git" "emacs30-from-git")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo apt-get build-dep -y   emacs




#####
#
# invisible-text
# 2023may17
#
#####

# «invisible-text»  (to ".invisible-text")
# (find-saving-links-intro "3. Invisible text")
# (find-eev-quick-intro "5.2. Cutting and pasting")
# (find-emacs-keys-intro "3. Cutting & pasting")

# (find-efunctiondescr 'eev-mode)
# (describe-minor-mode-from-indicator 'eev-mode)

Commands to generate pages with lists of hyperlinks:
      M-h M-f -- hyperlinks to an Emacs function
      M-h M-k -- hyperlinks to a key sequence
      M-h M-v -- hyperlinks to an Emacs variable
      M-h M-s -- hyperlinks to a face (default: face at point)
      M-h M-d -- hyperlinks about a Debian package
      M-h M-h -- hyperlinks to here
      M-h M-3 -- hyperlinks to here for beginners
  See: (find-eev-quick-intro "\n4.2." "find-ekey-links")
       (find-here-links-intro  "4."   "find-here-links-3")
Commands to edit hyperlinks:
      M-h M-2 -- duplicate this line
      M-h M-y -- yank into pos-spec-list
      M-h M-w -- copy this line to the kill ring
  M-1 M-h M-w -- copy the last anchor to the kill ring
      M-h M-- -- shrink ‘find-xxxfile’ to ‘find-xxx’
  See: (find-refining-intro "2. Refining hyperlinks")





#####
#
# setxkbmap
# 2023dec11
#
#####

# «setxkbmap»  (to ".setxkbmap")
# (find-es "x" "setxkbmap")
# (find-es "x" "setxkbmap-2023")



(find-angg ".emacs" "super-key")







# «.2023dec13»	(to "2023dec13")



#####
#
# 2023dec13
# 2023dec13
#
#####

# «2023dec13»  (to ".2023dec13")
(find-melpa-links)
(find-epackage-links 'hydra)
(find-epackage-links 'pdf-tools)
(find-angg ".emacs.local.labinfo" "symlink")

# (find-other-debian-links "colorweb.sty")
# (find-sh "apt-file search colorweb.sty")
texlive-latex-extra: /usr/share/texlive/texmf-dist/tex/latex/colorweb/colorweb.sty

# (find-debpkg-links "texlive-latex-extra")
# (find-angg "LUA/ExprDxDy1.lua" "ExprDxDy-tests-2D")

;; (find-newbrowser-links "g" "googlechrome" "google-chrome")
;; (find-newbrowser-links "g" "googlechrome" "firefox")
(defun find-googlechrome (url &rest rest)
  (find-bgprocess `("firefox" ,url)))

;; (find-es "x" "setxkbmap-2023")

  (eepitch-shell)
  (eepitch-kill)
  (eepitch-shell)
setxkbmap -model pc105 -layout us
setxkbmap -model abnt2 -layout br -variant abnt2

alunouff aaaaaa 2022





#  Local Variables:
#  coding:               utf-8-unix
#  End:
