#######
#
# E-scripts on the Linux kernel.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/linux.e>
#           or at <http://angg.twu.net/e/linux.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# Old version:
# (find-es "kernel")

# (find-zsh "installeddebs | sort | grep linux")
# (find-zsh "availabledebs | sort | grep linux")

# «.single»	(to "single")
# «.makedev»	(to "makedev")

# (find-status   "linux-base")
# (find-vldifile "linux-base.list")
# (find-udfile   "linux-base/")
# (find-status   "linux-generic")
# (find-vldifile "linux-generic.list")
# (find-udfile   "linux-generic/")
# (find-status   "linux-headers-4.4.0-140")
# (find-vldifile "linux-headers-4.4.0-140.list")
# (find-udfile   "linux-headers-4.4.0-140/")
# (find-status   "linux-headers-4.4.0-140-generic")
# (find-vldifile "linux-headers-4.4.0-140-generic.list")
# (find-udfile   "linux-headers-4.4.0-140-generic/")
# (find-status   "linux-headers-4.4.0-141")
# (find-vldifile "linux-headers-4.4.0-141.list")
# (find-udfile   "linux-headers-4.4.0-141/")
# (find-status   "linux-headers-4.4.0-141-generic")
# (find-vldifile "linux-headers-4.4.0-141-generic.list")
# (find-udfile   "linux-headers-4.4.0-141-generic/")
# (find-status   "linux-headers-generic")
# (find-vldifile "linux-headers-generic.list")
# (find-udfile   "linux-headers-generic/")
# (find-status   "linux-image-4.4.0-140-generic")
# (find-vldifile "linux-image-4.4.0-140-generic.list")
# (find-udfile   "linux-image-4.4.0-140-generic/")
# (find-status   "linux-image-4.4.0-141-generic")
# (find-vldifile "linux-image-4.4.0-141-generic.list")
# (find-udfile   "linux-image-4.4.0-141-generic/")
# (find-status   "linux-image-extra-4.4.0-140-generic")
# (find-vldifile "linux-image-extra-4.4.0-140-generic.list")
# (find-udfile   "linux-image-extra-4.4.0-140-generic/")
# (find-status   "linux-image-extra-4.4.0-141-generic")
# (find-vldifile "linux-image-extra-4.4.0-141-generic.list")
# (find-udfile   "linux-image-extra-4.4.0-141-generic/")
# (find-status   "linux-image-generic")
# (find-vldifile "linux-image-generic.list")
# (find-udfile   "linux-image-generic/")




#####
#
# Booting into single user mode
# 2019apr21
#
#####

# «single» (to ".single")

# (find-es "kernel" "boot-parameters")
# (find-status   "linux-doc")
# (find-vldifile "linux-doc.list")
# (find-udfile   "linux-doc/")
# (find-udfile "linux-doc/kernel-parameters.txt.gz")
# (find-linuxdocfile "kernel-parameters.txt.gz" "S" "[KNL] Run init in single mode")
# (find-linuxdocfile "kernel-parameters.txt.gz" "init=" "instead of /sbin/init")

(code-c-d "linuxdoc" "/usr/share/doc/linux-doc/")
# (find-linuxdocfile "")
# (find-linuxdocfile "kernel-parameters.txt.gz")

https://askubuntu.com/questions/132965/how-do-i-boot-into-single-user-mode-from-grub
http://www.noah.org/wiki/Single_User_Mode 

Select the Kernel line and press 'e' to edit. It should look something
like this:

  kernel /vmlinuz-2.6.15-27-386 root=/dev/mapper/Ubuntu-root ro quiet splash

Edit that line to get rid of quiet and splash and add 'single':

  kernel /vmlinuz-2.6.15-27-386 root=/dev/mapper/Ubuntu-root ro single





#####
#
# makedev
# 2019dec18
#
#####

# «makedev» (to ".makedev")

# (find-status   "makedev")
# (find-vldifile "makedev.list")
# (find-udfile   "makedev/")

# (find-fline "/sbin/MAKEDEV")
# (find-man "8 MAKEDEV")
# (find-udfile "makedev/copyright")
# (find-udfile "makedev/changelog.Debian.gz")
# (find-fline "/usr/share/lintian/overrides/makedev")

cd /dev/
sudo MAKEDEV sdb1
# /run/udev or .udevdb or .udev presence implies active udev.  Aborting MAKEDEV invocation.

# https://en.wikipedia.org/wiki/Udev
# https://www.freedesktop.org/wiki/Software/systemd/





https://opensource.com/article/19/8/linux-kernel-21st-century
https://news.ycombinator.com/item?id=34295165 Tilck – A Tiny Linux-Compatible Kernel (github.com/vvaltchev)
https://linuxtldr.com/file-descriptors-linux/
https://news.ycombinator.com/item?id=38960827 What Are File Descriptors in Linux (linuxtldr.com)




#  Local Variables:
#  coding:               utf-8-unix
#  End:
