#######
#
# E-scripts on connecting the computers at my house.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/localnet.e>
#           or at <http://angg.twu.net/e/localnet.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



fdisk -l | sort | grep '^/dev/hd' | grep native
df | sort | grep '^/dev/hd'
cat /etc/fstab | sort | grep '^/dev/hd' | grep ext2
mount | sort | grep ext2



#####
#
# angg
#
#####

cd /boot/angg/
insmod 8390.o
insmod ne.o
ifconfig eth0 10.0.0.1
route add -net 10.0.0.0

cd /boot/angg/
insmod nfs.o
/etc/init.d/nfs-server start


/etc/init.d/nfs-server restart




#####
#
# angg's ethernet - kernel 2.2
# 99nov21
#
#####

umount -a -t nfs
ifconfig eth0 down
for m in $(cat /proc/modules | awk '{print $1}'); do echo $m; rmmod $m; done

cd /boot/angg22/
insmod 8390.o
insmod ne2k-pci.o
ifconfig eth0 10.0.0.1
route add -net 10.0.0.0

cd /boot/angg22/
insmod sunrpc.o
insmod lockd.o
insmod nfs.o
/etc/init.d/nfs-server start






#####
#
# Samba
#
#####

# (find-fline "/usr/doc/samba/")
# (find-fline "/usr/doc/samba-doc/")
# (find-fline "/usr/doc/smbfs/")
# (find-vldifile "samba.list")
# (find-vldifile "samba-doc.list")
# (find-vldifile "smbfs.list")

apti samba samba-doc smbfs

smbclient //smilochs/c -I 10.0.0.2 -N

cd /boot/angg/
insmod smbfs.o
smbmount //smilochs/c /smilc -I 10.0.0.2 -n
smbmount //smilochs/d /smild -I 10.0.0.2 -n

cd /smilc
find |& tee ~/osmilc
cd /smild
find |& tee ~/osmild


# ifigenia:
smbclient //bruno/c -I 10.0.0.3 -N





#####
#
# patna - hardware
#
#####

# (find-fline "/patna:/home/root/CRIM/011ideas")

mouse de 2 botões no patna (anatômico):
bare at /dev/ttyS0

modem: ttyS1 (U.S. Robotics Sportster 33600 Voice V4.3.174)

# (find-fline "/patna:/etc/X11/XF86Config")
#   HorizSync   31.5, 35.15, 35.5
#   VertRefresh 50-90
#   Identifier  "Cirrus Logic GD542x"
#       Depth       8
#       Modes       "800x600" "640x480"
# Monitor: Philips 104s.

# (find-fline "/patna:/etc/rc2.d")
# (find-fline "/patna:/home/root/bin/S99patna")

cd /boot/angg22/
insmod 8390.o
insmod ne2k-pci.o
ifconfig eth0 10.0.0.2
route add -net 10.0.0.0

cd /boot/angg22/
insmod sunrpc.o
insmod lockd.o
insmod nfs.o
mount /big
mount /usr/src
mount /snarf

cd /boot/angg22/
insmod cdrom.o
insmod ide-cd.o
insmod vfat.o
mount /cdrom
mount /C
mount /D

# Not working:
# route add default gw 10.0.0.1
# (find-k2file "Documentation/Configure.help" "CONFIG_IP_FORWARD")
# (find-fline "/usr/doc/HOWTO/Ethernet-HOWTO.gz")



######
#
# ifigenia
#
######

mouse genius com três botôes e uma depressão redonda no botão da
direita: mman em ttyS0.

idecd em hdd.

Acho que as notas abaixo são antigas e se referem a uma placa
quebrada. O que funciona (em 99oct15) é insmod ne io=0x300.


aparentemente ne2000 isa em 0x340.

Posso escolher qualquer um dos irqs abaixo, só que quando eu escolho o
2 ele diz que usa o 9.

2=9; 3 5 6 7 9 10 11 12

cd /lib/modules/2.0.36/
insmod 8390.o
insmod ne.o io=0x340 irq=3
ifconfig eth0 10.0.0.3
route add -net 10.0.0.0
#
insmod nfs.o

# (find-fline "/etc/rc2.d/" "S99")

# ou irq=5/6/7/9/10/11/12.

ifconfig eth0 down


tcpdump -i eth0 

tcpdump -l -i eth0 | awk '{print "eth0: ", $0}'



# (find-fline "/etc/hosts.allow")
# (eeman "5 hosts_access")
# (eeman "5 hosts_options")
# (find-fline "/usr/doc/netbase/portmapper.txt.gz")

ALL: *

# (find-fline "/ifigenia:/etc/fstab")
# (find-fline "/ifigenia:/etc/rc2.d/")
# (find-fline "/ifigenia:/etc/rc2.d/S14rede")
# (find-fline "/ifigenia:/home/root/bin/")
# (find-fline "/ifigenia:/home/root/bin/rc.ifigenia")
# (find-fline "/ifigenia:/etc/modules")




######
#
#
#
######

# Pra desligar o ifigenia a partir do angg

cd /boot/angg/
insmod 8390.o
insmod ne.o
ifconfig eth0 10.0.0.1
route add -net 10.0.0.0

ifigenia

# Aí a gente manda um "shutdown -h now".




######
#
# Ligando a rede no angg (na partição nova)
# Why is the nfs server not starting by default?
#
######

# (eeman "5 hosts_access")
# (find-fline "/etc/hosts.allow")

# (find-fline "/etc/inittab" "default runlevel")
# (find-fline "/etc/init.d/")
# (find-fline "/etc/init.d/README")
# (find-fline "/etc/init.d/" " rc")
# (find-fline "/usr/doc/debian-policy/")
# (find-fline "/usr/doc/debian-policy/policy.text.gz")
# (find-fline "/usr/doc/debian-policy/policy.text.gz" "\n3.3. System run levels")

# (find-fline "/usr/doc/sysvinit/")
# (find-fline "/usr/doc/sysvinit/README.runlevels.gz")
# (find-fline "/etc/rcS.d/")
# (find-fline "/etc/rc2.d/")
# (find-fline "/etc/init.d/")

bash -x /etc/init.d/nfs-server start

# ^ Here it is: the server only starts if /etc/exports is non-trivial...
# (find-fline "/etc/init.d/nfs-server")
# (find-fline "/etc/exports")
# /	*	(rw,no_root_squash)

# (eeman "exports")
# (find-fline "/o/etc/exports")





#####
#
# exporting / to local machines
#
#####

heredoc /etc/exports -m 0644 <<'---'
# /etc/exports: the access control list for filesystems which may be exported
#		to NFS clients.  See exports(5).
#
/	*(rw,no_root_squash)
/	10.0.0.*(rw,no_root_squash)
---
/etc/init.d/nfs-server stop
/etc/init.d/nfs-server start


# (find-fline "/usr/doc/HOWTO/NFS-HOWTO.gz" "apollon(rw)")

# (find-fline "/patna:/etc/exports")
# (find-fline "/patna:/etc/fstab")
# (find-fline "/etc/exports")
# (find-fline "/etc/fstab")

mount /patna
echo foo > /patna/tmp/o
echo foo > /patna/home/root/foo



# (find-fline "/usr/doc/emacsen-common/debian-emacs-policy.gz")







psnedeb <<'---'
   50831 dists/potato/main/source/net/samba_2.0.5a-2.diff.gz
     592 dists/potato/main/source/net/samba_2.0.5a-2.dsc
 2196946 dists/potato/main/source/net/samba_2.0.5a.orig.tar.gz
---

psnedeb <<'---'
    1611 dists/potato/main/source/otherosfs/tksmb_0.8.6-1.diff.gz
     701 dists/potato/main/source/otherosfs/tksmb_0.8.6-1.dsc
   22566 dists/potato/main/source/otherosfs/tksmb_0.8.6.orig.tar.gz
    5679 dists/slink/main/source/otherosfs/smbfs_2.0.2-5.diff.gz
     525 dists/slink/main/source/otherosfs/smbfs_2.0.2-5.dsc
   21392 dists/slink/main/source/otherosfs/smbfs_2.0.2.orig.tar.gz
---

pdsc $SDEBIAN/dists/potato/main/source/otherosfs/tksmb_0.8.6-1.dsc
cd /usr/src/tksmb-0.8.6/

pdsc $SDEBIAN/dists/potato/main/source/net/samba_2.0.5a-2.dsc

pdsc $SDEBIAN/dists/slink/main/source/otherosfs/smbfs_2.0.2-5.dsc
cd /usr/src/smbfs-2.0.2/




#####
#
# samba 2.0.5a (potato)
#
#####

pdsc $SDEBIAN/dists/potato/main/source/net/samba_2.0.5a-2.dsc
cd /usr/src/samba-2.0.5a/






#  Local Variables:
#  coding:               utf-8-unix
#  End:
