#######
#
# E-scripts on dealing with e-mail.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/mail.e>
#           or at <http://angg.twu.net/e/mail.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.testmail»			(to "testmail")
# «.reconfiguring-exim»		(to "reconfiguring-exim")
# «.smtp»			(to "smtp")
# «.smtp-protocol»		(to "smtp-protocol")
# «.libmime-perl»		(to "libmime-perl")
# «.libmime-lite-perl»		(to "libmime-lite-perl")
# «.test-pop3server»		(to "test-pop3server")
# «.procmail_fetchmail»		(to "procmail_fetchmail")
# «.basic_fetchmail_test»	(to "basic_fetchmail_test")
# «.pop3-server»		(to "pop3-server")
# «.fetchmail-fakemda»		(to "fetchmail-fakemda")
# «.fetchmail-fakemda-fm»	(to "fetchmail-fakemda-fm")
# «.imap4»			(to "imap4")
# «.imap4-eepitch»		(to "imap4-eepitch")
# «.imap4-eepitch-ruby»		(to "imap4-eepitch-ruby")
# «.procmail»			(to "procmail")
# «.mutt-accents»		(to "mutt-accents")
# «.mutt-accents-old»		(to "mutt-accents-old")
# «.mutt»			(to "mutt")
# «.mutt-keys»			(to "mutt-keys")
# «.muttrc»			(to "muttrc")
# «.mhonarc»			(to "mhonarc")
# «.mhonarc-bug-aug2021»	(to "mhonarc-bug-aug2021")
# «.smail_to_exim_and_back»	(to "smail_to_exim_and_back")
# «.RFCs»			(to "RFCs")
# «.Net::SMTP»			(to "Net::SMTP")
# «.Net::SMTP2»			(to "Net::SMTP2")
# «.mime-construct»		(to "mime-construct")
# «.fetchmail-bug»		(to "fetchmail-bug")
# «.postfix»			(to "postfix")
# «.spamassassin»		(to "spamassassin")
# «.sylpheed-claws»		(to "sylpheed-claws")
# «.squirrelmail»		(to "squirrelmail")
# «.mailx-source»		(to "mailx-source")
# «.deliver»			(to "deliver")
# «.postfix-doc»		(to "postfix-doc")
# «.dovecot»			(to "dovecot")
# «.isync»			(to "isync")
# «.cyrus-imapd»		(to "cyrus-imapd")
# «.sieve-cyrus»		(to "sieve-cyrus")
# «.isync»			(to "isync")
# «.imap-on-gmail»		(to "imap-on-gmail")
# «.netqmail-install»		(to "netqmail-install")
# «.netqmail»			(to "netqmail")
# «.qmail-src»			(to "qmail-src")
# «.qmail-domainname»		(to "qmail-domainname")
# «.internal-mailing-lists»	(to "internal-mailing-lists")
# «.test-send-with-mailx»	(to "test-send-with-mailx")
# «.msmtp»			(to "msmtp")
# «.qmail-logs»			(to "qmail-logs")
# «.qmail-inject»		(to "qmail-inject")
# «.message.el»			(to "message.el")
# «.gmail-backup»		(to "gmail-backup")
# «.gmail-keys»			(to "gmail-keys")
# «.thunderbird»		(to "thunderbird")
# «.icedove»			(to "icedove")
# «.downloading-exes»		(to "downloading-exes")





#####
#
# What MTAs, mail daemons and MDAs do
# 2004dec18
#
#####

# Packages:
#   debian-policy
#   exim4
#   postfix-doc
#   fetchmail
# (find-dpolfile "policy.txt.gz" "11.6. Mail transport")
# (find-node "(exim4)How Exim receives and delivers mail")
# (find-node "(exim4)Delivery in detail")
# (find-udfile "postfix/MAILDROP_README.gz")
# (find-udw3m  "postfix/html/local.8.html")
# (find-udfile "fetchmail/NOTES.gz")
# (find-udw3m  "fetchmail/design-notes.html" "Relevant RFCS")

# (find-status   "fetchmail")
# (find-vldifile "fetchmail.list")
# (find-udfile   "fetchmail/")

# (find-zsh "acse mail-transport-agent | sort")
# (find-zsh "acse -i mda | sort")

# (find-man "1 mailx")



#####
#
# testmail
# 2004sep18
#
#####

# «testmail»  (to ".testmail")
# (find-angg ".zshrc" "testmail")
# (find-node "(coreutils)date invocation")
# (find-sh0  "date +%R:%S")
#
function testmail () {(
  DATE=$(date +%R:%S)
  USER1=$1
  USER2=$2
  STR="($DATE) $USER1 -> $USER2"
  echo $STR
  echo $STR | sudo -u $USER1 mail $*[3,-1] -s $STR $USER2
)}

#
sudo -u beth mail
testmail aleph beth   -v
sleep 2
sudo -u beth mail

#
testmail edrx eduardoochs@removethis.fastmail.fm

#
sudo -u edrx mail
#
HOME=~edrx sudo -u edrx fetchmail
#




#####
#
# reconfiguring exim
# 2004sep18
#
#####

# «reconfiguring-exim»  (to ".reconfiguring-exim")
#
grep-available -F Provides mail-transport-agent |& l -S
#
grep-status               -F Provides mail-transport-agent
grep-status -s Package -n -F Provides mail-transport-agent
#
# This is not what we want - the configs are in exim4-config..
dpkg-reconfigure exim4-daemon-light
#
dpkg-reconfigure exim4-config
#
# (find-status   "exim4-config")
# (find-status   "exim4-config" "Description:")
# (find-vldifile "exim4-config.list")
# (find-vldifile "exim4-config.conffiles")
# (find-vldifile "exim4-config.postinst")
# (find-vldifile "exim4-config.config")
# (find-vldifile "exim4-config.templates")
# (find-udfile   "exim4-config/")

# (find-vldifile "exim4-config.templates" "Template: exim4/dc_smarthost")
# (find-vldifile "exim4-config.templates" "replacing")
# (find-vldifile "exim4-config.config" "dc_smarthost=")
# (find-vldifile "exim4-config.config" "db_set exim4/dc_smarthost")
# (find-vldifile "exim4-config.config" "EX4QUESTION=\"exim4/dc_smarthost\"")
# (find-vldifile "exim4-config.config" "\t\t35)")
# (find-fline "/usr/share/debconf/confmodule" "db_set ()")
# (find-fline "/etc/exim4/exim4.conf.template")
# (find-fline "/etc/exim4/update-exim4.conf.conf")
# (find-fline "/etc/exim4/update-exim4.conf.conf" "dc_readhost")

# (find-man "1 find")
# (find-man "1 find" "`-maxdepth 0'")

#
grep /usr/share/doc/exim4-base/README.SMTP-AUTH $(
  find $(</var/lib/dpkg/info/exim4-config.list) -maxdepth 0 -type f
)
#
function files-only () { find $(cat $*) -maxdepth 0 -type f }
cd /var/lib/dpkg/info/
grep dc_smarthost $(echo exim*; files-only exim4*.list)

#
# (find-fline "/usr/share/debconf/confmodule")
# (find-vldifile "" "exim4-config.list")




#####
#
# SMTP
# 2004sep24
#
#####

# «smtp»  (to ".smtp")
# «smtp-protocol»  (to ".smtp-protocol")
# http://www.ietf.org/rfc/rfc0821.txt
# http://www.ietf.org/rfc/rfc0822.txt
# (code-c-d "rfc" "$S/http/www.ietf.org/rfc/")
# (find-rfcfile "rfc0821.txt" "MAIL <SP> FROM:")
# (find-rfcfile "rfc0821.txt" "Example of the SMTP Procedure")
# (find-rfcfile "rfc0822.txt")
# (find-fline "/etc/services" "smtp")

# SMTP:        (find-rfcfile "rfc0821.txt")
# Mail format: (find-rfcfile "rfc0822.txt")

#
cat > $EEG <<'%%%'
HELO persephone
MAIL FROM:<aleph@persephone>
RCPT TO:<beth@persephone>
DATA
Foo!
.
QUIT
%%%
eeg telnet 127.0.0.1 25
#




#####
#
# libmime-perl
# 2004sep24
#
#####

# «libmime-perl»  (to ".libmime-perl")
# (find-angg ".zshrc" "perlsendfile")
# (find-status   "libmime-perl")
# (find-vldifile "libmime-perl.list")
# (find-udfile   "libmime-perl/")
# (find-man "3pm MIME::Entity")
# (find-man "3pm MIME::Entity" "build PARAMHASH")
# (find-man "3pm MIME::Entity" "attach PARAMHASH")
# (find-man "3pm MIME::Entity" "print [OUTSTREAM]")
#
cp -v ~/DANIEL/daniel.png /tmp/daniel.png
perl -- =(<<'%%%'
  use MIME::Entity;
  $top = MIME::Entity->build(
    Type    => "multipart/related",
    From    => "aleph\@persephone",
    To      => "$line",
    Subject => "Hello! Hello!",
    'Return-Path:' => "aleph\@persephone"
  );
  $top->attach(
    Path     => "/tmp/daniel.png",
    Type     => "image/png",
    Encoding => "base64"
  );
  open MAIL, "| /usr/lib/sendmail beth@persephone" or die "open: $!";
  $top->print(\*MAIL);
  close MAIL;
%%%)

#




#####
#
# libmime-lite-perl
# 2004sep24
#
#####

# «libmime-lite-perl»  (to ".libmime-lite-perl")
# (find-angg ".zshrc" "perlsendfile")

# (find-status   "libmime-lite-perl")
# (find-vldifile "libmime-lite-perl.list")
# (find-udfile   "libmime-lite-perl/")
# (find-udfile   "libmime-lite-perl/README.gz")

# (find-udfile "libmime-lite-perl/examples/contrib/MailTool.pm.gz")
# (find-udfile "libmime-lite-perl/examples/contrib/README")
# (find-udfile "libmime-lite-perl/examples/mime_fwd")
# (find-udfile "libmime-lite-perl/examples/mime_gif")
# (find-udfile "libmime-lite-perl/examples/mime_hack")
# (find-udfile "libmime-lite-perl/examples/mime_longlines")
# (find-udfile "libmime-lite-perl/examples/mime_postcard")
# (find-udfile "libmime-lite-perl/examples/nodisp")
# (find-man "3pm MIME::Lite")
# (find-fline "/usr/share/perl5/MIME/Lite.pm")






#####
#
# fetchmail
# 2000nov02
#
#####

# (find-status   "fetchmail")
# (find-vldifile "fetchmail.list")
# (find-udfile   "fetchmail/")

# (find-man "1 fetchmail" "--fetchmailrc")




#####
#
# Testing a pop3server with fetchmail
# 2000nov02
#
#####

# «test-pop3server»  (to ".test-pop3server")
#
# You need to have a pop3-server (like ipopd or qpopper) installed for
# this to work.

# The zeroth step is to remove the leftovers of previous similar
# tests.

userdel aleph
rm -Rv /home/aleph
userdel beth
rm -Rv /home/beth

# The first step is to add two test users, with their own names as
# passwords. This is dangerous if you are not offline.

# Note: I think that some things here can freeze without any message
# if either aleph or beth are logged in.

expect -c '
  foreach u {aleph beth} {
    spawn adduser --debug $u
    interact -o "UNIX password:" {sleep 0.05; send "$u\n"} \
	        -ex {[]:} {send "\n"} \
		-ex {[y/n]} {send "y\n"}
}'

# Now we set the ".fetchmailrc"s; aleph will pick his mail from beth's
# mailbox and beth will pick her from aleph's.

function setfetchmailrc () {
  (echo "poll 127.0.0.1 with protocol pop3"
   echo "  user $2 with password $2 is $1 here"
  )>          /home/$1/.fetchmailrc
  chmod 600   /home/$1/.fetchmailrc
  chown $1:$1 /home/$1/.fetchmailrc
}
setfetchmailrc aleph beth
setfetchmailrc beth aleph

#
# Sometimes the "spawn" will freeze due to something that I don't
# understand yet. This will kill all the pending "expect"s:
ps ax | grep expect
kill -9 $(ps ax | grep expect | grep -v grep | awk '{print $1}')
ps ax | grep expect

# Beware that it will kill my ssh wrapper scripts also.

#

# Alternative test, 2000nov10:
# «procmail_fetchmail»  (to ".procmail_fetchmail")

# The basic test below worked fine and now this is a test for
# procmail. We copy root's mailbox to aleph (remember that my home
# machine, angg.popolvuh, is an offline machine where I am root 99% of
# the time), then we set beth's .procmailrc, and make beth fetch mail
# from aleph; then I can check if a .procmailrc can sort my mail in a
# satisfactory way (and test mutt's support for mailboxes).

cd /var/spool/mail/
laf
cp -iv root aleph
chmod 660 aleph
chown aleph:mail aleph
rm -v beth
laf

# (find-fline "~/" ".procmail")
# (find-fline "~/.procmailrc0")
# (find-fline "~beth/Mail/")
# (find-fline "~beth/Mail/mbox")
# (find-fline "~beth/Mail/mbox-froms")

cd ~beth
cp -v ~/.procmailrc0 .procmailrc
cp -v ~/.muttrc .
echo '"|exec /usr/bin/procmail"' > .forward
mkdir Mail
chmod 777 Mail
su -s /usr/bin/fetchmail beth
grep '^From ' ~beth/Mail/mbox | sort > ~beth/Mail/mbox-froms
laf ~beth/Mail
laf /var/spool/mail/
cd ~beth/Mail
#
# Now it makes sense to run mutt as beth.
# (eeman "1 mutt" "-y")
# (find-es "zsh" "zsh_suid")
(USERNAME=beth; HOME=~beth; mutt -y)

#

# Basic test, 2000nov02:
# «basic_fetchmail_test»  (to ".basic_fetchmail_test")
# Send a test mail to each one (aleph and beth).

date | mail -s "Hi aleph!" aleph
date | mail -s "Hi beth!" beth
# (find-fline "/var/spool/mail/")

#

# Run the fetchmails. Note that each one of the fetchmails will take
# about 4s to run. Is this a standard delay to prevent against scripts
# that try passwords?

su -s /usr/bin/fetchmail aleph
su -s /usr/bin/fetchmail beth
# (find-fline "/var/spool/mail/")

#

# This one is funny.
su -s /usr/bin/fetchmail aleph -- --mda cat

#





#####
#
# pop3-server / qpopper and ipopd
# 2000nov02
#
#####

# «pop3-server»  (to ".pop3-server")
#
acse pop3-server |& tee ~/o

#
# (find-status   "uw-mailutils")
# (find-vldifile "uw-mailutils.list")
# (find-udfile   "uw-mailutils/")
# (find-status   "ipopd")
# (find-vldifile "ipopd.list")
# (find-udfile   "ipopd/")

# (find-man "8C ipop2d")
# (find-man "8C ipop3d")
# (find-man "8C ipopd")
# (find-udfile "ipopd/README.Debian")
# (find-fline "/etc/pam.d/pop")

# (find-man "1 fetchmail")

#
fetchmail -a -k -p POP3 \
  -m cat \
  --invisible -u beth localhost

#
# courier-pop - Courier Mail Server - POP3 server
# dovecot-pop3d - A secure POP3 server that supports mbox and maildir mailboxes
# ipopd - POP2 and POP3 servers from UW
# mailutils-pop3d - GNU mailutils-based POP3 Daemon
# popa3d - A tiny POP3 daemon, designed with security as the primary goal
# qpopper - Enhanced Post Office Protocol server (POP3)
# solid-pop3d - POP3 server supporting Maildir, PAM, vhosting
# teapop - Powerful and flexible RFC-compliant POP3 server

#
# (find-status "qpopper")
# (find-vldifile "qpopper.list")
# (find-fline "/usr/doc/qpopper/")

# (eeman "8 qpopper")
# (eeman "8 popauth")
# (eeman "8 in.qpopper")

# (find-status "ipopd")
# (find-vldifile "ipopd.list")
# (find-fline "/usr/doc/ipopd/")





#####
#
# a fake mail delivery agent for fetchmail
# 2004oct04
#
#####

# «fetchmail-fakemda»  (to ".fetchmail-fakemda")
# (to "deliver")
# (find-man "1 fetchmail" "-m <command> | --mda <command>")
#
cat > /tmp/fakemda <<'%%%'
#!/bin/sh
cd /tmp/fakemda-mail/ || exit 1
if [ ! -e n ]; then echo 0 > n; fi
N=$[$(<n)+1]
cat            > $N
echo $N: "$*" >> args
echo $N        > n
%%%
chmod 755 /tmp/fakemda

#
rm -Rv /tmp/fakemda-mail/
mkdir  /tmp/fakemda-mail/
cd     /tmp/fakemda-mail/
echo beth > $EEG; eeg \
fetchmail -a -k -p POP3 --invisible \
  -m "/tmp/fakemda %F %T" \
  -u beth localhost

#
# «fetchmail-fakemda-fm»  (to ".fetchmail-fakemda-fm")
#
rm -Rv /tmp/fakemda-mail/
mkdir  /tmp/fakemda-mail/
cd     /tmp/fakemda-mail/
fetchmail -a -k -p IMAP --invisible \
  -m "/tmp/fakemda %F %T" \
  -u eduardoochs@removethis.fastmail.fm mail.messagingengine.com

#
# (find-man "1 fetchmail" "-r <name> | --folder <name>")
#
rm -Rv /tmp/fakemda-mail/
mkdir  /tmp/fakemda-mail/
cd     /tmp/fakemda-mail/
fetchmail -a -k -p IMAP --invisible \
  -m "/tmp/fakemda %F %T" \
  -r "INBOX.Sent Items" \
  -u eduardoochs@removethis.fastmail.fm mail.messagingengine.com

#
# (find-fline "/tmp/fakemda/")




#####
#
# IMAP4
# 2004oct04
#
#####

# «imap4»  (to ".imap4")
# (find-rfcfile "rfc1730.txt")
# (find-rfcfile "rfc1730.txt" "6.3.1.  SELECT Command\n")
# (find-rfcfile "rfc1730.txt" "6.3.8.  LIST Command\n")
# (find-rfcfile "rfc1730.txt" "6.3.9.  LSUB Command\n")
# (find-rfcfile "rfc2060.txt")
# (find-fline "/etc/services" "imap")
#
cat > $EEG <<'%%%'
A0001 LOGIN eduardoochs@removethis.fastmail.fm xxxxxxxx
A0002 LIST "" *
A0003 SELECT INBOX
A0004 SELECT "INBOX.Sent Items"
A0005 LOGOUT
%%%
eeg telnet mail.messagingengine.com 143

#
cat > $EEG <<'%%%'
 source ~/.passwds.tcl   ;# (find-angg ".passwds.tcl")
 l "A0001 LOGIN eduardoochs@removethis.fastmail.fm $passwd(fm)"
 l {A0002 LIST "" *}
 l {A0003 SELECT INBOX}
 l {A0004 SELECT "INBOX.Sent Items"}
 l {A0005 LOGOUT}
%%%
eeg4 telnet mail.messagingengine.com 143

#





#####
#
# IMAP4 via eepitch
# 2004oct04
#
#####

# «imap4-eepitch»  (to ".imap4-eepitch")

 (eepitch-comint "imap4-fastmail" "telnet mail.messagingengine.com 143")
A0001 LOGIN eduardoochs@removethis.fastmail.fm xxxxxxxx
A0002 LIST "" *
A0003 SELECT INBOX
A0004 SELECT "INBOX.Sent Items"
A0005 LOGOUT

# «imap4-eepitch-ruby»  (to ".imap4-eepitch-ruby")
# (find-fline "/usr/lib/ruby/1.8/net/imap.rb")
# (find-fline "/usr/lib/ruby/1.8/net/imap.rb" "usessl = false")
# (find-fline "/usr/lib/ruby/1.8/net/imap.rb" "== Examples of Usage")
# (find-vldifile "ri1.8.list")
# (find-fline "/usr/share/ri/1.8/system/Net/IMAP/")
# (find-rubyri "Net::IMAP")
# (find-rubyri "Net::IMAP#login")
# The version using ruby doesn't work!!! 8-(

 (eepitch-ruby)
 (eepitch-kill)
 (eepitch-ruby)
require "net/imap"
imap = Net::IMAP.new('mail.messagingengine.com')
imap.authenticate('LOGIN',    'eduardoochs@removethis.fastmail.fm', 'xxxxxxxx')
imap.authenticate('cram-md5', 'eduardoochs@removethis.fastmail.fm', 'xxxxxxxx')
imap.examine('INBOX')
imap.search(["RECENT"]).each do |message_id|
  envelope = imap.fetch(message_id, "ENVELOPE")[0].attr["ENVELOPE"]
  puts "#{envelope.from[0].name}: \t#{envelope.subject}"
end










#####
#
# procmail
#
#####

# «procmail»  (to ".procmail")

pdsc /big/slinks2/dists/slink/main/source/mail/procmail_3.10.7-7.dsc

# (find-status "procmail")
# (find-vldifile "procmail.list")
# (find-fline "/usr/doc/procmail/")
# (find-fline "/usr/doc/procmail/examples/")
# (find-fline "/usr/doc/procmail/examples/1procmailrc")
# (eeman "1 formail")
# (eeman "1 mailstat")
# (eeman "1 procmail")
# (eeman "1 lockfile")
# (eeman "5 procmailex")
# (eeman "5 procmailrc")
# (eeman "5 procmailsc")

# Pushing my old mail archives through procmail

echo -n "foo\nbar\n" \
  | expect -c 'while {![eof stdin]} {puts ".[gets stdin]."}'
echo -n 'foo' | expect -c 'foreach i {1 2 3 4} {puts [gets stdin li]}'
echo    'foo' | expect -c 'foreach i {1 2 3 4} {puts [gets stdin li]}'


chmod 600 $MAIL
cat $MAIL |
expect -c '
  proc writefile {fname bigstr} {
    set channel [open $fname w]
    puts -nonewline $channel $bigstr
    close $channel
  }
  # set lines [split [read stdin] "\n"]
  set msg {}
  while {[gets stdin line]!=-1} {
    if [regexp "^From " $line] {
      puts $line
      if {$msg!=""} {
        writefile /tmp/msg $msg
        exec procmail < /tmp/msg
        set msg {}
      }
    }
    append msg "$line\n"
  }
  if {$msg!=""} {
    writefile /tmp/msg $msg
    exec procmail < /tmp/msg
    set msg {}
  }
'




#######
#
# smail config
#
#######

# «smail_config»

# (find-vldifile "smail.list")
# (find-vldifile "" "smail")
# (find-fline "/usr/doc/smail/")

# (find-vldifile "smail.conffiles")
# (find-vldifile "smail.postinst")
# (find-vldifile "smail.postinst" "/usr/sbin/smailconfig")
# (find-vldifile "smail.postrm")
# (find-vldifile "smail.preinst")
# (find-vldifile "smail.prerm")

# (find-fline "/etc/smail/")
# (find-fline "/etc/smail/config")
# (find-fline "/etc/smail/config" "visible_name")
# (find-fline "/etc/smail/config" "hostnames")
# (find-fline "/etc/smail/routers" "inx")
man smail-config
smail-config

mail -s 'foo' edrx@inx.com.br <<'---'
baaaar
---

mail -s `date +%T` edrx@inx.com.br <<'---'
baaaar
---

echo `date +%T` | mail -s `date +%T` edrx
echo `date +%T` | mail -s `date +%T` edrx@angg
echo `date +%T` | mail -s `date +%T` edrx@localhost




######
#
# Killing outbound mail
#
######

# (find-fline "/var/spool/")

# (find-fline "/var/spool/smail/input/")
# (find-fline "/var/spool/smail/msglog/")

find /var/spool/smail/
laf /var/spool/smail/input/* /var/spool/smail/msglog/*
rm -v /var/spool/smail/input/* /var/spool/smail/msglog/*





#####
#
# Trying to make smail .forward to procmail
# 99oct21
#
#####

# (find-fline "/usr/doc/procmail/")
# (find-fline "/usr/doc/procmail/QuickStart" ".forward")

# It seems that smail doesn't like this .forward!!!
rm ~/.forward

cat > ~/.forward <<'---'
"|exec /usr/bin/procmail"
---

date | mail -s 'Teste' root

# (find-fline "/usr/src/smail-3.2.0.102/src/direct.c" "security violation")

# (find-fline "~edrx/.forward")
# (find-fline "~edrx/.procmailrc")




#####
#
# mutt - problem with accents - claviola's solution (working; thx to ISK)
# 2004dec28
#
#####

# «mutt-accents»  (to ".mutt-accents")
# http://lists.debian.org/debian-user-portuguese/2002/03/msg00286.html
# (find-fline "/etc/locale.gen")
# (find-man "locale-gen")
#
# as root:
echo en_US ISO-8859-1 > /etc/locale.gen
locale-gen

#
export LANG=en_US
export LANGUAGE=en_US
export LC_ALL=en_US
mutt -R -f ~/MAIL/current.pucmail

#




#####
#
# mutt - problem with accents - old attempts that didn't work
# 2004sep03
#
#####

# «mutt-accents-old»  (to ".mutt-accents-old")
# (find-es "locale")
# (find-status   "mutt")
# (find-vldifile "mutt.list")
# (find-udfile   "mutt/")
#
cat > /tmp/.muttrc <<'%%%'
# (find-udfile "mutt/examples/Muttrc.gz" "set charset")
set charset="iso-8859-1"
%%%
mutt -F /tmp/.muttrc -R -f /tmp/some.mbox
mutt                 -R -f /tmp/some.mbox

#
mutt -e 'set charset="iso8859-1"'  -R -f /tmp/some.mbox
mutt -e 'set charset="iso-8859-1"' -R -f /tmp/some.mbox
mutt -e 'set charset="latin-1"'    -R -f /tmp/some.mbox
mutt -e 'set charset="utf-8"'      -R -f /tmp/some.mbox
mutt                               -R -f /tmp/some.mbox
#
mutt -e 'set allow_8bit'    -R -f /tmp/some.mbox
#
mutt -F /tmp/_muttrc -R -f /tmp/some.mbox
#
# http://www.inf.ufsc.br/~nardin/linux/cfg/_muttrc
# (find-fline "$S/http/www.inf.ufsc.br/~nardin/linux/cfg/_muttrc")
# (find-fline "/tmp/_muttrc")

#
# (find-fline "/etc/locale.alias")
# (find-fline "/etc/locale.gen")
# (eev "sudo dpkg-reconfigure locales")
# (eev "EDITOR=nano sudo dpkg-reconfigure locales")
# Only the 4th one works
LC_ALL=C           mutt -R -f /var/spool/mail/aleph
LC_ALL=ISO8859-1   mutt -R -f /var/spool/mail/aleph
LC_ALL=C.ISO8859-1 mutt -R -f /var/spool/mail/aleph
LC_ALL=pt_BR       mutt -R -f /var/spool/mail/aleph
LC_ALL=en_US       mutt -R -f /var/spool/mail/aleph
#




######
#
# mutt
# 2002oct07
#
######

# «mutt»  (to ".mutt")
# (find-status   "mutt")
# (find-vldifile "mutt.list")
# (find-udfile   "mutt/")
# (find-udfile   "mutt/examples/")
# (find-udfile   "mutt/manual.txt.gz")
# (find-sh0 "zcat /usr/share/doc/mutt/manual.txt.gz > /tmp/mutt-manual.txt")
# (find-fline-ov "/tmp/mutt-manual.txt")
# mail format: (find-rfcfile "rfc0822.txt")

# (find-udw3 "mutt/html/manual.html")
# (find-fline "/usr/doc/mutt/manual.txt.gz")
zless /usr/doc/mutt/manual.txt.gz

zcat /usr/doc/mutt/manual.txt.gz | colcrt - > ~/tmp/muttmanual.txt
# (find-fline "~/tmp/muttmanual.txt")
# (find-fline "~/tmp/muttmanual.txt" "3.9.  Mailing lists")
# (find-fline "~/tmp/muttmanual.txt" "3.3.  Changing the default key bindings")
# (find-fline "~/tmp/muttmanual.txt" "hdr order From Date: From: To: Cc:")
# (find-fline "~/tmp/muttmanual.txt" "6.3.21.  charset")

# (find-fline "~/tmp/muttmanual.txt" "  2.3.  Reading Mail - The Index and Pa")
# (find-fline "~/tmp/muttmanual.txt" "  2.3.1.1.  Status Flags")

# (find-fline "~/tmp/muttmanual.txt")
# (find-fline "~/tmp/muttmanual.txt" "  6.4.  Functions" "next-undeleted")
# (find-fline "~/tmp/muttmanual.txt" "  6.4.3.  pager" "next-entry" "J")
# (find-fline "~/tmp/muttmanual.txt" "  6.4.3.  pager" "previous-entry" "K")
# (find-fline "~/tmp/muttmanual.txt" "  6.4.3.  pager" "mark-as-new" "N")
# (find-fline "~/tmp/muttmanual.txt" "  6.4.3.  pager" "undelete-message" "u")
# (find-fline "~/tmp/muttmanual.txt" "abort changes and exit")

# «muttrc»  (to ".muttrc")
# (find-man "mutt" "-F muttrc")
# (find-fline "~/.muttrc")
# (find-udw3 "mutt/html/manual-3.html")
# (find-fline "/usr/doc/mutt/examples/")
# (find-fline "/usr/doc/mutt/examples/sample.muttrc.gz")
# (find-fline "/usr/doc/mutt/NEWS.gz")

# (find-fline "~/tmp/muttmanual.txt" "  3.21.  Executing functions")
# (find-fline "~/tmp/muttmanual.txt" "bind editor <delete> backspace")
# (find-fline "/usr/doc/mutt/examples/sample.muttrc.gz" "bind generic")
# (find-fline "/usr/doc/mutt/examples/sample.muttrc.gz" "tify mailing lists")




#####
#
# mutt-keys
# 2008jan04
#
#####

# «mutt-keys»  (to ".mutt-keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.1. Most common navigation keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.2. Most common line editor keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.3. Most common message index keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.4. Most common pager keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.5. Most common thread mode keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.6. Most common mail sending keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.7. Most common compose menu keys")
# (find-udfile "mutt/manual.txt.gz" "Table 2.9. Message forwarding/bouncing keys")

# (find-udfile "mutt/manual.txt.gz" "Table 4.1. Pattern modifiers")

# (find-udfile "mutt/manual.txt.gz" "Table 6.2. Default generic function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.3. Default index menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.4. Default pager menu function bindings")

# (find-udfile "mutt/manual.txt.gz" "Table 6.5. Default alias menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.6. Default query menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.7. Default attach menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.8. Default compose menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.9. Default postpone menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.10. Default browser menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.11. Default pgp menu function bindings")
# (find-udfile "mutt/manual.txt.gz" "Table 6.12. Default editor function bindings")




#####
#
# nmh
# 2000jun22
#
#####

# (find-status "nmh")
# (find-vldifile "nmh.list")
# (find-fline "/usr/doc/nmh/")

# (find-node "(mh-e-e20)Tour Through mh-e")

# (mh-version)
# (install-mh)




#######
#
# metamail
#
#######

# Cuidado, ele se embola com 0xFFs
metamail -r < mich > mich.u




######
#
# mhonarc
# 2007dec28
#
######

# «mhonarc»  (to ".mhonarc")
# (find-status   "mhonarc")
# (find-vldifile "mhonarc.list")
# (find-udfile   "mhonarc/")
# (find-udw3m "mhonarc/index.html")
# (find-udw3m "mhonarc/mhonarc.html")
# (find-fline "/usr/share/mhonarc/")

# Very old notes:

rm -Rv /tmp/mho
mkdir /tmp/mho
cd /tmp/mho
mhonarc ~/Mail/debian-dev

cp $MAIL .mail
mhonarc .mail
ls

lynx threads.html

grep '^From ' $MAIL
grep '^From ' $MAIL | sort




#####
#
# mhonarc-bug-aug2021
# 2021aug11
#
#####

# «mhonarc-bug-aug2021»  (to ".mhonarc-bug-aug2021")
# (find-es "eev" "find-wget-email")
#
# https://www.mhonarc.org/
# https://www.mhonarc.org/archive/
# https://www.mhonarc.org/MHonArc/doc/app-bugs.html
# http://savannah.nongnu.org/bugs/?group=mhonarc
# http://savannah.nongnu.org/bugs/?55783
#
# https://lists.gnu.org/archive/html/eev/2021-08/msg00000.html
# https://lists.gnu.org/archive/mbox/eev/2021-08
# Look for:
#   setq my-url
#
# (find-wget "https://lists.gnu.org/archive/mbox/eev/2021-08")
# (find-wget "https://lists.gnu.org/archive/mbox/eev/2021-08" "(setq my-url")




######
#
# smartlist
#
######

apt-get install smartlist

# (find-fline "/usr/doc/smartlist/")
# (find-vldifile "smartlist.list")
# (find-fline "/var/list/.bin/")

cd /var/list/.bin/
./createlist
./createlist lakhesis	|& tee ~/o2
# (find-fline "/etc/aliases")
# lakhesis: "|/var/list/.bin/flist lakhesis"
# lakhesis-request: "|/var/list/.bin/flist lakhesis-request"
strace-to ~/s newaliases


# (find-fline "/var/list/lakhesis/")
# (eeman "newaliases")
# (eeman "mkaliases")
# (find-fline "/usr/sbin/mkaliases")


mailas edrx lakhesis-request -s 'subscribe edrx' <<'---'
subscribe edrx
---
mailas edrx lakhesis-request@angg -s 'Re: CONFIRM s05030132451029' <<'---'
hahahayhe
---

function lakhrmail () { echo $2 | mailas $1 lakhesis-request -s $2 }
function lakhmail () { echo $2 | mailas $1 lakhesis -s $2 }

lakhmail edrx :::1

lakhrmail alex 'subscribe lakhesis'
lakhrmail alex 'Re: CONFIRM s050302344713'
lakhrmail alex 'CONFIRM s050302193812'

mailas alex lakhesis-request -s 'subscribe alex' <<'---'
subscribe alex
---
mailas edrx -- lakhesis-request@angg -s 'Re: CONFIRM s05030132451029' <<'---'
hahahayhe
---

function lakhmail





#####
#
# Itatiaia
#
#####

{\bf Resumo.} Tome uma derivação em dedução natural no fragmento
$\setof{\land, \to}$ da lógica intuicionista. Pelo isomorfismo de
Curry-Howard ela pode ser vista como um termo de $ð$-cálculo tipado
construído usando a aplicação, a abstração, a formação de pares e as
projeções. Se algumas das funções que aparecem como constantes nesse
termo forem funções deriváveis podemos querer introduzir um operador
``derivada''; vamos mostrar dois modos como isso pode ser feito, e
também vamos introduzir um operador que corresponde a uma aplicação do
teorema da função inversa, e usá-lo para obter dois corolários do
teorema da função inversa: o teorema da função implícita e o da forma
local das imersões.

Para tornar o funcionamento desses dois operadores mais claro nós
vamos mostrar como interpretá-los em termos de infinitesimais; vamos
usar para isso um modelo de análise não-standard construído com
filtros ao invés de ultrafiltros. A lógica de um modelo desses é
booleana mas tem mais de dois valores de verdade; apesar disso os
infinitesimais nesses modelos têm uma interpretação clara como
seqüências, e certas provas usando infinitesimais têm uma tradução
quase automática para provas standard usando limites e continuidade.

Uma árvore de dedução num sistema desses pode ser interpretada como
dizendo que ``se eu sei a série de Taylor de ... até ordem ... e a de
... até ordem ... então eu sei a de ... até ordem ...''.



% (fooi "ç" "{\\c c}" "ã" "\\~a"  "õ" "\\~o"
	"á" "\\'a" "é" "\\'e" "í" "{\\'\\i}" "ó" "\\'o" 
	"ü" "\\\"u" "ê" "\\^e")





mail -s 'Edrx: Abstract' hermann@inf.puc-rio.br <<'----'
Hare Hermann. Aqui vai um resumo do que eu gostaria de apresentar em
Itatiaia. Eu cheguei a fazer duas paginas de algo muito mais detalhado
mas nao ia dar pra terminar dentro do prazo; vou supor que os textos
nao-resumidos so' precisam ser entregues (por quem quiser entregar,
que e' o meu caso) ate' uma data bem posterior.

Semi-P.S.: acabei de marcar a data da minha defesa. Vai ser no dia 29
de abril (sexta), `as 14:00hs, se todos os membros da banca toparem
esse dia e essa hora. So' dois ainda nao confirmaram: voce e o Luiz
Carlos. :-)

P.Semi-P.S.: eu nunca vi nenhum anuncio do encontro de Itatiaia. Se
existir um mail oficial o anunciando voce pode mandar uma copia pra
mim?

  Obrigados,
      Edrx.



% Eduardo Nahum Ochs
% Departamento de Matem\'atica -- PUC-Rio
% edrx@mat.puc-rio.br
% 286-9903

{\bf Resumo.} Tome uma deriva{\c c}\~ao em dedu{\c c}\~ao natural no
fragmento $\{\land, \to\}$ da l\'ogica intuicionista. Pelo isomorfismo
de Curry-Howard ela pode ser vista como um termo de
$\lambda$-c\'alculo tipado constru{\'\i}do usando a aplica{\c c}\~ao,
a abstra{\c c}\~ao, a forma{\c c}\~ao de pares e as proje{\c c}\~oes.
Se algumas das fun{\c c}\~oes que aparecem como constantes nesse termo
forem fun{\c c}\~oes deriv\'aveis podemos querer introduzir um
operador ``derivada''; vamos mostrar dois modos como isso pode ser
feito, e tamb\'em vamos introduzir um operador que corresponde a uma
aplica{\c c}\~ao do teorema da fun{\c c}\~ao inversa, e us\'a-lo para
obter dois corol\'arios do teorema da fun{\c c}\~ao inversa: o teorema
da fun{\c c}\~ao impl{\'\i}cita e o da forma local das imers\~oes.

Para tornar o funcionamento desses dois operadores mais claro n\'os
vamos mostrar como interpret\'a-los em termos de infinitesimais; vamos
usar para isso um modelo de an\'alise n\~ao-standard constru{\'\i}do
com filtros ao inv\'es de ultrafiltros. A l\'ogica de um modelo desses
\'e booleana mas tem mais de dois valores de verdade; apesar disso os
infinitesimais nesses modelos t\^em uma interpreta{\c c}\~ao clara
como seq\"u\^encias, e certas provas usando infinitesimais t\^em uma
tradu{\c c}\~ao quase autom\'atica para provas standard usando limites
e continuidade.

Uma \'arvore de dedu{\c c}\~ao num sistema desses pode ser
interpretada como dizendo que ``se eu sei a s\'erie de Taylor de ...
at\'e ordem ... e a de ... at\'e ordem ... ent\~ao eu sei a de ...
at\'e ordem ...''.
----








# (find-fline "$HAI/Packages")
# (find-vldifile "metamail.list")

# (find-vldifile "mm.list")




"ç" "{\\c c}" "ã" "\\~a"  "õ" "\\~o"
	"á" "\\'a" "é" "\\'e" "í" "{\\'\\i}" "ó" "\\'o" 
	"ü" "\\\"u" "ê" "\\^e")


% (fooi "á " "a' " "é " "e' " "í " "i' " "ê " "e^ " "ó " "o' ")
% (fooi "ç" "c" "ã" "a" "õ" "o"
	"á" "a" "é" "e" "í" "i" "ó" "o" 
	"ü" "u" "â" "a" "ê" "e")








#####
#
# my exim configuration on potato (that is not working at all)
# 2000apr09
#
#####

# «exim_conf_potato»

# (find-vldifile "exim.list")
# (find-fline "/usr/doc/exim/")

/usr/sbin/eximconfig

# (2) Internet site using smarthost
# `visible' mail name of your system: inx.com.br
# other names which may appear on incoming mail messages: none
# domains you want to relay mail for: none
# networks of local machines you want to relay mail for: none
# use the RBL: no
# machine that will act as the smarthost and handle outgoing mail:
#   mail.inx.com.br
# Which user account(s) should system administrator mail go to: none
# You already have an /etc/aliases file. Do you want to replace this with
#   a new one? y
# (find-fline "/etc/aliases")






#####
#
# from smail to exim and back (on potato)
# 2000apr09
#
#####

# «smail_to_exim_and_back»  (to ".smail_to_exim_and_back")

# (eeman "dpkg" "--force-things")
# (find-fline "/var/lib/dpkg/status" "smail")
# (find-fline "/var/lib/dpkg/status" "Package: exim")
# (find-fline "/var/lib/dpkg/status" "Package: smail")

# smail -> exim
#
dpkg --force-depends -r smail
dpkg -i $SDEBIAN/dists/potato/main/binary-i386/mail/exim_3.12-7.deb

# (find-fline "/etc/")

# (find-fline "/etc/init.d/exim")
/etc/init.d/exim restart


# exim -> smail
#
dpkg --force-depends -r exim
dpkg -i /big/potato/dists/potato/main/binary-i386/mail/smail_3.2.0.102-2.deb

/etc/init.d/inetd restart
/etc/init.d/smail restart




#####
#
# testing the delivery of local mail
# 2000apr09
#
#####

# «local_mail_test»

# (find-es "debian" "smail_config")
echo `date +%T` | mail -s `date +%T` edrx
echo `date +%T` | mail -s `date +%T` edrx@angg
echo `date +%T` | mail -s `date +%T` edrx@localhost

echo `date +%T` | mail -s `date +%T` root
echo `date +%T` | mail -s `date +%T` root@angg
echo `date +%T` | mail -s `date +%T` root@localhost

strace -f -o ~/s -p $(pidof inetd)

# (find-fline "/var/log/")
# (find-fline "/var/log/syslog")

cd /var/log/
agrep -i exim *



#####
#
# how exim installs itself
# 2000apr09
#
#####

# «how_exim_installs_itself»

# (find-vldifile "exim.list")
# (find-vldifile "exim.postinst")
# (find-vldifile "exim.postrm")
# (find-vldifile "exim.preinst")
# (find-vldifile "exim.prerm")
# (find-vldifile "" "exim")
# (find-fline "/usr/doc/exim/")

Pgrepp m/suidmanager/
suidmanager

# (eeman "update-inetd")
# (find-fline "/usr/sbin/update-inetd")

# (eeman "update-rc.d")
# (find-fline "/usr/sbin/update-rc.d")

# (find-fline "/etc/inetd.conf" "smtp")
# (eeman "inetd.conf")
# (eeman "inetd")
# (find-fline "/etc/init.d/inetd")

/etc/init.d/inetd restart




#####
#
# "host" is not working...
# 2000apr09
#
#####

# «host_and_resolv.conf»

ping localhost
ping angg
host localhost

LOCALDOMAIN=  \
  strace-to ~/s  \
  host localhost

# (eeman "host" "CUSTOMIZING HOST NAME LOOKUP")
# (find-fline "/etc/resolv.conf")





#####
#
# Tracing the I/O of the mail program
# 2000apr15
#
#####

# «tracing_smtpprog_io»

# (eeman "strace" "-e read")
# (eeman "vfork" "strace.1. cannot follow  vfork")
# (find-fline "~/.zshrc" "strace-to")
# (find-k22file "include/asm-i386/unistd.h")
# (find-fline "~/bin/kbrequest")
# (find-fline "~/bin/tracemail")

strace -o ~/s -f \
  -etrace=read,write,fork,_exit,execve,wait4 \
  -eread=0,1,2 -ewrite=0,1,2 \
  tclsh

strace -f -o ~/s tclsh



# (find-fline "/etc/inetd.conf" "smtp")
# (eeman "inetd.conf")
# (eeman "inetd")
#smtp		stream	tcp	nowait	root	/usr/sbin/tcpd	/home/root/bin/tracemail /usr/sbin/in.smtpd


/etc/init.d/inetd restart

echo `date +%T` | strace -f -o ~/s mail -s `date +%T` edrx
echo `date +%T` | strace-to ~/s mail -s `date +%T` edrx





#####
#
# more about tracing the mail delivery program
# 2000apr19
#
#####

# I want to trace what happens when I try to send a mail to the
# outside. This isn't working, and as it seems that nobody else has
# complained, I'm going to do the basic bug-hunting myself.

# It seems that programs that have to send mails (mailx, for example,
# and I guess that also fetchmail) call /usr/sbin/sendmail to do this
# for them. The mails certainly get stored somewhere, with a
# background process trying to send them; I want to get my hands on
# this process and to trace and debug it without letting it go to the
# background.

# Oh-oh. There are two main ways to exchange mails between two
# machines: smtp and pop3. I guess that outside-bound mail is sent via
# smtp and that pop3 is only for requesting mail stored in temporary
# places. Luckily, fetchmail can handle both, and I can use it to test
# local pop3/smtp servers.

# (find-fline "/etc/services" "smtp")
# (find-fline "/etc/services" "pop3")
# (find-vldifile "fetchmail.list")
# (find-fline "/usr/doc/fetchmail/")
# (find-fline "/usr/doc/fetchmail/README" "forwarding via SMTP to sendmail")
# (find-fline "/usr/doc/fetchmail/NOTES.gz" "port 25")



#####
#
# RFCs
# 2000may09
#
#####

# «RFCs»  (to ".RFCs")

ar p /big/potato/dists/potato/main/binary-all/doc/doc-rfc_1999.08-1.deb \
  data.tar.gz \
  | tar -tvzf - \
  | tee ~/o

# Get some RFCs.

cd /tmp/
ar p /big/potato/dists/potato/main/binary-all/doc/doc-rfc_1999.08-1.deb \
  data.tar.gz \
  | tar -xvzf - usr/doc/doc-rfc/all-included-rfcs/rfc{1939,821,977,850}.txt.gz

cd /tmp/
mv -v /tmp/usr/doc/doc-rfc/all-included-rfcs/* /tmp/
gzip -dv /tmp/*gz
rm -Rv /tmp/usr

cp -v /tmp/rfc* ~/tmp/

# (find-fline "~/tmp/rfc1939.txt")
# (find-fline "~/tmp/rfc1939.txt" "Example POP3 Session\n")
# (find-fline "~/tmp/rfc821.txt")
# (find-fline "~/tmp/rfc821.txt" "SMTP example")

# (find-fline "~/tmp/rfc977.txt")
# (find-fline "$S/ftp/ftp.uu.net/inet/rfc/rfc850.Z")





#####
#
# SMTP via Perl
# 2000apr22
#
#####

# «Net::SMTP»  (to ".Net::SMTP")

# (eeman "Net::SMTP")
# (eeman "Net::Cmd")
# (find-pl5file "Net/SMTP.pm" "=head")

# To print the mail domain name of the SMTP server known as localhost:
cat > /tmp/p <<'---'
    use Net::SMTP;
    $smtp = Net::SMTP->new('localhost');
    print $smtp->domain,"\n";
    $smtp->quit;
---
perl /tmp/p

# Send a simple test message
cat > /tmp/p <<'---'
    use Net::SMTP;
    $smtp = Net::SMTP->new('localhost',
			   Hello => 'anyname',
			   Debug => 1);
    # $smtp->mail($ENV{USER});
    $smtp->mail('hunnglah');
    $smtp->to('edrx');
    $smtp->data();
    $smtp->datasend("To: edrx\n");
    $smtp->datasend("\n");
    $smtp->datasend(`date "+Test: %Y%b%d %T"`);
    $smtp->dataend();
    $smtp->quit;
---
perl /tmp/p
sleep 1
tail -n 14 /var/spool/mail/edrx



# (find-pl5file "Net/SMTP.pm" "B<Hello>")
# (find-pl5file "Net/SMTP.pm" "B<Debug>")
# (eeman "perlop" "qx.STRING.")

# Seems that the "Hello" field is only used to authorize the sender,
# since smail doesn't put any part of it on the headers of the message
# that goes into the mailbox...




#####
#
# SMTP via Perl: using to send real mail
# 2000may08
#
#####

# «Net::SMTP2»  (to ".Net::SMTP2")

# (find-es "mail" "Net::SMTP")
# (find-es "perl" "sendEmail")
# (find-es "perl" "Getopt::Std")
# (find-fline "~/bin/sendemail")

# Send a simple test message
cat > /tmp/p <<'---'
    use Net::SMTP;
    $smtp = Net::SMTP->new('mail.inx.com.br',
			   Hello => 'inx.com.br',
			   Debug => 1);
    # $smtp->mail($ENV{USER});
    $smtp->mail('edrx@inx.com.br');
    $smtp->to('edrx@twu.net');
    $smtp->data();
    $smtp->datasend("To: edrx\@twu.net\n");
    $smtp->datasend("Subject: Net::SMTP test\n");
    $smtp->datasend("\n");
    $smtp->datasend(`date "+Test: %Y%b%d %T"`);
    $smtp->dataend();
    $smtp->quit;
---
perl /tmp/p


# (find-fline "~/.fetchmailrc")
fetchmail
sleep 1
tail -n 30 /var/spool/mail/root

# (find-fline "$MAIL")


# I'm using a variation of this to send mail. See:
# (find-fline "~/bin/sendemail")




#####
#
# mime-construct
# 2001jan10
#
#####

# «mime-construct»  (to ".mime-construct")

# (find-status "mime-construct")
# (find-vldifile "mime-construct.list")
# (find-fline "/usr/doc/mime-construct/")

# (eeman "1p mime-construct")
# (find-fline "/usr/bin/mime-construct")





#####
#
# fetchmail doesn't like exim at first sight
# 2000jun14
#
#####

# «fetchmail-bug»  (to ".fetchmail-bug")

pdsc $SPOTATO/main/source/mail/fetchmail_5.3.3-1.1.dsc
cd /usr/src/fetchmail-5.3.3/

# (code-c-d "fmail" "/usr/src/fetchmail-5.3.3/")

# (find-status "fetchmail")
# (find-vldifile "fetchmail.list")
# (find-fline "/usr/doc/fetchmail/FAQ.gz")
# (find-fline "/usr/doc/fetchmail/FAQ.gz" '* 2 "-v shows `SMTP connect failed")

# (find-fline "/etc/hosts")
# (eeman "1 fetchmail" "--mda")

fetchmail -S 127.0.0.1/25
# fails

# (find-fline "/etc/resolv.conf")
# (find-fline "/etc/nsswitch.conf")

# (find-es "init" "init-FQDN")

#hostname angg
domainname popolvuh
fetchmail
# also fails

# (find-fline "/etc/resolv.conf")
#order hosts,bind
# This also fails

fetchmail --mda 'exim -bS'
# Fails with better messages:

#reading message 2 of 68 (3706 octets) ...500 Command unrecognized
#Transaction started in line 0
#Error detected in line 1
#Return-Path: <bounce-debian-mentors=edrx=inx.com.br@lists.debian.org>
#An error was detected while processing a file of BSMTP input.
#The error message was:
#
#  500 Command unrecognized
#
#The SMTP transaction started in line 0.
#The error was detected in line 1.
#The SMTP command at fault was:
#
#   Return-Path: <bounce-debian-mentors=edrx=inx.com.br@lists.debian.org>
#
#0 previous messages were successfully processed.
#The rest of the batch was abandoned.
#fetchmail: MDA exited abnormally or returned nonzero status
# not flushed





#####
#
# pop3 server
# 2000jun14
#
#####

# (find-status "ipopd")
# (find-vldifile "ipopd.list")
# (find-fline "/usr/doc/ipopd/")

# (find-status "libc-client4.7")
# (find-vldifile "libc-client4.7.list")
# (find-fline "/usr/doc/libc-client4.7/")

# (find-status "mlock")
# (find-vldifile "mlock.list")
# (find-fline "/usr/doc/mlock/")

# (find-fline "~beth/.fetchmailrc")

cd /home/beth
chown beth.beth .fetchmailrc
chmod 600 .fetchmailrc
su -s /usr/bin/fetchmail beth
su -s /usr/bin/fetchmail beth -- --mda cat |& tee ~/o

(D=`date +%T`; echo $D; echo $D | mail -s $D edrx)
(D=`date +%T`; echo $D; echo $D | mail -s $D edrx@localhost)
(D=`date +%T`; echo $D; echo $D | mail -s $D edrx@angg)
(D=`date +%T`; echo $D; echo $D | mail -s $D edrx@angg.popolvuh)

# (find-fline "/var/spool/mail/edrx")
# (find-fline "/var/spool/mail/beth")
mail -f /var/spool/mail/edrx
mail -f /var/spool/mail/beth

su -s /usr/bin/mail edrx




#####
#
# postfix
# 2000nov04
#
#####

# «postfix»  (to ".postfix")
# Following a suggestion on the #debian IRC channel I replaced smail
# (that more or less worked) and exim (that didn't work with
# fetchmail) by postfix, that seems to work well with fetchmail.

# (find-status "postfix")
# (find-vldifile "postfix.list")
# (find-fline "/usr/doc/postfix/")
# (find-vldifile "postfix.conffiles")
# (find-vldifile "postfix.md5sums")
# (find-vldifile "postfix.preinst")
# (find-vldifile "postfix.postinst")
# (find-vldifile "postfix.prerm")
# (find-vldifile "postfix.postrm")
# (find-fline "/etc/postfix/")

# When I try to run this it asks for a parameter...
# /var/lib/dpkg/info/postfix.postinst

# Postfix's installation asked me a single question (plus confirmation):
# (find-vldifile "postfix.postinst" "world writable mail drop")
# dpkg --force-help
dpkg --purge --force-depends postfix
apti postfix

# (find-fline "/usr/doc/postfix/html/")
# (find-w3 "/usr/doc/postfix/html/")
# (find-w3 "/usr/doc/postfix/html/faq.html")
# (find-w3 "/usr/doc/postfix/html/faq.html#dialup")
# (find-w3 "/usr/doc/postfix/html/faq.html#masquerade")
# (find-fline "/usr/doc/postfix/examples/")

# (find-fline "/etc/postfix/main.cf")
# (find-fline "/etc/postfix/main.cf" "Other configurable parameters.")
## Edrx:
#relayhost = mail.inx.com.br
#myorigin = inx.com.br

/etc/init.d/postfix restart





#####
#
# procmail and spamassassin on puc
# 2004may09
#
#####

# «spamassassin»  (to ".spamassassin")
# Seguindo uma sugestão do Nicolau...
#
cd
mkdir mail
mkdir .spamassassin

cat > .procmailrc <<'%%%'
PATH=/bin:/usr/bin
MONTH=`date +%Y%m`
DAY=`date +%Y%m%d`
MAILDIR=$HOME/mail               #you'd better make sure it exists
# DEFAULT=$MAILDIR/from/main       #completely optional
LOGFILE=$MAILDIR/procmail.$DAY   #recommended

:0 fhbw
* < 256000
| /usr/bin/spamassassin -a

:0:
* ^X-Spam-Level: \*\*\*\*\*\*\*\*
spam.$DAY.mbx

# :0:
# * ^X-Spam-Status: Yes
# spam.$DAY.mbx

:0
* ^^rom[ ]
{
  LOG="*** Dropped F off From_ header! Fixing up. "

  :0 fhw
  | sed -e '1s/^/F/'
}
%%%

cat > .spamassassin/user_prefs <<'%%%'
# SpamAssassin user preferences file.  See 'man Mail::SpamAssassin::Conf' for
# details of what can be tweaked.
#*
#* Note: this file is not read by SpamAssassin until copied into the user
#* directory. At runtime, if a user has no preferences in their home directory
#* already, it will be copied for them, allowing them to perform personalised
#* customisation.  If you want to make changes to the site-wide defaults,
#* create a file in /etc/spamassassin or /etc/mail/spamassassin instead.
###########################################################################

# How many hits before a mail is considered spam.
# required_hits         5
required_hits           4

# Whitelist and blacklist addresses are now file-glob-style patterns, so
# "friend@somewhere.com", "*@isp.com", or "*.domain.net" will all work.
# whitelist_from        someone@somewhere.com
whitelist_from  *puc-rio.br

# Add your own customised scores for some tests below.  The default scores are
# read from the installed spamassassin rules files, but you can override them
# here.  To see the list of tests and their default scores, go to
# http://spamassassin.org/tests.html .
#
# score SYMBOLIC_TEST_NAME n.nn
%%%
#




#####
#
# sylpheed-claws
# 2004sep03
#
#####

# «sylpheed-claws»  (to ".sylpheed-claws")
# (find-fline "~e/MAIL/")
#
sudo cat ~e/MAIL/02may06.mcgillmail > /tmp/test-mbox
#




#####
#
# squirrelmail
# 2004oct03
#
#####

# «squirrelmail»  (to ".squirrelmail")
# (find-status   "squirrelmail")
# (find-vldifile "squirrelmail.list")
# (find-udfile   "squirrelmail/")
# Run /usr/sbin/squirrelmail-configure as root to configure/upgrade config.
#
sudo /usr/sbin/squirrelmail-configure

#
# (find-fline "/etc/squirrelmail/apache.conf")
# (find-fline "/etc/apache/")
# (find-fline "/etc/apache/httpd.conf")
# (find-fline "/etc/apache/conf.d/")

#
# As root:

cat > /etc/apache/conf.d/squirrelmail.conf <<'%%%'
# (find-fline "/etc/squirrelmail/apache.conf")
# (find-es "mail" "squirrelmail")
#
Alias /squirrelmail /usr/share/squirrelmail
#
<Directory /usr/share/squirrelmail>
  php_flag register_globals off
  Options Indexes FollowSymLinks
  <IfModule mod_dir.c>
    DirectoryIndex index.php
  </IfModule>
</Directory>
%%%

/etc/init.d/apache restart

#
firefox http:/127.0.0.1/squirrelmail/ &

#
# ^ "Unknown user or password incorrect."
# Why?
grep -i authentica $(find $(cd /var/lib/dpkg/info; cat squirrelmail.{list,conffiles}) -maxdepth 0 -type f | sort)

#
# (find-fline "/etc/squirrelmail/config_default.php")
# (find-fline "/usr/sbin/squirrelmail-configure")
# (find-fline "/usr/share/squirrelmail/functions/auth.php")

# (find-fline "/var/log/")

# (find-fline "/etc/squirrelmail/config_default.php")
# (find-fline "/etc/squirrelmail/config_local.php")
# (find-fline "/etc/squirrelmail/index.php")
# (find-fline "/etc/squirrelmail/sqspell_config.php")
# (find-fline "/etc/squirrelmail/filters_setup.php")
# (find-fline "/etc/cron.daily/squirrelmail")
# (find-fline "/usr/sbin/squirrelmail-configure")




#####
#
# qmail
# 2004oct13
#
#####

# (find-fline "~/tmp/qmail-igor/")
#
# (find-fline "~/tmp/qmail-igor/install")

A=(iproute localepurge linuxlogo dpkg-dev equivs pinfo links2
gpm less eject ctags ssh screen vim mc gcc make patch binutils
libncurses5-dev mtr-tiny squid bind9 ntpdate dnsutils unison gpm mc
vim less eject iproute gcc make bin86 libncurses5-dev smbfs smbclient
linuxlogo apache php4 portsentry nmap mtr-tiny hping2 php4-imap bzip2
heartbeat unison xinetd bind9 bind9-host dnsutils wget lockvc tnef
maildrop lsof g++ aspell aspell-bin ispell aspell-pt-br libgdbm-dev
libssl-dev expect arj unarj zip unzip file autoconf m4 perl-suid
libhtml-parser-perl libhtml-tagset-perl spamassassin spamc unrar
module-init-tools)

sudo apt-get -yu install $A

#
rm -Rv /tmp/qmail_dirs/

qmail_dirs.tgz

~/tmp/qmail-igor/




#####
#
# mailx - source
# 2004oct15
#
#####

# «mailx-source»  (to ".mailx-source")
#
cd ~/usrc
mkdir mailx
cd mailx
apt-get builddep mailx
apt-get build-dep mailx
sudo apt-get build-dep mailx
apt-get source mailx

#
rm -Rv ~/usrc/mailx/
mkdir  ~/usrc/mailx/
cd $S/http/ftp.debian.org/debian/pool/main/m/mailx/
cp -v mailx_8.1.2-0.20040524cvs-3.diff.gz   ~/usrc/mailx/
cp -v mailx_8.1.2-0.20040524cvs-3.dsc       ~/usrc/mailx/
cp -v mailx_8.1.2-0.20040524cvs.orig.tar.gz ~/usrc/mailx/
cd ~/usrc/mailx/
dpkg-source -x mailx_8.1.2-0.20040524cvs-3.dsc

cd ~/usrc/mailx/mailx-8.1.2-0.20040524cvs/
tar -cvzf /tmp/mailx-src.tgz .* *

#
cd ~/usrc/mailx/mailx-8.1.2-0.20040524cvs/
make |& tee om

#
Scp /tmp/mailx-src.tgz edrx@${SUCURI}:tmp/
#

 (eebg-channel-xterm "puc" "Sucuri")
 (eechannel "puc")
rm -Rv ~/usrc/mailx/
mkdir  ~/usrc/mailx/
cd     ~/usrc/mailx/
tar -xvzf ~/tmp/mailx-src.tgz
make |& tee om

# (code-c-d "mailx" "~/usrc/mailx/mailx-8.1.2-0.20040524cvs/")
# (find-mailxfile "")
# (find-mailxfile "aux.c")
# (find-mailxfile "aux.c" "TIMESPEC_TO_TIMEVAL")
# (find-mailxfile "popen.c")
# (find-mailxfile "popen.c" 46)

# (find-fline "/usr/include/lockfile.h")
Scp /usr/include/lockfile.h edrx@${SUCURI}:usrc/mailx/

TIMESPEC_TO_TIMEVAL

#include "lockfile.h"  /* <lockfile.h> */

liblockfile
liblockfile-dev

http://ftp.debian.org/debian/pool/main/m/mailx/
http://ftp.debian.org/debian/pool/main/m/mailx/

http://ftp.debian.org/debian/pool/main/libl/liblockfile/
liblockfile_1.06.dsc
liblockfile_1.06.tar.gz

# http://ftp.debian.org/debian/pool/main/libl/liblockfile/liblockfile_1.06.dsc
# http://ftp.debian.org/debian/pool/main/libl/liblockfile/liblockfile_1.06.tar.gz


# (code-c-d "mailx" "~/usrc/mailx/mailx-8.1.2-0.20040524cvs/")
# (find-mailxfile "")



#####
#
# Controlling the "In-reply-to" field on a broken mailx (RedHat)
#
#####

#
cd ~/usrc/mailx/mailx-8.1.2-0.20040524cvs/
grep "'r'" *.[ch]

#
# (find-mailxfile "")
# (find-mailxfile "collect.c")
# (find-mailxfile "collect.c" "case 'R':")
# (find-mailxfile "collect.c" "case 'R':" "case 'r':")
# (find-mailxfile "list.c")




#####
#
# grepmail bug
# 2004oct13
#
#####

Use of uninitialized value in subtraction (-) at /usr/share/perl5/Mail/Mbox/MessageParser/Grep.pm line 87.
Use of uninitialized value in numeric ne (!=) at /usr/share/perl5/Mail/Mbox/MessageParser/Grep.pm line 86.

<edrx> uma pergunta pros debian developers aqui presentes
<edrx> o grepmail buga comigo:
<edrx> Use of uninitialized value in subtraction (-) at
       /usr/share/perl5/Mail/Mbox/MessageParser/Grep.pm line 87.
<edrx> Use of uninitialized value in numeric ne (!=) at
       /usr/share/perl5/Mail/Mbox/MessageParser/Grep.pm line 86.
<edrx> pra poder reportar esse bug direito eu imagino que eu precise de
<edrx> um caso-teste reproduzivel que faca o bug acontecer...
<edrx> voces podem me dar algumas dicas de por onde comecar?





#####
#
# mb2md - convert mboxes to maildirs
# 2004dec19
#
#####

# (find-status   "mb2md")
# (find-vldifile "mb2md.list")
# (find-udfile   "mb2md/")
# (find-fline "/usr/bin/mb2md")
# (find-udfile "mb2md/USAGE.gz")
# (find-man "1 mb2md")
#
cp -v ~/MAIL/current.pucmail /tmp/
rm -Rv /tmp/md/
mkdir  /tmp/md/
cd     /tmp/md/
mb2md -s /tmp/current.pucmail -d $PWD

#
# The target format is not as simple as I expected -
# file names are not just numbers.
# (find-fline "/tmp/md/")
# (find-fline "/tmp/md/cur/")




# (find-available "apt-listchanges")


date | mail -s 'test!' edrx@twu.net
sleep 1
mailq
sendmail -q

mailq


# (find-fline "/usr/sbin/postconf")
# (find-fline "~/.fetchmailrc")

# (find-vldifile "" "postfix")




# (find-status "devscripts")
# (find-vldifile "devscripts.list")
# (find-fline "/usr/doc/devscripts/")
# (find-fline "/usr/doc/devscripts/examples/")
# (find-fline "/usr/share/doc/devscripts/examples/debian.procmail.gz")
/usr/share/doc/devscripts/examples




#####
#
# deliver
# 2004dec23
#
#####

# «deliver»  (to ".deliver")
# (to "fetchmail-fakemda")
# (find-status   "deliver")
# (find-vldifile "deliver.list")
# (find-udfile   "deliver/")
# (find-udfile   "deliver/SENDMAIL" "P=/usr/bin/deliver")
# (find-udfile   "deliver/examples/")
# (find-man "1 fetchmail" "-m <command> | --mda <command>" "/usr/bin/deliver")

# (find-man "8 deliver")
# (find-man "1 header")





#####
#
# postfix-doc
# 2004dec23
#
#####

# «postfix-doc»  (to ".postfix-doc")
# (find-status   "postfix-doc")
# (find-vldifile "postfix-doc.list")
# (find-udfile   "postfix-doc/")
#
firefox /usr/share/doc/postfix/html/index.html &
#




#####
#
# dovecot
# 2005jul30
#
#####

# «dovecot»  (to ".dovecot")
# (find-angg ".emacs" "gnus")
# (find-status   "dovecot-imapd")
# (find-vldifile "dovecot-imapd.list")
# (find-udfile   "dovecot-imapd/")
# (find-status   "dovecot-common")
# (find-vldifile "dovecot-common.list")
# (find-udfile   "dovecot-common/")

# (find-udfile "dovecot-common/NEWS.gz")
# (find-udfile "dovecot-common/README")
# (find-udfile "dovecot-common/README.Debian.gz")
# (find-udfile "dovecot-common/TODO.gz")
# (find-udfile "dovecot-common/USE-WIKI-INSTEAD")
# (find-udfile "dovecot-common/auth.txt.gz")
# (find-udfile "dovecot-common/changelog.Debian.gz")
# (find-udfile "dovecot-common/changelog.gz")
# (find-udfile "dovecot-common/configuration.txt.gz")
# (find-udfile "dovecot-common/index.txt.gz")
# (find-udfile "dovecot-common/mail-storages.txt.gz")
# (find-man "8 dovecot")

# http://www.dovecot.org/list/dovecot/
# http://wiki.dovecot.org/

# (find-udfile "dovecot-imapd/README.Debian" "protocols=")
# (find-udfile "dovecot-common/README.Debian.gz" "default_mail_env =")
# (find-fline "$ASROOT/etc/dovecot/dovecot.conf")
protocols = imaps
imap_listen = 127.0.0.1

# (find-fline "$ASROOT/etc/dovecot/dovecot.conf" "mail-storages.txt")
# (find-udfile "dovecot-common/mail-storages.txt.gz")

#
# (find-fline "/etc/init.d/dovecot")
# restart is different from stop+start
sudo /etc/init.d/dovecot stop
sudo /etc/init.d/dovecot start

#
cd ~/MAIL/
mboxgrep eev@nongnu.org current.pucmail > /tmp/o
laf /tmp/o

#
laf $MAIL
#

chown edrx:mail $MAIL
chmod 660 $MAIL

#
sudo /etc/init.d/dovecot restart
sudo /etc/init.d/inetd restart

#
# (find-es "net" "nmap")
# (find-sh "nmap -P0 localhost")
# (find-fline "/etc/services")

# (find-zsh "acse imap | sort")




#####
#
# isync (not working)
# 2005aug01
#
#####

# «isync»  (to ".isync")
# Como importar os meus mails do fastmail?
# (find-status   "isync")
# (find-vldifile "isync.list")
# (find-udfile   "isync/")

# (find-zsh "acse imap | sort")
# (find-available "imapproxy")
mailreader - Simple, but powerful WWW mail reader system
mailsync - Synchronize IMAP mailboxes
mailutils - GNU mailutils utilities for handling mail
postman - High performace web based IMAP and NNTP client

# (find-man "1 isync")

isync -l -V \
  -u eduardoochs@fastmail.fm \
  -s mail.messagingengine.com

#
# (find-fline "~/.isyncrc")
# (find-man "1 isync")
# (find-udfile "isync/examples/isyncrc.sample")

cd ~/FASTMAIL/
echo -n > .isyncrc
isync  -c .isyncrc -u edrx -s localhost -V -a

#

isync -a -L -V






#####
#
# cyrus-imapd
# 2007may29
#
#####

# «cyrus-imapd»  (to ".cyrus-imapd")

 (eepitch-shell)
apti cyrus-common-2.2 cyrus-imapd-2.2 cyrus-doc-2.2

# (find-debpkg-links "cyrus-imapd-2.2")
# (find-debpkg-links "cyrus-common-2.2")
# (find-debpkg-links "cyrus-doc-2.2")

# Packages with preconfigs with questions that I don't understand:
# (find-debpkg-links "libhesiod0")
# (find-debpkg-links "msmtp")
# They seem to have good defaults, though...
# http://www.daemon-systems.org/man/hesiod.conf.5.html
# (find-man "5 hesiod.conf")
# (find-vldifile "libhesiod0.templates")
# (find-vldifile "msmtp.templates")

# (find-status   "cyrus-doc-2.2")
# (find-vldifile "cyrus-doc-2.2.list")
# (find-udfile   "cyrus-doc-2.2/")
# (find-udfile "cyrus-doc-2.2/README.Debian.gz" "closed-box email system")

# The imap server at digirati is a cyrus - I got that info from
# something that I ran on Ruby, but what?...

 (eepitch-ruby)
 (eepitch-kill)
 (eepitch-ruby)
require "net/imap"
imap = Net::IMAP.new('mail.messagingengine.com')




#####
#
# Sieve on Cyrus
# 2007may31
#
#####

# «sieve-cyrus»  (to ".sieve-cyrus")
# (find-rfcfile "rfc1730.txt" "quoted string")
# (find-rfcfile "rfc3028.txt")
# (find-udw3m "cyrus-doc-2.2/html/sieve-protocol.html")
# (find-udw3m "cyrus-doc-2.2/html/sieve.html")




#####
#
# isync
# 2022jan22
#
#####

# «isync»  (to ".isync")
# https://isync.sourceforge.io/
# https://isync.sourceforge.io/mbsync.html
# https://sourceforge.net/p/isync/isync/ci/master/tree/
# https://sourceforge.net/projects/isync/lists/isync-devel
# (find-git-links "https://git.code.sf.net/p/isync/isync" "isync")

eduardoochs@id.uff.br

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/isync/
mkdir   ~/usrc/isync/
cd      ~/usrc/
git clone https://git.code.sf.net/p/isync/isync
cd      ~/usrc/isync/

# (code-c-d "isync" "~/usrc/isync/")
# (find-isyncfile "")
# (find-isyncfile "README")
# (find-isyncfile "README" "Cyrus SASL")
# (find-zsh "availabledebs | sort | grep sasl")
# (find-zsh "availabledebs | sort | grep berk")

apti libsasl2-dev
apti libdb-dev

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/isync/
./autogen.sh       |& tee oa
./configure        |& tee oc
make               |& tee om
sudo make install  |& tee omi

# (find-man "1 mbsync")






#####
#
# imap on gmail
# 2007nov11
#
#####

# «imap-on-gmail»  (to ".imap-on-gmail")

How do I enable IMAP?

You can retrieve your Gmail messages with a client or device that
supports IMAP, like Microsoft Outlook or Apple Mail.

To enable IMAP in your Gmail account:

   1. Log in to your Gmail account.
   2. Click Settings at the top of any Gmail page.
   3. Click Forwarding and POP/IMAP.
   4. Select Enable IMAP.
   5. Configure your IMAP client* and click Save Changes. 


Configuring other mail clients

You can use the following information to configure IMAP with many mail
clients. If you encounter difficulties, we suggest contacting your
mail client's customer support department for further instructions --
we're unable to provide assistance with configuring mail clients not
listed here.

Incoming Mail (IMAP) Server - requires SSL: imap.gmail.com
                                   Use SSL: Yes
                                      Port: 993
Outgoing Mail (SMTP) Server - requires TLS: smtp.gmail.com (use authentication)
                        Use Authentication: Yes
                              Use STARTTLS: Yes (some clients call this SSL)
                                      Port: 465 or 587
 Account Name:  your Gmail username (including @gmail.com)
Email Address: 	your full Gmail email address (username@gmail.com)
Password: 	your Gmail password

Please note that if your client does not support SMTP authentication,
you won't be able to send mail through your client using your Gmail
address.









#
cat > /tmp/mysendmail <<'%%%'
#!/bin/sh
mkdir -p /tmp/outmails
cd       /tmp/outmails || exit 1
if [ ! -e n ]; then 
  echo 0 > n
fi
N=$[$(<n)+1]
echo - $* > $N.sendmail
cat      >> $N.sendmail
echo $N > n
%%%
chmod 755 /tmp/mysendmail

#
# (setq sendmail-program "/tmp/mysendmail")
# (find-fline "/tmp/outmails")






echo - $*

is

#
cd /tmp/outmails
head -n 1 < 2.sendmail
#

# (find-status   "mboxgrep")
# (find-vldifile "mboxgrep.list")
# (find-udfile   "mboxgrep/")
# (find-man "1 mboxgrep")
# (find-node "(mboxgrep)Top")





#####
#
# netqmail: aloph's notes
# 2007dec12
#
#####

# «netqmail-install»  (to ".netqmail-install")

 (eepitch-caramelo)
 (eepitch-kill)
 (eepitch-caramelo)
mkdir ~/tmp/
cd    ~/tmp/
wget https://ghetto.homeunix.net/~andre/notes.tech/gomanet/qmail/install
wget --no-check-certificate \
  https://ghetto.homeunix.net/~andre/notes.tech/gomanet/qmail/install

# (find-caramelofile "")
# (find-caramelofile "tmp/install")
# (find-caramelofile "tmp/install" "config-fast the.full.hostname")




#####
#
# netqmail-1.05
# 2007dec12
#
#####

# «netqmail»  (to ".netqmail")
# http://zumbi/software/misc.src-pkgs/netqmail-1.05.tar.gz
# https://ghetto.homeunix.net/~andre/notes.tech/gomanet/qmail/install
#
rm -Rv ~/usrc/netqmail-1.05/
tar -C ~/usrc/ -xvzf \
  $S/http/zumbi/software/misc.src-pkgs/netqmail-1.05.tar.gz
cd     ~/usrc/netqmail-1.05/

#
# (code-c-d "netqmail" "~/usrc/netqmail-1.05/")
# (find-netqmailfile "")




#####
#
# qmail-src
# 2007dec12
#
#####

# «qmail-src»  (to ".qmail-src")
# (find-zsh "availabledebs | sort")
# (find-zsh "availabledebs | sort | grep qmail")
#
# qmail-qfilter_1.5-3.deb
# qmail-src_1.03-44.deb
# qmailanalog-installer_0.70.2.deb
# qmailmrtg7_4.2-1.deb
#
# (find-available "qmail-src")
# (find-fline "/etc/passwd" "qmaild:")
# (find-status   "qmail-src")
# (find-vldifile "qmail-src.list")
# (find-udfile   "qmail-src/")
#
apti ucspi-tcp-src
apti qmail-src

#
# (find-fline "/usr/bin/build-ucspi-tcp")
# (find-fline "/usr/bin/build-qmail")
#
rm -Rv ~/usrc/qmail/
mkdir  ~/usrc/qmail/
cd     ~/usrc/qmail/
build-ucspi-tcp |& tee obut
build-qmail     |& tee obq

#
# build-ucspi-tcp
# ===============
# Enter a directory where you would like to do this [/tmp/ucspi-tcp] .
# . already exists, should I use it anyway ? [yN] y
# Should I use sudo or fakeroot to build the package ? [sF] 
# Should I use sudo to gain real root access when required ? [Yn] 
# Press ENTER to continue...
# Do you want to remove all files in .,
# except ucspi-tcp_0.88-10_i386.deb now? [Yn] n
# Do you want to install ucspi-tcp_0.88-10_i386.deb now? [Yn] n
# Do you want to purge ucspi-tcp-src now? [yN] n
#
# build-qmail
# ===========
# Enter a directory where you would like to do this [/tmp/qmail] .
# . already exists, should I use it anyway ? [yN] y
# Should I use sudo or fakeroot to build the package ? [sF] 
# Should I use sudo to gain real root access when required ? [Yn] 
# Press ENTER to continue...
#
# Do you want to remove all files in /home/edrx/usrc/qmail,
# except qmail_1.03-44_i386.deb now? [Yn] n
# Do you want to install qmail_1.03-44_i386.deb now? [Yn] n
# Do you want to purge qmail-src now? [yN] n
#
# Don't forget to setup a /etc/qmail/rcpthosts file to prevent open relaying!

#
# qmail conflicts with mail-transport-agent
#  exim4-daemon-light provides mail-transport-agent and is installed.
#
aptrm exim4-daemon-light
#
# The following packages will be REMOVED:
#   at exim4 exim4-daemon-light mailx mutt

#
# (find-fline "~/usrc/qmail/ucspi-tcp-0.88/" "ucspi-tcp_0.88-10_i386.deb")
# (find-fline "~/usrc/qmail/" "qmail_1.03-44_i386.deb")
sudo dpkg -i ~/usrc/qmail/ucspi-tcp-0.88/ucspi-tcp_0.88-10_i386.deb |& tee ~/o1
sudo dpkg -i ~/usrc/qmail/qmail_1.03-44_i386.deb                    |& tee ~/o2

#
# (find-fline "~/usrc/qmail/obq")
# (find-fline "~/usrc/qmail/obut")
# (find-fline "~/usrc/qmail/")
# (find-fline "~/o2")

# To uninstall to reinstall from scratch (for tests):
aptrm qmail
aptrm ucspi-tcp


# (find-status   "ucspi-tcp")
# (find-vldifile "ucspi-tcp.list")
# (find-udfile   "ucspi-tcp/")
# (find-status   "qmail")
# (find-vldifile "qmail.list")
# (find-udfile   "qmail/")







#####
#
# qmail: domainname problem
# 2007dec12
#
#####

# «qmail-domainname»  (to ".qmail-domainname")
# My machine is called just "persephone" - dpkg -i qmail says:
#   Your hostname is persephone.
#   hard error
#   Sorry, I couldn't find your host's canonical name in DNS.
#   You will have to set up /var/qmail/control/me yourself.
# (find-fline "/var/qmail/control/me")
# (find-fline "/var/qmail/control/")
# (find-fline "~/usrc/qmail/obq" "config-fast.sh")
# config-fast is not installed globally, it seems -

# (find-fline "~/usrc/qmail/qmail-1.03/config-fast")
cd ~/usrc/qmail/qmail-1.03/
sudo ./config-fast persephone.omnisys.com.br |& tee ~/usrc/qmail/ocf

# (find-fline "~/usrc/qmail/ocf")
# Now qmail will refuse to accept SMTP messages except to persephone.omnisys.com.br.
# Make sure to change rcpthosts if you add hosts to locals or virtualdomains!

# https://ghetto.homeunix.net/~andre/notes.tech/gomanet/qmail/install
# (find-caramelofile "tmp/install" "config-fast the.full.hostname")

# (find-fline "/etc/init.d/qmail")
sudo /etc/init.d/qmail restart




# http://www.eyrie.org/~eagle/notes/debian/qmail.html
# http://newvibes.net/index.php/installation
# http://forum.qmailrocks.org/archive/index.php/f-8.html

# (find-man "8 splogger")

# (find-udfile "qmail/")
# (find-udgrep "zgrep -nH -e sendmail qmail/*")
# (find-udfile "qmail/INSTALL.gz" "To upgrade from sendmail to qmail:")
# (find-udfile "qmail/INSTALL.gz" "ln -s /var/qmail/bin/sendmail /usr/lib/sendmail")

sudo ln -s /var/qmail/bin/sendmail /usr/lib/sendmail
sudo ln -s /var/qmail/bin/sendmail /usr/sbin/sendmail

# (find-udfile "qmail/SENDMAIL.gz")





# (find-sh0 "host -t mx omnisys.com.br")
#   -> omnisys.com.br mail is handled by 10 pop.omnisys.com.br.
# (find-sh0 "host pop.omnisys.com.br")
#   -> pop.omnisys.com.br has address 200.169.82.8
# (find-sh0 "host 200.169.82.8")
#   -> 8.82.169.200.in-addr.arpa domain name pointer pop.omnisys.com.br.





#####
#
# internal mailing lists at omnisys
# 2007dec13
#
#####

# «internal-mailing-lists»  (to ".internal-mailing-lists")

                  SMTP
eduardo.omnisys --------> smtp.omnisys <----> mundo exterior
        ^ |  ^               |
        | |  |    POP        v
        | |  \------------ pop.omnisys
        | |
        | | SMTP
        | \---> ml.omnisys
        \------/
           POP

Máquinas:                Nomes curtos:
   smtp.omnisys.com.br      smtp.omnisys
    pop.omnisys.com.br	     pop.omnisys
     ml.omnisys.com.br	      ml.omnisys
  andre.omnisys.com.br	   andre.omnisys
  silas.omnisys.com.br	   silas.omnisys
eduardo.omnisys.com.br	 eduardo.omnisys

Mboxes:
    pop.omnisys/mail/andre
    pop.omnisys/mail/silas
    pop.omnisys/mail/eduardo
     ml.omnisys/mail/andre 
     ml.omnisys/mail/silas
     ml.omnisys/mail/eduardo      Arquivos (mailman):		 
     ml.omnisys/mail/ml1	    http://ml.omnisys/archives/ml1/
     ml.omnisys/mail/ml2	    http://ml.omnisys/archives/ml2/
  andre.omnisys/mail/andre
  silas.omnisys/mail/silas
eduardo.omnisys/mail/eduardo

Endereços:
  andre@omnisys
  silas@omnisys
eduardo@omnisys
    ml1@ml.omnisys
    ml2@ml.omnisys
someone@externalworld




To do:
Configurar o qmail pra suportar o ml.omnisys
Configurar o fetchmail pra ler do pop e do ml

# (find-fline "/var/log/mail.log")
# (find-sh0   "sudo chmod 777 /var/qmail/control/")
# (find-fline "/var/qmail/control/")
# (find-fline "/var/qmail/control/smtproutes")
# (find-man "8 qmail-remote")
# ml.omnisys.com.br:zumbi.omnisys.com.br
# :smtp.omnisys.com.br

 (eepitch-shell)
sudo /etc/init.d/qmail restart

# «test-send-with-mailx»  (to ".test-send-with-mailx")
D=$(date)
echo $D
echo $D | mailx -s "teste: $D" eduardoochs@gmail.com
# (find-man "mailx")

# (find-fline "/var/log/mail.log" "1197559745.993502 delivery 1: failure:")





# (find-es "mail")
# (find-es "mail" "test-send-with-mailx")


#####
#
# msmtp
# 2008jan04
#
#####

# «msmtp»  (to ".msmtp")
# (find-status   "msmtp")
# (find-vldifile "msmtp.list")
# (find-udfile   "msmtp/")
# (find-man "1 msmtp")
# (find-node "(msmtp)Top")

# (find-udfile "msmtp/Mutt+msmtp.txt")
# (find-udfile "msmtp/README")
# (find-udfile "msmtp/AUTHORS")
# (find-udfile "msmtp/THANKS")
# (find-udfile "msmtp/README.Debian")
# (find-udfile "msmtp/copyright")
# (find-udfile "msmtp/examples/msmtprc-system.example")
# (find-udfile "msmtp/examples/msmtprc-user.example")
# (find-udfile "msmtp/examples/msmtp-enqueue.sh")
# (find-udfile "msmtp/examples/msmtp-runqueue.sh")
# (find-udfile "msmtp/examples/README")
# (find-udfile "msmtp/NEWS.Debian.gz")
# (find-udfile "msmtp/changelog.gz")
# (find-udfile "msmtp/NEWS.gz")
# (find-udfile "msmtp/changelog.Debian.gz")

# (find-fline "~/.msmtprc")
# (find-caramelofile "")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
msmtp eduardoochs@gmail.com
From: eduardo.ochs@omnisys.com.br
To: eduardoochs@gmail.com
Subject: Foo

Bar bar
.




 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
/usr/sbin/sendmail eduardoochs@gmail.com <<'%%%'
From: eduardo.ochs@omnisys.com.br
To: eduardoochs@gmail.com
Subject: Foo

2008jan04 12:11
%%%

sudo mailq

# (find-sh "ps ax")




#####
#
# qmail logs
# 2008jan04
#
#####

# «qmail-logs»  (to ".qmail-logs")
# (find-fline       "/var/log/")
# (find-fline       "/var/log/" "mail.")
# (find-sh "sudo cat /var/log/mail.info")
# (find-sh "sudo cat /var/log/mail.log")




#####
#
# invoking qmail-inject directly (is it like "sendmail")?
# 2008jan04
#
#####

# «qmail-inject»  (to ".qmail-inject")
# (find-fline "~/.muttrc")
# (find-fline "~/.muttrc" "set sendmail=")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
/var/qmail/bin/qmail-inject -feduardo.ochs@omnisys.com.br <<'%%%'
From: Eduardo Nahum Ochs <eduardo.ochs@omnisys.com.br>
To: eduardoochs@gmail.com
Subject: Test

Test
2008jan04 16:02
%%%

# (find-man "qmail-inject")




#####
#
# sendmail.el (borrowing settings from a .muttrc)
# 2008jan04
#
#####

# «message.el»  (to ".message.el")
# (find-eapropos "sendmail")
# (find-efunction 'message-mail)
# (find-efunction 'message-send-mail-with-sendmail)
# (find-elnode "Index" "* sendmail-user-agent:")
# (find-enode "Variable Index" "* sendmail-user-agent:")
# (find-evardescr 'sendmail-program)
# (find-evardescr 'sendmail-user-agent)
# (find-evardescr 'user-mail-address)
# (find-gnusfile "message.el" "Sending via mail...")
# (find-gnusfile "message.el" "defcustom message-mail-user-agent")
# (find-gnusfile "message.el" "defun message-tool-bar-update")
# (find-node "(message)Mail Variables" "`message-send-mail-function'")
# (find-node "(message)New Mail Message")
# (find-node "(message)Sending")
# (setq sendmail-program "msmtp")
(message-mail "eduardoochs@gmail.com" "test")
(setq user-full-name "Eduardo Nahum Ochs") 
(setq user-mail-address "eduardo.ochs@omnisys.com")
message-send-mail-function
message-send-mail-real-function
message-send-mail-with-sendmail

# (find-man "sendmail")

# (find-sh "/usr/sbin/sendmail -h")
# (find-sh "/usr/sbin/sendmail -h" "-fsender")
# (find-sh "/usr/sbin/sendmail -h" "-Fname")

# (find-fline "~/.muttrc")
set sendmail="/var/qmail/bin/qmail-inject -feduardo.ochs@omnisys.com.br"
set from='eduardo.ochs@omnisys.com.br'
set realname='Eduardo Nahum Ochs'

# (setq sendmail-program "/var/qmail/bin/qmail-inject")
# (setq user-full-name "Eduardo Nahum Ochs") 
# (setq user-mail-address "eduardo.ochs@omnisys.com")
# (find-node "(message)New Mail Message")
# (message-mail "eduardoochs@gmail.com" "Subj")

# (find-gnusfile "message.el" "Sending...failed with exit value %d")

# (setq user-mail-address "eduardoochs@gmail.com")
# (find-efunction 'message-send)






#####
#
# gmail-backup
# 2009sep18
#
#####

# «gmail-backup»  (to ".gmail-backup")
# http://www.gmail-backup.com/
# http://www.gmail-backup.com/gmail-backup-0-105
# http://www.gmail-backup.com/files/gmail-backup-0.105-linux.zip
# http://www.gmail-backup.com/documentation
# http://www.gmail-backup.com/faq
# Gmail: Settings -> Forwarding and POP/IMAP -> IMAP Access -> Enable IMAP
#
rm -Rv ~/usrc/gmail-backup-0.105-linux/
unzip -d ~/usrc/ \
  $S/http/www.gmail-backup.com/files/gmail-backup-0.105-linux.zip
cd     ~/usrc/gmail-backup-0.105-linux/

#
# (code-c-d "gmailbackup" "~/usrc/gmail-backup-0.105-linux/")
# (find-gmailbackupfile "")

# http://www.gmail-backup.com/documentation
# Examples:
#   gmail-backup.exe backup dir user@gmail.com password
#   gmail-backup.exe backup dir user@gmail.com password 20070621 20080101
#   gmail-backup.exe backup dir user@gmail.com password 20070621
#   gmail-backup.exe restore dir user@gmail.com password

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

rm -Rv /tmp/eo2/
mkdir  /tmp/eo2/
cd ~/usrc/gmail-backup-0.105-linux/
./gmail-backup.sh backup /tmp/eo2/ eduardoochs2@gmail.com FooBar

# (find-fline "/tmp/eo2/")
# (find-fline "/tmp/eo2/2009/04/20090426-225044-eduardoochs@gmail.com-Fwd_Status_das_pendencias-1.eml")





#####
#
# gmail keys
# 2010oct17
#
#####

# «gmail-keys»  (to ".gmail-keys")
# (find-fline "~/tmp/gmail-keys.txt")




#####
#
# Thunderbird
# 2012jan29
#
#####

# «thunderbird»  (to ".thunderbird")
# «icedove»  (to ".icedove")
# (find-status   "icedove")
# (find-vldifile "icedove.list")
# (find-udfile   "icedove/")
# http://en.wikipedia.org/wiki/Mozilla_Corporation_software_rebranded_by_the_Debian_project

# (find-man "1 icedove")
# (find-fline "/usr/bin/icedove")

# (find-other-debian-links "thunderbird")

 (eepitch-gwenv)
 (eepitch-kill)
 (eepitch-gwenv)
cd
tar -cvzf /tmp/thu.tgz .thunderbird
ls -l /tmp/thu.tgz
scp -v /tmp/thu.tgz valeria@varda:/tmp/
md5sum /tmp/thu.tgz

 (eepitch-vardav)
 (eepitch-kill)
 (eepitch-vardav)
md5sum /tmp/thu.tgz
pwd
tar -xvzf /tmp/thu.tgz






#####
#
# dowonloading zip files with ".exe"s in gmail
# 2018mar26
#
#####

# «downloading-exes» (to ".downloading-exes")
# https://stackoverflow.com/questions/31903618/not-able-to-download-zip-file-from-gmail-which-contains-executable-jar-in-it
# https://mail.google.com/mail/ca/u/0/#inbox/16263f859ddcdbbe
# https://drive.google.com/drive/u/0/folders/172YBItENycYKL-WTJWRRMhb95IrlqSEp









http://librelist.com/
http://librelist.com/faq.html
stefans.lua.list@librelist.com


# (find-man "qmail-queue")
# (find-man "qmail-send")




http://homepages.tesco.net./~J.deBoynePollard/FGA/mail-mbox-formats.html
http://www.unicom.com/pw/reply-to-harmful.html

Configuring Mail Clients to Send Plain ASCII Text:
  http://www.expita.com/nomime.html

http://en.wikipedia.org/wiki/Signature_block

https://webapps.stackexchange.com/questions/31926/how-can-i-find-a-message-by-message-id-in-gmail
https://gmail.googleblog.com/2012/11/search-for-emails-by-size-and-more-in.html
https://support.google.com/mail/answer/7190?hl=en




#  Local Variables:
#  coding:               utf-8-unix
#  End:
