#######
#
# E-scripts on manim.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/manim.e>
#           or at <http://angg.twu.net/e/manim.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.git»		(to "git")
# «.could-not-import»	(to "could-not-import")
# «.docs»		(to "docs")
# «.jovane-install»	(to "jovane-install")
# «.jovane1»		(to "jovane1")





#####
#
# git
# 2023jul31
#
#####

# «git»  (to ".git")
# https://github.com/ManimCommunity/manim
# (find-git-links "https://github.com/ManimCommunity/manim" "manim")
# (code-c-d "manim" "~/usrc/manim/")
# (find-manimsh "find * | sort")
# (find-manimsh "find * | sort | grep rst")
# (find-manimsh "find * | sort | grep docbuild")
# (find-manimsh "find * | sort | grep reference/manim.mobject.graph.DiGraph")
# (find-manimsh "find * | sort | grep reference/manim.animation")
# (find-manimsh "find * | sort | grep reference/manim.animation.animation.Animation")
# (find-manimfile "docs/build/html/_sources/reference/manim.animation.animation.Animation.rst.txt")
# (find-manimfile "docs/build/html/reference/manim.animation.animation.Animation.html")
# (find-manimfile "")
# (find-manimfile "README.md")
# (find-manimfile "README.md" "local installation")
# (find-manimfile "docs/source/examples.rst")
# (find-manimfile "docs/source/examples.rst" "Jupyter")
# (find-manimfile "docs/")
# (find-manimfile "docs/Makefile")
# (find-manimfile "docs/Makefile" "make help")
# (find-manimfile "docs/source/examples.rst")
# (find-manimdocrgrep "grep --color=auto -nRH --null -e git *")
# (find-manimdocrgrep "grep --color=auto -nRiH --null -e irc *")
# (find-manimdocrgrep "grep --color=auto -nRH --null -e IRC *")
# (find-manimdocrgrep "grep --color=auto -nRH --null -e poetry *")
# (find-manimdocrgrep "grep --color=auto -nRH --null -e 'poetry shell' *")
# (find-manimdocrgrep "grep --color=auto -niRH --null -e build *")
# (find-manimdocw "contributing/development")
# (find-manimdocrfile "contributing/development.rst" "poetry install")
# (find-manimdocrfile "contributing/development.rst" "poetry shell")
# (find-es "python" "poetry")
# (find-fline "/home/edrx/usrc/manim/docs/source/examples.rst")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/manim/
cd      ~/usrc/
git clone https://github.com/ManimCommunity/manim
cd      ~/usrc/manim/

poetry install

cd      ~/usrc/manim/docs/
pip3 install -r     requirements.txt
pip3 install -r rtd-requirements.txt
make
poetry shell
  make html
  exit

   |& tee omh




# https://www.3blue1brown.com/faq#manim
# https://github.com/3b1b/manim
# https://github.com/ManimCommunity/manim
# (code-c-d "manim" "~/usrc/manim/")
# (find-manimfile "")

# https://www.3blue1brown.com/faq#manim

https://news.ycombinator.com/item?id=28245277 Manim: An animation engine for explanatory math videos (github.com/manimcommunity)

https://reanimate.github.io/

https://www.reddit.com/r/3Blue1Brown/comments/il1bbk/3blue1brown_as_a_tutor_for_a_course_at_mit_on/



#####
#
# Could not import extension manim.utils.docbuild.manim_directive
# 2023aug01
#
#####

# «could-not-import»  (to ".could-not-import")
# https://github.com/ManimCommunity/manim/issues/3309
# https://github.com/ManimCommunity/manim/issues/3309#issuecomment-1659537415





#####
#
# docs
# 2023jul31
#
#####

# «docs»  (to ".docs")
# (find-angg ".emacs" "ee-rstdoc-:manim")
# https://docs.manim.community/
# (find-manimsh "find * | sort | grep rst")
# (find-manimsh "find * | sort | grep rst | grep examples")
# https://docs.manim.community/en/stable/examples.html
# /home/edrx/usrc/manim/docs/source/examples.rst
# (find-manimdoc  "examples")
# (find-manimdocw "examples")
# (find-manimdocr "examples")
# (find-manimdoc  "installation")
# (find-manimdocw "installation")
# (find-manimdocr "installation")

# (find-manimsh "find * | sort | grep reference/manim.animation.animation.Animation")

docs/build/doctrees/reference/manim.animation.animation.Animation.doctree
docs/build/html/_sources/reference/manim.animation.animation.Animation.rst.txt
docs/build/html/reference/manim.animation.animation.Animation.html
docs/i18n/gettext/reference/manim.animation.animation.Animation.pot
docs/source/reference/manim.animation.animation.Animation.rst

https://stackoverflow.com/questions/67720634/matplotlib-does-not-find-basic-fonts



#####
#
# jovane-install
# 2021oct25
#
#####

# «jovane-install»  (to ".jovane-install")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# https://docs.manim.community/en/stable/installation/versions.html
# https://pypi.org/project/manim/
pip3 install manim

manim -ql -p myfile.py MyScene



#####
#
# jovane1
# 2021oct25
#
#####

# «jovane1»  (to ".jovane1")
# (find-fline "~/MANIM/jovane1.py")


https://news.ycombinator.com/item?id=35714228 Lessons by 3blue1brown (3blue1brown.com)
https://www.3blue1brown.com/topics/calculus
https://3blue1brown.substack.com/p/written-versions-of-the-calculus
https://www.3blue1brown.com/lessons/essence-of-calculus
https://www.3blue1brown.com/lessons/chain-rule-and-product-rule
https://www.3blue1brown.com/lessons/implicit-differentiation





#  Local Variables:
#  coding:               utf-8-unix
#  End:
