#######
#
# E-scripts on Markdown.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/markdown.e>
#           or at <http://angg.twu.net/e/markdown.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.pandoc»		(to "pandoc")
# «.dednat6-baez»	(to "dednat6-baez")
# «.markdown-mode»	(to "markdown-mode")
# «.markdown-export»	(to "markdown-export")
# «.quickref»		(to "quickref")



# (find-es "lua5" "lua-discount")

# (find-status   "libmarkdown2")
# (find-vldifile "libmarkdown2.list")
# (find-udfile   "libmarkdown2/")


2015oct18 or 2015oct19, lua-l:
pandoc -i -t beamer -V theme:Warsaw a-modern-lua-library.md -o a-modern-lua-library.pdf
pandoc -i -t beamer -V theme:Warsaw cqueues.md -o cqueues.pdf

# (find-epackages "\n  markdown-mode " t)
# (find-epackage 'markdown-mode)

https://en.wikipedia.org/wiki/Markdown
https://github.com/adam-p/markdown-here/wiki/Markdown-Cheatsheet

# (find-eev "README.md")




#####
#
# pandoc
# 2019may18
#
#####

# «pandoc» (to ".pandoc")
# (find-es "pandoc")
# (find-zsh "installeddebs | sort | grep pandoc")
# (find-zsh "availabledebs | sort | grep pandoc")
# (find-status   "pandoc")
# (find-vldifile "pandoc.list")
# (find-udfile   "pandoc/")
# (find-udfile   "pandoc/README.gz")
# (find-udfile   "pandoc/README.gz" "which languages are supported")
# (find-sh "pandoc --version")
# (find-sh "pandoc --version" "highlighting-kate")
# (find-sh "pandoc --version" "latex")
# (find-status   "pandoc-data")
# (find-vldifile "pandoc-data.list")
# (find-udfile   "pandoc-data/")

# (find-zsh "installeddebs | sort | grep pandoc")
# (find-zsh "availabledebs | sort | grep pandoc")
# https://pandoc.org/demos.html

# (find-man "1 pandoc")
# (find-man "1 pandoc" "--highlight-style=STYLE")
# (find-man "1 pandoc" "\nSYNTAX HIGHLIGHTING")

# (find-zsh "installeddebs | sort | grep kate")
# (find-zsh "availabledebs | sort | grep kate")


apti pandoc

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)




#####
#
# A post about dednat6 for John Baez's blog
# 2019sep29
#
#####

# «dednat6-baez» (to ".dednat6-baez")
# https://mail.google.com/mail/ca/u/0/#search/baez/QgrcJHsBqKldwMtLvRrFrDDbQdGKkFcWTqv
# https://golem.ph.utexas.edu/category/
# (find-fline "~/MARKDOWN/")
# (find-fline "~/MARKDOWN/lorand_blog_post.txt")
# https://golem.ph.utexas.edu/category/2018/02/hypergraph_categories_of_cospa.html
# http://math.ucr.edu/home/baez/mathematical/ACT2018/lorand/hypergraph_comp.png
# (find-sh "grep png ~/MARKDOWN/lorand_blog_post.txt")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/md/")
rm -Rv /tmp/md/
mkdir  /tmp/md/
cd     /tmp/md/
cp -iv ~/MARKDOWN/lorand_blog_post.txt .

pandoc lorand_blog_post.txt -o lo.html

# (defun c () (interactive) (find-sh "cd ~/MARKDOWN/ && pandoc d.md -o d.html"))
# (defun e () (interactive) (find-angg "MARKDOWN/d.md"))
# (defun d () (interactive) (brg "file:///home/edrx/MARKDOWN/d.html"))

# (find-sh0 "cp -v ~/MARKDOWN/d.md /tmp/")



Hi John,

sorry for taking ages to prepare the blog post... I was working
obsessively on a Free Software project that I've had for years
("eev"), and that I felt that working on it and teaching it to
students would be the best things that I could do against the
Bolsonaro government and its fake news...

Anyway, here goes a _first version_ of the blog post. I still have to
reread it tomorrow and to try to make the text more fluent... but is
it _technically_ ok? I used pandoc to compile it, like this:

  pandoc d.md -o d.html

but it didn't add syntax highlighting to the latex blocks, even though
"pandoc --version" said:

  pandoc 1.17.2
  Compiled with texmath 0.8.6.7, highlighting-kate 0.6.3.
  Syntax highlighting is supported for the following languages:
      abc, actionscript, ada, agda, apache, asn1, asp, awk, bash,
      bibtex, boo, c, changelog, clojure, cmake, coffee, coldfusion,
      commonlisp, cpp, cs, css, curry, d, diff, djangotemplate,
      dockerfile, dot, doxygen, doxygenlua, dtd, eiffel, elixir,
      email, erlang, fasm, fortran, fsharp, gcc, glsl, gnuassembler,
      go, hamlet, haskell, haxe, html, idris, ini, isocpp, java,
      javadoc, javascript, json, jsp, julia, kotlin, latex, lex,
      lilypond, literatecurry, literatehaskell, llvm, lua, m4,
      makefile, mandoc, markdown, mathematica, matlab, maxima,
      mediawiki, metafont, mips, modelines, modula2, modula3,
      monobasic, nasm, noweb, objectivec, objectivecpp, ocaml, octave,
      opencl, pascal, perl, php, pike, postscript, prolog, pure,
      python, r, relaxng, relaxngcompact, rest, rhtml, roff, ruby,
      rust, scala, scheme, sci, sed, sgml, sql, sqlmysql,
      sqlpostgresql, tcl, tcsh, texinfo, verilog, vhdl, xml, xorg,
      xslt, xul, yacc, yaml, zsh
  Default user data directory: /home/edrx/.pandoc
  Copyright (C) 2006-2016 John MacFarlane
  Web:  http://pandoc.org
  This is free software; see the source for copying conditions.
  There is no warranty, not even for merchantability or fitness
  for a particular purpose.

Should I use another program to convert from markdown to HTML for
tests? Which one?

Cheers, thanks in advance, etc etc,
  Eduardo Ochs
  http://angg.twu.net/dednat6.html
  http://angg.twu.net/math-b.html
  http://angg.twu.net/#eev






#####
#
# markdown-mode
# 2019sep29
#
#####

# «markdown-mode» (to ".markdown-mode")
# (find-epackage-links 'markdown-mode "markdownmode" t)
# (find-epackage       'markdown-mode)
# (code-c-d "markdownmode" "~/.emacs.d/elpa/markdown-mode-20240107.831/")
# (find-markdownmodefile "")
# https://jblevins.org/projects/markdown-mode/
git clone https://github.com/jrblevin/markdown-mode.git

# (code-c-d "markdownmode" "~/usrc/markdown-mode/")
# (find-markdownmodefile "")

# (find-elocus-links "C-c C-o" 'markdown-mode-map)
# (find-efunctiondescr  'markdown-follow-thing-at-point)
# (find-efunction       'markdown-follow-thing-at-point)



# (find-es "emacs" "melpa-stable")
# (find-epackages "\n  markdown-mode ")
# (find-epackage-links 'markdown-mode)
# (find-epackage 'markdown-mode)
# (find-elpafile "markdown-mode-readme.txt")
# (find-elpafile "markdown-mode-20190802.2215/")
# http://melpa.org/#/markdown-mode
# https://jblevins.org/projects/markdown-mode/

# Interesting but unrelated:
# https://golem.ph.utexas.edu/category/2019/09/the_narratives_category_theori.html



#####
#
# markdown-export
# 2024mar09
#
#####

# «markdown-export»  (to ".markdown-export")
# (find-elocus-links "C-c C-c e" 'markdown-mode-map)
# (find-ekeymapdescr     markdown-mode-map   "C-c C-c e" "markdown-export")
# (find-hkeymap-links   'markdown-mode-map 2 "C-c C-c e" "markdown-export")
# (find-efunction-links 'markdown-export)
# (find-efunctiondescr  'markdown-export)
# (find-efunction       'markdown-export)
# (find-evariable 'markdown-mode-command-map)
# (find-evariable 'markdown-mode-command-map "(make-keymap (markdown--command-map-prompt))")
# (find-evariable 'markdown-mode-command-map "markdown-export")
# (find-evariable 'markdown-mode-map)
# (find-evariable 'markdown-mode-map "C-c C-c")
# (find-evariable 'markdown-mode-map "C-c C-c" "markdown-mode-command-map")

# (find-efunction 'markdown--command-map-prompt)
# (find-estring   (markdown--command-map-prompt))




#####
#
# quickref
# 2019sep29
#
#####

# «quickref» (to ".quickref")
# https://en.support.wordpress.com/markdown-quick-reference/
# https://github.com/adam-p/markdown-here/wiki/Markdown-Cheatsheet
# https://github.com/adam-p/markdown-here/wiki/Markdown-Here-Cheatsheet
# https://help.github.com/en/categories/writing-on-github
# https://www.markdownguide.org/cheat-sheet/
# https://www.markdownguide.org/basic-syntax
# https://www.markdownguide.org/extended-syntax



https://news.ycombinator.com/item?id=34501901 Marp: Markdown Presentation Ecosystem (marp.app)
https://news.ycombinator.com/item?id=36528984 MdBook – A command line tool to create books with Markdown (rust-lang.github.io)
https://www.taipy.io/posts/augmenting-the-markdown-language-for-great-python-graphical-interfaces
https://news.ycombinator.com/item?id=39076908 Augmenting the Markdown Language for Great Python Graphical Interfaces (taipy.io)





#  Local Variables:
#  coding:               utf-8-unix
#  End:
