#######
#
# E-scripts on the Mate desktop.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/mate.e>
#           or at <http://angg.twu.net/e/mate.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.adduser»			(to "adduser")
# «.config-dir»			(to "config-dir")
# «.menu»			(to "menu")
# «.mate-session-manager»	(to "mate-session-manager")
# «.mate-panel»			(to "mate-panel")
# «.caja»			(to "caja")
# «.caja-google-drive»		(to "caja-google-drive")
# «.atril»			(to "atril")
# «.irc»			(to "irc")
# «.workspaces»			(to "workspaces")
# «.save-screenshot»		(to "save-screenshot")
# «.mate-screensaver»		(to "mate-screensaver")
# «.background»			(to "background")
# «.caja-desktop»		(to "caja-desktop")
# «.network-menu»		(to "network-menu")
# «.notification-applet»	(to "notification-applet")
# «.canberra-gtk-module»	(to "canberra-gtk-module")
# «.onboard»			(to "onboard")
# «.marco»			(to "marco")
# «.brightness»			(to "brightness")
# «.indicator-applet-complete»	(to "indicator-applet-complete")






# https://en.wikipedia.org/wiki/MATE_(software)
# https://mate-desktop.org/
# (find-zsh "installeddebs | sort | grep mate")
# (find-zsh "availabledebs | sort | grep mate")





#####
#
# adduser
# 2018nov03
#
#####

# «adduser» (to ".adduser")

# (find-sh "locate -i adduser")
# (find-fline "/home/")
# (find-fline "/home/edrx2/")
# (find-asrootfile "/home/edrx2/")

# (find-sh "find /home/edrx2/ | sort")

# (find-sh "find /usr | grep -i adduser")
# (find-sh "find /usr | grep -i bash_logout")
# (find-man "8 adduser")
# (find-man "5 adduser.conf")
# (find-fline "/usr/share/doc/adduser/examples/adduser.local.conf.examples/skel/dot.bash_logout")

# (find-status   "adduser")
# (find-vldifile "adduser.list")
# (find-udfile   "adduser/")
# (find-fline "/usr/share/adduser/adduser.conf")

[Trisquel] > System > Administration > Users and Groups




#####
#
# The ~/.config/ directory
# 2018nov03
#
#####

# «config-dir» (to ".config-dir")
# (find-fline "~/.config/" "mate")
# (find-fline "~/.config/mate/")
# (find-fline "~/.config/mate-menu/")
# (find-fline "~/.config/mate-session/")

# (find-fline "~/.config/user-dirs.dirs")




#####
#
# menu
# 2018nov03
#
#####

# «menu» (to ".menu")
# (find-status   "mate-menu")
# (find-vldifile "mate-menu.list")
# (find-udfile   "mate-menu/")
# (find-status   "mate-menus")
# (find-vldifile "mate-menus.list")
# (find-udfile   "mate-menus/")



#####
#
# mate-session-manager
# 2018nov14
#
#####

# «mate-session-manager» (to ".mate-session-manager")
# (find-status   "mate-session-manager")
# (find-vldifile "mate-session-manager.list")
# (find-udfile   "mate-session-manager/")

# (find-man "1 mate-wm")
# (find-man "1 mate-session-save")
# (find-man "1 mate-session-properties")
# (find-man "1 mate-session")
# (find-man "1 mate-session-inhibit")
# (find-fline "/etc/X11/Xsession.d/55mate-session_materc")

# (find-vldifile "mate-session-manager.list" "mate-wm")
# https://github.com/mate-desktop/mate-session-manager

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/mate-session-manager/
cd      ~/usrc/
git clone https://github.com/mate-desktop/mate-session-manager
cd      ~/usrc/mate-session-manager/
git pull

git branch --list -a
git for-each-ref
PAGER=cat git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/mate-session-manager/")
# (find-gitk  "~/usrc/mate-session-manager/")

# (code-c-d "matesessionm" "~/usrc/mate-session-manager/")
# (find-matesessionmfile "")



#####
#
# mate-panel
# 2019jan10
#
#####

# «mate-panel» (to ".mate-panel")
# (find-status   "mate-panel")
# (find-vldifile "mate-panel.list")
# (find-udfile   "mate-panel/")
# (find-man "1 mate-desktop-item-edit")
# (find-man "1 mate-panel-test-applets")
# (find-man "1 mate-panel")
# http://github.com/mate-desktop/mate-panel/issues

properties -> show arrows
hide




#####
#
# caja
# 2018nov27
#
#####

# «caja» (to ".caja")
# (find-man "1 caja")
# (find-zsh "installeddebs | sort | grep caja")

# (find-status   "caja")
# (find-vldifile "caja.list")
# (find-udfile   "caja/")
# (find-status   "caja-actions")
# (find-vldifile "caja-actions.list")
# (find-udfile   "caja-actions/")
# (find-status   "caja-actions-common")
# (find-vldifile "caja-actions-common.list")
# (find-udfile   "caja-actions-common/")
# (find-status   "caja-common")
# (find-vldifile "caja-common.list")
# (find-udfile   "caja-common/")
# (find-status   "caja-extensions-common")
# (find-vldifile "caja-extensions-common.list")
# (find-udfile   "caja-extensions-common/")
# (find-status   "caja-open-terminal")
# (find-vldifile "caja-open-terminal.list")
# (find-udfile   "caja-open-terminal/")
# (find-status   "caja-sendto")
# (find-vldifile "caja-sendto.list")
# (find-udfile   "caja-sendto/")
# (find-status   "caja-share")
# (find-vldifile "caja-share.list")
# (find-udfile   "caja-share/")
# (find-status   "caja-wallpaper")
# (find-vldifile "caja-wallpaper.list")
# (find-udfile   "caja-wallpaper/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
caja --browser "mtp://[usb:002,008]/Phone/Pictures/Quadros-2018.2"



#####
#
# caja-google-drive
# 2018dec04
#
#####

# «caja-google-drive» (to ".caja-google-drive")
# https://www.linuxuprising.com/2018/07/mounting-google-drive-on-xfce-or-mate.html




#####
#
# atril
# 2018dec03
#
#####

# «atril» (to ".atril")
# (find-es "ps" "evince")
# https://github.com/mate-desktop/atril
# (find-zsh "installeddebs | sort | grep atril")
# (find-zsh "availabledebs | sort | grep atril")
# (find-status   "atril")
# (find-vldifile "atril.list")
# (find-udfile   "atril/")
# (find-status   "atril-common")
# (find-vldifile "atril-common.list")
# (find-udfile   "atril-common/")
# (find-fline "/usr/share/gtk-doc/html/atril/")


# (find-man "1 atril-previewer")
# (find-man "1 atril-thumbnailer")
# (find-man "1 atril")
# (find-man "1 atril" "-p, --page-label=PAGE")
# (find-man "1 atril" "-i, --page-index=NUMBER")
# (find-man "1 atril" "-f, --fullscreen")
# (find-man "1 atril" "-s, --presentation")
# (find-man "1 atril" "-w, --preview")
# (find-man "1 atril" "--help")
# (find-sh "atril --help")
# (find-sh "atril --help-all")

(vgs)
(find-pdf-page   "~/LATEX/2018vichy-vgms-slides.pdf")
(find-efunction 'find-xpdfpage)

(find-bgprocess "atril         ~/LATEX/2018vichy-vgms-slides.pdf")
(find-bgprocess "atril      -s ~/LATEX/2018vichy-vgms-slides.pdf")
(find-bgprocess "atril      -f ~/LATEX/2018vichy-vgms-slides.pdf")
(find-bgprocess "atril      -w ~/LATEX/2018vichy-vgms-slides.pdf")
(find-bgprocess "atril -i 5    ~/LATEX/2018vichy-vgms-slides.pdf")
(find-bgprocess "atril -i 5 -s ~/LATEX/2018vichy-vgms-slides.pdf")
(find-bgprocess "atril -i 5 -f ~/LATEX/2018vichy-vgms-slides.pdf")
(find-bgprocess "atril -i 5 -w ~/LATEX/2018vichy-vgms-slides.pdf")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
atril --preview ~/LATEX/2018vichy-vgms-slides.pdf
atril -w ~/LATEX/2018vichy-vgms-slides.pdf
atril -i 5 -w ~/LATEX/2018vichy-vgms-slides.pdf

apti topmenu-gtk2
apti topmenu-gtk3





#####
#
# The Mate irc channel
# 2018dec04
#
#####

# «irc» (to ".irc")
# https://mate-desktop.org/community/
# #mate @ irc.freenode.net
# http://wiki.mate-desktop.org/irc
# (find-es "grub" "libreboot-irc")

(defun g2 () (interactive) (find-rcirc-buffer-2a "irc.freenode.net" "#eev #mate" nil "#mate"))
(defun g3 () (interactive) (find-rcirc-buffer-3a "irc.freenode.net" "#eev #mate" nil "#mate"))




#####
#
# workspaces
# 2018dec20
#
#####

# «workspaces» (to ".workspaces")
# https://learnubuntumate.weebly.com/multiple-workspaces.html




#####
#
# Saving screenshots
# 2019jan05
#
#####

# «save-screenshot» (to ".save-screenshot")
# Keys: Print Screen:     Takes a screenshot of the entire screen.
#       Alt+Print Screen: Takes a screenshot of the window which is active.
#          "Druck"

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xwininfo -all
# xwininfo: Window id: 0x4800010 "Desktop User Guide"


# (find-es "x" "xlsclients")
# (find-sh "xlsclients")
# (find-sh "xlsclients -l")
# (find-sh "xlsclients -l -a")
# (find-sh "xlsclients" "mate-screenshot")

# (find-sh "apt-file search mate-screenshot")

mate-utils
mate-utils-common

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
laf /usr/share/app-install/desktop/mate-utils:mate-screenshot.desktop

app-install-data: /usr/share/app-install/desktop/mate-utils:mate-screenshot.desktop
mate-utils: /usr/bin/mate-screenshot
mate-utils: /usr/share/applications/mate-screenshot.desktop
mate-utils-common: /usr/share/appdata/mate-screenshot.appdata.xml
mate-utils-common: /usr/share/man/man1/mate-screenshot.1.gz
mate-utils-common: /usr/share/mate-screenshot/mate-screenshot.ui





#####
#
# mate-screensaver
# 2019aug20
#
#####

# «mate-screensaver» (to ".mate-screensaver")
# (find-debpkg-links "mate-screensaver")
# (find-status   "mate-screensaver")
# (find-vldifile "mate-screensaver.list")
# (find-udfile   "mate-screensaver/")
# (find-status   "mate-screensaver-common")
# (find-vldifile "mate-screensaver-common.list")
# (find-udfile   "mate-screensaver-common/")
# (find-man "1 mate-screensaver-command")
# (find-man "1 mate-screensaver-preferences")
# (find-man "1 mate-screensaver")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mate-screensaver-preferences



#####
#
# background
# 2019jan10
#
#####

# «background» (to ".background")
# (find-angg ".zshrc" "prep-X")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xsetroot -solid black

xwininfo says that what looks like the root window is "x-caja-desktop"




#####
#
# caja-desktop
# 2019jan10
#
#####

# «caja-desktop» (to ".caja-desktop")
# (find-zsh "installeddebs | sort | grep caja-desktop")
# (find-zsh "availabledebs | sort | grep caja-desktop")

https://forums.linuxmint.com/viewtopic.php?t=148282
https://www.reddit.com/r/archlinux/comments/32b0nz/caja_without_xcajadesktop/

Yes, you need to edit the dconf entry. It should be under
/org/mate/caja/desktop or somewhere near ther

it's actually org/mate/desktop/backgroud/show-desktop-icons and
draw-background


dconf

# (find-zsh "installeddebs | sort | grep dconf")
# (find-zsh "availabledebs | sort | grep dconf")

dconf-cli_0.24.0-2.deb
dconf-editor_3.18.2-1.deb
dconf-gsettings-backend_0.24.0-2.deb
dconf-service_0.24.0-2.deb
dconf-tools_0.24.0-2.deb
libdconf1_0.24.0-2.deb

# (find-status   "dconf-cli")
# (find-vldifile "dconf-cli.list")
# (find-udfile   "dconf-cli/")
# (find-status   "dconf-editor")
# (find-vldifile "dconf-editor.list")
# (find-udfile   "dconf-editor/")
# (find-man "1 dconf-editor")
# (find-status   "dconf-gsettings-backend")
# (find-vldifile "dconf-gsettings-backend.list")
# (find-udfile   "dconf-gsettings-backend/")
# (find-status   "dconf-service")
# (find-vldifile "dconf-service.list")
# (find-udfile   "dconf-service/")
# (find-status   "dconf-tools")
# (find-vldifile "dconf-tools.list")
# (find-udfile   "dconf-tools/")
# (find-status   "libdconf1")
# (find-vldifile "libdconf1.list")
# (find-udfile   "libdconf1/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
dconf-editor

# (find-fline "/usr/share/backgrounds/flidas.jpg")





#####
#
# Where is the network menu in Mate
# 2019jan11
#
#####

# «network-menu» (to ".network-menu")
# https://ubuntu-mate.community/t/what-network-menu/13119

Alt-F2
nm-applet




#####
#
# The notification applet
# 2019jan12
#
#####

# «notification-applet» (to ".notification-applet")
# https://github.com/mate-desktop/mate-notification-daemon
# (find-status   "mate-notification-daemon")
# (find-vldifile "mate-notification-daemon.list")
# (find-udfile   "mate-notification-daemon/")

Is this the same as the "notification area"?
The notification area has the network thing...




#####
#
# The canberra-gtk-module error
# 2019jan12
#
#####

# «canberra-gtk-module» (to ".canberra-gtk-module")
# (find-zsh "installeddebs | sort | grep canberra-gtk")
# (find-zsh "availabledebs | sort | grep canberra-gtk")
# (find-status   "libcanberra-gtk-module")
# (find-vldifile "libcanberra-gtk-module:amd64.list")
# (find-udfile   "libcanberra-gtk-module/")
# http://0pointer.de/lennart/projects/libcanberra/
# https://askubuntu.com/questions/342202/failed-to-load-module-canberra-gtk-module-but-already-installed

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
nm-applet
# Gtk-Message: Failed to load module "canberra-gtk-module"

apti libcanberra-gtk-module
apti libcanberra-gtk3-module





#####
#
# onboard
# 2019jan28
#
#####

# «onboard» (to ".onboard")
# (find-status   "onboard")
# (find-vldifile "onboard.list")
# (find-udfile   "onboard/")
# (find-vldifile "onboard.postinst")
# (find-vldifile "onboard.prerm")
# (find-vldifile "onboard.postrm")
# (find-vldifile "onboard.conffiles")
# (find-vldifile "onboard.md5sums")
# https://launchpad.net/onboard




#####
#
# marco
# 2019mar22
#
#####

# «marco» (to ".marco")
# (find-man "1 marco")
# (find-zsh "installeddebs | sort | grep marco")
# (find-debpkg-links "marco")
# (find-status   "marco")
# (find-vldifile "marco.list")
# (find-udfile   "marco/")
# (find-status   "marco-common")
# (find-vldifile "marco-common.list")
# (find-udfile   "marco-common/")
# (find-status   "libmarco-private0")
# (find-vldifile "libmarco-private0.list")
# (find-udfile   "libmarco-private0/")




#####
#
# brightness
# 2019mar22
#
#####

# «brightness» (to ".brightness")
# (find-es "hardware" "T400-brightness")
Trisquel -> System -> control centel -> power management -> display




#####
#
# indicator-applet-complete
# 2019mar24
#
#####

# «indicator-applet-complete» (to ".indicator-applet-complete")
# (find-status   "indicator-applet-complete")
# (find-vldifile "indicator-applet-complete.list")
# (find-udfile   "indicator-applet-complete/")

https://packages.ubuntu.com/trusty/gnome/indicator-applet-complete

# (find-zsh "installeddebs | sort | grep indicator")
# (find-zsh "installeddebs | sort | grep indicator-applet-complete")
# (find-zsh "availabledebs | sort | grep indicator-applet-complete")

# (find-status   "indicator-network")
# (find-vldifile "indicator-network.list")
# (find-udfile   "indicator-network/")

https://launchpad.net/indicator-network







mate-wm




#  Local Variables:
#  coding:               utf-8-unix
#  End:
