#######
#
# E-scripts on mp3 and oggvorbis
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/mp3.e>
#           or at <http://angg.twu.net/e/mp3.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.mp3info»		(to "mp3info")
# «.lame-old»  		(to "lame-old")
# «.lame»  		(to "lame")
# «.lame-deb»		(to "lame-deb")
# «.optimizing-oggenc»	(to "optimizing-oggenc")
# «.id3tool»		(to "id3tool")
# «.id3v2»		(to "id3v2")
# «.mp3splt»		(to "mp3splt")
# «.flac2all»		(to "flac2all")
# «.split-flac»		(to "split-flac")




#####
#
# mp3 tags / info
# 2012jun22
#
#####

# «mp3info»  (to ".mp3info")
# (find-zsh "availabledebs | sort | grep mp3")
# http://en.wikipedia.org/wiki/MP3
# http://en.wikipedia.org/wiki/ID3
# http://en.wikipedia.org/wiki/Tag_editor
# (find-status   "mp3info")
# (find-vldifile "mp3info.list")
# (find-udfile   "mp3info/")




#####
#
# putting more info in the mp3s
#
#####

# (find-fline "/usr/doc/freeamp-doc/")
# (find-fline "/usr/doc/id3ed/")
# (find-fline "/usr/doc/mp3blaster/")
# (find-fline "/usr/doc/mp3info/")
# (find-vldifile "freeamp-doc.list")
# (find-vldifile "id3ed.list")
# (find-vldifile "mp3blaster.list")
# (find-vldifile "mp3info.list")

# (find-fline "/usr/doc/ncdt/")
# (find-vldifile "ncdt.list")

cd /hdc6/mp3.com/
mp3info *.mp3
#
mp3info devadasi_kif_mix1.mp3

# (find-man "mp3info")
# (find-sh  "mp3info -h")
# (find-fline "/usr/doc/mp3info/")
# (find-fline "/usr/doc/mp3info/README.gz")

cd /mp3.com/
for i in 0 1 2 3 4 5 6; do
  echo
  echo mp3info -F $i tell_me_how1.mp3
       mp3info -F $i tell_me_how1.mp3
done


rm -Rv /hdc6/tmp/Low/
mkdir  /hdc6/tmp/Low/
cd /mp3s/MINE/Low/
cp -iv {1,2,b1}_* /hdc6/tmp/Low/
cd /hdc6/tmp/Low/

mp3info -a 'David Bowie' -l 'Low' -y '1977' -G 'Avantgarde' *
mp3info -F 2 *

for i in 0 1 2 3 4 5 6; do
  echo
  echo mp3info -F $i 1*.mp3
       mp3info -F $i 1*.mp3
done


mp3info -p0
mp3info -p1
mp3info -p2




#####
#
# bladeenc-0.92
# 2000jun02
#
#####

# «bladeenc»

# Last version?
lynx http://bladeenc.mp3.no/skeleton/source.html
lynx http://bladeenc.mp3.no/skeleton/sourcearchive.html

#A comment about compilation and quality:
# (code-c-d "hblenc" "$S/http/bladeenc.mp3.no/")
# (find-hblencw3 "skeleton/source.html" "md5sum")
#I think I need to do something about the quality -- there's a
#"flp, flp" sound in "Mondo Passionale", around 1:40...

# (code-c-d "blenc" "/usr/src/bladeenc-0.92.0/")
# (find-blencfile "")
# (find-blencfile "ChangeLog")
# (find-blencfile "INSTALL")
# (find-blencfile "bladeenc/system.h" "#ifndef SYSTEM")
# (find-blencfile "om")

rm -Rv /usr/src/bladeenc-0.92.0/
cd /usr/src/
tar -xvzf $S/http/bladeenc.mp3.no/source/bladeenc-0.92.0-src-stable.tar.gz
cd /usr/src/bladeenc-0.92.0/

./configure	|& tee oc
make		|& tee om


# (find-fline "~/EXPECT/ripmp3")

# Old notes:

cd ~edrx/
/usr/src/bladesrc-081/bladeenc
/usr/src/bladesrc-081/bladeenc huh.wav huh.b.mp3

cd ~edrx/
/usr/src/bladesrc-081/bladeenc down_on_the_street.wav down_on_the_street.mp3

# (eeman "renice")
renice 20 $(pidof bladeenc)




#####
#
# bladeenc-0.93.7
# 2000jun20
#
#####

# «bladeenc»

# Last version?
lynx http://bladeenc.mp3.no/skeleton/source.html
lynx http://bladeenc.mp3.no/skeleton/sourcearchive.html

#A comment about compilation and quality:
# (code-c-d "hblenc" "$S/http/bladeenc.mp3.no/")
# (find-hblencw3 "skeleton/source.html" "md5sum")
#I think I need to do something about the quality -- there's a
#"flp, flp" sound in "Mondo Passionale", around 1:40...

# (code-c-d "blenc" "/usr/src/bladeenc-0.93.7/")
# (find-blencfile "")
# (find-blencfile "ChangeLog")
# (find-blencfile "INSTALL")
# (find-blencfile "bladeenc/system.h" "#ifndef SYSTEM")
# (find-blencfile "om")

rm -Rv /usr/src/bladeenc-0.93.7/
cd /usr/src/
tar -xvzf $S/http/bladeenc.mp3.no/source/bladeenc-0.93.7-src-unstable-2.tar.gz
cd /usr/src/bladeenc-0.93.7/

./configure	|& tee oc
# make		|& tee om
make CFLAGS=	|& tee om

# (find-fline "~/EXPECT/ripmp3")





#####
#
# gnome-napster-0.4.1
# 2000jun02
#
#####

# (find-status "gnome-napster")
# (find-vldifile "gnome-napster.list")
# (find-fline "/usr/doc/gnome-napster/")




#####
#
# gnome-napster-0.6
#
#####

rm -Rv /usr/src/gnome-napster-0.6.0/
cd /usr/src/
tar -xvzf $S/http/download.sourceforge.net/gnome-napster/gnome-napster-0.6.0.tar.gz
cd /usr/src/gnome-napster-0.6.0/

# (code-c-d "gnnap" "/usr/src/gnome-napster-0.6.0/")
# (find-gnnapfile "")
# (find-gnnapfile "INSTALL")
# (find-gnnapfile "README.install")

./configure	|& tee oc
make		|& tee om
make install	|& tee omi

# (find-gnnapfile "src/gconfig.c" "upload")
# (find-gnnapfile "src/host.c" "upload")
# (find-gnnapfile "src/lnap.h" "upload")
# (find-gnnapfile "src/ui.c" "upload")




#####
#
# Tagging many files at once
#
#####

cd /mp3s/MINE/

mp3info -a 'David Bowie' -l 'Low' -y '1977' -G 'Avantgarde' *
mp3info -F 2 *

MEDICINE



























function t () {
  echo $#
  for i in $1/*; do
    if [[ $# == 4 ]]; then
      mp3info -l $2 -a $3 -y $4 $i
    else
      mp3info -l $2 -a $3 $i
    fi
  done
}

cd /mp3s/MINE/

t ANNE_CLARK            'Trilogy'                         'Anne Clark'
t DAVID_BOWIE           "Let's Dance"			  'David Bowie'                     1983
t DEPECHE_MODE          'A Broken Frame'		  'Depeche Mode'
t FRENETICAS            'Freneticas'			  'Freneticas'
t GG_ALLIN              'You Give Love a Bad Name'	  'G G Allin and the Holy Men'
t GRACE_JONES           'Nightclubbing'			  'Grace Jones'
t JOY_DIVISION          'Closer'			  'Joy Division'
t KINKS                 'Something Else by the Kinks'	  'The Kinks'
t LKJ                   "Dread Beat an'Blood"		  'Linton Kwesi Johnson'            1978
t MORCHEEBA             'Big Calm'		   	  'Morcheeba'                       1998
t NICO                  'Chelsea Girl'		   	  'Nico'                            1967
t PERE_UBU              '1975-1977'		   	  'Pere Ubu'
t PINK_FLOYD            'The Piper at the Gates of Dawn'  'Pink Floyd'
t SA_RODRIX_E_GUARABIRA	''                         	  'Sa, Rodrix e Guarabira'
t SECOS_E_MOLHADOS      'Secos & Molhados 2'		  'Secos & Molhados'
t TOM_ZE                'Com defeito de fabricacao'	  'Tom Ze'
t TROGGS                'From Nowhere the Troggs'	  'Troggs'
t T_REX                	''				  'T. Rex'
t UK_SUBS              	''				  'U.K. Subs'
t VELVET_UNDERGROUND    'The Velvet Underground and Nico' 'The Velvet Underground and Nico' 1967

t 4_track_demos             '4-Track Demos'                'P J Harvey'	       	       	1993
t Bartok_jazz               'Bartok Jazz'                  'Quinteto Tomas Improta'     1995
t Bug                       'Bug'                          'Dinosaur Jr'       	       	1988
t Bull_of_the_woods         'Bull of the Woods'            'The 13th Floor Elevators'
t Chairs_missing            'Chairs Missing'               'Wire'		        1977
t Drum                      'Drum'                         'Hugo Largo'	       	       	1988
t Dry                       'Dry'                          'P J Harvey'	       	       	1992
t Dummy                     'Dummy'                        'Portishead'	       	       	1994
t Fascination_street        'Fascination Street'           'The Cure'
t Funhouse                  'Fun House'                    'The Stooges'       	       	1970
t Interview                 'Interview'                    'Gentle Giant'      	       	1976
t Loaded                    'Loaded'                       'The Velvet Underground'    	 1970
t Low                       'Low'                          'David Bowie'		 1977
t Lust_for_life             'Lust for Life'                'Iggy Pop'
t Menininha_lobo            'Menininha Lobo'               'Menininha Lobo'              1981
t Mezzanine                 'Mezzanine'                    'Massive Attack'              1998
t Osaka76                   'Osaka 76'                     'Neil Young and Crazy Horse'	 1976
t Pink_flag                 'Pink Flag'                    'Wire'                        1977
t Porque_sim_porque_nao     'Porque sim, porque nao?'      'Luci e Lucina'		 1992
t Portishead                'Portishead'                   'Portishead'
t Radio_ethiopia            'Radio Ethiopia'               'The Patti Smith Group'     	 1976
t Recorock                  'Recorock'                     'Sueli Mesquita'
t Rid_of_me		    'Rid of Me'			   'P J Harvey'	       	       	 1993
t Rita_mitsouko             'Rita Mitsouko'                'Les Rita Mitsouko'	       	 1984
t Rock_me                   'Rock Me'                      'Bia Grabois'		 1999
t Sister_ray                'Sister Ray'                   'The Sisters of Mercy'
t Some_girls...             'Some Girls Wander by Mistake' 'The Sisters of Mercy'
t Songs_about_fucking       'Songs About Fucking'          'Big Black'
t Systeme_d                 'Systeme D'                    'Les Rita Mitsouko' 	       	 1993
t Triplex                   'Triplex'                      'Triplex'			 1999
t Twisterella               'Twisterella'                  'Ride'
t Vange                     'Vange'                        'Vange Leonel'
t Vapour_trail              'Vapour Trail'                 'Ride'      	       	       	 1991
t Vermelho                  'Vermelho'                     'Vange Leonel'		 1996
t Violent_femmes            'Violent Femmes'               'Violent Femmes'		 1982
t Wave                      'Wave'                         'The Patti Smith Group'       1979
t White_light_white_heat    'White Light/White Heat'       'The Velvet Underground'	 1968
t You_re_living_all_over_me "You're Living All Over Me"    'Dinosaur Jr'       	       	 1987


Trainspotting  	       	  'Trainspotting'		 '(soundtrack)'
Velvet_goldmine	       	  'Velvet Goldmine'		 '(soundtrack)'



#####
#
# lame (potato)
# 2000oct22
#
#####

# «lame-old»  (to ".lame-old")

pdsc $S/http/www.ime.usp.br/~rbrito/debian/lame_3.85beta-0.0.dsc
cd /usr/src/lame-3.85beta/
debian/rules binary	|& tee odrb

dpkg -i /usr/src/lame_3.85beta-0.0_i386.deb

# (find-status "lame")
# (find-vldifile "lame.list")
# (find-fline "/usr/doc/lame/")
# (eeman "lame")

cd /usr/share/xemacs21/packages/etc/sounds/
for i in *.wav; do echo $i; bplay $i; done

cd /tmp/
lame -b 160kpbs -h intro_i.wav intro_i.160.mp3

cd /tmp/
lame            -h intro_i.wav intro_i.128.mp3

BLADEENC="lame -b 160kpbs -h" \
  ripmp3 BELLE_AND_SEBASTIAN '
    1 it_could_have_been_a_brilliant_career
  '



#####
#
# lame-398-2
# 2009jan11
#
#####

# http://ufpr.dl.sourceforge.net/sourceforge/lame/lame-398-2.tar.gz



#####
#
# lame-3.98.4
# 2011mar11
#
#####

# «lame»  (to ".lame")
# «lame-deb»  (to ".lame-deb")
# http://lame.sourceforge.net/
# http://lame.sourceforge.net/links.php
# (find-fline "~/tmp/" "lame-3.98.4.tar.gz")
#
rm -Rv ~/usrc/lame/
mkdir  ~/usrc/lame/
# rm -Rv ~/usrc/lame-3.98.4/
tar -C ~/usrc/lame/ -xvzf \
  ~/tmp/lame-3.98.4.tar.gz
cd     ~/usrc/lame/lame-3.98.4/

dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (code-c-d "lame" "~/usrc/lame/lame-3.98.4/")
# (find-lamefile "")
# (find-lamefile "debian/")
# (find-lamefile "debian/control" "Build-Depends:" "libsndfile1-dev")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/usrc/lame/
sudo dpkg -i *.deb

# (find-status   "lame")
# (find-vldifile "lame.list")
# (find-udfile   "lame/")
# (find-udfile   "lame/USAGE.gz")
# (find-udfile   "lame/html/")
# (find-status   "libmp3lame0")
# (find-vldifile "libmp3lame0.list")
# (find-udfile   "libmp3lame0/")
# (find-status   "libmp3lame0-dev")
# (find-vldifile "libmp3lame0-dev.list")
# (find-udfile   "libmp3lame0-dev/")

# (find-sh "lame --help")




#
rm -Rv ~/usrc/lame-398-2/
tar -C ~/usrc/ -xvzf \
  $S/http/ufpr.dl.sourceforge.net/sourceforge/lame/lame-398-2.tar.gz
cd     ~/usrc/lame-398-2/

./configure     |& tee oc
make            |& tee om

#

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -v ~/bin/lame
cd ~/usrc/lame-398-2/
cp -v frontend/lame ~/bin/

#
# (code-c-d "lame" "~/usrc/lame-398-2/")
# (find-lamefile "")
# (find-lamefile "om")
# (find-lamefile "doc/")
# (find-lamew3m  "doc/html/index.html")
# (find-lamesh "find .* * -type f | sort")
# (find-lamefile "frontend/")
# (find-sh "lame --help")





#####
#
# oggvorbis
# 2000nov10
#
#####

#
pdsc $SDEBIAN/dists/woody/main/source/sound/vorbis_1.0beta2-3.dsc
cd /usr/src/vorbis-1.0beta2/
debian/rules binary	|& tee odrb
#
cd /usr/src/
dpkg -i libvorbis-dev*.deb vorbis-tools*.deb xmms-vorbis*.deb
#

# (code-c-d "vorbis" "/usr/src/vorbis-1.0beta2/")
# (find-vorbisfile "")
# (find-vorbisfile "debian/")
# (find-vorbisfile "debian/control" "Build-Depends:")


# (find-fline "/usr/doc/libvorbis-dev/")
# (find-fline "/usr/doc/vorbis-tools/")
# (find-fline "/usr/doc/xmms-vorbis/")
# (find-status "libvorbis-dev")
# (find-status "vorbis-tools")
# (find-status "xmms-vorbis")
# (find-vldifile "libvorbis-dev.list")
# (find-vldifile "vorbis-tools.list")
# (find-vldifile "xmms-vorbis.list")

# (find-fline "/usr/doc/vorbis-tools/README")
# (find-fline "/usr/doc/vorbis-tools/examples/mp3tovorbis")
# (eeman "1 oggenc")
# (eeman "1 vorbize")
# (eeman "1 ogg123")

cd /tmp/
oggenc -m 4 -o 6_spy_in_the_cab.ogg 6_spy_in_the_cab.wav
ogg123 -d oss 6_spy_in_the_cab.ogg




#####
#
# optimizing oggenc
# 2004oct08
#
#####

# «optimizing-oggenc»  (to ".optimizing-oggenc")
# http://www.vorbis.com/files/1.0/unix/libogg-1.0.tar.gz
# http://www.vorbis.com/files/1.0/unix/libvorbis-1.0.tar.gz
# http://www.vorbis.com/files/1.0/unix/vorbis-tools-1.0.tar.gz
# (code-c-d "ogg"     "~/usrc/libogg-1.0/")
# (code-c-d "vorbis"  "~/usrc/libvorbis-1.0/")
# (code-c-d "ovtools" "~/usrc/vorbis-tools-1.0/")
# (find-oggfile "")
# (find-vorbisfile "")
# (find-ovtoolsfile "")
#
rm -Rv ~/usrc/libogg-1.0/
rm -Rv ~/usrc/libvorbis-1.0/
rm -Rv ~/usrc/vorbis-tools-1.0/

#
rm -Rv ~/usrc/libogg-1.0/
tar -C ~/usrc -xvzf $S/http/www.vorbis.com/files/1.0/unix/libogg-1.0.tar.gz
cd     ~/usrc/libogg-1.0/

# (find-node "(make)Catalogue of Rules")
# (find-node "(gcc)i386 and x86-64 Options")
export CFLAGS="-mcpu=pentium3 -march=pentium3"
./configure --prefix=$HOME/ulocal |& tee oc
make                              |& tee om
make install                      |& tee omi

#
rm -Rv ~/usrc/libvorbis-1.0/
tar -C ~/usrc -xvzf $S/http/www.vorbis.com/files/1.0/unix/libvorbis-1.0.tar.gz
cd     ~/usrc/libvorbis-1.0/

export CFLAGS="-mcpu=pentium3 -march=pentium3"
./configure --prefix=$HOME/ulocal |& tee oc
make                              |& tee om
make install                      |& tee omi

#
rm -Rv ~/usrc/vorbis-tools-1.0/
tar -C ~/usrc -xvzf \
  $S/http/www.vorbis.com/files/1.0/unix/vorbis-tools-1.0.tar.gz
cd     ~/usrc/vorbis-tools-1.0/

export CFLAGS="-mcpu=pentium3 -march=pentium3"
./configure --prefix=$HOME/ulocal |& tee oc
make                              |& tee om
make install                      |& tee om

#
ldd ~/ulocal/bin/oggenc
ldd /usr/bin/oggenc

#
cp -v /hdb2/CDs/rips/fossils/track06.cdda.wav /tmp

#
cd /tmp/
time     /usr/bin/oggenc -b 224 track06.cdda.wav -o track06.debian.ogg
time ~/ulocal/bin/oggenc -b 224 track06.cdda.wav -o track06.local.ogg

#




#####
#
# id3tool / id3v2
# 2013may22
#
#####

# «id3tool» (to ".id3tool")
# «id3v2» (to ".id3v2")

# (find-status   "id3tool")
# (find-vldifile "id3tool.list")
# (find-udfile   "id3tool/")
# (find-status   "id3v2")
# (find-vldifile "id3v2.list")
# (find-udfile   "id3v2/")

# (find-man "1 id3v2")
# (find-man "1 id3tool")

# (find-sh "id3v2 -l /sda5/torrents/Tin\\ Machine\\ I/03*.mp3")
# (find-sh "id3v2 -l /sda5/torrents/Tin\\ Machine\\ I/04*.mp3")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cp -v /sda5/torrents/Tin\ Machine\ I/04*.mp3 /tmp/04.mp3
id3v2 --USLT "$(cat /tmp/cc.txt)" /tmp/04.mp3
id3v2 -l /tmp/04.mp3

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/home/edrx/Music/Unknown Artist/Unknown Title/")
cd ~/Music/Unknown\ Artist/Unknown\ Title/
id3tool -h
laf
for i in *.ogg; do
  id3tool -r "Kristi Stassinopoulou & Stathis Kalyviotis" $i
  id3tool -a "Greekadelia" $i
  id3tool -y 2012 $i
done

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# http://www.worldmusic.net/store/item/TUG1065/
A=(
"Matia San Kai Ta Dika Sou"
"Anamesa Nissirou"
"Me Gelasan Ta Poulia"
"Halassia Mou"
"Mes Tou Aegeou Ta Nera"
"Neratzoula Fountomeni"
"Pes Mou Poia Mana"
"Kato Sta Dasia Platania"
"To Ponemeno Stithos Mou"
"Marenomai"
"Erhomai Ki Esy Koimasai"
"Rodo Tis Protanastasis"
"Rodise I Anatoli"
)
cd ~/Music/Unknown\ Artist/Unknown\ Title/
id3tool -h
laf
for i in 01 02 03 04 05 06 07 08 09 10 11 12 13; do
  N=$[$i+0]
  NAME=$A[$N]
  name=$(echo $NAME | tr ' ' _ | tr A-Z a-z)
  fname=$(ls mp3/$i*.mp3)
  id3tool -r "Kristi Stassinopoulou & Stathis Kalyviotis" $fname
  id3tool -a "Greekadelia" $fname
  id3tool -y 2012 $fname
  id3tool -t "$NAME" $fname
  id3tool -c $N $fname
  # mv -iv $i.ogg ${i}_$name.ogg
done

id3tool 01*.ogg
id3tool mp3/01*.mp3

mkdir mp3/
for i in *.ogg; do
  avconv -i $i mp3/$(basename $i .ogg).mp3
done



http://nekohako.xware.cx/id3tool/
(find-2a
  ' (find-fline "~/Music/Unknown Artist/Unknown Title/")
  ' (find-fline "~/Music/Unknown Artist/Unknown Title/mp3/")
  )




#####
#
# mp3splt
# 2013dec09
#
#####

# «mp3splt» (to ".mp3splt")

# (find-status   "mp3splt")
# (find-vldifile "mp3splt.list")
# (find-udfile   "mp3splt/")
# (find-status   "mp3splt-gtk")
# (find-vldifile "mp3splt-gtk.list")
# (find-udfile   "mp3splt-gtk/")
# (find-man "1 mp3splt")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-sh "mp3splt")
# (find-sh "locate mp3 | grep 'mp3$'")
cp -v /home/edrx/reef/tmp/2011jun10/05._matey_exterminator.mp3 /tmp/a.mp3

# (find-audio "/tmp/a.mp3")
# (find-audio "/tmp/a.mp3" "0:04")

cd /tmp/
# (find-fline "/tmp/")
mp3splt a.mp3 0.04 0.10

cd ~/audios/
mp3splt 2013dec05-rfm-orig.mp3 0.00 107.47



#####
#
# flac2all
# 2013dec10
#
#####

# «flac2all» (to ".flac2all")
# (find-angg ".zshrc" "flac2mp3")
# https://code.google.com/p/flac2all/
# -> http://ziva-vatra.com/index.php?aid=23&id=U29mdHdhcmU=
#    https://github.com/ZivaVatra/flac2all
# (find-angg "bin/flac2all")
# (find-sh "flac2all -h")

# (find-fline "/sda5/torrents/johann_sebastian_bach_-_cello_suites__fuchs_(viola)/")

# (code-c-d "lif" "/sda5/torrents/johann_sebastian_bach_-_cello_suites__fuchs_(viola)/")
# (find-liffile "")
# (find-liffile "renamed/")
# (find-liffile "mini/")
# (find-liffile "mp3s/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd "/sda5/torrents/johann_sebastian_bach_-_cello_suites__fuchs_(viola)/"
flac2all mp3 renamed/ -o mp3s/ -l -b 320
flac2all mp3 renamed/ -o mp3s/

lame

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/sda5/torrents/johann_sebastian_bach_-_cello_suites__fuchs_(viola)/")
cd            "/sda5/torrents/johann_sebastian_bach_-_cello_suites__fuchs_(viola)/"
flac2mp3 renamed/ mp3s/




# (find-sh "flac2all -h" "-l LAMEOPTS")
# (find-man "1 lame" "-b n")






#####
#
# Splitting a big FLAC file
# 2016oct18
#
#####

# «split-flac» (to ".split-flac")


# (find-zsh "acse -i flac | sort")
# (find-zsh "grep-available flac")
# (find-zsh "grep-status flac")
# (find-zsh "availabledebs | sort | grep flac")
# (find-google-links "how do i split a flac file into tracks in debian")
# http://www.google.com/search?q=how+do+i+split+a+flac+file+into+tracks+in+debian
# http://danilodellaquila.com/en/blog/how-to-split-an-audio-flac-file-using-ubuntu-linux
# https://wiki.archlinux.org/index.php/CUE_Splitting

# (find-status   "cuetools")
# (find-vldifile "cuetools.list")
# (find-udfile   "cuetools/")
# (find-status   "shntool")
# (find-vldifile "shntool.list")
# (find-udfile   "shntool/")

cuebreakpoints file.cue | shnsplit -o flac file.flac
# (find-man "1 shnsplit")
# (find-man "1 cuebreakpoints")

# (find-man "1 cuebreakpoints")
# (find-man "1 cueconvert")
# (find-man "1 cueprint")
# (find-man "1 cuetag")

# (find-man "1 shncat")
# (find-man "1 shncmp")
# (find-man "1 shnconv")
# (find-man "1 shncue")
# (find-man "1 shnfix")
# (find-man "1 shninfo")
# (find-man "1 shnjoin")
# (find-man "1 shnlen")
# (find-man "1 shnmd5")
# (find-man "1 shnpad")
# (find-man "1 shnsplit")
# (find-man "1 shnstrip")
# (find-man "1 shntool")












# (find-status   "quelcom")
# (find-vldifile "quelcom.list")
# (find-udfile   "quelcom/")
# (find-man "1 qmp3cut")
# (find-man "1 qmp3cut" "here are some examples:")




# (find-status   "mpg321")
# (find-vldifile "mpg321.list")
# (find-udfile   "mpg321/")
# (find-man "1 mpg321")
# (find-man "1 mpg321" "-w N, --wav N")

/oldfs/3/tmp/fernanda1/Hugo Largo (1) - Turtle Song.wav

cd /oldfs/3/tmp/fernanda1/
mpg321 'Hugo Largo (1) - Turtle Song.wav'

#
cd /big/hdd2/CDs/rips/old/mp3/Drum/
cp -v 5_scream_tall.mp3 /tmp/
cd /tmp/
mpg321 -w 5_scream_tall.wav 5_scream_tall.mp3

#









#  Local Variables:
#  coding:               utf-8-unix
#  End:
