#######
#
# E-scripts on sound and music (on a very wide sense)
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/music.e>
#           or at <http://angg.twu.net/e/music.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.timidity»			(to "timidity")
# «.playmidi»			(to "playmidi")
# «.csound»			(to "csound")
# «.csound-ezinefiles»		(to "csound-ezinefiles")
# «.air_on_G»			(to "air_on_G")
# «.festival»			(to "festival")
# «.festival-squeeze»		(to "festival-squeeze")
# «.denemo»			(to "denemo")
# «.scarlatti_sonatas_as_midi»	(to "scarlatti_sonatas_as_midi")
# «.sound_from_C»		(to "sound_from_C")
# «.nas»			(to "nas")
# «.aureal_vortex»		(to "aureal_vortex")
# «.disc-cover»			(to "disc-cover")
# «.xmms»			(to "xmms")
# «.puredata»			(to "puredata")
# «.compilation:hugo_largo»	(to "compilation:hugo_largo")
# «.secrets_of_the_rocks»	(to "secrets_of_the_rocks")
# «.penguinsap»			(to "penguinsap")
# «.asma»			(to "asma")
# «.bplay-deb-src»		(to "bplay-deb-src")
# «.libsndfile-deb-src»		(to "libsndfile-deb-src")
# «.flac»			(to "flac")
# «.kid3»			(to "kid3")
# «.pacpl»			(to "pacpl")
# «.cmus»			(to "cmus")
# «.projectm»			(to "projectm")
# «.audacity»			(to "audacity")
# «.noise-reduction»		(to "noise-reduction")
# «.nyquist»			(to "nyquist")
# «.ecasound»			(to "ecasound")
# «.supercollider-deb-src»	(to "supercollider-deb-src")
# «.kmetronome»			(to "kmetronome")
# «.medieval-dances»		(to "medieval-dances")
# «.snd-old»			(to "snd-old")
# «.snd»			(to "snd")
# «.byzantine-notation»		(to "byzantine-notation")
# «.scarlatti-andras-schiff»	(to "scarlatti-andras-schiff")
# «.fluid»			(to "fluid")
# «.gregorio»			(to "gregorio")
# «.maqams»			(to "maqams")
# «.terpsichore»		(to "terpsichore")

See:
  (find-es "music")
  (find-es "alsa")






#####
#
# cdda2wav
#
#####

cdda2wav -D /dev/cdrom -t 7 mlobo_7.wav
cdda2wav -D /dev/cdrom -t 8 mlobo_8.wav
cdda2wav -D /dev/cdrom -t 9 mlobo_9.wav

cd /mp3s/MINE/WAV/
anonftp ifigenia 'cd /hda1/' 'mget mlobo_?.wav' quit






#####
#
# bladeenc-081
# 99sep??
#
#####

rm -Rv /usr/src/bladesrc-081/
cd /usr/src/
tar -xvzf $S/http/home8.swipnet.se/~w-82625/encoder/source/bladeenc-081-src-stable.tar.gz
cd /usr/src/bladesrc-081/
# make	|& tee om
make CFLAGS="-O6 -malign-jumps=2 -malign-loops=2 -funroll-all-loops" \
  |& tee om




#####
#
# encoder
# 99sep??
#
#####

rm -Rv /usr/src/encoder-js/
cd /usr/src/
tar -xvzf $S/ftp/wopr.campus.luth.se/pub/mpeg_layer_3/encoder-pre2.0.tgz
cd /usr/src/encoder-js/
./configure	|& tee oc
make		|& tee om

cd ~edrx/
/usr/src/encoder-js/encode
/usr/src/encoder-js/encode huh.wav huh.e.mp3




#####
#
# timidity
# 2001jan18
#
#####

# «timidity»  (to ".timidity")
# (find-status   "timidity")
# (find-vldifile "timidity.list")
# (find-udfile   "timidity/")
# (find-udfile   "timidity/README.Debian")
# (find-status   "freepats")
# (find-vldifile "freepats.list")
# (find-udfile   "freepats/")




######
#
# Using MIDI files
# 00feb11
#
######

# (find-status "abcmidi")
# (find-vldifile "abcmidi.list")
# (find-fline "/usr/doc/abcmidi/")
#
cd /tmp/
cp -v $S/http/www.tfy.drugsense.org/jukebox/barimyst.mid .
playmidi barymist.mid
# timidity barymist.mid

#
cd /tmp/
mftext barimyst.mid
midi2abc -f barimyst.mid
#




######
#
# playmidi on potato
# 2000apr01
#
######

# «playmidi»  (to ".playmidi")

# (find-vldifile "playmidi.list")
# (find-vldifile "" "playmidi")
# (find-vldifile "playmidi.postinst")
# (find-vldifile "playmidi.postinst" "edit")
# (find-vldifile "playmidi.postinst" "CONFFILE")
# (find-fline "/usr/doc/playmidi/")

# (find-fline "/etc/playmidi/playmidi.conf")

cd $S/http/www.cs.uu.nl/~hanwen/lilypond/mutopia/E.Satie/out-www/
playmidi petite-ouverture-a-danser.midi





######
#
# MIDI on Gravis
#
######

cd /812.C/ultrapnp/mids/
playmidi -g barimyst.mid
# (find-fline "/usr/doc/HOWTO/")
# (find-vldifile "ultra-mod2.0.30.list")
# (find-vldifile "ultra-utils.list")
# (find-vldifile "ultra.list")
# (find-fline "$HAI/Packages" "Package: ultra")

# (find-fline "/usr/doc/ultra-utils/")




######
#
# 
#
######

cd /cdrom
find | grep ultra
cp -diPv $(find | grep ultra) /
pdsc /debian/main/source/sound/ultra_2.99a-devel2-1.dsc
cd /usr/src/ultra-2.99a-devel2/
debian/rules binary |& tee odrb

cd ~/HASH/
dpkg -i ultra-mod2.0.30 ultra

cd /812.C/ultrapnp/mids/
ultramidi barimyst.mid





####
#
# How should we pronounce Linux?
#
####

# (find-fline "/usr/doc/FAQ/Linux-FAQ.gz" "hear Linus himself")
cd /snarf/ftp/ftp.funet.fi/pub/Linux/PEOPLE/Linus/SillySounds/
dd if=swedish.au bs=1 skip=23000 > /dev/audio

cat swedish.au > /dev/audio
cat english.au > /dev/audio





####
#
# /dev/audio
#
####

# (find-k2file "drivers/sound/")
# (find-k2file "Documentation/devices.txt" "4 = /dev/audio")
# (find-k2file "include/linux/")
# (find-k2file "include/linux/soundcard.h")
# (find-k2file "include/linux/soundcard.h" "/dev/audio")





#####
#
# Hacking workbone
# 99jun??
#
#####

# (code-c-d "wb" "/usr/src/workbone-2.40/")

pdsc /debian/dists/slink/main/source/sound/workbone_2.40-1.dsc
cd /usr/src/workbone-2.40/
ln -s ~/C/edrxwb.c .
cat >>Makefile <<'---'

edrxwb.o: edrxwb.c workbone.h

edrxwb: edrxwb.o hardware.o
	gcc -E edrxwb.c > edrxwb.E
	$(CC) -o $@ $^ $(LDFLAGS)
---

cd /usr/src/workbone-2.40/
make CFLAGS='-g' LDFLAGS='' workbone
make CFLAGS='-g' LDFLAGS='' edrxwb

# (find-fline "~/C/edrxwb.c")

# (find-wbfile "")
# (find-wbfile "hardware.c")

# (gdb "gdb /usr/src/workbone-2.40/workbone")





######
#
# alsa
#
######

apt-get install alsa-modules alsalib alsautils

# (find-fline "/etc/init.d/alsa")
# (find-fline "/usr/sbin/alsaconfig")
# (find-fline "/usr/doc/alsa-modules/")
# (find-vldifile "alsa-modules.list")

# (find-fline "/usr/doc/alsalib/")
# (find-vldifile "alsalib.list")
# (find-fline "/usr/doc/alsautils/")
# (find-vldifile "alsautils.list")

# (code-c-d "alsad" "/usr/src/alsadriver-0.2.0-pre8/")
# (code-c-d "alsal" "/usr/src/alsalib-0.1.1/")
# (code-c-d "alsau" "/usr/src/alsautils-0.0.6/")

pdsc /debian/dists/slink/main/source/sound/alsadriver_0.2.0-pre8-3.dsc
cd /usr/src/alsadriver-0.2.0-pre8/
debian/rules binary	|& tee odrb
#
# (find-alsadfile "debian/rules")
# (find-alsadfile "cards/interwave.c")

pdsc /debian/dists/slink/main/source/sound/alsalib_0.1.1-1.dsc
cd /usr/src/alsalib-0.1.1/
#
# (find-alsalfile "")

pdsc /debian/dists/slink/main/source/sound/alsautils_0.0.6-2.dsc
cd /usr/src/alsautils-0.0.6/
#
# (find-alsaufile "")





#####
#
# wav
#
#####

apti emusic wavtools xwave bplay


# (insert-kbd-macro (make-symbol ""))
# (setq last-kbd-macro
   "# (find-vldifile \"\C-@\C-e\C-[w.list\")\C-a\C-[[B\C-m\C-[[A# (find=-\C-?\C-?-fline \"/usr/doc/\C-y/\")\C-a\C-[[B")


# (find-fline "/usr/doc/bplay/")
# (find-fline "/usr/doc/emusic/")
# (find-fline "/usr/doc/wavtools/")
# (find-fline "/usr/doc/xwave/")

# (find-vldifile "bplay.list")
# (find-vldifile "emusic.list")
# (find-vldifile "wavtools.list")
# (find-vldifile "xwave.list")

# (find-fline "$S/http/www.freshmeat.net/news/1999/")
# (find-fmfile "1999/05/20/index.html.txt")


    6958 dists/potato/main/source/sound/mp3blaster_2-0b9-1.diff.gz
     809 dists/potato/main/source/sound/mp3blaster_2-0b9-1.dsc
  183303 dists/potato/main/source/sound/mp3blaster_2-0b9.orig.tar.gz
    1297 dists/potato/main/source/sound/mp3info_0.2.16-1.diff.gz
     619 dists/potato/main/source/sound/mp3info_0.2.16-1.dsc
   42990 dists/potato/main/source/sound/mp3info_0.2.16.orig.tar.gz


psne $FDEBIAN/README.non-US

psne ftp://nonus.debian.org/pub/debian-non-US/ls-lR.gz





#####
#
# some slink mp3 programs
#
#####

pdsc $SDEBIAN/dists/slink/non-free/source/sound/mp3asm_0.01-1.dsc
debian/rules binary	|& tee odrb

pdsc $SDEBIAN/dists/slink/non-free/source/sound/mp3info_0.2.9-1.dsc
debian/rules binary	|& tee odrb

cd /usr/src/
mv *.deb .debs
apt-update





######
#
# potato freeamp
#
######

pdsc $SDEBIAN/dists/potato/main/source/sound/freeamp_1.2.0-1.dsc
cd /usr/src/freeamp-1.2.0/
debian/rules binary	|& tee odrb





#####
#
# csound-3.484 (slink)
#
#####

pdsc $SDEBIAN/dists/slink/non-free/source/sound/csound_3.484.0d-1.dsc
# (find-csoundfile "Make.Targets" 31)
patch -b -z'~' Make.Targets <<'%%%'
31c31
< 		$(CC) -shared -Wl,-soname,$(CSADYN) -o $@ $(COBJS) $(LDFLAGS) $(LIBS) -lc
---
> 		$(CC) -shared -Wl,-soname,$(CSADYN) -o $@ $(COBJS) $(LDFLAGS) -lc
%%%
debian/rules binary	|& tee odrb

cd /usr/src/
mv -v csound *.deb .debs/
apt-update

apti csound

# (code-c-d "csound" "/usr/src/csound-3.484.0d/")
# (find-csoundfile "")
# (find-csoundfile "odrb")
# (find-csoundfile "odrb" "dpkg-shlibdeps: warning")

# (find-fline "/usr/bin/dpkg-shlibdeps")
# (find-csoundfile "debian/tmp/DEBIAN/shlibs")

# (find-vldifile "csound.list")
# (find-fline "/usr/doc/csound/")

cd /usr/doc/csound/CsManual3.47b2/
cd /usr/doc/csound/tutorial/



# The "toot" examples:

rm -Rv /tmp/csoundtut/
mkdir  /tmp/csoundtut/
cd     /tmp/csoundtut/
# cp -iv /usr/doc/csound/tutorial/* .
# gzip -dv *.gz
cp -iv /usr/src/csound-3.484.0d/tutorial/* .

cd /tmp/csoundtut/
A=(1 2 3 4 5 6 7 8 9 10 11 12 13)
for i in $A; do
  csound -g -W -o $i.wav toot$i.orc toot$i.sco |& tee o$i
  echo $i.wav
  bplay $i.wav
done

# (find-fline "/usr/src/csound-3.484.0d/benchmarks/")



#####
#
# csound (sarge)
# 2005jan13
#
#####

# «csound»  (to ".csound")

# (find-status   "csound")
# (find-vldifile "csound.list")
# (find-udfile   "csound/")
# (find-status   "csound-doc")
# (find-vldifile "csound-doc.list")
# (find-udfile   "csound-doc/")

# (code-c-d "csoundman" "/usr/share/doc/csound-doc/manual/")
# (find-csoundmanfile "")
# (find-csoundmanfile "examples/a.orc")
# (find-csoundmanw3m "commandflags.html")
#
rm -Rv /tmp/csound/
mkdir  /tmp/csound/
cd     /tmp/csound/
# cp -v  /usr/share/doc/csound-doc/manual/examples/a* .
cp /usr/share/doc/csound-doc/manual/examples/* .
gunzip *.gz

#
cd /tmp/csound/
csound -d -W a.orc a.sco
bplay test.wav

#
# (find-csoundmanw3m "commandflags.html")
cd /tmp/csound/
function csplay () { csound -d -W $1 $(basename $1 .orc).sco && bplay test.wav }
for i in a*.orc; do echo $i; csplay $i; done

#




#####
#
# csound-3.53 (+ csound-doc_3.47b2)
# (very old)
#
#####

pdsc $SDEBIAN/dists/potato/non-free/source/sound/csound_3.53.0.1d-1.dsc
cd /usr/src/csound_3.53.0.1d/
debian/rules binary	|& tee odrb

pdsc $SDEBIAN/dists/potato/non-free/source/doc/csound-doc_3.47b2-1.dsc
cd /usr/src/csound-doc-3.47b2/
debian/rules binary	|& tee odrb

mv -v /usr/src/csound*.deb /usr/src/.debs/
apt-update

apti csound csound-dev csound-doc

# (find-fline "/usr/doc/csound/")
# (find-fline "/usr/doc/csound-dev/")
# (find-fline "/usr/doc/csound-doc/")
# (find-vldifile "csound.list")
# (find-vldifile "csound-dev.list")
# (find-vldifile "csound-doc.list")


# Trying to play the examples. Most are silent...
# The "toot" examples from the 3.484 distribution have disappeared!
# (find-fline "$SDEBIAN/dists/slink/non-free/source/sound/csound_3.484.0d-1.diff.gz")

# (find-fline "/usr/doc/csound/examples/")
rm -Rv /tmp/csound/csound/
mkdir -p /tmp/csound/csound/
cd /usr/doc/csound/examples/
cp -dipPvR * /tmp/csound/csound/

function cs2wav () {
  echo "\n$*:"
  time csound -g -W $*[3,-1] -o $2.wav $1 $2
  laf $2.wav
  bplay $2.wav
}

cd /tmp/csound/csound/
cat > p.sco <<'---'
f0 10
i1 1 4 100
i1 10 3 150
i1 20 2 400
---

cs2wav args.orc p.sco
cs2wav control.orc p.sco
cs2wav icall.orc p.sco
cs2wav kargs.orc p.sco
cs2wav micall.orc p.sco
cs2wav return.orc p.sco

cs2wav args.{orc,sco}
cs2wav control.{orc,sco}
cs2wav icall.{orc,sco}
cs2wav kargs.{orc,sco}
cs2wav micall.{orc,sco}
cs2wav return.{orc,sco}

# Benchmarks (in the 3.484 source!)
cd /usr/src/csound-3.484.0d/benchmarks/
cs2wav bach.{orc,sco}
cs2wav guitar.{orc,sco}
cs2wav james.{orc,sco}
cs2wav risset1.{orc,sco}






#####
#
# csound - playing the Ezine files
# 99oct24
#
#####

# «csound-ezinefiles»  (to ".csound-ezinefiles")
# (find-es "music" "csound")
cd $S/http/www.werewolf.net/~hljmm/Ezine/
find * | egrep '(orc|sco|srt)$' |& tee ~/o

rm -Rv /tmp/csound/
mkdir /tmp/csound/
cd $S/http/www.werewolf.net/~hljmm/Ezine/
for i in $(find * | egrep '(orc|sco|srt)$'); do
  cp -Pv $i /tmp/csound/
  tr -d \\r < $i > /tmp/csound/$i
done

function cs2wav () {
  echo "\n$*:"
  time csound -g -W $*[3,-1] -o $2.wav $1 $2
  laf $2.wav
  bplay $2.wav
}

cd /tmp/csound/
cs2wav Spring1999/beginner/bgoscil.{orc,sco}
cs2wav Spring1999/synthesis/parosc.{orc,sco}
cs2wav Spring1999/processing/tokbox.{orc,sco}
cs2wav Spring1999/within/depletion.{orc,sco}
cs2wav Winter1999/beginner/myfile.{orc,sco}
cs2wav beginners/envelop.{orc,sco}
cs2wav Winter1999/processing/{tanh.orc,tanh1.sco}
cs2wav Winter1999/processing/{tanh.orc,tanh2.sco}
cs2wav processing/delay.{orc,sco}

# This one takes almost four minutes to generate.
cs2wav Winter1999/synthesis/ca.{orc,sco}

# This one took 1'20''.
cs2wav synthesis/julia.{orc,sco}

# These generate only silence.
cs2wav realtime/fofrt.{orc,sco}
cs2wav Spring1999/realtime/anmod.{orc,sco}
cs2wav Spring1999/within/Within.{orc,sco}

# Other things:
# (find-fline "/tmp/csound/examples/")
# and I don't know how to use the "score.srt" files.





#####
#
# rms' free software song
# 99oct??
#
#####

cd $S/http/www.liacs.nl/~wichert/
bplay why-cooperation-with-rms-is-impossible.au

cd $S/http/www.liacs.nl/~wichert/
mp freesoftwareSong-remix.mp3




#####
#
# midikb
# 99nov27
#
#####

rm -Rv /usr/src/midikb-0.4.3/
cd /usr/src/
tar -xvzf $S/http/www.sdf.se/~simon/dl/midikb-0.4.3.tar.gz
cd /usr/src/midikb-0.4.3/
./configure	|& tee oc
make		|& tee om

cd /usr/src/midikb-0.4.3/
strace-to ~/s \
src/midikb -c midikb.conf.english

# (find-fline "/usr/src/midikb-0.4.3/")
# (find-fline "/usr/src/midikb-0.4.3/README" "output >/dev/midi")
# (find-fline "/usr/src/midikb-0.4.3/midikb.conf.english")




#####
#
# klav
# 99nov27
#
#####

rm -Rv /usr/src/klav-0.0.4/
cd /usr/src/
tar -xvzf $S/http/www.sdf.se/~simon/dl/klav-0.0.4.tar.gz
cd /usr/src/klav-0.0.4/
make	|& tee om

# (find-fline "/usr/src/klav-0.0.4/om")





#####
#
# cecilia
# 99nov27
#
#####

pdsc $SDEBIAN/dists/slink/non-free/source/sound/cecilia_2.0.2-1.dsc
cd /usr/src/cecilia-2.0.2/
debian/rules binary	|& tee odrb

mv -v /usr/src/cecilia*.deb /usr/src/.debs/
apt-update
apti cecilia
# (find-vldifile "cecilia.list")
# (find-fline "/usr/doc/cecilia/")

cd /usr/doc/cecilia/html/
edrxnetscape index.html




#####
#
# rosegarden
# 99nov27
#
#####

apti rosegarden tclmidi
# (find-vldifile "rosegarden.list")
# (find-fline "/usr/doc/rosegarden/")
# (find-vldifile "tclmidi.list")
# (find-fline "/usr/doc/tclmidi/")

pdsc /big/slinks2/dists/slink/main/source/sound/tclmidi_3.1-4.dsc
debian/rules binary	|& tee odrb

# ld: cannot open -lg++: No such file or directory

# (find-fline "/usr/src/tclmidi-3.1/tests/")
# (find-fline "/usr/src/tclmidi-3.1/tests/copy.test")

expect -c '
  package require tclmidi
  puts [midimake]
'

# even the humblest call causes a segfault...

cd /usr/src/tclmidi-3.1/tests/
for i in *.test; do
expect -c '
  package require tclmidi
' $i
done


  load tclmidi31.so

# (find-fline "/usr/bin/tmplay")





#####
#
# MIDIs from Wendy Carlos' site
# 99nov27
#
#####

# «air_on_G»  (to ".air_on_G")
#
cd /tmp/
unzip $S/http/www.wendycarlos.com/resources/airongst.zip
# playmidi airongst
timidity airongst
#

# The chords on the left hand (?) sound really horrible on my OPL3-SAX
# if I use playmidi (i.e., if I use the built-in instruments of the
# card). With timidity it sounds quite ok, but John Sankey's stuff
# survive the MIDIzation much better.




#####
#
# Speech syntesizers
# 2003feb17
#
#####

# (find-available "festival")
# (find-available "recite")
# (find-available "epos-ptd")
# (find-available "speech-tools")



#####
#
# festival (on potato)
# 2000apr01
#
#####

# «festival»  (to ".festival")
apti festival festvox-rablpc8k

nas-lib
speech-tools1
festival
festlex-oald
festlex-poslex
festvox-rablpc8k

# (find-fline "/usr/doc/festival/")
# (find-fline "/usr/doc/festlex-oald/")
# (find-fline "/usr/doc/festlex-poslex/")
# (find-fline "/usr/doc/festvox-rablpc8k/")
# (find-fline "/usr/doc/nas-lib/")
# (find-fline "/usr/doc/speech-tools1/")
# (find-vldifile "festival.list")
# (find-vldifile "festlex-oald.list")
# (find-vldifile "festlex-poslex.list")
# (find-vldifile "festvox-rablpc8k.list")
# (find-vldifile "nas-lib.list")
# (find-vldifile "speech-tools1.list")

echo "hello you, I'm festival" | festival --tts

cd /usr/doc/festival/examples/
zcat saytime.sh.gz > /tmp/saytime.sh
festival --script /tmp/saytime.sh

festival --tts intro.text

festival --tts benchmark.text
festival --tts ex1.ogi


aptrm	\
  speech-tools1	\
  festival	\
  festlex-oald	\
  festlex-poslex \
  festvox-rablpc8k



#####
#
# Festival on squeeze
# 2010nov18
#
#####

# «festival-squeeze»  (to ".festival-squeeze")
# (find-node "(festival)Checking an installation")
# Buggy.

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
festival
festival -q
libdir
datadir
(SayText "hello world")
(intro)

# (find-zsh "dmissing saytime")
# (find-udfile "festival/examples/")
# (find-udfile "festival/examples/saytime.gz")
# (find-udfile "festival/examples/saytime.sh.gz")
# (find-udfile "festival/examples/latest.gz")






#####
#
# denemo
# 2005jan12
#
#####

# «denemo»  (to ".denemo")
# (find-status   "denemo")
# (find-vldifile "denemo.list")
# (find-udfile   "denemo/")
# (find-udfile "denemo/README.gz")
# (find-udfile "denemo/README.gz" "insert a half note")
# (find-udfile "denemo/examples/english.keymaprc")




#####
#
# Scarlatti's sonatas
# 2005jan11
#
#####

# «scarlatti_sonatas_as_midi»  (to ".scarlatti_sonatas_as_midi")
# (find-shttpw3 "www.geocities.com/Vienna/Studio/1714/")
unzip -l $S/http/www.geocities.com/Vienna/Studio/1714/scarlatti.zip

# http://sankey.ws/data/scarlatti.zip
# http://sankey.ws/scarlatti.zip
# http://sankey.ws/ross.sbk
# http://sankey.ws/ross.sf2
# http://sankey.ws/my.html
# (find-status   "timidity")
# (find-vldifile "timidity.list")
# (find-udfile   "timidity/")
# (find-man "1 timidity")
# (find-man "1 timidity" "--chorus")
# (find-man "5 timidity.cfg")

#
rm -Rv /tmp/scarlatti/
mkdir  /tmp/scarlatti/
cd     /tmp/scarlatti/
unzip -L $S/http/sankey.ws/scarlatti.zip

cp -v $S/http/sankey.ws/ross.sbk .

cat > ross.cfg <<'%%%'
bank 0
6 %font ross.sbk 0 0
%%%

#
cd /tmp/scarlatti/
timidity -c ross.cfg --chorus=d k162.mid 
timidity -c ross.cfg --chorus=d --reverb=d k162.mid 
#timidity -c ross.cfg           k162.mid 

#
cd /tmp/scarlatti/
# playmidi k026.mid
timidity k026.mid

#
 (eechannel-xterm "S")
# The 12 sonatas in Andras Schiff's Hungaroton CD:
SCA=/tmp/scarlatti/
function T () { timidity -c $SCA/ross.cfg --chorus=d --reverb=d $*; }
echo  1; T k162.mid
echo  2; T k322.mid
echo  3; T k027.mid
echo  4; T k096.mid
echo  5; T k394.mid
echo  6; T k017.mid
echo  7; T k420.mid
echo  8; T k518.mid
echo  9; T k519.mid
echo 10; T k208.mid
echo 11; T k427.mid
echo 12; T k491.mid

cd /tmp/scarlatti/; cp -v \
  k162.mid k322.mid k027.mid k096.mid k394.mid \
  k017.mid k420.mid k518.mid k519.mid k208.mid \
  k427.mid k491.mid \
  ~/SQUEAK/ 

# k394 sounds bad when rendered in real-time.
# How to 
# (find-man "timidity")

function T () { timidity -c ross.cfg --chorus=d --reverb=d $*; }
cd /tmp/scarlatti/
T -OvM -o /tmp/k394.ogg k394.mid




#####
#
# soundtracker
# 2000jun17
#
#####

# (find-status "soundtracker")
# (find-vldifile "soundtracker.list")
# (find-fline "/usr/doc/soundtracker/")

# Where do I get mods and instruments?




#####
#
# spiralsynth
# 2000sep12
#
#####

apti libfltk-dev
apti mesag-dev

rm -Rv /usr/src/SpiralSynth-0.1.6/
cd /usr/src/
tar -xvzf $S/http/www.blueammonite.f9.co.uk/SpiralSynth/dload/SpiralSynth-0.1.6.tar.gz

cd /usr/src/SpiralSynth-0.1.6/
find * -name '*.[Cch]' > .files.Cch
etags $(.files.Cch)
./configure	|& tee oc
make		|& tee om

cd /usr/src/SpiralSynth-0.1.6/
cp -v .SpiralPatches.bank ~

# (find-fline "~/" ".Spiral")

# (code-c-d "spirsy" "/usr/src/SpiralSynth-0.1.6/")
# (find-spirsyfile "")
# (find-spirsyfile "oc")
# (find-spirsyfile "config.log")
# (find-spirsytag "main")




#####
#
# Generating sound from C
# 2001feb16
#
#####

# «sound_from_C»  (to ".sound_from_C")
# http://i2pi.com/comprez/tutorial/
# http://i2pi.com/comprez/tutorial/c2k-tut1.c
# http://i2pi.com/comprez/tutorial/c2k-tut2.c
# http://i2pi.com/comprez/tutorial/c2k-tut3.c
# http://i2pi.com/comprez/tutorial/c2k-tut4.c
# http://i2pi.com/comprez/tutorial/c2k-tut5.c
# http://i2pi.com/comprez/tutorial/c2k-tut6.c
# http://i2pi.com/comprez/tutorial/c2k-tut7.c
# http://i2pi.com/comprez/tutorial/c2k-tut8.c

# (find-w3m "$S/http/i2pi.com/comprez/index.html")
# (find-w3m "$S/http/i2pi.com/comprez/index.html" "sox")
# (find-w3m "$S/http/i2pi.com/comprez/tutorial/index.html")
# (find-shttpw3 "comprez.i2pi.com/tutorial.html")
# (find-shttpfile "comprez.i2pi.com/")
# (find-shttpfile "comprez.i2pi.com/c2k-tut1.c")

#
rm -Rv /tmp/c-sound/
mkdir  /tmp/c-sound/
cd     /tmp/c-sound/
cp -v $S/http/i2pi.com/comprez/tutorial/* .
cp -v /oldfs/6/snarf/http/comprez.i2pi.com/c2k-tut9.c .   ;# older copy
for i in 1 2 3 4 5 6 7 8 9; do
  echo $i; gcc -lm -o c2k-tut$i c2k-tut${i}.c
           ./c2k-tut$i > out${i}.raw
done

#
cd     /tmp/c-sound/
bplay -b 16 -S -s 44100 out1.raw
bplay -b 16 -S -s 44100 out2.raw
bplay -b 16 -S -s 44100 out3.raw
bplay -b 16 -S -s 44100 out4.raw
bplay -b 16 -S -s 44100 out5.raw
bplay -b 16 -S -s 44100 out6.raw
bplay -b 16 -S -s 44100 out7.raw
bplay -b 16 -S -s 44100 out8.raw
bplay -b 16 -S -s 44100 out9.raw

#




#####
#
# nas (network audio system)
# 2001oct21
#
#####

# «nas»  (to ".nas")

# (find-status "nas-bin")
# (find-vldifile "nas-bin.list")
# (find-fline "/usr/doc/nas-bin/")

# (find-status "nas-doc")
# (find-vldifile "nas-doc.list")
# (find-fline "/usr/doc/nas/")
# (find-fline "/usr/doc/nas-doc/")

# (find-status "nas")
# (find-vldifile "nas.list")
# (find-fline "/usr/doc/nas/")

# (find-fline "/usr/bin/start-nas")
# (find-fline "/etc/init.d/nas")

start-nas
/etc/init.d/nas start
auplay /snarf/http/www.pgeek.com/turtle.au
/etc/init.d/nas stop



#####
#
# aureal vortex driver
# 2002may14
#
#####

# «aureal_vortex»  (to ".aureal_vortex")
#
#  ----------\
# |           \
# in    black  \
# |     cd_in   \
# mic     green  \
# |        tad    \
# out       white  \
# |         aux_in  \----
# j                      |
# o                      |
# y           VORTEX     |
# s           AU8830A2   |
# t           AAPXP      |
# i           9923-M4J28 |
# c                      |
# k---------             |
#           |||||||||||||
#
# Aureal semiconductor
# vortex 2

#
rm -Rv /debian/tmp/aureal/
cd     /debian/tmp/
tar -xvzf ~/tmp/au88xx-1.1.2.tar.gz
cd     /debian/tmp/aureal/
make	|& tee om

#
# (code-c-d "aureal" "/debian/tmp/aureal/")
# (find-aurealfile "")
# (find-aurealfile "README" "8830-based (Vortex 2)" "make install")
# (find-aurealfile "Makefile")
# (find-aurealfile "Makefile" "ifndef AUCHIP\nAUCHIP = AU8830")
# (find-aurealfile "Makefile" "install:")




#####
#
# disc-cover
# 2003mar13
#
#####

# «disc-cover»  (to ".disc-cover")
# (find-status "disc-cover")
# (find-vldifile "disc-cover.list")
# (find-fline "/usr/doc/disc-cover/")
# (find-fline "/usr/bin/disc-cover")
# (find-fline "/usr/bin/disc-cover" "disc-cover-$process_number")

# (find-status "cdcover")
# (find-vldifile "cdcover.list")
# (find-fline "/usr/doc/cdcover/")

# (find-fline "$S/http/www.freedb.org/freedb/rock/c90d450e")
# (find-progoutput "disc-cover -h")
#
cd /tmp/
rm -Rv disc-cover*
cp -v $S/http/www.freedb.org/freedb/rock/c90d450e .
disc-cover -r -f c90d450e
mv -v disc-cover-* disc-cover
mv -v Various_*.ps disc-cover/disc-cover.ps
cd /tmp/disc-cover/
cp -v disc-cover.tex dc.tex
#
# «my-disc-cover.tex»
# (find-angg "LATEX/my-disc-cover.tex")
# (find-fline "/tmp/disc-cover/dc.tex")
# (fooi "\\color{black}" "" "\\bfseries" "" "\\sffamily " "" "\\sffamily" "")
cd ~/LATEX/
latex my-disc-cover.tex && dvips my-disc-cover.dvi && regv my-disc-cover.ps

#
# (find-fline "/tmp/disc-cover/dc.tex")
cd /tmp/disc-cover/
latex dc.tex && dvips dc.dvi && regv dc.ps

#
cd $usr_src/
rm -Rv $usr_src/disc-cover-1.4.0/
tar -xvzf $S/http/home.wanadoo.nl/jano/files/disc-cover-1.4.0.tar.gz
cd $usr_src/disc-cover-1.4.0/





#####
#
# solfege (from the .tar.gz)
# 2000sep18
#
#####

apti python-gtk python-gnome

#
rm -Rv /usr/src/solfege-0.7.22/
cd /usr/src/
tar -xvzf $S/http/download.sourceforge.net/solfege/solfege-0.7.22.tar.gz

cd /usr/src/solfege-0.7.22/
mkdir tmp
# --sequencer-device=/dev/sequencer
./configure --prefix=$PWD/tmp |& tee oc
make				|& tee om
make install			|& tee omi

cd /usr/src/solfege-0.7.22/tmp/bin/
./solfege

#
# (code-c-d "solf" "/usr/src/solfege-0.7.22/")
# (find-solffile "")
# (find-solffile "INSTALL" "--prefix")
# (find-solffile "online-docs/C/changelog.html" "dev/music")

man2t /usr/src/solfege-0.7.22/solfege.1 | l

cd /dev
mknod music u 14 8

rm /dev/music

# Sound is impossible to hear. Maybe I need that bugful 2.4 kernel to
# have /dev/music working.





#####
#
# xmms
# 2004sep07
#
#####

# «xmms»  (to ".xmms")
# (find-status   "xmms")
# (find-vldifile "xmms.list")
# (find-udfile   "xmms/")
# (find-udfile "xmms/FAQ.gz")
# (find-udfile "xmms/README.gz")
# (find-man  "1 xmms")

# (find-udfile "xmms/README.gz" "\n2.3 Skin Installation")
# (find-fline "~/.xmms/")

# http://www.xmms.org/files/Skins/minEguE-xmms-v2.zip
# http://www.xmms.org/files/Skins/UltrafinaSE.zip
#
cd ~/.xmms/Skins/
cp -v $S/http/www.xmms.org/files/Skins/* .

#




#####
#
# normalize
# 2005mar01
#
#####

# (find-status   "normalize")
# (find-vldifile "normalize.list")
# (find-udfile   "normalize/")

# http://thobias.org/doc/conv_audio.html



#####
#
# puredata
# 2005mar17
#
#####

# «puredata»  (to ".puredata")
# (find-es "puredata")
# (find-status   "puredata")
# (find-vldifile "puredata.list")
# (find-udfile   "puredata/")
# (find-status   "pd-zexy")
# (find-vldifile "pd-zexy.list")
# (find-udfile   "pd-zexy/")
# (find-status   "pd-csound")
# (find-vldifile "pd-csound.list")
# (find-udfile   "pd-csound/")
# (find-status   "pd-pdp")
# (find-vldifile "pd-pdp.list")
# (find-udfile   "pd-pdp/")
# (find-status   "pd-aubio")
# (find-vldifile "pd-aubio.list")
# (find-udfile   "pd-aubio/")

http://www-crca.ucsd.edu/~msp/
http://pd-graz.mur.at/label/book01/bangbook
http://pd-graz.mur.at/label/book/bangbook.pdf

 (eepitch-shell)
apti puredata
apti puredata pd-zexy pd-csound pd-pdp pd-aubio





#####
#
# Compilation: Hugo Largo (Drum + Mettle)
# 2006jan28
#
#####

# «compilation:hugo_largo»  (to ".compilation:hugo_largo")
#
# (find-fline "/oldfs/music/fernanda1/")
# (find-fline "/big/music/mp3/Drum/")
# (find-fline "/tmp/hugolargo/")

mkdir /tmp/hugolargo/
cd    /tmp/hugolargo/
FERNANDA1=/oldfs/music/fernanda1/
MP3DRUM=/big/music/mp3/Drum/

 ptowav a1_grow_wild.wav   $MP3DRUM/1_grow_wild.mp3                
 ptowav a4_harpers.wav     $MP3DRUM/4_harpers.mp3                  
 ptowav a5_scream_tall.wav $MP3DRUM/5_scream_tall.mp3      
 ptowav a6_country.wav     $MP3DRUM/6_country.mp3                  
ptowav a2_eskimo_song.wav "$FERNANDA1/Hugo Largo (2) - Eskimo Song.wav"
ptowav a3_fancy.wav       "$FERNANDA1/Hugo Largo (3) - Fancy.wav"
ptowav a8_second_skin.wav "$FERNANDA1/Hugo Largo (8) - Second Skin.wav"
ptowav a9_myfavpeople.wav "$FERNANDA1/Hugo Largo (9) - My Favourite People.wav"
silentwav 100 b0_10s-of-silence.wav
ptowav b1_turtle_song.wav  "$FERNANDA1/Hugo Largo (1) - Turtle Song.wav"
ptowav b4_hway_knowing.wav "$FERNANDA1/Hugo Largo (4) - Halfway Knowing.wav"
ptowav b5_4_brothers.wav   "$FERNANDA1/Hugo Largo (5) - 4 Brothers.wav"

#
cd     /tmp/hugolargo/
makecdrdaotoc 2004122055555 *.wav > toc.toc
showcdrdaotracks *.wav
# (find-zsh "cd /tmp/hugolargo/; showcdrdaotracks *.wav")

cdrdao read-test toc.toc
cdrdao toc.toc
cdrdao write -v 5 --speed 8 --device /dev/hdd --driver generic-mmc toc.toc




#####
#
# Kristi Stassinopoulou's "Secrets of the Rocks"
# 2006oct01
#
#####

# «secrets_of_the_rocks»  (to ".secrets_of_the_rocks")
# (find-fline "~/NICOTINE/KRISTI_STASSINOPOULOU/Secrets_of_the_rocks/")
#
mkdir /tmp/kstas/
cd    /tmp/kstas/
for i in ~/NICOTINE/KRISTI_STASSINOPOULOU/Secrets_of_the_rocks/*.mp3; do
  # echo ptowav $(basename $i .mp3).wav $i
         ptowav $(basename $i .mp3).wav $i
done

#
cdrdao read-test =(makecdrdaotoc 2006100155555 /tmp/kstas/*.wav)
#
cdrdao write -v 5 --speed 8 --device /dev/hdc --driver generic-mmc \
                 =(makecdrdaotoc 2006100155555 /tmp/kstas/*.wav)
#



#
cdrdao read-test =(makecdrdaotoc 2006100155554 /tmp/cuba/*.wav)
#
cdrdao write -v 5 --speed 8 --device /dev/hdc --driver generic-mmc \
                 =(makecdrdaotoc 2006100155554 /tmp/cuba/*.wav)
#





#####
#
# pengiunsap-0.1 (a console SAP player)
# 2007aug31
#
#####

# «penguinsap»  (to ".penguinsap")
# http://asma.atari.org/
# http://asma.atari.org/main.html#plr
# http://asma.atari.org/bin/pengiunsap-0.1.tar.bz2
# http://asma.atari.org/bin/pengiunsap-0.1.tar.gz
# ^ the .bz2 extension is wrong, we have to copy the .bz2 to a .gz.
#
cd $S/http/asma.atari.org/bin/
cp -v pengiunsap-0.1.tar.bz2 \
      pengiunsap-0.1.tar.gz

#
rm -Rv ~/usrc/penguinsap-0.1/
tar -C ~/usrc/ -xvzf \
  $S/http/asma.atari.org/bin/pengiunsap-0.1.tar.gz
cd     ~/usrc/penguinsap-0.1/

rm -v .main.cpp.swp
make depend |& tee omd
make        |& tee om

#
# (code-c-d "penguinsap" "~/usrc/penguinsap-0.1/")
# (find-penguinsapfile "")
# (find-penguinsapfile "README")
# Installation:
# (find-fline "~/bin/" " sap")
# (find-sh0 "rm -v ~/bin/sap")
# (find-sh0 "cd ~/bin/; cp -sfv ../usrc/penguinsap-0.1/sap .")




#####
#
# ASMA (a big archive of SAP songs)
# 2007aug31
#
#####

# «asma»  (to ".asma")
# http://asma.atari.org/
# http://asma.atari.org/bin/asma32.zip
#
unzip -d /tmp/ $S/http/asma.atari.org/bin/asma32.zip
rm -Rv   ~/usrc/asma/
rm -Rv   ~/usrc/ASMA/
unzip -d ~/usrc/ /tmp/files
rm -Rv   ~/usrc/asma/

#
# (code-c-d "asma" "~/usrc/ASMA/")
# (find-asmafile "")

 (eepitch-shell)
# (find-asmafile "Docs/STIL.txt")
cd ~/usrc/ASMA/
sap Various/Grayscale/Kwiatek_Grzegorz/Desastre.sap
sap Unsorted/Wiosna.sap




#####
#
# mmsap-1.6
# 2007aug31
#
#####

# http://mmsap.sourceforge.net/
# http://ufpr.dl.sourceforge.net/sourceforge/mmsap/mmsap-1.6c.tar.gz
#
rm -Rv ~/usrc/mmsap-1.6/
tar -C ~/usrc/ -xvzf \
  $S/http/ufpr.dl.sourceforge.net/sourceforge/mmsap/mmsap-1.6c.tar.gz
cd     ~/usrc/mmsap-1.6/

rm -v mmsap-als
rm -v mmsap-sdl
# Broken:
./compile-alsa |& tee oca
./compile-sdl  |& tee ocs

#
# (code-c-d "mmsap" "~/usrc/mmsap-1.6/")
# (find-mmsapfile "")
# (find-mmsapfile "readme.txt" "4. How to compile")

apti libgtkmm-dev




#####
#
# bplay (from the debian sources)
# 2007sep04
#
#####

# «bplay-deb-src»  (to ".bplay-deb-src")
# http://ftp.debian.org/debian/pool/main/b/bplay/
# http://ftp.debian.org/debian/pool/main/b/bplay/bplay_0.991-9.dsc
# http://ftp.debian.org/debian/pool/main/b/bplay/bplay_0.991-9.diff.gz
# http://ftp.debian.org/debian/pool/main/b/bplay/bplay_0.991.orig.tar.gz
#
rm -Rv ~/usrc/bplay/
mkdir  ~/usrc/bplay/
cd $S/http/ftp.debian.org/debian/pool/main/b/bplay/
cp -v bplay_0.991* ~/usrc/bplay/
cd     ~/usrc/bplay/
dpkg-source -sn -x bplay_0.991-9.dsc
cd     ~/usrc/bplay/bplay-0.991/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/bplay/")
 (eepitch-shell)
cd ~/usrc/bplay/
sudo dpkg -i *.deb

#
# (find-status   "bplay")
# (find-vldifile "bplay.list")
# (find-udfile   "bplay/")
# (find-bplayfile "debian/changelog" "claviola@debian.org")

# (find-bplayfile "bplay.c" "strcmp(progname, \"brec\")")
# (find-bplayfile "bplay.c" "if (recorder)")

# (code-c-d "bplay" "~/usrc/bplay/bplay-0.991/")
# (find-bplayfile "")
# (find-bplayfile "" "bplay.1" '(woman-dired-find-file))
# (find-bgprocess "xterm -e sudo aumix")

 (eepitch-shell)
cd /tmp/
brec -t 2 -D 2 /tmp/o.wav
bplay /tmp/o.wav

brec -t 2 -D 2 -r /tmp/o.raw
# (find-fline "/tmp/o.raw")

bplay o.wav





#####
#
# libsndfile (from the debian sources)
# 2007sep06
#
#####

# «libsndfile-deb-src»  (to ".libsndfile-deb-src")
# http://ftp.debian.org/debian/pool/main/libs/libsndfile/
# http://ftp.debian.org/debian/pool/main/libs/libsndfile/libsndfile_1.0.17-3.dsc
# http://ftp.debian.org/debian/pool/main/libs/libsndfile/libsndfile_1.0.17-3.diff.gz
# http://ftp.debian.org/debian/pool/main/libs/libsndfile/libsndfile_1.0.17.orig.tar.gz
# Homepage: http://www.mega-nerd.com/libsndfile/
# dpkg-checkbuilddeps: Unmet build dependencies: libflac-dev (>= 1.1.4-3) libasound2-dev
# dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.
#
rm -Rv ~/usrc/libsndfile/
mkdir  ~/usrc/libsndfile/
cd $S/http/ftp.debian.org/debian/pool/main/libs/libsndfile/
cp -v libsndfile_1.0.17* ~/usrc/libsndfile/
cd     ~/usrc/libsndfile/
dpkg-source -sn -x libsndfile_1.0.17-3.dsc
cd     ~/usrc/libsndfile/libsndfile-1.0.17/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/libsndfile/")
 (eepitch-shell)
cd ~/usrc/libsndfile/
sudo dpkg -i *.deb

#
# (code-c-d "libsndfile" "~/usrc/libsndfile/libsndfile-1.0.17/")
# (find-libsndfilefile "")





#####
#
# FLAC
# 2011nov05
#
#####

# «flac»  (to ".flac")
# (find-zsh "grep-available flac")
# http://www.linuxtutorialblog.com/post/solution-converting-flac-to-mp3



#####
#
# kid3
# 2012aug17
#
#####

# «kid3»  (to ".kid3")
# (find-status   "kid3")
# (find-vldifile "kid3.list")
# (find-udfile   "kid3/")
# (find-man "1 kid3")

# (find-sh "kid3 --help")

# (find-fline "/sda6/CDs/zoe_keating_natoma/2/")
http://mindref.blogspot.com.br/2012/06/convert-flac-mp3-batch.html



#####
#
# pacpl
# 2012aug17
#
#####

# «pacpl»  (to ".pacpl")
# (find-status   "pacpl")
# (find-vldifile "pacpl.list")
# (find-udfile   "pacpl/")
# (find-man "1 pacpl")
# (find-sh "pacpl -h")
# (find-sh "pacpl -f")

# (find-fline "/sda6/CDs/zoe_keating_natoma/2/")
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /sda6/CDs/zoe_keating_natoma/2/
pacpl -t mp3 06._We_Insist.flac

 (eepitch-shell2)
 (eepitch-kill)
 (eepitch-shell2)
# (find-fline "/sda6/CDs/zoe_keating_natoma/")
# (find-fline "/sda6/CDs/zoe_keating_natoma/2/")
rm -Rv /sda6/CDs/zoe_keating_natoma/2/
mkdir  /sda6/CDs/zoe_keating_natoma/2/
cd     /sda6/CDs/zoe_keating_natoma/
cp -lv *.flac 2/
cp -v  cover.jpg 2/albumart.jpg


cd /sda6/CDs/zoe_keating_natoma/2/

cd /sda6/CDs/zoe_keating_natoma/2/
pacpl -t ogg --bitrate 320 -v *.flac

pacpl -t mp3 --bitrate 320 -v *.flac
pacpl -t mp3 --bitrate 320 -v 06*.flac







#####
#
# cmus
# 2011nov06
#
#####

# «cmus»  (to ".cmus")
# (find-status   "cmus")
# (find-vldifile "cmus.list")
# (find-udfile   "cmus/")

# (find-man "1 cmus")
# (find-man "1 cmus" "Copying Tracks Between Views")
# (find-man "1 cmus" "Moving Tracks")
# (find-man "1 cmus" "Removing Tracks")
# (find-man "1 cmus" "KEYBINDINGS" "Common Context")
# (find-man "1 cmus" ":a ~/music")
# (find-man "1 cmus-remote")
# (find-man "7 cmus-tutorial")
# (find-fline "~/.cmus/")


       z              player-prev
       x              player-play
       c              player-pause
       b              player-next
       v              player-stop


    Press 4 to view/edit the queue. This view works and looks a lot like the
       simple library view. The main difference is that you can change the
       order of the tracks with the p and P keys. You can press shift-D to
       remove a track from the queue.



 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/NICOTINE/panda/Garlands/
cmus




#####
#
# ProjectM
# 2011dec03
#
#####

# «projectm»  (to ".projectm")
# (find-status   "projectm-data")
# (find-vldifile "projectm-data.list")
# (find-udfile   "projectm-data/")
# (find-fline "/usr/share/projectM/shaders/")
# (find-fline "/usr/share/projectM/presets/")
# http://projectm.sf.net/
# http://en.wikipedia.org/wiki/Music_visualization





#####
#
# Audacity
# 2011dec15
#
#####

# «audacity»  (to ".audacity")
# (find-zsh "availabledebs | sort | grep audacity")
# (find-status   "audacity")
# (find-vldifile "audacity.list")
# (find-udfile   "audacity/")
# (find-status   "audacity-data")
# (find-vldifile "audacity-data.list")
# (find-udfile   "audacity-data/")
# (find-man "1 audacity")
# (find-fline "/usr/share/audacity/plug-ins/")
# (find-fline "/usr/share/audacity/nyquist/")
# http://en.wikipedia.org/wiki/Audacity
# http://audacity.sourceforge.net/
# http://audacity.sourceforge.net/help/
# http://wiki.audacityteam.org/wiki/Audacity_Wiki_Home_Page
# http://audacity.sourceforge.net/help/documentation
# http://en.wikipedia.org/wiki/Nyquist_(programming_language)
# http://en.wikipedia.org/wiki/XLISP

# http://fullcirclemagazine.org/
# http://fullcirclemagazine.org/issue-55/
# http://dl.fullcirclemagazine.org/issue55_en.pdf

(code-xpdf      "fullcircle55" "$S/http/dl.fullcirclemagazine.org/issue55_en.pdf")
(code-pdftotext "fullcircle55" "$S/http/dl.fullcirclemagazine.org/issue55_en.pdf")
;; (find-fullcircle55page  1 "Contents")
;; (find-fullcircle55page 19 "Audacity basics")
;; (find-fullcircle55page 55 "Ubuntu games")
;; (find-fullcircle55text "")

# «noise-reduction»  (to ".noise-reduction")
# http://www.google.com/search?q=audacity+noise+reduction
# http://www.google.com/search?q=audacity+noise+removal
# http://wiki.audacityteam.org/index.php?title=Noise_Removal

http://wiki.audacityteam.org/index.php?title=Noise_Removal
http://wiki.audacityteam.org/index.php?title=Noise_Removal#Nyquist_Noise_Gate_Plug-in
http://wiki.audacityteam.org/index.php?title=Noise_Removal#Audacity_Noise_Removal
http://wiki.audacityteam.org/index.php?title=Noise_Removal#How_does_it_work.3F
http://wiki.audacityteam.org/index.php?title=Noise_Removal#Noise_Removal_steps
http://www.youtube.com/watch?v=mlKX6p85R2M Audacity Noise Removal Tool

https://www.theregister.com/2021/07/05/audacity_profile/

https://github.com/tenacityteam/tenacity/issues/99 Stepdown as Maintainer of this Fork




#####
#
# Audacity: Nyquist
# 2012feb25
#
#####

# «nyquist»  (to ".nyquist")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cp -v ~/NICOTINE/gmail/12._grapevine.mp3 /tmp/grap.mp3
audacity /tmp/grap.mp3

# http://manual.audacityteam.org/index.php?title=Main_Page
# http://manual.audacityteam.org/man/Main_Page
# http://manual.audacityteam.org/man/Tutorials
# http://manual.audacityteam.org/man/Main_Page#using
# http://audacity.sourceforge.net/help/nyquist
# http://www.cs.cmu.edu/~music/music.software.html
# http://www.cs.cmu.edu/~rbd/doc/nyquist/
# http://www.audacity-forum.de/download/edgar/nyquist/nyquist-doc/examples/examples.htm
# http://www.audacity-forum.de/download/edgar/nyquist/nyquist-doc/manual/home.html
# http://www.audacity-forum.de/download/edgar/nyquist/nyquist-doc/nyquist.htm
# http://wiki.audacityteam.org/index.php?title=Talk:Nyquist_Audio_Programming
# http://wiki.audacityteam.org/wiki/Nyquist_Basics:_The_Audacity_Nyquist_Prompt
# http://audacity.sourceforge.net/nyquist/generate.zip
# http://stackoverflow.com/questions/8948237/lisp-nyquist-opening-a-file-and-reading-line-by-line
# http://www.aosabook.org/en/audacity.html
# http://www.audacity-forum.de/download/edgar/nyquist/nyquist-doc/devel/audacity-nyquist-en.htm




#####
#
# ecasound
# 2012feb24 / 2019sep07
#
#####

# «ecasound»  (to ".ecasound")
# (find-sh "apt-file search ecasound")
# (find-status   "ecasound")
# (find-vldifile "ecasound.list")
# (find-udfile   "ecasound/")
# (find-status   "ecasound-el")
# (find-vldifile "ecasound-el.list")
# (find-udfile   "ecasound-el/")
# (find-status   "ecasound-doc")
# (find-vldifile "ecasound-doc.list")
# (find-udfile   "ecasound-doc/")
# (find-fline "/usr/share/doc/ecasound/")
;; (find-code-pdf-links "/usr/share/doc/ecasound/ecasound_users_guide.pdf.gz" "{c}")
;; (find-pdf-page "/usr/share/doc/ecasound/ecasound_users_guide.pdf.gz")
;; (find-pdf-text "/usr/share/doc/ecasound/ecasound_users_guide.pdf.gz")

# http://eca.cx/ecasound/
# https://packages.debian.org/source/sid/ecasound

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti ecasound ecasound-doc ecasound-el
# Setting up ecasound-el (2.9.1-7) ...
# ERROR: ecasound-el is broken - called emacs-package-install as a
# new-style add-on, but has no compat file.






#####
#
# supercollider (from the debian sources)
# 2012feb25
#
#####

# «supercollider-deb-src»  (to ".supercollider-deb-src")
# http://ftp.de.debian.org/debian/pool/main/s/supercollider/
# http://ftp.de.debian.org/debian/pool/main/s/supercollider/supercollider_3.4.5-1.dsc
# http://ftp.de.debian.org/debian/pool/main/s/supercollider/supercollider_3.4.5-1.diff.gz  <-- no
# http://ftp.de.debian.org/debian/pool/main/s/supercollider/supercollider_3.4.5-1.debian.tar.gz
# http://ftp.de.debian.org/debian/pool/main/s/supercollider/supercollider_3.4.5.orig.tar.gz
#
apti libcwiid-dev libfftw3-dev libicu-dev libjack-dev python-all-dev scons

#
rm -Rv ~/usrc/supercollider/
mkdir  ~/usrc/supercollider/
cd $S/http/ftp.de.debian.org/debian/pool/main/s/supercollider/
cp -v supercollider_3.4.5* ~/usrc/supercollider/
cd     ~/usrc/supercollider/
dpkg-source -sn -x supercollider_3.4.5-1.dsc
cd     ~/usrc/supercollider/supercollider-3.4.5/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/supercollider/")
 (eepitch-shell)
cd ~/usrc/supercollider/
sudo dpkg -i *.deb

#
# (code-c-d "supercollider" "~/usrc/supercollider/supercollider-3.4.5/")
# (find-supercolliderfile "")

# libsclang1 libscsynth1 supercollider-common supercollider-dev
# supercollider-doc supercollider-emacs supercollider-server
# supercollider-vim supercollider

# (find-status   "supercollider-common")
# (find-vldifile "supercollider-common.list")
# (find-udfile   "supercollider-common/")
# (find-status   "supercollider-dev")
# (find-vldifile "supercollider-dev.list")
# (find-udfile   "supercollider-dev/")
# (find-status   "supercollider-doc")
# (find-vldifile "supercollider-doc.list")
# (find-udfile   "supercollider-doc/")
# (find-status   "supercollider-emacs")
# (find-vldifile "supercollider-emacs.list")
# (find-udfile   "supercollider-emacs/")
# (find-status   "supercollider-server")
# (find-vldifile "supercollider-server.list")
# (find-udfile   "supercollider-server/")
# (find-status   "supercollider-vim")
# (find-vldifile "supercollider-vim.list")
# (find-udfile   "supercollider-vim/")
# (find-status   "supercollider")
# (find-vldifile "supercollider.list")
# (find-udfile   "supercollider/")
# (find-status   "libsclang1")
# (find-vldifile "libsclang1.list")
# (find-udfile   "libsclang1/")
# (find-status   "libscsynth1")
# (find-vldifile "libscsynth1.list")
# (find-udfile   "libscsynth1/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sclang



# An interesting blog with some entries about supercollider:
# http://www.dewdrop-world.net/words/blog5.php
# http://www.dewdrop-world.net/words/blog5.php/2011/12/13/last-week-of-classes



# http://packages.debian.org/source/supercollider
# http://en.wikipedia.org/wiki/SuperCollider







#####
#
# kmetronome
# 2017ago16
#
#####

# «kmetronome» (to ".kmetronome")
# https://wiki.linuxaudio.org/apps/categories/metronomes
# http://kmetronome.sourceforge.net/
# (find-status   "kmetronome")
# (find-vldifile "kmetronome.list")
# (find-udfile   "kmetronome/")
# (find-man "1 kmetronome")
# (find-udfile "kmetronome/README")
# (find-udfile "kmetronome/NEWS.gz")
# (find-udfile "kmetronome/TODO")
# (find-udfile "kmetronome/copyright")
# (find-udfile "kmetronome/changelog.Debian.gz")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
kmetronome





#####
#
# Medieval dances
# 2019sep01
#
#####

# «medieval-dances» (to ".medieval-dances")
# https://www.facebook.com/groups/vegasdnqd/permalink/2263747003935486/ Victor Lazzarini - Trotto
# https://www.youtube.com/watch?v=tCg9hKsXJtw Victor Lazzarini - Trotto
# https://imslp.org/wiki/Manuscript%2C_GB-Lbl_Add._MS_29987_(Various)
# https://en.wikipedia.org/wiki/Add_MS_29987
# https://wikivisually.com/wiki/Add_MS_29987
# https://wikimili.com/en/Add_MS_29987
# https://www.amazon.com/Medieval-Renaissance-Dances-Recorders-Dancers/dp/0934017514
# https://earlymusicshop.com/products/anon-medieval-songs-sop-rec-bk
# https://www.youtube.com/watch?v=i9M8o2_82Vg




#####
#
# snd
# 2004oct12
#
#####

# «snd-old»  (to ".snd-old")
# (find-status   "snd")
# (find-vldifile "snd.list")\
# (find-udfile   "snd/")
# (find-fline "/usr/share/snd/")
# (find-status   "snd-doc")
# (find-vldifile "snd-doc.list")
# (find-udfile   "snd-doc/")
# (find-status   "snd-gtk")
# (find-vldifile "snd-gtk.list")
# (find-udfile   "snd-gtk/")
# (find-man "1 snd")
#
firefox /usr/share/doc/snd-doc/HTML/manual/index.html &
#
firefox /usr/share/doc/snd-doc/HTML/tutorial/index.html &
#
cp -v /oldfs/music/kristi/07-Only_Love_Remains.wav /tmp/07.wav
#
snd /tmp/07.wav &
#





#####
#
# snd
# 2019sep08
#
#####

# «snd» (to ".snd")
# https://ccrma.stanford.edu/software/snd/
# https://packages.debian.org/sid/snd
# (find-zsh "installeddebs | sort | grep snd")
# (find-zsh "availabledebs | sort | grep snd")
# (find-zsh "availabledebs | sort | grep s7")
# (find-status   "snd-doc")
# (find-vldifile "snd-doc.list")
# (find-udfile   "snd-doc/")
# (find-status   "snd-nox")
# (find-vldifile "snd-nox.list")
# (find-udfile   "snd-nox/")
# (find-status   "snd-gtk-jack")
# (find-vldifile "snd-gtk-jack.list")
# (find-udfile   "snd-gtk-jack/")
# (find-status   "snd")
# (find-vldifile "snd.list")
# (find-udfile   "snd/")
# (find-status   "libss7-dev")
# (find-vldifile "libss7-dev:amd64.list")
# (find-udfile   "libss7-dev/")
# (find-status   "libss7-2.0")
# (find-vldifile "libss7-2.0:amd64.list")
# (find-udfile   "libss7-2.0/")
# (find-fline "/usr/share/doc/snd/HTML/manual/")
# file:///usr/share/doc/snd/HTML/manual/index.html

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti snd-doc snd-nox snd-gtk-jack snd
apti libss7-dev

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
snd.nox




#####
#
# byzantine-notation
# 2019oct12
#
#####

# «byzantine-notation» (to ".byzantine-notation")
# http://www.youtube.com/watch?v=dNVLbs_758U Class 1 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=5l3oT9VQcfU Class 2 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=1173LyMn7uE Class 3 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=O-11sqt8TkU Class 4 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=K6Mpbz0ObRY Class 5 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=ppGXTJp56EU Class 6 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=qCuRY9-PvgM Class 7 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=eWNf0E1GN4k Class 8 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=7JUJ7sGkBB0 Class 9 - Beginner Byzantine Notation
# http://www.youtube.com/watch?v=5vBtHskE7jQ Class 10 - Beginner Byzantine Notation




#####
#
# scarlatti-andras-schiff
# 2019dec01
#
#####

# «scarlatti-andras-schiff» (to ".scarlatti-andras-schiff")

https://www.discogs.com/Domenico-Scarlatti-Andr%C3%A1s-Schiff-12-Sonatas/master/942150
Tracklist:
E Major K.162 Andante Allegro
A Major K.322 Allegro	
B Minor K.27 Allegro	
D Major K.96 Allegrissimo	
E Minor K.394 Allegro	
F Major K.17 Presto	
C Major K.420 Allegro	
J Major K.518 Allegro	
F Minor K.519 Allegro Assai	
A Major K.208 Andante Cantabile	
G Major K.427 Prestissimo	
D Major K.491 Allegretto

https://imslp.org/wiki/Keyboard_Sonata_in_E_major%2C_K.162_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_A_major%2C_K.322_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_B_minor%2C_K.27_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_D_major%2C_K.96_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_E_minor,_K.394_(Scarlatti,_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_F_major%2C_K.17_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_C_major,_K.420_(Scarlatti,_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_F_major,_K.518_(Scarlatti,_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_F_minor%2C_K.519_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_A_major%2C_K.208_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_G_major%2C_K.427_(Scarlatti%2C_Domenico)
https://imslp.org/wiki/Keyboard_Sonata_in_D_major%2C_K.491_(Scarlatti%2C_Domenico)

k162: https://www.youtube.com/watch?v=WcKacRCdMQw
k322: https://www.youtube.com/watch?v=epcmZIPQ-EU
k27:  https://www.youtube.com/watch?v=Fy6plkuF50o
k96:  https://www.youtube.com/watch?v=nP7-QJX1jTs
k394: https://www.youtube.com/watch?v=F5297gsUqAQ
k17:  https://www.youtube.com/watch?v=ZOC-2BPZmRs
k420: https://www.youtube.com/watch?v=o4ht1O-pAeg
k518: https://www.youtube.com/watch?v=H3PKr-q-My4
k519: https://www.youtube.com/watch?v=nGyjrRaTg_0
k208: https://www.youtube.com/watch?v=8JwVCBFAVwA
k427: https://www.youtube.com/watch?v=JH4oSkGh9uw
k491: https://www.youtube.com/watch?v=j_SIyBJ2IGQ


function yds () {
  cd /sda5/videos/scarlatti/ &&
  youtube-dl -t -f 18 --restrict-filenames $1
}

A=(
"https://www.youtube.com/watch?v=WcKacRCdMQw"
"https://www.youtube.com/watch?v=epcmZIPQ-EU"
"https://www.youtube.com/watch?v=Fy6plkuF50o"
"https://www.youtube.com/watch?v=nP7-QJX1jTs"
"https://www.youtube.com/watch?v=F5297gsUqAQ"
"https://www.youtube.com/watch?v=ZOC-2BPZmRs"
"https://www.youtube.com/watch?v=o4ht1O-pAeg"
"https://www.youtube.com/watch?v=H3PKr-q-My4"
"https://www.youtube.com/watch?v=nGyjrRaTg_0"
"https://www.youtube.com/watch?v=8JwVCBFAVwA"
"https://www.youtube.com/watch?v=JH4oSkGh9uw"
"https://www.youtube.com/watch?v=j_SIyBJ2IGQ"
)

for i in $A; do yds $i; done




#####
#
# fluid
# 2019dec31
#
#####

# «fluid» (to ".fluid")
fluid-soundfont-gm
libfluidsynth1



#####
#
# gregorio
# 2021nov27
#
#####

# «gregorio»  (to ".gregorio")
# https://emacsconf.org/2021/talks/gregorian/





#####
#
# maqams
# 2022jan23
#
#####

# «maqams»  (to ".maqams")
# (find-books "__music/__music.el" "farraj-shumays")
# https://www.patreon.com/SamiAbuShumays
# https://www.youtube.com/watch?v=fBLN2q-YCUE




#####
#
# terpsichore
# 2024jan27
#
#####

# «terpsichore»  (to ".terpsichore")

    (find-video "/sda5/videos/Terpsichore/Anonymous: Bassa danza à 2 [ddzStH4ZBXQ].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Bassa danza à 3 [hwVCgZj1HX4].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Istampita cominciamento di gioia [WpsKMR-rfPk].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Istampitta Ghaetta [cbnxSx3IrQE].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Kemp's Jig [02BOrh_ZWB0].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Lamento di Tristano - La rotta [hmw2foEz6uA].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Mascherade [DizmqUf_4nc].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Saltarello (c.1400) [J8v8ZZPsmFo].webm")
    (find-video "/sda5/videos/Terpsichore/Anonymous: Trotto [RA6ItitWBJI].webm")
 (find-video "/sda5/videos/Terpsichore/Attaingnant: Basse danse La brosse - Tripla - Tourdion [IrPJV2RLcAY].webm")
    (find-video "/sda5/videos/Terpsichore/Attaingnant: Basse danse la Magdalena [nYYbPM3gnjk].webm")
 (find-video "/sda5/videos/Terpsichore/Attaingnant: Basse danse la gatta [WNyxF572ldE].webm")
 (find-video "/sda5/videos/Terpsichore/Besard: Branle gay [blPmdWLmkOc].webm")
    (find-video "/sda5/videos/Terpsichore/Caroso: Barriera [1PaJ1IaNzq0].webm")
    (find-video "/sda5/videos/Terpsichore/Caroso: Celeste Giglio [NbtCY1vHlbU].webm")
    (find-video "/sda5/videos/Terpsichore/Caroubel: Courante [H_EKdMtTptw].webm")
    (find-video "/sda5/videos/Terpsichore/Caroubel: Courante [S_taUr9Yfdc].webm")
    (find-video "/sda5/videos/Terpsichore/Caroubel: Pavane de Spaigne [b_E2ytu-GbA].webm")
    (find-video "/sda5/videos/Terpsichore/Caroubel: Volte [G89I64e0fzw].webm")
    (find-video "/sda5/videos/Terpsichore/Caroubel: Volte [yJsIUAG22wY].webm")
 (find-video "/sda5/videos/Terpsichore/Dalza: Calata ala Spagnola [oaUjmv7qbjk].webm")
    (find-video "/sda5/videos/Terpsichore/Dowland: Mrs. Winter's Jump [BHiP7zHPOYA].webm")
    (find-video "/sda5/videos/Terpsichore/Dowland: Queen Elizabeth's Galliard [r_Ewf3bYE_M].webm")
    (find-video "/sda5/videos/Terpsichore/E. Widmann: Daentze und Galliarden - 1. Sophia und Anna [mQmWVDpa_S0].webm")
    (find-video "/sda5/videos/Terpsichore/E. Widmann: Daentze und Galliarden - 2. Clara [xaJMPcaCf2w].webm")
    (find-video "/sda5/videos/Terpsichore/E. Widmann: Daentze und Galliarden - 3. Magdalena [zJUkDkrpOMQ].webm")
    (find-video "/sda5/videos/Terpsichore/E. Widmann: Daentze und Galliarden - 4. Agatha [Qz09S0vBHQg].webm")
    (find-video "/sda5/videos/Terpsichore/E. Widmann: Daentze und Galliarden - 5. Regina [1rTnK8mIZrQ].webm")
    (find-video "/sda5/videos/Terpsichore/Gervaise: Branle de Bourgogne [vvNqCZwPJeQ].webm")
    (find-video "/sda5/videos/Terpsichore/Gervaise: Branle de Champagne [7ztoA68_19w].webm")
    (find-video "/sda5/videos/Terpsichore/Gesualdo: Gagliarda del Principe di Venosa [okZCecw3oho].webm")
    (find-video "/sda5/videos/Terpsichore/Gibbons: Galliard [dgCtAy-ET2Q].webm")
    (find-video "/sda5/videos/Terpsichore/Gulielmus: Bassa danza à 2 [fRGv5uw7dCI].webm")
    (find-video "/sda5/videos/Terpsichore/Haussmann: Catkanei [SRf_-mENO84].webm")
 (find-video "/sda5/videos/Terpsichore/Haussmann: Gaillarde [K8B_Y5x286A].webm")
    (find-video "/sda5/videos/Terpsichore/Haussmann: Paduan [N7A0OPNb9Co].webm")
    (find-video "/sda5/videos/Terpsichore/Haussmann: Tantz [zMecq-Tx_kY].webm")
    (find-video "/sda5/videos/Terpsichore/Holborne: Coranto \"Heigh - Ho Holiday\" [kdHFzfmCpXs].webm")
    (find-video "/sda5/videos/Terpsichore/Holborne: Noel's Galliard [Jb_R85RIHgw].webm")
    (find-video "/sda5/videos/Terpsichore/Holborne: Pavan - The Funerals [l3Jwx02dpN4].webm")
    (find-video "/sda5/videos/Terpsichore/Le Roy: Branle de Bourgogne [l8z4KhQCAjg].webm")
 (find-video "/sda5/videos/Terpsichore/Mainerio: Schiarazula Marazula [_neJYsPXgyI].webm")
    (find-video "/sda5/videos/Terpsichore/Mainerio: Tedesca - Saltarello [hXiqCJAPk-8].webm")
 (find-video "/sda5/videos/Terpsichore/Mainerio: Ungaresca - Saltarello [_JFXZBnNd94].webm")
    (find-video "/sda5/videos/Terpsichore/Milán: Pavana I & II [-15-a3g4kuA].webm")
    (find-video "/sda5/videos/Terpsichore/Molinaro: Ballo detto \"Il Conte Orlando\" - Saltarello [4EEp_6kAOO8].webm")
    (find-video "/sda5/videos/Terpsichore/Molinaro: Saltarello [M-5sDBOOrGk].webm")
    (find-video "/sda5/videos/Terpsichore/Mudarra: Romanesca Guarda me las vacas [YdOpEzQ-3dA].webm")
   (find-video "/sda5/videos/Terpsichore/Neusidler: Der Judentantz [lhI1pGOCqWE].webm")
 (find-video "/sda5/videos/Terpsichore/Neusidler: Welscher Tantz Wascha mesa - Hupfauff [6Y5ajWkwg9c].webm")
 (find-video "/sda5/videos/Terpsichore/Neusidler: Welscher Tantz Wascha mesa - Hupfauff [6Y5ajWkwg9c].webm" "0:51")
 (find-video "/sda5/videos/Terpsichore/Paix: Schiarazula Marazula [_IiJAibJmZ0].webm")
 (find-video "/sda5/videos/Terpsichore/Paix: Ungaresca - Saltarello [F7h8ZoQS_eM].webm")
    (find-video "/sda5/videos/Terpsichore/Phalèse: Passamezzo - Saltarello [byNpz5tbAaI].webm")
    (find-video "/sda5/videos/Terpsichore/Phalèse: Passamezzo d'Italye - Reprise - Gaillarde [05Ewg98huus].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Dances From Terpsichore - 1. Entrée - Courante [JKZgSA2seHM].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Dances From Terpsichore - 2. Gavotte [60G8Op3tRbA].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Dances From Terpsichore - 3. Spagnoletta [s3bK6r3zU_w].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Dances From Terpsichore - 4. La Bourée [xKD1_7_oFwo].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Dances From Terpsichore - 5. Ballet [UDpiRpczkM4].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Dances From Terpsichore - 6. Volte [RNArqV5PL58].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Galliarde de Monsieur Wustron [zop0e5MimnI].webm")
    (find-video "/sda5/videos/Terpsichore/Praetorius: Galliarde de la guerre [EiWjp3v_y68].webm")
 (find-video "/sda5/videos/Terpsichore/Praetorius: Reprinse [XFmT5CF6x7s].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 3 In A - 1. Pavane [EcqKLWlS0vA].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 3 In A - 2. Galliarde [_7Iz56MValk].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 3 In A - 3. Courante [Q-EHwPGvT4E].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 3 In A - 4. Allemande - Tripla [8NPpyZV7G9s].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 4 In D - 1. Pavane [vGVyrWw4pvw].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 4 In D - 2. Galliarde [skR0cGo0Nqs].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 4 In D - 3. Courante [SY8oMroXwcQ].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 4 In D - 4. Allemande - Tripla [NFN7yiBPPpQ].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 5 In G - 1. Pavane [-CMX3td1MUY].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 5 In G - 2. Galliarde [tvNWjmfZmzw].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 5 In G - 3. Courante [azpPzEs9Bq0].webm")
    (find-video "/sda5/videos/Terpsichore/Schein: Suite No. 5 In G - 4. Allemande - Tripla [EDy3zKNrN40].webm")
    (find-video "/sda5/videos/Terpsichore/Schmid d. Ä.: Englischer Tanz [f29dMav4JeA].webm")
    (find-video "/sda5/videos/Terpsichore/Schmid d. Ä.: Tanz Du hast mich wollen nemmen [aHaPODoJ8b0].webm")
    (find-video "/sda5/videos/Terpsichore/Susato: Ronde [EWgfr-pg0MI].webm")
    (find-video "/sda5/videos/Terpsichore/T. Simpson: Alman [P4ILllRYpuQ].webm")
    (find-video "/sda5/videos/Terpsichore/Torre: Alta danza à 3 [Ek2PEl-ibi0].webm")

# (find-fline "~/books/__music/")

(code-pdf-page "attaignant" "~/books/__music/IMSLP548673-PMLP445624-Attaingnant,_Pierre_-_Danceries_(1530).pdf")
(code-pdf-text "attaignant" "~/books/__music/IMSLP548673-PMLP445624-Attaingnant,_Pierre_-_Danceries_(1530).pdf")
(code-googlechrome-page "attaignant" "~/books/__music/IMSLP548673-PMLP445624-Attaingnant,_Pierre_-_Danceries_(1530).pdf")
;; (find-attaignantpage)
;; (find-attaignanttext)
;; (find-attaignantpage 6 "La gatta")
;; (find-attaignanttext 6 "La gatta")

(code-pdf-page "besardbranlegay" "~/books/__music/Branle Gay by Jean Baptiste Besard.pdf")
(code-pdf-text "besardbranlegay" "~/books/__music/Branle Gay by Jean Baptiste Besard.pdf")
(code-googlechrome-page "besardbranlegay" "~/books/__music/Branle Gay by Jean Baptiste Besard.pdf")
;; (find-besardbranlegaypage)
;; (find-besardbranlegaytext)

(code-pdf-page "neusidlerwelscher" "~/books/__music/IMSLP11519-Neusiedler_-_Welscher_tantz-Wascha_mesa_(Passamezzo).pdf")
(code-pdf-text "neusidlerwelscher" "~/books/__music/IMSLP11519-Neusiedler_-_Welscher_tantz-Wascha_mesa_(Passamezzo).pdf")
(code-googlechrome-page "neusidlerwelscher" "~/books/__music/IMSLP11519-Neusiedler_-_Welscher_tantz-Wascha_mesa_(Passamezzo).pdf")
;; (find-neusidlerwelscherpage)
;; (find-neusidlerwelschertext)

(code-pdf-page "paixschirazula" "~/books/__music/IMSLP501601-PMLP812385-Paix_Schirazula_Marazula.pdf")
(code-pdf-text "paixschirazula" "~/books/__music/IMSLP501601-PMLP812385-Paix_Schirazula_Marazula.pdf")
(code-googlechrome-page "paixschirazula" "~/books/__music/IMSLP501601-PMLP812385-Paix_Schirazula_Marazula.pdf")
;; (find-paixschirazulapage)
;; (find-paixschirazulatext)


https://www.discogs.com/release/6106777-Konrad-Ragossnig-Ulsamer-Collegium-Josef-Ulsamer-Terpischore-Tanzmusik-Der-Renaissance-Und-Des-Fr%C3%BCh

1 Lamento Di Tristano - Rotta 
Composed By – Anonym*
https://www.youtube.com/watch?v=hmw2foEz6uA

2 Trotto
Composed By – Anonym*
https://www.youtube.com/watch?v=RA6ItitWBJI

3 Saltarello
Composed By – Anonym*

4 Bassa Danse La Brosse - Tripla - Tourdion 
Edited By – Pierre Attaignant
https://www.youtube.com/watch?v=IrPJV2RLcAY

5 Bassa Danse La Gatta
Edited By – Pierre Attaignant
https://www.youtube.com/watch?v=WNyxF572ldE
https://www.youtube.com/watch?v=yCp3yZoyEm4

6 Bassa Danse La Magdalena
Edited By – Pierre Attaignant
https://www.youtube.com/watch?v=nYYbPM3gnjk

7 Calata Ala Spagnola
Composed By – Joan Ambrosio Dalza
Edited By – Petrucci*
https://www.youtube.com/watch?v=oaUjmv7qbjk

8 Der Judentanz
Composed By – Hans Neusiedler
Edited By – Hans Neusiedler

9 Welscher Tanz Wascha Mesa - Hupfauff
Composed By – Hans Neusiedler
Edited By – Hans Neusiedler
https://www.youtube.com/watch?v=6Y5ajWkwg9c

10 Ronde
Edited By – Tylman Susato*
https://www.youtube.com/watch?v=GkdlAPbX5es
https://www.youtube.com/watch?v=mzP276pU534

11 Branle De Bourgogne
Edited By – Claude Gervaise
https://www.youtube.com/watch?v=vvNqCZwPJeQ

12 Branle De Champagne
Edited By – Claude Gervaise
https://www.youtube.com/watch?v=7ztoA68_19w

13 Passamezzo D'Italye - Reprise - Gaillarde
Edited By – Pierre Phalèse
https://www.youtube.com/watch?v=05Ewg98huus
https://www.youtube.com/watch?v=TULqgXrsHUc

----

Tanzmusik Des Frühbarock	
14 Schiarazula Marazula
Composed By – Giorgio Mainerio

15 Tedesca - Saltarello
Composed By – Giorgio Mainerio

16 Ungaresca - Saltarello
Composed By – Giorgio Mainerio

17 Branle - Branle Gai
Composed By – Jean-Baptiste Besard

18 Mascherade
Composed By – Anonym*

19 Saltarello
Composed By – Simone Molinaro

20 Ballo Detto "Il Conte Orlando" - Saltarello
Composed By – Simone Molinaro

21 Gagliarda Del Principe Di Venosa
Composed By – Carlo Gesualdo Da Venosa*

22 Barriera
Composed By – Fabritio Caroso

23 Celeste Giglio
Composed By – Fabritio Caroso

24 Pavana De Spaigne
Composed By – Pierre Francisque Caroubel*

25 Courante
Composed By – Pierre Francisque Caroubel*

26 Courante
Composed By – Pierre Francisque Caroubel*

27 Volte
Composed By – Pierre Francisque Caroubel*

28 Volte
Composed By – Pierre Francisque Caroubel*

29 Pavan: The Funerals
Composed By – Anthony Holborne

30 Noel's Galliard
Composed By – Anthony Holborne

31 Coranto: Heigh Ho Holiday
Composed By – Anthony Holborne

32 Kemp's Jig
Composed By – Anonym*

33 Queen Elizabeth Her Galliard
Composed By – John Dowland

34 Mrs. Winter's Jump
Composed By – John Dowland

35 Alman
Composed By – Thomas Simpson

36 Galliard
Composed By – Orlando Gibbons

37 Galliarde De Monsieur Wustron
Composed By – Michael Praetorius

38 Galliarde De La Guerre
Composed By – Michael Praetorius
https://www.youtube.com/watch?v=4E5UgQjYxJQ

39 Reprinse
Composed By – Michael Praetorius
https://www.youtube.com/watch?v=XFmT5CF6x7s

40 Tantz
Composed By – Valentin Haussmann
https://www.youtube.com/watch?v=zMecq-Tx_kY

41 Paduan
Composed By – Valentin Haussmann
https://www.youtube.com/watch?v=N7A0OPNb9Co

42 Galliard
Composed By – Valentin Haussmann
https://www.youtube.com/watch?v=K8B_Y5x286A

43 Catkanei
Composed By – Valentin Haussmann
https://www.youtube.com/watch?v=SRf_-mENO84





https://www.sheetmusicplus.com/title/progressive-steps-to-syncopation-for-the-modern-drummer-sheet-music/3541603





# (find-status   "mpd")
# (find-vldifile "mpd.list")
# (find-udfile   "mpd/")




# (find-available "grandfatherclock")
# http://www.sourceforge.net/projects/grandfather/
#
# As a matter of fact, grandfatherclock can be configured to execute
# any command. The upstream default is simply to write a *.au file to
# a sound device file by using cat(1).
#
# Since cat is not a good sound player, the default is changed to use
# sox instead. grandfatherclock depends on sox to ensure that it can
# run under the default configuration. You also need a kernel support
# for a sound device to use grandfatherclock.


http://insanecoding.blogspot.com/2007/05/sorry-state-of-sound-in-linux.html


http://www.davep.org/emacs/festival.el

https://www.musicxml.com/music-in-musicxml/
https://github.com/MTG/SymbTr/releases/tag/v2.0.0 Turkish Makam Music Symbolic Data Collection






#  Local Variables:
#  coding:               utf-8-unix
#  End:
