#######
#
# E-scripts on net-related things.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/net.e>
#           or at <http://angg.twu.net/e/net.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######






# «.rfcs»		(to "rfcs")
# «.netcat»		(to "netcat")
# «.route»		(to "route")
# «.dig»		(to "dig")
# «.seashells»		(to "seashells")
# «.nmap»		(to "nmap")
# «.lsof»		(to "lsof")

# «.ctan_mirrors»	(to "ctan_mirrors")
# «.netselect»		(to "netselect")
# «.sniffit»		(to "sniffit")
# «.sendmail_conf_rh»	(to "sendmail_conf_rh")
# «.sendmail_conf»	(to "sendmail_conf")
# «.weblint»		(to "weblint")
# «.hping2»		(to "hping2")
# «.iwconfig»		(to "iwconfig")





#####
#
# RFCs
# 2004oct11
#
#####

# «rfcs»  (to ".rfcs")
# In 2004oct09 my connection went down for two days - the ethernet
# card was fine and I could ping myself, but I couldn't ping the
# gateway machine in my building, and the support guy didn't know how
# to fix it - so I started to collect links and texts... The next time
# something like that happens I'll try to learn how to do some
# low-level tests.

# (find-k24file "include/net/udp.h")
# (find-k24file "include/linux/udp.h")
# (find-k24file "net/ipv6/udp.c")
# (find-k24file "net/ipv4/netfilter/ip_nat_proto_udp.c")
# (find-k24file "net/ipv4/netfilter/ip_conntrack_proto_udp.c")
# (find-k24file "net/ipv4/udp.c")
# (find-k24file "net/ipv4/")

# (find-rfcfile "rfc0001.txt")

# (find-rfcfile "")
# TCP:    (find-rfcfile "rfc0793.txt")
# Layers: (find-rfcfile "rfc1122.txt")
# Layers: (find-rfcfile "rfc1122.txt" "[Page 76]" "UDP")
#         (find-rfcfile "rfc1123.txt")




#####
#
# kernel calls
# 2004dec25
#
#####

# (find-man "2 socket")
# (find-man "2 socketpair")
# (find-man "2 bind")
# (find-man "2 listen")
# (find-man "2 connect")
# (find-man "2 accept")

# (find-man "7 unix")
# (find-man "7 ip")
# (find-man "7 netlink")
# (find-man "7 packet")

# (find-man "2 path_resolution")
# (find-man "2 path_resolution" "search permission")




#####
#
# netcat
# 2004oct12
#
#####

# «netcat»  (to ".netcat")
# (find-status   "netcat")
# (find-vldifile "netcat.list")
# (find-udfile   "netcat/")
# (find-udfile "netcat/README.gz")
# (find-udfile "netcat/examples/data/")
# (find-udfile "netcat/examples/scripts/")
# (find-man "1 nc")

# (find-udfile "netcat/README.gz" ".rhosts")
# (find-udfile "netcat/README.gz" "syslogger")

# (find-eev "examples/eev-tests.e" "eechannel")

# https://blog.ikuamike.io/posts/2021/netcat/



#####
#
# route
# 2023nov05
#
#####

# «route»  (to ".route")
# (find-man "8 route")
# (find-esgrep "grep --color=auto -nH --null -e route *.e")
# (find-man "arp")
# (find-man "rarp")
# (find-man "ip")



#####
#
# dig
# 2023nov05
#
#####

# «dig»  (to ".dig")
# (find-man "1 dig")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
dig denis.com.br



#####
#
# seashells
# 2021oct18
#
#####

# «seashells»  (to ".seashells")
# https://news.ycombinator.com/item?id=28901580 Seashells: Pipe output from command-line programs to the web in real-time
# https://seashells.io/
# https://github.com/anishathalye/seashells






#####
#
# nmap: finding which ports have daemons listening
# 2004dec18
#
#####

# «nmap»  (to ".nmap")
# (find-status   "nmap")
# (find-vldifile "nmap.list")
# (find-udfile   "nmap/")
# (find-udfile   "nmap/nmap.usage.txt.gz")
# (find-man "1 nmap")
# (find-man "1 nmap" "-P0")
# (find-man "1 nmap" "-v")
# (find-man "1 nmap" "-O")
# (find-man "1 nmap" "-sS")
# (find-man "1 nmap" "-sV")

# (find-sh "nmap -P0 localhost")
# (find-sh "nmap -v -v localhost")

nmap 127.0.0.1
nmap -v -sS -O 127.0.0.1




#####
#
# lsof
# 2007may17
#
#####

# «lsof»  (to ".lsof")
# (find-status   "lsof")
# (find-vldifile "lsof.list")
# (find-udfile   "lsof/")

# (find-esgrep "grep -nH -e lsof *.e")
# (find-es "modem" "efax" "lsof | grep /dev/")
# (find-es "x" "xfs0" "lsof | grep $(pidof xfs)")

# (find-node "(zsh)Redirection" "preceded by a digit")
# (find-sh "lsof")
# (find-sh "lsof 2> /dev/null ")
# (find-sh "lsof              | awk '$5==\"IPv4\"'")
# (find-sh "lsof 2> /dev/null | awk '$5==\"IPv4\"'")
# (find-sh "lsof |& awk '$5==\"IPv4\"'")
# (find-man "8 lsof")
# (find-man "8 lsof" "``IPv4'' for an IPv4 socket")

# 2011aug11:

# (find-udfile "lsof/00DIST.gz")
# (find-udfile "lsof/00FAQ.gz")
# (find-udfile "lsof/README.Debian")
# (find-udfile "lsof/README.Debian-source")
# (find-udfile "lsof/changelog.Debian.gz")
# (find-udfile "lsof/copyright")
# (find-udfile "lsof/examples/00MANIFEST")
# (find-udfile "lsof/examples/00README")
# (find-udfile "lsof/examples/big_brother.perl5.gz")
# (find-udfile "lsof/examples/count_pf.perl")
# (find-udfile "lsof/examples/count_pf.perl5")
# (find-udfile "lsof/examples/identd.perl5")
# (find-udfile "lsof/examples/idrlogin.perl.gz")
# (find-udfile "lsof/examples/idrlogin.perl5.gz")
# (find-udfile "lsof/examples/list_NULf.perl5.gz")
# (find-udfile "lsof/examples/list_fields.awk.gz")
# (find-udfile "lsof/examples/list_fields.perl.gz")
# (find-udfile "lsof/examples/shared.perl5.gz")
# (find-udfile "lsof/examples/sort_res.perl5")
# (find-udfile "lsof/examples/watch_a_file.perl")
# (find-udfile "lsof/examples/xusers.awk")

# (find-man "8 lsof")
# (find-man "8 lsof" "\nOUTPUT FOR OTHER PROGRAMS\n")
# (find-sh "lsof -h")
# (find-sh "lsof -F '?'")
# (find-sh "sudo lsof")







#####
#
# CTAN mirrors
#
#####

# «ctan_mirrors»  (to ".ctan_mirrors")
# (find-fline "$SCTAN/")
# (find-fline "$SCTAN/ls-lR.i")

mynetselect $(grep '^  [a-z]' $SCTAN/CTAN.sites | awk '{print $1}')






#######
#
# netselect (old notes)
#
#######

# «netselect»  (to ".netselect")
# (find-es "apt" "netselect-apt")

# (find-vldifile "netselect.list")
# (find-fline "/usr/doc/netselect/")
# (find-fline "/usr/doc/netselect/README.gz")

# Debian mirrors:
#
cd /usr/doc/netselect/examples/
netselect -vvv $(cat debian-ftp-mirrors)	|& tee ~/o
agrep ' ok ' < ~/o \
  | awk '{printf "%s %s %s\n",
            substr($0, 73), substr($0, 39, 33), substr($0, 1, 37)}' \
  | sort -r \
  | tee ~/o2

# (find-fline "~/o2")
# (find-fline "/usr/doc/netselect/examples/debian-ftp-mirrors")
# (find-fline "/big/slinkb1/README.mirrors.txt")

# CPAN mirrors:
#
getlinks < $S/http/www.perl.com/CPAN/SITES.html |& tee ~/o3
perl -nle 'm%.*://([.0-z-]+)/.*% && print $1' < ~/o3 | sort | uniq > ~/o2
netselect -vvv $(<~/o2)	|& tee ~/o
agrep ' ok ' < ~/o \
  | awk '{printf "%s %s %s\n", substr($0, 73), substr($0, 39, 33), substr($0, 1, 37)}' \
  | sort -r \
  | tee ~/o2

# (find-fline "~/o2")
# (find-fline "~/o3")

ftp://ftp.cdrom.com/pub/perl/CPAN/



pdsc /debian/dists/slink/main/source/net/netselect_0.2-3.dsc
cd /usr/src/netselect-0.2/
make |& tee om
# Uh-oh - it's suid root, can't install it at my university account


# Novo esquema:
# (find-fline "~/.zshrc" "netselect")
mynetselect $(cat /usr/doc/netselect/examples/debian-ftp-mirrors)

# (find-fline "/big/slinkb1/README.mirrors.txt")





#######
#
# dip + expect
#
#######

# (find-fline "~/bin/inx.dip")
# (find-fline "~/EXPECT/inx")

  port ttyS2
  speed 115200
  netmask 255.255.255.0

  reset

# Meu string de inicializacao para o USR Sportster 14400:
#
  send ATL3&A3&B1&H1&R2&S0=0X3\r
  wait OK 1
  send ATDT///////5126882\r

#  inx:	512-688[012349]
#	512-689[0126789]
#	512-690[456]

  wait CONNECT 60
  if $errlvl != 0 goto error

login:
  wait rname: 10

edrx:
# wait 1
# send spg\r
  send edrx\r
  if $errlvl != 0 goto error

  wait ord: 10
  if $errlvl != 0 goto error
  send xxxxxxxx\n

  wait ing\sPPP
  if $errlvl != 0 goto error

  done:
  print CONNECTED $locip ---> $rmtip

loggedin:
  default

done:
  print CONNECTED to $remote with address $rmtip
  mode PPP
  exit

error:
  print PPP to $remote failed.





#######
#
# urlget 3.12
#
#######

cd /usr/src/
rm -Rv urlget-3.12/
tar -xvzf /snarf/http/www.inf.ufrgs.br/~sagula/urlget-3.12.tar.gz
cd /usr/src/urlget-3.12/
make |& tee om




#####
#
# The dummy net device
#
#####

# (find-k22file "Documentation/Configure.help" "Dummy net driver")
# (find-k2file "drivers/net/loopback.c")
# (find-k2file "drivers/net/dummy.c")

insmod $MODULES/dummy.o
ifconfig dummy 33.44.22.11 up

ifconfig dummy down

route add -net 99.0.0.0 netmask 255.0.0.0 dev lo

route add 99.0.0.0 netmask 255.0.0.0 gw localhost dev lo
route del 99.0.0.0


/etc/init.d/netstd_init	stop
/etc/init.d/netbase	stop
/etc/init.d/netstd_misc	stop

/etc/init.d/netstd_init	start
/etc/init.d/netbase	start
/etc/init.d/netstd_misc	start




######
#
# News
#
######

(load-library "gnus")
# (find-node "(gnus)Summary Post Commands")
# (find-node "(gnus)Article Caching")
# (find-efile "gnus.el")
# (find-efile "nntp.el")

cd /usr/share/emacs/19.34/lisp/
agrep '^\(' nntp.el

# (find-fline "/snarf/ftp/rtfm.mit.edu/pub/usenet/news.software.readers/")
# (find-fline "/snarf/ftp/rtfm.mit.edu/pub/usenet/news.software.readers/Gnus_(Emacs_Newsreader)_FAQ" ": Q1.12")




######
#
# Sending mail with the correct "from" field
#
######

sendmail -fFritz.Cohen@somewhere.zz -Fedrx edrx@mat.puc-rio.br <<'EOF'
blip blip
poo
EOF

(find-efile "sendmail.el")
(find-enode "Sending Mail")
(find-etag "mail-send")
(find-etag "sendmail-send-it")




#######
#
# sendmail configuration (RedHat; old)
#
#######

# «sendmail_conf_rh»  (to ".sendmail_conf_rh")

# I use "DMmat.puc-rio.br"

# (find-fline "/etc/sendmail.cf" "my official domain name")
# (find-fline "/etc/sendmail.cf" "\nDM")
# (find-fline "/big/a42/live/usr/doc/sendmail/RELEASE_NOTES" "masq")
# (find-sendmfile "cf/README" "who I claim to be")
# (find-sendmfile "cf/README" "TION To M4")
# (find-sendmfile "src/conf.c")
# (find-sendmfile "src/macro.c" "DEFINE --")
# (find-sendmfile "src/main.c" "\ninitmacros")

groff -Tascii -me /big/a42/live/usr/doc/sendmail/doc/op/op.me | l

/etc/rc.d/init.d/sendmail.init stop
/etc/rc.d/init.d/sendmail.init start





#######
#
# sendmail configuration (Slink)
# 00jan11
#
#######

# «sendmail_conf»  (to ".sendmail_conf")

# (find-vldifile "sendmail.list")
# (find-vldifile "" "sendmail")
# (find-vldifile "sendmail.postinst")
# (find-fline "/usr/doc/sendmail/")

# (find-fline "/usr/share/sendmail.cf/feature/")

# *ARGH*, I lost fetchmail'ed mail due to a misconfigured sendmail!
# I have to be much more careful the next time...

# (find-vldifile "s






######
#
# Sniffit 0.3.5
#
######

cd /usr/src/
rm -Rv sniffit.0.3.5/
tar -xvzf /snarf/http/reptile.rug.ac.be/~coder/sniffit/files/sniffit.0.3.5.tar.gz
cd sniffit.0.3.5/
tar -xvf /snarf/http/reptile.rug.ac.be/~coder/sniffit/files/sniffit.0.3.5.p1.tar
patch < sniffit.0.3.5.patch.1 |& tee op
cp -v sniffit.5 /usr/man/man5/
cp -v sniffit.8 /usr/man/man8/
cp -iv /home/root/config.cache .
./configure |& tee oc
make |& tee om

# using:
# (find-fline "/usr/src/sniffit.0.3.5/README.FIRST" 160)
# (find-fline "/usr/src/sniffit.0.3.5/PLUGIN-HOWTO" 155)

sniffit -t @ -a -b -d -x	|& tee o
sniffit -t @ -a -b		|& tee oasc
sniffit -M1 -N -P UDP -t @



#####
#
# sniffit
# 2011oct13
#
#####

# «sniffit»  (to ".sniffit")
# (find-zsh "grep-available sniffer")
# http://reptile.rug.ac.be/~coder/sniffit/
# (find-status   "sniffit")
# (find-vldifile "sniffit.list")
# (find-udfile   "sniffit/")
# (find-man "5 sniffit")
# (find-man "8 sniffit")
# (find-udfile "sniffit/PLUGIN-HOWTO.gz")
# (find-udfile "sniffit/README.FIRST.gz")
# (find-udfile "sniffit/README.FIRST.gz" "-t <IP nr/name>")
# (find-udfile "sniffit/examples/dns_plugin.plug.gz")
# (find-udfile "sniffit/examples/dummy_plugin.plug")
# (find-udfile "sniffit/examples/sample_config_file")
# (find-udfile "sniffit/sniffit-FAQ")

# (find-sh "sudo iwconfig")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo sniffit -t @ -a -b -d -x
sniffit -t @ -a -b
sniffit -M1 -N -P UDP -t @

sudo sniffit --help
sudo sniffit -h
sudo sniffit -t @
sudo sniffit -P tcp
sudo sniffit -a -F wlan0




#######
#
# old java links
#
#######

http://www.blackdown.org/java-linux.html
http://www.blackdown.org/java-linux/docs/faq/FAQ-java-linux.htm
http://www.cs.utsa.edu/research/plss.html
http://www.redhat.com/linux-info/jolt/
http://www.transvirtual.com/kaffe/
http://www.transvirtual.com/kaffe/faq.html
http://www.webteacher.com/javatour.htm
http://www.best.com/~pvdl/javafaq.html

http://www.lesstif.org/
http://www.bcpl.lib.md.us/~jspath/usenet-newbie.html





##########
#
# ppp over minicom
#
##########

(find-fline "/usr/doc/HOWTO/mini/PPP-over-minicom" 107)
(find-fline "/etc/ppp/options")

(write-heredoc "/etc/ppp/mini_options")
asyncmap 0
lock
defaultroute
noipdefault
crtscts
modem
EOF

# Why? Well, strace'ing dip we see this:
#
# execve("/usr/sbin/pppd", ["pppd", "-detach", "defaultroute",
# "noipdefault", "crtscts", "modem"], [/* 38 vars */]) = 0
#
# which, by the way, corresponds to this source line:
#
# (find-fline "/usr/src/redhat/BUILD/dip-3.3.7o/ppp.c")
#
# I don't remember where did I get the asyncmap/lock lines from, maybe
# (find-fline "/c1/home/root/Tips/PPP-Client-HOWTO-11.html" 118)
# (find-fline "/c1/home/root/Tips/PPP-Client-HOWTO-14.html" 71)
# (find-fline "/c1/home/root/Tips/PPP-Tips-7.html")
# (find-fline "/usr/doc/HTML/ldp/PPP-HOWTO-12.html")
# (find-fline "/usr/doc/HTML/ldp/PPP-HOWTO-13.html" 52)
# (find-fline "/usr/doc/HTML/ldp/PPP-HOWTO-26.html" 118)
# (find-fline "/usr/doc/HTML/ldp/ISP-Hookup-HOWTO-6.html" 31)


/usr/sbin/pppd file /etc/ppp/mini_options < /dev/cua2 > /dev/cua2 &

laf -R /var/lock /var/run


Esse é o do INX:

(write-heredoc "/etc/resolv.conf")
search .
nameserver 200.240.18.1
EOF


Esse é o do Plugue:

(write-heredoc "/etc/resolv.conf")
search .
nameserver 200.255.50.117
nameserver 200.255.253.241
EOF

cd /etc/rc.d/init.d/

/etc/rc.d/init.d/inet stop
/etc/rc.d/init.d/inet start

smtp mail.plugue.com.br
pop  mail.plugue.com.br




######
#
# less (at saci)
#
######

mkdir -p ~/ftp/prep.ai.mit.edu/pub/gnu
cd       ~/ftp/prep.ai.mit.edu/pub/gnu
wget     ftp://prep.ai.mit.edu/pub/gnu/
wget     ftp://prep.ai.mit.edu/pub/gnu/less-332.tar.gz

rm -Rv ~/less-332
cd ~
tar -xvzf ~/ftp/prep.ai.mit.edu/pub/gnu/less-332.tar.gz
cd ~/less-332/
./configure |& tee oc
make |& tee om

cp -iv less ~/bin-AIX/




######
#
# apache-1.3.0 (with -g)
#
######

debsource /debian/main/source/web apache 1.3.0 -2
# (find-apafile "debian/rules")
# find * -type f | glimpseindex -H . -F

make -f debian/rules stamp-configure		|& tee omsc
make LDFLAGS_SHLIB="-Bshareable -lc" OPTIM="-g"	|& tee om
debian/rules binary				|& tee odrb

# Parece que o debhelper stripa os binários...
# (find-apafile "odrb" "dh_strip")
# (find-fline "/usr/doc/debhelper/")

# Só que eu me lembrei que os cgis não podem ser owned by root, e isso
# resolve o problema. O debugamento fica para outro dia.

# (find-apafile "src/main/http_protocol.c" "You don't")
# (find-fline "/usr/doc/lsof/")
# (find-fline "/usr/doc/lsof/00QUICKSTART.gz" "\n13.")
# (find-fline "/var/run/")
# (find-fline "/var/run/apache.pid")
ps ax --sort=pgrp
pstree -pu

mycat /var/lib/dpkg/info/apache.*

# (find-fline "/usr/doc/apache/examples/")
# (find-fline "/var/log/apache/error.log")





########
#
# devinfo
#
########

# (find-fline "/snarf/http/sunsite.unc.edu/pub/Linux/ls-lR" "devinfo.tar.gz")
# (find-fline "$SUNSITE/ls-lR" "devinfo.tar.gz")

rm -Rv /usr/src/devinfo/
cd /usr/src/
tar -xvzf $SUNSITE/system/network/misc/devinfo.tar.gz
cd /usr/src/devinfo/
gcc -o devinfo devinfo.c
gcc -o gethost gethost.c
gcc -o netmath netmath.c
cp -v *.8 /usr/man/man8/
cp -v devinfo gethost netmath /usr/bin/





######
#
# configuring hostname, ip address, etc
#
######

man ifconfig
man route
man netstat

# (find-fline "/etc/rc.d/init.d/network")
# (find-fline "/etc/sysconfig/network")

find /etc/rc.d/ /etc/sysconfig/ -type f

man init

# (find-fline "/etc/inittab" "si::")
#   (find-fline "/etc/rc.d/rc.sysinit")
#     (find-fline "/etc/sysconfig/network")
#     (find-fline "/var/log/dmesg")
#   (find-fline "/etc/rc.d/rc3.d/")
#     (find-fline "/etc/rc.d/init.d/network")
#       (find-fline "/etc/sysconfig/network-scripts/")
#       (find-fline "/etc/sysconfig/network-scripts/ifup")
#     (find-fline "/etc/rc.d/init.d/inet")
#       (find-fline "/etc/rc.d/init.d/functions")
#       (find-fline "/etc/sysconfig/network")

#       (find-fline "/etc/rc.d/init.d/network")

# (find-node "(zsh)Array Parameters")

F=(`find /etc/rc.d/ /etc/sysconfig/ -type f`)
agrep route $F
agrep ifconfig $F
agrep netstat $F

agrep -l 'ifconfig|netstat|route' $F





#####
#
# plip device
#
#####

# O que é o tal do device plip0? É um symlink?

cd /cdrom/
cp -diPv $(<<'---'
debian/main/source/base/makedev_1.6-32.diff.gz
debian/main/source/base/makedev_1.6-32.dsc
debian/main/source/base/makedev_1.6.orig.tar.gz
---) /
debsource /debian/main/source/base makedev 1.6 -32

# (find-k2file "Documentation/devices.txt")
# (find-k2file "include/linux/major.h")
# (find-fline "/etc/devinfo")
# (find-fline "/etc/makedev.cfg")
man devinfo
man makedev.cfg

# (find-k2file "drivers/cdrom/mcd.c" "MAJOR_NR")
# (find-k2file "drivers/cdrom/mcd.c" "register_blkdev(")
# (find-k2tag "register_blkdev")




#######
#
# cipe
#
#######

# (find-fline "/etc/cipe/")
# (find-fline "/etc/cipe/options")

cd /proxy/home/var/src/cipe-1.0.0/
insmod cip3b

cd ~/cipe-1.0.0/
ciped

telnet 10.0.1.1 12345

telnet 10.0.1.88

ps ax | grep cipe

# (find-fline "/proxy/home/var/src/cipe-0.5.3/")
# (code-c-d "cipe" "/proxy/home/var/src/cipe-0.5.3/" "/proxy/home/var/src/cipe-0.5.3/cipe")

# (find-cipenode "Top")
# (find-cipenode "insmod")

cd ~
rm -Rv cipe-1.0.0/
tar -xvzf /proxy/home/var/src/cipe-0.5.3/cipe-1.0.0.tar.gz
cd ~/cipe-1.0.0/
make |& tee om



cd /
tar -cvzf ~/r2hsep3.tgz /proxy/etc/cipe /etc/cipe ~/CRIM/009ideas \
  /proxy/home/var/src/cipe-0.5.3/cipe-1.0.0.tar.gz


Problemas: não sei usar o kerneld, o msdos.o depende de um monte de
módulos, não sei configurar o empilhamento automático, etc.

O apache está reclamando de estar proibido de rodar os cgis.

Quero ser capaz de carregar arquivos dos CDs da Debian mais
facilmente. Quero ser capaz de mudar o repeat rate do teclado.

O samba depende de uns pacotes básicos, como pam0 e libc5; quando eu
tento intalá-lo eu me embaralho. Qual o modo standard? Dar um jeito de
lidar com as dependências.

Apagar as coisas desnecessárias da Debian do amendoim.




######
#
# cipe at angg
#
######

rm -Rv /usr/src/cipe-1.0.0/
cd /usr/src/
tar -xvzf ~/cipe/proxy/home/var/src/cipe-0.5.3/cipe-1.0.0.tar.gz
cd /usr/src/cipe-1.0.0/

# (find-fline "/usr/src/cipe-1.0.0/")
# (find-fline "/usr/src/cipe-1.0.0/Make")
# (find-node "(make)Top")
# (find-node "(make)Overriding")
# (find-fline "/etc/cipe/options")

make MODVERSIONS= |& tee om
cp cipe.info /usr/info/

#
# Esses são os que funcionam (ou pelo menos funcionaram na terça na raven):
#
telnet 200.240.24.219 12345
telnet 200.240.24.209 12345

kill $(ps ax | grep 'cip[e3]' | awk '{print $1}')
rmmod cip3b

ifconfig
route
ps ax | grep 'cip[e3]'

cd /usr/src/cipe-1.0.0/
insmod cip3b.o
ciped

ping 10.0.1.1

cd /var/log/
cat daemon.log kern.log messages syslog | grep -i 'cip[e3]' |
  sort | tail -n 100

perl 

# (find-k2file "Documentation/Configure.help")

CONFIG_IP_FORWARD
CONFIG_NET_IPIP



# (find-fline "~/cipe/proxy/etc/cipe/")
# (find-fline "/etc/cipe/")
# (find-fline "/etc/cipe/options")

# (find-fline "/var/log/daemon.log" "ciped")
# (find-fline "/var/log/kern.log")
# (find-fline "/var/log/messages")
# (find-fline "/var/log/syslog")

# (find-fline "/usr/src/cipe-1.0.0/ciped.c" "kxchg: recv")


cd /var/log/
grep -i 'cip[e3]' daemon.log
grep -i 'cip[e3]' kern.log
grep -i 'cip[e3]' messages
grep -i 'cip[e3]' syslog



telnet 209.130.76.158 12345
telnet 209.130.17.167 12345

route del 10.0.1.88
route del 10.0.1.99
  route add 10.0.1.88 cip3b0
# route add 10.0.1.99 cip3b0
ping -c 5 10.0.1.88
ping -c 5 10.0.1.99

# (find-node "(cipe)Top")
# (find-fline "/etc/cipe/options")

cd /usr/src/cipe-1.0.0/
insmod cip3b.o
ciped

ps ax | grep ciped
cat /proc/modules
sleep 2
ifconfig
route



lynx http://209.130.76.158/
lynx http://209.130.17.167/

telnet ol24-219.openlink.com.br 12345
telnet 10minutos.openlink.com.br 12345

# ol24-219.openlink.com.br:  200.240.24.219  <- maus
# 10minutos.openlink.com.br: 209.130.17.167






#######
#
# wwwoffle
#
#######

# (find-fline "/var/lib/dpkg/info/wwwoffle.list")
# (find-fline "/usr/doc/wwwoffle/")
# (find-fline "/etc/wwwoffle.conf")
# (find-fline "/var/spool/wwwoffle/")

pdsc /debian/main/source/web/wwwoffle_2.1c-1.dsc
cd /usr/src/wwwoffle-2.1c/
etags *.[ch]

# (code-c-d "wo" "/usr/src/wwwoffle-2.1c/")
# (find-wotag "main")
# (find-wofile "wwwoffled.c")
# (find-wofile "upgrade-cache.c")

# (find-fline "~/.zshrc" "wwwoffle")
export http_proxy=http://localhost:8080/
export ftp_proxy=http://localhost:8080/

        Set the environment variables http_proxy and ftp_proxy to
        http://localhost:8080/


# (find-fline "/var/lib/dpkg/info/lynx.list")
# (find-fline "/usr/doc/lynx/")


# (find-fline "~edrx/.netscape/preferences.js")
user_pref("network.proxy.http", "localhost");
user_pref("network.proxy.http_port", 8080);


mail majordomo@gedanken.demon.co.uk <<'---'
subscribe wwwoffle-users
---

mail majordomo@gedanken.demon.co.uk <<'---'
auth 68101fda subscribe wwwoffle-users edrx@inx.com.br (Eduardo Ochs)
---



#####
#
# Links between dirs of Debian mirrors
# (old)
#
#####

ftp://riksun.riken.go.jp/pub/Linux/debian/debian
ftp://riksun.riken.go.jp/pub/Linux/debian/debian-non-US

psne ftp://riksun.riken.go.jp/pub/Linux/debian/debian-non-US/ls-lR.gz

function mksymlink () {
  mkdir -p $1 && cd $1 && [[ ! -e $2 ]] && ln -s $3 $2 && echo ok. && laf
}
mksymlink $S/ftp/riksun.riken.go.jp/pub/Linux/debian debian \
	  $S/ftp/ftp.debian.org/debian
mksymlink $S/ftp/riksun.riken.go.jp/pub/Linux/debian debian-non-US \
	  $S/ftp/ftp.debian.org/debian-non-US
mksymlink $S/ftp/slug.ctv.es debian \
	  $S/ftp/ftp.debian.org/debian

psne $FDEBIAN/ls-lR.gz

cd $SDEBIAN
gzip -dv ls-lR.gz
~/ICON/lslR2find < ls-lR > ls-lR.i
agrep non-free ls-lR.i | nolinks > ls-lR-nf.i





#######
#
# weblint
#
#######

# «weblint»  (to ".weblint")
# (find-es "net" "latte")

# (find-vldifile "weblint.list")
# (find-fline "/usr/doc/weblint/")
# (find-fline "/usr/bin/weblint")

cd ~/latte/
weblint out/*.html

cd ~/latte/
weblint out/




#######
#
# linbot
#
#######

# (find-vldifile "linbot.list")
# (find-fline "/usr/doc/linbot/")

lynx /usr/doc/linbot/index.html




#######
#
# allowing anonymous ftp
#
#######

# (eeman "ftpd" "authenticates")
rm -Rv /home/ftp
mkdir /home/ftp
cd /home/ftp
mkdir bin etc pub lib
cd /home/ftp/bin
ln -v /bin/ls /sbin/ldconfig .
cd /home/ftp/lib
ln -v /lib/libc.so.6 /lib/libc-2.1.1.so .
ln -v /lib/ld-linux.so.2 /lib/ld-2.1.1.so .
cd /home/ftp/etc
cp -iv /etc/passwd /etc/group .

chroot /home/ftp /bin/ldconfig /lib
chroot /home/ftp /bin/ls

~/EXPECT/anonftp 127.0.0.1 dir quit

# (find-fline "/etc/passwd" "ftp")




#####
#
# libpcap
#
#####

apti libpcap0 libpcap-dev
# (find-vldifile "libpcap0.list")
# (find-vldifile "libpcap-dev.list")
# (find-fline "/usr/doc/libpcap0/")
# (find-fline "/usr/doc/libpcap-dev/")

pdsc /big/slinks2/dists/slink/main/source/libs/libpcap_0.4a6-2.1.dsc
cd /usr/src/libpcap-0.4a6/





#####
#
# hping2
# 2001feb02
#
#####

# «hping2»  (to ".hping2")
# (find-available "hping2")
# (find-available "hping3")




#####
#
# iwconfig
# 2014jan23
#
#####

# «iwconfig» (to ".iwconfig")
# (find-man "8 iwconfig")
# (find-status   "wireless-tools")
# (find-vldifile "wireless-tools.list")
# (find-udfile   "wireless-tools/")
# (find-man "8 iwlist")
# (find-sh "sudo iwlist scan")




# 2013nov16:
# (find-esgrep "grep -niH -e network *.e | grep -i manager")
# http://canyouseeme.org/

# (find-man "8 mtr")
# (find-sh "locate bin/mtr")

https://news.ycombinator.com/item?id=27973020 Netcat – All you need to know (ikuamike.io)
https://news.ycombinator.com/item?id=34623604 tcpdump is amazing (2016) (jvns.ca)
https://news.ycombinator.com/item?id=34875109 Computer Networking Introduction: Ethernet and IP – Heavily Illustrated (2021) (iximiuz.com)
https://jvns.ca/blog/2013/10/31/day-20-scapy-and-traceroute/





#  Local Variables:
#  coding:               utf-8-unix
#  End:
