#######
#
# E-scripts on network-manager.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/networkmanager.e>
#           or at <http://angg.twu.net/e/networkmanager.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######






# «.mailing-list»	(to "mailing-list")
# «.irc»		(to "irc")
# «.network-manager»	(to "network-manager")
# «.connections»	(to "connections")
# «.daemon»		(to "daemon")
# «.nm-applet»		(to "nm-applet")
# «.network-manager-deb-src»	(to "network-manager-deb-src")
# «.wicd»		(to "wicd")
# «.git»		(to "git")
# «.gnutls»		(to "gnutls")
# «.nss»		(to "nss")
# «.nmcli»		(to "nmcli")




# (find-initdfile "network-manager")

# https://wiki.debian.org/NetworkManager
# https://wiki.debian.org/NetworkManager#Wired_Networks_are_Unmanaged
# (find-fline "/usr/share/doc/network-manager-gnome/README.Debian")

# (find-esgrep "grep -niH -e network *.e")
# (find-es "gnome" "network-manager")

# (find-zsh "installeddebs | sort | grep network-manager")
# (find-zsh "availabledebs | sort | grep network-manager")

# (find-status   "network-manager-gnome")
# (find-vldifile "network-manager-gnome.list")
# (find-udfile   "network-manager-gnome/")





#####
#
# mailing list
# 2019jan13
#
#####

# «mailing-list» (to ".mailing-list")
# https://wiki.gnome.org/Projects/NetworkManager
# https://gitlab.freedesktop.org/NetworkManager/NetworkManager.git
# https://mail.gnome.org/mailman/listinfo/networkmanager-list
# https://mail.gnome.org/archives/networkmanager-list/




#####
#
# irc
# 2019jan13
#
#####

# «irc» (to ".irc")
# irc://irc.freenode.net/nm



#####
#
# network-manager (the debian package)
# 2013nov25
#
#####

# «network-manager» (to ".network-manager")
# (find-status   "network-manager")
# (find-vldifile "network-manager.list")
# (find-udfile   "network-manager/")
# (find-man "8 NetworkManager")
# (find-man "5 NetworkManager.conf")
# (find-man "5 nm-system-settings.conf")
# (find-man "1 nm-online")
# (find-man "1 nm-tool")
# (find-man "1 nmcli")
# (find-man "1 nmcli" "unable to supply the secrets")
# (find-man "1 nmcli" "COMMAND := { list | status | up | down | delete }")
# (find-man "1 nmcli" "COMMAND := { status | list | disconnect | wifi }")

# (find-man "8 NetworkManager")
# (find-man "5 nm-settings")
# (find-man "5 nm-system-settings.conf")
# (find-man "5 nm-settings-keyfile")
# (find-man "5 NetworkManager.conf")
# (find-man "1 nmtui-connect")
# (find-man "1 nmcli")
# (find-man "1 nm-online")
# (find-man "1 nmtui-hostname")
# (find-man "1 nmtui")
# (find-man "1 nmtui-edit")
# (find-man "7 nmcli-examples")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
nmcli
nmcli general
nmcli radio
nmcli connection
nmcli device

nmcli nm
# (find-sh0 "nmcli nm")
# (find-sh "nmcli con")
# (find-sh "nmcli con wifi")
# (find-sh "nmcli con list")
# (find-sh "nmcli dev")
nmcli -p nm
nmcli nm
nmcli dev list

# (find-fline "/usr/share/nm-applet/")




#####
#
# Connections and their passwords
# 2017fev07
#
#####

# «connections» (to ".connections")
# (find-fline "/etc/NetworkManager/system-connections/")
# (find-asrootfile "/etc/NetworkManager/system-connections/")
# (find-asrootfile "/etc/NetworkManager/system-connections/eduardo")
# (find-asrootfile "/etc/NetworkManager/system-connections/eduardo" "psk=")
# (find-asrootfile "/etc/NetworkManager/system-connections/Apokos")
# (find-asrootfile "/etc/NetworkManager/system-connections/Sganzerla")
# (find-asrootfile "/etc/NetworkManager/system-connections/AndroidAP")
# (find-asrootfile "/etc/NetworkManager/system-connections/PLUSNET-JSXJ")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
locate system-connections
locate eduardo

# https://developer.gnome.org/NetworkManager/unstable/nm-settings-keyfile.html file format
# https://askubuntu.com/questions/368560/what-is-the-structure-of-network-managers-system-connections-files
# https://superuser.com/questions/863800/how-to-configure-a-new-networkmanager-connection-from-a-shell-script-command-lin
# (find-man "5 nm-settings")
# (find-man "5 nm-settings" "psk")
# https://arstechnica.com/civis/viewtopic.php?t=1163023 Howto deal with Network Manager completely from the command line.





#####
#
# The daemon
# 2013nov25
#
#####

# «daemon» (to ".daemon")
# (find-initdfile "network-manager")
# (find-fline "/etc/rc2.d/" "network-manager")
# (find-man "8 NetworkManager")
# (find-man "8 NetworkManager" "D-Bus")
# (find-man "8 NetworkManager" "--no-daemon")
# (find-man "8 NetworkManager" "--log-level=<level>")
# (find-man "5 NetworkManager.conf")
# (find-man "5 NetworkManager.conf" "[logging]")
# (find-asrootfile "/etc/NetworkManager/")
# (find-asrootfile "/etc/NetworkManager/NetworkManager.conf")
# (find-asrootfile "/etc/NetworkManager/system-connections/")
# (find-asrootfile "/etc/NetworkManager/system-connections/Eduardo")
# (find-fline "/var/run/NetworkManager.pid")
# (find-fline "/usr/sbin/" "NetworkManager")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-initdfile "network-manager")
# (find-fline "/lib/lsb/init-functions")

sudo /etc/init.d/network-manager stop
sudo /etc/init.d/network-manager start

sudo /etc/init.d/network-manager stop
sudo NetworkManager --no-daemon --plugins=ifupdown,keyfile --log-level=INFO

sudo /etc/init.d/network-manager start



#####
#
# nm-applet
# 2013nov25
#
#####

# «nm-applet» (to ".nm-applet")
# (find-zsh "dmissing nm-applet")




#####
#
# network-manager (from the debian sources)
# 2013dec01 / 2019jan13
#
#####

# «network-manager-deb-src» (to ".network-manager-deb-src")

# 2019:
# (find-es "apt" "apt-get-source")
# https://packages.debian.org/sid/network-manager
# https://packages.debian.org/source/sid/network-manager

sudo apt-get update
sudo apt-get upgrade
sudo apt-get build-dep network-manager

rm -Rv /tmp/nm/
mkdir  /tmp/nm/
cd     /tmp/nm/
apt-get build-dep      network-manager
apt-get build-dep -y   network-manager
apti libgnutls-dev


# Old:

# http://ftp.debian.org/debian/pool/main/n/network-manager/
# http://ftp.debian.org/debian/pool/main/n/network-manager/network-manager_0.9.8.8-1.dsc
# http://ftp.debian.org/debian/pool/main/n/network-manager/network-manager_0.9.8.8-1.debian.tar.gz
# http://ftp.debian.org/debian/pool/main/n/network-manager/network-manager_0.9.8.8.orig.tar.xz
#
rm -Rv ~/usrc/network-manager/
mkdir  ~/usrc/network-manager/
cd $S/http/ftp.debian.org/debian/pool/main/n/network-manager/
cp -v network-manager_0.9.8.8* ~/usrc/network-manager/
cd     ~/usrc/network-manager/
dpkg-source -sn -x network-manager_0.9.8.8-1.dsc
cd     ~/usrc/network-manager/network-manager-0.9.8.8/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/network-manager/")
 (eepitch-shell)
cd ~/usrc/network-manager/
sudo dpkg -i *.deb

#
# (code-c-d "networkmanager" "~/usrc/network-manager/network-manager-0.9.8.8/")
# (find-networkmanagerfile "")

# (code-c-d "nm" "~/usrc/network-manager/network-manager-0.9.8.8/")
# (find-nmfile "")
# (find-nmfile "docs/api/")




#####
#
# wicd
# 2014may02
#
#####

# «wicd» (to ".wicd")
# (find-zsh "availabledebs | sort | grep wicd")
# (find-status   "wicd-curses")
# (find-vldifile "wicd-curses.list")
# (find-udfile   "wicd-curses/")
# (find-status   "wicd-gtk")
# (find-vldifile "wicd-gtk.list")
# (find-udfile   "wicd-gtk/")
# (find-status   "wicd-daemon")
# (find-vldifile "wicd-daemon.list")
# (find-udfile   "wicd-daemon/")
# (find-status   "wicd-cli")
# (find-vldifile "wicd-cli.list")
# (find-udfile   "wicd-cli/")

# (find-man "8 wicd-curses")
# (find-man "8 wicd-cli")





#####
#
# NetworkManager from git
# 2019jan13
#
#####

# «git» (to ".git")
# https://wiki.gnome.org/Projects/NetworkManager
# https://gitlab.freedesktop.org/NetworkManager/NetworkManager.git
# (find-sh "apt-cache showsrc network-manager")
# (find-sh "apt-cache showsrc network-manager" "Build-Depends:")
# https://sites.google.com/site/nandydandyoracle/openvswitch-ovs/build-networkmanager-1-11-1-on-ubuntu-17-10
# https://packages.debian.org/pt-br/source/sid/pygobject

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/NetworkManager/
cd      ~/usrc/
git clone https://gitlab.freedesktop.org/NetworkManager/NetworkManager.git
cd      ~/usrc/NetworkManager/
git reset

./autogen.sh  |& tee oa
make          |& tee om

# (find-fline "~/usrc/")
# (find-fline "~/usrc/NetworkManager/")

# (code-c-d "networkmanager" "~/usrc/NetworkManager/")
# (find-networkmanagerfile "")
# (find-networkmanagersh "find * | sort")
# (find-networkmanagerfile "clients/cli/")
# (find-gitk "~/usrc/NetworkManager/")





#####
#
# gnutls
# 2019jan27
#
#####

# «gnutls» (to ".gnutls")
# (find-es "apt" "apt-get-source")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti libgnutls
apti libgnutls-dev
apti libgnutls30

# (find-zsh "installeddebs | sort | grep gnutls")
# (find-zsh "availabledebs | sort | grep gnutls")
# (find-status   "libgnutls30")
# (find-vldifile "libgnutls30.list")
# (find-udfile   "libgnutls30/")

# http://packages.debian.org/src:gnutls28
# https://packages.debian.org/search?searchon=sourcenames&keywords=gnutls28
# https://packages.debian.org/search?searchon=sourcenames&keywords=gnutls
# https://packages.ubuntu.com/search?suite=all&section=all&arch=any&searchon=sourcenames&keywords=gnutls28

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-sh "apt-cache show    gnutls28")
# (find-sh "apt-cache showsrc gnutls28")
rm -Rv /tmp/d/
mkdir  /tmp/d/
cd     /tmp/d/
sudo apt-get build-dep -y   gnutls28
   # apt-get source         gnutls28   |& tee osource
     git clone https://anonscm.debian.org/git/pkg-gnutls/gnutls.git
     apt-get source --build gnutls28   |& tee osourceb

cd     /tmp/d/
laf *.deb
sudo dpkg -i *.deb
apti -f

# cd /tmp/d/
# laf
# mv -iv * ~/usrc/gnutls28/

# (find-fline "~/usrc/gnutls28/")
rm -Rv ~/usrc/gnutls28/
mkdir  ~/usrc/gnutls28/
cd     ~/usrc/gnutls28/
sudo apt-get build-dep -y   gnutls28
   # apt-get source         gnutls28   |& tee osource
     git clone https://anonscm.debian.org/git/pkg-gnutls/gnutls.git
     apt-get source --build gnutls28   |& tee osourceb

# (find-status   "gnutls-doc")
# (find-vldifile "gnutls-doc.list")
# (find-udfile   "gnutls-doc/")





#####
#
# nss
# 2019jan27
#
#####

# «nss» (to ".nss")

# (find-zsh "installeddebs | sort | grep nss")
# (find-zsh "availabledebs | sort | grep nss")
# (find-sh "apt-cache showsrc nss")

# (find-fline "~/usrc/nss/")
rm -Rv ~/usrc/nss/
mkdir  ~/usrc/nss/
cd     ~/usrc/nss/
sudo apt-get build-dep -y   nss
     apt-get source         nss   |& tee osource
   # git clone https://anonscm.debian.org/git/pkg-gnutls/gnutls.git
     apt-get source --build nss   |& tee osourceb

cd     ~/usrc/nss/
ls -lAF *.deb
sudo dpkg -i *.deb
apti -f






#####
#
# nmcli
# 2019mar04
#
#####

# «nmcli» (to ".nmcli")
# https://github.com/DanielFGray/fzf-scripts/blob/master/wifi









wifi networks available
use the network menu to connect to a wifi network







#  Local Variables:
#  coding:               utf-8-unix
#  End:
