#######
#
# E-scripts on compiling and installing non-free packages.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/nonfree.e>
#           or at <http://angg.twu.net/e/nonfree.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




######
#
# Qt 1.42
#
######

# «qt»

pdsc $SDEBIAN/dists/potato/non-free/source/libs/qt1_1.42-2.dsc
cd /usr/src/qt1-1.42/
debian/rules binary	|& tee odrb

cd /usr/src/
rm -v qt1_1.42.orig.tar.gz
mv -v qt*.deb .debs

cd /usr/src/.debs/
dpkg-scanpackages . /dev/null | tee Packages
apt-get update

apt-get install qt1g qt1g-dev




######
#
# blender
#
######

# «blender»

pdsc $SDEBIAN/dists/potato/non-free/source/graphics/blender_1.58-1.dsc
cd /usr/src/blender-1.58/
debian/rules binary	|& tee odrb

cd /usr/src/
mv -v blender_1.58-1_i386.deb .debs
rm blender_1.58.orig.tar.gz

cd /usr/src/.debs/
dpkg-scanpackages . /dev/null | tee Packages
apt-get update

apt-get install blender

# (find-fline "/usr/doc/blender/")
# (find-vldifile "blender.list")

tar -tvzf $S/ftp/ftp.blender.nl/pub/manual_1.02.tgz
tar -tvzf $S/ftp/ftp.blender.nl/pub/tutor_1.02.tgz
tar -tvzf $S/ftp/ftp.blender.nl/pub/tutor_1.6.tgz

rm -Rv /usr/src/manual_1.02/
rm -Rv /usr/src/tutor_1.02/
rm -Rv /usr/src/tutor_1.6/
cd /usr/src/
tar -xvzf $S/ftp/ftp.blender.nl/pub/manual_1.02.tgz
tar -xvzf $S/ftp/ftp.blender.nl/pub/tutor_1.02.tgz
tar -xvzf $S/ftp/ftp.blender.nl/pub/tutor_1.6.tgz
cd /usr/src/manual_1.02/
cd /usr/src/tutor_1.02/
cd /usr/src/tutor_1.6/




######
#
# jdk
#
######

# «jdk»

pdsc $SDEBIAN/dists/slink/non-free/source/devel/jdk1.1_1.1.7v1a-2.dsc
cd /usr/src/jdk1.1-1.1.7v1a/
debian/rules binary	|& tee odrb

cd /usr/src/
mv -iv jdk*deb .debs
rm jdk1.1_1.1.7v1a.orig.tar.gz

cd /usr/src/.debs/
dpkg-scanpackages . /dev/null | tee Packages
apt-get update

apt-get install jdk1.1

# (find-fline "/usr/src/jdk1.1-1.1.7v1a/odrb")
# (find-fline "~/SLINK/Packages-contrib" ": cup")



#####
#
# unhtml
#
#####

pdsc $SDEBIAN/dists/slink/non-free/source/text/unhtml_2.2-2.dsc
cd /usr/src/unhtml-2.2/
debian/rules binary	|& tee odrb
mv -v /usr/src/unhtml*deb /usr/src/.debs/
apt-update

# (find-vldifile "unhtml.list")
# (find-fline "/usr/doc/unhtml/")




#  Local Variables:
#  coding:               utf-8-unix
#  End:
