#######
#
# E-scripts on Octal (the tracker).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/octal.e>
#           or at <http://angg.twu.net/e/octal.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





#####
#
# octal
# 2000apr02
#
#####

anonftp ftp://alpha.gnu.org/gnu/octal/

# «octal»
# (find-fline "$S/ftp/alpha.gnu.org/gnu/octal/")
psne ftp://alpha.gnu.org/gnu/octal/

rm -Rv /usr/src/octal-alpha/
cd /usr/src/
tar -xvf $S/ftp/alpha.gnu.org/gnu/octal/octal-alpha-0.1.1a.tar
cd /usr/src/octal-alpha/
make	|& tee om

vol 10
octal-test

# (code-c-d "octal" "/usr/src/octal-alpha/")
# (find-octalfile "")
# (find-octalfile "Makefile")
# (find-octalfile "om")

# (gdb "gdb /usr/src/octal-alpha/octal-test")

xdvi $S/ftp/alpha.gnu.org/gnu/octal/ox_api_guide.dvi &




#####
#
# octal and Tcl
# 2000may09
#
#####

# «octal_and_tcl»

# (find-fline "$S/http/www.cica.indiana.edu/cica/faq/tcl/book.examples" "29")

rm -Rv /usr/src/octal-alpha/
cd /usr/src/
tar -xvf $S/ftp/alpha.gnu.org/gnu/octal/octal-alpha-0.1.1a.tar
cd /usr/src/octal-alpha/

patch main.c <<'---'
21a22
> #include <tcl.h>
54a56,57
>   Tcl_Interp *interp;
> 
58a62,64
> 
>   interp = Tcl_CreateInterp();
>   Tcl_EvalFile(interp, "octal.tcl");
---

make LIBDL="-rdynamic -ldl -ltcl8.0"	|& tee om

cat > octal.tcl <<'---'
puts "This is Tcl from inside OCTAL!\n"
---

vol 10
octal-test




#####
#
# octal and mktclapp
# 2000may09
#
#####

# «octal_and_mktclapp»

cd /usr/src/octal-alpha/
cat > Makefile.mta <<'---'
#
# (find-mtafile "examples/Makefile")
EXTNAME = Test
#
mktclapp.h:
	mktclapp -header > mktclapp.h
%_e.c: %.c
	mktclapp -notk -extension $(EXTNAME) $*.c > $*_e.c
%.o: %.c mktclapp.h
%.so: %_e.o %.o
	gcc -shared -o $*.so  $*_e.o $*.o
---



# (find-octalfile "")
# (find-octalfile "main.c" "int main() {")
# (find-fline "~/MTA/Makefile")
# (find-node "(make)Automatic")

%_e.c: %.c
	mktclapp -notk -extension Factor \
		factor.c  > factor_e.c




#####
#
# octal-0.3
# 2000jun10
#
#####

rm -Rv /usr/src/octal-alpha/
cd /usr/src/
tar -xvf $S/ftp/alpha.gnu.org/gnu/octal/octal-alpha-0.3a.tar
cd /usr/src/octal-alpha/

cd /usr/src/octal-alpha/
make

cd /usr/src/octal-alpha/
make doc
xdvi ox_api_main.dvi &

cd /usr/src/octal-alpha/
aumix -v 25
octal-test

# (find-octalfile "")




#
rm -Rv /usr/src/octal/
mkdir  /usr/src/octal/
cd     /usr/src/octal/
tar -xvzf $S/ftp/ftp.gnu.org/gnu/octal/octal-0.92.3b.tar.gz
mv release/* .
rmdir release
rm -v octal
#





#  Local Variables:
#  coding:               utf-8-unix
#  End:
