#######
#
# E-scripts about OpenOffice (that became LibreOffice).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/openoffice.e>
#           or at <http://angg.twu.net/e/openoffice.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######






# «.oo-backport-download»		(to "oo-backport-download")
# «.oo-backport-local-repository»	(to "oo-backport-local-repository")
# «.j2re»				(to "j2re")
# «.help-not-working»			(to "help-not-working")
# «.oocalc»				(to "oocalc")
# «.oobasic»				(to "oobasic")
# «.beanshell»				(to "beanshell")
# «.eval-and-load»			(to "eval-and-load")
# «.oowriter-guide»			(to "oowriter-guide")
# «.libreoffice»			(to "libreoffice")
# «.macros»				(to "macros")




#####
#
# openoffice 2.0.3, backported to sarge
# 2006jul03
#
#####

# «oo-backport-download»  (to ".oo-backport-download")
# For some reason 2.0.3 is in contrib, not in main.

# http://www.backports.org/debian/dists/sarge-backports/main/binary-i386/
# http://www.backports.org/debian/dists/sarge-backports/main/binary-i386/Packages
# http://www.backports.org/debian/dists/sarge-backports/contrib/binary-i386/
# http://www.backports.org/debian/dists/sarge-backports/contrib/binary-i386/Packages
# http://www.backports.org/debian/pool/contrib/o/openoffice.org/
# http://www.backports.org/debian/pool/main/o/openoffice.org/
function ooget () {
  # psne http://www.backports.org/debian/pool/main/o/openoffice.org/$1
  psne http://www.backports.org/debian/pool/contrib/o/openoffice.org/$1
}
ooget libmythes-dev_2.0.3-0bpo1_i386.deb                 99K
ooget openoffice.org-base_2.0.3-0bpo1_i386.deb          3.9M
ooget openoffice.org-calc_2.0.3-0bpo1_i386.deb          5.2M
ooget openoffice.org-common_2.0.3-0bpo1_all.deb          26M
ooget openoffice.org-core_2.0.3-0bpo1_i386.deb           33M
ooget openoffice.org-dev-doc_2.0.3-0bpo1_all.deb        4.8M
ooget openoffice.org-dev_2.0.3-0bpo1_i386.deb           3.2M
ooget openoffice.org-draw_2.0.3-0bpo1_i386.deb          2.4M
ooget openoffice.org-evolution_2.0.3-0bpo1_i386.deb     246K
ooget openoffice.org-filter-so52_2.0.3-0bpo1_i386.deb   8.1M
ooget openoffice.org-gnome_2.0.3-0bpo1_i386.deb         232K
ooget openoffice.org-gtk-gnome_2.0.3-0bpo1_all.deb      161K
ooget openoffice.org-help-en-us_2.0.3-0bpo1_all.deb      10M
ooget openoffice.org-help-pt-br_2.0.3-0bpo1_all.deb      11M
ooget openoffice.org-impress_2.0.3-0bpo1_i386.deb       917K
ooget openoffice.org-java-common_2.0.3-0bpo1_all.deb    3.2M
ooget openoffice.org-kde_2.0.3-0bpo1_i386.deb           367K
ooget openoffice.org-l10n-en-us_2.0.3-0bpo1_all.deb     629K
ooget openoffice.org-l10n-pt-br_2.0.3-0bpo1_all.deb     1.8M
ooget openoffice.org-math_2.0.3-0bpo1_i386.deb          451K
ooget openoffice.org-officebean_2.0.3-0bpo1_i386.deb    206K
ooget openoffice.org-writer_2.0.3-0bpo1_i386.deb        5.7M
ooget python-uno_2.0.3-0bpo1_i386.deb                   301K
ooget ttf-opensymbol_2.0.3-0bpo1_all.deb                230K




#####
#
# openoffice 2: local debian repository
# 2006jul03
#
#####

# «oo-backport-local-repository»  (to ".oo-backport-local-repository")
# (find-esgrep    "grep -nH -e Packages *.e")
# (find-man "dpkg-scanpackages")
#
rm -Rv /tmp/backports/
mkdir  /tmp/backports/
cd     /tmp/backports/
ln -s $S/http/www.backports.org/debian/pool/contrib/o/openoffice.org pool
mkdir -p dists/sarge-backports/main/binary-i386/
dpkg-scanpackages pool /dev/null \
       > dists/sarge-backports/main/binary-i386/Packages

#
# (find-fline "$ASROOT/etc/apt/sources.list")
# deb file:///tmp/backports sarge-backports main
# (eev "sudo apt-get update")
# (find-fline "/tmp/backports/pool/")

# (find-fline "/tmp/backports/dists/sarge-backports/main/binary-i386/Packages")
# (find-fline "/tmp/backports/dists/sarge-backports/main/binary-i386/Packages" "help-en-us")

# (find-zsh "acse openoffice.org | sort")

A=(
openoffice.org-help-en-us
openoffice.org-impress
)
apti $A

apti openoffice.org-java-common





#####
#
# java: download j2re to twu, then from twu to sweetjane
# 2006jul03
#
#####

# «j2re»  (to ".j2re")
# To twu (because the proxy at sweetjane blocks ftp.tux.org):

 (eebgTWU)
zsh
mkdir ~/public_html/tmp/java/
cd    ~/public_html/tmp/java/
function wget-j2 () {
 wget ftp://ftp.tux.org/java/debian/pool/non-free/j/j2se1.4-i586/$1
}
wget-j2 j2re1.4-mozilla-plugin_1.4.2.03-1_i386.deb          6 KB
wget-j2 j2re1.4_1.4.2.03-1_i386.deb                     22011 KB
wget-j2 j2sdk1.4-demo_1.4.2.03-1_i386.deb                6202 KB
wget-j2 j2sdk1.4-doc_1.4.2.03-1_i386.deb                    9 KB
wget-j2 j2sdk1.4-src_1.4.2.03-1_i386.deb                10692 KB
wget-j2 j2sdk1.4_1.4.2.03-1_i386.deb                     3491 KB


# twu->sweetjane:
#
# http://angg.twu.net/tmp/java/
# http://angg.twu.net/tmp/java/j2re1.4-mozilla-plugin_1.4.2.03-1_i386.deb
# http://angg.twu.net/tmp/java/j2re1.4_1.4.2.03-1_i386.deb
# Download with brtmpwget, move to ~/tmp/ by hand
# (find-fline "~/tmp/")
# (find-man "dpkg")
cd ~/tmp/
apti libasound2
sudo dpkg -i java-common*
sudo dpkg -i j2re1.4*
sudo dpkg --purge j2re1.4-mozilla-plugin j2re1.4






#####
#
# things that are not working
# 2006jul03
#
#####

# «help-not-working»  (to ".help-not-working")
Help doesn't work - my guess is that when I double-click an entry in
the index it tries to invoke a browser, and it tries to use the wrong
browser, and does not say that at stdout.




#####
#
# oocalc
# 2009jul20
#
#####

# «oocalc»  (to ".oocalc")
# (find-zsh "installeddebs | sort | grep office")
# (find-debpkg-links "openoffice.org-help-en-us")

openoffice.org-base-core
openoffice.org-base
openoffice.org-calc
openoffice.org-common
openoffice.org-core
openoffice.org-draw
openoffice.org-evolution
openoffice.org-filter-mobiledev
openoffice.org-gcj
openoffice.org-gnome
openoffice.org-gtk
openoffice.org-help-en-us
openoffice.org-impress
openoffice.org-java-common
openoffice.org-math
openoffice.org-officebean
openoffice.org-report-builder-bin
openoffice.org-style-andromeda
openoffice.org-style-tango
openoffice.org-thesaurus-en-us
openoffice.org-writer2latex
openoffice.org-writer
openoffice.org

# (find-status   "openoffice.org")
# (find-status   "openoffice.org-base")
# (find-status   "openoffice.org-base-core")
# (find-status   "openoffice.org-calc")
# (find-status   "openoffice.org-common")
# (find-status   "openoffice.org-core")
# (find-status   "openoffice.org-draw")
# (find-status   "openoffice.org-evolution")
# (find-status   "openoffice.org-filter-mobiledev")
# (find-status   "openoffice.org-gcj")
# (find-status   "openoffice.org-gnome")
# (find-status   "openoffice.org-gtk")
# (find-status   "openoffice.org-help-en-us")
# (find-status   "openoffice.org-impress")
# (find-status   "openoffice.org-java-common")
# (find-status   "openoffice.org-math")
# (find-status   "openoffice.org-officebean")
# (find-status   "openoffice.org-report-builder-bin")
# (find-status   "openoffice.org-style-andromeda")
# (find-status   "openoffice.org-style-tango")
# (find-status   "openoffice.org-thesaurus-en-us")
# (find-status   "openoffice.org-writer")
# (find-status   "openoffice.org-writer2latex")
# (find-udfile   "openoffice.org-base-core/")
# (find-udfile   "openoffice.org-base/")
# (find-udfile   "openoffice.org-calc/")
# (find-udfile   "openoffice.org-common/")
# (find-udfile   "openoffice.org-core/")
# (find-udfile   "openoffice.org-draw/")
# (find-udfile   "openoffice.org-evolution/")
# (find-udfile   "openoffice.org-filter-mobiledev/")
# (find-udfile   "openoffice.org-gcj/")
# (find-udfile   "openoffice.org-gnome/")
# (find-udfile   "openoffice.org-gtk/")
# (find-udfile   "openoffice.org-help-en-us/")
# (find-udfile   "openoffice.org-impress/")
# (find-udfile   "openoffice.org-java-common/")
# (find-udfile   "openoffice.org-math/")
# (find-udfile   "openoffice.org-officebean/")
# (find-udfile   "openoffice.org-report-builder-bin/")
# (find-udfile   "openoffice.org-style-andromeda/")
# (find-udfile   "openoffice.org-style-tango/")
# (find-udfile   "openoffice.org-thesaurus-en-us/")
# (find-udfile   "openoffice.org-writer/")
# (find-udfile   "openoffice.org-writer2latex/")
# (find-udfile   "openoffice.org/")

# (find-vldifile "openoffice.org-base-core.list")
# (find-vldifile "openoffice.org-base.list")
# (find-vldifile "openoffice.org-calc.list")
# (find-vldifile "openoffice.org-common.list")
# (find-vldifile "openoffice.org-core.list")
# (find-vldifile "openoffice.org-draw.list")
# (find-vldifile "openoffice.org-evolution.list")
# (find-vldifile "openoffice.org-filter-mobiledev.list")
# (find-vldifile "openoffice.org-gcj.list")
# (find-vldifile "openoffice.org-gnome.list")
# (find-vldifile "openoffice.org-gtk.list")
# (find-vldifile "openoffice.org-help-en-us.list")
# (find-vldifile "openoffice.org-impress.list")
# (find-vldifile "openoffice.org-java-common.list")
# (find-vldifile "openoffice.org-math.list")
# (find-vldifile "openoffice.org-officebean.list")
# (find-vldifile "openoffice.org-report-builder-bin.list")
# (find-vldifile "openoffice.org-style-andromeda.list")
# (find-vldifile "openoffice.org-style-tango.list")
# (find-vldifile "openoffice.org-thesaurus-en-us.list")
# (find-vldifile "openoffice.org-writer.list")
# (find-vldifile "openoffice.org-writer2latex.list")
# (find-vldifile "openoffice.org.list")

# (find-fline "/usr/lib/openoffice/help/en/")

_I_nsert -> Faunc




#####
#
# OpenOffice BASIC
# 2009jul20
#
#####

# «oobasic»  (to ".oobasic")
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide
# http://en.wikipedia.org/wiki/StarOffice_Basic
# http://www.linux.com/archive/articles/48258
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide/Spreadsheets
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide/Runtime_Library
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide/Language
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide/Structure_of_Spreadsheets
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide/Rows_and_Columns
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide/Cells_and_Ranges
# http://wiki.services.openoffice.org/wiki/Documentation/BASIC_Guide/Files_and_Directories_(Runtime_Library)

=IF(A1;"yes";"no")




#####
#
# BeanShell
# 2009jul20
#
#####

# «beanshell»  (to ".beanshell")
# (find-es "java" "beanshell")
# http://www.ikayzo.org/confluence/display/BSH/Home
# http://www.ikayzo.org/confluence/display/BSH/FAQ
# http://framework.openoffice.org/scripting/scriptingf1/developer-guide.html
# http://beanshell.org/manual/
# http://machine.homeunix.org/beanshell4newble/index_en.html
# http://framework.openoffice.org/scripting/scriptingf1/developer-guide.html

# (find-status   "bsh")
# (find-vldifile "bsh.list")
# (find-udfile   "bsh/")




#####
#
# eval and load
# 2009jul20
#
#####

# «eval-and-load»  (to ".eval-and-load")


<edrx> is there an "eval" function in oobasic? or better, how can I
       create a menu entry in openoffice whose action would be to
       load and execute the file /tmp/foo.oobasic? 
<edrx> btw, I'm an openoffice newbie, and I'd like to use that to -
       sort of - send commands to openoffice from emacs... from
       emacs I would save a block of text into that temporary
       script file, and then in openoffice I'd execute that menu
       entry...

<edrx> anyone familiar with openoffice here? I'm trying to find a
       way to add an entry to a menu in oocalc to make it load and
       execute a file /tmp/foo.bas... actually the idea is to
       prepare a block of BASIC code from Emacs, save it into
       /tmp/foo.bas, and then execute it from within openoffice
       with a few keystrokes...
<quotemstr> edrx: Create a macro. I believe you can assign a macro
            a menu item or a keystroke.
<edrx> the problem is that I can't find the commands from "load" &c
       in the openoffice wiki
<edrx> quotemstr: that's the part that I know how to do 8-S




TYPE
Returns the type of value.
If an error occurs, the function returns a logical or numerical value. 
Syntax
TYPE(value)
Value is a specific value for which the data type is determined. Value 1 = number, value 2 = text, value 4 = Boolean value, value 8 = formula, value 16 = error value.
Example (see example table above)
TYPE(C2) returns 2 as a result.
TYPE(D9) returns 1 as a result.

TYPE(42)
TYPE("42")
TYPE(TRUE)
TYPE(2+3)
TYPE(


# (find-bgprocess "oocalc ~/OOCALC/foo.ods")
# (find-fline "~/OOCALC/foo.ods")



Information Functions
This category contains the Information functions. 
To access this command... 
Insert - Function - Category Information 

The data in the following table serves as the basis for some of the examples in the function descriptions:

C
D
2 
x value
y value
3 
-5
-3
4 
-2
0
5 
-1
1
6 
0
3
7 
2
4
8 
4
6
9 
6
8

CURRENT
Calculates the current value of a formula at the actual position.
Syntax
CURRENT()
Example
You can use this function in connection with the cell formatting function TEMPLATE. For example, to assign the current value in a new format to the current cell:
=CURRENT()+TEMPLATE("New")

FORMULA
Displays the formula of a formula cell as a text string.
Syntax
FORMULA(reference)
reference is a reference to a cell containing a formula.
An invalid reference or a reference to a cell with no formula results in the error value #N/A.
Example
If cell A8 contains the formula =SUM(1;2;3) then
FORMULA(A8) returns the text "=SUM(1;2;3)" (without the double quotes).

ISREF
Tests if the argument is a reference. Returns TRUE if the argument is a reference, returns FALSE otherwise. When given a reference this function does not examine the value being referenced.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISREF(value)
Value is the value to be tested, to determine whether it is a reference.
Example
ISREF(C5) returns the result TRUE because C5 is a valid reference.
ISREF("abcdef") returns always FALSE because a text can never be a reference.
ISREF(4) returns FALSE.
=ISREF(INDIRECT("A6")) returns TRUE, because INDIRECT is a function that returns a reference.
=ISREF(ADDRESS(1; 1; 2; "Sheet2")) returns FALSE, because ADDRESS is a function that returns a text, although it looks like a reference.

ISERR
Tests for error conditions, except the #N/A error value, and returns TRUE or FALSE.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISERR(value)
Value is any value or expression which is tested to see whether an error value other than #N/A is present.
Example
ISERR(C8) where cell C8 contains =1/0 returns TRUE, because 1/0 is an error.
ISERR(C9) where cell C9 contains =NA() returns FALSE, because ISERR() ignores the #N/A error.

ISERROR
Tests for error conditions, including the #N/A error value, and returns TRUE or FALSE.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISERROR(value)
Value is or refers to the value to be tested. ISERROR() returns TRUE if there is an error and FALSE if not.
Example
ISERROR(C8) where cell C8 contains =1/0 returns TRUE, because 1/0 is an error.
ISERROR(C9) where cell C9 contains =NA() returns TRUE.

ISFORMULA
Returns TRUE if a cell is a formula cell.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISFORMULA(reference)
Reference indicates the reference to a cell in which a test will be performed to determine if it contains a formula.
Example
ISFORMULA(C4) returns FALSE if the cell C4 contains the number 5.

ISEVEN_ADD
This function is only available if Analysis AddIn is installed. 
Tests for even numbers. Returns 1 if the number divided by 2 returns a whole number.
The functions whose names end with _ADD return the same results as the corresponding Microsoft Excel functions. Use the functions without _ADD to get results based on international standards. For example, the WEEKNUM function calculates the week number of a given date based on international standard ISO 6801, while WEEKNUM_ADD returns the same week number as Microsoft Excel.
Syntax
ISEVEN_ADD(Number)
Number: the number to be tested.
Example
ISEVEN_ADD(5) returns 0.
ISEVEN_ADD(A1) returns 1 if cell A1 contains the number 2.

ISNONTEXT
Tests if the cell contents are text or numbers, and returns FALSE if the contents are text.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISNONTEXT(value)
Value is any value or expression where a test is performed to determine whether it is a text or numbers or a Boolean value.
Example
ISNONTEXT(D2) returns FALSE if cell D2 contains the text "abcdef".
ISNONTEXT(D9) returns TRUE if cell D9 contains the number 8.

ISBLANK
Returns TRUE if the reference to a cell is blank. This function is used to determine if the content of a cell is empty. A cell with a formula inside is not empty. 
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISBLANK(value)
Value is the content to be tested.
Example
ISBLANK(D2) returns FALSE as a result.

ISLOGICAL
Tests for a logical value (TRUE or FALSE).
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISLOGICAL(value)
Returns TRUE if Value is a logical value (TRUE or FALSE), and returns FALSE otherwise.
Example
ISLOGICAL(99) returns FALSE, because 99 is a number, not a logical value.
ISLOGICAL(ISNA(D4)) returns TRUE whatever the contents of cell D4, because ISNA() returns a logical value.

ISNA
Returns TRUE if a cell contains the #N/A (value not available) error value.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISNA(value)
Value is the value or expression to be tested.
Example
ISNA(D3) returns FALSE as a result.

ISTEXT
Returns TRUE if the cell contents refer to text.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISTEXT(value)
Value is a value, number, Boolean value, or an error value to be tested.
Example
ISTEXT(D9) returns TRUE if cell D9 contains the text "abcdef".
ISTEXT(C3) returns FALSE if cell C3 contains the number 3.

ISODD_ADD
This function is only available if Analysis AddIn is installed. 
Returns TRUE (1) if the number does not return a whole number when divided by 2.
The functions whose names end with _ADD return the same results as the corresponding Microsoft Excel functions. Use the functions without _ADD to get results based on international standards. For example, the WEEKNUM function calculates the week number of a given date based on international standard ISO 6801, while WEEKNUM_ADD returns the same week number as Microsoft Excel.
Syntax
ISODD_ADD(Number)
Number: the number to be tested.
Example
=ISODD_ADD(5) returns 1.

ISNUMBER
Returns TRUE if the value refers to a number.
If an error occurs, the function returns a logical or numerical value. 
Syntax
ISNUMBER(value)
Value is any expression to be tested to determine whether it is a number or text.
Example
ISNUMBER(C3) returns TRUE if the cell C3 contains the number 4.
ISNUMBER(C2) returns FALSE if the cell C2 contains the text "abcdef".
N
Returns the numeric value.
If an error occurs, the function returns a logical or numerical value. 
Syntax

N(value)
Value is the parameter to be converted into a number. N() returns the numeric value if it can. It returns the logical values TRUE and FALSE as 1 and 0 respectively. It returns text and errors as 0.
Example
N(123) returns 123
N(TRUE) returns 1
N(FALSE) returns 0
N("abc") returns 0
NA
Returns the error value #N/A.
Syntax

NA()
Example
NA() converts the contents of the cell into #N/A.

TYPE
Returns the type of value.
If an error occurs, the function returns a logical or numerical value. 
Syntax
TYPE(value)
Value is a specific value for which the data type is determined. Value 1 = number, value 2 = text, value 4 = Boolean value, value 8 = formula, value 16 = error value.
Example (see example table above)
TYPE(C2) returns 2 as a result.
TYPE(D9) returns 1 as a result.

CELL
Returns information on address, formatting or contents of a cell.
Syntax
CELL(Info_type; Reference)
Info_type is the character string that specifies the type of information. The character string is always in English. Upper or lower case is optional.
Info_type
Meaning

COL
Returns the number of the referenced column.
Cell("COL";D2) returns 4.

ROW
Returns the number of the referenced row.
Cell("ROW";D2) returns 2.

SHEET
Returns the number of the referenced sheet.
Cell("Sheet";Sheet3.D2) returns 3.

ADDRESS
Returns the absolute address of the referenced cell.
CELL("ADDRESS";D2) returns $D$2.
CELL("ADDRESS";Sheet3.D2) returns $Sheet3.$D$2.
CELL("ADDRESS";'X:\dr\test.sxc'#$Sheet1.D2) returns 'file:///X:/dr/test.sxc'#$Sheet1.$D$2.

FILENAME
Returns the file name and the sheet number of the referenced cell.
CELL("FILENAME";D2) returns 'file:///X:/dr/own.sxc'#$Sheet1, if the formula in the current document X:\dr\own.sxc is located in Sheet1.
CELL("FILENAME";'X:\dr\test.sxc'#$Sheet1.D2) returns 'file:///X:/dr/test.sxc'#$Sheet1.

COORD
Returns the complete cell address in Lotus(TM) notation.
CELL("COORD"; D2) returns $A:$D$2.
CELL("COORD"; Sheet3.D2) returns $C:$D$2.

CONTENTS
Returns the contents of the referenced cell, without any formatting.

TYPE
Returns the type of cell contents.
b = blank. empty cell
l = label. Text, result of a formula as text
v = value. Value, result of a formula as a number

WIDTH
Returns the width of the referenced column. The unit is the number of zeros (0) that fit into the column in the default text and the default size.

PREFIX
Returns the alignment of the referenced cell.
' = align left or left-justified
" = align right
^ = centered
\ = repeating (currently inactive)

PROTECT
Returns the status of the cell protection for the cell.
1 = cell is protected
0 = cell is not protected

FORMAT
Returns a character string that indicates the number format.
, = number with thousands separator
F = number without thousands separator
C = currency format
S = exponential representation, for example, 1.234+E56
P = percentage
In the above formats, the number of decimal places after the decimal separator is given as a number. Example: the number format #,##0.0 returns ,1 and the number format 00.000% returns P3
D1 = MMM-D-YY, MM-D-YY and similar formats
D2 = DD-MM
D3 = MM-YY
D4 = DD-MM-YYYY HH:MM:SS
D5 = MM-DD
D6 = HH:MM:SS AM/PM
D7 = HH:MM AM/PM
D8 = HH:MM:SS
D9 = HH:MM
G = All other formats
- (Minus) at the end = negative numbers are formatted in color
() (brackets) at the end = there is an opening bracket in the format code

COLOR
Returns 1, if negative values have been formatted in color, otherwise 0.

PARENTHESES
Returns 1 if the format code contains an opening bracket (, otherwise 0.

Reference (list of options) is the position of the cell to be examined. If Reference is a range, the cell moves to the top left of the range. If Reference is missing, OpenOffice.org Calc uses the position of the cell in which this formula is located. Microsoft Excel uses the reference of the cell in which the cursor is positioned.





#####
#
# OOWriter User's Guide
# 2012feb03
#
#####

# «oowriter-guide»  (to ".oowriter-guide")
# http://wiki.services.openoffice.org/wiki/Documentation/OOo3_User_Guides/OOo3.3_User_Guide_Chapters
# http://wiki.services.openoffice.org/w/images/8/8a/0104GS33-GettingStartedWithWriter.pdf
# http://wiki.services.openoffice.org/w/images/1/11/0200WG33-WriterGuideOOo.pdf

;; (ee-page-parameters "oowriterg" 0)
(code-xpdf      "oowriterg" "$S/http/wiki.services.openoffice.org/w/images/1/11/0200WG33-WriterGuideOOo.pdf")
(code-pdftotext "oowriterg" "$S/http/wiki.services.openoffice.org/w/images/1/11/0200WG33-WriterGuideOOo.pdf" 0
;; (ee-page-parameters "oowriterg" 0)
;; (find-oowritergpage   3 "Contents")
;; (find-oowritergtext   3 "Contents")
;; (find-oowritergpage  13    "Customizing toolbars")
;; (find-oowritergtext  13    "Customizing toolbars")
;; (find-oowritergpage 236 "8. Working with Graphics")
;; (find-oowritergtext 236    "Working with Graphics")
;; (find-oowritergpage 247    "Original size button")
;; (find-oowritergtext 247    "Original size button")
;; (find-oowritergpage 251    "Positioning graphics within the text")
;; (find-oowritergtext 251    "Positioning graphics within the text")
;; (find-oowritergpage 458 "Index")
;; (find-oowritergtext 458 "Index")

http://www.openoffice.org/pt/download/download.htm
http://www.openoffice.org/pt-br/




#####
#
# LibreOffice
# 2012feb16
#
#####

# «libreoffice»  (to ".libreoffice")
# http://www.libreoffice.org/
# http://en.wikipedia.org/wiki/LibreOffice
# http://en.wikipedia.org/wiki/Tango_Desktop_Project

# (find-es "kernel" "kernel-backports")

sudo apt-get -t squeeze-backports install libreoffice

# (find-status   "libreoffice")
# (find-vldifile "libreoffice.list")
# (find-udfile   "libreoffice/")
# (find-status   "libreoffice-writer")
# (find-vldifile "libreoffice-writer.list")
# (find-udfile   "libreoffice-writer/")





#####
#
# macros
# 2018dec11
#
#####

# «macros» (to ".macros")
# https://help.libreoffice.org/Common/Recording_a_Macro
# https://documentation.libreoffice.org/assets/Uploads/Documentation/en/GS5.1/HTML/GS5113-GettingStartedWithMacros.html





# (find-zsh "installeddebs | sort | grep office")
# (find-status   "libreoffice-calc")
# (find-vldifile "libreoffice-calc.list")
# (find-udfile   "libreoffice-calc/")
# (find-status   "libreoffice-help-common")
# (find-vldifile "libreoffice-help-common.list")
# (find-udfile   "libreoffice-help-common/")
# (find-status   "libreoffice-help-en-gb")
# (find-vldifile "libreoffice-help-en-gb.list")
# (find-udfile   "libreoffice-help-en-gb/")
# (find-status   "libreoffice-help-en-us")
# (find-vldifile "libreoffice-help-en-us.list")
# (find-udfile   "libreoffice-help-en-us/")
# (find-fline "/usr/share/libreoffice/help/en-GB/text/scalc/01/")



https://www.youtube.com/watch?v=EclKK0UM4l8&list=PL0pdzjvYW9RFl1ZRu8MkE3QxWQSt7Xktk&index=29

# https://documentation.libreoffice.org/assets/Uploads/Documentation/en/CG7.1/CG71-CalcGuide.pdf
# (code-pdf-page "localc" "$S/https/documentation.libreoffice.org/assets/Uploads/Documentation/en/CG7.1/CG71-CalcGuide.pdf")
# (code-pdf-text "localc" "$S/https/documentation.libreoffice.org/assets/Uploads/Documentation/en/CG7.1/CG71-CalcGuide.pdf")
;; (find-localcpage)
;; (find-localctext)
# (find-localcpage 16 "Calc main window")
# (find-localctext 16 "Calc main window")
# (find-localcpage 32 "Selecting columns and rows")
# (find-localctext 32 "Selecting columns and rows")
# (find-localcpage 256 "=B8-SUM(B10:B14)")
# (find-localctext 256 "=B8-SUM(B10:B14)")


Re: Move/shift a column
Postby acknak » Fri Sep 02, 2016 3:42 am

Here's the step-by-step:

Select the source column
Click again anywhere on the selected area, hold for a second and drag left or right.
To move the column, hold Alt when you release the mouse button to drop it.

Note:
Drop with no key pressed: move/replace
Drop with Ctrl: copy source to target

https://ask.libreoffice.org/en/question/91840/switch-rows-calc/





# (find-zsh "acse j2re | sort")
# (find-status   "j2re1.4")
# (find-vldifile "j2re1.4.list")
# (find-udfile   "j2re1.4/")
# (find-status   "j2re1.4-mozilla-plugin")
# (find-vldifile "j2re1.4-mozilla-plugin.list")
# (find-udfile   "j2re1.4-mozilla-plugin/")


# (find-zsh "installeddebs | sort | grep openoffice")
# (find-zsh "availabledebs | sort | grep openoffice")
# (find-man "openoffice")

https://wiki.documentfoundation.org/Faq/Writer/PDF_Hybrid

https://news.ycombinator.com/item?id=31634704 Ask HN: Has anyone successfully used LibreOffice for their business?
https://news.ycombinator.com/item?id=34137264 Use LibreOffice Base as a GUI for an SQLite Database in OS X (2016) (andrewheiss.com)
https://news.ycombinator.com/item?id=34141584 eBay, Etsy and other marketplaces on brink of having to disclose seller details (eseller365.com)
https://news.ycombinator.com/item?id=34138863 The US-Canada border cuts through the Haskell Free Library and Opera House (aljazeera.com)
https://news.ycombinator.com/item?id=34115109 Archaeologists Discover Lost Civilization in Guatemala (vice.com)
https://www.youtube.com/watch?v=8PhdfcX9tG0
https://www.youtube.com/watch?v=WiP09XwdvKw






#  Local Variables:
#  coding:               utf-8-unix
#  End:
