#######
#
# E-scripts on Oracle.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/oracle.e>
#           or at <http://angg.twu.net/e/oracle.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.unpack-cpios»	(to "unpack-cpios")
# «.make-isos»		(to "make-isos")
# «.doc:create_table»	(to "doc:create_table")
# «.doc:connect»	(to "doc:connect")
# «.tnsnames.ora»	(to "tnsnames.ora")




#####
#
# Oracle 9 for Linux: downloading and listing the files
# 2006jun21
#
#####

# (find-orgfile "2006-06-16.org" "oracle9_for_linux")
# (find-node "(cpio)Options" "`-t, --list'")
# http://www.oracle.com/technology/software/products/oracle9i/index.html
# http://www.oracle.com/technology/software/products/oracle9i/htdocs/linuxsoft.html

# Directions to extract the files:
# 1. Run "gunzip <filename>" on all the files. Eg.
#    ship_9204_linux_disk1.cpio.gz
# 2. Extract the cpio archives with the command "cpio -idmv <
#    <filename>" Eg. cpio -idmv < ship_9204_linux_disk1.cpio

# (find-fline "~/tmp/")
# (find-fline "~/tmp/" "ship_9204")
# (find-node "(cpio)Options" "`-t, --list'")

#
cd ~/tmp/
zcat ship_9204_linux_disk1.cpio.gz | cpio -t  | tee /tmp/o1
zcat ship_9204_linux_disk1.cpio.gz | cpio -tv | tee /tmp/o1v
zcat ship_9204_linux_disk2.cpio.gz | cpio -t  | tee /tmp/o2
zcat ship_9204_linux_disk2.cpio.gz | cpio -tv | tee /tmp/o2v
zcat ship_9204_linux_disk3.cpio.gz | cpio -t  | tee /tmp/o3
zcat ship_9204_linux_disk3.cpio.gz | cpio -tv | tee /tmp/o3v

#
# (find-fline "/tmp/o1")
# (find-fline "/tmp/o1v")
# (find-fline "/tmp/o2")
# (find-fline "/tmp/o2v")
# (find-fline "/tmp/o3")
# (find-fline "/tmp/o3v")




#####
#
# Oracle 9 for Linux: unpacking
# 2006jun21
#
#####

# «unpack-cpios»  (to ".unpack-cpios")
#
rm -Rv /tmp/oracle9/
mkdir  /tmp/oracle9/
cd /tmp/oracle9/ && zcat ~/tmp/ship_9204_linux_disk1.cpio.gz | cpio -idmv
cd /tmp/oracle9/ && zcat ~/tmp/ship_9204_linux_disk2.cpio.gz | cpio -idmv
cd /tmp/oracle9/ && zcat ~/tmp/ship_9204_linux_disk3.cpio.gz | cpio -idmv
cd /tmp/oracle9/
find $PWD -type f | sort > ofindf

#
# (find-fline "/tmp/oracle9/")
# (find-fline "/tmp/oracle9/ofindf")
# (find-sh "grep -i install /tmp/oracle9/ofindf")

# (find-w3m "/tmp/oracle9/Disk1/doc/unixdoc/a95979/2install.htm")
# (find-fline "/tmp/oracle9/Disk1/install/linux/runInstaller")
# (find-fline "/tmp/oracle9/Disk1/install/linux/runInstaller.sh")
# (find-fline "/tmp/oracle9/Disk1/runInstaller")
# (find-w3m "/tmp/oracle9/Disk1/stage/Components/oracle.apache.apache/1.3.22.0.0a/1/DataFiles/Expanded/docs_unix/manual/install-tpf.html")
# (find-w3m "/tmp/oracle9/Disk1/stage/Components/oracle.apache.apache/1.3.22.0.0a/1/DataFiles/Expanded/docs_unix/manual/install.html.en")
# (find-w3m "/tmp/oracle9/Disk1/stage/Components/oracle.apache.jserv/1.1.0.0.0g/1/DataFiles/Expanded/docs_unix/install/howto.unix_install.html")
# (find-w3m "/tmp/oracle9/Disk1/stage/Components/oracle.apache.jserv/1.1.0.0.0g/1/DataFiles/Expanded/docs_unix/install/index.html")
# (find-fline "/tmp/oracle9/Disk1/stage/Components/oracle.swd.oui/2.2.0.18.0/1/DataFiles/Expanded/install/linux/runInstaller")
# (find-fline "/tmp/oracle9/Disk1/stage/Components/oracle.swd.oui/2.2.0.18.0/1/DataFiles/Expanded/install/linux/runInstaller.sh")

#
# (find-sh "grep -i index /tmp/oracle9/ofindf")
# (find-sh "grep -i pdf   /tmp/oracle9/ofindf")
file:///tmp/oracle9/Disk1/doc/unixdoc/index.htm
file:///tmp/oracle9/Disk1/doc/unixdoc/index.htm





#####
#
# Oracle 9 for Linux: making the ISOs
# 2006jun21
#
#####

# «make-isos»  (to ".make-isos")
# (find-esgrep "grep -nH -e mkisofs *.e")
# (find-man "mkisofs")
#
cd /tmp/oracle9/
mkisofs -r -J -o cd1.iso Disk1/
mkisofs -r -J -o cd2.iso Disk2/
mkisofs -r -J -o cd3.iso Disk3/

#
# Mount the isos as loop devices
# (find-esgrep "grep -nH -e loop *.e")

mkdir /tmp/oraclecd1/
mkdir /tmp/oraclecd2/
mkdir /tmp/oraclecd3/
sudo mount -o loop /tmp/oracle9/cd1.iso /tmp/oraclecd1/
sudo mount -o loop /tmp/oracle9/cd2.iso /tmp/oraclecd2/
sudo mount -o loop /tmp/oracle9/cd3.iso /tmp/oraclecd3/

#
# Umount the loop devices
sudo umount /tmp/oraclecd1/
sudo umount /tmp/oraclecd2/
sudo umount /tmp/oraclecd3/

#




#####
#
# Oracle 9 - documentation CD
# 2006jun23
#
#####

mkdir /tmp/cdrom
sudo mount -o ro /dev/cdrom /tmp/cdrom
cd /tmp/cdrom
laf
mkdir ~/tmp/oracledoc
laf
laf .rr_moved
cp -diPpvR * ~/tmp/oracledoc/
cd
sudo umount /dev/cdrom

# (find-fline "~/tmp/oracledoc/")
# (code-c-d "oracledoc" "~/tmp/oracledoc/")
# (find-oracledocfile "")
# (find-oracledocfile "readme.txt" "http://docs.oracle.com/")

file:///home/edrx/tmp/oracledoc/index.htm
file:///home/edrx/tmp/oracledoc/server.920/a96540/statements_12a.htm

# DDL, CREATE, CONNECT:

# «doc:create_table»  (to ".doc:create_table")
# «doc:connect»  (to ".doc:connect")

# (find-oracledocw3m "server.920/a96540/statements_12a.htm")
# (find-oracledocw3m "server.920/a96540/statements_12a.htm" "Data Definition Language (DDL) Statements")
# (find-oracledocw3m "server.920/a96540/statements_12a.htm" "(DDL) Statements")
# (find-oracledocw3m "server.920/a96540/index.htm" "    CREATE TABLE")

file:///home/edrx/tmp/oracledoc/server.920/a90842/toc.htm
file:///home/edrx/tmp/oracledoc/server.920/a90842/qstart.htm#970667
SQL> connect username/password@connect_identifier
file:///home/edrx/tmp/oracledoc/server.920/a90842/ch13.htm#1008724




#####
#
# The "tnsnames.ora" file
# 2006jun23
#
#####

# «tnsnames.ora»  (to ".tnsnames.ora")
# (find-paratifile "/opt/oracle/product/9.2.0/network/admin/")
# (find-paratifile "/opt/oracle/product/9.2.0/network/admin/tnsnames.ora")
# (find-paratifile "/opt/oracle/product/9.2.0/network/admin/tnsnames.ora" "BD_SITE_VAS_DESENV =")
# (find-paratioraclehomefile "")
# (find-paratioraclehomefile "network/admin/tnsnames.ora")

# (find-fline "/tmp/oracle9/ofindf")
# (find-sh "grep -i install /tmp/oracle9/ofindf")




#####
#
# connecting to a remote machine
# 2006jun23
#
#####

 (eepitch-parati)
edrx
sqlplus desenv/desenv@bd_site_vas_desenv









#  Local Variables:
#  coding:               utf-8-unix
#  End:
