#######
#
# E-scripts on Org.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/org.e>
#           or at <http://angg.twu.net/e/org.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.git»			(to "git")
# «.mailing-list»		(to "mailing-list")
# «.gmane»			(to "gmane")
# «.mailing-list-mbox»		(to "mailing-list-mbox")
# «.stackexchange»		(to "stackexchange")
# «.edit-link»			(to "edit-link")
# «.hyperlinks»			(to "hyperlinks")
# «.elisp-links»		(to "elisp-links")
# «.internal-links»		(to "internal-links")
# «.youtube»			(to "youtube")
# «.org-link-parameters»	(to "org-link-parameters")
# «.org-babel»			(to "org-babel")
# «.org-babel-screen»		(to "org-babel-screen")
# «.code-blocks»		(to "code-blocks")
# «.languages»			(to "languages")
# «.org-element-context»	(to "org-element-context")
# «.picolisp»			(to "picolisp")
# «.emacs-starter-kit»		(to "emacs-starter-kit")
# «.R-squared»			(to "R-squared")
# «.tables»			(to "tables")
# «.captures»			(to "captures")
# «.org-capture»		(to "org-capture")
# «.org-capture-prot»		(to "org-capture-prot")
# «.org-capture-2021jun04»	(to "org-capture-2021jun04")
# «.checkmark»			(to "checkmark")
# «.reproducible-research»	(to "reproducible-research")
# «.org-export-dispatch»	(to "org-export-dispatch")
# «.org-export-dispatch-ihor»	(to "org-export-dispatch-ihor")
# «.org-export-dispatch-2023-01»  (to "org-export-dispatch-2023-01")
# «.export-to-html»		(to "export-to-html")
# «.export-via-sexp»		(to "export-via-sexp")
# «.export-options»		(to "export-options")
# «.export-title»		(to "export-title")
# «.org-html-postamble»		(to "org-html-postamble")
# «.carsten-video»		(to "carsten-video")
# «.carsten-2008»		(to "carsten-2008")
# «.carsten-max-planck»		(to "carsten-max-planck")
# «.video-offsets»		(to "video-offsets")
# «.latex-header»		(to "latex-header")
# «.ee-goto-position-bug»	(to "ee-goto-position-bug")
# «.tab-templates»		(to "tab-templates")
# «.papers-about-org»		(to "papers-about-org")
# «.org-texinfo»		(to "org-texinfo")
# «.ox-texinfo»			(to "ox-texinfo")
# «.thunderlink»		(to "thunderlink")
# «.TODO-and-DONE»		(to "TODO-and-DONE")
# «.promote-and-demote»		(to "promote-and-demote")
# «.to-org-and-to-latex»	(to "to-org-and-to-latex")
# «.kitchin-scipy-org»		(to "kitchin-scipy-org")
# «.time-offsets»		(to "time-offsets")
# «.link-type-for-video-files»	(to "link-type-for-video-files")
# «.easy-templates»		(to "easy-templates")
# «.audio-blocks»		(to "audio-blocks")
# «.adding-new-tags»		(to "adding-new-tags")
# «.org-download»		(to "org-download")
# «.bibtex»			(to "bibtex")
# «.org-syntax»			(to "org-syntax")
# «.redirecting-stderr»		(to "redirecting-stderr")
# «.tikz-in-org-for-newbies»	(to "tikz-in-org-for-newbies")
# «.parse-org-with-lua»		(to "parse-org-with-lua")
# «.org-compact-guide»		(to "org-compact-guide")
# «.org-ref»			(to "org-ref")
# «.M-up-and-M-down»		(to "M-up-and-M-down")
# «.organice»			(to "organice")
# «.literate-devops»		(to "literate-devops")
# «.multiline-comments»		(to "multiline-comments")
# «.lazyblorg»			(to "lazyblorg")
# «.problem-with-source-blocks»	(to "problem-with-source-blocks")
# «.named-code-blocks»		(to "named-code-blocks")
# «.collections»		(to "collections")
# «.org-agenda»			(to "org-agenda")
# «.matplotlib»			(to "matplotlib")
# «.csv-to-latex»		(to "csv-to-latex")
# «.rainer-koenig»		(to "rainer-koenig")
# «.rainer-koenig-playlist»	(to "rainer-koenig-playlist")
# «.org-roam»			(to "org-roam")
# «.org-journal»		(to "org-journal")
# «.worg»			(to "worg")
# «.org-player»			(to "org-player")
# «.links-to-pdfs»		(to "links-to-pdfs")
# «.org-pdftools»		(to "org-pdftools")
# «.export-escript-blocks»	(to "export-escript-blocks")
# «.ol-eshell»			(to "ol-eshell")
# «.blogging»			(to "blogging")
# «.ox-slimhtml»		(to "ox-slimhtml")
# «.org-html-postamble»		(to "org-html-postamble")
# «.emacs-survey-org»		(to "emacs-survey-org")
# «.protesilaos-dot-emacs»	(to "protesilaos-dot-emacs")
# «.toc»			(to "toc")
# «.org-elpa»			(to "org-elpa")
# «.this-month-in-org»		(to "this-month-in-org")
# «.org-protocol»		(to "org-protocol")
# «.org-critical-edition»	(to "org-critical-edition")
# «.david-pineiden»		(to "david-pineiden")
# «.yaca»			(to "yaca")
# «.org-grasp»			(to "org-grasp")
# «.agda.org»			(to "agda.org")
# «.scimax»			(to "scimax")
# «.projectile»			(to "projectile")
# «.literatemacs»		(to "literatemacs")
# «.org-babel-tangle»		(to "org-babel-tangle")
# «.antonin-januska»		(to "antonin-januska")
# «.orgstrap»			(to "orgstrap")
# «.orgdown»			(to "orgdown")
# «.org-src-fontify-natively»	(to "org-src-fontify-natively")
# «.ob-ipython»			(to "ob-ipython")
# «.org-store-link»		(to "org-store-link")
# «.kb-macro-defun-eek»		(to "kb-macro-defun-eek")
# «.org-git-testing»		(to "org-git-testing")
# «.kbd»			(to "kbd")
# «.org-git-hooks»		(to "org-git-hooks")
# «.github-orgmode-tests»	(to "github-orgmode-tests")
# «.outshine»			(to "outshine")
# «.sexps-as-backends»		(to "sexps-as-backends")
# «.org-noter-pdftools»		(to "org-noter-pdftools")
# «.org-babel-eval-in-repl»	(to "org-babel-eval-in-repl")
# «.org-tempo»			(to "org-tempo")
# «.org-persist»		(to "org-persist")
# «.ihor-wconfig»		(to "ihor-wconfig")
# «.2022-to-ihor-in-private»	(to "2022-to-ihor-in-private")
# «.maxima»			(to "maxima")
# «.status-of-ob-maxima.el»	(to "status-of-ob-maxima.el")
# «.session»			(to "session")
# «.one-block-per-heading»	(to "one-block-per-heading")




http://orgmode.org/index.html#sec-2
http://orgmode.org/org-7.7.tar.gz
http://orgmode.org/worg/org-contrib/babel/
http://orgmode.org/worg/org-contrib/babel/how-to-use-Org-Babel-for-R.html




#####
#
# Org from the git repo
# 2011nov23 / 2013feb19 / 2019nov03
#
#####

# «git»  (to ".git")
# (find-angg ".emacs" "org-mode")
# http://lists.gnu.org/archive/html/emacs-orgmode/2013-02/msg01029.html
# http://orgmode.org/org.html#Installation
# http://orgmode.org/worg/org-faq.html#updating-org

# (code-c-d "orggit" "~/usrc/org-mode/")
# (find-orggitfile "")
# (find-orgnode "")

# https://code.orgmode.org/bzg/org-mode.git
# (find-git-links "https://code.orgmode.org/bzg/org-mode.git" "orggit")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/org-mode/
cd      ~/usrc/
git clone https://code.orgmode.org/bzg/org-mode.git
cd      ~/usrc/org-mode/

git branch --list -a
git for-each-ref
PAGER=cat git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/org-mode/")
# (find-gitk  "~/usrc/org-mode/")

# (find-orggitfile "Makefile")

cd      ~/usrc/org-mode/
make          |& tee om
make pdf      |& tee op
make card     |& tee oc
make refcard  |& tee orc







#####
#
# Mailing list
# 2011nov23
#
#####

# «mailing-list»  (to ".mailing-list")
# http://lists.gnu.org/mailman/listinfo/emacs-orgmode
# http://lists.gnu.org/archive/html/emacs-orgmode/
# emacs-orgmode@gnu.org
# http://lists.gnu.org/archive/html/emacs-orgmode/2011-11/msg00874.html

# http://lists.gnu.org/archive/html/emacs-orgmode/2013-09/msg00979.html
#   Re: [O] org mode R remote code evaluation

# http://lists.gnu.org/archive/html/emacs-orgmode/2013-11/msg00124.html
#  Alan Schmitt [O] Org mode and eev
#   https://lists.gnu.org/archive/html/emacs-orgmode/2013-11/msg00319.html seb
#   https://lists.gnu.org/archive/html/emacs-orgmode/2013-11/msg00359.html edrx
#   https://lists.gnu.org/archive/html/emacs-orgmode/2013-11/msg00379.html edrx M-T

# 2023aug28: unsubscribed:
# https://mail.google.com/mail/u/0/#inbox/FMfcgzGtwqKrlfWBBSbQkhmMVlZLWgkC

# «gmane» (to ".gmane")
# http://news.gmane.org/gmane.emacs.orgmode
#  A small hack to document programs externally [fetchlines]
#   http://article.gmane.org/gmane.emacs.orgmode/79615
#   http://lists.gnu.org/archive/html/emacs-orgmode/2013-12/msg00192.html





#####
#
# mailing-list-mbox
# 2022may27
#
#####

# «mailing-list-mbox»  (to ".mailing-list-mbox")
# (find-es "emacs" "emacs-devel-mbox")
# https://lists.gnu.org/archive/html/emacs-orgmode/2013-11/
# https://lists.gnu.org/archive/html/emacs-orgmode/2013-11/msg00319.html
# https://lists.gnu.org/archive/mbox/emacs-devel/
# https://lists.gnu.org/archive/mbox/emacs-orgmode/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mkdir -p $S/https/lists.gnu.org/archive/mbox/emacs-orgmode/
cd       $S/https/lists.gnu.org/archive/mbox/emacs-orgmode/
YYYYS=(2013 2014 2015 2016 2017 2018 2019 2020 2021 2022)
YYYYS=(2020 2021 2022)
for yyyy in $YYYYS; do
  for mm in 01 02 03 04 05 06 07 08 09 10 11 12; do
      URL=https://lists.gnu.org/archive/mbox/emacs-orgmode/${yyyy}-${mm}
      echo $URL
      wget -nc $URL
  done
done

# (code-c-d "orgmodembox" "$S/https/lists.gnu.org/archive/mbox/emacs-orgmode/")
# (find-orgmodemboxfile "")

# (find-orgmodemboxsh "mboxgrep 'From: Eduardo Ochs' 2020-01")
# (find-orgmodemboxsh "mboxgrep 'From: Eduardo Ochs' 2021-01")
# (find-orgmodemboxsh "mboxgrep 'From: Eduardo Ochs' 2021-11")
# (find-orgmodemboxsh "mboxgrep 'From: Eduardo Ochs' 2021-12")
# (find-orgmodemboxsh "mboxgrep 'From: Eduardo Ochs' 2022-02")
# (find-orgmodemboxsh "mboxgrep 'From: Eduardo Ochs' 2022-05")

# (find-man "mboxgrep")








#####
#
# stackexchange
# 2019nov09
#
#####

# «stackexchange» (to ".stackexchange")
# https://emacs.stackexchange.com
# https://emacs.stackexchange.com/tags
# https://emacs.stackexchange.com/?tags=org-mode
# https://emacs.stackexchange.com/?tags=org-export
# https://emacs.stackexchange.com/?tags=org-babel
# https://emacs.stackexchange.com/questions/52836/org-mode-babel-is-there-a-way-to-assert-the-expected-results-of-evaluation
# https://emacs.stackexchange.com/questions/tagged/fonts




#####
#
# Edit links (with backspace and C-c C-l)
# 2021sep06
#
#####

# «edit-link»  (to ".edit-link")
# (find-fline "~/LOGS/2021sep06.emacs")
# (find-fline "~/LOGS/2021sep06.emacs" "C-c C-l")
# (find-orgnode "Handling Links" "C-c C-l")
# (find-orgnode "Link Format" "[[LINK][DESCRIPTION]]")
# (find-orgnode "Link Format" "<BS>")




#####
#
# Hyperlinks in Org
# 2011nov23
#
#####

# «hyperlinks»  (to ".hyperlinks")
# (find-orgnode "External links" "elisp:")
# (find-orgnode "Using links outside Org")
# (find-orgnode "Link abbreviations")
# (find-orgnode "Search options")
# (find-orgnode "Adding hyperlink types")
# (find-orgnode "Internal links" "C-c C-o")

# Compare with:
# (find-eev-quick-intro "3. Elisp hyperlinks")
# (find-eev-quick-intro "9. Shorter hyperlinks")
# (find-links-conv-intro "1. Security vs. transparency")
#
# And with these (very old):
# (find-eevarticlesection "hyperlinks")
# (find-eevarticlesection "shorter-hyperlinks")
# (find-eevarticlesection "dangerous-hyperlinks")
# (find-eevarticlesection "generating-hyperlinks")




#####
#
# Elisp hyperlinks in Org
# 2012jan25
#
#####

# «elisp-links»  (to ".elisp-links")
# (find-orgnode "External links")
# (find-orgnode "Handling links" "C-c l"   "Store a link")
# (find-orgnode "Handling links" "C-c C-l" "Insert a link")
# (find-orgnode "Handling links" "C-c C-o" "Open link at point")
# (find-evardescr 'org-link-elisp-confirm-function)
# (find-evariable 'org-link-elisp-confirm-function)

[[elisp:(sexp)][descricao]] 

(setq org-confirm-elisp-link-function nil)
[[elisp:(progn (eek "C-e") (insert "\nHELLO"))][HELLO]]


# (find-sh0 "echo '[[elisp:(find-fline \"/tmp/\")][/tmp/]]' > /tmp/el.org")
# (find-fline "/tmp/el.org")

# (find-efunction 'org-open-at-point)
# (find-efunction 'org-open-at-point "(string= type \"elisp\")")
# (find-elfile "org/ChangeLog")

  [[file:~/TODO]]
  [[file:~/TODO::idle]]

# (find-fline "~/TODO")
# (find-fline "~/TODO" "idle")
# (find-orgnode "External links" "file:projects.org::some words")




#####
#
# internal links
# 2014sep06
#
#####

# «internal-links» (to ".internal-links")
# http://orgmode.org/manual/Internal-links.html
# (find-orgnode "Internal links" "C-c C-o")



#####
#
# youtube
# 2022sep26
#
#####

# «youtube»  (to ".youtube")
# https://irreal.org/blog/?p=10830 Extending Org Links and Youtube
# https://bitspook.in/blog/extending-org-mode-to-handle-youtube-links/




#####
#
# org-link-parameters
# 2023dec27
#
#####

# «org-link-parameters»  (to ".org-link-parameters")
# (find-evardescr 'org-link-parameters)
# (find-evariable 'org-link-parameters)
# (find-epp        org-link-parameters)





#####
#
# Org-babel
# 2011nov23 / 2019nov03
#
#####

# «org-babel»  (to ".org-babel")
# (find-orgnode "Library of Babel")
# https://orgmode.org/worg/library-of-babel.html

# (find-orgnode "Literal examples"              "#+BEGIN_SRC")
# (find-orgnode "Source blocks in LaTeX export" "#+BEGIN_SRC")
# (find-orgnode "Advanced configuration"        "#+begin_src")
# (find-orgnode "Working with source code"      "#+BEGIN_SRC")
# (find-orgnode "Structure of code blocks"      "#+BEGIN_SRC")
# (find-orgnode "Code block specific header arguments" "#+BEGIN_SRC")
# (find-orgnode "var"       "#+BEGIN_SRC")
# (find-orgnode "results"     "BEGIN_SRC")
# (find-orgnode "dir"       "#+BEGIN_SRC")
# (find-orgnode "noweb"     "#+BEGIN_SRC")
# (find-orgnode "noweb-ref" "#+BEGIN_SRC")
# (find-orgnode "cache"     "#+BEGIN_SRC")
# (find-orgnode "hlines"    "#+BEGIN_SRC")
# (find-orgnode "colnames"  "#+BEGIN_SRC")
# (find-orgnode "rownames"  "#+BEGIN_SRC")
# (find-orgnode "post"      "#+BEGIN_SRC")
# (find-orgnode "Results of evaluation"  "#+BEGIN_SRC")
# (find-orgnode "Noweb reference syntax" "#+BEGIN_SRC")
# (find-orgnode "Easy templates"         "#+BEGIN_SRC")
# (find-orgnode "Structure Templates")
# (find-orgnode "Structure Templates"               "#+BEGIN_SRC")
# (find-orgnode "Structure Templates" "C-c C-," "s" "#+BEGIN_SRC")
# (find-orgnode "Main Index" "#+BEGIN_SRC")

# http://www.cs.unm.edu/~eschulte/data/CISE-13-3-SciProg.pdf
# http://orgmode.org/worg/org-contrib/babel/index.html
# http://orgmode.org/worg/org-contrib/babel/intro.html
# http://orgmode.org/manual/Literal-examples.html
# http://orgmode.org/manual/Working-With-Source-Code.html
# http://orgmode.org/worg/org-contrib/babel/languages.html

# (find-orgsrcfile "contrib/babel/")
# (find-orgbabelfile "library-of-babel.org")
# (find-orgbabelfile "library-of-babel.org")
# (find-orgbabelfile "library-of-babel.org" "Available languages")
# (find-orgbabelfile "library-of-babel.org" "Available languages" "From Org's core")



#####
#
# Org-babel-screen (inspired on eev)
# 2011nov23
#
#####

# «org-babel-screen»  (to ".org-babel-screen")
# http://orgmode.org/worg/org-contrib/babel/languages/ob-doc-screen.html
# http://orgmode.org/worg/org-contrib/babel/languages/ob-doc-screen.org.html
# (find-orgsrcfile "lisp/")
# (find-orgsrcfile "lisp/ob-screen.el")
# (find-orgsrcfile "lisp/ob.el")

# My announcement of eepitch (as similar to org-babel-screen):
# http://lists.gnu.org/archive/html/emacs-orgmode/2011-11/msg00874.html

# (find-es "org")
# (find-sh "locate /ob-")
# (find-efile "org/")





#####
#
# Code blocks
# 2013sep12
#
#####

# «code-blocks» (to ".code-blocks")
# (find-orgnode "Evaluating code blocks")
# (find-efunctiondescr 'org-ctrl-c-ctrl-c "If the cursor is on a code block")
# (find-efunction 'org-ctrl-c-ctrl-c)
# (find-evardescr 'org-confirm-babel-evaluate)
# (setq org-confirm-babel-evaluate nil)

# http://lists.gnu.org/archive/html/emacs-orgmode/2013-09/msg00551.html andrey
# http://lists.gnu.org/archive/html/emacs-orgmode/2013-09/msg00552.html edrx
# http://lists.gnu.org/archive/html/emacs-orgmode/2013-09/msg00553.html eric
# http://www.emacswiki.org/emacs/OrgMode
# (find-efile "org/ob-sh.el")
# (find-efile "org/ob-sh.el" "defun org-babel-execute:sh")
# (find-efunction 'org-babel-execute-src-block)
# (require 'ob-sh)
# (require 'ob-shell)

* Switch to org-mode: (org-mode)
# Back: (fundamental-mode)

#+BEGIN_SRC sh
seq 10 14
#+END_SRC

#+RESULTS:
| 10 |
| 11 |
| 12 |
| 13 |
| 14 |

#+begin_src sh :dir /ssh:edrx@angg.twu.net:
ls -la
#+end_src

# "org-babel-execute-src-block: No org-babel-execute function for sh!"
# (find-efunction 'org-babel-execute-src-block)
# (find-efile "org/ob.el" "No org-babel-execute function for %s!")

* Rest of the file:
# (find-efunction 'org-babel-do-load-languages)
# (find-efunction 'org-babel-load-languages)




#####
#
# Org-babel languages
# 2013feb16
#
#####

# «languages» (to ".languages")
# (find-orgnode "Languages")
# (find-orgnode "Structure of code blocks")
# (find-orgnode "Evaluating code blocks")
# (find-orgnode "Code Evaluation Security")
# (find-efile "org/ob-emacs-lisp.el")
# (find-efile "org/ob-shell.el")
# (find-efunctiondescr 'org-babel-do-load-languages)
# (find-evardescr      'org-babel-load-languages)

     (org-babel-do-load-languages
      'org-babel-load-languages
      '((emacs-lisp . nil)
        (R . t)))

   It is also possible to enable support for a language by loading the
related elisp file with `require'.

     The following adds support for evaluating `clojure' code blocks.

     (require 'ob-clojure)

(require 'ob-shell)




#####
#
# org-element-context
# 2021dec07
#
#####

# «org-element-context»  (to ".org-element-context")
# (find-fline "~/LOGS/2021dec07.emacs")
# (find-fline "~/LOGS/2021dec07.emacs" "org-element-context")
# (find-ssr-links     "org20211207" "2021dec07-org")
# (code-eevvideo      "org20211207" "2021dec07-org")
# (code-eevlinksvideo "org20211207" "2021dec07-org")
# (find-org20211207video "0:00")
# (find-angg "ORG/dec2021.org")


# (require 'ob-shell)
# (setq org-confirm-babel-evaluate nil)

#+BEGIN_SRC sh
# Run:   (eek "C-c C-c")
#        (org-babel-execute-src-block)
#  See:  (eek "M-h M-k  C-c C-c  ;; org-ctrl-c-ctrl-c")
#        (find-efunctiondescr      'org-ctrl-c-ctrl-c)
#        (find-efunction           'org-ctrl-c-ctrl-c)
#        (find-efunction           'org-babel-execute-src-block)

# Clear the results: (org-babel-remove-result)
#  See:  (eek "M-h M-k  C-c C-v k  ;; org-babel-remove-result-one-or-many")
#        (find-efunctiondescr        'org-babel-remove-result-one-or-many)
#        (find-efunction             'org-babel-remove-result-one-or-many)

# Parse: (find-eppp (org-element-context))

seq 10 14

#+END_SRC



#+begin_comment
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
emacs28_0 /tmp/foo.org

#+end_comment






#####
#
# PicoLisp in Babel
# 2011nov23
#
#####

# «picolisp»  (to ".picolisp")
# (find-es "lisp" "picolisp")
# http://www.mail-archive.com/picolisp@software-lab.de/msg02796.html
# http://www.mail-archive.com/picolisp@software-lab.de/index.html#02796
# (find-orgbabelfile "langs/")
# (find-orgbabelfile "langs/ob-picolisp.el")




#####
#
# Emacs starter kit
# 2011nov24
#
#####

# «emacs-starter-kit»  (to ".emacs-starter-kit")
# http://eschulte.github.com/emacs-starter-kit/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv /tmp/emacs24-starter-kit/
mkdir   /tmp/emacs24-starter-kit/
cd      /tmp/emacs24-starter-kit/
git clone https://github.com/eschulte/emacs24-starter-kit
tar -cvzf ~/tmp/emacs24-starter-kit-git.tgz *

rm -Rfv ~/usrc/emacs24-starter-kit/
tar -C  ~/usrc/ -xvzf ~/tmp/emacs24-starter-kit-git.tgz
cd      ~/usrc/emacs24-starter-kit/

# (code-c-d "emacsstarterkit" "~/usrc/emacs24-starter-kit/")
# (find-emacsstarterkitfile "")




#####
#
# R squared
# 2012jan12
#
#####

# «R-squared»  (to ".R-squared")
# http://lists.gnu.org/archive/html/emacs-orgmode/2012-01/msg00444.html
# http://lists.gnu.org/archive/html/emacs-orgmode/2012-01/msg00456.html




#####
#
# Tables in Org
# 2012feb12
#
#####

# «tables»  (to ".tables")
# (find-orgnode "Built-in table editor")
# Did I disable the table keys?...
# (find-angg ".emacs" "org-mode")
# (find-efunctiondescr 'org-mode)




#####
#
# Captures
# 2012feb12 / 2016feb14
#
#####

# «captures»  (to ".captures")
# «org-capture» (to ".org-capture")
# (find-orgnode "Remember")
# (find-orgsrcfile "lisp/org-capture.el")
# http://orgmode.org/manual/Using-capture.html
# http://orgmode.org/manual/Capture.html
# (find-orgnode "Adding hyperlink types")
# http://lists.gnu.org/archive/html/emacs-orgmode/2012-02/msg00692.html
# http://lists.gnu.org/archive/html/emacs-orgmode/2012-02/msg00706.html

# (find-efunctiondescr 'org-capture)
# (find-efunction      'org-capture)

# https://addons.mozilla.org/en-US/firefox/addon/org-mode-capture/
# https://www.reddit.com/r/emacs/comments/4peje3/does_anyone_have_orgcapture_for_firefox_working/
# http://weblog.zamazal.org/org-mode-firefox/
# https://github.com/sprig/org-capture-extension
# https://www.youtube.com/watch?v=JVo06-7tKNM




#####
#
# Protesilaos Stavrou: Emacs: Introduction to ORG-CAPTURE
# 2021jun02
#
#####

# «org-capture-prot»  (to ".org-capture-prot")
# https://lists.gnu.org/archive/html/help-gnu-emacs/2021-06/msg00051.html me: org-capt suggestions?
#
# Protesilaos Stavrou: Emacs: Introduction to ORG-CAPTURE
# https://www.youtube.com/watch?v=qCdScs4YO8k
# (find-youtubedl-links nil nil "qCdScs4YO8k" nil "orgcaptprot")
# (code-video "orgcaptprotvideo" "/sda5/videos/Emacs_-_Introduction_to_ORG-CAPTURE-qCdScs4YO8k.webm")
# (find-orgcaptprotvideo "0:00")
# (find-orgcaptprotvideo "1:37" "let's call")
# (find-orgcaptprotvideo "2:02" "let's hit r")
# (find-orgcaptprotvideo "2:30" "meetings.org")
# (find-orgcaptprotvideo "3:40" "d")
# (find-orgcaptprotvideo "4:30" "specify a file")
# (find-orgcaptprotvideo "7:25" "clipboard pasted as level 2 subtree")
# (find-orgcaptprotvideo "8:21" "dired")
# (find-orgcaptprotvideo "11:15" "another prompt (3rd)")
# (find-orgcaptprotvideo "11:50" "options with |")
# (find-orgcaptprotvideo "15:00" "active region")
# (find-orgcaptprotvideo "16:00" "let's select this")
# (find-orgcaptprotvideo "16:20" "relative date")
# (find-orgcaptprotvideo "17:10" "submenu")
# (find-orgcaptprotvideo "22:20" "underpowered")
#
# https://protesilaos.com/codelog/2020-02-04-emacs-org-capture-intro/

# (find-orgnode "Capture")
# (find-evardescr 'org-capture-templates)
# (find-evariable 'org-capture-templates)

# https://irreal.org/blog/?p=8694 An Introduction to Org Capture



#####
#
# My e-mail about find-orgctarget in 2021jun04
# 2021jun04
#
#####

# «org-capture-2021jun04»  (to ".org-capture-2021jun04")
# https://lists.gnu.org/archive/html/help-gnu-emacs/2021-06/msg00106.html

Hi Jean Louis,

this is an answer to these messages that you sent:

  https://lists.gnu.org/archive/html/help-gnu-emacs/2021-06/msg00028.html
  https://lists.gnu.org/archive/html/help-gnu-emacs/2021-06/msg00055.html

I decided to create a new thread, and I'm working on org-capture
first. I'll leave org-protocol for later.

I watched Prot's video about org-capture -
https://www.youtube.com/watch?v=qCdScs4YO8k - and I am trying to
implement a function that works as a sexp hyperlink to a "target"
structure like the ones that appear in org-capture-templates. These
target structures are documented here:

  (find-evardescr 'org-capture-templates)
  (find-evardescr 'org-capture-templates "\ntarget")
  (find-evardescr 'org-capture-templates "\ntarget" "file+headline")
  (find-orgnode "Capture templates" "file+headline")
  (find-orgnode "Template elements" "\ntarget")

In Prot's video he uses targets like these,

  (file+headline "tasks.org" "Task list")
  (file+headline "tasks.org" "Links to buffers/files")

and I am trying to write a function `find-orgctarget' such that

  (find-orgctarget '(file+headline "tasks.org" "Task list"))

would open the file

  (concat org-directory "/tasks.org")

and then find the headline "* Task list" in it, and put the point in
the line following that headline. After a few very naive attempts I
got this definition for `find-orgctarget':

  (require 'org-capture)

  (defun find-orgctarget (target)
    (org-capture-set-target-location target)
    (org-capture-finalize t))

but when I run this

  (find-orgctarget '(file+headline "tasks.org" "Task list"))

I get this error:

  org-capture-finalize: This does not seem to be a capture buffer for Org mode

Do you - or anyone else - know how to fix that?

  Thanks in advance!
    Eduardo Ochs
    http://angg.twu.net/#eev
    http://angg.twu.net/eev-intros/find-eev-quick-intro.html#3
    (find-eev-quick-intro "3. Elisp hyperlinks")





#####
#
# Replacing [X] by a checkmark
# 2012feb12
#
#####

# «checkmark»  (to ".checkmark")
# (find-elnode "Customizing Keywords")
# (find-efunction 'compose-region)

;; I asciified this a bit
(font-lock-add-keywords
 'org-mode
 '(("\\[\\(X\\)\\]"
   (0 (progn (compose-region (match-beginning 1) (match-end 1) "><") nil)))
  ))

(font-lock-add-keywords
 nil
 '(("\\[\\(X\\)\\]"
   (0 (progn (compose-region (match-beginning 1) (match-end 1) "abcd") nil)))
  ))

;; (font-lock-mode 1)
;; (font-lock-mode 0)
;; [X]






#####
#
# Reproducible research
# 2012feb23
#
#####

# «reproducible-research»  (to ".reproducible-research")
# http://www.jstatsoft.org/v46/i03
# http://www.jstatsoft.org/v46/i03/paper
# http://www.google.com/search?q=org+reproducible+research
# http://reproducibleresearch.net/index.php/Main_Page
# http://www.reproducibleresearch.net/blog/

# From:
# http://lists.gnu.org/archiv/ehtml/emacs-orgmode/2012-02/msg00622.html
#
#   Some people on the list might like to see the short (13 min)
#   segment on Duke University's recent problems with reproducible
#   research
#     http://www.cbsnews.com/video/watch/?id=7398476n&tag=contentMain;contentAux
#   and the heroic efforts to uncover what had been done (37 min):
#     http://videolectures.net/cancerbioinformatics2010_baggerly_irrh/




#####
#
# org-export-dispatch
# 2021dec29
#
#####

# «org-export-dispatch»  (to ".org-export-dispatch")
# (find-efunctiondescr 'org-export-dispatch)
# (find-efunction      'org-export-dispatch)

(progn
 (find-angg "emacs-lua/README.org")
 (eek "C-c C-e"))

(toggle-debug-on-entry 'org-export-dispatch)

# https://lists.gnu.org/archive/html/emacs-orgmode/2021-12/msg00674.html
# Subj: Org for non-users, part 2: `C-c C-e', a.k.a. `org-export-dispatch'

Hi all,

a few weeks ago I recorded a video called "Org for non-users" -
link:

  http://angg.twu.net/2021-org-for-non-users.html

that was about a way to understand some of the data structures that
are used in the support for code blocks. Now I would like to do
something similar with the exporter, but I am stuck at the first
step... When I run `M-x org-export-dispatch' or `C-c C-e' it creates a
second window whose mode line says "*Org Export Dispatcher*" -

My first question is:

  What are the recommended ways to abort org-export-dispatch without
  letting it destroy the "*Org Export Dispatcher*" window and its
  buffer?

I will probably get stuck at other points later, but I think that I'll
be able to get quite far by myself if I can inspect that buffer with
the tools that I know.

All suggestions are welcome, including suggestions related to
questions that you guess that I will have later. =)

  Thanks in advance!
    Eduardo Ochs
    http://angg.twu.net/#eev
    http://angg.twu.net/emacsconf2021.html



# «org-export-dispatch-ihor»  (to ".org-export-dispatch-ihor")
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-02/msg00098.html
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-02/msg00106.html
# My answer (2022feb07):

Hi Ihor,

What do you mean by "you cannot"?
I was expecting an answer like this:

  That's difficult to do, but the temporary buffer is generated by the
  function `org-foo-bar'... you can try to make a copy of
  `org-foo-bar' called `org-foo-bar-hacked-version', add your own
  debugging functions to that copy - suggestion: the lines 42 and 99
  are good places for that - and then you can change the function
  `org-plic-ploc', that is called by `org-export-dispatch', to make it
  call `org-foo-bar-hacked-version' instead of `org-foo-bar'...

One possible meaning of "you cannot" is:

  Org is NOT MEANT to be explored in that way, and this "is not meant
  to" is in a very strong sense. The last time that a person gave
  technical information of that kind in the mailing list was 4 or 5
  years ago, and we banished her from the community and excommunicated
  her. Her name shall not be mentioned.

Frustrated cheers =(,
  Eduardo Ochs
  http://angg.twu.net/#eev


# (find-es "emacs" "unwind-protect")




#####
#
# org-export-dispatch-2023-01
# 2023jan03
#
#####

# «org-export-dispatch-2023-01»  (to ".org-export-dispatch-2023-01")

https://lists.gnu.org/archive/html/emacs-orgmode/2022-12/msg00806.html Edrx
https://lists.gnu.org/archive/html/emacs-orgmode/2022-12/msg00812.html Jean Louis

https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00013.html Ihor 1
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00029.html Edrx 2
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00042.html Jean Louis 3
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00065.html Ihor 4
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00067.html Edrx 5
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00073.html Max Nikulin 6
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00074.html Edrx 7
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00113.html Ihor 8 
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00127.html Edrx 9


(find-orggrep "grep --color=auto -nH --null -e read-char-exclusive *.el")


https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00136.html
Hi Alain,

here is what I am doing to try to understand those buffers using
eev-isms. I am keeping this in one part of my notes,

  (org-mode)
  (debug-on-entry        'read-char-exclusive)
  (eek "C-c C-e")
  (cancel-debug-on-entry 'read-char-exclusive)
  (fundamental-mode)

and to make the "*Org Export Dispatcher*" appear I run the first three
sexps with my favorite variant of `C-e C-x C-e'.

Then I did this to pretty-print the buffer-list,

  (find-eppp (buffer-list))

and this to save the contents of that buffer in a variable:

  (with-current-buffer "*Org Export Dispatcher*"
    (setq o (buffer-string)))

Cheers,
  Eduardo Ochs
  http://angg.twu.net/#eev




#####
#
# Exporting to HTML
# 2012mar12
#
#####

# «export-to-html»  (to ".export-to-html")
# (find-orgnode "Markup")
# (find-orgnode "Exporting")
# (find-orgnode "HTML export")
# (find-orgnode "HTML Export commands" "`C-c C-e h'")
# (find-orgnode "HTML Export commands" "`C-c C-e b'")
# (find-orgnode "CSS support")
# (find-orgnode "CSS support" "#+STYLE:")
# (find-orgnode "Literal examples" "#+BEGIN_SRC emacs-lisp")
# (find-efunctiondescr 'org-export)

# http://www.emacswiki.org/emacs/DavidOtoole
# http://dto.github.com/notebook/orgtutorial.html
# http://dto.github.com/notebook/orgtutorial.org
# http://dto.github.com/eon.css

# http://florian.adamsky.it/about/
# http://stevelosh.com/blog/

# 
# It seems to have a version of htmlize in it...




#####
#
# export via sexps
# 2015jan23
#
#####

# «export-via-sexp» (to ".export-via-sexp")
# (find-efunctiondescr 'org-export-dispatch)
# (find-efunction 'org-export-dispatch)
# (find-evardescr 'org-export-dispatch-use-expert-ui)
# (find-efunctiondescr 'org-export--dispatch-ui)
# (find-efunction 'org-export--dispatch-ui)




#####
#
# export-options
# 2021jul31
#
#####

# «export-options»  (to ".export-options")
# (find-orgnode "Table of Contents")
#+OPTIONS: toc:nil num:nil
# (find-eapropos "org.*option")
# (find-orgfile "ob-exp.el")
# (find-fline "~/2021-1-C2-C3/README.org")
# (find-fline "~/2021-1-C2-C3/README.org" "C-c C-e h h")
# (find-evardescr 'org-export-with-date)
# (find-evardescr 'org-export-with-date "date:nil")
# (find-evariable 'org-export-with-date)
# (find-evardescr 'org-export-with-author)
# (find-evardescr 'org-export-with-author "author:nil")
# (find-evariable 'org-export-with-author)

# (find-evardescr 'org-html-validation-link)
# (find-evariable 'org-html-validation-link)




#####
#
# export-title
# 2021jul31
#
#####

# «export-title»  (to ".export-title")
# (find-orgnode "Export Settings" "#+TITLE")
# (find-fline "~/ORG/agda.org")




#####
#
# org-html-postamble
# 2021jul31
#
#####

# «org-html-postamble»  (to ".org-html-postamble")
# (find-orgnode "HTML preamble and postamble")
# (find-evardescr 'org-html-postamble)
# (find-evariable 'org-html-postamble)
# (find-evariable 'org-html-postamble "No postamble")
# (find-evardescr 'org-html-postamble-format)
# (find-evariable 'org-html-postamble-format)
# (find-fline "~/.emacs.custom" "(safe-local-variable-values")
# (find-fline "~/.emacs.custom"  "org-html-postamble")
# (find-fline "~/ORG/agda.org")





#####
#
# Carsten Dominik's video on Google TechTalks
# 2012mar12
#
#####

# «carsten-video»  (to ".carsten-video")
# «carsten-2008» (to ".carsten-2008")
# (find-org-intro)

# http://orgmode.org/talks.html
# http://orgmode.org/worg/org-tutorials/org-screencasts/org-mode-google-tech-talk.html
# http://www.youtube.com/watch?v=oJTwQvgfgMM Emacs Org-mode - a system for note-taking and project planning
# (find-youtubedl-links "/sda5/videos/" "Emacs_Org-mode_-_a_system_for_note-taking_and_project_planning" "oJTwQvgfgMM" ".flv" "orgcarsten")

# (find-mplayer  "/sda5/videos/Emacs_Org-mode_-_a_system_for_note-taking_and_project_planning-oJTwQvgfgMM.flv")
# (code-mplayer "orgcarstenvideo" "/sda5/videos/Emacs_Org-mode_-_a_system_for_note-taking_and_project_planning-oJTwQvgfgMM.flv")
# (find-orgcarstenvideo)
# (find-orgcarstenvideo "13:30" "TODO")
# (find-orgcarstenvideo "18:30" "Column view")

(eev-avadj-mode 1)
(find-orgcarstenvideo t)

1:20 Carsten Start
1:50 History
2:15 Working with Text Files
3:58 Notes (not tasks) based project planning
5:50 Outline mode - fixing
9:56 Structure Editing
11:00 Note taking other supports
13:35 Meta data Intro
14:57 tags
15:26 Timeplanning
15:53 Properties
16:02 Meta data propagation
16:49 Special Meta entry interfaces
17:55 DateTime interface
18:24 Column view
19:20 Capture with remember
23:02 Collect and Display
23:52 Sparse tree
25:47 Agenda view
27:27 Exporting and publishing
29:05 Tables
31:34 Calc
32:44 Radio tables
34:53 Context sensitive keys
38:13 How is org used
40:55 Evolved Software software
Thanks to Rustom Mody for this timeline.




#####
#
# Carsten Dominik's talk at the Max Planck Institute
# 2013sep28
#
#####

# «carsten-max-planck» (to ".carsten-max-planck")

http://www.nf.mpg.de/orgmode/guest-talk-dominik.html
http://ftp5.gwdg.de/pub/misc/videos/emacs_org_mode/orgmode-mpinf-2010-c1.ogg

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /sda5/videos/
wget http://ftp5.gwdg.de/pub/misc/videos/emacs_org_mode/orgmode-mpinf-2010-c1.ogg

;; (find-fline "/sda5/videos/")
(code-video "orgmode2010" "/sda5/videos/orgmode-mpinf-2010-c1.ogg")
;; (find-orgmode2010)
;; (find-orgmode2010 "0:00")
;; (find-orgmode2010 t)

(eev-avadj-mode 1)
(find-orgcarstenvideo t)








#####
#
# Links to video offsets
# 2013sep28
#
#####

# «video-offsets» (to ".video-offsets")

<edrx> anyone knows how the time offsets like "=2:15=" in
       http://orgmode.org/worg/org-tutorials/org-screencasts/org-mode-google-tech-talk.org.html
       are converted to links to a youtube video (Google Tech Talk
       by Carsten Dominik, 2008)?
<edrx> I want to know how standard that is, and how the htmlizer
       knew that they had to point to
       http://www.youtube.com/watch?v=oJTwQvgfgMM ...
<edrx> I have a similar feature in eev-mode and I am trying to
       write more on how to integrate eev and org...
<edrx> btw, how do I configure org to run the sexp (funcall
       ee-audiovideo-last "1:23") when I follow a link like
       "=1:23=" in an org file?






#####
#
# LaTeX header
# 2012mar21
#
#####

# «latex-header»  (to ".latex-header")

I want to set the latex-head for latex exporting, I use
*org-export-latex-append-header*,but it seem not used by
*org-preview-latex-fragment* . is there any other way?
simple way?

#+begin_latex
\ifxetex    % xelatex
 \usepackage[xetex]{hyperref}
\else
 \ifpdf    % pdflatex
   \usepackage[pdftex,unicode]{hyperref}
 \else     % dvipdfmx or dvips
   \usepackage[dvipdfmx,unicode]{hyperref}
   %\usepackage[ps2pdf,unicode]{hyperref}
 \fi
\fi

\ifxetex\else\ifpdf\else
 % pdftex 3.1415926-1.40.10-2.2 has trouble with it
 \InputIfFileExists{zhwinfonts.tex}{}{}
\fi\fi
#+end_latex

#+begin_src emacs-lisp
(setq  org-export-latex-append-header
      "
\\ifxetex    % xelatex
 \\usepackage[hyperref,UTF8,nofonts]{ctex}
 \\setCJKmainfont[ItalicFont={AR PL UKai CN}]{AR PL UMing CN}
 \\setCJKsansfont{WenQuanYi Zen Hei}
 \\setCJKmonofont{WenQuanYi Zen Hei}
 \\usepackage[xetex]{hyperref}
\\else
 \\ifpdf    % pdflatex
   \\usepackage[pdftex,unicode]{hyperref}
 \\else     % dvipdfmx or dvips
   \\usepackage[dvipdfmx,unicode]{hyperref}
   %\\usepackage[ps2pdf,unicode]{hyperref}
 \\fi
\\fi

\\ifxetex\\else\\ifpdf\\else
 % pdftex 3.1415926-1.40.10-2.2 has trouble with it
 \\InputIfFileExists{zhwinfonts.tex}{}{}
\\fi\\fi
")
#+end_src




#####
#
# An ee-goto-position bug (it jumps to hidden regions)
# 2012mar21
#
#####

# «ee-goto-position-bug»  (to ".ee-goto-position-bug")
# (find-fline "~/ORG/index.org" "ee-goto-postion bug")
# (find-fline "~/ORG/index.org" "ee-goto-postion bug" "test")





#####
#
# TAB for inserting templates
# 2012mar29
#
#####

# «tab-templates»  (to ".tab-templates")
# (find-orgnode "Completion")
# (find-orgnode "Easy Templates")
# (find-orgnode "Easy Templates" "s" "#+BEGIN_SRC ... #+END_SRC")
# (find-orgnode "Structure Templates")
# (find-orgnode "Structure Templates" "s" "#+BEGIN_SRC" "#+END_SRC")
# (find-orgmanualpage (+ 10 231) "16.1 Completion")
# (find-orgmanualtext (+ 10 231) "16.1 Completion")
# (find-orgmanualpage (+ 10 231) "16.2 Structure Templates")
# (find-orgmanualtext (+ 10 231) "16.2 Structure Templates")

<edrx> I just read about the "< e TAB" trick to insert a
       #+BEGIN_EXAMPLE / #+END_EXAMPLE pair in the mailing list,
       at:
       http://lists.gnu.org/archive/html/emacs-orgmode/2012-03/msg01182.html
<edrx> but I can't find anything about it in the manual... anyone
       knows where this is described?
<edrx> (source code pointers would be great too)


# (find-efunction 'org-cycle)
# (find-efunction 'org-cycle "template completion")
# (find-efunction 'org-cycle "org-try-structure-completion")
# (find-efunction 'org-try-structure-completion)

# (find-egrep "zgrep -nH -e EXAMPLE org/*.el*")
# (find-egrep "zgrep -nH -e org-complete org/*.el*")
# (find-efile "org/org.el" ";;;; Completion")
# (find-evardescr 'org-structure-template-alist)
# (find-evariable 'org-structure-template-alist)
# (find-efile "org/org-pcomplete.el")





#####
#
# Papers about org-mode
# 2012apr16
#
#####

# «papers-about-org»  (to ".papers-about-org")
# This thread:
# http://lists.gnu.org/archive/html/emacs-orgmode/2012-04/msg00394.html




#####
#
# org-texinfo / ox-texinfo
# 2012jul19 / 2022mar11
#
#####

# «org-texinfo»  (to ".org-texinfo")
# «ox-texinfo»   (to ".ox-texinfo")
# (find-es "texinfo" "org-texinfo")
# http://lists.gnu.org/archive/html/emacs-orgmode/2012-07/msg00572.html
# (find-angg "ORG/testinfo.org")
# (require                 'ox-texinfo)
# (find-fline (symbol-file 'ox-texinfo))
# (find-orgfile            "ox-texinfo.el")
# (find-orgfile            "ox-texinfo.el" ":menu-entry")
# (find-efunction 'org-texinfo-export-to-texinfo)
# (find-efunction 'org-texinfo-export-to-info)




#####
#
# Thunderbird / Thunderlink
# 2012dec08
#
#####

# «thunderlink» (to ".thunderlink")
# http://lists.gnu.org/archive/html/emacs-orgmode/2012-12/msg00231.html
# https://addons.mozilla.org/de/thunderbird/addon/thunderlink/




#####
#
# TODO and DONE
# 2013jan04
#
#####

# «TODO-and-DONE» (to ".TODO-and-DONE")
# (eek "M-h M-k C-c C-t  ;; org-todo")
# (find-orgnode "TODO basics")
# (find-orgnode "TODO extensions")
# (find-orgnode "Faces for TODO keywords")
# (find-orgnode "Closing items")
# (find-evardescr 'org-log-done)

# (find-anggfile "ORG/genero.org" "#+TODO:")
# (find-orgnode "Per-file keywords")
# (find-orgnode "Faces for TODO keywords")

# (find-es "org" "TODO-and-DONE")
#+TODO: TODO | DONE | HALF




#####
#
# Promote and demote
# 2013jan10
#
#####

# «promote-and-demote» (to ".promote-and-demote")
# (find-efunctiondescr 'org-shiftmetaright)
# (find-orgnode "Structure editing" "`M-S-<left>'")



#####
#
# to-org and to-latex
# 2013apr16
#
#####

# «to-org-and-to-latex» (to ".to-org-and-to-latex")
# (find-anggfile "quadradinho/quadradinho-a5.tex" "to-org")

(defun ee-replace-regexp-all (regexp replacement)
  (save-excursion
    (goto-char (point-min))
     (while (re-search-forward regexp nil t)
       (replace-match replacement))))

(defun to-org () (interactive)
  (ee-replace-regexp-all "\n% \\(*+\\) " "\n\\1 % ")
  (org-mode))

(defun to-latex () (interactive)
  (latex-mode)
  (ee-replace-regexp-all "\n\\(*+\\) % " "\n% \\1 "))




#####
#
# John Kitchin's presentation
# 2013sep27
#
#####

# «kitchin-scipy-org» (to ".kitchin-scipy-org")

> I don't know if this has been linked to before on this mailing
> list.  At SciPy 2013, John Kitchin has made an amazing
> demonstration of Org-mode as a tool for reproducible research.
> Really amazing to watch.
>
> http://www.youtube.com/watch?v=1-dUkyn_fZA
>




#####
#
# Time offsets
# 2013oct01
#
#####

# «time-offsets» (to ".time-offsets")
# My message:
# http://lists.gnu.org/archive/html/emacs-orgmode/2013-09/msg01372.html
# http://orgmode.org/worg/org-tutorials/org-screencasts/org-mode-google-tech-talk.html
# http://orgmode.org/worg/org-tutorials/org-screencasts/org-mode-google-tech-talk.org.html
# Answer:
# http://lists.gnu.org/archive/html/emacs-orgmode/2013-10/msg00012.html
# http://orgmode.org/worg/org-hacks.html
# http://orgmode.org/worg/org-hacks.html#sec-3-12
https://github.com/dbrock/bongo
http://orgmode.org/worg/code/elisp/org-player.el




#####
#
# Add a new link type for video files (by Stardiviner)
# 2020jan04
#
#####

# «link-type-for-video-files» (to ".link-type-for-video-files")
# https://lists.gnu.org/archive/html/emacs-orgmode/2020-01/msg00007.html stardiviner
# https://lists.gnu.org/archive/html/emacs-orgmode/2020-01/msg00011.html my answer
# https://stackexchange.com/users/366399/stardiviner
# https://emacs.stackexchange.com/questions/30031/how-to-display-overlay-like-this-screencast
# https://stardiviner.github.io/
# (find-eevfile "eev-audiovideo.el" "stardiviner")
# (find-orgnode "Adding Hyperlink Types")




#####
#
# Easy templates
# 2013dec08
#
#####

# «easy-templates» (to ".easy-templates")
# (find-orgnode "Paragraphs")
# (find-orgnode "Easy Templates")
# (find-orgnode "Easy Templates" "<e")
# (find-elongkey-links "<tab>  ;; org-cycle")
# (find-efunctiondescr 'org-cycle)
# (find-efunction 'org-cycle)
# (find-egrep "grep -nH -e VERSE org/*.el")
# (find-egrep "grep -nH -e org-structure-template-alist org/*.el")
# (find-evardescr 'org-structure-template-alist)
# (find-evariable 'org-structure-template-alist)
# (find-efunction 'org-try-structure-completion)

# (setq last-kbd-macro (kbd "C-w #+BEGIN_VERSE RET C-y #+END_VERSE RET"))
# (find-angg "ORG/lyrics.org")



#####
#
# audio blocks
# 2013dec09
#
#####

# «audio-blocks» (to ".audio-blocks")
# (find-orgnode "Quoting HTML tags" "#+BEGIN_HTML")

# (find-TH "html5-audio")
# http://orgmode.org/worg/org-tutorials/org-screencasts/org-mode-google-tech-talk.html




#####
#
# Adding new tags
# 2013dec09
#
#####

# «adding-new-tags» (to ".adding-new-tags")
# (to "export-to-html")
# (find-egrep "grep -niH -e mathjax org/*.el")




#####
#
# org-download
# 2014feb26
#
#####

# «org-download» (to ".org-download")
# http://lists.gnu.org/archive/html/emacs-orgmode/2014-02/msg00867.html
(require 'org-download)
https://github.com/abo-abo/org-download
https://github.com/abo-abo/org-download/blob/master/org-download.el





#####
#
# BibTeX
# 2014jun25
#
#####

# «bibtex» (to ".bibtex")
# http://lists.gnu.org/archive/html/emacs-orgmode/2014-06/msg00884.html
# https://vimeo.com/99167082 Emacs Org-mode Bibtex Screencast




#####
#
# Org syntax
# 2014oct03
#
#####

# «org-syntax» (to ".org-syntax")
# (find-node "(org)Org syntax")
# http://orgmode.org/worg/dev/org-syntax.html




#####
#
# Redirecting stderr to stdout with babel/shell
# 2015jan11
#
#####

# «redirecting-stderr» (to ".redirecting-stderr")
# http://lists.gnu.org/archive/html/emacs-orgmode/2015-01/msg00001.html
# http://lists.gnu.org/archive/html/emacs-orgmode/2015-01/msg00212.html




#####
#
# Tikz in Org for newbies
# 2015feb18
#
#####

# «tikz-in-org-for-newbies» (to ".tikz-in-org-for-newbies")
# http://lists.gnu.org/archive/html/emacs-orgmode/2015-02/msg00645.html eric
# http://lists.gnu.org/archive/html/emacs-orgmode/2015-02/msg00655.html edrx
# https://mail.google.com/mail/ca/u/0/#inbox/14b9caf302bde775

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cat > /tmp/t.org <<'%%%'
# To export to LaTeX and open the PDF, type `C-c C-e l o'.
#
# Note that you may have to add latex support to babel
# to make the tikzpicture block work...
# see: (info "(org)Languages")
# try: (org-babel-do-load-languages 'org-babel-load-languages '((latex . t)))
#
# To disable to question "Evaluate this latex code block on your system?",
# see: (info "(org)Code evaluation security")
# try: (setq org-confirm-babel-evaluate nil)

#+latex_header: \usepackage{tikz}
* tikz with babel
This example generates a figure using tikz and exports it as raw latex

#+begin_src latex :results latex raw :exports results
  \begin{tikzpicture}
    \node[red!50!black] (a) {A};
    \node (b) [right of=a] {B};
    \draw[->] (a) -- (b);
  \end{tikzpicture}
#+end_src

Alternatively, you can put tikz inline:
#+latex: \tikz \draw[rotate=30] (0,0) ellipse (6pt and 3pt);
which should appear in the middle of the sentence.
%%%

 (find-fline "/tmp/t.org")




#####
#
# Parsing Org files with Lua and Lpeg
# 2015may10
#
#####

# «parse-org-with-lua» (to ".parse-org-with-lua")
# (find-es "lua-intro" "lpeg-quickref")
# (find-angg "LUA/lua50init.lua" "loadlpeg")
# (find-lpegw3m "lpeg.html#cap-g")
# (find-lpegw3m "lpeg.html#cap-t")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
require "lpeg"
lpeg.test = function (pat, str, ...) PP(pat:C():match(str, ...)) end
P     = lpeg.P
S     = lpeg.S
C     = lpeg.C
sp    = P" "^1
Stars = (P"*"^1):Cg"stars"
Big   = sp*P(":big:"):Cg"big"
Todo  = sp*(P"DONE" + P"HALF" + P"TODO"):Cg"todo"
Rest  = sp*(P(1)^0):Cg"rest"
Pat   = (Stars*(Big+Todo)^0*Rest):Ct()

Pat:test "* :big: TODO why a is b"
Pat:test "**      DONE why b is c"
Pat:test "**           foo"


 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
require "lpeg"
--             (find-fline "~/ORG/istanbul.org")
bigstr = readfile "/home/edrx/ORG/istanbul.org"
P     = lpeg.P
S     = lpeg.S
C     = lpeg.C
NL    = S "\n"
NonNL = 1 - NL
Line         = NonNL^0 * NL 
StarLine     = P"*"^1 * P" " * NonNL^1 * Line
NonStarLine  = (-StarLine) * Line
NonStarLines = (NonStarLine^0):C()
Block        = (StarLine:C() * (NonStarLine^0):C()):Ct()
Blocks       = (Block^0):Ct()

lpeg.test = function (pat, str, ...) PP(pat:C():match(str, ...)) end

pre, blocks = (NonStarLines * Blocks):match(bigstr)
PP(pre)
PP(blocks[1])
PP(blocks[2])
for _,b in ipairs(blocks) do printf("%s", b[1]) end




#####
#
# Org compact guide
# 2015aug09
#
#####

# «org-compact-guide» (to ".org-compact-guide")
# http://orgmode.org/cgit.cgi/org-mode.git/plain/doc/orgguide.texi




#####
#
# org-ref
# 2015dec22
#
#####

# «org-ref» (to ".org-ref")
# http://kitchingroup.cheme.cmu.edu/blog/2015/12/22/org-ref-is-on-Melpa/




#####
#
# M-up and M-down
#
#####

# «M-up-and-M-down» (to ".M-up-and-M-down")
# (find-efunctiondescr 'org-metadown)
# (find-efunctiondescr 'org-move-subtree-down)
# (find-efunctiondescr 'org-move-item-down)
# (find-orgnode "Structure editing" "org-move-subtree-down")
# (find-efunction 'org-move-subtree-down)





#####
#
# organice (Alain M. Lafon, 200ok.ch)
# 2019nov02
#
#####

# «organice» (to ".organice")
# https://organice.200ok.ch/
# https://github.com/200ok-ch/organice
# https://www.youtube.com/watch?v=aQKc0hcFXCk




#####
#
# literate-devops (emacsconf 2015 - recommended by johnw)
# 2019nov02
#
#####

# «literate-devops» (to ".literate-devops")
# (find-fline "~/LOGS/2019nov01.emacsconf" "http://howardism.org/")
# http://howardism.org/Technical/Emacs/literate-devops.html
# http://howardism.org/Technical/LP/introduction.html
# https://www.youtube.com/watch?v=dljNabciEGg
#
# (find-audiovideo-intro)
# (find-youtubedl-links "/sda5/videos/" "Literate_Devops_with_Emacs" "dljNabciEGg" ".mp4" "litdevops")
# (code-video "litdevopsvideo" "/sda5/videos/Literate_Devops_with_Emacs-dljNabciEGg.mp4")
# (find-litdevopsvideo)
# (find-litdevopsvideo "0:00")
# (find-litdevopsvideo "6:32" "#+BEGIN_SRC")
# (find-litdevopsvideo "11:02" "C-c '")

# (find-orgnode "Literal examples" "#+BEGIN_SRC")




#####
#
# multiline-comments
# 2019nov03
#
#####

# «multiline-comments» (to ".multiline-comments")
# (find-orgnode "Comment lines")
# (find-eepitch-intro "3. Test blocks")
# (find-eev "eev-testblocks.el" "ee-insert-test")
# https://lists.gnu.org/archive/html/emacs-orgmode/2013-11/msg00359.html




#####
#
# lazyblorg
# 2019nov03
#
#####

# «lazyblorg» (to ".lazyblorg")
# https://lists.gnu.org/archive/html/emacs-orgmode/2019-11/msg00043.html
# https://github.com/novoid/lazyblorg#why-lazyblorg
# https://github.com/novoid/lazyblorg#features
# https://github.com/novoid/lazyblorg/wiki/Orgmode-Elements#embedding-external-content
# https://github.com/novoid/lazyblorg#how-to-start
# https://github.com/novoid/lazyblorg

# (find-git-links "https://github.com/novoid/lazyblorg" "lazyblorg")
# (code-c-d "lazyblorg" "~/usrc/lazyblorg/")
# (find-lazyblorgfile "")
# (find-lazyblorgfile "config.py")
# (find-lazyblorgfile "example_invocation.sh")
# (find-lazyblorgsh "find * | sort")
# (find-lazyblorggrep "grep --color -nRH --null -e orgformat *")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo apt-get install python3-werkzeug
sudo apt-get install pandoc
sudo apt-get install python3-pypandoc
sudo apt-get install python3-opencv
pip3 install orgformat

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/usrc/lazyblorg/
./example_invocation.sh

# (find-lazyblorgfile "testdata/2del/blog/" "index.html")





#####
#
# problem-with-source-blocks
# 2019nov10
#
#####

# «problem-with-source-blocks» (to ".problem-with-source-blocks")
# https://lists.gnu.org/archive/html/emacs-orgmode/2019-11/msg00113.html my question
# https://lists.gnu.org/archive/html/emacs-orgmode/2019-11/msg00115.html Ken Mankoff
# https://lists.gnu.org/archive/html/emacs-orgmode/2019-11/msg00122.html Ken Mankoff 2
# (find-orggitgrep "grep --color -nrH -e :result *")
# (find-orggitgrep "grep --color -nrH -e ':results output' *")
# (find-orgnode "Evaluating code blocks" ":results output")
# (find-orgnode "Header arguments in Org mode properties" ":results silent")
# (find-orgnode "results" "output")
# (find-org-intro)

# (find-angg ".emacs" "org-mode")




#####
#
# Named code blocks
# 2021jan07
#
#####

# «named-code-blocks»  (to ".named-code-blocks")
# https://lists.gnu.org/archive/html/emacs-orgmode/2021-02/msg00244.html How do you name your code blocks?
# (find-orgnode "Evaluating Code Blocks" "calling a named code block")
# (find-orgnode "Using Header Arguments" ":session")
# (find-efunctiondescr 'org-sbe)
# (find-efunction      'org-sbe)

<noonker> edrx: Did you get an answer to your org-mode question?
          It's (org-sbe BLOCK &optional ARGS)





#####
#
# Org mode collections
# 2019dec14
#
#####

# «collections» (to ".collections")
# https://lists.gnu.org/archive/html/emacs-orgmode/2019-12/msg00215.html



#####
#
# org-agenda
# 2020mar20
#
#####

# «org-agenda» (to ".org-agenda")
# (find-orgnode "Agenda views")
# (find-efunctiondescr 'org-agenda)
# (find-efunction 'org-agenda)




#####
#
# matplotlib
# 2020feb23
#
#####

# «matplotlib» (to ".matplotlib")
# https://orgmode.org/worg/org-contrib/babel/languages/ob-doc-python.html
# (find-orgnode "Handling links")
# (find-orgnode "Handling links" "org-toggle-inline-images")

#+begin_src python :session :results file
import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
fig=plt.figure(figsize=(3,2))
plt.plot([1,3,2])
fig.tight_layout()
plt.savefig('images/myfig.pdf')
'images/myfig.pdf' # return this to org-mode
#+end_src

#+RESULTS:
[[file:images/myfig.pdf]]



#+begin_src python :results file
import matplotlib, numpy
matplotlib.use('Agg')
import matplotlib.pyplot as plt
fig=plt.figure(figsize=(4,2))
x=numpy.linspace(-15,15)
plt.plot(numpy.sin(x)/x)
fig.tight_layout()
plt.savefig('images/python-matplot-fig.png')
return 'images/python-matplot-fig.png' # return filename to org-mode
#+end_src

#+RESULTS:
[[file:images/python-matplot-fig.png]]





#####
#
# csv-to-latex
# 2020sep29
#
#####

# «csv-to-latex»  (to ".csv-to-latex")
# https://lwn.net/Articles/832698/
# https://en.wikipedia.org/wiki/Comma-separated_values

It's three steps, so it's not like you need an engineering degree to
achieve it. Also, you don't need to read 600 manual pages if you are
willing to just use a search engine.

Open csv file in csv-mode, run C-c C-s (for alphabetic sort) or C-c C-n
(for numeric sort). If you haven't selected a region of the file
(typically the entire file or the entire file minus the header), Emacs
will select the entire file and ask you it you indeed want to sort the
entire file (including the first row). Then Emacs asks you which
column, and it defaults to the column your cursor is in (select 2).
Now, enter org-mode, select the table and run C-c |. (Sounds weird, but
pipe is column separator in org-mode, so it's quite natural if you're
familiar with org-mode.) If you want to make the first row the header
row, you simply press C-c -, which inserts a separator line under your
cursor.

Finally, run C-c C-e l p (again, possibly weird, but C-c C-e is
org-export, and then l p means LaTeX and PDF).





#####
#
# Rainer König's Orgmode tutorial
# 2020oct09
#
#####

# «rainer-koenig»  (to ".rainer-koenig")
# https://www.youtube.com/playlist?list=PLVtKhBrRV_ZkPnBtt_TD1Cs9PJlU0IIdE
# https://www.youtube.com/watch?v=L_DYO0_eJ6A Interview with Martin K. Schröder
# https://www.youtube.com/watch?v=kPKhS-QDn7c Interview with Martin K. Schröder part 2

# (eev   "less ~/.emacs-doom.d/docs/getting_started.org")
# (find-fline "~/.emacs-doom.d/docs/getting_started.org")
# (find-fline "~/.emacs-doom.d/docs/getting_started.org")
# (find-fline "/tmp/gs.org")

# (find-youtubedl-links "/sda5/videos/" nil "eoIfLS4zMa8" nil "orglinks1")
# (find-youtubedl-links "/sda5/videos/" nil "0TS3pTNGFIA" nil "orglinks2")
# (find-youtubedl-links "/sda5/videos/" nil "INE7n8EscvQ" nil "orgexport")
# (find-youtubedl-links "/sda5/videos/" nil "E-SZHFtiGGI" nil "orgsource")
# (code-ytvideo "orglinks1video" "/sda5/videos/OrgMode E05S01 - Linking (internal)-eoIfLS4zMa8.mkv")
# (code-ytvideo "orglinks2video" "/sda5/videos/OrgMode E05S02 - Linking (external)-0TS3pTNGFIA.mp4")
# (code-ytvideo "orgexportvideo" "/sda5/videos/OrgMode E06S01 - Exporting-INE7n8EscvQ.mp4")
# (code-ytvideo "orgsourcevideo" "/sda5/videos/OrgMode E07S04 - Source code in OrgMode-E-SZHFtiGGI.mp4")

# (find-orglinks1video "0:00")
# (find-orglinks1video "5:00" "#MyID123")
# (find-orglinks1video "7:12" "radio target: <<<Newton>>>")

# (find-orglinks2video "0:00")
# (find-orglinks2video "3:43" "org-id-get-create")

# (find-orgexportvideo "0:00")
# (find-orgexportvideo "0:47" "customize org-file-apps")
# (find-orgexportvideo "1:06" "customize org-file-apps")
# (find-orgexportvideo "2:24" "export to HTML")
# (find-orgexportvideo "3:20" "no name target")

# (find-orgsourcevideo "0:00")

# (eek "M-h M-k  C-c C-l  ;; org-insert-link")
# (find-efunctiondescr      'org-insert-link)
# (find-efunction           'org-insert-link)
# (find-orgnode "Handling Links" "org-insert-link")

# (eek "M-h M-k  C-c C-o  ;; org-open-at-point")
# (find-efunctiondescr      'org-open-at-point)
# (find-efunction           'org-open-at-point)
# (find-orgnode "Handling Links" "org-open-at-point")

# (find-orgnode               "Radio Targets")
# (find-orgnode "Top")




#####
#
# Rainer König's Orgmode tutorial: full playlist
# 2022apr24
#
#####

# «rainer-koenig-playlist»  (to ".rainer-koenig-playlist")
# https://www.youtube.com/playlist?list=PLVtKhBrRV_ZkPnBtt_TD1Cs9PJlU0IIdE

# (find-man "yt-dlp")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/koenig/")
rm -Rv /tmp/koenig/
mkdir  /tmp/koenig/
cd     /tmp/koenig/
PL="https://www.youtube.com/playlist?list=PLVtKhBrRV_ZkPnBtt_TD1Cs9PJlU0IIdE"
yt-dlp --get-id --skip-download $PL

yt-dlp --get-id --get-title --skip-download $PL

• (eepitch-shell)
• (eepitch-kill)
• (eepitch-shell)
cd /sda5/videos/Rainer_Koenig/
zip /tmp/rainer-koenig-playlist.zip *

# (find-fline "/sda5/videos/Rainer_Koenig/")
# (find-fline "/sda5/videos/Rainer_Koenig/README")

/sda5/videos/Rainer_Koenig/
f () {
  youtube-dl -t --restrict-filenames --all-subs --write-auto-sub "http://www.youtube.com/watch?v=$2"
}
f () {
  youtube-dl -t --restrict-filenames --write-auto-sub "http://www.youtube.com/watch?v=$2"
}



{
f 01 sQS06Qjnkcc "OrgMode E01S01: Headlines & outline mode"
f 02 15w3I6MwCfs "Orgmode E01S02: ToDo keywords"
f 03 IofHvutUWV0 "OrgMode E01S03: Schedule, deadlines & agenda views"
f 04 nbC-gL5wcf4 "OrgMode E01S04: Repeating tasks"
f 05 gvgfmED8RD4 "OrgMode E01S05: Checklists"
f 06 GcUVvlClo9k "OrgMode E02S01: Tags"
f 07 u00pglDfgX4 "OrgMode E02S02: Agenda view (advanced)"
f 08 PJ3qHIl-eOM "OrgMode E02S03: Customized agenda views"
f 09 nUvdddKZQzs "Orgmode E02S04: Drawers, Logging & quick notes"
f 10 5M8L7vtWY1k "OrgMode E02S05: Archiving"
f 11 R4QSTDco_w8 "OrgMode E03S01: Automatic logging of status changes"
f 12 ECWtf6mAi9k "Orgmode E03S02: Splitting your system up to several files"
f 13 Af4NVJbNAB4 "OrgMode E03S03: The first capture template(s)"
f 14 ABrv_vnVbkk "OrgMode E03S04: The :PROPERTIES: drawer"
f 15 Y3g8d-IwIT4 "OrgMode E03S05: Archiving to different files"
f 16 9hxEEbUWJYA "OrgMode E04S01: Ordered tasks"
f 17 lxkPeJS6keY "OrgMode E04S02: Timers"
f 18 uVv49htxuS8 "Orgmode E04S03: Clocking (aka time tracking)"
f 19 BfEAiWe3uvc "OrgMode E04S04: Column view"
f 20 BeAtCVZpHCg "OrgMode E04S05: Effort estimates"
f 21 eoIfLS4zMa8 "OrgMode E05S01: Linking (internal)"
f 22 0TS3pTNGFIA "OrgMode E05S02: Linking (external)"
f 23 KMlp9HUJI3s "OrgMode E05S03: Attachments"
f 24 kPr0KMR1YdQ "OrgMode E05S04: Priorities"
f 25 JHKrTsiz4JU "OrgMode E05S05: Tables"
f 26 INE7n8EscvQ "OrgMode E06S01: Exporting"
f 27 cTrizroQeL8 "OrgMode E06S02: Advanced exporting"
f 28 ecRYNWtCvbs "OrgMode E06S03: Publishing"
f 29 ldTx_CB5cRc "OrgMode E06S04: Dynamic blocks"
}

{
f 30 acj3NhXlnnk "OrgMode E06S05: Tracking habits"
f 31 X6rNQPlxbhM "OrgMode E07S01: Bulk agenda actions"
f 32 -2RXhPV_zgc "Orgmode E07S02: Presenting my system"
f 33 cIzzjSaq2N8 "OrgMode E07S03: Google Calendar integration"
f 34 E-SZHFtiGGI "OrgMode E07S04: Source code in OrgMode"
f 35 APhhHCBI8xc "OrgMode E07S05: Goal setting & Goal Tracking"
f 36 odOKnNDKSIs "OrgMode - A third approach to goal setting & tracking"
f 37 NqPhz8aqk2U "Orgmode TV - News about the future plans"
f 38 l0SILI0U4BE "Orgmode TV - A new episode"
f 39 be8TC-i-NpE "Orgmode-TV: How do I plan my days"
f 40 EFKdMctqELk "My course is online on Udemy"
}


f 01 sQS06Qjnkcc "OrgMode E01S01: Headlines & outline mode"
f 02 15w3I6MwCfs "Orgmode E01S02: ToDo keywords"
f 03 IofHvutUWV0 "OrgMode E01S03: Schedule, deadlines & agenda views"
f 04 nbC-gL5wcf4 "OrgMode E01S04: Repeating tasks"
f 05 gvgfmED8RD4 "OrgMode E01S05: Checklists"
f 06 GcUVvlClo9k "OrgMode E02S01: Tags"
f 07 u00pglDfgX4 "OrgMode E02S02: Agenda view (advanced)"
f 08 PJ3qHIl-eOM "OrgMode E02S03: Customized agenda views"
f 09 nUvdddKZQzs "Orgmode E02S04: Drawers, Logging & quick notes"
f 10 5M8L7vtWY1k "OrgMode E02S05: Archiving"
f 11 R4QSTDco_w8 "OrgMode E03S01: Automatic logging of status changes"
f 12 ECWtf6mAi9k "Orgmode E03S02: Splitting your system up to several files"
f 13 Af4NVJbNAB4 "OrgMode E03S03: The first capture template(s)"
f 14 ABrv_vnVbkk "OrgMode E03S04: The :PROPERTIES: drawer"
f 15 Y3g8d-IwIT4 "OrgMode E03S05: Archiving to different files"
f 16 9hxEEbUWJYA "OrgMode E04S01: Ordered tasks"
f 17 lxkPeJS6keY "OrgMode E04S02: Timers"
f 18 uVv49htxuS8 "Orgmode E04S03: Clocking (aka time tracking)"
f 19 BfEAiWe3uvc "OrgMode E04S04: Column view"
f 20 BeAtCVZpHCg "OrgMode E04S05: Effort estimates"
f 21 eoIfLS4zMa8 "OrgMode E05S01: Linking (internal)"
f 22 0TS3pTNGFIA "OrgMode E05S02: Linking (external)"
f 23 KMlp9HUJI3s "OrgMode E05S03: Attachments"
f 24 kPr0KMR1YdQ "OrgMode E05S04: Priorities"
f 25 JHKrTsiz4JU "OrgMode E05S05: Tables"
f 26 INE7n8EscvQ "OrgMode E06S01: Exporting"
f 27 cTrizroQeL8 "OrgMode E06S02: Advanced exporting"
f 28 ecRYNWtCvbs "OrgMode E06S03: Publishing"
f 29 ldTx_CB5cRc "OrgMode E06S04: Dynamic blocks"




Do not download the video but
         write all related files (Alias: --no-download) maybe?

yt-dlp --flat-playlist "https://www.youtube.com/playlist?list=PLVtKhBrRV_ZkPnBtt_TD1Cs9PJlU0IIdE"








#####
#
# org-roam
# 2020oct11
#
#####

# «org-roam»  (to ".org-roam")
# (find-epackage-links 'org-roam)
# (find-epackage       'org-roam)
# (find-elpafile "org-roam-readme.txt")
# (code-c-d "orgroam" "~/.emacs.d/elpa/org-roam-20201011.652/")
# (find-orgroamfile "")

https://www.reddit.com/r/orgmode/comments/zi0k1x/is_there_any_advantage_in_using_orgroam_if_i_keep/

# https://en.wikipedia.org/wiki/Zettelkasten
# https://github.com/org-roam/org-roam
# https://www.reddit.com/r/orgmode/comments/jysnrf/why_does_the_recent_zettelkasten_craze_use_one/
# https://koenig-haunstetten.de/2020/12/26/exploring-org-roam/
# https://www.youtube.com/watch?v=gDAbpz98ooU

# (find-youtubedl-links "/sda5/videos/" "Making_Connections_in_your_Notes" "Lg61ocfxk3c" ".mp4" "roamciyn")
# (code-video "roamciynvideo" "/sda5/videos/Making_Connections_in_your_Notes-Lg61ocfxk3c.mp4")
# (find-roamciynvideo)
# (find-roamciynvideo "0:00")
# (find-roamciynvideo "3:32" "Let's get back to Roam")
# (find-roamciynvideo "7:20" "Let's take a look")
# (find-roamciynvideo "8:33" "Spacemacs")
# (find-roamciynvideo "9:03" "Doom Emacs webpage")
# (find-roamciynvideo "10:25" "use-package")
# (find-roamciynvideo "10:40" "doom update and refresh")
# (find-roamciynvideo "11:20" "cask-install platypus")
# (find-roamciynvideo "11:40" "all the videos and documents")
# (find-roamciynvideo "11:49" "slack")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti sqlite3 graphviz
mkdir ~/org-roam/

(require 'org-roam)

org-roam-find-file
org-roam-insert
org-roam-graph
org-roam-db-build-cache
org-roam-buffer-toggle-display

https://emacs.cafe/emacs/org-mode/org-roam/2021/03/11/introduction-to-nroam.html





#####
#
# org-journal
# 2020oct30
#
#####

# «org-journal»  (to ".org-journal")
# (find-epackage-links 'org-journal)
# (find-epackage       'org-journal)
# http://github.com/bastibe/org-journal
# (code-c-d "orgjournal" "~/.emacs.d/elpa/org-journal-20201028.2115/")
# (find-orgjournalfile "")





#####
#
# worg
# 2020oct26
#
#####

# «worg»  (to ".worg")
# https://orgmode.org/worg/
# https://orgmode.org/worg/org-hacks.html
# https://code.orgmode.org/bzg/worg

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/worg/
cd      ~/usrc/
git clone https://code.orgmode.org/bzg/worg
cd      ~/usrc/worg/

# (code-c-d "worg" "~/usrc/worg/")
# (find-worgfile "")




#####
#
# org-player - adds support to "::2:43" to links to audio and video files
# 2020oct27
#
#####

# «org-player»  (to ".org-player")
# https://orgmode.org/worg/org-hacks.html#org23a9e1b Audio/video file playback within org mode
# https://orgmode.org/worg/code/elisp/org-player.el
# https://code.orgmode.org/bzg/worg/src/master/code/elisp/org-player.el

# (code-c-d "worg" "~/usrc/worg/")
# (find-worgfile "")
# (find-worgfile "code/elisp/org-player.el")
# (find-worgfile "code/elisp/org-player.el" "path/to/song.mp3::2:43")
#  [[file:/path/to/song.mp3::2:43]]      Starts playback at 2 min 43 sec.




#####
#
# links-to-pdfs
# 2020oct26
#
#####

# «links-to-pdfs»  (to ".links-to-pdfs")
# (find-orgnode "External Links" "papers/last.pdf")



#####
#
# org-pdftools - add support to "#page=42" to links to PDFs
# 2020oct27
#
#####

# «org-pdftools»  (to ".org-pdftools")
# (find-epackage-links 'org-pdftools)
# (find-epackage       'org-pdftools)
# (code-c-d "orgpdftools" "~/.emacs.d/elpa/org-pdftools-20200929.2241/")
# (find-orgpdftoolsfile "")
# https://github.com/fuxialexander/org-pdftools/
# (find-git-links "https://github.com/fuxialexander/org-pdftools" "orgpdftoolsgit")
# (code-c-d "orgpdftoolsgit" "~/usrc/org-pdftools/")
# (find-orgpdftoolsgitfile "")
# (find-orgpdftoolsgitfile "README.org" "prefix")
# (find-orgpdftoolsgitfile "README.org" "(use-package org-pdftools")
# (require 'org-pdftools)
# (org-pdftools-setup-link)

# (find-orgpdftoolsgitgrep "grep --color -nH --null -e org-pdftools-link-prefix *")
# (find-orgpdftoolsgitgrep "grep --color -nH --null -e org-pdftools-setup *")

# Juan Manual Macias:
# https://lists.gnu.org/archive/html/emacs-orgmode/2024-02/index.html
# https://lists.gnu.org/archive/html/emacs-orgmode/2024-02/msg00195.html
# https://lists.gnu.org/archive/html/emacs-orgmode/2024-02/msg00198.html
# https://lists.gnu.org/archive/html/emacs-orgmode/2024-02/msg00207.html




#####
#
# export-escript-blocks
# 2020dec15
#
#####

# «export-escript-blocks»  (to ".export-escript-blocks")
# (find-angg "ORG/testexport.org")
# (to "export-to-html")

#+BEGIN_SRC emacs-lisp
  (defun org-xor (a b)
     "Exclusive or."
     (if a (not b) b))
#+END_SRC

#+BEGIN_COMMENT
(code-video "eev2020video" "$S/http/angg.twu.net/eev-videos/emacsconf2020.mp4")
(find-eev2020video  "0:00" "Title")
(find-eev2020video  "0:22" "1.1. M-e and M-k")
(find-eev2020video  "3:34" "1.2. Hyperlinks that don't create new buffers")
#+END_COMMENT




#####
#
# ol-eshell
# 2020dec16
#
#####

# «ol-eshell»  (to ".ol-eshell")
# (find-orgnode "Handling Links")
# (find-orgsrcfile "lisp/ol-eshell.el")




#####
#
# blogging
# 2020dec25
#
#####

# «blogging»  (to ".blogging")
# (to "lazyblorg")
# https://www.reddit.com/r/orgmode/comments/763gfz/blogging_with_orgmode/
# https://orgmode.org/worg/org-blog-wiki.html
# https://github.com/bastibe/org-static-blog/
# https://github.com/bastibe
# https://bastibe.de/
# http://emacs-fu.blogspot.com/2009/05/writing-and-blogging-with-org-mode.html
# https://www.brautaset.org/articles/2017/blogging-with-org-mode.html
# https://www.evenchick.com/blog/blogging-with-org-mode.html
# https://www.sadiqpk.org/blog/2018/08/08/blogging-with-org-mode.html
# https://www.reddit.com/r/emacs/comments/agnwxt/recommended_way_of_blogging_with_orgmode_to/
# https://medium.com/@zac.wood9/blogging-with-org-mode-abc24ba81b8b
# https://ox-hugo.scripter.co/

# https://emacs.love/weblorg/




#####
#
# ox-slimhtml
# 2020dec25
#
#####

# «ox-slimhtml»  (to ".ox-slimhtml")
# http://www.bald.cat/ox-slimhtml/
# http://www.bald.cat/ox-slimhtml/
# https://github.com/balddotcat/ox-slimhtml




#####
#
# org-html-postamble
# 2020dec25
#
#####

# «org-html-postamble»  (to ".org-html-postamble")




#####
#
# emacs-survey-org
# 2021jan10
#
#####

# «emacs-survey-org»  (to ".emacs-survey-org")
# https://old.reddit.com/r/emacs/comments/ksknww/some_more_analysis_of_the_2020_emacs_user_survey/
# https://tecosaur.com/public/EmacsSurveyAnalysis2020.org
# https://tecosaur.com/public/EmacsSurveyAnalysis2020.pdf




#####
#
# protesilaos-dot-emacs
# 2021jan10
#
#####

# «protesilaos-dot-emacs»  (to ".protesilaos-dot-emacs")
# https://protesilaos.com/
# https://protesilaos.com/codelog/2020-10-21-emacs-favourite-package/
# https://gitlab.com/protesilaos/dotfiles
# (find-git-links "https://gitlab.com/protesilaos/dotfiles" "protdot")
# (code-c-d "protdot" "~/usrc/dotfiles/")
# (find-protdotsh "find * | sort")
# (find-protdotfile "")
# (find-protdotfile "emacs/.emacs.d/")
# (find-protdotfile "emacs/.emacs.d/prot-emacs.org")




#####
#
# Table of Contents
# 2021jan11
#
#####

# «toc»  (to ".toc")
# (find-orgnode "Table of Contents" "toc:nil")
# (find-orgnode "Export Settings" "num" "section-numbers")
# (find-eev "README.org")





#####
#
# org-elpa
# 2021apr17
#
#####

# «org-elpa»  (to ".org-elpa")
# https://orgmode.org/elpa.html
# (require 'package)
# (add-to-list 'package-archives '("org" . "https://orgmode.org/elpa/") t)




#####
#
# this-month-in-org
# 2021apr26
#
#####

# «this-month-in-org»  (to ".this-month-in-org")
# https://blog.tecosaur.com/tmio/
# https://github.com/tecosaur/this-month-in-org/




#####
#
# org-protocol
# 2021jun01
#
#####

# «org-protocol»  (to ".org-protocol")
# (find-orgnode "Protocols")
# https://github.com/alphapapa/org-protocol-capture-html
# https://www.reddit.com/r/emacs/comments/ai7hf0/does_anyone_here_still_use_orgprotocol/
# https://sachachua.com/blog/2015/11/capturing-links-quickly-with-emacsclient-org-protocol-and-chrome-shortcut-manager-on-microsoft-windows-8/
# https://chrome.google.com/webstore/detail/org-capture/kkkjlfejijcjgjllecmnejhogpbcigdc?hl=en
# https://github.com/sprig/org-capture-extension
# https://orgmode.org/worg/org-contrib/org-protocol.html

# (find-youtubedl-links "/sda5/videos/" "Using_Emacs_Episode_70" "FYKcVKg0OCU" ".mkv" "orgprotocol")
# (code-video "orgprotocolvideo" "/sda5/videos/Using_Emacs_Episode_70-FYKcVKg0OCU.mkv")
# (find-orgprotocolvideo)
# (find-orgprotocolvideo "0:00")
# (find-orgprotocolvideo "4:40" "org capture for firefox")
# (find-orgprotocolvideo "6:00" "%a")
# (find-orgprotocolvideo "9:15" "g")
# (find-orgprotocolvideo "9:56" "m")

stackoverflow questions 7464951
https://stackoverflow.com/questions/7464951/how-can-i-make-org-protocol-work-on-openbox

# (find-fline "~/.local/share/applications/")





#####
#
# org-critical-edition
# 2021jun07
#
#####

# «org-critical-edition»  (to ".org-critical-edition")
# https://gitlab.com/maciaschain/org-critical-edition





#####
#
# david-pineiden
# 2021jul03
#
#####

# «david-pineiden»  (to ".david-pineiden")
# https://gitlab.com/pineiden
# https://gitlab.com/pineiden/curso-orgmode
# (code-c-d "cursoorgmode" "~/usrc/curso-orgmode/")
# (find-cursoorgmodefile "")

# MediatecaComun
# https://video.hardlimit.com/video-channels/orgmode_emacs/videos




#####
#
# drimyswinteri's home page (by yaca)
# 2021jul06
#
#####

# «yaca»  (to ".yaca")
# https://drimyswinteri.ml/
# https://drimyswinteri.ml/esteblog.html
# https://git.sr.ht/~yaca/drimyswinteri
# (find-git-links "https://git.sr.ht/~yaca/drimyswinteri" "drimyswinteri")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/drimyswinteri/
cd      ~/usrc/
git clone https://git.sr.ht/~yaca/drimyswinteri
cd      ~/usrc/drimyswinteri/

# (code-c-d "drimyswinteri" "~/usrc/drimyswinteri/")
# (find-drimyswinterifile "")
# (find-drimyswinterigrep "grep --color=auto -nRH --null -e base-directory *")
# (find-drimyswinterigrep "grep --color=auto -niRH --null -e options *")
# (find-drimyswinterifile "snippet.elisp")
# (find-drimyswinterifile "org/esteblog.org")
# (find-drimyswinterifile "org/esteblog.org" "/C-c C-e P p/")

# (find-angg    "elisp/yaca.el")
# (find-fline "~/elisp/yaca.el")
# (load       "~/elisp/yaca.el")

# (find-2a nil '(find-drimyswinterifile "org/esteblog.org"))
# (eek "M-o  C-c C-e P p")

# (find-fline "~/usrc/drimyswinteri/public_html/")
# (find-drimyswinterifile          "public_html/")




#####
#
# org-grasp
# 2021jul11
#
#####

# «org-grasp»  (to ".org-grasp")
# https://yewtu.be/watch?v=Z8Bk-IazdGo
# https://github.com/karlicoss/grasp
# (code-c-d "grasp" "~/usrc/grasp/")
# (find-graspfile "")




#####
#
# agda.org
# 2021aug01
#
#####

# «agda.org»  (to ".agda.org")
# (find-angg "ORG/agda.org")



#####
#
# scimax - data structures in emacs-lisp
# 2021oct05
#
#####

# «scimax»  (to ".scimax")
# My question: "Looking for extensions of [[file:~/xx.org::My Target]]"
# (find-orgnode "Search Options")
# (find-orgnode "Search Options" "<<My Target>>")
# (find-orgnode "Publishing links")
# (find-eev-quick-intro "8. Anchors")
# https://lists.gnu.org/archive/html/emacs-orgmode/2021-12/msg00285.html my question
# https://lists.gnu.org/archive/html/emacs-orgmode/2021-12/msg00288.html jk's answer
# https://www.youtube.com/watch?v=HyFbIWvmV0A
# https://github.com/jkitchin/scimax
# (find-git-links "https://github.com/jkitchin/scimax" "scimax")
# (code-c-d "scimax" "~/usrc/scimax/")
# (find-scimaxfile "")
# (find-scimaxfile "scimax-notebook.org")
# (find-scimaxfile "scimax-notebook.org" "* Notebook/project links")
# (find-scimaxfile "scimax-notebook.org" "*** Example links")
# https://github.com/jkitchin/scimax/blob/master/scimax-notebook.org
# https://github.com/jkitchin/scimax/blob/master/scimax-notebook.org#notebookproject-links
# https://github.com/jkitchin/scimax/blob/master/scimax-notebook.org#example-links

https://www.youtube.com/watch?v=H4sK5ld6Bw0




#####
#
# projectile and org-projectile
# 2021dec07
#
#####

# «projectile»  (to ".projectile")

# (find-epackage-links 'projectile "projectile" t)
# (find-epackage       'projectile)
# (code-c-d "projectile" "{d}")
# (find-projectilefile "")
# https://github.com/bbatsov/projectile

# (find-epackage-links 'org-projectile "orgprojectile" t)
# (find-epackage       'org-projectile)
# (code-c-d "orgprojectile" "{d}")
# (find-orgprojectilefile "")
# https://github.com/IvanMalison/org-projectile





#####
#
# literatemacs - A literate README that produces an init.el
# 2021oct13
#
#####

# «literatemacs»  (to ".literatemacs")
https://github.com/joseph8th/literatemacs



#####
#
# org-babel-tangle
# 2021oct20
#
#####

# «org-babel-tangle»  (to ".org-babel-tangle")
# (find-fline "~/LOGS/2021oct19.emacs")
# (find-fline "~/ORG/rdrg109-20211020.org")
# (find-orgnode "Extracting Source Code" "org-babel-tangle")




#####
#
# Videos by Antonin Januska
# 2021nov02
#
#####

# «antonin-januska»  (to ".antonin-januska")
# https://www.youtube.com/watch?v=TK2kGpCQMfk&t=2815s
# ^ Basic Org-Mode Todo Management and Notetaking




#####
#
# orgstrap
# 2021nov26
#
#####

# «orgstrap»  (to ".orgstrap")
# https://github.com/tgbugs/orgstrap/blob/master/README.org
# https://github.com/tgbugs/orgstrap/blob/master/shebang.org




#####
#
# orgdown
# 2021dec01
#
#####

# «orgdown»  (to ".orgdown")
# https://karl-voit.at/2021/12/02/Orgdown-feedback/





#####
#
# org-src-fontify-natively
# 2021dec08
#
#####

# «org-src-fontify-natively»  (to ".org-src-fontify-natively")
# (find-orgnode "Editing Source Code" "org-src-fontify-natively")
# (find-evardescr      'org-src-fontify-natively)
# (find-evariable      'org-src-fontify-natively)
# (find-efunctiondescr 'org-src-font-lock-fontify-block)
# (find-efunction      'org-src-font-lock-fontify-block)
# (find-orggrep "grep --color=auto -nH --null -e org-src-font-lock-fontify-block *.el")

<edrx> hey, a question about org...
<edrx> I just noticed that if I edit text in a #+begin_src sh /
       #+end_src block
<edrx> the text is fontified as shell code. I'm surprised that this
       is active by default... that looks tricky to me and I
       remember very vaguely that ages ago we had to edit the
       contents of the source block in a separate buffer to have it
       fontified...
<edrx> what is the name of that feature? where is the code that
       does that?
<grym> org-src-fontify-natively
<edrx> thanks! =)
<grym> if you need more than that, ,,polymode,, is the 800 pound
       gorilla
<fsbot> polymode is [0] https://github.com/vspinu/polymode
<fsbot> [1] See also ,MultipleModes
<grym> https://github.com/polymode/poly-org being the operative
       beast i think, but i've not had to care yet
<edrx> thanks =)



#####
#
# ob-ipython
# 2022jan04
#
#####

# «ob-ipython»  (to ".ob-ipython")
# https://github.com/gregsexton/ob-ipython
# (find-epackage-links 'ob-ipython)
# (require 'ob-ipython)

* Testando o ox-ipynb

  #+begin_src ipython :results value
    import pandas as pd

    df = pd.DataFrame({'allgo': [1, 2, 3]})

    df
  #+end_src

  #+RESULTS:
  : # Out[5]:
  : #+BEGIN_EXAMPLE
  : allgo
  : 0 1
  : 1 2
  : 2 3
  : #+END_EXAMPLE

* Para converter de ipynb para org
:PROPERTIES:
:ID: 62cd5f40-431a-4f29-aabd-04950da2b594
:END:
- https://www.reddit.com/r/emacs/comments/7lcgkz/import_a_jupyter_notebook_to_an_orgmode_file/

 (eepitch-vterm)
 (eepitch-kill)
 (eepitch-vterm)
ls
cd personificacao
jupyter nbconvert personificacao.ipynb --to markdown && ls
pandoc personificacao.md -o personificacao.org







#####
#
# org-store-link
# 2022jan04
#
#####

# «org-store-link»  (to ".org-store-link")
# (find-efunctiondescr 'org-store-link)
# (find-efunction      'org-store-link)
# (find-efunctiondescr 'org-insert-link)
# (find-efunction      'org-insert-link)
# (find-orgnode "")
# (find-orgnode "Activation")
# (find-orgnode "Handling Links")
# (find-orgnode "Search Options")
# (find-orgnode "Literal Examples")
# (find-orgnode "Adding Hyperlink Types")

<thblt> Add an ID to your heading, like this
        https://writequit.org/articles/emacs-org-mode-generate-ids.html#the-solution
<thblt> Then link to the ID with C-c C-l
<thblt> I *think* the link type is ref:
<dale> Minall: You can try just M-x org-store-link RET somewhere in
       your org document.  Here, at least, that automatically adds
       an ID to the headline.  Then C-c C-l will try to make a link
       to the headline where you called org-store-link.
<dale> Minall: https://orgmode.org/manual/Handling-Links.html might
       be a good place to start.



#####
#
# kb-macro-defun-eek
# 2022jan25
#
#####

# «kb-macro-defun-eek»  (to ".kb-macro-defun-eek")
# https://lists.gnu.org/archive/html/emacs-orgmode/2021-12/msg00287.html my answer
# https://lists.gnu.org/archive/html/emacs-orgmode/2021-12/msg00300.html
# https://lists.gnu.org/archive/html/emacs-orgmode/2021-12/msg00301.html

Hi Ypo!

You may find this useful too. I often use it when I want to put
editing commands in my functions and I'm in a hurry and not in a mood
to find their names - so for example I use (eek "C-l") instead of
(recenter-top-bottom), or (eek "<up> C-a C-SPC <down> M-w C-y") to
duplicate the line above the point...

  Cheers & happy hacking =),
    E.
    http://angg.twu.net/#eev





#####
#
# org-git-testing
# 2022mar15
#
#####

# «org-git-testing»  (to ".org-git-testing")
# https://www.reddit.com/r/emacs/comments/tblodh/did_you_know_that_orgmodes_source_code_contains/
# https://github.com/tonyaldon/posts
# (find-orggitfile "testing/examples/")




#####
#
# kbd
# 2022mar27
#
#####

# «kbd»  (to ".kbd")
# (find-fline "~/LOGS/2022mar27.emacs" "@@html:<kbd>C-x C-f</kbd>@@")

@@html:<kbd>&lt;f8&gt;</kbd>@@



#####
#
# org-git-hooks
# 2022mar27
#
#####

# «org-git-hooks»  (to ".org-git-hooks")
# (find-fline "~/LOGS/2022mar27.emacs" "org-git-hooks")
# (find-git-links "https://git.sr.ht/~mplscorwin/org-git-hooks" "orggithooks")
# (code-c-d "orggithooks" "~/usrc/org-git-hooks/")
# (find-orggithooksfile "")
# (find-orggithooksfile "README.md")
# (find-orggithooksfile "build.el")
# file:///home/edrx/TH/L/usrc/org-git-hooks/README.html



#####
#
# github-orgmode-tests
# 2022mar27
#
#####

# «github-orgmode-tests»  (to ".github-orgmode-tests")
# https://github.com/novoid/github-orgmode-tests
# (find-git-links "https://github.com/novoid/github-orgmode-tests" "githuborgmodetests")
# (code-c-d "githuborgmodetests" "~/usrc/github-orgmode-tests/")
# (find-githuborgmodetestsfile "")



#####
#
# outshine
# 2022aug17
#
#####

# «outshine»  (to ".outshine")
# (find-epackage-links 'outshine "outshine" t)
# (find-epackage       'outshine)
# https://github.com/alphapapa/outshine





#####
#
# sexps-as-backends (eev-kla)
# 2022sep27
#
#####

# «sexps-as-backends»  (to ".sexps-as-backends")
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-09/msg00698.html Jean Louis
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-09/msg00699.html edrx: eev-kla
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-09/msg00713.html Jean Louis: rcd-template
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-09/msg00725.html edrx: find-eregionpp
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-09/msg00764.html edrx: factoring
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-09/msg00811.html Jean Louis: prot please
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-09/msg00812.html Jean Louis: not hiding
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-10/msg00244.html Edrx: put that on hold

Hi Jean Louis,

> Instead of:
> 
> >   (find-evardescr 'hkey-alist)
> 
> I would like to see visually:
> 
> "Description of Emacs Lisp function `hkey-alist'"

In cases like that there would be some key sequence that parses the
text and the text properties around point and produces a sexp that
goes to the target of the link when executed. Let me call that sexp
the "back-end" of the link.

I did play with some ways to buttonize back-end sexps, and with some
ways to parse the text around point to generate these back-end sexps,
but I didn't find those things much fun, and in all the cases I ended
up finding nice ways to solve my problems with just explicit sexps,
without hiding them behind a title. So I postponed the problem behind
your question - and I will deal with it again when someone who wants
"back-end sexps hidden behind titles" asks me for help, or asks me to
work together on their ideas.

> There must be some way of quickly generating above links, do you have
> such?
> 
> Let us say you are in buffer A, you go to Emacs Lisp file at line 134, and
> you just press there a key, and link is inserted in buffer A, leading
> to Emacs Lisp file at line 134, you have that?

Yes, and I am working in a way to do that that requires fewer keys. I
submitted it to the EmacsConf2022:

  http://angg.twu.net/emacsconf2022-kla.html

and I am asking my friends to test it. I haven't made commented
screenshots for it - like these ones:

  http://angg.twu.net/eepitch.html#test-blocks

yet, so right now the best way to understand how it works is to try
the "Try:"s in the sections 1 and 8 of its docs:

  http://angg.twu.net/eev-current/eev-kla.el.html#intro

Cheers,
  Eduardo Ochs
  http://angg.twu.net/#eev



#####
#
# org-noter-pdftools
# 2022oct07
#
#####

# «org-noter-pdftools»  (to ".org-noter-pdftools")
# (find-epackage-links 'org-noter-pdftools "orgnoterpdftools" t)
# (find-epackage       'org-noter-pdftools)
# (code-c-d "orgnoterpdftools" "~/.emacs.d/elpa/org-noter-pdftools-20220320.300/")
# (find-orgnoterpdftoolsfile "")

# (find-epackage-links 'org-pdftools "orgpdftools" t)
# (find-epackage       'org-pdftools)
# (code-c-d "orgpdftools" "~/.emacs.d/elpa/org-pdftools-20220320.301/")
# (find-orgpdftoolsfile "")

# (find-epackage-links 'org-noter "orgnoter" t)
# (find-epackage       'org-noter)
# (code-c-d "orgnoter" "~/.emacs.d/elpa/org-noter-20191020.1212/")
# (find-orgnoterfile "")



#####
#
# org-babel-eval-in-repl
# 2022nov03
#
#####

# «org-babel-eval-in-repl»  (to ".org-babel-eval-in-repl")
# https://github.com/diadochos/org-babel-eval-in-repl
# https://github.com/diadochos/org-babel-eval-in-repl/wiki
# (find-git-links "https://github.com/diadochos/org-babel-eval-in-repl" "ober")
# (code-c-d "ober" "~/usrc/org-babel-eval-in-repl/")
# (find-oberfile "")

# (find-epackage-links 'org-babel-eval-in-repl "orgbabelevalinrepl" t)
# (find-epackage       'org-babel-eval-in-repl)
# (code-c-d "orgbabelevalinrepl" "~/.emacs.d/elpa/org-babel-eval-in-repl-20201206.1540/")
# (find-orgbabelevalinreplfile "")

# (find-epackage-links 'eval-in-repl "evalinrepl" t)
# (find-epackage       'eval-in-repl)
# (code-c-d "evalinrepl" "~/.emacs.d/elpa/eval-in-repl-20201121.1341/")
# (find-evalinreplfile "")

# (find-epackage       'eval-in-repl)




#####
#
# org-tempo
# 2022nov10
#
#####

# «org-tempo»  (to ".org-tempo")
# (find-fline "~/LOGS/2022nov10.emacs" "<parsnip> org-tempo")
# (find-orgnode "Structure Templates")
# (find-orgnode "Structure Templates" "Org Tempo")
# (find-orgfile "org-tempo.el")
# (find-orgfile "org-tempo.el" "<s")
# (find-efunctiondescr 'org-insert-structure-template)
# (find-efunction      'org-insert-structure-template)
# (find-efile "tempo.el")

(require 'org-tempo)
(org-tempo--keys)




#####
#
# org-persist
# 2022dec16
#
#####

# «org-persist»  (to ".org-persist")

org-persist: Writing to "/home/edrx/.cache/org-persist/29/10773f-2b84-4362-a114-fd343dd22412" took 0.85 sec
# (find-fline "~/.cache/org-persist/29/10773f-2b84-4362-a114-fd343dd22412")




#####
#
# Ihor's reactions to my video about eev-wconfig
# 2022dec31
#
#####

# «ihor-wconfig»  (to ".ihor-wconfig")
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00565.html Edrx 1
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00714.html Ihor 2
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00722.html Edrx 3
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00742.html Ihor 4
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00747.html Edrx 5
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00781.html Ihor 6
# https://lists.gnu.org/archive/html/emacs-orgmode/2022-05/msg00785.html Edrx 7




#####
#
# 2022-to-ihor-in-private
# 2022dec31
#
#####

# «2022-to-ihor-in-private»  (to ".2022-to-ihor-in-private")
# https://mail.google.com/mail/u/0/#sent/FMfcgzGrbcCBwKPWWRPkxlWtHqdssvSC
# https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00029.html Edrx

(3) _is_ my experience with the Org mailing list.

What I meant by "the developers like your questions" was roughly:
"recognizing that that person deserves help, and giving him tools that
would let him solve his problems in hours instead of in months or
years".

For example, in this thread

https://lists.gnu.org/archive/html/emacs-orgmode/2021-12/msg00674.html

no one considered that if I was asking that then maybe it would be a
good idea to make `org-export-dispatch' more hackeable by beginners...

For example, someone could have said "can you try this? Copy that
function to other file, replace its lines foo and bar by the lines
plic and bletch, and use the ideas in these two blog posts to debug
and inspect its data structures"... but no, that didn't happen - I've
asked lots of technical questions here over the years and never got
detailed answers like that, only answers whose technical details _were
kept as short as possible_, and whose explanations were much closer to
"in English" than to "in Lisp".

A few days ago I added subtitles to my video about "Org for
Non-Users". The links are here,

  http://angg.twu.net/2021-org-for-non-users.html

and some people will prefer to just read this:

  http://angg.twu.net/eev-videos/2021-org-for-non-users.vtt
  http://angg.twu.net/SUBTITLES/2021-org-for-non-users.lua.html

It explains with examples how a "non-user" thinks, and it shows what I
mean by "explanations in Lisp".

  Cheers =/,
    Eduardo



#####
#
# maxima
# 2023dec03
#
#####

# «maxima»  (to ".maxima")
# (find-fline "~/LOGS/2023dec03.org")
# (find-sh "locate bin/maxima")
# (find-fline "/usr/bin/"       "maxima")
# (find-fline "/usr/local/bin/" "maxima")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
w maxima
export PATH=/usr/bin:$PATH
w maxima
echo $PATH

(setenv "PATH" "/usr/bin:/home/edrx/bin:/home/edrx/.elan/bin:/home/edrx/.local/bin:/home/edrx/.opam/default/bin:/home/edrx/.cabal/bin:/home/edrx/.ghcup/bin:/usr/local/texlive/2020/bin/x86_64-linux:/home/edrx/bin:/usr/local/bin:/usr/bin:/bin:/usr/local/games:/usr/games:.:/home/edrx/EXPECT:/home/edrx/TCL:/home/edrx/pkg/bin:/home/edrx/usrc/plan9port/bin:/home/edrx/.nimble/bin")
(setenv "PATH"          "/home/edrx/bin:/home/edrx/.elan/bin:/home/edrx/.local/bin:/home/edrx/.opam/default/bin:/home/edrx/.cabal/bin:/home/edrx/.ghcup/bin:/usr/local/texlive/2020/bin/x86_64-linux:/home/edrx/bin:/usr/local/bin:/usr/bin:/bin:/usr/local/games:/usr/games:.:/home/edrx/EXPECT:/home/edrx/TCL:/home/edrx/pkg/bin:/home/edrx/usrc/plan9port/bin:/home/edrx/.nimble/bin")
(find-sh0 "which maxima")

(setq org-confirm-babel-evaluate nil)
(require 'ob-maxima)

#+begin_src maxima
2+3;
#+end_src

#+RESULTS:
| Adding  |                                 118 | subdirectories | of | /usr/local/share/maxima/branch_5_47_base_312_gd5a35a21b/share | to | search | path. |
| Adding  |                                   0 | subdirectories | of | /home/edrx/.maxima                                            | to | search | path. |
| Loading | /home/edrx/.maxima/maxima-init.lisp |                |    |                                                               |    |        |       |
| Loading |  /home/edrx/.maxima/maxima-init.mac |                |    |                                                               |    |        |       |

#+begin_src maxima :session *m*
2+3;
#+end_src

#+RESULTS:

#+begin_comment
 (eepitch-to-buffer "*m*")
 (eepitch-kill)
 (eepitch-to-buffer "*m*")
echo hello

#+end_comment



• (eepitch-maxima)
• (eepitch-kill)
• (eepitch-maxima)
2+3;

--snip--snip--

Adding 118 subdirectories of "/usr/local/share/maxima/branch_5_47_base_312_gd5a35a21b/share" to search path.
Adding 0 subdirectories of "/home/edrx/.maxima" to search path.
Loading /home/edrx/.maxima/maxima-init.lisp
Loading /home/edrx/.maxima/maxima-init.mac
Maxima branch_5_47_base_312_gd5a35a21b https://maxima.sourceforge.io
using Lisp SBCL 2.1.1.debian
Distributed under the GNU Public License. See the file COPYING.
Dedicated to the memory of William Schelter.
The function bug_report() provides bug reporting information.
(%i1) 2+3;
(%o1)                                  5
(%i2)




#####
#
# What is the status of ob-maxima.el? Is this a bug?
# 2023dec04
#
#####

# «status-of-ob-maxima.el»  (to ".status-of-ob-maxima.el")
# https://lists.gnu.org/archive/html/emacs-orgmode/2023-12/msg00027.html Edrx 1
# https://lists.gnu.org/archive/html/emacs-orgmode/2023-12/msg00032.html Eric 2
# https://lists.gnu.org/archive/html/emacs-orgmode/2023-12/msg00035.html Edrx 3
# Subj: What is the status of ob-maxima.el? Is this a bug?

Hi list,

what is the status of ob-maxima.el? Is it considered to be functional?
If yes, what am I doing wrong? If no, should I file a bug report about
the problem below?

If I eval these two sexps and then execute the code block below them
with `C-c C-c' - obs: I added some indentation for clarity,

  (setq org-confirm-babel-evaluate nil)
  (require 'ob-maxima)

  #+begin_src maxima
  2+3;
  #+end_src

then I get this "#+RESULTS:" block when the first "maxima" found in
the $PATH is /usr/local/bin/maxima, that is a script that runs a
Maxima compiled from the git sources a few days ago,

  #+RESULTS:
  | Adding  |                                 118 | subdirectories | of | /usr/local/share/maxima/branch_5_47_base_312_gd5a35a21b/share | to | search | path. |
  | Adding  |                                   0 | subdirectories | of | /home/edrx/.maxima                                            | to | search | path. |
  | Loading | /home/edrx/.maxima/maxima-init.lisp |                |    |                                                               |    |        |       |
  | Loading |  /home/edrx/.maxima/maxima-init.mac |                |    |                                                               |    |        |       |

and I get this empty "#+RESULTS:" block

  #+RESULTS:

when the first "maxima" found in the $PATH is /usr/bin/maxima, that is
a script that runs the Maxima that comes with Debian 11
("oldstable")...

If I simply run the tests above in a shell the log is:

  /home/edrx(edrx:sc)# /usr/local/bin/maxima
  Adding 118 subdirectories of "/usr/local/share/maxima/branch_5_47_base_312_gd5a35a21b/share" to search path.
  Adding 0 subdirectories of "/home/edrx/.maxima" to search path.
  Loading /home/edrx/.maxima/maxima-init.lisp
  Loading /home/edrx/.maxima/maxima-init.mac
  Maxima branch_5_47_base_312_gd5a35a21b https://maxima.sourceforge.io
  using Lisp SBCL 2.1.1.debian
  Distributed under the GNU Public License. See the file COPYING.
  Dedicated to the memory of William Schelter.
  The function bug_report() provides bug reporting information.
  (%i1) 2+3;
  (%o1)                                  5
  (%i2) quit()$
  /home/edrx(edrx:sc)# 
  /home/edrx(edrx:sc)# /usr/bin/maxima
  
  Maxima 5.44.0 http://maxima.sourceforge.net
  using Lisp GNU Common Lisp (GCL) GCL 2.6.12
  Distributed under the GNU Public License. See the file COPYING.
  Dedicated to the memory of William Schelter.
  The function bug_report() provides bug reporting information.
  (%i1) 2+3;
  (%o1)                                  5
  (%i2) quit()$
  /home/edrx(edrx:sc)# 


Thanks in advance,
  Eduardo Ochs
  http://anggtwu.net/eepitch.html






#####
#
# :session
# 2023dec03
#
#####

# «session»  (to ".session")
# (find-fline "~/LOGS/2023dec03.emacsconf-gen")
# (find-orgnode "Environment of a Code Block" "Using sessions")
# https://stackoverflow.com/questions/60152256/get-value-of-a-variable-from-another-session-in-org-mode
# (find-orgfile "ob-shell.el")
# (find-orgfile "ob-shell.el" "(assq :session params)")
# (find-orgfile "ob-maxima.el")
# (find-orgfile "ob-maxima.el" "session")

# (setq org-confirm-babel-evaluate nil)
# (require 'ob-shell)
#+begin_src shell :session *bla*
date
#+end_src

#+RESULTS:
: Sun Dec  3 15:04:20 -03 2023

#+begin_comment
 (eepitch-to-buffer "*bla*")
 (eepitch-kill)
 (eepitch-to-buffer "*bla*")
echo hello

#+end_comment


# (find-node "(org)Speed Keys")
# (find-orgnode "")




#####
#
# one-block-per-heading
# 2024may05
#
#####

# «one-block-per-heading»  (to ".one-block-per-heading")
# (find-fline "~/LOGS/2024may04.emacs" "one-block-per-heading")













https://orgmode.org/worg/org-contrib/babel/languages/ob-doc-python.html

# (find-efunctiondescr 'org-table-paste-rectangle)
# (find-efunction      'org-table-paste-rectangle)



# [O] Wolfram Language versus org mode literate:
# http://lists.gnu.org/archive/html/emacs-orgmode/2014-02/msg01020.html




#####
#
# Conkeror webjumps
# 2013oct01
#
#####

Useful webjumps for conkeror
If you are using the conkeror browser, maybe you want to put this into your ~/.conkerorrc file:

define_webjump("orglist", "http://search.gmane.org/?query=%s&group=gmane.emacs.orgmode");
define_webjump("worg", "http://www.google.com/cse?cx=002987994228320350715%3Az4glpcrritm&ie=UTF-8&q=%s&sa=Search&siteurl=orgmode.org%2Fworg%2F");

http://conkeror.org/Webjumps










# Firefox extension for org-protocol and org-capture:
# http://lists.gnu.org/archive/html/emacs-orgmode/2014-02/msg00750.html
# http://chadok.info/firefox-org-capture/



Hi,

I recently switched from having several Graphviz files to inlining
them via Babel in my source Org file. However, I noticed something
that might either be strange, or might just mean I don't yet
understand some stuff (as a relative newbie): I usually follow this
pattern to include my graphics:

    #+begin_center
    #+attr_html: height="350"
    #+attr_latex: width=0.5\textwidth
    [[./img/foo.png]]

    This is the caption for foo.png
    #+end_center

But if I try to replace this [[./img/foo.png]] with a
«#+begin_src dot» block, it does not get picked up by Babel (and ends
up in the generated document as a syntax-highlighted block  So,
clearly, org-mode understands it's a source block, but Babel ignores
it).

I currently commented out the #+begin_center and #+end_center
statements, but I'd really like to have them back. Or, at least, to
find a more proper way to mark the images (and captions!) as material
that should be distinguished from the flowing text. Something along
the lines of the LaTeX «figure» environment.

Thanks,








What's new:
http://lists.gnu.org/archive/html/emacs-orgmode/2012-12/msg00236.html


;; (find-orgsrcfile "lisp/ob-table.el" "defmacro sbe ")

Minimal overhead Org-mode blogging system:
http://lists.gnu.org/archive/html/emacs-orgmode/2011-12/msg00056.html

# https://github.com/punchagan/blog-files/blob/master/README.org
# (find-fline "/sda5/videos/org-mode/")

cd /sda5/videos/org-mode/
youtube-dl -t 'http://www.youtube.com/watch?v=oJTwQvgfgMM'
youtube-dl -t 'http://www.youtube.com/watch?v=V-gVWT3iMXY'
youtube-dl -t 'http://www.youtube.com/watch?v=6W82EdwQhxU'
youtube-dl -t 'http://www.youtube.com/watch?v=eoyi2vrsWow'

http://www.emacswiki.org/emacs/org-occur-goto.el
http://orgmode.org/worg/org-tutorials/advanced-searching.html

http://dl.dropbox.com/u/2440/org-tree-slide/Voila_Capture12.mov
http://orgmode.org/worg/org-tutorials/org-screencasts/org-mode-google-tech-talk.html

# (find-node "(org)Tags")

http://osiux.com/visualizando-org-mode-con-gnuplot.txt
http://pub.osiux.com/org-mode/plot.org

# (find-orgsrcfile "lisp/ob-tangle.el")

#+begin_src sh
for np in $(seq 1 32)
do
  echo $np
done
#+end_src

https://github.com/vxc/org-mode-ws
http://pascal.iiit.ac.in/~itws2
https://github.com/eschulte/babel-presentation/  late march 2012

# (find-node "(org)Column width and alignment" "clipped")

http://orgmode.org/worg/org-hacks.html

http://www.youtube.com/watch?v=6W82EdwQhxU An overview of Org Mode
http://www.youtube.com/watch?v=nsGYet02bEk Org Mode in Depth:Managing Structure
http://lists.gnu.org/archive/html/emacs-orgmode/2013-03/msg01843.html


http://awarewriter.wordpress.com/2012/03/04/org-mode-for-writing-structure-focus/
http://awarewriter.wordpress.com/2012/02/27/monday-musings-org-mode-for-writing-ii/
http://emacslife.wordpress.com/2011/07/07/org-mode-and-novel-writing/
http://scienceblogs.com/gregladen/2011/07/22/emacs-for-writers-org-mode/

https://github.com/novoid/org-mode-workshop/blob/master/featureshow/org-mode-teaser.org
http://glt13-programm.linuxtage.at/events/161.de.html
https://github.com/novoid/Memacs

https://github.com/novoid/extract_pdf_annotations_to_orgmode + more on github

http://www.docear.org/2014/01/15/comprehensive-comparison-of-reference-managers-mendeley-vs-zotero-vs-docear/
https://en.wikipedia.org/wiki/List_of_personal_information_managers
http://www.youtube.com/watch?v=1Ct4O0Ect18 How Mendeley can help your research

;; Export to markdown:
;;   (require 'ox-md)
;; or:
;;   (add-to-list 'org-export-backends 'md)


`(insert (org-make-link-string LINK DESCRIPTION))' should do what you


Videos:
http://kitchingroup.cheme.cmu.edu/blog/2014/07/12/Org-mode-is-awesome/

http://kitchingroup.cheme.cmu.edu/blog/2015/07/06/Indexing-headlines-in-org-files-with-swish-e-with-laser-sharp-results/
https://mail.google.com/mail/ca/u/0/#inbox/14e86ca7be82000d
https://www.youtube.com/channel/UCQp2VLAOlvq142YN3JO3y8w John Kitchin

http://kitchingroup.cheme.cmu.edu/blog/2015/11/21/Insert-org-entities-into-org-mode-with-helm/

https://github.com/vikasrawal/endingmalnutrition book

http://ehneilsen.net/notebook/orgExamples/org-examples.html 
https://github.com/bzg/emacs-training 




https://orgmode.org/org.html#Previewing-LaTeX-fragments

https://github.com/alphapapa/outshine

https://lists.gnu.org/archive/html/emacs-orgmode/2020-01/msg00029.html trey -> steven
https://lists.gnu.org/archive/html/emacs-orgmode/2020-01/msg00039.html when I grow up
https://mail.google.com/mail/ca/u/0/#search/impeccable/FMfcgxwGCbBHnwKndSbzxwjdgXvQqKtC

https://lists.gnu.org/archive/html/emacs-orgmode/2020-01/msg00292.html Testimony on how to publish a book using Org-mode


- To insert a new headline, type 'M-RET'.
- To insert a source block, type '< s TAB'.
- To insert org export headers, type ''C-c C-e #'.
- To schedule a headline for later, type 'C-c C-s'.
- To insert a link, type 'C-c C-l'.
- etc.




# (find-node "(org)Deadlines and scheduling")

https://github.com/toshism/org-super-links
https://github.com/takaxp/org-tree-slide

https://karl-voit.at/2020/01/25/avoid-complex-folder-hierarchies/
https://karl-voit.at/2018/08/25/deskop-metaphor/
https://github.com/novoid/Memacs
https://karl-voit.at/managing-digital-photographs/
https://arxiv.org/pdf/1304.1332.pdf

Text-based tables in Emacs has a problem when used with variable-pitch
fonts and CJK characters: they don't align. To solve that problem, I
wrote a package, vailgn.el, to provide automatic alignment for Org
Mode, Markdown, and table.el tables. Many people have been using it
(primarily the Chinese community) with success and many bugs have been
fixed. With the latest version, I am satisfied with the features
valign.el provides and its stability, so I want to see added to ELPA.

https://github.com/casouri/valign

https://lists.gnu.org/archive/html/emacs-orgmode/2020-12/msg00679.html Yet another browser extension for capturing notes - LinkRemark

https://en.wikipedia.org/wiki/Lightweight_markup_language

https://github.com/abo-abo/org-download
https://lists.gnu.org/archive/html/emacs-orgmode/2020-12/msg00779.html Jean Louis about org tables

https://github.com/the-ted/org-mind-map
https://pages.sachachua.com/evil-plans/


https://lists.gnu.org/archive/html/emacs-orgmode/2021-01/msg00313.html :var VAR1=(getenv "HOSTNAME")


https://emacsconf.org/2020/talks/22/
https://www.youtube.com/watch?v=2t925KRBbFc

https://www.reddit.com/r/emacs/comments/m3fknu/introducing_orgxournalpp_based_on_orgkrita/
https://github.com/lepisma/org-krita

https://github.com/bjonnh/PyOrgMode

https://github.com/tarsius/orglink
https://github.com/seanohalpin/org-link-minor-mode


Example paper written in org completely - Eric S Fraga 2021jun17:
https://lists.gnu.org/archive/html/emacs-orgmode/2021-06/msg00321.html

https://paperswithcode.com/

https://www.reddit.com/r/emacs/comments/q5y8sc/emacs_evaluation_of_c_without_manually_compiling/

https://lists.gnu.org/archive/html/emacs-orgmode/2021-10/msg00932.html Introducing Org-transclusion

Asilata Bapat: "Babel for academics"
https://emacsconf.org/2021/talks/babel/ 

https://stackoverflow.com/questions/11272632/how-to-create-a-column-view-in-emacs-lisp/11529749#11529749

https://github.com/minad/org-modern

https://www.reddit.com/r/emacs/comments/t77yr6/i_revamped_the_readme_of_zetteldeskel_to_make_it/
https://emacstil.com/til/2022/03/13/process-org-files-programmatically/
https://news.ycombinator.com/item?id=30745524 Plaintext Productivity (plaintext-productivity.net)

https://www.badykov.com/emacs/generating-site-from-org-mode-files/ 
https://braindump.badykov.com/about/
https://news.ycombinator.com/item?id=30945926 Tree-sitter grammar for org-mode (github.com/milisims)

https://github.com/amake/orgro
https://github.com/petitparser/dart-petitparser

https://www.youtube.com/watch?v=EK1oc9tlQrM
https://www.youtube.com/watch?v=ZXoahymWSvk
https://www.youtube.com/watch?v=EK1oc9tlQrM
https://www.youtube.com/watch?v=GwziWe0BpSw
https://www.youtube.com/watch?v=GwziWe0BpSw
https://www.youtube.com/watch?v=HGyt9Jgib7A
https://www.youtube.com/watch?v=oQq3Jwz0bDQ
https://www.youtube.com/watch?v=XfzTaw01RKI

https://scripter.co/improving-ox-hugo-exported-org-info-links/?utm_source=atom_feed

https://christiantietze.de/posts/2022/04/transient-menu-galore/ org-menu and tray

https://org-roam.discourse.group/t/zero-to-emacs-and-org-roam-a-step-by-step-guide-on-windows-10/400/68?page=4

* Org is too complex
# https://lists.gnu.org/archive/html/emacs-devel/2022-06/msg00205.html Alan Mackenzie
# https://lists.gnu.org/archive/html/emacs-devel/2022-06/msg00206.html Akib Azmain Tuja
# (find-fline "~/LOGS/2022jun04.emacs3" "msg00205.html")

https://orgmode.org/worg/dev/org-syntax.html
https://github.com/yantar92/org-capture-ref

https://lists.gnu.org/archive/html/emacs-orgmode/2022-10/msg00494.html termux
https://orgmode.org/worg/org-faq.html#org0a6fc30

https://lists.gnu.org/archive/html/emacs-orgmode/2022-10/msg00692.html Re: Haskell code blocks

https://orgmode.org/worg/org-contrib/babel/languages/ob-doc-shell.html
https://github.com/Kungsgeten/org-brain

https://www.youtube.com/watch?v=6FcnSrrmKig&feature=youtu.be

# (find-fline "~/LOGS/2022nov30.emacs" "Org-Plot")

# ob-tmux
# https://github.com/ahendriksen/ob-tmux

https://sachachua.com/blog/2023/01/linking-to-and-exporting-function-definitions-in-org-mode/

https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00032.html Arbitrary code execution
https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00056.html Arbitrary code execution

https://github.com/dfeich/org-screenshot org-attach-screenshot
https://github.com/abo-abo/org-download
https://www.wisdomandwonder.com/emacs/13972/org-mode-table-data-%e2%87%92-code-%e2%87%92-results
https://sachachua.com/blog/2024/01/org-mode-custom-link-copy-to-clipboard/

A collection of short Org-mode snippets demonstrating the usage of code blocks:
https://eschulte.github.io/org-scraps/ 

https://zzamboni.org/post/beautifying-org-mode-in-emacs/
https://news.ycombinator.com/item?id=40037844 Beautifying Org Mode in Emacs (2018) (zzamboni.org)



#  Local Variables:
#  coding: utf-8-unix
#  modes:  (fundamental-mode org-mode)
#  End:
