#######
#
# E-scripts on OSKit.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/oskit.e>
#           or at <http://angg.twu.net/e/oskit.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.oskit-200005»	(to "oskit-200005")
# «.oskit-200102»	(to "oskit-200102")



psnedeb <<'---'
     2077 dists/woody/main/source/devel/oskit_0.97.20000505-0.1.diff.gz
      585 dists/woody/main/source/devel/oskit_0.97.20000505-0.1.dsc
 12197133 dists/woody/main/source/devel/oskit_0.97.20000505.orig.tar.gz
---

cd $SDEBIAN/dists/woody/main/source/devel/
wget -c http://mirror.direct.ca/linux/debian/dists/woody/main/source/devel/oskit_0.97.20000505.orig.tar.gz

# (find-status "oskit")
# (find-vldifile "oskit.list")
# (find-fline "/usr/doc/oskit/")




#####
#
# oskit source
# 2000aug28
#
#####

# «oskit-200005»  (to ".oskit-200005")
#
pdsc $SDEBIAN/dists/woody/main/source/devel/oskit_0.97.20000505-0.1.dsc
cd /usr/src/oskit-0.97.20000505/
debian/rules binary	|& tee odrb
#

# (code-c-d "oskit" "/usr/src/oskit-0.97.20000505/")
# (find-oskitfile "")
# (find-oskitfile "examples/")
# (find-oskitfile "doc/")
# (find-oskitfile "doc/GNUmakerules")

cd /usr/src/oskit-0.97.20000505/doc/
make -f GNUmakerules oskit.dvi OSKIT_SRCDIR=/usr/src/oskit-0.97.20000505

# (find-oskitfile "doc/oskit.txt.gz")
# (find-oskitfile "doc/oskit.txt.gz" "hello: What else?")

xdvi +32 /usr/src/oskit-0.97.20000505/doc/oskit.dvi &
#

# (find-oskitfile "examples/")

hello
multiboot
mouse

cd /usr/src/oskit-0.97.20000505/examples/
cmp unix/hello		x86/hello
cmp unix/multiboot	x86/multiboot

mount -o remount,rw /hda1
rm -Rv /hda1/oskit/
mkdir  /hda1/oskit/
cp -pv unix/hello x86/hello     /hda1/oskit/
cp -pv unix/mouse x86/mouse     /hda1/oskit/
cp -pv            x86/multiboot /hda1/oskit/





#####
#
# oskit-0.97.20010214
# 2001may11
#
#####

# «oskit-200102»  (to ".oskit-200102")
# (find-es "hurd" "oskit-mach")
# (find-shttpw3 "www.cs.utah.edu/flux/oskit/")
# (find-es "oskit")
# (code-c-d "oskit200102" "/usr/src/oskit-0.97.20010214/")
# (find-oskit200102file "")
#
pdsc $SDEBIAN/pool/main/o/oskit/oskit_0.97.20010214-3.dsc
debian/rules binary	|& tee odrb
#

# Aaargh!:
# /usr/lib/libc.a(init-first.o)(.data+0x0): multiple definition of `__libc_multiple_libcs'
# sbrk-hack.o(.data+0x0):/hdd2/usr/src/oskit-0.97.20010214/unix/../unix/linux/sbrk-hack.c: first defined here
# make[2]: *** [nativecalls.o] Error 1
# make[2]: Leaving directory `/hdd2/usr/src/oskit-0.97.20010214/unix'
# make[1]: *** [unix/all.MAKE] Error 2

rm -Rv /usr/src/oskit-0.97.20010214/
#




#####
#
# fiasco
# 2000sep22
#
#####

# (find-shttpw3 "os.inf.tu-dresden.de/~fm3/l4hints/index.html")
# (find-shttpw3 "os.inf.tu-dresden.de/~fm3/l4rtl/index.html")
# (find-shttpw3 "os.inf.tu-dresden.de/drops/")
# (find-shttpw3 "os.inf.tu-dresden.de/L4/LinuxOnL4/use.html")
# (find-shttpw3 "os.inf.tu-dresden.de/fiasco/use.html")

rm -Rv /usr/src/l4/
cd /usr/src/
tar -xvzf $S/ftp/ftp.inf.tu-dresden.de/pub/os/L4/fiasco/fiasco-l4-990428.tar.gz
cd /usr/src/l4/
zcat $S/ftp/ftp.inf.tu-dresden.de/pub/os/L4/fiasco/fiasco-l4-990428.patch-01.gz | patch -p0

# (code-c-d "fiasco" "/usr/src/l4/l4/kernel/fiasco/src/")
# (find-fline "/usr/src/l4/")
# (find-fline "/usr/src/l4/README.fiasco")
# (find-fiascofile "")

# This is the Fiasco microkernel.  To build it, you also need the L4
# development libraries from l4-<date>.tar.gz and the OSKit from
# oskit-l4-<date>.tar.gz; unpack these packages in the same directory as
# the Fiasco tar-ball.

# But how do I get the L4 package?  Look at this:
# (find-shttpw3 "os.inf.tu-dresden.de/L4/l4down.html")






#  Local Variables:
#  coding:               utf-8-unix
#  End:
