#######
#
# E-scripts on P2P programs (SoulSeek, BitTorrent, etc)
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/p2p.e>
#           or at <http://angg.twu.net/e/p2p.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.transmission»		(to "transmission")
# «.transmission-settings»	(to "transmission-settings")
# «.create-torrent»		(to "create-torrent")
# «.test-tracker»		(to "test-tracker")
# «.transmission-qt»		(to "transmission-qt")
# «.trackers»			(to "trackers")
# «.transmission-daemon»	(to "transmission-daemon")
# «.transmission-svn»		(to "transmission-svn")
# «.magnet-links»		(to "magnet-links")
# «.tor-browser»		(to "tor-browser")
# «.frostwire»			(to "frostwire")
# «.qbittorrent»		(to "qbittorrent")
# «.xdg-open»			(to "xdg-open")
# «.tpb-proxies»		(to "tpb-proxies")




#####
#
# Transmission
# 2012mar12
#
#####

# «transmission»  (to ".transmission")
# (find-status   "transmission")
# (find-vldifile "transmission.list")
# (find-udfile   "transmission/")
# (find-status   "transmission-cli")
# (find-vldifile "transmission-cli.list")
# (find-udfile   "transmission-cli/")
# (find-status   "transmission-common")
# (find-vldifile "transmission-common.list")
# (find-udfile   "transmission-common/")
# (find-status   "transmission-gtk")
# (find-vldifile "transmission-gtk.list")
# (find-udfile   "transmission-gtk/")

# (find-man "1 transmission-cli")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
transmissioncli -h

# https://trac.transmissionbt.com/wiki/ConfigFiles
# https://trac.transmissionbt.com/wiki
# (find-fline "~/.config/transmission/")
# (find-fline "~/.config/transmission/torrents/")

<edrx> hi! is there a way to disable the GUI? because I may have
       selected the option that disables it, without knowing...
<edrx> I am running transmission 2.03 on debian stable
<edrx> and actually torrents given by magnet links instead of by
       torrent files were never displayed in the list of downloads
       here
<edrx> but they are downloaded correctly, and I transmission tells
       me when they finish downloading
<edrx> oops, "and transmission tells me"
<edrx> even weirder: since a few days ago the GUI does not get
       shown when I start transmission
<ajf_> the only way to disable the gui is to use
       transmission-daemon, as far as I know
<edrx> hm, weird
<edrx> I just got a small window telling me that a download was
       finished
<edrx> but I don't get the main window
<edrx> I just found the dir ~/.config/transmission/
<edrx> time to have some fun inspecting it... =)
<edrx> time to sleep, too - thanks and gnight =)





#####
#
# Transmission: the file "~/.config/transmission/settings.json"
# 2016feb14
#
#####

# «transmission-settings» (to ".transmission-settings")
# (find-fline "~/.config/transmission/")
# (find-fline "~/.config/transmission/setting.json")
# (find-fline "~/.config/transmission/setting.json.bup")
# (find-fline "~/.config/transmission/resume/")
# (find-ebuffer "#transmission@irc.freenode.net")
# (find-fline "~/LOGS/2016feb14.transmission")

<edrx> hi, I have a question about transmission's innards... any
       relevant links would be super-welcome
<edrx> I use transmission-gtk and some days ago the GUI stopped
       working - I would start the program and no window would show
       up. What I tried to do as a workaround
<edrx> (I've done that before)
<edrx> is to rename ~/.config/transmission/settings.json to
       ~/.config/transmission/settings.json.backup
<edrx> then I started transmission and everything worked - modulo
       one weird thing
<edrx> transmission thought that a big torrent that I had
       downloaded to /home/torrents/ was not here yet, and started
       downloading it... into /home/edrx/Downloads/
<edrx> so
<edrx> question
<edrx> where is the information about active torrents stored?
<edrx> in /home/edrx/.config/transmission/resume/
<edrx> and /home/edrx/.config/transmission/torrents/ ?
<edrx> my guess is that in ~/.config/transmission/resume/...
<edrx> is there a description of the file format of .resume files
       anywhere? say, in a source file for transmission?
<edrx> it seems that in things like
       "11:destination14:/home/torrents" we have a number n in
       decimal, then a ":", then n chars, then the next field...
(edrx) 



#####
#
# Creating torrents
# 2012mar12 / 2013sep10
#
#####

# «create-torrent»  (to ".create-torrent")
# Old links:
#   http://torrentfreak.com/how-to-create-a-torrent/
#   http://www.utorrent.com/help/guides/make-a-torrent
#   http://www.wikihow.com/Create-a-Torrent
#   https://forum.transmissionbt.com/viewtopic.php?t=7455&p=58245 
#   http://mktorrent.sourceforge.net/
#   http://wiki.tryphon.eu/how_to_use_bittorrent
#   http://www.morehawes.co.uk/bittorrent-transmission

# 2013sep10:
# (find-zsh "dmissing transmission")
# (find-status   "transmission-cli")
# (find-vldifile "transmission-cli.list")
# (find-udfile   "transmission-cli/")
# (find-man "1 transmission-remote")
# (find-man "1 transmission-cli")
# (find-man "1 transmission-create")
# (find-man "1 transmission-edit")
# (find-man "1 transmission-show")

# (find-fline "/sda5/videos/")
# (find-fline "/sda5/torrents/mytorrent/")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

# Create the torrent
#
BIGFILE=/sda5/videos/Vai_pensando_ai-_GDsuSk1vdA.mp4

rm -Rv /sda5/torrents/mytorrent/
mkdir  /sda5/torrents/mytorrent/
cd     /sda5/torrents/mytorrent/

date > /sda5/torrents/mytorrent/VERSION
mkdir  /sda5/torrents/mytorrent/videos/
cd     /sda5/torrents/mytorrent/videos/
cp -v $BIGFILE .

cd     /sda5/torrents/
# transmission-create   -o test.torrent -c 'My comment' \
transmission-create   -o test2.torrent -c 'My comment' \
                      -t http://tracker.ccc.de/announce \
                      -t udp://tracker.publicbt.com:80/announce \
                      mytorrent/

# 
# http://bitsnoop.com/trackers/
# tracker.ccc.de:80


cd     /sda5/torrents/
transmission-show     test2.torrent
transmission-show     test2.torrent | awk 'NR>=23 {print $1}' | tee /tmp/o
#
# This is what the last command answers:
#                     mytorrent/VERSION
#                     mytorrent/videos/Vai_pensando_ai-_GDsuSk1vdA.mp4
#
# Test again (this works):
ls -l $(cat /tmp/o)


# Upload the torrent:
#
chmod 644             test2.torrent
Scp -v /sda5/torrents/test2.torrent edrx@angg.twu.net:public_html/tmp/
#
# Ckeck its URL:
#   (find-wget "http://angg.twu.net/tmp/test.torrent")
#   (find-twupfile "")


# On transmission-qt:
#   Edit -> Preferences -> Download -> Save to location ->
#     (change to "/sda5/torrents/")
#   File -> Open -> File name ->
#     /sda5/torrents/test.torrent
# We'll get a window called "Open Torrent" with all the right defaults:
#   Torrent file:       [/sda5/torrents/] test [.torrent]
#   Destination folder:  /sda5/torrents/
#   Files:
#                                       mytorrent
#                                             |-- Version
#                                             \-- videos
#                                                 \----- vai_pensando_ai___.mp4
# Then clicking on "verify local data" should work.





#####
#
# Checking that a tracker is in service
# 2013sep11
#
#####

# «test-tracker» (to ".test-tracker")
# (find-man "1 dig")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-man "1 dig")
# (find-sh "dig a      tracker.publicbt.com")
traceroute tracker.publicbt.com

<Lacrocivious> edrx: Have you confirmed that your transmission port
               is open?
<Lacrocivious> edrx: Default is 51413; use https://canyouseeme.org
               to verify

https://canyouseeme.org/




#####
#
# transmission-qt
# 2013sep10
#
#####

# «transmission-qt» (to ".transmission-qt")
# (find-zsh "availabledebs | sort | grep transmission")
# (find-status   "transmission-qt")
# (find-vldifile "transmission-qt.list")
# (find-udfile   "transmission-qt/")
# http://trac.transmissionbt.com/wiki/UnixServer/Debian
# https://trac.transmissionbt.com/wiki/ConfigFiles
# https://trac.transmissionbt.com/wiki/EditConfigFiles
# https://trac.transmissionbt.com/wiki/EnvironmentVariables

# (find-fline "~/LOGS/2013sep10.transmission")
# (find-fline "~/LOGS/2013sep10.transmission2")




#####
#
# Trackers
# 2013sep10
#
#####

# «trackers» (to ".trackers")
# (find-zsh "availabledebs | sort | grep tracker")
# http://en.wikipedia.org/wiki/BitTorrent_tracker
# http://en.wikipedia.org/wiki/Comparison_of_BitTorrent_tracker_software
# http://btracs.com/
# http://publicbt.com/
#   udp://tracker.publicbt.com:80/announce



#####
#
# transmission-daemon
# 2013sep10
#
#####

# «transmission-daemon» (to ".transmission-daemon")
# (find-status   "transmission-daemon")
# (find-vldifile "transmission-daemon.list")
# (find-udfile   "transmission-daemon/")
# (find-man "1 transmission-daemon")




#####
#
# Transmission from SVN
# 2013sep12
#
#####

# «transmission-svn» (to ".transmission-svn")
# https://trac.transmissionbt.com/wiki/Building
# https://trac.transmissionbt.com/browser/trunk/extras/rpc-spec.txt

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/Transmission/")
rm -Rfv ~/usrc/Transmission/
cd      ~/usrc/
svn co svn://svn.transmissionbt.com/Transmission/trunk Transmission
cd      ~/usrc/Transmission/

# (code-c-d "transmission" "~/usrc/Transmission/")
# (find-transmissionfile "")
# (find-transmissionfile "libtransmission/")
# (find-transmissionfile "qt/")
# (find-transmissionfile "utils/")
# (find-transmissionfile "utils/create.c")




#####
#
# Magnet links
# 2012apr02
#
#####

# «magnet-links»  (to ".magnet-links")
# http://torrentfreak.com/bittorrents-future-dht-pex-and-magnet-links-explained-091120/
# http://en.wikipedia.org/wiki/Transmission_(BitTorrent_client)
# http://en.wikipedia.org/wiki/Magnet_URI_scheme





#####
#
# tor-browser
# 2020sep27
#
#####

# «tor-browser»  (to ".tor-browser")
# https://www.torproject.org/download/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/")
# (find-fline "/tmp/" "tor-browser-")

rm -Rv /tmp/tor-browser_en-US/
tar -C /tmp/ \
 -xvJf /tmp/tor-browser-linux64-11.0.14_en-US.tar.xz
cd     /tmp/tor-browser_en-US/

/tmp/tor-browser_en-US/Browser/start-tor-browser

./start-tor-browser

# (find-fline "/tmp/tor-browser_en-US/")
# (find-fline "/tmp/tor-browser_en-US/Browser/")
# (find-fline "/tmp/tor-browser_en-US/Browser/start-tor-browser")
# (find-fline "/tmp/tor-browser_en-US/Browser/Downloads/")





#####
#
# frostwire
# 2021sep09
#
#####

# «frostwire»  (to ".frostwire")
# https://www.frostwire.com/
# https://www.frostwire.com/downloads





#####
#
# qbittorrent
# 2022sep11
#
#####

# «qbittorrent»  (to ".qbittorrent")
# https://www.qbittorrent.org/download.php
# (find-status   "qbittorrent")
# (find-vldifile "qbittorrent.list")
# (find-udfile   "qbittorrent/")
# https://github.com/qbittorrent/search-plugins/wiki/Unofficial-search-plugins

Search for:
https://www.discogs.com/master/103238-Hugo-Largo-Drum
https://www.discogs.com/master/779617-Pink-Industry-Pink-Industry
https://www.discogs.com/master/131917-Medicine-Her-Highness
https://www.discogs.com/master/970183-Kristi-Stassinopoulou-Echotropia



#####
#
# xdg-open
# 2024mar31
#
#####

# «xdg-open»  (to ".xdg-open")
# (find-angggrep "grep --color=auto -niH --null -e xdg LOGS/*")




#####
#
# tpb-proxies
# 2024mar31
#
#####

# «tpb-proxies»  (to ".tpb-proxies")
# https://www.reddit.com/r/TPB/comments/14lfoih/which_ad_blocker_is_recommended_with_tpb/
# https://www.reddit.com/r/TPB/comments/1bgf7rv/100_working_the_pirate_bay_proxies_list_updated/
# https://www.reddit.com/r/TPB/






[TRS-80 goes to check out transmission.el]





# (find-status   "nicotine")
# (find-vldifile "nicotine.list")
# (find-udfile   "nicotine/")


https://code.google.com/p/mergetorrent/wiki/HowTo
http://tracker.publicbt.com/
http://www.publicbt.com/
https://code.google.com/p/mergetorrent/wiki/HowTo
http://forum.utorrent.com/viewtopic.php?id=49515 Dealing With Multi-Part Torrents
http://wiki.vuze.com/w/Selective_downloading

https://wiki.theory.org/BitTorrentSpecification


https://news.ycombinator.com/item?id=28370662 Tor is a great sysadmin tool (2020) (jamieweb.net)
https://stackoverflow.com/questions/3844502/how-do-bittorrent-magnet-links-work

https://news.ycombinator.com/item?id=34703478 Transmission v4.0 (github.com/transmission)
https://annas-blog.org/how-to-run-a-shadow-library.html








#  Local Variables:
#  coding:               utf-8-unix
#  End:
