#######
#
# E-scripts on maintaining my home page.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/page.e>
#           or at <http://angg.twu.net/e/page.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######


# «.full_upload»		(to "full_upload")
# «.upload_changes»		(to "upload_changes")
# «.upload-eev»			(to "upload-eev")
# «.upload-rsync»		(to "upload-rsync")
# «.lstoindexhtml_lua»		(to "lstoindexhtml_lua")
# «.rumi_dl_angg_install»	(to "rumi_dl_angg_install")
# «.rumi_dl_angg_compare»	(to "rumi_dl_angg_compare")
# «.rumi_upl_to_gmail»		(to "rumi_upl_to_gmail")
# «.angg_dl_rumi_compare»	(to "angg_dl_rumi_compare")
# «.compare-home-and-tourism»	(to "compare-home-and-tourism")
# «.compare-produce-o.tgz»	(to "compare-produce-o.tgz")
# «.compare-tp-and-home»	(to "compare-tp-and-home")
# «.add-extras-make-o.tgz»	(to "add-extras-make-o.tgz")
# «.compare-o.tgz-and-home»	(to "compare-o.tgz-and-home")
# «.NOTCL»			(to "NOTCL")
# «.quick-upload-to-zumbi»	(to "quick-upload-to-zumbi")
# «.vcsa2pnm_icon»		(to "vcsa2pnm_icon")
# «.vcsa2pnm»			(to "vcsa2pnm")
# «.capture_screen»		(to "capture_screen")
# «.math.th-files»		(to "math.th-files")
# «.mathstuff.pack»		(to "mathstuff.pack")
# «.cgis_on_twu»		(to "cgis_on_twu")
# «.info2www_twu»		(to "info2www_twu")
# «.man2html»			(to "man2html")
# «.eeman»			(to "eeman")
# «.slow_html-twu»		(to "slow_html-twu")
# «.zsh-on-twu»			(to "zsh-on-twu")
# «.lua50-on-twu»		(to "lua50-on-twu")
# «.lua51-on-twu»		(to "lua51-on-twu")
# «.test_unpacking»		(to "test_unpacking")
# «.tp»				(to "tp")
# «.apt_repository»		(to "apt_repository")
# «.checking_broken_links»	(to "checking_broken_links")
# «.makeapacheindex»		(to "makeapacheindex")
# «.lua-without-readline»	(to "lua-without-readline")


# «.upload-edrx.tgz-with-rsync»	(to "upload-edrx.tgz-with-rsync")
# «.update-pages-with-3ee»	(to "update-pages-with-3ee")
# «.update-pages-with-4eee»	(to "update-pages-with-4eee")
# «.makepagefromtar-at-twu»	(to "makepagefromtar-at-twu")
# «.download-edrx.tgz-and-sync»	(to "download-edrx.tgz-and-sync")
# «.upload-o.tgz»		(to "upload-o.tgz")
# «.download-o.tgz-and-sync»	(to "download-o.tgz-and-sync")

#  (find-efunction 'eejump)

                upload-e-w-rsync
     persephone ----------------> angg (edrx.tgz)
          ^           (8J)          |
 dl-o.tgz-|(8888J)             (88J)|dl-edrx.tgz
  and-sync|                         |-and-sync
          |        upload-o.tgz     v
    gmail (o.tgz) <------------ sweetjane
                     (888J)




#####
#
# Uploading the full page
# 99dec12
#
#####

# «full_upload»  (to ".full_upload")
# make the bundle, upload to twu, generate things there
#
makeL
cd ~/TH/L/
make -f a/s/Makefile a/s/edrx.tgz
anonftp angg.twu.net 'lcd a/s/' 'put edrx.tgz' 'quit'
#
# Always update ~/pagetwu.tgz after a full upload
cp ~/TH/L/a/s/edrx.tgz ~/pagetwu.tgz
#

# «twu_make_page»
# At twu (with zsh; use sshtwu and eevt):
makepage
# (find-angg ".zshrc" "makepage")



# To upload directly to sucuri:
#
makeLedrxtgz
scpsucuri ~/TH/L/edrx.tgz edrx@sucuri:
#





#####
#
# Partial uploads
# 99dec27
#
#####

# «upload_changes»  (to ".upload_changes")
# (find-angg ".emacs" "upload-changes")
#
makeLedrxtgz
rm -Rv /tmp/oldpage/
rm -Rv /tmp/newpage/

mkdir  /tmp/oldpage/
cd     /tmp/oldpage/
tar -xvzf ~/pagetwu.tgz

mkdir  /tmp/newpage/
cd     /tmp/newpage/
tar -xvzf ~/TH/L/edrx.tgz

# Delete the files that haven't changed:
cd     /tmp/newpage/
for i in $(find . -type f -or -type l); do
  cmp $i ../oldpage/$i && rm -v $i
done

# Pack the changed files and upload them.
cd /tmp/newpage/
tar -cvzf /tmp/pagechanges.tgz $(find . -type f -or -type l)
laf /tmp/pagechanges.tgz
anonftp angg.twu.net 'lcd /tmp' 'put pagechanges.tgz' 'quit'

# (find-angg ".zshrc" "scp")
# scpsucuri /tmp/pagechanges.tgz edrx@sucuri:pagechanges.tgz

#
# If all went well then update our notion of what's in twu.
cp ~/TH/L/edrx.tgz ~/pagetwu.tgz

#
# For when I want to upload everything:
makeLedrxtgz
cd ~/TH/L/
anonftp angg.twu.net 'put edrx.tgz' 'quit'

#



#####
#
# Partial uploads using rsync
# 2005jul19
#
#####

# «upload-eev»  (to ".upload-eev")
#
# Remake eev-current.tar.gz
# (find-eevfile "Makefile" "htmls:")
# (find-eev "Makefile" "htmlize.el")
# (find-eevfile "htmlize-eev.el" "eev-intro.el")
# (find-eevfile                  "eev-intro.el")
# (find-eevfile "htmlize-eev.el" "eev-multiwindow.el")
# (find-blogme3file "anggmake.lua" "eev-current/eev-multiwindow.el")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/eev-current/
# make htmlize.el
make htmls

makeL

# (find-eev "Makefile" "tarball")
# (find-eev ".files")
#
cd ~/eev-current/
rm -v /tmp/eev-current.tar.gz
make  /tmp/eev-current.tar.gz
cp -v /tmp/eev-current.tar.gz ~/TH/L/eev-current/
cp -v /tmp/eev-current.tar.gz ~/TH/L/

# (find-es "page" "lstoindexhtml_lua")
for i in $(cd ~/TH/L/ && find .* * -type d); do 
  cd ~/TH/L/$i && LC_COLLATE=C lstoindexhtml_lua_maybe $i
done

#
# (find-angg ".zshrc" "eev-current-upload")
eev-current-upload

# (find-twusfile "" "eev-current.tar.gz")
# (find-twusfile    "eev-current.tar.gz")

# The scripts to build and upload a new version of eev_<date>_all.deb
# are here:
# (find-es "eev" "dh-make-2")
# They need to be run by hand.

#




#####
#
# upload-rsync
# 2023apr06
#
#####

#
# «upload-rsync»  (to ".upload-rsync")
# «upload-edrx.tgz-with-rsync»  (to ".upload-edrx.tgz-with-rsync")
# (to "update-pages-with-3ee")
# (to "update-pages-with-4eee")
# Make edrx.tar and update the one in angg.twu.net from it using rsync
# (eev-bounded)

makeLhomeedrxtgz
zcat ~/edrx.tgz > /tmp/edrx.tar
laf /tmp/edrx.tar
# echo 'l $passwd(twu)' > $EEG

# eegpasswd \
~/EXPECT/autopasswd \
  rsync -avvz -e ssh /tmp/edrx.tar edrx@angg.twu.net:edrx.tar
rsync   -avvz -e ssh /tmp/edrx.tar edrx@linode:edrx.tar

date
laf ~/edrx.tgz

#



#####
#
# Update the pages at twu and at linode using find-3ee
# 2023apr07
#
#####

# «update-pages-with-3ee»  (to ".update-pages-with-3ee")

 (eepitch-password-prompt 'yes)
 (eepitch-password-prompt 'no)

 (eepitch-linode)
cd; tar -xvf edrx.tar; rezshrc
touch ~/blogme3/anggmake.lua
{makepagefromtar; makepageindexhtmls} |& tee ~/ompft

 (find-3ee '(eepitch-linode) '(eepitch-Twu))
 (eepitch-Twu)
cd; tar -xvf edrx.tar; rezshrc
touch ~/blogme3/anggmake.lua
{makepagefromtar; makepageindexhtmls} |& tee ~/ompft

 (eepitch-password-prompt 'no)
 (eepitch-password-prompt 'yes)




#####
#
# update-pages-with-4eee
# 2023dec21
#
#####

# «update-pages-with-4eee»  (to ".update-pages-with-4eee")

 (eepitch-password-prompt 'yes)
 (eepitch-password-prompt 'no)
 (find-4EEE '(eepitch-shell2) '(eepitch-linode) '(eepitch-Twu))
 (find-4eee '(eepitch-shell2) '(eepitch-linode) '(eepitch-Twu))

 (eepitch-shell2)
makeLhomeedrxtgz
zcat ~/edrx.tgz > /tmp/edrx.tar
laf /tmp/edrx.tar
# echo 'l $passwd(twu)' > $EEG

                    rsync -avvz -e ssh /tmp/edrx.tar edrx@linode:edrx.tar
~/EXPECT/autopasswd rsync -avvz -e ssh /tmp/edrx.tar edrx@angg.twu.net:edrx.tar

date
laf ~/edrx.tgz

 (eepitch-linode)
cd; tar -xvf edrx.tar; rezshrc
touch ~/blogme3/anggmake.lua
{makepagefromtar; makepageindexhtmls} |& tee ~/ompft

 (eepitch-Twu)
cd; tar -xvf edrx.tar; rezshrc
touch ~/blogme3/anggmake.lua
{makepagefromtar; makepageindexhtmls} |& tee ~/ompft

 (eepitch-Twu)
exit
 (eepitch-linode)
exit
 (eepitch-shell2)
exit





#
# On twu:
## rm -Rf ~/public_html/ 2>&1 | head -n 1000
# makepagefromtar

#
# «makepagefromtar-at-twu»  (to ".makepagefromtar-at-twu")
# (find-es "linode" "edrx.tar-update")
# (find-angg ".zshrc" "makepagefromtar")
# (find-sh0 "rm -v ~/.eev/eeg.TWU.pid")

 (eek "C-x 1")
 (ee-set-fullscreen nil)
 (size 127 56)

 (eechannel-TWU)
cd; tar -xvf edrx.tar; rezshrc
touch ~/blogme3/anggmake.lua
{makepagefromtar; makepageindexhtmls} |& tee ~/ompft

 (eek "C-x 1")
 (ee-set-fullscreen 1)



cd ~/public_html/audios/      && for i in *.html; do
  echo $i; crlf < $i > $i.txt
done; rm -v index.html.txt
cd ~/public_html/ferramentas/ && for i in *.html; do
  echo $i; crlf < $i > $i.txt
done; rm -v index.html.txt
makepageindexhtmls

# For debugging:
# (find-twufile "ompft")
# (find-fline "/edrx@angg.twu.net:ompft")
# (find-fline "/ftp:edrx@angg.twu.net:ompft")
#   (eev "date | tee /tmp/o; Scp -vv /tmp/o edrx@angg.twu.net:")
#   (eev "date | tee /tmp/o; Scp -vv /tmp/o edrx@angg.twu.net:edrx.tgz")
#   (eev "Scp -vv ~/edrx.tgz edrx@angg.twu.net:o")

# For desperate cases:
# (find-fline "~/" "edrx.tgz")
#   (eev "Scp -vv ~/edrx.tgz edrx@angg.twu.net:")
# and unpack the .tgz to the .tar at twu...

 (eebgTWU)
zsh
{makepagefromtar; makepageindexhtmls} |& tee ~/ompft

# «lstoindexhtml_lua»  (to ".lstoindexhtml_lua")
for i in $(cd ~/public_html && find .* * -type d); do 
  cd ~/public_html/$i && LC_COLLATE=C lstoindexhtml_lua_maybe $i .favicon.png
done

#
makeLedrxtgz
cd ~/TH/L/
# (find-angg ".zshrc" "remote-accounts")
echo 'l $passwd(puc)' > $EEG; eegpasswd scp edrx.tgz edrx@$SUCURI:

#
# (eev "Scp edrx@angg.twu.net:ompft /tmp/ompft")
# (find-fline "/tmp/ompft")

# (find-man "1 rsync" "by sending only the differences")
# (find-man "1 rsync" "-z, --compress")
# (find-man "1 rsync" "-W, --whole-file\n")
# (find-man "1 rsync" "--no-whole-file\n")





#####
#
# compare ~ with the tourism package, produce an o.tgz with the changes
# 2006jun23
#
#####

# «compare-home-and-tourism»  (to ".compare-home-and-tourism")
#
# Unpack ~/edrx.tgz (the tourism package, fetched from twu) into
# /tmp/TP/, and produce (find-fline "/tmp/.tp.files")

rm -Rv /tmp/TP/
mkdir  /tmp/TP/
tar -xvzf ~/edrx.tgz -C /tmp/TP/
# cd /tmp/TP/ && find -type f | sort | cut -b 3- > /tmp/.tp.files
  cd /tmp/TP/ && find $('ls' -A) -type f | sort > /tmp/.tp.files

# Produce (find-fline "/tmp/.tp.files.changed")
#     and (find-fline "/tmp/.tp.files.changed.e")
# (find-angg "LUA/lua50init.lua")
cd /tmp/TP/
lua5.1 -e '
  HOME = getenv("HOME")
  files = split(readfile("/tmp/.tp.files"))
  for i=1,getn(files) do
    local fname = files[i]
    local fname2 = HOME.."/"..fname
    f1 = readfile(fname)
    f2 = readfile(fname2)
    if f1 ~= f2 then print(fname) end
  end
' | tee /tmp/.tp.files.changed
for i in $(</tmp/.tp.files.changed); do
  echo '# (find-tkdiff "/tmp/TP/" "~/" "'$i'")'
done | tee /tmp/.tp.files.changed.e
# (find-fline "/tmp/.tp.files.changed.e")

#
# Produce:  (find-fline "/tmp/.tp.files.new")
# Requires: (eev "makeLedrxtgz")

rm -Rv /tmp/HERE/
mkdir  /tmp/HERE/
tar -xvzf ~/TH/L/edrx.tgz -C /tmp/HERE/
cd /tmp/HERE/ && find -type f | sort | cut -b 3- > /tmp/.here.files
comm       /tmp/.tp.files /tmp/.here.files >     /tmp/.tp.files.comm
comm -1 -3 /tmp/.tp.files /tmp/.here.files | tee /tmp/.tp.files.new

# (find-man "1 comm")
# (find-node "(coreutils)comm invocation")
# (find-sh "comm -1 -3 /tmp/.tp.files /tmp/.here.files")

# Damn, this is broken - some symlink thing.
# (find-fline "/tmp/TP/eev-current/"   "eeg")
# (find-fline "/tmp/HERE/eev-current/" "eeg")

# (find-fline "/tmp/.tp.files")
# (find-fline "/tmp/.tp.files.changed")
# (find-fline "/tmp/.tp.files.comm")

#
# «compare-produce-o.tgz»  (to ".compare-produce-o.tgz")
# Produce the o.tgz.
# The eekill is because it is usually "uploaded" to gmail.
# The second line lists extra files; atm I always adjust it by hand.
# Currently (jun2006) I only run this block at sweetjane.
# (find-es "sweetjane")

cd
tar -cvzf /tmp/o.tgz $(cat /tmp/.tp.files.changed) \
  ORG/*.org e/oracle.e e/swig.e e/dialog.e TITAN/titanl.c bin/fastcmp.lua
laf /tmp/o.tgz

# (find-fline "/tmp/o.tgz")
# (eekill     "/tmp/o.tgz")

#





#####
#
# sync between rumi and angg (and persephone)
# 2007apr18
#
#####

# «rumi_dl_angg_install»  (to ".rumi_dl_angg_install")
# At rumi download angg's edrx.tgz and unpack/install it at "~/":
#
 (eepitch-shell)
mkdir /tmp/page/
cd    /tmp/page/
wget -O edrx-angg.tgz http://angg.twu.net/edrx.tgz 
mkdir  /tmp/page/angg/
tar -C /tmp/page/angg/ -xvzf /tmp/page/edrx-angg.tgz
#
# Unpack on ~:
tar -C ~               -xvzf /tmp/page/edrx-angg.tgz


# «rumi_dl_angg_compare»  (to ".rumi_dl_angg_compare")
# At rumi download angg's edrx.tgz and compare its files with the ones at ~
# (find-angg "LUA/quickdiff.lua")
#
 (eepitch-shell)
mkdir /tmp/page/
cd    /tmp/page/
wget -O edrx-angg.tgz http://angg.twu.net/edrx.tgz 
mkdir  /tmp/page/angg/
tar -C /tmp/page/angg/ -xvzf /tmp/page/edrx-angg.tgz
#
 (eepitch-shell)
makeLedrxtgz
cp -v ~/TH/L/edrx.tgz /tmp/page/edrx-rumi.tgz
rm -Rv /tmp/page/rumi/
mkdir  /tmp/page/rumi/
tar -C /tmp/page/rumi/ -xvzf /tmp/page/edrx-rumi.tgz
#
# (find-angg "LUA/quickdiff.lua")
#
# Then:
# (find-sh "~/LUA/quickdiff.lua | sort | tee /tmp/page/odiff")
# (find-fline "/tmp/page/odiff")
# To compare and update files - manually - use this:
# (find-efunction 'find-anggrumidiff-links)


# «rumi_upl_to_gmail»  (to ".rumi_upl_to_gmail")
# From rumi prepare a /tmp/rumi.tgz and upload it to gmail.
# The list of files in the A=(...) is extracted from 
#   (find-fline "/tmp/page/odiff")
# by:
#         (find-sh  "egrep '^(changed:)' /tmp/page/odiff | awk '{print $2}'")
# (eekill (find-sh0 "egrep '^(changed:)' /tmp/page/odiff | awk '{print $2}'"))
# and the "odiff" file is prepared by the "rumi_dl_angg_compare" block, above.
#
A=(
 .emacs
 TH/rrj4.blogme
 e/apache.e
 e/mail.e
 eev-current/eev-mini-steps.el
)
cd
tar -cvzf /tmp/rumi.tgz $A svn/adm/ TODO ORG/index.org RUMI/ LOGS/
laf       /tmp/rumi.tgz
# (find-fline "/tmp/rumi.tgz")
# (eekill     "/tmp/rumi.tgz")

#


# «angg_dl_rumi_compare»  (to ".angg_dl_rumi_compare")
# At persephone, when angg is in sync with persephone, download a
# /tmp/rumi.tgz from gmail; this .tgz should contain newer versions of
# some files (because I modified them at work - on rumi), and then
# compare these newer version with the ones at angg by hand, using
# find-anggrumidiff-links on the output of a "find".
#
# Unpack /tmp/rumi.tgz at angg:
#
 (eepitch-shell)
makeLedrxtgz
mkdir /tmp/page/
cp -v ~/TH/L/edrx.tgz /tmp/page/edrx-angg.tgz
cp -v   /tmp/rumi.tgz /tmp/page/edrx-rumi.tgz

mkdir  /tmp/page/angg/
tar -C /tmp/page/angg/ -xvzf /tmp/page/edrx-angg.tgz
mkdir  /tmp/page/rumi/
tar -C /tmp/page/rumi/ -xvzf /tmp/page/edrx-rumi.tgz

# (find-sh "cd /tmp/page/rumi/ && find -type f | cut -b 3-")

 (eepitch-shell)
# Optional: unpack RUMI/
# (find-fline "/tmp/page/edrx-rumi.tgz" "RUMI/")
cd
tar -tvzf /tmp/page/edrx-rumi.tgz RUMI/
tar -xvzf /tmp/page/edrx-rumi.tgz RUMI/
# (find-fline "~/RUMI/")
# (find-blogme3file "rumimake.lua")





#####
#
# compare angg.twu.net/edrx.tgz with the stuff in ~ (in sweetjane)
# 2006jul03
#
#####

# I run this in machines that are not persephone to produce a set of
# changes that should be applied (by hand, always) at persephone.

# More precisely: when I work at a machine that is not my home machine
# ("persephone") - for example, when I'm at my machine at work
# ("sweetjane") - I do most things that I do when I'm home: I can
# change the files that go into edrx.tgz, I can change the list of
# those files (at Files.tcl), I can run makeL from time to time to
# produce an html version of my page locally, etc; but then the
# edrx.tgz produced at sweetjane becomes out-of-sync with the edrx.tgz
# from persephone, and there are updates at sweetjane that I would
# like to propagated to persephone...

# More explanations later.

# «compare-tp-and-home»  (to ".compare-tp-and-home")
# «download-edrx.tgz-and-sync»  (to ".download-edrx.tgz-and-sync")
#
cd /tmp/
wget http://angg.twu.net/edrx.tgz

#
# Produce: (find-fline "/tmp/.files.changed")
#          (find-fline "/tmp/.files.changed.e")
# (find-fline "/tmp/edrx.tgz")
rm -Rv /tmp/tp/
mkdir  /tmp/tp/
tar -C /tmp/tp/ -xvzf /tmp/edrx.tgz
cd     /tmp/tp/
# (find-angg "bin/fastcmp.lua")
find $('ls' -A) -type f | sort | tee /tmp/.files.tp | \
  fastcmp.lua /tmp/tp/ ~/ | tee /tmp/.files.changed | \
  gsub.lua '^(.*)$' '# (find-tkdiff "/tmp/tp/" "~/" "%1")' | \
  tee /tmp/.files.changed.e

#
# «upload-o.tgz»  (to ".upload-o.tgz")
makeLedrxtgz

#
# Produce:  (find-fline "/tmp/.files.new")
# Requires: ~/TH/L/edrx.tgz
#           (eev "makeLedrxtgz")

rm -Rv /tmp/here/
mkdir  /tmp/here/
tar -xvzf ~/TH/L/edrx.tgz -C /tmp/here/
cd /tmp/here/ && find $('ls' -A) -type f | sort > /tmp/.files.here
comm       /tmp/.files.tp /tmp/.files.here >     /tmp/.files.comm
comm -1 -3 /tmp/.files.tp /tmp/.files.here | tee /tmp/.files.here.new

#
# «add-extras-make-o.tgz»  (to ".add-extras-make-o.tgz")
# (find-fline "~/ORG/")
# (find-fline "~/TITAN/")
# (find-fline "~/MEDIADOR/")
cd
print -l ORG/*.org MEDIADOR/*.{e,sh,svg} \
         MEDIADOR/{admin,billing,interface}/ \
         TITAN/*.{lua,e,c,h} TITAN/Makefile \
  | grep -v _wrap \
  | sort | tee /tmp/.files.extra

tar -cvzf /tmp/o.tgz $(
  cat /tmp/.files.changed /tmp/.files.here.new /tmp/.files.extra
)

#
# Now export the o.tgz, by uploading it to gmail...
# (find-fline "/tmp/o.tgz")
# (eekill     "/tmp/o.tgz")

#
# «compare-o.tgz-and-home»  (to ".compare-o.tgz-and-home")
# «download-o.tgz-and-sync»  (to ".download-o.tgz-and-sync")
# Compare /tmp/o.tgz and the files at ~.
# I run this at persephone to sync its files with the ones at sweetjane.

rm -Rv /tmp/there/
mkdir  /tmp/there/
tar -C /tmp/there/ -xvzf /tmp/o.tgz
tar -tzf /tmp/o.tgz | \
  gsub.lua '^(.*)$' '# (find-tkdiff "/tmp/there/" "~/" "%1")' | \
  tee /tmp/.files.there.e

#
# (find-fline "/tmp/.files.there.e")





#####
#
# NOTCL
# 2008jan18
#
#####

# «NOTCL»  (to ".NOTCL")
# (find-angg "TH/Makefile" "NOTCL")
# (find-angg ".zshrc" "makeL")

# (find-blogme3file "anggmake.lua")
# (find-THLfile "TH/Makefile")
# (find-THLfile "TH/Makefile" "$(TH_HTMLS)")
# (find-THLfile "TH/Makefile.auto")
# (find-THLfile "TH/Makefile.auto" "TH_HTMLS =")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
makeLedrxtgz

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -R /tmp/testL/
mkdir /tmp/testL/
cd    /tmp/testL/
tar -xzf ~/TH/L/edrx.tgz
make -f TH/Makefile NOTCL=1

# file:///tmp/testL/emacs.html




#####
#
# a quick way to upload my page to zumbi
# 2008jan18
#
#####

# «quick-upload-to-zumbi»  (to ".quick-upload-to-zumbi")
# (find-angg ".zshrc" "lstoindexhtml_lua_maybe")
# (find-THLfile "blogme3/index.html")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
makeLedrxtgz
cd ~/TH/L/
        find -type f | grep index.html
rm -v $(find -type f | grep index.html)
makeL
                         find . -type d | cut -b3- | sort
lstoindexhtml_lua_dirs $(find . -type d | cut -b3- | sort)
laf blogme3/index.html
tar -cf /tmp/THL.tar .

 (eepitch-zumbi)
 (eepitch-kill)
 (eepitch-zumbi)
cd ~/public_html/
mkdir -p ~/public_html/TH/L/
cd       ~/public_html/TH/L/
tar -xvf ~/THL.tar

# (ee-cp "/tmp/THL.tar" (ee-zumbifile "THL.tar") 'over)

# http://zumbi/~edrx/TH/L/
# http://zumbi/~edrx/TH/L/blogme3/
# http://zumbi/~edrx/TH/L/e/sisrot.e.html




#####
#
# upload my page to angelfire, from twu
# 00feb11
#
#####

# (find-fline "~/.netrc
# (find-fline "edrx@angg.twu.net:.netrc")

# at angg:

cd
grep angelfire ~/.netrc | tee ~/o
anonftp angg.twu.net 'put .netrc' 'chmod 600 .netrc' 'quit'

# twu stuff:
# Run the block below at twu, using "sshtwu |& tee ~/oa" (we tee at
# angg, to make the log more accessible). Note that twu has no expect,
# and so we can't use my anonftp script.

cd ~/public_html/
(echo hash on
 echo prompt off
 find * -type d | awk '{print "mkdir ", $1}'
 find * -type f | sort | awk '{printf "!echo %s :\nput %s %s\n", $1, $1, $1}'
) > ~/o

ftp ftp.angelfire.com < ~/o
exit





######
#
# vcsa2pnm (screenshots of vts; Icon version)
# 99sep15
#
######

# «vcsa2pnm_icon»  (to ".vcsa2pnm_icon")
# (find-fline "~/ICON/vcsa2pnm.icn")

cd ~/ICON/
icont -s vcsa2pnm
# vcsa2pnm > /tmp/v.pnm
vcsa2pnm /home/root/C/math1.8 2 > /tmp/v.pnm
display /tmp/v.pnm

cd ~/ICON/
icont -s vcsa2pnm

~/ICON/vcsa2pnm /home/root/C/math1.8 2 \
  | convert - /tmp/v.png
laf /tmp

cd /tmp
zgv

# (find-vldifile "pnmtopng.list")
# (find-fline "/usr/doc/pnmtopng/")




######
#
# vcsa2pnm (mktclapp version)
# 99oct04
#
######

# «vcsa2pnm»  (to ".vcsa2pnm")
# (find-fline "~/MTA/vtutil.tcl")
# (find-fline "~/.emacs")
# (find-fline "/etc/inittab" "kbrequest")
# (find-fline "~/bin/kbrequest")

cd ~/MTA/
vtutil vcsa2pnm  /dev/vcsa1  256 8 math1.8  /tmp/1.pnm
convert /tmp/1.pnm /tmp/1.png
laf /tmp/1*

# Timing:
cd ~/MTA/
time  vtutil vcsa2pnm  /dev/vcsa1  256 8 math1.8  /tmp/1.pnm
time  pnmtopng /tmp/1.pnm > /tmp/1.png
time  pnmtopng < /tmp/1.pnm > /tmp/1.png
time  convert /tmp/1.pnm /tmp/1c.png
laf /tmp/1*
# "convert" is faster and compresses color output better.


# 99dec06: but when I tried to use these pngs in netscape I noticed
# that it (netscape 4.5) really really really doesn't like the pngs
# generated by convert; so, use the one created by pnmtopng for
# anything serious.


# Old command line (obsolete):
# ./vtutil.tcl vcsa2pnm math2.8 8 /dev/vcsa1 /tmp/1.pnm





#####
#
# Binding Alt-Up to a screen-capture script
# 99dec06
#
#####

# «capture_screen»  (to ".capture_screen")

# (find-fline "/etc/inittab" "kbrequest")
# (find-fline "~/bin/kbrequest")

if [[ -e /tmp/ncaptures ]]; then
  N=$(</tmp/ncaptures)
else
  N=0
fi
N=$[$N+1]
echo $N > /tmp/ncaptures
cd /home/root/MTA/
./vtutil.tcl vcsa2pnm math2.8 8 /dev/vcsa1 /tmp/$N.pnm
/usr/X11R6/bin/convert /tmp/$N.pnm /tmp/$N.png
rm /tmp/$N.pnm

exit





#####
#
# Condensing forms
#
#####

# «condensing_forms»

# (find-enode "Regexps")
# (find-fline "~/TH/search.th")

(query-replace-regexp
  "^<option value=\\(\"\\([^\"]*\\)\"\\|\\([^ >]*\\)\\)\\( selected\\)?>"
  "\\2\\3 ")

(query-replace-regexp
  "^<select name=\\(\"\\([^\"]*\\)\"\\|\\([^ >]*\\)\\) size=\\([^>]*\\)>"
  "[SELECT \\2\\3 \\4")

# Test on this:

Language:
<select name="LNG" size=1>
<option value=ALL selected>any
<option value=chinese>Chinese
<option value="danish">Danish
<option value=dutch>Dutch
</select>




#####
#
# html.007: converting .ths from the old format
# 99sep??
#
#####

# (find-fline "~/.zshrc" "getstrings")
# (eeman "perlop" "REPLACEMENT")
# (eeman "perldata" "hash literal")

# Tool to help me select which "$..."s to replace
#
cd $PAGE
for i in *.th; do
  perl -ne 'while ( m/(\$[0-9A-Za-z_]+)( |$)/gc ) { print $1, "\n"; }' < $i
done | sort | uniq

# Convert (partially) most of the old pages to the new format
#
cat > /tmp/p <<'---'
%a = ( '$ANGG' => 'ANGG', '$E' => 'ES', '$L' => 'L', '$L2' => 'L',
'$LR' => 'LR', '$Ldir' => 'L', '$Loc' => 'LOC', '$bf' => 'BF', '$h3'
=> 'H3', '$hlist1' => 'HLIST1', '$hlist2' => 'HLIST2', '$href' =>
'HREF', '$ifLR' => 'IFLR', '$it' => 'IT', '$j' => 'J', '$li' => 'LI',
'$list1' => 'LIST1', '$p' => 'P', '$pre' => 'PRE', '$q' => 'Q', '$t'
=> 'T', '$t0' => 'T1', '$tt' => 'TT' );
s/(\$[0-9A-Za-z_]+)( |$)/($a{$1}||$1).$2/eg;
print $_;
---
# perl -nl /tmp/p < $PAGE/ebabble.th
for i in crashco debian ebabble escripts files forth haskell html icon \
  index linux logic math music other perl redhat0 tcltk tese tex \
  unclassified; do
    echo $i.th
    perl -nl /tmp/p < $PAGE/$i.th > ~/TCL/PAGE2/$i.th
done




# (find-fline "~/TCL/PAGE/")
# (find-fline "~/TCL/PAGE2/")

cd ~/TCL/PAGE2/
make




#####
#
# angelfire
# 99oct08
#
#####

# «angelfire»

# (find-es "http" "tcl_http")
# (find-fline "$S/http/www.angelfire.com/or2/edrx/")
psne http://www.angelfire.com/or2/edrx/
lynx http://www.angelfire.com/or2/edrx/

ftp ftp.angelfire.com
cd incoming

cd $ES

cd ~/TH/L/
anonftp ftp.angelfire.com 'cd incoming' 'put index.html edrxindex.html'


# (find-fline "~/.psne.log")
find $S/http/www.angelfire.com/
find $S/http/help.angelfire.com/

cd $S/http/www.angelfire.com/cgi-bin/
getforms < bedit.html
cp bedit.html /tmp
edrxnetscape /tmp/bedit.html

A=$S/http/help.angelfire.com/bin/help
cd $A
rm -v $(find * -type l)
for i in $(find * -type f); do ln -s $(basename $i) $i.html; done

A=$S/http/help.angelfire.com/bin/help
lynx -force_html $A/B-Homepage_Building_Help/G-Uploading
lynx -force_html $A/B-Homepage_Building_Help/A-Web_Shell
lynx -force_html $A/A-General_Questions/A-About_Angelfire_Membership

grep angel ~/.psne.log

# (find-fline "$S/http/www.angelfire.com/cgi-bin")
# (find-fline "$S/http/www.angelfire.com/cgi-bin/_webshell.html")




#####
#
# The *.pack targets in ~/LATEX/Makefile (for uploading my math stuff in TeX)
# 2001oct09
#
#####

# «mathstuff.pack»  (to ".mathstuff.pack")
# (find-angg "LATEX/Makefile" "making_tgzs")
#
rm -Rv /tmp/PACK/
mkdir  /tmp/PACK/
cd ~/LATEX/
make PACKDIR=/tmp/PACK 2001F.pack
(cd /tmp/PACK/; laf)

#
cd /tmp/PACK/
anonftp angg.twu.net 'cd ~/slow_html/math/' 'mput 2001F*' quit
# scp 2001F* edrx@sucuri:slow_html/math/

#





#####
#
# Files on slow_html that math.th refers to
# 2000mar01
#
#####

# «math.th-files»  (to ".math.th-files")
# (find-fline "~/TH/math.th")
# (find-angg ".zshrc" "TeX")

#
cd ~/LATEX/
rm -v /tmp/2001*
dvi+eps 2001a.dvi | sort | uniq
tar -cvzf /tmp/2001a-dvi.tgz $(dvi+eps 2001a.dvi | sort | uniq)
zip /tmp/2001a-dvi.zip       $(dvi+eps 2001a.dvi | sort | uniq)
make DPI=600 /tmp/2001a.ps
cd /tmp/
zip 2001a-ps.zip 2001a.ps
gzip 2001a.ps
laf /tmp/2001a*

#
cd ~/LATEX/
rm -v /tmp/2001*
dvi+eps 2001b.dvi | sort | uniq
tar -cvzf /tmp/2001b-dvi.tgz $(dvi+eps 2001b.dvi | sort | uniq)
zip /tmp/2001b-dvi.zip       $(dvi+eps 2001b.dvi | sort | uniq)
make DPI=600 /tmp/2001b.ps
cd /tmp/
zip 2001b-ps.zip 2001b.ps
gzip 2001b.ps
laf /tmp/2001b*

#
cd ~/LATEX/
rm -v /tmp/2001*
dvi+eps 2001c.dvi | sort | uniq
tar -cvzf /tmp/2001c-dvi.tgz $(dvi+eps 2001c.dvi | sort | uniq)
zip /tmp/2001c-dvi.zip       $(dvi+eps 2001c.dvi | sort | uniq)
make DPI=600 /tmp/2001c.ps
cd /tmp/
zip 2001c-ps.zip 2001c.ps
gzip 2001c.ps
laf /tmp/2001c*

#
cd ~/LATEX/
rm -v /tmp/2001*
make DPI=600 2001nd-abs.dvi /tmp/2001nd-abs.ps
cp -v 2001nd-abs.dvi /tmp/
cd /tmp/
zip 2001nd-abs-dvi.zip 2001nd-abs.dvi
zip 2001nd-abs-ps.zip  2001nd-abs.ps
gzip 2001nd-abs.dvi
gzip 2001nd-abs.ps

#
cd /tmp/
anonftp angg.twu.net 'mkdir slow_html/math' 'cd slow_html/math' \
  'mput 2001nd-abs*' 'quit'

#
# tese-mestr.tgz
# tese-mestr.ps.tgz

rm -Rv /tmp/tese/
mkdir /tmp/tese/
# mkdir /tmp/tese/eps/
cd ~/LATEX/
cp -iv feb98.dvi /tmp/tese/tese-mestr.dvi
cp -iv frostos.dvi /tmp/tese/
cp -iPv $(dvieps feb98.dvi | sort | uniq) /tmp/tese/
cd /tmp/tese/
mkdir -p ~/slow_html/math/
tar -cvzf ~/slow_html/math/tese-mestr.tgz $(find * -type f)
laf ~/slow_html/math/tese-mestr.tgz

cd /tmp/tese/
dvips -o /tmp/tese-mestr.ps tese-mestr.dvi
dvips -o /tmp/frostos.ps frostos.dvi
laf /tmp/frostos.ps /tmp/tese-mestr.ps
cd /tmp/
tar -cvzf tese-mestr.ps.tgz frostos.ps tese-mestr.ps
laf /tmp/tese-mestr.ps.tgz
cp -v /tmp/tese-mestr.ps.tgz ~/slow_html/math/

# slides-mestr.tgz

rm -Rv /tmp/slides/
mkdir /tmp/slides/
# mkdir /tmp/slides/eps/
cd ~/LATEX/
cp -iv slides.dvi /tmp/slides/slides-mestr.dvi
cp -iPv $(dvieps slides.dvi | sort | uniq) /tmp/slides/
cd /tmp/slides/
mkdir -p ~/slow_html/math/
tar -cvzf ~/slow_html/math/slides-mestr.tgz $(find * -type f)
laf ~/slow_html/math/slides-mestr.tgz

cd /tmp/slides/
dvips -o /tmp/slides-mestr.ps slides-mestr.dvi
laf /tmp/slides-mestr.ps
gzip -f6 /tmp/slides-mestr.ps
laf /tmp/slides-mestr.ps.gz
cp -v /tmp/slides-mestr.ps.gz ~/slow_html/math/

# 00feb24.dvi
# 99sep25.dvi

cd ~/LATEX/
make 00feb24.dvi 99sep25.dvi
cp -v 00feb24.dvi 99sep25.dvi ~/slow_html/math

cd ~/slow_html/math
anonftp angg.twu.net 'cd ~/slow_html/math' 'put tese-mestr.tgz' 'quit'
anonftp angg.twu.net 'cd ~/slow_html/math' 'put slides-mestr.tgz' 'quit'
anonftp angg.twu.net 'cd ~/slow_html/math' 'put 00feb24.dvi' 'quit'
anonftp angg.twu.net 'cd ~/slow_html/math' 'put 99sep25.dvi' 'quit'



# (find-vldifile "tetex-bin.list")
# (find-fline "/usr/doc/tetex-bin/")

# (find-vldifile "psutils.list")
# (find-fline "/usr/doc/psutils/")






#####
#
# cgis on twu - first tests
# 2000mar11
#
#####

# «cgis_on_twu»  (to ".cgis_on_twu")
#
# (eev-bounded)
# at angg:
cat > /usr/lib/cgi-bin/Dummy.cgi <<'---'
#!/bin/sh
echo "Content-type: text/plain"
echo ""
echo Hello
---
chmod 755 /usr/lib/cgi-bin/Dummy.cgi

wget -q -O - http://localhost/cgi-bin/Dummy.cgi
#
# (eevt-bounded)
# At twu:
cd ~/public_html/
cat > Dummy.cgi <<'---'
#!/bin/sh
echo "Content-type: text/plain"
echo ""
echo Hello
---
chmod 755 Dummy.cgi

lynx http://angg.twu.net/Dummy.cgi
#




#####
#
# info2www at twu
# 2000mar11
#
#####

# «info2www_twu»  (to ".info2www_twu")
#
# (eev-bounded)
cd /usr/lib/cgi-bin/
anonftp angg.twu.net 'put info2www' 'quit'

#
# At twu:  (eevt-bounded)
cd ~/public_html
cp ~/info2www info2www.cgi
patch info2www.cgi <<'%%'
45,46c45,46
<      "/usr/info",
<      "/usr/local/info"
---
>      "/home2/edrx/info",
>      "/usr/info"
%%
chmod 755 info2www.cgi
# I'll keep a copy of it in slow_html as a temporary solution.
cp -v info2www.cgi ~/slow_html/

#
# Back to angg:  (eev-bounded)
lynx 'http://angg.twu.net/info2www.cgi?(emacs)Top'

# (find-fline "~/TH/emacs-tutor.th" "nodehref e")
cd /usr/info/

laf emacs-e20*.gz
laf elisp*.gz
laf emacs-lisp-intro*.gz
laf info-e20*.gz
laf texinfo*.gz
laf emacs-faq*.gz
laf gdb.*.gz

tar -cvzf /tmp/info.tgz \
	emacs-e20*.gz	\
	elisp*.gz	\
	emacs-lisp-intro*.gz	\
	info-e20*.gz	\
	texinfo*.gz	\
	emacs-faq*.gz	\
	gdb.*.gz
laf /tmp/info.tgz

cd /tmp/
anonftp angg.twu.net 'put info.tgz' 'quit'

#
# At twu:
rm -Rv ~/info/
mkdir ~/info/
cd ~/info/
tar -xvzf ~/info.tgz

# At angg:
lynx 'http://angg.twu.net/info2www.cgi?(elisp)Top'

cd /usr/share/info/
anonftp angg.twu.net 'cd info' 'mput make.info*'





#####
#
# man2html
# 2000nov08
#
#####

# «man2html»  (to ".man2html")
# (find-status "man2html")
# (find-vldifile "man2html.list")
# (find-fline "/usr/doc/man2html/")

# (find-fline "/usr/sbin/manglimpse")
# (find-fline "/etc/cron.weekly/man2html")

lynx  http://127.0.0.1/cgi-bin/man2html
lynx 'http://127.0.0.1/cgi-bin/man2html?Apache::Debug+3'

# In cases like this man2html offers a menu:
# (eeman "3 exec")
# (eeman "3tcl exec")
lynx    'http://127.0.0.1/cgi-bin/man2html?exec+3'
lynx 'http://angg.twu.net/cgi-bin/man2html?mutt+1'

# «eeman»  (to ".eeman")
#
expect -c '
  proc eeman {str} {
    if {[regexp {^(([1-8])[!-~]* +)?([!-~]+)$} $str -> _ n prog]} {
      puts "$n $prog"
    }
  }
  eeman "3tcl exec"
  eeman fprintf
'
#
# (find-fline "~/TH/Generate" "procj MANL1")
# (find-fline "~/TH/Generate" "proc eeman")

~/TH/Generate /tmp/o.html 'puts [flinkli heelo]' 
~/TH/Generate /tmp/o.html 'puts [flinkli {# (eeman "1 man" "naa")}]' 
~/TH/Generate /tmp/o.html 'puts [flinkli {# (eeman "1 make-kpkg")}]' 
~/TH/Generate /tmp/o.html 'puts [txt2html {# (eeman "1 make-kpkg")}]' 
#
touch $ES/kernel.e
makeL
#

# (find-vldifile "man2html.list")
anonftp angg.twu.net 'lcd /usr/lib/cgi-bin/' 'cd ~/slow_html/cgi-bin/' \
  'put man2html' 'quit'




#####
#
# slow_html on twu
# 2002nov30
#
#####

# «slow_html-twu»  (to ".slow_html-twu")
#
# On twu:
cd ~/slow_html/
# find | sort | l -S
chmod 644 $(find * -type f)
chmod 755 $(find * -type d)
chmod 755 info2www.cgi*
chmod 755 cgi-bin/man2html

#
lynx http://angg.twu.net/cgi-bin/man2html
lynx http://angg.twu.net/info2www.cgi





#####
#
# zsh on twu
# 2004nov09
#
#####

# «zsh-on-twu»  (to ".zsh-on-twu")

mkdir ~/usrc/
cd    ~/usrc/
mkdir ~/ulocal/

psne ftp://ftp.zsh.org/zsh/zsh-4.2.1.tar.bz2

rm -R ~/usrc/zsh-4.2.1/
tar -C ~/usrc/ \
  -xvjf $S/ftp/ftp.zsh.org/zsh/zsh-4.2.1.tar.bz2
cd     ~/usrc/zsh-4.2.1/
./configure --prefix=$HOME/ulocal    2>&1 | tee oc
make                                 2>&1 | tee om
make install                         2>&1 | tee omi




#####
#
# lua50 on twu
# 2004nov18
#
#####

# «lua50-on-twu»  (to ".lua50-on-twu")
# This could be much cleaner.
# Basically I'm taking (find-eevex "lua.e" "install-5.0.2")
# and removing the readline support.

# (eev "eggt -channel A Twu")
# (define-key eev-mode-map [f9] 'eegt-this-line)

 (setq eegt-channel "A")
psne http://www.lua.org/ftp/lua-5.0.2.tar.gz

mkdir  ~/usrc/
rm -Rv ~/usrc/lua-5.0.2/
mkdir  ~/usrc/lua-5.0.2/
tar -xvzf $S/http/www.lua.org/ftp/lua-5.0.2.tar.gz -C ~/usrc/
cd     ~/usrc/lua-5.0.2/

find * -name '*.[ch]' | sort > .files.ch
etags $(<.files.ch)

# (find-lua5file "INSTALL")
# (find-lua5file "config")
# (find-lua5file "etc/README")
# (find-lua5file "src/lib/loadlib.c")
cat >> config <<'%%%'

# --- Edrx's changes
# (find-lua5file "config" "dynamic loading on Unix systems")
LOADLIB= -DUSE_DLOPEN=1
DLLIB= -ldl
MYLDFLAGS= -Wl,-E
# MYCFLAGS=-g
#
# (find-lua5file "config" "\n#USERCONF=")
# USERCONF=-DLUA_USERCONFIG='"$(LUA)/etc/saconfig.c"' -DUSE_READLINE
USERCONF=-DLUA_USERCONFIG='"$(LUA)/etc/saconfig.c"'
# EXTRA_LIBS= -lm -lreadline -ldl
EXTRA_LIBS= -lm -ldl

INSTALL_EXEC= cp -v
INSTALL_DATA= cp -v
# STRIP=echo NOT stripping:
INSTALL_BIN=$(HOME)/bin
INSTALL_INC=$(HOME)/include/lua5
INSTALL_LIB=$(HOME)/ulocal/lib
INSTALL_MAN=$(HOME)/ulocal/man/man1
%%%

mkdir ~/include ~/ulocal

make test       2>&1 | tee omt
ldd  bin/lua    2>&1 | tee ol
#make so        2>&1 | tee oms
make install    2>&1 | tee omi
#make soinstall 2>&1 | tee omsi
# (find-lua5file "om")
# (find-lua5file "omi")
# (find-lua5file "omsi")

cd ~/bin/
ln -sf lua lua50




#####
#
# lua51 on twu
# 2013may05
#
#####

# «lua51-on-twu» (to ".lua51-on-twu")
# (find-es "lua5" "install-5.1.4")
# (find-es "lua5" "lpeg-0.9")
 (eepitch-Twu)
 (eepitch-kill)
 (eepitch-Twu)
zsh
psne http://www.lua.org/ftp/lua-5.1.5.tar.gz

rm -Rfv ~/usrc/lua-5.1.5/
mkdir   ~/usrc/
tar  -C ~/usrc/ -xvzf $S/http/www.lua.org/ftp/lua-5.1.5.tar.gz
cd      ~/usrc/lua-5.1.5/

make CC="gcc -fPIC" linux test local                    |& tee omltl
cd src; ld -o liblua.so -shared $(ar t liblua.a); cd ..
cd src; install -p -m 0644 liblua.so ../lib;      cd ..

cd ~/usrc/lua-5.1.5/src/
cp -iv lua  ~/bin/lua51
cp -iv luac ~/bin/luac51

rm -Rv ~/usrc/lpeg-0.9/
tar -C ~/usrc/ -xvzf \
  $S/http/www.inf.puc-rio.br/~roberto/lpeg/lpeg-0.9.tar.gz
cd     ~/usrc/lpeg-0.9/ \
  && chmod 644 *

LUA51SRC=$HOME/usrc/lua-5.1.5
make LUADIR=$LUA51SRC/src CC="gcc -fPIC"  |& tee om

# lua51
# loadlpeg()

# (find-twufile "usrc/lua-5.1.5/")
# (find-twufile "bin/")








#####
#
# test unpacking
# 2000oct09
#
#####

# «test_unpacking»  (to ".test_unpacking")
# (to "upload_changes")
# (find-es "zsh" "unsetall")
# (find-fline "~/TH/Makefile" "pagetgz_angg")
#
makeL

cd ~/TH/L/
# make -f ~/TH/Makefile /tmp/page.tgz
make -f ~/TH/Makefile pagetgz_angg

rm -Rv /tmp/edrx/
mkdir  /tmp/edrx/
cd     /tmp/edrx/
tar -xvzf /tmp/page.tgz
# (find-fline "/tmp/edrx/a/s/Htmllib.tcl" "env")
unsetall env
unsetall make -f a/s/Makefile
unsetall make -f a/s/Makefile a/s/page.tgz
#




#####
#
# notes on the typical point notation
# 2000nov07
#
#####

# «tp»  (to ".tp")
# (find-zshnode "Array Parameters")
#
cd ~/LATEX/
make edrxnotes
rm -v tp-*.ps

cd ~/LATEX/
make DPI=600 tp-calc.ps tp-categs.ps
laf tp-calc.ps tp-categs.ps

zip /tmp/tp-ps600.ps.zip tp-calc.ps tp-categs.ps
laf /tmp/tp-ps600.ps.zip

tar -cvzf /tmp/tp-ps600.ps.tar.gz tp-calc.ps tp-categs.ps
laf /tmp/tp-ps600.ps.tar.gz

A=($((dvi+eps tp-categs.dvi; dvi+eps tp-calc.dvi) | sort | uniq))
echo $A
laf $A
tar -cvzf /tmp/tp-dvi.tar.gz $A
zip /tmp/tp-dvi.zip $A

laf /tmp/tp-dvi.tar.gz
laf /tmp/tp-dvi.zip
laf /tmp/tp-ps600.ps.tar.gz
laf /tmp/tp-ps600.ps.zip

#

cd /tmp/
anonftp angg.twu.net 'cd slow_html' 'cd math' \
  'mput tp-dvi.tar.gz tp-dvi.zip tp-ps600.ps.tar.gz tp-ps600.ps.zip'

#



#####
#
# apt repository on twu
# 2001jan18
#
#####

# «apt_repository»  (to ".apt_repository")
#
rm -Rv /tmp/aptrep/
mkdir  /tmp/aptrep/
cd /usr/src/.debs/
find dists | egrep 'mktclapp|lua|xaster' | tee /tmp/.files
cp -diPpvR $(</tmp/.files) /tmp/aptrep/

cd /tmp/aptrep/
find | sort

# (find-angg ".zshrc" "apt")
dpkg-scan_p+s dists/potato/local

cd /tmp/aptrep/
find | sort
# (find-fline "/tmp/aptrep/dists/potato/local/binary-i386/")
# (find-fline "/tmp/aptrep/dists/potato/local/source/")

#
cd /tmp/aptrep/
tar -cvzf /tmp/aptrep.tgz $(find dists | egrep 'mktclapp|lua|P|S' | sort)
laf /tmp/aptrep.tgz
anonftp angg.twu.net 'lcd /tmp' 'put aptrep.tgz' 'quit'

#
# This is to be run at twu...
# (eevt-bounded)
cd
# rm -Rv ~/slow_html/debian/
mkdir ~/slow_html/debian/
cd    ~/slow_html/debian/
tar -xvzf ~/aptrep.tgz
(cd ~/slow_html/; cp -dPpvRl * ~/public_html/)

#
# (eevt-bounded)
# Strange, it seems that twu's apache does not show files named
# "README" in directory listings; I'm renaming this one to README.txt
# to circumvent that.
cat > ~/slow_html/debian/dists/potato/local/README.txt <<'---'
To make your apt aware of this package repository add these lines to
/etc/apt/sources.list:

  deb     http://angg.twu.net/debian potato local
  deb-src http://angg.twu.net/debian potato local

and issue the command "apt-get update".

A quick description of the packages here can be found in the
"Packages" file in the binary-i386 directory, and the scripts that I
used to make them from the pristine sources can be found at:

  http://angg.twu.net/e/mktclapp.e.html#mktclapp.debs
  http://angg.twu.net/e/lua.e.html#lua-4.0_debs
  http://angg.twu.net/e/lua.e.html#lua-3.2_yada
---
(cd ~/slow_html/; cp -dPpvRl * ~/public_html/)
#

lynx http://angg.twu.net/debian/dists/potato/local/





#####
#
# reinstalling twu's home files from the tgz
# 2001jan18
#
#####

#
# (find-angg ".zshrc" "edrxpage")
# (find-angg "bin/edrxpage" "phtml")
# (eevt-bounded)

cd
~/public_html/a/bin/edrxpage \
  THISMAKEFILE=$HOME/public_html/a/bin/edrxpage \
  EDRXTGZ=$HOME/edrx.tgz \
    phtml_unpack phtml_to_home
laf edrx.tgz public_html/a/s/edrx.tgz

#
# (eevt-bounded)
makepagedeb && (
  rm -v   ~/slow_html/debian/dists/potato/local/binary-i386/edrxpage*
  cp -liv ~/slow_html/tmp/edrxpage*_all.deb \
    ~/slow_html/debian/dists/potato/local/binary-i386/
  cd ~/slow_html/debian/
  dpkg-scan_p+s dists/potato/local

  rm -Rv ~/public_html/debian/dists/potato/local/{binary-i386,source}/
  (cd ~/slow_html/; cp -dPpvRl * ~/public_html/)
)

#





#####
#
# Checking broken links
# 2001mar03
#
#####

# «checking_broken_links»  (to ".checking_broken_links")
#
cd ~/TH/L/
cat *.html | gethrefs | egrep -v '^(/snarf|http://|ftp://)' | l -S
#
cd ~/TH/L/
cat *.html | gethrefs | egrep -v '^(/snarf|http://|ftp://|file://|mailto:)' \
  | egrep -v '^(\.\./R/|#)' | egrep -v '^/' \
  |& l -S
#
cd ~/TH/R/
cat *.html | gethrefs | egrep -v '^(/snarf|http://|ftp://|file://|mailto:)' \
  | egrep -v '^(\.\./R/|#)' | egrep -v '^/' \
  | sed 's/#.*//g' | sort | uniq | tee ~/o \
  |& l -S
laf -ld $(<~/o) |& l -S

#
makeLedrxtgz
rm -Rv /tmp/edrx/
mkdir  /tmp/edrx/
tar -xzf ~/TH/L/edrx.tgz -C /tmp/edrx/
cd /tmp/edrx/
make -f TH/Makefile

#
cd /tmp/edrx/
cat *.html | gethrefs | egrep -v '^(/snarf|http://|ftp://|file://|mailto:)' \
  | egrep -v '^(\.\./R/|#)' | egrep -v '^/' \
  | sed 's/#.*//g' | sort | uniq | tee ~/o \
  |& l -S
laf -ld $(<~/o) |& l -S

#




#####
#
# makeapacheindex
# 2001oct14
#
#####

# «makeapacheindex»  (to ".makeapacheindex")
# (find-angg ".zshrc" "makeapacheindex")
# (find-angg ".zshrc" "makeindexhtmls")
#
ls -laF | col -bx | perl -e 'while (<STDIN>) {
  if (m/^(.{56})(.+?)([\*\=\@\|]| -> .*)?\n/) {
    printf "%s[%s]%s\n", $1, $2, $3
  } else {
    printf "??: %s", $_
  }
}'

#
echo '<!DOCTYPE html PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head><title></title></head><body><pre>
hello
</pre></body></html>' | tidy

#
ls -laF | col -bx | perl -e '
  printf "<!DOCTYPE html PUBLIC \"-//IETF//DTD HTML 2.0//EN\">\n";
  printf "<html><head><title></title></head><body><pre>\n";
  while (<STDIN>) {
    if (m/^(.{56})(.+?)([\*\=\@\|]| -> .*)?\n/) {
      printf "%s[%s]%s\n", $1, $2, $3
    } else {
      printf "??: %s", $_
    }
  }
  printf "</pre></body></html>\n";
  '

#





#####
#
# Compiling Lua without readline on a broken twu
# 2018nov14
#
#####

# «lua-without-readline» (to ".lua-without-readline")

# (find-twufile "bin/" "lua51")
# (find-twufile "usrc/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
ssh edrx@angg.twu.net
lua51

cd ~/usrc/lua-5.1.5/
make clean
make
# make linux
# make clean
make generic







#  Local Variables:
#  coding:               utf-8-unix
#  End:
