#######
#
# E-scripts on Pic.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/pic.e>
#           or at <http://angg.twu.net/e/pic.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.pic-manual»		(to "pic-manual")
# «.chem»		(to "chem")
# «.gpic»		(to "gpic")
# «.conses»		(to "conses")




#####
#
# The Pic manual
# 2011nov17
#
#####

# «pic-manual»  (to ".pic-manual")
# (find-angg ".emacs" "esrpic")
# (find-status   "groff")
# (find-vldifile "groff.list")
# (find-udfile   "groff/")
# (find-sh0 "cd /usr/share/doc/groff-base/ && zcat pic.ps.gz | ps2pdf - ~/tmp/esrpic.pdf")

(code-xpdf      "esrpic" "~/tmp/esrpic.pdf")
(code-pdftotext "esrpic" "~/tmp/esrpic.pdf")
;; (find-esrpicpage      1  "Contents")
;; (find-esrpicpage (+ 1 1) "Index")
;; (find-esrpictext "")
# (find-esrpicorigtext "")
# (find-esrpicorigtext)

# (find-esrpicorigtext "1.  Introduction to PIC")
# (find-esrpicorigtext "1.1.  Why PIC?")
# (find-esrpicorigtext "1.2.  PIC Versions")
# (find-esrpicorigtext "2.  Invoking PIC")
# (find-esrpicorigtext "2.1.  PIC Error Messages")
# (find-esrpicorigtext "3.  Basic PIC Concepts")
# (find-esrpicorigtext "4.  Sizes and Spacing")
# (find-esrpicorigtext "4.1.  Default Sizes of Objects")
# (find-esrpicorigtext "4.2.  Objects Do Not Stretch!")
# (find-esrpicorigtext "4.3.  Resizing Boxes")
# (find-esrpicorigtext "4.4.  Resizing Other Object Types")
# (find-esrpicorigtext "4.5.  The `same' Keyword")
# (find-esrpicorigtext "5.  Generalized Lines and Splines")
# (find-esrpicorigtext "5.1.  Diagonal Lines")
# (find-esrpicorigtext "5.2.  Multi-Segment Line Objects")
# (find-esrpicorigtext "5.3.  Spline Objects")
# (find-esrpicorigtext "6.  Decorating Objects")
# (find-esrpicorigtext "6.1.  Text Special Effects")
# (find-esrpicorigtext "6.2.  Dashed Objects")
# (find-esrpicorigtext "6.3.  Dotted Objects")
# (find-esrpicorigtext "6.4.  Rounding Box Corners")
# (find-esrpicorigtext "6.5.  Slanted Boxes")
# (find-esrpicorigtext "6.6.  Arrowheads")
# (find-esrpicorigtext "6.7.  Line Thickness")
# (find-esrpicorigtext "6.8.  Invisible Objects")
# (find-esrpicorigtext "6.9.  Filled Objects")
# (find-esrpicorigtext "6.10.  Colored Objects")
# (find-esrpicorigtext "7.  More About Text Placement")
# (find-esrpicorigtext "8.  More About Direction Changes")
# (find-esrpicorigtext "9.  Naming Objects")
# (find-esrpicorigtext "9.1.  Naming Objects By Order Of Drawing")
# (find-esrpicorigtext "9.2.  Naming Objects With Labels")
# (find-esrpicorigtext "10.  Describing locations")
# (find-esrpicorigtext "10.1.  Absolute Coordinates")
# (find-esrpicorigtext "10.2.  Locations Relative to Objects")
# (find-esrpicorigtext "10.2.1.  Locations Relative to Closed Objects")
# (find-esrpicorigtext "10.2.2.  Locations Relative to Open Objects")
# (find-esrpicorigtext "10.3.  Ways of Composing Positions")
# (find-esrpicorigtext "10.3.1.  Vector Sums and Displacements")
# (find-esrpicorigtext "10.3.2.  Interpolation Between Positions")
# (find-esrpicorigtext "10.3.3.  Projections of Points")
# (find-esrpicorigtext "10.4.  Using Locations")
# (find-esrpicorigtext "10.5.  The `chop' Modifier")
# (find-esrpicorigtext "11.  Object Groups")
# (find-esrpicorigtext "11.1.  Brace Grouping")
# (find-esrpicorigtext "11.2.  Block Composites")
# (find-esrpicorigtext "12.  Style Variables")
# (find-esrpicorigtext "13.  Expressions, Variables, and Assignment")
# (find-esrpicorigtext "14.  Macros")
# (find-esrpicorigtext "15.  Import/Export Commands")
# (find-esrpicorigtext "15.1.  File and Table Insertion")
# (find-esrpicorigtext "15.2.  Debug Messages")
# (find-esrpicorigtext "15.3.  Escape to Post-Processor")
# (find-esrpicorigtext "15.4.  Executing Shell Commands")
# (find-esrpicorigtext "16.  Control-flow constructs")
# (find-esrpicorigtext "17.  Interface To [gt]roff")
# (find-esrpicorigtext "17.1.  Scaling Arguments")
# (find-esrpicorigtext "17.2.  How Scaling is Handled")
# (find-esrpicorigtext "17.3.  PIC and [gt]roff commands")
# (find-esrpicorigtext "17.4.  PIC and EQN")
# (find-esrpicorigtext "17.5.  Absolute Positioning of Pictures")
# (find-esrpicorigtext "18.  Interface to TeX")
# (find-esrpicorigtext "19.  Obsolete Commands")
# (find-esrpicorigtext "20.  Some Larger Examples")
# (find-esrpicorigtext "21.  PIC Reference")
# (find-esrpicorigtext "21.1.  Lexical Items")
# (find-esrpicorigtext "21.2.  Semi-Formal Grammar")
# (find-esrpicorigtext "22.  History and Acknowledgements")
# (find-esrpicorigtext "23.  Bibliography")

;; 1.  Introduction to PIC
;; 1.1.  Why PIC?
;; 1.2.  PIC Versions
;; 2.  Invoking PIC
;; 2.1.  PIC Error Messages
;; 3.  Basic PIC Concepts
;; 4.  Sizes and Spacing
;; 4.1.  Default Sizes of Objects
;; 4.2.  Objects Do Not Stretch!
;; 4.3.  Resizing Boxes
;; 4.4.  Resizing Other Object Types
;; 4.5.  The `same' Keyword
;; 5.  Generalized Lines and Splines
;; 5.1.  Diagonal Lines
;; 5.2.  Multi-Segment Line Objects
;; 5.3.  Spline Objects
;; 6.  Decorating Objects
;; 6.1.  Text Special Effects
;; 6.2.  Dashed Objects
;; 6.3.  Dotted Objects
;; 6.4.  Rounding Box Corners
;; 6.5.  Slanted Boxes
;; 6.6.  Arrowheads
;; 6.7.  Line Thickness
;; 6.8.  Invisible Objects
;; 6.9.  Filled Objects
;; 6.10.  Colored Objects
;; 7.  More About Text Placement
;; 8.  More About Direction Changes
;; 9.  Naming Objects
;; 9.1.  Naming Objects By Order Of Drawing
;; 9.2.  Naming Objects With Labels
;; 10.  Describing locations
;; 10.1.  Absolute Coordinates
;; 10.2.  Locations Relative to Objects
;; 10.2.1.  Locations Relative to Closed Objects
;; 10.2.2.  Locations Relative to Open Objects
;; 10.3.  Ways of Composing Positions
;; 10.3.1.  Vector Sums and Displacements
;; 10.3.2.  Interpolation Between Positions
;; 10.3.3.  Projections of Points
;; 10.4.  Using Locations
;; 10.5.  The `chop' Modifier
;; 11.  Object Groups
;; 11.1.  Brace Grouping
;; 11.2.  Block Composites
;; 12.  Style Variables
;; 13.  Expressions, Variables, and Assignment
;; 14.  Macros
;; 15.  Import/Export Commands
;; 15.1.  File and Table Insertion
;; 15.2.  Debug Messages
;; 15.3.  Escape to Post-Processor
;; 15.4.  Executing Shell Commands
;; 16.  Control-flow constructs
;; 17.  Interface To [gt]roff
;; 17.1.  Scaling Arguments
;; 17.2.  How Scaling is Handled
;; 17.3.  PIC and [gt]roff commands
;; 17.4.  PIC and EQN
;; 17.5.  Absolute Positioning of Pictures
;; 18.  Interface to TeX
;; 19.  Obsolete Commands
;; 20.  Some Larger Examples
;; 21.  PIC Reference
;; 21.1.  Lexical Items
;; 21.2.  Semi-Formal Grammar
;; 22.  History and Acknowledgements
;; 23.  Bibliography





#####
#
# Chem
# 2011nov17
#
#####

# «chem»  (to ".chem")
# (find-status   "groff")
# (find-vldifile "groff.list")
# (find-udfile   "groff/")
# (find-man "1 chem")
# (find-sh "chem -h")
# (find-fline "/usr/bin/chem")
# (find-fline "/usr/share/groff/1.20.1/pic/")
# (find-fline "/usr/share/groff/1.20.1/pic/chem.pic")
# (find-udfile "groff-base/examples/")
# (find-udfile "groff-base/examples/chem/")
# (find-udfile "groff-base/examples/chem/README/")
# (find-udfile "groff-base/examples/chem/lsd.chem")
# (find-udfile "groff-base/examples/chem/122/")
# (find-udfile "groff-base/examples/chem/122/README")
# http://cm.bell-labs.com/cm/cs/cstr/122.ps.gz

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/chem/
mkdir  /tmp/chem/
cd     /tmp/chem/
cp -v /usr/share/doc/groff-base/examples/chem/lsd.chem /tmp/chem/
chem lsd.chem > lsd.pic
gpic -t      lsd.pic > lsd.ptex
gpic         lsd.pic > lsd.roff
groff -T dvi lsd.roff > lsd.dvi
xdvi /tmp/chem/lsd.dvi

# (find-man "1 groff" "  -T dev")
# (find-man "1 gpic")
# (find-fline "/tmp/chem/")
# (find-fline "/tmp/chem/lsd.chem")
# (find-fline "/tmp/chem/lsd.pic")
# (find-fline "/tmp/chem/lsd.ptex" ".de PS")
# (find-fline "/tmp/chem/lsd.roff")




#####
#
# gpic
# 2007may19
#
#####

# «gpic»  (to ".gpic")
# (find-angg ".emacs" "esrpic")
# (find-es "tex" "pic_manual")
# (find-es "ps" "pstotext")
# (find-man "1 gpic")
# (find-man "1 gpic" "TeX mode\n")
# (find-man "1 groff")
# (find-man "1 groff" "-p" "Preprocess with pic.")
# (find-man "1 groff" "-e" "Preprocess with eqn.")
# (find-man "1 groff" "-t" "Preprocess with tbl.")
# (find-man "5 groff_out")
# (find-node "(groff)Top")
# (find-node "(groff)Comments")

# (find-udfile "groff-base/")
# (find-udfile "groff-base/pic.ms.gz")
# (find-udfile "groff-base/pic.ps.gz")
# (find-udfile "groff-base/pic.txt.gz")
# (find-sh "zcat /usr/share/doc/groff-base/pic.txt.gz | col -b")
# (find-pspage "/usr/share/doc/groff-base/pic.ps.gz")
# (code-ps "esrpic" "/usr/share/doc/groff-base/pic.ps.gz")
# (find-esrpicpage 1)
# (find-esrpicpage 12 "9. Naming Objects")
# (find-esrpicpage 21 "14. Macros")
# (find-esrpicpage 26 "18. Interface to TeX")

# (find-sh "zcat /usr/share/doc/groff-base/pic.ms.gz | groff -p -e -t")
# (find-sh "zcat /usr/share/doc/groff-base/pic.ms.gz | groff")
# (find-udfile "groff-base/pic.ms.gz")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/pic/
mkdir  /tmp/pic/
cd     /tmp/pic/
cat >  /tmp/pic/1.ptex <<'---'
.PS
box; box wid 1 ht 1; box same; box
# Comment
.PE
.PS
figname = foobar;
box
.PE
---
gpic -t 1.ptex > 1.tex
# (find-fline "/tmp/pic/1.ptex")
# (find-fline "/tmp/pic/1.tex")

# (find-man "gpic" "TeX mode\n")
cat >  /tmp/pic/2.tex <<'---'
\input 1.tex
\centerline{\box\graph}
\centerline{\box\foobar}
\bye
---
cd     /tmp/pic/
tex 2.tex

# (find-dvipage "/tmp/pic/2.dvi")



# (find-man "col")




#####
#
# Conses
# 2011nov17
#
#####

# «conses»  (to ".conses")
# (find-esrpicpage 12 "9. Naming Objects")
# (find-esrpictext    "10.4.  Using Locations")
# (find-esrpicpage 21 "14. Macros")
# (find-esrpictext    "<attribute> ::=")
# (eepic-now "box; box rad 0.1")
# (eepic-now "A: box rad 0.1; line from A.n to A.s; line from A.c to A.r")










#  Local Variables:
#  coding:               utf-8-unix
#  End:
