#######
#
# E-scripts on planner (the package for Emacs)
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/planner.e>
#           or at <http://angg.twu.net/e/planner.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# http://sacha.free.net.ph/notebook/emacs/sacha-dev.tar.gz

#
rm -Rv ~/usrc/sacha-dev/
tar -C ~/usrc/ -xvzf $S/http/sacha.free.net.ph/notebook/emacs/sacha-dev.tar.gz
cd     ~/usrc/sacha-dev/emacs-wiki/
makeinfo emacs-wiki.texi
cd     ~/usrc/sacha-dev/planner/
makeinfo planner-el.texi

#
mkdir ~/info/
cd    ~/info/
ln -sf ../usrc/sacha-dev/planner/planner-el.info .
ln -sf ../usrc/sacha-dev/remember/remember-el.info .
ln -sf ../usrc/sacha-dev/emacs-wiki/emacs-wiki.info .

#
# (find-sachafile "")
# (find-plannerfile "")
# (find-plannerfile "planner.el" "+ Usage")

(progn (add-to-list 'load-path "~/usrc/sacha-dev/emacs-wiki/")
       (add-to-list 'load-path "~/usrc/sacha-dev/planner/")
       (add-to-list 'load-path "~/usrc/sacha-dev/remember/")
       (require 'planner))

(eesteps '(
  (setq planner-directory "~/tmp/Plans")
  (find-sh "rm -Rf ~/tmp/Plans/; mkdir  ~/tmp/Plans/")
  (planner-update-wiki-project)


planner-directory's value is "~/Plans"



# (find-plannernode "")
# (find-plannernode "Stable Version")
# (find-plannernode "Getting Started")
# (find-plannernode "Tasks")


<sachac> edrx: setq planner-directory =)
<sachac> edrx: Then (planner-update-wiki-project) after you set it.




# (eev "emacs-cvs $ES/planner.e &")



  [HLIST2 [J Planner:]
    [R http://sacha.free.net.ph/notebook/wiki/PlannerMode.php sachac's page]
    [R http://www.emacswiki.org/cgi-bin/wiki/PlannerMode main emacswiki page]
    [R http://www.plannerlove.com/pmwiki/pmwiki.php www.plannerlove.com]
  ]








#  Local Variables:
#  coding:               utf-8-unix
#  modes:                (fundamental-mode emacs-lisp-mode)
#  End:
