#######
#
# E-scripts on making installation CDs for potato
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/potatocds.e>
#           or at <http://angg.twu.net/e/potatocds.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.pseudo-image-kit»	(to "pseudo-image-kit")


# (code-c-d "hdebian" "$S/http/www.debian.org/")
# (code-c-d "hdebianla" "$S/http/www.debian.org/Lists-Archives/")


#####
#
# potato-i386-...-list (by rsync)
# 2000jun01
#
#####

# «potato-i386-...-list»

# (find-wwwdebw3 "Lists-Archives/debian-cd-0005/msg00026.html")

rm -Rv /tmp/rsync/
mkdir  /tmp/rsync/
cd     /tmp/rsync/
rsync "129.13.126.5::debian-cd/potato-i386*list" .


mkdir -p ~/POTATO/rsync/129.13.126.5/debian-cd/
cd       ~/POTATO/rsync/129.13.126.5/debian-cd/
cp -iv /tmp/rsync/* .

# (find-fline "~/POTATO/rsync/129.13.126.5/debian-cd/")
# (find-fline "~/POTATO/rsync/129.13.126.5/debian-cd/potato-i386-1.raw.list")

cd ~/POTATO/rsync/129.13.126.5/debian-cd/
egrep '\.deb$' potato-i386-1.raw.list \
  | cut -b2- \
  | tee ~/o
cd /big/potato/
ls $(<~/o) \
  |& tee ~/o2
perl -nle 'm/ls: (.*): No such file or directory/ && print $1' < ~/o2 \
  | tee ~/omissingdebs
grep -v 'No such file' ~/o2 \
  | tee ~/opresentdebs

# (find-fline "~/omissingdebs")
# (find-fline "~/opresentdebs")

grep -




# (find-fline "~/o")




#####
#
# Checking if the new /big/potato is good enough
# 2000jun03
#
#####

# (find-es "debian-net" "download-missing-potato-files")






#####
#
# Debian potato pseudo-image kit
# 2001jun23
#
#####

# «pseudo-image-kit»  (to ".pseudo-image-kit")
# (find-shttpw3 "cdimage.debian.org/ch3111.html")
# (find-shttpw3 "cdimage.debian.org/~costar/pseudo-image-kit/")
#
rm -Rv /usr/src/pseudo-image-kit-2.0/
cd /usr/src/
tar -xvzf $S/http/cdimage.debian.org/~costar/pseudo-image-kit/pseudo-image-kit-2.0.tar.gz
cd /usr/src/pseudo-image-kit-2.0/

#
# (code-c-d "pik" "/usr/src/pseudo-image-kit-2.0/")
# (find-pikfile "")
# (find-pikfile "README")
# (find-pikfile "README" "binary-i386-1.list")
# (find-shttpw3 "www.uk.debian.org/debian-cd/cd-images/")
# (find-shttpw3 "www.uk.debian.org/debian-cd/cd-images/2.2_rev3/i386/")
# (find-shttpw3 "www.uk.debian.org/debian-cd/cd-images/2.2_rev3/source/")

# There is a binary in the file, "isoinfo", that probably comes from
# mkisofs:
# (find-vldifile "mkisofs.list")

http://www.uk.debian.org/debian-cd/cd-images/
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/i386/
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/i386/binary-i386-1.list
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/i386/binary-i386-2.list
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/i386/binary-i386-3.list
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/i386/binary-i386-1_NONUS.list
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/source/source-1.list
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/source/source-2.list
http://www.uk.debian.org/debian-cd/cd-images/2.2_rev3/source/source-3.list
http://www.uk.debian.org/debian-cd/cd-images/potato_test/i386/potato-i386-1.list









# (find-node "(w3)Action")
# (w3-fetch "http://www.debian.org/")




#####
#
# Debian-cd
# 2000may30
#
#####

# «debian-cd»

# $POTATO/$CI386/admin/debian-cd_2.1.92.deb
apti debian-cd

# (find-status "debian-cd")
# (find-vldifile "debian-cd.list")
# (find-fline "/usr/doc/debian-cd/")

# (find-fline "/usr/share/debian-cd/tools/boot/potato/boot-i386")
# (find-fline "/usr/share/debian-cd/tools/potato/")
# (find-fline "/usr/share/debian-cd/tools/")
# (find-fline "/usr/share/debian-cd/tasks/")
# (find-fline "/usr/share/debian-cd/tasks/slink/i386/")
# (find-fline "/usr/share/debian-cd/data/")
# (find-fline "/usr/share/debian-cd/")

# (find-fline "/usr/doc/debian-cd/README.gz")
# (find-fline "/usr/doc/debian-cd/README.gz" "Pseudo Image Kit")
# (find-fline "/usr/doc/debian-cd/README.gz" "exported environment variables")
# (find-fline "/etc/debian-cd/conf.sh" "export MIRROR=/home/ftp/debian")

grep export /etc/debian-cd/conf.sh

agrep scanpacka $(</var/lib/dpkg/info/debian-cd.list)
agrep scanpacka $(</var/lib/dpkg/info/debian-cd.list)
agrep scanpacka $(</var/lib/dpkg/info/debian-cd.list)

# (find-fline "/usr/share/debian-cd/tools/scanpackages" '* 1 "scanpackages")
# (find-fline "/usr/share/debian-cd/Makefile" '* 1 "scanpackages")
# (find-fline "/usr/share/debian-cd/Makefile" '* 3 "scanpackages")
# (find-fline "/usr/share/debian-cd/Makefile" '* 4 "scanpackages")
# (find-fline "/usr/share/debian-cd/README" '* 1 "scanpackages")
# (find-fline "/usr/share/debian-cd/README" '* 2 "scanpackages")












# (find-hdebianlaw3 "debian-cd-0005/msg00065.html")
# (find-hdebianlaw3 "debian-cd-0005/msg00114.html")

psne http://panic.et.tudelft.nl/~costar/potato/.cd_readme_temp/README.txt






#  Local Variables:
#  coding:               utf-8-unix
#  End:
