#######
#
# E-scripts on prolog.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/prolog.e>
#           or at <http://angg.twu.net/e/prolog.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.prolog-mode»	(to "prolog-mode")
# «.egglog»	(to "egglog")


# (find-status   "swi-prolog")
# (find-vldifile "swi-prolog.list")
# (find-udfile   "swi-prolog/")
# (find-status   "swi-prolog-core")
# (find-vldifile "swi-prolog-core.list")
# (find-udfile   "swi-prolog-core/")
# (find-status   "swi-prolog-core-packages")
# (find-vldifile "swi-prolog-core-packages.list")
# (find-udfile   "swi-prolog-core-packages/")
# (find-status   "swi-prolog-doc")
# (find-vldifile "swi-prolog-doc.list")
# (find-udfile   "swi-prolog-doc/")
# (find-status   "swi-prolog-nox")
# (find-vldifile "swi-prolog-nox.list")
# (find-udfile   "swi-prolog-nox/")
# (find-status   "swi-prolog-x")
# (find-vldifile "swi-prolog-x.list")
# (find-udfile   "swi-prolog-x/")

# (find-efunctiondescr 'prolog-mode)
# (find-efunction      'prolog-mode)



#####
#
# prolog-mode
# 2021dec04
#
#####

# «prolog-mode»  (to ".prolog-mode")
# (find-efile "progmodes/prolog.el" "(setq auto-mode-alist")

(setq prolog-system 'swi)
(add-to-alist 'auto-mode-alist '("\\.pl\\'" . prolog-mode))

# (find-fline "/usr/lib/swi-prolog/customize/README.md")
# (find-fline "/usr/lib/swi-prolog/demo/README.md")
# (find-fline "/usr/lib/swi-prolog/demo/likes.pl")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
swipl -l likes.pl
help.
likes(sam,dahl).
b
likes(sam,chop_suey).
likes(sam,pizza).
likes(sam,chips).
likes(sam,curry).



# (find-man "swipl")
# (find-man "1 swipl")
# (find-man "1 swipl" "-s file")
# (find-man "1 swipl" "-l file")

# (find-fline "/tmp/likes.pl")





apti swi-prolog swi-prolog-doc


prolog programming for artificial intelligence - ivan bratko

# (find-zsh "installeddebs | sort | grep prolog")
# (find-zsh "availabledebs | sort | grep prolog")

swi-prolog-doc_5.6.59-2.deb
swi-prolog-java_7.2.3+dfsg-6.deb
swi-prolog-nox_7.2.3+dfsg-6.deb
swi-prolog-odbc_7.2.3+dfsg-6.deb
swi-prolog-x_7.2.3+dfsg-6.deb
swi-prolog_7.2.3+dfsg-6.deb

https://www.swi-prolog.org


Which books would you recommend to one learning prolog and interested in some logic base topics?

Check the SWI-Prolog website reference section for a good assortment of literature on the topic

http://dstrohmaier.com/sudoku-prolog/



#####
#
# Egglog - A prolog like syntax for egg
# 2021aug20
#
#####

# «egglog»  (to ".egglog")
https://www.philipzucker.com/egglog/?example=pb_compose.pl
https://github.com/philzook58/egglog
https://www.philipzucker.com/egglog-checkpoint/
https://www.philipzucker.com/egglog2-monic/
https://egraphs-good.github.io/

https://news.ycombinator.com/item?id=29652995 Introduction to Modern Prolog (github.com/triska)
https://news.ycombinator.com/item?id=34164221 Prolog at Work (reddit.com)
https://news.ycombinator.com/item?id=34224456 Solving a Dungeons and Dragons riddle using Prolog (gist.github.com)
https://news.ycombinator.com/item?id=34287270 PHP: Prolog Home Page (php.energy)

https://news.ycombinator.com/item?id=34427081 Tar.pl – A tar creator and extractor in ~130 lines of Prolog (github.com/superdisk) 
https://github.com/SuperDisk/tar.pl
https://www2.eecs.berkeley.edu/Pubs/TechRpts/1990/CSD-90-600.pdf

https://www.softwarepreservation.org/projects/prolog/





#  Local Variables:
#  coding:               utf-8-unix
#  ee-anchor-format:     "«%s»"
#  End:
