#######
#
# E-scripts on Racket.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/racket.e>
#           or at <http://angg.twu.net/e/racket.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.debian»		(to "debian")
# «.racket-git»		(to "racket-git")
# «.racket-mode»	(to "racket-mode")
# «.racket-repl»	(to "racket-repl")
# «.scribble-mode»	(to "scribble-mode")
# «.sicp-pict»		(to "sicp-pict")
# «.raco»		(to "raco")
# «.plot»		(to "plot")
# «.geiser»		(to "geiser")



https://en.wikipedia.org/wiki/Racket_(programming_language)
https://racket-lang.org/



#####
#
# debian
# 2022nov30
#
#####

# «debian»  (to ".debian")
# (find-zsh "installeddebs | sort | grep racket")
# (find-zsh "availabledebs | sort | grep racket")
# (find-status   "racket-doc")
# (find-vldifile "racket-doc.list")
# (find-udfile   "racket-doc/")
# (find-status   "racket-common")
# (find-vldifile "racket-common.list")
# (find-udfile   "racket-common/")
# (find-status   "racket")
# (find-vldifile "racket.list")
# (find-udfile   "racket/")
# (find-udfile   "racket/quick/")
# (find-udfile   "racket/quick/quick.scrbl")
# (find-udfile   "racket/quick/quick.scrbl" "scribblings/more")
# (find-udfile   "racket/algol60/")

file:///usr/share/doc/racket/index.html
file:///usr/share/doc/racket/quick/index.html
file:///usr/share/doc/racket/getting-started/index.html
file:///usr/share/doc/racket/racket-cheat/index.html
file:///usr/share/doc/racket/guide/index.html



#####
#
# Racket from git
# 2022nov30
#
#####

# «racket-git»  (to ".racket-git")
# (find-git-links "https://github.com/racket/racket.git" "racketgit")
# (code-c-d "racketgit" "~/usrc/racket/")
# (find-racketgitfile "")
# (find-racketgitsh "find * | sort")
# (find-racketgitfile "pkgs/racket-doc/ffi/examples/")





#####
#
# racket-mode
# 2022nov30
#
#####

# «racket-mode»  (to ".racket-mode")
# (find-angg ".emacs" "racket")

# (find-epackage-links 'racket-mode "racketmode" t)
# (find-epackage       'racket-mode)
# (code-c-d "racketmode" "~/.emacs.d/elpa/racket-mode-1.0.20221130.125641/" "racket-mode")
# (find-racketmodefile "")
# (find-racketmodenode "")
# (find-racketmodenode "Edit buffers and REPL buffers")




#####
#
# racket-repl
# 2022nov30
#
#####

# «racket-repl»  (to ".racket-repl")

# (find-eapropos "racket-repl")
# (find-efunctiondescr 'racket-repl-mode)
# (find-efunction      'racket-repl-mode)
# (find-efunctiondescr 'racket-repl)
# (find-efunction      'racket-repl)
# (find-efunctiondescr 'with-racket-repl-buffer)
# (find-efunction      'with-racket-repl-buffer)
# (find-racketmodenode "racket-run-module-at-point" "C-c C-c")


(defun eepitch-racketrepl () (interactive) (eepitch '(find-dbsw-call '(racket-repl))))

 (eepitch-racketrepl)
 (eepitch-kill)
 (eepitch-racketrepl)



#####
#
# scribble-mode
# 2022nov30
#
#####

# «scribble-mode»  (to ".scribble-mode")
# (find-epackage-links 'scribble-mode "scribblemode" t)
# (find-epackage       'scribble-mode)
# (code-c-d "scribblemode" "~/.emacs.d/elpa/scribble-mode-20190912.200/")
# (find-scribblemodefile "")

https://news.ycombinator.com/item?id=32865098 Scribble: The Racket Documentation Tool (racket-lang.org)

# (find-racketgitfile "pkgs/racket-doc/syntax/scribblings/")




#####
#
# sicp-pict
# 2022nov30
#
#####

# «sicp-pict»  (to ".sicp-pict")
# https://docs.racket-lang.org/sicp-manual/SICP_Picture_Language.html
# https://github.com/sicp-lang/sicp/blob/master/sicp-pict/main.rkt

 (eepitch-racket)
 (eepitch-kill)
 (eepitch-racket)
#lang racket
(require sicp-pict)
(paint (number->painter 0))
(paint diagonal-shading)
(paint (below (beside diagonal-shading
              (rotate90 diagonal-shading))
       (beside (rotate270 diagonal-shading)
               (rotate180 diagonal-shading))))
(paint einstein)


# file:///usr/share/doc/racket/index.html
# file:///usr/share/doc/racket/pkg/getting-started.html#%28part._installing-packages%29


https://docs.racket-lang.org/sicp-manual/index.html
https://docs.racket-lang.org/sicp-manual/Installation.html

Resolving "sicp" via https://download.racket-lang.org/releases/7.9/catalog/
Resolving "sicp" via https://pkgs.racket-lang.org
Downloading repository https://github.com/sicp-lang/sicp.git
raco setup: version: 7.9
raco setup: platform: x86_64-linux [3m]
raco setup: target machine: racket
raco setup: installation name: 7.9
raco setup: variants: 3m
raco setup: main collects: /usr/share/racket/collects
raco setup: collects paths: 
raco setup:   /home/edrx/.local/share/racket/7.9/collects
raco setup:   /usr/share/racket/collects
raco setup: main pkgs: /usr/share/racket/pkgs
raco setup: pkgs paths: 
raco setup:   /usr/share/racket/pkgs
raco setup:   /home/edrx/.local/share/racket/7.9/pkgs
raco setup: links files: 
raco setup:   /usr/share/racket/links.rktd
raco setup:   /home/edrx/.local/share/racket/7.9/links.rktd
raco setup: main docs: /usr/share/doc/racket
raco setup: --- updating info-domain tables ---                    [22:24:37]
raco setup: updating: /home/edrx/.local/share/racket/7.9/share/info-cache.rktd
raco setup: --- pre-installing collections ---                     [22:24:37]
raco setup: --- installing foreign libraries ---                   [22:24:37]
raco setup: --- installing shared files ---                        [22:24:37]
raco setup: --- compiling collections ---                          [22:24:37]
raco setup: --- parallel build using 2 jobs ---                    [22:24:37]
raco setup: 1 making: <pkgs>/sicp/sicp
raco setup: 1 making: <pkgs>/sicp/sicp/lang
raco setup: 0 making: <pkgs>/sicp/sicp-doc
raco setup: 1 making: <pkgs>/sicp/sicp/test
raco setup: 1 making: <pkgs>/sicp/sicp-pict
raco setup: 1 making: <pkgs>/sicp/sicp-pict/test
raco setup: --- creating launchers ---                             [22:24:44]
raco setup: --- installing man pages ---                           [22:24:44]
raco setup: --- building documentation ---                         [22:24:44]
raco setup: 0 running: <pkgs>/racket-index/scribblings/main/user/local-redirect.scrbl
raco setup: 1 running: <pkgs>/racket-index/scribblings/main/user/release.scrbl
raco setup: 0 running: <pkgs>/racket-index/scribblings/main/user/search.scrbl
raco setup: 0 running: <pkgs>/sicp/sicp-doc/sicp-manual.scrbl
raco setup: 1 running: <pkgs>/racket-index/scribblings/main/user/start.scrbl
raco setup: 1 rendering: <pkgs>/racket-index/scribblings/main/user/local-redirect.scrbl
raco setup: 0 rendering: <pkgs>/racket-index/scribblings/main/user/release.scrbl
raco setup: 1 rendering: <pkgs>/racket-index/scribblings/main/user/search.scrbl
raco setup: 1 rendering: <pkgs>/sicp/sicp-doc/sicp-manual.scrbl
raco setup: 0 rendering: <pkgs>/racket-index/scribblings/main/user/start.scrbl
raco setup: --- installing collections ---                         [22:25:10]
raco setup: --- post-installing collections ---                    [22:25:10]

https://stackoverflow.com/questions/39886804/how-to-run-picture-language-examples-of-sicp-scheme-in-repl




#####
#
# raco
# 2022nov30
#
#####

# «raco»  (to ".raco")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
raco pkg install sicp
raco help
raco docs
# (find-man "raco")

# (find-racketlocalfile "")
# (find-racketlocalsh "find *")
# (find-racketlocalsh "find * | sort")
# (find-racketlocalfile "pkgs/sicp/")
# (find-racketlocalfile "pkgs/sicp/sicp/")
# (find-racketlocalfile "pkgs/sicp/sicp-doc/")
# (find-racketlocalfile "pkgs/sicp/sicp-doc/doc/sicp-manual/")
# (find-racketlocalfile "pkgs/sicp/sicp-pict/")
# (find-racketlocalfile "pkgs/sicp/sicp-pict/main.rkt")




#####
#
# plot
# 2022dec15
#
#####

# «plot»  (to ".plot")
# https://docs.racket-lang.org/plot/index.html
# https://mail.google.com/mail/u/0/#inbox/FMfcgzGrbbwXRVpmRSzgGWTDVhkpzklh



#####
#
# geiser
# 2022dec29
#
#####

# «geiser»  (to ".geiser")

# (find-epackages)
geiser
# (find-epackages 'geiser)
# (find-epackage-links 'geiser)
# (find-epackage-links 'geiser-racket)
# (find-epackage 'geiser)

# (find-epackage-links 'geiser "geiser" t)
# (find-epackage       'geiser)
# (code-c-d "geiser" "~/.emacs.d/elpa/geiser-20221225.2214/")
# (find-geiserfile "")

# (find-epackage-links 'geiser-racket "geiserracket" t)
# (find-epackage       'geiser-racket)
# (code-c-d "geiserracket" "~/.emacs.d/elpa/geiser-racket-20210421.125/")
# (find-geiserracketfile "")


(require 2htdp/image)
# (find-efunction 'geiser-repl-mode)


(save-window-excursion (geiser 'racket))





(defun find-racketrepl () (interactive)

  (find-wottb-call "\\`\\*Racket REPL" bufname &rest pos-spec-list)

;; (find-eev "eev-blinks.el" "find-wottb")


(racket-repl-buffer-name)



(find-dbsw-call '(racket-repl))


# (find-node "(racket-mode)Top")


# (find-fline "~/LOGS/2022nov30.racket" "geiser-repl-import-module")












# (find-es "scheme" "racket")
# https://racket-lang.org/

https://news.ycombinator.com/item?id=32478808 Certifying Interpreters in Racket (kmicinski.com)
https://kmicinski.com/certifying-interpreters - racket 



https://docs.racket-lang.org/draw/index.html


# (find-sh "locate racket/doc/quick")



(code-c-d "racketlocal" "~/.local/share/racket/7.9/")
# (find-racketlocalfile "")
# (find-racketlocalsh "find * | sort")
# (find-racketlocalfile "pkgs/sicp/sicp-pict/")

https://github.com/avelino/awesome-racket
https://github.com/jackfirth/lens
https://github.com/jeapostrophe/pict3d

https://docs.racket-lang.org/teachpack/2htdpimage-guide.html

# (find-sh "locate 2htdp")

# https://www.nongnu.org/geiser/
# https://www.reddit.com/r/emacs/comments/7zc1so/scheme_geiser_and_emacs/

https://soegaard.github.io/blog/metapict/
https://soegaard.github.io/blog/2013/06/27/drawing-bezier-curves/
https://soegaard.github.io/blog/2013/06/21/summer-project-meta-font-post-in-racket/
https://nullprogram.com/blog/2023/01/18/ u-config: a new, lean pkg-config clone

https://easylang.online/
https://easylang.online/easyprogramming/
https://rdivyanshu.github.io/hat.html
https://news.ycombinator.com/item?id=37621151 Drawing hat tiling using Racket (rdivyanshu.github.io)
https://gist.github.com/vindarel/c1ef5e043773921e3b11d8f4fe1ca7ac Common Lisp VS Racket - testimonies.md








#  Local Variables:
#  coding:               utf-8-unix
#  End:

