#######
#
# E-scripts on rcd (by Jean Louis).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/rcd.e>
#           or at <http://angg.twu.net/e/rcd.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.rcd-button-insert»	(to "rcd-button-insert")
# «.triplets-jan2023»	(to "triplets-jan2023")



# (find-es "postgres" "emacs-libpq")
# (find-telegachat "1873588412#228758"  "accounts.sql")
# (find-fline "~/.telega/cache/documents/accounts.sql")
# (find-TH "2024-rcd")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
                       dropdb     -e rcdnotes
                       dropdb     -e smith
sudo sudo -u postgres  dropuser   -e            $USER
sudo sudo -u postgres  createuser -e --createdb $USER
                       createdb   -e smith
                       createdb   -e rcdnotes

psql rcdnotes < /tmp/accounts.sql

psql rcdnotes
DROP TABLE accounts;
\q

(code-video "{c}video" "/tmp/2024-02-11-11_12_53.ogv")
;; (find-{c}video)
;; (find-{c}video "0:00")







#####
#
# rcd-button-insert
# 2023jan01
#
#####

# «rcd-button-insert»  (to ".rcd-button-insert")
# (find-es "emacs" "buttons")
# (find-es "emacs" "insert-text-button")

# https://gnu.support/files/emacs/packages/rcd-utilities.el
# (code-c-d "rcdep" "$S/https/gnu.support/files/emacs/packages/")
# (find-rcdepfile "")
# (find-rcdepfile "rcd-utilities.el" "(defun rcd-button-insert")

(add-to-list 'load-path (ee-expand "$S/https/gnu.support/files/emacs/packages/"))
(require 'rcd-utilities)

(rcd-button-insert "Hello" (lambda (_) (message-box "Hello")) nil nil "⟦ (hyperscope 123) ⟧")Hello


(insert-text-button
 button-text
 'action action-function
 'follow-link t
 revert-key revert-value)



https://lists.gnu.org/archive/html/help-gnu-emacs/2023-01/msg00128.html rcd-dired-for-file



# https://gnu.support/images/eev/2023/01/2023-01-01/2023-01-01-21:44:16.ogv
# (code-video "jlbtnvideo" "$S/https/gnu.support/images/eev/2023/01/2023-01-01/2023-01-01-21:44:16.ogv")
# (find-jlbtnvideo "0:00")

# (find-telegachat "@rcdrun#209922" "dictionary")
# https://gnu.support/images/emacs/dictionary/2023-01-01-21:48:58.ogv
# (code-video "jldictvideo" "$S/https/gnu.support/images/emacs/dictionary/2023-01-01-21:48:58.ogv")
# (find-jldictvideo "0:00")

# (find-telegachat "@rcdrun#209966" "--header-left")

# https://gnu.support/files/emacs/packages/rcd-org-export/2022-12-19-23:36:10.ogv
# (code-video "orgexportvideo" "$S/https/gnu.support/files/emacs/packages/rcd-org-export/2022-12-19-23:36:10.ogv")
# (find-orgexportvideo "0:00")



#####
#
# triplets-jan2023
# 2023jan21
#
#####

# «triplets-jan2023»  (to ".triplets-jan2023")
# Re: Programming Emacs visually with semantic triplets
# https://lists.gnu.org/archive/html/help-gnu-emacs/2023-01/msg00415.html




https://hyperscope.link/3/7/1/3/3/RCD-Template-Interpolation-System-for-Emacs.html
https://hyperscope.link/3/7/1/4/9/Comparison-of-rcd-template-eval-with-eev-template0-el-37149.html


https://lists.gnu.org/archive/html/emacs-orgmode/2023-01/msg00845.html Should Org provide commonly used link types?
hyperscope-capture-mpv-playback-position





#  Local Variables:
#  coding:               utf-8-unix
#  End:
