#######
#
# E-scripts on rebol.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/rebol.e>
#           or at <http://angg.twu.net/e/rebol.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# http://web.archive.org/web/20110705115848/http://www.rebol.com/faq.html#033
# https://twitter.com/#!/korsch/status/196549574075224065/photo/1
# http://web.archive.org/web/20110705113044/http://www.rebol.com/downloads/v278/rebol-view-278-4-2.tar.gz
# (find-fline "~/tmp/rebol-view-278-4-2.tar.gz")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/rebol/
mkdir  ~/usrc/rebol/
cd     ~/usrc/rebol/
tar -xvzf ~/tmp/rebol-view-278-4-2.tar.gz
mv -iv ~/usrc/rebol/releases/rebol-view/* .

rebol -v
[ 1 2 ]

# http://www.rebol.com/
# http://www.rebol.com/tools/
# http://www.rebol.com/tools/rebol.el
# http://www.rebol.com/docs/reference.html
# http://www.rebol.com/article/0508.html




(defun eepitch-rebol () (interactive) (eepitch-comint "rebol" "~/usrc/rebol/rebol -v"))

 (eepitch-rebol)
 (eepitch-kill)
 (eepitch-rebol)
[1 2 3 4]
[1 a 3 (1 + 3)]
compose [1 a 3 (1 + 3)]
reduce [1 + (2 + 4)]


# http://www.youtube.com/watch?v=IAy9tBHiLJo&feature=player_embedded#!
# http://www.youtube.com/watch?v=IAy9tBHiLJo

# (find-youtubedl-links "/sda5/videos/" "REBOL_VID_demonstration_-_Nenad_Rakocevic" "IAy9tBHiLJo" ".flv" "rebolrak")
# (code-mplayer "rebolrakvideo" "/sda5/videos/REBOL_VID_demonstration_-_Nenad_Rakocevic-IAy9tBHiLJo.flv")
# (find-rebolrakvideo)



(require 'rebol)
(add-to-list 'auto-mode-alist '("\\.r$" . rebol-mode))

(defvar rebol-command-args)
(setq rebol-command-args ())

(defvar rebol-interactive-program "rebol")
(setq rebol-interactive-program "rebol")

(defun rebol-ensure-process ()
  (or (get-process "rebol")
      (let ((b (apply 'make-comint "rebol"
                      rebol-interactive-program
              nil rebol-command-args)))
    (with-current-buffer b
      (make-local-variable 'comint-prompt-regexp)
      (setq comint-process-echoes t)
      (setq comint-prompt-regexp "^>> "))
        (get-process "rebol"))))

(defun run-rebol ()
  "Start the REBOL interpreter."
  (interactive)
  (switch-to-buffer-other-window (process-buffer (rebol-ensure-process))))

(defun rebol-eval-region (start end)
  "Send the supplied region to the REBOL interpreter (starting if necessary)."
  (interactive "r")
  (let* ((proc (rebol-ensure-process))
         (region (buffer-substring-no-properties start end)))
    (pop-to-buffer (process-buffer proc))
    (process-send-string "rebol" (concat region "\n"))))

(defun rebol-eval-buffer ()
  (interactive)
  (rebol-eval-region (point-min) (point-max)))

(defun rebol-do-file ()
  "Execute current REBOL file."
  (interactive)
  (let ((filename (buffer-file-name)))
    (if (not filename)
        (message "You'll need to save the file first.")
      (switch-to-buffer-other-window
       (make-comint (format "rebol-%s" (gensym)) "rebol" () filename)))))

(define-key rebol-mode-map "\C-c\C-r" 'rebol-eval-region)
(define-key rebol-mode-map "\C-c\C-l" 'rebol-eval-buffer)
(define-key rebol-mode-map "\C-c\C-s" 'run-rebol)
(define-key rebol-mode-map "\C-c\C-d" 'rebol-do-file)
(define-key rebol-mode-map (kbd "RET") 'newline-and-indent)



http://www.red-lang.org/
http://ll1.ai.mit.edu/marshall.html Tail recursion in REBOL





#  Local Variables:
#  coding:               utf-8-unix
#  End:

