#######
#
# E-scripts on ...
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/rest.e>
#           or at <http://angg.twu.net/e/rest.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




################
#
# Kernel 2.0.30
# 97dec26
#
################

rpm -iv /big/b42/SRPMS/kernel-2.0.30-2.src.rpm
cd /usr/src/
rm -R linux linux-2.0.30
tar -xvzf /usr/src/redhat/SOURCES/linux-2.0.30.tar.gz

cd /usr/src/
mv linux linux-2.0.30
ln -s linux-2.0.30 linux

cd /usr/src/linux-2.0.30/
cp -iv ~/2030apmg .config
make symlinks
bash scripts/Configure -d arch/i386/config.in		|& tee omc
# cp .config ~/2030apmg

make depend						|& tee omd

sleep 2
echo -n > .mkzImage-start
sleep 2

# Add -g to taste.
# (find-k2file "Makefile" 90)
#
make zImage	|& tee omz

sleep 2
echo -n > .mkmodules-start
sleep 2
#
make modules	|& tee omm

find * -name '*.[chS]' -and      -anewer .mkzImage-start > .files.chS.used
find * -name '*.[chS]' -and -not -anewer .mkzImage-start > .files.chS.unused
etags `cat .files.chS.used`
glimpseindex -H . -F < .files.chS.used 

BOOTDEST=/a3/boot/2030g
mkdir -p $BOOTDEST
cd $BOOTDEST
ln -s . cdrom
ln -s . misc
ln -s . net

cd /usr/src/linux-2.0.30/
cp .config arch/i386/boot/zImage System.map modules/* $BOOTDEST
lilo

# If -g,
cd /usr/src/linux-2.0.30/
echo 'quit' | gdb -m vmlinux /proc/kcore
# (find-etag "gdb")
# (gdb "gdb /usr/src/linux-2.0.30/vmlinux /proc/kcore")
# (find-node "(gdb)File Options" "`-m'")



#
# Patches:
# (I'm not using them anymore)
cd /usr/src/linux/drivers/char/
patch keyboard.c \
  /snarf/http/www.kabel.de/~hmueller/armada11xx/armada11xx_apm.patch

# I don't know how to handle the -C error that happens when sound
# is configured...

# At this point you should have a clean
# .config that can be copied back to a
# safe place.

# Talvez eu queira os mdulos sem debug info.

rdev zImage /dev/hda3
vidmode zImage 1
rootflags zImage 1






##########################
#
# doc: "The Linux Kernel"
#
##########################

cd /usr/src/
rm -Rv tlk
tar -xvzf /snarf/ftp/sunsite.unc.edu/pub/Linux/docs/linux-doc-project/linux-kernel/tlk-0.1-13-19.tar.gz
cd /usr/src/tlk/
make all |& tee oma
#
# precisa do fig2dev





##########
#
# Duel
#
#########

rpm -iv /big/rh41b/SRPMS/gdb-4.16-5.src.rpm
rpm -bp /usr/src/redhat/SPECS/gdb-4.16.spec
rm -v	/usr/src/redhat/SOURCES/binutils-2.7.0.2.tar.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16.tar.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16axp-2.diff.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16axp-3.diff.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16axp.patch.gz	\
	/usr/src/redhat/SOURCES/gdb-4.16sparc.patch.gz
cd /usr/src/redhat/BUILD/gdb-4.16/
cp -iv /home/root/config.cache .
./configure |& tee oc
cd /usr/src/redhat/BUILD/gdb-4.16/
make |& tee om

#
# Parte nova
#
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
mkdir duel/
cd duel/
tar -xvzf /snarf/ftp/ftp.cs.princeton.edu/pub/duel/duel-1.10.4.tar.gz
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/duel/src/
make |& tee om
#
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
ln -s duel/duelgdb.c duelgdb.c
cp main.c duel_main.c



# (find-fline "/usr/src/redhat/BUILD/gdb-4.16/duel/INSTALL" 150)

cd /usr/src/redhat/BUILD/gdb-4.16/

# (find-fline "/usr/src/redhat/BUILD/gdb-4.16/gdb/top.c" 1529)


mgolan@ibm.net

Michael Golan mgolan@ibm.net  or  talsoft@ibm.net  or mg@cs.princeton.edu

http://www.math.tau.ac.il/~frangy/duel_man.html




###########
#
# modules
#
###########


# rm -Rv /usr/src/modules-2.1.13
rm -Rv /usr/src/modutils-2.1.55
cd /usr/src/
tar -xvzf /snarf/http/www.kernel.org/pub/linux/kernel/v2.1/modules-2.1.13.src.tar.gz
tar -xvzf /snarf/http/www.kernel.org/pub/linux/kernel/v2.1/modutils-2.1.55.tar.gz





################
#
# xduel
#
###############

rpm -iv $RS/gdb-4.16-6.src.rpm
cd /usr/src/redhat/SPECS/
rpm -bc gdb-4.16.spec |& tee orbc-gdb

rpm -iv $RS/xxgdb-1.12-1.src.rpm
cd /usr/src/redhat/SPECS/
rpm -bc xxgdb-1.12.spec |& tee orbc-xxgdb

# (find-xdfile "INSTALL" 87)

# These patches must by applied (by hand):
#
# (find-xdfile "xduel_gdb_patch" 35)
# (find-gdbfile "gdb/Makefile" 186)
#
# (find-xdfile "xduel_gdb_patch" 52)
# (find-gdbfile "gdb/Makefile" 349)
#
# (find-xdfile "xduel_gdb_patch" 69)
# (find-gdbfile "gdb/Makefile" 474)

cd /usr/src/
rm -Rv xduel-2.14/
mkdir xduel-2.14/
cd xduel-2.14/
tar -xvZf /snarf/ftp/ftp.math.tau.ac.il/pub/amiram/xduel/xduel-2.14.tar.Z

cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
rm duel
rm duelgdb.c
ln -s /usr/src/xduel-2.14 duel
ln -s /usr/src/xduel-2.14/duelgdb.c .
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/duel/src/
make |& tee om
cd /usr/src/redhat/BUILD/gdb-4.16/gdb/duel/
etags *.[ch] src/*.[ch]

cd /usr/src/redhat/BUILD/gdb-4.16/gdb/
mv init.c init.c.0
make CFLAGS='-O2 -m486 -fno-strength-reduce' |& tee om2

# Problema 1: fazer o xduel no imprimir os drawing commands.
#
# (find-xdfile "src/Makefile" 14)
# (find-xdfile "src/xduel.c" 81)
# (find-xdtag "xdlbd_draw")
#
# Tenho que fazer os drawing commands no rodarem mas sem fazer com
# que o xduel chame os xdlbd_...'s.

# Problema 2: aparece por exemplo em
#
cd /usr/src/linux-2.0.30/
echo 'quit' | gdb -m vmlinux /proc/kcore
echo -e 'dl console_driver\nquit' | gdb vmlinux /proc/kcore
#
# (find-k2file "drivers/char/console.c" 121)
# e, p, long long ints so importantes e deveriam estar sendo aceitos:
# (find-xdtag "duel_fatal")
# (find-xdfile "duelgdb.c" 490)
# (find-xdfile "duelgdb.c" 391)







# gcc -c xduel.c -o xduel.o
# make |& tee om2

# (find-xdfile "INSTALL")
# (find-xdfile "src/Makefile")
# (find-xdfile "xduelins.pl")

# I don't apply the '#' patch, but I keep the references anyway:
#     (find-xdfile "INSTALL" 244)
#     (find-xdfile "MANUAL" 139)
#     (find-xdfile "xduel_gdb_patch" 16)
#     (find-gdbfile "gdb/top.c" 2078)
#     (find-gdbfile "gdb/top.c" 2167)

# But I'd like to disable the output lines that control drawing...
# (find-xdfile "src/xduel.c" 209)
# (find-node "(gcc)Preprocessor Options" 143)

# (find-xdtag "main")





#############
#
# glibc docs
#
#############

mkdir glibc-2.0.5
ln -s /usr/info glibc-2.0.5/manual
tar -xvzf /snarf/ftp/prep.ai.mit.edu/pub/gnu/glibc-2.0.5.tar.gz \
  'glibc-2.0.5/manual/libc.info*'
rm glibc-2.0.5/manual
rmdir glibc-2.0.5



###########
#
# Geomview
#
###########

(find-fline "/usr/src/Geomview/makefiles/mk.site.public")

cd /usr/src/
rm -Rv Geomview/
tar -xvzf /dl/geomview-1.5.0.src.tgz
cd /usr/src/Geomview/
make CPU=linux |& tee om
make CPU=linux install |& tee omi

# muita coisa d errado, e ele no cria o gvx



############
#
# grail 0.3
#
############

cd /usr/src/
rm -Rv grail-0.3/
tar -xvzf /snarf/http/monty.cnri.reston.va.us/grail-0.3/source/grail-0.3.tar.gz




###########
#
# TXL 7.4
#
###########

cd /usr/src/
rm -Rv TXL7.4/
tar -xvzf /snarf/ftp/ftp.qucis.queensu.ca/pub/txl/7.4/TXL7.4.tar.Z
cd /usr/src/TXL7.4/csrc
make |& tee om




##########
#
# Yard 1.12a
#
##########

cd /usr/src/
rm -Rv yard-1.12a/
tar -xvzf /snarf/http/www.cs.umass.edu/~fawcett/yard/yard-1.12a.tar.gz
cd yard-1.12a/
tar -xvzf /snarf/http/www.cs.umass.edu/~fawcett/code/yard-prefabs-2.tar.gz
./configure |& tee oc
make |& tee om
make install |& tee omi





################
#
# Sniffit 0.3.5
#
################

cd /usr/src/
rm -Rv sniffit.0.3.5/
tar -xvzf /snarf/http/reptile.rug.ac.be/~coder/sniffit/files/sniffit.0.3.5.tar.gz
cd sniffit.0.3.5/
tar -xvf /snarf/http/reptile.rug.ac.be/~coder/sniffit/files/sniffit.0.3.5.p1.tar
patch < sniffit.0.3.5.patch.1 |& tee op
cp -v sniffit.5 /usr/man/man5/
cp -v sniffit.8 /usr/man/man8/
cp -iv /home/root/config.cache .
./configure |& tee oc
make |& tee om

# using:
# (find-fline "/usr/src/sniffit.0.3.5/README.FIRST" 160)
# (find-fline "/usr/src/sniffit.0.3.5/PLUGIN-HOWTO" 155)

sniffit -t @ -a -b -d -x	|& tee o
sniffit -t @ -a -b		|& tee oasc
sniffit -M1 -N -P UDP -t @





#################
#
# xscavenger 1.3
#
#################

cd /usr/src/
rm -Rv xscavenger-1.3/
tar -xvzf /snarf/http/www.geocities.com/TimesSquare/Arcade/4567/scavenger-13.tgz
cd /usr/src/xscavenger-1.3/src/
xmkmf
make




##################
#
# pcmcia-cs-2.9.7
#
##################

cd /usr/src/
rm -Rv pcmcia-cs-2.9.7/
tar -xvzf /snarf/ftp/hyper.stanford.edu/pub/pcmcia/pcmcia-cs-2.9.7.tar.gz
cd pcmcia-cs-2.9.7/
make config |& tee oc




############
#
# LATOS
#
#########

rm -Rv /usr/src/latos/
mkdir  /usr/src/latos/
cd     /usr/src/
tar -xvzf /snarf/http/www.ecs.soton.ac.uk/~phh/latos.tar.gz
cd     /usr/src/latos/
. make.sh |& tee om




##########
#
# gnuserv
#
##########

cd /usr/src/
rm -Rv gnuserv-2.1alpha/
tar -xvzf /snarf/ftp/ftp.wellfleet.com/netman/psmith/emacs/gnuserv-2.1alpha.tar.gz
cd gnuserv-2.1alpha/
cp -iv config.h.proto config.h
# (find-fline "/usr/src/gnuserv-2.1alpha/config.h")
make DEST=/home/bin install		|& tee omi
cp -iv gnuserv.1 /usr/man/man1/
cp -iv gnuserv.el /usr/share/emacs/19.34/lisp/

# not working.




##############
#
# Tunes (doc)
#
##############

rm -Rv /usr/src/Tunes
mkdir  /usr/src/Tunes
cd     /usr/src/Tunes/
tar -xvzf /snarf/http/www.eleves.ens.fr/home/rideau/Tunes/files/tgz/tunes.0.0.0.34.doc.tgz
cd /usr/src/Tunes/www/




#############
#
# Stella 0.7
#
#############

cd /usr/src/
tar -xvzf /snarf/ftp/ftp.ncsu.edu/pub/eos/pub/bsvc/st/stella-0.7-src.tar.gz
cd /usr/src/stella-0.7/src/
make linux-i386-svga |& tee om

unzip /snarf/http/www.general.uwa.edu.au/u/darrins/2600/c.zip Cryscast.bin
stella Cryscast.bin




######################
#
# netscape 3.01 gold, a.k.a. "Bus Error"
#
######################

# ftp://archive.netscape.com/archive/index.html

rm -Rv /usr/src/netscape
mkdir /usr/src/netscape/
cd /usr/src/netscape/
tar -xvzf /snarf/ftp/archive.netscape.com/archive/navigator/gold/3.01/unix/unsupported/netscape-v301-export.x86-unknown-linux-elf.tar.gz




#########
#
# X docs
#
#########

rpm -iv $RS/XFree86-3.2-9.src.rpm
rpm -bp $RSP/XFree86-3.2.spec

XC=/usr/src/redhat/BUILD/XFree86-3.2/xc
imake -I$XC/config/cf/
make TOP=$XC PEXlib.txt

O diretrio xc/config/cf/ fica no incio do xc-1.tgz.
O xc-2  principalmente fontes e specs.
O xc-3 tem doc/hardcopy e umas coisas typo
xc/test/xsuite/xtest/tset/CH08/bttnprss/bttnprss.m que eu no
sei se so docs ou no.

make -f xmakefile  Makefiles
cd $RBU/XFree86-3.2/xc/doc/misc/
groff -Tascii -ms INSTALL.ms

make TOP=/usr/src/redhat/BUILD/XFree86-3.2/xc ddx.txt

(find-xcfile "INSTALL.TXT" 757)
(find-xcfile "config/cf/Project.tmpl" 1424)

(find-xcfile "Makefile")
(find-xcfile "xmakefile" 720)
(find-xcfile "doc/misc/INSTALL.ms")



############
#
# Yodl 1.15 (Yet OneOther Document Language)
#
############

cd /usr/src/
rm -Rv yodl-1.15
tar -xvzf /snarf/ftp/ftp.icce.rug.nl/pub/unix/yodl-1.15.tar.gz







#  Local Variables:
#  coding:               utf-8-unix
#  End:
