#######
#
# E-scripts on rsync.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/rsync.e>
#           or at <http://angg.twu.net/e/rsync.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.spaces»	(to "spaces")


(find-es "cvs" "rsync_angg_slow_html")
(find-es "cvs" "rsync-backup-2022")
(find-es "linode" "angg-to-linode")


# (find-status   "rsync")
# (find-vldifile "rsync.list")
# (find-udfile   "rsync/")
# https://rsync.samba.org/
# https://rsync.samba.org/FAQ.html
# https://rsync.samba.org/documentation.html
# https://rsync.samba.org/examples.html
# https://rsync.samba.org/lists.html
# https://rsync.samba.org/resources.html
# https://rsync.samba.org/features.html

# (find-fline "/home/torrents/")
# (find-fline "/home/torrents/" "__mover")
# (find-fline "/tmp/sgexpansion1/movies/")
# (find-fline "/tmp/sgexpansion1/movies/" "__mover")
# (find-fline "/tmp/sgexpansion1/movies/__mover3/")


 (eepitch-shell3)
 (eepitch-kill)
 (eepitch-shell3)
mkdir -p /tmp/sgexpansion1/movies/__mover3/
cd /home/torrents/__mover/
rsync -avvz * /tmp/sgexpansion1/movies/__mover3/




#####
#
# spaces
# 2023oct03
#
#####

# «spaces»  (to ".spaces")
# https://codeyarns.com/tech/2019-05-17-how-to-run-rsync-on-path-with-spaces.html
# https://unix.stackexchange.com/questions/104618/how-to-rsync-over-ssh-when-directory-names-have-spaces




#  Local Variables:
#  coding:               utf-8-unix
#  End:
