#######
#
# E-scripts on creating screencasts (with high-level tools).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/screencasts.e>
#           or at <http://angg.twu.net/e/screencasts.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.pkg-config»			(to "pkg-config")
# «.slop»			(to "slop")
# «.maim»			(to "maim")
# «.maim-colorpicker»		(to "maim-colorpicker")
# «.yaxg»			(to "yaxg")
# «.ffcast»			(to "ffcast")
# «.gif»			(to "gif")
# «.gifsicle»			(to "gifsicle")
# «.simplescreenrecorder»	(to "simplescreenrecorder")
# «.ssr-deb-src»		(to "ssr-deb-src")
# «.gneve»			(to "gneve")
# «.jitsi»			(to "jitsi")
# «.obsstudio»			(to "obsstudio")
# «.screencasting.el»		(to "screencasting.el")
# «.showkeys»			(to "showkeys")
# «.key-mon»			(to "key-mon")
# «.screenkey»			(to "screenkey")
# «.keycast»			(to "keycast")
# «.asciinema»			(to "asciinema")
# «.scrot-xournalpp»		(to "scrot-xournalpp")
# «.mp3-vs-aac»			(to "mp3-vs-aac")
# «.pjb-echo-keys»		(to "pjb-echo-keys")
# «.waveforms»			(to "waveforms")
# «.keycast»			(to "keycast")
# «.peek»			(to "peek")
# «.byzanz»			(to "byzanz")




# (find-es "ffmpeg" "screencasts")
# (find-es "ffmpeg" "vichy-video")




#####
#
# pkg-config
# 2019aug09
#
#####

# «pkg-config» (to ".pkg-config")
# (find-sh "apt-file search /usr/bin/pkg-config")

# slop seems to need /usr/bin/pkg-config, that is provided by both
# pkg-config and pkgconf... and pkgconf seems to be better.
# https://lists.archlinux.org/pipermail/arch-dev-public/2018-May/029252.html
# https://github.com/pkgconf/pkgconf/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti pkgconf

# (find-status   "pkgconf")
# (find-vldifile "pkgconf.list")
# (find-udfile   "pkgconf/")
# (find-man "1 pkg-config")




#####
#
# slop ("Select Operation"): queries for a selection from the user
# and prints the region to stdout.
# 2019mar04
#
#####

# «slop» (to ".slop")
# (find-fline "~/LOGS/2019mar04.emacsb" "slop")
# https://github.com/naelstrof/slop
# https://packages.debian.org/sid/slop
# https://packages.debian.org/source/sid/slop

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/slop/
cd      ~/usrc/
git clone https://github.com/naelstrof/slop
cd      ~/usrc/slop/

git reset

# cmake -DCMAKE_INSTALL_PREFIX="/usr/local" ./   |& tee ocm
  cmake -DCMAKE_INSTALL_PREFIX="/usr" ./         |& tee ocm
make   |& tee om
sudo make install   |& tee omi

# (find-man "1 slop")

# (code-c-d "slop" "~/usrc/slop/")
# (find-gitk "~/usrc/slop/")
# (find-slopfile "")
# (find-slopfile "README.md")
# (find-slopfile "README.md" "Install using CMake")

# (find-slopfile "ocm")
# (find-fline "/sda1/home/edrx/usrc/slop/ocm")
# (find-zsh "availabledebs | sort | grep uc")

# (find-sh "apt-file search /usr/lib/x86_64-linux-gnu/libXrender.so")
# (find-sh "apt-file search FindICU")
# (find-sh "apt-file search icu-config")
# (find-sh "apt-file search EGL/egl.h")

# (find-zsh "availabledebs | sort | grep libxext")
# (find-zsh "availabledebs | sort | grep glew")
# (find-zsh "availabledebs | sort | grep glm")
apti cmake libxext-dev libglew-dev libglm-dev
apti pkgconf libxrender-dev libicu-dev libegl1-mesa-dev
apti cmake-data cmake-doc

# Note: when I installed to /usr/local I got this error from yaxg...
# maim: error while loading shared libraries: libslopy.so.7.4: cannot
# open shared object file: No such file or directory
# error recording file




#####
#
# maim - takes screenshots of your desktop
# 2019mar04
#
#####

# «maim» (to ".maim")
# https://github.com/naelstrof/maim
# (find-man "1 maim")
# (find-man "1 maim" "-u, --hidecursor")
# (find-man "1 maim" "-s, --select")

apti maim

# (find-status   "maim")
# (find-vldifile "maim.list")
# (find-udfile   "maim/")
# (find-status   "slop")
# (find-vldifile "slop.list")
# (find-udfile   "slop/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/maim/
cd      ~/usrc/
git clone https://github.com/naelstrof/maim
cd      ~/usrc/maim/

git reset

cmake -DCMAKE_INSTALL_PREFIX="/usr/local/" ./   |& tee ocm
make   |& tee om
sudo make install   |& tee omi

# (code-c-d "maim" "~/usrc/maim/")
# (find-gitk "~/usrc/maim/")
# (find-maimfile "")
# (find-maimfile "README.md" "Install using CMake")

# (find-zsh "availabledebs | sort | grep libpng")
# (find-sh "apt-file search libpng")
# (find-sh "apt-file search jpeglib.h")
# (find-sh "apt-file search libjpeg")
# (find-sh "apt-file search xcomposite")
# (find-sh "apt-file search xrandr")
apti libpng-dev libjpeg-dev libjpeg62-turbo-dev libxcomposite-dev libxrandr-dev
apti libglew-dev

# (find-man "1 maim")

sleep 5 &&
maim    -s /tmp/o.png
maim -u -s /tmp/o.png



#####
#
# maim-colorpicker
# 2023apr08
#
#####

# «maim-colorpicker»  (to ".maim-colorpicker")
# https://github.com/naelstrof/maim#examples

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti maim
maim -st 0 | convert - -resize 1x1\! -format '%[pixel:p{0,0}]' info:-





#####
#
# yaxg - Yet Another X Grabber script (for screenshots and screencasts)
# 2019mar04
#
#####

# «yaxg» (to ".yaxg")
# https://www.reddit.com/r/unixporn/comments/5qfpja/i_wrote_a_screenshot_utility_that_uses_slop_and/
# https://github.com/DanielFGray/yaxg
# https://github.com/DanielFGray/yaxg/wiki/Example-callback-scripts

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/yaxg/
cd      ~/usrc/
git clone https://github.com/DanielFGray/yaxg
cd      ~/usrc/yaxg/
cp -v yaxg ~/bin/

cd /tmp/
laf *.webm
yaxg
laf *.webm

# (find-fline "~/usrc/")
# (find-fline "~/usrc/yaxg/")

# (code-c-d "yaxg" "~/usrc/yaxg/")
# (find-gitk "~/usrc/yaxg/")
# (find-yaxgfile "")
# (find-yaxgfile "yaxg" "colors[red]=")
# (find-yaxgfile "yaxg" "Usage:")
# (find-yaxgfile "yaxg" "Usage:" "-F  overwrite file if it exists")
# (find-yaxgfile "yaxg" "Usage:" "-s  select a region or window")
# (find-yaxgfile "yaxg" "Ctrl+C to stop recording")
# (find-yaxgfile "yaxg" "yaxg stop")

apti ffmpeg

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
yaxg o.png

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
sleep 3
sleep 3; yaxg -F -s /tmp/2019-viipl.png
sleep 3; yaxg -F -s /tmp/intro-tys-lfc.png
sleep 3; yaxg -F -s /tmp/o.png
# (find-fline "/tmp/")
# (find-fline "/tmp/o.png")


 (find-3EE '(eepitch-shell2) '(eepitch-shell3))
 (eepitch-shell3)
cd /tmp/
laf   *.webm
rm -v *.webm
yaxg
 (eepitch-shell2)
cd /tmp/
yaxg stop
yaxg stop
laf *.webm
 (eepitch-shell2)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
laf   *.webm
rm -v *.webm
yaxg
 (find-sh0 "yaxg stop")
laf   *.webm





#####
#
# ffcast
# 2019mar04
#
#####

# «ffcast» (to ".ffcast")
# https://unix.stackexchange.com/questions/113695/gif-screencasting-the-unix-way
# https://github.com/lolilolicon/FFcast




#####
#
# gif
# 2019mar04
#
#####

# «gif» (to ".gif")
# (find-es "emacs" "gif-screencast.el")
# https://unix.stackexchange.com/questions/113695/gif-screencasting-the-unix-way
# https://github.com/webdev23/gif



#####
#
# gifsicle (used by emacs-gif-screencast)
# 2019aug07
#
#####

# «gifsicle» (to ".gifsicle")
# https://www.lcdf.org/gifsicle/




#####
#
# simplescreenrecorder
# 2019aug07
#
#####

# «simplescreenrecorder» (to ".simplescreenrecorder")
# https://www.maartenbaert.be/simplescreenrecorder/
# (find-other-debian-links "simplescreenrecorder")

# https://github.com/MaartenBaert/ssr
# https://github.com/MaartenBaert/ssr/archive/master.tar.gz

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/ssr/
cd      ~/usrc/
git clone https://github.com/MaartenBaert/ssr
cd      ~/usrc/ssr/

# (find-fline "~/usrc/")
# (find-fline "~/usrc/ssr/")
# (find-gitk  "~/usrc/ssr/")

# (code-c-d "ssr" "~/usrc/ssr/")
# (find-ssrsh "find * | sort")
# (find-ssrfile "data/icons/scalable/")
# (find-ssrgrep "grep --color=auto -nRH --null -e data/icons *")

# (find-ssrfile "")
# (find-ssrfile "README.md")
# (find-ssrfile "README.md" "Build dependencies")
# (find-ssrfile "README.md" "qt5-qmake")
# (find-ssrfile "notes.txt")

# (find-status   "simplescreenrecorder")
# (find-vldifile "simplescreenrecorder.list")
# (find-udfile   "simplescreenrecorder/")
# (find-fline "/usr/share/applications/simplescreenrecorder.desktop")
# (find-fline "/usr/share/applications/simplescreenrecorder.desktop" "Exec=")
# (find-fline "/usr/share/metainfo/simplescreenrecorder.appdata.xml")
# (find-man "1 simplescreenrecorder")
# (find-man "1 ssr-glinject")
# http://www.maartenbaert.be/simplescreenrecorder/

# (find-fline "~/.ssr/")
# (find-fline "~/.ssr/settings.conf")
# (find-fline "~/.ssr/settings.conf" "[record]")
# (find-fline "~/.ssr/settings.conf" "[record]" "hotkey")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
simplescreenrecorder --logfile
simplescreenrecorder




#####
#
# ssr-deb-src
# 2021sep09
#
#####

# «ssr-deb-src»  (to ".ssr-deb-src")
# (find-apt-get-source-links "simplescreenrecorder")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-sh "apt-cache show    simplescreenrecorder")
# (find-sh "apt-cache showsrc simplescreenrecorder")
rm -Rv /tmp/d/
mkdir  /tmp/d/
cd     /tmp/d/
sudo apt-get build-dep -y   simplescreenrecorder
     apt-get source         simplescreenrecorder   2>&1 | tee osource
     apt-get source --build simplescreenrecorder   2>&1 | tee osourceb

cd /tmp/d/simplescreenrecorder-0.4.2/data/icons/scalable/
cp -v ~/usrc/ssr/data/icons/scalable/simplescreenrecorder-fallbackmic.svg .

# (find-fline "~/usrc/ssr/data/icons/scalable/simplescreenrecorder-fallbackmic.svg")

# (find-fline "/tmp/d/simplescreenrecorder-0.4.2/")
# (code-c-d "ssrdebsrc" "/tmp/d/simplescreenrecorder-0.4.2/")
# (find-ssrdebsrcfile "")

cd /tmp/d/
sudo dpkg -i simplescreenrecorder_0.4.2-2_amd64.deb
#
# (find-status   "simplescreenrecorder")
# (find-vldifile "simplescreenrecorder.list")
# (find-vldifile "simplescreenrecorder.list" "fallbackmic")
# (find-udfile   "simplescreenrecorder/")

# (find-fline "/tmp/d/simplescreenrecorder/")

# (find-fline "/tmp/d/")
cd /tmp/d/
git clone https://salsa.debian.org/multimedia-team/simplescreenrecorder.git





#####
#
# GNEVE (Video editor - very old, single .el. very short)
# 2019aug07
#
#####

# «gneve» (to ".gneve")
# https://www.emacswiki.org/emacs/GNEVE
# http://1010.co.uk/gneve.html
# https://www.youtube.com/watch?v=0vumR5Hcz7s
# https://www.reddit.com/r/emacs/comments/2iqqaj/gneve_gnu_emacs_video_editor/
# https://github.com/emacsattic/gneve

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/gneve/
cd      ~/usrc/
git clone https://github.com/emacsattic/gneve
cd      ~/usrc/gneve/

# (find-fline "~/usrc/")
# (find-fline "~/usrc/gneve/")
# (find-gitk  "~/usrc/gneve/")

# (code-c-d "gneve" "~/usrc/gneve/")
# (find-gnevefile "")
# (find-gnevefile "gneve.el")




#####
#
# jitsi
# 2019aug25 / 2020jul07
#
#####

# «jitsi» (to ".jitsi")
# (find-es "apt" "apt-transport-https")
# (find-fline "~/LOGS/2019aug24.emacsconf")
# https://jitsi.org/jitsi-meet/
# https://meet.jit.si
# https://en.wikipedia.org/wiki/Jitsi
# https://desktop.jitsi.org/Main/DebianRepository

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
wget -qO - https://download.jitsi.org/jitsi-key.gpg.key | sudo apt-key add -
sudo sh -c "echo 'deb https://download.jitsi.org stable/' > /etc/apt/sources.list.d/jitsi-stable.list"
sudo apt-get -y update
sudo apt-get -y install jitsi-meet

# (find-zsh "installeddebs | sort | grep jitsi")
# (find-zsh "availabledebs | sort | grep jitsi")

# (find-status   "jitsi-meet")
# (find-vldifile "jitsi-meet.list")
# (find-udfile   "jitsi-meet/")

# (find-status   "jitsi")
# (find-vldifile "jitsi.list")
# (find-udfile   "jitsi/")
# (find-man "1 jitsi")

jitsi

# (find-sh "apt-file search libjawt")

gcj-6-jre: /usr/lib/jvm/java-1.5.0-gcj-6-amd64/jre/lib/amd64/libjawt.so
libgcj17-awt: /usr/lib/jvm/java-1.5.0-gcj-6-amd64/lib/libjawt.so
libgcj17-awt: /usr/lib/x86_64-linux-gnu/gcj-6-17/libjawt.so
openjdk-8-jdk-headless: /usr/lib/jvm/java-8-openjdk-amd64/lib/amd64/libjawt.so
openjdk-8-jre-headless: /usr/lib/jvm/java-8-openjdk-amd64/jre/lib/amd64/libjawt.so

# (find-zsh "installeddebs | sort | grep openjdk")
# (find-zsh "installeddebs | sort | grep gcj")

apti gcj-6-jre libgcj17-awt

# (find-status   "openjdk-8-jre-headless")
# (find-vldifile "openjdk-8-jre-headless:amd64.list")
# (find-vldifile "openjdk-8-jre-headless:amd64.list" "libjawt.so")
# (find-udfile   "openjdk-8-jre-headless/")
# (find-status   "openjdk-8-jre")
# (find-vldifile "openjdk-8-jre:amd64.list")
# (find-udfile   "openjdk-8-jre/")





#####
#
# OBS Studio
# 2019aug30
#
#####

# «obsstudio» (to ".obsstudio")
# https://obsproject.com/
# https://obsproject.com/download
# (find-status   "obs-studio")
# (find-vldifile "obs-studio.list")
# (find-udfile   "obs-studio/")
# (find-zsh "installeddebs | sort | grep obs")
# (find-zsh "availabledebs | sort | grep obs")
# (find-man "1 obs")
# (find-fline "/home/edrx/.config/obs-studio/")

 http://www.youtube.com/watch?v=_jL_GaFjGwk OBS HOW TO CUT AND RESIZE 22.0.2  2018
 http://www.youtube.com/watch?v=QjEWAJ3d-jw OBS Studio: Understanding how to use it, to create and edit videos

<mplsCorwin> messing with obs-websocket+OBSCommand; so far I can
             change scenes with M-!
             C:\OBSCommand_v1.5.4\OBSCommand\OBSCommand.exe
             /scene="Emacs Only"

# Failed to initialize video. Your GPU may not be supported, or your
# graphics drivers may need to be updated.

https://www.youtube.com/watch?v=z6l5TzTgJ0I

• (eepitch-shell)
• (eepitch-kill)
• (eepitch-shell)
# LIBGL_ALWAYS_SOFTWARE=1 obs-studio
  LIBGL_ALWAYS_SOFTWARE=1 obs




#####
#
# screencasting.el (by Damien Cassou)
# 2020sep20
#
#####

# «screencasting.el»  (to ".screencasting.el")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/screencasting.el/")
rm -Rv ~/usrc/screencasting.el/
mkdir  ~/usrc/screencasting.el/
cd     ~/usrc/screencasting.el/

#    https://gist.github.com/DamienCassou/0e3663ce3bdb710a44eeb7122870f621
wget https://gist.github.com/DamienCassou/0e3663ce3bdb710a44eeb7122870f621/raw/4a580456bfee951a41ef70785371d82c7e75044a/screencasting.el

# (find-fline "~/usrc/screencasting.el/screencasting.el")




#####
#
# showkeys
# 2020sep20
#
#####

# «showkeys»  (to ".showkeys")
# https://github.com/nibrahim/showkeys

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/showkeys/
cd      ~/usrc/
git clone https://github.com/nibrahim/showkeys
cd      ~/usrc/showkeys/

# (find-fline "~/usrc/")
# (find-fline "~/usrc/showkeys/")
# (find-gitk  "~/usrc/showkeys/")

# (code-c-d "showkeys" "~/usrc/showkeys/")
# (find-showkeysfile "")
# (find-showkeysfile "README.md")
# (find-sh "xdpyinfo" "RECORD")
# (find-showkeysfile "config.h")
# (find-showkeysfile "Makefile")

apti libx11-dev libxosd-dev libxtst-dev

make showkeys |& tee om

laf
./showkeys





#####
#
# key-mon
# 2020sep20
#
#####

# «key-mon»  (to ".key-mon")
# http://code.google.com/p/key-mon/
# https://code.google.com/archive/p/key-mon/
# (find-status   "key-mon")
# (find-vldifile "key-mon.list")
# (find-udfile   "key-mon/")
# (find-man "1 key-mon")
# (find-sh "key-mon --help")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
key-mon
abcd
key-mon --smaller




#####
#
# screenkey
# 2020sep20 / 2024jan06
#
#####

# «screenkey»  (to ".screenkey")
# (find-angg ".emacs.templates" "find-screenkey-links")
# (find-angg ".zshrc" "screenkey")
# (find-status   "screenkey")
# (find-vldifile "screenkey.list")
# (find-udfile   "screenkey/")
# (find-udfile "screenkey/NEWS.rst.gz")
# (find-udfile "screenkey/README.rst.gz")
# (find-udfile "screenkey/changelog.Debian.gz")
# (find-udfile "screenkey/copyright")
# http://pabloseminario.com/projects/screenkey/
# (code-c-d "screenkey" "/usr/lib/python3/dist-packages/Screenkey/")
# (find-screenkeyfile "")
# (find-man "1 screenkey")
# (find-sh "screenkey --help")
# (find-sh "screenkey --help" "--font-size")
# (find-sh "screenkey --help" "--font-size" "--opacity OPACITY")
# (find-es "x" "geometry")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
screenkey
killall screenkey

screenkey -s medium
killall screenkey

screenkey -s small
killall screenkey

screenkey -s small --mods-mode emacs
screenkey -s small --mods-mode emacs --opacity 0.4
screenkey -s small --mods-mode emacs --opacity 0.3 --timeout 0.5 &
screenkey -s small --mods-mode emacs --opacity 0.2 --timeout 0.5 &
killall screenkey

screenkey -s small --geometry +100+100 &
screenkey -s small --geometry 100x100 &
screenkey -s small --geometry 400x100 &
killall screenkey




#####
#
# keycast
# 2020oct13
#
#####

# «keycast»  (to ".keycast")
# (find-epackage-links 'keycast)
# (find-epackage 'keycast)
# (find-elpafile "keycast-readme.txt")
# (code-c-d "keycast" "~/.emacs.d/elpa/keycast-20200612.2247/")
# (find-keycastfile "")
# https://github.com/tarsius/keycast




#####
#
# asciinema
# 2021jul30
#
#####

# «asciinema»  (to ".asciinema")
# https://asciinema.org/
# https://asciinema.org/docs/how-it-works
# https://github.com/asciinema/asciinema-server
# https://github.com/asciinema/asciinema-player




#####
#
# scrot-xournalpp
# 2021aug30
#
#####

# «scrot-xournalpp»  (to ".scrot-xournalpp")
# (find-man "1 scrot" "SCReenshOT")
# (find-man "1 scrot" "-o, --overwrite")
# (find-man "1 scrot" "-s, --select")
# (find-man "1 convert")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

scrot -o --select /tmp/sshot.png
cd /tmp/
convert sshot.png sshot.pdf
xournalpp sshot.pdf





#####
#
# mp3-vs-aac
# 2021aug02
#
#####

# «mp3-vs-aac»  (to ".mp3-vs-aac")
# https://en.wikipedia.org/wiki/Advanced_Audio_Coding

Oi Reinaldo! Tudo bem? Voce trabalha com video, ne'? Voce pode me dar uma dica? Acho que se voce me der umas palavras-chave eu devo conseguir me virar procurando nas internets...

E' o seguinte... eu so' sei usar Linux, e ate' dois anos atras eu nao entendia absolutamente nada de gravar videos... agora eu entendo pouquissimo, mas ja' gravei uns screencasts sobre coisas de Software Livre, e agora eu gravo algumas das minhas aulas como screencasts tambem...

Eu costumo usar um programa chamado SimpleScreenRecorder, com esses settings aqui... vou mandar uma foto de uma das janelas dele, mas o que importa e' so' a parte dela que diz que o audio vai ser gravado em "Codec: MP3" e "Bit rate (in kbits/s): 128", e incluido num arquivo .mp4 com Codec H.264

Eu achava que isso seria um formato mais ou menos universal que todos os players tocariam numa boa, mas uns alunos meus que tem iPhones me disseram que quando eles tentam assistir esses MP4s eles nao ouvem som

e ai' eu tive que fazer uma coisa bem idiota, que e' subir cada .mp4 pro youtube tambem... exemplo:

http://angg.twu.net/eev-videos/2021-1-C2-somas-1-dicas.mp4

https://www.youtube.com/watch?v=pCD1p9FZYdI

Onde eu posso aprender mais sobre que formatos de video sao "universais" no sentido de que qualquer browser em qualquer celular?

Ooops

De que qualquer browser em qualquer celular deve conseguir tocar eles direito

Desculpa a falta de jeito de ja' ir perguntando coisas tecnicas direto... eu meio que desaprendi como interagir com humanos, e eu ate' ando dizendo - meio a serio e meio de brincadeira - que eu virei a Rainha da Amargura... =S

Fala Zico, tudo certo. O apocalipse afetou todo mundo.

Tenta 96 bits em vez de 128. Alguns telefones não aceitam 128 e os iPhones são merdas caras. O formato de áudio padrão do iPhione é o AAC mas ele costuma suportar o MP3.

Recomendo dois programas que existem para Linux. O Player VLC que vc deve sugerir aos seus alunos por que toca tudo e existe para iphone, andoird etc

E o OBS que ofcialmente é para trasmições mas grava no PC e é um poderoso fácil de usar. Capturara tela é com ele mesmo.

Opa! Obrigado!!! 

Reinaldo Rocha
Reinaldo sent Today at 12:13
Disponha
You sent Today at 12:13
Ja' me deu um monte de ideias de coisas pra testar e pra pesquisar! Quando ao VLC: eu uso ele e o mplayer pra quase tudo aqui em casa, mas tou tentando fazer com que o material das minhas aulas fique acessivel sem apps extras... ja' tem um monte de alunos que ficam revoltados que 90% das minhas aulas sao discussoes por Telegram com todo mundo mandando foto do que esta' fazendo... 
You sent Today at 12:14
Alias, agora ao inves de mplayer eu uso mpv.
Reinaldo Rocha
Reinaldo sent Today at 12:27
O VLC funciona como conversor. No Windows seria CTRL+R
You sent Today at 12:29
Tou testando aqui no Linux... o Ctrl-R parece ser pra abrir arquivos, URLs, or discos...
You sent Today at 12:30
Pra mim e' mais facil usar o ffmpeg pra fazer as conversoes dos audios




#####
#
# pjb-echo-keys
# 2021oct05
#
#####

# «pjb-echo-keys»  (to ".pjb-echo-keys")
# https://github.com/informatimago/emacs/blob/master/pjb-echo-keys.el





#####
#
# waveforms
# 2021dec07
#
#####

# «waveforms»  (to ".waveforms")
# https://sachachua.com/blog/2021/12/emacsconf-backstage-picking-timestamps-from-a-waveform/
# https://github.com/sachac/waveform-el



#####
#
# peek
# 2022sep26
#
#####

# «peek»  (to ".peek")
# (find-status   "peek")
# (find-vldifile "peek.list")
# (find-udfile   "peek/")
# (find-man "1 peek")
# (find-sh "peek --help-all")

# https://itsfoss.com/best-gif-recorder-linux/
# https://github.com/phw/peek
# (find-git-links "https://github.com/phw/peek" "peek")
# (code-c-d "peek" "~/usrc/peek/")
# (find-peekfile "")
# (find-peekfile "README.md")
# https://en.wikipedia.org/wiki/Vala_(programming_language)




#####
#
# byzanz
# 2022sep26
#
#####

# «byzanz»  (to ".byzanz")
# https://askubuntu.com/questions/107726/how-to-create-animated-gif-images-of-a-screencast
# (find-status   "byzanz")
# (find-vldifile "byzanz.list")
# (find-udfile   "byzanz/")
byzanz-record --duration=15 --x=200 --y=300 --width=700 --height=400 out.gif





https://gitlab.com/ambrevar/emacs-gif-screencast
https://old.reddit.com/r/emacs/comments/63ckc8/how_can_i_create_a_screencast_of_an_emacs_session/
https://github.com/esbena/screencast-mode

https://github.com/nbedos/termtosvg

https://www.emacswiki.org/emacs/EmacsScreencasts

https://github.com/tarsius/keycast

https://emacsconf.org/2021/prepare/

https://github.com/jordansissel/xdotool
https://github.com/chuntaro/emacs-keypression



#  Local Variables:
#  coding:               utf-8-unix
#  End:
