#######
#
# E-scripts on shibari.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/shibari.e>
#           or at <http://angg.twu.net/e/shibari.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.svbl-single-column»		(to "svbl-single-column")
# «.svbl-double-column»		(to "svbl-double-column")
# «.larks-head-single-column»	(to "larks-head-single-column")
# «.larks-head-double-column»	(to "larks-head-double-column")
# «.bent-arms-behind-head»	(to "bent-arms-behind-head")
# «.wrists-up-behind-the-neck»	(to "wrists-up-behind-the-neck")
# «.larks-head-hair-tie»	(to "larks-head-hair-tie")

# (find-books "__shibari/__shibari.el")




#####
#
# Sommerville Bowline Single Column
# 2020sep26
#
#####

# «svbl-single-column»  (to ".svbl-single-column")
# https://crash-restraint.com/ties/66 Sommerville bowline single column cuff
#         https://vimeo.com/193199846 Sommerville bowline single column cuff
# (code-video "sbvlsinglecolumn" "/sda5/sda5/videos/__shibari/Somerville_Bowline_Single_Column_Cuff-193199846.mp4")
# (find-sbvlsinglecolumn)
# (find-sbvlsinglecolumn "0:00")




#####
#
# Sommerville Bowline Double Column
# 2020sep26
#
#####

# «svbl-double-column»  (to ".svbl-double-column")
# https://crash-restraint.com/ties/69 Somerville Bowline Double Column
#         https://vimeo.com/193267706 Somerville Bowline Double Column
# (code-video "svbldoublecolumnvideo" "/sda5/sda5/videos/__shibari/Somerville Bowline Double Column Cuff-193267706.mp4")
# (find-svbldoublecolumnvideo)
# (find-svbldoublecolumnvideo "0:00")
# (find-svbldoublecolumnvideo "0:58" "I'm gonna need more bight for the double column")




#####
#
# larks-head-single-column
# 2020sep20
#
#####

# «larks-head-single-column»  (to ".larks-head-single-column")
# https://crash-restraint.com/ties/19 Lark's Head Single Column
# https://vimeo.com/193280591         Lark's Head Single Column
# (code-video "basicsinglecolumnvideo" "/sda5/sda5/videos/__shibari/Basic Single Column Tie-193280591.mp4.part")
# (find-basicsinglecolumnvideo)
# (find-basicsinglecolumnvideo "1:22" "straight up through that space")



#####
#
# larks-head-double-column
# 2020aug27
#
#####

# «larks-head-double-column»  (to ".larks-head-double-column")
# https://crash-restraint.com/ties/25 Lark's Head Double Column
# https://vimeo.com/193478557         Lark's Head Double Column (Basic Double Column Tie)
# (code-video "basicdoublecolumnvideo" "/sda5/sda5/videos/__shibari/Basic_Double_Column_Tie-193478557.mp4")
# (find-basicdoublecolumnvideo)
# (find-basicdoublecolumnvideo "0:00")
# (find-basicdoublecolumnvideo "3:22" "figure 4")




#####
#
# bent-arms-behind-head
# 2020aug27
#
#####

# «bent-arms-behind-head»  (to ".bent-arms-behind-head")
# https://crash-restraint.com/ties/104
# (find-vimeodl-links "/sda5/sda5/videos/__shibari/" "Tying Bent Arms" "195735897" ".mp4" "tyingbentarms")
# (code-video "tyingbentarmsvideo" "/sda5/sda5/videos/__shibari/Tying Bent Arms-195735897.mp4")
# (find-tyingbentarmsvideo)
# (find-tyingbentarmsvideo "0:00")
# (find-tyingbentarmsvideo "1:50" "through the double bight again")
# (find-tyingbentarmsvideo "3:55" "if I just tie these two together")
# (find-tyingbentarmsvideo "4:50" "bring the rope up")
# (find-tyingbentarmsvideo "5:28" "and two wraps is probably")
# (find-tyingbentarmsvideo "5:40" "would pinch")
# (find-tyingbentarmsvideo "7:10" "nó de orelhinhas")



#####
#
# wrists-up-behind-the-neck
# 2020aug27
#
#####

# «wrists-up-behind-the-neck»  (to ".wrists-up-behind-the-neck")
# https://crash-restraint.com/ties/26 Wrists over Head to Back [Level 1]
# https://vimeo.com/120126006 Tying_the_Wrists_Up_Behind_the_Neck 
# (find-vimeodl-links "/sda5/sda5/videos/__shibari/" "Tying the Wrists Up Behind the Neck" "120126006" ".mp4" "wristsupbehindtheneck")
# (code-video "wristsupbehindtheneckvideo" "/sda5/sda5/videos/__shibari/Tying the Wrists Up Behind the Neck-120126006.mp4")
# (find-wristsupbehindtheneckvideo)
# (find-wristsupbehindtheneckvideo "0:00")
# (find-wristsupbehindtheneckvideo "0:30" "using a double column tie")




#####
#
# Collapsed Lark's Head Hair Tie
# 2020sep08
#
#####

# «larks-head-hair-tie»  (to ".larks-head-hair-tie")
# https://crash-restraint.com/ties/47 Collapsed Lark's Head Hair Tie
# https://vimeo.com/195215408         Collapsed Lark's Head Hair Tie
# (code-video "larksheadhairtievideo" "/sda5/sda5/videos/__shibari/Collapsed Lark's Head Hair Tie-195215408.mp4")
# (find-larksheadhairtievideo)
# (find-larksheadhairtievideo "0:00")




https://www.instagram.com/p/CEZwpZeFzi7/ tutorial de nodome da Akira (4 fotos)
https://crash-restraint.com/ties/category/Second%20Column

https://en.wikipedia.org/wiki/Two_half-hitches





#  Local Variables:
#  coding:               utf-8-unix
#  End:
