#######
#
# E-scripts on installing a Slink system.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/slink.e>
#           or at <http://angg.twu.net/e/slink.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





######
#
# short names (with the CDs already copied to my HD)
# 99jul04/00jan03
#
######

# «short_names»
# Cheapbytes' slinkr1 comes with a kde dir, but r2 doesn't...

# cd /big; find slink* -type f | grep '\.deb$'

rm -Rv ~/SLINK
mkdir ~/SLINK
cd ~/SLINK
ln -s /big/slinkb1/dists/slink/main/binary-all		.1mall
ln -s /big/slinkb1/dists/slink/main/binary-i386		.1m386
ln -s /big/slinkb2/dists/slink/contrib/binary-all	.2call
ln -s /big/slinkb2/dists/slink/contrib/binary-i386	.2c386
ln -s /big/slinkb2/dists/slink/main/binary-all		.2mall
ln -s /big/slinkb2/dists/slink/main/binary-i386		.2m386
ln -s /big/slinks1/project/experimental				.exp
#ln -s /big/slinks2/kde/1.1/distribution/deb/slink/binary-i386	.kde

for i in .{1m,2c,2m}{all,386}/ .kde/; do
  find $i -type f | grep '\.deb$' |
  perl -nle 'm:.*/([-a-z0-9.+]+)_.*: && ((symlink $_, $1)==1 || print $_)'
done

# In '(symlink $_, $1 || print $_)', the clause '|| print $_' isn't
# working. Why?
# (eeman "perlfunc" "symlink OLDFILE,NEWFILE")
# (eeman "perlop" "Binary .\\|\\|.")
# (eeman "perldata" "TRUE in the Boolean sense")
# (eeman "perlfunc" "0 but true")

ln -s /big/slinkb1/dists/slink/Contents-i386 ~/SLINK -iv




#####
#
# MIME::Lite (for sending mime'd mail)
#
#####

# «mime_lite»
# (find-fline "$SCPAN/authors/id/ERYQ/MIME-Lite-1.135.tar.gz")

rm -Rv /usr/src/MIME-Lite-1.135/
cd /usr/src/
tar -xvzf $SCPAN/authors/id/ERYQ/MIME-Lite-1.135.tar.gz
cd /usr/src/MIME-Lite-1.135/

perl Makefile.PL	|& tee opM
make	|& tee om
make install	|& tee omi

# (find-fline "~/.zshrc" "email")

apti tcs

email850 edrx 'teste' <<'---'
Alôôô
---




#  Local Variables:
#  coding:               utf-8-unix
#  End:
