#######
#
# E-scripts about installing and configuring Debian on sweetjane, a
# machine that is behind an "ISA Server" proxy.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/sweetjane.e>
#           or at <http://angg.twu.net/e/sweetjane.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.compile_at_parati»	(to "compile_at_parati")
# «.VPN»		(to "VPN")
# «.VPN-dependencias»	(to "VPN-dependencias")
# «.VPN-compile-install»  (to "VPN-compile-install")


# (find-orggrep "grep -nH -e dialog *.org")
# (find-zsh "acse dialog | sort")
# (find-status   "dialog")
# (find-vldifile "dialog.list")
# (find-udfile   "dialog/")
# (find-udfile   "dialog/examples/")
# (find-udfile   "dialog/examples/inputbox")
# (find-man "1 dialog")
# (find-man "3 dialog")




#####
#
# compiling dialog at parati
# 2006jun23
#
#####

# «compile_at_parati»  (to ".compile_at_parati")
# http://invisible-island.net/dialog/
# ftp://invisible-island.net/dialog/dialog.tar.gz

 (eepitch-eshell)
cd (ee-paratifile "")
mkdir snarf/
mkdir snarf/ftp/
mkdir snarf/ftp/invisible-island.net/
mkdir snarf/ftp/invisible-island.net/dialog/
cd    snarf/ftp/invisible-island.net/dialog/
cp -v $S/ftp/invisible-island.net/dialog/dialog.tar.gz .

 (eepitch-parati)
edrx
cd
mkdir  ~/usrc/
rm -Rf ~/usrc/dialog-1.0-20060221/
mkdir  ~/usrc/dialog-1.0-20060221/
cd     ~/usrc/
gunzip -cd < ~/snarf/ftp/invisible-island.net/dialog/dialog.tar.gz | tar -xvf -
cd     ~/usrc/dialog-1.0-20060221/
export LC_ALL=C
export LANG=C
./configure 2>&1 | tee oc
make        2>&1 | tee om

cd ~/bin/
ln -sf ../usrc/dialog-1.0-20060221/dialog dialog




#####
#
# testing dialog at parati
# 2006jun23
#
#####

 (eechannel-xterm "P")
telnet parati
edrx
S4
export DIALOG=$HOME/bin/dialog
cd     ~/usrc/dialog-1.0-20060221/samples/

# (find-udfile   "dialog/examples/")
# (find-udfile   "dialog/examples/inputbox")





#####
#
# VPN
# 2006aug24
#
#####

# «VPN»  (to ".VPN")
# (find-orggrep "grep -niH -e vpn *.org")
# (find-org "NOTES.org" "vpn-compile")
# (find-org "NOTES.org" "vpn-kernel-headers")




#####
#
# VPN dependencies - linux 2.6.8
# 2006aug24
#
#####

# «VPN-dependencias»  (to ".VPN-dependencias")
# (find-org "NOTES.org" "vpn-kernel-headers")
# (find-angg ".zshrc" "installeddebs")
# (find-zsh "installeddebs | sort" "kernel-image")
# (find-zsh "acse kernel   | sort")
# (find-zsh "grep-available kernel-headers-2.6.8-2")

# kernel-headers-2.6.8-2
# kernel-headers-2.6.8-2-386

apti kernel-kbuild-2.6-3

# http://security.debian.org/debian-security/pool/updates/main/k/kernel-image-2.6.8-i386/kernel-headers-2.6.8-2_2.6.8-16sarge1_i386.deb
cd $S/http/security.debian.org/debian-security/pool/updates/main/k/kernel-image-2.6.8-i386/
sudo dpkg -i kernel-headers-2.6.8-2_2.6.8-16sarge1_i386.deb

# http://security.debian.org/debian-security/pool/updates/main/k/kernel-image-2.6.8-i386/kernel-headers-2.6.8-2-686_2.6.8-16sarge1_i386.deb
cd $S/http/security.debian.org/debian-security/pool/updates/main/k/kernel-image-2.6.8-i386/
sudo dpkg -i kernel-headers-2.6.8-2-686_2.6.8-16sarge1_i386.deb

# Note: remove this, ...-386 is the wrong one.
# http://ftp.debian.org/debian/pool/main/k/kernel-image-2.6.8-i386/kernel-headers-2.6.8-2-386_2.6.8-16sarge1_i386.deb
cd $S/http/ftp.debian.org/debian/pool/main/k/kernel-image-2.6.8-i386/
sudo dpkg -i kernel-headers-2.6.8-2-386_2.6.8-16sarge1_i386.deb




#####
#
# VPN - compiling
# 2006aug24
#
#####

# «VPN-compile-install»  (to ".VPN-compile-install")
# (find-org "NOTES.org" "vpn-compile")
# (code-c-d "vpnclient" "~/tmp/confs_vivo/vpnclient/")
# (find-vpnclientfile "")
# (find-vpnclientfile "Makefile")
# (find-vpnclientfile "vpn_install")
# (find-vpnclientfile "ovi")
# (find-vpnclientfile "ovi" "/etc/init.d/vpnclient_init")

# Installation (it's interactive, so use eechannel)
 (eechannel-xterm "A")

rm -Rfv ~/tmp/confs_vivo/vpnclient/
tar -C  ~/tmp/confs_vivo/ -xvf \
        ~/tmp/confs_vivo/vpnclient_cisco_vivo.tar
cd      ~/tmp/confs_vivo/vpnclient/

R
./vpn_install |& tee ovi
/usr/local/bin
yes
/usr/src/kernel-headers-2.4.27-2-386
y
exit    ;# from su

R
./vpn_install |& tee ovi
/usr/local/bin
yes
/usr/src/kernel-headers-2.6.8-2-686
y
exit    ;# from su



# I tried with
#   /usr/src/kernel-headers-2.6.8-2-386
# but it didn't work.

# Now make Debian set up the vpn thing on startup
# (find-fline "/etc/init.d/")
# (find-fline "/etc/init.d/" "vpnclient_init")
# (find-fline "/etc/init.d/vpnclient_init")
# (find-fline "/etc/rc2.d/")
# (find-fline "/etc/rc2.d/" "vpnclient_init")

 (eepitch-shell)
cd /etc/rc2.d/
sudo rm -v /etc/rc2.d/S99vpnclient_init
sudo ln -sf ../init.d/vpnclient_init /etc/rc2.d/S99vpnclient_init
sudo /etc/rc2.d/S99vpnclient_init start
sudo /etc/rc2.d/S99vpnclient_init stop

# Ugh, it seems that it has some binary module that needs linux-2.4


# Arquivos que o Fabiano copiou pra ca':

# (find-fline "~/bin/vpn_cisco.sh")
# (find-fline "/etc/opt/cisco-vpnclient/")
# (find-fline "/etc/opt/cisco-vpnclient/Profiles/VIVO_ADMxOPER.pcf")

~/bin/vpn_cisco.sh start
~/bin/vpn_cisco.sh stop



#####
#
# vpn - test
# 2006aug24
#
#####

# (find-angg "MEDIADOR/mediador.e" "teresopolis-via-arraial")
# From sweetjane (it doesn't work):
 (eechannel-xterm "A")
telnet teresopolis

ssh teresopolis










#  Local Variables:
#  coding:               utf-8-unix
#  End:
