#######
#
# E-scripts on syslinux (and isolinux and isohybrid).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/syslinux.e>
#           or at <http://angg.twu.net/e/syslinux.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######





# «.debian-packages»		(to "debian-packages")
# «.packages-with»		(to "packages-with")
# «.live-build-isolinux»	(to "live-build-isolinux")
# «.irc-channel»		(to "irc-channel")
# «.mailing-list»		(to "mailing-list")
# «.isohybrid»			(to "isohybrid")



# (find-esgrep "grep -nH -e isolinux *.e")
# (find-esgrep "grep -nH -e syslinux *.e")
# (find-esgrep "grep -nH -e debootstrap *.e")
# (find-es "qemu")




#####
#
# The debian packages for isolinux and syslinux
# 2018jun01
#
#####

# «debian-packages» (to ".debian-packages")

# (find-zsh "installeddebs | sort | grep isolinux")
# (find-zsh "availabledebs | sort | grep isolinux")
# (find-zsh "installeddebs | sort | grep syslinux")
# (find-zsh "availabledebs | sort | grep syslinux")

# (find-status   "syslinux")
# (find-vldifile "syslinux.list")
# (find-udfile   "syslinux/")
# (find-udfile "syslinux/README" "isolinux.txt")
# (find-udfile "syslinux/isolinux.txt.gz" "\"hybrid mode\"")
# (find-udfile "syslinux/isolinux.txt.gz" "USB key")

# (find-man "1 gethostip")
# (find-man "1 isohybrid")
# (find-man "1 isohybrid" "USB key")
# (find-man "1 memdiskfind")
# (find-man "1 syslinux")




#####
#
# packages with files with "isolinux" in their names
# 2018jun01
#
#####

# «packages-with» (to ".packages-with")
# (find-es "apt" "apt-file")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apt-file search isolinux
apt-file search -l isolinux

bootcd
debian-cd
live-build
live-image-gnome-desktop
live-image-kde-desktop
live-image-lxde-desktop
live-image-rescue
live-image-standard
live-image-xfce-desktop
syslinux-common
syslinux-themes-debian-squeeze
syslinux-themes-debian-wheezy
syslinux-themes-ubuntu-oneiric
syslinux-themes-ubuntu-precise
syslinux-themes-ubuntu-quantal
syslinux-themes-ubuntu-raring
syslinux-themes-ubuntu-saucy
syslinux-themes-ubuntu-trusty




#####
#
# The isolinux/ directory in pen drives created by live-build
# 2018jun01
#
#####

# «live-build-isolinux» (to ".live-build-isolinux")
# (find-fline "/usr/share/live/build/bootloaders/isolinux/")
# (find-fline "/usr/share/live/build/bootloaders/isolinux/menu.cfg")
# (find-fline "/usr/share/live/build/bootloaders/isolinux/install.cfg")
# (find-fline "/usr/share/live/build/bootloaders/isolinux/live.cfg.in")




#####
#
# The syslinux IRC channel
# 2018jun03
#
#####

# «irc-channel» (to ".irc-channel")
# https://www.syslinux.org/wiki/index.php?title=Contact
# irc://irc.freenode.net#syslinux

(defun s2 () (interactive) (find-rcirc-buffer-2a "irc.freenode.net" "#syslinux" nil "#syslinux"))
(defun s3 () (interactive) (find-rcirc-buffer-3a "irc.freenode.net" "#syslinux" nil "#syslinux"))

# (find-fline "~/LOGS/2018jun03.syslinux")

<edrx> hi... I'm not sure if this is possible, but let me phrase
       the question as if it is...
<edrx> I'm trying to modify a live pen drive with Debian built by
       live-build to add a third partition to it, but the obvious
       way - to run fdisk or something similar to it, add another
       partition, format it, and so on - doesn't work
<edrx> because fdisk (and gparted, which I also tested) give lots
       of warnings about the GPT partition table being sort of
       broken, as if I tell them to go ahead and make the third
       partition anyway the rest gets corrupted, and when I boot
       the pen drive I get this:
       http://angg.twu.net/tmp/live-build-partition-3-bug-2018may29.jpg
<edrx> anyway
<edrx> I decided to take a blank pen drive, partition it with
       gparted - with a third partition -, and copy the files from
       the image produced by live-build to it
<edrx> and now I have pen drive that has all the files that
       isohybrid would use
<edrx> is it possible to run isohybrid on that, make it locate the
       files that it needs - that are all already on partition 1 -
       and make isohybrid only write the boot record things?







#####
#
# The syslinux mailing list
# 2018jun03
#
#####

# «mailing-list» (to ".mailing-list")
# https://www.syslinux.org/archives/





#####
#
# isohybrid
# 2018jun03
#
#####

# «isohybrid» (to ".isohybrid")
# (find-udfile "syslinux/README" "isolinux.txt")
# (find-udfile "syslinux/isolinux.txt.gz" "\"hybrid mode\"")
# (find-udfile "syslinux/isolinux.txt.gz" "USB key")
# (find-man "1 isohybrid")
# (find-man "1 isohybrid" "USB key")
# https://www.syslinux.org/wiki/index.php?title=Isohybrid

# (find-pen-links)
# (find-sh "sudo ls -l /dev/disk/by-id/*usb* | cut -b 56-")

 (eepitch-shell)
mkdir /tmp/pen/
sudo mount -o uid=$UID         /dev/sdb1 /tmp/pen/
# (find-fline "/tmp/pen/")

isohybrid --help
           Display help.

       -v, --verbose


sudo umount /tmp/pen
sync














https://www.syslinux.org/wiki/index.php?title=The_Syslinux_Project
https://www.syslinux.org/wiki/index.php?title=ISOLINUX
https://www.syslinux.org/wiki/index.php?title=ISOLINUX#How_Can_I_Make_a_Bootable_CD_With_ISOLINUX.3F
https://www.syslinux.org/wiki/index.php?title=ISOLINUX#Isohybrid
https://www.syslinux.org/wiki/index.php?title=Isohybrid
https://wiki.archlinux.org/index.php/syslinux
https://wiki.archlinux.org/index.php/syslinux#UEFI_Systems






#  Local Variables:
#  coding:               utf-8-unix
#  End:
