#######
#
# E-scripts about Tallin (Diagrams 2020 and other things).
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/tallin.e>
#           or at <http://angg.twu.net/e/tallin.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# (find-es "tex" "llncs")
# (taa)


% Topics of Interest (Main Track)
% 
% Conference topics include, but are not limited to:
% 
% – applications of diagrams,
% – computational models of reasoning with, and interpretation of, diagrams,
% – design of diagrammatic notations,
% – diagram understanding by humans or machines,
% – diagram aesthetics and layout,
% – educational uses of diagrams,
% – evaluation of diagrammatic notations,
% – graphical communication and literacy,
% – heterogeneous notations involving diagrams,
% – history of diagrammatic notations,
% – information visualization using diagrams,
% – nature of diagrams and diagramming,
% – novel technologies for diagram use,
% – philosophy of diagrams (separate call),
% – psychological issues pertaining to diagrams (separate call),
% – reasoning with diagrams,
% – semiotics of diagrams,
% – software to support the use of diagrams, and
% – usability and human-computer interaction issues concerning diagrams.
% 
% In addition to the main track, Diagrams 2020 will have the special
% tracks of philosophy of diagrams and psychology of diagrams. If the
% main research contribution of your submission is considered to be on
% either of these themes, you are strongly encouraged to submit to the
% respective special track, each of which has a dedicated program
% committee.
% 
% ****************************************************************************
% Submission Categories
% 
% Diagrams 2020 will include presentations of refereed Papers,
% Abstracts, and Posters, alongside tutorials, workshop sessions, and a
% graduate symposium.
% 
% We invite submissions for peer review that focus on any aspect of
% diagrams research, as follows:
% 
% – Long Papers (16 pages)
% – Abstracts (3 pages)
% – Short Papers (8 pages)
% – Posters (4 pages – this is both a maximum and minimum requirement)
% 
% All submissions should include diagrams where appropriate. Submission
% of Long Papers, Abstracts, Short Papers, and Posters should be made to
% either the main conference track, or one of the special session
% tracks, on the philosophy of diagrams and the psychology of diagrams.
% 
% Long Papers and Short Papers should report on original research
% contributions.
% 
% Submissions to the Abstracts category should report on significant
% research contributions, which may have been published elsewhere (such
% submissions must clearly cite prior work) or are intended to be
% published elsewhere. The contribution should be of a similar level to
% that expected of a Long Paper. Submissions to the Abstracts category
% will not be included as an archival contribution in the proceedings,
% but will be made available in hard-copy form at the conference.
% Accepted Abstract submissions will be offered the same presentation
% time in the program as Long papers. High quality Abstract submissions
% that nonetheless fall short of the standard required for full
% acceptance may be accepted for a short presentation. The Abstracts
% submission category is not intended for work-in-progress; the Poster
% submission category should be used for work-in-progress.
% 
% Posters may report on original, yet early stage, research or on
% previously published research that is of interest to the Diagrams
% community (such submissions must clearly cite prior work).






#  Local Variables:
#  coding:               utf-8-unix
#  End:
