\#######
#
# E-scripts on telegram.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/telegram.e>
#           or at <http://angg.twu.net/e/telegram.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.api»			(to "api")
# «.cli»			(to "cli")
# «.inlatexbot»			(to "inlatexbot")
# «.supergroup»			(to "supergroup")
# «.channels»			(to "channels")
# «.desktop»			(to "desktop")
# «.telega»			(to "telega")
#   «.telega-server»		(to "telega-server")
#   «.eev-telega»		(to "eev-telega")
#   «.telega-tme»		(to "telega-tme")
# «.two-step-verification»	(to "two-step-verification")
# «.sci-hub»			(to "sci-hub")
# «.2022-march-STF»		(to "2022-march-STF")

# (find-es "android" "telegram")






#####
#
# Telegram API
# 2018mar14
#
#####

# «api» (to ".api")
# https://core.telegram.org/api





#####
#
# cli
# 2018mar14
#
#####

# «cli» (to ".cli")
# https://telegram.org/apps#source-code
# https://github.com/vysheng/tg
# https://www.quora.com/Is-there-any-way-to-save-Telegram-chats
# https://www.quora.com/Is-there-any-way-to-save-Telegram-chats/answer/Samim-Pezeshki
# https://github.com/psamim/telegram-cli-backup

# https://luarocks.org/modules/si-kabayan/tdcli.lua
# A simple Lua library for the telegram-cli.




#####
#
# InLaTeXbot
# 2020mar23
#
#####

# «inlatexbot» (to ".inlatexbot")
# https://github.com/vdrhtc/InLaTeXbot
# http://t.me/InLaTeXbot
# https://web.telegram.org/#/im?p=@InLaTeXbot

% Test:

$\bfig
  \morphism(300,0)/->/<-300,-375>[{A}`{FA};{}]
  \morphism(300,0)/->/<300,-375>[{A}`{GA};{}]
  \morphism(0,-375)|b|/->/<600,0>[{FA}`{GA};{TA}]
  \morphism(300,0)/|->/<0,-375>[{A}`{\phantom{O}};{}]
  \efig
$


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/InLaTeXbot/
cd      ~/usrc/
git clone https://github.com/vdrhtc/InLaTeXbot
cd      ~/usrc/InLaTeXbot/

export PAGER=cat
git branch --list -a
git for-each-ref
git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/InLaTeXbot/")
# (find-gitk  "~/usrc/InLaTeXbot/")

# (code-c-d "inlatexbot" "~/usrc/InLaTeXbot/")
# (find-inlatexbotfile "")





#####
#
# supergroup
# 2020sep14
#
#####

# «supergroup»  (to ".supergroup")

https://technology.onehowto.com/article/what-is-telegram-supergroup-12892.html
https://pt.wikihow.com/Converter-um-Grupo-do-Telegram-para-Supergrupo-em-um-iPhone-ou-iPad
https://medium.com/@weibeld/telegram-basics-7c566d6d35c1
https://telegram.org/faq#usernames-and-t-me

How do I create a supergroup group in telegram?

Tap the three vertical dots icon.

This button is in the upper-right corner of the group info page. It
will open a drop-down menu. If you tap the three dots icon in the
group conversation before you open the group info page, you will not
have the option to convert to a supergroup.




#####
#
# channels
# 2020sep14
#
#####

# «channels»  (to ".channels")
# https://telegram.org/faq_channels




#####
#
# desktop
# 2021apr10
#
#####

# «desktop»  (to ".desktop")
# https://getdesktop.telegram.org/
# (find-man "1 tar")
# (find-man "1 tar" "-J, --xz")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/")
# (find-fline "/tmp/Telegram/")

sudo rm -Rv /home/Telegram
sudo tar -C /home/ -xvJf tsetup.2.7.1.tar.xz
cd /home/Telegram/
./Updater

# cd /tmp/
# tar -xvJf tsetup.2.7.1.tar.xz
# cd /tmp/Telegram/
# ./Updater




#####
#
# telega
# 2021jul03
#
#####

# «telega»  (to ".telega")
# (find-es "telega")





#####
#
# telega-tme
# 2022oct21
#
#####

# «telega-tme»  (to ".telega-tme")
# (find-epackage-links 'telega "telega" t)
# (find-epackage       'telega)
# (code-c-d "telega" "~/.emacs.d/elpa/telega-20221015.1120/")
# (find-telegafile "")
# (find-telegafile "telega-tme.el")
# (find-telegafile "telega-tme.el" "defun telega-tme-open")
# (find-telegafile "telega-tme.el" "defun telega-tme-internal-link-to")

There is telega-tme-internal-link-to to create a link to the object
(chat, message or file) and telega-tme-open-tg to open it




#####
#
# eev-telega
# 2022mar20
#
#####

# «eev-telega»  (to ".eev-telega")
# (find-angg "elisp/eev-telega.el")

(defun t0 () (interactive) (find-ebuffer "*Telega Root*"))
(defun tb () (interactive) (find-ebuffer "◀[telega.el@emacs_telega]"))
(defun te () (interactive) (find-fline "~/e/telegram.e"))
(defun t2 () (interactive) (find-2a '(te) '(tb)))




#####
#
# two-step-verification
# 2021jul03
#
#####

# «two-step-verification»  (to ".two-step-verification")
# https://en.wikipedia.org/wiki/Multi-factor_authentication




#####
#
# sci-hub
# 2022jan29
#
#####

# «sci-hub»  (to ".sci-hub")
# Go to this link: https://telegram.me/scihubot




#####
#
# 2022-march-STF
# 2022oct21
#
#####

# «2022-march-STF»  (to ".2022-march-STF")
2022mar18:

NEKORB

It seems that we had an issue with emails going between our
telegram.org corporate addresses and the Brazilian Supreme Court. As a
result of this miscommunication, the Court ruled to ban Telegram for
being unresponsive.
    
On behalf of our team, I apologize to the Brazilian Supreme Court for
our negligence. We definitely could have done a better job.
    
We complied with an earlier court decision in late February and
responded with a suggestion to send future takedown requests to a
dedicated email address. Unfortunately, our response must have been
lost, because the Court used the old general-purpose email address in
further attempts to reach us. As a result, we missed its decision in
early March that contained a follow-up takedown request. Luckily, we
have now found and processed it, delivering another report to the
Court today.
    
Because tens of millions of Brazilians rely on Telegram to communicate
with family, friends and colleagues, I ask the Court to consider
delaying its ruling for a few days at its discretion to allow us to
remedy the situation by appointing a representative in Brazil and
setting up a framework to react to future pressing issues like this in
an expedited manner.
    
The last 3 weeks have been unprecedented for the world and for
Telegram. Our content moderation team was flooded with requests from
multiple parties. However, I am certain that once a reliable channel
of communication is established, we'll be able to efficiently process
takedown requests for public channels that are illegal in Brazil.




Forwarded message
Entendendo o Telegram
Pavel Durov responde ao STF do Brasil

Parece que tivemos um problema com e-mails entre nossos endereços
corporativos do telegram.org e o Supremo Tribunal Federal. Como
resultado dessa falha de comunicação, o Tribunal decidiu proibir o
Telegram por não responder.
    
Em nome de nossa equipe, peço desculpas ao Supremo Tribunal Federal
por nossa negligência. Definitivamente, poderíamos ter feito um
trabalho melhor.
    
Cumprimos uma decisão judicial anterior no final de fevereiro e
respondemos com uma sugestão de enviar futuras solicitações de remoção
para um endereço de e-mail dedicado. Infelizmente, nossa resposta deve
ter sido perdida, porque o Tribunal usou o antigo endereço de e-mail
de uso geral em outras tentativas de entrar em contato conosco. Como
resultado, perdemos sua decisão no início de março que continha uma
solicitação de remoção de acompanhamento. Felizmente, já o encontramos
e processamos, entregando hoje outro relatório ao Tribunal.
    
Como dezenas de milhões de brasileiros contam com o Telegram para se
comunicar com familiares, amigos e colegas, peço ao Tribunal que
considere adiar sua decisão por alguns dias, a seu critério, para nos
permitir remediar a situação nomeando um representante no Brasil e
estabelecendo uma estrutura para reagir a futuras questões urgentes
como esta de maneira acelerada.
    
As últimas 3 semanas foram inéditas para o mundo e para o Telegram.
Nossa equipe de moderação de conteúdo foi inundada com solicitações de
várias partes. No entanto, estou certo de que, uma vez estabelecido um
canal de comunicação confiável, poderemos processar com eficiência as
solicitações de remoção de canais públicos que são ilegais no Brasil.

Fonte: Durov's Channel

18/03/2022 #Durov #Bloqueio #Telegram #STF

Via: @EntendendoTelegram







https://m.youtube.com/watch?v=2uxmcdxlbD0&feature=youtu.be




https://telegram.org/blog/inline-bots
https://core.telegram.org/bots



https://gadgets.ndtv.com/apps/news/telegram-export-chats-notifications-exceptions-passport-encryption-1906903

https://www.emacswiki.org/emacs/ZajcevEvgeny
https://github.com/zevlg
https://github.com/zevlg?tab=repositories
https://github.com/phil-r/hackernewsbot





#  Local Variables:
#  coding:               utf-8-unix
#  End:
