#######
#
# E-scripts on packing and transporting
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/transp.e>
#           or at <http://angg.twu.net/e/transp.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




######
#
# moving to another angg partition
#
######

cd
A=(
.Xdefaults
.emacs
.fetchmailrc
.fvwm2/
.netrc
.xinitrc
.xmame/robotron.cfg
.zshrc
C/math1.8
C/math850.map
EXPECT/
TCL/PAGE/*.th
TCL/PAGE/.*
TCL/PAGE/Makefile
TCL/html.005
ZHTML/escripts/*.e
bin/gravis-up
bin/inx-down
bin/inx-up
bin/inx.dip
eev.el
replace/defkeymap*.map
replace/ega*
)
tar -cvzf /tmp/home.tgz $A
laf /tmp/home.tgz

cd /
A=(
/etc/apt/sources.list
/etc/group
/etc/inittab
/etc/passwd
/etc/securetty
/home/bin
/home/replace
/usr/lib/games/xmame/robotron.hi
/usr/lib/games/xmame/roms/robotron.zip
)
tar -cvzf /tmp/bar.tgz $A
laf /tmp/bar.tgz







#######
#
# angg -> nautilus 99jan12
#
#######

cd ~
tar -cvzf angg.tgz ZHTML/escripts/*.e .zshrc .emacs TK/Edit CRIM/010ideas
laf angg.tgz
ftp $SACI <<'---'
  hash on
  binary
  prompt off
  put angg.tgz
  quit
---



#######
#
# arquivos pra levar pra raven, 98ago??
#
#######

cd ~
tar -cvzf toraven3.tgz .zshrc .emacs CRIM/009ideas CRIM/lixo9 \
  ZHTML/escripts/debian.e ZHTML/escripts/debian0.e CB/*.txt odlist \
  ocn ocnb1 ocnb1ppp ICON/lslR2find.icn



#######
#
# idem, 98aug25
#
#######

dpkg --root=/b1 --list > ~/dlistb1
dpkg 		--list > ~/dlistb6

cd /home/root
tar -cvzf /home/short.tgz HA HASH

cd /
tar -cvzf /home/aug25.tgz $(<<'---'
/home/short.tgz
/home/deb-bin.tgz
/home/deb-src.tgz
/home/root/CB/CD1ls-lR.i
/home/root/CB/CD2ls-lR.i
/home/root/CB/CD3ls-lR.i
/home/root/CB/bin-ls-lR.i
/home/root/CB/e1-ls-lR.i
/home/root/CB/e2-ls-lR.i
/home/root/CB/src-ls-lR.i
/home/root/CRIM/009ideas
/home/root/ICON/detrans.icn
/home/root/ICON/detrans2.icn
/home/root/ICON/hlang1.icn
/home/root/ZHTML/emacs.ht
/home/root/ZHTML/escripts/debian.e
/home/root/ZHTML/linux.ht
/home/root/dlistb1
/home/root/dlistb6
---)







cd
tar -cvzf ~/a.tgz ZHTML/escripts/*.e .zshrc PERL/urlchop
laf a.tgz



cd
tar -cvzf ~/a.tgz \
	.emacs	\
	.fvwmrc	\
	.zshrc	\
	XF86Config	\
	PERL/dscchop	\
	PERL/urlchop	\
	PERL/ptrans	\
	PERL/edrxlib.pl	\
	ZHTML/escripts/*.e	\
	ZHTML/*.html	\
	ICON/*.icn	\
	bin/alta-s	\
	bin/deja	\
	bin/sne		\
	bin/inx-down	\
	bin/inx-up	\
	bin/inx.dip	\
	replace/defkeymap*.map	\
	replace/ega*	\

laf a.tgz





cd
tar -cvzf ~/a.tgz \
	.emacs	\
	.zshrc	\
	XF86Config	\
	PERL	\
	ZHTML/escripts/*.e	\
	replace/defkeymap*.map	\
	mich*	\

laf a.tgz



cd ~
tar -cvzf ~/gm.tgz \
	bis/PERL/mail-003.cgi	\
	bis/PERL/settings.pl	\
	bis/PERL/gmlib.pl	\
	bis/PERL/cadastro.htm	\
	bis/PERL/cadastro.html	\
	bis/PERL/checkboxes	\
	ZHTML/escripts/*.e	\
	.zshrc	\
	.emacs	\
	replace/defkeymap*.map	\
	PERL/urlchop	\

laf ~/gm.tgz




A=(
.Xdefaults
.bashrc
.config2035
.config2035-sc
.config2035angg
.config2035lea
.dialdir
.dosemu/
.dosemurc
.emacs
.fetchmailrc
.fvwm2/
.fvwmrc
.lynxrc
.mtoolsrc
.netrc
.preferences
.profile
.secret
.tkdesk/
.wgetrc
.xinitrc
.zshrc
ZHTML/
bin/
PERL/
replace/
)
cd ~
tar -cvzf a.tgz $A ICON/*.icn
laf a.tgz





#####
#
# -> boto
# 99sep02
#
#####

# (find-fline "$PAGE/")
# (find-fline "$PAGE/.anggfiles")
# (find-fline "$PAGE/.escripts")

cd
tar -cvzf /tmp/angghome.tgz $(grep -v '^#' $PAGE/.anggfiles)
cd $ES
tar -cvzf /tmp/e.tgz $(for i in $(grep -v '^#' $PAGE/.escripts); do echo $i.e; done)

cd /tmp
tar -tvzf angghome.tgz
tar -tvzf e.tgz
laf angghome.tgz e.tgz






#  Local Variables:
#  coding:               utf-8-unix
#  End:
