#######
#
# E-scripts on tree-sitter.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/treesit.e>
#           or at <http://angg.twu.net/e/treesit.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.tree-sitter.git»	(to "tree-sitter.git")
# «.ruby-ts-mode»	(to "ruby-ts-mode")
# «.yaml»		(to "yaml")



(find-es "emacs" "tree-sitter")



#####
#
# tree-sitter.git
# 2022dec18
#
#####

# «tree-sitter.git»  (to ".tree-sitter.git")
# (find-es "git" "emacs30-from-git")
# (find-fline "~/LOGS/2022dec18.emacs" "admin/notes/tree-sitter/starter-guide")
# (find-gitemacsfile "admin/notes/tree-sitter/starter-guide")
# (find-git-links "https://github.com/tree-sitter/tree-sitter.git" "treesittergit")
# (code-c-d "treesittergit" "~/usrc/tree-sitter/")
# (find-treesittergitfile "")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/tree-sitter/
cd      ~/usrc/
git clone https://github.com/tree-sitter/tree-sitter.git
cd      ~/usrc/tree-sitter/

export PAGER=cat
git branch --list -a
git for-each-ref
git log --oneline --graph --all -20

make              |& tee om
sudo make install |& tee omi

# (find-fline "~/usrc/")
# (find-fline "~/usrc/tree-sitter/")
# (find-gitk  "~/usrc/tree-sitter/")

# (code-c-d "treesittergit" "~/usrc/tree-sitter/")
# (find-treesittergitfile "")

./temacs: error while loading shared libraries: libtree-sitter.so.0: cannot open shared object file: No such file or directory



#####
#
# ruby-ts-mode
# 2022dec18
#
#####

# «ruby-ts-mode»  (to ".ruby-ts-mode")
# https://github.com/pedz/ruby-ts-mode
# (code-c-d "rubytsmode" "~/usrc/ruby-ts-mode/")
# (find-rubytsmodefile "")
# (find-rubytsmodefile "ruby-ts-mode.el" "with tree-sitter enabled")
# (find-rubytsmodefile "ruby-ts-mode.el" "The tree sitter binary")


# (find-epackages 'tree-sitter)
# (find-epackage 'tree-sitter)
# (find-epackage 'tree-sitter-langs)
# (find-epackages 'tsc)


<parsnip> edrx: i did ./configure --with-tree-sitter


https://ahelwer.ca/post/2023-01-11-tree-sitter-tlaplus/ Writing a TLA+ tree-sitter grammar
https://en.wikipedia.org/wiki/TLA%2B

# (find-node "(elisp)Tree-sitter Major Modes")
# (find-node "(elisp)Parsing Program Source")
# (find-node "(emacs)Parser-based Font Lock")
treesit-available-p
https://www.masteringemacs.org/article/how-to-get-started-tree-sitter
treesit-install-language-grammar
(treesit-language-available-p 'python)
https://www.masteringemacs.org/article/combobulate-structured-movement-editing-treesitter
https://github.com/mickeynp/combobulate
https://news.ycombinator.com/item?id=37494595 Let's write a treesitter major mode for Emacs (masteringemacs.org)
# (find-fline "~/.emacs.d/tree-sitter/")
# (find-efunction 'treesit-install-language-grammar)
# (find-evardescr 'treesit-language-source-alist)
# (find-evariable 'treesit-language-source-alist)




#####
#
# yaml
# 2024feb16
#
#####

# «yaml»  (to ".yaml")

⛔ Warning (treesit): Cannot activate tree-sitter, because language grammar for yaml is unavailable (not-found): (libtree-sitter-yaml libtree-sitter-yaml.0 libtree-sitter-yaml.0.0 libtree-sitter-yaml.so libtree-sitter-yaml.so.0 libtree-sitter-yaml.so.0.0) No such file or directory
⛔ Warning (treesit): Cannot activate tree-sitter, because language grammar for yaml is unavailable (not-found): (libtree-sitter-yaml libtree-sitter-yaml.0 libtree-sitter-yaml.0.0 libtree-sitter-yaml.so libtree-sitter-yaml.so.0 libtree-sitter-yaml.so.0.0) No such file or directory

(treesit-install-language-grammar 'yaml)



# (find-fline "~/LOGS/2024may04.emacs" "https://siraben.dev/2022/03/01/tree-sitter.html")
# https://siraben.dev/2022/03/01/tree-sitter.html






#  Local Variables:
#  coding:               utf-8-unix
#  End:
