#######
#
# E-scripts on trisquel.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/trisquel.e>
#           or at <http://angg.twu.net/e/trisquel.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.trisquel-mini»		(to "trisquel-mini")
# «.non-free»			(to "non-free")
# «.unrar-nonfree-deb-src»	(to "unrar-nonfree-deb-src")
# «.phased-update-percentage»	(to "phased-update-percentage")
# «.do-release-upgrade»		(to "do-release-upgrade")
# «.pen-drive-2018»		(to "pen-drive-2018")
# «.pen-drive-efi-partition»	(to "pen-drive-efi-partition")
# «.persistent»			(to "persistent")
# «.distros»			(to "distros")
# «.dist-upgrade-to-flidas»	(to "dist-upgrade-to-flidas")
# «.irc»			(to "irc")
# «.bug-tracker»		(to "bug-tracker")
# «.package-helpers»		(to "package-helpers")
# «.web-browsers»		(to "web-browsers")
# «.abrowser»			(to "abrowser")




# http://trisquel.info/en/wiki/documentation
# http://wiki.sugarlabs.org/go/Trisquel_On_A_Sugar_Toast


trisquel

# (find-zsh "installeddebs | sort | grep trisquel")
# (find-zsh "availabledebs | sort | grep trisquel")

trisquel-base-data_7.0-1.deb
trisquel-base-recommended_7.0-39.deb
trisquel-base_7.0-39.deb
trisquel-codecs_7.0-39.deb
trisquel-desktop-common-data_7.0-16.deb
trisquel-desktop-common-recommended_7.0-39.deb
trisquel-desktop-common_7.0-39.deb
trisquel-gnome-base-recommended_7.0-39.deb
trisquel-gnome-base_7.0-39.deb
trisquel-gtk-theme_7.0-8.deb
trisquel-icon-theme_7.0-4.deb
trisquel-keyring_4.5-1.deb
trisquel-mini-data_7.0-2.deb
trisquel-mini-recommended_7.0-39.deb
trisquel-mini_7.0-39.deb
trisquel-minimal_7.0-39.deb
trisquel-recommended_7.0-39.deb
trisquel-release-upgrader-core_0.220.8+7.0trisquel12.deb
trisquel-release-upgrader-gtk_0.220.8+7.0trisquel12.deb
trisquel-release-upgrader-qt_0.220.8+7.0trisquel12.deb
trisquel-session_3.8.0-1ubuntu12.2+7.0trisquel11.deb
trisquel-sounds_7.0.deb
trisquel-sugar-recommended_7.0-39.deb
trisquel-sugar_7.0-39.deb
trisquel-wallpapers_7.0-1.deb
trisquel_7.0-39.deb




#####
#
# trisquel-mini
# 2018mai08
#
#####

# «trisquel-mini» (to ".trisquel-mini")
# (find-zsh "installeddebs | sort | grep trisquel")
# (find-zsh "availabledebs | sort | grep trisquel")
# (find-zsh "installeddebs | sort | grep trisquel-mini")
# (find-zsh "availabledebs | sort | grep trisquel-mini")

# (find-status   "trisquel-mini-data")
# (find-vldifile "trisquel-mini-data.list")
# (find-udfile   "trisquel-mini-data/")
# (find-status   "trisquel-mini-recommended")
# (find-vldifile "trisquel-mini-recommended.list")
# (find-udfile   "trisquel-mini-recommended/")
# (find-status   "trisquel-mini")
# (find-vldifile "trisquel-mini.list")
# (find-udfile   "trisquel-mini/")
# (find-status   "trisquel-minimal")
# (find-vldifile "trisquel-minimal.list")
# (find-udfile   "trisquel-minimal/")




#####
#
# how to add non-free repositories to trisquel
# 2018dec03
#
#####

# «non-free» (to ".non-free")
# https://wiki.debian.org/SourcesList
# https://unix.stackexchange.com/questions/45879/how-to-add-repository-from-shell-in-debian
# https://help.ubuntu.com/community/Repositories/Ubuntu



#####
#
# unrar-nonfree (from the debian sources)
# 2015dec22
#
#####

# «unrar-nonfree-deb-src» (to ".unrar-nonfree-deb-src")
# http://ftp.debian.org/debian/pool/non-free/u/unrar-nonfree/
# http://ftp.debian.org/debian/pool/non-free/u/unrar-nonfree/unrar-nonfree_5.3.2-1.dsc
# http://ftp.debian.org/debian/pool/non-free/u/unrar-nonfree/unrar-nonfree_5.3.2.orig.tar.gz
# http://ftp.debian.org/debian/pool/non-free/u/unrar-nonfree/unrar-nonfree_5.3.2-1.debian.tar.xz
#
rm -Rv ~/usrc/unrar-nonfree/
mkdir  ~/usrc/unrar-nonfree/
cd $S/http/ftp.debian.org/debian/pool/non-free/u/unrar-nonfree/
cp -v unrar-nonfree_5.3.2* ~/usrc/unrar-nonfree/
cd     ~/usrc/unrar-nonfree/
dpkg-source -sn -x unrar-nonfree_5.3.2-1.dsc
cd     ~/usrc/unrar-nonfree/unrar-nonfree-5.3.2/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/unrar-nonfree/")
 (eepitch-shell)
cd ~/usrc/unrar-nonfree/
sudo dpkg -i *.deb

#
# (code-c-d "unrarnonfree" "~/usrc/unrar-nonfree/unrar-nonfree-5.3.2/")
# (find-unrarnonfreefile "")




#####
#
# Phased-Update-Percentage
# 2016feb14
#
#####

# «phased-update-percentage» (to ".phased-update-percentage")
# https://lwn.net/Articles/563966/
# https://wiki.ubuntu.com/PhasedUpdates
# (find-available "gdb-minimal")
# (find-available "gdb-minimal" "Phased-Update-Percentage")




#####
#
# do-release-upgrade
# 2018abr25
#
#####

# «do-release-upgrade» (to ".do-release-upgrade")

# https://unix.stackexchange.com/questions/255749/what-is-debians-equivalent-of-do-release-upgrade-to-upgrade-the-operating-syste

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo do-release-upgrade

# (find-zsh "w do-release-upgrade")
# (find-fline "/usr/bin/do-release-upgrade")


Updating repository information

Third party sources disabled 

Some third party entries in your sources.list were disabled. You can 
re-enable them after the upgrade with the 'software-properties' tool 
or your package manager. 

To continue please press [ENTER]






#####
#
# Bootable pen drive 2018
# 2018abr22
#
#####

# «pen-drive-2018» (to ".pen-drive-2018")
# https://trisquel.info/en/download
# http://mirror.fsf.org/trisquel-images/
# http://mirror.fsf.org/trisquel-images/trisquel-mini_8.0_amd64.iso
# http://mirror.fsf.org/trisquel-images/trisquel-mini_8.0_amd64.iso.md5
# https://trisquel.info/en/wiki/how-create-liveusb
#   Windows (Universal USB Installer (GPLv2))

# (find-man "md5sum")
# (find-fline "$S/http/mirror.fsf.org/trisquel-images/")
cd $S/http/mirror.fsf.org/trisquel-images/
md5sum -c trisquel-mini_8.0_amd64.iso.md5

# (find-pen-links nil)
# (find-man "sync")
cd $S/http/mirror.fsf.org/trisquel-images/
sudo dd if=trisquel-mini_8.0_amd64.iso of=/dev/sdb
sync

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo fdisk /dev/sdb

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mkdir /tmp/pen1
mkdir /tmp/pen2
sudo mount -o ro /dev/sdb1 /tmp/pen1
sudo mount -o ro /dev/sdb2 /tmp/pen2
# (find-fline "/tmp/pen1/")
# (find-fline "/tmp/pen1/.disk/")
# (find-fline "/tmp/pen1/.disk/release_notes_url")
# (find-fline "/tmp/pen1/casper/" "filesystem.manifest")
# (find-fline "/tmp/pen1/casper/" "filesystem.squashfs")
# (find-fline "/tmp/pen1/isolinux/")
# (find-fline "/tmp/pen1/isolinux/back.jpg")
# (find-fline "/tmp/pen1/isolinux/en.hlp")
# (find-fline "/tmp/pen1/isolinux/dtmenu.cfg")
# (find-fline "/tmp/pen1/isolinux/menu.cfg")
# (find-fline "/tmp/pen2/")
# (find-fline "/tmp/pen2/EFI/BOOT/")

# (find-es "plurall" "isolinux")
# (find-es "hd" "EFI")




#####
#
# Trisquel pen drive: its mysterious EFI partition
# 2018mai15
#
#####

# «pen-drive-efi-partition» (to ".pen-drive-efi-partition")
# (find-es "hd" "EFI")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mkdir /tmp/pen1/
mkdir /tmp/pen2/
mkdir /tmp/efi/
sudo mount -o ro                       /dev/sdb1 /tmp/pen1/
sudo mount -o ro                       /dev/sdb2 /tmp/pen2/
sudo mount -o ro,loop /tmp/pen1/EFI/BOOT/efi.img /tmp/efi/
# (find-fline "/tmp/pen1/")
# (find-fline "/tmp/pen2/")
# (find-fline "/tmp/pen1/EFI/BOOT/")
# (find-fline "/tmp/pen1/EFI/BOOT/" "efi.img")
# (find-fline "/tmp/pen2/EFI/BOOT/")
# (find-fline "/tmp/efi/")
# (find-fline "/tmp/efi/EFI/BOOT/")

cd /tmp/efi/EFI/BOOT/
for i in *; do echo $i; cmp $i /tmp/pen2/EFI/BOOT/$i; done
for i in *; do echo $i; cmp $i /tmp/pen1/EFI/BOOT/$i; done
cd

sudo umount /tmp/efi
sudo umount /tmp/pen1
sudo umount /tmp/pen2
sync








#####
#
# persistent storage
# 2018mai01
#
#####

# «persistent» (to ".persistent")
# https://ubuntuforums.org/showthread.php?t=2335723 How to save live CD/DVD changes in "/cow/upper" to persistent storage
# https://help.ubuntu.com/community/LiveCD/Persistence
# https://www.howtogeek.com/howto/14912/create-a-persistent-bootable-ubuntu-usb-flash-drive/
# https://www.maketecheasier.com/persistent-live-usb-vs-full-install-usb/ 
# https://trisquel.info/it/forum/how-set-trisquel-persistent-live-system-booting-directly-flash-drive
# https://trisquel.info/en/forum/i-recently-had-interesting-idea-and-then-found-someone-did-it-librepup
# https://archiveos.org/librepup/
# https://trisquel.info/en/forum/persistent-live-usb-only-remember-settings-laptops-not-desktops
# http://murga-linux.com/puppy/viewtopic.php?t=101106 Puppy Linux Discussion Forum

# (find-sh "dmesg")
# sudo cfdisk /dev/sdb
sudo parted /dev/sdb

# (find-es "hd" "parted")





#####
#
# (Names of) Trisquel distros
# 2018mai17
#
#####

# «distros» (to ".distros")
# (find-fline "/etc/debian_version")
# (find-fline "/etc/debian_version" "jessie/sid")
# (find-fline "/etc/apt/sources.list")
# https://trisquel.info/en/trisquel-70-lts-belenos
# https://trisquel.info/en/wiki/trisquel-70-lts-belenos
# https://en.wikipedia.org/wiki/Trisquel
# https://trisquel.info/en/forum/upgrading-trisquel-8




#####
#
# dist-upgrade to Flidas
# 2018mai17
#
#####

# «dist-upgrade-to-flidas» (to ".dist-upgrade-to-flidas")
# https://trisquel.info/en/forum/upgrading-trisquel-8
# https://trisquel.info/en/forum/testing-trisquel-8-upgrade-process

# Upgrade to Trisquel 8 (Flidas):

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo apt-get update
sudo apt-get upgrade
sudo apt-get dist-upgrade




#####
#
# The #trisquel irc channel
# 2019jan19
#
#####

# «irc» (to ".irc")

(defun t2 () (interactive)
  (find-rcirc-buffer-2a "irc.freenode.net" "#eev #trisquel" nil "#trisquel"))
(defun t3 () (interactive)
  (find-rcirc-buffer-3a "irc.freenode.net" "#eev #trisquel" nil "#trisquel"))




#####
#
# The Trisquel bug tracker
# 2019jan19
#
#####

# «bug-tracker» (to ".bug-tracker")
# https://trisquel.info/en/project/issues
# https://trisquel.info/en/project/issues?text=network-manager&projects=&status=Open&priorities=All&categories=All
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgxwBVMdxFCSbSbRTFFXttCqQVrxM register; S+
# https://trisquel.info/en/issues/25393 "apt-get build-dep network-manager" fails

"apt-get build-dep network-manager" fails


When I run "apt-get build-dep network-manager" it aborts with this:

  The following packages have unmet dependencies:
  builddeps:network-manager : Depends: libgnutls-dev but it is not
    going to be installed

and when I run "apt-get install libgnutls-dev" it gives this error:

  The following packages have unmet dependencies:
  libgnutls-dev : Depends: libgnutls30 (= 3.4.10-4ubuntu1.4) but
    3.5.18-1ubuntu1+8.0trisquel1 is to be installed


1) The only repository listed in /etc/apt/ here that is not
   trisquel/flidas is the one for google chrome,

2) I did run "apt-get update; apt-get upgrade",

3) "aptitude search '?obsolete'" doesn't report any obsolete packages,

4) I discussed this in the #trisquel IRC channel and joepublic got the
   same errors in his machine when he tried to install these
   build-deps and then libgnutls-dev by hand.






#####
#
# Package helpers
# 2019jan27
#
#####

# «package-helpers» (to ".package-helpers")
# https://trisquel.info/en/issues/25393
# https://devel.trisquel.info/trisquel/package-helpers/
# https://devel.trisquel.info/trisquel/package-helpers/tree/flidas/helpers




#####
#
# Web brosers
# 2019jan29
#
#####

# «web-browsers» (to ".web-browsers")
# (find-fline "/etc/alternatives/" "x-www-browser")
# (find-vldigrep "grep --color -nH --null -e x-www-browser *")




#####
#
# abrowser
# 2019jan29
#
#####

# «abrowser» (to ".abrowser")
# (find-fline "/usr/bin/")
# (find-fline "/usr/bin/sensible-browser")
# (find-status   "abrowser")
# (find-vldifile "abrowser.list")
# (find-udfile   "abrowser/")
# (find-sh-at-dir "/usr/bin/" "ls -lAF *browser*")
# (find-sh-at-dir "/usr/bin/" "ls -lAF *firefox*")










#  Local Variables:
#  coding:               utf-8-unix
#  End:
