#######
#
# E-scripts on playing, converting, recording and editing videos.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/video.e>
#           or at <http://angg.twu.net/e/video.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.deb-multimedia»		(to "deb-multimedia")
# «.avidemux»			(to "avidemux")
# «.cinelerra»			(to "cinelerra")
# «.recordmydesktop»		(to "recordmydesktop")
# «.ffmpeg-x11grab»		(to "ffmpeg-x11grab")
# «.minicats»			(to "minicats")
# «.mplayer»			(to "mplayer")
# «.youtube-dl»			(to "youtube-dl")
# «.play-in-browser»		(to "play-in-browser")
# «.kdenlive»			(to "kdenlive")
# «.aegisub»			(to "aegisub")
# «.youtube-time-link»		(to "youtube-time-link")
# «.youtube-uploading-long»	(to "youtube-uploading-long")
# «.video4-eepitch»		(to "video4-eepitch")
# «.subtitle-editors»		(to "subtitle-editors")
# «.subtitleeditor»		(to "subtitleeditor")
# «.twitcasting-recorded»	(to "twitcasting-recorded")
# «.vob-to-mp4»			(to "vob-to-mp4")



#####
#
# deb-multimedia
# 2013nov29
#
#####

# «deb-multimedia» (to ".deb-multimedia")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# http://www.deb-multimedia.org/
sudo apt-get update
sudo apt-get install deb-multimedia-keyring
sudo apt-get install avidemux



#####
#
# avidemux
# 2012feb04
#
#####

# «avidemux»  (to ".avidemux")
# (find-es "dvd" "subtitles-avidemux")
# (find-fline "/etc/apt/sources.list")
#   deb http://www.debian-multimedia.org stable main non-free
# http://www.avidemux.org/admWiki/doku.php?id=build:debian_install
# http://www.debian-multimedia.org/
# http://fixounet.free.fr/avidemux/
# http://www.avidemux.org/admWiki/doku.php
# http://www.avidemux.org/admWiki/doku.php?id=tutorial:guide_to_encoding_types
# http://www.avidemux.org/admWiki/doku.php?id=tutorial:h.264
# http://www.avidemux.org/admWiki/doku.php?id=tutorial:scripting_tutorial
# http://www.avidemux.org/admWiki/doku.php?id=using:scripting
# (find-status   "avidemux")
# (find-vldifile "avidemux.list")
# (find-udfile   "avidemux/")
# (find-status   "avidemux-cli")
# (find-vldifile "avidemux-cli.list")
# (find-udfile   "avidemux-cli/")

# (find-man "1 avidemux2_cli")

# (find-status   "debian-multimedia-keyring")
# (find-vldifile "debian-multimedia-keyring.list")
# (find-udfile   "debian-multimedia-keyring/")

apti avidemux avidemux-cli debian-multimedia-keyring

# http://news.softpedia.com/news/Convert-DVD-Video-to-AVI-with-Avidemux-54002.shtml




#####
#
# Cinelerra
# 2012feb05
#
#####

# «cinelerra»  (to ".cinelerra")
# (find-status   "cinelerra")
# (find-vldifile "cinelerra.list")
# (find-udfile   "cinelerra/")
# (find-status   "cinelerra-cv")
# (find-vldifile "cinelerra-cv.list")
# (find-udfile   "cinelerra-cv/")

cinelerra-cv-data_2.1.5-0.0.deb
cinelerra-cv-doc_2.1.5-0.0.deb
cinelerra-cv_2.1.5-0.0.deb
cinelerra-data_4.2-0.1.deb
cinelerra-doc_4.2-0.1.deb
cinelerra_4.2-0.1.deb

http://cinelerra.org/



# (find-status   "mencoder")
# (find-vldifile "mencoder.list")
# (find-udfile   "mencoder/")

# (find-status   "transcode")
# (find-vldifile "transcode.list")
# (find-udfile   "transcode/")
# (find-status   "transcode-doc")
# (find-vldifile "transcode-doc.list")
# (find-udfile   "transcode-doc/")

http://estudiolivre.org/tiki-index.php?page=Softwares+de+V%C3%ADdeo
http://estudiolivre.org/tiki-index.php?page=v%C3%ADdeo+tutorial+swf




#####
#
# RecordMyDesktop
# 2012feb08 / 2016oct20
#
#####

# «recordmydesktop»  (to ".recordmydesktop")
# (find-zsh "availabledebs | sort | grep recordmy")
# (find-status   "recordmydesktop")
# (find-vldifile "recordmydesktop.list")
# (find-udfile   "recordmydesktop/")
# (find-man "1 recordmydesktop")
# http://recordmydesktop.sourceforge.net/about.php

# About "--no-shared":
#   http://recordmydesktop.sourceforge.net/rug/p1_3d.php
#   If you disable it recordMyDesktop might require extravagant amounts of CPU. 





#####
#
# ffmpeg: x11grab
# 2012feb08
#
#####

# «ffmpeg-x11grab»  (to ".ffmpeg-x11grab")
# http://www.youtube.com/watch?v=EjbtlzOY7S4 Ubuntu Tutorial: Recording your Computer Screen Desktop
# Nixie Pixel's command line:
# ffmpeg -r 30 -s 1680x1050 -f x11grab -i :0.0 -vcodec msmpeg4v2 -qscale 2 filename.avi

# (find-sh "xwininfo")
# WxH of an F8-ed (fullscreen) Emacs:
#   Width: 1020
#   Height: 598
# WxH of an F7-ed (verticalized) Emacs:
#   Width:  498
#   Height: 598
# WxH of an ax00-ed (small) Emacs:
#   Width:  498
#   Height: 481

# http://www.sgenomics.org/~jtang/blog/posts/Using_FFMPEG_to_capture_an_X11_session___40__screencasting__63____41__/
#
# ffmpeg -f x11grab -s 498x598 -b 10000  -i :0.0+2229,231 out.avi
# According to the docs at ffmpeg, in my case
# 0.0 is display.screen number of your X11 server, same as the DISPLAY
# environment variable.
# 2229 is the x-offset and 231 the y-offset for the grabbing.
# 478x302 is the Height and Width of the window I want to capture,
# noticed I rounded it down to 302, this is because some (if not all)
# video formats require a number divisible by 2 (or even 4) for the
# input/output sizes
# 10000 is the bitrate in bits per second (need to check this), the
# bigger the value the better the quality.
# out.avi is of course the target output file.
# you can also specify the frame rate with the -r option
#
# (find-man "1 ffmpeg")
# (find-man "1 ffmpeg" "-f x11grab")
# (find-man "1 ffmpeg" "-s size")
# (find-man "1 ffmpeg" "-b bitrate")
# (find-man "1 ffmpeg" "-i :0.0+10,20")

# (eev "ffmpeg -f x11grab -s 498x598  -i $DISPLAY /tmp/out.avi")
# (eev "ffmpeg -f x11grab -s 498x481  -i $DISPLAY /tmp/out.avi")
# (eev "ffmpeg -f x11grab -s 498x482  -i $DISPLAY /tmp/out.ogv")
# (eev "ffmpeg -f x11grab -s 498x482  -i $DISPLAY /tmp/out.mp4")
# (eev "ffmpeg -f x11grab -s 498x482 -b 50k -i $DISPLAY /tmp/out.mp4")
# (eev "ffmpeg -f x11grab -s 498x482  -i $DISPLAY /tmp/out.swf")
# (find-angg "eev-puro/mini-lua-intro.e")
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
vlc /tmp/out.avi

# http://ubuntuforums.org/archive/index.php/t-1710642.html

# (find-elnode "Size and Position")
# (frame-pixel-width)
# (frame-pixel-height)




#####
#
# Minicourse on Category Theory
# 2012feb08
#
#####

# «minicats»  (to ".minicats")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /sda7/nikon/aula_2/
# (find-fline "/sda7/nikon/aula_2/")
# (find-es "video" "ffmpeg")
ffmpeg -i DSC_0002.MOV -ar 44100 -r 6 DSC_0002_6.flv
make -f ~/VIDEOS/Makefile DSC_0002_6.flv
make -f ~/VIDEOS/Makefile DSC_0003_6.flv
make -f ~/VIDEOS/Makefile DSC_0004_6.flv
make -f ~/VIDEOS/Makefile DSC_0005_6.flv
make -f ~/VIDEOS/Makefile DSC_0006_6.flv
make -f ~/VIDEOS/Makefile DSC_0007_6.flv
make -f ~/VIDEOS/Makefile DSC_0008_6.flv
make -f ~/VIDEOS/Makefile DSC_0009_6.flv
make -f ~/VIDEOS/Makefile DSC_0010_6.flv

# (find-fline "/sda7/nikon/aula_2/")
# (find-es "video" "ffmpeg")
cd /sda7/nikon/aula_2/
make -f ~/VIDEOS/Makefile DSC_0003_frames
make -f ~/VIDEOS/Makefile DSC_0004_frames
make -f ~/VIDEOS/Makefile DSC_0005_frames
make -f ~/VIDEOS/Makefile DSC_0006_frames
make -f ~/VIDEOS/Makefile DSC_0007_frames
make -f ~/VIDEOS/Makefile DSC_0008_frames
make -f ~/VIDEOS/Makefile DSC_0009_frames
make -f ~/VIDEOS/Makefile DSC_0010_frames



#####
#
# Mplayer
# 2012feb12
#
#####

# «mplayer»  (to ".mplayer")
# (find-angg ".emacs" "find-mplayer")
# (find-es "dvd" "mplayer-running")
# (eev "sudo apt-get -t squeeze-backports install mplayer")
# (find-man "1 mplayer" "GENERAL OPTIONS")
# (find-man "1 mplayer" "-endpos")
# (find-man "1 mplayer" "-ss <time>")
# (find-man "1 mplayer" "-sb <byte position>")
# (find-man "1 mplayer" "-osdlevel <0-3>")
# (find-man "1 mplayer" "9 and 0" "Decrease/increase volume")

# (find-fline "/sda7/nikon/aula_4/" "DSC_0007_6.flv")
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
mplayer /sda7/nikon/aula_4/DSC_0007_6.flv
mplayer     -osdlevel 2 /sda7/nikon/aula_4/DSC_0007_6.flv
mplayer -fs -osdlevel 2 /sda7/nikon/aula_4/DSC_0007_6.flv
mplayer -geometry 0x0+0+0 -fs -osdlevel 2 /sda7/nikon/aula_4/DSC_0007_6.flv
mplayer -ss 1:00 -fs -osdlevel 2 /sda7/nikon/aula_4/DSC_0007_6.flv
mplayer -ss 10:00 -fs -osdlevel 2 /sda7/nikon/aula_4/DSC_0007_6.flv
mplayer -ss 10:20 -fs -osdlevel 2 /sda7/nikon/aula_4/DSC_0007_6.flv
mplayer -ss 620 -fs -osdlevel 2 /sda7/nikon/aula_4/DSC_0007_6.flv

# (find-fline "/sda7/nikon/aula_4/DSC_0007_frames/DSC_0007-030.jpg")

# (find-sh "mplayer -list-options")




#####
#
# youtube-dl
# 2012mar12
#
#####

# «youtube-dl»  (to ".youtube-dl")
# (find-es "dvd" "youtube-dl")
# (find-angg ".emacs.templates" "find-youtubedl-links")




#####
#
# Playing videos in a browser
# 2012mar21
#
#####

# «play-in-browser»  (to ".play-in-browser")
# (find-es "flash" "flv-player")
# (find-es "flash" "flowplayer")
# (find-es "vnc" "vnc2swf")
# (find-eevfile "anim/channels.anim.html")
# (find-eevfile "anim/channels.anim.html" "channels.swf")
# http://angg.twu.net/eev-current/anim/channels.anim.html
# http://angg.twu.net/eev-current/anim/channels.swf




#####
#
# kdenlive
# 2012aug10
#
#####

# «kdenlive»  (to ".kdenlive")
# (find-status   "kdenlive")
# (find-vldifile "kdenlive.list")
# (find-udfile   "kdenlive/")




#####
#
# aegisub
# 2012aug16
#
#####

# «aegisub»  (to ".aegisub")
# http://www.aegisub.org/
# (find-status   "aegisub")
# (find-vldifile "aegisub.list")
# (find-udfile   "aegisub/")
# (find-status   "aegisub-doc")
# (find-vldifile "aegisub-doc.list")
# (find-udfile   "aegisub-doc/")
# (find-status   "aegisub-scripts")
# (find-vldifile "aegisub-scripts.list")
# (find-udfile   "aegisub-scripts/")
# (find-fline "/usr/share/aegisub/2.1/automation/")

' (progn
    (rcirc-defs)
    (let ((rcirc-default-port 6669))
      (ee-rcirc-connect "irc.rizon.net" '("#AnimeNSK"))))

;; (find-ebuffer          "*irc.rizon.net*")
;; (find-ebuffer "#AnimeNSK@irc.rizon.net")



O editor de vídeo que eu queria indicar para vc é o *openshot*.
Na hora, me enrolei e acabei dizendo openbox, que é um gerenciador de
janelas.

Sobre extrair (via OCR) legendas queimadas no vídeo, dê uma olhada em
http://www.videohelp.com/tools/Subrip e em http://zuggy.wz.cz/.

O Subrip é para Windows, mas um dos sites diz que roda com o Wine.
Na verdade, ele depende de um tal avisynth, que só existe para
Windows. Existe um análogo para Linux, chamado avxsynth.

Consegui rodar o Subrip no wine, mas ele deu erro quando fui abrir um
avi. Talvez seja a falta do av(i|x)synth. Não tive tempo de tentar
mais.




#####
#
# Youtube - links to offsets
# 2012aug29
#
#####

# «youtube-time-link»  (to ".youtube-time-link")
# http://www.youtube.com/watch?v=dJ-1I-nWR6Q
# http://www.youtube.com/watch?v=radmjL5OIaA&feature=youtu.be&t=10m17s Richard Stallman | GNU/LAS | s20e10
# http://www.youtube.com/watch?v=radmjL5OIaA&feature=youtu.be&t=58m00s Richard Stallman | GNU/LAS | s20e10




#####
#
# Uploading long videos to youtube
# 2012oct29
#
#####

# «youtube-uploading-long» (to ".youtube-uploading-long")
# http://support.google.com/youtube/bin/answer.py?hl=en&answer=71673



#####
#
# video4-eepitch.mp4
# 2013feb16
#
#####

# «video4-eepitch» (to ".video4-eepitch")
# (find-eev2-links)
# (find-eevvideos "")
# (find-eevvideos "4-eepitch")
# (find-eevvideos "4-bare.el")
# (find-eevvideos "4b-explan-1")
# (find-eevvideos "4c-explan-2")
# (find-eevvideos "4d-explan-3")
# (find-eevvideos "4e-explan-4")
# (find-angg "bin/emacs-default")
# (find-angg ".zshrc" "ae")
# (find-node "(zsh)Parameter Expansion" "split on whitespace")
# (find-node "(zsh)Parameter Expansion" "${=SPEC}")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
eev2-build-tgz
eev2-test-unpack
cd /tmp/eev/
# (find-sh "awk '82<=NR && NR<=113' ~/eev-intros/find-prepared-intro")
awk '82<=NR && NR<=113' ~/eev-intros/find-prepared-intro \
  > ~/eev-videos/4a-script
cp -v ~/eev-videos/4* /tmp/eev/
# (find-eevvideos "4-bare.el")
# (find-eevvideos "4-bare.el")
# cp -v ~/eev-videos/4-eepitch .
# cp -v ~/eev-videos/4-bare.el .

rm -fv /tmp/out.mp4
export SHELL=/bin/bash
FvwmCommand "CursorMove +0 +100" &&
  ~/bigsrc/emacs/src/emacs ${=EMACSARGSX00} -Q \
    -l eev-readme.el -l 4-bare.el 4-eepitch

# (find-sh0 "killall avconv")
# (find-fline "/tmp/")
# (find-fline "/tmp/" "out.mp4")

# (find-man "killall")
# (find-eevvideos "4-bare.el")





#####
#
# Subtitle editors
# 2013nov15
#
#####

# «subtitle-editors» (to ".subtitle-editors")
# (find-zsh "availabledebs | sort | grep subtitle")
# (find-available "gnome-subtitles" "Subtitle editor for the GNOME Desktop")
# (find-available "subtitlecomposer" "Subtitles editor for KDE")
# (find-available "subtitleeditor" "subtitle editor with sound waves repr")
# (find-available "gaupol" "subtitle editor for text-based subtitle files")
# (find-available "pitivi" "non-linear audio/video editor using GStreamer")

# http://www.linuxinsider.com/story/76949.html
# http://fixounet.free.fr/avidemux/download.html
# http://www.openshot.org/download/
# http://www.pitivi.org/
# http://home.gna.org/gaupol/
# http://home.gna.org/subtitleeditor/
# http://www.jubler.org/
# http://en.wikipedia.org/wiki/Subtitle_editor
# http://sub.wordnerd.de/linux-subs.html
#   ^ mplayer dvd://1 -dumpstream -dumpfile title1.vob



#####
#
# subtitleeditor
# 2013nov15
#
#####

# «subtitleeditor» (to ".subtitleeditor")
# (find-status   "subtitleeditor")
# (find-vldifile "subtitleeditor.list")
# (find-udfile   "subtitleeditor/")
# http://home.gna.org/subtitleeditor/
# http://www.debuntu.org/how-to-synchronising-subtitles-with-subtitleeditor/




#####
#
# Twitcasting - recorded videos
# 2014jul09
#
#####

# «twitcasting-recorded» (to ".twitcasting-recorded")

http://us.twitcasting.tv/morrediabo72/movie/78476442
http://pt.twitcasting.tv/antuanegestalt/movie/55855252 18/abr/2014 2:18

cd /tmp/; youtube-dl http://us.twitcasting.tv/olhodarua1/movie/82921631
cd /tmp/; youtube-dl http://us.twitcasting.tv/olhodarua1/movie/82920586
cd /tmp/; youtube-dl http://us.twitcasting.tv/olhodarua1/movie/82918843
cd /tmp/; youtube-dl http://us.twitcasting.tv/olhodarua1/movie/82916753
cd /tmp/; youtube-dl http://us.twitcasting.tv/olhodarua1/movie/82916530




#####
#
# VOB to MP4
# 2015apr12
#
#####

# «vob-to-mp4» (to ".vob-to-mp4")
# http://forums.debian.net/viewtopic.php?f=6&t=80138 How to convert .vob file to .mp4
# http://unix.stackexchange.com/questions/106374/how-to-convert-a-vob-file-to-avi
# (find-fline "/sda7/DVDs/ParaPara/Harajuku Dansu  3/VIDEO_TS/")








# ClassX (dica do David Deharbe)
# http://classx.sourceforge.net/
# http://classx.sourceforge.net/users.html
# http://classx.sourceforge.net/developer.html#Download


# (find-status   "pitivi")
# (find-vldifile "pitivi.list")
# (find-udfile   "pitivi/")
# (find-status   "openshot")
# (find-vldifile "openshot.list")
# (find-udfile   "openshot/")
# (find-status   "openshot-doc")
# (find-vldifile "openshot-doc.list")
# (find-udfile   "openshot-doc/")



# http://lscube.org/pipermail/ffmpeg-issues/2009-September/006947.html
# http://commons.wikimedia.org/wiki/Help:Converting_video#ffmpeg2theora_2

https://www.fsf.org/blogs/rms/20140407-geneva-tedx-talk-free-software-free-society






#  Local Variables:
#  coding:               utf-8-unix
#  End:
