#######
#
# E-scripts on vlc.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/vlc.e>
#           or at <http://angg.twu.net/e/vlc.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.keys»		(to "keys")
# «.vlc-keys»		(to "vlc-keys")
# «.start-time»		(to "start-time")
# «.video-information»	(to "video-information")
# «.mediainfo»		(to "mediainfo")
# «.vlc.el»		(to "vlc.el")


# (find-sh "vlc --help")
# (find-sh "vlc --help" "URL")
# (find-sh "vlc --help" "Track settings:")
# (find-sh "vlc -H")
# (find-es "dvd" "vlc")
# (find-es "dvd" "vlc-upstream")

http://forum.videolan.org/viewforum.php?f=29
http://stackoverflow.com/questions/6012921/vlc-scripting-with-lua-jump-to-a-specific-time-in-a-file

cd /sda5/videos/

(defun find-vlc (&rest args) (find-bgprocess (cons "vlc" args)))

# (find-fline "/sda5/videos/")
# (find-vlc   "/sda5/videos/Cat_Power_cross_bones_style-wU291yKCbBE.flv")

/sda5/videos/Cat_Power_cross_bones_style-wU291yKCbBE.flv




#####
#
# VLC keys
# 2012jun30
#
#####

# «keys» (to ".keys")
# «vlc-keys»  (to ".vlc-keys")
# (find-es "mplayer" "keys")
# (find-man "1 vlc")
# (find-zsh "availabledebs | sort | grep vlc")
# (find-zsh "installeddebs | sort | grep vlc")
# (find-status   "vlc")
# (find-vldifile "vlc.list")
# (find-udfile   "vlc/")
# (find-status   "vlc-data")
# (find-vldifile "vlc-data.list")
# (find-udfile   "vlc-data/")
# (find-status   "vlc-nox")
# (find-vldifile "vlc-nox.list")
# (find-udfile   "vlc-nox/")
# http://www.videolan.org/vlc/

# (find-man "1 qvlc")
# (find-man "1 svlc")

# (find-sh "vlc --longhelp --advanced")

# From:
# http://wiki.videolan.org/Linux_keyboard_shortcuts

Menu Key: bring up popup menu
Left/Right/Up/Down/Enter: DVD menus navigation keys
Page Up/Page Down/Shift + Right Arrow/Shift + Left Arrow: seek (10 secs)
Home/End: Beginning/End of file
Ctrl + Arrow Down: volume down
Ctrl + Arrow Up: volume up
Space: Pause
f/F: fullscreen
q/Q: quit vlc
Esc: exit fullscreen/Stop input
a/A: cycle aspect ratio (when in fullscreen)
+/-: fast/slow reproduction
p/n: previous/next playlist item
m: toggle audio (mute)
k: toggle between available subtitles
l: toggle between available audio tracks





#####
#
# start-time
# 2013jun19
#
#####

# «start-time» (to ".start-time")
# (find-man "1 vlc")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
FNAME=$S/http/angg.twu.net/eev-videos/2021-test-blocks.mp4
vlc $FNAME
vlc --start-time 1:00 $FNAME
vlc --start-time 60 $FNAME

(setq fname "$S/http/angg.twu.net/eev-videos/2021-test-blocks.mp4")

(find-vlc-video fname)
(find-vlc-video fname "1:23")
(ee-find-vlc-video fname)
(ee-split-and-expand (ee-find-vlc-video fname "1:23"))

# (find-efunction 'find-mpv-video)

(ee-time-to-seconds "1:23")

# (find-sh "vlc --help")
# (find-sh "vlc --help --full-help --help-verbose")
# (find-sh "vlc -H --full-help --help-verbose")
# (find-sh "vlc -H" "--start-time")
# (find-sh "vlc -H" "--start-time <float>")

  -H, --full-help, --no-full-help
                                 Exhaustive help for VLC and its modules
                                 (default disabled)
      --longhelp, --no-longhelp  print help for VLC and all its modules (can
                                 be combined with --advanced and
                                 --help-verbose) (default disabled)
      --help-verbose, --no-help-verbose
                                 ask for extra verbosity when displaying help






#####
#
# video-information
# 2019sep01
#
#####

# «video-information» (to ".video-information")
# https://www.vlchelp.com/find-video-resolution-frame-rate-vlc/
# https://superuser.com/questions/595177/how-to-retrieve-video-file-information-from-command-line-under-linux



#####
#
# mediainfo
# 2019sep01
#
#####

# «mediainfo» (to ".mediainfo")
# https://superuser.com/questions/595177/how-to-retrieve-video-file-information-from-command-line-under-linux
# https://unix.stackexchange.com/questions/131186/pull-metadata-from-a-video-in-the-terminal
# (find-status   "mediainfo")
# (find-vldifile "mediainfo.list")
# (find-udfile   "mediainfo/")

# (find-udfile "mediainfo/README")
# (find-udfile "mediainfo/changelog.Debian.gz")
# (find-udfile "mediainfo/changelog.gz")
# (find-udfile "mediainfo/copyright")
# (find-man "1 mediainfo")

# (find-sh "mediainfo --Help")
# (find-sh "mediainfo ~/eev-videos/three-keys-1-pt-video.webm")
# (find-sh "mediainfo ~/eev-videos/three-keys-1-pt-audio.wav")





#####
#
# vlc.el
# 2021dec12
#
#####

# «vlc.el»  (to ".vlc.el")
# (find-epackage-links 'vlc "vlc" t)
# (find-epackage       'vlc)
# (code-c-d "vlc" "~/.emacs.d/elpa/vlc-20200328.1143/")
# (find-vlcfile "")
# https://github.com/xuchunyang/vlc.el





RECURSO DE PESQUISA DE LEGENDA NO VLC

Para quem não conhece, o player VLC tem um extensão chamada VLsub, que
automaticamente procura legenda dos vídeos. Para usá-la, basta seguir
os seguintes passos: 1) baixe a extensão; 2) coloque o vídeo para
rodar no VLC; 3) clique em "Exibir" e, depois, em "VLsub"; 4)
selecione o idioma e "Search by name"; 5) aparecerão as opções. Então
é só selecionar e clicar em "download selection". A legenda é salva na
pasta em que está o arquivo de vídeo



# (find-fline "/usr/share/vlc/utils/")
# (find-fline "/usr/share/vlc/lua/http/")
# (find-fline "/usr/share/vlc/lua/http/custom.lua")
# (find-fline "~/.local/share/vlc/")

# http://www.videolan.org/developers/vlc/share/lua/README.txt
# http://www.coderholic.com/extending-vlc-with-lua/
# http://wiki.videolan.org/
# http://wiki.videolan.org/index.php?title=Special%3ASearch&search=keys&go=Go
# http://wiki.videolan.org/Linux_keyboard_shortcuts
# http://wiki.videolan.org/DBus

http://stackoverflow.com/questions/6012921/vlc-scripting-with-lua-jump-to-a-specific-time-in-a-file
https://mfkl.github.io/2024/01/10/unity-double-oss-standards.html

# (find-zsh "availabledebs | sort | grep k9")



https://www.trevoragilbert.com/posts/a-love-letter-to-tinkerable-software/
https://github.com/ambulancja/mariposa Mariposa: programs that travel in time
https://news.ycombinator.com/item?id=38935485 Mariposa – A programming language with time-travel (github.com/ambulancja)





#  Local Variables:
#  coding:               utf-8-unix
#  End:
