#######
#
# E-scripts on vnc
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/vnc.e>
#           or at <http://angg.twu.net/e/vnc.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.ming»			(to "ming")
# «.vnc2swf»			(to "vnc2swf")
# «.vncserver»			(to "vncserver")
# «.xvncviewer»			(to "xvncviewer")
# «.swftools»			(to "swftools")
# «.gplflash»			(to "gplflash")
# «.short-movie-about-f9»	(to "short-movie-about-f9")
# «.movie1»			(to "movie1")
# «.Xnest»			(to "Xnest")
# «.xnest-2011»			(to "xnest-2011")
# «.vnc2swf-2011»		(to "vnc2swf-2011")
# «.swf-objects»		(to "swf-objects")
# «.key-mon»			(to "key-mon")




#####
#
# ming
# 2005feb07
#
#####

# «ming»  (to ".ming")
# http://www.opaque.net/wiki/index.php?MingInstall
# http://voxel.dl.sourceforge.net/sourceforge/ming/ming-0.2a.tar.bz2
#
rm -Rv ~/usrc/ming-0.2a/
tar -C ~/usrc/ -xvzf \
  $S/http/voxel.dl.sourceforge.net/sourceforge/ming/ming-0.2a.tgz
cd     ~/usrc/ming-0.2a/

#
cd     ~/usrc/ming-0.2a/
make \
  PREFIX=/usr/share/php \
  CFLAGS="-L/usr/lib/php4/20020429 -I/usr/include/php4" \
  dynamic static   |& tee om

#
# (code-c-d "ming" "~/usrc/ming-0.2a/")
# (find-mingfile "")
# (find-mingfile "src/")
# (find-mingfile "INSTALL")
# (find-mingfile "Makefile")

# I tried this version too (0.3beta1) but it doesn't work with vnc2swf-0.4.2...
# http://voxel.dl.sourceforge.net/sourceforge/ming/ming-0.3beta1.tar.bz2




#####
#
# vnc2swf
# 2005feb07
#
#####

# «vnc2swf»  (to ".vnc2swf")
# «vncserver»  (to ".vncserver")
# «xvncviewer»  (to ".xvncviewer")
# (find-es "eev" "vnc2swf")
# (find-es "eev" "byzanz")

# http://www.unixuser.org/~euske/vnc2swf/
# http://www.unixuser.org/~euske/vnc2swf/rec_vncserver.html
# http://www.unixuser.org/~euske/vnc2swf/vnc2swf-0.4.2.tar.gz
#
rm -Rv ~/usrc/vnc2swf-0.4.2/
tar -C ~/urc/ -xvzf \
  $S/http/www.unixuser.org/~euske/vnc2swf/vnc2swf-0.4.2.tar.gz
cd     ~/usrc/vnc2swf-0.4.2/
./configure --with-ming=$HOME/usrc/ming-0.2a/src   |& tee oc
make           |& tee om

#
# (code-c-d "vnc2swf" "~/usrc/vnc2swf-0.4.2/")
# (find-vnc2swffile "")
# (find-vnc2swffile "Makefile")
# (find-vnc2swffile "configure.in")
# (find-node "(make)Catalogue of Rules")
# (find-vnc2swffile "oc")
# (find-vnc2swffile "om")



# (find-man "8 ld.so" "LD_LIBRARY_PATH")

vncserver -geometry 320x240 -depth 16 :2
# cd ~/usrc/vnc2swf-0.4.2/

cd /tmp/
LD_LIBRARY_PATH=$HOME/usrc/ming-0.2a/src: \
  ~/usrc/vnc2swf-0.4.2/vnc2swf out.swf :2

# (find-status   "vncserver")
# (find-vldifile "vncserver.list")
# (find-udfile   "vncserver/")
# (find-status   "xvncviewer")
# (find-vldifile "xvncviewer.list")
# (find-udfile   "xvncviewer/")

# (find-vldifile "vncserver.postinst")
# (find-fline "/etc/alternatives/" "vncserver")

# (find-man "1x realvncserver")
# (find-man "1 realvncconnect")
# (find-man "1 Xrealvnc")

# (find-man "1x realvncserver" "vncserver :1")
# (find-man "1x realvncserver" "vncserver -kill :1")





#####
#
# swftools (for generating the html wrapper around the .swf)
# 2005feb08
#
#####

# «swftools»  (to ".swftools")
# (find-es "flash" "swftools")
# http://www.quiss.org/swftools/swftools-0.6.3.tar.gz
#
rm -Rv ~/usrc/swftools-0.6.3/
tar -C ~/usrc/ -xvzf $S/http/www.quiss.org/swftools/swftools-0.6.3.tar.gz
cd     ~/usrc/swftools-0.6.3/

#
cd     ~/usrc/swftools-0.6.3/
./configure   |& tee oc
make          |& tee om
#
# (code-c-d "swftools" "~/usrc/swftools-0.6.3/")
# (find-swftoolsfile "")
# (find-swftoolsfile "src/")

#
cd /tmp/
function swftohtml () {
  echo -e "<html>\n<head><title>$1</title></head>\n<body>"
  ~/usrc/swftools-0.6.3/src/swfdump --html $1
  echo -e "</body>\n</html>"
}
swftohtml out.swf | tee out.html

#
cd ~/eev-current/anim/
swftohtml channels.swf | tee channels.html

#




#####
#
# gplflash
# 2005feb22
#
#####

# «gplflash»  (to ".gplflash")
# http://gplflash.sourceforge.net/
# http://voxel.dl.sourceforge.net/sourceforge/gplflash/gplflash-0.4.13.tar.bz2
#
rm -Rv ~/usrc/gplflash-0.4.13/
tar -C ~/usrc/ -xvjf \
  $S/http/voxel.dl.sourceforge.net/sourceforge/gplflash/gplflash-0.4.13.tar.bz2
cd     ~/usrc/gplflash-0.4.13/
./configure	|& tee oc
make            |& tee om

#

#
# (code-c-d "gplflash" "~/usrc/gplflash-0.4.13/")
# (find-gplflashfile "")

apti libmad0-dev






#####
#
# A short movie about <f9>
# 2005feb08
#
#####

# «short-movie-about-f9»  (to ".short-movie-about-f9")
#
# Missing:
unclutter -idle 2 &
#
# (progn (eev-bounded) (find-zsh0 ". $EE"))
cat > /tmp/.zshrc <<'%%%'
PS1='%d# '
PS2='> '
setopt autocd interactivecomments
%%%
#
;; Movie settings
;; «movie1»  (to ".movie1")
(progn
  (cd "/tmp")
  (eechannel "A" "exit\n")
  (eechannel "B" "exit\n")
  (find-sh0 "xrdb -merge <(echo 'xterm*geometry: 40x12')")
  (find-sh0 "xrdb -merge <(echo 'xterm*foreground: black')")
  (find-sh0 "xrdb -merge <(echo 'xterm*background: white')")
  (find-sh0 "xsetroot -solid black")
  (fvwm-sloppy-focus)
  (define-key eev-mode-map [f7] 'eechannel-do-this-line)
  ;; (setenv "HOME" "/home/edrx")
  ;; (setenv "HOME" "/tmp")
  (scroll-bar-mode -1)
  (my-modes :no-scroll-bar :no-pager)
  ;; (my-modes :no-fringe)
  )


 (eechannel-xterm "A") ;; create
 (eechannel-xterm "B") ;; create
# Listen on port 1234
netcat -l -p 1234

 (eechannel "A") ;; change target
# Send things to port 1234
{
  echo hi
  sleep 1
  echo bye
  sleep 1
} | netcat -q 0 localhost 1234













  (find-sh0 "xrdb -merge <(echo 'xterm*background: green')")
  (find-sh0 "xrdb -merge <(echo 'xterm*foreground: purple')")
 (eechannel-xterm "A") ;; create






;; Normal settings
(progn
  (setenv "HOME" "/home/edrx")
  (fvwm-click-to-focus)
  (find-sh0 "xrdb -merge <(echo 'xterm*geometry: 80x24')")
  ;; (scroll-bar-mode 1)
  (my-modes :scroll-bar)
  (my-modes :fringe)
  )



What about:
(find-sh0 "xrdb -merge <(echo 'emacs*geometry: 80x24')")
and what about xnest?


# «Xnest»  (to ".Xnest")
# (find-man "xrdb")
# (find-es "x" "Xnest")
# (find-angg ".zshrc")
#
Xnest -geometry 550x400 -br :1 &
export DISPLAY=:1.0
cd /tmp/
# xterm -geometry 40x12&
fvwm &
emacs-cvs -geometry 40x28+0+0 \
  $ES/vnc.e &

unclutter -idle 2 &

# xterm -display :1 &
export DISPLAY=:0.0

#
cd /tmp/
export DISPLAY=:0.0
killall -9 Xrealvnc
rm -Rfv /tmp/.X2-lock
rm -Rfv /tmp/.X11-unix/X2

# vncserver -geometry 550x400 -depth 16 :2
vncserver -geometry 600x400 -depth 16 :2
LD_LIBRARY_PATH=$HOME/usrc/ming-0.2a/src: \
  ~/usrc/vnc2swf-0.4.2/vnc2swf out.swf :2

#
export DISPLAY=:2.0
fvwm &
emacs-cvs -geometry 40x28+0+0 \
  -fg bisque -bg black \
  $ES/vnc.e &
unclutter -idle 2 &

# xsetroot -solid black

# xterm -display :1 &
export DISPLAY=:0.0

#


  (to "movie1")

# http://www.unixuser.org/~euske/vnc2swf/

# (find-man "vncserver")
# (find-man "vncpasswd")
# (find-fline "~/.vnc/")





 (eechannel-xterm "A0" nil '("-geometry" "79x10"))
 (ee-at "my_swf_functions" (eev-bounded) (eech "ee\n"))

# (find-zsh "dmissing vnc | grep server")
# (find-zsh "dmissing vnc | grep server | awk '{print $2}' | sort | uniq")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-zsh "dmissing vncserver")
dmissing vncserver | awk '{print $2}' | sort | uniq

libvncserver0-dbg
libvncserver0
libvncserver-dev
tightvncserver

# (find-available "libvncserver0-dbg")
# (find-available "libvncserver0")
# (find-available "libvncserver-dev")
# (find-available "tightvncserver")

Homepage: http://www.tightvnc.com
http://en.wikipedia.org/wiki/Vnc
http://en.wikipedia.org/wiki/RealVNC
http://en.wikipedia.org/wiki/X11vnc

# (find-status   "vnc4server")
# (find-vldifile "vnc4server.list")
# (find-udfile   "vnc4server/")
# (find-status   "xvnc4viewer")
# (find-vldifile "xvnc4viewer.list")
# (find-udfile   "xvnc4viewer/")

update-alternatives: using /usr/bin/tightvncserver to provide /usr/bin/vncserver (vncserver) in auto mode.
update-alternatives: using /usr/bin/Xtightvnc to provide /usr/bin/Xvnc (Xvnc) in auto mode.
update-alternatives: using /usr/bin/tightvncpasswd to provide /usr/bin/vncpasswd (vncpasswd) in auto mode.

# (find-es "dpkg" "dpkg:alternatives")



apti tightvncserver

# (find-es "eev" "byzanz")




#####
#
# Xnest (2011)
# 2011nov25
#
#####

# «xnest-2011»  (to ".xnest-2011")
# (find-es "x" "geometry")
# (find-status   "xnest")
# (find-vldifile "xnest.list")
# (find-udfile   "xnest/")
# (find-man "1 Xnest")
# (find-sh "Xnest --help" "-br")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
killall Xnest
Xnest -geometry 500x400+512+0 -br :2 &
export DISPLAY=:2
fvwm &
emacs23 -fn 6x13 -geometry 40x28
# (scroll-bar-mode 0)

export DISPLAY=:1.0
cd /tmp/
# xterm -geometry 40x12&
fvwm &
emacs-cvs -geometry 40x28+0+0 \
  $ES/vnc.e &

unclutter -idle 2 &

# xterm -display :1 &
export DISPLAY=:0.0




#####
#
# vnc2swf 2011
# 2011nov25
#
#####

# «vnc2swf-2011»  (to ".vnc2swf-2011")
# (find-es "python" "pygame")
# http://www.unixuser.org/~euske/vnc2swf/
# http://www.unixuser.org/~euske/vnc2swf/index.html
# http://www.unixuser.org/~euske/python/vnc2flv/
# http://www.unixuser.org/~euske/python/vnc2flv/index.html
# http://pypi.python.org/pypi/vnc2flv/
# http://pypi.python.org/pypi/vnc2flv/index.html
# http://www.unixuser.org/~euske/vnc2swf/vnc2swf-0.5.0.tar.gz
# http://www.unixuser.org/~euske/vnc2swf/pyvnc2swf-0.9.5.tar.gz
# http://pypi.python.org/packages/source/v/vnc2flv/vnc2flv-20100207.tar.gz
#
rm -Rv ~/usrc/vnc2swf-0.5.0/
rm -Rv ~/usrc/pyvnc2swf-0.9.5/
rm -Rv ~/usrc/vnc2flv-20100207/

tar -C ~/usrc/ -xvzf \
  $S/http/www.unixuser.org/~euske/vnc2swf/vnc2swf-0.5.0.tar.gz
tar -C ~/usrc/ -xvzf \
  $S/http/www.unixuser.org/~euske/vnc2swf/pyvnc2swf-0.9.5.tar.gz
tar -C ~/usrc/ -xvzf \
  $S/http/pypi.python.org/packages/source/v/vnc2flv/vnc2flv-20100207.tar.gz

cd     ~/usrc/vnc2swf-0.5.0/
./configure  |& tee oc
make         |& tee om

cd     ~/usrc/vnc2flv-20100207/
cd     ~/usrc/pyvnc2swf-0.9.5/

#
# (code-c-d "vnc2swf"   "~/usrc/vnc2swf-0.5.0/")
# (code-c-d "pyvnc2swf" "~/usrc/pyvnc2swf-0.9.5/")
# (code-c-d "vnc2flv"   "~/usrc/vnc2flv-20100207/")
# (find-vnc2swffile "")
# (find-pyvnc2swffile "")
# (find-vnc2flvfile "")
# (find-vnc2swffile "README")
# (find-pyvnc2swffile "README.txt")
# (find-pyvnc2swffile "README.txt" "see docs/pyvnc2swf.html")
# (find-pyvnc2swffile "docs/")
# (find-pyvnc2swfw3m  "docs/index.html")
# (find-pyvnc2swfw3m  "docs/pyvnc2swf.html")
# (find-pyvnc2swfw3m  "docs/pyvnc2swf.html" "Control-C")
# (find-pyvnc2swfw3m  "docs/pyvnc2swf.html" "Control-C" ".html")
# (find-pyvnc2swfw3m  "docs/recordwin.html")
# (find-pyvnc2swffile  "bin/recordwin.sh")
# (find-pyvnc2swffile "pyvnc2swf/swf.py")
# (find-pyvnc2swffile "pyvnc2swf/vnc2swf.py")
# (find-pyvnc2swffile "pyvnc2swf/vnc2swf.py" "usage: %s")
# (find-pyvnc2swffile "pyvnc2swf/html_templates.py" "SEEKBAR_HEADER =")
# http://www.squarefree.com/

# (find-vnc2flvw3m "docs/index.html")
# (find-vnc2flvfile "tools/")
# (find-vnc2flvfile "tools/flvsplit.py")
# (find-vnc2flvfile "vnc2flv/")

# http://www.unixuser.org/~euske/vnc2swf/pyvnc2swf.html
# http://www.unixuser.org/~euske/vnc2swf/vnc2swf.html

# Mailing list:
# https://lists.sourceforge.net/lists/listinfo/vnc2swf-users
# http://sourceforge.net/mailarchive/forum.php?forum=vnc2swf-users




#####
#
# SWF objects in HTML pages
#
#####

# «swf-objects»  (to ".swf-objects")
# (find-es "html" "swf-objects")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/pyvnc2swf-0.9.5/bin/recordwin.sh")
# (find-fline "/tmp/" "out")
killall -v    recordwin.sh
killall -v -9 recordwin.sh
killall -v    x11vnc
killall -v -9 x11vnc
rm -v /tmp/out.*
cd ~/usrc/pyvnc2swf-0.9.5/
# bin/recordwin.sh /tmp/out.swf  &
  bin/recordwin.sh /tmp/out.swf

ps ax
killall -v    recordwin.sh
killall -v -9 recordwin.sh
killall -v    x11vnc
killall -v -9 x11vnc
laf /tmp/out.*
# (find-fline "/tmp/" "out")
# file:///tmp/out.html





#####
#
# key-mon-1.9 (for showing the keys on the screen)
# 2012mar17
#
#####

# «key-mon»  (to ".key-mon")
# http://code.google.com/p/key-mon/
# http://key-mon.googlecode.com/files/key-mon-1.9.tar.gz
#
rm -Rv ~/usrc/key-mon-1.9/
tar -C ~/usrc/ -xvzf \
  $S/http/key-mon.googlecode.com/files/key-mon-1.9.tar.gz
cd     ~/usrc/key-mon-1.9/

#
# (code-c-d "keymon" "~/usrc/key-mon-1.9/")
# (find-keymonfile "")
# (find-keymonfile "README.rst")
# (find-keymonfile "src/keymon/")





http://www.swftools.org/changelog.html





#  Local Variables:
#  coding:               utf-8-unix
#  modes:                (fundamental-mode sh-mode)
#  End:
