#######
#
# E-scripts on X.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/x.e>
#           or at <http://angg.twu.net/e/x.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# 2000sep26: I finally got Emacs and xterm to work with an X version
# of my math-tweaked console font! Follow the "font2bdf" link...
# (BTW, later I abandoned that and returned to using just the standard
# fonts in X, as it seems that my tweaked font triggered some bugs)

# «.startx»			(to "startx")
# «.second-X-server»		(to "second-X-server")

# «.font2bdf»			(to "font2bdf")
# «.font2bdf_2x»		(to "font2bdf_2x")
# «.X_with_mathfont»		(to "X_with_mathfont")
# «.Multi_key»			(to "Multi_key")
# «.xkbprint-hamm»		(to "xkbprint-hamm")
# «.xf86src1»			(to "xf86src1")
# «.tmp_vga.bdf»		(to "tmp_vga.bdf")
# «.xterm»			(to "xterm")
# «.xterm-colors»		(to "xterm-colors")
# «.xterm-mkey»			(to "xterm-mkey")
# «.installing_a_font»  	(to "installing_a_font")
# «.imagemagick»		(to "imagemagick")
# «.imagemagick-bp-to-sarge»  	(to "imagemagick-bp-to-sarge")
# «.screenshots»		(to "screenshots")
# «.wmctrl»			(to "wmctrl")
# «.wmctrl-deb-src»		(to "wmctrl-deb-src")
# «.xwit»			(to "xwit")
# «.xbooks0»			(to "xbooks0")
# «.xbooks»			(to "xbooks")
# «.xvt»			(to "xvt")
# «.xfs-xtt»			(to "xfs-xtt")
# «.fstobdf»			(to "fstobdf")
# «.tt_utils»			(to "tt_utils")
# «.bdf_2x»			(to "bdf_2x")
# «.bdfresize»			(to "bdfresize")
# «.creep-font»			(to "creep-font")

# «.xanim»			(to "xanim")
# «.flwm»			(to "flwm")
# «.sawmill»			(to "sawmill")
# «.sawfish»			(to "sawfish")
# «.default_background»		(to "default_background")
# «.xsetroot»			(to "xsetroot")
# «.xsetbg»			(to "xsetbg")
# «.chameleon»			(to "chameleon")
# «.xloadimage»			(to "xloadimage")
# «.xview»			(to "xview")
# «.xtartan»			(to "xtartan")
# «.fvwm-2.5»			(to "fvwm-2.5")
# «.xauth»			(to "xauth")
# «.Xnest»			(to "Xnest")
# «.xephyr»			(to "xephyr")

# «.keyboard-layout-2018»	(to "keyboard-layout-2018")
# «.keyboard-layouts»		(to "keyboard-layouts")
# «.setxkbmap-2023»		(to "setxkbmap-2023")
# «.setxkbmap-show»		(to "setxkbmap-show")
# «.setxkbmap-thinkpad»		(to "setxkbmap-thinkpad")
# «.keyboard-layouts-2»		(to "keyboard-layouts-2")
# «.xkbprint»			(to "xkbprint")
# «.setxkbmap»			(to "setxkbmap")
# «.setxkbmap-2»		(to "setxkbmap-2")
# «.setxkbmap-switch»		(to "setxkbmap-switch")
# «.X-kbdrate»			(to "X-kbdrate")

# «.xpm»			(to "xpm")
# «.ratpoison»			(to "ratpoison")
# «.mouse-parameters»		(to "mouse-parameters")
# «.deb-for-a-font»		(to "deb-for-a-font")
# «.fonts.alias»		(to "fonts.alias")
# «.fontconfig»			(to "fontconfig")
# «.xorg-docs»			(to "xorg-docs")
# «.tinywm»			(to "tinywm")
# «.xnee»			(to "xnee")
# «.capslock-as-mod4»		(to "capslock-as-mod4")
# «.no-capslock»		(to "no-capslock")
# «.dpi»			(to "dpi")
# «.geometry»			(to "geometry")
# «.xzgv»			(to "xzgv")
# «.xzgv-deb-src»		(to "xzgv-deb-src")
# «.display-manager»		(to "display-manager")
# «.gdm»			(to "gdm")
# «.ldm»			(to "ldm")
# «.touchfreeze»		(to "touchfreeze")
# «.xdpyinfo»			(to "xdpyinfo")
# «.screen-size»		(to "screen-size")
# «.screen-dimensions»		(to "screen-dimensions")
# «.xwininfo»			(to "xwininfo")
# «.xlsclients»			(to "xlsclients")
# «.inconsolata»		(to "inconsolata")
# «.clipboard»			(to "clipboard")
# «.xsel»			(to "xsel")
# «.xpad»			(to "xpad")
# «.emacs-on-pure-X»		(to "emacs-on-pure-X")
# «.xrdb»			(to "xrdb")
# «.class»			(to "class")
# «.xdotool»			(to "xdotool")
# «.vtwm»			(to "vtwm")
# «.xmodmap»			(to "xmodmap")
# «.scrot»			(to "scrot")
# «.xfce»			(to "xfce")
# «.xfce4-keyboard-shortcuts»	(to "xfce4-keyboard-shortcuts")
# «.calibration»		(to "calibration")
# «.matchbox»			(to "matchbox")
# «.xclip»			(to "xclip")
# «.logs»			(to "logs")
# «.bell-volume»		(to "bell-volume")
# «.conky»			(to "conky")
# «.i3wm»			(to "i3wm")
# «.xlsfonts»			(to "xlsfonts")
# «.fc-list»			(to "fc-list")
# «.xfonts»			(to "xfonts")
# «.xserver-log»		(to "xserver-log")
# «.xinit-as-user-2021»		(to "xinit-as-user-2021")
# «.xinit-as-user»		(to "xinit-as-user")
# «.moosotc-snippets»		(to "moosotc-snippets")
# «.which-window-manager»	(to "which-window-manager")
# «.replace-window-manager»	(to "replace-window-manager")
# «.lock»			(to "lock")
# «.lightdm»			(to "lightdm")
# «.C-M-backspace»		(to "C-M-backspace")
# «.xdg-utils»			(to "xdg-utils")
# «.unclutter»			(to "unclutter")
# «.xorg-in-buster»		(to "xorg-in-buster")
# «.sway»			(to "sway")
# «.hack-font»			(to "hack-font")
# «.xeyes»			(to "xeyes")




#####
#
# startx
# 2021aug15
#
#####

# «startx»  (to ".startx")
# (find-man "1 startx")
# (find-man "1 xinit")

# (find-fline "/etc/X11/xinit/xinitrc")

# (find-man "1 xinit" "xterm -geometry +1+1 -n login -display :0")
# (find-fline "~/" ".xinitrc")
# (find-fline "~/.xinitrc")
# (find-fline "~/.xinitrc.debian")




#####
#
# Another X server with another XF86Config
# 2001nov23
#
#####

# «second-X-server»  (to ".second-X-server")
# (find-angg ".zshrc" "inix-lea")
# (find-angg "LEA/")
# (find-angg "LEA/.xinitrc")

# 2021nov01: See:
# (to "xinit-as-user-2021")

#
# cp -iv /etc/X11/XF86Config ~/LEA/XF86Config-800x600
tkdiff /etc/X11/XF86Config ~/LEA/XF86Config-800x600
# (find-angg "LEA/XF86Config-800x600" "modes")

#

# (find-man "1 xinit" "xinit /usr/local/lib/site.xinitrc -- /usr/bin/X -br")
# (find-angg ".xinitrc")

# (find-man "1 startx")

# (find-man "1x XFree86" "-xf86config file")
# (find-man "1x XFree86" "In addition to the normal server options")
# (find-man "1x Xserver")
# (find-man "1x XF86_SVGA")

# (find-fline "/etc/X11/XF86Config")
# (find-man "5x XF86Config")

# (find-fline "/usr/doc/xfree86-common/")
# (find-fline "/usr/doc/xserver-common/")
# (find-fline "/usr/doc/xserver-svga/")
# (find-status "xfree86-common")
# (find-status "xserver-common")
# (find-status "xserver-svga")
# (find-vldifile "xfree86-common.list")
# (find-vldifile "xserver-common.list")
# (find-vldifile "xserver-svga.list")

# (find-man "5 Xsession.options")

# (find-man "1x XFree86")
# (find-man "5x XF86Config")

# (find-man "1x reconfig")
# (find-man "1x xf86config")
# (find-man "1x SuperProbe")

# (find-man "7 X")
# (find-man "startx")
# (find-man "xinit")

# (find-man "1x XFree86" "/tmp/.X11-unix/Xn")




#####
#
# .Xdefaults for xdvi
#
#####

# (find-fline "~/.Xdefaults")
# I'm using these defaults:

# xdvi*geometry: 730x750
xdvi*expert: on
xdvi*shrinkFactor: 6
xdvi*thorough: yes

# (find-man "X" "GEOMETRY SPECIFICATIONS")
# (find-man "xdvi" "  -thorough")




#####
#
# changes on .fvwmrc
#
#####

# (find-fline "~/.fvwmrc")

EdgeScroll 100 100

EdgeResistance 0 20

DeskTopSize 2x2

Function "InitFunction"
#	All the rest was commented out
	Desk 	"I"	0 0
EndFunction

Popup "Utilities"
	...
	Exec    "Kill Asteroids" exec kill $(pidof asteroids) &
	...
EndPopup

# Now the title bar buttons
...
#     Button	Context Modifi 	Function
Mouse 0         1       A       Function "window_ops_func"
Mouse 1         2       A       Iconify
Mouse 3         2       A       Destroy
Mouse 1         4       A       Maximize 0 100
Mouse 3         4       A       Maximize 100 100
Mouse 1         6       A       Close
Mouse 3         6       A       Close

# press shift arrow + control anywhere, and move the pointer by 1% of a page
Key Left	A	SC	CursorMove -1 0
Key Right	A	SC	CursorMove +1 +0
Key Up		A	SC	CursorMove +0   -1
Key Down	A	SC	CursorMove +0   +1

# press shift arrow + meta key, and move the pointer by 1/10 of a page
Key Left	A	SM	CursorMove -10 +0
Key Right	A	SM	CursorMove +10 +0
Key Up		A	SM	CursorMove +0   -10
Key Down	A	SM	CursorMove +0   +10





#####
#
# X compose tables (hamm)
#
#####

# (find-fline "/usr/doc/HOWTO/Danish-HOWTO.gz" "keycode 78 = Multi_key")
# (find-fline "/usr/doc/HOWTO/German-HOWTO.gz" "Multi_key")
# (find-fline "/usr/doc/HOWTO/French-HOWTO.gz" "Multi_key")
# (find-fline "/usr/doc/HOWTO/unmaintained/Portuguese-HOWTO.gz" "Multi_key")
# (find-fline "/usr/doc/bash/examples/scripts/adventure.sh.gz")

# (find-fline "~/XF86Config" "RightCtl    Compose")
# (find-fline "/etc/X11/XF86Config" "RightCtl    Compose")

cd /usr/X11R6/lib/X11/xkb/

locate '*ompose*'
# (find-fline "/usr/X11R6/lib/X11/locale/compose.dir")
locate '*8859*'

# (find-fline "/usr/X11R6/lib/X11/locale/iso8859-1/Compose")
# (find-fline "/usr/X11R6/lib/X11/locale/iso8859-2/Compose")

# (find-htetfile "Keyboard-and-Console-HOWTO.txt.gz" "initialize its keymap")

# «Multi_key»  (to ".Multi_key")

# It seems that xkb picks a compose table when it starts.
# We need a compose key (a "Multi_key")...
# RightCtl is 109 (=0x6D) under X with my keyboard. So:

xmodmap -e 'keycode 0x6D = Multi_key'

#
# «xkbprint-hamm»  (to ".xkbprint-hamm")
# (find-man "1 xkbprint")
# (to "setxkbmap")
cd /tmp/
xkbprint :0.0
gv -seascape -scale 4 server-0_0.ps &
#
# Ctrl_L=37 Meta_L=64 Alt_R=113 Multi_key=109

xmodmap -pm
xmodmap -pk
xmodmap -pp
xmodmap -pke



#####
#
# xfree86 from the sources
# 2000aug25
#
#####

# «xf86src1»  (to ".xf86src1")
#
rm -Rv /usr/src/xfree86-1-3.3.6/
pdsc $SDEBIAN/dists/potato/main/source/x11/xfree86-1_3.3.6-10.dsc
cd /usr/src/xfree86-1-3.3.6/
debian/rules source.unpack	|& tee odrsu
#
# «tmp_vga.bdf»  (to ".tmp_vga.bdf")
# (find-xcfile "programs/Xserver/hw/xfree86/etc/vga.bdf")
cd /usr/src/xfree86-1-3.3.6/
cp -iv build-tree/xc/programs/Xserver/hw/xfree86/etc/vga.bdf ~/tmp/
#


# (code-c-d "xf1src" "/usr/src/xfree86-1-3.3.6/")
# (find-xf1srcfile "debian/")
# (find-xf1srcfile "debian/rules")
# (find-xf1srcfile "debian/sys-build.mk")
# (find-xf1srcfile "debian/scripts/source.unpack")
# (find-xf1srcfile "debian/sys-build.mk" "source.unpack:")

# (code-c-d "xf1xc" "/usr/src/xfree86-1-3.3.6/build-tree/xc/")
# (code-c-d "xhw86" (ee-xf1xcfile "programs/Xserver/hw/xfree86/"))
# (code-c-d "xterm" (ee-xf1xcfile "programs/xterm/"))
# (find-xf1xcfile "")
# (find-xhw86file "")
# (find-xtermfile "")

eecd xf1xc
cd programs/Xserver/
find * -type f | grep -i sis

eecd xf1xc
cd programs/Xserver/
find * -type f > .files
glimpseindex -H . -F < .files
glimpse -y -H . -l SiS | tee .files.SiS


# (find-xhw86file "SuperProbe/SiS.c")
# (find-xhw86file "doc/Japanese/sgml/SiS.sgml")
# (find-xhw86file "doc/Japanese/README.SiS")
# (find-xhw86file "doc/README.SiS")
# (find-xhw86file "doc/sgml/SiS.sgml")
# (find-xhw86file "vga16/drivers/sis/Imakefile")
# (find-xhw86file "vga2/drivers/sis/Imakefile")
# (find-xhw86file "vga256/drivers/sis/Imakefile")
# (find-xhw86file "vga256/drivers/sis/sis_accel.c")
# (find-xhw86file "vga256/drivers/sis/sis_BitBlt.c")
# (find-xhw86file "vga256/drivers/sis/sis_Blitter.h")
# (find-xhw86file "vga256/drivers/sis/sis_FillRct.c")
# (find-xhw86file "vga256/drivers/sis/sis_FillSt.c")
# (find-xhw86file "vga256/drivers/sis/sis_curs.c")
# (find-xhw86file "vga256/drivers/sis/sis_bank.s")
# (find-xhw86file "vga256/drivers/sis/sis_blitter.c")
# (find-xhw86file "vga256/drivers/sis/sis_blt16.c")
# (find-xhw86file "vga256/drivers/sis/sis_colexp.c")
# (find-xhw86file "vga256/drivers/sis/sis_driver.h")
# (find-xhw86file "vga256/drivers/sis/sis86c201.c")
# (find-xhw86file "vga256/drivers/sis/sis_pntwin.c")
# (find-xhw86file "vga256/drivers/sis/sis_solid.c")
# (find-xhw86file "vga256/drivers/sis/sis_teblt8.c")
# (find-xhw86file "vga256/drivers/sis/sis_textblt.s")
# (find-xhw86file "vga256/drivers/sis/sis_Blitter2.h")
# (find-xhw86file "vga256/drivers/sis/sis_accel2.c")
# (find-xhw86file "vga256/drivers/sis/")
# (find-xhw86file "xf86config/Cards")

# Old notes:

# (find-xffile "debian/rules")
# (find-xffile "Makefile" 51)

xinit -- :1 vt14





#####
#
# misc X things (mainly on cp850 font/keymap; old)
#
#####

# (find-demufile "etc/xinstallvgafont")
# (find-demufile "etc/vga.bdf")

# (find-node "(gawk)Top")
# (find-node "(gawk)Reading Files")
# (find-node "(gawk)Constant Size")
awk 'BEGIN{printf "%2x\n", 27}'

# (find-fline "/usr/X11R6/man/whatis")
# (find-elfile "iso-swed.el")
# (find-elfile "iso-ascii.el")
# (find-elfile "disp-table.el")
# (find-elfile "enriched.el")
# (find-elfile "iso-swed.el")
# (find-elnode "Frames")
# (find-elnode "Frames and Windows")
# (find-elnode "Input Focus")
# (find-elnode "X Selections")
# (find-elnode "Resources")
# (find-elnode "Frame Parameters")

man iso_8859_1
rpm -ql kbd

# (find-fline "/usr/lib/kbd/consolefonts/")
# (find-fline "/usr/lib/kbd/consoletrans/")

setfont /usr/lib/kbd/consolefonts/cp850-8x8

# "Danish HOWTO", na página ...
# "Keyboard and Console HOWTO"
# "Italian HOWTO"
# "Portuguese HOWTO"

# (find-fline "/usr/lib/X11/XKeysymDB")

# (find-fline "/.Xmodmap")
xmodmap -pk

man psfaddtable
man psfgettable
man psfstriptable

psfgettable /usr/lib/kbd/consolefonts/lat1u-10.psf
psfgettable /usr/lib/kbd/consolefonts/lat1-08.psf

(find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.dir")
(find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.alias")
(hexl-find-file "/home/replace/ega0.16")



#####
#
# bdf programs in xfree-3.3.6
# 2000sep26
#
#####

# «base_bdf_programs»  (to "font2bdf")
# (to "xf86src1")

# (find-xcfile "lib/font/Speedo/")
# (find-xcfile "lib/font/Speedo/sptobdf.c")
# (find-xcfile "lib/font/bitmap/")
# (find-xcfile "lib/font/bitmap/bdfint.h")
# (find-xcfile "lib/font/bitmap/bdfread.c")
# (find-xcfile "lib/font/bitmap/bdfutils.c")
# (find-xcfile "programs/Xserver/xkb/xkbDflts.h")
# (find-xcfile "programs/bdftopcf/")
# (find-xcfile "programs/bdftopcf/bdftopcf.c")
# (find-xcfile "programs/bdftopcf/bdftopcf.man")
# (find-xcfile "programs/fstobdf/")
# (find-xcfile "programs/fstobdf/chars.c")
# (find-xcfile "programs/fstobdf/fstobdf.c")
# (find-xcfile "programs/fstobdf/fstobdf.man")
# (find-xcfile "programs/fstobdf/header.c")
# (find-xcfile "programs/fstobdf/props.c")

# (find-xcfile "programs/Xserver/hw/xfree86/etc/vga.bdf")

xlsfonts | grep misc-fixed
for i ($(xlsfonts | grep misc-fixed | sort)); do xfd -fn $i ; done

# (find-sh "xlsfonts")
# (find-sh "xlsfonts | grep -v -")



#####
#
# font2bdf
# 2000sep26
#
#####

# «font2bdf»  (to ".font2bdf")
# (to "base_bdf_programs")
# (find-fline "~/TCL/font2bdf")

#
hexdump ~/MTA/math1.8 \
  | expect -c '
      while {[gets stdin li]!=-1} {
        if {[regexp {^[0-z]+ ([ 0-z]+)} $li -> pairs]} {
	  set bytes {}
	  foreach pair $pairs {
	    regexp (..)(..) $pair -> low hi
	    lappend bytes $hi $low
	  }
	  puts [lrange $bytes 0 7]
	  puts [lrange $bytes 8 15]
        }
      }
    ' \
  | tee ~/MTA/math1.8.hex
#

# (find-fline "~/TCL/font2bdf")
#font2bdf ~/MTA/math1.8.hex

rm -v *.bdf

COMMENT=mathvga0 \
FONT=mathvga0 \
  font2bdf ~/MTA/math1.8.hex \
  |& tee ~/MTA/math1.8.bdf

COMMENT=mathvga		\
FONT=mathvga		\
BITMAPFORMAT="%s"	\
BBX="8 8 0 0"		\
FONTBOUNDINGBOX="8 8 0 0"	\
FONT_DESCENT=0		\
FONT_ASCENT=8		\
  font2bdf ~/MTA/math1.8.hex \
  |& tee ~/MTA/math1.8b.bdf

rm -v ~/MTA/fonts.dir
mkfontdir ~/MTA/

# (find-fline "~/TCL/font2bdf")
# (find-fline "~/MTA/")
# (find-fline "~/MTA/math1.8.bdf")
# (find-fline "~/MTA/math1.8b.bdf")
# (find-fline "~/tmp/vga.bdf")
# (to "tmp_vga.bdf")

#
# «font2bdf_2x»  (to ".font2bdf_2x")
# (to "bdfresize")

cd ~/MTA/
cat math1.8b.bdf \
  | sed s/mathvga/mathvgax2/g \
  | bdfresize -w 2 -h 2 \
  > math1.8c.bdf

rm -v ~/MTA/fonts.dir
mkfontdir ~/MTA/

#
# (to "installing_a_font")

rm -Rv /tmp/xfonts/
mkdir  /tmp/xfonts/
cp -v ~/MTA/math1.8.bdf /tmp/xfonts/
cp -v ~/MTA/math1.8b.bdf /tmp/xfonts/
mkfontdir /tmp/xfonts/

xset fp default
xset fp+ /tmp/xfonts
xset fp rehash
xlsfonts | grep math

#

# Tests:
# (used to be with mathvga0.)
xfd -fn mathvga
xterm -fn mathvga
emacs -fn mathvga ~/CRIM/014ideas

xterm -fn mathvga0

#
# «X_with_mathfont»  (to ".X_with_mathfont")
# (find-fline "~/.xinitrc")
# (find-fline "~/MTA/")
# (find-angg ".zshrc" "X")

rm -v ~/MTA/fonts.dir
mkfontdir ~/MTA/
xset_MATH

#





#####
#
# mk_modmap
# 2000sep26
#
#####

# (find-fline "/usr/bin/mk_modmap")
mk_modmap < ~/MTA/math850.map




#####
#
# making X start without changing the VC
#
#####

l /usr/man/whatis
man console

cd $RBU/XFree86-3.2/xc/programs/Xserver/
agrep -i /dev/ $(find -name '*.c') | grep -i /dev/ | sort
(find-xcfile "programs/Xserver/hw/xfree86/os-support/linux/lnx_init.c" 55)
(find-xcfile "programs/Xserver/hw/xfree86/os-support/linux/lnx_init.c" 107)
(find-xcfile "programs/Xserver/hw/xfree86/os-support/linux/lnx_init.c" 77)
(find-k2file "drivers/char/vt.c" 762)
(find-k2file "drivers/char/vt.c" 697)
(find-k2file "include/linux/vt.h" 6)




######
#
# xfs-xtt
# 2000oct30
#
######

# «xfs-xtt»  (to ".xfs-xtt")
# (find-status "xfs-xtt")
# (find-vldifile "xfs-xtt.list")
# (find-fline "/usr/doc/xfs-xtt/")
# (find-fline "/usr/doc/xfstt/FAQ.gz" "mkdir")
# (find-fline "/usr/sbin/update-fonts-ttcap")
# (find-fline "/usr/doc/xfstt/examples/")
# (find-fline "/usr/share/fonts/truetype/")
# (find-man "xset")
# (find-man "xfstt")

# (find-vldifile "xfs-xtt.conffiles")
# (find-vldifile "xfs-xtt.postinst")
# (find-vldifile "xfs-xtt.postrm")
# (find-vldifile "xfs-xtt.preinst")
# (find-vldifile "xfs-xtt.prerm")

# (find-fline "/etc/init.d/xfs")
# (find-fline "/etc/init.d/xfstt")
# (find-fline "/etc/init.d/xfs-xtt")
# (find-fline "/etc/X11/xfs/config")
# (find-fline "/etc/X11/xfs/xfs.options")

cp -v /dos/c/windows/system/*.ttf /usr/share/fonts/truetype/
# /etc/init.d/xfstt restart
/etc/init.d/xfs-xtt restart

xset fp default
xset fp+ unix/:7101
xlsfonts | grep ttf

# (eeman "xfs-xtt" "7100")
xset fp default
xlsfonts | sort | uniq | tee ~/o1 | wc
xset fp+ unix/:7100
xlsfonts | sort | uniq | tee ~/o2 | wc
xlsfonts | grep ttf

xlsfonts | grep 0-0-0

comm ~/o1 ~/o2




#####
#
# TrueType utils
# 2000nov01
#
#####

# «tt_utils»  (to ".tt_utils")
# (find-status "dtm")
# (find-vldifile "dtm.list")
# (find-fline "/usr/doc/dtm/")

# (find-status "type1inst")
# (find-vldifile "type1inst.list")
# (find-fline "/usr/doc/type1inst/")

# (find-status "freetype-tools")
# (find-vldifile "freetype-tools.list")
# (find-fline "/usr/doc/freetype-tools/")
# (find-fline "/usr/doc/freetype-tools/README.gz" "\nIII. How to use the test")
# (eeman "1 ttf2bdf")
# (eeman "1 ttf2pk")
# (eeman "1 ttf2tfm")
# (find-fline "/etc/ttf2pk/ttfonts.map")

# (find-status "t1utils")
# (find-vldifile "t1utils.list")
# (find-fline "/usr/doc/t1utils/")

# (find-status "gfontview")
# (find-vldifile "gfontview.list")
# (find-fline "/usr/doc/gfontview/")

# (find-status "xfonts-arphic-bkai00mp")
# (find-vldifile "xfonts-arphic-bkai00mp.list")
# (find-fline "/usr/doc/xfonts-arphic-bkai00mp/")

# (find-fline "/usr/share/enlightenment/themes/BlueSteel/ttfonts/")
cd /usr/share/enlightenment/themes/BlueSteel/ttfonts/
gfontview .
gfontview *.ttf

# (find-fline "/usr/X11R6/lib/X11/fonts/TrueType/")
gfontview /usr/X11R6/lib/X11/fonts/TrueType/

locate '' | agrep -i type1

# (find-htetfile "Font-HOWTO.gz")




#####
#
# xfs
# 2005mar03
#
#####

# «xfs0»  (to "xfs")
# «fstobdf»  (to ".fstobdf")

# (find-status "xfs")
# (find-vldifile "xfs.list")
# (find-fline "/usr/doc/xfs/")

# (find-man "1x xfs")
# (find-man "1x xfs" "/usr/X11R6/lib/X11/fs/config")
# (find-man "5 xfs.options")

# (find-status "xbase-clients")
# (find-vldifile "xbase-clients.list")
# (find-fline "/usr/doc/xbase-clients/")

# (find-man "1x fstobdf")
# (find-man "1x fslsfonts")

# (find-fline "/usr/X11R6/lib/X11/fs/config")
# (find-fline "/usr/X11R6/lib/X11/fs/config" "no-listen = tcp")
# (find-fline "$ASROOT/usr/X11R6/lib/X11/fs/config" "no-listen = tcp")

 (eechannel-xterm "A")

ps ax | grep xfs
lsof | grep $(pidof xfs)

# (find-fline "/etc/init.d/xfs")
/etc/init.d/xfs restart
fslsfonts -server 127.0.0.1:7100
fslsfonts -server 127.0.0.1:7100 | grep -i mule

fstobdf -s 127.0.0.1:7100 \
  -fn -etl-fixed-medium-r-normal--0-0-72-72-c-0-muleipa-1
fstobdf -s 127.0.0.1:7100 \
  -fn -etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-0

xfd -fn -etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-1
fstobdf -s 127.0.0.1:7100 \
    -fn -etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-1 \
      > /tmp/o.bdf
xmbdfed /tmp/o.bdf

 ==[ end of the f9 section ]==


(defun find-fsbdf (fontname &rest rest)
  (apply 'find-sh (concat "fstobdf -s 127.0.0.1:7100 -fn " fontname) rest))
(defun find-fsbdf0 (fontname)
  (start-process "xfd" "*Messages*" "xfd" "-fn" fontname))

;; (find-fsbdf  "-etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-1")
;; (find-fsbdf0 "-etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-0")
;; (find-fsbdf0 "-etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-1")
;; (find-fsbdf0 "-etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-2")
;; (find-fsbdf0 "fixed")

#
# (find-anggfile "vtutil4/vtfontlib.lua")
cd ~/vtutil4/
lua50 vtutil.lua -e '
  Loadfont("ega1-iso.8");
  Modifyfont();
  Writefont("/tmp/isomath.psf")
'
laf /tmp/isomath.psf

#
# (find-man "1 xmbdfed")
# (find-man "1 xmbdfed" "Console Font <Ctrl+L>")
cd /tmp/
xmbdfed &

# File > Import > Console Font <Ctrl+L> > isomath.psf
# File > Save as > isomath.bdf
# (find-fline "/tmp/isomath.bdf")
# Set the frame geometry to 80x49 to make pgup/pgdn behave nicer

#
mkfontdir /tmp
xset fp default
xset fp+ /tmp
xset fp rehash
xlsfonts | grep math

xfd -fn isomath.psf

#
# But Emacs doesn't like the new font:
emacs21 -fn isomath.psf 
~/bigsrc/emacs/src/emacs -fn isomath.ps

emacs21 -fn -etl-fixed-medium-r-normal--24-240-72-72-c-120-mulearabic-2



# (find-man "1 xlsfonts")

# (find-sh "xlsfonts -ll -fn fixed")
# (find-sh "xlsfonts -ll -fn 5x8")
# (find-sh "xlsfonts -ll -fn 6x9")
# (find-sh "xlsfonts -ll -fn isomath")

# (find-sh "xlsfonts -ll -fn fixed")
# (find-sh "xlsfonts -ll -fn 5x8")
# (find-sh "xlsfonts -ll -fn 6x9")


;; (find-fsbdf  "5x8")
;; (find-fsbdf  "6x9")
;; (find-fsbdf  "isomath.psf")



  properties:		22
      FONTNAME_REGISTRY     
      FOUNDRY               Misc
      FAMILY_NAME           Fixed
      WEIGHT_NAME           Medium
      SLANT                 R
      SETWIDTH_NAME         Normal
      ADD_STYLE_NAME        
      PIXEL_SIZE            8
      POINT_SIZE            80
      RESOLUTION_X          75
      RESOLUTION_Y          75
      SPACING               C
      AVERAGE_WIDTH         50
      CHARSET_REGISTRY      ISO8859
      CHARSET_ENCODING      1
      COPYRIGHT             Public domain font.  Share and enjoy.
      CAP_HEIGHT            6
      X_HEIGHT              4
    FONT                  -Misc-Fixed-Medium-R-Normal--8-80-75-75-C-50-ISO8859-1
      WEIGHT                10
      RESOLUTION            103
      QUAD_WIDTH            5



      PIXEL_SIZE            8
      POINT_SIZE            80
      RESOLUTION_X          72
      RESOLUTION_Y          72
      SPACING               C
      AVERAGE_WIDTH         0
      _XMBDFED_INFO         471
      FONT                  isomath
      WEIGHT                10
      RESOLUTION            99
      X_HEIGHT              -1
      QUAD_WIDTH            0




x





(find-man "1 xmbdfed")

xfd -fn -etl-fixed-medium-r-normal--0-0-72-72-c-0-muleipa-1
xfd -fn -etl-fixed-medium-r-normal--24-240-72-72-c-120-muleipa-1

# What is the name of the font in a pcf?

cd /usr/X11R6/lib/X11/fonts/
find | grep font

xset fp default
xlsfonts | grep math
xset fp+ /usr/X11R6/lib/X11/fonts/Xg
xset fp rehash
xlsfonts | grep math

xfd -fn misc.math1
xfd -fn misc.math2
xfd -fn matty.math1
xfd -fn matty.math2

fstobdf -s 127.0.0.1:7100 \
  -fn misc.math1

# (eeman "xfs" "SIGUSR1")
# (find-fline "/usr/X11R6/lib/X11/fs/config")
# (find-fline "/etc/X11/xfs/config")





#####
#
# fonte 850 no X: novas esperanças
#
#####

# «installing_a_font»  (to ".installing_a_font")
# (to "font2bdf")

cd ~/C
xmbdfed

# (find-fline "~/C/math1.bdf")
cd ~/C
bdftopcf -o math1.pcf math1.bdf

# (eeman "X" "using bdftopcf")

strace-to ~/s \

mkfontdir ~/C
xset fp default
xset fp+ ~/C
xset fp rehash
xlsfonts | grep math
xfd -fn math1

xterm -fn math1


# Broken:

xterm -geometry 80x50 -font math1.8 &

xterm -geometry 80x50 -font nh12 &

fslsfonts
fstobdf

# (find-fline "/etc/X11/")
# (find-fline "/usr/X11R6/lib/X11/fonts/")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.alias")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.dir")

xfd -fn math1 &
xfd -fn vga &
xfd -fn cursor &

gzip -cd /usr/X11R6/lib/X11/fonts/misc/vga.pcf.gz | 

dmissing bdftopcf
# (find-vldifile "xbase-clients.list")
# (find-vldifile "xfs.list")
# (find-fline "/etc/X11/xfs/xfs.options")

/etc/init.d/xfs start




#####
#
# xanim
# 2001apr06
#
#####

# «xanim»  (to ".xanim")
#
pdsc $SDEBIAN/dists/potato/non-free/source/graphics/xanim_2.80.1-4.dsc
cd /usr/src/xanim-2.80.1/
debian/rules binary	|& tee odrb
# Then install it, etc, etc.

#
# (find-status "xanim")
# (find-vldifile "xanim.list")
# (find-fline "/usr/doc/xanim/")
# (find-fline "/usr/doc/xanim/indeo.readme.gz")
# (find-shttpw3 "xanim.va.pubnix.com/")
# (find-shttpw3 "xanim.va.pubnix.com/linuxELFx86g21.html")

# This is to make xanim support some proprietary formats:
# (find-fline "/usr/lib/xanim/")
cd /usr/lib/xanim/
tar -xvzf $S/ftp/xanim.va.pubnix.com/dlls/vid_h261_1.0_linuxELFx86g21.tgz
tar -xvzf $S/ftp/xanim.va.pubnix.com/dlls/vid_h263_1.0_linuxELFx86g21.tgz
tar -xvzf $S/ftp/xanim.va.pubnix.com/dlls/vid_iv32_2.1_linuxELFx86g21.tgz
tar -xvzf $S/ftp/xanim.va.pubnix.com/dlls/vid_iv41_1.0_linuxELFx86g21.tgz
tar -xvzf $S/ftp/xanim.va.pubnix.com/dlls/vid_iv50_1.0_linuxELFx86g21.tgz
tar -xvzf $S/ftp/xanim.va.pubnix.com/dlls/vid_cvid_2.0_linuxELFx86g21.tgz
tar -xvzf $S/ftp/xanim.va.pubnix.com/dlls/vid_cyuv_1.0_linuxELFx86g21.tgz
#






######
#
# xzoom hacking notes (slink)
# 99aug??
#
######

# «xzoom_hacking»

# xzoom wasn't respecting the gravity specs in its -geometry
# parameter. Here are some notes on debugging/hacking it.

apti xlib6g-dev
apti ltrace
apti gccdocs

# Let this run for a few seconds, then abort:
ltrace -o ~/s xzoom -geometry -0+0
sort ~/s | uniq | tee ~/o
# (find-fline "~/s")
# (find-fline "~/o")

XChangeProperty
XCheckWindowEvent
XCreateFontCursor
XCreateGC
XCreatePixmapCursor
XCreatePixmapFromBitmapData
XCreateWindow
XDefineCursor
XMapWindow
XOpenDisplay
XParseGeometry
XShmAttach
XShmCreateImage
XShmGetImage
XShmPutImage
XSync
XWindowEvent

dmissing XParseGeometry
apti xmanpages

# (find-vldifile "xmanpages.list")
# (find-fline "/usr/doc/xmanpages/")
# (eeman "XParseGeometry")
# (eeman "XCreateWindow")

# (find-vldifile "ltrace.list")
# (find-fline "/usr/doc/ltrace/")
# (find-fline "/etc/ltrace.conf")





######
#
# xzoom hacking
# 99aug??
#
######

pdsc /big/slinks2/dists/slink/main/source/x11/xzoom_0.3-8.dsc
cd /usr/src/xzoom-0.3/
# (find-fline "/usr/src/xzoom-0.3/xzoom.c" 506)
#	xswa.bit_gravity = NorthEastGravity;	/* edrx */
#	xswa.win_gravity = NorthEastGravity;	/* edrx */
debian/rules CDEBUGFLAGS=-g3 binary	|& tee odrb

cd /usr/src/xzoom-0.3/
gcc -E xzoom.c > xzoom.E
agrep '^\#' *.E | getstrings | sort | uniq > .files.ch

/usr/src/xzoom-0.3/xzoom -geometry 300x300+0-0

# (find-fline "/usr/src/xzoom-0.3/xzoom.c")
# (find-fline "/usr/src/xzoom-0.3/xzoom.E")
# (find-fline "/usr/src/xzoom-0.3/debian/rules")
# (find-fline "/usr/src/xzoom-0.3/Makefile" "CDEBUGFLAGS")


cd /usr/src/xzoom-0.3/
agrep WidthValue $(<.files.ch)
# (find-fline "/usr/include/X11/Xutil.h" "WidthValue")
# (find-fline "/usr/include/X11/Xlib.h" "XSetWindowAttributes")
# (find-fline "/usr/include/X11/Xlib.h" "bit_gravity")
# (find-fline "/usr/include/X11/X.h" "bit gravity")
# (find-fline "/usr/include/X11/X.h" "Window gravity")

# (find-fline "~/.gdbinit")
# (find-node "(gdb)Source Path")
# (find-node "(gcc)Debugging Options")
# (gdb "gdb /usr/src/xzoom-0.3/xzoom")

#
# (eeg-bounded)
br 405
br 507
run -geometry 300x300+20-20

p *argv
n
p xpos
p ypos
p width
p height
p dest_geom_mask
cont

p xpos
p ypos
p width
p height
p xswa
#
p *(xswa.win_gravity)
#




#####
#
# wmctrl
# 2012mar16 / 2019aug08
#
#####

# «wmctrl»  (to ".wmctrl")
# (find-angg ".emacs" "fullscreen")
# (find-es "lua5" "xctrl")
# (find-status   "wmctrl")
# (find-vldifile "wmctrl.list")
# (find-udfile   "wmctrl/")
# (find-man "1 wmctrl")
# (find-man "1 wmctrl" "\nEXAMPLES\n")

# (find-sh "wmctrl -l")
# (find-sh "wmctrl -p -G -l")
# (find-sh "wmctrl -p -G -l -r :SELECT:")
# (find-sh "wmctrl -m")

# (find-sh "wmctrl -h")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

wmctrl -r :ACTIVE: -b add,fullscreen
wmctrl -r :ACTIVE: -b remove,fullscreen
wmctrl -o 1024,0
wmctrl -o 0,0

wmctrl -r channel -b add,shaded
wmctrl -r channel -b remove,shaded
wmctrl -a channel

wmctrl -r :SELECT: -T "channel TWU_"

# (find-fline "~/LOGS/2007apr12.lua")
# (find-sh "xwininfo -tree")
# (find-man "xwininfo")




#####
#
# wmctrl (from the debian sources)
# 2012mar16
#
#####

# «wmctrl-deb-src»  (to ".wmctrl-deb-src")
# http://ftp.debian.org/debian/pool/main/w/wmctrl/wmctrl_1.07-6.dsc
# http://ftp.debian.org/debian/pool/main/w/wmctrl/wmctrl_1.07-6.diff.gz
# http://ftp.debian.org/debian/pool/main/w/wmctrl/wmctrl_1.07.orig.tar.gz

#
rm -Rv ~/usrc/wmctrl/
mkdir  ~/usrc/wmctrl/
cd $S/http/ftp.debian.org/debian/pool/main/w/wmctrl/
cp -v wmctrl_1.07* ~/usrc/wmctrl/
cd     ~/usrc/wmctrl/
dpkg-source -sn -x wmctrl_1.07-6.dsc
cd     ~/usrc/wmctrl/wmctrl-1.07/
# dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (code-c-d "wmctrl" "~/usrc/wmctrl/wmctrl-1.07/")
# (find-wmctrlfile "")
# (find-wmctrlfile "README")
# http://www.freedesktop.org/standards/wm-spec/
# http://sweb.cz/tripie/utils/wmctrl/
# http://ftp.acc.umu.se/pub/GNOME/sources/zenity/





#####
#
# Which window manager is running
# 2019aug08
#
#####

# «which-window-manager» (to ".which-window-manager")
# https://askubuntu.com/questions/72549/how-to-determine-which-window-manager-is-running
# https://en.wikipedia.org/wiki/X_display_manager
# https://en.wikipedia.org/wiki/Window_manager
# https://en.wikipedia.org/wiki/Display_server
# https://en.wikipedia.org/wiki/Desktop_environment

# (find-status   "wmctrl")
# (find-vldifile "wmctrl.list")
# (find-udfile   "wmctrl/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
wmctrl -m
echo $XDG_CURRENT_DESKTOP
echo $GDMSESSION





#####
#
# replace-window-manager
# 2021nov01
#
#####

# «replace-window-manager»  (to ".replace-window-manager")
# (find-sh "wmctrl -m")
# (find-sh "locate -i bin/xfwm4")
# (find-fline "/usr/bin/" "awesome")
# (find-man "1 xfwm4")
# (find-man "1 awesome")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xfwm4   --replace &
# ^ creates something that looks like a bare X
awesome --replace &
# ^ "another window manager is already running (can't select SubstructureRedirect)"

https://askubuntu.com/questions/572892/changing-window-manager-in-lightdm



#####
#
# lock
# 2019aug14
#
#####

# «lock» (to ".lock")
# (find-es "apt" "apt-cache")
# (find-zsh "installeddebs | sort | grep lock")
# (find-zsh "availabledebs | sort | grep lock")
# (find-status   "light-locker")
# (find-vldifile "light-locker.list")
# (find-udfile   "light-locker/")

# (find-man "1 light-locker")
# (find-man "1 light-locker-command")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apt-cache show light-locker
apt-cache search light-locker
apt-cache depends light-locker
apt-cache rdepends light-locker

apt-cache showpkg light-locker




# (find-sh "pstree")
# (find-sh "pstree" "light-locker")

        |-lightdm-+-2*[Xorg---{InputThread}]
        |         |-lightdm-+-x-session-manag-+-applet.py---{gmain}
        |         |         |                 |-caja-+-{dconf worker}
        |         |         |                 |      |-{gdbus}
        |         |         |                 |      `-{gmain}
        |         |         |                 |-light-locker-+-{dconf worker}
        |         |         |                 |              |-{gdbus}
        |         |         |                 |              `-{gmain}
        |         |         |                 |-marco-+-{dconf worker}
        |         |         |                 |       |-{gdbus}
        |         |         |                 |       `-{gmain}
        |         |         |                 |-mate-panel-+-chrome-+-2*[cat]
        |         |         |                 |            |        |-chrome-+-chrome
        |         |         |                 |            |        |        |-{Chrome_ChildIOT}
        |         |         |                 |            |        |        |-{MemoryInfra}
        |         |         |                 |            |        |        |-{ThreadPoolForeg}
        |         |         |                 |            |        |        |-{ThreadPoolServi}
        |         |         |                 |            |        |        |-{VizCompositorTh}
        |         |         |                 |            |        |        `-{Watchdog}
        |         |         |                 |            |        |-chrome-+-{Chrome_ChildIOT}
        |         |         |                 |            |        |        |-{MemoryInfra}
        |         |         |                 |            |        |        |-3*[{ThreadPoolForeg}]
        |         |         |                 |            |        |        |-{ThreadPoolServi}
        |         |         |                 |            |        |        `-{inotify_reader}
        |         |         |                 |            |        |-chrome-+-{Chrome_ChildIOT}
        |         |         |                 |            |        |        |-{MemoryInfra}
        |         |         |                 |            |        |        |-2*[{ThreadPoolForeg}]
        |         |         |                 |            |        |        |-{ThreadPoolServi}
        |         |         |                 |            |        |        `-{threaded-ml}
        |         |         |                 |            |        |-chrome-sandbox---chrome-+-chrome-+-chrome-+-{AudioOutputDevi}
        |         |         |                 |            |        |                         |        |        |-{Chrome_ChildIOT}
        |         |         |                 |            |        |                         |        |        |-2*[{CompositorTil+
        |         |         |                 |            |        |                         |        |        |-{Compositor}
        |         |         |                 |            |        |                         |        |        |-{GpuMemoryThread}
        |         |         |                 |            |        |                         |        |        |-{Media}
        |         |         |                 |            |        |                         |        |        |-{MemoryInfra}
        |         |         |                 |            |        |                         |        |        |-2*[{ThreadPoolFor+
        |         |         |                 |            |        |                         |        |        |-{ThreadPoolServi}
        |         |         |                 |            |        |                         |        |        |-{ThreadPoolSingl}
        |         |         |                 |            |        |                         |        |        `-{WebCrypto}
        |         |         |                 |            |        |                         |        |-24*[chrome-+-{Chrome_Child+
        |         |         |                 |            |        |                         |        |            |-2*[{Composito+
        |         |         |                 |            |        |                         |        |            |-{Compositor}]
        |         |         |                 |            |        |                         |        |            |-{GpuMemoryThr+
        |         |         |                 |            |        |                         |        |            |-{MemoryInfra}+
        |         |         |                 |            |        |                         |        |            |-{ThreadPoolFo+
        |         |         |                 |            |        |                         |        |            `-{ThreadPoolSe+
        |         |         |                 |            |        |                         |        |-chrome-+-{Chrome_ChildIOT}
        |         |         |                 |            |        |                         |        |        |-2*[{CompositorTil+
        |         |         |                 |            |        |                         |        |        |-{Compositor}
        |         |         |                 |            |        |                         |        |        |-{Database thread}
        |         |         |                 |            |        |                         |        |        |-{GpuMemoryThread}
        |         |         |                 |            |        |                         |        |        |-{Media}
        |         |         |                 |            |        |                         |        |        |-{MemoryInfra}
        |         |         |                 |            |        |                         |        |        |-{ServiceWorker t}
        |         |         |                 |            |        |                         |        |        |-2*[{ThreadPoolFor+
        |         |         |                 |            |        |                         |        |        |-{ThreadPoolServi}
        |         |         |                 |            |        |                         |        |        `-{ThreadPoolSingl}
        |         |         |                 |            |        |                         |        |-2*[chrome-+-{Chrome_ChildI+
        |         |         |                 |            |        |                         |        |           |-2*[{Compositor+
        |         |         |                 |            |        |                         |        |           |-{Compositor}]
        |         |         |                 |            |        |                         |        |           |-{GpuMemoryThre+
        |         |         |                 |            |        |                         |        |           |-{ThreadPoolFor+
        |         |         |                 |            |        |                         |        |           `-{ThreadPoolSer+
        |         |         |                 |            |        |                         |        `-chrome-+-{Chrome_ChildIOT}
        |         |         |                 |            |        |                         |                 |-{ThreadPoolForeg}
        |         |         |                 |            |        |                         |                 `-{ThreadPoolServi}
        |         |         |                 |            |        |                         `-chrome-sandbox---nacl_helper
        |         |         |                 |            |        |-{BatteryStatusNo}
        |         |         |                 |            |        |-{Bluez D-Bus thr}
        |         |         |                 |            |        |-{BrowserWatchdog}
        |         |         |                 |            |        |-{CacheThread_Blo}
        |         |         |                 |            |        |-{Chrome_HistoryT}
        |         |         |                 |            |        |-{Chrome_IOThread}
        |         |         |                 |            |        |-{Chrome_SyncThre}
        |         |         |                 |            |        |-{CompositorTileW}
        |         |         |                 |            |        |-{CrShutdownDetec}
        |         |         |                 |            |        |-{LevelDBEnv.IDB}
        |         |         |                 |            |        |-{LevelDBEnv}
        |         |         |                 |            |        |-{MemoryInfra}
        |         |         |                 |            |        |-4*[{ThreadPoolForeg}]
        |         |         |                 |            |        |-{ThreadPoolServi}
        |         |         |                 |            |        |-2*[{ThreadPoolSingl}]
        |         |         |                 |            |        |-{VideoCaptureThr}
        |         |         |                 |            |        |-{chrome}
        |         |         |                 |            |        |-{extension_crash}
        |         |         |                 |            |        |-{gdbus}
        |         |         |                 |            |        |-{gmain}
        |         |         |                 |            |        |-{gpu-process_cra}
        |         |         |                 |            |        |-{inotify_reader}
        |         |         |                 |            |        |-{ppapi_crash_upl}
        |         |         |                 |            |        |-{renderer_crash_}
        |         |         |                 |            |        |-{sandbox_ipc_thr}
        |         |         |                 |            |        `-{utility_crash_u}
        |         |         |                 |            |-xterm---zsh---zsh---emacs24-+-zsh
        |         |         |                 |            |                             |-{dconf worker}
        |         |         |                 |            |                             |-{gdbus}
        |         |         |                 |            |                             `-{gmain}
        |         |         |                 |            |-{dconf worker}
        |         |         |                 |            |-{gdbus}
        |         |         |                 |            `-{gmain}
        |         |         |                 |-mate-power-mana-+-{dconf worker}
        |         |         |                 |                 |-{gdbus}
        |         |         |                 |                 `-{gmain}
        |         |         |                 |-mate-screensave-+-{dconf worker}
        |         |         |                 |                 |-{gdbus}
        |         |         |                 |                 `-{gmain}
        |         |         |                 |-mate-settings-d-+-2*[{dconf worker}]
        |         |         |                 |                 |-{gdbus}
        |         |         |                 |                 `-{gmain}
        |         |         |                 |-mate-volume-con-+-{gdbus}
        |         |         |                 |                 `-{gmain}
        |         |         |                 |-nm-applet-+-{dconf worker}
        |         |         |                 |           |-{gdbus}
        |         |         |                 |           `-{gmain}
        |         |         |                 |-polkit-mate-aut-+-{gdbus}
        |         |         |                 |                 `-{gmain}
        |         |         |                 |-ssh-agent
        |         |         |                 |-{dconf worker}
        |         |         |                 |-{gdbus}
        |         |         |                 `-{gmain}
        |         |         |-{gdbus}
        |         |         `-{gmain}
        |         |-lightdm-+-lightdm-gtk-gre-+-{gdbus}
        |         |         |                 `-{gmain}
        |         |         |-{gdbus}
        |         |         `-{gmain}
        |         |-{gdbus}
        |         `-{gmain}




#####
#
# lightdm
# 2019aug14
#
#####

# «lightdm» (to ".lightdm")
# (find-zsh "installeddebs | sort | grep lightdm")
# (find-zsh "availabledebs | sort | grep lightdm")
# https://launchpad.net/lightdm

# (find-status   "liblightdm-gobject-1-0")
# (find-vldifile "liblightdm-gobject-1-0.list")
# (find-udfile   "liblightdm-gobject-1-0/")
# (find-status   "lightdm-gtk-greeter")
# (find-vldifile "lightdm-gtk-greeter.list")
# (find-udfile   "lightdm-gtk-greeter/")
# (find-status   "lightdm")
# (find-vldifile "lightdm.list")
# (find-udfile   "lightdm/")

# (find-vldifile "gdm3.templates" "Please select which display manager")
# (find-vldifile "lightdm.templates" "Please select which display manager")
# (find-debpkg-links "lightdm")
# (find-debpkg-links "gdm3")





#####
#
# X calls
#
#####

# «xwit»  (to ".xwit")
# http://packages.debian.org/sid/xwit
# (find-available "xwit")
# (find-status   "xwit")
# (find-vldifile "xwit.list")
# (find-udfile   "xwit/")
# (find-man "1 xwit")

apti xmon

# (find-available "xmon")
# (find-vldifile "xmon.list")
# (find-fline "/usr/doc/xmon/")

# (find-zsh "dmissing xmon")



# (find-status   "xspecs")
# (find-vldifile "xspecs.list")
# (find-udfile   "xspecs/")

# (find-pspage "/usr/share/doc/xspecs/icccm.ps.gz")
# (find-pspage "/usr/share/doc/xspecs/icccm.ps.gz" 24 "win_gravity")

# (find-fline "/usr/share/doc/xspecs/icccm.txt.gz")




#####
#
# xbooks
#
#####

# «xbooks0»  (to ".xbooks0")
# (to "xbooks")

apti xbooks
#aptrm xbooks
# (find-vldifile "xbooks.list")
# (find-fline "/usr/doc/xbooks/")
# (find-fline "/usr/doc/xbooks/specs/XProtocol/")

cd /usr/doc/xbooks/hardcopy/
rm -Rv /tmp/xbooks
mkdir /tmp/xbooks
for i in $(find * -type f | grep PS | sed 's/.gz$//'); do
  b=$(basename $i)
  B=/tmp/xbooks/$b
  echo $i
  gzip -cd $i.gz > $B
  # gv $B
done

# ddx is nice.

mkdir /tmp/xbooks
gzip -cd < /usr/doc/xbooks/hardcopy/BDF/bdf.PS.gz > /tmp/xbooks/bdf.PS
gv /tmp/xbooks/bdf.PS

pstotext /tmp/xbooks/bdf.PS | tr ¡ - > /tmp/xbooks/bdf.txt
# (find-fline "/tmp/xbooks/bdf.txt")
# (find-fline "~/bdf.txt")




#####
#
# bdf/pcf
#
#####

dmissing bdf
dmissing pcf

apti 9fonts
# (find-vldifile "9fonts.list")
# (find-vldifile "9fonts.list" "math")
# (find-fline "/usr/doc/9fonts/")
# (find-vldifile "9fonts.postinst")

xset fp rehash

# (eeman "bdftopcf")
xbase-clients
# (find-vldifile "xbase-clients.list")
# (find-fline "/usr/doc/xbase-clients/")

xfd





######
#
# all fixed-width fonts
#
######

# «all_fixwid_xfonts»

# (find-e20node "Font X")
xlsfonts -fn '*x*'
xlsfonts -fn '*-*-*-*-*-*-*-*-*-*-*-m*'
xlsfonts -fn '*-*-*-*-*-*-*-*-*-*-*-c*'

# (find-man "X" "FONT NAMES")

alias getbdf='fstobdf -s 127.0.0.1:7100 -fn'
rm -Rv /tmp/bdf
mkdir /tmp/bdf
cd /tmp/bdf/
for i in $(
  xlsfonts -fn '*x*'
  xlsfonts -fn '*-*-*-*-*-*-*-*-*-*-*-m*'
  xlsfonts -fn '*-*-*-*-*-*-*-*-*-*-*-c*'
); do echo $i; getbdf $i > $i; done
rm -v -- $(find . -size 0)



# (find-fline "/usr/src/Isabelle98-1/src/Tools/8bit/fonts/")
mkfontdir /usr/src/Isabelle98-1/src/Tools/8bit/fonts/

xset fp default
xset fp+ /usr/src/Isabelle98-1/src/Tools/8bit/fonts
xset fp rehash

xfd -fn isacr14
xfd -fn oldisacr14
xfd -fn isacb24
xfd -fn -isabelle-fixed-medium-r-normal--14-140-75-75-m-90-isabelle-0
xfd -fn -isabelle-fixed-bold-r-normal--24-240-75-75-m-150-isabelle-0
xfd -fn spcb24
xfd -fn spcr14

xlsfonts | grep math

# (find-e20node "Faces")

# (find-vldifile "emacs20-el.list" "custom")
# (find-fline "/usr/doc/emacs20-el/")


getbdf misc.math1



# (code-c-d "isafnt" "/usr/src/Isabelle98-1/src/Tools/8bit/fonts/")
# (find-fline "~/bdf.txt")
# (find-isafntfile "")
# (find-isafntfile "isabelle14.bdf")

SWIDTH 0 0
SWIDTH 144 0
SWIDTH 168 0
SWIDTH 192 0
SWIDTH 216 0
SWIDTH 240 0
SWIDTH 264 0
SWIDTH 600 0
SWIDTH 666 0


STARTCHAR Gamma
ENCODING 161
SWIDTH 216 0
DWIDTH 9 0
BBX 7 10 1 -1
BITMAP
fe
62
60
60
60
60
60
60
60
f0
ENDCHAR





#####
#
# Emacs X keys
# 99dec25
#
#####

# «emacs_x_keys»
xmodmap -e "keycode 64 = Meta_L"
xmodmap -e "keysym Alt_R = Alt_R Multi_key"

# (find-fline "/usr/doc/xterm/README.Debian" "Delete:")
# (find-fline "/usr/doc/debian-policy/policy.text.gz" "``<--''")

# (find-fline "/usr/X11R6/lib/X11/")
# (find-fline "/usr/X11R6/lib/X11/xkb/symbols/us" "del")

# Oops - on Slink, emacs19 doesn't treat bsp and all dels the right
# way, but everything is ok on emacs20



#####
#
# a compose key (Multi_Key) for X
# 2005jan26
#
#####

# (find-man "1 xmodmap")
# (find-man "1 xmodmap" "keysym KEYSYMNAME = KEYSYMNAME ...")
xmodmap -e "keysym Menu = Multi_key"





######
#
# Meta key on X - for Emacs
#
######

# (find-fline "/etc/X11/XF86Config" "LeftAlt     Meta")

(defun mfk (key)
  (interactive "kKey: ")
  (insert (format "%s\n" (key-description key))))
(define-key global-map [f11] 'mfk)

# No meu X os dois Alts estão gerando A-key ao invés de M-key. 
# Isso é mau:
# (find-node "(elisp)Keyboard Events")

 (key-binding key))
         (current-buffer)))
; (define-key global-map "\M-g" 'mf)

# (find-fline "/etc/X11/XF86Config" "LeftAlt     Meta")
# (find-fline "~/.zshrc" "xmodmap")
# (eeman "xmodmap")
# (find-fline "~/replace/defkeymap850b.map")
xmodmap -e "keysym Alt_R = Alt_R Multi_key"'

xmodmap -pp

xmodmap -pm
xmodmap -pke
xmodmap -grammar

# Isso aqui resolve o problema, mas é específico para o meu teclado:

xmodmap -pke | egrep 'Alt|Meta'
xmodmap -e "keycode 64 = Meta_L"
xmodmap -pke | egrep 'Alt|Meta'

# Será que é o caso de mudar o tipo de teclado que o X escolhe usar? E
# como eu inspeciono as que existem? Bom, o xinit dá isso na
# inicialização:

/usr/X11R6/lib/X11/xkb/xkbcomp -w 1 \
  -R/usr/X11R6/lib/X11/xkb -xkm -m us -em1 \
  "The XKEYBOARD keymap compiler (xkbcomp) reports:" -emp "> " \
  -eml "Errors from xkbcomp are not fatal to the X server" \
  keymap/xfree86 compiled/xfree86.xkm'

# (find-fline "/usr/X11R6/lib/X11/xkb/keymap/xfree86")
# (find-fline "/usr/X11R6/lib/X11/xkb/")
# (find-fline "/usr/X11R6/lib/X11/xkb/geometry/pc")

cd /usr/X11R6/lib/X11/xkb/
agrep -i meta $(find *)


# (find-vldifile "xcontrib.list")
# (find-fline "/usr/doc/xcontrib/")

xev





#####
#
# mesa/glut (esp. demos)
# 99oct04
#
#####

Pgrep m/mesa/i
Pgrep m/glut/i

apti mesa-doc mesag-dev mesag3
apti glut-data glut-doc glutg3 glutg3-dev

# (find-fline "/usr/doc/glut-data/")
# (find-fline "/usr/doc/glut-doc/")
# (find-fline "/usr/doc/glutg3-dev/")
# (find-fline "/usr/doc/glutg3/")
# (find-fline "/usr/doc/mesa-doc/")
# (find-fline "/usr/doc/mesag-dev/")
# (find-fline "/usr/doc/mesag3/")
# (find-vldifile "glut-data.list")
# (find-vldifile "glut-doc.list")
# (find-vldifile "glutg3-dev.list")
# (find-vldifile "glutg3.list")
# (find-vldifile "mesa-doc.list")
# (find-vldifile "mesag-dev.list")
# (find-vldifile "mesag3.list")

# (find-fline "/usr/doc/glut-doc/examples/")

rm -Rv /tmp/mesa
mkdir /tmp/mesa
cd /tmp/mesa
ln -s /usr/include /tmp/mesa/include
tar -xvzf /usr/doc/glut-doc/examples/advanced.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/contrib.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/demos.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/examples.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/gle.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/mesademos.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/perf_harness.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/redbook.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/test.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/texfont.tar.gz
tar -xvzf /usr/doc/glut-doc/examples/tiff.tar.gz

cd /tmp/mesa/progs/demos/
make	|& tee om
# Run the demos:
atlantis/atlantis
# "bluepony" is too slow. Shrink its window.
bluepony/bluepony
bounce/bounce
chess/chess
geoface/geoface
glflare/glflare
gliq/gliq
glutmech/glutmech
ideas/ideas
lorenz/lorenz
opengl_logo/opengl_logo
(cd rollercoaster; rc)
# smooth/smooth
underwater/underwater
(cd walker; walker)
# yacme/yacme

cd /tmp/mesa/progs/examples/
make	|& tee om
# for i in *; do [[ -x $i ]] && echo $i; done
abgr; bitfont; blender; circlefit; cube; dials; dials2; dinoball;
dinoshade; dinospin; editgrid; evaltest; fogtst; fontdemo; glpuzzle;
glutdino; glutplane; halomagic; highlight; lightlab; mjksift; mjkwarp;
molehill; movelight; oclip; ohidden; olight; olympic; origami;
oversphere; reflectdino; rendereps; sb2db; scene; screendoor; scube;
simple; sphere; sphere2; splatlogo; spots; stars; stenciltst; stereo;
stroke; subwin; surfgrid; texenv; trippy; triselect; zoomdino;

cd /tmp/mesa/progs/gle/
make	|& tee om
# for i in *; do [[ -x $i ]] && echo $i; done
for i in *; do [[ -x $i ]] && echo $i && $i; done

cd /tmp/mesa/progs/advanced/
make	|& tee om
# for i in *; do [[ -x $i ]] && echo $i; done | tee ~/o
# Warning: "videoresize" is evil
# for i in *; do [[ -x $i ]] && echo $i && $i; done
accumaa; af_depthcue; af_teapots; boundary; comp; convolve; csg;
decal; dissolve; envmap; envphong; field; genmipmap; haloed;
hello2rts; hiddenline; imgproc; mipmap_lines; motionblur; multilight;
occlude; pointburst; projshadow; projtex; rasonly; sgiflag; shadowfun;
shadowmap; shadowvol; silhouette; softshadow; tess; textext; textile;
textrim; tvertex; -videoresize; warp; zcomposite;

cd /tmp/mesa/progs/contrib/
make	|& tee om
# for i in *; do [[ -x $i ]] && echo $i; done | tee ~/o
for i in *; do [[ -x $i ]] && echo $i && $i; done

cd /tmp/mesa/progs/redbook/
make	|& tee om
# for i in *; do [[ -x $i ]] && echo $i; done | tee ~/o
for i in *; do [[ -x $i ]] && echo $i && $i; done




pdsc /big/slinks2/dists/slink/main/source/libs/mesa_3.0-1.dsc
cd /usr/src/mesa-3.0/
debian/rules binary	|& tee odrb

# (code-c-d "mesa" "/usr/src/mesa-3.0/")
# (find-mesafile "")
# (find-mesafile "debian/")





######
#
# Detecting the video card for X
# 99oct20
#
######

# First some stuff about trying to make a minuscule XF86Config by
# hand. Useless.

# (eeman "XF86Config")
# (find-fline "/etc/X11/XF86Config")
# (find-fline "~/o")

grep -v '^#' /etc/X11/XF86Config
grep -v '^#' /etc/X11/XF86Config | uniq
grep -v '^#' /etc/X11/XF86Config | egrep -v '^[ 	]*$'
startx -- -xf86config /tmp/mini -bpp 16 &
startx -- -xf86config /home/root/XF86Config.mini -bpp 16 &

# (eeman "XFree86" "-xf86config file")
# (find-angg ".zshrc" "X")
# (find-fline "~/XF86Config.mini")
# (find-fline "/etc/X11/XF86Config")

# «auto-xf86config»

# Now the real stuff. The trick is to start X with the wrong card
# configured; the SVGA server will probe for the right card, and by
# examining its output we'll get a very good guess about which card we
# have. Then we make a modified copy of the script below and call it
# an "auto-xf86config"...

# The card #72 is a CT64200 on XFree86 3.3.2.

apti xserver-svga xbase-clients xfonts-75dpi

expect -c '
spawn xf86config
interact {
  -o -nobuffer "Press enter to continue" {send "\r"}
  "Enter a protocol number:" {send "6\r"}
  "Do you want to enable ChordMiddle?" {send "y\r"}
  "Do you want to enable Emulate3Buttons?" {send "n\r"}
  "Mouse device:" {send "\r"}
  "Do you want to use XKB?" {send "y\r"}
  "11  Enter your own horizontal sync range" {send "11\r"}
  "Horizontal sync range:" {send "30-64\r"}
  "2  50-90" {send "2\r"}
  "1  Standard 101-key, US encoding" {send "1\r"}
  "Enter an identifier" {send "\r"}
  "Enter the vendor name" {send "\r"}
  "Enter the model" {send "\r"}
  "3  The XF86_SVGA server" {send "3\r"}
  "5  4096K" {send "5\r"}
  "q to quit without selection of a RAMDAC" {send "q\r"}
  -re "Just press enter if you don.t want a Clockchip setting" {send "\r"}
  -re "Do you want me to run .X -probeonly. now?" {send "n\r"}
  "Do you want to look at the card database?" {send "y\r"}
  "Enter a number to choose the corresponding card definition." {send "76\r"}
  "5  The modes are OK, continue." {send "5\r"}
  "Do you want me to set the /etc/X11/Xserver file?" {send "y\r"}
  "Shall I write it there?" {send "n\n"}
  "Do you want it written to the current directory" {send "y\r"}
}
'

startx |& tee ~/o

grep '^(--)' ~/o | grep -v Mode




#####
#
# imagemagick
# 2004sep09
#
#####

# «imagemagick»  (to ".imagemagick")
# (find-es "imagemagick")
# (find-status   "imagemagick")
# (find-vldifile "imagemagick.list")
# (find-udfile   "imagemagick/")
# (find-man "1 ImageMagick")
# (find-man "1 ImageMagick" "-snaps")
# (find-man "1 animate")
# (find-man "1 compare")
# (find-man "1 composite")
# (find-man "1 conjure")
# (find-man "1 convert")
# (find-man "1 display")
# (find-man "1 identify")
# (find-man "1 import")
# (find-man "1 mogrify")
# (find-man "1 montage")
# (find-man "4 miff")
# (find-man "5 quantize")

# Section 19, "Commandline Options": "-affine"
# (find-pspage "/usr/share/ImageMagick-6.0.5/Magick.pdf" 48)




#####
#
# ImageMagick: backporting to sarge
# 2006sep21
#
#####

# «imagemagick-bp-to-sarge»  (to ".imagemagick-bp-to-sarge")
# (find-status   "imagemagick")
# (find-vldifile "imagemagick.list")
# (find-udfile   "imagemagick/")
# http://ftp.debian.org/debian/pool/main/i/imagemagick/
# http://ftp.debian.org/debian/pool/main/i/imagemagick/imagemagick_6.2.4.5.dfsg1-0.9.dsc
# http://ftp.debian.org/debian/pool/main/i/imagemagick/imagemagick_6.2.4.5.dfsg1-0.9.diff.gz
# http://ftp.debian.org/debian/pool/main/i/imagemagick/imagemagick_6.2.4.5.dfsg1.orig.tar.gz
#
rm -Rv ~/usrc/imagemagick/
mkdir  ~/usrc/imagemagick/
cd $S/http/ftp.debian.org/debian/pool/main/i/imagemagick/
cp -v imagemagick_6.2.4.5.dfsg1* ~/usrc/imagemagick/
cd     ~/usrc/imagemagick/
dpkg-source -sn -x imagemagick_6.2.4.5.dfsg1-0.9.dsc
cd     ~/usrc/imagemagick/imagemagick-6.2.4.5.dfsg1/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb
dpkg-buildpackage -us -uc -b -rfakeroot    -d     |& tee odbd

#
# (code-c-d "imagemagick" "~/usrc/imagemagick/imagemagick-6.2.4.5.dfsg1/")
# (find-imagemagickfile "")
# (find-imagemagickfile "odb")
# (find-man "1 dpkg-buildpackage" "dpkg-BUILDPACKAGE OPTIONS" "-d")

apti libbz2-dev libwmf-dev liblcms1-dev libexif-dev libjasper-1.701-dev libltdl3-dev

# (find-udfile "imagemagick/www/")
# (find-udw3m "imagemagick/www/convert.html")
# (find-udw3m "imagemagick/www/command-line-options.html#quality")






#####
#
# capturing screenshots
# 2004sep09
#
#####

# «screenshots»  (to ".screenshots")
# (find-status   "xbase-clients")
# (find-vldifile "xbase-clients.list")
# (find-udfile   "xbase-clients/")
# (find-status   "x11-apps")
# (find-vldifile "x11-apps.list")
# (find-udfile   "x11-apps/")
# (find-status   "xloadimage")
# (find-vldifile "xloadimage.list")
# (find-udfile   "xloadimage/")
#
cd /usr/lib/menu/
grep -i shot $(find *)
# (find-fline "/usr/lib/menu/xbase-clients" "Screenshot")
#
# (find-man "1 xwd")
# (find-man "1 xwud")
# (find-man "1 convert")
#
cd /tmp/
convert <(xwd) 
#
cd /tmp/
xwd | convert - ss.png
xview ss.png
#
cd /tmp/
xwd -root | convert - ss.png
laf ss.png
xview ss.png
#




#####
#
# gnome
# 99nov21
#
#####

# «gnome»

cd ~/SLINK/
ls *gno*

apti gnome-terminal gnome-session gnome-panel gmc

cd /var/lib/dpkg/info/
for i in *gno*.list; do basename $i .list; done

# (find-vldifile "gnome-core.list")
# (find-fline "/usr/doc/gnome-core/")
# (find-fline "/usr/doc/gnome-core/README.Debian")
# (find-fline "/usr/doc/gnome-core/README.Debian" "My .xsession file")

# (find-vldifile "gnome-session.list")
# (find-fline "/usr/doc/gnome-session/")

# E aí no X eu dou:
gnome-session &





#####
#
# WindowMaker
# 99nov22
#
#####

# «windowmaker»

cd ~/SLINK/
ls wm*

apti wmaker wmaker-usersguide-ps

# (find-vldifile "wmaker-usersguide-ps.list")
# (find-fline "/usr/doc/wmaker-usersguide-ps/")

# (find-vldifile "wmaker.list")
# (find-fline "/usr/doc/wmaker/")
# (find-fline "/usr/doc/wmaker/README.gz")
# (find-fline "/usr/doc/wmaker/README.gz" "Control+Shift+NumLock")

gzip -cd < /usr/doc/wmaker/guide.ps.gz > /tmp/guide.ps
gv /tmp/guide.ps





#####
#
# xmbdfed on potato
# 2000apr16
#
#####

# «xmbdfed»

# (find-vldifile "xmbdfed.list")
# (find-fline "/usr/doc/xmbdfed/")

# (code-c-d "bdf" "/usr/src/xmbdfed-4.3/")
# (find-bdffile "")
# (find-bdffile "CHANGES" "codepage")
# (find-bdftag "bdf_load_console_font")

pdsc $SDEBIAN/dists/potato/main/source/x11/xmbdfed_4.3-3.dsc
cd /usr/src/xmbdfed-4.3/
etags *.[ch]


# It worked! Now I have a bdf and a psf of my console math fonts.
# (find-fline "~/MTA/")
# (find-fline "~/MTA/math1.bdf")



cd ~/MTA/
bdftopcf -o math1.pcf math1.bdf
bdftopcf -o math.pcf math.bdf
mkfontdir ~/MTA/

xset fp default
xset fp+ ~/MTA
xset fp rehash
xlsfonts | grep math
xfd -fn math1.8
xfd -fn math

# Don't work:
xterm -fn math1.8
xterm -fn math


# (find-e20node "Command Arguments")
# (find-e20node "Font X")

emacs20 -fn 6x10




#####
#
# xtermset
# 2004sep09
#
#####

# (find-status   "xtermset")
# (find-vldifile "xtermset.list")
# (find-udfile   "xtermset/")
# (find-man "1 xtermset")
# (find-man "5 terms")
#
read; xtermset -fn 5x8
read; xtermset -fn math
read; xtermset -fn micro
read; xtermset -fn fixed
#





#####
#
# xfs on potato
# 2000apr19
#
#####

# «xfs»  (to "xfs0")
# The only way I know to get BDFs for the standard X fonts, besides
# taking them from the xfree sources, is using the font server via
# TCP. So:

# (find-vldifile "xfs.list")
# (find-fline "/usr/doc/xfs/")
# (find-fline "/usr/doc/xfs/README.Debian" "TCP")
# (find-fline "/etc/X11/xfs/config" "no-listen")

# (find-es "x" "all_fixwid_xfonts")
# (eeman "xlsfonts")
# (eeman "fslsfonts")
# (eeman "xfd")

/etc/init.d/xfs restart

fslsfonts -server 127.0.0.1:7100 \
  |& sort | uniq | tee ~/o
# (find-fline "~/o" "10x20")

rm -Rv /tmp/bdf
mkdir  /tmp/bdf
cd     /tmp/bdf/
for i in $(grep -v '^-' ~/o); do
  echo $i
  fstobdf -s 127.0.0.1:7100 -fn $i > $i
done
rm -v -- $(find . -size 0)

# (eeman "X" "FONT NAMES")
# (find-fline "/tmp/bdf/5x8")
#
# Now I do manual surgery on a font and try to use it...
# (find-fline "/tmp/bdf/fixed")
# (find-fline "~/MTA/fedrxed.bdf")
# (find-fline "~/MTA/fedrxed.bdf" "ENCODING 97")
# (find-fline "~/MTA/math.bdf")
# (find-node "(emacs-e20)Split Window")

(progn (find-fline "~/MTA/math.bdf")
  (split-window-horizontally)
  (find-fline "~/MTA/fedrxed.bdf"))




# (find-fline "~/MTA/")
# (find-fline "~/MTA/fonts.dir")
# (find-fline "/usr/X11R6/lib/X11/fonts/100dpi/fonts.alias")
# (find-fline "/usr/X11R6/lib/X11/fonts/75dpi/fonts.alias")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.alias")
# (eeman "update-fonts-alias")
# (eeman "mkfontdir" "FONT NAME ALIASES")
# (find-fline "/usr/sbin/update-fonts-alias")

cd ~/MTA/
bdftopcf -o fedrxed.pcf fedrxed.bdf
cat > fonts.alias <<'%%%'
!! fonts.alias -- automatically generated file.  DO NOT EDIT.
!! To modify, see update-fonts-alias(8).
edrx -edrx-fixed-medium-r-semicondensed--0-0-75-75-c-0-iso8859-1
%%%
# update-fonts-alias ~/MTA
mkfontdir ~/MTA/

xset fp default
xset fp+ ~/MTA
xset fp rehash
xlsfonts | grep dr

xtermset -fn edrx



xfd -fn math1.8
xfd -fn math




#####
#
# comparing short-named fonts to long-named ones
# 2000apr20
#
#####

# Ok, so I have to add functions to generate standard bdfs to my
# vtutil stuff... but does every font with a short name come from one
# with a full name? 

fslsfonts -server 127.0.0.1:7100 \
  |& sort | uniq | tee ~/o
rm -Rv /tmp/bdf
mkdir  /tmp/bdf
cd     /tmp/bdf/
# Avoid problems with spaces
for i in $(tr ' ' '_' < ~/o); do
  echo $i
  fstobdf -s 127.0.0.1:7100 -fn "$(echo $i | tr '_' ' ')" > "$i"
done

md5sum -- * | tee ~/o2
sort ~/o2 | l -S

# Yes, it seems that all short-named fonts are just aliases... which
# means that my bdf generator must be able to generate the long names.





#####
#
# xbooks' bdf.PS on potato
# 2000apr19
#
#####

# «xbooks»  (to ".xbooks")
# (to "xbooks0")
rm -Rv /tmp/xbooks/
mkdir  /tmp/xbooks/
cd     /tmp/xbooks/
ar p /big/potato/dists/potato/main/binary-all/x11/xbooks_3.3.6-1.deb \
  data.tar.gz | tar -xvzf - ./usr/share/doc/xbooks/BDF/bdf.ps.gz
zcat usr/share/doc/xbooks/BDF/bdf.ps.gz > ~/tmp/bdf.ps
rm -Rv /tmp/xbooks/

pstotext ~/tmp/bdf.ps | tr ¡ - > ~/tmp/bdf.txt

gv ~/tmp/bdf.ps

# (find-fline "~/tmp/bdf.txt")




#####
#
# xterm
# 2012apr02
#
#####

# «xterm»  (to ".xterm")
# (find-status   "xterm")
# (find-vldifile "xterm.list")
# (find-udfile   "xterm/")
# (find-man "1 xterm")
# (find-man "1 xterm" "-T string")
# (find-man "1 xterm" "-T string")
# (find-man "1 xterm" "-display display")
# (find-man "1 xterm" "\nPOINTER USAGE")
# (find-man "1 xterm" "\nMENUS")
# (find-man "1 xterm" "\nMENUS" "The xterm fontMenu pops up when")
-fn micro
-e
class

2022dec08:
The most complete spec of xterm known to me is here:
  https://invisible-island.net/xterm/ctlseqs/ctlseqs.html



#####
#
# xterm colors
# 2012oct27
#
#####

# «xterm-colors»  (to ".xterm-colors")
# (find-es "console" "tput")
# (find-man "1 xterm" "boldColors")




#####
#
# making xterms interpret the M-<letter> keyseqs correctly
# 2000sep18
#
#####

# «xterm-mkey»  (to ".xterm-mkey")
# (to "Multi_key")
# (to "xf86src1")

# (code-c-d "xf1xc" "/usr/src/xfree86-1-3.3.6/build-tree/xc/")
# (code-c-d "xterm" (ee-xf1xcfile "programs/xterm/"))
# (code-c-d "xterm" "/usr/src/xfree86-1-3.3.6/build-tree/xc/programs/xterm/")
# (find-xf1xcfile "")
# (find-xtermfile "")
# (find-xtermfile "main.c" "XTerm*SimpleMenu*menuLabel.vertSpace: 100")
# (find-xtermfile "XTerm.ad" "unreadable")
# unreadable = nil2.
# tiny=5x7, micro não está na lista.

# (find-fline "/etc/X11/app-defaults/XTerm" "Unreadable" "nil2")
# (find-fline "/etc/X11/app-defaults/XTerm" "Tiny" "5x7")

cd /usr/src/xfree86-1-3.3.6/build-tree/xc/programs/xterm/
agrep -i meta $(find *)
agrep -i eightbit $(find *)

# (find-man "xterm" "eightBitInput")
# (find-man "xterm" "8-bit-control")
# (find-man "xterm" "^ACTIONS")
# (find-fline "/usr/doc/xterm/ctlseqs.ms.gz")
# (find-man "xrdb")
#
zcat /usr/doc/xterm/ctlseqs.ms.gz \
  | groff -Tascii -ms \
  |& l -S
#
# (find-fline "/usr/doc/xfree86-common/XFree86-FAQ.txt.gz")
# (find-man "1x xev")

# (find-fline "/etc/X11/Xresources/xterm")
# (find-man "X" "^RESOURCES")
# (find-man "X" "xrdb -merge")
# (find-man "X" "^EXAMPLES")
# (find-man "xrdb")

strace-to ~/s xterm -e echo
# (find-fline "~/s")

#
# (find-fline "~/.Xresources")
# (find-fline "~/.Xdefaults")
# XTerm*eightBitInput: true
xrdb -merge ~/.Xresources
#

# (find-fline "~/.fvwm/")
# (find-fline "~/.fvwm2/")

# (find-status "fvwm")
# (find-vldifile "fvwm.list")
# (find-fline "/usr/doc/fvwm/")

# (find-status "fvwm-common")
# (find-vldifile "fvwm-common.list")
# (find-fline "/usr/doc/fvwm-common/")

# (find-fline "~/EXPECT/seefonts")
#
expect -c '
  stty raw
  expect_user {
    q exit
    -re {(.)} {
      set c $expect_out(1,string)
      scan $c "%c" ord
      puts "[string length c] $ord"
      exp_continue
    }
  }
'
#




#####
#
# xvt
# 2000sep19
#
#####

# «xvt»  (to ".xvt")
# Among xvt, rxvt and xterm xvt is the only one that is interpreting
# the "Meta" key correctly... I'll try to understand how it does that
# to discover why the others are (?) buggy.

#
# (eev-bounded)

rm -Rv /usr/src/xvt-2.1/
pdsc $SDEBIAN/dists/potato/main/source/x11/xvt_2.1-11.dsc
cd     /usr/src/xvt-2.1/
# debian/rules binary	|& tee odrb
debian/rules binary DEBUG="-DDEBUG -g"	|& tee odrb
laf xvt
laf debian/tmp-xvt/usr/X11R6/bin/xvt

#
# (code-c-d "xvt" "/usr/src/xvt-2.1/")
# (find-xvtfile "odrb")
# (find-xvtfile "debian/rules")
# (find-xvtfile "debian/")
# (find-xvtfile "debian/" "dpatch")
# (find-xvtfile "debian/packages")
# (find-xvtfile "")
# (find-xvtfile "Makefile" "DEBUG=")

#
set args -7
# br main
# br init_display
# br extract_resources
# br create_window
br init_command
run

# (progn (eeg-bounded) (gdb "gdb /usr/src/xvt-2.1/xvt") (gdbk-mode))
#

# It is not that simple, it seems that xvt can't run zsh correctly
# under gdb's control. Too bad.

# (find-status "xvt")
# (find-vldifile "xvt.list")
# (find-fline "/usr/doc/xvt/")
# (find-man "xvt" "-8")

xvt -fn fixed -7

# Ok, "meta" works, but the compose key (activated by the "xmulti"
# alias or by .xinitrc) doesn't; and it still works on xterms...
# (find-angg ".zshrc" "X")
# (find-fline "~/.xinitrc")





#####
#
# rxvt
# 2000sep18
#
#####

apti xpm4g-dev

pdsc $SDEBIAN/dists/potato/main/source/x11/rxvt_2.6.2-2.dsc
cd /usr/src/rxvt-2.6.2/
debian/rules binary	|& tee odrb

# (code-c-d "rxvt" "/usr/src/rxvt-2.6.2/")
# (find-rxvtfile "")
# (find-rxvtfile "src/xdefaults.c" "meta8")
# (find-rxvtfile "src/xdefaults.c" "void\nextract_resources(")

# (find-man "rxvt" "^CHANGING FONTS")

rxvt --font1 nil2 --font2 micro --background orange
# --font3 5x7

# (find-fline "/usr/doc/rxvt/Changelog")

# (find-status "rxvt")
# (find-vldifile "rxvt.list")
# (find-fline "/usr/doc/rxvt/")
# (find-fline "/usr/doc/rxvt/FAQ.Debian.gz" "internal Xresources support")
# (find-fline "/usr/doc/rxvt/README.xvt.gz" "META")
# (find-fline "/usr/doc/rxvt/changes.txt.gz" "Removed 7bit mode.")
# (find-fline "/usr/doc/rxvt/changes.txt.gz" "dull Canadian look:")
# (find-fline "~/.Xresources")
# (find-fline "~/.Xdefaults")
xrdb -merge ~/.Xresources





#####
#
# doubling the size of a bdf font
# 2000nov01
#
#####

# «bdf_2x»  (to ".bdf_2x")
# «bdfresize»  (to ".bdfresize")
# (to "font2bdf_2x")
# (find-htetfile "mini/X-Big-Cursor.txt.gz" "bdfresize")
# (find-shttpw3 "xerxes.thphy.uni-duesseldorf.de/~kielhorn/xfaq/X-FAQ_37.html")

pdsc $SDEBIAN/dists/woody/main/source/x11/bdfresize_1.4-1.dsc
cd /usr/src/bdfresize-1.4/
debian/rules binary	|& tee odrb

dpkg -i /usr/src/bdfresize_1.4-1_i386.deb

# (code-c-d "bdfresize" "/usr/src/bdfresize-1.4/")
# (find-bdfresizefile "")

# (find-status "bdfresize")
# (find-vldifile "bdfresize.list")
# (find-fline "/usr/doc/bdfresize/")
# (find-man "bdfresize")

#
cd ~/MTA/
bdfresize -w 2 -h 2 < math1.8b.bdf |& tee /tmp/math1big.bdf | l -S
#

# (to "font2bdf")

# To do: try to install this font in another dir (/tmp), change X's
# fontpath to make it include /tmp and not ~/MTA, see if then X
# discards all informations about the old font and starts using the
# new one.




#####
#
# creep: a pretty sweet 4px wide pixel font
# 2021jul09
#
#####

# «creep-font»  (to ".creep-font")
# https://github.com/romeovs/creep
# (find-git-links "https://github.com/romeovs/creep" "creep")
# (code-c-d "creep" "~/usrc/creep/")
# (find-creepfile "")
# (find-creepfile "screens/")
# (find-creepfile "screens/haskell.png")
# (find-creepfile "README.md")
# (find-creepfile "convert.pe")
# (find-creepfile "convert.pe" "fontforge")





#####
#
# pwm
# 2000jan05
#
#####

# «pwm»
# (find-shttpw3 "www.students.tut.fi/~tuomov/pwm/")
#
rm -Rv /usr/src/pwm-1.0/
cd /usr/src/
tar -xvzf $S/http/www.students.tut.fi/~tuomov/dl/pwm-1.0.tar.gz
cd /usr/src/pwm-1.0/

patch system.mk <<'%%%'
10c10,11
< PREFIX=/usr/local
---
> #PREFIX=/usr/local
> PREFIX=/tmp/pwminst
%%%

make		|& tee om
make install	|& tee omi
#
# (find-fline "/tmp/pwminst/")
# (find-fline "/tmp/pwminst/etc/pwm/")


# (code-c-d "pwm" "/usr/src/pwm-1.0/")
# (find-pwmfile "")
# (find-pwmfile "README")
# (find-pwmfile "README" "~/.pwm/")
# (find-pwmfile "config.txt")
# (find-pwmfile "system.mk")
# (find-pwmfile "system.mk" "PREFIX=")
#PREFIX=/tmp/pwminst









xlsclients

# (find-fline "/etc/X11/fvwm/")
# (find-fline "/etc/X11/fvwm/system.fvwm2rc")
# (find-fline "/etc/X11/fvwm/system.fvwm2rc" "Exit Fvwm")



#####
#
# sawmill
# 2001jun16
#
#####

# «sawmill»  (to ".sawmill")
# (find-status "librep5")
# (find-status "rep")
# (find-status "rep-gtk")
# (find-vldifile "librep5.list")
# (find-vldifile "rep-gtk.list")
# (find-vldifile "rep.list")
# (find-fline "/usr/doc/librep5/")
# (find-fline "/usr/doc/rep-gtk/")
# (find-fline "/usr/doc/rep/")

# (find-status "sawmill")
# (find-vldifile "sawmill.list")
# (find-fline "/usr/doc/sawmill/")
# (find-fline "/usr/doc/sawmill/README" "To dump all Lisp documentation")

#
sawmill --batch --no-rc rep -f rep > /tmp/sawmill-apropos <<'---'
(apropos-function "" t)
(apropos-variable "")
---
laf /tmp/sawmill-apropos
#
# (find-fline "/tmp/sawmill-apropos")

# (code-c-d "sawmill" "/usr/share/sawmill/0.20.1/" "sawmill")
# (find-sawmillfile "")
# (find-sawmillnode "Top")
# (find-sawmillnode "Themes")





#####
#
# flwm
# 2001jun18
#
#####

# «flwm»  (to ".flwm")
# (find-status "flwm")
# (find-vldifile "flwm.list")
# (find-fline "/usr/share/doc/flwm/")

# (find-man "1 flwm")
# (find-fline "/usr/lib/menu/flwm")
# (find-fline "/etc/menu-methods/flwm")

# (find-fline "/usr/lib/menu/")
# (find-fline "/etc/menu-methods/")




#####
#
# sawfish
# 2002oct28
#
#####

# «sawfish»  (to ".sawfish")
# (find-fline "/usr/doc/sawfish/")
# (find-fline "/usr/doc/sawfish-lisp-source/")
# (find-status "sawfish")
# (find-status "sawfish-lisp-source")
# (find-vldifile "sawfish.list")
# (find-vldifile "sawfish-lisp-source.list")

# (find-fline "/usr/share/emacs/site-lisp/sawfish.el")

# Debian menu stuff:

# (find-fline "/usr/lib/menu/")
# (find-fline "/etc/menu-methods/")
# (find-fline "/usr/share/doc/fvwm/examples/post-hook.menu-form-exit")
# (find-fline "/usr/share/doc/fvwm/examples/sacha/main-menu-pre.hook")
# (find-fline "/usr/share/doc/fvwm/hooks/main-menu-pre.hook")
# (find-fline "/usr/share/doc/fvwm/hooks/main-menu.hook")
# (find-fline "/usr/bin/fvwm-update-menu")
# (find-man "1 fvwm-update-menu")

fvwm-update-menu




#####
#
# default background
# 2004apr18
#
#####

# «default_background»  (to ".default_background")
# «xsetroot»  (to ".xsetroot")
# (find-man "1 xsetroot")
# (find-man "1 xsetroot" "gray mesh")
# (find-angg "bin/myxsettings")
#
xsetroot -default
#
xsetroot -solid black
#
# (find-fline "/usr/share/wallpapers/")




#####
#
# xsetbg
# 2006sep09
#
#####

# «xsetbg»  (to ".xsetbg")
# (find-status   "xloadimage")
# (find-vldifile "xloadimage.list")
# (find-udfile   "xloadimage/")
# (find-man "1 xsetbg")
# Lady with an Ermine:
# http://www.bbc.co.uk/science/leonardo/images/gallery/ladyermine_1024.jpg
#
xsetbg \
  $S/http/www.bbc.co.uk/science/leonardo/images/gallery/ladyermine_1024.jpg
#

# (find-man "1 xsetbg" "-background color")
# (find-man "1 xsetbg" "-border color")
# (find-man "1 xsetbg" "-at X,Y")
# (find-man "1 xsetbg" "-center")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xsetbg \
  $S/http/www.bbc.co.uk/science/leonardo/images/gallery/ladyermine_1024.jpg
xsetbg \
  -at 0,0 \
  -border black \
  $S/http/www.newwavephotos.com/AriUp/20030627_034AriUp.jpg
xsetroot -solid black




#####
#
# Some programs to view images and set the root window
# 2004sep09
#
#####

# «chameleon»  (to ".chameleon")
# (find-status   "chameleon")
# (find-vldifile "chameleon.list")
# (find-udfile   "chameleon/")
# (find-udfile "chameleon/README")
# (find-man "1 chameleon")
#
chameleon    /usr/share/pixmaps/cham.xpm
#
chameleon -t /usr/share/pixmaps/cham.xpm
#
chameleon
#

# «xloadimage»  (to ".xloadimage")
# «xview»  (to ".xview")
# (find-status   "xloadimage")
# (find-vldifile "xloadimage.list")
# (find-udfile   "xloadimage/")
# (find-fline "/etc/X11/Xloadimage")
# (find-fline "/usr/lib/mime/packages/xloadimage")
# (find-udfile "xloadimage/README.gz")
# (find-udfile "xloadimage/changelog.Debian.gz")
# (find-udfile "xloadimage/copyright")
# (find-man "1x uufilter")
# (find-man "1x xloadimage")
# (find-man "1x xsetbg")
# (find-man "1x xview")
#
read; xsetbg /usr/share/wallpapers/sunday_brunch.jpg
read; xsetbg /usr/share/wallpapers/Hans-Ponders-5.JPG
read; xsetbg /usr/share/wallpapers/A-Little-Exercise-1.JPG
#
xview /usr/share/wallpapers/winter_theme_1.jpg
xview $S/http/www.bmezine.com/ritual/A40803/high/iam00049362.jpg
#



#####
#
# xtartan
# 2004sep09
#
#####

# «xtartan»  (to ".xtartan")
# (find-status   "xtartan")
# (find-vldifile "xtartan.list")
# (find-udfile   "xtartan/")
#
xtartan
#
xtartan -r -t Lindsay -s 3 -w 3 -fv 2
#


#####
#
# some programs that draw ugly things on the root window
# 2004sep09
#
#####

# (find-status   "xhangglider")
# (find-vldifile "xhangglider.list")
# (find-udfile   "xhangglider/")
# (find-fline "/usr/share/xhangglider/")
# (find-fline "/usr/share/xhangglider/glider.def")
# (find-udfile "xhangglider/README")
# (find-man "6 xhangglider")
#
xhangglider -vario
#

# (find-status   "xmountains")
# (find-vldifile "xmountains.list")
# (find-udfile   "xmountains/")
# (find-udfile "xmountains/README.gz")
# (find-udfile "xmountains/changelog.Debian.gz")
# (find-man "1 xmountains")
#
xmountains
#

# (find-status   "xphoon")
# (find-vldifile "xphoon.list")
# (find-udfile   "xphoon/")
#
xphoon
#




#####
#
# fvwm from the upstream source
# 2004jul11
#
#####

# «fvwm-2.5»  (to ".fvwm-2.5")
# Note: I moved most stuff about fvwm to: (find-es "fvwm")
# (find-fline "~/.fvwm/.fvwm2rc")

# http://www.igs.net/~tril/fvwm/
# http://www.plig.org/xwinman/fvwm.html
# http://www.zensites.net/fvwm/guide/

# ftp://ftp.fvwm.org/pub/fvwm/version-2/fvwm-2.5.10.tar.gz

# (code-c-d "fvwm" "~/usrc/fvwm-2.5.10/")
# (find-fvwmfile "")
# (find-fvwmfile "sample.fvwmrc/")
# (find-fvwmfile "modules/FvwmPager/")

#
rm -Rv ~/usrc/fvwm-2.5.10/
tar -C ~/usrc/ \
  -xvzf $S/ftp/ftp.fvwm.org/pub/fvwm/version-2/fvwm-2.5.10.tar.gz
cd ~/usrc/fvwm-2.5.10/
./configure --prefix=$HOME/ulocal	|& tee oc
make		|& tee om
make install	|& tee omi

#
~/ulocal/bin/fvwm -replace &

#
# (find-fvwmfile "sample.fvwmrc/")
# (find-fvwmfile "sample.fvwmrc/system.fvwm2rc-sample-95")
# (find-fvwmfile "sample.fvwmrc/system.fvwm2rc-sample-95" "Showing Settings")




#####
#
# xauth
# 2004sep09
#
#####

# «xauth»  (to ".xauth")
# (find-man "1 xauth")
# (find-man "1 xauth" "[n]extract")
# (find-man "1 xinit")
# (find-man "1 startx" ".Xauthority")
# (find-man "1 Xserver")
# (find-man "1 Xserver" "-auth authorization-file")
# (find-man "1 Xserver" "GRANTING ACCESS")
# (find-man "7x Xsecurity")
# (find-man "1 xauth")
# (find-sh "xauth info")
# (find-sh "xauth help")
# (find-sh "xauth '?'")
# (find-man "1 xhost")
# (find-man "1 xhost" "+" "Access is granted to everyone")
#
xauth -v nextract - :0.0
#
cd
laf .Xauthority
xauth -v generate :0.0 .
laf .Xauthority
#

# I think that the default if I start X with xinit is to generate a
# friendly/insecure X session that anyone can cannect to.

# (find-angg ".xinitrc.debian" "xauth")
xauth nextract /tmp/xauth_$DISPLAY $DISPLAY
chmod 666      /tmp/xauth_$DISPLAY
su -s /usr/X11R6/bin/xauth edrx nmerge /tmp/0.0




#####
#
# Xnest
# 2004sep09
#
#####

# «Xnest»  (to ".Xnest")
# (find-man "1 Xnest")
# (find-man "1 Xserver")
# (find-man "1 Xserver" "-br")
# (find-man "1 xinit")
#
Xnest -br :1 &
xterm -display :1 &

#
# (find-man "1 xinit" "xinit /usr/local/lib/site.xinitrc --")
# (find-sh "xlsfonts | grep -v ^- | sort")

xinit =(echo "exec xterm -fn 5x7 -display :1") -- /usr/bin/X11/Xnest -br :1

#
xinit =(echo "exec ~/EXPECT/player -geometry 800x600 -display :1 ") \
  -- /usr/bin/X11/Xnest -br :1
#
xinit =(echo "exec ~/EXPECT/player -geometry 800x600 -display :1 ") \
  -- /usr/bin/X11/X :1
#
xinit =(echo "exec ~/EXPECT/player -geometry 1024x768 -display :1 ") \
  -- /usr/bin/X11/X :1
#
startx =(echo "exec xterm -fn 5x7 -display :1") -- /usr/bin/X11/Xnest -br :1

#
Using authority file /home/aleph/.Xauthority
Writing authority file /home/aleph/.Xauthority
AUDIT: Mon Sep 27 23:36:01 2004: 2043 Xnest: client 1 rejected from local host
Xlib: connection to ":1.0" refused by server
Xlib: No protocol specified
xterm Xt error: Can't open display: :1



#####
#
# xephyr
# 2022aug30
#
#####

# «xephyr»  (to ".xephyr")
# https://wiki.archlinux.org/title/Xephyr
# https://en.wikipedia.org/wiki/Xephyr




#####
#
# How to switch a keyboard layout in X11
# 2018mai31
#
#####

# «keyboard-layout-2018» (to ".keyboard-layout-2018")
# (find-es "xfce" "gkbd-keyboard-display")
# https://wiki.debian.org/Keyboard
# https://askubuntu.com/questions/973257/how-to-get-keyboard-layout-language-in-terminal-console-command-line




#####
#
# switching between keyboard layouts
# 2004aug29
#
#####

# «keyboard-layouts»  (to ".keyboard-layouts")
# (find-man "setxkbmap")
# (find-man "setxkbmap" "setxkbmap -print us | xkbcomp - $DISPLAY")
# (find-man "xkbcomp")
# (find-fline "/usr/X11R6/lib/X11/xkb/")
# (find-fline "/etc/X11/")
# (find-fline "/etc/X11/XF86Config-4")
# (find-fline "/etc/X11/XF86Config-4" "Generic Keyboard")
#
cd /tmp/
setxkbmap us       -print
setxkbmap us/abnt2 -print
setxkbmap    abnt2 -print

#
cd /usr/X11R6/lib/X11/xkb/
find *

#
# (find-fline "/usr/share/X11/xkb/keycodes/")

# (find-fline "/usr/X11R6/lib/X11/xkb/")
# (find-fline "/usr/X11R6/lib/X11/xkb/symbols/pc104")
# (find-fline "/usr/X11R6/lib/X11/xkb/symbols/us")
# (find-fline "/usr/X11R6/lib/X11/xkb/geometry/pc" "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/geometry.dir" "pc(abnt2)")
# (find-fline "/usr/X11R6/lib/X11/xkb/keycodes/xfree86" "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/keycodes.dir" "xfree86(abnt2)")
# (find-fline "/usr/X11R6/lib/X11/xkb/keymap/xfree86"    "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/rules/xfree86"     "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/rules/xfree86.lst" "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/rules/xfree86.xml" "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/symbols/br"    "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/symbols/pc/br" "abnt2")
# (find-fline "/usr/X11R6/lib/X11/xkb/symbols.dir"   " br(abnt2)")
# (find-fline "/usr/X11R6/lib/X11/xkb/symbols.dir"   " pc/br(abnt2)")

# It seems that kde issues this to change the layout
# (kcontrol?)... Thanks to topeira from #debian-br for the hint.





#####
#
# setxkbmap-2023
# 2023dec12
#
#####

# «setxkbmap-2023»  (to ".setxkbmap-2023")
# https://askubuntu.com/questions/787772/how-to-show-keyboard-chart-of-a-specific-layout-variant-from-command-line
# https://unix.stackexchange.com/questions/468311/show-keyboard-layout-on-xfce
# https://askubuntu.com/questions/968673/how-to-gracefully-change-keyboard-layout-from-command-line-setxkbmap-breaks-all?rq=1

# (find-fline  "/var/log/Xorg.0.log")
# (find-fline  "/var/log/Xorg.0.log" "xkb_model")
# (find-fline  "/var/log/Xorg.0.log" "xkb_layout")
# (find-sh "cat /var/log/Xorg.0.log | grep xkb")
# (find-man "1 setxkbmap")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
setxkbmap -print
setxkbmap -query
setxkbmap -query | awk '$1=="model:"  {print $2}'
setxkbmap -query | awk '$1=="layout:" {print $2}'
setxkbmap -verbose 10
# (find-fline "/usr/share/X11/xkb/rules/evdev")

gkbd-keyboard-display --help
gkbd-keyboard-display --help-all
gkbd-keyboard-display
gkbd-keyboard-display --group=1
gkbd-keyboard-display --group=2
gkbd-keyboard-display --group=3
gkbd-keyboard-display --group=4
gkbd-keyboard-display --layout=br
gkbd-keyboard-display --layout=us
gkbd-keyboard-display --layout=us_intl
gkbd-keyboard-display -l $'us\tintl'
echo gkbd-keyboard-display -l $'us\tintl'
echo gkbd-keyboard-display -l  'us\tintl'

gkbd-keyboard-display --layout=abnt
gkbd-keyboard-display --layout=abnt2


setxkbmap -model thinkpad;    gkbd-keyboard-display --layout=us
setxkbmap -model thinkpad60;  gkbd-keyboard-display --layout=us
setxkbmap -model thinkpadz60; gkbd-keyboard-display --layout=us
setxkbmap -model thinkpad;    gkbd-keyboard-display --layout=br
setxkbmap -model thinkpad60;  gkbd-keyboard-display --layout=br
setxkbmap -model thinkpadz60; gkbd-keyboard-display --layout=br

setxkbmap -model pc105;       gkbd-keyboard-display --layout=us
setxkbmap -model pc105;       gkbd-keyboard-display --layout=br
setxkbmap -model abnt2;       gkbd-keyboard-display --layout=us
setxkbmap -model abnt2;       gkbd-keyboard-display --layout=br

setxkbmap -model foo -layout bar
setxkbmap -model pc105 -layout gb
setxkbmap -model pc105 -layout us
setxkbmap -model pc102 -layout us_intl
setxkbmap -model abnt2 -layout br -variant abnt2
setxkbmap -model abnt2 -layout br -variant abnt2; gkbd-keyboard-display --layout=br

setxkbmap -model pc105 -layout us; gkbd-keyboard-display --layout=us
setxkbmap -model pc105 -layout gb; gkbd-keyboard-display --layout=gb

setxkbmap -model thinkpadz60 -layout us; gkbd-keyboard-display --layout=us
setxkbmap -model pc105       -layout us; gkbd-keyboard-display --layout=us
setxkbmap -model thinkpadz60 -layout us; gkbd-keyboard-display --layout=us

gkbd-keyboard-display --help-all
gkbd-keyboard-display --help-all
setxkbmap -help




#####
#
# setxkbmap-show
# 2024may15
#
#####

# «setxkbmap-show»  (to ".setxkbmap-show")
# (find-angg ".emacs" "ee-setxkbmap-show")

 (ee-setkbmap-show "thinkpad60"  "us")
 (ee-setkbmap-show "thinkpadz60" "us")
 (ee-setkbmap-show "pc105" "us")




#####
#
# setxkbmap-thinkpad
# 2024may15
#
#####

# «setxkbmap-thinkpad»  (to ".setxkbmap-thinkpad")
# (find-es "hardware" "T400-keyboard")
# (code-c-d "xkb" "/usr/share/X11/xkb/")
# (find-xkbfile "")
# (find-xkbgrep "grep --color=auto -niRH --null -e thinkpad *")




#####
#
# setxkbmap
# 2021oct31
#
#####

# «setxkbmap»  (to ".setxkbmap")
# (to "xkbprint")
# (find-es "labinfo" "setxkbmap")
# (find-man "1 setxkbmap")
# (find-man "7 xkeyboard-config")
# (find-man "7 xkeyboard-config" "English (US)")
# (find-man "7 xkeyboard-config" "Portuguese (Brazil)")
# (find-man "7 xkeyboard-config" "Generic 105-key PC")
# (find-fline "/usr/share/X11/xkb")
# (code-c-d "xkb" "/usr/share/X11/xkb/")
# (find-xkbsh "find * | sort")
# (find-xkbfile "")
# (find-xkbgrep "grep --color=auto -niRH --null -e abnt *")
# (find-xkbgrep "grep --color=auto -niRH --null -e xkb_geometry *")
# (find-xkbgrep "grep --color=auto -niRH --null -e layout *")
# (find-xkbfile "rules/base")
# (find-xkbfile "rules/base" "$pcmodels = pc101 pc102 pc104 pc105")

setxkbmap -model abnt2 -layout br -variant abnt2
setxkbmap -model pc105 -layout us
setxkbmap -model pc102 -layout us_intl

# (find-sh0 "setxkbmap -model pc105 -layout us")
# (find-sh0 "setxkbmap -model pc105 -layout us_intl")
# (find-sh0 "cd /tmp/; xkbprint :0.0; gv -seascape -scale 4 server-0_0.ps")
# (find-sh0 "cd /tmp/; xkbprint :0.0; gv --orientation=seascape --scale=2 server-0_0.ps")
# (find-sh0 "cd /tmp/; xkbprint :0.0; grep Layout: server-0_0.ps")
# (find-fline "/tmp/server-0_0.ps" "Layout:")




#####
#
# Trying to switch between US and ABNT2 using setxkbmap
# 2006feb09
#
#####

# «setxkbmap-2»  (to ".setxkbmap-2")
;; Keymap captions:
;; My default:   "Group 1   Layout: pc/pc(pc104)+pc/us        Generic 104"
;; US w/d.k.s:   "Group 1   Layout: pc/pc(pc104)+pc/us_intl   Generic 104"
;; ABNT w/d.k.s: "Group 1   Layout: us(pc101)+br              Generic 101"

<llp> Section "InputDevice"
<llp>         Identifier      "Keyboard"
<llp>         Driver          "keyboard"
<llp>         Option          "CoreKeyboard"
<llp>         Option          "XkbRules"      "xorg"
<llp>         Option          "XkbModel"      "abnt2"
<llp>         Option          "XkbLayout"     "br"
<llp> EndSection
<llp> minha configuração é essa
<llp> e funciona
<llp> ---------------------
<llp> leonardo@DickVigarista:~$ setxkbmap -v 10
<llp> Setting verbose level to 10
<llp> locale is C
<llp> Applied rules from xorg:
<llp> model:      abnt2
<llp> layout:     br
<llp> Trying to build keymap using the following components:
<llp> keycodes:   xfree86(abnt2)+aliases(qwerty)
<llp> types:      complete
<llp> compat:     complete
<llp> symbols:    pc/pc(pc104)+pc/br
<llp> geometry:   pc(abnt2)
<llp> leonardo@DickVigarista:~$

<Kenjiro> $ setxkbmap -v 10
<Kenjiro> Setting verbose level to 10
<Kenjiro> locale is C
<Kenjiro> Applied rules from xorg:
<Kenjiro> model:      abnt2
<Kenjiro> layout:     br
<Kenjiro> Trying to build keymap using the following components:
<Kenjiro> keycodes:   xfree86(abnt2)+aliases(qwerty)
<Kenjiro> types:      complete
<Kenjiro> compat:     complete
<Kenjiro> symbols:    pc/pc(pc104)+pc/br
<Kenjiro> geometry:   pc(abnt2)

(find-fline "/etc/X11/XF86Config-4")
(find-fline "$ASROOT/etc/X11/XF86Config-4")

Note: ideally we should be able to start with a half-broken
configuration, find the right parameters using the command line (with
shell functions!), and only then fix the config files... the idea that
you need a kid who knows all the config options at your side by
installation time is sick, sick, sick.




#####
#
# Switching between US and ABNT2 with setxkbmap
# 2006feb09
#
#####

# «setxkbmap-switch»  (to ".setxkbmap-switch")
# (find-angg ".fvwm/nokeys.fvwm" "KeyboardMenu")
# (find-angg "bin/mysetxkb")
#
# (eechannel-xterm "A")
function foo       () { egrep '^[a-z]+:'; xkbfooter; echo }
function xkbfooter () {
  xkbprint $DISPLAY - | tail -n 20 | grep -w show \
  | cut -b12- | rev | cut -b17- | rev
}
setxkbmap -v 10 -model pc104 -layout us                | foo
setxkbmap -v 10 -model pc104 -layout us_intl           | foo
xkbprint $DISPLAY /tmp/us.ps
setxkbmap -v 10 -model pc104 -layout br                | foo
setxkbmap -v 10 -model pc104 -layout br -variant abnt2 | foo
setxkbmap -v 10 -geometry 'pc(abnt2)'                  | foo
setxkbmap -v 10 -geometry 'pc(abnt2)' -layout br       | foo
xkbprint $DISPLAY /tmp/br.ps
gv --orientation=seascape /tmp/us.ps &
gv --orientation=seascape /tmp/br.ps &

#
# (find-pspage "~/abnt2.ps" nil "--orientation=seascape")
# (find-pspage "/tmp/us.ps" nil "--orientation=seascape")
# (find-pspage "/tmp/br.ps" nil "--orientation=seascape")

"abnt2.ps" is a file that caio1982 from #debian-br (who uses Gnome and
a Sarge-based Brazilian Debian distro) sent to me; the mapping is
almost totally correct, the only error is that the "windows" keys are
missing. But it might be that the windows keys are there and are
active, they're just missing from the geometry description and so they
don't get drawn in the ".ps"...

The last one that I got (br.ps, "-geometry 'pc(abnt2)' -layout br")
gives a result that is almost the one in abnt2.ps; two keys are wrong,
though.

This is how my keyboard (hardware) looks (main part only):

+---+---+---+---+---+---+---+---+---+---+---+---+---+-------+
| '"| 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 0 | - | = |  bsp  |
+---++--++--++--++--++--++--++--++--++--++--++--++--+-------+
| tab| q | w | e | r | t | y | u | i | o | p | '`| [ |      |
+----++--++--++--++--++--++--++--++--++--++--++--++--++ ret |
| cps | a | s | d | f | g | h | j | k | l | ç | ~ | ] |     |
+----++--++--++--++--++--++--++--++--++--++--++--++--++-----+
|shft| \ | z | x | c | v | b | n | m | , | . | ; | / | shft |
+----++--++--++--+---+---+---+---+---+-+-+--++---+---++-----+
|ctrl |win|alt|         space          | alt| win|mnu | ctrl|
+-----+---+---+------------------------+----+----+----+-----+

This is how my keyboard is behaving:

+---+---+---+---+---+---+---+---+---+---+---+---+---+-------+
| '"| 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 0 | - | = |  bsp  |
+---++--++--++--++--++--++--++--++--++--++--++--++--+-------+
| tab| q | w | e | r | t | y | u | i | o | p | '`| [ |      |
+----++--++--++--++--++--++--++--++--++--++--++--++--++ ret |
| cps | a | s | d | f | g | h | j | k | l | ç | ~ | \ |     |
+----++--++--++--++--++--++--++--++--++--++--++--++--++-----+
|shft|   | z | x | c | v | b | n | m | , | . | ; | / | shft |
+----++--++--++--+---+---+---+---+---+-+-+--++---+---++-----+
|ctrl |win|alt|         space          | alt| win|mnu | ctrl|
+-----+---+---+------------------------+----+----+----+-----+

That is, the key at the right of the left shift, that should be a "\",
is dead, and the key below the "[" is behaving as it - i.e., as "\",
"|" instead of as "]", "}".

According to xev the dead key at the right of the left shift is
currently configured as this:
  keycode 94 (keysym 0x0, NoSymbol)
and the key below the "[" as this:
  keycode 51 (keysym 0x5c, backslash)

I think that it would be enough to configure them as this
  keycode 94 (keysym 0x5c, backslash)
and this
  keycode 51 (keysym 0x5d, bracketright)

Ok, this works:

setxkbmap -geometry 'pc(abnt2)' -layout br
# (find-man "xmodmap")
# (find-man "xmodmap" "keycode NUMBER = KEYSYMNAME")
xmodmap -e "keycode 94 = backslash bar"
xmodmap -e "keycode 51 = bracketright braceright"
# (find-xkbprint)

And I think that this should set the keyboard back to the the US
layout...

setxkbmap -model pc104 -layout us
setxkbmap -model pc104 -layout us_intl

Ok, works. I installed it in an fvwm menu:
(find-angg ".fvwm/nokeys.fvwm" "KeyboardMenu")
(find-angg "bin/mysetxkb")








#####
#
# Reading and writing keyboard layout specs
# 2006feb09
#
#####

# «keyboard-layouts-2»  (to ".keyboard-layouts-2")
(find-sh "setxkbmap -help")
(find-man "setxkbmap")
(find-man "setxkbmap" "-geometry name")
(find-man "setxkbmap" "-keymap name")
(find-man "setxkbmap" "-layout name")
(find-man "setxkbmap" "-model name")

(find-fline "/usr/X11R6/lib/X11/xkb/README")
(find-fline "/etc/X11/xkb/")
(find-fline "/etc/X11/xkb/README.enhancing")
(find-fline "/etc/X11/xkb/geometry.dir" "pc(abnt2)")
(find-fline "/etc/X11/xkb/keycodes.dir" "aliases(qwerty)")
(find-fline "/etc/X11/xkb/keymap.dir" "xfree86(us)")
(find-fline "/etc/X11/xkb/keymap.dir" "xfree86(us_intl)")
(find-fline "/etc/X11/xkb/keymap.dir" "xfree86(br)")
(find-fline "/etc/X11/xkb/symbols.dir" "br(abnt2)")
(find-fline "/etc/X11/xkb/symbols.dir" "pc/br(abnt2)")
(find-fline "/etc/X11/xkb/symbols.dir" "pc/br(nodeadkeys)")
(find-fline "/etc/X11/xkb/types.dir" "pc(default)")

(find-fline "/etc/X11/xkb/")
(find-fline "/etc/X11/xkb/geometry/pc")
(find-fline "/etc/X11/xkb/geometry/pc" "Generic 104")
(find-fline "/etc/X11/xkb/geometry/pc" "Brazilian ABNT2")
(find-fline "/etc/X11/xkb/geometry/pc" "xkb_geometry \"abnt2\"")
(find-fline "/etc/X11/xkb/keycodes/xfree86")
(find-fline "/etc/X11/xkb/keycodes/xfree86" "xkb_keycodes \"abnt2\"")
(find-fline "/etc/X11/xkb/rules/xfree86.lst")
(find-fline "/etc/X11/xkb/rules/xfree86.lst" "abnt2")
(find-fline "/etc/X11/xkb/rules/xfree86.lst" "! layout")
(find-fline "/etc/X11/xkb/rules/xfree86.xml")
(find-fline "/etc/X11/xkb/symbols/br")
(find-fline "/etc/X11/xkb/symbols/br" "xkb_symbols \"abnt2\"")
(find-fline "/etc/X11/xkb/symbols/pc/br")
(find-fline "/etc/X11/xkb/symbols/pc/br" "xkb_symbols \"abnt2\"")

# (find-fline "/etc/X11/xkb/README.enhancing")
# (find-fline "/etc/X11/xkb/README.enhancing" "'!'")
# (find-fline "/etc/X11/xkb/rules/xfree86.lst" "! layout")
# (find-fline "/etc/X11/xkb/rules/xfree86")
# So, which files does setxkbmap read?

 (eechannel-xterm "A")
strace-to ~/o setxkbmap -v 10 -geometry 'pc(abnt2)' -layout br
# (find-fline "~/o")
# (find-sh "grep -v ENOENT ~/o")




#####
#
# xkbprint (is broken on squeeze)
# 2010oct14
#
#####

# «xkbprint»  (to ".xkbprint")
# (find-angg "bin/mysetxkb")
# (find-sh "~/bin/mysetxkb xkbprint")
#   Fatal Error: Cannot load geometry for :1.0
# (to "xkbprint-hamm")
# (find-man "1 xkbprint")

# https://askubuntu.com/questions/380052/how-to-use-xkbprint
# https://unix.stackexchange.com/questions/348021/visualizing-layout-key-maps-in-xkb
# https://superuser.com/questions/1293956/show-keyboard-geometry-model-in-gnome





#####
#
# generating xpms
# 2004sep09
#
#####

# «xpm»  (to ".xpm")
# (find-fline "/usr/X11R6/include/X11/xpm.h" "image width")
# (find-angg "LUA/rectxpm.lua")
(let ((auto-image-file-mode nil))
  (find-fline "/usr/X11R6/include/X11/pixmaps/vim.xpm"))

#
# A simple one
cat > /tmp/1.xpm <<'%%%'
/* XPM */
static char * myfig3x2[] = {
"3 2 4 1",
"  c None",
"r c #ff0000",
"g c #00ff00",
"b c #0000ff",
"  r",
"ggb"};
%%%

# (find-man "1x cxpm")
cxpm /tmp/1.xpm
# (find-file "/tmp/1.xpm")
# (let ((auto-image-file-mode nil)) (find-file "/tmp/1.xpm"))
# (find-file "/tmp/2.xpm")
# (let ((auto-image-file-mode nil)) (find-file "/tmp/2.xpm"))

#
# A red dot
cat > /tmp/dot.xpm <<'%%%'
/* XPM */
static char * myfig3x2[] = {
"1 1 1 1",
". c #ff0000",
"."};
%%%

cxpm /tmp/1.xpm
# (find-file "/tmp/1.xpm")

#
function dotxpm () {
  echo '/* XPM */'
  echo 'static char * myfig1x1[] = {'
  echo '"1 1 1 1",'
  echo '". c '$1'",'
  echo '"."};'
}
dotxpm '#0000ff' > /tmp/dot.xpm
# (find-file "/tmp/dot.xpm")

#
lua50 ~/LUA/rectxpm.lua '#555500' 100 200 > /tmp/rect.xpm
# (find-fline "~/LUA/rectxpm.lua")
# (find-fline "/tmp/rect.xpm")

#
# (find-man "1 convert")
lua50 ~/LUA/rectxpm.lua aa5500 200 100 > /tmp/rect.xpm
convert -font helvetica\
        -fill red   -draw "text 10,0 Cockatoo" \
        -fill blue  -draw "text 10,10 Cockatoo" \
        -fill green -draw "text 10,20 Cockatoo" \
  /tmp/rect.xpm /tmp/rect2.png

# (find-fline  "/tmp/rect2.png")

#



#####
#
# ratpoison
# 2005jan03
#
#####

# «ratpoison»  (to ".ratpoison")
# (find-status   "ratpoison")
# (find-vldifile "ratpoison.list")
# (find-udfile   "ratpoison/")
# (find-udfile "ratpoison/examples/ratpoison.el.gz")
# (find-node "(ratpoison)Top")

# (find-status   "xbindkeys")
# (find-vldifile "xbindkeys.list")
# (find-udfile   "xbindkeys/")




#####
#
# keyboard repeat rate in X
# 2005jan15
#
#####

# «X-kbdrate»  (to ".X-kbdrate")
# (find-angg ".zshrc" "ax0")
# (find-angg ".zshrc" "ax0" "xset r rate")
# (find-angg ".emacs" "prep-X-kbdrate")
# (find-man "1 xset" "repeat rate")
# Default rate:         (find-sh0 "xset r rate")
# My preferred setting: (find-sh0 "xset r rate 250 30")
# Very fast:            (find-sh0 "xset r rate 250 75")




#####
#
# Mouse parameters
# 2010sep27
#
#####

# «mouse-parameters»  (to ".mouse-parameters")
# (find-angg ".fvwm/.fvwm2rc" "KeyboardMenu")
# (find-man "1 xset" "mouse default")
# (find-man "1 xset" "  mouse  ")
# Default rate:         (find-sh0 "xset mouse default")
# Current settings:     (find-sh "xset q")
# Current settings:    (find-sh0 "xset q | grep accel")
# Help:                 (find-sh "xset")
# No accel (for Gimp, etc): (find-sh0 "xset mouse 0")
# Accel:               (find-sh0 "xset mouse 1")
# Accel:               (find-sh0 "xset mouse 1.5")
# Accel:               (find-sh0 "xset mouse 2")
# Accel:               (find-sh0 "xset mouse 3/4")
# Accel:               (find-sh0 "xset mouse 1 0")
# Accel and threshold: (find-sh0 "xset mouse 0 0")
# Accel and threshold: (find-sh0 "xset mouse 1/8 1")
# Accel and threshold: (find-sh0 "xset mouse 1/8 1")
# Accel and threshold: (find-sh0 "xset mouse 1/8 1")
# Accel and threshold: (find-sh0 "xset mouse 1/2 0")





#####
#
# The debian package that supplies a(n installed) font
# 2005oct24
#
#####

# «deb-for-a-font»  (to ".deb-for-a-font")
# (find-angg ".zshrc" "Xfontslists")

function Xfontslists () {
  find /usr/X11R6/lib/X11/fonts/ -type f -name 'fonts.dir'
  find /etc/X11/fonts/           -type f -name '*.alias'
}
# (find-sh "xlsfonts")
# (find-zsh "grep -i Misc-Fixed-Medium-R-SemiCondensed--13-120-75-75-C-60-ISO10646-1 $(Xfontslists)")
# (find-zsh "dmissing usr/X11R6/lib/X11/fonts/misc/6x13.pcf.gz")

# (find-fline "/usr/X11R6/lib/X11/fonts/misc/")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.alias")
# (find-fline "/usr/X11R6/lib/X11/fonts/misc/fonts.dir")

# «fonts.alias»  (to ".fonts.alias")
# (find-sh "locate fonts.alias")
# (find-fline "/usr/share/fonts/X11/100dpi/fonts.alias")
# (find-fline "/usr/share/fonts/X11/75dpi/fonts.alias")
# (find-fline "/usr/share/fonts/X11/misc/fonts.alias")
# (find-fline "/usr/share/fonts/X11/misc/fonts.alias" "fixed")
# (find-sh "grep 13-120 /usr/share/fonts/X11/misc/fonts.alias")
# (find-sh "grep 13-120 /usr/share/fonts/X11/misc/fonts.alias | grep -v bold")

# (find-man "8 update-fonts-alias")
# (find-fline "/etc/X11/fonts/misc/xfonts-base.alias")
# (find-man "1 mkfontdir")
# (find-man "7 X")
# (find-man "7 X" "xlsfonts")
# (find-man "1 Xserver")
# (find-man "1 xfs")
# (find-man "1 xfd")
# (find-man "1 xset")

# (find-man "1 xlsfonts")
# (find-zsh "dmissing man7 | grep X")
# (find-zsh "dmissing fontconfig")



#####
#
# fontconfig
# 2013sep12
#
#####

# «fontconfig» (to ".fontconfig")
# (find-status   "fontconfig")
# (find-vldifile "fontconfig.list")
# (find-udfile   "fontconfig/")
# (find-status   "fontconfig-config")
# (find-vldifile "fontconfig-config.list")
# (find-udfile   "fontconfig-config/")
# (find-fline "/etc/fonts/conf.d/")
# (find-fline "/etc/fonts/conf.d/README")
# (find-fline "/etc/fonts/conf.avail/")
# (find-fline "/etc/fonts/conf.avail/50-user.conf")
# (find-fline "/etc/fonts/")
# (find-fline "/etc/fonts/fonts.dtd")



#####
#
# xorg-docs
# 2012mar16
#
#####

# «xorg-docs»  (to ".xorg-docs")
# (find-status   "xorg-docs")
# (find-vldifile "xorg-docs.list")
# (find-udfile   "xorg-docs/")

# (find-status   "xorg-docs-core")
# (find-vldifile "xorg-docs-core.list")
# (find-udfile   "xorg-docs-core/")
# (find-status   "xorg-docs")
# (find-vldifile "xorg-docs.list")
# (find-udfile   "xorg-docs/")
# (code-c-d "xorgdocs" "/usr/share/X11/doc/")
# (find-xorgdocsfile "")
# (find-xorgdocsfile "core/Xserver-spec.txt" "Resource classes")





#####
#
# feh
# 2006nov26
#
#####

# (find-status   "feh")
# (find-vldifile "feh.list")
# (find-udfile   "feh/")




#####
#
# tinywm
# 2007jul30
#
#####

# «tinywm»  (to ".tinywm")
# http://incise.org/index.cgi/TinyWM
# http://ftp.debian.org/debian/pool/main/t/tinywm/tinywm_1.3-4.dsc
# http://ftp.debian.org/debian/pool/main/t/tinywm/tinywm_1.3-4.diff.gz
# http://ftp.debian.org/debian/pool/main/t/tinywm/tinywm_1.3.orig.tar.gz
#
rm -Rv ~/usrc/tinywm/
mkdir  ~/usrc/tinywm/
cd $S/http/ftp.debian.org/debian/pool/main/t/tinywm/
cp -v tinywm_1.3* ~/usrc/tinywm/
cd     ~/usrc/tinywm/
dpkg-source -sn -x tinywm_1.3-4.dsc
cd     ~/usrc/tinywm/tinywm-1.3/
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (code-c-d "tinywm" "~/usrc/tinywm/tinywm-1.3/")
# (find-tinywmfile "")
# (find-tinywmfile "tinywm.py")
# (find-tinywmfile "tinywm.c")
# (find-tinywmfile "annotated.c")




#####
#
# xnee
# 2007nov11
#
#####

# «xnee»  (to ".xnee")
# http://www.gnu.org/software/xnee/
# http://www.sandklef.com/xnee/
# http://lists.gnu.org/archive/html/bug-xnee/
# http://lists.gnu.org/archive/html/info-xnee/
# http://lists.gnu.org/archive/html/xnee-devel/
# http://ftp.gnu.org/gnu/xnee/xnee-3.02.tar.gz
# (find-THfile "index.blogme" "Related projects:")
#
rm -Rv ~/usrc/xnee-3.02/
tar -C ~/usrc/ -xvzf \
  $S/http/ftp.gnu.org/gnu/xnee/xnee-3.02.tar.gz
cd     ~/usrc/xnee-3.02/

#
# (code-c-d "xnee" "~/usrc/xnee-3.02/")
# (code-c-d-new "xnee" "~/usrc/xnee-3.02/" :linfo "doc/xnee")
# (find-xneefile "")
# (find-xneefile "FAQ" "Load  \"record\"")
# (find-fline "/etc/X11/xorg.conf")
# (find-xneenode "")
# (find-xneenode "Examples" "Record a gnumeric session")




#####
#
# trying to make CapsLock act as Mod4 for fvwm and emacs
# 2007dec27
#
#####

# «capslock-as-mod4»  (to ".capslock-as-mod4")
# Note: this does not work...

keycode 66

# (find-esfile "x.e" "keycode 94 =")
# (find-sh0 "xmodmap -e 'keycode 66 = Super_L'")
# (find-sh0 "xmodmap -e 'keycode 66 = Super_L'")
# (find-man "1 xmodmap")
# (find-man "1 xmodmap" "keysym KEYSYMNAME = KEYSYMNAME")
# (find-man "1 xmodmap" "keycode NUMBER = KEYSYMNAME")

xmodmap -e "keysym Alt_L = Meta_L Alt_L"

KeyboardMenu
# (find-angg ".fvwm/nokeys.fvwm" "KeyboardMenu")

locate X11/keysymdef.h
# (find-fline "/usr/X11R6/lib/X11/XKeysymDB")
# (find-fline "/usr/X11R6/include/X11/keysymdef.h")
# (find-fline "/usr/X11R6/include/X11/keysymdef.h" "XK_Super_L")

KeyPress event, serial 32, synthetic NO, window 0xc00001,
    root 0x40, subw 0xc00002, time 255125020, (34,28), root:(722,306),
    state 0x0, keycode 66 (keysym 0xffe5, Caps_Lock), same_screen YES,
    XLookupString gives 0 bytes: 
    XmbLookupString gives 0 bytes: 
    XFilterEvent returns: False

KeyRelease event, serial 32, synthetic NO, window 0xc00001,
    root 0x40, subw 0xc00002, time 255125128, (34,28), root:(722,306),
    state 0x2, keycode 66 (keysym 0xffe5, Caps_Lock), same_screen YES,
    XLookupString gives 0 bytes: 

KeyPress event, serial 32, synthetic NO, window 0xc00001,
    root 0x40, subw 0xc00002, time 255129645, (34,28), root:(722,306),
    state 0x2, keycode 109 (keysym 0xffe4, Control_R), same_screen YES,
    XLookupString gives 0 bytes: 
    XmbLookupString gives 0 bytes: 
    XFilterEvent returns: False

KeyRelease event, serial 32, synthetic NO, window 0xc00001,
    root 0x40, subw 0xc00002, time 255129759, (34,28), root:(722,306),
    state 0x6, keycode 109 (keysym 0xffe4, Control_R), same_screen YES,
    XLookupString gives 0 bytes: 




#####
#
# Ignoring CapsLock
# 2009nov23
#
#####

# «no-capslock»  (to ".no-capslock")
# (find-es "fvwm" "numlock")
# (find-udfile "fvwm/docs/FAQ.gz" "xmodmap -e \"clear Lock\"")





#####
#
# The "-dpi" option for the Xserver
# 2008jan04
#
#####

# «dpi»  (to ".dpi")
<aloph1> 13:16 < aloph1> 13:16'p0:andre@/disk/linux/etc/X11':)% cat
         xinit/xserverrc
<aloph1> 13:16 < aloph1> #!/bin/sh
<aloph1> 13:16 < aloph1> exec /usr/bin/X11/X -dpi 96




#####
#
# geometry
# 2008feb07
#
#####

# «geometry»  (to ".geometry")
# (find-zsh "dmissing /man | grep -e '/X\\.'")
# (find-status   "xorg-docs")
# (find-vldifile "xorg-docs.list")
# (find-udfile   "xorg-docs/")
# (find-man "7 X")
# (find-man "7 X" "GEOMETRY SPECIFICATIONS")
# (find-man "7 X" "GEOMETRY SPECIFICATIONS" "-0+0")
# (find-angg ".fvwm/.fvwm2rc" "northeast")




#####
#
# xzgv
# 2012nov30
#
#####

# «xzgv» (to ".xzgv")
# http://en.wikipedia.org/wiki/Xzgv
# http://en.wikipedia.org/wiki/Comparison_of_image_viewers
# (find-status   "xzgv")
# (find-vldifile "xzgv.list")
# (find-udfile   "xzgv/")
# (find-node "(xzgv)Top")
# (find-man "1 xzgv")
# (find-man "1 xzgv" "`-f'" "`--fullscreen'")
# (find-man "1 xzgv" "SELECTOR LAYOUT AND RESIZING")
# (find-man "1 xzgv" "BRIGHTNESS AND CONTRAST")
# (find-xzgv "/sda6/nikon/tattoo/_DSC0372_r4.JPG")

# (find-angg ".xzgvrc")
# (find-node "(xzgv)Config Files")




#####
#
# xzgv (from the debian sources)
# 2008mar14
#
#####

# «xzgv-deb-src»  (to ".xzgv-deb-src")
# (find-status   "xzgv")
# (find-vldifile "xzgv.list")
# (find-udfile   "xzgv/")
# (find-node "(xzgv)Top")
# (find-node "(xzgv)Keyboard Commands Index")
# (find-node "(xzgv)Closing a File")
# (find-node "(xzgv)Why Yet Another Viewer?" "xli")
# http://packages.qa.debian.org/x/xzgv.html
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=379869
# http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=214112
# http://ekaia.org/blog/2009/01/01/new-years-proposal-look-at-your-reported-bugs/
# (find-fline "~/tmp/xzgv-thumbnail-bug.png")

# http://ftp.debian.org/debian/pool/main/x/xzgv/
# http://ftp.debian.org/debian/pool/main/x/xzgv/xzgv_0.9+svn40-1.dsc
# http://ftp.debian.org/debian/pool/main/x/xzgv/xzgv_0.9+svn40-1.diff.gz
# http://ftp.debian.org/debian/pool/main/x/xzgv/xzgv_0.9+svn40.orig.tar.gz
#
rm -Rv ~/usrc/xzgv/
mkdir  ~/usrc/xzgv/
cd $S/http/ftp.debian.org/debian/pool/main/x/xzgv/
cp -v xzgv_0.9+svn40* ~/usrc/xzgv/
cd     ~/usrc/xzgv/
dpkg-source -sn -x xzgv_0.9+svn40-1.dsc
cd     ~/usrc/xzgv/xzgv-0.9+svn40/
# dpkg-buildpackage -d -us -uc -b -rfakeroot     |& tee odb
dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/usrc/xzgv/")
 (eepitch-shell)
cd ~/usrc/xzgv/
sudo dpkg -i *.deb

#
# (code-c-d "xzgv" "~/usrc/xzgv/xzgv-0.9+svn40/")
# (find-xzgvfile "")
# (find-xzgvfile "README" "rus@")

# (find-fline "/tmp/screenshots/xzgv-thumbnail-bug.png")


# (find-status   "xzgv")
# (find-vldifile "xzgv.list")
# (find-udfile   "xzgv/")



#####
#
# display-manager
#
#####

# «display-manager» (to ".display-manager")
# (find-man "8 apt-cache")
# (find-sh "apt-cache showpkg x-display-manager")
# (find-sh "apt-cache showpkg libxdmcp6")
# (find-fline "/etc/X11/default-display-manager")

# (find-status   "libxdmcp6")
# (find-vldifile "libxdmcp6:i386.list")
# (find-udfile   "libxdmcp6/")

# (find-available "gdm")
# (find-available "xdm")

# (find-available "gdm3")
# (find-available "kdm")
# (find-available "lightdm")
# (find-available "slim")
# (find-available "wdm")
# (find-available "xdm")


libxdmcp6






#####
#
# gdm
# 2010apr18
#
#####

# «gdm»  (to ".gdm")
# (find-fline "/etc/X11/default-display-manager")
# (find-es "gnome" "pstree")
# (find-esgrep "grep -nH -e xdm *.e")
# (find-esgrep "grep -nH -e gdm *.e")
# (find-status   "gdm")
# (find-vldifile "gdm.list")
# (find-udfile   "gdm/")
# (find-fline "/usr/share/gdm/defaults.conf")
# (find-fline "/etc/gdm/")
# (find-fline "/etc/gdm/PreSession/Default" "# Set background color")
# (find-fline "/etc/gdm/Xsession")
# (find-fline "/etc/gdm/Xsession" "OPTIONFILE=/etc/X11/Xsession.options")
# (find-fline "/etc/X11/Xsession.options")
# (find-fline "/etc/X11/")
# (find-fline "/etc/X11/Xsession.d/")
# (find-fline "/etc/X11/Xsession.d/50x11-common_determine-startup" "/usr/bin/x-window-manager")
# (find-fline "/usr/share/xsessions/")
# (find-fline "/usr/share/xsessions/Fvwm.desktop" "Exec=fvwm")
# (find-fline "/usr/share/xsessions/gnome.desktop" "Exec=/usr/bin/gnome-session")
# (find-zsh "dmissing xsessions")
# (find-fline "/usr/bin/" "x-window-manager")
# (find-fline "/etc/alternatives/" "x-window-manager")
# (find-fline "/etc/init.d/gdm")
# (find-man "1 gdm")
# (find-man "1 gdmflexiserver")
# (find-man "8 gdm")
# (find-man "8 gdmchooser")
# (find-man "8 gdmlogin")



#####
#
# ldm
# 2013aug27
#
#####

# «ldm» (to ".ldm")
# (find-available "ldm")




#####
#
# touchfreeze
# 2010sep04
#
#####

# «touchfreeze»  (to ".touchfreeze")
# (find-status   "touchfreeze")
# (find-vldifile "touchfreeze.list")
# (find-udfile   "touchfreeze/")

# (find-fline "/usr/bin/touchfreeze")
# (find-fline "/usr/share/applications/touchfreeze.desktop")
# (find-fline "/usr/share/icons/hicolor/scalable/apps/touchpad.svg")
# (find-udfile "touchfreeze/copyright")
# (find-udfile "touchfreeze/changelog.Debian.gz")
# (find-man "1 touchfreeze")



#####
#
# xdpyinfo
# 2010oct14
#
#####

# «xdpyinfo»  (to ".xdpyinfo")
# (find-man "1 xdpyinfo")
# (find-sh "xdpyinfo" "dimensions:" "resolution:")

# (find-man "7 X")
# (find-man "1 xprop")
# (find-man "1 xrdb")
# (find-man "1 xwininfo")
# (find-man "1 xdriinfo")
# (find-man "1 xvinfo")
# (find-man "1 glxinfo")

# «screen-size»  (to ".screen-size")
# «screen-dimensions» (to ".screen-dimensions")
# A.k.a. screen resolution
# (find-sh "xdpyinfo")
# (find-sh "xdpyinfo | grep 'dimensions:'")
# (find-sh "xdpyinfo | grep 'dimensions:' | awk '{print $2}'")





#####
#
# xwininfo
# 2010oct07
#
#####

# «xwininfo»  (to ".xwininfo")
# (find-es "emacs" "frame-geometry")
# (find-status   "x11-utils")
# (find-vldifile "x11-utils.list")
# (find-udfile   "x11-utils/")
# (find-man "1 xwininfo")
# (find-man "1 xlsclients")
# (find-sh "xwininfo -help")
# (find-sh "xwininfo -all")
# (find-sh "xwininfo -root")
# (find-sh "xwininfo -root -children")
# (find-sh "xwininfo -root -children | sort")
# (find-sh "xlsclients")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xwininfo
xwininfo -help
xlsclients

 (eepitch-gs)
 (eepitch-kill)
 (eepitch-gs)
% quit

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xwininfo -help
# xwininfo -id
xwininfo -name ghostscript
xwininfo -root
xwininfo -root -children
xwininfo -root -tree
xwininfo -name ghostscript -stats
xwininfo -name ghostscript -bits
xwininfo -name ghostscript -events
xwininfo -name ghostscript -size
xwininfo -name ghostscript -wm
xwininfo -name ghostscript -shape
# xwininfo -frame
xwininfo -name ghostscript -all
xwininfo -name emacs -all

# (find-sh "xwininfo -name emacs -all")



#####
#
# xlsclients
# 2019apr20
#
#####

# «xlsclients» (to ".xlsclients")
# (find-status   "x11-utils")
# (find-vldifile "x11-utils.list")
# (find-udfile   "x11-utils/")
# (find-man "1 xlsclients")
# (find-sh "xlsclients")




#####
#
# Inconsolata
# 2010dec17
#
#####

# «inconsolata»  (to ".inconsolata")
# (find-status   "ttf-inconsolata")
# (find-vldifile "ttf-inconsolata.list")
# (find-udfile   "ttf-inconsolata/")
# (find-udfile "ttf-inconsolata/README.Debian")
# (find-status   "x-ttcidfont-conf")
# (find-vldifile "x-ttcidfont-conf.list")
# (find-udfile   "x-ttcidfont-conf/")
# (find-udfile "x-ttcidfont-conf/README.Debian")
# (find-man "5 xorg.conf")
# (find-fline "/var/lib/defoma/x-ttcidfont-conf.d/dirs/")

# (find-sh0 "zcat /usr/share/doc/ttf-inconsolata/textest.pdf.gz > /tmp/textest.pdf")
# (find-xpdfpage "/tmp/textest.pdf")

# (find-sh "xlsfonts")

# (find-status   "ttf-dejavu-core")
# (find-vldifile "ttf-dejavu-core.list")
# (find-udfile   "ttf-dejavu-core/")
# (find-status   "ttf-dejavu-extra")
# (find-vldifile "ttf-dejavu-extra.list")
# (find-udfile   "ttf-dejavu-extra/")
# (find-status   "ttf-dejavu")
# (find-vldifile "ttf-dejavu.list")
# (find-udfile   "ttf-dejavu/")
# (find-status   "ttf-freefont")
# (find-vldifile "ttf-freefont.list")
# (find-udfile   "ttf-freefont/")
# (find-udfile   "ttf-freefont/README.Debian")
# (find-status   "ttf-inconsolata")
# (find-vldifile "ttf-inconsolata.list")
# (find-udfile   "ttf-inconsolata/")
# (find-status   "ttf-liberation")
# (find-vldifile "ttf-liberation.list")
# (find-udfile   "ttf-liberation/")
# (find-status   "ttf-lyx")
# (find-vldifile "ttf-lyx.list")
# (find-udfile   "ttf-lyx/")
# (find-status   "ttf-opensymbol")
# (find-vldifile "ttf-opensymbol.list")
# (find-udfile   "ttf-opensymbol/")
# (find-status   "ttf-sil-gentium-basic")
# (find-vldifile "ttf-sil-gentium-basic.list")
# (find-udfile   "ttf-sil-gentium-basic/")
# (find-status   "ttf-sil-gentium")
# (find-vldifile "ttf-sil-gentium.list")
# (find-udfile   "ttf-sil-gentium/")




#####
#
# Clipboard
# 2011nov23
#
#####

# «clipboard»  (to ".clipboard")
# (find-enode "Clipboard")
# (find-enode "Variable Index" "* x-select-enable-clipboard:")
# (find-elnode "Index"         "* x-select-enable-clipboard:")
# (find-elnode "Window System Selections" "x-select-enable-clipboard")




#####
#
# xsel
# 2012may03
#
#####

# «xsel»  (to ".xsel")
# (find-status   "xsel")
# (find-vldifile "xsel.list")
# (find-udfile   "xsel/")




#####
#
# xpad
# 2012feb11
#
#####

# «xpad»  (to ".xpad")
# (find-status   "xpad")
# (find-vldifile "xpad.list")
# (find-udfile   "xpad/")
# (find-man "1 xpad")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xpad -n

# Color: ffee99




#####
#
# Emacs on pure X (standalone-ish)
# 2012feb12
#
#####

# «emacs-on-pure-X»  (to ".emacs-on-pure-X")
# (find-man "1 xinit" " XINITRC")
# (find-anggfile "bin/emacs-default")
# (find-anggfile "bin/emacs-default-x")
# (find-angg ".zshrc" "ae")
# (find-sh "xwininfo" "-geometry" "167x46+0+0")
# (find-angg "eev-puro/.emacs" nil "(eq arg 11)")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cat > /tmp/em.sh <<'%%%'
#!/bin/sh
/usr/bin/emacs
%%%
chmod 755 /tmp/em.sh
XINITRC=/tmp/em.sh xinit -- :2.0 &

# ^ Why I can't run xinit from an xterm?

# Test this with eev (needs (scroll-bar-mode -1), no menu bar, no toolbar)
# Oops, "-class bare" does not work...
# (find-es "fvwm" "style:bare")
emacs -fn 6x13 -fg bisque -bg black -geometry 167x46+0+0




#####
#
# xrdb and Class
# 2012mar10
#
#####

# «xrdb»  (to ".xrdb")
# «class»  (to ".class")
# (find-angg ".Xdefaults")
# (find-man "1 xterm" "-class string")
# (find-man "7 X")
# (find-man "7 X" "-xrm resourcestring")
# (find-angg ".emacs" "ee-popup")
# (find-angg ".emacs" "ee-popup" "-class Bare")

# (find-fline "/etc/X11/app-defaults/")
# (find-fline "/etc/X11/app-defaults/XTerm" "Unreadable" "nil2")
# (find-fline "/etc/X11/app-defaults/XTerm" "Tiny" "5x7")


# (find-angg ".Xdefaults")
# (find-man "1 xrdb")
# (find-man "1 xrdb" "  -query")
# (find-enode "Table of Resources" "font")
# (find-enode "Table of Resources" "geometry")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xrdb -query
xrdb -query xdvi.highlight

 Not working:
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cat > /tmp/.Xdefaults <<'%%%'
Emacs.Font: fixed
Emacs.Geometry: 167x59+0+0
%%%
xrdb -load     ~/.Xdefaults
xrdb -merge /tmp/.Xdefaults
xrdb -query
emacs -Q




#####
#
# xdotool
# 2012nov16
#
#####

# «xdotool» (to ".xdotool")
# (find-status   "xdotool")
# (find-vldifile "xdotool.list")
# (find-udfile   "xdotool/")
# http://www.semicomplete.com/projects/xdotool/
# http://forums.opensuse.org/english/get-technical-help-here/applications/453953-window-placement-resizing-command-line.html

# (find-udfile "xdotool/README")
# (find-udfile "xdotool/changelog.gz")
# (find-udfile "xdotool/examples/ffsp.sh")
# (find-man "1 xdotool")
# (find-man "1 xdotool" "windowsize [options] windowid width height")




#####
#
# vtwm
# 2012nov18
#
#####

# «vtwm» (to ".vtwm")
# http://www.vtwm.org/
# (find-status   "vtwm")
# (find-vldifile "vtwm.list")
# (find-udfile   "vtwm/")




#####
#
# xmodmap
# 2013feb09
#
#####

# «xmodmap» (to ".xmodmap")

From lua-l, 2013feb09:

On any Xwindows-based system, one can write

$ xmodmap -e "keycode  28 = t T t T asciitilde"

select the "Third Level" key from a menu if you have
no AltGr, I chose left Alt. Then AltGr-t gives a tilde in
Xwindows based programs (which in effect means all.)

I can also with the click of a mouse choose this tweaked
keyboard or the standard response for which it was
designed.



#####
#
# Scrot (for screenshots)
# 2013may18
#
#####

# «scrot» (to ".scrot")
# (find-status   "scrot")
# (find-vldifile "scrot.list")
# (find-udfile   "scrot/")
# (find-man "1 scrot")
# http://comments.gmane.org/gmane.emacs.orgmode/72263
# http://thread.gmane.org/gmane.emacs.orgmode/72263/focus=72469




#####
#
# xfce
# 2013jun05
#
#####

# «xfce» (to ".xfce")
# (find-es "xfce")
# (find-zsh "installeddebs | sort | grep xfce")
# (find-zsh "availabledebs | sort | grep xfce")
# (find-status   "xfce4")
# (find-vldifile "xfce4.list")
# (find-udfile   "xfce4/")
# (find-status   "xfce4-battery-plugin")
# (find-vldifile "xfce4-battery-plugin.list")
# (find-udfile   "xfce4-battery-plugin/")
# http://docs.xfce.org/
# http://docs.xfce.org/xfce/getting-started
# http://docs.xfce.org/xfce/xfce4-panel/start

Applications menu -> Settings -> Screensaver
Applications menu -> Settings -> Panel

# (find-status   "libxfce4ui-1-0")
# (find-vldifile "libxfce4ui-1-0.list")
# (find-udfile   "libxfce4ui-1-0/")
# (find-status   "libxfce4util-bin")
# (find-vldifile "libxfce4util-bin.list")
# (find-udfile   "libxfce4util-bin/")
# (find-status   "xfce-keyboard-shortcuts")
# (find-vldifile "xfce-keyboard-shortcuts.list")
# (find-udfile   "xfce-keyboard-shortcuts/")
# (find-fline "/etc/xdg/xfce4/xfconf/xfce-perchannel-xml/xfce4-keyboard-shortcuts.xml")
http://docs.xfce.org/faq
http://docs.xfce.org/xfce/xfconf/start

# (find-man "8 xfce4-kiosk-query")

xfce4-dbg
xfce4-dev-tools
xfce4-dict


# «xfce4-keyboard-shortcuts» (to ".xfce4-keyboard-shortcuts")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
fname = "/etc/xdg/xfce4/xfconf/xfce-perchannel-xml/xfce4-keyboard-shortcuts.xml"
lines = readfile(fname)
for _,li in ipairs(splitlines(lines)) do
  -- print(li)
  n, v = li:match('name="(.-)".-value="(.-)"')
  if n then
    n = n:gsub("&lt;", "<")
    n = n:gsub("&gt;", ">")
    -- print(n, v)
    printf("%-30s%s\n",n, v)
  end
end

# http://linuxlibrary.org/xfce-4-keyboard-shortcuts/





#####
#
# Calibration
# 2013jun05
#
#####

# «calibration» (to ".calibration")
# (find-status   "xcalib")
# (find-vldifile "xcalib.list")
# (find-udfile   "xcalib/")
# (find-udfile "xcalib/")
# (find-man  "1 xcalib")

# (find-status   "icc-profiles")
# (find-vldifile "icc-profiles.list")
# (find-udfile   "icc-profiles/")
# (find-fline "/usr/share/color/icc/")

# http://stereopsis.com/flux/
# http://jonls.dk/redshift/

# (find-status   "redshift")
# (find-vldifile "redshift.list")
# (find-udfile   "redshift/")



#####
#
# Matchbox
# 2013jul04
#
######

# «matchbox» (to ".matchbox")
# (find-available "matchbox-common")
# (find-zsh "availabledebs | sort | grep matchbox")
# (find-available "libmatchbox-dev")
# (find-available "libmatchbox-doc")
# (find-available "libmatchbox1")
# (find-available "matchbox-common")
# (find-available "matchbox-desktop")
# (find-available "matchbox-keyboard-im")
# (find-available "matchbox-keyboard")
# (find-available "matchbox-panel-manager")
# (find-available "matchbox-panel")
# (find-available "matchbox-themes-extra")
# (find-available "matchbox-window-manager")
# (find-available "matchbox")



#####
#
# xclip
# 2013jul20
#
#####

# «xclip» (to ".xclip")
# (find-es "ssh" "ssh-keygen")
# (find-angg ".emacs" "eekill")
# (find-status   "xclip")
# (find-vldifile "xclip.list")
# (find-udfile   "xclip/")

# (find-fline "/usr/bin/xclip-cutfile")
# (find-fline "/usr/bin/xclip-copyfile")
# (find-fline "/usr/bin/xclip-pastefile")
# (find-udfile "xclip/README")
# (find-man "1 xclip")
# (find-man "1 xclip-copyfile")

<artefact> $(xclip -o) ?



#####
#
# logs
# 2013aug12
#
#####

# «logs» (to ".logs")
# (find-fline "/var/log/Xorg.0.log")
# (find-fline "/var/log/Xorg.1.0.log")
# (find-fline "/var/log/Xorg.1.0.log" "vesa")
# (find-sh "grep -e '(--)' < /var/log/Xorg.1.0.log")

# (find-sh "dmesg")



#####
#
# bell / beep volume
# 2013aug23
#
#####

# «bell-volume» (to ".bell-volume")
# (find-man "xset" " b " "bell volume")

 (eexterm "A")

echo -e '\a'
echo -e '\a\b'
xset b 90 440




#####
#
# conky
# 2013dec31
#
#####

# «conky» (to ".conky")
# (find-angg ".conkyrc")

# (find-status   "conky")
# (find-vldifile "conky.list")
# (find-udfile   "conky/")

# (find-status   "conky-std")
# (find-vldifile "conky-std.list")
# (find-udfile   "conky-std/")

# (find-man "1 conky")

# (find-fline "/etc/conky/conky_no_x11.conf")
# (find-fline "/etc/conky/conky.conf")
# (find-fline "/usr/lib/conky/libimlib2.so.0.0.0")
# (find-fline "/usr/lib/conky/libcairo.so.0.0.0")
# (find-fline "/usr/bin/conky")
# (find-udfile "conky-std/changelog.gz")
# (find-udfile "conky-std/README.gz")
# (find-udfile "conky-std/README.gz" "/etc/conky/conky.conf")
# (find-udfile "conky-std/lua.html")
# (find-udfile "conky-std/docs.html")
# (find-udfile "conky-std/config_settings.html")
# (find-udfile "conky-std/variables.html")
# (find-udfile "conky-std/TODO")
# (find-udfile "conky-std/changelog.Debian.gz")
# (find-udfile "conky-std/copyright")
# (find-udfile "conky-std/AUTHORS.gz")
# (find-udfile "conky-std/NEWS.Debian.gz")
# (find-fline "/usr/share/menu/conky-std")
# (find-fline "/usr/share/apport/package-hooks/conky.py")
# (find-fline "/usr/share/doc-base/conky-manual")





#####
#
# i3wm - improved tiling wm
# 2014oct22
#
#####

# «i3wm» (to ".i3wm")
# http://i3wm.org/docs/userguide.html#presentations
# (find-status   "i3")
# (find-vldifile "i3.list")
# (find-udfile   "i3/")
# (find-status   "i3-wm")
# (find-vldifile "i3-wm.list")
# (find-udfile   "i3-wm/")




#####
#
# xlsfonts
# 2015aug10
#
#####

# «xlsfonts» (to ".xlsfonts")
# (find-angg ".emacs" "find-font-links")
# (find-esgrep "grep --color -nH -e xlsfonts *.e")
# (find-sh "xlsfonts | sort | uniq")
# (find-sh "xlsfonts | grep -v ^- | sort | uniq")
# (find-sh "xlsfonts | grep -v ^- | sort | uniq | gsub.lua .+ '(set-frame-font \"%1\")'")

# (find-zsh "installeddebs | sort | grep fonts")
# (find-zsh "availabledebs | sort | grep fonts")
# (find-zsh "installeddebs | sort | grep xfonts")
# (find-zsh "availabledebs | sort | grep xfonts")



#####
#
# fc-list
# 2021dec30
#
#####

# «fc-list»  (to ".fc-list")
# (find-man "1 fc-list")
# (find-sh "fc-list | sort")
# (find-sh "fc-list | awk -F : '{print $2}' | sort | uniq")
# (find-sh "fc-list | awk -F : '{print $2}' | cut -b2- | sort | uniq")
# https://tex.stackexchange.com/questions/2798/adobe-garamond-pro-not-working-with-xelatex?rq=1

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
fc-list
fc-list | sort
fc-list 'Nimbus Sans L' | sort
fc-list 'Nimbus Sans L' -f '%{weight} %{style}\n' | sort -g



#####
#
# xfonts
# 2024jun01
#
#####

# «xfonts»  (to ".xfonts")
# (find-zsh "installeddebs | sort | grep xfonts")
# (find-zsh "availabledebs | sort | grep xfonts")
# (find-status   "xfonts-100dpi")
# (find-vldifile "xfonts-100dpi.list")
# (find-udfile   "xfonts-100dpi/")
# (find-status   "xfonts-75dpi")
# (find-vldifile "xfonts-75dpi.list")
# (find-udfile   "xfonts-75dpi/")
# (find-status   "xfonts-base")
# (find-vldifile "xfonts-base.list")
# (find-udfile   "xfonts-base/")
# (find-status   "xfonts-encodings")
# (find-vldifile "xfonts-encodings.list")
# (find-udfile   "xfonts-encodings/")
# (find-status   "xfonts-scalable")
# (find-vldifile "xfonts-scalable.list")
# (find-udfile   "xfonts-scalable/")
# (find-status   "xfonts-utils")
# (find-vldifile "xfonts-utils.list")
# (find-udfile   "xfonts-utils/")

# (find-fline "/usr/bin/mkfontdir")
# (find-fline "/usr/sbin/update-fonts-alias")
# (find-fline "/usr/sbin/update-fonts-dir")
# (find-fline "/usr/sbin/update-fonts-scale")
# (find-fline "/usr/share/aclocal/fontutil.m4")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-1")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-10")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-11")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-13")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-14")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-15")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-16")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-2")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-3")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-4")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-5")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-6")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-7")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-8")
# (find-fline "/usr/share/fonts/X11/util/map-ISO8859-9")
# (find-fline "/usr/share/fonts/X11/util/map-JISX0201.1976-0")
# (find-fline "/usr/share/fonts/X11/util/map-KOI8-R")
# (find-man "1 bdftopcf")
# (find-man "1 bdftruncate")
# (find-man "1 fonttosfnt")
# (find-man "1 mkfontdir")
# (find-man "1 mkfontscale")
# (find-man "1 ucs2any")
# (find-man "8 update-fonts-alias")
# (find-man "8 update-fonts-dir")
# (find-man "8 update-fonts-scale")
# (find-fline "/usr/share/pkgconfig/fontutil.pc")






#####
#
# xserver-log
# 2017ago09 / 2018may30
#
#####

# «xserver-log» (to ".xserver-log")
# (find-fline "/var/log/" "Xorg.0.log")
# (find-fline "/var/log/" "Xorg.1.0.log")
#
# On Debian Stretch:
# (find-fline "~/.local/share/xorg/Xorg.1.0.log")
# (find-fline "~/.local/share/xorg/Xorg.2.0.log")




#####
#
# xinit-as-user-2021
# 2021nov01
#
#####

# «xinit-as-user-2021»  (to ".xinit-as-user-2021")
# (find-angg ".zshrc" "a")
# (find-man "1 xinit")
# https://unix.stackexchange.com/questions/554592/how-to-manually-run-init-start-a-xorg-server-on-a-different-vt-tty
# https://wiki.archlinux.org/title/Xinit

# (find-fline      "/etc/X11/Xwrapper.config")
# (find-asrootfile "/etc/X11/Xwrapper.config")
# (find-man "5 Xwrapper.config")
# (find-man "1 Xorg.wrap")
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=856351

# (find-asrootfile "/etc/X11/Xwrapper.config")

# Edrx:
# (find-es "x" "xinit-as-user-2021")
needs_root_rights=yes
allowed_users=anybody




#####
#
# Running xinit as a common user in Debian Stretch
# 2018may30
#
#####

# «xinit-as-user» (to ".xinit-as-user")
# (find-fline "~/.local/share/xorg/")
# (find-fline "~/.local/share/xorg/Xorg.1.0.log")
# (find-fline "~/.local/share/xorg/Xorg.3.0.log")

# Fatal server error:
# (EE) parse_vt_settings: Cannot open /dev/tty0: Permission denied
#
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=856351
# https://forum.snapcraft.io/t/startx-as-a-regular-user/460/3

# Fatal server error:
# (EE) xf86OpenConsole: Cannot open virtual console 2: Permission denied
#
# https://bbs.archlinux.org/viewtopic.php?id=192329
# https://bbs.archlinux.org/viewtopic.php?id=221075
# https://bugs.launchpad.net/ubuntu/+source/xinit/+bug/1562219
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=873262

# (find-status   "acl")
# (find-vldifile "acl.list")
# (find-udfile   "acl/")
# (find-man "1 chacl")
# (find-man "1 getfacl")
# (find-man "1 setfacl")
# (find-man "5 acl")

getfacl --help
getfacl /dev/tty0
groups
# (find-man "groups")
# (find-man "4 groups")
# (find-asrootfile "/etc/group" "tty:")

# https://bugs.launchpad.net/ubuntu/+source/xinit/+bug/1562219
#   "sudo chmod 0660 /dev/tty*" worked for me until reboot. Changing
#   permission in udev rules for tty to 0660 from 0620 could be a
#   temporary fix.

laf /dev/tty*
sudo chmod 0660 /dev/tty
sudo chmod 0660 /dev/tty*

Addscreen/screeninit failed for driver 0

https://www.linuxquestions.org/questions/linux-desktop-74/cannot-start-xserver-addscreen-screeninit-failed-for-driver-0-a-692238/




#####
#
# moosotc-snippets (from malc_ @ #emacs)
# 2020dec28
#
#####

# «moosotc-snippets»  (to ".moosotc-snippets")
# https://github.com/moosotc
# https://github.com/moosotc/snippets
# (find-git-links "https://github.com/moosotc/snippets" "moosnippets")

# (code-c-d "moosnippets" "~/usrc/snippets/")
# (find-moosnippetsfile "")
# (find-moosnippetsfile ".xinitrc")
# (find-moosnippetsfile ".zprofile")
# (find-moosnippetsfile ".zprofile" "exec xinit")




#####
#
# C-M-backspace
# 2019sep20
#
#####

# «C-M-backspace» (to ".C-M-backspace")
# https://askubuntu.com/questions/698677/how-to-kill-x-server-using-a-key-combination/698692
# https://askubuntu.com/questions/10622/how-can-i-enable-ctrlaltbackspace?lq=1
# https://askubuntu.com/questions/367983/how-do-i-enable-ctrl-alt-backspace-to-kill-the-x-server

sudo dpkg-reconfigure keyboard-configuration

setxkbmap -option terminate:ctrl_alt_bksp





#####
#
# xdg-utils
# 2019sep28
#
#####

# «xdg-utils» (to ".xdg-utils")
# (find-status   "xdg-utils")
# (find-vldifile "xdg-utils.list")
# (find-udfile   "xdg-utils/")
# (find-man "1 xdg-open")
# http://www.freedesktop.org/wiki/Software/xdg-utils/



#####
#
# unclutter - hides the mouse cursor in X after a period of inactivity
# 2019oct23
#
#####

# «unclutter» (to ".unclutter")
# https://stackoverflow.com/questions/660613/how-do-you-hide-the-mouse-pointer-under-linux-x11
# https://askubuntu.com/questions/157134/how-to-hide-the-mouse-cursor
# https://github.com/Airblader/unclutter-xfixes
# (find-status   "unclutter")
# (find-vldifile "unclutter.list")
# (find-udfile   "unclutter/")
# (find-fline "/etc/X11/Xsession.d/90unclutter")
# (find-fline "/etc/default/unclutter")
# (find-udfile "unclutter/README")
# (find-man "1 unclutter")
# (find-man "1 unclutter" " -idle ")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
unclutter -idle 1 &
killall unclutter
ps ax | grep unclutter






#####
#
# How Xorg is called in Debian Buster
# 2020jan01
#
#####

# «xorg-in-buster» (to ".xorg-in-buster")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

# (find-man "ps")
ps --cols 200 ax | cat

 1262 ?        Ssl    0:00 /usr/sbin/lightdm
 1267 tty7     Ssl+   0:00 /usr/lib/xorg/Xorg :0 -seat seat0 -auth /var/run/lightdm/root/:0 -nolisten t 1276 ?        Sl     0:00 lightdm --session-child 16 19
 1279 ?        Ssl    0:00 /usr/sbin/lightdm-gtk-greeter

# (find-man "1 Xorg")
# (find-man "1 Xorg" "-seat")
# (find-man "1 Xorg" "-auth")
# (find-man "1 Xorg" "command line options")
# (find-man "1 Xserver")
# (find-man "1 Xserver" "-auth authorization-file")
# (find-man "1 Xserver" "-seat seat")




#####
#
# sway (Wayland)
# 2021nov01
#
#####

# «sway»  (to ".sway")
# (find-status   "sway")
# (find-vldifile "sway.list")
# (find-udfile   "sway/")
https://packages.debian.org/sid/sway
https://packages.debian.org/sid/kwin

apti kwin-wayland

https://codeberg.org/blau_araujo/xbrightness



#####
#
# The Hack font
# 2022mar23
#
#####

# «hack-font»  (to ".hack-font")
# https://sourcefoundry.org/hack/
# https://source-foundry.github.io/Hack/font-specimen.html




#####
#
# xeyes
# 2022jun20
#
#####

# «xeyes»  (to ".xeyes")
# (find-status   "x11-apps")
# (find-vldifile "x11-apps.list")
# (find-udfile   "x11-apps/")
# (find-man "1 xeyes")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xeyes






# (find-zsh "installeddebs | sort | grep xserver")
# (find-zsh "availabledebs | sort | grep xserver")

x11-xserver-utils_7.7~3.deb
xserver-xorg-video-i128_1.3.5-1+b1.deb
xserver-xorg-video-i740_1.3.2-4+b3.deb
xserver-xorg-video-intel-dbg_2.19.0-6.deb
xserver-xorg-video-intel_2.19.0-6.deb




# (find-man "gdmXnest")
# (find-fline "/usr/bin/gdmXnest")





# (find-man "X")
# (find-man "X" "\nGEOMETRY SPECIFICATIONS\n")
# (find-man "X" "\nRESOURCES\n")

# (find-available "blast")
# (find-available "blast" "holes")

# (find-man "1x blast")
# (find-udfile "blast/README")



# (find-fline "/etc/X11/xkb/symbols/")

# (find-status   "xpad")
# (find-vldifile "xpad.list")
# (find-udfile   "xpad/")

# https://unix.stackexchange.com/questions/568634/how-does-a-linux-gui-work-at-the-lowest-level
# https://blogs.igalia.com/itoral/2014/07/29/a-brief-introduction-to-the-linux-graphics-stack/

https://news.ycombinator.com/item?id=29681507 Cool, but Obscure X11 Tools (dabamos.de)

<twb> Holy shit did they *handwrite* a BDF
<toniz4> twb: probably used gbdfed
<twb> Nope
<twb> +COMMENT "Generated by fontforge,
      http://fontforge.sourceforge.net"
<twb> ^ they're using fontforge


https://lists.gnu.org/archive/html/emacs-devel/2022-08/msg01002.html Po Lu on X vs Wayland
https://magcius.github.io/xplain/article/x-basics.html 
https://magcius.github.io/xplain/article/
https://kevroletin.github.io/terminal/2021/12/11/how-terminal-works-in.html
https://news.ycombinator.com/item?id=40419325 How terminal works. Part 1: Xterm, user input (2021) (kevroletin.github.io)





#  Local Variables:
#  coding:               utf-8-unix
#  End:
