#######
#
# E-scripts on xfce.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/xfce.e>
#           or at <http://angg.twu.net/e/xfce.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.keyboard-layout»		(to "keyboard-layout")
# «.keyboard-layout-gkbd»	(to "keyboard-layout-gkbd")
# «.gkbd-keyboard-display»	(to "gkbd-keyboard-display")
# «.setxkbmap»			(to "setxkbmap")
# «.panel»			(to "panel")
# «.lxdm»			(to "lxdm")
# «.keyboard-shortcuts»		(to "keyboard-shortcuts")
# «.screenshot»			(to "screenshot")
# «.xfc4e-session»		(to "xfc4e-session")
# «.zoom-mode»			(to "zoom-mode")




# (find-es "x" "xfce")

https://en.wikipedia.org/wiki/Xfce
https://www.slant.co/topics/9328/~linux-distributions-for-xfce
https://thishosting.rocks/best-lightweight-linux-distros/
https://wiki.archlinux.org/index.php/xfce
https://wiki.xfce.org/faq

https://ubuntuforums.org/showthread.php?t=282897 Thread: Gnome=gdm, Kde=kdm, Xfce= ? (Solved)

# (find-man "startxfce4")





#####
#
# keyboard-layout
# 2021aug16
#
#####

# «keyboard-layout»  (to ".keyboard-layout")
£ https://docs.xfce.org/faq?s[]=keyboard&s[]=layout
# https://docs.xfce.org/4.16/faq#what_should_i_do_to_change_keyboard_layout
# https://docs.xfce.org/panel-plugins/xfce4-xkb-plugin/start

Setting Keyboard Layout
Open Xfce 4 Settings Manager Menu => Settings => Settings Manager.
Click on the Keyboard icon.
Switch to the Layout tab.
Untick Use system defaults.
Click the Add button and choose the appropriate keymap from the list.
Select the active layout.

Applications -> Settings -> Keyboard
Applications -> Settings -> Keyboard -> Layout -> Change Layout Option




#####
#
# Displaying keyboard layouts with gkbd
# 2021aug16
#
#####

# «keyboard-layout-gkbd»   (to ".keyboard-layout-gkbd")
# «gkbd-keyboard-display»  (to ".gkbd-keyboard-display")
# https://unix.stackexchange.com/questions/111624/how-to-display-the-current-keyboard-layout
# https://stackoverflow.com/questions/30177379/keyboard-layout-map-generation
# https://askubuntu.com/questions/787772/how-to-show-keyboard-chart-of-a-specific-layout-variant-from-command-line
# (find-status   "gkbd-capplet")
# (find-vldifile "gkbd-capplet.list")
# (find-vldifile "gkbd-capplet.list" "gkbd-keyboard-display")
# (find-udfile   "gkbd-capplet/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
          setxkbmap -query
          setxkbmap -query | awk '$1=="model:"  {print $2}'
          setxkbmap -query | awk '$1=="layout:" {print $2}'
          setxkbmap -query | grep layout
          setxkbmap -query | grep layout  | tr -s ' '
          setxkbmap -query | grep layout  | tr -s ' ' | cut -d ' ' -f2
LAYOUT=$( setxkbmap -query | grep layout  | tr -s ' ' | cut -d ' ' -f2)
          setxkbmap -query | grep variant | tr -s ' ' | cut -d ' ' -f2
VARIANT=$(setxkbmap -query | grep variant | tr -s ' ' | cut -d ' ' -f2)
echo ${LAYOUT}\t${VARIANT}
echo "${LAYOUT}\t${VARIANT}"

gkbd-keyboard-display --help
gkbd-keyboard-display --help-all

gkbd-keyboard-display -l ${LAYOUT}\t${VARIANT}
gkbd-keyboard-display -l gb
gkbd-keyboard-display -l us
gkbd-keyboard-display -l "us(intl)"

use tab

gkbd-keyboard-display --help
gkbd-keyboard-display --help-all
gkbd-keyboard-display -g 1

cd /tmp/
xkbprint -color "${DISPLAY}" - |\
    ps2pdf - > current_keyboard_layout.pdf



#####
#
# setxkbmap
# 2021aug16
#
#####

# «setxkbmap»  (to ".setxkbmap")
# (find-esgrep "grep --color -nH --null -e setxkb *.e")
# (find-es "x" "keyboard-layouts")
# (find-man "1 setxkbmap")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
setxkbmap -v 10




#####
#
# panel
# 2022jan08
#
#####

# «panel»  (to ".panel")
# (find-sh "pstree")
# (find-sh "pstree" "xfce4-panel")
# (find-status   "xfce4-panel")
# (find-vldifile "xfce4-panel.list")
# (find-udfile   "xfce4-panel/")




#####
#
# lxdm
# 2018mai21
#
#####

# «lxdm» (to ".lxdm")
# https://wiki.xfce.org/faq
# https://wiki.xfce.org/faq#starting_xfce





#####
#
# keyboard-shortcuts
# 2019may03
#
#####

# «keyboard-shortcuts» (to ".keyboard-shortcuts")
# https://unix.stackexchange.com/questions/44643/change-global-keyboard-shortcuts
# (find-sh "locate -i xfce4")
# (find-sh "locate -i xfce4 | grep -i shortcuts")
# (find-fline "/etc/xdg/xfce4/xfconf/xfce-perchannel-xml/")
# (code-c-d "xfconfxml" "/etc/xdg/xfce4/xfconf/xfce-perchannel-xml/")
# (find-xfconfxmlfile "")
# (find-xfconfxmlfile "xfce4-keyboard-shortcuts.xml" "Alt" "F1" "xfce4-popup-applicationsmenu")
# (find-xfconfxmlfile "xfce4-keyboard-shortcuts.xml" "Alt" "F9" "hide_window_key")
# (find-xfconfxmlfile "xfce4-keyboard-shortcuts.xml" "Alt" "F11" "fullscreen_key")

Alt-F1 -> Accessories -> Screenshot
Alt-F1 -> Multimedia -> SimpleScreenRecorder

Alt-F9 = hide_window_key

# O xfce do Ayrton esta' pegando as teclas M-1, M-2, M-3, M-4

# (find-es "xml" "libxml")



#####
#
# screenshot
# 2022jan06
#
#####

# «screenshot»  (to ".screenshot")
# https://docs.xfce.org/apps/xfce4-screenshooter/usage
# https://makandracards.com/makandra/12531-xfce-take-a-screenshot-with-the-print-key

Alguem pode me dar dicas de como o modo "padrao" de tirar screenshots
no Debian funciona? Eu acho que ele nao ta' configurado aqui, e eu
acabei fazendo uma funcaozinha no Emacs pra tirar screenshots...

E' o window manager que captura uma tecla? Ou e' algo no systemd? Ou
as duas coisas? Obs: eu uso Debian 11 e XFCE4...

Mauro Siqueira
Tecla print screen

O que ela faz?

No teclado

Nao, que programa interpreta ela? Onde isso esta' configurado?
Aaaaaah
Acho que achei

Pressione ela, abra uma aplicação para receber a imagem e ctrl V

Acho que a partir das informacoes daqui eu consigo descobrir o que eu
preciso: https://docs.xfce.org/apps/xfce4-screenshooter/usage
Desculpem o ruido! =)

Pressione ela, abra uma aplicação para receber a imagem e ctrl V

Isso e' a "visao do usuario" de como o printscreen funciona, eu queria a "visao do sistema" =)

no meu Debian, uso LXQT a aplicação acionada por pintScreen é "lximage-qt --screenshot"
O proprio visualizador padrao de imagens do lxqt é o responsável pelo print screen
lximage no caso
xfce tambem vai ter uma aplicação ligada na tecla de função printScreen
xfce4-screenshooter no caso

Obrigado!!! Guardei tudo aqui, vou mexer nisso mais tarde!





#####
#
# xfc4e-session
# 2020sep20
#
#####

# «xfc4e-session»  (to ".xfc4e-session")
# (find-es "fvwm" "fvwm-xfce4")
# (find-man "xfce4-session")
# (find-fline "~/.cache/sessions/")


# (find-sh "sleep 3; pstree")

        |-xfce4-panel-+-panel-16-batter---2*[{panel-16-batter}]
        |             |-panel-17-pulsea---2*[{panel-17-pulsea}]
        |             |-panel-2-actions
        |             |-panel-6-systray
        |             |-xterm---zsh---zsh---emacs-+-pstree
        |             |                           `-3*[{emacs}]
        |             `-2*[{xfce4-panel}]
        |-xfce4-power-man---2*[{xfce4-power-man}]
        |-xfdesktop---2*[{xfdesktop}]
        |-xfsettingsd---2*[{xfsettingsd}]
        `-xfwm4




#####
#
# zoom-mode
# 2021may18
#
#####

# «zoom-mode»  (to ".zoom-mode")
# https://www.facebook.com/eduardo.ochs/posts/10225927907013988
# https://dfourtheye.blogspot.com/2013/04/ubuntu-screen-custom-resolution.html
# https://unix.stackexchange.com/questions/190289/xfce-entered-zoom-mode-how-do-i-exit

alt-scrollwheel

https://fossforce.com/2023/02/kde-plasma-full-featured-desktop-thats-surprisingly-easy-on-resources/



#  Local Variables:
#  coding:               utf-8-unix
#  End:
