#######
#
# E-scripts on xournal and xournalpp.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/xournal.e>
#           or at <http://angg.twu.net/e/xournal.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######




# «.xournalpp»			(to "xournalpp")
# «.xournalpp-keybindings»	(to "xournalpp-keybindings")
# «.xournalpp-help»		(to "xournalpp-help")
# «.cursor»			(to "cursor")
# «.xournal»			(to "xournal")
# «.xournalpp-debian-10»	(to "xournalpp-debian-10")
# «.latex»			(to "latex")




# Old location: (find-fline "~/.xournalpp/")
# New location: (find-fline "~/.config/xournalpp/")
# (find-man "1 xournalpp")



#####
#
# xournalpp
# 2021aug20
#
#####

# «xournalpp»  (to ".xournalpp")
# https://snapcraft.io/xournalpp
# https://xournalpp.github.io/
# https://github.com/xournalpp/xournalpp
# https://github.com/xournalpp/xournalpp/releases/download/1.1.0/xournalpp-1.1.0-Debian-buster-x86_64.deb

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
sudo dpkg -i xournalpp*.deb
apti -f -y

# (find-status   "xournalpp")
# (find-vldifile "xournalpp.list")
# (find-udfile   "xournalpp/")

# (find-git-links "https://github.com/xournalpp/xournalpp" "xournalpp")
# (find-gitk  "~/usrc/xournalpp/")
# (code-c-d "xournalpp" "~/usrc/xournalpp/")
# (find-xournalppfile "")
# (find-xournalppfile "README.md")

# (find-xournalppgrep "grep --color=auto -nRH --null -e 'Due to a recent update' *")
# (find-xournalppgrep "grep --color=auto -nRiH --null -e pressure *")
# (find-xournalppgrep "grep --color=auto -nRiH --null -e f11 *")

# (find-xournalppfile "README.md" "Doxygen")
cd      ~/usrc/xournalpp/
sudo apt-get install -y doxygen
sudo apt-get install -y graphviz
doxygen

# (find-xournalppfile "plugins/")
# (find-xournalppfile "plugins/QuickScreenshot/main.lua")

# «xournalpp-keybindings»  (to ".xournalpp-keybindings")
# (find-xournalppfile "ui/main.glade")
# (find-xournalppfile "ui/main.glade" "menuViewToolbarsVisible" "F9")
# (find-xournalppfile "ui/main.glade" "menuHideMenu"            "F10")
# (find-xournalppfile "ui/main.glade" "menuViewFullScreen"      "F11")
# (find-xournalppfile "ui/main.glade" "menuViewSidebarVisible"  "F12")





#####
#
# xournalpp-help
# 2021aug20
#
#####

# «xournalpp-help»  (to ".xournalpp-help")
# https://xournalpp.github.io/community/help/
# https://github.com/xournalpp/xournalpp/wiki/User-Manual
# https://github.com/xournalpp/xournalpp/discussions
# https://github.com/xournalpp/xournalpp/discussions/3309



#####
#
# cursor
# 2021aug20
#
#####

# «cursor»  (to ".cursor")
# https://github.com/xournalpp/xournalpp/wiki/User-Manual#cursor-configuration
# Edit -> preferences -> view -> cursor




#####
#
# xournal
# 2021aug20
#
#####

# «xournal»  (to ".xournal")
# (find-status   "xournal")
# (find-vldifile "xournal.list")
# (find-udfile   "xournal/")
# http://xournal.sourceforge.net/
# https://packages.debian.org/buster/xournal
# https://packages.debian.org/bullseye/xournal




#####
#
# xournalpp on Debian 10 (Buster)
# 2021aug20
#
#####

# «xournalpp-debian-10»  (to ".xournalpp-debian-10")
# (find-es "ead" "xournalpp")
# https://github.com/xournalpp/xournalpp
# https://github.com/xournalpp/xournalpp/releases
# https://github.com/xournalpp/xournalpp/releases/download/1.0.18/xournalpp-1.0.18-Debian-buster-x86_64.deb
# http://xournal.sourceforge.net/manual.html
#  -> Paper settings (in the [paper] section): -> plain, lined, ruled, or graph
# Journal -> paper background -> graph

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
wget https://github.com/xournalpp/xournalpp/releases/download/1.0.18/xournalpp-1.0.18-Debian-buster-x86_64.deb
sudo dpkg -i xournalpp*.deb
apti -f

# (find-status   "xournalpp")
# (find-vldifile "xournalpp.list")
# (find-udfile   "xournalpp/")
(find-sh-at-dir "/etc/" "find * | grep xournal")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
xournalpp




#####
#
# latex
# 2021aug20
#
#####

# «latex»  (to ".latex")
# (find-es "tex" "standalone")
# https://github.com/xournalpp/xournalpp/wiki/User-Manual#latex


https://news.ycombinator.com/item?id=31557140 Xournalpp++ – closs-platform, open source note taking software (xournalpp.github.io)





#  Local Variables:
#  coding:               utf-8-unix
#  End:
