#!/bin/sh
# URLs for this file:
#   http://angg.twu.net/eev/changer.sh
#   http://angg.twu.net/eev/changer.sh.html
# Version: 2002may11; copyleft Edrx. License: GPL.
# Please help me with the headers! :)
#
# changer.sh: a crude wrapper around `changer.awk'.
# This script is invoked by:           (find-eev "Makefile" "dotfiles")
# and the bulk of its work is done by: (find-eev "changer.awk")
#
# (find-node "(bash)Simple Command Expansion" "variable assignments affect")
# (find-node "(bash)Shell Parameter Expansion" "${PARAMETER}")
# (find-node "(bash)Shell Parameters")
# (find-node "(bash)Positional Parameters" "digit")
# (find-node "(bash)Shell Parameter Expansion" "`${PARAMETER:-WORD}'")

rcfile_eevblock=$1
rcfile=$2
rcfile_backup=${3:-${rcfile}_pre-eev}
rcfile_tmp=${rcfile}.tmp

# (find-node "(bash)Conditional Constructs" "`if'")
# (find-node "(bash)Bash Conditional Expressions")
# (find-node "(bash)Bourne Shell Builtins" "`test'")
# (find-node "(fileutils)touch invocation" "not exist is created empty.")

echo "  Changing \`$rcfile'..."

if [ ! -e $rcfile_eevblock ]
then
  echo "  The template file \`$rcfile_eevblock' does not exist!"
  exit 1
else
  echo "  Using \`$rcfile_eevblock' as the template file..."
fi

if [ ! -e $rcfile ]
then
  echo "  Creating an empty \`$rcfile'..."
  touch $rcfile
fi

# (find-eev "changer.awk")
if awk -f changer.awk -v eevblock=$rcfile_eevblock $rcfile > $rcfile_tmp
then
  if [ ! -e $rcfile_backup ]
  then
    echo "  Making a backup in \`$rcfile_backup'..."
    cp $rcfile $rcfile_backup
  else
    echo "  Found a previous backup file: \`$rcfile_backup'"
    echo "  Not changing \`$rcfile_backup'."
  fi
  mv $rcfile_tmp $rcfile
else
  # changer.awk is verbose enough, we don't need extra error messages
  rm -f $rcfile_tmp
  exit 1
fi
