;; Copyright (C) 1999, 2000, 2001, 2002 Free Software Foundation, Inc.

;; Author:     Eduardo Ochs <edrx@mat.puc-rio.br>
;; Maintainer: Eduardo Ochs <edrx@mat.puc-rio.br>
;; Version:    2002may11
;; Keywords:   escripts, menu-bar
;;
;; This file was copylefted to prevent against patent psychopaths; if
;; you want a version with any other license you'll have to write it
;; yourself. More formally,
;;
;; This program is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation; either version 2 of the
;; License, or (at your option) any later version.
;;
;; URLs for this file:
;;   http://angg.twu.net/eev/eev-menu-bar.el
;;   http://angg.twu.net/eev/eev-menu-bar.el.html

;;; Commentary:

;; This package provides support for e-scripts in Emacs. Look in
;; <http://angg.twu.net/emacs.html> for more information and in
;; <http://angg.twu.net/escripts.html> for examples of e-scripts... an
;; e-script is typically a text file in which certain parts are meant
;; to be executed by the shell or by other programs and certain
;; comments are in fact Emacs Lisp code; executing one of these
;; comments with C-x C-e (i.e., eval-last-sexp) brings up a file or an
;; info node, and thus works as a hyperlink. Many of the comments in
;; this file can be executed in this way.

;; See also the "eev Manifesto", at
;; <http://angg.twu.net/eev-manifesto.html>, the section named
;; "eev-howto", below, and whatever else seem important in
;; <http://angg.twu.net/>; that site is almost completely dedicated to
;; using eev.el.

;; menu-bar  (to ".menu-bar")
;; (find-es "emacs" "menu-bar")

(defvar menu-bar-eev-menu (make-sparse-keymap "(eev)"))

(define-key menu-bar-eev-menu [end-of-line-then-eval-last-sexp]
  '("C-e + eval-last-sexp" . end-of-line-then-eval-last-sexp))
(define-key menu-bar-eev-menu [eval-last-sexp]
  '("eval-last-sexp" . eval-last-sexp))
(define-key menu-bar-eev-menu [kill-buffer]
  '("kill-buffer (M-k)" . kill-buffer))
(define-key menu-bar-eev-menu [tutorial-pt]
  '("Tutorial (pt_BR)" . (lambda () (interactive)
			   (find-eev "e/tutorial.pt.e"))))
(define-key menu-bar-eev-menu [tutorial]
  '("Tutorial" . (lambda () (interactive)
		   (find-eev "e/tutorial.e"))))
(define-key menu-bar-eev-menu [key-help]
  '("Key help" . (lambda () (interactive)
		   (find-eev "e/keys.e"))))




;;; eev-menu-bar.el ends here

