#!/bin/bash
# eev-videos/2.sh - bash-y functions for recording screencats.
# This file: http://angg.twu.net/eev-videos/2.sh.html
#            http://angg.twu.net/eev-videos/2.sh
#             (find-angg        "eev-videos/2.sh")
#
# (find-angg ".zshrc" "eev2-files")
# (find-zsh0 "eev2-build-tgz")
# (find-sh0 "~/eev-videos/2.sh down xterm 80x32+0+0 ffmpeg 530x550+0+0")
# (find-sh0 "~/eev-videos/2.sh record")

# And for the final version:
# (find-es "eev" "eev2-upload")
source ~/eev-videos/0.sh; # (find-angg "eev-videos/0.sh")
#
if [[ "$1" == "record" ]]; then
  exec $0 down xterm 80x32+0+0 ffmpeg 1024x600+0+0
fi
if [[ "$1" == "down"   ]]; then fvwm-down; shift; fi
if [[ "$1" == "ffmpeg" ]]; then ffmpeg-grab -r 5 -s $2; shift 2; fi
if [[ "$1" == "xterm"  ]]; then shift; exec-xterm $*; fi

#------------
# Preparation
rm -Rv /tmp/eev/
export SHELL=/bin/bash

# Initial messages
clear
cat <<%%%

           ${C1}                                     ${C0}
           ${C1}  A very quick introduction to eev2  ${C0}
           ${C1}  ---------------------------------  ${C0}
           ${C1}  See: http://angg.twu.net/#eev      ${C0}
           ${C1}  (Date: 2012nov15)                  ${C0}
           ${C1}                                     ${C0}

  According to the instructions in eev-readme.el,
  the shell commands to download and unpack eev for tests
  (i.e., in a temporary directory) and load it into Emacs
  are:

    mkdir /tmp/eev/
    cd    /tmp/eev/
    wget http://angg.twu.net/eev-current/eev2.tgz
    ${CB}wget http://angg.twu.net/eev-videos/2.el${C0}
    tar -xvzf eev2.tgz
    emacs eev-readme.el
%%%

se 1 "  Plan for this presentation:"
echo "   ${CB}1.${C0} Emacs as a Lisp environment: \`C-x C-e'"
echo "   ${CB}2.${C0} the sexp at eol: \`C-e C-x C-e' and \`M-e'"
echo "   ${CB}3.${C0} highlighting the sexp at eol: \`M-0 M-e'"
echo "   ${CB}4.${C0} sexps as hyperlinks"
echo "   ${CB}5.${C0} going back with: \`M-k'"
echo "   ${CB}6.${C0} opening in other windows: \`M-2 M-e' and \`M-3 M-e'"
echo "   ${CB}7.${C0} temporary buffers"
echo "   ${CB}8.${C0} temporary buffers with many hyperlinks"
echo "   ${CB}9.${C0} \`find-eev-intro' and other sandbox-y intros"
echo "  ${CB}10.${C0} \`eejump' and other sandbox-y intros"
echo "  ${CB}11.${C0} \`fnd-eev-update-links' and a glimpse into eepitch"

# se 1 "  Let's execute that:"

# se 1 "  This is typical - but do we have to always remember long"
# echo "  sequences of commands, and type them without errors?"
# 
# se 1 "  I think that the answer should be ${CB}NO${C0},"
# echo "  and that's what eev is all about."
# 
# se 1 "  So let's execute the commands above and open"
# echo "  eev-readme.el with Emacs. We will invoke Emacs with some"
# echo "  extra options, namely: \"-Q -fn 6x13 -fg bisque -bg black\""
# echo "  but they're just to make the video look nicer."

echo ""


cd
rm -Rf /tmp/eev/

de 'mkdir /tmp/eev/'
de 'cd    /tmp/eev/'

if [[ -e /tmp/eev2.tgz ]]
then de 'cp -v /tmp/eev2.tgz .'
else de 'wget http://angg.twu.net/eev-current/eev2.tgz'
fi

if [[ -e /tmp/2.el ]]
then de 'cp -v /tmp/2.el .'
else de 'wget http://angg.twu.net/eev-videos/2.el'
fi

de 'tar -xvzf eev2.tgz'
de 'emacs -Q -fn 6x13 -fg bisque -bg black -geometry +0+0 eev-readme.el'

# Kill the video recorder
# killall -q ffmpeg
ffmpeg-kill
