;; This file:
;;   http://angg.twu.net/elisp/2022-find-elisp-intro.el.html
;;   http://angg.twu.net/elisp/2022-find-elisp-intro.el
;;           (find-angg "elisp/2022-find-elisp-intro.el")
;; Author: Eduardo Ochs <eduardoochs@gmail.com>
;;
;; Based on: (find-angg "elisp/emacsconf2021.el")
;; (find-2022findelispintrovideo "0:00")

(load "/home/edrx/eev-current/eev-beginner.el")

(code-c-d "angg" "~/" :anchor :grep)
(code-c-d "es"   "$ES/")
(defun find-es (stem &rest rest)
  (apply 'find-anchor (ee-esfile (concat stem ".e")) rest))

(defun e () (interactive) (find-angg "elisp/2022-find-elisp-intro.el"))
(defun b () (interactive) (find-TH "find-elisp-intro"))
(defun g () (interactive) (find-fline "~/tmp/Gwen, ou le livre de sable.jpg"))
(defun o () (interactive) (find-fline "/tmp/o"))
(defun og () (interactive) (find-2a '(o) '(g)))

(defun m () (interactive) (insert "
My most favorite animation movie ever!!! ->
In English: \"Gwen, or The Book of Sand\"
You can watch it on Youtube!
"))

;; (find-esetkey-links (kbd "M-o") 'other-window)
(global-set-key (kbd "M-o") 'other-window)
(global-set-key (kbd "s-b") 'blink-cursor-mode)
(global-set-key (kbd "s-f") 'toggle-frame-fullscreen)
(global-set-key (kbd "s-m") 'menu-bar-mode)
(global-set-key (kbd "s-s") 'toggle-scroll-bar)
(global-set-key (kbd "s-t") 'tool-bar-mode)
(global-set-key (kbd "<f12>") 'ee-svg-screenshot)

;; (defun eepitch-shell () (eepitch-bash))
(defun eejump-16 () (set-frame-font "Monospace 16" t))
(defun eejump-14 () (set-frame-font "Monospace 14" t))
(defun eejump-12 () (set-frame-font "Monospace 11" t))

;;    Why eev has a
;;    weird elisp tutorial
;;    and how to use it
;; 
;;      Eduardo Ochs
;;      2022jan23
;;      http://angg.twu.net/#eev
;;      http://angg.twu.net/find-elisp-intro.html
;;                         (find-elisp-intro)
;; 
;;    0. Compare with: (find-node "(eintr)")
;; 
;;    1. Short answer: with `M-7 M-j',
;;                              `M-e',
;;                              `M-k',
;;                          `M-h M-2'.
;; 
;;    2. What is `M-7 M-j'?
;; 
;;                   `M-e' - execute
;;                   `M-k' - kill / go back
;;                   `M-j' - jump
;; 
;;         (find-eek "M-j"  "M-2 M-1 M-j  shows")
;;         (find-eek "M-j"  "M-3 M-1 M-j  opens")
;;         (find-eek "M-j"  "targets:")
;;         (find-eek "M-j"  "eejump-7")
;; 
;;           (find-elisp-intro     "M-7 M-j")
;;             (find-eev-intro "M-5 M-0 M-j")
;;       (find-eev-quick-intro     "M-5 M-j")
;;      (find-emacs-keys-intro     "M-2 M-j")
;; 
;; 
;;    3. Hyperlinks to sections
;; 
;;           (find-elisp-intro)
;;           (find-elisp-intro "5. Variables")
;; 
;;    4. Why most people love the eintr but I don't:
;;        (find-node "(eintr)Top")
;;        (find-node "(eintr)Top" "not programmers")
;;        (find-node "(eintr)Top" "Menu:")
;;        (find-node "(eintr)copy-to-buffer")
;; 
;;       In short:
;;         big,
;;         hard to navigate,
;;         uses faces,
;;         read-only,
;;         few executable examples per page,
;;         for people who want to write elisp,
;;         teaches pure Lisp and editor functions
;;           at the same time,
;;         few links to the primary sources...
;; 
;;       ...and the main point:
;;       "Do it yourself"

(defun ee-svg-screenshot (&optional fname)
  (interactive)
  (write-region
   (x-export-frames nil 'svg) nil
   (or fname "/tmp/screenshot.svg")))

(if (fboundp 'menu-bar-mode)   (menu-bar-mode 0))
(if (fboundp 'tool-bar-mode)   (tool-bar-mode 0))
(if (fboundp 'scroll-bar-mode) (scroll-bar-mode -1))

(setq show-paren-mode nil)
(setq electric-indent-mode nil)

(eejump-16)
(og)
(eek "s-f")
(message "")

;; (find-angg ".zshrc" "emacs28_")
;;
'("This is a test block:
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
emacs28_0 -Q -l /home/edrx/elisp/2022-find-elisp-intro.el &

--")







;; Local Variables:
;; coding:  utf-8-unix
;; End:
