;; rcirc-x.el -- extra rcirc functionality

(require 'rcirc)

(defun rcirc-occur-nick ()
  (interactive)
  (with-syntax-table rcirc-nick-syntax-table
    (modify-syntax-entry ?< "w")
    (occur (concat "\\b" rcirc-nick "\\b"))))

(define-key rcirc-mode-map (kbd "C-c M-o") 'rcirc-occur-nick)

(defun rcirc-search-backward-nick ()
  (interactive)
  (modify-syntax-entry ?< "w")
  (re-search-backward (concat "\\b" rcirc-nick "\\b")))

(defun rcirc-search-forward-nick ()
  (interactive)
  (modify-syntax-entry ?< "w")
  (re-search-forward (concat "\\b" rcirc-nick "\\b")))

(define-key rcirc-mode-map (kbd "C-c M-n") 'rcirc-search-forward-nick)
(define-key rcirc-mode-map (kbd "C-c M-p") 'rcirc-search-backward-nick)


;;; scroll to bottom code:

(defvar rcirc-scroll-to-bottom-flag nil
  "*If non-nil, scroll window to bottom on output.")

;; in rcirc-print

	(walk-windows (lambda (w)
			(if (not (eq (selected-window) w))
			    (when (and (eq (current-buffer) (window-buffer w))
				       (>= (window-point w) rcirc-insert-marker))
			      (set-window-point w (point-max))))
			(when (and rcirc-scroll-to-bottom-flag
				   (eq (current-buffer) (window-buffer w)))
			  (save-selected-window
			    (select-window w)
			    (recenter -1))))
			nil t)
			

;; put this in `rcirc-mode'

  ;; This makes it really work to keep point at the bottom. (but it
  ;; breaks things
  ;;(make-local-variable 'scroll-conservatively)
  ;;(setq scroll-conservatively 10000)




(provide 'rcirc-x)
