#######
#
# E-scripts for TeX-related things.
#
# Note 1: use the eev command (defined in eev.el) and the
# ee alias (in my .zshrc) to execute parts of this file.
# Executing this file as a whole makes no sense.
# An introduction to eev can be found here:
#
#   (find-eev-quick-intro)
#   http://angg.twu.net/eev-intros/find-eev-quick-intro.html
#
# Note 2: be VERY careful and make sure you understand what
# you're doing.
#
# Note 3: If you use a shell other than zsh things like |&
# and the for loops may not work.
#
# Note 4: I always run as root.
#
# Note 5: some parts are too old and don't work anymore. Some
# never worked.
#
# Note 6: the definitions for the find-xxxfile commands are on my
# .emacs.
#
# Note 7: if you see a strange command check my .zshrc -- it may
# be defined there as a function or an alias.
#
# Note 8: the sections without dates are always older than the
# sections with dates.
#
# This file is at <http://angg.twu.net/e/tex.e>
#           or at <http://angg.twu.net/e/tex.e.html>.
#        See also <http://angg.twu.net/emacs.html>,
#                 <http://angg.twu.net/.emacs[.html]>,
#                 <http://angg.twu.net/.zshrc[.html]>,
#                 <http://angg.twu.net/escripts.html>,
#             and <http://angg.twu.net/>.
#
#######



# «.index»
# «.mailing-lists»		(to "mailing-lists")
# «.texdoc»			(to "texdoc")
# «.docs»			(to "docs")
# «.minimal»			(to "minimal")
# «.docstrip»			(to "docstrip")
# «.docstrip-geometry»		(to "docstrip-geometry")
# «.source2e»			(to "source2e")
# «.source2e-compiling»		(to "source2e-compiling")
# «.dtx»			(to "dtx")
# «.dtxtut»			(to "dtxtut")
# «.ltxdoc»			(to "ltxdoc")
# «.classes»			(to "classes")
# «.source2e.dvi»		(to "source2e.dvi")
# «.classes.dtx-dvi»		(to "classes.dtx-dvi")
# «.equation-numbers»		(to "equation-numbers")
# «.if»				(to "if")
# «.texbook»			(to "texbook")
# «.mfbook»			(to "mfbook")
# «.ps-720dpi»			(to "ps-720dpi")
# «.latex2html»			(to "latex2html")
# «.pstoimg»			(to "pstoimg")
# «.dtx2dvi»			(to "dtx2dvi")
# «.texmf.cnf»			(to "texmf.cnf")
# «.kpathsea»			(to "kpathsea")
# «.stmaryrd»			(to "stmaryrd")
# «.bye»			(to "bye")
# «.testfont»			(to "testfont")
# «.testfontcmds»		(to "testfontcmds")
# «.testfont.tex»		(to "testfont.tex")
# «.mf_X»			(to "mf_X")
# «.mf_X.1»			(to "mf_X.1")
# «.mf_X.2»			(to "mf_X.2")
# «.metapost-old»		(to "metapost-old")
# «.metapost»			(to "metapost")
# «.tetex-bin»			(to "tetex-bin")
# «.weaving»			(to "weaving")
# «.leo_moura_eev»		(to "leo_moura_eev")
# «.babel-2024»			(to "babel-2024")
# «.babel»			(to "babel")
# «.polyglossia»		(to "polyglossia")
# «.portug-hyph»		(to "portug-hyph")
# «.texlive-lang»		(to "texlive-lang")
# «.showhyphens»		(to "showhyphens")
# «.gftype»			(to "gftype")
# «.gftodvi»			(to "gftodvi")
# «.bbold_and_rsfs»		(to "bbold_and_rsfs")
# «.arabtex»			(to "arabtex")
# «.pic_manual»			(to "pic_manual")
# «.xdvi-gz»			(to "xdvi-gz")
# «.xdvi-pid»			(to "xdvi-pid")
# «.xdvi»			(to "xdvi")
# «.rail»»			(to "rail")
# «.src2tex»			(to "src2tex")
# «.auctex»			(to "auctex")
# «.twocolumn»			(to "twocolumn")
# «.show_and_tracing»		(to "show_and_tracing")
# «.nonstopmode»		(to "nonstopmode")
# «.show_box_dims»		(to "show_box_dims")
# «.smash»			(to "smash")
# «.indices»			(to "indices")
# «.tatsutaproof»		(to "tatsutaproof")
# «.bussproofs»			(to "bussproofs")
# «.bussproofs-vdots»		(to "bussproofs-vdots")
# «.bussproofs-extra»		(to "bussproofs-extra")
# «.bussproofs-victor»		(to "bussproofs-victor")
# «.prftree»			(to "prftree")
# «.ptproof-old»		(to "ptproof-old")
# «.ptproof»			(to "ptproof")
# «.proof»			(to "proof")
# «.texcad»			(to "texcad")
# «.phantom»			(to "phantom")
# «.mathstrut»			(to "mathstrut")
# «.mathop»			(to "mathop")
# «.arrow.tex»			(to "arrow.tex")
# «.picture_mode»		(to "picture_mode")
# «.picture-mode»		(to "picture-mode")
# «.thin_supset»		(to "thin_supset")
# «.begin-picture»		(to "begin-picture")
# «.beginpicture»		(to "beginpicture")
# «.pict2e»			(to "pict2e")
# «.pict2e-example»		(to "pict2e-example")
# «.pict2e-vector»		(to "pict2e-vector")
# «.pict2e-vector-params»	(to "pict2e-vector-params")
# «.pict2e-squigbij»		(to "pict2e-squigbij")
# «.pict2e-no-suitable-driver»	(to "pict2e-no-suitable-driver")
# «.pict2e-grid-on-image»	(to "pict2e-grid-on-image")
# «.curve2e»			(to "curve2e")
# «.lapdf»			(to "lapdf")
# «.diagmac»			(to "diagmac")
# «.begin»			(to "begin")
# «.newenvironment»		(to "newenvironment")
# «.calc»			(to "calc")
# «.realcalc»			(to "realcalc")
# «.tex-br»			(to "tex-br")
# «.LaTeX-demo»			(to "LaTeX-demo")
# «.cmsy10_scaled»		(to "cmsy10_scaled")
# «.bibtex-2017»		(to "bibtex-2017")
# «.bibtex-test»		(to "bibtex-test")
# «.bibliography-by-hand»	(to "bibliography-by-hand")
# «.bibtex-arxiv»		(to "bibtex-arxiv")
# «.bibtex»			(to "bibtex")
# «.makebbl»			(to "makebbl")
# «.biber»			(to "biber")
# «.biber-ph1»			(to "biber-ph1")
# «.biber-ph1-biblatex»		(to "biber-ph1-biblatex")
# «.biber-shorthands»		(to "biber-shorthands")
# «.biber-git»			(to "biber-git")
# «.biber-2.8-from-git»		(to "biber-2.8-from-git")
# «.biblatex-git»		(to "biblatex-git")
# «.biblatex-git-dirs»		(to "biblatex-git-dirs")
# «.biblatex-git-install»	(to "biblatex-git-install")
# «.biblatex-git-uninstall»	(to "biblatex-git-uninstall")
# «.biblatex»			(to "biblatex")
# «.betterbib»			(to "betterbib")
# «.pmb»			(to "pmb")
# «.poor-mans-bold»		(to "poor-mans-bold")
# «.co»				(to "co")
# «.poor-mans-code»		(to "poor-mans-code")
# «.TOCs»			(to "TOCs")
# «.mytoc»			(to "mytoc")
# «.tableofcontents»		(to "tableofcontents")
# «.contentsline»		(to "contentsline")
# «.contentsline-Show2»		(to "contentsline-Show2")
# «.tocloft»			(to "tocloft")
# «.footnote»			(to "footnote")
# «.ulem»			(to "ulem")
# «.strikethrough»		(to "strikethrough")
# «.enlarge-pool_size»		(to "enlarge-pool_size")
# «.fraktur»			(to "fraktur")
# «.fraktur-alternatives»	(to "fraktur-alternatives")
# «.mathfrak-kpfonts»		(to "mathfrak-kpfonts")
# «.mathrsfs»			(to "mathrsfs")
# «.fontfamily»			(to "fontfamily")
# «.fontfamily»			(to "fontfamily")
# «.linebreak»			(to "linebreak")
# «.hyperref»			(to "hyperref")
# «.breakurl»			(to "breakurl")
# «.vbox»			(to "vbox")
# «.newbox»			(to "newbox")
# «.newsavebox»			(to "newsavebox")
# «.dvi2dvi»			(to "dvi2dvi")
# «.savebox»			(to "savebox")
# «.savebox-2019»		(to "savebox-2019")
# «.prime-bug»			(to "prime-bug")
# «.ignoring»			(to "ignoring")
# «.makeindex»			(to "makeindex")
# «.minipage»			(to "minipage")
# «.fullminipage»		(to "fullminipage")
# «.greek»			(to "greek")
# «.ThesisPUC»			(to "ThesisPUC")
# «.texdoc»			(to "texdoc")
# «.pdfpages»			(to "pdfpages")
# «.pdfpages-a4»		(to "pdfpages-a4")
# «.pdfpages-decrypt»		(to "pdfpages-decrypt")
# «.pdfpages-tex»		(to "pdfpages-tex")
# «.pdfpages-frame»		(to "pdfpages-frame")
# «.pdfpages-links»		(to "pdfpages-links")
# «.ite»			(to "ite")
# «.psfonts»			(to "psfonts")
# «.pstricks-old»		(to "pstricks-old")
# «.pstricks»			(to "pstricks")
# «.cartao-claudia»		(to "cartao-claudia")
# «.png_screenshots»		(to "png_screenshots")
# «.cv-packages»		(to "cv-packages")
# «.cv»				(to "cv")
# «.currvita»			(to "currvita")
# «.currvitaedrx»		(to "currvitaedrx")
# «.TEXINPUTS»			(to "TEXINPUTS")
# «.dvipng»			(to "dvipng")
# «.tetex-and-texlive»		(to "tetex-and-texlive")
# «.fontdimen»			(to "fontdimen")
# «.parindent»			(to "parindent")
# «.quote»			(to "quote")
# «.quotation»			(to "quotation")
# «.verse»			(to "verse")
# «.running-TeX-show»		(to "running-TeX-show")
# «.tesemestr»			(to "tesemestr")
# «.framebox»			(to "framebox")
# «.dags»			(to "dags")
# «.figure-and-caption»		(to "figure-and-caption")
# «.caption»			(to "caption")
# «.long»			(to "long")
# «.longtable»			(to "longtable")
# «.miniforth.bib»		(to "miniforth.bib")
# «.magnification-in-tex»	(to "magnification-in-tex")
# «.magnification-in-latex»	(to "magnification-in-latex")
# «.indentfirst»		(to "indentfirst")
# «.verbatim»			(to "verbatim")
# «.verbatim.dtx»		(to "verbatim.dtx")
# «.verbatimbox»		(to "verbatimbox")
# «.verbbox»			(to "verbbox")
# «.verbatiminput»		(to "verbatiminput")
# «.fbox»			(to "fbox")
# «.boxedminipage»		(to "boxedminipage")
% «.smini»			(to "smini")
# «.fbox-minipage»		(to "fbox-minipage")
# «.tools»			(to "tools")
# «.toolbox»			(to "toolbox")
# «.amsmath»			(to "amsmath")
# «.smallmatrix»		(to "smallmatrix")
# «.MaxMatrixCols»		(to "MaxMatrixCols")
# «.unicode-math»		(to "unicode-math")
# «.declareunicodecharacter»	(to "declareunicodecharacter")
# «.inputenc»			(to "inputenc")
# «.inputenc-edrxchars»		(to "inputenc-edrxchars")
# «.newunicodechar»		(to "newunicodechar")
# «.detokenize»			(to "detokenize")
# «.fontspec»			(to "fontspec")
# «.selinput»			(to "selinput")
# «.agda.sty»			(to "agda.sty")
# «.weaving-tex.web»		(to "weaving-tex.web")
# «.latex-general»		(to "latex-general")
# «.leavevmode»			(to "leavevmode")
# «.ttchars»			(to "ttchars")
# «.texbytopic»			(to "texbytopic")
# «.color»			(to "color")
# «.vrule»			(to "vrule")
# «.bicolorhbox»		(to "bicolorhbox")
# «.bhbox»			(to "bhbox")
# «.definecolor»		(to "definecolor")
# «.color-packages»		(to "color-packages")
# «.colorweb»			(to "colorweb")
# «.xcolor»			(to "xcolor")
# «.xcolor-spectrum»		(to "xcolor-spectrum")
# «.xcolor-Hcolors»		(to "xcolor-Hcolors")
# «.testcolor»			(to "testcolor")
# «.protect»			(to "protect")
# «.times»			(to "times")
# «.psnfss-2021»		(to "psnfss-2021")
# «.psnfss-avant-garde»		(to "psnfss-avant-garde")
# «.ovals»			(to "ovals")
# «.xfig»			(to "xfig")
# «.xfig-file-format»		(to "xfig-file-format")
# «.eepic»			(to "eepic")
# «.tac.cls»			(to "tac.cls")
# «.demobox»			(to "demobox")
# «.matrix»			(to "matrix")
# «.math-atoms»			(to "math-atoms")
# «.lshort»			(to "lshort")
# «.left-quote-double-hat»	(to "left-quote-double-hat")
# «.message»			(to "message")
# «.newlinechar»		(to "newlinechar")
# «.debugging-diagxy»		(to "debugging-diagxy")
# «.cmtt-and-cmttb»		(to "cmtt-and-cmttb")
# «.math-lists»			(to "math-lists")
# «.beamer»			(to "beamer")
# «.texlive-base-deb-src»	(to "texlive-base-deb-src")
# «.texlive-bin-deb-src»	(to "texlive-bin-deb-src")
# «.dvired-fonts»		(to "dvired-fonts")
# «.skencil»			(to "skencil")
# «.big-delimiters»		(to "big-delimiters")
# «.book.cls»			(to "book.cls")
# «.qtree»			(to "qtree")
# «.juridico»			(to "juridico")
# «.newcounter»			(to "newcounter")
# «.fitch»			(to "fitch")
# «.kluwer-fitch»		(to "kluwer-fitch")
# «.lplfitch»			(to "lplfitch")
# «.selinger-fitch»		(to "selinger-fitch")
# «.mdwtab»			(to "mdwtab")
# «.smashpicture»		(to "smashpicture")
# «.shortvrb»			(to "shortvrb")
# «.llangle-and-rrangle»	(to "llangle-and-rrangle")
# «.llbracket-and-rrbracket»	(to "llbracket-and-rrbracket")
# «.landscape»			(to "landscape")
# «.crossover»			(to "crossover")
# «.birkjour»			(to "birkjour")
# «.arxiv»			(to "arxiv")
# «.more-than-9-args»		(to "more-than-9-args")
# «.selinger-fitch»		(to "selinger-fitch")
# «.ipe»			(to "ipe")
# «.geometry»			(to "geometry")
# «.screenshotgeometry»		(to "screenshotgeometry")
# «.2-pages-per-sheet»		(to "2-pages-per-sheet")
# «.floats»			(to "floats")
# «.includegraphics»		(to "includegraphics")
# «.pdfcrop»			(to "pdfcrop")
# «.subfigure»			(to "subfigure")
# «.subfig»			(to "subfig")
# «.let»			(to "let")
# «.ata.cls»			(to "ata.cls")
# «.tlmgr»			(to "tlmgr")
# «.T1-fontenc»			(to "T1-fontenc")
# «.inputenx»			(to "inputenx")
# «.no-room-for-a-new-dimen»	(to "no-room-for-a-new-dimen")
# «.vcenter»			(to "vcenter")
# «.rotatebox»			(to "rotatebox")
# «.resizebox»			(to "resizebox")
# «.scalebox»			(to "scalebox")
# «.adjustbox»			(to "adjustbox")
# «.collectbox»			(to "collectbox")
# «.overbrace»			(to "overbrace")
# «.underbrace»			(to "underbrace")
# «.picture-cells»		(to "picture-cells")
# «.lower-and-raise»		(to "lower-and-raise")
# «.scriptscriptstyle»		(to "scriptscriptstyle")
# «.virginia-lake»		(to "virginia-lake")
# «.cancel»			(to "cancel")
# «.latex-recorder»		(to "latex-recorder")
# «.latex-recorder-2017»	(to "latex-recorder-2017")
# «.ott»			(to "ott")
# «.array»			(to "array")
# «.halign»			(to "halign")
# «.arraycolsep»		(to "arraycolsep")
# «.arraystretch»		(to "arraystretch")
# «.delarray»			(to "delarray")
# «.tabbing»			(to "tabbing")
# «.eqnarray»			(to "eqnarray")
# «.overset-and-underset»	(to "overset-and-underset")
# «.amslatex»			(to "amslatex")
# «.multicol»			(to "multicol")
# «.firstcol-anothercol»	(to "firstcol-anothercol")
# «.multicolumn»		(to "multicolumn")
# «.multirow»			(to "multirow")
# «.hss»			(to "hss")
# «.fmtutil»			(to "fmtutil")
# «.parse-aux-file»		(to "parse-aux-file")
# «.parse-aux-file-sajl»	(to "parse-aux-file-sajl")
# «.pagebreak»			(to "pagebreak")
# «.thispagestyle»		(to "thispagestyle")
# «.fancyvrb»			(to "fancyvrb")
# «.fancyhdr»			(to "fancyhdr")
# «.fancyhdr-Show2»		(to "fancyhdr-Show2")
# «.edrxheadfoot.tex»		(to "edrxheadfoot.tex")
# «.edrxheadfoot-Show2»		(to "edrxheadfoot-Show2")
# «.beamerposter»		(to "beamerposter")
# «.sciposter»			(to "sciposter")
# «.template-sajl»		(to "template-sajl")
# «.newtheorem»			(to "newtheorem")
# «.theorem»			(to "theorem")
# «.amsthm»			(to "amsthm")
# «.lastpage»			(to "lastpage")
# «.12pt»			(to "12pt")
# «.label»			(to "label")
# «.texlive-2016»		(to "texlive-2016")
# «.texlive-install»		(to "texlive-install")
# «.install-tl»			(to "install-tl")
# «.displaystyle»		(to "displaystyle")
# «.page-numbers»		(to "page-numbers")
# «.mapsto»			(to "mapsto")
# «.documentclass»		(to "documentclass")
# «.usepackage»			(to "usepackage")
# «.document»			(to "document")
# «.abstract»			(to "abstract")
# «.catcode»			(to "catcode")
# «.varepsilon»			(to "varepsilon")
# «.varphi»			(to "varphi")
# «.section»			(to "section")
# «.tocline»			(to "tocline")
#   «.TocLines2»		(to "TocLines2")
#   «.dottedtocline»		(to "dottedtocline")
#   «.linktopage»		(to "linktopage")
#   «.hyperref-hyperlink»	(to "hyperref-hyperlink")
# «.eqalign»			(to "eqalign")
# «.huge»			(to "huge")
# «.obsolete»			(to "obsolete")
# «.title»			(to "title")
# «.latex-beginners-course»	(to "latex-beginners-course")
# «.itemize»			(to "itemize")
# «.enumitem»			(to "enumitem")
# «.list»			(to "list")
# «.visuallatexfaq»		(to "visuallatexfaq")
# «.graphicx»			(to "graphicx")
# «.stackrel»			(to "stackrel")
# «.shipout»			(to "shipout")
# «.eject»			(to "eject")
# «.tableaux»			(to "tableaux")
# «.squiggly-arrows»		(to "squiggly-arrows")
# «.comments»			(to "comments")
# «.stix»			(to "stix")
# «.symbols»			(to "symbols")
# «.symbols-2001»		(to "symbols-2001")
# «.unimathsymbols»		(to "unimathsymbols")
# «.fontcatalogue»		(to "fontcatalogue")
# «.settoheight»		(to "settoheight")
# «.bakoma»			(to "bakoma")
# «.texniccenter»		(to "texniccenter")
# «.texmaker»			(to "texmaker")
# «.texmaker-planar-has-1»	(to "texmaker-planar-has-1")
# «.texstudio»			(to "texstudio")
# «.texstudio-synctex»		(to "texstudio-synctex")
# «.texworks»			(to "texworks")
# «.texmacs»			(to "texmacs")
# «.synctex»			(to "synctex")
# «.magic-comments»		(to "magic-comments")
# «.tugboat»			(to "tugboat")
# «.ltugboat.cls»		(to "ltugboat.cls")
# «.practex»			(to "practex")
# «.lipsum»			(to "lipsum")
# «.string»			(to "string")
# «.ifx»			(to "ifx")
# «.ifundefined»		(to "ifundefined")
# «.xpdf-windows-mac»		(to "xpdf-windows-mac")
# «.list-macros-select»		(to "list-macros-select")
# «.eyes-mouth-stomach»		(to "eyes-mouth-stomach")
# «.abnt»			(to "abnt")
# «.vskip»			(to "vskip")
# «.compositionality»		(to "compositionality")
# «.doi»			(to "doi")
# «.normalsize»			(to "normalsize")
# «.mathpartir»			(to "mathpartir")
# «.ebproof»			(to "ebproof")
# «.rlap-and-llap»		(to "rlap-and-llap")
# «.oto»			(to "oto")
# «.arara»			(to "arara")
# «.asymptote»			(to "asymptote")
# «.luke-smith»			(to "luke-smith")
# «.math-fonts-for-latex»	(to "math-fonts-for-latex")
# «.txfonts»			(to "txfonts")
# «.cmbright»			(to "cmbright")
# «.arev»			(to "arev")
# «.newtxsf»			(to "newtxsf")
# «.14pt»			(to "14pt")
# «.newlength»			(to "newlength")
# «.square-already-defined»	(to "square-already-defined")
# «.latexmk»			(to "latexmk")
# «.poster-bandali»		(to "poster-bandali")
# «.cases»			(to "cases")
# «.pictex»			(to "pictex")
# «.dcpic»			(to "dcpic")
# «.foiltex»			(to "foiltex")
# «.nonstopmode»		(to "nonstopmode")
# «.calculator»			(to "calculator")
# «.joseph-wright»		(to "joseph-wright")
# «.typewriter»			(to "typewriter")
# «.lhookdownarrow»		(to "lhookdownarrow")
# «.mnsymbol»			(to "mnsymbol")
# «.mathabx»			(to "mathabx")
# «.mathabx-email»		(to "mathabx-email")
# «.limp-abx»			(to "limp-abx")
# «.llncs»			(to "llncs")
# «.overleaf-nonstopmode»	(to "overleaf-nonstopmode")
# «.tufte»			(to "tufte")
# «.ebgaramond»			(to "ebgaramond")
# «.garamond»			(to "garamond")
# «.getnonfreefonts»		(to "getnonfreefonts")
# «.unicode-math»		(to "unicode-math")
# «.svg»			(to "svg")
# «.fira»			(to "fira")
# «.pythontex»			(to "pythontex")
# «.unravel»			(to "unravel")
# «.bm»				(to "bm")
# «.microtype»			(to "microtype")
# «.TUG2020»			(to "TUG2020")
# «.paul-blain-levy-macros»	(to "paul-blain-levy-macros")
# «.minted»			(to "minted")
# «.chinese»			(to "chinese")
# «.reledmac»			(to "reledmac")
# «.standalone»			(to "standalone")
# «.currfile»			(to "currfile")
# «.memoir»			(to "memoir")
# «.mathchoice»			(to "mathchoice")
# «.natbib»			(to "natbib")
# «.meteor»			(to "meteor")
# «.socpsych»			(to "socpsych")
# «.complex-tables»		(to "complex-tables")
# «.multiple-pdfs»		(to "multiple-pdfs")
# «.noto»			(to "noto")
# «.emoji»			(to "emoji")
# «.edef»			(to "edef")
# «.expandafter»		(to "expandafter")
# «.sile»			(to "sile")
# «.monospaced»			(to "monospaced")
# «.reference-cards»		(to "reference-cards")
# «.mdframed»			(to "mdframed")
# «.debug-chapter»		(to "debug-chapter")
# «.sa-and-ga»			(to "sa-and-ga")
# «.ensuremath»			(to "ensuremath")
# «.box-drawing-chars»		(to "box-drawing-chars")
# «.visible-space»		(to "visible-space")




# (find-zsh "installeddebs | sort | grep texlive")
# (find-zsh "availabledebs | sort | grep texlive")
# (find-status   "texlive-pictures")
# (find-status   "texlive-pictures" "pict2e ")
# (find-vldifile "texlive-pictures.list")
# (find-udfile   "texlive-pictures/")
# (find-status   "texlive-pictures-doc")
# (find-vldifile "texlive-pictures-doc.list")
# (find-udfile   "texlive-pictures-doc/")





#####
#
# mailing-lists
# 2019nov16
#
#####

# «mailing-lists» (to ".mailing-lists")
# (find-es "texlive" "mailing-list")
# https://www.tug.org/texlive/lists.html
# https://tug.org/mailman/listinfo/tex-live
# https://tug.org/pipermail/tex-live/
# https://tug.org/pipermail/tex-live/2019-November/044433.html two TL installations at the same time




#####
#
# texdoc
# 2016jan01
#
#####

# «texdoc» (to ".texdoc")
# (find-man "1 texdoc")
# (find-sh "texdoc -f")

# (find-fline "/usr/share/texlive/texmf-dist/texdoc/texdoc.cnf")
# (find-angg "texmf/texdoc/texdoc.cnf")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
texdoc texdoc




#####
#
# some docs
# 2000oct02
#
#####

# «docs»  (to ".docs")
# (to "texbook")
# (to "xdvi-gz")
# (find-angg ".zshrc" "zxdvi")
# (find-vldifile "tetex-doc.list")
# (find-vldifile "tetex-src.list")
#
#   texbook:   p.427=438 font charts
#              p.434=445 symbol commands
#   essential: p.20      huge table of symbols commands (<- use this)
#   amsguide:  p.20=21   symbol commands
#
#   amsldoc:   many examples of ams math mode

# (find-angg "X")
# export DISPLAY=:0.0
xdvi +438 $SCTAN/systems/knuth/tex/texbook.dvi &
xdvi +445 $SCTAN/systems/knuth/tex/texbook.dvi &
zxdvi /usr/share/doc/texmf/latex/general/essential.dvi.gz +20 &
xdvi /usr/share/doc/texmf/amstex/amsguide.dvi.gz         +21 &
zxdvi /usr/share/doc/texmf/latex/amslatex/amsldoc.dvi.gz  +10 &

gv   /usr/share/doc/texmf/generic/xypic/xyrefer.ps.gz &
gv   /usr/share/doc/texmf/generic/xypic/xyguide.ps.gz &
xdvi /usr/share/texmf/source/generic/xypic/doc/xyrefer.dvi &
xdvi /usr/share/texmf/source/generic/xypic/doc/xyguide.dvi &

xdvi $SCTAN/systems/knuth/mf/mfbook.dvi &
gv /usr/share/doc/texmf/metapost/base/mpman.ps.gz &

zxdvi /usr/share/doc/texmf/latex/base/cfgguide.dvi.gz &
zxdvi /usr/share/doc/texmf/latex/base/clsguide.dvi.gz &
zxdvi /usr/share/doc/texmf/latex/base/fntguide.dvi.gz &
zxdvi /usr/share/doc/texmf/latex/base/usrguide.dvi.gz &
zxdvi /usr/share/doc/texmf/latex/general/guide.dvi.gz &


# The paths below this point are not yet potatoized, and I need to
# rewrite the e-scripts that generate testmath.dvi and source2e.dvi...

xdvi /usr/lib/texmf/source/latex/amslatex/math/testmath.dvi &

# (find-knuthfile "tex/texbook.tex" 25862)
# xdvi /usr/lib/texmf/texmf/doc/ams/amslatex/testmath.dvi &

# Source2e:
xdvi /usr/lib/texmf/source/latex/base/source2e.dvi &
# and its index...
# (find-lsrcfile "base/source2e.tex")
# (find-lsrcfile "base/source2e.ind")
cd /usr/lib/texmf/source/latex/base/
agrep '\{part\}...hspace' source2e.toc

xdvi $SCTAN/systems/knuth/tex/texbook.dvi &
#
# (find-fline "$SCTAN/systems/knuth/mf/mfbook.tex")
# (find-fline "$SCTAN/systems/knuth/tex/texbook.tex")
# (find-web2cfile "tex/tex.web")
# (find-web2cfile "mf/mf.web")
# (find-knuthfile "tex/index.tex")

# (find-fline "/usr/doc/texmf/latex/amslatex/testmath.tex.gz")
# (find-fline "/usr/lib/texmf/source/latex/amslatex/math/testmath.tex")
# (find-fline "/usr/share/texmf/source/latex/guide/essential.tex")
# (find-fline "/usr/share/texmf/source/latex/guide/essential2e.tex")

# xdvi /usr/lib/texmf/texmf/doc/latex/general/guide.dvi &
# xdvi /usr/lib/texmf/texmf/doc/latex/general/l2kurz.dvi &

# (find-node "(latex)Top")
xdvi /usr/lib/texmf/texmf/doc/latex/general/latex2e.dvi &
# (find-lshfile "lshort2e.tex")
xdvi /usr/lib/texmf/texmf/doc/latex/general/lshort2e.dvi &
xdvi /usr/lib/texmf/texmf/doc/latex/base/fntguide.dvi &

cd /usr/lib/texmf/texmf/doc/ams/amslatex/
latex testmath.tex
latex testmath.tex
latex testmath.tex

xdvi /snarf/ftp/ftp.dcs.qmw.ac.uk/pub/tex/contrib/pt/proofs/prooftree-doc.dvi &

# amsldoc has many examples of ams math mode.
#
xdvi /usr/lib/texmf/texmf/doc/ams/amslatex/amsldoc.dvi &
xdvi /usr/lib/texmf/texmf/doc/ams/amslatex/instr-l.dvi &
xdvi /usr/lib/texmf/texmf/doc/ams/amstex/amsguide.dvi &

# amsfndoc has font charts at the end.
xdvi /usr/lib/texmf/texmf/doc/ams/amsfonts/amsfndoc.dvi &
xdvi /usr/lib/texmf/texmf/doc/ams/amsfonts/amsfonts.dvi &
xdvi /usr/share/doc/texmf/fonts/amsfonts/eufrak.dvi.gz &
xdvi /usr/share/doc/texmf/fonts/amsfonts/euscript.dvi.gz &

# Install the LaTeX2e texinfo docs, to be accessed with, e.g.:
# (find-node "(latex)Top")
#
cd /usr/lib/texmf/source/info/
makeinfo latex2e.texi
mv -v latex latex-* /usr/info/

locate '/usr/*.dvi' | sort

# 2008jun07:
# amsldoc and instr-l are broken...
# (find-dvipage  "/usr/share/doc/tetex-doc/amstex/amsguide.dvi.gz")
# (find-pdf-page "/usr/share/doc/tetex-doc/latex/amsmath/amsldoc.pdf.gz")
# (find-fline    "/usr/share/doc/tetex-doc/latex/amsmath/amsldoc.pdf.gz")
# (find-pdf-page "/usr/share/doc/tetex-doc/latex/amscls/instr-l.pdf.gz")
# (find-fline    "/usr/share/doc/tetex-doc/latex/amscls/instr-l.pdf.gz")




#####
#
# A minimal LaTeX file
# 2000oct31
#
#####

# «minimal»  (to ".minimal")
#
cd /tmp/
cat > ltest.tex <<'---'
\documentclass{book}
\begin{document}
Hello
\end{document}
---
latex ltest.tex
xdvi ltest.dvi &
#




#####
#
# TeXing testmath (potato)
# 2000oct31
#
#####

# «testmath»  (to ".testmath")
#
cd ~/tmp/
rm -v testmath.{aux,log,dvi}
zcat /usr/share/doc/texmf/latex/amslatex/testmath.tex.gz > testmath.tex
# cp /usr/share/texmf/source/latex/amslatex/math/testmath.tex .
latex testmath.tex
latex testmath.tex
latex testmath.tex
#
xdvi ~/tmp/testmath.dvi &
xdvi +29 ~/tmp/testmath.dvi &

# (find-fline "~/tmp/testmath.tex")




#####
#
# source2e.tex (generating a dvi doc for the LaTeX base files)
# 2000oct04 / 2016may27 / 2019jan04
#
#####

# «source2e»  (to ".source2e")
# (find-angg ".emacs.papers" "source2e")
# (find-angg ".emacs.papers" "macros2e")
# (find-sh "apt-file search source2e")
# (find-tlsh "find * | sort")
# (find-tlsh "find * | sort | grep source2e")
# (find-tlfile "texmf-dist/doc/latex/base/" "source2e.pdf")

# (find-source2efile "source2e.tex")
# (find-source2efile "source2e.tex" "\\DocInclude{ltplain}")
# (find-source2egrep "grep --color -nH -e DocInclude source2e.tex")

# (find-source2epage (+ 10 53) "14      Program control structure")
# (find-source2etext (+ 10 53) "14      Program control structure")
# (find-source2epage (+ 10 404) "64       Page styles and related commands")
# (find-source2etext (+ 10 404) "64       Page styles and related commands")
# (find-source2epage (+ 11 690) "Index")
# (find-source2etext (+ 11 690) "Index")






#####
#
# Producing a source2e.pdf from the sources
# 2017ago15
#
#####

# «source2e-compiling» (to ".source2e-compiling")
# (find-sh "apt-file search texpert")
# (find-udfile "texlive-doc/latex/base/")
# (find-udfile "texlive-doc/latex/base/texpert.txt.gz")
# (find-udfile "texlive-doc/latex/base/texpert.txt.gz" ".dtx file")
# (find-udfile "texlive-doc/latex/base/texpert.txt.gz" "at the end of source2e.tex")
# (find-udfile "texlive-doc/latex/base/manifest.txt.gz" "ltcntrl.dtx" "Program control macros.")

# 2016may27:
# There is no "source2e.tex" in debian packages,
# I'll have to download it from CTAN...
# http://mirrors.ctan.org/macros/latex/base.zip

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/latex/base/")
# (find-source2efile "")
# (find-source2efile "source2e.tex")
# (find-source2efile "source2e.tex" "\\DocInclude{ltdirchk}")

mkdir  ~/usrc/latex/
rm -Rv ~/usrc/latex/base/
mkdir  ~/usrc/latex/base/
cd     ~/usrc/latex/
unzip $S/http/mirrors.ctan.org/macros/latex/base.zip
cd     ~/usrc/latex/base/

# Old:
# (find-lsrcfile "base/texpert.txt" "print the LaTeX source")
# (find-lsrcfile "base/texpert.txt" "To typeset a documented code file")
# (find-lsrcfile "base/source2e.tex" "to produce a fully indexed source code")
#
# (find-fline "/tmp/texsrc/latex/base/source2e.ind")
# (find-fline "/tmp/texsrc/latex/base/source2e.ind" "\\put")

cd /tmp/texsrc/latex/base/
grep '{part}' source2e.toc \
  | sed 's/\\hspace {1em}/ /g' \
  | sed 's/\\contentsline {part}{\(.*\)}{\(.*\)}/\2	\1/g'

#





#####
#
# dtx
# 2016may27 / 2020feb01
#
#####

# «dtx» (to ".dtx")
# «dtxtut»  (to ".dtxtut")
# (code-c-d      "dtxtut" "/usr/local/texlive/2019/texmf-dist/doc/latex/dtxtut/")
# (code-pdf-page "dtxtut" "/usr/local/texlive/2019/texmf-dist/doc/latex/dtxtut/dtxtut.pdf")
# (code-pdf-text "dtxtut" "/usr/local/texlive/2019/texmf-dist/doc/latex/dtxtut/dtxtut.pdf")
# (find-dtxtutfile "")
# (find-dtxtutpage)
# (find-dtxtuttext)

# (find-tlfile "texmf-dist/doc/latex/" "dtx")
# (find-tlfile "texmf-dist/doc/latex/dtxgallery/")
# (find-tlfile "texmf-dist/doc/latex/dtxgallery/README")
# (find-tlfile "texmf-dist/doc/latex/dtxtut/")
# (find-tlfile "texmf-dist/doc/latex/dtxtut/README")

# (find-tlsh "find * | sort | grep dtxgen")
# (code-c-d      "dtxgen" "/usr/local/texlive/2019/texmf-dist/doc/support/dtxgen/")
# (code-pdf-page "dtxgen" "/usr/local/texlive/2019/texmf-dist/doc/support/dtxgen/dtxgen.pdf")
# (code-pdf-text "dtxgen" "/usr/local/texlive/2019/texmf-dist/doc/support/dtxgen/dtxgen.pdf")
# (find-dtxgenfile "")
# (find-dtxgenpage)
# (find-dtxgentext)


# Old:
# See: (find-es "tex" "dtx2dvi")
# (find-kopkadaly4page (+ 12 13) "into a single file with extension .dtx")
# (find-kopkadaly4text (+ 12 13) "into a single file with extension .dtx")
# (find-zsh "dmissing dtx")
# (find-fline "/usr/bin/dtxgen")
# (find-fline "/usr/bin/sty2dtx")
# (find-fline    "/usr/share/doc/texlive-doc/support/dtxgen/")
# (find-fline    "/usr/share/doc/texlive-doc/support/dtxgen/README")
# (find-pdf-page "/usr/share/doc/texlive-doc/support/dtxgen/dtxgen.pdf")
# (find-fline    "/usr/share/doc/texlive-doc/support/sty2dtx/")
# (find-fline    "/usr/share/doc/texlive-doc/support/sty2dtx/README.gz")
# (find-pdf-page "/usr/share/doc/texlive-doc/support/sty2dtx/sty2dtx.pdf")





#####
#
# ltxdoc
# 2020nov17
#
#####

# «ltxdoc»  (to ".ltxdoc")
# (find-tlsh "find * | sort | grep ltxdoc")
# (code-pdf-page "ltxdoc" "/usr/local/texlive/2019/texmf-dist/doc/latex-dev/base/ltxdoc.pdf")
# (code-pdf-text "ltxdoc" "/usr/local/texlive/2019/texmf-dist/doc/latex-dev/base/ltxdoc.pdf")
# (find-ltxdocpage)
# (find-ltxdoctext)
# (find-ltxdocpage 4 "8      Old Comments")
# (find-ltxdoctext 4 "8      Old Comments")




#####
#
# DocStrip
# 2016may27
#
#####

# «docstrip» (to ".docstrip")
# (find-kopkadaly4page (+ 12 464) "D.7.1   The DocStrip utility")
# (find-kopkadaly4text (+ 12 464) "D.7.1   The DocStrip utility")

# (find-tlsh "find * | sort | grep docstrip")
# (find-tlfile "texmf-dist/doc/latex/base/"     "docstrip.pdf")
# (find-tlfile "texmf-dist/doc/latex-dev/base/" "docstrip.pdf")
# (code-pdf-page "docstrip" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/docstrip.pdf")
# (code-pdf-text "docstrip" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/docstrip.pdf")
# (find-docstrippage)
# (find-docstriptext)
# (find-docstrippage 2 "extension .ins")
# (find-docstriptext 2 "extension .ins")
# (find-tlsh "find * | sort | grep 'ins$'")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/docstrip/")
rm -Rv /tmp/docstrip/
mkdir  /tmp/docstrip/
cd     /tmp/docstrip/
cp -iv /usr/local/texlive/2019/texmf-dist/source/latex/base/ltmiscen.dtx .

cat > foo.ins <<'%%%'
\input docstrip
\keepsilent
\generate{%
	\file{ltmiscen.sty}{\from{ltmiscen.dtx}{package,latex}}%
}
\endbatchfile
%%%

tex foo.ins
# (find-fline "/tmp/docstrip/")




# (find-fline    "/usr/share/doc/texlive-doc/latex/ecv/docstrip.cfg")

# (find-fline    "/usr/share/texlive/texmf-dist/tex/latex/l3kernel/")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/l3kernel/l3docstrip.pdf")
# (find-fline    "/usr/share/texlive/texmf-dist/tex/latex/l3kernel/l3docstrip.tex")


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/geometry/")
rm -Rv /tmp/geometry/
mkdir  /tmp/geometry/
cd     /tmp/geometry/
cp -iv /usr/local/texlive/2019/texmf-dist/source/latex/geometry/* .
ls -lAF               |& tee ols0
lualatex geometry.ins |& tee olg
ls -lAF               |& tee ols1
lualatex geometry.dtx
lualatex geometry.dtx
ls -lAF               |& tee ols2

# (find-fline "/tmp/geometry/")
# (find-fline "/tmp/geometry/olg")
# (find-fline "/tmp/geometry/olg" "->")
# (find-fline "/tmp/geometry/olg" "-> geometry.sty")





#####
#
# classes.pdf, built from classes.dtx (2017)
# 2017ago09 / 2019may18
#
#####

# «classes» (to ".classes")
# (find-angg ".emacs" "classes")
# (find-classespage 1 "Contents")
# (find-classestext 1 "Contents")

# Old:
# (find-zsh "apt-file search classes")
# (find-zsh "apt-file search classes | grep texlive")
# (find-zsh "apt-file search article | grep texlive")
# (find-zsh "apt-file search article | grep texlive" "/article.cls")
# (find-status   "texlive-latex-base-doc")
# (find-vldifile "texlive-latex-base-doc.list")
# (find-udfile   "texlive-latex-base-doc/")
# (find-fline "/usr/share/doc/texlive-doc/latex/base/")
# (find-fline "/usr/share/doc/texlive-doc/latex/base/" "classes.pdf")





####
#
# typesetting source2e.dvi
# 2004jan27 / 2009aug18
#
####

# «source2e.dvi»  (to ".source2e.dvi")
# (find-angg ".emacs" "source2e")
# (find-zsh "dmissing source2e")
# (find-status   "texlive-latex-base-doc")
# (find-vldifile "texlive-latex-base-doc.list")
# (find-udfile   "texlive-latex-base-doc/")
# http://www.ctan.org/pkg/source2e

# (find-zsh "dmissing texpert.txt")
# (find-lsrcfile "base/manifest.txt")
# (find-lsrcfile "base/texpert.txt" "How to print the LaTeX source")
# (find-lsrcfile "base/texpert.txt" "source2e.tex")
# (find-lsrcfile "base/")

# (code-c-d "latexsrc" "~/usrc/latex/base/")
# (defun find-source2epage (n &rest r) (find-dvipage "~/usrc/latex/base/source2e.dvi" n))
# (find-source2epage (+ 9 487) "Index")
# (find-latexsrcfile "")
#
# Old way:
rm -Rv   ~/usrc/latex/base/
mkdir -p ~/usrc/latex/base/
cd /usr/share/texmf-tetex/source/latex/base/
cp -v *  ~/usrc/latex/base/
cd       ~/usrc/latex/base/

#
# New way:
# http://www.ctan.org/tex-archive/macros/latex/base/
# http://www.ctan.org/get/macros/latex/base.zip
rm -Rv   ~/usrc/latex/base/
mkdir -p ~/usrc/latex/base/
unzip -d ~/usrc/latex/ $S/http/www.ctan.org/get/macros/latex/base.zip
cd       ~/usrc/latex/base/

# (find-source2efile "source2e.tex" "latex source2e.tex")
latex source2e.tex
makeindex -s source2e.ist source2e.idx
makeindex -s gglo.ist -o source2e.gls source2e.glo
latex source2e.tex
latex source2e.tex	|& tee ols
pdflatex source2e.tex   |& tee opls

# «classes.dtx-dvi»  (to ".classes.dtx-dvi")
# (find-angg ".emacs" "classes.dtx")
# Is this the right way?
latex    classes.dtx
latex    classes.dtx    |& tee olc
pdflatex classes.dtx    |& tee oplc

#

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd       ~/usrc/latex/base/
# (code-dvi       "lclasses" "~/usrc/latex/base/classes.dvi")
# (code-pdf-text  "lclasses" "~/usrc/latex/base/classes.pdf")
# (find-lclassespage 1)


# (code-c-d "source2e" "~/usrc/latex/base/")
# (code-dvi       "source2e" "~/usrc/latex/base/source2e.dvi")
# (code-pdf-text  "source2e" "~/usrc/latex/base/source2e.pdf")
# (find-source2efile "")
# (find-source2epage 1)
# (find-source2etext)

# (find-man "1 dvipdf")
# (find-node "(dvips)Option summary")
# dvipdf source2e.dvi source2e.pdf    |& tee odvipdf
#
# dvips: Font tcrm1000 not found, characters will be left blank.
# dvips: Font ecrm1000 at 8000 not found; scaling 600 instead.
# dvips: Such scaling will generate extremely poor output.
# dvips: Font tcbx1000 not found, characters will be left blank.

# (code-c-d "ulsrc" "~/usrc/latex/base/" :xdvi)
# (find-ulsrcxdvi "source2e.dvi")
# (find-ulsrcfile "ltlists.dtx")
# (find-ulsrcxdvi "source2e.dvi" (+ 9 245))

#
# (find-latexsrcfile "source2e.tex" "\\DocInclude{ltdirchk}")
# (find-latexsrcfile "ltxdoc.dtx" "\\section{DocInclude}")
# (find-latexsrcfile "ltxdoc.dtx" "\\section{DocInclude}" "\\thepart=")

#
# Jumping from index entries to source lines
# (find-latexsrcfile "source2e.ind")
# (find-source2epage (+ 9 487) "Index")
# (find-latexsrcfile "source2e.toc")

cd ~/usrc/latex/base/
grep '{part}' source2e.toc | grep hspace | tee .parts0

# (find-latexsrcfile ".parts0")
# \contentsline {part}{a\hspace {1em}ltdirchk.dtx}{1}

lua50e '
  for line in io.lines(".parts0") do
    _, __, c, fname, page = string.find(line, "{part}{(.).-{1em}(.-)}{(.-)}")
    if _ then
      print(string.format("\"%s\" %-14s %3s", c, "\""..fname.."\"", page))
    end
  end
' | tee .parts

#
cd ~/usrc/latex/base/
latex doc.dtx
latex doc.dtx
latex doc.dtx
#
;; (find-latexsrcfile ".parts")




#####
#
# Putting equation numbers in parts of a diagram
# 2004jan28
#
#####

# «equation-numbers»  (to ".equation-numbers")
# (source2e-ind "ttfamily equation")
# (find-source2e "")
# (find-source2e "ltmath.dtx")

\@definecounter{equation}
\def\equation{$$\refstepcounter{equation}}
\def\endequation{\eqno \hbox{\@eqnnum}$$\@ignoretrue}

%
% (eelatex-bounded)
\makeatletter

\begin{equation} a \end{equation}
\begin{equation} b \end{equation}
%
\refstepcounter{equation}
%
\begin{equation} c \end{equation}
$$ d \eqno                 $$
$$ e \eqno \hbox{\@eqnnum} $$
$$ f       \hbox{\@eqnnum} $$
$$ g                       $$
\begin{equation} h \end{equation}

%





#####
#
# more on jumping to source lines in .dtx files
# 2004jan27
#
#####

(find-source2e "doc.dtx")

(find-source2e "doc.dtx" 17)
(find-dvipage (ee-latexsrcfile "doc.dvi") 14)

(find-source2e "doc.dtx" 100)
(find-dvipage (ee-latexsrcfile "doc.dvi") 18)

(find-source2e "doc.dtx" 151)
(find-dvipage (ee-latexsrcfile "doc.dvi") 20)

;; Na linha 152 a gente já se ferra:
;; tem umas linhas "%" começando na margem...
(find-source2e "doc.dtx" 151 "\\begin{macrocode}\n%")
(find-source2e "doc.dtx" 152)
(find-dvipage (ee-latexsrcfile "doc.dvi") 20)

;; Depois ainda tem truques com catcodes:
(find-source2e "doc.dtx" 152 "^^A")
(find-source2e "doc.dtx" 152 "\\catcode`\\%=12")


(find-source2e "doc.dtx" 1 "four spaces between the |%|")
(progn
  (find-latexsrcfile "doc.dtx")
  (ee-isearch-re "%    \\\\\\(begin\\|end\\){macrocode\\*?}\n")
)

# (find-elnode "Selective Display")
# (find-elnode "Invisible Text")









(source2e-tofname "a")
(source2e-tofname "doc.dtx")

# (find-elnode "Regexp Search" "Command: re-search-forward")
# (find-elnode "Regexp Special" "matches only at the end of a line")


(progn
  (find-source2e "doc.dtx" 1)
  (re-search-forward "\n\\([^%]\\|$\\|%<\\)" nil nil 2))

  (find-source2e "doc.dtx" 1)


(= 1 (length "c"))

(defun source2e-file (c) (interactive "sPart: ")
  (let* ((fname (second (member c source2e-parts-list)))
	 (fullfname (ee-latexsrcfile fname)))
    (find-fline fullfname)))

(defun source2e-part (c) (interactive "sPart: ")
  (let* ((page (third (member c source2e-parts-list)))
	 (realpage (+ 9 page))
	 (dvifname (ee-latexsrcfile "source2e.dvi")))
    (find-dvipage dvifname realpage)))

;; (source2e-file "C")
;; (source2e-part "C")





# (find-latexsrcfile "source2e.ind")
# (find-latexsrcfile "")

# (find-latexsrcfile "source2e.aux")
# (find-latexsrcfile "source2e.log")
# (find-latexsrcfile "source2e.tex")





ols

# (find-latexsrcfile "manifest.txt")




# Index:
# (find-lsrcfile "base/source2e.ind")
cd /usr/lib/texmf/source/latex/base/
agrep '\{part\}...hspace' source2e.toc

# Compiling:
cd /usr/lib/texmf/source/latex/base/
latex source2e.tex
makeindex -s source2e.ist source2e.idx
makeindex -s gglo.ist -o source2e.gls source2e.glo
latex source2e.tex
latex source2e.tex	|& tee ols

xdvi /usr/lib/texmf/source/latex/base/source2e.dvi &

# Índice das seções:

# (find-lsrcfile "base/ols")
# (find-pl5pod "var" "undef $/;")
cd /usr/lib/texmf/source/latex/base/
grep -v '^\*' ols | perl -e '
  undef $/; $ols = <STDIN>;
  $i = 0;
  @letras = split(//, " abdefghiklmnopqrstuwyzABCDEFGHIJKLMNO  ");
  # @letras = split(//, " abcdefghijklmnopqrstuwxyzABCDEFGHIJKLMNO  ");
  while ($ols =~ m/\(([a-z0-9.]*)[ \n]\[([0-9]*)\]/g) {
    # print "$1 $2\n";
    printf "%1s %12s %3d\n", $letras[$i++], $1, $2;
  }
' | tee olss

grep 'part.*hspace' source2e.toc
grep 'part.*hspace' source2e.toc | cut -b 22,30,36- |
  perl -nle 'm/^(.*?)\}/ && print $1' | tee oletras






latex classes.dtx

export DISPLAY=:0.0
xdvi /usr/lib/texmf/source/latex/base/source2e.dvi &
xdvi /usr/lib/texmf/source/latex/base/classes.dvi &

# verbatim: p.212=221.
# (find-lsrcfile "base/ltmiscen.dtx" 564)

# (find-fline "/usr/lib/texmf/texmf/tex/plain/base/plain.tex" 42)
# (find-fline "/usr/lib/texmf/texmf/tex/plain/base/plain.tex" 1231)




#####
#
# .dtx -> .dvi in the general case
#
#####

# «dtx2dvi»  (to ".dtx2dvi")
# (find-w3 "/usr/doc/texmf/help/faq/uktug-faq/texfaq_3.html#QU32" ".dtx files")

# (find-lsrcfile "base/docstrip.dtx" 179)
# (find-lsrcfile "base/docstrip.dtx" 932)
# (find-lsrcfile "base/docstrip.ins")
# (find-lsrcfile "base/docstrip.ins" 166)
# (find-lsrcfile "base/doc.dtx" "abstract")
# (find-lsrcfile "base/ltxdoc.dtx" 82)

cd /usr/lib/texmf/source/latex/base/
latex docstrip.ins
makeindex -s docstrip.ist docstrip.aux

cat <<'EOF' | latex |& tee ol
\def\batchfile{keywords.ins}
\input docstrip.tex
\generateFile{keywords.ist}{f}{\from{keywords.dtx}{index}}
\endinput
EOF

# (find-fline "/usr/lib/texmf/source/latex/progkeys/keywords.dtx" 9)
# (find-fline "/usr/lib/texmf/source/latex/progkeys/keywords.dtx" 478)
# (find-fline "/usr/lib/texmf/source/latex/progkeys/Makefile.tetex")
# (find-fline "/usr/lib/texmf/source/latex/progkeys/keywords.ins" 43)
#
cd /usr/lib/texmf/source/latex/progkeys/
#
cat <<'EOF' | latex |& tee ol
\def\batchfile{keywords.ins}
\input docstrip.tex
\generateFile{keywords.drv}{f}{\from{keywords.dtx}{driver}}
\generateFile{keywords.sty}{f}{\from{keywords.dtx}{style}}
\generateFile{keywords.ist}{f}{\from{keywords.dtx}{index}}
\endinput
EOF
#
latex keywords.drv
latex keywords.drv
latex keywords.drv
makeindex -s keywords.ist keywords.idx
latex keywords.drv

# AFAIremember, the general case doesn't work.




#####
#
# babel-2024
# 2024may15
#
#####

# «babel-2024»  (to ".babel-2024")

(code-c-d "babelport" "/usr/local/texlive/2019/texmf-dist/doc/generic/babel-portuges/")
(code-pdf-page "babelport" "/usr/local/texlive/2019/texmf-dist/doc/generic/babel-portuges/portuges.pdf")
(code-pdf-text "babelport" "/usr/local/texlive/2019/texmf-dist/doc/generic/babel-portuges/portuges.pdf")
;; (find-babelportfile "")
;; (find-babelportpage)
;; (find-babelporttext)






#####
#
# Babel: using portuguese
# 2001feb05 / 2015oct23 / 2019jan05
#
#####

# «babel»  (to ".babel")
# (find-angg ".emacs.papers" "babel")
# (find-tlsh "find * | sort | grep babel")
# (find-tlsh "find * | sort | grep babel | grep pdf")
# (find-tlfile "texmf-dist/doc/generic/babel-portuges/" "portuges.pdf")

# https://en.wikibooks.org/wiki/LaTeX/Internationalization
# (to "portug-hyph")

# (find-sh "locate babel")
# (find-zsh "dmissing babel | grep user")
# (find-zsh "dmissing babel | grep texlive")
# (find-sh "apt-file search babel | grep texlive")

# (find-dvipage "/usr/share/doc/tetex-doc/generic/babel/tb1202.dvi.gz")
# (find-dvipage "/usr/share/doc/tetex-doc/generic/babel/tb1401.dvi.gz")
# (find-dvipage "/usr/share/doc/tetex-doc/generic/babel/tb1604.dvi.gz")
# (find-dvipage "/usr/share/doc/tetex-doc/generic/babel/user.dvi.gz")

zxdvi /usr/doc/texmf/generic/babel/user.dvi.gz +20
zxdvi /usr/doc/texmf/generic/babel/tb1202.dvi.gz +5
zxdvi /usr/doc/texmf/generic/babel/tb1401.dvi.gz
zxdvi /usr/doc/texmf/generic/babel/tb1604.dvi.gz

# (find-fline "/etc/texmf/language.dat" "change the active language")
# (find-fline "/usr/share/texmf/tex/generic/babel/")
# (find-fline "/usr/share/doc/texmf/generic/babel/")
# (find-texmfsrcgenfile "babel/")
# (find-texmfsrcgenfile "babel/language.skeleton" "file is read as an option")
# (find-texmfsrcgenfile "babel/babel.dtx" "subsection{Multiple languages}")
# (find-texmfsrcgenfile "babel/portuges.dtx")
# (find-texmfsrcgenfile "babel/portuges.dtx" "Lopt{brazil}")
# (find-texmftexgenfile "babel/portuges.ldf")

# (find-fline "/usr/doc/texmf/generic/babel/")
# (find-fline "/usr/doc/texmf/generic/babel/announce.txt" "otherlanguage")
# (find-angg "LATEX/tese2.sty")

# Example of usage (syntax only, without text to hyphenate):
#
cd /tmp/
cat > tmp.tex <<'---'
\documentclass{book}
\usepackage[cp850]{inputenc}
\usepackage[brazilian,english]{babel}
\begin{document}
...
% Redundant because brazilian is the first option to babel:
\selectlanguage{brazilian}
...
\begin{otherlanguage}{english}
...
\end{otherlanguage}
...
\end{document}
---
latex tmp.tex
#

% 2008nov11
% (find-fline "/usr/share/texmf-texlive/tex/generic/babel/babel.sty")
% (find-fline "/usr/share/texmf-texlive/tex/generic/babel/portuges.ldf")
% (find-fline "/usr/share/texmf-texlive/tex/generic/babel/babel.def")
% (find-fline "/usr/share/texmf-texlive/tex/generic/babel/english.ldf")
% (find-sh "locate hyphen.cfg")
% (find-fline "/usr/share/texmf-texlive/tex/generic/babel/hyphen.cfg")
% (find-kopkadaly4page (+ 12 253) "language.dat")
% (find-kopkadaly4page (+ 12 256) "hyphen.cfg")




#####
#
# polyglossia
# 2019feb14
#
#####

# «polyglossia» (to ".polyglossia")
# (find-angg ".emacs.papers" "polyglossia")
# (find-lshortpage (+ 14 23) "2.5.1 Polyglossia Usage")
# (find-tlsh "find * | sort | grep polyglossia")
# (find-tlsh "find * | sort | grep polyglossia | grep pdf")
# (code-c-d      "polyglossia" "/usr/local/texlive/2019/texmf-dist/doc/latex/polyglossia/")
# (code-pdf-page "polyglossia" "/usr/local/texlive/2019/texmf-dist/doc/latex/polyglossia/polyglossia.pdf")
# (code-pdf-text "polyglossia" "/usr/local/texlive/2019/texmf-dist/doc/latex/polyglossia/polyglossia.pdf")
# (find-polyglossiafile "")
# (find-polyglossiafile "README")
# (find-polyglossiapage)
# (find-polyglossiatext)
# (find-polyglossiapage 4 "\\setdefaultlanguage[options]{lang}")
# (find-polyglossiatext 4 "\\setdefaultlanguage[options]{lang}")
# (find-polyglossiapage 4 "\\setotherlanguage[options]{lang}")
# (find-polyglossiatext 4 "\\setotherlanguage[options]{lang}")
# (find-polyglossiapage 5 "\\begin{greek}")
# (find-polyglossiatext 5 "\\begin{greek}")





#####
#
# Portuguese hyphenation
# 2000oct04 / 2008nov10 / 2010jun16 / 2015oct23
#
#####

# «portug-hyph»  (to ".portug-hyph")
# Allowing portuguese hyphenation:
# (find-fline "/etc/texmf/language.dat" "portuges")
/usr/bin/texconfig init |& tee ~/o
# (find-fline "~/o")

# 2012apr02
# (find-zsh "availabledebs | sort | grep texlive-lang")
# (find-status   "texlive-lang-portuguese")
# (find-vldifile "texlive-lang-portuguese.list")
# (find-udfile   "texlive-lang-portuguese/")
# (find-fline "/etc/texmf/hyphen.d/10texlive-lang-portuguese.cnf")
# (find-fline "/var/lib/tex-common/hyphen-cnf/texlive-lang-portuguese.list")

# 2008nov10:
# (find-sh "locate language.dat")
# (find-fline "/var/lib/texmf/tex/generic/config/language.dat")
# (find-fline "/etc/texmf/language.d/")
# (find-fline "/etc/texmf/language.d/10tetex.cnf" "portuges")
# (find-man "1 update-language")

# (find-sh "locate pt8hyph.tex")
# (find-zsh "dmissing hyph | grep pt")

# Reference?

# 2010jun16:
# (find-zsh "dmissing babel | grep texlive")
# (find-zsh "dmissing babel | grep texlive | grep portug")
# (find-lsrcfile "babelbib/portuguese.bdf")
# (find-udfile "texlive-doc/generic/babel/")
# (find-udfile "texlive-latex-base-doc/generic/babel/")

(code-pdf-page  "babel" "/usr/share/doc/texlive-latex-base-doc/generic/babel/babel.pdf")
(code-pdf-text  "babel" "/usr/share/doc/texlive-latex-base-doc/generic/babel/babel.pdf")
;; (find-babelpage   1  "Contents")
;; (find-babelpage  59  "13 Local language configuration")
;; (find-babelpage 145  "35 The portuguese language")
;; (find-babelpage 362 "Index")
;; (find-babelpage 365 "Index" "\\noextrasportuges")
;; (find-babelpage 366 "Index" "\\selectlanguage")
;; (find-babeltext "")

;; (find-kopkadaly4page (+ 12 254) "Language switching commands")
;; (find-kopkadaly4text (+ 12 254) "Language switching commands")
;; (find-kopkadaly4page (+ 12 254) "\\selectlanguage{language}")
;; (find-kopkadaly4text (+ 12 254) "\\selectlanguage{language}")
;; (find-kopkadaly4page (+ 12 255) "\\noextraslang")
;; (find-kopkadaly4text            "\\noextraslang")
;; (find-kopkadaly4page (+ 12 553) "\\language{num}")
;; (find-kopkadaly4text            "\\language{num}")

# (find-fline "/etc/texmf/")
# (find-fline "/etc/texmf/language.d/09texlive-base.cnf")
# (find-fline "/etc/texmf/language.d/09texlive-base.cnf")
# (find-udfile "" "texlive")

# (find-vldifile "texlive-base.preinst")
# (find-vldish "grep /etc/texmf/ texlive*")
# (find-vldifile "texlive-base.conffiles" "/etc/texmf/language.d/09texlive-base.cnf")


# «texlive-lang»  (to ".texlive-lang")
# (find-man "texconfig")
# (find-sh "locate -i tex-on-debian")
# (find-fline "/usr/share/doc/tex-common/")
# (find-udfile "tex-common/TeX-on-Debian.txt.gz" "texlive-lang-*")
# (find-zsh "availabledebs | sort | grep texlive-lang")

apti texlive-lang-portuguese
# (find-status   "texlive-lang-portuguese")
# (find-vldifile "texlive-lang-portuguese.list")
# (find-udfile   "texlive-lang-portuguese/")
# (find-fline "/etc/texmf/language.d/10texlive-lang-portuguese.cnf")

# Fnaufel recommends this:
# (find-LATEXfile "2009-planodetrabalho.tex" "\\usepackage[brazil]{babel}")



#####
#
# \showhyphens
# 2019jan05
#
#####

# «showhyphens»  (to ".showhyphens")
# (find-texbooktext "\\def\\showhyphens")
# (find-texbooktext "\\showhyphens{ random text }")

# (find-texbookpage (+ 11 455) "several languages in the same paragraph")
# (find-texbooktext            "several languages in the same paragraph")

# (find-angg ".emacs.papers" "babel")
# (find-fline "/usr/share/texmf-texlive/tex/generic/babel/")
# (find-fline "/usr/share/texmf-texlive/tex/generic/babel/portuges.ldf")
# (find-fline "/usr/share/texmf-texlive/tex/generic/babel/portuges.sty")
# (find-fline "/usr/share/texmf-texlive/tex/generic/hyphen/pthyph.tex")
# (find-fline "/usr/share/texmf-texlive/tex/generic/babel/english.ldf")

 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\tracingonline=1\scrollmode
\show\languagename
\makeatletter
\show\l@portuges
\showhyphens{eduardo}
\language=\l@portuges
\show\languagename
\showhyphens{eduardo}
\language=\l@english
\showhyphens{eduardo}




#####
#
# getting a CTAN subdirectory (pstricks)
#
#####

cd $CTAN/graphics/
wget ftp://ftp.rge.com/pub/tex/graphics/pstricks.tar.gz

cd $CTAN/graphics/
rm -Rv pstricks
tar -xvzf pstricks.tar.gz
gzip -dv $(find pstricks)

mkdir -p $CTAN/fonts/
cd       $CTAN/fonts/
wget ftp://ftp.rge.com/pub/tex/fonts/ascii.tar.gz
mkdir -p $CTAN/fonts/utilities/
cd       $CTAN/fonts/utilities/
wget 	ftp://ftp.rge.com/pub/tex/fonts/utilities/a2ac.tar.gz	\
	ftp://ftp.rge.com/pub/tex/fonts/utilities/ega2mf.tar.gz
mkdir -p $CTAN/help/Catalogue/
cd       $CTAN/help/Catalogue/
wget 	ftp://ftp.rge.com/pub/tex/help/Catalogue/catalogue.html.gz	\
	ftp://ftp.rge.com/pub/tex/help/Catalogue/ctfull.html.gz	\
	ftp://ftp.rge.com/pub/tex/help/Catalogue/ctindex.html

ps2mf
mff-29
MF-PS
metafont-for-beginners

moredefs
morehelp
phonet
picins
proofs
pslatex
pstotext
rail
rlepsf
rmpage
rsfs
saferef
schedule
semantic
showlabels
simpsons
smallcap
sobolev
startex
stmaryrd
subeqn
subeqnarray
subfigure
swift
syngen
syntonly
tensor
theorem
thumb
time
times
tipa
titleref
twg-list
typehtml
uniqleaf
varioref
verbatim
word2x
wsuipa
xr
xspace





#####
#
# Proofing a font (old)
#
#####

# (to "gftodvi")

cd /MP
mf cmr10
gftodvi cmr10.2602gf

export DISPLAY=:0.0
xdvi -p 300 cmr10.dvi

# The gray font is broken by default, so
# take a look at missfont.log (on the current directory) and

MakeTeXPK gray 600 600 1+0/600 ljfour

# It is trying to produce a gray font for an "imagen". What is it?

# (find-fline "/usr/lib/texmf/texmf/fonts/source/public/misc/gray.mf")
# (find-fline "/usr/lib/texmf/texmf/ls-R")
# (find-fline "/usr/lib/texmf/texmf/metafont/misc/")
# (find-fline "/usr/lib/texmf/texmf/metafont/misc/modes.mf" 869)
# (find-fline "/usr/bin/MakeTeXPK" 104)
# (find-fline "/usr/lib/texmf/texmf/metafont/misc/modes.mf" 1591)
# (find-fline "/usr/lib/texmf/texmf/metafont/misc/modes.mf" 2303)

(write-heredoc "~/MP/grayljfour.mf")
if mode<>ljfour: errmessage "This file is for ljfour only"; fi
rep=5; boolean large_pixels;
font_identifier "GRAYLJFOUR";
input grayf
EOF

cd ~/MP/
rm /var/lib/texmf/fonts/pk/ljfour/gnu/raleigh/grayljfour.600pk
MakeTeXPK grayljfour 600 600 1+0/600 ljfour

# Quem decide o diretório do pk? E o tfm novo, é sempre escrito? Como
# a fonte vai mudar muito eu quero apagar sempre o tfm velho. Onde ele
# está?




#####
#
# psfrag
#
#####

# (find-fline "/usr/lib/texmf/source/latex/psfrag/announce.txt" "overlay")
# (find-zsh "dmissing psfrag")
# (find-fline "/usr/share/texmf-tetex/source/latex/psfrag/announce.txt")
# (find-fline "/usr/share/texmf-tetex/source/latex/psfrag/pfgguide.tex")




#####
#
# texmf.cfg
# 2017abr16
#
#####

# «texmf.cnf» (to ".texmf.cnf")
# (find-node "(kpathsea)Path sources")
# (find-node "(kpathsea)Config files")

# (find-sh "locate texmf.cnf")
# (find-fline "/usr/share/texmf/web2c/" "texmf.cnf")

# (find-fline "/etc/texmf/web2c/" "texmf.cnf")
# (find-fline "/usr/share/texlive/texmf-dist/web2c/" "texmf.cnf")
# (find-fline "/usr/share/texmf/web2c/" "texmf.cnf")





#####
#
# Kpathsea search
# 2004jan21
#
#####

# «kpathsea»  (to ".kpathsea")
# (find-angg "LATEX/dout/")
# (find-angg "LATEX/dout/Makefile")

# (find-node "(kpathsea)Default expansion")
# (find-node "(kpathsea)Top")
# (find-node "(kpathsea)Slow path searching")
# (find-node "(kpathsea)Debugging")
# (find-node "(kpathsea)Debugging" "KPATHSEA_DEBUG")
# (find-node "(kpathsea)Filename database")

# (find-fline "/usr/share/texmf/web2c/" "texmf.cnf")
# (find-fline "/etc/texmf/texmf.cnf")

# How can I make emacs use kpathsea to get the full path for a filename?
# (find-sh  "kpsewhich --help")
# (find-sh0 "kpsewhich -n tex tex epsf.tex")
# (find-sh "KPATHSEA_DEBUG=-1 kpsewhich -n tex tex epsf.tex")
# (find-sh "KPATHSEA_DEBUG=63 kpsewhich -n tex tex epsf.tex")





#####
#
# kpathsea debugging
#
#####

# (find-node "(kpathsea)Debugging")
# TeX finds the lilypond .texs but LaTeX doesn't.
#
export KPATHSEA_DEBUG=63
tex '\input lilyponddefs'   |& tee ot
latex '\input lilyponddefs' |& tee ol
#
# I guess the .texs are being installed at the wrong place (in my system).
#
# kdebug:  before expansion = $KPSE_DOT:$TEXMFS/tex{/plain,/generic,}//
# kdebug:  before expansion = $KPSE_DOT:$TEXMFS/tex/{latex,latex209,generic}//
#
# (find-fline "/usr/lib/texmf/texmf.cnf" 62)

Eu copiei o diretório /usr/lib/texmf/texmf/..lily.. para um lugar
acessivel pelo latex e rehasheei.

(find-lilyfile "bin/make-website.pl")
(find-lilyfile "bin/out/make-website" 88)
(find-lilyfile "bin/out/make-website" 114)
(find-lilyfile "bin/out/make-website" 157)
(find-lilyfile "input/wtk1-fugue2.ly")
(find-lilyfile "input/wtk1-fugue2.ly")
(find-lilyfile "Documentation/out/wtk1-fugue2.ly.txt")





#########
#
# ega2mf
#
#########

cd /usr/src/
rm -Rv ega2mf
tar -xvzf $CTAN/fonts/utilities/ega2mf.tar.gz
cd ega2mf
gzip -dv *
gcc -o ega2mf ega2mf.c
gcc -o vga2mf vga2mf.c

# (find-fline "/c5/home/BUP/PROgLOJA/vga437t.mf")
# (find-fline "/c5/home/BUP/PROgLOJA/vga437t0.mf")
# (find-fline "/c5/home/BUP/PROgLOJA/vga850.mf")
# (find-fline "/c5/home/BUP/PROgLOJA/vgasqdot.mf")

# Name of the .gf file: <jobname>.<resolution>gf; MFbook p.324, MFprog
# block 1164.
#
# p.277 (find-knuthfile "mf/mfbook.tex" "|screenchars|.")
# (find-fline "/usr/lib/texmf/texmf/metafont/base/plain.mf" "z@#")

## Eu modifiquei o vga2mf à beça, ele não tem mais pickups, usa chars
## 8x8 e isso é o header novo:

% This is vga850.mf generated by vga8tomf from /home/replace/ega1.8.
if unknown cmbase: input cmbase fi
mode_setup;
def generate suffix t= enddef;
input cmtt10; font_setup;
if ligs>1: font_coding_scheme:="TeX text";
else: font_coding_scheme:=if ligs=0: "TeX typewriter text"
  else: "TeX text without f-ligatures" fi; fi

def corner(expr row,col) =
  ((col/8)[0, 9u],
   (row/8)[body_height, -desc_depth])
enddef;
def crt(expr row,col) =
  numeric x[],y[];
  z0=corner(row,col);
  z1=corner(row+1,col+1);
  fill (x0,y0)--(x0,y1)--(x1,y1)--(x1,y0)--cycle;
enddef;

## Todas as outras coisas importantes foram parar dentro de uma
## Makefile:

SRCDIR = /usr/lib/texmf/texmf/fonts/source/vga
PKDIR  = /var/lib/texmf/fonts/pk/ljfour/unknown/unknown
PK600  = $(PKDIR)/vga850.600pk

vga8tomf: vga8tomf.c
	gcc -o vga8tomf vga8tomf.c

vga850.mf: vga8tomf
	vga8tomf /home/replace/ega1.8 vga850.mf

font0:
	-rm -Rv  $(SRCDIR)
	-mkdir -p $(SRCDIR)
	cd       $(SRCDIR)/
	#
	-rm -v $(SRCDIR)/vga850.mf
	-ln -s ~/LATEX/vga850.mf $(SRCDIR)/vga850.mf
	texhash

fonttfm:
	-rm -Rv /usr/lib/texmf/texmf/fonts/tfm/public/vga
	-mkdir  /usr/lib/texmf/texmf/fonts/tfm/public/vga
	-rm -v  /var/lib/texmf/fonts/tfm/unknown/unknown/vga850.tfm
	MakeTeXTFM vga850

clearpks:
	-rm -v $(PKDIR)/vga850*pk

btype:
	mf '\mode:=ljfour; mag:=1; scrollmode; input vga850b'
	gftype -i vga850b.600gf

$(PK600): vga850.mf
	-rm -v $(PK600)
	MakeTeXPK vga850 600 600 1.0

font600: $(PK600)

##
##

# (find-fline "/usr/lib/texmf/texmf/fonts/source/vga/vga850.mf")
# (find-fline "~/LATEX/vga850.mf")
# (find-fline "$CTAN/systems/knuth/mf/mfbook.tex" "^@beginchar@")





######
#
# stmaryrd
# 2000oct01 / 2013aug20 / 2017set23
#
######

#
# «stmaryrd»  (to ".stmaryrd")
# (find-angg ".emacs.papers" "stmaryrd")
# (find-tlsh "find * | sort | grep stmaryrd")
# (code-c-d      "stmaryrd" "/usr/local/texlive/2019/texmf-dist/doc/fonts/stmaryrd/")
# (code-pdf-page "stmaryrd" "/usr/local/texlive/2019/texmf-dist/doc/fonts/stmaryrd/stmaryrd.pdf")
# (code-pdf-text "stmaryrd" "/usr/local/texlive/2019/texmf-dist/doc/fonts/stmaryrd/stmaryrd.pdf")
# (find-stmaryrdfile "")
# (find-stmaryrdpage)
# (find-stmaryrdtext)

# (find-zsh "dmissing stmaryrd")
# (find-status   "texlive-math-extra")
# (find-vldifile "texlive-math-extra.list")
# (find-udfile   "texlive-math-extra/")
# (find-sh "locate stmaryrd")


# (find-status "tetex-nonfree")
# (find-vldifile "tetex-nonfree.list")
# (find-vldifile "tetex-nonfree.list" "stmary")
# (find-fline "/usr/doc/tetex-nonfree/")
# (find-fline "/usr/share/texmf/tex/latex/misc/stmaryrd.sty")
# (find-fline "/usr/share/texmf/tex/latex/misc/stmaryrd.sty" "bindnasrepma")

cd /usr/share/doc/texmf/latex/styles/
zcat stmaryrd.dvi.gz > /tmp/stmaryrd.dvi
xdvi /tmp/stmaryrd.dvi &

#
# 2006sep24:
# (find-zsh "dmissing stmaryrd")
# (find-dvipage "/usr/share/doc/tetex-doc/latex/stmaryrd/stmaryrd.dvi.gz")
# (find-dvipage "/usr/share/doc/texlive-doc/fonts/stmaryrd/stmaryrd.dvi.gz")
# (find-dvipage "/usr/share/doc/texlive-math-extra/fonts/stmaryrd/stmaryrd.dvi.gz")
# (find-status   "tetex-extra")
# (find-vldifile "tetex-extra.list")
# (find-udfile   "tetex-extra/")
# (find-fline "/usr/share/texmf-tetex/source/latex/stmaryrd/stmaryrd.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/stmaryrd/stmaryrd.sty")
# (find-fline "/usr/share/texmf-texlive/tex/latex/stmaryrd/stmaryrd.sty")
# (find-fline "/usr/share/texmf-texlive/tex/latex/stmaryrd/stmaryrd.sty" "\\llbracket")
# (find-texbookpage (+ 11 469))
# (find-texbookpage (+ 11 292) "\\left<delim>")




#####
#
# \bye
# 2023feb12
#
#####

# «bye»  (to ".bye")
# (find-texbookpage (+ 12 357) "\\def\\bye")
# (find-texbooktext (+ 12 357) "\\def\\bye")



#####
#
# testfont
# 2000oct01
#
#####

# «testfont»  (to ".testfont")
# First a quick way to get descriptions for many chars:
cd /usr/share/texmf/fonts/source/
agrep cmchar $(find * -name '*.mf') | tee ~/o
# (find-fline "~/o")
# (find-fline "~/o" "linear logic")

#
# Now testfont itself.
# (find-knuthfile "mf/mfbook.tex" "The last line of |testfont| is")
# (find-fline "/usr/share/texmf/tex/plain/base/testfont.tex")

cat > $EEG <<'---'
\let\noinit! \input testfont.tex
\def\fontname{bbmbx10}\startfont\table
\def\fontname{stmary10}\startfont\table
\def\fontname{msam10}\startfont\table
\bye
---
cd /tmp/
eeg tex
xdvi testfont.dvi &
#

cd /tmp/
tex '\let\noinit! \input testfont.tex'\
    '\def\fontname{bbmbx10}\startfont\table'\
    '\def\fontname{stmary10}\startfont\table'\
    '\def\fontname{msam10}\startfont\table'\
    '\bye'
xdvi testfont.dvi &
#

cd /tmp/
tex '\let\noinit! \input testfont.tex'\
    '\def\Test#1{\def\fontname{#1}\startfont\table}'\
    '\Test{bbmbx10}'\
    '\Test{stmary10}'\
    '\Test{msam10}'\
    '\bye'
xdvi testfont.dvi &

#
# «testfontcmds»  (to ".testfontcmds")
# (find-angg ".zshrc" "testfontcmds")

function testfontcmds () {
  echo -nE '\let\noinit! \input testfont.tex'
  for i in $*; do
    echo -nE '\def\fontname{'$i'}\startfont\table'
  done
  echo -E '\bye'
}
cd /tmp/
tex "$(testfontcmds bbmbx10 stmary10)"

#
tex "$(testfontcmds wasy10 ccmi10)"; rexdvi /tmp/testfont.dvi
testfont wasy10 ccmi10

testfont xccam10 xccbm10 xccex10 xccmi10 xccsy10 cccsc10 ccmi10 \
  ccmic9 ccr10 ccsl10 ccslc9 ccti10




#####
#
# testfont.tex (another approach)
# 2008jun21
#
#####

# «testfont.tex»  (to ".testfont.tex")
# (find-angg ".emacs" "find-testfont")
# (find-mfbookpage (+ 13 336))
# (find-mfbookfile "mfbook.tex" "testfont.tex")
# (find-mfbooktext "testfont.tex ")
# (find-plainsrcfile "testfont.tex")

 (eepitch-tex)
 (eepitch-kill)
 (eepitch-tex)
\let\noinit!
\input testfont
\def\Test#1{\def\fontname{#1}\startfont\table}
\def\newpage{\vfill\break}
\Test{bbm10}
\newpage
\Test{bbold10}
\bye

# (find-dvipage "/tmp/texput.dvi")
# (find-efunction 'eev)



function dvifonts-l () { dvitype -output-level=1 $1 | grep fntdef }
function dvifonts () { dvifonts-l $* | cut -d' ' -f 4- }


  (eev eelatex-eevscript nil)
  (format "eelatex: wrote %s and %s" ee-file-tex ee-file))


  (ee-write-with-nl s e "" "" altfile)





#####
#
# gftype
# 2000oct01
#
#####

# «gftype»  (to ".gftype")
# (eeman "gftype")
# With "-i" gftype will show the bitmaps for the font (in ascii)!
#

cd /tmp/
mf '\mode:=ljfour; mag:=1/2; nonstopmode; input stmary10'
gftype -i stmary10.300gf > o
# (find-fline "/tmp/o")
#

# (find-fline "/etc/texmf/modes.mf" "one pixel one point")





#####
#
# gftodvi
# 2000oct01
#
#####

# «gftodvi»  (to ".gftodvi")
# (eeman "gftodvi")
# (find-knuthfile "mf/mfbook.tex" "beginchapter Appendix H. Hardcopy Proofs")
# But by doing like this we still don't get labels:
#
cd /tmp/
mf '\mode:=ljfour; mag:=4; nonstopmode; input stmary10'
gftodvi stmary10.2400gf
xdvi    stmary10.dvi &

cd /tmp/
mf '\mode:=ljfour; mag:=4; nonstopmode; input cmr10'
gftodvi cmr10.2400gf
xdvi    cmr10.dvi &

#
# (find-knuthfile "mf/mfbook.tex" "proofing:=2")
# Just setting "proofing" doesn't change much:
cd /tmp/
mf '\mode:=ljfour; mag:=4; proofing:=2; nonstopmode; input cmr10'
gftodvi cmr10.2400gf
xdvi    cmr10.dvi &

# By using "mode:=proof" we get everything: labels, equations and grids.
cd /tmp/
mf '\mode:=proof; nonstopmode; input stmary10'
gftodvi stmary10.2602gf
xdvi    stmary10.dvi &
#


# How do I make mf (i.e., mfw) display every char?
# (find-knuthfile "mf/mfbook.tex" "if displaying>0:")





#####
#
# blackboard bold and rsfs
# 2000oct07 / 2008mar04
#
#####

# «bbold_and_rsfs»  (to ".bbold_and_rsfs")
# (find-dn4ex "edrx08.sty" "bbold")
# (find-symbolspage 46)
# (find-fline "/usr/share/texmf-tetex/tex/latex/amsfonts/amsfonts.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/amsmath/amstex.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/bbm/bbm.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/bbold/bbold.sty")
# (find-angg ".zshrc" "testfontcmds")
# (find-zsh0 "cd /tmp/; tex \"$(testfontcmds bbm10 bbold10)\"")
# (find-dvipage "/tmp/testfont.dvi")

cd /usr/lib/texmf/fonts
find | grep bb

#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
tex '\let\noinit! \input testfont.tex'\
    '\def\Test#1{\def\fontname{#1}\startfont\table}'\
    '\Test{bbm10}'\
    '\Test{bbold10}'\
    '\Test{bbmbx10}'\
    '\Test{rsfs10}'\
    '\bye'
x
xdvi testfont.dvi
#

# (find-fline "/usr/share/texmf/doc/latex/jknappen/")
# (find-fline "/usr/share/texmf/doc/latex/jknappen/mathbbol.rme")
# (find-fline "/usr/share/texmf/doc/latex/jknappen/mathrsfs.rme")
# (find-fline "/usr/share/texmf/fonts/source/jknappen/sauter/")
# (find-fline "/usr/share/texmf/tex/latex/jknappen/")
# (find-fline "/usr/share/texmf/fonts/source/public/bbold/")
# (find-fline "/usr/share/texmf/tex/latex/misc/bbold.sty")
# (find-fline "/usr/share/texmf/source/latex/bbm/")
# (find-fline "/usr/share/texmf/source/latex/bbm/bbm.dtx")
# (find-fline "/usr/share/texmf/tex/latex/bbm/")

cd /usr/lib/texmf/
find * -type f | sort > .files
agrep -i 'blackboard bold' $(grep dtx .files)

# (find-fline "/usr/share/texmf/source/latex/amsfonts/amsfonts.dtx")
# (find-fline "/usr/share/texmf/source/latex/amsfonts/euscript.dtx")
# (find-fline "/usr/share/texmf/source/latex/psnfss/mathtime.dtx")

# (find-fline "$SCTAN/systems/knuth/tex/texbook.tex" 25862)

#
cd /tmp/
cat > bb.tex <<'---'
\nonstopmode\tracingonline1\makeatletter
\documentclass{book}
\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{mathrsfs}
\begin{document}
$\mathbb{RIC}\mathscr{ABCDEFGHIJKLMNOPQRSTUVWXYZ}$
\show\mathbb
\end{document}
---
latex bb.tex
dvifonts bb.dvi
#
xdvi /tmp/testfont.dvi
#





######
#
# 720dpi fonts
#
######

# (find-fline "/var/spool/texmf/")
# (find-fline "/var/spool/texmf/ls-R")

# (find-fline "/var/spool/texmf/pk/cx/")
# (find-fline "/var/spool/texmf/pk/cx/public/cm/")
# (find-fline "/var/spool/texmf/pk/ljfour/public/cm/")

rm /var/spool/texmf/pk/cx/public/cm/cmr10.300pk
rm /var/spool/texmf/pk/ljfour/public/cm/cmr10.600pk

rm /var/spool/texmf/pk/ljfour/public/cm/cmr10.600pk
cd ~/LATEX/
strace-to ~/s xdvi -geometry +240+0  99feb11.dvi |& tee ~/o

cut -b 7- ~/s | sort | uniq
cut -b 7- ~/s | sort | uniq | getstrings | sort | uniq |& tee ~/o2
find $(grep '^/' ~/o2) -type f -maxdepth 0 > ~/o3
agrep -l ljfour $(<~/o3)

# (find-fline "/usr/bin/mktexpk" "ljfour")
# (find-fline "/usr/lib/texmf/web2c/mf.base")

/etc/texmf/modes.mf
/usr/lib/texmf/metafont/misc/modes.mf

# (find-node "(kpathsea)Top")
# (find-node "(kpathsea)mktex configuration")

# (find-fline "/var/spool/texmf/pk/cx/")
/usr/lib/texmf/web2c/texmf.cnf


agrep ljfour $(locate mktex)

# (find-fline "/etc/texmf/mktex.cnf")
# (find-fline "/usr/bin/mktexlsr")
# (find-fline "/usr/bin/mktexmf")
# (find-fline "/usr/bin/mktexpk")
# (find-fline "/usr/bin/mktextfm")
# (find-fline "/usr/lib/texmf/web2c/mktex.cnf")
# (find-fline "/usr/lib/texmf/web2c/mktex.opt" "ljfour")
# (find-fline "/usr/lib/texmf/web2c/mktexdir")
# (find-fline "/usr/lib/texmf/web2c/mktexdir.opt")
# (find-fline "/usr/lib/texmf/web2c/mktexnam")
# (find-fline "/usr/lib/texmf/web2c/mktexnam.opt")
# (find-fline "/usr/lib/texmf/web2c/mktexupd")


# (find-node "(bash)Bourne Shell Builtins" "`:'")
# (find-node "(bash)Shell Parameter Expansion")




kpathsea: Running mktexpk --mfmode ljfour --bdpi 600 --mag 1+0/600 --dpi 600 cmr10
mktexpk: Running mf \mode:=ljfour; mag:=1+0/600; nonstopmode; input cmr10


kpathsea: Running mktexpk --mfmode / --bdpi 720 --mag 1+0/720 --dpi 720 cmr10
mktexpk: Mismatched mode ljfour and resolution 720; ignoring mode.
mktexpk: Can't guess mode for 720 dpi devices.
mktexpk: Use a config file, or update me.
kpathsea: Appending font creation commands to missfont.log.
dvips: Font cmr10 at 720 not found; scaling 600 instead.
dvips: Such scaling will generate extremely poor output.




#####
#
# ctan mirrors
#
#####

# (find-fline "/usr/doc/texmf/help/ctan/CTAN.sites.gz")

mynetselect $(
  gzip -cd /usr/doc/texmf/help/ctan/CTAN.sites.gz |
    grep '^  [a-z]' |
    awk '{print tolower($1)}'
)

# (find-fline "~/o2")


# Para FCTAN=ftp://ctan.tug.org/tex-archive :
psne $FCTAN/ls-lR.gz
#
cd $SCTAN
gzip -dv ls-lR.gz
~/ICON/lslR2find -1 < ls-lR | cut -b0-8,21- > ls-lR.i

# (find-fline "$SCTAN/ls-lR.i")

psne $FCTAN/macros/tip.tgz
cd $SCTAN/macros/
tar -xvzf tip.tgz




#####
#
# TeX in practice
# 99nov01
#
#####

# «tip»
# (code-c-d "tip" "$SCTAN/macros/tip/")
# (find-tipfile "" "boxing")
#
# (find-tipfile "boxing7.tip")
# (find-tipfile "boxing6.tip")
# (find-tipfile "box-zero.tip")
# (find-tipfile "boxing5.tip")
# (find-tipfile "box-bul.tip")
# (find-tipfile "box-bb.tip")
# (find-tipfile "box-thck.tip")
# (find-tipfile "vcentx.tip")

# (find-tipfile "inputd.tip")

#
cd $SCTAN/macros/tip/
cp -v boxing7.tip boxing6.tip box-zero.tip boxing5.tip box-bul.tip \
  box-bb.tip box-thck.tip vcentx.tip ~/LATEX/

cd $SCTAN/macros/tip/
zip /tmp/tip.zip boxing7.tip boxing6.tip box-zero.tip boxing5.tip \
  box-bul.tip box-bb.tip box-thck.tip vcentx.tip
laf /tmp/tip.zip

#
cd ~/LATEX/
cat > tmp.tex <<'---'
\def\wlog#1{}
\def\InputD#1{\input #1}
\input boxing7.tip

a\HboxR{bcd}e
\bye
---
tex tmp.tex
xdvi -s 2 tmp.dvi
#





#####
#
# ethiop
#
#####

# (find-available "ethiop")
# (find-vldifile "ethiop.list")
# (find-fline "/usr/doc/ethiop/")

cd /usr/doc/ethiop/
gzip -dv *
latex ethiodoc.tex
latex ethiodoc.tex
latex ethiodoc.tex
xdvi ethiodoc.dvi



#####
#
# arabtex
# 2001oct23
#
#####

# «arabtex»  (to ".arabtex")
# (find-available "perspic-texts")
# (find-available "arabtex")

# (find-status "arabtex")
# (find-vldifile "arabtex.list")
# (find-fline "/usr/doc/arabtex/")

# (code-c-d "arabtexdoc" "/usr/share/doc/texmf/arabtex/")
# (code-c-d "arabtexdoc" "/tmp/arabtex-doc/")
# (find-arabtexdocfile "")

#
rm -Rv /tmp/arabtex-doc/
mkdir  /tmp/arabtex-doc/
cp -iv /usr/share/doc/texmf/arabtex/* /tmp/arabtex-doc/
cd     /tmp/arabtex-doc/
gzip -dv *.gz
latex arabdoc.tex	|& tee ol

#
# (find-dvipage "/tmp/arabtex-doc/arabdoc.dvi" (+ 2 36))
# (find-arabtexdocfile "")
# (find-arabtexdocfile "arabdocd.tex")
# (find-arabtexdocfile "arabdoce.tex")

cd /tmp/arabtex-doc/
xdvi +38 arabdoc.dvi &
#





#####
#
# The pic manual
#
#####

# «pic_manual»  (to ".pic_manual")

gv $S/http/cm.bell-labs.com/cm/cs/cstr/116.ps
# But gv is not happy...
# (find-es "ps" "gv_psheaders")

# (find-fline "$S/http/cm.bell-labs.com/cm/cs/cstr/116.ps")
# (find-node "(gawk)If Statement")

(
echo "116.ps:\n"
awk '{if ($0 ~ /^%/) {print $0; c=0} else {if (c==0) {print ""; c=1}}}' \
  < $S/http/cm.bell-labs.com/cm/cs/cstr/116.ps
# echo "\n\n\ntmp.ps:\n"
# awk '{if ($0 ~ /^%/) {print $0; c=0} else {if (c==0) {print ""; c=1}}}' \
#   < ~/LATEX/tmp.ps
) > ~/o

# (find-fline "~/o")

# (find-fline "$S/http/cm.bell-labs.com/cm/cs/cstr/116.ps" "%%Page: 14 16")



pstotext $S/http/cm.bell-labs.com/cm/cs/cstr/116.ps \
  | tr "<inverted !>" - | tee ~/o

# (find-es "ps" "pstotext")
# (find-es "ps" "pstotext")

# Incomplete output.
# (find-es "ps" "pstotext")





#####
#
# Gothic fonts
# 99oct24
#
#####

# (find-fline "/usr/lib/texmf/tex/latex/amsfonts/eufrak.sty")





#####
#
# Tese do Max
#
#####

# «tese_do_max»

rm -Rv /tmp/thesis*
cd /tmp/
tar -xvzf ~/tese-max.tgz

cd /tmp/thesis/
latex thesis.tex	|& tee olt
# latex thesis.tex
# latex thesis.tex

(cd /tmp/thesis/; xdvi /tmp/thesis/thesis.dvi &)

# (find-fline "/tmp/thesis/")
# (find-fline "/tmp/thesis/")




#####
#
# TeX ruler (to estimate dims with xdvi)
#
#####

# (find-zsh "dmissing tex-ruler")
# (find-zsh "dmissing /ruler")
# (find-zsh "dmissing /ruler | grep tex")
# http://www.ntg.nl/doc/eijkhout/ruler.pdf
# http://ftp.sayclub.com/pub/CTAN/macros/generic/misc/ruler.tex
xdvi $S/http/www.loria.fr/services/tex/divers/tex-ruler.dvi &





######
#
# tex -> png
# 99nov06
#
######

# «tex2png»

# (find-fline "~/LATEX/Makefile")
# (find-es "music" "ps_to_png")





#####
#
# Hunting ps fonts (for certain calligraphic chars)
# 99nov16
#
#####

# «hunting_ps_fonts»
# «rsfs»

# (find-es "tex" "testfont")
# (find-fline "~/.zshrc" "dvifonts")
# (find-lsrcfile "psnfss/")
# (find-lsrcfile "psnfss/mathtime.dtx")
# (find-lsrcfile "psnfss/mathtest.tex")

cd /usr/lib/texmf/source/latex/psnfss/
latex mathtest
xdvi mathtest.dvi &

cd /usr/lib/texmf/source/latex/psnfss/
dvifonts mathtest.dvi

cd /tmp/
tex '\let\noinit! \input testfont.tex'\
    '\def\Test#1{\def\fontname{#1}\startfont\table}'\
    '\Test{ectt1000}'\
    '\Test{ptmb7t}'\
    '\Test{ptmb8t}'\
    '\Test{ptmr8t}'\
    '\Test{ptmri8t}'\
    '\Test{zptmcm7m}'\
    '\Test{zptmcm7t}'\
    '\Test{zptmcm7v}'\
    '\Test{zptmcm7y}'\
    '\bye'
dvips -o testfont.ps testfont.dvi
regv testfont.ps

# xdvi testfont.dvi &

dtxagrep ptm
locate zptmcm

# (find-fline "/usr/lib/texmf/fonts/vf/adobe/mathptmx/zptmcm7y.vf")
# (eeman "vftovp")

cp /usr/lib/texmf/fonts/vf/adobe/mathptmx/zptmcm7y.vf /tmp/
cp /usr/lib/texmf/fonts/tfm/adobe/mathptmx/zptmcm7y.tfm /tmp/
cd /tmp/
vftovp zptmcm7y > o

# (find-fline "/tmp/o")
# There's a mention to the "rsfs" encoding, and rsfs sounds familiar...
# So,

dtxagrep rsfs
# (find-fline "/usr/lib/texmf/source/latex/jknappen/mathrsfs.rme")
# (find-fline "/usr/lib/texmf/source/latex/jknappen/mathrsfs.sty")
# (find-fline "/usr/lib/texmf/source/latex/jknappen/ursfs.fd")

# The trick is to put a \usepackage{mathrsfs} in the preamble and use
# things like \mathscr{ABCDE} in the body of the text.





#####
#
# Patrick Lincoln's linear logic "par" macro
# 99sep??
#
#####

# «upside_down_ampersand»

# (find-fline "$S/ftp/ftp.csl.sri.com/pub/linear/mailing-list-traffic/18.summary" "\\draw package")





#####
#
# \edrxnotes
# 00jan19
#
#####

# «edrxnotes»

# 00jan19: moved the script below to my .zshrc. Now I can use
# "savetmptex" insted of "/tmp/save". See:
# (find-angg ".zshrc" "savetmptex")
# (find-angg ".emacs" "eelatex")

# (find-node "(zsh)Conditional Expressions")
# (find-fline "~/LATEX/tese2.sty" "\\def\\edrxnotes#1")
# (find-angg "eev.el" "eelatex")

cat > /tmp/save <<'---'
i=$(perl -nle 'm/^\\edrxnotes{([!-~]+)}/ && print $1' < tmp.tex)
if [[ -n $i ]]; then
  echo $i.tex
  sed -e "s/^\\\\input tmp.dnt/\\\\input $i.auto.dnt/" < tmp.tex > $i.tex
fi
---

# First, run the block above to create the script /tmp/save; then,
# instead of doing just "ee" to run LaTeX on a block saved with f3,
# do:
#
#   ee; . /tmp/save
#
# if the LaTeXable block had a line like "\edrxnotes{xxx}" then
# tmp.tex will be copied to xxx.tex; if it had a "\input tmp.dnt" then
# it will be changed to "\input xxx.auto.dnt".



# (find-es "emacs" "saving_emacs_macros")
# (load-library "edmacro")
# (insert-kbd-macro (make-symbol ""))

(setq last-kbd-macro
  (read-kbd-macro "<<search-forward>> edrxnotes RET <f3>"))

# Only use the macro below if you have two windows and the other one
# is a shell buffer...

(setq last-kbd-macro
  (read-kbd-macro "<<search-forward>> edrxnotes RET <f3>
      C-x o ee; SPC . SPC /tmp/save RET C-x o"))


# «edrxnotes-makefile»
# (find-angg "LATEX/Makefile" "edrxnotes")
#
cd ~/LATEX/
export A=""
echo -n .INTERMEDIATE: > ~/o2
echo -n edrxnotes: > ~/o3
# for i in [0-9]*.tex tp-*.tex tesemestr.tex slidesmestr.tex; do
# for i in [0-9]*.tex; do
for i in *.tex; do
  j=$(basename $i .tex)
  echo -n " $j.dvi" >> ~/o3
  if grep "input $j.auto.dnt" $i > /dev/null; then
    echo $j.dvi: $j.tex $j.auto.dnt
    echo -n " $j.auto.dnt" >> ~/o2
  else
    echo $j.dvi: $j.tex
  fi
done |& tee ~/o
(echo 'ifeq ($(KEEPAUX),)'
 cat ~/o2; echo
 echo 'endif'
 echo; cat ~/o; echo; cat ~/o3) | tee ~/o4

# (find-fline "~/o4")

echo '# (find-es "tex" "edrxnotes-makefile")' > ~/LATEX/Makefile.auto
cat ~/o4 >> ~/LATEX/Makefile.auto
# (find-fline "~/LATEX/Makefile.auto")
#




#####
#
# Leo Moura's PIC examples
# 00jan24
#
#####

# «leo_moura_pic»

# (find-fline "~/99oct26.pucmail" "eevP")

cd /tmp/
rm -fv 7 instrs examples.tar.gz
expect -c '
  spawn mail -f ~/99oct26.pucmail
  send "s7 7\rx\r"
  interact
  spawn metamail -r -w -q 7
  send "instrs\r\r"
  interact
'
rm -fv mm.a00*

rm -Rv /tmp/pic
mkdir /tmp/pic
cd /tmp/pic/
tar -xvzf /tmp/examples.tar.gz

tr -d \\r < eev.el > eev0.el
mv eev0.el eev.el

# (find-fline "/tmp/pic/")
# (find-fline "/tmp/pic/eev.el")

rm -v Makefile~
rm -v abs_tree_fatorial.tex
rm -v comp_tree_range_1.tex
rm -v eev.el
rm -v eev.el~
rm -v gravelSFC.tex
rm -v test.tex~

tar -cvzf /tmp/examples0.tar.gz *
laf	  /tmp/examples*gz

cd /tmp/pic/
make	|& tee om

# (find-fline "/tmp/instrs")
# (find-fline "/tmp/pic/")
# (find-fline "/tmp/pic/Makefile")
# (find-fline "/tmp/pic/test.tex")
# (find-fline "/tmp/pic/gravelSFC.pic")
# (find-fline "/tmp/pic/abs_tree_fatorial.pic")
# (find-fline "/tmp/pic/comp_tree_range_1.pic")
# (find-fline "/tmp/pic/sfc.pic")




#####
#
# Leo Moura's extensions to eev.el
# 00jan24
#
#####

# «leo_moura_eev»  (to ".leo_moura_eev")

# (find-fline "~/99oct26.pucmail" "eevP")
# (find-etag "file-name-sans-extension")

(defun se-to-string-without-comments (s e char)
  (let ((currpos) (content))
	(save-excursion
	  (setq currpos s)
	  (setq content "")
	  (while (< currpos e)
		(goto-char currpos)
		(beginning-of-line)
		(while (eq (char-after (point)) (string-to-char char))
		  (forward-char))
		(setq currpos (point))
		(end-of-line)
		(setq content (concat content (buffer-substring
					       currpos (point)) "\n"))
		(next-line 1)
		(setq currpos (point)))
	  content)))

(defun tst-se-to-string-without-comments (s e)
  (interactive "r")
  (insert (se-to-string-without-comments s e ";")))

(defun write-ee-without-comments
  (s e comment-char pre post &optional other-ee-file fmode)
  (write-ee-string (concat pre (se-to-string-without-comments
				s e comment-char)
			   post)

;;

(defun eevP (s e &optional other-ee-file) (interactive "r")
  (write-ee-without-comments s e "%" "set -v\n" "\nset +v" other-ee-file)
  (shell-command ". ~/bin/emacs.ee &")
  )             ; zsh/bash

(defun eevB (s e &optional other-ee-file) (interactive "r")
  (write-ee-without-comments s e "/" "set -v\n" "\nset +v" other-ee-file)
  (shell-command ". ~/bin/emacs.ee &")
  )             ; zsh/bash

(defun eevC (s e &optional other-ee-file) (interactive "r")
  (write-ee-without-comments s e ";" "set -v\n" "\nset +v" other-ee-file)
  (shell-command ". ~/bin/emacs.ee &")
  )             ; zsh/bash

;;;;;
;;;;; «lm-eepic»
;;;;; things to run PIC on a block of text
;;;;;
;
(defun eepic (s e) (interactive "r")
  (write-ee s e "cat > ~/LATEX/tmp.pic <<'--%%--'
		 .PS\n"                 
	        "\n.PE\n--%%--\n
                 cd ~/LATEX
                 pic -t tmp.pic > tmp_pic.tex
                 cat > ~/LATEX/tmp.tex <<'--%%--'
                 \\input{tese_defs}
                 \\begin{document}
                 \\begin{figure}
                   \\scriptsize
                   \\input{tmp_pic} 
                   \\centerline{\\box\\graph}
                 \\end{figure}
                 \\end{document}\n--%%--\n
                 rm tmp.dvi
                 latex tmp.tex\n
                 xdvi tmp.dvi")
  (shell-command ". ~/bin/emacs.ee &"))

;;;;;
;;;;; «lm-eespic»
;;;;; things to run PIC on buffer
;;;;;
;
(defun eespic () (interactive)
  (write-ee (point-min) (point-max) "cat > tmp.pic <<'--%%--'\n"
	    "\n--%%--\n
             pic -t tmp.pic > ~/LATEX/tmp_pic.tex
             rm tmp.pic
             cd ~/LATEX
             cat > ~/LATEX/tmp.tex <<'--%%--'
             \\input{tese_defs}
             \\begin{document}
             \\begin{figure}
               \\scriptsize
               \\input{tmp_pic} 
               \\centerline{\\box\\graph}
             \\end{figure}
             \\end{document}\n--%%--\n
             rm tmp.dvi
             latex tmp.tex\n
             xdvi tmp.dvi")
  (shell-command ". ~/bin/emacs.ee &"))

;;;;;
;;;;; «lm-eespic»
;;;;; things to run PIC on buffer
;;;;;
;
;
(defun pic2tex () 
  (interactive)
  (shell-command (concat "pic -t " (buffer-name) " > " (file-name-sans-extension (buffer-name)) ".tex")))





#####
#
# \if and friends
# 2022may19
#
#####

# «if»  (to ".if")
# (find-dn6 "preamble6.lua" "preamble1")
# (find-texbookpage (+ 12 210) "\\ifx" "test if tokens agree")
# (find-texbooktext (+ 12 210) "\\ifx" "test if tokens agree")
# (find-texbookpage (+ 12 468) "\\if")
# (find-texbooktext (+ 12 468) "\\if")
# (find-texbookpage (+ 12 209) "\\if")
# (find-texbooktext (+ 12 209) "\\if")
# (find-texbookpage (+ 12 209) "\\ifhtoken1")
# (find-texbooktext (+ 12 209) "\\ifhtoken1")
# (find-texbookpage (+ 12 207) "\\ifhcondition")
# (find-texbooktext (+ 12 207) "\\ifhcondition")

\def\USEREALDIAGRAMS{Y}
\def\USEREALDIAGRAMS{N}
\if\USEREALDIAGRAMS Y
  Foo
\else
  Bar
\fi

\newlength{\foolength}
\ifx\foolength\relax \newlength{\foolength} \fi





#####
#
# TeXing the TeXbook
# 2000feb29 / 2005jan01
#
#####

# «texbook»  (to ".texbook")
# (find-angg ".emacs.papers" "texbook")
# https://ctan.org/pkg/texbook
# http://www.ctan.org/tex-archive/systems/knuth/dist/tex/
# http://www.ctan.org/tex-archive/systems/knuth/dist/tex/texbook.tex
# http://mirrors.dotsrc.org/ctan/systems/knuth/dist/tex/texbook.tex
#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/texbook/
mkdir  ~/usrc/texbook/
cd     ~/usrc/texbook/
cp -v  $S/http/mirrors.dotsrc.org/ctan/systems/knuth/dist/tex/texbook.tex .
cp -v $S/http/www.ctan.org/tex-archive/systems/knuth/dist/tex/texbook.tex .

patch texbook.tex <<'%%%'
7,10c7,10
< \loop\iftrue
<   \errmessage{This manual is copyrighted and should not be TeXed}\repeat
< \pausing1 \input manmac
< \ifproofmode\message{Proof mode is on!}\pausing1\fi
---
> %\loop\iftrue
> %  \errmessage{This manual is copyrighted and should not be TeXed}\repeat
> \input manmac %\pausing1 \input manmac
> %\ifproofmode\message{Proof mode is on!}\pausing1\fi
%%%

tex texbook
#
cd     ~/usrc/texbook/
# dvipdf texbook.dvi
pdftex texbook.tex

#
# (find-texbookpage 400)
# (find-texbooktext)



#####
#
# mfbook
# 2008jun21 / 2019jan06
#
#####

# «mfbook»  (to ".mfbook")
# (find-angg ".emacs.papers" "mfbook")
# https://ctan.org/pkg/mfbook
# https://ctan.org/tex-archive/systems/knuth/dist/mf/mfbook.tex
#
rm -Rv ~/usrc/mfbook/
mkdir  ~/usrc/mfbook/
cd     ~/usrc/mfbook/
cp -v $S/https/ctan.org/tex-archive/systems/knuth/dist/mf/mfbook.tex .

# (find-fline "~/usrc/mfbook/mfbook.tex")
# 7,10c7,10

patch mfbook.tex <<'%%%'
8,11c8,11
< \loop\iftrue
<   \errmessage{This manual is copyrighted and should not be TeXed}\repeat
< \pausing1 \input manmac
< \ifproofmode\message{Proof mode is on!}\pausing1\fi
---
> %\loop\iftrue
> %  \errmessage{This manual is copyrighted and should not be TeXed}\repeat
> \input manmac %\pausing1 \input manmac
> %\ifproofmode\message{Proof mode is on!}\pausing1\fi
%%%

tex mfbook
# dvipdf mfbook.dvi
pdftex mfbook.tex

#
# (find-mfbookpage 200)
# (find-mfbooktext)




#####
#
# portuguese hyphenation in potato's tetex
#
#####

# (find-fline "~/LATEX/tese2.sty")

% (find-es "tex" "edrxnotes")
% (find-lsrcfile "../generic/babel/portuges.dtx" "dateportuges")

cd /var/lib/dpkg/info/
for i in tetex*.list; do basename $i .list; done

cd /var/lib/dpkg/info/
agrep -h babel tetex*list | sort


# (find-fline "/usr/doc/tetex-base/")
# (find-fline "/usr/doc/tetex-bin/")
# (find-fline "/usr/doc/tetex-doc/")
# (find-fline "/usr/doc/tetex-extra/")
# (find-fline "/usr/doc/tetex-lib/")
# (find-fline "/usr/doc/tetex-src/")

# (find-vldifile "tetex-base.list")
# (find-vldifile "tetex-bin.list")
# (find-vldifile "tetex-doc.list")
# (find-vldifile "tetex-extra.list")
# (find-vldifile "tetex-lib.list")
# (find-vldifile "tetex-src.list")

# (find-fline "/usr/share/doc/texmf/generic/babel/")

cd /usr/share/doc/texmf/generic/babel/
rm -Rv /tmp/babel/
mkdir /tmp/babel/
cp -iv *.dvi* /tmp/babel/
cd /tmp/babel/
gzip -dv *gz

cd /tmp/babel/
xdvi user.dvi



# (find-vldifile "tetex-src.list")
# (find-fline "/usr/doc/tetex-src/")
# (find-fline "/usr/share/texmf/source/generic/babel/portuges.dtx")

# (find-fline "/usr/doc/" "tetex")
# (find-fline "/usr/doc/tetex-base/")
# (find-fline "/usr/doc/tetex-base/README.Debian")

cd /usr/share/texmf/source/generic/babel/
# (find-fline "/usr/share/texmf/source/generic/babel/bbcompat.dtx")
# (find-fline "/usr/share/texmf/source/generic/babel/bbcompat.dtx" "old interface")





#####
#
# Metafont with X display (potato)
# 2000sep20
#
#####

# «mf_X»  (to ".mf_X")
# «mf_X.1»  (to ".mf_X.1")
# «mf_X.2»  (to ".mf_X.2")
# (find-angg ".Xdefaults" "metafont")
# (find-mfbookfile "mfbook.tex" "Chapter 23. Online\\\\Displays")
# (find-mfbookpage (+ 13 191)   "Chapter 23: Online Displays")
# (find-mfbooktext              "Chapter 23: Online Displays")
# (find-mfbookfile "mfbook.tex" "Appendix E. Examples")
# (find-mfbookpage (+ 13 301)   "Appendix E: Examples")
# (find-mfbooktext              "Appendix E: Examples")
# (find-mfbookpage (+ 13 356)   "Appendix I: Index")
# (find-mfbooktext              "Appendix I: Index")
# (find-man "1 mf" "ONLINE GRAPHICS OUTPUT")
# http://www.tug.org/teTeX/texmf/doc/tetex/teTeX-FAQ
# (find-fline "/usr/share/doc/texmf/tetex/teTeX-FAQ.gz" "\n29) Metafont does not support the X display")
# (find-fline "/usr/doc/tetex-base/README.Debian" "use mf with X")
# (find-status "tetex-bin")
# (find-vldifile "tetex-bin.list" "mfw")
# (find-fline "/usr/doc/tetex-bin/")
# (find-man "1 mf")
#
cd /usr/bin/
ldd mf
ldd mft
ldd mfw

#
cd /tmp/
cat > $EEG <<'---'
beginchar(incr code,10pt#,10pt#,0);
pickup pencircle scaled .3pt; draw unitsquare scaled w;
pickup pencircle scaled 1pt;
for k=1 upto 10:
  drawdot(uniformdeviate w, uniformdeviate w);
endfor;
showit;
endchar;
bye;
---
eeg mfw '\screen_width:=100; screen_depth:=200; screenstrokes;'
# (find-fline "/etc/texmf/modes.mf" "screen_rows :=")
# (find-fline "/usr/share/texmf-texlive/metafont/misc/modes.mf" "screen_rows :=")
#

 (eepitch-mf)
 (eepitch-kill)
 (eepitch-mf)
\screen_width:=100; screen_depth:=200; screenstrokes;
beginchar(incr code,10pt#,10pt#,0);
pickup pencircle scaled .3pt; draw unitsquare scaled w;
pickup pencircle scaled 1pt;
for k=1 upto 10:
  drawdot(uniformdeviate w, uniformdeviate w);
endfor;
showit;
endchar;
bye;






#####
#
# metapost
#
#####

# «metapost-old»  (to ".metapost-old")
# (find-fline "~/MP/arrow.mp")
cd ~/MP/
mp arrow.mp
gv -watch arrow.1

# (find-fline "/cdbup1/home981121/root/MP/arrow.mp")
#
rm -Rv /tmp/mp/
mkdir  /tmp/mp/
cd     /tmp/mp/
cat > 1.mp <<'%%%'
beginfig(1);
u=2cm;
w=2mm;
z1=(4u,1u);	z1d=up;
z2=z1+(0u,3u);	z2d=up;
z3=z2+(2u,2u);	z3d=right;
z4=z3+(1u,0u);	z4d=right;
for n=1,2,3,4:
  z[n]l=z[n] + (z[n]d rotated 90) scaled w;
  z[n]r=z[n] - (z[n]d rotated 90) scaled w;
endfor;
%fill z1--z2--z3--z4--cycle;
fill z1l---z2l..z3l---z4l--z4r---z3r..z2r---z1r--cycle;
endfig;
end
%%%

mpost 1.mp
gv 1.1
#

# (find-fline "/usr/share/doc/texmf/metapost/base/")
gv /usr/share/doc/texmf/metapost/base/mpgraph.ps.gz &
gv /usr/share/doc/texmf/metapost/base/mpintro.ps.gz &
gv /usr/share/doc/texmf/metapost/base/mpman.ps.gz &
# About arrows: mpman, p.37

# (find-node "(dvips)EPSF Macros")
# (find-fline "/usr/lib/texmf/texmf/tex/latex/graphics/epsfig.sty")
# (find-fline "/usr/lib/texmf/source/latex/graphics/epsfig.dtx")
# (find-fline "/usr/lib/texmf/source/latex/graphics/epsfig.dtx" "epsf.tex")

# Boxes:
kpsewhich mp boxes.mp
# (find-fline "/usr/lib/texmf/texmf/metapost/base/boxes.mp")

kpsewhich tex epsf.sty
kpsepath latex

# (find-fline "/usr/lib/texmf/texmf/metapost/base/plain.mp" 421)

# Roubar o código de setas de alguma fonte do TeX (ams, talvez)
# Escrever o script que usa o testfont.

# (find-fline "/usr/share/texmf/tex/plain/base/testfont.tex")
# (find-fline "/usr/share/texmf/tex/plain/misc/mproof.tex")




#####
#
# metapost
# 2008jun21
#
#####

# «metapost»  (to ".metapost")
# (find-es "metapost")
# (find-angg ".emacs" "metapost")
# (find-angg ".emacs.papers" "metapost")
# (find-eeshell "apti texlive-metapost texlive-metapost-doc")
# (find-status   "texlive-metapost")
# (find-vldifile "texlive-metapost.list")
# (find-udfile   "texlive-metapost/")
# (find-status   "texlive-metapost-doc")
# (find-vldifile "texlive-metapost-doc.list")
# (find-udfile   "texlive-metapost-doc/")

# (code-c-d "metapostdoc" "/usr/share/doc/texlive-metapost-doc/metapost/")
# (code-c-d "featpostdoc" "/usr/share/doc/texlive-metapost-doc/metapost/featpost/")
# (find-metapostdocfile "")
# (find-metapostdocfile "base/")
# (find-featpostdocfile "")

# (find-man "1 dmp")
# (find-man "1 dvitomp")
# (find-man "1 makempx")
# (find-man "1 mpost")
# (find-man "1 mpto")
# (find-man "1 newer")
# (find-fline "/usr/share/texmf-tetex/metapost/misc/x.mp")
# (find-fline "/usr/share/texmf-tetex/metapost/misc/null.mp")
# (find-efunction 'eepitch-latex)

(defun eepitch-mpost () (interactive) (ee-eepitch-comint "/tmp/" "mpost" "mpost"))
(defun eepitch-mf    () (interactive) (ee-eepitch-comint "/tmp/" "mf"    "mf"))

 (eepitch-mpost)
 (eepitch-kill)
 (eepitch-mpost)
null
beginfig(1);
u=2cm;
w=2mm;
z1=(4u,1u);	z1d=up;
z2=z1+(0u,3u);	z2d=up;
z3=z2+(2u,2u);	z3d=right;
z4=z3+(1u,0u);	z4d=right;
for n=1,2,3,4:
  z[n]l=z[n] + (z[n]d rotated 90) scaled w;
  z[n]r=z[n] - (z[n]d rotated 90) scaled w;
endfor;
% fill z1--z2--z3--z4--cycle;
fill z1l---z2l..z3l---z4l--z4r---z3r..z2r---z1r--cycle;
endfig;
end

% (find-pspage "/tmp/mpout.1")




#####
#
# Generating ".ps"s with other resolutions (potato)
# 2000sep19
#
#####

# «ps-720dpi»  (to ".ps-720dpi")
# (find-fline "/etc/texmf/")
# (find-fline "/etc/texmf/mktex.cnf")
# (find-fline "/usr/bin/mktexpk")
# (find-fline "/usr/bin/mktexpk" "MODE=ljfour")
# (find-fline "/etc/texmf/modes.mf")
# (find-fline "/etc/texmf/modes.mf" "epscszz")

# (find-status "tetex-bin")
# (find-vldifile "tetex-bin.list")
# (find-fline "/usr/doc/tetex-bin/")

# (find-fline "/usr/sbin/texconfig" "default mode (xdvi/dvips/mf)")
# (find-fline "/usr/sbin/texconfig" "FAQ=")
# (find-fline "/usr/doc/texmf/tetex/teTeX-FAQ.gz" "\n9)")
# (find-node "(dvips)config.ps installation")
# (find-node "(dvips)Option details" "`-mode MODE'")
# (find-node "(dvips)Configuration file searching" "`-mode'")

# (find-fline "~/LATEX/Makefile" "%.ps720 : %.dvi")

#
rm -v /var/spool/texmf/pk/epscszz/public/cm/cmr10.720pk
cd ~/LATEX/
rm tmp.ps
MODE=epscszz make tmp.ps720
#


# (find-fline "/etc/texmf/modes.mf" "ljlo")
# Now we add versions of ljlo with other "blacker" factors, and...
#
/usr/bin/texconfig init |& tee ~/o
#
rm -v /tmp/tmp.*
cd ~/LATEX/
make tmp.dvi
dvips -D 150 -mode edrxlozerofive -o /tmp/tmp.05.ps tmp.dvi
dvips -D 150 -mode edrxloone -o /tmp/tmp.1.ps tmp.dvi
dvips -D 150 -mode edrxlotwo -o /tmp/tmp.2.ps tmp.dvi
#




#####
#
# latex2html
# 2000sep27
#
#####

# «latex2html»  (to ".latex2html")
# (find-status "latex2html")
# (find-vldifile "latex2html.list")
# (find-fline "/usr/doc/latex2html/")

# (find-fline "/usr/share/latex2html/")
# (find-fline "/usr/share/texmf/tex/latex/latex2html/")
# (find-fline "/usr/bin/latex2html")
# (find-fline "/usr/bin/pstoimg")
# (find-fline "/usr/bin/texexpand")
# (find-fline "/etc/latex2html.config")
# (eeman "latex2html")
# (eeman "pstoimg")

# (find-w3 "/usr/doc/latex2html/html/index.html")
# (find-fline "~/LATEX/Makefile")

# Can latex2html convert my texts?

#
rm -Rv /tmp/LATEX/
cd
cp -diPpvR LATEX /tmp/
cd /tmp/LATEX/
# (find-fline "/tmp/LATEX/Makefile" "\n.INTERMEDIATE")
sed 's/.INTERMEDIATE/#.INTERMEDIATE/g' < Makefile > Makefile2
mv Makefile2 Makefile

cd /tmp/LATEX/
make 00jan09.auto.dnt
latex2html 00jan09 |& tee o

#
cd /tmp/LATEX/00jan09/
edrxnetscape ./index.html &

#

# No.

# (find-fline "/tmp/LATEX/00jan09/")




#####
#
# pstoimg
# 2001mar06
#
#####

# «pstoimg»  (to ".pstoimg")
#
# (eev-bounded)
# (find-angg "LATEX/Makefile" "making_pngs")
# (find-es "music" "ps_to_png")
# (find-fline "/usr/bin/pstoimg")
# (find-man "1 pstoimg")
cd ~/LATEX/
rm /tmp/tmp*
make /tmp/tmp.ps300
pstoimg -multi -type png -crop a -antialias -aaliastext \
  -density 150 \
  -out /tmp/tmp.png /tmp/tmp.ps300
make /tmp/tmp.ps
pstoimg -multi -type png -crop a -antialias -aaliastext \
  -density 150 \
  -out /tmp/tmp600..png /tmp/tmp.ps

# Why the "..":
#   pstoimg: Written /tmp/tmp600.1.png
#   pstoimg: Written /tmp/tmp600.2.png

# make /tmp/tmp.300.05.p01.png
# make /tmp/tmp.300.05.png
# make /tmp/tmp.150.png

#
cd ~/dednat/
make example.dvi
rm -fv example.ps example.png
make -f ~/LATEX/Makefile DPI=150 example.ps
# make -f ~/LATEX/Makefile DPI=150 /tmp/example.150.png
pstoimg -type png -crop a -antialias -aaliastext \
  -density 150 \
  -out /tmp/a.png example.ps
# Bad news: "display" doesn't like the result (though zgv and netscape do)

#




#####
#
# tetex-bin source (potato)
# 2000oct01
#
#####

# «tetex-bin»  (to ".tetex-bin")

# (find-status "tetex-bin")
# (find-vldifile "tetex-bin.list")
# (find-fline "/usr/doc/tetex-bin/")

# The tetex-bin source package generates tetex-bin, tetex-dev and
# tetex-lib, but the last two are not very interesting because they
# contain only kpathsea stuff.

#
pdsc $SDEBIAN/dists/potato/main/source/tex/tetex-bin_1.0.6-7.dsc
cd /usr/src/tetex-bin-1.0.6/
find * | sort > .files
debian/rules binary	|& tee odrb

#
cd /usr/src/tetex-bin-1.0.6/
agrep '\./tangle' odrb

#
# «weaving»  (to ".weaving")
cd /usr/src/tetex-bin-1.0.6/texk/web2c/
rm -Rv /tmp/weave/
mkdir  /tmp/weave/
cp -v {tex,mf,gftodvi}.{web,ch} /tmp/weave/
cd     /tmp/weave/

weave gftodvi.web
tex   gftodvi.tex
weave gftodvi.web gftodvi.ch
mv    gftodvi.tex gftodvi-ch.tex
tex           gftodvi-ch.tex

weave tex.web
tex   tex.tex
weave tex.web tex.ch
mv    tex.tex tex-ch.tex
tex           tex-ch.tex

weave mf.web
tex   mf.tex
weave mf.web mf.ch
mv    mf.tex mf-ch.tex
tex          mf-ch.tex

xdvi  gftodvi.dvi &
xdvi  gftodvi-ch.dvi &

xdvi  tex.dvi &
xdvi  tex-ch.dvi &

xdvi  mf.dvi &
xdvi  mf-ch.dvi &

#

# (find-texbinfile "odrb" "./tangle ")

# (code-c-d "texbin" "/usr/src/tetex-bin-1.0.6/")
# (find-texbinfile "")
# (find-texbinfile "odrb")
# (find-texbinfile ".files")
# (find-texbinfile "texk/web2c/")
# (find-texbinfile "texk/web2c/window/")
# (find-texbinfile "texk/web2c/mf.web")
# (find-texbinfile "texk/web2c/mf.web" "Online graphic output.")
# (find-texbinfile "texk/web2c/window/")
# (find-node "(web2c)Metafont")
# (find-node "(web2c)Online Metafont graphics" "`Metafont'")

# (find-fline "/tmp/weave/")
# (find-fline "/tmp/weave/mf.tex")
# (find-fline "/tmp/weave/mf.tex" "\\:\\X")
# (find-fline "/tmp/weave/mf-ch.tex")
# (find-fline "/tmp/weave/mf-ch.tex" "\\:\\X")
# (find-fline "/tmp/weave/mf-ch.tex" "16 ``window'' areas")




#####
#
# xdvi'ing compressed files
# 2000oct01
#
#####

# «xdvi-gz»  (to ".xdvi-gz")
# (to "docs")
# (find-fline "/usr/doc/tetex-base/README.Debian" "view the compressed .dvi")
# (find-fline "/usr/doc/tetex-bin/changelog.Debian.gz" "zipped files")
# (find-status "tetex-bin")
# (find-vldifile "tetex-bin.list")
# (find-texbinfile "texk/xdvik/")
# (find-texbinfile "texk/xdvik/xdvi-sh")
# (find-fline "/usr/bin/X11/xdvi" "*.gz")

#
# Prepare to hand-patch
cd /usr/bin/X11/
if [[ ! -e xdvi.orig ]]; then cp -av xdvi xdvi.orig; fi
# (find-fline "/usr/bin/X11/xdvi" "*.gz")
#
# Bring the original back
cd /usr/bin/X11/
mv -v xdvi.orig xdvi
#

# ...then I gave up. Instead of fixing the xdvi wrapper or writing one
# of my own I decided to use a simple shell function instead. Here it
# is: (find-angg ".zshrc" "zxdvi")

# I'm not calling it in scripts or mime descriptions, just in
# e-scripts, like in this one: (to "docs")


# A test:
#
rm -Rv /tmp/a
mkdir /tmp/a
cd ~/LATEX
gzip -c6 feb98.dvi > /tmp/a/feb98.dvi.gz
zxdvi /tmp/a/feb98.dvi.gz
#




#####
#
# xdvi and sigusr1
# 2000oct29
#
#####

# «xdvi-pid»  (to ".xdvi-pid")
# (find-angg ".zshrc" "rexdvi")
# (find-man "1 xdvi" "SIGUSR1")
# (find-zshnode "Parameters Set By The Shell")
# (find-zshnode "Parameters Set By The Shell" "! <S>")

cd ~/LATEX/
xdvi tmp.dvi &
echo $! > /tmp/xdvi.pid

kill -USR1 $(</tmp/xdvi.pid)




#####
#
# xdvi
# 2012sep07
#
#####

# «xdvi»  (to ".xdvi")
# (find-man "1 xdvi")
# (find-man "1 xdvi" "  +page")
# (find-man "1 xdvi" "srcltx.sty")
# (find-man "1 xdvi" "  -unique")
# (find-man "1 xdvi" "-useTeXpages" "\\count0")
# (find-man "1 xdvi" "pagehistory-back")
# (find-man "1 xdvi" "\nHYPERLINKS")
# (find-man "1 xpdf")





#####
#
# rail
# 2000oct22
#
#####

# «rail»  (to ".rail")
# (find-fline "$SCTAN/support/")

#
rm -Rv /usr/src/rail/
cd /usr/src/
tar -xvzf $SCTAN/support/rail.tar.gz
cd /usr/src/rail/
make |& tee om
#
cd /usr/src/rail/
make clean
make rail.dvi	|& tee omrd
#

gv /usr/src/rail/rail.ps &
man2t /usr/src/rail/rail.man |& l -S
#

# (find-fline "/usr/src/rail/")
# (find-fline "/usr/src/rail/rail.tex")
# (find-fline "/usr/src/rail/rail.rai")
# (find-fline "/usr/src/rail/rail.rao")




#####
#
# twocolumn
# 2000oct31 / 2019may18
#
#####

# «twocolumn»  (to ".twocolumn")
# (find-kopkadaly4page (+ 12  34) "Two-column pages")
# (find-kopkadaly4text (+ 12  34) "Two-column pages")
# (find-kopkadaly4page (+ 12  38) "\\columnsep and \\columnseprule")
# (find-kopkadaly4text (+ 12  38) "\\columnsep and \\columnseprule")
# (find-kopkadaly4page (+ 12  40) "\\columnsep")
# (find-kopkadaly4text (+ 12  40) "\\columnsep")
# (find-kopkadaly4page (+ 12 603) "\\columnsep")
# (find-kopkadaly4text (+ 12 603) "\\columnsep")
# (find-classespage 15 "\\if@twocolumn")
# (find-classestext 15 "\\if@twocolumn")
# (find-geometrypage 10 "modifies \\columnsep")
# (find-geometrytext 10 "modifies \\columnsep")

# (find-angg "LATEX/tese2.sty" "twocolumn")

cd /usr/share/texmf/source/latex/base/
agrep -l twocolumn *

zxdvi /usr/doc/texmf/latex/tools/multicol.dvi.gz &

# (find-fline "/usr/share/texmf/source/latex/tools/multicol.dtx")
# (find-fline "/usr/share/texmf/tex/latex/tools/multicol.sty")

# (find-fline "/usr/doc/texmf/index.html" "fix2col")
# (find-w3 "/usr/doc/texmf/index.html" "fix2col")

# (find-lsrcfile "base/changes.txt")
# (find-lsrcfile "base/classes.dtx")
# (find-lsrcfile "base/clsguide.tex")
# (find-lsrcfile "base/doc.dtx")
# (find-lsrcfile "base/idx.tex")
# (find-lsrcfile "base/letter.dtx")
# (find-lsrcfile "base/ltclass.dtx")
# (find-lsrcfile "base/ltfiles.dtx")
# (find-lsrcfile "base/ltfloat.dtx")
# (find-lsrcfile "base/ltnews.cls")
# (find-lsrcfile "base/ltoutput.dtx")
# (find-lsrcfile "base/makeindx.dtx")
# (find-lsrcfile "base/manual.err")
# (find-lsrcfile "base/proc.dtx")
# (find-lsrcfile "base/slides.dtx")
# (find-lsrcfile "base/usrguide.tex")

# (find-node "(latex)Layout")




#####
#
# \show, \tracingall, etc
# 2000oct31
#
#####

# «show_and_tracing»  (to ".show_and_tracing")
# «nonstopmode»  (to ".nonstopmode")
# (find-texbookpage (+ 11 476))
# (find-knuthfile "tex/")
# (find-knuthfile "tex/texbook.tex" "beginchapter Appendix I. Index" "show")
# (find-knuthfile "tex/texbook.tex" "|\\tracingall|")
# (find-fline "/usr/share/texmf/tex/plain/base/plain.tex")
# (find-fline "/usr/share/texmf/tex/plain/base/plain.tex" "% \\tracingonline=")
# (find-fline "/usr/share/texmf/tex/plain/base/plain.tex" "\\def\\tracingall")

# (find-texbookpage (+ 11 32))
# (find-knuthfile "tex/texbook.tex" "nonstopmode")
# (find-texbookfile "texbook.tex" "nonstopmode")
#
cd /tmp/
tex '\relax\tracingonline=1\nonstopmode
  \show\smash
  \setbox1\hbox{bp}
  \showbox1
  \bye
'
#

# 2008may09 / 2021nov01:
# (find-texbookfile "texbook.tex")
# (find-texbookfile "texbook.tex" "\\tracingall")
# (find-texbookfile "texbook.tex" "Appendix I. Index")
# (find-texbookfile "texbook.tex" "Appendix I. Index" "show")
# (find-texbookfile "texbook.tex" "Appendix I. Index" "tracing")
% (find-texbooktext "")
# (find-texbookpage (+ 12 31) "! Undefined control sequence.")
# (find-texbooktext (+ 12 31) "! Undefined control sequence.")
# (find-texbookpage (+ 12 31) "The `?' that appears after")
# (find-texbooktext (+ 12 31) "The `?' that appears after")
# (find-texbookpage (+ 12 32) "`S', `R', or `Q'")
# (find-texbooktext (+ 12 32) "`S', `R', or `Q'")
# (find-texbookpage (+ 12 32) "\\scrollmode, \\nonstopmode, and \\batchmode")
# (find-texbooktext (+ 12 32) "\\scrollmode, \\nonstopmode, and \\batchmode")
# (find-texbookpage (+ 12 31) "Type `S'. TEX will proceed without pausing")
# (find-texbooktext (+ 12 31) "Type `S'. TEX will proceed without pausing")
# (find-texbookpage (+ 12 31) "Type `R'. This is like `S' but even stronger")
# (find-texbooktext (+ 12 31) "Type `R'. This is like `S' but even stronger")
# (find-texbookpage (+ 12 31) "Type `Q'. This is like `R' but even more so")
# (find-texbooktext (+ 12 31) "Type `Q'. This is like `R' but even more so")
# (find-texbookpage (+ 12 121) "\\showthe\\dimen2")
# (find-texbooktext (+ 12 121) "\\showthe\\dimen2")
# (find-texbookpage (+ 12 121) "\\showbox4")
# (find-texbooktext (+ 12 121) "\\showbox4")
# (find-texbookpage (+ 12 121) "only in the log file, unless")
# (find-texbooktext (+ 12 121) "only in the log file, unless")
# (find-texbookpage (+ 12 121) "\\tracingonline=1")
# (find-texbooktext (+ 12 121) "\\tracingonline=1")
# (find-texbookpage (+ 12 215) "`\\showthe'")
# (find-texbooktext (+ 12 215) "`\\showthe'")
# (find-texbookpage (+ 12 273) "\\tracingonline (positive")
# (find-texbooktext (+ 12 273) "\\tracingonline (positive")
# (find-texbookpage (+ 12 277) "\\errorstopmode | \\scrollmode")
# (find-texbooktext (+ 12 277) "\\errorstopmode | \\scrollmode")
# (find-texbookpage (+ 12 299) "\\batchmode or \\nonstopmode")
# (find-texbooktext (+ 12 299) "\\batchmode or \\nonstopmode")


 (eepitch-tex)
 (eepitch-kill)
 (eepitch-tex)
\tracingonline=1
\newlinechar=`\^^J
\catcode` =12\def\spac{ }\catcode` =10
\setbox1\hbox{bp}
\message{^^J \the\wd1\spac \the\ht1\spac \the\dp1}
\showbox1
I\show\smash
I\showthe\wd1
\interact
\showthe\wd1
I\bye
%\interact



#####
#
# Showing the dimensions of a box
# 99nov06
#
#####

# «show_box_dims»  (to ".show_box_dims")
# (find-angg "LATEX/edrx.sty" "showboxdims")
# (find-texbookfile "texbook.tex" "The \\<token list> of a |\\write|")
# (find-texbookfile "texbook.tex" "\\newlinechar=`\\^^J")
# (find-texbookfile "texbook.tex" "10&Space")
# (find-texbookfile "texbook.tex" "12&Other character")
# (find-texbookfile "texbook.tex" "13&Active character")
# (find-texbookfile "texbook.tex" "^|\\message||{...}|")
# (find-texbookpage (+ 11 37) "Category" "Meaning")
# (find-texbookpage (+ 11 481))
# (find-texbookpage (+ 11 227))

%
% (eelatex-bounded)
\setbox1\hbox{bp}
\newlinechar=`\^^J
\catcode` =12\def\spac{ }\catcode` =10
\message{^^J \the\wd1\spac \the\ht1\spac \the\dp1}
\dp1=12pt
\message{^^J \the\wd1\spac \the\ht1\spac \the\dp1}
\message{^^J \the\wd1\spac \the\ht1\spac \the\dp1}
%
% (eelatex-bounded)
\catcode` =12\gdef\spac{ }\catcode` =10
\gdef\showboxdims#1{\immediate\write16{
  wd=\the\wd#1\spac ht=\the\ht#1\spac dp=\the\dp#1
}}
\setbox1\hbox{bp}
\showboxdims{1}
\dp1=12pt
\showboxdims{1}
%


# Converting dimensions:
# (find-knuthfile "tex/texbook.tex" "newdimen")
# (find-fline "/usr/lib/texmf/tex/plain/base/plain.tex" "newdimen")
# (find-knuthfile "tex/texbook.tex" "in=72.27")
# (/ 1 72.27)

%
\newlinechar=`\^^J
\newdimen\tmpdimen
%\def\rmpt#1pt{#1}
\def\rmpt#1{#1}

\tmpdimen=72.27pt
\message{^^J \the\tmpdimen}
\tmpdimen=0.013837\tmpdimen
\message{^^J \rmpt\the\tmpdimen in}
%


# Other notes:
#
tex '\tracingonline=1\scrollmode
  \message{hello}
  \setbox1\hbox{bp}
  \showthe\wd1
  \showthe\ht1
  \showthe\dp1
  \bye'
#
tex '\tracingonline=1\scrollmode
\newlinechar=`\^^J
\def\sp{ }
\setbox1\hbox{bp}
\catcode` =12\def\spac{ }\catcode` =10
\message{    \the\wd1   \the\ht1\ \the\dp1}
\message{^^J \the\wd1^^ \the\ht1{} \the\dp1}
\message{^^J \the\wd1\sp \the\ht1^^20 \the\dp1}
\message{^^J \the\wd1\string\ \the\ht1\char` \the\dp1}
\message{^^J \the\wd1\spac \the\ht1\spac \the\dp1}
\message{^^J \the\wd1\spac \the\ht1\spac \the\dp1}
\bye'
#

# (find-knuthfile "tex/texbook.tex")
# (find-texbooktext "256 box registers")
# (find-texbooktext "\\expandafter token")
# (find-texbooktext "futurelet")
# (find-texbooktext "batchmode")
# (find-texbooktext "showthe\n")
# (find-texbooktext "\\csname")
# (find-texbooktext "2\\wd3")

# (find-fline "/usr/lib/texmf/tex/plain/base/manmac.tex" "index")

# (find-fline "~/LATEX/")
# (find-fline "~/LATEX/boxing7.tip")
# (find-fline "~/LATEX/Makefile")




#####
#
# \smash
# 2001oct23
#
#####

# «smash»  (to ".smash")
% (find-texbookpage (+ 12 178) "\\smash")
% (find-texbookpage (+ 12 360) "\\def\\smash")
% (find-texbooktext            "\\def\\smash")
% (find-amsldocpage (+ 6 11) "\\smash options")
% (find-lsrcfile "base/ltmath.dtx" "\\def\\smash")
% (find-lsrcfile "amslatex/math/amsmath.dtx" "\\renewcommand{\\smash}")
% (find-lsrcfile "base/ltdefns.dtx" "\\def\\@protected@testopt")
% (find-plainsrcfile "plain.tex" "\\def\\smash")
% Why doesn't the standard LaTeX \smash work?
%
\def\mysmash#1{{\setbox0\hbox{#1}%
  \wd0=0pt\ht0=0pt\dp0=0pt%
  \box0}}

aa\smash{BBB}cccc

aa\mysmash{BBB}cccc

%
% (eedn4a-bounded)
\def\mysmash#1{{%
  \setbox0\hbox{#1}%
  \wd0=0pt\ht0=0pt\dp0=0pt%
  \box0
  }}
\def\red#1{{\color{red}#1}}

Foo: \mysmash{right}wrong

Foo: \mysmash{\red{right}}wrong

\leavevmode \mysmash{right}wrong

%





#####
#
# tetex-bin source (potato)
# 2000oct01
#
#####

# «tetex-bin»  (to ".tetex-bin")

# (find-status "tetex-bin")
# (find-vldifile "tetex-bin.list")
# (find-fline "/usr/doc/tetex-bin/")

# The tetex-bin source package generates tetex-bin, tetex-dev and
# tetex-lib, but the last two are not very interesting because they
# contain only kpathsea stuff.

#
pdsc $SDEBIAN/dists/potato/main/source/tex/tetex-bin_1.0.6-7.dsc
cd /usr/src/tetex-bin-1.0.6/
find * | sort > .files
debian/rules binary	|& tee odrb

#
cd /usr/src/tetex-bin-1.0.6/
agrep '\./tangle' odrb

#
# «weaving»  (to ".weaving")
cd /usr/src/tetex-bin-1.0.6/texk/web2c/
rm -Rv /tmp/weave/
mkdir  /tmp/weave/
cp -v {tex,mf,gftodvi}.{web,ch} /tmp/weave/
cd     /tmp/weave/

weave gftodvi.web
tex   gftodvi.tex
weave gftodvi.web gftodvi.ch
mv    gftodvi.tex gftodvi-ch.tex
tex           gftodvi-ch.tex

weave tex.web
tex   tex.tex
weave tex.web tex.ch
mv    tex.tex tex-ch.tex
tex           tex-ch.tex

weave mf.web
tex   mf.tex
weave mf.web mf.ch
mv    mf.tex mf-ch.tex
tex          mf-ch.tex

xdvi  gftodvi.dvi &
xdvi  gftodvi-ch.dvi &

xdvi  tex.dvi &
xdvi  tex-ch.dvi &

xdvi  mf.dvi &
xdvi  mf-ch.dvi &

#

# (find-texbinfile "odrb" "./tangle ")

# (code-c-d "texbin" "/usr/src/tetex-bin-1.0.6/")
# (find-texbinfile "")
# (find-texbinfile "odrb")
# (find-texbinfile ".files")
# (find-texbinfile "texk/web2c/")
# (find-texbinfile "texk/web2c/window/")
# (find-texbinfile "texk/web2c/mf.web")
# (find-texbinfile "texk/web2c/mf.web" "Online graphic output.")
# (find-texbinfile "texk/web2c/window/")
# (find-node "(web2c)Metafont")
# (find-node "(web2c)Online Metafont graphics" "`Metafont'")

# (find-fline "/tmp/weave/")
# (find-fline "/tmp/weave/mf.tex")
# (find-fline "/tmp/weave/mf.tex" "\\:\\X")
# (find-fline "/tmp/weave/mf-ch.tex")
# (find-fline "/tmp/weave/mf-ch.tex" "\\:\\X")
# (find-fline "/tmp/weave/mf-ch.tex" "16 ``window'' areas")




#####
#
# xdvi'ing compressed files
# 2000oct01
#
#####

# «xdvi-gz»  (to ".xdvi-gz")
# (to "docs")
# (find-fline "/usr/doc/tetex-base/README.Debian" "view the compressed .dvi")
# (find-fline "/usr/doc/tetex-bin/changelog.Debian.gz" "zipped files")
# (find-status "tetex-bin")
# (find-vldifile "tetex-bin.list")
# (find-texbinfile "texk/xdvik/")
# (find-texbinfile "texk/xdvik/xdvi-sh")
# (find-fline "/usr/bin/X11/xdvi" "*.gz")

#
# Prepare to hand-patch
cd /usr/bin/X11/
if [[ ! -e xdvi.orig ]]; then cp -av xdvi xdvi.orig; fi
# (find-fline "/usr/bin/X11/xdvi" "*.gz")
#
# Bring the original back
cd /usr/bin/X11/
mv -v xdvi.orig xdvi
#

# ...then I gave up. Instead of fixing the xdvi wrapper or writing one
# of my own I decided to use a simple shell function instead. Here it
# is: (find-angg ".zshrc" "zxdvi")

# I'm not calling it in scripts or mime descriptions, just in
# e-scripts, like in this one: (to "docs")


# A test:
#
rm -Rv /tmp/a
mkdir /tmp/a
cd ~/LATEX
gzip -c6 feb98.dvi > /tmp/a/feb98.dvi.gz
zxdvi /tmp/a/feb98.dvi.gz
#




#####
#
# src2tex
# 2000oct25
#
#####

# «src2tex»  (to ".src2tex")
# (find-status "src2tex")
# (find-vldifile "src2tex.list")
# (find-fline "/usr/doc/src2tex/")

#
rm -Rv /tmp/st-e/
mkdir  /tmp/st-e/
cd     /tmp/st-e/
cp -v /usr/share/doc/src2tex/examples/contrib/* .
cp -v /usr/share/doc/src2tex/examples/*         .
gzip -dv *
#
cd     /tmp/st-e/
for i in *.dvi; do xdvi -s 8 $i; done
for i in *.ps; do  gv -antialias $i; done





#####
#
# auctex
# 2000oct31 / 2008nov12
#
#####

# «auctex»  (to ".auctex")
# (find-status   "auctex")
# (find-vldifile "auctex.list")
# (find-udfile   "auctex/")
# (find-node "(auctex)Top")
# (find-node "(auctex)Itemize-like")
# (find-node "(preview-latex)Top")
# (find-firefox "/usr/share/doc/auctex/HTML/auctex/index.html")
# (find-firefox "/usr/share/doc/auctex/HTML/preview-latex/index.html")
# (find-node "(auctex)Top")
# (find-node "(auctex)Commands" "% Local Variables:")
# (find-node "(auctex)Commands" "write the current region into the region file")

# (find-fline "/etc/emacs-snapshot/site-start.d/50auctex.el")
# (find-sitelispfile "auctex/")
# (find-fline "/var/lib/auctex/emacs21/")




# Just as a curiosity: auctex uses local variables a lot.
zcatinfo /usr/share/info/auctex > /tmp/auctex.info
# (find-fline "/tmp/auctex.info")





#####
#
# making indices
# 2001jan25
#
#####

# «indices»  (to ".indices")
# (find-lsrcfile "amslatex/math/amsldoc.tex")
#
rm -Rv /tmp/latex/
mkdir  /tmp/latex/
cd     /tmp/latex/
cp -v /usr/share/texmf/source/latex/amslatex/math/amsldoc.tex .
latex amsldoc.tex
latex amsldoc.tex
xdvi /tmp/latex/amsldoc.dvi

# (find-fline "/tmp/latex/")
# (find-fline "/tmp/latex/amsldoc.tex" "tableofcontents")
# (find-fline "/tmp/latex/amsldoc.toc")
#
lsrcagrep tableofcontents
lsrcagrep -l tableofcontents |& tee ~/o
l +/tableofcontents $(<~/o)
#

# (find-node "(latex)Table of Contents")
# (find-node "(latex)Sectioning")





#####
#
# proof.sty: the default "proof" package, by Makoto Tatsuta
# 2017jun17 / 2018dec22
#
#####

# «proof»  (to ".proof")
# «tatsutaproof»  (to ".tatsutaproof")
# https://ctan.org/pkg/lkproof
# (find-sh "locate proof")
# (find-dn6 "preamble6.lua" "preamble0")

# (find-tlsh "find * | sort | grep proof.sty")
# (find-tlsh "find * | sort | grep lkproof")
# (find-tlfile "texmf-dist/doc/latex/lkproof/")
# (find-tlfile "texmf-dist/tex/latex/lkproof")
# (find-tlfile "texmf-dist/tex/latex/lkproof/proof.sty")
# (find-tlfile "texmf-dist/tex/latex/lkproof/proof.sty" "Usage:")
# (find-tlfile "texmf-dist/tex/latex/lkproof/proof.sty" "\\DeduceSym")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/lkproof/")
(code-pdf-page "lkproof" "/usr/local/texlive/2019/texmf-dist/doc/latex/lkproof/lkproof-doc.pdf")
(code-pdf-text "lkproof" "/usr/local/texlive/2019/texmf-dist/doc/latex/lkproof/lkproof-doc.pdf")
;; (find-lkproofpage)
;; (find-lkprooftext)

# (find-LATEXgrep "grep --color -nH -e DeduceSym *")




#####
#
# Makoto Tatsuta's proof.sty
# 2001oct23
#
#####

# (find-angg "LATEX/proof.orig.sty")
# (find-angg "LATEX/proof.edrx.sty")
# (find-fline "$SCTAN/macros/latex/contrib/other/proof/proof.sty")
# (find-fline "$SCTAN/macros/latex/contrib/other/proof/proofeg.tex")

tkdiff ~/LATEX/proof.edrx.sty $SCTAN/macros/latex/contrib/other/proof/proof.sty

# (find-angg "dednat/dednat.lua" "tatsuta_donode")
# (find-angg "dednat/dednat2.lua" "tatsuta_do_node")

# 2007aug20:
# http://tug.ctan.org/macros/latex/contrib/lkproof/proof.sty
# http://tug.ctan.org/macros/latex/contrib/lkproof/proofeg.tex
# (find-sh0 "cp -v $S/http/tug.ctan.org/macros/latex/contrib/lkproof/proof* ~/LATEX/")
# (find-dvipage "~/LATEX/proofeg.dvi" 1)
#
cd ~/LATEX/
latex proofeg.tex
rexdvi proofeg.dvi

#




#####
#
# Samuel Buss's package for typesetting proof trees
# 2001feb25 / 2019jan16
#
#####

# «bussproofs»  (to ".bussproofs")
# http://www.math.ucla.edu/~asl/
# http://www.math.ucla.edu/~asl/bussproofs.sty
# http://www.math.ucsd.edu/~sbuss/ResearchWeb/bussproofs/index.html
# http://www.math.ucsd.edu/~sbuss/ResearchWeb/bussproofs/bussproofs.sty
# https://ctan.org/pkg/bussproofs?lang=en

# (find-tlsh "find * | sort | grep buss")
# (find-tlsh "find * | sort | grep bussproofs")
# (find-tlfile "texmf-dist/doc/latex/bussproofs/")
# (find-tlfile "texmf-dist/tex/latex/bussproofs/bussproofs.sty")
(code-pdf-page "bussguide" "/usr/local/texlive/2019/texmf-dist/doc/latex/bussproofs/BussGuide2.pdf")
(code-pdf-text "bussguide" "/usr/local/texlive/2019/texmf-dist/doc/latex/bussproofs/BussGuide2.pdf")
;; (find-bussguidepage)
;; (find-bussguidetext)
# (find-bussguidepage 6 "\\QuaternaryInfC{form}")
# (find-bussguidetext 6 "\\QuaternaryInfC{form}")
# (find-bussguidepage 8 "\\RightLabel{text}")
# (find-bussguidetext 8 "\\RightLabel{text}")
# (find-bussguidepage 9 "\\doubleLine")
# (find-bussguidetext 9 "\\doubleLine")

# Old:

# (find-shttpw3 "www.math.ucla.edu/~asl/bussproofs.sty")
#
cd /tmp/
cp $S/http/www.math.ucla.edu/~asl/bussproofs.sty .
cat > proof.tex <<'---'
\documentclass{book}
\usepackage{bussproofs}
\begin{document}

% (find-fline "/tmp/bussproofs.sty" "For example, to generate")
% (find-fline "/tmp/bussproofs.sty" "\\def\\BinaryInfC")
% (find-fline "/tmp/bussproofs.sty" "Usages:")
$$
\AxiomC{D}
\AxiomC{A}
\AxiomC{B}
\BinaryInfC{C}
%\BinaryInf{E}
\BinaryInfC{E}
\DisplayProof
$$

\scriptsize
\def\ScoreOverhang{0pt}

$$
\AxiomC{A}
\AxiomC{\(B\)}
\RightLabel{X}
\BinaryInfC{C}
\DisplayProof
$$

\end{document}
---

latex proof.tex && rexdvi proof.dvi
#




#####
#
# bussproofs-vdots
# 2020aug24
#
#####

# «bussproofs-vdots»  (to ".bussproofs-vdots")
# https://tex.stackexchange.com/questions/277258/premise-discharge-with-vertical-dots-with-bussproof-sty
# https://tex.stackexchange.com/questions/278053/assumptions-discharge-proof-summary-and-labelling-with-bussproof
# https://tex.stackexchange.com/questions/303380/how-to-align-a-prooftree-left/303431#303431
# https://tex.stackexchange.com/questions/477606/how-to-arrange-inference-rules-in-a-figure-so-that-they-are-as-tight-as-possible/477610#477610
# http://www.actual.world/resources/tex/doc/Proofs.pdf Proofs in LaTeX - Alexander W. Kocurek



#####
#
# bussproofs-extra
# 2020aug24
#
#####

# «bussproofs-extra»  (to ".bussproofs-extra")
# http://ctan.math.illinois.edu/macros/latex2e/contrib/bussproofs-extra/bussproofs-extra.pdf
# (code-pdf-page "bussproofsextra" "$S/http/ctan.math.illinois.edu/macros/latex2e/contrib/bussproofs-extra/bussproofs-extra.pdf")
# (code-pdf-text "bussproofsextra" "$S/http/ctan.math.illinois.edu/macros/latex2e/contrib/bussproofs-extra/bussproofs-extra.pdf")
# (find-bussproofsextrapage)
# (find-bussproofsextratext)
# (find-tlsh "find * | sort | grep bussproofs")
# (find-fline "/usr/local/texlive/2019/texmf-dist/source/latex/bussproofs-extra/bussproofs-extra.dtx")

# https://github.com/OpenLogicProject/bussproofs-extra

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/bussproofs-extra/
cd      ~/usrc/
git clone https://github.com/OpenLogicProject/bussproofs-extra
cd      ~/usrc/bussproofs-extra/

pdflatex bussproofs-extra.dtx

# (code-c-d      "bussproofsextra" "~/usrc/bussproofs-extra/")
# (code-pdf-page "bussproofsextra" "~/usrc/bussproofs-extra/bussproofs-extra.pdf")
# (code-pdf-text "bussproofsextra" "~/usrc/bussproofs-extra/bussproofs-extra.pdf")
# (find-gitk                       "~/usrc/bussproofs-extra/")
# (find-bussproofsextrafile "")
# (find-bussproofsextrafile "README.md" "pdflatex bussproofs-extra.dtx")
# (find-bussproofsextrapage)
# (find-bussproofsextratext)





#####
#
# bussproofs-victor
# 2020mar18
#
#####

# «bussproofs-victor» (to ".bussproofs-victor")
# (find-es "dednat" "bussproofs")

\usepackage{bussproofs}
\newenvironment{bprooftree}
  {\leavevmode\hbox\bgroup}
  {\DisplayProof\egroup}

%L addabbrevs("->", "\\to ")
%
%:  [x]^1  f     [a]^1  a->b                                 H
%:  --------     -----------                                ...
%:     f(x)   g       b       b->c      A  B  C   E  F      \Pi
%:     --------       ------------      =======r  ::::\phi  ...
%:     g(f(x))             c               D       G         I
%:   ----------1         ----1             -------------------
%:   Lx.g(f(x))          a->c                      J
%:
%:   ^x.g(f(x))          ^x.g(f(x)).t              ^bars
%:
\pu
$$\ded{x.g(f(x))} \qquad \ded{x.g(f(x)).t} \qquad \ded{bars}$$

\begin{bprooftree}
    \AxiomC{A}
    \AxiomC{B}
    \AxiomC{C}
   \doubleLine
   \RightLabel{\textit{r}}
  \TrinaryInfC{D}
    \AxiomC{E}
    \AxiomC{F}
   \noLine
   \BinaryInfC{.}
   \noLine
   \UnaryInfC{.}
   \noLine
   \RightLabel{\ \ \   $\phi$}
   \UnaryInfC{.}
   \noLine
  \UnaryInfC{G}
    \AxiomC{H}
   \noLine
   \UnaryInfC{$\Pi$}
   \noLine
  \UnaryInfC{I}
\TrinaryInfC{J}
\end{bprooftree}


% \usepackage{bussproofs}

\newenvironment{bprooftree}
  {\leavevmode\hbox\bgroup}
  {\DisplayProof\egroup}

\begin{bprooftree}
    \AxiomC{$A$}
    %
    \AxiomC{$B$}
    \noLine
    \UnaryInfC{$C$}
    \noLine
    \UnaryInfC{$D$}
    %
  \BinaryInfC{$E$}
  \noLine
  \UnaryInfC{$F$}
  \noLine
  \UnaryInfC{$G$}
  \noLine
  \UnaryInfC{$H$}
  %
  \AxiomC{$I$}
  \noLine
  \UnaryInfC{?}
  \noLine
  \UnaryInfC{$J$}
  \noLine
  \UnaryInfC{?}
  \noLine
  \UnaryInfC{$K$}
  %
    \AxiomC{$L$}
    %
    \AxiomC{$M$}
    %
  \BinaryInfC{$N$}
  \noLine
  \UnaryInfC{$O$}
  \noLine
  \UnaryInfC{?}
  \noLine
  \UnaryInfC{$P$}
   \RightLabel{$Q$}
  %
\TrinaryInfC{$R$}
\end{bprooftree}








#####
#
# prftree
# 2019nov18
#
#####

# «prftree» (to ".prftree")
# (find-tlsh "find * | sort | grep prftree")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/prftree/")
(code-c-d      "prftree" "/usr/local/texlive/2019/texmf-dist/doc/latex/prftree/")
(code-pdf-page "prftree" "/usr/local/texlive/2019/texmf-dist/doc/latex/prftree/prftreedoc.pdf")
(code-pdf-text "prftree" "/usr/local/texlive/2019/texmf-dist/doc/latex/prftree/prftreedoc.pdf")
;; (find-prftreefile "")
;; (find-prftreepage)
;; (find-prftreetext)





#####
#
# Paul Taylor's proof tree package
# 2001apr03 / 2019jan16
#
#####

# «ptproof-old»  (to ".ptproof-old")
# https://ctan.org/pkg/proofs
# http://ftp.inf.utfsm.cl/pub/tex-archive/macros/generic/proofs/taylor/prooftree-doc.pdf
# (find-tlsh "find * | sort | grep proof")
# Not in TeXLive?

# Old:

# (find-angg "dednat/dednat3.lua" "paul.taylor")
# (find-sftpfile "ftp.dcs.qmw.ac.uk/pub/tex/contrib/pt/proofs/")

# (code-c-d "ptproof" "$S/ftp/ftp.dcs.qmw.ac.uk/pub/tex/contrib/pt/proofs/")
# (find-ptprooffile "prooftree-doc.tex" "primitive")
# (find-ptprooffile "prooftree.tex")
#
rm -Rv /tmp/pt/
mkdir  /tmp/pt/
cd     /tmp/pt/
# cp -iv $S/ftp/ftp.dcs.qmw.ac.uk/pub/tex/contrib/pt/proofs/* .
cp    -v $S/http/www.monad.me.uk/proofs/prooftree.sty .
cp    -v $S/http/www.monad.me.uk/proofs/prooftree-doc.tex .

cd     /tmp/pt/
cat > pttest.tex <<'%%%'
\documentclass{book}
\usepackage{prooftree}
\begin{document}
\begin{prooftree}
  \[ A \quad
     B \using \land I \justifies
  A \land B \]
  A \land B \to C
  \[ \[ \justifies
     ?? \] \justifies
  ? \] \justifies
C
\end{prooftree}
\end{document}
%%%
latex pttest.tex  &&  rexdvi pttest.dvi

#


# «ptproof»  (to ".ptproof")
# http://www.monad.me.uk/proofs/
# http://www.monad.me.uk/proofs/prooftree.sty
# http://www.monad.me.uk/proofs/prooftree-doc.tex
#
rm -Rv ~/usrc/ptproof/
mkdir  ~/usrc/ptproof/
cd     ~/usrc/ptproof/
cp -v $S/http/www.monad.me.uk/proofs/prooftree.sty .
cp -v $S/http/www.monad.me.uk/proofs/prooftree-doc.tex .
cp -v prooftree.sty prooftree.tex
latex prooftree-doc.tex  \
  && rexdvi prooftree-doc.dvi \
  && dvipdf prooftree-doc.dvi

#
# (code-c-d "ptproof" "~/usrc/ptproof/")
# (find-ptprooffile "")
# (find-ptprooffile "prooftree-doc.tex")
# (find-fline "~/LATEX/" "prooftree")
# (find-sh0 "rm -v ~/LATEX/prooftree.sty")
# (find-sh0 "cp -v $S/http/www.monad.me.uk/proofs/prooftree.sty ~/LATEX/")

# (code-dvi       "ptproof" "~/usrc/ptproof/prooftree-doc.dvi")
# (code-pdf-text  "ptproof" "~/usrc/ptproof/prooftree-doc.pdf")
# (find-ptproofpage 1)
# (find-ptprooftext)
# (find-ptprooftext "\\kern-26em")



# (find-tlsh "find * | sort | grep diagrams")




#####
#
# TeXCad
# 2001may26
#
#####

# «texcad»  (to ".texcad")
#
rm -Rv /usr/src/xtexcad-2.4.1/
cd /usr/src/
tar -xvzf $S/ftp/ftp.tex.ac.uk/tex-archive/graphics/xtexcad/xtexcad-2.4.1.tar.gz
cd /usr/src/xtexcad-2.4.1/

xmkmf		|& tee ox
make		|& tee om

#
debtartvzf /var/cache/apt/archives/xlib6g-dev_3.3.6-9_i386.deb	|& tee ~/o
# (find-fline "~/o" "xmkmf")
#
cd /
debtarxvzf /var/cache/apt/archives/xlib6g-dev_3.3.6-9_i386.deb \
  ./usr/X11R6/bin/xmkmf	\
  ./usr/X11R6/bin/imake
#

# (code-c-d "texcad" "/usr/src/xtexcad-2.4.1/")
# (find-texcadfile "")
# (find-texcadfile "README")



#####
#
# \phantom
# 2022jul07
#
#####

# «phantom»  (to ".phantom")
# (find-texbookpage (+ 12 360) "\\def\\phantom")
# (find-texbooktext (+ 12 360) "\\def\\phantom")

# (find-texbookpage (+ 0 479))
# (find-texbooktext (+ 0 479))

# Index: (find-texbookpage (+ 12 467) "*\\hbox")
#        (find-texbooktext (+ 12 467) "*\\hbox")
# (find-texbookpage (+ 12 77) "\\hbox to")
# (find-texbooktext (+ 12 77) "\\hbox to")
# (find-texbookpage (+ 12 77) "\\hbox spread 5pt")
# (find-texbooktext (+ 12 77) "\\hbox spread 5pt")
# (find-texbookpage (+ 12 221) "\\vrule height4pt width3pt depth2pt")
# (find-texbooktext (+ 12 221) "\\vrule height4pt width3pt depth2pt")
# (find-texbookpage (+ 12 222) "\\hbox" "box specificationi")
# (find-texbooktext (+ 12 222) "\\hbox" "box specificationi")
# (find-texbookpage (+ 12 278))
# (find-texbooktext (+ 12 278))
# (find-texbookpage (+ 12 388) "new value to the \\ht, \\wd, or \\dp")
# (find-texbooktext (+ 12 388) "new value to the \\ht, \\wd, or \\dp")

# (find-texbookpage (+ 12 86))
# (find-texbookpage (+ 12 93))
# (find-texbookpage (+ 12 151))
# (find-texbookpage (+ 12 159))
# (find-texbookpage (+ 12 163))
# (find-texbookpage (+ 12 175))
# (find-texbookpage (+ 12 179))
# (find-texbookpage (+ 12 185))
# (find-texbookpage (+ 12 221))
# (find-texbooktext (+ 12 221))
# (find-texbookpage (+ 12 222))
# (find-texbookpage (+ 12 278))

\setbox0=\hbox{} \ht0=20pt \dp0=10pt \box0

\hbox, 64­67, 77, 86, 93, 151, 159, 163,
      175, 179, 185­186, 221, 222, 278,
      282, 388­389.



#####
#
# \mathstrut
# 2022jul07
#
#####

# «mathstrut»  (to ".mathstrut")
# (find-LATEX "edrx21defs.tex" "mystrut")
# (find-texbookpage (+ 12 131) "\\mathstrut")
# (find-texbooktext (+ 12 131) "\\mathstrut")
# (find-texbookpage (+ 12 178) "\\vphantom(")
# (find-texbooktext (+ 12 178) "\\vphantom(")
# (find-texbookpage (+ 12 388) "new value to the \\ht, \\wd, or \\dp")
# (find-texbooktext (+ 12 388) "new value to the \\ht, \\wd, or \\dp")



#####
#
# \mathop
# 2021jul03
#
#####

# «mathop»  (to ".mathop")
# (find-texbookpage (+ 12 178) "\\mathop{\\phantom\\sum}")
# (find-texbooktext (+ 12 178) "\\mathop{\\phantom\\sum}")
# (find-texbookpage (+ 12 321) "\\def\\limsup{\\mathop{\\overline{\\rm lim}}}")
# (find-texbooktext (+ 12 321) "\\def\\limsup{\\mathop{\\overline{\\rm lim}}}")




#####
#
# arrow.tex
# 2001nov01
#
#####

# «arrow.tex»  (to ".arrow.tex")
# (find-fline "/usr/share/texmf/tex/plain/misc/arrow.tex" "% Some examples")
#
cd /tmp/
cat > arrowtest.tex <<'---'
\input arrow.tex
\parskip=20pt

The first example:
$$\commdiag{A&\mapright^f&B&\mapleft^g&C\cr
\mapdown\lft\psi&\arrow(3,-2)\rt s&\mapup\rt\phi&
\arrow(-3,2)\lft l&\mapdown\rt\theta\cr
D&\mapright_h&E&\mapleft_{\int_0^t{\bf A}\,d\sigma}&F\cr}$$

Covering homotopy property (Bott and Tu, {\it Differential Forms in
Algebraic Topology}):
$$\commdiag{Y&\mapright^f&E\cr \mapdown&\arrow(3,2)\lft{f_t}&\mapdown\cr
Y\times I&\mapright^{\bar f_t}&X}$$

Universal mapping property (Warner, {\it Foundations of Differentiable
Manifolds and Lie Groups}): $$\varrowlength=20pt
\commdiag{V\otimes W\cr \mapup\lft\phi&\arrow(3,-1)\rt{\tilde l}\cr
V\times W&\mapright^l&U\cr}$$

A cube (Francis Borceux):
$$\harrowlength=48pt \varrowlength=48pt \sarrowlength=20pt
\def\cross#1#2{\setbox0=\hbox{$#1$}%
  \hbox to\wd0{\hss\hbox{$#2$}\hss}\llap{\unhbox0}}
\gridcommdiag{&&B&&\mapright^b&&D\cr
&\arrow(1,1)\lft a&&&&\arrow(1,1)\lft d\cr
A&&\cross{\hmorphposn=12pt\mapright^c}{\vmorphposn=-12pt\mapdown\lft f}
&&C&&\mapdown\rt h\cr\cr
\mapdown\lft e&&F&&\cross{\hmorphposn=-12pt\mapright_j}
{\vmorphposn=12pt\mapdown\rt g}&&H\cr
&\arrow(1,1)\lft i&&&&\arrow(1,1)\rt l\cr
E&&\mapright_k&&G\cr}$$

Zassenhaus's Butterfly Lemma (Lang, {\it Algebra}):
$$\hgrid=16pt \vgrid=8pt \sarrowlength=32pt
\def\cross#1#2{\setbox0=\hbox{$#1$}%
  \hbox to\wd0{\hss\hbox{$#2$}\hss}\llap{\unhbox0}}
\def\l#1{\llap{$#1$\hskip.5em}}
\def\r#1{\rlap{\hskip.5em$#1$}}
\gridcommdiag{&&U&&&&V\cr &&\bullet&&&&\bullet\cr
&&\sarrowlength=16pt\sline(0,1)&&&&\sarrowlength=16pt\sline(0,1)\cr
&&\l{u(U\cap V)}\bullet&&&&\bullet\r{(U\cap V)v}\cr
&&&\sline(2,-1)&&\sline(2,1)\cr
&&\cross{=}{\sline(0,1)}&&\bullet&&\cross{=}{\sline(0,1)}\cr\cr
&&\l{^{\textstyle u(U\cap v)}}\bullet&&\cross{=}{\sline(0,1)}&&
 \bullet\r{^{\textstyle(u\cap V)v}}\cr
&\sline(2,1)&&\sline(2,-1)&&\sline(2,1)&&\sline(2,-1)\cr
\l{u}\bullet&&&&\bullet&&&&\bullet\r{v}\cr
&\sline(2,-1)&&\sline(2,1)&&\sline(2,-1)&&\sline(2,1)\cr
&&\bullet&&&&\bullet\cr &&u\cap V&&&&U\cap v\cr}$$

\bye
---
tex arrowtest.tex && rexdvi arrowtest.tex
#




#####
#
# The "picture" mode
# 2001nov02
#
#####

# «picture_mode»  (to ".picture_mode")
# «picture-mode» (to ".picture-mode")
#
# Moved to: (find-es "pict2e" "picture-mode")
# Use this instead: (to "pict2e")




#####
#
# \limp: a logical implication symbol (as a thin \supset, in picture mode)
# 2021aug09
#
#####

# «thin_supset»  (to ".thin_supset")
# (find-angg "LATEX/edrx.sty" "limp")
# (find-LATEX "2020hyp.tex" "limp-2020")

cd ~/LATEX/
cat > tmp.tex <<'---'
\documentclass{book}
\begin{document}
aa%
\setlength{\unitlength}{1pt}%
\begin{picture}(10,10)
  \put(0,2){\oval(20,4)[r]}
\end{picture}%
%
zz
\end{document}
---
latex tmp.tex
rexdvi tmp.dvi
# dvifonts tmp.dvi

#
# 2005oct19
# A thin "\supset" char, used as a logical "implies" symbol
# (find-pdf-page  "/usr/share/doc/texlive-doc/latex/amsmath/amsopn.pdf")
# (find-pdftotext "/usr/share/doc/texlive-doc/latex/amsmath/amsopn.pdf")
# (find-pdf-page  "/usr/share/doc/texlive-doc/latex/amsmath/amsldoc.pdf")
# (find-pdftotext "/usr/share/doc/texlive-doc/latex/amsmath/amsldoc.pdf")
# (find-lsrcfile "amsmath/amsopn.sty")
# (find-lsrcfile "amsmath/amsopn.dtx")
# (find-man "texdoc")
# (find-sh "texdoc -l amsldoc")
# (eev "texdoc amsldoc")
# (find-texbookpage (+ 11 389))
# (find-angg "LATEX/edrx.sty" "showboxdims")

%
% (eedn4a-bounded)
% (find-dn4ex "edrx08.sty" "limp")
% (find-texbookpage (+ 12 155) "\\mathrel")
% (find-texbooktext (+ 12 155) "\\mathrel")
% (find-texbookpage (+ 12 155) "$1\\mathord,234$")
% (find-texbooktext (+ 12 155) "$1\\mathord,234$")

\par \def\limp{\mathrel{\limpchar}} $P(par)Q${}$|||$
\par \def\limp{\mathbin{\limpchar}} $P(par)Q${}$|||$
\par \def\limp{\mathrel{\limpchar}} $P(par)${}$|||$
\par \def\limp{\mathbin{\limpchar}} $P(par)${}$|||$

%



#####
#
# How \begin{picture} is defined (in source2e)
# 2019apr22
#
#####

# «begin-picture» (to ".begin-picture")
# Moved to: (find-es "pict2e" "picture-mode-source2e")




#####
#
# \beginpicture(x0,y0)(x1,y1) - this has extremities (x0,y0) and (x1,y1)
# 2019apr22
#
#####

# «beginpicture» (to ".beginpicture")
# (find-LATEX "edrxpict.lua" "beginpicture")
# (find-LATEX "edrxgac2.tex" "beginpicture")






#####
#
# pict2e - supersedes picture mode
# 2015oct09
#
#####

# «pict2e» (to ".pict2e")
# Moved to: (find-es "pict2e")



#####
#
# pict2e: a lua function "pict2evector" and a macro "\Vector"
# 2019apr18
#
#####

# «pict2e-vector» (to ".pict2e-vector")
# Moved to: (find-es "pict2e" "pict2e-vector")




#####
#
# Adjusting vector parameters in pict2e
# 2019apr18
#
#####

# «pict2e-vector-params» (to ".pict2e-vector-params")
# (find-kopkadaly4page (+ 12 300) "Line thickness")
# (find-kopkadaly4text (+ 12 300) "Line thickness")
# (find-pict2epage 5 "2.3.2     Vector")
# (find-pict2etext 5 "2.3.2     Vector")
# (find-pict2epage 6 "Figure 2: Vector")
# (find-pict2etext 6 "Figure 2: Vector")
# (find-pict2epage 7 "Figure 3: Vector: shape variants of the arrow-heads")
# (find-pict2etext 7 "Figure 3: Vector: shape variants of the arrow-heads")
# (find-pict2epage 25 "Figure 10: Sketch of the path")
# (find-pict2etext 25 "Figure 10: Sketch of the path")
# (find-pict2epage 26 "Figure 11: Sketch of the path drawn")
# (find-pict2etext 26 "Figure 11: Sketch of the path drawn")




#####
#
# pict2e-squigbij
# 2019apr19
#
#####

# «pict2e-squigbij» (to ".pict2e-squigbij")
# (find-LATEX "2017planar-has-defs.tex" "squigbij")
# (find-es "tikz" "squiggly-arrows")
# (find-dn6 "picture.lua" "LPicture-tests")
# (find-angg "LUA/lua50init.lua" "trailing-zeroes")
# (find-LATEX "edrxpict.lua" "beginpicture")
# (find-LATEX "2017planar-has-defs.tex" "squigbij")

\unitlength=10pt
\def\closeddot{\circle*{4.0}}
\linethickness{1pt}

% (find-es "tex" "pict2e")
% (find-pict2epage 5 "2.3.2     Vector")
% (find-pict2etext 5 "2.3.2     Vector")
% (find-pict2epage 10 "2.4.4   Ends of paths, joins of subpaths")
% (find-pict2etext 10 "2.4.4   Ends of paths, joins of subpaths")
% (find-pict2epage 5 "\\linethickness")
% (find-pict2etext 5 "\\linethickness")
% (find-kopkadaly4page (+ 12 300) "Line thickness")
% (find-kopkadaly4text (+ 12 300) "Line thickness")
% (find-kopkadaly4page (+ 12 289) "\\put(x,y){pic elem}")
% (find-kopkadaly4text (+ 12 289) "\\put(x,y){pic elem}")

\unitlength=4pt
\linethickness{1.2pt}

a
\bhbox{%
\beginpicture(-5,-1)(17,1)%
  \def\mytriangle(#1,#2)#3{\polygon*(#1,0)(#2,#3)(#2,-#3)}
  \polyline(-3,0)(0,0)%
           (1,1)(3,-1)%
           (5,1)(7,-1)%
           (9,1)(11,-1)%
           (12,0)(14,0)%
  \mytriangle(-5,-2){0.8}
  \mytriangle(17,14){0.8}
\end{picture}%
}
b





#####
#
# pict2e: the "No suitable driver specified" error
# 2017jul15
#
#####

# «pict2e-no-suitable-driver» (to ".pict2e-no-suitable-driver")
# (find-fline "/usr/local/texlive/2017/texmf-dist/tex/latex/pict2e/")
# (find-fline "/usr/local/texlive/2017/texmf-dist/tex/latex/pict2e/p2e-pdftex.def")
# (find-fline "/usr/local/texlive/2017/texmf-dist/tex/latex/pict2e/pict2e.sty" "No suitable driver")
# (find-fline "/usr/local/texlive/2017/texmf-dist/tex/latex/pict2e/pict2e.cfg" "check pdfTeX")
# (find-fline "/usr/local/texlive/2017/texmf-dist/tex/latex/pict2e/pict2e.cfg" "\\ExecuteOptions{pdftex}")

! Package pict2e Error: No suitable driver specified.

See the pict2e package documentation for explanation.

# http://www.tug.org/pipermail/tex-live/2016-July/039038.html
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=853119
# https://github.com/sisl/TikzPictures.jl/issues/15

# (find-angg ".emacs.papers" "pict2e")
# (find-pict2epage 3 "p2e-drivers.dtx")
# (find-pict2etext 3 "p2e-drivers.dtx")




#####
#
# pict2e-grid-on-image
# 2020sep06
#
#####

# «pict2e-grid-on-image»  (to ".pict2e-grid-on-image")
# (find-es "tikz" "grid-on-image")
# (find-LATEX "2020draw-on-tree.tex")





#####
#
# curve2e
# 2020jan17
#
#####

# «curve2e» (to ".curve2e")
# (code-pdf-page "curve2e"  "/usr/local/texlive/2019/texmf-dist/doc/latex/curve2e/curve2e.pdf")
# (code-pdf-text "curve2e"  "/usr/local/texlive/2019/texmf-dist/doc/latex/curve2e/curve2e.pdf")
# (code-pdf-page "curve2em" "/usr/local/texlive/2019/texmf-dist/doc/latex/curve2e/curve2e-manual.pdf")
# (code-pdf-text "curve2em" "/usr/local/texlive/2019/texmf-dist/doc/latex/curve2e/curve2e-manual.pdf")
# (find-curve2empage)
# (find-curve2emtext)
# (find-curve2empage 7 "Figure 1: Three (displaced) identical vectors")
# (find-curve2emtext 7 "Figure 1: Three (displaced) identical vectors")
# (find-curve2epage)
# (find-curve2etext)

https://ctan.org/pkg/curve2e?lang=en




#####
#
# LAPDF - Drawing in TEX with PDF commands
# 2019jan05
#
#####

# «lapdf» (to ".lapdf")
# (find-tlfile "texmf-dist/doc/latex/lapdf/README")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/lapdf/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/lapdf/" "lapdf.pdf")
(code-pdf-page "lapdf" "/usr/local/texlive/2019/texmf-dist/doc/latex/lapdf/lapdf.pdf")
(code-pdf-text "lapdf" "/usr/local/texlive/2019/texmf-dist/doc/latex/lapdf/lapdf.pdf")
;; (find-lapdfpage)
;; (find-lapdftext)




#####
#
# diagmac
# 2016feb12
#
#####

# «diagmac» (to ".diagmac")
# (find-sh "locate diagmac")
# (find-fline    "/usr/share/doc/texlive-doc/latex/diagmac2/")
# (find-fline    "/usr/share/doc/texlive-doc/latex/diagmac2/README")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/diagmac2/doc/diagmac2.pdf")
# (find-fline    "/usr/share/doc/texlive-doc/latex/diagmac2/doc/diagmac2.tex.gz")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/diagmac2/doc/diagmactest.pdf")
# (find-fline    "/usr/share/doc/texlive-doc/latex/diagmac2/doc/diagmactest.tex.gz")




#####
#
# understanding \begin and \end
# 2002apr09 / 2019oct27
#
#####

# «begin»  (to ".begin")
# «newenvironment»  (to ".newenvironment")
# (find-node "(latex)Command Index")
# (find-node "(latex)\newenvironment")
# (find-LATEXgrep "grep --color -nH -e newenv *.tex *.sty")

# (find-source2epage (+ 11 690) "Index")
# (find-source2etext (+ 11 690) "Index")
# (find-source2epage (+ 11 708) "\\begin")
# (find-source2etext (+ 11 708) "\\begin")

# (find-ldtxfile "base/ltmiscen.dtx" "|\\begin{foo}| and |\\end{foo}|")

# (find-ldtxfile "base/")
# (find-ldtxfile "base/ltmiscen.dtx" "\\def\\begin")
# (find-ldtxfile "base/ltmiscen.dtx" "\\def\\end")
# (find-ldtxfile "base/ltdefns.dtx" "\\def\\newenvironment")

# (find-vldifile "tetex-src.list")

# (find-texbytopictext "\\begin{...} ... \\end{...}")
# (find-texbytopicpage (+ 1 131))








#####
#
# calc
# 2019jan05
#
#####

# «calc» (to ".calc")
# (find-tlsh "find * | sort | grep calc")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/calculator/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/calculator/README")
# (find-tlfile "texmf-dist/doc/latex/tools/")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/")
(code-pdf-page "calc" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/calc.pdf")
(code-pdf-text "calc" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/calc.pdf")
;; (find-calcpage)
;; (find-calctext)



#####
#
# realcalc
# 2002apr15 / 2019jan08
#
#####

# «realcalc»  (to ".realcalc")
# (find-tlsh "find * | sort | grep realcalc")

lynx /debian/usr/share/doc/texmf/help/Catalogue/entries/calc.html
lynx /debian/usr/share/doc/texmf/help/Catalogue/entries/realcalc.html

# (find-fline "/usr/share/texmf/tex/latex/tools/calc.sty")
# (find-dvipage "/usr/share/texmf/doc/latex/tools/calc.dvi" 1)
# (find-fline "/debian/usr/share/texmf/source/latex/calc/calc.dtx")
# (find-fline "/debian/usr/share/texmf/source/latex/tools/calc.dtx")

#
rm -Rv $usr_src/realcalc/
cd $usr_src/
tar -xvzf $S/ftp/ftp.dante.de/tex-archive/macros/generic/realcalc.tar.gz
cd $usr_src/realcalc/
grep '%%' realcalc.tex > realcalc.doc
latex realdemo.tex

cp -v realcalc.tex ~/LATEX/

# (code-c-d "realcalc" "$usr_src/realcalc/")
# (find-realcalcfile "readme")
# (find-realcalcfile "realcalc.doc")
# (find-realcalcfile "realcalc.tex")
# (find-realcalcfile "realtest.tex")

#



####
#
# LaTeX-demo (in Portuguese)
# 2002jul08
#
####

# «tex-br»  (to ".tex-br")
# (find-shttpw3 "biquinho.furg.br/tex-br/")

# «LaTeX-demo»  (to ".LaTeX-demo")
#
rm -Rv $usr_src/LaTeX-demo-1.13/
cd     $usr_src/
tar -xvzf $S/http/biquinho.furg.br/tex-br/doc/LaTeX-demo/LaTeX-demo-1.13.tar.gz
cd     $usr_src/LaTeX-demo-1.13/
make demo.dvi

#
# (code-c-d "ltxdemo" "$usr_src/LaTeX-demo-1.13/")
# (find-ltxdemofile "")




#####
#
# cmsy10 scaled
# 2002nov21
#
#####

# «cmsy10_scaled»  (to ".cmsy10_scaled")
# Producing an \otimes in cmsy10 scaled 1000, for Dynkin diagrams.
# See Kopka/Daly pp.62-63.
# (find-lsrcfile "base/fontdef.dtx" "\\otimes}{\\mathbin}{symbols}{\"0A}")
# (find-fline "~/dynkin/")
# (eev "testfont cmsy10")
# (eev "dvifonts ~/LATEX/2002h.dvi | sort")
%
\newfont{\mycmsyten}{cmsy10 scaled 5000}
\def\myox{{\mycmsyten\symbol{"0A}}}
ab{\myox}cd
%




#####
#
# the pullback symbol
# 2003mar29
#
#####

# (find-man "1 xdvi")
# (find-texbookpage 9)
# (find-texbookpage (+ 11 221) "Chapter 21: Making Boxes")
# (find-knuthfile "tex/texbook.tex")
# (find-fline "/usr/share/texmf/tex/plain/base/manmac.tex")
# (find-fline "/usr/share/texmf/tex/plain/base/manmac.tex" "samplebox")
# (find-fline "/usr/share/texmf/tex/plain/base/manmac.tex" "\\def\\setcornerrules")
rexdvi $SCTAN/systems/knuth/tex/texbook.dvi -s 7 -topmargin .9in
%

%\def\setcornerrules{\hbox to \pagewidth{\vrule width 1pc height\ruleht
%    \hfil \vrule width 1pc}
%  \hbox to \pagewidth{\llap{\sevenrm(page \folio)\kern1pc}%
%    \vrule height1pc width\ruleht depth\z@
%    \hfil \vrule width\ruleht depth\z@}}

\par abc\hbox to 1pc{\vrule \vbox to 10pt{\hrule height 2pt width 3pt}}def
\par abc\hbox to 1pc{\vrule \vbox{\hrule \hbox to 10pt{}}}def
\par abc\hbox{\vrule p\vrule}def
\par abc\hbox{\vrule b\vrule}def
\par abc\hbox{\vrule \vbox{\hrule o}\vrule}def
\par abc\hbox{\vrule \vbox{o \hrule}\vrule}def
\par abc\hbox{\vrule \vbox{o}\vrule}def
\par abc\hbox{\vrule\hbox to 10pt{\vbox{o}\vrule}}def
\par abc\hbox{\vrule\hbox to 10pt{\vbox{\hrule \noindent o}\vrule}}def
\par abc\hbox to 1cm{\vrule width 1pc height .5pt \hfil \vrule width 1pc}def

%



#####
#
# bibtex 2017
# 2017ago12
#
#####

# «bibtex-2017» (to ".bibtex-2017")
# (find-angg ".emacs.papers" "bibtex")
# (find-sh "locate bibtex")
# (find-zsh "apt-file search bibtex")
# (find-zsh "apt-file search bibtex | grep texlive")
# (find-zsh "installeddebs | sort | grep bibtex")
# (find-zsh "availabledebs | sort | grep bibtex")
# (find-zsh "grep-available bibtex")
# (find-zsh "grep-status bibtex")
# https://tex.stackexchange.com/questions/tagged/bibtex?sort=faq

# (find-tlsh "find * | sort | grep bibtex")
# (find-tlfile "texmf-dist/doc/bibtex/base/")
# (find-tlfile "texmf-dist/doc/bibtex/base/README")
# (code-pdf-page "btxdoc" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/base/btxdoc.pdf")
# (code-pdf-text "btxdoc" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/base/btxdoc.pdf")
# (find-btxdocpage)
# (find-btxdoctext)


# (find-fline "/usr/share/doc/texlive-doc/bibtex/base/")
# (find-fline "/usr/share/doc/texlive-doc/bibtex/base/README")
# (find-fline "/usr/share/texlive/texmf-dist/bibtex/bib/base/xampl.bib")

# (find-status   "texlive-bibtex-extra")
# (find-vldifile "texlive-bibtex-extra.list")
# (find-udfile   "texlive-bibtex-extra/")

# (find-fline "/usr/share/texlive/texmf-dist/bibtex/bst/")

# (find-man "1 bibtex.original")
# (find-man "1 bibtex8")
# (find-udfile "texlive-doc/bibtex8/")
# (find-udfile "texlive-doc/bibtexu/")

# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page (+ 12 217) "9.3.1   Bibliography by hand")
# (find-kopkadaly4text (+ 12 217) "9.3.1   Bibliography by hand")
# (find-kopkadaly4page (+ 12 217)  "\\bibitem[label]{key}")
# (find-kopkadaly4text (+ 12 217)  "\\bibitem[label]{key}")
# (find-kopkadaly4page (+ 12 219) "9.3.2   Bibliography with BIBTEX")
# (find-kopkadaly4text (+ 12 219) "9.3.2   Bibliography with BIBTEX")
# (find-kopkadaly4page (+ 12 228) "9.4.3      Running MakeIndex")
# (find-kopkadaly4text (+ 12 228) "9.4.3      Running MakeIndex")
# (find-kopkadaly4page (+ 12 309) "\\bibliography{database1,")
# (find-kopkadaly4text (+ 12 309) "\\bibliography{database1,")
# (find-kopkadaly4page (+ 12 310) "With \\nocite{*}, every entry")
# (find-kopkadaly4text (+ 12 310) "With \\nocite{*}, every entry")
# (find-kopkadaly4page (+ 12 310) "\\bibliographystyle{style}")
# (find-kopkadaly4text (+ 12 310) "\\bibliographystyle{style}")
# (find-kopkadaly4page (+ 12 316) "14.2.3 Cross-referencing")
# (find-kopkadaly4text (+ 12 316) "14.2.3 Cross-referencing")



#####
#
# bibtex-test
# 2020feb07
#
#####

# «bibtex-test» (to ".bibtex-test")
# (find-LATEX "2020bibtex-test.tex")




#####
#
# Citing papers from Arxiv in BibTeX
# 2018fev17
#
#####

# «bibtex-arxiv» (to ".bibtex-arxiv")
# https://tex.stackexchange.com/questions/3833/how-to-cite-an-article-from-arxiv-using-bibtex
# (find-LATEX "catsem-u.bib" "bib-Chlipala")




#####
#
# bibliography-by-hand
# 2019sep11
#
#####

# «bibliography-by-hand» (to ".bibliography-by-hand")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page (+ 12 217) "9.3.1   Bibliography by hand")
# (find-kopkadaly4text (+ 12 217) "9.3.1   Bibliography by hand")
# (find-kopkadaly4page (+ 12 217)  "\\bibitem[label]{key}")
# (find-kopkadaly4text (+ 12 217)  "\\bibitem[label]{key}")
# (find-LATEXgrep "grep --color -nH -e thebibliography *")
# (find-classespage 49 "thebibliography")
# (find-classestext 49 "thebibliography")




#####
#
# bibtex
# 2002dec09
#
#####

# «bibtex»  (to ".bibtex")
# (find-angg "LATEX/catsem.bib")
# (find-angg "LATEX/filters.bib")
# (find-sh "locate bibtex")
# (find-zsh "dmissing bibtex")
# (find-fline "/hdd6/snarf/ftp/ftp.cs.cmu.edu/user/jcr/ReynoldsJC.bib")
# (find-fline "/hdd6/snarf/ftp/ftp.math.mcgill.ca/pub/rags/SeelyRAG.bib")
# (find-fline "/hdd6/snarf/http/hypatia.dcs.qmw.ac.uk/author/FreydPJ/bilbio.bib.html")
# (find-fline "$S/ftp/ftp.imf.au.dk/pub/kock/KockA.bib")
# (find-fline "/usr/share/doc/texmf/bibtex/base/")
# (find-fline "/usr/share/doc/texmf/bibtex/base/btxdoc.tex.gz")
# (find-fline "/usr/share/doc/texmf/bibtex/base/btxdoc.bib")
# (code-dvi "btxdoc" "/usr/share/doc/tetex-doc/bibtex/base/btxdoc.dvi.gz")
# (code-dvi "btxdoc" "/tmp/bib/btxdoc.dvi")
# (find-btxdocpage 11 "Helpful Hints")
# (find-lsrcfile "natbib/")
# (find-lsrcfile "natbib/README.1st")
# (find-lsrcfile "lshort/src/spec.tex" "\\section{Bibliography}")
# (find-dvipage "/usr/share/doc/texmf/latex/general/lshort.dvi.gz" (+ 14 57))
#
# (find-sh "locate btxdoc")
# (find-fline "/usr/share/doc/texlive-base/bibtex/base/")
# (find-fline "/usr/share/doc/texlive-doc/bibtex/base/")

rm -Rv /tmp/bib/
mkdir  /tmp/bib/
cd     /tmp/bib/
cp -v /usr/share/doc/texlive-base/bibtex/base/* .
gunzip -v *.gz
# (find-fline "/usr/share/doc/texmf/bibtex/base/btxdoc.tex.gz" "running")
# (find-man "1 bibtex")
latex  btxdoc.tex
bibtex btxdoc
latex  btxdoc.tex
latex  btxdoc.tex

#
rm -Rv /tmp/bib2/
mkdir  /tmp/bib2/
cd     /tmp/bib2/
cat > ragsmini.bib <<'%%%'
@article{SeelyRAG:cshoplc,
 author		= {R. A. G. Seely},
 title		= {Categorical Semantics for Higher Order Polymorphic
                   Lambda Calculus},
 journal	= {Journal of Symbolic Logic},
 volume		= {52},
 number		= {4},
 pages		= {969--988},
 checked	= {Yes},
 month		= {dec},
 year		= 1987}
%%%
cat > bibtest.tex <<'%%%'
\documentclass{article}
\begin{document}
% \cite{SeelyRAG:cshoplc}
\nocite{*}
\bibliography{ragsmini}
% \bibliographystyle{plain}
\bibliographystyle{alpha}
\end{document}
%%%

latex  bibtest.tex
bibtex bibtest
latex  bibtest.tex
latex  bibtest.tex

rexdvi bibtest.dvi
#
# (find-fline "/tmp/bib2/")
# (find-lsrcfile "base/")
# (find-lsrcfile "base/ltbibl.dtx")
# (find-fline "/usr/share/texmf/bibtex/")

# (find-fline "/usr/share/texmf/bibtex/bst/ams/amsalpha.bst")
# (find-fline "/usr/share/texmf/bibtex/bst/base/alpha.bst")
# (find-fline "/usr/share/texmf/bibtex/bst/plbib/plalpha.bst")
# (find-fline "/usr/share/texmf/source/latex/amscls/amsalpha.bst")




#####
#
# makebbl
# 2003jul04
#
#####

# «makebbl»  (to ".makebbl")
# (find-angg ".zshrc" "makebbl")
# (find-LATEX "catsem.bib" "test")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page (+ 12 309) "\\bibliography{database1,")
# (find-kopkadaly4text (+ 12 309) "\\bibliography{database1,")
# (find-kopkadaly4page (+ 12 310) "With \\nocite{*}, every entry")
# (find-kopkadaly4text (+ 12 310) "With \\nocite{*}, every entry")
# (find-kopkadaly4page (+ 12 310) "\\bibliographystyle{style}")
# (find-kopkadaly4text (+ 12 310) "\\bibliographystyle{style}")
# (find-kopkadaly4page (+ 12 316) "14.2.3 Cross-referencing")
# (find-kopkadaly4text (+ 12 316) "14.2.3 Cross-referencing")
#
rm -Rv /tmp/tmpbib/
mkdir  /tmp/tmpbib/
cd     /tmp/tmpbib/
cp ~/LATEX/catsem.bib .
cp ~/LATEX/filters.bib .
cat > tmpbib.tex <<'%%%'
\documentclass{book}
\begin{document}
\nocite{*}
% \bibliography{catsem}
\bibliography{catsem,filters}
% \bibliography{filters}
\bibliographystyle{alpha}
\end{document}
%%%
latex tmpbib.tex
bibtex tmpbib
# latex tmpbib.tex
# latex tmpbib.tex

#
rm -Rv /tmp/tmpbib/
mkdir  /tmp/tmpbib/
cd     /tmp/tmpbib/
cp ~/LATEX/catsem.bib .
function makebbl () {
  echo -E '\documentclass{book}'	>  tmpbib.tex
  echo -E '\begin{document}'		>> tmpbib.tex
  echo -E '\nocite{*}'			>> tmpbib.tex
  for i in $*[2,-1]; do
    echo -E '\bibliography{'$i'}'	>> tmpbib.tex
  done
  echo -E '\bibliographystyle{alpha}'	>> tmpbib.tex
  echo -E '\end{document}'		>> tmpbib.tex
  latex  tmpbib.tex
  bibtex tmpbib
  cp -v tmpbib.bbl $1
}

makebbl mybib.bbl catsem

cat > test.tex <<'%%%'
\documentclass[oneside]{book}
\begin{document}
See \cite{GeuversPhD}.
\input mybib.bbl
\end{document}
%%%
latex test.tex
latex test.tex
rexdvi test.dvi

#



#####
#
# biber
# 2017mar28
#
#####

# «biber» (to ".biber")
# «biblatex» (to ".biblatex")
# (find-angg ".emacs.papers" "biber")
# (find-angg ".emacs.papers" "biblatex")
# (find-tlsh "find * | sort | grep biber")
# (find-tlsh "find * | sort | grep biblatex")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/bibtex/biber/")
(code-pdf-page "biber" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/biber/biber.pdf")
(code-pdf-text "biber" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/biber/biber.pdf")
;; (find-biberpage)
;; (find-bibertext)


# (find-tlsh "find * | sort | grep biblatex.sty")
# (find-sh "apt-file search biblatex.sty")
# (find-sh "apt-file search biblatex.sty" "texlive-bibtex-extra")

# (find-angg ".emacs.papers" "biber")
# (find-angg ".emacs.papers" "biblatex")
# http://biblatex-biber.sourceforge.net/
# https://en.wikipedia.org/wiki/Biber_(LaTeX)
# https://tex.stackexchange.com/questions/25701/bibtex-vs-biber-and-biblatex-vs-natbib/25702#25702
# https://tex.stackexchange.com/questions/5091/what-to-do-to-switch-to-biblatex#5105
# https://tex.stackexchange.com/questions/201843/biber-warning-about-non-ascii-characters
# https://tex.stackexchange.com/questions/26516/how-to-use-biber
# (find-zsh "availabledebs | sort | grep biber")
# (find-zsh "availabledebs | sort | grep biblatex")
# (find-zsh "apt-file search biblatex")
# (find-udfile "texlive-doc/latex/biblatex/")
# (find-udfile "texlive-doc/latex/biblatex/examples/")
# (find-udfile "texlive-doc/latex/biblatex/examples/biblatex-examples.bib.gz")

# (find-status   "biber")
# (find-vldifile "biber.list")
# (find-udfile   "biber/")

# (find-man "3pm Biber")
# (find-man "3pm Biber::Config")
# (find-man "3pm Biber::Constants")
# (find-man "3pm Biber::DataModel")
# (find-man "3pm Biber::Entries")
# (find-man "3pm Biber::Entry")
# (find-man "3pm Biber::Entry::Name")
# (find-man "3pm Biber::Entry::Names")
# (find-man "3pm Biber::Input::file::biblatexml")
# (find-man "3pm Biber::Input::file::bibtex")
# (find-man "3pm Biber::Input::file::endnotexml")
# (find-man "3pm Biber::Input::file::ris")
# (find-man "3pm Biber::Input::file::zoterordfxml")
# (find-man "3pm Biber::Internals")
# (find-man "3pm Biber::LaTeX::Recode")
# (find-man "3pm Biber::Output::base")
# (find-man "3pm Biber::Output::bbl")
# (find-man "3pm Biber::Output::biblatexml")
# (find-man "3pm Biber::Output::bibtex")
# (find-man "3pm Biber::Output::dot")
# (find-man "3pm Biber::Output::test")
# (find-man "3pm Biber::Section")
# (find-man "3pm Biber::Sections")
# (find-man "3pm Biber::SortList")
# (find-man "3pm Biber::SortLists")
# (find-man "3pm Biber::Utils")
# (find-man "1p biber")



# Package logreq Error: File '2017yoneda.run.xml' not created by logreq.
# See the logreq package documentation for explanation.

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
locate logreq
dmissing logreq
apt-file search logreq

# (find-status   "logreq")
# (find-vldifile "logreq.list")
# (find-udfile   "logreq/")

apti logreq
install logreq in the new TeX




#####
#
# Running biber on PH1
# 2019may28
#
#####

# «biber-ph1» (to ".biber-ph1")
# (find-LATEXfile "catsem-u.bib")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/
flsfiles-tgz 2017planar-has-1.fls 2017planar-has-1.tgz

# (find-fline "/tmp/ph1/")
rm -Rfv /tmp/ph1/
mkdir   /tmp/ph1/
cd      /tmp/ph1/
tar -C  /tmp/ph1/ -xvzf ~/LATEX/2017planar-has-1.tgz
rm -v /tmp/ph1/2017planar-has-1.bbl
rm -v /tmp/ph1/2017planar-has-1.run.xml
cp -v     ~/LATEX/catsem-u.bib .
cp -v     ~/LATEX/2017planar-has-1.mk Makefile

make veryclean
make pdf
make clean
rm -v  /tmp/ochs-planar-has.zip
zip -r /tmp/ochs-planar-has.zip *
# (find-fline "/tmp/ochs-planar-has.zip")

rm -Rfv /tmp/ph1/
mkdir   /tmp/ph1/
cd      /tmp/ph1/
unzip   /tmp/ochs-planar-has.zip
make veryclean
make pdf
make clean

rm -Rfv /tmp/ph1/
mkdir   /tmp/ph1/
cd      /tmp/ph1/
unzip   /tmp/ochs-planar-has.zip
lualatex 2017planar-has-1.tex
biber    2017planar-has-1
lualatex 2017planar-has-1.tex

# lualatex 2017planar-has-1.tex
# (find-pdf-page "/tmp/ph1/2017planar-has-1.pdf")
# (find-fline    "/tmp/ph1/")

echo $PATH



Oi Marcelo!

Desculpa a demora... eu realmente achei que ia conseguir terminar tudo
oito dias atrás...

Ainda falta uma ultimíssima revisão pra ver se tem typos e
coisas assim no abstract, na introdução e na seção 10, que
foram totalmente reescritas, e parece que a partir de um pouco depois
da meia-noite de hoje eu vou poder trocar uma das URLs pra coisas
minhas - a da "Notes on the Yoneda Lemma etc etc" - pra uma URL no
Arxiv...

Se você tiver 5 minutos livres hoje você pode testar o .zip em
anexo pra ver se ele realmente está fácil de compilar por
"humanos normais"? As instruções são:

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
export PATH=/home/edrx/bin:/home/edrx/.local/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games:/usr/local/games:.:/home/edrx/bin:/home/edrx/EXPECT:/home/edrx/TCL:/home/edrx/pkg/bin

  # Unpack the .zip in a clean directory - e.g., with:
  rm -Rfv /tmp/ochs-planar-has/
  mkdir   /tmp/ochs-planar-has/
  cd      /tmp/ochs-planar-has/
  unzip   /tmp/ochs-planar-has.zip

  # Optional: remake the PDF, with:
  lualatex 2017planar-has-1.tex
  biber    2017planar-has-1
  lualatex 2017planar-has-1.tex

  # Another way to remake the PDF (using the Makefile):
  make veryclean
  make pdf
  make clean

[[]],
  Eduardo...




#####
#
# biber-ph1-biblatex
# 2019jun03
#
#####

# «biber-ph1-biblatex» (to ".biber-ph1-biblatex")
# (code-c-d "ochspla" "/tmp/ochs-planar-has/")
# (find-ochsplafile "")
# (find-ochsplagrep "grep --color -nH -e biblatex *")

# (find-zsh "apt-file search biblatex")
# (find-zsh "apt-file search biblatex.sty")
# (find-zsh "apt-file search diagxy")
# (find-zsh "availabledebs | sort | grep biber")

Oi Marcelo!

Eu tou pesquisando aqui e tentando montar hipóteses sobre o que
pode estar acontecendo... umas peguntas: 1) que distribuição
você usa? 2) É Debian, Ubuntu ou alguma variante delas? 3)
Você está usando os pacotes latex dela, né? 4) Você tem
aí um texlive "upstream" instalado diretamente a partir de alguma
página como esta aqui?...

  https://www.tug.org/texlive/doc.html

Se as respostas pra (2) e pra (3) forem "sim" e a resposta pra (4) for
"não" - obs: isto é o default; dá pra ter os pacotes latex do
Debian e um texlive upstream instalados ao mesmo tempo, mas isto
não é algo totalmente trivial - então TALVEZ isto aqui
resolva o problema:

  sudo apt-get install biber texlive-bibtex-extra
  sudo apt-get install texlive-generic-extra

Você pode tentar?

  [[]],
    Eduardo



Oi Marcelo!

Acho que consegui fazer um truque aqui pra rodar a mesma versão do
texlive/lualatex/biber/etc que você. Eu tinha pedido pra você
rodar isto aqui pra compilar o meu .tex, né?

  # Unpack the .zip in a clean directory - e.g., with:
  rm -Rfv /tmp/ochs-planar-has/
  mkdir   /tmp/ochs-planar-has/
  cd      /tmp/ochs-planar-has/
  unzip   /tmp/ochs-planar-has.zip

  # Optional: remake the PDF, with:
  lualatex 2017planar-has-1.tex
  biber    2017planar-has-1
  lualatex 2017planar-has-1.tex

Você pode tentar o segundo método? Pode ser que os erros estejam
vindo de algum arquivo temporário deixado por uma tentativa
anterior de compilação... o segundo método, abaixo, deleta
todos os arquivos temporários. Tente:

  # Unpack the .zip in a clean directory - e.g., with:
  rm -Rfv /tmp/ochs-planar-has/
  mkdir   /tmp/ochs-planar-has/
  cd      /tmp/ochs-planar-has/
  unzip   /tmp/ochs-planar-has.zip

  # Another way to remake the PDF (using the Makefile):
  make veryclean
  make pdf
  make clean


[[]],
  Eduardo



#####
#
# Forcing \cite{OchsPH1} to appear as [PH1]
# 2019aug22
#
#####

# «biber-shorthands»  (to ".biber-shorthands")
# (find-LATEXgrep "grep --color -nH -e PH1 2019elephant*.tex *.bib")
# (find-LATEXgrep "grep --color -nH -e PH1 2019elephant*.tex 2019ilha-grande-poster*.tex *.bib")
# (find-LATEXgrep "grep --color -nH -e PH1 2019ilha-grande-poster*.tex *.bib")
# https://tex.stackexchange.com/questions/73913/how-can-i-use-shorthands-in-citations-from-the-first-time-with-biblatex
# https://tex.stackexchange.com/questions/432230/how-to-use-shorthand-in-biblatex-without-altering-the-bibliography-entry?rq=1
# https://www.texdev.net/2014/03/30/biblatex-more-versatile-shorthand-lists/

# (find-biblatexfile "examples/biblatex-examples.bib" "shorthand" "= {KpV}")
# (find-LATEX "catsem-u.bib" "bib-Ochs")
# (find-LATEX "catsem-u.bib" "bib-Ochs" "PH1")


# (find-biblatexpage)
# (find-biblatextext)
# (find-biblatexpage 72 "alphabetic label")
# (find-biblatextext 72 "alphabetic label")
# (find-biblatexpage 24 "shorthand field")
# (find-biblatextext 24 "shorthand field")
# (find-biblatexpage 83 "bibliography/shorthands")
# (find-biblatextext 83 "bibliography/shorthands")
# (find-biblatexpage 92 "biblist")
# (find-biblatextext 92 "biblist")
# (find-biblatexpage 141 "3.14.5 Bibliography Filters and Citation Labels")
# (find-biblatextext 141 "3.14.5 Bibliography Filters and Citation Labels")
# (find-biblatexpage 215 "\\DeclareBiblistFilter{shorthand}")
# (find-biblatextext 215 "\\DeclareBiblistFilter{shorthand}")




#####
#
# biber-git
# 2019dec12
#
#####

# «biber-git» (to ".biber-git")
# https://en.wikipedia.org/wiki/Biber_(LaTeX)
# https://github.com/plk/biber
# https://github.com/plk/biber/issues
# (find-git-links "https://github.com/plk/biber" "biber")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/biber/
cd      ~/usrc/
git clone https://github.com/plk/biber
cd      ~/usrc/biber/

export PAGER=cat
git branch --list -a
git for-each-ref
PAGER=cat git log --oneline --graph --all -20

git checkout v2.8

# (find-fline "~/usrc/")
# (find-fline "~/usrc/biber/")
# (find-gitk  "~/usrc/biber/")

# (code-c-d "biber" "~/usrc/biber/")
# (find-biberfile "")
# (find-biberfile "doc/biber.tex")
# (find-biberfile "TODO.org")
# (find-biberfile "doc/biber.tex" "\\subsection{Building}")




#####
#
# biber-2.8-from-git
# 2020jun28
#
#####

# «biber-2.8-from-git» (to ".biber-2.8-from-git")
# (find-sh "locate biber | grep pdf")
# (code-pdf-page "biber" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/biber/biber.pdf")
# (code-pdf-text "biber" "/usr/local/texlive/2019/texmf-dist/doc/bibtex/biber/biber.pdf")
# (find-biberpage)
# (find-bibertext)
# (find-biberpage 5 "Biber version   Biblatex version")
# (find-bibertext 5 "Biber version   Biblatex version")
# (find-biberpage 5 "2.8             3.8")
# (find-bibertext 5 "2.8             3.8")
# (find-biberpage 52 "4.4. Building")
# (find-bibertext 52 "4.4. Building")

sudo apt-get build-dep -y biber
apti libmodule-build-perl
apti libmojomojo-perl

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biber/
git reset
perl ./Build.PL  |& tee opb
./Build help
./Build help clean
./Build help realclean
./Build installdeps
sudo ./Build install   |& tee obi

# (find-fline "/usr/local/bin/" "biber")
# (find-fline "/usr/local/share/perl/5.28.1/" "Biber")
# (find-fline "/usr/local/man/man3/" "Biber")

sudo rm -Rfv /usr/local/bin/biber
sudo rm -Rfv /usr/local/share/perl/5.28.1/Biber*
sudo rm -Rfv /usr/local/man/man3/Biber*

sudo ./Build install   |& tee obi

w biber
echo $PATH
export PATH=/usr/local/bin:$PATH
w biber
biber
biber --version

# (find-biberfile "")

# (find-fline "/usr/local/lib/x86_64-linux-gnu/perl/5.28.1/")

# (find-sh "apt-file search META.json")
# (find-sh "apt-file search META.yml")
# (find-sh "apt-file search perl5 | grep ENCODE")




#####
#
# biblatex-git
# 2020jun28
#
#####

# «biblatex-git» (to ".biblatex-git")
# https://github.com/plk/biblatex
# https://github.com/plk/biblatex/issues
# https://github.com/plk/biblatex/wiki
# https://github.com/plk/biblatex/wiki/biblatex-and-the-arXiv
# https://github.com/plk/biblatex/wiki/biblatex-and-the-arXiv#bbl-files-in-arxiv-uploads

# (find-sh "locate biblatex")
# (find-sh "locate biblatex | grep pdf")
# (code-c-d "biblatexdoc" "/sda1/usr/local/texlive/2019/texmf-dist/doc/latex/biblatex/")
# (code-pdf-page "biblatex" "/sda1/usr/local/texlive/2019/texmf-dist/doc/latex/biblatex/biblatex.pdf")
# (code-pdf-text "biblatex" "/sda1/usr/local/texlive/2019/texmf-dist/doc/latex/biblatex/biblatex.pdf")
# (find-biblatexdocfile "")
# (find-biblatexpage)
# (find-biblatextext)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# rm -Rfv ~/usrc/biblatex/
cd      ~/usrc/
git clone https://github.com/plk/biblatex
cd      ~/usrc/biblatex/

export PAGER=cat
git branch --list -a
git for-each-ref
git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/biblatex/")
# (find-gitk  "~/usrc/biblatex/")

# (code-c-d "biblatex" "~/usrc/biblatex/")
# (find-biblatexfile "")
# (find-biblatexsh "find * | sort")
# (find-biblatexfile "README.md" "obuild/build.sh")
# (find-biblatexfile "obuild/build.sh")
# (find-biblatexfile "obuild/test/examples/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd      ~/usrc/biblatex/
git checkout v3.8
git reset

obuild/build.sh help
obuild/build.sh build 3.8
obuild/build.sh install 3.8 ~/texmf/
obuild/build.sh uninstall   ~/texmf/

# (find-fline "~/texmf/")
# (find-fline "~/texmf/tex/latex/biblatex/")
# (find-fline "~/texmf/tex/latex/biblatex/biblatex.sty" "\\def\\abx@version")
# (find-fline "~/texmf/tex/latex/biblatex/biblatex.sty" "expected \\blx@bblversion")

# obuild/build.sh testbiber

# «biblatex-git-dirs»  (to ".biblatex-git-dirs")
#
# (find-fline     "/tmp/texmf/")
# (find-sh-at-dir "/tmp/texmf/" "find * | sort")
# (find-sh-at-dir "/tmp/texmf/" "find * -type d | sort")

cd      ~/usrc/biblatex/
rm -Rv /tmp/texmf/
mkdir  /tmp/texmf/
obuild/build.sh   install 3.8 /tmp/texmf
cd /tmp/texmf/
ls -laFd biber bibtex doc/latex/biblatex tex/latex/biblatex


# «biblatex-git-install»  (to ".biblatex-git-install")
#
cd      ~/usrc/biblatex/
obuild/build.sh install 3.8 ~/texmf

# «biblatex-git-uninstall»  (to ".biblatex-git-uninstall")
#
rm -Rfv ~/texmf/biber/
rm -Rfv ~/texmf/bibtex/
rm -Rfv ~/texmf/doc/latex/biblatex/
rm -Rfv ~/texmf/tex/latex/biblatex/










#####
#
# betterbib
# 2017out12
#
#####

# «betterbib» (to ".betterbib")
# https://github.com/nschloe/betterbib




#####
#
# \pmb: poor man's bold
# 2023oct30
#
#####

# «pmb»  (to ".pmb")
# «poor-mans-bold»  (to ".poor-mans-bold")
# (find-texbookpage (+ 12 386) "poor" "man's bold")
# (find-texbooktext (+ 12 386) "poor" "man's bold")




#####
#
# \co: a low-level way to typeset code; a poor man's "\verb"
# 2019feb03
#
#####

# «co» (to ".co")
# «poor-mans-code»  (to ".poor-mans-code")
# (find-LATEX "edrx21defs.tex" "co")
# (find-LATEX "2019emacsconf.tex" "co")
# (find-LATEX "2019emacsconf.tex" "co" "\\cocolor")
# (find-LATEXfile "2019xysyntax.tex" "\\co:")
# (find-LATEXfile "2018tugboat-rev1.tex" "\\co:")
# (find-LATEX "2021excuse.tex" "co")
# (find-LATEXgrep "grep --color -nH -e '\\\\def\\\\co#1' *.tex")
# (find-texbookpage (+ 12 43) "\\char")
# (find-texbooktext (+ 12 43) "\\char")
# Version in Lua:
#   (find-angg "LUA/Co1.lua")

% (find-es "tex" "co")
% \co: a low-level way to typeset code; a poor man's "\verb"
\def\co#1{{%
  \def\%{\char37}%
  \def\\{\char92}%
  \def\^{\char94}%
  \def\~{\char126}%
  \tt#1%
  }}
\def\qco#1{`\co{#1}'}
\def\qqco#1{``\co{#1}''}




#####
#
# generating tables of contents automatically
# 2002dec24
#
#####

# «TOCs»  (to ".TOCs")
#
rm -Rv /tmp/latextoc/
mkdir  /tmp/latextoc/
cd     /tmp/latextoc/
cat > test.tex <<'%%%'
\documentclass{book}
\begin{document}
\par Title page
\tableofcontents
\chapter{chapter the 1st}
\section{section the 1st.1st}
\section{section the 1st.2st}
\chapter{chapter the 2st}
\chapter{chapter the 3st}
\end{document}
%%%
latex test.tex
latex test.tex
#
# (find-fline "/tmp/latextoc/")
# (find-fline "/tmp/latextoc/test.toc")

#



#####
#
# generating a "mytoc" and producing an eev-ish "to" index from it
# 2002dec24 / 2005jul08
#
#####

# «mytoc»  (to ".mytoc")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-angg ".zshrc" "mytoctoeevlinks")
# (find-texbookfile "")
# (find-texbookpage (+ 11 226))
# (find-texbookfile "texbook.tex")
# (find-texbookfile "texbook.tex" "^|\\newwrite| command")
# (find-texbookfile "texbook.tex" "^|\\newwrite||{\\alloc@7\\write")
#
rm -Rv /tmp/latextoc/
mkdir  /tmp/latextoc/
cd     /tmp/latextoc/
cat > test.tex <<'%%%'
\documentclass{book}
\begin{document}
  % \makeatletter\@starttoc{mytoc}\makeatother
  % (find-lsrcfile "base/ltsect.dtx" "|\\@starttoc|")
  % (find-lsrcfile "base/ltsect.dtx" "\\def\\@starttoc")
  % (find-lsrcfile "base/ltplain.dtx" "\\def\\newwrite")
  % (find-lsrcgrep "grep -nH -e addtocontents base/*.dtx")
  % (find-lsrcgrep "grep -nH -e tf@ base/*.dtx")
  % (find-lsrcfile "base/ltsect.dtx" "\\def\\addtocontents#1#2")
  % (find-lsrcfile "base/ltsect.dtx" "\\def\\@starttoc#1")
  % (find-lsrcfile "base/ltsect.dtx" "open \\jobname.EXT as file \\tf@EXT")
  % (find-source2epage 'ltplain +3)
  % (find-knuthfile "tex/texbook.tex" "csname")
  \makeatletter
    \newwrite\tf@mytoc
     \openout\tf@mytoc=\jobname.mytoc
  \makeatother
  \def\mychapter#1#2{\chapter{#1}\label{#2}\addtocontents{mytoc}{: #2}}
  \def\mysection#1#2{\section{#1}\label{#2}\addtocontents{mytoc}{:: #2}}
\par Title page
\tableofcontents
\mychapter{chapter the 1st}{ch1}
\mysection{section the 1st.1st}{sec1.1}
\mysection{section the 1st.2st}{sec1.2}
\mychapter{chapter the 2st}{ch2}
\mychapter{chapter the 3st}{ch3}
\end{document}
%%%
latex test.tex \
  && latex test.tex
cat test.mytoc | mytoctoeevlinks
#
# (find-fline "/tmp/latextoc/")
# (find-fline "/tmp/latextoc/test.toc")
# (find-fline "/tmp/latextoc/test.mytoc")

#
# (find-lsrcfile "base/classes.dtx" "tableofcontents")
# (find-lsrcfile "base/ltsect.dtx" "\\def\\addtocontents")
# (find-lsrcfile "base/ltsect.dtx" "\\def\\addcontentsline")
# (find-lsrcfile "base/ltsect.dtx" "\\begin{macro}{\\@starttoc}")
# (find-lsrcfile "base/ltsect.dtx" "\\def\\@starttoc")
# (find-lsrcfile "base/ltplain.dtx" "\\def\\newwrite")
# (find-knuthfile "tex/texbook.tex" "writes\none line to a file")
# (find-knuthfile "tex/texbook.tex" "|\\openout|\\<number>|=|\\<file name>")




#####
#
# \tableofcontents
# 2018fev07
#
#####

# «tableofcontents» (to ".tableofcontents")
# (find-kopkadaly4page (+ 12  58)  "3.4 Table of contents")
# (find-kopkadaly4text (+ 12  58)  "3.4 Table of contents")
# (find-source2epage (+ 8 287) "\\tableofcontents")
# (find-source2etext (+ 8 287) "\\tableofcontents")
# (find-source2epage (+ 8 431) "Index")
# (find-source2etext (+ 8 431) "Index")
# (find-classespage 38 "8.1      Table of Contents")
# (find-classestext 38 "8.1      Table of Contents")
# (find-classespage 38 "\\contentsline{name}")
# (find-classestext 38 "\\contentsline{name}")
# (find-classespage 39 "\\@starttoc{toc}")
# (find-classestext 39 "\\@starttoc{toc}")
# (find-classespage 41 "\\l@section")
# (find-classestext 41 "\\l@section")




#####
#
# Using \tableofcontents but changing \contentsline
# 2012dec27 / 2019feb19
#
#####

# «contentsline» (to ".contentsline")
# See: (to "section")
#      (to "dottedcline")
# Example: (find-LATEX "2017yoneda.tex" "index-of-sections")
#          (yonp 2 "index-of-sections")
#          (yona   "index-of-sections")

# (find-tlsh "find * | sort | grep article")
# (find-tlfile "texmf-dist/tex/latex/base/" "article.cls")
# (find-tlfile "texmf-dist/tex/latex/base/article.cls" "\\l@subsection{\\@dottedtocline")
# (find-anggfile "quadradinho/quadradinho-a5.aux")
# (find-anggfile "quadradinho/quadradinho-a5.toc")
# (find-source2epage (+ 10 712) "\\contentsline")
# (find-source2etext (+ 10 712) "\\contentsline")

# (find-classespage 44 "8.1      Table of Contents, etc.")
# (find-classestext 44 "8.1      Table of Contents, etc.")
# (find-classespage 48 "\\l@section")
# (find-classestext 48 "\\l@section")



#####
#
# contentsline-Show2
# 2023may29
#
#####

# «contentsline-Show2»  (to ".contentsline-Show2")
# (find-es "tex" "tableofcontents" "\\tableofcontents")

 (find-code-show2 "~/LATEX/Show2.tex")
       (code-show2 "~/LATEX/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()

outertexbody = Dang.from [=[
\documentclass{article}
\usepackage{hyperref}
\usepackage[<<geometry>>]{geometry}
<<usepackages>>
<<defrepl>>
\begin{document}
\pagestyle{empty}
<<defs>>
<<texbody>>
<<saysuccess>>
\end{document}
]=]

texbody = [[
\tableofcontents
  \contentsline   {section}{\numberline {20}SB}{42}{section.30}
  \contentsline{subsection}{\numberline {42}SB}{99}{section.2}

Aaa \dotfill Zzz

\href{page.2}{p2}

\hyperlink{page.2}{poo}

\section{SA}
\subsection{SSAA}
\subsection{SSAB}
\section{SB}
\section{SC}
\condrepl
]]
= show()
= show()
 (etv)

 (find-fline "~/LATEX/Show2.aux")

\@writefile{toc}{\contentsline {section}{\numberline {1}SA}{2}{section.1}\protected@file@percent }
\@writefile{toc}{\contentsline {subsection}{\numberline {1.1}SSAA}{2}{subsection.1.1}\protected@file@percent }
\@writefile{toc}{\contentsline {subsection}{\numberline {1.2}SSAB}{2}{subsection.1.2}\protected@file@percent }
\@writefile{toc}{\contentsline {section}{\numberline {2}SB}{2}{section.2}\protected@file@percent }
\@writefile{toc}{\contentsline {section}{\numberline {3}SC}{2}{section.3}\protected@file@percent }

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/ && REPL=1 lualatex Show2.tex
printmeaning "tableofcontents"
printmeaning "@starttoc"
printmeaning "protected@file@percent"
printmeaning "contentsline"
printmeaning "l@section"
printmeaning "l@subsection"
printmeaning "numberline"
printmeaning "hb@xt@"

printmeaning "Hy@linktoc"
printmeaning "Hy@safe@activestrue"
printmeaning "Hy@temp"
printmeaning "Hy@tocdestname"
printmeaning "hyper@linkend"
printmeaning "hyper@linkstart"
printmeaning "ltx@empty"







#####
#
# tocloft
# 2020jun14
#
#####

# «tocloft» (to ".tocloft")
# Google: how do I change the format of the table of contents in latex
# https://tex.stackexchange.com/questions/157396/formatting-of-the-table-of-contents
# https://texblog.org/2011/09/09/10-ways-to-customize-tocloflot/
# https://texfaq.org/FAQ-tocloft
# https://texblog.org/tag/tocloft/
# https://texblog.org/2011/09/09/10-ways-to-customize-tocloflot/
# https://texblog.org/2013/07/16/how-to-add-extra-space-to-the-table-of-contents-list-of-figures-and-tables/
# https://tex.stackexchange.com/questions/197369/how-to-use-tocloft-to-create-a-list-which-appears-in-the-middle-of-the-document
# (find-tlsh "find * | sort | grep tocloft")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/tocloft/README")
# (code-pdf-page "tocloft" "/usr/local/texlive/2019/texmf-dist/doc/latex/tocloft/tocloft.pdf")
# (code-pdf-text "tocloft" "/usr/local/texlive/2019/texmf-dist/doc/latex/tocloft/tocloft.pdf")
# (find-tocloftpage)
# (find-toclofttext)
# (find-tocloftpage 7 "2.2    Changing the titles")
# (find-toclofttext 7 "2.2    Changing the titles")
# (find-tocloftpage 7 "\\cfttoctitlefont \\contentsname")
# (find-toclofttext 7 "\\cfttoctitlefont \\contentsname")
# (find-tocloftpage 9 "\\cftbeforeXskip")
# (find-toclofttext 9 "\\cftbeforeXskip")

# Other TOC-related packages:
# (find-tlsh "find * | sort | grep tocstyle")
# (find-tlsh "find * | sort | grep tocstyle")
# (find-tlsh "find * | sort | grep eloft")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/koma-script/README")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/koma-script/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/koma-script/tocstyle.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/koma-script/tocstyle.pdf")

# https://latex.org/forum/viewtopic.php?t=1196 amsbook.cls
# (find-tlsh "find * | sort | grep amsbook")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/amscls/")




#####
#
# \footnote
# 2022oct11
#
#####

# «footnote»  (to ".footnote")
# (find-kopkadaly4page (+ 12 112) "4.10.1 Standard footnotes")
# (find-kopkadaly4text (+ 12 112) "4.10.1 Standard footnotes")
# (find-kopkadaly4page (+ 12 114) "\\footnote[num]{footnote text}")
# (find-kopkadaly4text (+ 12 114) "\\footnote[num]{footnote text}")



#####
#
# "The ulem package: underlining for emphasis"
# 2022oct11
#
#####

# «ulem»           (to ".ulem")
# «strikethrough»  (to ".strikethrough")
# (find-tlsh "find * | sort | grep ulem")
# (find-tlfile "texmf-dist/doc/generic/ulem/")
# (code-pdf-page "ulem" "/usr/local/texlive/2019/texmf-dist/doc/generic/ulem/ulem.pdf")
# (code-pdf-text "ulem" "/usr/local/texlive/2019/texmf-dist/doc/generic/ulem/ulem.pdf")
# (find-ulempage)
# (find-ulemtext)
# (find-ulempage 1 "\\sout" "line struck through word")
# (find-ulemtext 1 "\\sout" "line struck through word")





#####
#
# Some math commands fail inside \chapter, \section, etc
# 2002dec25
#
#####

#
rm -Rv /tmp/latexbug/
mkdir  /tmp/latexbug/
cd     /tmp/latexbug/
cat > test.tex <<'%%%'
\documentclass{book}
\usepackage{amsmath}
\begin{document}
\tableofcontents
$a \overset{\bullet}{\to} b$
\chapter{$a \overset{\bullet}{\to} b$}
\end{document}
%%%
latex test.tex \
  && latex test.tex

#



#####
#
# Enlarging TeX (for SGA1)
# 2003jan17
#
#####

# «enlarge-pool_size»  (to ".enlarge-pool_size")
# (find-es "math" "SGA1")
# (find-fline "/usr/share/doc/texmf/tetex/teTeX-FAQ.gz" "enlarge")

# (find-fline "/etc/texmf/texmf.cnf" "\npool_size = ")
pool_size = 325000
%pool_size = 125000 - enlarged by Edrx! (find-es "tex" "enlarge-pool_size")
#
texconfig init
#



#####
#
# fraktur / mathfrak
# 2003mar08 / 2020feb23
#
#####

# «fraktur»  (to ".fraktur")
# (find-tlsh "find * | sort | grep frak")
# (find-tlsh "find * | sort | grep frak | grep pdf")
# (code-pdf-page "eufrak" "/usr/local/texlive/2019/texmf-dist/doc/fonts/amsfonts/eufrak.pdf")
# (code-pdf-text "eufrak" "/usr/local/texlive/2019/texmf-dist/doc/fonts/amsfonts/eufrak.pdf")
# (find-eufrakpage)
# (find-eufraktext)
# (find-eufraktext "\\mathfrak{A}")

xdvi /usr/share/doc/texmf/fonts/amsfonts/amsfndoc.dvi.gz &
xdvi /usr/share/doc/texmf/fonts/amsfonts/amsfonts.dvi.gz &
xdvi /usr/share/doc/texmf/fonts/amsfonts/eufrak.dvi.gz &
xdvi /usr/share/doc/texmf/fonts/amsfonts/euscript.dvi.gz &
# (find-fline "/usr/share/texmf/source/latex/amsfonts/eufrak.dtx" "mathfrak")

cd /usr/share/doc/texmf/fonts/amsfonts/
for i in eufrak.dvi euscript.dvi; do zcat $i.gz > /tmp/$i; done
dvifonts /tmp/eufrak.dvi
dvifonts /tmp/euscript.dvi
testfont eufm10 eusm10
testfont eufm5 eufm6 eufm7 eufm8 eufm9

#
cd ~/LATEX/
cat > tmp.tex <<'%%%'
\documentclass{book}
\usepackage{amsfonts}
\usepackage{bbm}
\usepackage{mathrsfs}
% (find-lsrcfile "amsfonts/euscript.dtx" "\\DeclareMathAlphabet\\EuScript")
\DeclareMathAlphabet\EuScript{U}{eus}{m}{n}
\SetMathAlphabet\EuScript{bold}{U}{eus}{b}{n}
\begin{document}
\par Gothic:
\par mathfrak: $\mathfrak{ABCDEFGHIJKLMNOPQRSTUVWXYZ-abc-012345}$
\par Calligraphic (``script''):
\par mathcal:  $\mathcal{ABCDEFGHIJKLMNOPQRSTUVWXYZ}$
\par mathscr:  $\mathscr{ABCDEFGHIJKLMNOPQRSTUVWXYZ}$
\par EuScript: $\EuScript{ABCDEFGHIJKLMNOPQRSTUVWXYZ}$
\par Blackboard bold:
\par mathbb:   $\mathbb{ABCDEFGHIJKLMNOPQRSTUVWXYZ}$
\par mathbbm:  $\mathbbm{ABCDEFGHIJKLMNOPQRSTUVWXYZ-abc-012345}$
\end{document}
%%%
latex tmp.tex
rexdvi tmp.dvi
dvifonts tmp.dvi
#
testfont eufm10 cmsy10 rsfs10 eusm10 msbm10 bbm10
#

% (find-fline "/usr/share/texmf/tex/latex/jknappen/mathrsfs.sty")
% (find-fline "/usr/share/doc/texmf/latex/jknappen/mathrsfs.rme")
% (find-fline "/usr/share/texmf/tex/latex/bbm/bbm.sty" "\\mathbbm")
% (find-es "tex" "rsfs")

# (find-lsrcfile "amsfonts/amsfonts.dtx" "\\DeclareMathAlphabet\\mathfrak")
# (find-lsrcfile "amsfonts/eufrak.dtx" "\\DeclareMathAlphabet\\EuFrak")
# (find-lsrcfile "amsfonts/eufrak.dtx" "mathfrak")
# (find-lsrcfile "amsfonts/amsfonts.fdd" "eufm10")
# (find-lsrcfile "base/cmfonts.fdd")
# (find-lsrcfile "jknappen/ubbold.fd")
# (find-lsrcfile "jknappen/ursfs.fd")
# (find-lsrcfile "jknappen/ustmary.fd")
# (find-progoutput "locate .fd")
# (find-progoutput "locate .fd | grep texmf | sort")
grep ptmr $(locate .fd | grep texmf)

/usr/share/texmf/source/latex/amsfonts/amsfonts.fdd
/usr/share/texmf/source/latex/base/cmfonts.fdd




#####
#
# fraktur-alternatives
# 2020feb25
#
#####

# «fraktur-alternatives» (to ".fraktur-alternatives")
# https://tex.stackexchange.com/questions/437834/alternative-to-mathfrak-a/437870
# https://tex.stackexchange.com/questions/320403/how-do-i-typeset-a-fraktur-x-that-looks-like-r/320407
# (find-symbolspage 119 "Table 307: Math Alphabets" "\\mathfrak")
# (find-symbolstext 119 "Table 307: Math Alphabets" "\\mathfrak")



#####
#
# mathfrak-kpfonts
# 2020feb25
#
#####

# «mathfrak-kpfonts» (to ".mathfrak-kpfonts")
# (find-tlsh "find * | sort | grep kpfonts")
# (code-c-d      "kpfonts" "/usr/local/texlive/2019/texmf-dist/doc/fonts/kpfonts/")
# (code-pdf-page "kpfonts" "/usr/local/texlive/2019/texmf-dist/doc/fonts/kpfonts/kpfonts.pdf")
# (code-pdf-text "kpfonts" "/usr/local/texlive/2019/texmf-dist/doc/fonts/kpfonts/kpfonts.pdf")
# (find-kpfontspage)
# (find-kpfontstext)
# (find-kpfontspage 2 "\\mathfrak")
# (find-kpfontstext 2 "\\mathfrak")



#####
#
# mathrsfs
# 2020sep12
#
#####

# «mathrsfs»  (to ".mathrsfs")
# http://tug.ctan.org/info/symbols/math/scriptfonts.pdf






#####
#
# \fontfamily
# 2020feb25
#
#####

# «fontfamily»  (to ".fontfamily")
# (code-dvi "fntguide" "/usr/share/doc/texmf/latex/base/fntguide.dvi.gz")
# (find-lsrcfile "base/fntguide.tex" "|ptm|  & Adobe Times")
# (find-fntguidepage 5)
#
cd ~/LATEX/
cat > tmp.tex <<'%%%'
\documentclass{book}
\begin{document}
\par Computer Modern
\par \fontfamily{ptm}\selectfont
     Adobe Times, a.k.a.\ Times Roman
\end{document}
%%%
latex tmp.tex
rexdvi tmp.dvi
dvifonts tmp.dvi
#
# (find-fline "/usr/share/texmf/tex/latex/psnfss/ot1ptm.fd")
# (find-lsrcfile "base/fntguide.tex" "\\begin{decl}\n|\\DeclareFontShape|")
# (find-lsrcfile "base/fntguide.tex" "\\label{sec:loadinfo}")
# (find-lsrcfile "base/fntguide.tex" "|\\fontfamily|")

# (find-lsrcfile "guide/guide.tex" "\\fontexample{ptm}{Times}")
# (find-fline "/usr/share/texmf/tex/latex/psnfss/times.sty")
# (find-fline "/usr/share/texmf/tex/latex/psnfss/")
# (find-lsrcfile "psnfss/psfonts.dtx")
# (find-lsrcfile "psnfss/psnfss2e.tex")
gv /usr/share/texmf/source/latex/psnfss/psnfss2e.pdf &

# (find-lsrcfile "psnfss/" "test")





#####
#
# \linebreak
# 2020jan22
#
#####

# «linebreak» (to ".linebreak")
# https://tex.stackexchange.com/questions/1959/allowing-line-break-at-in-inline-math-mode
# https://tex.stackexchange.com/questions/3782/how-can-i-split-an-equation-over-two-or-more-lines
# https://latex.org/forum/viewtopic.php?t=28639 Breaking math expression
# Breaking equations:
#   http://www.tug.org/TUGboat/Articles/tb18-3/tb56down.pdf
# (find-kopkadaly4page (+ 12 31) "\\linebreak is used to encourage or force a line break")
# (find-kopkadaly4text (+ 12 31) "\\linebreak is used to encourage or force a line break")





#####
#
# hyperlinks in dvi files
# 2003jan17 / 2005jun17 / 2008nov14
#
#####

# «hyperref»  (to ".hyperref")
# (find-angg ".emacs.papers" "hyperref")
# (find-LATEXgrep "grep --color -nH -e hyperref *.tex")
# (find-tlsh "find * | sort | grep hyperref")

# (code-c-d      "hyperref" "/usr/local/texlive/2019/texmf-dist/doc/latex/hyperref/")
# (code-pdf-page "hyperref" "/usr/local/texlive/2019/texmf-dist/doc/latex/hyperref/hyperref.pdf")
# (code-pdf-text "hyperref" "/usr/local/texlive/2019/texmf-dist/doc/latex/hyperref/hyperref.pdf")
# (find-hyperreffile "")
# (find-hyperrefpage)
# (find-hyperreftext)
# (code-c-d      "hyperrefmanual" "/usr/local/texlive/2019/texmf-dist/doc/latex/hyperref/")
# (code-pdf-page "hyperrefmanual" "/usr/local/texlive/2019/texmf-dist/doc/latex/hyperref/manual.pdf")
# (code-pdf-text "hyperrefmanual" "/usr/local/texlive/2019/texmf-dist/doc/latex/hyperref/manual.pdf")
# (find-hyperrefmanualfile "")
# (find-hyperrefmanualpage)
# (find-hyperrefmanualtext)

# (find-LATEXgrep "grep --color -nH -e hyperref *.tex")
# (find-LATEXgrep "grep --color -nH -e hyperref *.tex | grep urlcolor")
# (find-es "ps" "page-labels")
# (find-sh "locate hyperref")
# (find-zsh "dmissing hyperref")
# (find-zsh "dmissing hyperref | grep texlive")
# (find-fline "/usr/share/texmf-texlive/tex/latex/hyperref/")
# (find-fline "/usr/share/doc/texlive-latex-base-doc/latex/hyperref/")
# (find-hyperrefdocfile "")
# (find-hyperreffile "")
# (find-hyperrefdocw3m "manual.html")
# file:///usr/share/doc/texlive-latex-base-doc/latex/hyperref/manual.html

;; Old:
(progn
  (code-c-d "hyperrefdoc" "/usr/share/doc/texlive-doc/latex/hyperref/")
  (code-c-d "hyperref"    "/usr/share/texlive/texmf-dist/tex/latex/hyperref/")
  (code-pdf-page  "hyperrefreadme"   (ee-hyperrefdocfile "README.pdf"))
  (code-pdf-text  "hyperrefreadme"   (ee-hyperrefdocfile "README.pdf"))
  (code-pdf-page  "hyperrefhyperref" (ee-hyperrefdocfile "hyperref.pdf"))
  (code-pdf-text  "hyperrefhyperref" (ee-hyperrefdocfile "hyperref.pdf"))
  (code-pdf-page  "hyperrefmanual"   (ee-hyperrefdocfile "manual.pdf"))
  (code-pdf-text  "hyperrefmanual"   (ee-hyperrefdocfile "manual.pdf"))
  (code-pdf-page  "hyperrefoptions"  (ee-hyperrefdocfile "options.pdf"))
  (code-pdf-text  "hyperrefoptions"  (ee-hyperrefdocfile "options.pdf"))
  (code-pdf-page  "hyperrefpaper"    (ee-hyperrefdocfile "paper.pdf"))
  (code-pdf-text  "hyperrefpaper"    (ee-hyperrefdocfile "paper.pdf"))
  (code-pdf-page  "hyperrefslides"   (ee-hyperrefdocfile "slides.pdf"))
  (code-pdf-text  "hyperrefslides"   (ee-hyperrefdocfile "slides.pdf"))
  )

;; (find-hyperrefmanualpage 17 "\\href[options]{URL}{text}")
;; (find-hyperrefmanualtext 17 "\\href[options]{URL}{text}")
;; (find-hyperrefmanualpage 18 "\\hypertarget{name}{text}")
;; (find-hyperrefmanualtext 18 "\\hypertarget{name}{text}")

;; (find-hyperrefreadmepage     1  "Contents")
;; (find-hyperrefreadmepage     7  "Customizing index style file")
;; (find-hyperrefreadmetext "")
;; (find-hyperrefhyperrefpage   1 "Contents")
;; (find-hyperrefhyperrefpage 234 "Index")
;; (find-hyperrefhyperreftext "")
;; (find-hyperrefmanualpage )
;; (find-hyperrefmanualtext "")
;; (find-hyperrefmanualpage 12 "\\href{URL}{text}")
;; (find-hyperrefmanualtext    "\\href{URL}{text}")
;; (find-hyperrefmanualpage 13 "\\hypertarget")
;; (find-hyperrefmanualtext    "\\hypertarget")
;; (find-hyperrefmanualpage 15 "\\url{URL}")
;; (find-hyperrefmanualtext 15 "\\url{URL}")
;; (find-hyperrefmanualtext "\\phantomsection")
;; (find-hyperrefoptionspage  1)
;; (find-hyperrefoptionstext "")
;; (find-hyperrefpaperpage 1)
;; (find-hyperrefpapertext "")
;; (find-hyperrefslidespage      1  "Contents")
;; (find-hyperrefslidestext "")

# (find-fline "/usr/share/doc/texlive-doc/latex/hyperref/")
# (find-fline "/usr/share/texmf-texlive/tex/latex/hyperref/")

# (find-kopkadaly4page 7 "Contents")
# (find-kopkadaly4page (+ 12 3))
# (find-kopkadaly4page (+ 12 607) "Index")
# (find-kopkadaly4page (+ 12 241) "Options for hyperref")
# (find-kopkadaly4text            "Options for hyperref")
# (find-kopkadaly4page (+ 12 247) "\\href{url}{text}")
# (find-kopkadaly4text            "\\href{url}{text}")

# (find-man "1 xdvi" "small arrow")
# (find-man "1 xdvi" "\nHYPERLINKS\n")
# (find-man "1 xdvi" "htex-back()")

# (find-lsrcfile "hyperref/hyperref.sty" "Implicit mode ON; LaTeX internals redefined")

# (find-LATEXgrep "grep -nH -e hyperref *.tex")
# (find-LATEXfile "2009unilog-dnc.aux")

#
# (eev-bounded)
cd /tmp/
cat > hyperreftest.tex <<'---'
\documentclass{article}
\usepackage[colorlinks]{hyperref} % (find-es "tex" "hyperref")
\begin{document}
\par This is page 1
\par \hypertarget{anchor-One}{This is anchor-One}
\par \href      {#anchor-Two}{This is a link to anchor-Two}
\newpage
\par This is page 2
\par \hypertarget{anchor-Two}{This is anchor-Two}
\par \href      {#anchor-One}{This is a link to anchor-One}
\end{document}
---
latex hyperreftest.tex && rexdvi hyperreftest.dvi

#




#####
#
# breakurl
# 2012aug07
#
#####

# «breakurl»  (to ".breakurl")
# (find-tlsh "find * | sort | grep breakurl")
# (code-c-d      "breakurl" "/usr/local/texlive/2019/texmf-dist/doc/latex/breakurl/")
# (code-pdf-page "breakurl" "/usr/local/texlive/2019/texmf-dist/doc/latex/breakurl/breakurl.pdf")
# (code-pdf-text "breakurl" "/usr/local/texlive/2019/texmf-dist/doc/latex/breakurl/breakurl.pdf")
# (find-breakurlfile "")
# (find-breakurlfile "README")
# (find-breakurlpage)
# (find-breakurltext)
# (find-breakurlpage 1 "after" "\\usepackage{hyperref}")
# (find-breakurltext 1 "after" "\\usepackage{hyperref}")

\usepackage{breakurl}   % (find-es "tex" "breakurl")



#####
#
# \vbox
# 2023sep03
#
#####

# «vbox»  (to ".vbox")
# (find-texbookpage (+ 12 65) "\\vbox{\\hbox{Two lines}\\hbox{of type.}}")
# (find-texbooktext (+ 12 65) "\\vbox{\\hbox{Two lines}\\hbox{of type.}}")

 (find-angg "LUA/Show2.lua" "texbody")
 (find-code-show2 "~/LATEX/Show2.tex")
       (code-show2 "~/LATEX/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()
middletexbody = Dang.from "<<texbody>>"

texbody = [=[
x:
\vbox{\hbox{a}
      \hbox{bc}}
:y:
\vtop{\hbox{e}
      \hbox{fg}}
:z
]=]

= Show.try(tostring(outertexbody))
= Show.log
= Show.bigstr
 (etv)




#####
#
# newbox and saving diagrams
# 2003mar21
#
#####

# «newbox»  (to ".newbox")
# «newsavebox»  (to ".newsavebox")
# Inspired by a (bigger) hint given by Michael Barr
# (find-kopkadaly4page (+ 12 87) "\\newsavebox")
# (find-kopkadaly4text (+ 12 87) "\\newsavebox")
# (find-kopkadaly4page (+ 12 87) "\\savebox{\\boxname}[width][pos]{text}")
# (find-kopkadaly4text (+ 12 87) "\\savebox{\\boxname}[width][pos]{text}")
# (find-kopkadaly4page (+ 12 439) "Avoid the TEX box commands \\setbox")
# (find-kopkadaly4text (+ 12 439) "Avoid the TEX box commands \\setbox")
# (find-source2epage (+ 10 16) "\\newbox")
# (find-source2etext (+ 10 16) "\\newbox")

#
cd /tmp/
cat > test.tex <<'%%%'
\documentclass{book}
\usepackage{xypic}
\begin{document}

\newbox\dnar
\setbox\dnar=\hbox{\raise 5pt\hbox{$ \xy\ar (0,-100) \endxy $}}
\def\downarrow{\mathrel{\copy\dnar}}
\def\downarrow{{\mathrel{\copy\dnar}}}

$$ \pmatrix{a \\ \downarrow \\ c} $$

\end{document}
%%%
latex test.tex && rexdvi test.dvi
#
cd ~/LATEX/
cat > test.tex <<'%%%'
\documentclass{book}
\input diagxy.tex
\begin{document}

\makeatletter
\newbox\@dnmto
\setbox\@dnmto=\hbox{\raise 5pt\hbox{$\xy \ar(0,-100)\dir{|} \endxy$}}
\def\dnmto{\mathrel{\copy\@dnmto}}
\newbox\@mot
\setbox\@mot=\hbox{$\xy \ar(-100,0)\dir{|} \endxy$}
\def\mot{\mathrel{\copy\@mot}}
\makeatother

$$ \begin{array}{ccc} a & \mot & b \\ \dnmto \\ c \end{array} $$

\end{document}
%%%
latex test.tex && rexdvi test.dvi
#




#####
#
# dvi2dvi
# 2008apr03
#
#####

# «dvi2dvi»  (to ".dvi2dvi")
# «savebox»  (to ".savebox")
# (find-kopkadaly4page (+ 12  87) "\\newsavebox{\\boxname}")
# (find-kopkadaly4text            "\\newsavebox{\\boxname}")
# (find-man "dvi2dvi")
# (find-sh "dvi2dvi")
# (find-sh "cd ~/LATEX/ && dvi2dvi -m 5 < tmp.dvi > /tmp/tmp2.dvi")
# (find-zsh "cd ~/LATEX/ && strace-to ~/s dvi2dvi -m 5 < tmp.dvi > /tmp/tmp2.dvi")
# (find-fline "~/s")
# (find-sh "dvi2dvi -h")
# (find-dvipage "/tmp/tmp2.dvi")
# (find-sh "xdvi /tmp/tmp2.dvi")
# (find-dvipage "~/tmp/tmp2.dvi")

%
% (eedn4-51-bounded)
% (find-node "(latex)Spaces & Boxes")
% (find-angg "LATEX/tmp.dnt")

\thispagestyle{empty}

%D diagram demo
%D 2Dx    100      +25
%D 2D 100 a0 <==== a1
%D 2D	   -        -
%D 2D	   |  <-->  |
%D 2D	   v	    v
%D 2D +25 a2 ====> a3
%D 2D
%D (( a0 .tex= a,b a1 .tex= a
%D    a2 .tex=  c  a3 .tex= b|->c
%D    @ 0 @ 1 <= @ 0 @ 2 |-> @ 1 @ 3 |-> @ 2 @ 3 =>
%D    @ 0 @ 3 harrownodes nil 20 nil <->
%D ))
%D enddiagram

$\diag{demo}$

\newsavebox{\diagabc}
\savebox{\diagabc}{\bf Foo}

ab \usebox{\diagabc} cd \usebox{\diagabc} ef

\savebox{\diagabc}{$\diag{demo}$}

ab \usebox{\diagabc} cd \usebox{\diagabc} ef

%

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
dvifonts tmp2.dvi
dvifonts ~/LATEX/tmp.dvi




#####
#
# \savebox and friends
# 2019mar05
#
#####

# «savebox-2019» (to ".savebox-2019")
# (find-LATEX "edrx15.sty" "savebox")
# (find-kopkadaly4page (+ 12 87) "\\newsavebox{\\boxname}")
# (find-kopkadaly4text (+ 12 87) "\\newsavebox{\\boxname}")
# (find-kopkadaly4page (+ 12 87) "\\savebox{\\boxname}[width][pos]{text}")
# (find-kopkadaly4text (+ 12 87) "\\savebox{\\boxname}[width][pos]{text}")
# (find-kopkadaly4page (+ 12 87) "\\usebox{\\boxname}")
# (find-kopkadaly4text (+ 12 87) "\\usebox{\\boxname}")
# (find-source2epage (+ 10 310) "\\newsavebox")
# (find-source2etext (+ 10 310) "\\newsavebox")
# (find-source2epage (+ 10 310) "\\savebox")
# (find-source2etext (+ 10 310) "\\savebox")




####
#
# the '->^\prime bug on old TeTeXes
# 2003may25
#
####

# «prime-bug»  (to ".prime-bug")
%
\tracingonline=1\nonstopmode
\tracingall
$f'''$
%
#
# (find-knuthfile "tex/texbook.tex" "\\hex{8000}")
# (find-knuthfile "tex/texbook.tex" "\\mathcode`\\'=\"8000")
# (find-knuthfile "tex/texbook.tex" "convert |f'''| into")
# (find-knuthfile "tex/texbook.tex" "\\gdef'{^\\bgroup\\prim@s}")
# (find-knuthfile "tex/texbook.tex" "\\let\\bgroup={")
# (find-lsrcfile "base/ltmath.dtx" "\\global\\let'\\active@math@prime")
# (find-lsrcfile "base/fontdef.dtx" "\\mathcode`\\'=\"8000 % ^\\prime")

# It is \active@math@prime that does not exist on the old TeTeX

#
eev-cd lsrc base
grep 'prim[@e]' *
#

# (find-lsrcfile "tools/trace.dtx")
# (find-fline "/usr/share/texmf/tex/latex/tools/trace.sty")




####
#
# ignoring parts of a document
# 2003jun14
#
####

# «ignoring»  (to ".ignoring")
# (find-angg "LATEX/2003a.hdr.tex" "ignoring")

\def\ENDIGNORE{}
\long\def\BEGINIGNORE#1\ENDIGNORE{}		% means ignore
\long\def\BEGINIGNORE{}				% means do not ignore

\def\ENDIGNOREAE{}	% for when we want to ignore almost everything
\long\def\BEGINIGNOREAE#1\ENDIGNOREAE{}  	% means ignore
\long\def\BEGINIGNOREAE{}			% means do not ignore

\def\doignore#1#2{\long\def#1##1#2{}}
\def\donotignore#1#2{\def#1{}\def#2{}}
\def\defIFs#1#2#3#4#5{
  \def#1{\donotignore#3#5 \doignore#4#5}
  \def#2{\doignore#3#5 \donotignore#4#5}
}

\defIFs \MINIMALYES      \MINIMALNO
      \IFMINIMAL    \IFNOTMINIMAL      \ENDIFMINIMAL
\defIFs \ALLOWTRASHYES   \ALLOWTRASHNO
      \IFALLOWTRASH \IFNOTALLOWTRASH   \ENDIFALLOWTRASH

\MINIMALYES
\ALLOWTRASHNO




#####
#
# makeindex
# 2003jul04
#
#####

# «makeindex»  (to ".makeindex")
# (find-man "1 makeindex" "SPECIAL EFFECTS")
# (find-lsrcfile "guide/" "Makefile")
# (find-lsrcfile "guide/guide.tex")
# (find-lsrcfile "guide/")
# (find-lsrcfile "lshort/src/spec.tex" "\\section{Indexing}")
# (find-dvipage "/usr/share/doc/texmf/latex/general/lshort.dvi.gz" (+ 14 58))
# (find-lsrcfile "misc/")
# (find-lsrcfile "showlabels/")
#
rm -Rv /tmp/guide/
mkdir  /tmp/guide/
cd /usr/share/texmf/source/latex/guide/
cp -iv * /tmp/guide/
cd     /tmp/guide/
latex guide
latex guide
makeindex guide
latex guide
# (find-fline "/tmp/guide/" "guide.aux")

#
# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page 7 "Contents")
# (find-kopkadaly4page (+ 12 228) "9.4.3      Running MakeIndex")
# (find-kopkadaly4text            "9.4.3      Running MakeIndex")
# (find-kopkadaly4page (+ 12 607) "Index")
# (find-kopkadaly4text)


rm -Rv /tmp/mitest/
mkdir  /tmp/mitest/
cd     /tmp/mitest/
cat > mitest.tex <<'----'
\documentclass{article}
\usepackage{makeidx}
\usepackage{showidx}
\usepackage{showlabels}
\makeindex
\begin{document}

\section{sigma}\label{sigma}
aa \index{alpha}
bb \index{alpha!beta}
cc \index{alpha!beta!gamma}

\section{tau}\label{tau}

\printindex
\end{document}
----
latex mitest.tex
latex mitest.tex
makeindex mitest
latex mitest.tex

rexdvi mitest.dvi

#



#####
#
# \parbox, \makebox, minipage
# 2003jun19
#
#####

# Not yielding results as nice as I would like, but it's ok for now
# (find-node "(latex)\\parbox")
# (find-node "(latex)\\framebox")
%
% (eelatex-bounded 'once)
\def\blas{bla bla bla bla bla bla bla bla bla bla bla bla bla bla bla
          bla bla bla bla bla bla bla bla}

\par \blas
\par
\framebox{
\begin{minipage}{4in}
  \par \blas
  \par \blas
\end{minipage}
}
\par
\framebox{
\parbox{4in}{
  \par \blas
  \par \blas
  }
}
\par \blas
%



#####
#
# greek
# 2003aug10 / 2019jan05
#
#####

# «greek»  (to ".greek")
# (find-tlfile "texmf-dist/doc/generic/babel-greek/")
# (find-tlfile "texmf-dist/doc/generic/babel-greek/" "babel-greek.pdf")

# (find-tlsh "find * | sort | grep neohellenic")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/fonts/gfsneohellenic/")
# http://linorg.usp.br/CTAN/fonts/greek/gfs/gfsneohellenic/doc/GFSNeohellenic-Guide-for-LaTeX.pdf

# Old:
# (code-c-d "babel" "/usr/share/texmf/source/generic/babel/")
# (find-babelfile "greek.dtx" "Typing conventions")
# (find-efunction 'eelatex)
# (find-angg "LATEX/echotropia.tex")
#
cd /tmp/
cat > tmp-greek.tex <<'%%%'
\documentclass{book}
\usepackage[brazilian,english,greek]{babel}
\begin{document}

\par\greektext polutoniko
\par\latintext polutoniko

\end{document}
%%%
latex tmp-greek.tex
rexdvi tmp-greek.dvi

#




#####
#
# ThesisPUC (by Thomas Lewiner)
# 2003dec29
#
#####

# «ThesisPUC»  (to ".ThesisPUC")
# (code-c-d "tpuc" "~/usrc/ThesisPUC/")
# (find-tpucfile "")
#
rm -Rv ~/usrc/ThesisPUC/
cd ~/usrc/
unzip ~/LATEX/ThesisPUC.zip
cd ~/usrc/ThesisPUC/

rm -v ThesisPUC.pdf

# tomlew's titlesec.sty is 2.5, but woody's is 2.4...
# If we don't remove this then "latex Exple.tex" will complain
rm -v titlesec.sty
#
# How I got the list of files:
#  cd /usr/share/texmf/tex/latex/titlesec/
#  for i in *; do (cd ~/usrc/ThesisPUC; laf $i); done
#
# (find-vldifile "tetex-extra.list" "titlesec")
# (find-fline "/usr/share/texmf/tex/latex/titlesec/")
rm -v block.tss drop.tss frame.tss leftmargin.tss margin.tss rightmargin.tss
rm -v titletoc.sty wrap.tss
#
# But if I remove those I get errors, oops
# (find-vldifile "tetex-src.list" "titlesec")
# rm -v ttlkeys.def ttlps.def

# Tomlew uses the same extramarks.sty as woody but a newer fancyhdr.sty...
# (find-vldifile "tetex-extra.list" "fancyhdr")
# (find-fline "/usr/share/texmf/tex/latex/fancyhdr/")
rm -v extramarks.sty
# rm -v fancyhdr.sty

# These are even in tetex-base, so bye tomlew's
# (find-vldifile "tetex-base.list" "indentfirst.sty")
# (find-vldifile "tetex-base.list" "inputenc.sty")
# (find-vldifile "tetex-base.list" "setspace.sty")
rm -v indentfirst.sty
rm -v inputenc.sty
rm -v setspace.sty

# Tomlew uses a newer subfigure
# (find-tpucfile "")
# (find-tpucfile "subfigure.cfg")
# (find-tpucfile "ltxdoc.cfg")
# (find-fline "/usr/share/texmf/tex/latex/config/ltxdoc.cfg")
# (find-fline "/usr/share/texmf/tex/latex/misc/subfigure.sty")

#
# Exemplo
# (find-fline "~/usrc/ThesisPUC/")
cd ~/usrc/ThesisPUC/
rm -fv Exple.{aux,dvi,lof,log,lot,toc}
latex Exple.tex
latex Exple.tex
latex Exple.tex
rexdvi Exple.dvi &

#
# Manual
cd ~/usrc/ThesisPUC/
latex ThesisPUC.tex
latex ThesisPUC.tex
latex ThesisPUC.tex
rexdvi ThesisPUC.dvi &

#




#####
#
# texdoc
# 2004jan27 / 2015oct24
#
#####

# «texdoc»  (to ".texdoc")
# (find-man "1 texdoc")
# (find-fline "/usr/bin/texdoc")
# (find-fline "/usr/bin/texdoctk")
# (find-fline "/etc/texdoctk/texdoctk.dat")
#
texdoc multicol
texdoc lshort
texdoc amssymbols
#

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
texdoc -l lshort
TEXDOCVIEW_dvi=echo texdoc lshort

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
texdoc showkeys
texdoc
texdoc -l showkeys
texdoc -v -l showkeys

# (find-sh "texdoc showkeys")
# (find-fline "/usr/bin/texdoc")
# How do I run texdoc->xdvi in background?
# This doesn't work...
#   (find-bgprocess "texdoc showkeys")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
texdoc amsldoc
texdoc -l amsldoc
# (find-man "1 texdoc")
# (find-fline "/etc/texmf/texdoctk/texdocrc.defaults")
# (find-sh "locate texdoc")
# (find-fline "/usr/share/texlive/texmf-dist/texdoc/texdoc.cnf")








#####
#
# pdfpages
# 2004feb26 / 2015oct23 / 2019sep05
#
#####

# «pdfpages»  (to ".pdfpages")
# (find-angg ".zshrc" "pdfpages-tex")
# (find-es "luatex" "insert-pdf-page")
# (find-es "ps" "pdfpages")
# (find-LATEXgrep "grep --color -nH -e pdfpages *.tex")
# (find-quadrgrep "grep --color -nH -e pdfpages *.tex")
# https://tex.stackexchange.com/questions/105589/insert-pdf-file-in-latex-document
# https://stackoverflow.com/questions/2739159/inserting-a-pdf-file-in-latex
# http://www.mostlymaths.net/2008/09/latex-booklets.html
# http://www.mostlymaths.net/2009/04/easy-paperback-book-binding-how-to.html

# (find-tlsh "find * | sort | grep pdfpages")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/pdfpages/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/source/latex/pdfpages/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/pdfpages/")
(code-c-d      "pdfpages" "/usr/local/texlive/2019/texmf-dist/doc/latex/pdfpages/")
(code-pdf-page "pdfpages" "/usr/local/texlive/2019/texmf-dist/doc/latex/pdfpages/pdfpages.pdf")
(code-pdf-text "pdfpages" "/usr/local/texlive/2019/texmf-dist/doc/latex/pdfpages/pdfpages.pdf")
# (find-pdfpagesfile)
# (find-pdfpagespage)
# (find-pdfpagestext)
# (find-pdfpagespage 2 "\\includepdf")
# (find-pdfpagestext 2 "\\includepdf")
# (find-pdfpagespage 3 "frame")
# (find-pdfpagestext 3 "frame")
# (find-pdfpagespage 4 "pagecommand={\\thispagestyle{empty}}")
# (find-pdfpagestext 4 "pagecommand={\\thispagestyle{empty}}")

#
cd /tmp/
cat > p.tex <<'%%%'
\documentclass[oneside]{book}
\usepackage{pdfpages}
\begin{document}
\includepdf[pages={1,3}]{ThesisPUC.pdf}
\end{document}
%%%
pdflatex p.tex

#
function pdfpages () {
  echo -E '\documentclass[oneside]{book}
    \usepackage{pdfpages}
    \begin{document}
    \includepdf[pages={'$2'}]{'$1'}
    \end{document}
  ' > $3.tex
  pdflatex $3.tex
}

#
rm -Rv /tmp/pdfpages/
mkdir  /tmp/pdfpages/
cd     /tmp/pdfpages/
cp ~/LATEX/dout/ThesisPUC/ThesisPUC.pdf .
pdfpages ThesisPUC.pdf 1,3-4 selection1
gv selection1.pdf

#
rm -Rv /tmp/puc-parts/
mkdir  /tmp/puc-parts/
cd     /tmp/puc-parts/
cp ~/LATEX/puc.pdf .

function pdfpages () {
  echo -E '\documentclass[oneside]{book}
    \usepackage{pdfpages}
    \begin{document}
    \includepdf[pages={'$2'}]{'$1'}
    \end{document}
  ' > $3.tex
  pdflatex $3.tex
}

pdfpages puc.pdf  1-11 9916982_2003_pretextual
pdfpages puc.pdf 12-15 9916982_2003_cap_0
pdfpages puc.pdf 16-33 9916982_2003_cap_1
pdfpages puc.pdf 34-51 9916982_2003_cap_2
pdfpages puc.pdf 52-67 9916982_2003_cap_3
pdfpages puc.pdf 68-69 9916982_2003_postextual

#
cd /tmp/puc-parts/
for i in 9916982*pdf; do gv $i; done

#



#####
#
# pdfpages-a4
# 2022aug30
#
#####

# «pdfpages-a4»  (to ".pdfpages-a4")
# https://unix.stackexchange.com/questions/394065/command-line-how-do-you-rotate-a-pdf-file-90-degrees
# (find-LATEX "2022-1-C2-VSB-rodada.tex")
# (find-LATEX "2022-1-C3-VSB-rodada.tex")
# (find-pdf-page "~/LATEX/2022-1-C2-VSB-rodada.pdf")
# (find-pdf-page "~/LATEX/2022-1-C3-VSB-rodada.pdf")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/
lualatex 2022-1-C2-VSB-rodada.tex
lualatex 2022-1-C3-VSB-rodada.tex
# (find-pdf-page "~/LATEX/2022-1-C2-VSB.pdf")
# (find-pdf-page "~/LATEX/2022-1-C3-VSB.pdf")
# (find-pdf-page "~/LATEX/2022-1-C2-VSB-rodada.pdf")
# (find-pdf-page "~/LATEX/2022-1-C3-VSB-rodada.pdf")
cp -v 2022-1-C2-VSB-rodada.pdf /tmp/
cp -v 2022-1-C3-VSB-rodada.pdf /tmp/

 (eepitch-maxima)
 (eepitch-kill)
 (eepitch-maxima)
C2 : 26;
C3 : 16;
C2 * 5 + C3 * 4;
C2 * 4 + C3 * 3;




#####
#
# pdfpages-decrypt
# 2021feb10
#
#####

# «pdfpages-decrypt»  (to ".pdfpages-decrypt")
# (find-angg ".zshrc" "pdfpages-tex")
# (find-books "__analysis/__analysis.el" "martins-martins")
# (find-fline "~/TH/2021.1-C2.blogme" "martins_martins__cap_1")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)


FILE=$HOME/books/__analysis/martins_martins__elementos_de_calculo_diferencial_e_integral.pdf
cp -v $FILE /tmp/inp.pdf

cat > /tmp/out.tex <<'---'
\documentclass[oneside]{book}
\usepackage{pdfpages}
\begin{document}
\includepdf[pages={7,11,12,27-70}]{inp.pdf}
\end{document}
---

cd /tmp/
lualatex out.tex

# (brg "/tmp/inp.pdf")
# (brg "/tmp/out.pdf")

cd    /tmp/
cat > /tmp/out.tex <<'---'
\documentclass[oneside]{book}
\usepackage{pdfpages}
\begin{document}
\includepdf[pages={7,11-14,119-134}]{inp.pdf}
\end{document}
---
lualatex  out.tex

# (find-pdf-page "/tmp/inp.pdf")
# (find-pdf-page "/tmp/out.pdf")

cp out.pdf martins_martins__secs_4.2-4.4.pdf
# (find-cp-angg-links "martins_martins__secs_4.2-4.4.pdf" "/tmp/" "2021.1-C2/")



# (find-angg ".emacs.templates" "find-pdfpages-links")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
FILE=$HOME/books/__analysis/martins_martins__elementos_de_calculo_diferencial_e_integral.pdf
cp -v $FILE /tmp/inp.pdf
 (find-pdfpages-links "7,11-16,175-185")
cp out.pdf martins_martins__sec_6.1.pdf
# (find-cp-angg-links "martins_martins__sec_6.1.pdf" "/tmp/" "2021.1-C2/")



#####
#
# pdfpages-tex
# 2021nov14
#
#####

# «pdfpages-tex»  (to ".pdfpages-tex")
# (find-angg ".zshrc" "pdfpages-tex")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
FILE=$HOME/books/__cats/maclane__cwm_springer_2nd_ed.pdf

# (find-fline "/tmp/pdfpages-tex/")
rm -Rv /tmp/pdfpages-tex/
mkdir  /tmp/pdfpages-tex/
cd     /tmp/pdfpages-tex/

cp -iv $FILE inp.pdf
pdfpages-tex "pages={58-59}" "inp.pdf" | tee out.tex
pdflatex out.tex

# (find-pdf-page "/tmp/pdfpages-tex/out.pdf")
# (find-pdf-text "/tmp/pdfpages-tex/out.pdf")



#####
#
# pdfpages-frame
# 2022dec09
#
#####

# «pdfpages-frame»  (to ".pdfpages-frame")
# https://tex.stackexchange.com/questions/356003/border-around-included-pdf
# https://tex.stackexchange.com/questions/454137/adjust-frame-option-of-pdfpages-package

https://stackoverflow.com/questions/2034766/when-using-pdfpages-in-latex-how-to-avoid-page-breaks-before-the-first-page/20972874#20972874
https://tex.stackexchange.com/questions/356003/border-around-included-pdf/356008#356008



#####
#
# pdfpages-links
# 2023jun30
#
#####

# «pdfpages-links»  (to ".pdfpages-links")
# (find-es "ps" "qpdf-merge")
# (find-pdfpagespage 2 "that can copy links")
# (find-pdfpagestext 2 "that can copy links")

Links and other interactive features of PDF documents
-----------------------------------------------------
When including pages of a PDF only the so called content stream of
these pages is copied but no links. Up to now there are no TeX-engines
(pdfTeX, XeTeX, ...) available that can copy links or other
interactive features of a PDF document, too. Thus, all kinds of
links[1] will get lost during inclusion. (Using \includepdf,
\includegraphics, or other low-level commands.)

However, there's a glimmer of hope. Some links may be extracted and
later reinserted by a package called pax which can be downloaded from
CTAN [3]. Have a look at it!

1. Actually not only links but all kinds of PDF annotations will get
lost.

# (find-tlsh "find * | sort | grep pax")
# (find-tlfile "texmf-dist/doc/latex/pax/README")
# (find-tlfile "texmf-dist/doc/latex/pax/README" "3. Install PDFBox")





####
#
# ite
# 2004mar15
#
####

# «ite»  (to ".ite")
# (code-c-d "ite" "~/usrc/ite_3/")
# (code-c-d "ite" "$HOME/usrc/ite_3/")
# (find-itefile "")
# (find-itefile "lisp/")

# Needs shell=bash
#
rm -Rv ~/usrc/ite_3/
tar -xvzf $S/http/www.ctan.org/tex-archive/support/ite/ite_3.tar.Z -C ~/usrc/
cd ~/usrc/ite_3/
cp -v ite.conf ite.conf.orig
# (find-itefile "ite.conf")

find * -type f | sort > .files

patch -p0 ite.conf <<'%%%'
17c17,18
< home-path "~/iTe/development"
---
> #home-path "~/iTe/development"
> home-path "~/usrc/ite_3"
40,41c41,42
< #gs-options "-sDEVICE=x11"
< gs-options ""
---
> gs-options "-sDEVICE=x11"
> #gs-options ""
%%%

cd ~/usrc/ite_3/test/
# export TEXINPUTS=~/usrc/ite_3/tex:
. compile |& tee oc

#
# (find-itew3m "doc/index.html")
# (find-itew3m "doc/manual.html")
# (find-itew3m "doc/installation.html")
# (find-itew3m "doc/bindings.html")
# (find-itefile "test/")

(progn
  (require 'tex-site)
  (code-c-d "ite" "$HOME/usrc/ite_3/")
  (add-to-list 'load-path (ee-itefile "lisp"))
  (setq ite-config-files (list (ee-itefile "ite.conf")))
  (load-library "~/usrc/ite_3/lisp/ite.el")
  )

(find-itefile "test/basic.tex")
(find-itefile "test/")

#
  ;; (autoload 'ite "ite" "...interactive TeX editor..." t)
  ;; (debug-on-entry 'ite-start-process)
#

cd ~/usrc/ite_3/
grep 'Processing block' $(<.files)
grep 'iTe_PerlFinished' $(<.files)
grep 'Starting ' $(<.files)
grep 'iTe_GhostScriptStarted' $(<.files)
grep 'not found' $(<.files)
grep 'iTe log' $(<.files)

#
# (find-itefile "rsc/ite.pl")
# (find-itefile "rsc/ite.pl" "Processing block")
# (find-itefile "rsc/ite.pl" "iTe_PerlFinished")
# (find-itefile "lisp/ite.el")
# (find-itefile "lisp/ite.el" "iTe_PerlFinished")
# (find-itefile "lisp/ite.el" "Starting %s with %s")

# (find-itefile "lisp/ite.el" "iTe_GhostScriptStarted")
# (find-itefile "lisp/ite.el" "-c /iTe_GhostScriptStarted == flush")

# (find-itefile "lisp/ite.el")

# (find-status "auctex")
# (find-vldifile "auctex.list")
# (find-fline "/usr/doc/auctex/")





####
#
# PS fonts
# 2004mar29
#
####

# «psfonts»  (to ".psfonts")
# (find-lsrcfile "psnfss.extra/OT1pzc.fd")
# (find-lsrcfile "psnfss.extra/T1pzc.fd")
# (find-fline  "/usr/share/doc/texmf/fontinst/base/")
# (find-dvipage "/usr/share/doc/texmf/fontinst/base/fontinst.dvi.gz" 1)
# (find-fline  "/usr/share/texmf/tex/fontinst/base/")
# (find-man "1 fontinst")

# (find-fline "/usr/share/texmf/source/latex/psnfss.extra/OT1pzc.fd")
# (find-fline "/usr/share/texmf/source/latex/psnfss.extra/T1pzc.fd")

# (find-w3m "/usr/share/doc/texmf/help/Catalogue/entries/psfonts.html")

# (find-fline "/etc/texmf/dvips/psfonts.map")
# (find-fline "/etc/texmf/dvipsj/psfonts.map")
# (find-fline "/usr/share/texmf/dvi2ps/fontsk/")
# (find-fline "/usr/share/texmf/dvips/base/psfonts.map")
# (find-fline "/usr/share/texmf/dvips/bluesky/")
# (find-fline "/usr/share/texmf/dvipsj/base/psfonts.map")
# (find-fline "/usr/share/texmf/source/latex/psnfss/psfonts.dtx")
# (find-fline "/usr/share/texmf/source/latex/psnfss/psfonts.ins")
# (find-fline "/usr/share/ttf2pt1/app/netscape/psfonts.cf")

# (find-fline "/usr/share/texmf/fontname/")

cd /usr/share/texmf/
du -c tex fontname source

cd /usr/share/texmf/
find tex fontname source -type f | l -S

cd /usr/share/texmf/
find tex fontname source -type f \
  | xargs -s 64000 \
    grep installfonts

cd /usr/share/texmf/; find tex source -type f | sort | xargs -s 64000 \
  grep DeclareFontFamily
cd /usr/share/texmf/; find tex source -type f | sort | xargs -s 64000 \
  grep DeclareFontShape

# (find-lsrcfile "base/ltfssbas.dtx" "\\def\\DeclareFontFamily#1#2#3")
# (find-lsrcfile "base/ltfsscmp.dtx" "DeclareFontFamily")
# (find-fline "/usr/share/texmf/tex/latex/base/latex.ltx" "DeclareFontFamily")

# (find-lsrcfile "base/ltfssbas.dtx" "\\def\\DeclareFontShape{")
# (find-lsrcfile "base/ltfssbas.dtx" "\\def\\DeclareFontShape@#1#2#3#4#5#6")
# (find-fline "/usr/share/texmf/tex/latex/base/latex.ltx" "DeclareFontShape")
# (find-fline "/usr/share/texmf/tex/latex/base/latex.ltx" "DeclareFontShape@")

# (find-fline "/usr/share/texmf/tex/fontinst/base/xfntinst.sty" "\\def\\latinfamily")
# (find-fline "/usr/share/texmf/tex/fontinst/base/fontinst.sty" "\\def\\latinfamily")

/usr/share/texmf/tex/
/usr/share/texmf/source/




#####
#
# pstricks
# 2001oct23
#
#####

# «pstricks-old»  (to ".pstricks-old")
# (find-status "tetex-extra")
# (find-vldifile "tetex-extra.list")
# (find-fline "/usr/doc/tetex-extra/")
# (find-fline "/usr/share/texmf/tex/generic/pstricks/")

# (find-status "tetex-src")
# (find-vldifile "tetex-src.list")
# (find-fline "/usr/doc/tetex-src/")
# (find-fline "/usr/share/texmf/source/generic/pstricks/")

# (find-status "tetex-doc")
# (find-vldifile "tetex-doc.list")
# (find-fline "/usr/doc/tetex-doc/")
# (find-fline "/usr/doc/texmf/generic/pstricks/")
# (find-fline "/usr/doc/texmf/generic/pstricks/obsolete/")

# (code-c-d "pstdoc" "/usr/doc/texmf/generic/pstricks/")
# (find-pstdocfile "")
# 
# VI: Text Tricks (find-pspage (ee-pstdocfile "obsolete/pst-usr3.ps.gz") 52)
#
cd /usr/doc/texmf/generic/pstricks/
for i in *dvi*; do xdvi $i; done
#
cd /usr/doc/texmf/generic/pstricks/obsolete/
for i in *.ps*; do gv $i; done
#


gv /usr/share/doc/texmf/generic/pstricks/doc-fill.ps.gz &
gv /usr/share/doc/texmf/generic/pstricks/obsolete/betadoc1.ps.gz &
gv /usr/share/doc/texmf/generic/pstricks/obsolete/betadoc2.ps.gz &
gv /usr/share/doc/texmf/generic/pstricks/obsolete/pst-quik.ps.gz &
gv /usr/share/doc/texmf/generic/pstricks/obsolete/pst-usr1.ps.gz &
gv /usr/share/doc/texmf/generic/pstricks/obsolete/pst-usr2.ps.gz &
gv /usr/share/doc/texmf/generic/pstricks/obsolete/pst-usr3.ps.gz &
gv /usr/share/doc/texmf/generic/pstricks/obsolete/pst-usr4.ps.gz &

# (code-c-d "pst" "/usr/src/pstricks/")

rm -Rv /usr/src/pstricks
cd /usr/src/
cp -dipvR $SCTAN/graphics/pstricks.tar.gz

cd /usr/src/pstricks

cd /usr/src/pstricks/src.old/
# (find-pstfile "src.old/pst-user.tex")
# (find-pstfile "src.old/pst-user.sty")
cp -iv /usr/lib/texmf/texmf/tex/latex/base/article.sty art12.sty

# (find-pstfile "src.old/pst-user.sty")
# (find-pstfile "src.old/art12.sty")
# (find-pstfile "src.old/npsfont.sty")
# (find-pstfile "src.old/pst-user.sty" 93)
# (find-pstfile "src.old/pst-user.log")

cd /usr/src/pstricks/origdoc/
# Logotipos do Denis Girou; só dá pra ver com o gv.
tex denis1.tex
dvips -o denis1.ps denis1.dvi
gv denis1.ps

tex denis2.tex
dvips -o denis2.ps denis2.dvi
gv denis2.ps

latex samples.tex
dvips -o samples.ps samples.dvi
gv samples.ps

rm -Rv $CTAN/graphics/pstricks/
cd $CTAN/graphics/
tar -xvzf pstricks.tar.gz
gzip -dv $(find pstricks -name '*.gz')

cd $CTAN/graphics/pstricks/origdoc/

# (find-pstfile "src.old/pst-user.tex")
# (find-pstfile "src.old/pst-user.sty" 199)
# (find-pstfile "src.old/pstricks.doc")
# (find-pstfile "src.old/pst-make.tex")
# (find-pstfile "src.old/pst-code.tex")

# (find-fline "~/PS/pst1.tex")

# (find-lsrcfile "base/doc.dtx" "abstract")
# (find-lsrcfile "base/doc.dtx" "produce the documentation")
# (find-lsrcfile "base/ltxdoc.dtx" 82)
# (find-fline "/usr/lib/texmf/texmf/tex/latex/base/doc.sty")




####
#
# pstricks
# 2004mar26
#
####

% «pstricks»  (to ".pstricks")
% (find-eevnewfile "tmp-pst.tex")
% (setq eelatex-eevscript "cd ~/eev-0.94/; latex tmp-pst.tex && dvips -o tmp-pst.ps tmp-pst.dvi && regv tmp-pst.ps &")

#
# (eev-bounded)
cat > ~/eev-0.94/tmp-pst.tex
\documentclass{book}
\usepackage {pstcol,pst-text}
\usepackage {lscape}
\begin{document}
\input ee.tex
\end{document}
%%%

#

%
% (eelatex-bounded)
%
% \usepackage {pstcol,pst-text}
\definecolor{pink}{rgb}{1, .75, .8}

\begin{pspicture}(-3,-2.2)(3,2.2)
  \psset{linestyle=none}
  % \newcommand{\curly}[1]{{\fontfamily{pzc}%
  %   \fontsize{17}{17}\itshape#1}}
  \def\curly#1{{\fontfamily{pzc}\fontsize{17}{17}#1}}
  \def\curly#1{{\fontfamily{pzc}\fontsize{17}{17}\itshape#1}}
  \pstextpath[c]{\psarcn(0,0){2}{180}{0}}
  {\curly{The Unseen University}}
\end{pspicture}

%
% (eelatex-bounded)

\begingroup
\fontfamily{pzc}\fontsize{60}{60}\itshape

Hello

Bye

\endgroup

%
% (eelatex-bounded)

\begin{landscape}
\begingroup
\fontfamily{pzc}\fontsize{60}{60}\itshape

\centerline{Hello}

\centerline{Bye}

\endgroup
\end{landscape}

%




#####
#
# cartão pra Cláudia
# 2004jul07
#
#####

# «cartao-claudia»  (to ".cartao-claudia")
%
% (eelatex-bounded)

\def\newpage{\vfill\break}

\def\HWID{65mm}        % largura do cartão
\def\VMRG{12mm}        % \vspace's acima e abaixo do texto num cartão 
\def\HSEP{-3.8pt}      % usado num \hspace pra fazer os cartões grudarem
\def\VSEP{-1.5pt}      % usado num \vspace pra fazer os cartões grudarem

\def\cartao{
  \framebox{\parbox{\HWID}{
    \vspace{\VMRG}
    \centerline{\bf Aulas de Italiano}
    \centerline{   Cláudia O'Connor    }
    \centerline{ 8118-2034 / 2508-5184 }
    \vspace{\VMRG}
}}}
\def\cartaocartao{\centerline{\cartao\hspace{\HSEP}\cartao}}
\def\novalinha{\par\vspace{\VSEP}}

\cartaocartao\novalinha
\cartaocartao\novalinha
\cartaocartao\novalinha
\cartaocartao\novalinha
\cartaocartao

%
#
# (eev-bounded)
cd /tmp/
dvips -D 600 -o cartao-claudia.ps ~/eev-0.94/tmp.dvi
dvipdf ~/eev-0.94/tmp.dvi cartao-claudia.pdf

#
cd /tmp/
Scp cartao-claudia.ps cartao-claudia.pdf edrx@${SUCURI}:public_html/tmp/
Scp cartao-claudia.ps cartao-claudia.pdf edrx@${SUCURI}:slow_html/tmp/
#
# http://www.mat.puc-rio.br/~edrx/tmp/cartao-claudia.ps
# http://www.mat.puc-rio.br/~edrx/tmp/cartao-claudia.pdf

#




#####
#
# including png screenshots
# 2005apr14
#
#####

# «png_screenshots»  (to ".png_screenshots")
% What's the right scale to use?
%
% A png of, say, 590x400 pngpx ("png pixels") is by default converted
% to an image of size 590x400 pt (points, those that are 1/72 in), but
% I want to convert that a size in which each pngpx takes an integer
% number or pdots ("printer dots"), considering a 600dpi printer...
%
% The base case is making each pngpx take exactly one pdot: that is
% done by
%
%   \includegraphics[scale=0.12]{convertedpng.eps}
%
% (really - nice number, heh? (/ 72 600.0) = 0.12
#
mkdir /tmp/pngtex/
cd    /tmp/pngtex/
cp /tmp/ss-lua-2.png foo.png

#
# (find-sh "cd /tmp/pngtex/; file foo.png")
# 590 x 400
# (find-fline "$EEVTMPDIR/tmp.tex")
# (find-eevtmpfile "tmp.tex")

%
% (eelatex-bounded)

   $\backslash$includegraphics[scale=0.60]\{/tmp/ss-lua-2.eps\}:
\par\noindent \includegraphics[scale=0.12]{/tmp/ss-lua-2.eps}
\par          \includegraphics[scale=0.60]{/tmp/ss-lua-2.eps}
\vfill

%
! LaTeX Error: Cannot determine size of graphic in /tmp/ss-lua-2.png (no BoundingBox).

# (find-sh "pngcrush -h")
# (find-sh "pngcrush -h" "convert color to grayscale")
# (find-sh "pngcrush -h" "delete an unwanted alpha channel")
# (find-sh "pngcrush -h" "0 means try all of 1-10")
# (find-man "convert")
# (find-man "ImageMagick")
# (find-man "ImageMagick" "-density <width>x<height>")




#####
#
# Typesetting CVs using LaTeX
# 2005feb19
#
#####

# «cv-packages»  (to ".cv-packages")

#         http://www.ctan.org/tex-archive/macros/latex/contrib/cv/
#          ftp://ftp.dante.de/tex-archive/macros/latex/contrib/cv.tar.gz

# http://www.ctan.org/tex-archive/macros/latex/contrib/cv/
#  ftp://ftp.dante.de/tex-archive/macros/latex/contrib/cv.tar.gz
# http://www.ctan.org/tex-archive/macros/latex/contrib/curve/
#  ftp://ftp.dante.de/tex-archive/macros/latex/contrib/curve.tar.gz
# http://www.ctan.org/tex-archive/macros/latex/contrib/currvita/
#  ftp://ftp.dante.de/tex-archive/macros/latex/contrib/currvita.tar.gz

mkdir -p $S/http/www.ctan.org/tex-archive/macros/latex/contrib/
tar   -C $S/http/www.ctan.org/tex-archive/macros/latex/contrib/ \
   -xvzf  $S/ftp/ftp.dante.de/tex-archive/macros/latex/contrib/cv.tar.gz
cd       $S/http/www.ctan.org/tex-archive/macros/latex/contrib/cv/

mkdir -p $S/http/www.ctan.org/tex-archive/macros/latex/contrib/
tar   -C $S/http/www.ctan.org/tex-archive/macros/latex/contrib/ \
   -xvzf  $S/ftp/ftp.dante.de/tex-archive/macros/latex/contrib/curve.tar.gz
cd       $S/http/www.ctan.org/tex-archive/macros/latex/contrib/curve/

mkdir -p $S/http/www.ctan.org/tex-archive/macros/latex/contrib/
tar   -C $S/http/www.ctan.org/tex-archive/macros/latex/contrib/ \
   -xvzf  $S/ftp/ftp.dante.de/tex-archive/macros/latex/contrib/currvita.tar.gz
cd       $S/http/www.ctan.org/tex-archive/macros/latex/contrib/currvita/

ftp://ftp.dante.de/tex-archive/macros/latex/contrib/cv.tar.gz
http://www.ctan.org/tex-archive/macros/latex/contrib/cv/

#
# «cv»  (to ".cv")
# (code-c-d "cv" "/tmp/cv/" :xdvi)
rm -Rv /tmp/cv/
cd /tmp/
tar -xvzf $S/ftp/ftp.dante.de/tex-archive/macros/latex/contrib/cv.tar.gz
cd /tmp/cv/
latex CVCTAN.tex
xdvi  CVCTAN.dvi &

#
# «currvita»  (to ".currvita")
# (code-c-d "currvita" "/tmp/currvita/" :xdvi)
# (find-currvitaxdvi "cvtest.dvi")
# (find-currvitaxdvi "currvita.dvi")
rm -Rv /tmp/currvita/
cd     /tmp/
tar -xvzf $S/ftp/ftp.dante.de/tex-archive/macros/latex/contrib/currvita.tar.gz
cd /tmp/currvita/
latex currvita.ins
latex currvita.dtx
latex currvita.dtx
latex currvita.dtx
latex cvtest.tex

# (find-currvitafile "")
# (find-currvitafile "cvtest.tex")

#
# (find-fline "/tmp/currvita/")
# (find-fline "/tmp/cv/")

# (eebg-xdvi "/tmp/currvita/cvtest.dvi")
# (eebg-xdvi "/tmp/currvita/currvita.dvi")
# (eebg-xdvi "/tmp/cv/CVCTAN.dvi")

#
# «currvitaedrx»  (to ".currvitaedrx")
# (code-c-d "currvitaedrx" "~/CURRICULO/currvita/")
# (find-currvitaedrxfile "")
# (find-currvitaedrxfile "cvtest.tex")

cd ~/CURRICULO/currvita/
tar -xvzf $S/ftp/ftp.dante.de/tex-archive/macros/latex/contrib/currvita.tar.gz
mv -v currvita/* .
rmdir currvita/

# (find-anggfile "CURRICULO/curric-edrx-jan2005.txt")

#




#####
#
# TEXINPUTS
# 2006jul19
#
#####

# «TEXINPUTS»  (to ".TEXINPUTS")
# (find-node "(kpathsea)Variable expansion")
# (find-node "(kpathsea)Path sources")
# (find-node "(kpathsea)Default expansion")
# (find-node "(kpathsea)Supported file formats" "`tex'")
# (find-fline "/etc/texmf/texmf.cnf" "% TEXINPUTS ")
# (find-fline "/etc/texmf/texmf.d/")
# (find-fline "/etc/texmf/texmf.d/45TeXinputs.cnf")
# (find-fline "/etc/texmf/texmf.d/45TeXinputs.cnf")

# (find-fline "/etc/texmf/texmf.cnf")
# (find-fline "/usr/share/tetex-bin/texmf.cnf")
# (find-fline "/usr/share/texmf/web2c/texmf.cnf")
# (find-sh "locate texmf.cnf")
# (find-zsh "dmissing texmf.cnf")




#####
#
# dvipng
# 2006oct11
#
#####

# «dvipng»  (to ".dvipng")
# http://trac.lunatic-bumblebee.com/trac/browser/emacs-blog/trunk/emacs-blog-latex.el
# (find-status   "dvipng")
# (find-vldifile "dvipng.list")
# (find-udfile   "dvipng/")
# (find-node "(dvipng)")
# (find-node "(dvipng)Basic usage")
# (find-node "(dvipng)Option details")
# (find-node "(dvipng)Index")
# (find-sh "dvipng --help")




#####
#
# TeTeX and TeXLive
# 2007nov19
#
#####

# «tetex-and-texlive»  (to ".tetex-and-texlive")
# "TeTeX has been abandoned upstream, TeX Live..."
# http://lists.debian.org/debian-devel-announce/2007/04/msg00006.html

# http://www.tug.org/texlive/doc.html
# http://www.tug.org/texlive/doc/texlive-en/live.html#x1-6500010




#####
#
# fontdimen parameters for the typewriter fonts
# 2007nov24
#
#####

# «fontdimen»  (to ".fontdimen")
# (find-texbookpage 400)
# (find-texbooktext)
# (find-texbookpage (+ 12 157) "special \\fontdimen parameters")
# (find-texbooktext (+ 12 157) "special \\fontdimen parameters")
# (find-texbookpage (+ 12 179) "\\fontdimen16\\tensy=2.7pt")
# (find-texbooktext (+ 12 179) "\\fontdimen16\\tensy=2.7pt")
# (find-texbooktext " 22 \\fontdimen param")
# (find-texbooktext "5    x height")
# (find-texbooktext "1   slant per pt")

# (find-angg ".emacs.papers" "hatcher")
# http://www.math.cornell.edu/~hatcher/AT/typography.html
#   \fontdimen16\textfont2=2.5pt

# (find-sh "locate plain.tex")
# (code-c-d "plaintex" "/usr/share/texmf-tetex/tex/plain/")
# (find-plaintexfile "")
# (find-plaintexfile "base/plain.tex" "\\font\\tentt=cmtt10 % typewriter")

# (find-es "tex" "kpathsea")
# (find-sh  "kpsewhich --help")
# (find-sh0 "kpsewhich cmr10.mf")




#####
#
# parindent
# 2022dec18
#
#####

# «parindent»  (to ".parindent")
# (find-texbookpage (+ 12 474) "*\\parindent")
# (find-texbooktext (+ 12 474) "*\\parindent")

# (find-texbookpage (+ 12  86) "\\indent\\indent")
# (find-texbooktext (+ 12  86) "\\indent\\indent")
# (find-texbookpage (+ 12 100) "\\narrower")
# (find-texbooktext (+ 12 100) "\\narrower")
# (find-texbookpage (+ 12 101) "semicircular hole" "\\parshape")
# (find-texbooktext (+ 12 101) "semicircular hole" "\\parshape")
# (find-texbookpage (+ 12 102) "\\hangindent")
# (find-texbooktext (+ 12 102) "\\hangindent")
# (find-texbookpage (+ 12 105) "horizontal list will be initiated")
# (find-texbooktext (+ 12 105) "horizontal list will be initiated")
# (find-texbookpage (+ 12 262) "\\def\\beginindex")
# (find-texbooktext (+ 12 262) "\\def\\beginindex")
# (find-texbookpage (+ 12 274) "dimen parameter")
# (find-texbooktext (+ 12 274) "dimen parameter")
# (find-texbookpage (+ 12 282) "\\indent")
# (find-texbooktext (+ 12 282) "\\indent")
# (find-texbookpage (+ 12 286))
# (find-texbooktext (+ 12 286))
# (find-texbookpage (+ 12 291))
# (find-texbooktext (+ 12 291))
# (find-texbookpage (+ 12 342))
# (find-texbooktext (+ 12 342))
# (find-texbookpage (+ 12 348))
# (find-texbooktext (+ 12 348))
# (find-texbookpage (+ 12 355))
# (find-texbooktext (+ 12 355))
# (find-texbookpage (+ 12 394))
# (find-texbooktext (+ 12 394))
# (find-texbookpage (+ 12 406))
# (find-texbooktext (+ 12 406))
# (find-texbookpage (+ 12 415))
# (find-texbooktext (+ 12 415))





#####
#
# quote, quotation, verse
# 2008feb10
#
#####

# «quote»  (to ".quote")
# «quotation»  (to ".quotation")
# «verse»  (to ".verse")

# (find-es "tex" "list")
# (find-kopkadaly4page (+ 12 67) "4.2.3   Two-sided indentation")
# (find-kopkadaly4text           "4.2.3   Two-sided indentation")
# (find-kopkadaly4page (+ 12 67) "\\begin{quote}")
# (find-kopkadaly4text (+ 12 67) "\\begin{quote}")
# (find-kopkadaly4page (+ 12 67) "\\begin{quotation}")
# (find-kopkadaly4text (+ 12 67) "\\begin{quotation}")
# (find-source2epage (+ 10 292) "55     List, and related environments")
# (find-source2etext (+ 10 292) "55     List, and related environments")
# (find-source2epage (+ 10 292) "55     List, and related environments" "quotation")
# (find-source2etext (+ 10 292) "55     List, and related environments" "quotation")
# (find-classespage 38 "7.4.3     Quotation")
# (find-classestext 38 "7.4.3     Quotation")
# (find-classespage 38 "7.4.4     Quote")
# (find-classestext 38 "7.4.4     Quote")

%
% (eedn4-51-bounded)
% (find-lsrcfile "base/article.cls" "\\newenvironment{quotation}")
% (find-kopkadaly4text "\\list \\do {cmds}")
% (find-kopkadaly4text "\\listparindent")

\noindent
A section of text may be displayed by indenting it by an equal amount
on both sides, with the environments

\begin{quote}
\begin{verbatim}
\begin{quote}      text  \end{quote}
\begin{quotation}  text  \end{quotation}
\end{verbatim}

  Additional vertical spacing is inserted above and below the
  displayed text to separate it visually from the normal text.

  The text to be displayed may be of any length; it can be part of a
  sentence, a whole paragraph, or several paragraphs.

  Paragraphs are separated as usual with an empty line, although no
  empty lines are needed at the beginning and end of the displayed
  text since additional vertical spacing is inserted here anyway.

\end{quote}

The difference between the above two forms is thus:

\begin{quotation}

    In the \verb|quotation| environment, paragraphs are marked by
  extra indentation of the first line, whereas in the \verb|quote|
  environment, they are indicated with more vertical spacing between
  them.

    The present text is produced within the \verb|quotation|
  environment, while the sample above was done with the \verb|quote|
  environment.

    The \verb|quotation| environment is only really meaningful when
  the regular text makes use of first-line indentation to show off new
  paragraphs.

\end{quotation}

\noindent
For indenting rhymes, poetry, verses, etc.\ on both sides, the
environment

\begin{verbatim}
\begin{verse}   text  \end{verse}
\end{verbatim}

\noindent
is more appropriate.

\begin{verse}
  Stanzas as separated by blank lines \\
  while the individual lines of the stanza are divided by \verb|\\|.

  If a line is too long for the reduced text width, it will be left
    and right justified and continued on the next line, which is
    indented even further.
\end{verse}

%




#####
#
# Running TeX and showing defs
# 2008feb10
#
#####

# «running-TeX-show»  (to ".running-TeX-show")
# (find-texbookpage (+ 11 23) "Running TeX")
# (find-texbookpage (+ 11 31) "the machine will soon stop")
# (find-texbookfile "texbook.tex" "the machine will soon stop")
# (find-texbooktext               "the machine will soon stop")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
latex
\makeatletter
\blop
?
H
I\show\smash
I\show\begin
I\show\on@line
I\show\newenvironment
I\show\new@environment
I\show\verse

% (find-source2efile "")
% (find-source2egrep "grep -nH -e quotation *")
% (find-source2egrep "grep -nH -e verse *")
% (find-source2efile "classes.dtx" "\\begin{environment}{verse}")
% (find-source2efile "classes.dtx" "\\begin{environment}{quotation}")
% (find-source2efile "classes.dtx" "\\begin{environment}{quote}")

% (find-source2efile "")
% (find-source2egrep "grep -nH -e newenvironment *")
% (find-source2efile "ltdefns.dtx" "\\begin{macro}{\\newenvironment}")




#####
#
# tesemestr
# 2008mar04
#
#####

# «tesemestr»  (to ".tesemestr")
# (find-angg ".emacs.papers" "tesemestr")
# http://angg.twu.net/math/tesemestr-texsrc.tar.gz
# http://angg.twu.net/math/tesemestr-dvi.tar.gz
# http://angg.twu.net/math/tesemestr.ps.gz
# http://angg.twu.net/math/tesemestr.pdf
# http://angg.twu.net/math/slidesmestr-texsrc.tar.gz
# http://angg.twu.net/math/2000uff-texsrc.tar.gz
# http://angg.twu.net/math/
#
rm -Rv ~/usrc/tesemestr/
mkdir  ~/usrc/tesemestr/
cd     ~/usrc/tesemestr/
tar -C ~/usrc/tesemestr/ -xvzf \
  $S/http/angg.twu.net/math/tesemestr-texsrc.tar.gz

mkdir  ~/usrc/tesemestr/slides/
cd     ~/usrc/tesemestr/slides/
tar -C ~/usrc/tesemestr/slides/ -xvzf \
  $S/http/angg.twu.net/math/slidesmestr-texsrc.tar.gz

mkdir  ~/usrc/tesemestr/uff/
cd     ~/usrc/tesemestr/uff/
tar -C ~/usrc/tesemestr/uff/ -xvzf \
  $S/http/angg.twu.net/math/2000uff-texsrc.tar.gz

#
# (code-c-d "tesemestr" "~/usrc/tesemestr/")
# (find-tesemestrfile "")
# (find-tesemestrfile "tesemestr.tex" "\\cpoQuatro cbad")
# (find-tesemestrfile "edrx.sty" "\\def\\cpoQuatro")
# (find-tesemestrpage 83)
# (code-c-d "slidesmestr" "~/usrc/tesemestr/slides/")
# (find-slidesmestrfile "")




#####
#
# framebox
# 2008mar04
#
#####

# «framebox»  (to ".framebox")
# «dags»  (to ".dags")
# (find-dn4ex "edrx08.sty" "dags")
# (find-node "(latex)\\framebox")
# (find-source2egrep "grep -nH -e framebox *")
# (find-source2efile "ltboxes.dtx" "\\DescribeMacro\\framebox")
# (find-source2epage (+ 8 231) "\\framebox")
# (find-source2etext (+ 8 231) "\\framebox")
# (find-source2epage (+ 8 235) "\\framebox")
# (find-source2etext (+ 8 235) "\\framebox")

# (find-kopkadaly4page (+ 12 635) "Index" "picture")
# (find-kopkadaly4page (+ 12 288))
# (find-kopkadaly4page (+ 12 301))
%
% (eedn4a-bounded)

Bla \framebox{foo} bar

\def\dagThree#1#2#3{{\unitlength=.1ex
  \begin{picture}(13,24)
    \put(0,12){\scriptsize #1}    % top left
    \put(12,12){\scriptsize #2}   % top right
    \put(6,0){\scriptsize #3}     % bottom
  \end{picture}
  }}
\def\dagFive#1#2#3#4#5{{\unitlength=.1ex
  \begin{picture}(13,48)
    \put(6,36){\scriptsize $#1$}    % top
    \put(0,24){\scriptsize $#2$}    % second line, left
    \put(12,24){\scriptsize #3}   % second line, right
    \put(6,12){\scriptsize #4}    % third line
    \put(6,0){\scriptsize #5}     % bottom
  \end{picture}
  }}
\def\lowerDagFiveBy{1.2ex}
\def\dagFive#1#2#3#4#5{\lower\lowerDagFiveBy\hbox{\unitlength=.1ex
  \begin{picture}(13,48)
    \put(6,36){\scriptsize #1}    % top
    \put(0,24){\scriptsize #2}    % second line, left
    \put(12,24){\scriptsize #3}   % second line, right
    \put(6,12){\scriptsize #4}    % third line
    \put(6,0){\scriptsize #5}     % bottom
  \end{picture}
  }}

% Foo:\framebox{\dagThree 123}:bar:\dagThree 123:plic
% 
% Foo:\framebox{\dagFive 12345}:bar:\dagFive 12345:plic
% 
% Foo:\framebox{\dagFive 12345}:bar:\dagFive 12345:plic

\edrxcolors
\def\bhbox{\bicolorhbox}
\def\Bhbox{}

Foo: a\bhbox{\dagThree 234}b\bhbox{\dagFive 23456}c

Foo: a\bhbox{\dagThree 234}b\bhbox{\dagFive 23456}c

Foo: a\Bhbox{\dagThree 234}b\Bhbox{\dagFive 23456}c

Foo: a\Bhbox{\dagThree 234}b\Bhbox{\dagFive 23456}c

Foo: a\Bhbox{\dagThree 234}b\bhbox{\dagFive {\,$·$}3456}c


Foo: \bhbox{\scriptsize 9} \bhbox{\scriptsize $9{·}8$} \bhbox{\scriptsize $·$}bar

{
\def·{{\,$\cdot$}}
\def·{0}
$\{a, \dagFive23456, b\}$

$\left\{a, \dagFive23456, b\right\}$

\def\lowerFiveBy{1.6ex}
$\left\{\dagFive23456, \dagFive01011\right\}$

$\{\dagFive23456, \dagFive01011\}$
}


%



#####
#
# figures, listings, captions
# 2008mar12 / 2019may07
#
#####

# «figure-and-caption»  (to ".figure-and-caption")
# «caption» (to ".caption")
# (find-kopkadaly4page (+ 12 169) "\\begin{figure}[where]")
# (find-kopkadaly4text (+ 12 169) "\\begin{figure}[where]")
# (find-kopkadaly4page (+ 12 173) "7.4   Float captions")
# (find-kopkadaly4text (+ 12 173) "7.4   Float captions")
# (find-tesemestrfile "edrx.sty" "\\def\\epsscale")
# https://en.wikibooks.org/wiki/LaTeX/Floats,_Figures_and_Captions

# (find-source2epage (+ 10 382) "\\caption")
# (find-source2etext (+ 10 382) "\\caption")
# (find-classespage 41 "generate the figure number for a caption")
# (find-classestext 41 "generate the figure number for a caption")
# (find-classespage 43 "7.6.3     Captions")
# (find-classestext 43 "7.6.3     Captions")

# https://tex.stackexchange.com/questions/112631/how-to-write-multiple-line-caption-with-figure
# (find-tlsh "find * | sort | grep caption")
# (find-tlsh "find * | sort | grep caption | grep pdf")
# (find-tlfile "texmf-dist/source/latex/caption/")
# (code-c-d      "caption-eng" "/usr/local/texlive/2019/texmf-dist/doc/latex/caption/")
# (code-pdf-page "caption-eng" "/usr/local/texlive/2019/texmf-dist/doc/latex/caption/caption-eng.pdf")
# (code-pdf-text "caption-eng" "/usr/local/texlive/2019/texmf-dist/doc/latex/caption/caption-eng.pdf")
# (find-caption-engfile "")
# (find-caption-engpage)
# (find-caption-engtext)





#####
#
# \long
# 2019oct05
#
#####

# «long» (to ".long")
# (find-texbookpage (+ 12 205) "\\long")
# (find-texbooktext (+ 12 205) "\\long")
# (find-texbookpage (+ 12 206) "\\long\\outer\\global\\long\\def")
# (find-texbooktext (+ 12 206) "\\long\\outer\\global\\long\\def")
# (find-texbookpage (+ 12 382) "\\long\\def\\verbatim")
# (find-texbooktext (+ 12 382) "\\long\\def\\verbatim")
# (find-texbookpage (+ 12 470) "\\long,")
# (find-texbooktext (+ 12 470) "\\long,")





#####
#
# longtable
# 2019may06
#
#####

# «longtable» (to ".longtable")
# (find-tlsh "find * | sort | grep longtable")
# (find-tl-links "/usr/local/texlive/2019/" "texmf-dist/doc/latex/tools/longtable.pdf" "longtable")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/longtable.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/longtable.pdf")
# (code-c-d      "longtable" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/")
# (code-pdf-page "longtable" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/longtable.pdf")
# (code-pdf-text "longtable" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/longtable.pdf")
# (find-longtablefile "")
# (find-longtablepage)
# (find-longtabletext)
# (find-longtablepage 4 "3      Captions and Headings")
# (find-longtabletext 4 "3      Captions and Headings")
# https://tex.stackexchange.com/questions/317121/automatically-adding-page-breaks-into-long-array-environments





#####
#
# miniforth.bib
# 2008mar12
#
#####

# «miniforth.bib»  (to ".miniforth.bib")
# (find-miniforthfile "")
# (find-miniforthfile "miniforth.bib")
# (find-miniforthfile "citing.tex")
# http://bibdesk.sourceforge.net/
#
rm -Rv /tmp/bib/
mkdir  /tmp/bib/
cd     /tmp/bib/
cp -v ~/miniforth/miniforth.bib .
cp -v ~/miniforth/citing.tex .

latex citing ; bibtex citing ; latex citing ; latex citing

#
# (find-fline   "/tmp/bib/")
# (find-dvipage "/tmp/bib/citing.dvi")




#####
#
# Magnification in TeX and LaTeX
# 2008apr03
#
#####

# «magnification-in-tex»  (to ".magnification-in-tex")
# (find-2000ufffile "2000uff.tex")
# (find-2000ufffile "2000uff.tex" "\\large")
# (find-texbookpage (+ 11 403) "\\magnification")
# (find-texbookpage (+ 11 349) "\\magstep")
# (find-texbookpage (+ 11 59) "\\magnification")
# (find-texbookfile "")
# (find-texbookfile "texbook.tex" "^|\\magnification||=\\magstep2|")

# «magnification-in-latex»  (to ".magnification-in-latex")
# http://www.elec.ucl.ac.be/logistique/informatique/Digests/TeX/1992/texhax.21




#####
#
# indentfirst
# 2008apr07
#
#####

# «indentfirst»  (to ".indentfirst")
# (find-sh "locate indentfirst")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/indentfirst.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/indentfirst.pdf")
# (find-kopkadaly4page (+ 12 46) "indentfirst")
# (find-kopkadaly4text (+ 12 46) "indentfirst")




#####
#
# understanding \begin{verbatim}
# 2008apr15 / 2019feb14
#
#####

# «verbatim»  (to ".verbatim")
# (find-angg ".emacs.papers" "source2e")
# (find-source2epage (+ 10 609) "Index")
# (find-source2etext (+ 10 609) "Index")
# (find-source2epage (+ 10 659) "verbatim")
# (find-source2etext (+ 10 659) "verbatim")
# (find-source2epage (+ 10 274) "53.3      Verbatim")
# (find-source2etext (+ 10 274) "53.3      Verbatim")
# (find-source2epage (+ 10 277) "verbatim")
# (find-source2etext (+ 10 277) "verbatim")

# (find-source2efile "")
# (find-source2efile "ltmiscen.dtx" "\\subsection{Verbatim}")
# (find-source2efile "ltmiscen.dtx" "\\subsection{Verbatim}" "missing item")
# (find-source2efile "ltmiscen.dtx" "\\gdef\\@vobeyspaces")
# (find-source2egrep "grep -nH -e obeyspaces *")
# (find-source2egrep "grep -nH -e makeother *")

# (find-texbookfile "")
# (find-texbookgrep "grep -nH -e obeyspaces *")
# (find-texbookgrep "grep -nH -e obeylines *")

# (find-fline "/usr/share/texmf-tetex/tex/plain/verbatim/verbatim.tex")
# (find-plainsrcfile "")
# (find-plainsrcfile "plain.tex" "\\def\\obeyspaces")
# (find-plainsrcfile "plain.tex" "\\gdef\\obeylines")
# (find-plainsrcfile "plain.tex" "\\let\\endgraf=\\par \\let\\endline=\\cr\n")

\def\par{\leavevmode\endgraf}

 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\tracingonline=1
\makeatletter
\show\verbatim
i\show\endverbatim
i\show\endtrivlist
i\show\@verbatim
i\show\frenchspacing
i\show\sfcode
i\show\@vobeyspaces
i\show\@xverbatim
i\show\verb
i\show\dospecials
i\show\@makeother
i\show\obeylines
i\show\obeyspaces
i\show\space

%
% (eedn4a-bounded)

plic {\tt bar} ploc

plic \begingroup bar \tt poo \endgroup foo

plic \begingroup\def{\endgroup} foo \tt poo  bar


\makeatletter
\def\makespecialsother{\let\do\@makeother\dospecials}
\makeatother
\let\softpar=\par
\def\hardpar{\softpar\leavevmode}
\def\myobeylines{\let\par=\hardpar\obeylines}
\def\mysetverbatim{\makespecialsother\myobeylines\obeyspaces}
\def\mystarverbatim{\begingroup\def{\endgroup}\tt\mysetverbatim}

a\mystarverbatim
foo bar
  plic  ploc
 tt tt plic
%@~\\{}bar

\setbox0=\vtop{
a\mystarverbatim
foo bar
  plic  ploc
 tt tt plic
%@~\\{}bar}

\leavevmode\copy0\copy0

\fbox{\copy0}

\bhbox{\copy0}

\fbox{\vbox{a b c}}

\fbox{\hbox{a b c}}

%




#####
#
# verbatim.dtx
# 2009aug18
#
#####

# «verbatim.dtx»  (to ".verbatim.dtx")
# (find-zsh "dmissing verbatim")
# (find-zsh "dmissing verbatim | grep tex ")
# (find-zsh "dmissing verbatim.pdf")
# (find-fline "/usr/share/texmf-texlive/tex/generic/genmisc/verbatim.tex")
# (find-fline "/usr/share/texmf-texlive/tex/latex/tools/verbatim.sty")
# (code-pdf-page  "verbatim" "/usr/share/doc/texlive-latex-base-doc/latex/tools/verbatim.pdf")
# (code-pdf-text  "verbatim" "/usr/share/doc/texlive-latex-base-doc/latex/tools/verbatim.pdf")
# (find-verbatimpage 4 "boxed text")
# (find-verbatimtext   "boxed text")

# The .dtx is in the "tools" bundle: (to "tools")




#####
#
# verbatimbox
# 2009aug18 / 2019feb14
#
#####

# «verbatimbox»  (to ".verbatimbox")
# «verbbox»  (to ".verbbox")
# (find-tlsh "find * | sort | grep verbatim")

# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/verbatimbox/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/verbatimbox/README")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/verbatimbox/verbatimbox.sty")
# (code-pdf-page "verbatimbox" "/usr/local/texlive/2019/texmf-dist/doc/latex/verbatimbox/verbatimbox.pdf")
# (code-pdf-text "verbatimbox" "/usr/local/texlive/2019/texmf-dist/doc/latex/verbatimbox/verbatimbox.pdf")
# (find-verbatimboxpage)
# (find-verbatimboxtext)
# (find-verbatimboxpage 4 "1.4    The \\theverbbox Command")
# (find-verbatimboxtext 4 "1.4    The \\theverbbox Command")

\usepackage{verbatimbox}

\begin{verbbox}
   x = 1
10 a = a + x
   if (a .eq. 100) stop
\end{verbbox}
%
a\bhbox{\theverbbox}b

{\footnotesize
\begin{verbbox}
   x = 1
10 a = a + x
   if (a .eq. 100) stop
\end{verbbox}
}
%
a\bhbox{\theverbbox}b

a\fbox{\theverbbox}b

\begin{verbbox}
      Program test
      implicit none
      integer a, x
      a = 0
      x = 1
   10 a = a + x
      if (a .eq. 100) stop
      goto 10
      end
\end{verbbox}




#####
#
# verbatiminput
# 2020dec20
#
#####

# «verbatiminput»  (to ".verbatiminput")
# https://tex.stackexchange.com/questions/85200/include-data-from-a-txt-verbatim





#####
#
# \fbox
# 2016oct26
#
#####

# «fbox» (to ".fbox")
# (find-source2epage (+ 8 231) "\\framebox")
# (find-source2etext (+ 8 231) "\\framebox")
# (find-source2epage (+ 8 231) "\\fbox")
# (find-source2etext (+ 8 231) "\\fbox")
# (find-source2epage (+ 8 235) "\\newdimen\\fboxsep")
# (find-source2etext (+ 8 235) "\\newdimen\\fboxsep")
# (find-source2epage (+ 8 235) "\\kern\\fboxsep")
# (find-source2etext (+ 8 235) "\\kern\\fboxsep")

# (find-texbookpage (+ 12 56) "10" "Dimensions")
# (find-texbooktext (+ 12 56) "10" "Dimensions")
# (find-texbookpage (+ 12 61) "full set")
# (find-texbooktext (+ 12 61) "full set")
# (find-texbookpage (+ 12 66) "\\setbox0=")
# (find-texbooktext (+ 12 66) "\\setbox0=")
# (find-texbookpage (+ 12 118) "\\advance\\dimen")
# (find-texbooktext (+ 12 118) "\\advance\\dimen")
# (find-texbookpage (+ 12 271) "plus dimen")
# (find-texbooktext (+ 12 271) "plus dimen")

;; (find-kopkadaly4page (+ 12 86) "fbox")
;; (find-kopkadaly4page (+ 12 94) "\\ovalbox")
;; (find-kopkadaly4page (+ 12 607) "Index")
;; (find-kopkadaly4page (+ 12 620) "fbox")
;; (find-kopkadaly4text)

;; (find-texbookpage 1)
;; (find-texbooktext)


\newdimen\cellsep
\cellsep=2pt
\def\addcellsep{%
  \setbox0=\hbox{\kern\cellsep\box0\kern\cellsep}%
  \ht0=\ht0 plus \cellsep%
  \dp0=\dp0 plus \cellsep%
  \box0%
}
\def\cellsp#1{%
  \setbox0=\hbox{#1}%
  \addcellsep%
1  \box0%
}



#####
#
# \minipage
# 2018dec07
#
#####

# «minipage» (to ".minipage")
# (to "boxedminipage")
# (to "fbox-minipage")

# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page         7  "Contents")
# (find-kopkadaly4page (+ 12  88) "4.7.3   Parboxes and minipages")
# (find-kopkadaly4text (+ 12  88) "4.7.3   Parboxes and minipages")
# (find-kopkadaly4page (+ 12  89) "4.7.4   Problems with vertical placement")
# (find-kopkadaly4text (+ 12  89) "4.7.4   Problems with vertical placement")
# (find-kopkadaly4page (+ 12  90) "4.7.5   Paragraph boxes of speci" "c height")
# (find-kopkadaly4text (+ 12  90) "4.7.5   Paragraph boxes of speci" "c height")
# (find-kopkadaly4page (+ 12  93)       "Finally, vertical boxes such as")
# (find-kopkadaly4text (+ 12  93)       "Finally, vertical boxes such as")
# (find-kopkadaly4page (+ 12 607) "Index")
# (find-kopkadaly4text)

https://tex.stackexchange.com/questions/156767/multiple-columns-with-minipage-cant-use-100-of-textwidth




#####
#
# fullminipage
# 2021oct28
#
#####

# «fullminipage»  (to ".fullminipage")
# (find-tlsh "find * | sort | grep minipage")

(code-pdf-page "fullminipage" "/usr/local/texlive/2019/texmf-dist/doc/latex/fullminipage/fullminipage.pdf")
(code-pdf-text "fullminipage" "/usr/local/texlive/2019/texmf-dist/doc/latex/fullminipage/fullminipage.pdf")
;; (find-fullminipagepage)
;; (find-fullminipagetext)





#####
#
# boxedminipage
# 2009aug18 / 2016sep19
#
#####

# «boxedminipage»  (to ".boxedminipage")
# http://ctan.org/pkg/boxedminipage

# (find-tlsh "find * | sort | grep boxedminipage")


# (find-sh "locate boxedminipage")
# (find-zsh "dmissing boxedminipage")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/boxedminipage/")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/boxedminipage2e/")
(code-pdf-page "boxedminipage"   "/usr/local/texlive/2019/texmf-dist/doc/latex/boxedminipage/boxedminipage.pdf")
(code-pdf-text "boxedminipage"   "/usr/local/texlive/2019/texmf-dist/doc/latex/boxedminipage/boxedminipage.pdf")
(code-pdf-page "boxedminipage2e" "/usr/local/texlive/2019/texmf-dist/doc/latex/boxedminipage2e/boxedminipage2e.pdf")
(code-pdf-text "boxedminipage2e" "/usr/local/texlive/2019/texmf-dist/doc/latex/boxedminipage2e/boxedminipage2e.pdf")
;; (find-boxedminipagepage)
;; (find-boxedminipagetext)
;; (find-boxedminipage2epage)
;; (find-boxedminipage2etext)

# (find-pdf-page "/usr/share/doc/texlive-doc/latex/boxedminipage/boxedminipage.pdf")
# (find-fline "/usr/share/doc/texlive-doc/latex/boxedminipage/boxedminipage.tex")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/boxedminipage/boxedminipage.sty")


# How to mix the boxy verbatims with my ttchars?
# (find-dn4ex "edrx08.sty" "ttchars")

 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\tracingonline=1\scrollmode
\show\setbox
\show\begin


%
% (eedn4a-bounded)
% (find-sh0 "cd ~/LATEX/ && dvips  -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-sh0 "cd ~/LATEX/ && dvired -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-pspage "~/LATEX/tmp.ps")

A b c d:
\begin{minipage}[c]{2cm}
a b c d e f g
\par a b c d e f g

\noindent a b c d e f

a a a a a a a a a a a a a a a a a a a a a a
\end{minipage}
bar.

\savebox{\myboxa}{%
\begin{minipage}[c]{2cm}
a b c d e f g
\par a b c d e f g

\noindent a b c d e f

a a a a a a a a a a a a a a a a a a a a a a
\end{minipage}%
}

Boo: \usebox{\myboxa} woo: \usebox{\myboxa} plink.


%
% (eedn4a-bounded)
% (find-sh0 "cd ~/LATEX/ && dvips  -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-sh0 "cd ~/LATEX/ && dvired -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-pspage "~/LATEX/tmp.ps")

\setbox0=\hbox{%
\begin{minipage}[c]{2cm}
\par \verb|a = 123|
\par \verb|b = 234|
\par a b c d e f g

\noindent a b c d e f

a a a a a a a a a a a a a a a a a a a a a a
\end{minipage}%
}
\savebox{\myboxa}{\copy0}

Boo: \fbox{\usebox{\myboxa}} woo: \usebox{\myboxa} plink.

%

% «smini»  (to ".smini")
% (defun smini () (interactive) (insert "\\setbox0=\\hbox{%\n\\begin{minipage}[c]{2cm}\n\\end{minipage}%\n}\n\\savebox{\\myboxa}{\\copy0}\n"))




#####
#
# fbox'ing a verbatim in a minipage
# 2015apr17
#
#####

# «fbox-minipage» (to ".fbox-minipage")
# (find-angg ".emacs" "unilog-current")
# (find-854 "" "prog-with-long-names")
# (find-854file "" "\\fbox{\\usebox{\\myboxsrc}}")
# (find-854page 31 "Programming with long names")

\newsavebox{\myboxsrc}

\setbox0=\hbox{%
\begin{minipage}[c]{5.5cm}
\par \verb!<a,b|->a,c> = function (<a,b>)!
\par \verb!    local a = pi1(<a,b>)!
\par \verb!    local b = pi2(<a,b>)!
\par \verb!    local c = <b|->c>(b)!
\par \verb!    local <a,c> = {a, c}!
\par \verb!    return <a,c>!
\par \verb!  end!
\end{minipage}%
}
\savebox{\myboxsrc}{\copy0}

\setbox0=\hbox{%
\begin{minipage}[c]{5.5cm}
\begin{verbatim}
<a,b|->a,c> = function (<a,b>)
    local a = pi1(<a,b>)
    local b = pi2(<a,b>)
    local c = <b|->c>(b)
    local <a,c> = {a, co}
    return <a,c>
  end
\end{verbatim}
\end{minipage}%
}
\savebox{\myboxsrc}{\copy0}

a
\fbox{\usebox{\myboxsrc}}
b







#####
#
# The source for the "tools" package
# 2009aug18 / 2018dec09
#
#####

# «tools»  (to ".tools")
# https://ctan.org/pkg/latex-tools?lang=en
# (find-sh "locate tools | grep texlive")
# (find-tlfile "texmf-dist/doc/latex/tools/")
# (find-tlfile "texmf-dist/source/latex/tools/")

# http://www.ctan.org/tex-archive/help/Catalogue/entries/tools.html
# http://tug.ctan.org/get/macros/latex/required/tools.zip
#
rm -Rv   ~/usrc/tools/
unzip -d ~/usrc/ \
  $S/http/tug.ctan.org/get/macros/latex/required/tools.zip
cd       ~/usrc/tools/

#
# (code-c-d "latextools" "~/usrc/tools/")
# (find-latextoolsfile "")
# (find-latextoolsfile "verbatim.dtx")
#
# (code-pdf-page  "verbatim" "~/usrc/tools/verbatim.pdf")
# (code-pdf-text  "verbatim" "~/usrc/tools/verbatim.pdf")
# (find-verbatimpage      5  "\\def\\verbatimboxed")
# (find-verbatimtext         "\\def\\verbatimboxed")
# (find-verbatimpage      5  "\\def\\verbatimwrite")
# (find-verbatimtext         "\\def\\verbatimwrite")
# (find-verbatimpage      1  "Contents")
# (find-verbatimpage (+ 1 1) "Index")
# (find-verbatimtext "")




#####
#
# toolbox
# 2020jun15
#
#####

# «toolbox» (to ".toolbox")
# (find-tlsh "find * | sort | grep toolbox")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/toolbox/")
(code-pdf-page "toolbox" "/usr/local/texlive/2019/texmf-dist/doc/latex/toolbox/toolbox.pdf")
(code-pdf-text "toolbox" "/usr/local/texlive/2019/texmf-dist/doc/latex/toolbox/toolbox.pdf")
;; (find-toolboxpage)
;; (find-toolboxtext)



#####
#
# amsmath
# 2018dec09
#
#####

# «amsmath» (to ".amsmath")
# (find-angg ".emacs.papers" "amsmath")
# (find-sh "locate amsmath")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/amsmath/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/source/latex/amsmath/")
# (code-c-d      "amsmath" "/usr/local/texlive/2019/texmf-dist/source/latex/amsmath/")
# (code-pdf-page "amsldoc" "/usr/local/texlive/2019/texmf-dist/doc/latex/amsmath/amsldoc.pdf")
# (code-pdf-text "amsldoc" "/usr/local/texlive/2019/texmf-dist/doc/latex/amsmath/amsldoc.pdf" 4)




#####
#
# smallmatrix
# 2008apr26
#
#####

# «smallmatrix»  (to ".smallmatrix")
# (find-LATEX "edrx17defs.tex" "psm-and-pmat")
# (find-angg ".emacs.papers" "amsmath")
# https://tex.stackexchange.com/questions/98663/how-to-model-smallmatrix-with-array

# (find-amsldocpage)
# (find-amsldoctext)
# (find-amsldocpage (+ 4 13) "smallmatrix")
# (find-amsldoctext (+ 4 13) "smallmatrix")
# (find-amsldocpage (+ 4 13) "mathtools" "p,b,B,v,V versions of smallmatrix")
# (find-amsldoctext (+ 4 13) "mathtools" "p,b,B,v,V versions of smallmatrix")
# (find-amsmathfile "")
# (find-amsmathgrep "grep --color -nH -e smallmatrix *")
# (find-amsmathfile "amsmath.dtx" "\\begin{environment}{smallmatrix}")
# (find-amsmathpage 31 "\\newenvironment{smallmatrix}")
# (find-amsmathtext 31 "\\newenvironment{smallmatrix}")




#####
#
# MaxMatrixCols
# 2015sep27
#
#####

# «MaxMatrixCols» (to ".MaxMatrixCols")
# (find-angg ".emacs" "find-amsmathpage")
# (find-amsmathpage 28 "smallmatrix")
# (find-amsmathtext 28 "smallmatrix")
# (find-amsmathpage 29 "MatrixCols")
# (find-amsmathtext 29 "MatrixCols")
# http://tex.stackexchange.com/questions/95162/how-to-create-a-matrix-with-20-columns-in-latex
# http://tex.stackexchange.com/questions/212816/typing-an-11-x-11-or-larger-matrix?rq=1

\setcounter{MaxMatrixCols}{15}

# (find-sh "locate amsmath")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/amsmath/")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/amsmath/amsmath.sty")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/amsmath/amstex.sty" "\\c@MaxMatrixCols")

# (code-c-d "amsmath" "/usr/share/texlive/texmf-dist/tex/latex/amsmath/")
# (find-amsmathfile "")
# (find-amsmathgrep "grep --color -niH -e matrixcols *")
# (find-amsmathgrep "grep --color -nrH -e MaxMatrixCols ../*")




#####
#
# unicode-math
# 2021jul07
#
#####

# «unicode-math»  (to ".unicode-math")
# (find-tlsh "find * | sort | grep unicode-math")
(code-pdf-page "unimath" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unicode-math.pdf")
(code-pdf-text "unimath" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unicode-math.pdf")
(code-pdf-page "unimathsymbols" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unimath-symbols.pdf")
(code-pdf-text "unimathsymbols" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unimath-symbols.pdf")
;; (find-unimathpage)
;; (find-unimathtext)
;; (find-unimathsymbolspage)
;; (find-unimathsymbolstext)
# (find-unimathpage 10 "4.4.1   Default `text math' fonts")
# (find-unimathtext 10 "4.4.1   Default `text math' fonts")





#####
#
# inputenc and \DeclareUnicodeCharacter
# 2008may06 / 2019dec01
#
#####

# «declareunicodecharacter» (to ".declareunicodecharacter")
# «inputenc»  (to ".inputenc")
# (find-LATEX "2019oxford-chars.tex")
# (find-angg ".emacs.papers" "inputenc")
# https://tex.stackexchange.com/questions/432671/printing-rare-characters
# https://tex.stackexchange.com/questions/229957/how-do-i-redefine-the-qed-symbol-to-be-a-unicode-character

# (find-tlsh "find * | sort | grep inputenc")
# (find-tlsh "find * | sort | grep ienc")
# (code-c-d      "inputenc" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/")
# (code-pdf-page "inputenc" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/inputenc.pdf")
# (code-pdf-text "inputenc" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/inputenc.pdf")
# (find-inputencfile "")
# (find-inputencpage)
# (find-inputenctext)
# (find-inputencpage 4 "\\DeclareUnicodeCharacter{00E4}{\\\"a}")
# (find-inputenctext 4 "\\DeclareUnicodeCharacter{00E4}{\\\"a}")
# (find-inputencpage 4 "1.3.3   Unicode char" "not set up for use with LaTeX")
# (find-inputenctext 4 "1.3.3   Unicode char" "not set up for use with LaTeX")

# (code-c-d      "utf8ienc" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/")
# (code-pdf-page "utf8ienc" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/utf8ienc.pdf")
# (code-pdf-text "utf8ienc" "/usr/local/texlive/2019/texmf-dist/doc/latex/base/utf8ienc.pdf")
# (find-utf8iencfile "")
# (find-utf8iencpage)
# (find-utf8ienctext)
# (find-utf8iencpage 7 "\\DeclareUnicodeCharacter")
# (find-utf8ienctext 7 "\\DeclareUnicodeCharacter")





# (find-dn4exfile "edrx08.sty")
# (find-dn4exfile "edrxmain41.tex" "\\usepackage[latin1]{inputenc}")
# (find-sh "locate inputenc")
# (find-sh "locate latin1.def")
# (find-fline   "/usr/share/texlive/texmf-dist/tex/latex/base/latin1.def")

;; (find-fline "/usr/share/doc/texlive-doc/latex/base/")
;; (find-inputencpage)
;; (find-inputenctext)

# (find-fline "/usr/share/doc/texlive-doc/latex/base/")
# (find-fline "/usr/share/doc/texlive-doc/latex/base/" "usrguide.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/base/utf8ienc.pdf" 19)
# (find-pdf-text "/usr/share/doc/texlive-doc/latex/base/utf8ienc.pdf" 19)

# (find-sh "locate utf8 | grep def")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/base/utf8.def")

# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/base/inputenc.sty")

# (find-fline "/usr/share/doc/texlive-doc/lualatex/luainputenc/inputenc.sty.diff")
# (find-pdf-page "/usr/share/doc/texlive-doc/lualatex/luainputenc/luainputenc.pdf")
# (find-fline "/usr/share/doc/texlive-doc/lualatex/luainputenc/NEWS.gz")
# (find-fline "/usr/share/doc/texlive-doc/lualatex/luainputenc/README")
# (find-fline "/usr/share/doc/texlive-doc/lualatex/luainputenc/test.tex")
# (find-fline "/usr/share/texlive/texmf-dist/tex/lualatex/luainputenc/luainputenc.lua")
# (find-fline "/usr/share/texlive/texmf-dist/tex/lualatex/luainputenc/luainputenc.sty")
# (find-fline "/usr/share/texlive/texmf-dist/tex/lualatex/luainputenc/lutf8.def")
# (find-fline "/usr/share/texlive/texmf-dist/tex/lualatex/luainputenc/lutf8x.def")

! Package inputenc Error: Unicode character µ (U+03B5)
(inputenc)                not set up for use with LaTeX.

See the inputenc package documentation for explanation.




#####
#
# Converting my special chars in edrxchars.tex to inputenc/utf8
# 2019may02
#
#####

# «inputenc-edrxchars» (to ".inputenc-edrxchars")
# (find-LATEX "edrxchars.tex")
# (find-LATEX "2019oxford-abs.tex")
# (find-LATEX "2019oxford-chars.tex")

# The Oxford abstract had to be typeset with:
#   \usepackage[utf8]{inputenc}
#   \usepackage[english]{babel}
#   \usepackage[T1]{fontenc}
# This is how I converted my `\def's in edrxchars.tex to things like:
#   \DeclareUnicodeCharacter{03B5}{\epsilon}
#   \DeclareUnicodeCharacter{03B7}{\eta}

# (find-angg "LUA/lua50init.lua" "u8c_to_l1")
# (find-lua53manual "#6.5" "UTF-8 Support")

 (eepitch-lua53)
 (eepitch-kill)
 (eepitch-lua53)
bigstr = ee_readfile "~/LATEX/edrxchars.tex"
pat0 = "catcode"
pat0 = "^\\catcode"
pat  = "^\\catcode`(.-)=13 \\def(.-)(%b{})"
for _,li in ipairs(splitlines(bigstr)) do
  if li:match(pat0) then
    print(li)
    PP(li:match(pat))
    local _,c,expansion = li:match(pat)
    expansion = expansion:sub(2,-2)
    PP(#c, c, expansion)
    local cp = utf8.codepoint(c)
    local cphex = format("%X", cp)
    local cphex = format("%04X", cp)
    local decl = format("\\DeclareUnicodeCharacter{%s}{%s}", cphex, expansion)
    local declplus = format("%-50s %% %s", decl, c)
    PP(cp, cphex)
    -- print(decl)
    print(declplus)
  end
end

 (eepitch-lua53)
 (eepitch-kill)
 (eepitch-lua53)
bigstr = ee_readfile "~/LATEX/edrxchars.tex"
for _,li in ipairs(splitlines(bigstr)) do
  if li:match(pat0) then
    local _,c,expansion = li:match(pat)
    expansion = expansion:sub(2,-2)
    local cp = utf8.codepoint(c)
    local cphex = format("%04X", cp)
    local decl = format("\\DeclareUnicodeCharacter{%s}{%s}", cphex, expansion)
    local declplus = format("%-50s %% %s", decl, c)
    print(declplus)
  end
end

(find-lua52manual "")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
apti lua5.3
apti lua5.3 lua5.3-doc





#####
#
# The newunicodechar package
# 2019dec01
#
#####

# «newunicodechar» (to ".newunicodechar")
# https://ctan.org/pkg/newunicodechar?lang=en
# (find-LATEX "mynewunicodechar.sty")
# (find-tlsh "find * | sort | grep newunicodechar")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/newunicodechar/")
;; (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/newunicodechar/newunicodechar.pdf")
;; (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/newunicodechar/newunicodechar.pdf")
(code-pdf-page "newunicodechar" "/usr/local/texlive/2019/texmf-dist/doc/latex/newunicodechar/newunicodechar.pdf")
(code-pdf-text "newunicodechar" "/usr/local/texlive/2019/texmf-dist/doc/latex/newunicodechar/newunicodechar.pdf")
;; (find-newunicodecharpage)
;; (find-newunicodechartext)
# (find-newunicodecharpage 3 "\\@namedef{u8:\\detokenize{u}}")
# (find-newunicodechartext 3 "\\@namedef{u8:\\detokenize{u}}")
# (find-source2epage 47 "\\@namedef")
# (find-source2etext 47 "\\@namedef")

# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/newunicodechar/newunicodechar.sty")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/mynu/")
rm -Rv /tmp/mynu/
mkdir  /tmp/mynu/
cd     /tmp/mynu/
cp -iv /usr/local/texlive/2019/texmf-dist/tex/latex/newunicodechar/newunicodechar.sty mynu.sty

cat > test.tex <<'==='
\documentclass{article}
\usepackage{mynu}
\begin{document}
\end{document}
===

pdflatex test.tex
lualatex test.tex

# (find-fline "/tmp/mynu/")
# (find-fline "/tmp/mynu/test.tex")
# (find-pdf-page "/tmp/mynu/test.pdf")
# (find-fline "/tmp/mynu/mynu.sty")




# (find-fline "/tmp/nu/nu.tex")

Hi Enrico,




\end{document}




enrico.gregorio@univr.dot.it





#####
#
# \detokenize
# 2019dec01
#
#####

# «detokenize» (to ".detokenize")
# https://tex.stackexchange.com/questions/20059/what-are-the-exact-semantics-of-detokenize
# http://tex.loria.fr/moteurs/etex_ref.html#detokenize
# https://tex.stackexchange.com/questions/44391/detokenizing-without-extra-spaces
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work:_The_meaning_of_expansion
# https://tex.stackexchange.com/questions/233718/show-content-of-token-register-as-a-string-in-the-document
# (find-luatexrefpage (+ 4 203) "etex")
# (find-luatexreftext (+ 4 203) "etex")
# (find-luatexreftext (+ 4 203) "etex" "detokenize")




#####
#
# fontspec and selinput
# 2015oct10 / 2022jan15
#
#####

# «fontspec» (to ".fontspec")
# «selinput» (to ".selinput")

# (find-tlsh "find * | sort | grep fontspec")
# (code-c-d      "fontspec" "/usr/local/texlive/2019/texmf-dist/doc/latex/fontspec/")
# (code-pdf-page "fontspec" "/usr/local/texlive/2019/texmf-dist/doc/latex/fontspec/fontspec.pdf")
# (code-pdf-text "fontspec" "/usr/local/texlive/2019/texmf-dist/doc/latex/fontspec/fontspec.pdf")
# (find-fontspecfile "")
# (find-fontspecpage)
# (find-fontspectext)

;; https://tug.org/TUGboat/tb39-2/tb122robertson-rfontspec.pdf
;; (find-fline "$S/https/tug.org/TUGboat/tb39-2/")
(code-pdf-page "rfontspec" "$S/https/tug.org/TUGboat/tb39-2/tb122robertson-fontspec.pdf")
(code-pdf-text "rfontspec" "$S/https/tug.org/TUGboat/tb39-2/tb122robertson-fontspec.pdf")
;; (find-rfontspecpage)
;; (find-rfontspectext)

\usepackage{fontspec}
\setmainfont{TeX Gyre Pagella}

# (find-sh "apt-file search otf")
# (find-sh "apt-file search otf | grep otf$")
# (find-fline "~/LOGS/2023apr13.emacs" "AnkaCLM-Bold")

https://arkandis.tuxfamily.org/tugfonts.htm



# (find-sh "locate fontspec")
# (find-sh "locate selinput")
# (find-fline "/usr/share/doc/texlive-doc/latex/fontspec/")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/oberdiek/selinput.pdf")
# (find-fline "/usr/share/doc/texlive-doc/latex/oberdiek/test/")

http://tex.stackexchange.com/questions/8857/how-to-type-special-accented-letters-in-latex

https://tug.org/TUGboat/tb39-2/tb122robertson-fontspec.pdf
<lockywolf> \setmainfont{whatever.otf}

# (find-sh "locate otf")
# (find-sh "locate OTF")
# (find-sh "locate 'otf$' | grep -v texlive")


<edrx> lockywolf: this gave me lots of results - apt-file search
       otf - but all the otfs are in other dirs. suppose that I
       want to use this font:
       /usr/share/fonts/opentype/culmus-fancy/AnkaCLM-Bold.otf
<edrx> do you think that this would work?
       \setmainfont{AnkaCLM-Bold}




;; <fontspec>






#####
#
# agda.sty
# 2022jan15
#
#####

# «agda.sty»  (to ".agda.sty")
# (find-fline "~/LATEX/agda.sty")
# (find-LATEXfile "agda.sty")





#####
#
# weaving tex.web
# 2008may09
#
#####

# «weaving-tex.web»  (to ".weaving-tex.web")
# http://www.ctan.org/get/systems/knuth/dist/tex/tex.web
# (find-es "tex" "weaving")
#
rm -Rv ~/usrc/tex/
mkdir  ~/usrc/tex/
cd     ~/usrc/tex/
cp -v $S/http/www.ctan.org/get/systems/knuth/dist/tex/tex.web .
weave tex.web
tex   tex.tex
dvipdf tex.dvi

#
(code-c-d "texwebsrc" "~/usrc/tex/")
(code-dvi       "texwebsrc" (ee-texwebsrcfile "tex.dvi"))
(code-pdf-text  "texwebsrc" (ee-texwebsrcfile "tex.pdf"))
;; (find-texwebsrcfile "")
;; (find-texwebsrcpage 1)
;; (find-texwebsrcpage (+ -2 482))
;; (find-texwebsrctext)
;; (find-texwebsrctext "define show box")
;; (find-texwebsrcpage (+ -2 453))




#####
#
# tetex-doc/latex/general
# 2008may09
#
#####

# «latex-general»  (to ".latex-general")
# (find-status   "tetex-doc")
# (find-vldifile "tetex-doc.list")
# (find-udfile   "tetex-doc/")
# (find-fline "/usr/share/doc/tetex-doc/latex/general/")
#
rm -Rv /tmp/general/
mkdir  /tmp/general/
cd     /tmp/general/
cp -v /usr/share/doc/tetex-doc/latex/general/* .
cp -v /usr/share/doc/tetex-doc/plain/impatient/impatient.dvi.gz .
gunzip -v *.gz

#
# (find-sh "ls /tmp/general/*")
# (find-pspage  "/tmp/general/a.ps")
# (find-dvipage "/tmp/general/guide.dvi")
# (find-pspage  "/tmp/general/guide.ps")
# (find-pspage  "/tmp/general/l2kurz.pdf")
# (find-pspage  "/tmp/general/l2tabu.pdf")
# (find-pspage  "/tmp/general/l2tabuen.pdf")
# (find-dvipage "/tmp/general/latex2e.dvi")
# (find-pspage  "/tmp/general/lshort.pdf")
# (find-dvipage "/tmp/general/symbols.dvi")
# (find-dvipage "/tmp/general/symbols.dvi")
# (find-dvipage "/tmp/general/impatient.dvi")
# (find-dvipage "/usr/share/doc/tetex-doc/plain/impatient/impatient.dvi.gz")

(code-ps        "lshort" "/tmp/general/lshort.pdf")
(code-pdf-text  "lshort" "/tmp/general/lshort.pdf")
;; (find-lshortpage 1)
;; (find-lshorttext)




#####
#
# \leavevmode
# 2008may17
#
#####

# «leavevmode»  (to ".leavevmode")
# (find-LATEXgrep "grep --color -nH -e leavevmode *")
# (find-texbytopictext "\nHorizontal and Vertical Mode")
# (find-texbytopictext "The horizontal commands are the following:")
# (find-texbytopictext "\\def\\leavevmode{\\unhbox\\voidb@x}")
# (find-texbookpage (+ 12 313) "\\leavevmode is an abbreviation for")
# (find-texbooktext (+ 12 313) "\\leavevmode is an abbreviation for")
# (find-texbookpage (+ 12 313) "\\unskip")
# (find-texbooktext (+ 12 313) "\\unskip")
# (find-texbookpage (+ 12 222) "\\unskip")
# (find-texbooktext (+ 12 222) "\\unskip")
# (find-texbookpage (+ 12 267) "24 Summary of Vertical Mode")
# (find-texbookpage (+ 12 285) "25 Summary of Horizontal Mode")
# (find-lsrcgrep "grep -nH -e leavevmode base/*")
# (find-lsrcfile "base/ltplain.dtx" "\\def\\leavevmode")

\hbox{a}\hbox{b}\hbox{c}

\vbox{d}\vbox{e}\vbox{f}

0\hbox{a}\hbox{b}\hbox{c}

0\vbox{d}\vbox{e}\vbox{f}

0\vbox{d}\vbox{e}\vbox{f}

0\vbox{d}\vbox{e}\vbox{f}1 hello




#####
#
# ttchars: a trick to use other symbols in \tt and verbatim mode
# 2019sep09
#
#####

# «ttchars» (to ".ttchars")
# Current version: (find-LATEX "edrxchars.tex" "ttchars")
# See: (find-LATEX "istanbulall.lua" "ttchars")
#      (to "leavevmode")
# Old versions:
#   (find-LATEXgrep "grep --color -nH -e ttchar *")
#   (find-dn4ex "edrx08.sty" "ttchars")
#   (find-LATEX "edrx15.sty" "ttchars")
#   (find-LATEX "edrx17.sty" "ttchars")
#   (find-LATEX "edrx17defs.tex" "ttchars")
# Some uses:
#   (find-LATEXgrep "grep -nH -e ttchar *.tex")
#   (find-LATEXfile "2008dnc-sets.tex" "{\\myttchars")
#   (find-LATEX "istanbul1.tex")
#   (find-LATEX "istanbuldefs.tex" "ttchars")






#####
#
# texbytopic.dvi
# 2008may20
#
#####

# «texbytopic»  (to ".texbytopic")
# (find-angg ".emacs.papers" "texbytopic")

# (find-tlsh "find * | sort | grep texbytopic")

# ftp://tug.ctan.org/pub/tex-archive/info/texbytopic/
# (eev "psner-ftp ftp://tug.ctan.org/pub/tex-archive/info/texbytopic/")
#
rm -Rv ~/usrc/texbytopic/
mkdir  ~/usrc/texbytopic/
cd     ~/usrc/texbytopic/

cd $S/ftp/tug.ctan.org/pub/tex-archive/info/texbytopic/
cp -v README TeXbyTopic.tex figflow.tex glossary.tex tables.tex tex.bib \
       ~/usrc/texbytopic/
cd     ~/usrc/texbytopic/

# "ol" will contain 18000 lines of warnings like this:
#   Package hyperref Warning: Token not allowed in a PDFDocEncoded string,
#   (hyperref)                removing `\\' on input line 786.
latex TeXbyTopic.tex > ol
latex TeXbyTopic.tex > ol2
latex TeXbyTopic.tex > ol3

#
# (code-c-d "texbytopic" "~/usrc/texbytopic/")
# (code-dvi "texbytopicdvi" (ee-texbytopicfile "TeXbyTopic.dvi"))
# (find-texbytopicfile "")
# (find-texbytopicfile "ol")
# The dvi version seem to be identical to the pdf...
# (find-texbytopicdvipage 1)
# (find-texbytopicpage  1)




#####
#
# color
# 2008may21 / 2016sep10
#
#####

# «color»  (to ".color")
# (find-lsrcfile "graphics/color.dtx")
# (find-lsrcfile "graphics/color.sty")

# 2016sep10:
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/graphics/color.sty")
# (find-fline "/usr/share/doc/texlive-doc/latex/graphics/")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/graphics/color.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/graphics/graphics.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/graphics/graphicx.pdf")

# (find-fline "/usr/share/texmf-tetex/tex/latex/graphics/color.sty")
# (find-zsh "dmissing grfguide")
# (find-zsh "dmissing color.sty")
# (code-pdf-page  "grfguide" "/usr/share/doc/texlive-latex-base-doc/latex/graphics/grfguide.pdf")
# (code-pdf-text  "grfguide" "/usr/share/doc/texlive-latex-base-doc/latex/graphics/grfguide.pdf")
# (find-grfguidepage      1  "Contents")
# (find-grfguidetext "")

# (find-grfguidepage 4)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/

cat > test.tex <<'%%%'
\documentclass[oneside]{book}
\usepackage{color}
\begin{document}
Hello {\color{red}world}.
\end{document}
%%%

latex test.tex
rexdvi test.dvi





#####
#
# vrule
# 2016sep08
#
#####

# «vrule» (to ".vrule")
# (find-texbookpage (+ 12  64) "\\vrule")
# (find-texbooktext (+ 12  64) "\\vrule")
# (find-texbookpage (+ 12 221) "Chapter 21: Making Boxes")
# (find-texbooktext (+ 12 221) "Chapter 21: Making Boxes")
# (find-LATEX "2018-1-GA-material.tex" "comprehension-tables")
# (find-LATEX "2018-1-GA-material.tex" "comprehension-tables" "stop")




#####
#
# \bicolorhbox, a.k.a. \bhbox
# 2008jun09 / 2023nov09
#
#####

# «bicolorhbox»  (to ".bicolorhbox")
# «bhbox» (to ".bhbox")
# (find-LATEX "edrx21defs.tex" "bhbox")
# (find-LATEX "edrx15.sty" "bhbox")
# (find-dn4ex "edrx08.sty" "colors")

 (find-code-show2 "~/LATEX/Show2.tex")
       (code-show2 "~/LATEX/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()
usepackages.edrx21 = true
= ("a \\bhbox{a} \\bhbox{b} \\bhbox{p}"):show {scale=4}
 (etv)

-- Old:
%
% (eedn4a-bounded)
% (find-es "color")
\definecolor{orange}{rgb}{1,.64,0}
\def\red   #1{{\color{red}#1}}
\def\orange#1{{\color{orange}#1}}
\def\yellow#1{{\color{yellow}#1}}
\def\smashedvrule#1#2#3{\vrule width#1 height#2 depth#3 \kern-#1}
\def\bicolorhbox#1{%
  \setbox0\hbox{#1}%
  \yellow{\smashedvrule{\wd0}{\ht0}{0pt}}%
  \orange{\smashedvrule{\wd0}{0pt}{\dp0}}%
  \box0%
  }

Foobar\bicolorhbox{plic}ploc

Foobarplicploc

%
% (eedn4a-bounded)
\edrxcolors
\def\bhbox{\bicolorhbox}

Foobar\bhbox{plic}ploc

Foobarplicploc

%

% (find-dn4ex "edrx08.sty" "colors")
% (find-lsrcfile "graphics/color.dtx")

 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\tracingonline=1\scrollmode
\documentclass{article}
\usepackage{color}
\begin{document}
\def\red#1{{\color{red}#1}}
a\red{b}c
\end{document}

# (find-sh "dvitype -output-level=1 /tmp/texput.dvi")
# (find-man "dvitype")
# (find-node "(web2c)dvitype invocation")




#####
#
# \definecolor
# 2018dec09
#
#####

# «definecolor» (to ".definecolor")
# (find-kopkadaly4page (+ 12 289) "6.2   Adding color")
# (find-kopkadaly4text (+ 12 289) "6.2   Adding color")
# (find-kopkadaly4page (+ 12 289) "6.2   Adding color")
# (find-kopkadaly4text (+ 12 289) "6.2   Adding color")

# (find-tlsh "find * | sort | grep color")
# (find-tlsh "find * | sort | grep graphic")
# (find-tlfile "texmf-dist/doc/latex/graphics")
# (find-tlfile "texmf-dist/source/latex/graphics")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/graphics/")
(code-pdf-page "grfguide" "/usr/local/texlive/2019/texmf-dist/doc/latex/graphics/grfguide.pdf")
(code-pdf-text "grfguide" "/usr/local/texlive/2019/texmf-dist/doc/latex/graphics/grfguide.pdf")
;; (find-grfguidepage)
;; (find-grfguidetext)
# (find-grfguidepage 4 "\\definecolor{hnamei}")
# (find-grfguidetext 4 "\\definecolor{hnamei}")

# (find-tlfile "texmf-dist/source/latex/graphics/")
# (find-tlfile "texmf-dist/source/latex/graphics/color.dtx" "\\def\\definecolor")



#####
#
# Color packages
# 2016aug26
#
#####

# «color-packages» (to ".color-packages")
# (find-tlsh "find * | sort | grep color")
# (find-tlsh "find * | sort | grep color | grep pdf")
# (find-zsh "dmissing texlive | grep color")
# (find-zsh "dmissing texlive | grep color.sty")
# (find-zsh "dmissing texlive | grep color | grep pdf")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/graphics/" "color.sty")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/context/base/mkiv/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/context/base/mkiv/" "colo")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/context/base/mkiv/colo-imp-crayola.mkiv")

# (find-pdf-page "/usr/share/doc/texlive-doc/generic/colortab/colortab-doc.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/colordoc/colordoc.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/colortbl/colortbl-DE.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/colortbl/colortbl.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/colorwav/colorwav.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/colorweb/colorweb.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/colorweb/colorwebfull.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/colorweb/colorwebuser.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/graphics/color.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/lapdf/colors.pdf")
# (find-fline    "/usr/share/doc/texlive-doc/latex/lapdf/colors.tex")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/oberdiek/hycolor.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/oberdiek/luacolor.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/pagecolor/pagecolor-example.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/pagecolor/pagecolor.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/spotcolor/readme.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/tcolorbox/tcolorbox-example.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/tcolorbox/tcolorbox.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/metapost/mpcolornames/mpcolornames.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/pdftex/manual/samplepdf/pdfcolor.tex.gz")
# (find-pdf-page "/usr/share/texlive/texmf-dist/tex/latex/uadocs/ua_color.pdf")
# (find-pdf-page "/usr/share/texlive/texmf-dist/tex/plain/misc/pdfcolor.tex")


#####
#
# colorweb
# 2019oct05
#
#####

# «colorweb» (to ".colorweb")
# (find-tlsh "find * | sort | grep colorweb")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/colorweb/")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/colorweb/")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/colorweb/colorweb.sty")
(code-c-d      "colorweb" "/usr/local/texlive/2019/texmf-dist/doc/latex/colorweb/")
(code-pdf-page "colorweb" "/usr/local/texlive/2019/texmf-dist/doc/latex/colorweb/colorweb.pdf")
(code-pdf-text "colorweb" "/usr/local/texlive/2019/texmf-dist/doc/latex/colorweb/colorweb.pdf")
;; (find-colorwebfile "")
;; (find-colorwebpage)
;; (find-colorwebtext)




#####
#
# xcolor
# 2018dec31
#
#####

# «xcolor»  (to ".xcolor")
# (find-angg ".emacs.papers" "xcolor")
# (find-LATEX "edrx15.sty" "colors-2019")
# https://en.wikibooks.org/wiki/LaTeX/Colors
# https://www.overleaf.com/learn/latex/Using_colours_in_LaTeX
# http://latexcolor.com/
# https://martin-thoma.com/colors-in-latex/
# https://ctan.org/pkg/xcolor?lang=en
# (find-zsh "installeddebs | sort | grep xcolor")
# (find-zsh "availabledebs | sort | grep xcolor")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/xcolor/svgnam.def")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/xcolor/x11nam.def")

# (find-tlsh "find * | sort | grep color | grep pdf")
# (find-tlsh "find * | sort | grep xcolor")
# (find-tlfile "texmf-dist/doc/latex/xcolor/")
# (find-tlfile "texmf-dist/doc/latex/xcolor-material/")
# (find-tlfile "texmf-dist/doc/latex/xcolor-solarized/")
# (find-tlfile "texmf-dist/source/latex/xcolor/xcolor.dtx")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/xcolor/")
(code-pdf-page "xcolor"  "/usr/local/texlive/2019/texmf-dist/doc/latex/xcolor/xcolor.pdf")
(code-pdf-text "xcolor"  "/usr/local/texlive/2019/texmf-dist/doc/latex/xcolor/xcolor.pdf")
(code-pdf-page "xcolor2" "/usr/local/texlive/2019/texmf-dist/doc/latex/xcolor/xcolor2.pdf")
(code-pdf-text "xcolor2" "/usr/local/texlive/2019/texmf-dist/doc/latex/xcolor/xcolor2.pdf")
(code-c-d      "xcolor"  "/usr/local/texlive/2019/texmf-dist/doc/latex/xcolor/")
;; (find-xcolorfile "")
;; (find-xcolorgrep "grep --color=auto -nH --null -e definecolorseries *.tex")
;; (find-xcolorpage)
;; (find-xcolortext)
;; (find-xcolorpage  4 "40% green and 60% yellow" "green!40!yellow")
;; (find-xcolortext  4 "40% green and 60% yellow" "green!40!yellow")
;; (find-xcolorpage  4 "485nm" "\\color[wave]{485}")
;; (find-xcolortext  4 "485nm" "\\color[wave]{485}")
;; (find-xcolorpage  7 "2.1.2     Package options")
;; (find-xcolortext  7 "2.1.2     Package options")
;; (find-xcolorpage 17 "2.4       Predefined colors")
;; (find-xcolortext 17 "2.4       Predefined colors")
;; (find-xcolorpage 22   "\\pagecolor")
;; (find-xcolortext 22   "\\pagecolor")
;; (find-xcolorpage 22   "\\colorbox")
;; (find-xcolortext 22   "\\colorbox")
;; (find-xcolorpage 22   "\\fcolorbox")
;; (find-xcolortext 22   "\\fcolorbox")
;; (find-xcolorpage 33 "Figure 5: Standard color expressions")
;; (find-xcolortext 33 "Figure 5: Standard color expressions")
;; (find-xcolorpage 38 "4.3    Colors via svgnames option")
;; (find-xcolortext 38 "4.3    Colors via svgnames option")
;; (find-xcolorpage 39 "4.4   Colors via x11names option")
;; (find-xcolortext 39 "4.4   Colors via x11names option")
;; (find-xcolor2page)
;; (find-xcolor2text)

# (find-xcolorpage 23 "\\fcolorbox[gray]{0.5}[wave]{580}{test}")
# (find-xcolortext 23 "\\fcolorbox[gray]{0.5}[wave]{580}{test}")
# (find-xcolorpage 55 "6.3.12    The wave model")
# (find-xcolortext 55 "6.3.12    The wave model")




#####
#
# How to define sequences of colors in xcolor
# 2020mar18
#
#####

# «xcolor-spectrum» (to ".xcolor-spectrum")
# (find-xcolorpage 31 "Figure 1: Color spectrum")
# (find-xcolortext 31 "Figure 1: Color spectrum")

\newcount\WL \unitlength.75pt
\begin{picture}(460,60)(355,-10)
\sffamily \tiny \linethickness{1.25\unitlength} \WL=360
\multiput(360,0)(1,0){456}%
 {{\color[wave]{\the\WL}\line(0,1){50}}\global\advance\WL1}
\linethickness{0.25\unitlength}\WL=360
\multiput(360,0)(20,0){23}%
 {\picture(0,0)
  \line(0,-1){5} \multiput(5,0)(5,0){3}{\line(0,-1){2.5}}
  \put(0,-10){\makebox(0,0){\the\WL}}\global\advance\WL20
  \endpicture}
\end{picture}



#####
#
# xcolor: define many saturated colors in the Hsb model
# 2023feb27
#
#####

# «xcolor-Hcolors»  (to ".xcolor-Hcolors")

% (find-xcolorpage 4 "mixture of 40% green and 60% yellow" "green!40!yellow")
% (find-xcolortext 4 "mixture of 40% green and 60% yellow" "green!40!yellow")
% (find-xcolorpage 20 "2.5.3    Defining sets of colors")
% (find-xcolortext 20 "2.5.3    Defining sets of colors")
% (find-xcolorpage 36 "Figure 11: Hsb and tHsb: hue in 15 steps")
% (find-xcolortext 36 "Figure 11: Hsb and tHsb: hue in 15 steps")
%
%L defcolor   = function (H) return format("H%d,%d,1,1", H, H) end
%L defcolors  = mapconcat(defcolor, seq(0,360), ";")
%L testcolor  = function (H) return format("{\\color{H%d}%d}", H, H) end
%L testcolors = mapconcat(testcolor, seq(0,360), " ")
\pu
\definecolorset{Hsb}{}{}{\expr{defcolors}}
\expr{testcolors}

{\color{H56!20!black}20
 \color{H56!40!black}40
 \color{H56!60!black}60
 \color{H56!80!black}80
}

{\color{black!20!H56}20
 \color{black!40!H56}40
 \color{black!60!H56}60
 \color{black!80!H56}80
}




#####
#
# \testcolor
# 2019oct05
#
#####

# «testcolor» (to ".testcolor")
# (find-LATEX "edrx15.sty" "colors-2019")

\def\testcolor#1{\par {\color{#1}#1}}
\Huge
\bf
\testcolor{brown}
\testcolor{Brown}
\testcolor{GrayLight}
\testcolor{black!30!white}
\testcolor{SpringDarkHard}
\testcolor{SpringGreen4}
\testcolor{SpringGreenDark}
\testcolor{Red1}
\testcolor{Red}
\testcolor{MagentaVioletLight}
\testcolor{Violet!50!black}

\testcolor{brown}
\testcolor{Brown}
\testcolor{GrayLight}           (needs colorweb)
\testcolor{black!30!white}
\testcolor{SpringDarkHard}      (needs colorweb)
\testcolor{SpringGreen4}
\testcolor{SpringGreenDark}     (needs colorweb)
\testcolor{Red1}
\testcolor{Red}
\testcolor{MagentaVioletLight}  (needs colorweb)
\testcolor{Violet!50!black}






#####
#
# \protect
# 2008may24 / 2018mai08
#
#####

# «protect»  (to ".protect")
# (find-angg ".emacs" "source2e")
# (find-lsrcgrep "grep -nH -e \\protect base/*.dtx")
# (find-lsrcgrep "grep -nH -e \\\\protect base/*.dtx")
# (find-lsrcfile "base/makeindx.dtx" "\\def\\protect")
# (find-kopkadaly4page (+ 12 445) "\\protect")
# (find-kopkadaly4text (+ 12 445) "\\protect")
# (find-kopkadaly4page (+ 12 446) "\\protect")
# (find-kopkadaly4text (+ 12 446) "\\protect")
# (find-kopkadaly4page (+ 12 571) "\\protect")
# (find-kopkadaly4text (+ 12 571) "\\protect")

# (find-source2epage (+ 8  29) "Fragile and robust commands")
# (find-source2etext (+ 8  29) "Fragile and robust commands")
# (find-source2epage (+ 8  31) "  \\protect ")
# (find-source2etext (+ 8  31) "  \\protect ")
# (find-source2epage (+ 8 465) "\\protect")
# (find-source2etext (+ 8 465) "\\protect")
# (find-source2efile "ltdefns.dtx")

# http://tex.stackexchange.com/questions/4736/what-is-the-difference-between-fragile-and-robust-commands
# http://www.tex.ac.uk/FAQ-protect.html
# http://pbelmans.ncag.info/blog/2011/02/20/why-latex-beamer-needs-fragile-when-using-verbatim/
# (find-sh "locate makerobust")

# (find-fline "/usr/share/doc/texlive-doc/latex/oberdiek/makerobust-example.tex")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/oberdiek/makerobust.pdf")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/oberdiek/makerobust.sty")
# (find-texbookpage (+ 12 213) "\\noexpand")
# (find-texbooktext (+ 12 213) "\\noexpand")
# (find-texbookpage (+ 12 216) "\\noexpand\c")
# (find-texbooktext (+ 12 216) "\\noexpand\c")


# (find-LATEX "2018-1-GA-material.tex" "mypsection")

# Old:

 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\interact
I\show\protect

# (find-source2epage (+ 9 473))
# (find-source2efile "ltdefns.dtx" "Fragile and robust commands")





#####
#
# Times New Roman
# 2015oct23
#
#####

# «times» (to ".times")
# (find-zsh "dmissing times | grep texlive")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/psnfss/")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/psnfss/times.sty")
# http://tex.stackexchange.com/questions/67768/times-new-roman-font




#####
#
# psnfss-2021
# 2021nov27
#
#####

# «psnfss-2021»  (to ".psnfss-2021")
# (find-LATEXfile "rrj.tex"     "\\sectitlefont=pagk7t")
# (find-LATEXfile "2021rrj.tex" "\\sectitlefont")
# (find-sh "locate psnfss")
# (find-tlsh "find * | sort | grep avant")

# (code-c-d "psnfss" "/usr/local/texlive/2019/texmf-dist/doc/latex/psnfss/")
# (code-pdf-page "psnfss" "/usr/local/texlive/2019/texmf-dist/doc/latex/psnfss/psnfss2e.pdf")
# (code-pdf-text "psnfss" "/usr/local/texlive/2019/texmf-dist/doc/latex/psnfss/psnfss2e.pdf")
# (find-psnfssfile "")
# (find-psnfsspage)
# (find-psnfsstext)
# (find-psnfsspage 11 "Don't use Avant Garde for typesetting larger")
# (find-psnfsstext 11 "Don't use Avant Garde for typesetting larger")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/psnfss/avant.sty")

\font\sectitlefont=pagk7t scaled 5000
\font\secsubtitlefont=pagk7t scaled 4000
\def\rrjfile#1{
  \sectitlefont #1
}
\rrjfile{RRJ}




#####
#
# psnfss (for Avant Garde and Utopia)
# 2008may26
#
#####

# «psnfss-avant-garde»  (to ".psnfss-avant-garde")
# (find-sh "locate times.sty")
# (find-fline "/usr/share/texmf-tetex/tex/cslatex/ntimes.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/dvilj/cgtimes.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/psnfss/times.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/qfonts/qtimes.sty")

# (find-sh "locate psfonts.dtx")
# (find-fline "/usr/share/texmf-tetex/source/latex/psnfss/psfonts.dtx")
# (find-sh "locate /psfonts")
# (find-fline "/usr/share/texmf-tetex/source/latex/psnfss/")

# (find-sh "locate /psnfss")
# (code-c-d "psnfssdoc" "/usr/share/doc/texlive-latex-base-doc/latex/psnfss/")

;; (find-psnfssdocfile "")
;; (find-psnfssdocfile "psnfss/")
;; (find-psnfssdocfile "test/test0.tex.gz")
;; (find-psnfssdocfile "test/test1.tex")
;; (find-psnfssdocfile "test/test2.tex")
(code-pdf-page  "psnfss" (ee-psnfssdocfile "psnfss2e.pdf"))
(code-pdf-text  "psnfss" (ee-psnfssdocfile "psnfss2e.pdf"))
;; (find-psnfsspage 1)
;; (find-psnfsspage 10 "Typeface examples")
;; (find-psnfsstext)
;; (find-psnfsstext "9.4 The package utopia\n")

# (find-sh "locate utopia")
# (find-fline "/usr/share/texmf-tetex/source/latex/psnfss/utopia.map")
# (find-fline "/usr/share/texmf-tetex/source/latex/psnfss/utopia.sty")
# (find-fline "/usr/share/texmf-tetex/tex/latex/psnfss/utopia.sty")
# (find-sh "locate /avant")

%
% (eedn4a-bounded)

\large

{\rm Rmoo}

% Broken:
% (find-lsrcfile "psnfss/utopia.sty")
% \renewcommand{\rmdefault}{put}
% {\rm Rmutopia}

{\bf Bfoo}

{\sl Sloo}

{\sf Sfoo}

% (find-fline "/usr/share/texmf-tetex/tex/latex/psnfss/avant.sty")
\renewcommand{\sfdefault}{pag}

{\sf Sfoo}

{\sf RRJ 4}

{\sf Rimbaud 0}

%
% (find-zsh "cd ~/LATEX/; dvifonts tmp.dvi")
# (find-fline "locate pagk")




#####
#
# ovals
# 2008may26
#
#####

# «ovals»  (to ".ovals")
# (find-kopkadaly4page (+ 12 288) "13.1   The picture environment")
# (find-kopkadaly4text            "13.1   The picture environment")
# (find-kopkadaly4page (+ 12 296) "\\oval(x dimen,y dimen)[part]")
# (find-kopkadaly4text            "\\oval(x dimen,y dimen)[part]")
# (find-kopkadaly4page (+ 12 301) "13.1.6 Shifting a picture environment")
# (find-kopkadaly4text            "13.1.6 Shifting a picture environment")
%
% (eedn4a-bounded)

\begingroup

\def\n #1 #2 #3 {\put(#1,#2){\makebox(0,0){$\bullet$}}}
\def\n #1 #2 #3 {\put(#1,#2){\makebox(0,0){#3}}}
\def\o #1 #2 #3 #4 {\put(#1,#2){\oval(#3,#4)}}
\def\d #1 #2 #3 {\put(#1,#2){\vector(0,-1){#3}}}

\setlength{\unitlength}{0.9pt}

\begin{picture}(100,100)
  \n 10 10 1
  \n 20 10 2
  \n 20 20 3
  \o 30 30 15 10
\end{picture}

\begin{picture}(100,100)
  \n 20 80 10
  \n 22 65 11
  \n 21 50 12
  \o 21 65 32 55
  %
  \n 60 62 20
  \o 60 62 20 20
  %
  \n 95 70 31
  \n 95 54 32
  \o 95 62 28 42
  %
  \n 21 12 1
  \n 60 12 2
  \n 95 12 3
  \o 58 12 105 28
  %
  \d 21 36 8
  \d 60 50 22
  \d 95 39 11
\end{picture}

\endgroup

%




#####
#
# xfig
# 2008may26
#
#####

# «xfig»  (to ".xfig")
# (find-status   "xfig-doc")
# (find-vldifile "xfig-doc.list")
# (find-udfile   "xfig-doc/")
# (find-status   "xfig-libs")
# (find-vldifile "xfig-libs.list")
# (find-udfile   "xfig-libs/")
# (find-status   "xfig")
# (find-vldifile "xfig.list")
# (find-udfile   "xfig/")
# (find-status   "transfig")
# (find-vldifile "transfig.list")
# (find-udfile   "transfig/")
# (find-man "1 fig2dev")
# (find-man "1 fig2dev" "EPIC is an enhancement to LaTeX picture")
# (find-man "1 transfig")

# (find-man "1 xfig")
# (find-xfigdocw3m "contents.html")




#####
#
# Xfig file format (for ".fig"s)
# 2008aug08
#
#####

# «xfig-file-format»  (to ".xfig-file-format")
# (find-xfigdocw3m "contents.html")
# (find-xfigdocw3m "fig-format.html")
# (find-xfigdocw3m "fig-format.html" "The character #")
# (find-xfigdocw3m "fig-format.html" "(3.7) TEXT")
# (find-xfigrefpage 29 "comments")
# (find-xfigreftext    "comments")
# (find-xfigrefpage 43 "edit Fig comments")
# (find-xfigreftext    "edit Fig comments")
# (find-xfigrefw3m "editing.html#edit")
# (find-fline "/tmp/foo.fig")
# (find-bgprocess "xfig /tmp/foo.fig")

#
cat > /tmp/foo.fig <<'%%%'
#FIG 3.2  Produced by xfig version 3.2.5-alpha5
Landscape
Center
Metric
A4      
100.00
Single
-2
1200 2

# (find-xfigdocw3m "fig-format.html" "(3.5) POLYLINE")
2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
	 1080 1710 2160 2115

# (find-xfigdocw3m "fig-format.html" "(3.7) TEXT")
4 0 0 50 -1 0 12 0.0000 4 150 960 900 1260 a b "c" \\foo\001
4 0 0 50 -1 0 12 0.0000 4 150 285 900 1515 bar\001
%%%

#




#####
#
# eepic
# 2008aug08
#
#####

# «eepic»  (to ".eepic")
# (find-es "tex" "picture_mode")
# (find-zsh "dmissing eepic")
# (find-dvipage "/usr/share/doc/tetex-doc/latex/eepic/eepic.dvi.gz")
# (find-fline "/usr/share/doc/tetex-doc/latex/eepic/epic-eg3.fig")
# (find-fline "/usr/share/doc/tetex-doc/latex/eepic/epic-eg3.tex")
# (find-fline "/usr/share/doc/tetex-doc/latex/eepic/epic-eg4.fig")
# (find-fline "/usr/share/doc/tetex-doc/latex/eepic/epic-eg4.tex")
# (find-fline "/usr/share/doc/tetex-doc/latex/eepic/readme.gz")




#####
#
# tac.cls
# 2008may26
#
#####

# «tac.cls»  (to ".tac.cls")
# http://tac.mta.ca/tac/style/
# http://tac.mta.ca/tac/style/sample.dvi
# http://tac.mta.ca/tac/style/sample.tex
# http://tac.mta.ca/tac/style/styhint.txt
# http://tac.mta.ca/tac/style/tac.cls
#
rm -Rv ~/usrc/tac-cls/
mkdir  ~/usrc/tac-cls/
cd     ~/usrc/tac-cls/

cp -v $S/http/tac.mta.ca/tac/style/sample.tex .
cp -v $S/http/tac.mta.ca/tac/style/tac.cls .
cp -v ~/LATEX/diagxy.tex .

latex sample.tex

#
# (find-dvipage "~/usrc/tac-cls/sample.dvi")
# (find-sh0 "rm -v ~/LATEX/tac.cls")
# (find-sh0 "cp -v $S/http/tac.mta.ca/tac/style/tac.cls ~/LATEX/")




#####
#
# demobox
# 2008jun09
#
#####

# «demobox»  (to ".demobox")
%
% (eedn4a-bounded)
% (find-texbookpage (+ 11 65))
% (find-texbookfile "texbook.tex")
% (find-texbookfile "texbook.tex" "\\demobox{A line of type.}")
% (find-texbookfile "texbook.tex" "exercise Construct a |\\demobox| macro")
% (find-texbookfile "texbook.tex" "\\demobox{Two lines}")

\def\dolist{\afterassignment\dodolist\let\next= }
\def\dodolist{\ifx\next\endlist \let\next\relax
  \else \\\let\next\dolist \fi
  \next}
\def\endlist{\endlist}
\def\hidehrule#1#2{\kern-#1%
  \hrule height#1 depth#2 \kern-#2 }
\def\hidevrule#1#2{\kern-#1{\dimen0=#1
    \advance\dimen0 by#2\vrule width\dimen0}\kern-#2 }
\def\makeblankbox#1#2{\hbox{\lower\dp0\vbox{\hidehrule{#1}{#2}%
    \kern-#1 % overlap the rules at the corners
    \hbox to \wd0{\hidevrule{#1}{#2}%
      \raise\ht0\vbox to #1{}% set the vrule height
      \lower\dp0\vtop to #1{}% set the vrule depth
      \hfil\hidevrule{#2}{#1}}%
    \kern-#1\hidehrule{#2}{#1}}}}
\def\maketypebox{\makeblankbox{0pt}{1pt}}
\def\makelightbox{\makeblankbox{.2pt}{.2pt}}
\def\\{\if\space\next\ % assume that \next is unexpandable
 \else \setbox0=\hbox{\next}\maketypebox\fi}
\def\demobox#1{\setbox0=\hbox{\dolist#1\endlist}%
  \leavevmode\copy0\kern-\wd0\makelightbox}

\setbox0=\vbox{\hbox{\demobox{Two lines}}\hbox{\demobox{of type.}}}
$\vcenter{\hbox{\makelightbox\kern-\wd0\box0}}$\qquad
  i.e.,\qquad$\vcenter{\vbox{\hbox{Two lines}\hbox{of type.}}}$

\hbox{\setbox0=\vbox{\hbox{\demobox{Two lines}}\hbox{\demobox{of type.}}}
      \makelightbox\kern-\wd0\box0}

%




#####
#
# \matrix
# 2008jun18 / 2016jul19
#
#####

# «matrix»  (to ".matrix")
# (find-texbookpage (+ 11 177))
# (find-texbookfile "texbook.tex" "\\bordermatrix")
# (find-plainsrcfile "plain.tex" "\\def\\bordermatrix")
# (find-plainsrcfile "plain.tex" "\\def\\matrix")
# (find-plainsrcfile "plain.tex" "\\def\\ialign")
# (find-source2epage (+ 8 431) "Index")
# (find-source2epage (+ 8 462) "Index" "\\matrix")
# (find-source2epage (+ 8 211) "\\matrix")
# (find-source2etext (+ 8 211) "\\matrix")




#####
#
# math atoms and math lists
# 2008jun20
#
#####

# «math-atoms»  (to ".math-atoms")

# (find-texbooktext)
# (find-texbookfile "")
# (find-texbookfile "texbook.tex")

# (find-texbookpage (+ 11 158) "thirteen kinds of atoms")
# (find-texbookpage (+ 11 170) "spacing between pairs of adjacent atoms")
# (find-texbooktext "thirteen kinds of atoms")
# (find-texbooktext "spacing" "between pairs of adjacent atoms")
# (find-texbookfile "texbook.tex" "thirteen kinds of atoms")
# (find-texbookfile "texbook.tex" "spacing between pairs of adjacent atoms")





#####
#
# lshort
# 2008jun24 / 2019jan04
#
#####

# «lshort»  (to ".lshort")
# (find-angg ".emacs.papers" "lshort")
# (find-clg ".emacs.clg" "lshort")
# (find-tlsh "find * | sort | grep lshort")
# (find-lshortfile "")
# (find-lshortfile "README")

# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/lshort-english/")
(code-pdf-page "lshort" "/usr/local/texlive/2019/texmf-dist/doc/latex/lshort-english/lshort.pdf")
(code-pdf-text "lshort" "/usr/local/texlive/2019/texmf-dist/doc/latex/lshort-english/lshort.pdf" 14)
# (find-lshortpage)
# (find-lshorttext)
# (find-lshortpage (+ 14 2) "1.2.1 Author, Book Designer, and Typesetter")
# (find-lshorttext (+ 14 2) "1.2.1 Author, Book Designer, and Typesetter")
# (find-lshortpage (+ 14 11) "1.6.3 Page Styles")
# (find-lshorttext (+ 14 11) "1.6.3 Page Styles")

# http://www.ctan.org/get/info/lshort/english/lshort-4.24.src.tar.gz
#
rm -Rv ~/usrc/lshort-4.24/
tar -C ~/usrc/ -xvzf \
  $S/http/www.ctan.org/get/info/lshort/english/lshort-4.24.src.tar.gz
cd     ~/usrc/lshort-4.24/

make |& tee om

#
rm -Rv ~/usrc/lshort/
mkdir  ~/usrc/lshort/
cd /usr/share/texmf-tetex/source/latex/lshort-4.14/ &&
  cp -Rv * ~/usrc/lshort/
mkdir ~/usrc/lshort/src/
cd    ~/usrc/lshort/src/
cp -v $S/http/www.ctan.org/tex-archive/fonts/euro/latex/eurosans/eurosans.sty .
cd ~/usrc/lshort/
cp -v $S/http/www.ctan.org/tex-archive/fonts/euro/latex/eurosans/eurosans.sty .
make |& tee om

#
# (code-c-d "lshort" "~/usrc/lshort/")
# (find-lshortfile "")
# (find-lshortfile "om")
# /usr/share/doc/tetex-doc/help/Catalogue/entries/eurosans.html
# http://www.ctan.org/tex-archive/fonts/euro/latex/eurosans/
# http://www.ctan.org/tex-archive/fonts/euro/latex/eurosans/eurosans.sty
# http://www.ctan.org/tex-archive/fonts/euro/latex/eurosans/README.eurosans
# (code-c-d "lshort" "~/usrc/lshort-4.24/")
# (find-lshortfile "")




#####
#
# left quote and double hat
# 2008jun27
#
#####

# «left-quote-double-hat»  (to ".left-quote-double-hat")
# (find-texbookfile "texbook.tex" "^{left quote}")
# (find-texbookpage (+ 11 44)       "left quote")
# (find-texbooktext                "(left quote),")
# (find-texbookfile "texbook.tex" "double hat")
# (find-texbookpage (+ 11 45)     "double hat")
# (find-texbooktext               "double hat")
# Confusing... some things here don't work. 8-|
# What are the contexts in which "`^^J" becomes "10"?

# (find-texbookfile "texbook.tex" "control sequences that are expanded")
# (find-texbookpage (+ 11 212)    "control sequences that are expanded")
# (find-texbooktext               "control sequences that are expanded")
# (find-texbookfile "texbook.tex" "The powerful |\\the| operation")
# (find-texbookpage (+ 11 214)    "The powerful |\\the| operation")
# (find-texbooktext               "The powerful \\the operation")
# (find-texbookfile "texbook.tex" "^\\<integer parameter> is one of")
# (find-texbookpage (+ 11 272)    "integer parameter is one of")
# (find-texbooktext               "integer parameter is one of")

 (eepitch-tex)
 (eepitch-kill)
 (eepitch-tex)
\tracingonline=1\scrollmode
\message{`^^J}
\message{`a}
\newlinechar=32
\message{\the\newlinechar}
\newlinechar=`^^J
\message{\the\newlinechar}
\message{\newlinechar}




#####
#
# \message and \newlinechar
# 2008jun27
#
#####

# «message»  (to ".message")
# «newlinechar»  (to ".newlinechar")
# (find-texbookpage (+ 12 471) "\\message")
# (find-texbooktext (+ 12 471) "\\message")
# (find-texbookfile "texbook.tex" "to the ^{terminal}")
# (find-texbookfile "texbook.tex" "The \\<token list> of a |\\write|")
# TeX breaks messages at 79 chars; it resets the counter when
# a \newlinechar is found. \newlinechar is -1 by default.
# Trick:
#   \myspace := (char 32)_(catcode 12)
#   \mynl    := (char 10)_(catcode 12)
#   \newlinechar := 10
# and \msg{...} is like \message{...}, but
# inside msg's argument we define \s:=\myspace and \n:=\mynl.

 (eepitch-tex)
 (eepitch-kill)
 (eepitch-tex)
\tracingonline=1\scrollmode
%
{\catcode` =12\gdef\myspace{ }}
{\catcode`^^J=12\gdef\mynl{^^J}}
\def\msg#1{{\def\s{\myspace}\def\n{\mynl}\message{#1}}}
\newlinechar=`^^J
%
\def\digs{1234567890}
\def\twenty{\digs\digs}
\def\sixty{\digs\digs\digs\digs\digs\digs}
%
\message{\twenty\sixty}
\message{\twenty\mynl\sixty\twenty}
\msg{\twenty\n\sixty\twenty}
\msg{\twenty\s \s \s\sixty}
\msg{\digs\digs\n\sixty\s \s \s \sixty}
%
\newlinechar=-1
\message{\twenty\mynl\sixty\twenty}
\newlinechar=`^^J
\message{\twenty\mynl\sixty\twenty}





#####
#
# debugging diagxy
# 2008jun27
#
#####

# «debugging-diagxy»  (to ".debugging-diagxy")
# Objective: make "\morphism" print the diagxy command
# instead of running it.
# (find-LATEXfile "diagxy.tex")
# (find-LATEXsh "grep POS diagxy.tex")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cat ~/LATEX/diagxy.tex |
  lua51 -e 'io.write((io.read("*a"):gsub("\\POS","\\NEWPOS")))' > \
  /tmp/newdiagxy.tex

# (find-tkdiff "~/LATEX/diagxy.tex" "/tmp/newdiagxy.tex")

 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\tracingonline=1\scrollmode
\input /home/edrx/LATEX/diagxy.tex
\documentclass{article}
\begin{document}
$\bfig
  \morphism(225,0)/->/<-225,-300>[{a}`{b};{}]
  \morphism(225,0)/->/<225,-300>[{a}`{c};{}]
  \morphism(0,-300)/->/<0,-300>[{b}`{d};{}]
 \efig
$
\end{document}

% (find-dvipage "/tmp/texput.dvi")


 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\tracingonline=1\scrollmode
%\input /home/edrx/LATEX/diagxy.tex
\input /tmp/newdiagxy.tex
\def\NEWPOS{\POS}
\documentclass{article}
\begin{document}
$\bfig
  \morphism(225,0)/->/<-225,-300>[{a}`{b};{}]
  \morphism(225,0)/->/<225,-300>[{a}`{c};{}]
  \morphism(0,-300)/->/<0,-300>[{b}`{d};{}]
 \efig
$
\end{document}

% (find-xdvi "/tmp/texput.dvi")


% (find-LATEXfile "diagxy.tex")
%  \POS(#1,#2)*+!!<0ex,\axis>{#7}\ar#4^-{#9} (\xend,\yend)*+!!<0ex,\axis>{#8}%
   \POS(.1,.2)*+!!<0ex,.axis>{.7}.ar.4^-{.9} (.xend,.yend)*+!!<0ex,.axis>{.8}%
\def\MSGPOS#1<#2>#3<#4>#5{%
  \message{#1<#2>#3<#4>#5}%
  }



 (eepitch-latex)
 (eepitch-kill)
 (eepitch-latex)
\tracingonline=1\scrollmode
\input /home/edrx/LATEX/diagxy.tex
\documentclass{article}
\begin{document}
$\bfig
  \let\ORIGPOS=\POS
  % \def\POS{\message{POS}\ORIGPOS}
  \def\POS#1{\message{POS#1}\ORIGPOS#1}
  \morphism(0,-300)/->/<0,-300>[{b}`{d};{}]
 \efig
$

% (find-sh "locate xypic")

% (code-c-d "xy" "/usr/share/texmf-tetex/tex/generic/xypic")
% (find-xyfile "")





  \def\POS{\MSGPOS}
  \message{\POS}
  \message{\POS^/_$/}
  \setbox0=\hbox{aa}\message{\the\wd0}
  \message{\setbox0=\hbox{a}\the\wd0}
  % \message{\morphism(225,0)/->/<-225,-300>[{a}`{b};{}]}
  % \morphism(225,0)/->/<225,-300>[{a}`{c};{}]

\def\MSGPOS#1<#2>#3<#4>#5{%
  \message{POS#1<#2>#3<#4>#5}%
  }
{ \def\POS{\MSGPOS}
  \POS(.1,.2)*+!!<0ex,.axis>{.7}.ar.4^-{.9} (.xend,.yend)*+!!<0ex,.axis>{.8}%
}




#####
#
# cmtt and cmttb
# 2008jun28
#
#####

# «cmtt-and-cmttb»  (to ".cmtt-and-cmttb")
# (find-sh "locate cmtt")
# (find-fline "/usr/share/texmf-tetex/fonts/source/public/cm-bold/cmttb10.mf")
# (find-fline "/usr/share/texmf-tetex/fonts/source/public/cm/cmtt10.mf")

(find-tkdiff "/usr/share/texmf-tetex/fonts/source/public/cm-bold/cmttb10.mf"
             "/usr/share/texmf-tetex/fonts/source/public/cm/cmtt10.mf")




#####
#
# math lists
# 2008jul08
#
#####

# «math-lists»  (to ".math-lists")
# (find-texbookpage 1)
# (find-texbooktext)
# (find-texbookpage (+ 11 88) "### display math mode entered")
# (find-texbooktext           "### display math mode entered")
# (find-texbookpage (+ 11 158) "Vcent   is")
# (find-texbooktext            "Vcent   is")

 (eepitch-tex)
 (eepitch-kill)
 (eepitch-tex)
\tracingonline=1\scrollmode
$a + b
 \showlists




#####
#
# beamer
# 2008aug15 / 2013apr01 / 2019feb15
#
#####

# «beamer»  (to ".beamer")
# (find-angg ".emacs.papers" "beamer")
# (find-tlsh "find * | sort | grep beamer")
# (find-tlsh "find * | sort | grep beamer | grep pdf")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/beamer/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/beamer/" "beamerexample-lecture")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /usr/local/texlive/2019/texmf-dist/doc/latex/beamer/
cp -v beamerexample-lecture* ~/2019-CLG/

# (find-fline "~/2019-CLG/")


# (find-es "beamer")
# (find-angg ".zshrc" "regv-beamer")
# (find-status   "latex-beamer")
# (find-vldifile "latex-beamer.list")
# (find-udfile   "latex-beamer/")

# (find-vldish "grep pdf latex-beamer.list")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/latex-beamer/")
rm -Rv /tmp/latex-beamer/
cp -Rv /usr/share/doc/latex-beamer /tmp/
cd     /tmp/latex-beamer/
gunzip -rv *

cd /tmp/latex-beamer/solutions/conference-talks/
# pdflatex conference-ornate-20min.en.tex
  lualatex conference-ornate-20min.en.tex

# (find-fline "/tmp/latex-beamer/solutions/conference-talks/")
# (find-fline "/tmp/latex-beamer/solutions/conference-talks/conference-ornate-20min.en.tex")



 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv /tmp/beamerdocs/
mkdir  /tmp/beamerdocs/
cd     /tmp/beamerdocs/
cp -v $(grep pdf /var/lib/dpkg/info/latex-beamer.list) .
gunzip -v *.gz

# (find-fline "/tmp/beamerdocs/")
cd     

# (code-c-d "beamerthemes" "/usr/share/texmf/tex/latex/beamer/themes/")
# (code-c-d "beamerthemes" "/usr/share/texmf/tex/latex/beamer/base/themes")
# (find-beamerthemesfile "")
# (find-beamerthemesfile "theme/")
# (find-beamerthemesfile "theme/beamerthemeHannover.sty")
# \usetheme{Hannover}   % Renata

(code-ps        "beameruserguide" "/tmp/beamerdocs/beameruserguide.pdf")
(code-pdf-text  "beameruserguide" "/tmp/beamerdocs/beameruserguide.pdf")
;; (find-beameruserguidepage 1)
;; (find-beameruserguidetext)
;; (find-beameruserguidetext "\\usetheme{Warsaw}")


\begin{frame}
  \frametitle{There Is No Largest Prime Number}
  \framesubtitle{The proof uses \textit{reductio ad absurdum}.}
  \begin{theorem}
    There is no largest prime number.
  \end{theorem}
  \begin{proof}
    \begin{enumerate}
    \item<1-| alert@1> Suppose $p$ were the largest prime number.
    \item<2-> Let $q$ be the product of the first $p$ numbers.
    \item<3-> Then $q+1$ is not divisible by any of them.
    \item<1-> Thus $q+1$ is also prime and greater than $p$.\qedhere
    \end{enumerate}
  \end{proof}
\end{frame}





#####
#
# texlive-base (from the debian sources)
# 2008aug17
#
#####

# «texlive-base-deb-src»  (to ".texlive-base-deb-src")
# http://ftp.debian.org/debian/pool/main/t/texlive-base/
# http://ftp.debian.org/debian/pool/main/t/texlive-base/texlive-base_2007.dfsg.1-3.dsc
# http://ftp.debian.org/debian/pool/main/t/texlive-base/texlive-base_2007.dfsg.1-3.diff.gz
# http://ftp.debian.org/debian/pool/main/t/texlive-base/texlive-base_2007.dfsg.1.orig.tar.gz
#
rm -Rv ~/bigsrc/texlive-base/
mkdir  ~/bigsrc/texlive-base/
cd $S/http/ftp.debian.org/debian/pool/main/t/texlive-base/
cp -v texlive-base_2007.dfsg.1* ~/bigsrc/texlive-base/
cd     ~/bigsrc/texlive-base/
dpkg-source -sn -x texlive-base_2007.dfsg.1-3.dsc
cd     ~/bigsrc/texlive-base/texlive-base-2007.dfsg.1/
find * -type f | sort > .files
# dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
# (find-fline "~/bigsrc/texlive-base/")
 (eepitch-shell)
cd ~/bigsrc/texlive-base/
sudo dpkg -i *.deb

#
# (code-c-d "texlivebase" "~/bigsrc/texlive-base/texlive-base-2007.dfsg.1/")
# (find-texlivebasefile "")
# (find-texlivebasefile ".files")
# (find-texlivebasesh "grep bluesky .files")
# (find-texlivebasesh "grep bluesky .files | grep cmr10")
# (find-texlivebasefile "texmf-dist/fonts/afm/bluesky/cm/cmr10.afm")
# (find-texlivebasefile "texmf-dist/fonts/type1/bluesky/cm/cmr10.pfb")




#####
#
# texlive-bin (from the debian sources)
# 2008aug16
#
#####

# «texlive-bin-deb-src»  (to ".texlive-bin-deb-src")
# http://ftp.debian.org/debian/pool/main/t/texlive-bin/
# http://ftp.debian.org/debian/pool/main/t/texlive-bin/texlive-bin_2007.dfsg.2-3.dsc
# http://ftp.debian.org/debian/pool/main/t/texlive-bin/texlive-bin_2007.dfsg.2-3.diff.gz
# http://ftp.debian.org/debian/pool/main/t/texlive-bin/texlive-bin_2007.dfsg.2.orig.tar.gz
#
rm -Rv ~/bigsrc/texlive-bin/
mkdir  ~/bigsrc/texlive-bin/
cd $S/http/ftp.debian.org/debian/pool/main/t/texlive-bin/
cp -v texlive-bin_2007.dfsg.2* ~/bigsrc/texlive-bin/
cd     ~/bigsrc/texlive-bin/
dpkg-source -sn -x texlive-bin_2007.dfsg.2-3.dsc
cd     ~/bigsrc/texlive-bin/texlive-bin-2007.dfsg.2/
# dpkg-buildpackage -us -uc -b -rfakeroot     |& tee odb

#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd     ~/bigsrc/texlive-bin/texlive-bin-2007.dfsg.2/
find * -type f | sort > .files

#
# (find-fline "~/bigsrc/texlive-bin/")
 (eepitch-shell)
cd ~/bigsrc/texlive-bin/
sudo dpkg -i *.deb

#
# (code-c-d "texlivebin" "~/bigsrc/texlive-bin/texlive-bin-2007.dfsg.2/")
# (find-texlivebinfile "")
# (find-texlivebinfile ".files")
# (find-texlivebinsh "grep dvired .files")
# (find-texlivebinfile "build/source/texk/tetex/dvired")
# (find-texlivebinfile "build/source/texk/tetex/dvired.man")
# (find-texlivebinfile "texmf/doc/man/man1/dvired.1")
# (find-texlivebinfile "texmf/dvips/config/config.dvired")
# (find-texlivebinfile "texmf/dvips/config/dvired.cfg")

# (find-texlivebinfile "build/source/texk/web2c/tex.web")
# (find-texlivebinfile "build/source/texk/dvipsk/")




#####
#
# dvired fonts
# 2008aug17
#
#####

# «dvired-fonts»  (to ".dvired-fonts")
# At first I thought that I would have to pass an argument "-D 300" to
# dvired to make it generate fonts that looked good on my HP
# DeskJet... But then I discovered that dvips uses the T1 (or T3?)
# versions of the Computer Modern fonts created by BlueSky...

# Karl Berry's hints, 2008sep23:
# (find-sh "locate updmap.cfg")
# (find-sh "locate config.pk")
# (find-man "5 updmap.cfg")
# (find-fline "/etc/texmf/updmap.d/00updmap.cfg")
# (find-fline "/usr/share/tex-common/00updmap.cfg")
# (find-fline "/usr/share/tex-common/00updmap.cfg.md5sum")
# (find-fline "/var/lib/texmf/web2c/updmap.cfg")
# (find-tkdiff "/var/lib/texmf/web2c/updmap.cfg" "/etc/texmf/updmap.d/00updmap.cfg")
# (find-fline "/usr/share/texmf-texlive/dvips/tetex/config.pk" "prefer bitmap")

# (find-sh "locate dvired")

# (find-fline "/etc/texmf/texlive/dvips/config.dvired")
# (find-fline "/etc/texmf/texlive/dvips/dvired.cfg")
# (find-fline "/usr/bin/dvired")
# (find-man "1 dvired")
# (find-fline "/usr/share/texmf-texlive/dvips/config/config.dvired")
# (find-fline "/usr/share/texmf-texlive/dvips/config/dvired.cfg")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
function mkechobody () { echo '#!/bin/sh'; echo 'echo $0 $*'; }
function mkecho () { mkechobody > $1; chmod -v 755 $1; }
cd /tmp/
mkecho lpr
mkecho dvips
mkecho pstops
cd ~/LATEX/
# Why doesn't this trick work???
PATH=/tmp:$PATH dvired -o /tmp/tmp.ps 2008graphs.dvi
PATH=/tmp:$PATH /usr/bin/dvired -o /tmp/tmp.ps 2008graphs.dvi
PATH=/tmp:$PATH dvips foo bar
PATH=/tmp:$PATH sh -x /usr/bin/dvired -o /tmp/tmp.ps 2008graphs.dvi
rm -v /tmp/lpr /tmp/dvips /tmp/pstops

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd /tmp/
echo -E "Hello t \\bye" > hello.tex
cat hello.tex
tex hello.tex
sh -x  /usr/bin/dvired -o hello.2.ps    hello.dvi
sh -x           dvired -o hello.2.ps    hello.dvi |& tee o
PRINTER=deskjet dvired -o hello.2.dj.ps hello.dvi
PRINTER=deskjet dvired -o hello.2.dj.ps hello.dvi
PRINTER=deskjet sh -x dvired -o hello.2.dj.ps hello.dvi

dvips            -o hello.ps      hello.dvi
dvips -P pk      -o hello.pk.ps   hello.dvi
dvips -P deskjet -o hello.dj.ps   hello.dvi
dvips -D 300     -o hello.300.ps  hello.dvi
dvips -D 150     -o hello.150.ps  hello.dvi
# (find-dvipage "/tmp/hello.dvi")
# (find-pspage  "/tmp/hello.pk.ps")
# (find-pspage  "/tmp/hello.300.ps")
# (find-pspage  "/tmp/hello.150.ps")

# (find-fline   "/tmp/hello.pk.ps")

dvips -d 4            -o hello.ps      hello.dvi
dvips -d 4 -P deskjet -o hello.dj.ps   hello.dvi
dvips -d 4 -D 300     -o hello.300.ps  hello.dvi

# (find-sh "cd /tmp/ && dvips -d 68 -P deskjet -o hello.dj.ps hello.dvi")
# (find-sh "cd /tmp/ && dvips -d 68 -P deskjet -o hello.dj.ps hello.dvi |& tee o")
# (find-sh "cd /tmp/; tr '(),' \\\\n\\\\n\\\\n < o | sort | uniq | grep /")
# (find-fline "/usr/share/texmf/web2c/texmf.cnf" "fonts/type1")
# (find-fline "/var/lib/texmf/fonts/map/dvips/updmap/psfonts.map" "CMR10")

# (find-fline "/usr/share/texmf-texlive/fonts/type1/bluesky/")
# (find-zsh "dvifonts ~/LATEX/2008graphs.dvi | sort")
# (find-zsh "dvifonts ~/LATEX/2008sheaves.dvi | sort")

# (find-node "(dvips)Debug options")

# (find-man "xdvi")

# (find-fline "/tmp/o")
# (find-fline "/tmp/hello.2.ps")
# (find-fline "/tmp/hello.2.dj.ps")
# (find-pspage "/tmp/hello.2.ps")
# (find-pspage "/tmp/hello.2.dj.ps")
# (find-tkdiff "/tmp/hello.2.ps" "/tmp/hello.2.dj.ps")
# (find-tkdiff "/tmp/hello.ps" "/tmp/hello.dj.ps")
# (find-tkdiff "/tmp/hello.ps" "/tmp/hello.300.ps")
# (find-node "(dvips)Option details" "`-x NUM'" "magnification")
# (find-node "(dvips)Option details" "`-D NUM'" "resolution")
# (find-node "(dvips)Option details" "`-P PRINTER'")
# (find-node "(dvips)config.ps installation")
# (find-node "(dvips)config.ps installation" "p +cmfonts.map")
# (find-node "(dvips)Environment variables")

# (find-LATEXgrep "grep -nH -e dvips *.tex")

# (find-sh "locate dvips | grep config")
# (find-fline "/etc/texmf/texlive/dvips/config.ps")
# (find-fline "/etc/texmf/texlive/dvips/config.deskjet")
# (find-fline "/etc/texmf/texlive/dvips/deskjet.cfg")

# (find-node "(dvips)Configuration file commands" "`p [+]NAME'")
# (find-node "(dvips)PostScript fonts")
# (find-node "(dvips)psfonts.map")

# (find-fline "/etc/texmf/texlive/dvips/config.ps")
# (find-fline "/usr/share/texmf-texlive/dvips/config/config.ps")

# (find-sh "locate bluesky")

http://www.tex.ac.uk/cgi-bin/texfaq2html?label=getbitmap
http://www.tex.ac.uk/cgi-bin/texfaq2html?label=useMF
http://www.mail-archive.com/debian-tetex-maint@lists.debian.org/msg00548.html
http://www.tex.ac.uk/cgi-bin/texfaq2html?label=PSpreview





#####
#
# skencil
# 2008aug17
#
#####

# «skencil»  (to ".skencil")
# (find-status   "skencil")
# (find-vldifile "skencil.list")
# (find-udfile   "skencil/")




#####
#
# big delimiters
# 2008sep25
#
#####

# «big-delimiters»  (to ".big-delimiters")
# (find-texbookpage (+ 12 146) "\\big delimiters")
# (find-texbooktext (+ 12 147) "\\big delimiters")
%
% (eedn4a-bounded)

\def\lcurlybar#1{\left\{\mskip#1mu\middle|}
\def\rcurlybar#1{\middle|\mskip#1mu\right\}}
\def\scof#1#2{\lcurlybar{#1}#2\rcurlybar{#1}}

\def\pmtwo#1#2{\begin{pmatrix}#1 \\ #2\end{pmatrix}}
\def\pmthree#1#2#3{\begin{pmatrix}#1 \\ #2 \\ #3\end{pmatrix}}

$\scof{-4}{abc}
 \scof{-5.5}{\pmtwo a b}
 \scof{-6}{\pmthree a b c}
$

%
% (find-dvifonts "~/LATEX/tmp.dvi")

% (find-testfont "\\T{cmr10}\\T{cmmi10}\\T{cmsy10}")
% (find-testfont "\\T{cmex10}\\T{cmsy10}\\T{cmbx10}\\T{cmmi10}\\T{cmr10}\\T{cmsl10}")

% (find-symbolspage 53 "\\middle")
% (find-symbolstext    "\\middle")
% (find-sh "locate braket")
% (find-sh "locate ltxmisc")
% (code-c-d "ltxmisc" "/usr/share/texmf-texlive/tex/latex/ltxmisc/")
# (find-ltxmiscfile "braket.sty" "\\def\\mid@vertical")
% (find-ltxmiscfile "braket.sty" "e-TeX with its \\middle primitive")
% http://www.tex.ac.uk/cgi-bin/texfaq2html?label=etex
% http://www.tex.ac.uk/cgi-bin/texfaq2html?label=omegaleph

# (find-texbookpage (+ 11 471) "mu (math unit)")
# (find-texbookpage (+ 11 168) "mu")
# (find-texbookpage (+ 11 270) "mu")
# (find-texbookpage (+ 11 473) "openings")
# (find-texbookpage (+ 11 437) "openings")
# (find-texbookpage (+ 11 156) "\\delimiter")
# (find-texbookpage (+ 11 146) "\\big delimiters")
# (find-texbookpage (+ 11 150) "\\lmoustache")
# (find-plainsrcfile "plain.tex" "\\def\\lmoustache")
# (find-plainsrcfile "plain.tex" "\\def\\langle")
# (find-source2egrep "grep -nH -e moustache *")
# (find-source2egrep "grep -nH -e DeclareMathDelimiter *")
# (find-source2efile "ltfssdcl.dtx" "\\def\\@DeclareMathDelimiter")




#####
#
# book.cls
# 2008oct09
#
#####

# «book.cls»  (to ".book.cls")
# (find-dn4exfile "edrxheadfoot.tex")

# (find-source2efile "install.txt" "classes.dtx" "documented sources")
# (find-source2efile "install.txt" "running iniTeX on" "unpack.ins")
# (find-source2efile "unpack.ins"  "\\batchinput{classes.ins}")
# (find-source2efile "classes.ins" "\\generate" "\\file{book.cls}")
# (find-lsrcfile "base/book.cls" "\\if@twoside" "\\def\\ps@headings")

# Source:
# (find-source2efile "classes.dtx" "%<*article|report|book>")
# (find-source2efile "classes.dtx" "\\if@twoside" "\\def\\ps@headings")

# (find-source2efile "doc.dtx" "`documentation part'")




#####
#
# qtree
# 2008nov04
#
#####

# «qtree»  (to ".qtree")
# (find-angg "elisp/eeqtree.el")
# http://www.ling.upenn.edu/advice/latex/qtree/
# http://www.ling.upenn.edu/advice/latex/qtree/qtree.sty
# http://www.ling.upenn.edu/advice/latex/qtree/qtreenotes.tex
# http://www.ling.upenn.edu/advice/latex/qtree/qarrows.tex
# http://www.ling.upenn.edu/advice/latex/qtree/qtreenotes.pdf
# http://www.ling.upenn.edu/advice/latex/qtree/qarrows.pdf
#
cd $S/http/www.ling.upenn.edu/advice/latex/qtree/
cp -v qtree.sty qtreenotes.tex qarrows.tex qtreenotes.pdf qarrows.pdf ~/.eev/

#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)

cd ~/.eev/
cat > eeqtree.tex <<'%%%'
\documentclass[12pt]{article}
\usepackage{fullpage}
\usepackage{qtree}
\begin{document}
\Tree [.Root [.Left a b ] [.Right c ddd ] ]
\end{document}
%%%
cd ~/.eev/ && latex eeqtree.tex && dvipdf eeqtree.dvi && ls -l eeqtree*



#

%
% (eeqtree-bounded)
% (eeqtreenow-bounded)
% (defun c () (interactive) (find-sh eeqtree-command))
% (find-man "1 xpdf" "Reload the current PDF file.")
% (find-pdf-page "~/.eev/eeqtree.pdf")
\Tree [.Root [.Left a b ] [.Right c d e ] ]

%
# (find-man "xpdf")
% (find-node \"(gv)Notation\" \"<SC-X>\")
% (find-node \"(gv)Miscellaneous keys\" \"<SC-.>\" \"Reopen the current file\")
%
% (eeqtree-bounded)
% (defun c () (interactive) (find-sh "cd ~/.eev/ && latex eeqtree.tex && dvipdf eeqtree.dvi && ls -l eeqtree*"))
% (find-pdf-page "~/.eev/eeqtree.pdf")
% (find-node "(gv)Notation" "<SC-X>")
% (find-node "(gv)Miscellaneous keys" "<SC-.>" "Reopen the current file")
\Tree [.Root [.Left a b ] [.Right c dd ] ]

%




#####
#
# juridico (by fnaufel)
# 2008nov17
#
#####

# «juridico»  (to ".juridico")
# http://www.ic.uff.br/~fnaufel/
# (find-fline "~/tmp/juridico.zip")
#
rm -Rv   ~/usrc/juridico/
mkdir    ~/usrc/juridico/
unzip -d ~/usrc/juridico/ ~/tmp/juridico.zip
cd       ~/usrc/juridico/

latex exemplojuridico.tex 2>&1 > /dev/null
latex exemplojuridico.tex 2>&1 > /dev/null
latex exemplojuridico.tex

#
# (code-c-d "juridico" "~/usrc/juridico/")
# (find-juridicofile "")
# (find-pspage (ee-juridicofile "exemplojuridico.pdf"))




#####
#
# \newcounter
# 2009apr29
#
#####

# «newcounter»  (to ".newcounter")
# (find-LATEXgrep "grep -nH -e newcounter *.tex")
# (find-kopkadaly4page (+ 12 631) "Index" "newcounter")
# (find-kopkadaly4text (+ 12 631) "Index" "newcounter")
# (find-kopkadaly4page (+ 12 182) "8.1.2   User-defined counters")
# (find-kopkadaly4text (+ 12 182) "8.1.2   User-defined counters")
# (find-kopkadaly4page (+ 12 182) "8.1.3   Changing counter values")
# (find-kopkadaly4text            "8.1.3   Changing counter values")
# (find-kopkadaly4page (+ 12 213) "9.2.1   Cross-references")
# (find-kopkadaly4text            "9.2.1   Cross-references")

 (find-code-show2 "~/LATEX/Show2.tex")
       (code-show2 "~/LATEX/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()

outertexbody = Dang.from [=[
\documentclass{article}
\usepackage[<<geometry>>]{geometry}
\begin{document}
<<defs>>
<<texbody>>
<<saysuccess>>
\end{document}
]=]

texbody = [[
\newcounter{myex}
\par (\arabic{myex})
\par \refstepcounter{myex} (\arabic{myex}) \label{myex1} ($\Leftarrow$ this one)
\par \refstepcounter{myex} (\arabic{myex})
\par \refstepcounter{myex} (\arabic{myex})
\par \ref{myex1} ($\Leftarrow$ that one)
]]
= show()
 (etv)



# Old (2009apr29):
# (find-LATEX "2009apr29-C1.tex")
# (find-LATEX "2009apr29-MD.tex")
%
% (eedn4a-bounded)

\newcounter{myex}

(\arabic{myex})

\refstepcounter{myex}
(\arabic{myex})
\label{myex1}
($\Leftarrow$ this one)

\refstepcounter{myex}
(\arabic{myex})

\refstepcounter{myex}
(\arabic{myex})

\ref{myex1} ($\Leftarrow$ that one)

%





#####
#
# Fitch-style natural deductions
# 2009may08 / 2018nov13
#
#####

# «fitch»  (to ".fitch")
# https://www.logicmatters.net/latex-for-logicians/nd/
# http://www.phil.cam.ac.uk/teaching_staff/Smith/LaTeX/fitch.html
# http://angasm.org/papers/fitch/
# http://folk.uio.no/johanw/FitchSty.html
# http://folk.uio.no/johanw/nd.pdf
# http://folk.uio.no/johanw/fitch.sty

#
# (eev-bounded)

rm -v /tmp/fitch/
mkdir /tmp/fitch/
cd    /tmp/fitch/
cp -v $S/http/folk.uio.no/johanw/fitch.sty .

cat > test.tex <<'---'
\documentclass{article}
\usepackage{fitch}
\begin{document}
\begin{equation*}
  \begin{fitch}
    \fh \forall y\lnot P(y)                             \\
    \fa\fh \exists xP(x)                                \\
    \fa\fa\fitchmodalh{u}  P(u)                         \\
    \fa\fa\fa \forall y\lnot P(y) & R, 1                \\
    \fa\fa\fa \lnot P(u)          & $\forall$E, 4       \\
    \fa\fa\fa \bot                & $\lnot$E, 3,5       \\
    \fa\fa \bot                   & $\exists$E, 2, 3--6 \\
    \fa \lnot\exists xP(x)        & $\lnot$I, 2--7
  \end{fitch}
\end{equation*}
\end{document}
---

latex test.tex
rexdvi test.dvi

#
# (eev-bounded)
# Provas que a Aline LaTeXou em 2009may18:

rm -v /tmp/fitch/
mkdir /tmp/fitch/
cd    /tmp/fitch/
cp -v $S/http/folk.uio.no/johanw/fitch.sty .

cat > test.tex <<'---'
\documentclass{article}
\usepackage[latin1]{inputenc}
\usepackage{fitch}
\begin{document}

Exemplo 1.11 (p.11)
\begin{equation*}
  \begin{fitch}
    \fh                                          & sem premissa           \\
    \fa \fh q \to r                              & hipótese               \\
    \fa \fa \fh \lnot q \to \lnot p              & hipótese               \\
    \fa \fa \fa \fh p                            & hipótese               \\
    \fa \fa \fa \fa \lnot \lnot p                & $\lnot \lnot i \ 3$    \\
    \fa \fa \fa \fa \lnot \lnot q                & MT 2,4                 \\
    \fa \fa \fa \fa    q                         & $\lnot \lnot e \ 5$    \\
    \fa \fa \fa \fa r                            & $\to e \ 1,6$          \\
    \fa \fa \fa p \to r                          & $\to i \ 3-7$          \\
    \fa \fa (\lnot q \to \lnot p) \to (p \to r)  & $\to i \ 2-8$          \\
    \fa (q \to r) \to ((\lnot q \to \lnot p) \to (p \to r))  & $\to i \ 1-9$ \\
  \end{fitch}
\end{equation*}

Exemplo 1.13 (p.12)
\begin{equation*}
  \begin{fitch}
    \fh p \land q \to r        & premissa         \\
    \fa \fh p                  & hipótese         \\
    \fa \fa \fh q              & hipótese         \\
    \fa \fa \fa p \land q      & $\land i \ 2,3$  \\
    \fa \fa \fa r              & $\to e \ 1,4$    \\
    \fa \fa q \to r            & $\to i \ 3-5$    \\
    \fa p \to (q \to r)        & $\to i \ 2-6$    \\
  \end{fitch}
\end{equation*}

Página 14
\begin{equation*}
  \begin{fitch}
    \fh p \lor q               & premissa          \\
    \fa \fh p                  & hipótese          \\
    \fa \fa q \lor p           & $\lor i_{2} \ 2$  \\
    \fa \fh q                  & hipótese          \\
    \fa \fa q \lor p           & $\lor i_{1} \ 4$  \\
    \fa q \lor p               & $\lor e \ 1, \; 2-3, \; 4-5$ \\
  \end{fitch}
\end{equation*}

Segunda derivação da p.36:
\begin{equation*}
  \begin{fitch}
    \fb p \land q    \to r     & premissa         \\
    \fj p                      & premissa         \\
    \fa \fh q                  & hipótese         \\
    \fa \fa p \land q          & $\land i \ 2,3$  \\
    \fa \fa r                  & $\to e \ 1,4$    \\
    \fa q \to r                & $\to i \ 3-5$    \\
  \end{fitch}
\end{equation*}

\end{document}
---

latex test.tex
rexdvi test.dvi

#

% (find-sh "cp -v $S/http/folk.uio.no/johanw/fitch.sty ~/LATEX/")
% (find-LATEXfile "tmp.tex")

# https://www.logicmatters.net/resources/fitchguide.txt
# https://www.logicmatters.net/resources/pdfs/latex/Fitchexamples.pdf
# https://www.logicmatters.net/resources/fitch.sty
# https://tex.stackexchange.com/questions/404432/remove-numbering-from-fitch-sty-natural-deduction





#####
#
# Johan Klüwer's fitch.sty (version patched by Alexander Kocurek)
# 2021oct20
#
#####

# «kluwer-fitch»  (to ".kluwer-fitch")
# (find-es "dednat" "fitch")
# http://www.actual.world/latex/ ->
# http://www.actual.world/resources/tex/sty/kluwer/edited/fitch.sty
# http://www.actual.world/resources/tex/doc/Proofs.pdf

cp -v $S/http/www.actual.world/resources/tex/sty/kluwer/edited/fitch.sty ~/LATEX/kluwer-fitch.sty

# (find-fline "~/LATEX/kluwer-fitch.sty")

# Alexander W. Kocurek: "Proofs in LaTeX"
# (code-pdf-page "kocurek" "$S/http/www.actual.world/resources/tex/doc/Proofs.pdf")
# (code-pdf-text "kocurek" "$S/http/www.actual.world/resources/tex/doc/Proofs.pdf")
# (find-kocurekpage)
# (find-kocurektext)
# (find-kocurekpage 8 "1.1.7 An Illustrative Example")
# (find-kocurektext 8 "1.1.7 An Illustrative Example")






#####
#
# lplfitch - by Etchemendy, Barker-Plummer, Zach
# 2018nov13
#
#####

# «lplfitch» (to ".lplfitch")
# (find-books "__logic/__logic.el" "barwise-etchemendy")
# (find-tlfile "")
# (find-tlfile "texmf-dist/doc/latex/lplfitch")
# (find-tlsh "find * | sort | grep fitch")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/lplfitch/")
(code-pdf-page "lplfitch" "/usr/local/texlive/2019/texmf-dist/doc/latex/lplfitch/lplfitch.pdf")
(code-pdf-text "lplfitch" "/usr/local/texlive/2019/texmf-dist/doc/latex/lplfitch/lplfitch.pdf")
# (find-lplfitchpage)
# (find-lplfitchtext)
# (find-lplfitchpage 9 "Peter Selinger's package is available at")
# (find-lplfitchtext 9 "Peter Selinger's package is available at")
# (find-lplfitchpage 9 "and that by Johan Kluwer at")
# (find-lplfitchtext 9 "and that by Johan Kluwer at")



#####
#
# selinger-fitch
# 2020mar17
#
#####

# «selinger-fitch» (to ".selinger-fitch")
# https://www.mathstat.dal.ca/~selinger/fitch/
# https://www.mathstat.dal.ca/~selinger/fitch/fitch-0.5.tgz
# https://www.mathstat.dal.ca/~selinger/fitch/fitchdoc.pdf
# https://www.mathstat.dal.ca/~selinger/fitch/fitch.sty
# (code-pdf-page "selfitch" "$S/https/www.mathstat.dal.ca/~selinger/fitch/fitchdoc.pdf")
# (code-pdf-text "selfitch" "$S/https/www.mathstat.dal.ca/~selinger/fitch/fitchdoc.pdf")
# (find-selfitchpage)
# (find-selfitchtext)

# (find-sh "locate fitch")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/fitch-0.5/
tar -C ~/usrc/ -xvzf $S/https/www.mathstat.dal.ca/~selinger/fitch/fitch-0.5.tgz
cd     ~/usrc/fitch-0.5/
cp -v fitch.sty ~/LATEX/

# (code-c-d "selfitch" "~/usrc/fitch-0.5/")
# (find-selfitchfile "")
# (find-selfitchfile "fitch.sty")
# (find-selfitchfile "fitch.hacker.txt")
# (find-selfitchfile "fitch.hacker.txt" "using layer A syntax:")


   \begin{nd}
      \hypo {1} {P\vee Q}
      \hypo {2} {\neg Q}
      \open

      \hypo {3} {P}
      \have {4} {P}         \r{3}
      \close
      \open
      \hypo {aa} {Q}
      \have {6} {\neg Q}    \r{2}
      \have {7} {\bot}      \ne{aa,6}
      \have {8} {P}         \be{7}
      \close
      \have {9} {P}         \oe{1,3-4,aa-8}
         \end{nd}





#####
#
# fitch-0.5
# 2011nov24
#
#####

# «selinger-fitch»  (to ".selinger-fitch")
# http://www.mscs.dal.ca/~selinger/fitch/fitch-0.5.tgz
#
rm -Rv ~/usrc/fitch-0.5/
tar -C ~/usrc/ -xvzf \
  $S/http/www.mscs.dal.ca/~selinger/fitch/fitch-0.5.tgz
cd     ~/usrc/fitch-0.5/

#
# (code-c-d "fitch" "~/usrc/fitch-0.5/")
# (find-fitchfile "")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
ee_dofile "~/dednat5/eoo.lua"
FitchLine = Class {
  type    = "FitchLine",
  __index = {
    totex = function (fl, cmd)
        local n    = format(" {%s}", fl.n)
        local body = format(" {%s}", fl.body)
        local by   = fl.by and format(" \\by{%s}", fl.by) or ""
        return cmd..n..body..by
      end,
  },
}
FitchSubproof = Class {
  type    = "FitchSubproof",
  __index = {
    totex = function (fs, prefix)
        local T = {}
	local cmd = "\\hypo"
	for n,fl in ipairs(fs) do
	  PP(fl)
          if fl == "-" then cmd = "\\have"
	  else table.insert(T, prefix..fl:totex(cmd).."\n")
	  end
        end
        return table.concat(T)
      end,
  },
}

L1 = FitchLine {n=1, body="A", by="algebra"}
L2 = FitchLine {n=2, body="B"}
L3 = FitchLine {n=3, body="C", by="cee"}
L4 = FitchLine {n=4, body="D", by="dee"}
S1 = FitchSubproof {L1, L2, "-", L3, L4}

= S1:totex("  ")

= L1:totex "\\hypo"
= L2:totex "\\have"







#####
#
# mdwtab
# 2009may19
#
#####

# «mdwtab»  (to ".mdwtab")
# http://www.ctan.org/tex-archive/macros/latex/contrib/mdwtools/mdwtab.pdf
# (code-pdf-page  "mdwtab" "$S/http/www.ctan.org/tex-archive/macros/latex/contrib/mdwtools/mdwtab.pdf")
# (code-pdf-text  "mdwtab" "$S/http/www.ctan.org/tex-archive/macros/latex/contrib/mdwtools/mdwtab.pdf")
# (find-mdwtabpage 1)
# (find-mdwtabtext 1)




#####
#
# \smashpicture
# 2009aug18
#
#####

# «smashpicture»  (to ".smashpicture")
# (find-kopkadaly4page (+ 12 635) "Index" "picture")
# (find-kopkadaly4page (+ 12 288) "picture")
# (find-kopkadaly4text            "13.1.4 Picture element commands")
# (find-kopkadaly4page (+ 12 301) "13.1.6 Shifting a picture environment")
# (find-kopkadaly4text            "13.1.6 Shifting a picture environment")
# (find-kopkadaly4page (+ 12 296) "Ovals and rounded corners")
# (find-kopkadaly4text            "Ovals and rounded corners")
%
% (eedn4a-bounded)
% (find-sh0 "cd ~/LATEX/ && dvips  -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-sh0 "cd ~/LATEX/ && dvired -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-pspage "~/LATEX/tmp.ps")

\def\smashpicture#1{\begin{picture}(0,0)#1\end{picture}}
\def\vdashq{\smashpicture{\put(5,4.5){\tiny?}}\vdash}
\def\smashoval#1{\smashpicture{\put(0,0){\oval(#1)}}}

$a \vdashq b$

$a \smashoval{30,20} b$

%




#####
#
# shortvrb (for DNC in Coq)
# 2009sep19
#
#####

# «shortvrb»  (to ".shortvrb")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page 7 "Contents")
# (find-kopkadaly4page (+ 12 607) "Index")
# (find-kopkadaly4page (+ 12 639) "\f Index" "shortvrb")
# (find-kopkadaly4text            "\f Index" "shortvrb")
# (find-kopkadaly4page (+ 12 111) "shortvrb")
# (find-kopkadaly4page (+ 12 393) "shortvrb")
# (find-kopkadaly4page (+ 12 468) "shortvrb")
# (find-kopkadaly4page (+ 12 558) "shortvrb")
# (find-kopkadaly4text            "shortvrb")
# (find-lsrcfile "base/shortvrb.sty")
# (find-source2efile "doc.dtx")
# (find-source2efile "doc.dtx" "%<*package|shortvrb>")
# (find-dn4ex "edrx08.sty" "ttchars")
# (find-LATEX "2009dnc-in-coq.tex")

%
% (eedn4a-bounded)
% (find-sh0 "cd ~/LATEX/ && dvips  -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-sh0 "cd ~/LATEX/ && dvired -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-pspage "~/LATEX/tmp.ps")

Foo:

\par \verb.012345678.
\par \verb.  23  678.

{\MakeShortVerb{<^V>}
 \ttchars
 \par Foo bar<^V>0123456789ABCD<^V>plic ploc
 \par Foo bar<^V>  23  678«»  <^V>plic ploc
 \DeleteShortVerb{<^V>}
}

% $\substack{\delta \\ I \\ e}  f(\delta, e)$

\widemtos

\bsk

This:

\ssk

{\MakeShortVerb{<^V>}
 \ttchars
 \par<^V>a := proj1 «a,b»<^V>
 \par<^V>b := proj2 «a,b»<^V>
 \par<^V>c := «b|->c» b<^V>
 \par<^V>«a,c» := (a, c)<^V>
 \DeleteShortVerb{<^V>}
}

\ssk

Becomes:

{\MakeShortVerb{<^V>}
 \ttchars
 \par<^V>a := proj1 «<^V>$a,b$<^V>»<^V>
 \par<^V>b := proj2 «<^V>$a,b$<^V>»<^V>
 \par<^V>c := «<^V>$b \mto c$<^V>» b<^V>
 \par<^V>«<^V>$a,c$<^V>» := (a, c)<^V>
 \DeleteShortVerb{<^V>}
}

\ssk

And:

{\MakeShortVerb{<^V>}
 \ttchars
 \par<^V>a := proj1 dnc0<^V>
 \par<^V>b := proj2 dnc0<^V>
 \par<^V>c := dnc1 b<^V>
 \par<^V>dnc2 := (a, c)<^V>
 \DeleteShortVerb{<^V>}
}

%




#####
#
# llangle and rrangle
# 2009nov09
#
#####

# «llangle-and-rrangle»  (to ".llangle-and-rrangle")
# (find-LATEXfile "2009dnc-in-coq.tex" "\\def\\llangle")
# https://tex.stackexchange.com/questions/79657/how-to-get-double-angle-bracket-without-using-mnsymbol-package

% (find-es "tex" "llangle-and-rrangle")
% (find-dn4ex "edrx08.sty" "ttchars")
% (find-symbolspage 54 "\\llangle")
% (find-symbolstext    "\\llangle")
% http://ubuntuforums.org/archive/index.php/t-722871.html
\def\llangle{\langle\!\langle}
\def\rrangle{\rangle\!\rangle}
\def\angg#1{\llangle#1\rrangle}
\def\myotherttchars{
  \def«{\ttchar{$\llangle$}}
  \def»{\ttchar{$\rrangle$}}
  }
\def\myttchars{\basicttchars\myotherttchars}



#####
#
# llbracket-and-rrbracket
# 2020apr14
#
#####

# «llbracket-and-rrbracket» (to ".llbracket-and-rrbracket")
# (find-stmaryrdpage 2 "\\llbracket")
# (find-stmaryrdtext 2 "\\llbracket")




#####
#
# landscape
# 2010apr20
#
#####

# «landscape»  (to ".landscape")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/preprint/fullpage.pdf")
# (find-pdf-page "/usr/share/doc/texlive-latex-extra-doc/latex/preprint/fullpage.pdf")
# (find-fline "/usr/share/texmf-texlive/tex/latex/preprint/fullpage.sty")
# (find-man "1 xdvi" "\\usepackage[dvips]{geometry}")
# (find-man "1 xdvi" "\nPAPERSIZE SPECIALS")

% (find-angg ".emacs.papers" "kopkadaly")
% (find-kopkadaly4page 7 "Contents")
% (find-kopkadaly4page (+ 12 607) "Index")
% (find-kopkadaly4page (+ 12 626) "landscape")
% (find-kopkadaly4page (+ 12 633) "page format")
% (find-kopkadaly4page (+ 12 452) "fullpage.sty")
% (find-kopkadaly4page (+ 12  47) "3.2.5    Page format")
% (find-kopkadaly4text            "3.2.5    Page format")
% (find-kopkadaly4page (+ 12 159) "lscape")
% (find-kopkadaly4page (+ 12 232) "10.1.1 The dvips driver")
% (find-kopkadaly4text            "10.1.1 The dvips driver")
% (find-kopkadaly4page (+ 12  38) "Specifying paper size")
% (find-kopkadaly4text)
% (find-kopkadaly4text "\\ProvidesPackage{fullpage}")
% (find-lsrcfile "preprint/fullpage.sty")

% \special{landscape}
% \special{xdvi:papersize=27cm,21cm}
% \usepackage[dvips]{a5}
% \usepackage[a4paper,landscape]{anysize}
%\usepackage[a4paper]{anysize}
%\marginsize{1cm}{1cm}{1cm}{1cm}  % left, right, top, bottom
% (find-zsh "dmissing anysize")
% (find-fline   "/usr/share/doc/texlive-doc/latex/anysize/")
% (find-dvipage "/usr/share/doc/texlive-doc/latex/anysize/anysize.dvi")
% (find-lsrcfile "anysize/anysize.sty")




#####
#
# crossover
# 2010jun06
#
#####

# «crossover»  (to ".crossover")
# (find-dn4ex "edrx08.sty" "crossover")
%
% (eedn4a-bounded)
% (find-sh0 "cd ~/LATEX/ && dvips  -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-sh0 "cd ~/LATEX/ && dvired -D 300 -P pk -o tmp.ps tmp.dvi")
% (find-pspage "~/LATEX/tmp.ps")

% (find-texbookpage (+ 11 221) "\\vrule height4pt width3pt depth2pt")
% (find-texbooktext            "\\vrule height4pt width3pt depth2pt")
% (find-texbookpage (+ 11 285) "\\raise dimen box")
% (find-texbooktext            "\\raise dimen box")
\def\crossover#1#2#3{%
  \setbox0\hbox{#1}%
  \copy0%
  \hskip -\wd0%
  \setbox1\hbox{\vrule height #2 width\wd0 depth0pt}%
  \raise #3\copy1\relax}

Foo: \crossover{bleh bar}{0.25pt}{1.75pt} blop

Foo: \mycrossover{bleh bar} blop

%



#####
#
# birkjour (for submitting a paper to a Birkauser journal)
# 2010nov01
#
#####

# «birkjour»  (to ".birkjour")
# http://article.gmane.org/gmane.science.mathematics.categories/5991
# http://www.springer.com/birkhauser/mathematics/journal/11787
# http://www.springer.com/cda/content/document/cda_downloaddocument/birkjour.zip

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv   ~/usrc/birkjour/
mkdir    ~/usrc/birkjour/
unzip -d ~/usrc/birkjour/ \
  $S/http/www.springer.com/cda/content/document/cda_downloaddocument/birkjour.zip
cd       ~/usrc/birkjour/

# (code-c-d       "birkjour" "~/usrc/birkjour/")
# (code-pdf-page  "birkjour" "~/usrc/birkjour/bjourdoc.pdf")
# (code-pdf-text  "birkjour" "~/usrc/birkjour/bjourdoc.pdf")
# (find-birkjourfile "")
# (find-birkjourpage 1)
# (find-birkjourtext 1)



#####
#
# Submitting to Arxiv
# 2010nov01
#
#####

# «arxiv»  (to ".arxiv")
# https://arxiv.org/help/primer
# https://arxiv.org/help/endorsement
# https://arxiv.org/help/submit
# https://arxiv.org/help/faq/index
# https://arxiv.org/help/license

# http://en.wikipedia.org/wiki/Self_archiving
# http://en.wikipedia.org/wiki/Open_access_mandate
# http://www.eprints.org/openaccess/self-faq/



#####
#
# Macros with more than 9 arguments
# 2011jan04
#
#####

# «more-than-9-args»  (to ".more-than-9-args")
# (find-angg "LUA/defwithmanyargs.lua")
# (find-angg "LUA/defwithmanyargs.lua" "DefWithManyArgs-class")
# (find-angg "LUA/defwithmanyargs.lua" "DefWithManyArgs-tests")
# (find-angg "LUA/defwithmanyargs.lua" "Bottle")
%
% (eedn4a-bounded)
% My solution, using \sa, \ga, \begingroup and \endgroup.
% (find-angg "LUA/defwithmanyargs.lua")
% (find-dn4ex "edrxdnt.tex" "defded")

\def\sa#1#2{\expandafter\def\csname myarg#1\endcsname{#2}}
\def\ga#1{\csname myarg#1\endcsname}

\makeatletter
\def\foo#1#2#3#4#5{\begingroup%
  \sa{1}{#1}\sa{2}{#2}\sa{3}{#3}\sa{4}{#4}\sa{5}{#5}\foo@}
\def\foo@#1#2#3#4#5{%
  \sa{6}{#1}\sa{7}{#2}\sa{8}{#3}\sa{9}{#4}\sa{10}{#5}\foo@@}
\def\foo@@#1#2#3#4#5{%
  \sa{11}{#1}\sa{12}{#2}\sa{13}{#3}\sa{14}{#4}\sa{15}{#5}\foo@@@}
\def\foo@@@#1{%
  \sa{16}{#1}
  \begin{pmatrix}
    \ga{1} & \ga{2} & \ga{3} & \ga{4} \\
    \ga{5} & \ga{6} & \ga{7} & \ga{8} \\
    \ga{9} & \ga{10} & \ga{11} & \ga{12} \\
    \ga{13} & \ga{14} & \ga{15} & \ga{16} \\
  \end{pmatrix}
  \endgroup}
\makeatother

$$bar \foo 0123 4567 89AB CDEF bar$$
$$bar \foo 0123
           45{\foo 0123 4567 89ab cdef}7
           89AB
           CDEF bar$$

%
% (eedn4a-bounded)
% The original solution, from:
% http://www.tex.ac.uk/cgi-bin/texfaq2html?label=moren9

\def\setargsitov#1#2#3#4#5{%
  \def\argi{#1}\def\argii{#2}\def\argiii{#3}\def\argiv{#4}\def\argv{#5}}
\def\setargsvitox#1#2#3#4#5{%
  \def\argvi{#1}\def\argvii{#2}\def\argviii{#3}\def\argix{#4}\def\argx{#5}}

% \def\argii{2}

\def\showargs{%
  1:{\argi}
  2:{\argii}
  3:{\argiii}
  4:{\argiv}
  5:{\argv}
  6:{\argvi}
  7:{\argvii}
  8:{\argviii}
  9:{\argix}
  10:{\argx}}

\makeatletter
\def\foo #1#2#3#4#5{\setargsitov{#1}{#2}{#3}{#4}{#5}\@foo}
\def\@foo#1#2#3#4#5{\setargsvitox{#1}{#2}{#3}{#4}{#5}\showargs}
\makeatother

\par \foo abcdefghij
\par \foo ABCDEFGHIJ
% \par 2:\argii

%




#####
#
# showhyphens
# 2010jun08
#
#####




#####
#
# ipe
# 2012jun04
#
#####

# «ipe»  (to ".ipe")
# http://ipe7.sourceforge.net/
# http://lamut.informatik.uni-wuerzburg.de/mediawiki/ipe7/index.php/Main_Page
# (find-status   "ipe")
# (find-vldifile "ipe.list")
# (find-udfile   "ipe/")

# (find-fline "/usr/lib/ipe/7.0.10/ipelets/")
# (find-fline "/usr/share/ipe/7.0.10/")
# (find-fline "/usr/share/ipe/7.0.10/lua/")
#       file:///usr/share/ipe/7.0.10/doc/manual.html




#####
#
# geometry
# 2012aug09 / 2019jan05
#
#####

# «geometry»  (to ".geometry")
# (find-LATEXgrep "grep --color -nH -e geometry *.tex")
# (find-tlsh "find * | sort | grep geometry")
# (find-tlfile "texmf-dist/doc/latex/geometry/")
# (find-tlfile "texmf-dist/doc/latex/geometry/" "geometry.pdf")
# (find-tlfile "texmf-dist/source/latex/geometry/")
# (find-tlfile "texmf-dist/source/latex/geometry/geometry.dtx")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/geometry/")
(code-pdf-page "geometry" "/usr/local/texlive/2019/texmf-dist/doc/latex/geometry/geometry.pdf")
(code-pdf-text "geometry" "/usr/local/texlive/2019/texmf-dist/doc/latex/geometry/geometry.pdf")
;; (find-geometryfile "")
;; (find-geometrypage)
;; (find-geometrytext)
;; (find-geometrypage 3 "Figure 1: Dimension names")
;; (find-geometrytext 3 "Figure 1: Dimension names")
;; (find-geometrypage 4 "\\newgeometry")
;; (find-geometrytext 4 "\\newgeometry")
;; (find-geometrypage 15 "7    Changing layout mid-document")
;; (find-geometrytext 15 "7    Changing layout mid-document")
;; (find-geometrypage 41 "\\savegeometry")
;; (find-geometrytext 41 "\\savegeometry")

# (find-angg ".emacs.papers" "latexgeom")
# (find-LATEXgrep "grep --color -nH -e geometry *.tex")
# (find-LATEX "2011ebl-slides.tex" "geometry")
# (find-LATEXfile "istanbul-handouts.tex" "geometry")

# (find-es "tex" "docstrip")



#####
#
# \screenshotgeometry
# 2021nov02
#
#####

# «screenshotgeometry»  (to ".screenshotgeometry")
# (find-LATEX "2021emacsconf.tex" "screenshotdimens")
# (find-LATEX "2021emacsconf.tex" "screenshotgeometry")





#####
#
# 2 pages per sheet (Hugo Nóbrega)
# 2012dec01
#
#####

# «2-pages-per-sheet» (to ".2-pages-per-sheet")
# http://www.facebook.com/hugo.nobrega.372/posts/10151305375155777

LaTeX protip: to produce a pdf which looks pretty damn good printed in
"2 pages per sheet" mode, put the following in your preamble:

\usepackage{calc}
\usepackage[paperwidth=\textwidth+1cm,left=0.5cm,right=0.5cm,
            paperheight=\textheight+\footskip+1cm,top=0.5cm,bottom=0.5cm,
            includefoot]{geometry}

(this does change the paper proportions *ever so slightly*, though)

Hugo de Holanda This "version" will keep the paper size proportional
to A4, if that's what floats your boat:

\usepackage{calc}
\newlength{\newpaperheight}
\setlength{\newpaperheight}{\textheight+\footskip+1cm}
\newlength{\newpaperwidth}
\setlength{\newpaperwidth}{.707\newpaperheight}
\newlength{\newsidemargin}
\setlength{\newsidemargin}{.5\newpaperwidth - .5\textwidth}
\newlength{\newverticalmargin}
\setlength{\newverticalmargin}{.5cm}
\usepackage[paperwidth=\newpaperwidth,
            left=\newsidemargin,right=\newsidemargin,
            paperheight=\newpaperheight,
            top=\newverticalmargin,bottom=\newverticalmargin,
            includefoot]{geometry}

There was a problem if you used a documentclass with nonempty headers
(say, amsart). I think this fixes it:

\usepackage{calc}

\newlength{\newverticalmargin}
\setlength{\newverticalmargin}{.5cm}
\newlength{\newpaperheight}
\setlength{\newpaperheight}{\textheight+\headheight+\headsep+\footskip+2\newverticalmargin}
\newlength{\tempone}
\setlength{\tempone}{.707\newpaperheight - \textwidth}
\newlength{\newsidemargin}
\setlength{\newsidemargin}{.5\tempone}
\newlength{\newpaperwidth}
\setlength{\newpaperwidth}{\textwidth+2\newsidemargin}

\usepackage[paperwidth=\newpaperwidth,
            left=\newsidemargin,right=\newsidemargin,
            paperheight=\newpaperheight,
            top=\newverticalmargin,bottom=\newverticalmargin,
            includehead,includefoot]{geometry}




#####
#
# Floats
# 2013jan09
#
#####

# «floats» (to ".floats")
# (find-angg "quadradinho/quadradinho-texto.tex" "queremos")
# http://tex.stackexchange.com/questions/24796/how-to-handle-old-source-needing-floatflt-sty

% (find-angg ".emacs.papers" "kopkadaly")
% (find-kopkadaly4page 8 "Floating tables and figures")
% (find-kopkadaly4text 8 "Floating tables and figures")
% (find-kopkadaly4page (+ 12 170) "Floating tables and figures")
% (find-kopkadaly4text (+ 12 170) "Floating tables and figures")
% (find-kopkadaly4page (+ 12 173) "7.4   Float captions")
% (find-kopkadaly4text (+ 12 173) "7.4   Float captions")
% (find-kopkadaly4page (+ 12 178) "floatflt")
% (find-kopkadaly4text (+ 12 178) "floatflt")
% (find-lshortpage (+ 14 39) "2.13 Floating Bodies")

% (find-sh "locate floatflt")
% (find-zsh "dmissing floatflt")
% (find-zsh "dmissing texlive | grep float")
% (find-zsh "dmissing texlive | grep float | grep README")

% (find-lsrcfile "float/float.sty")
% (find-fline "/usr/share/doc/texlive-doc/latex/float/")
% (find-fline "/usr/share/doc/texlive-doc/latex/float/README")
% (find-fline "/usr/share/doc/texlive-doc/latex/float/README" "[H]")
% (find-fline "/usr/share/doc/texlive-doc/latex/float/")
(code-pdf-page "float" "/usr/share/doc/texlive-doc/latex/float/float.pdf")
(code-pdf-text "float" "/usr/share/doc/texlive-doc/latex/float/float.pdf")
% (find-floatpage)
% (find-floattext)
% (find-floatpage 11 "boxed float style")
% (find-floattext 11 "boxed float style")
% (find-floatpage 2 "\\newfloat{ type }{ placement }{ ext }[ within ]")
% (find-floattext 2 "\\newfloat{ type }{ placement }{ ext }[ within ]")
% (find-floatpage 3 "\\newfloat{Program}{tbp}{lop}[section]")
% (find-floattext 3 "\\newfloat{Program}{tbp}{lop}[section]")

% Doesn't work:
\begin{floatingfigure}[hl]{1in}
$$\includegraphics[scale=0.15]{queremos4.pdf}$$
\end{floatingfigure}

;; (find-fline "/usr/share/doc/texlive-doc/latex/subfloat/")
(code-pdf-page "subfloat" "/usr/share/doc/texlive-doc/latex/subfloat/subfloat.pdf")
(code-pdf-text "subfloat" "/usr/share/doc/texlive-doc/latex/subfloat/subfloat.pdf")
;; (find-subfloatpage)
;; (find-subfloattext)

% (find-fline "/usr/share/doc/texlive-doc/latex/dpfloat/README.dpfloat")
% (find-fline "/usr/share/doc/texlive-doc/latex/floatrow/README")
% (find-fline "/usr/share/doc/texlive-doc/latex/subfloat/README")
% (find-fline "/usr/share/doc/texlive-doc/latex/trivfloat/README")




#####
#
# \includegraphics
# 2018mai31
#
#####

# «includegraphics» (to ".includegraphics")
# (find-es "tex" "graphicx")
# (find-kopkadaly4page (+ 12 154) "graphicx")
# (find-kopkadaly4text (+ 12 154) "graphicx")
# (find-kopkadaly4page (+ 12 155) "\\includegraphics")
# (find-kopkadaly4text (+ 12 155) "\\includegraphics")
# (find-graphicspage 2 "\\includegraphics")
# (find-graphicstext 2 "\\includegraphics")
# (find-graphicxpage 2 "\\includegraphics")
# (find-graphicxtext 2 "\\includegraphics")



#####
#
# pdfcrop
# 2021oct24
#
#####

# «pdfcrop»  (to ".pdfcrop")
# (find-tlsh "find * | sort | grep pdfcrop")
# (find-tlfile "texmf-dist/doc/support/pdfcrop/README")
# (find-tlfile "texmf-dist/doc/latex/latex4musicians/pdfcrop.sh")
# (find-pdf-page "~/INKSCAPE/square-cube-4.pdf")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cp ~/INKSCAPE/square-cube-4.pdf /tmp/input.pdf

cd /tmp/
gs -q -sDEVICE=bbox -dBATCH -dNOPAUSE input.pdf 2>&1
gs -q -sDEVICE=bbox -dBATCH -dNOPAUSE input.pdf 2>&1 | grep %%B
mutool info    input.pdf

# https://www.kwasan.kyoto-u.ac.jp/solarb6/usinggraphicx.pdf
# (code-pdf-page "mahoney" "$S/https/www.kwasan.kyoto-u.ac.jp/solarb6/usinggraphicx.pdf")
# (code-pdf-text "mahoney" "$S/https/www.kwasan.kyoto-u.ac.jp/solarb6/usinggraphicx.pdf")
# (find-mahoneypage)
# (find-mahoneytext)
# (find-mahoneypage 2 "clip = true/false")
# (find-mahoneytext 2 "clip = true/false")
# (find-mahoneypage 4 "viewport = 0 0 64 84")
# (find-mahoneytext 4 "viewport = 0 0 64 84")



# Error: /undefinedfilename in (input.pdf)








#####
#
# subfigure
# 2013apr13
#
#####

# «subfigure» (to ".subfigure")
# (find-sh "locate subfigure")
# (find-fline "/usr/share/doc/texlive-doc/latex/subfigure/")
/usr/share/doc/texlive-doc/latex/subfigure/

# (find-sh "locate subfig")
# (find-sh "locate subfig | grep -v subfigure")
# (find-sh "locate subfigure")
# (find-fline "/usr/share/doc/texlive-doc/latex/subfig/")
(code-pdf-page "subfig" "/usr/share/doc/texlive-doc/latex/subfig/subfig.pdf")
(code-pdf-text "subfig" "/usr/share/doc/texlive-doc/latex/subfig/subfig.pdf" 8)
# (find-subfigpage)
# (find-subfigtext)
# (find-subfigpage (+ 8 41))
# (find-subfigtext (+ 8 41))
# (find-subfigpage (+ 8 42) "5.1        A Simple Example")
# (find-subfigtext (+ 8 42) "5.1        A Simple Example")
# (find-subfigpage (+ 8 54) "\\newcounter{sub#2}")
# (find-subfigtext (+ 8 54) "\\newcounter{sub#2}")

;; "subfig" supersedes "subfigure"...
;; (find-fline "/usr/share/doc/texlive-doc/latex/subfigure/")
(code-pdf-page "subfigure" "/usr/share/doc/texlive-doc/latex/subfigure/subfigure.pdf")
(code-pdf-text "subfigure" "/usr/share/doc/texlive-doc/latex/subfigure/subfigure.pdf")
;; (find-subfigurepage)
;; (find-subfiguretext)




#####
#
# The "subfig" package
# 2013apr26
#
#####

# «subfig» (to ".subfig")
http://tex.stackexchange.com/questions/9256/using-one-counter-for-different-floats
http://stackoverflow.com/questions/3865036/using-a-single-count-for-figures-and-tables-in-latex

% http://tex.stackexchange.com/questions/9256/using-one-counter-for-different-floats
% http://stackoverflow.com/questions/3865036/using-a-single-count-for-figures-and-tables-in-latex
% The "\let" below is a dirty trick to makefigures and boxedfigures
% use the same counter.




#####
#
# \let
# 2013apr18
#
#####

# «let» (to ".let")
# (find-texbookpage (+ 12 206) "\\let\\a=\\def")
# (find-texbooktext (+ 12 206) "\\let\\a=\\def")





#####
#
# Classe para atas de reunião
# 2013jan29
#
#####

# «ata.cls» (to ".ata.cls")
# [puro-uff-rfm: 1958] Uma classe LaTeX para atas de reunião
# (find-zsh "dmissing lineno.sty")
# (find-zsh "dmissing eorm")
# (find-status   "texlive-humanities")
# (find-vldifile "texlive-humanities.list")
# (find-udfile   "texlive-humanities/")
# (find-status   "texlive-humanities-doc")
# (find-vldifile "texlive-humanities-doc.list")
# (find-udfile   "texlive-humanities-doc/")
# (find-status   "texlive-fonts-extra")
# (find-vldifile "texlive-fonts-extra.list")
# (find-udfile   "texlive-fonts-extra/")
# (find-status   "texlive-fonts-extra-doc")
# (find-vldifile "texlive-fonts-extra-doc.list")
# (find-udfile   "texlive-fonts-extra-doc/")

# (find-angg "LATEX/2012-ata-rfm-dez.tex")




#####
#
# tlmgr
# 2013apr30
#
#####

# «tlmgr» (to ".tlmgr")
# Mentioned by:
# (find-es "luatex" "luacode")

# (find-man "tlmgr")
# http://www.tug.org/texlive/tlmgr.html
# http://www.tug.org/texlive/doc/tlmgr.html
# (find-zsh "dmissing tlmgr")




#####
#
# \usepackage[T1]{fontenc}
# 2013jul17 / 2015oct26
#
#####

# «T1-fontenc» (to ".T1-fontenc")
# (find-kopkadaly4page (+ 12 378) "\\usepackage[OT2,T1]{fontenc}")
# (find-kopkadaly4text (+ 12 378) "\\usepackage[OT2,T1]{fontenc}")
# (find-kopkadaly4page (+ 12 501) "\\usepackage[T1]{fontenc}")
# (find-kopkadaly4text (+ 12 501) "\\usepackage[T1]{fontenc}")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/base/t1enc.def")
# http://tex.stackexchange.com/questions/187485/only-getting-strange-symbols-when-copying-from-pdf-to-text
# http://tex.stackexchange.com/questions/239170/make-pdflatex-output-utf-8-copy-pasteable-when-using-times-font
# http://tex.stackexchange.com/questions/64188/what-are-good-ways-to-make-pdflatex-output-copy-and-pasteable 
# http://tex.stackexchange.com/questions/64409/proper-use-of-cmap-and-mmap

# (find-sh "locate fontenc")
# (find-zsh "dmissing fontenc")

# (find-sh "locate glyphtounicode")
# (find-fline "/usr/share/texlive/texmf-dist/tex/generic/pdftex/glyphtounicode.tex")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/pdfx/glyphtounicode-cmr.tex")



#####
#
# inputenx
# 2015oct26
#
#####

# «inputenx» (to ".inputenx")
# http://tex.stackexchange.com/questions/64188/what-are-good-ways-to-make-pdflatex-output-copy-and-pasteable
# (find-sh "locate inputenx")
# (code-pdf-page "inputenx" "/usr/share/doc/texlive-doc/latex/oberdiek/inputenx.pdf")
# (code-pdf-text "inputenx" "/usr/share/doc/texlive-doc/latex/oberdiek/inputenx.pdf")
# (find-inputenxpage)
# (find-inputenxtext)




#####
#
# no room for a new dimen
# 2014apr03
#
#####

# «no-room-for-a-new-dimen» (to ".no-room-for-a-new-dimen")
# http://tex.stackexchange.com/questions/38607/no-room-for-a-new-dimen
# http://www.tex.ac.uk/cgi-bin/texfaq2html?label=noroom
# http://www.tex.ac.uk/cgi-bin/texfaq2html?label=etex

# (find-sh "locate etex")
# (find-sh "locate etex | grep texlive")



#####
#
# \vcenter
# 2016sep22
#
#####

# «vcenter» (to ".vcenter")
# (find-texbookpage (+ 12 150) "\\vcenter")
# (find-texbooktext (+ 12 150) "\\vcenter")
# (find-texbookpage (+ 12 151) "\\vcenter" "only in math")
# (find-texbooktext (+ 12 151) "\\vcenter" "only in math")




#####
#
# \rotatebox
# 2016sep22
#
#####

# «rotatebox» (to ".rotatebox")
# https://en.wikibooks.org/wiki/LaTeX/Rotations
# (find-angg ".emacs.papers" "latex-graphics")
# (find-graphicstext)
# (find-graphicspage 3 "\resizebox")
# (find-graphicspage 4 "\\rotatebox")
# (find-graphicstext 4 "\\rotatebox")
# (find-graphicxpage 4 "\\rotatebox")
# (find-graphicxtext 4 "\\rotatebox")



#####
#
# \resizebox
# 2015jun02
#
#####

# «resizebox» (to ".resizebox")
# «scalebox»  (to ".scalebox")
# (find-angg ".emacs.papers" "latex-graphics")
# (find-LATEXgrep "grep --color -nH -e resizebox *.tex")
# (find-LATEXgrep "grep --color -nH -e scalebox  *.tex")
# (find-sh "locate -i graphic | grep -i tex")
# (find-udfile "texlive-latex-base-doc/latex/graphics/")
# (find-kopkadaly4page (+ 12 156) "\\scalebox{h scale}[v scale]{text}")
# (find-kopkadaly4text (+ 12 156) "\\scalebox{h scale}[v scale]{text}")
# (find-kopkadaly4page (+ 12 156) "\\resizebox{h length}{v length}{text}")
# (find-kopkadaly4text (+ 12 156) "\\resizebox{h length}{v length}{text}")

# (find-fline "/usr/share/doc/texlive-latex-base-doc/latex/graphics/")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/graphics/graphics.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/graphics/graphicx.pdf")
(code-pdf-page "latexgraphics" "/usr/share/doc/texlive-doc/latex/graphics/graphics.pdf")
(code-pdf-text "latexgraphics" "/usr/share/doc/texlive-doc/latex/graphics/graphicx.pdf" 0)
# (find-latexgraphicspage)
# (find-latexgraphicstext)
# (find-latexgraphicspage 4 "resizebox")
# (find-latexgraphicstext 4 "resizebox")

\rotatebox{90}{
\resizebox{10cm}!{
$\bfig
  \morphism(0,0)/<=/<300,0>[{a,b}`{a};]
  \morphism(0,0)/|->/<0,-300>[{a,b}`{c};]
  \morphism(300,0)/|->/<0,-300>[{a}`{b\mapsto c};]
  \morphism(0,-300)/=>/<300,0>[{c}`{b\mapsto c};]
\efig
$
}
}

\resizebox{10cm}!{Hello}

\resizebox{10cm}!{$\Diag{foo}$}
\rotatebox{90}{\resizebox{10cm}!{$\Diag{foo}$}}


# From the Org mailing list:

Hi there,

I am trying to find a way to automatically resize tables
in the latex output.

When doing slides in beamer, I use this to resize tables
to fit in a frame

     #+LaTeX: \scriptsize{\resizebox{\textwidth}{!}{
        | . | . |
     #+LaTeX: }}


#####
#
# adjustbox and collectbox
# 2015jun20
#
#####

# «adjustbox» (to ".adjustbox")
# «collectbox» (to ".collectbox")
# https://www.ctan.org/tex-archive/macros/latex/contrib/adjustbox?lang=en
# https://www.ctan.org/pkg/collectbox
# http://repositorios.cpai.unb.br/ctan/macros/latex/contrib/adjustbox/adjustbox.pdf
# (find-sh    "locate adjustbox")
# (find-zsh "dmissing adjustbox")
# (find-sh    "locate collectbox")
# (find-zsh "dmissing collectbox")
# (find-fline "/usr/share/doc/texlive-pictures-doc/latex/adjustbox/")
# (find-fline "/usr/share/doc/texlive-latex-extra-doc/latex/collectbox/")

apti texlive-pictures-doc texlive-latex-extra-doc




#####
#
# \overbrace and \underbrace
# 2015jun02
#
#####

# «overbrace» (to ".overbrace")
# «underbrace» (to ".underbrace")
# (find-kopkadaly4page (+ 12 136) "\\overbrace" "\\underbrace")
# (find-kopkadaly4text (+ 12 136) "\\overbrace" "\\underbrace")

% 2*3+4*5
% \-/ \-/
%  6   20
% \-----/
%    26

$$
\underbrace{
  \underbrace{2 \cdot 3}_{6} +
  \underbrace{4 \cdot 5}_{20}
}_26
$$

$$
\underbrace{
  \underbrace{\underbrace{a}_2 \cdot \underbrace{b}_3}_{6} +
  \underbrace{\underbrace{c}_4 \cdot \underbrace{d}_5}_{20}
}_{26}
$$




#####
#
# \cell and friends, for pict2e
# 2023jun03
#
#####

# «picture-cells»  (to ".picture-cells")
# (find-LATEX "edrx21defs.tex" "cells")
# (find-dn6 "preamble6.lua" "preamble1")
# (find-dn6 "preamble6.lua" "preamble1" "\\def\\cell")
# (find-LATEXgrep "grep --color=auto -nH --null -e picture-cells *.tex *.sty")
# (find-LATEXgrep "grep --color=auto -nH --null -e cell   *.tex *.sty")
# (find-LATEXgrep "grep --color=auto -nH --null -e cellnw *.tex *.sty")
# (find-LATEXgrep "grep --color=auto -nH --null -e celllower *.tex")
# (find-LATEX "material-para-GA.tex" "cells")
# (find-LATEX "material-para-GA.tex" "cells" "\\def\\cellnw")

\newlength{\celllower}
\newlength{\lcelllower}
\def\cellfont{}
\def\lcellfont{}
\def\cell #1{\lower\celllower\hbox to 0pt{\hss\cellfont${#1}$\hss}}
\def\lcell#1{\lower\celllower\hbox to 0pt   {\lcellfont${#1}$\hss}}

% Typical values:
\celllower=3pt     % For \documentclass[10pt]{...}
\celllower=3.5pt   % For \documentclass[12pt]{...}




#####
#
# lower and raise
# 2015jun07
#
######

# «lower-and-raise» (to ".lower-and-raise")
# (find-texbookpage (+ 12 66) "\\lower.5ex")
# (find-texbooktext (+ 12 66) "\\lower.5ex")
# (find-texbookpage (+ 12 470) "*\\lower,")
# (find-texbooktext (+ 12 470) "*\\lower,")

# (find-texbookpage (+ 12 80) "\\moveright dimen box")
# (find-texbooktext (+ 12 80) "\\moveright dimen box")

# (find-texbookpage (+ 12 80))
# (find-texbookpage (+ 12 151))
# (find-texbookpage (+ 12 179))
# (find-texbookpage (+ 12 285))
# (find-texbookpage (+ 12 290))

Test:
$
\def\cell#1{\hbox to 0pt{\hss \footnotesize#1\hss}}
\def\cell#1{\raise 1.5pt\hbox to 0pt{\hss \footnotesize#1\hss}}
\left({\unitlength=7pt
\lower1\unitlength\hbox{\begin{picture}(3,3)(-1.5,0)
  \put(0,0){\cell{11}}
  \put(1,1){\cell{01}}
  \put(-1,1){\cell{10}}
  \put(0,2){\cell{00}}
  \put(0,-0.5){\line(1,1){2}}
  \put(0,-0.5){\line(-1,1){2}}
  \put(0,3.5){\line(1,-1){2}}
  \put(0,3.5){\line(-1,-1){2}}
\end{picture}
}}\right)
$




#####
#
# \scriptscriptstyle
# 2015jul29
#
#####

# «scriptscriptstyle» (to ".scriptscriptstyle")
# (find-texbookpage (+ 12 140) "scriptscript style")
# (find-texbooktext (+ 12 140) "scriptscript style")
# (find-texbookpage (+ 12 141) "\\scriptscriptstyle")
# (find-texbooktext (+ 12 141) "\\scriptscriptstyle")
# (find-texbookpage (+ 12 433) "seven \\fontdimen parameters")
# (find-texbooktext (+ 12 433) "seven \\fontdimen parameters")
# (find-texbookpage (+ 12 350) "\\font\\fivesy=cmsy5")
# (find-texbooktext (+ 12 350) "\\font\\fivesy=cmsy5")
# (find-texbookpage (+ 12 15) "\\fiverm")
# (find-texbooktext (+ 12 15) "\\fiverm")

# (find-kopkadaly4page (+ 12 63) "\\tiny")
# (find-kopkadaly4text (+ 12 63) "\\tiny")

Same size:
{\tiny a$a$}$\scriptscriptstyle a$

# http://tex.stackexchange.com/questions/24599/what-point-pt-font-size-are-large-etc?lq=1



#####
#
# Virginia Lake
# 2015aug31
#
#####

# «virginia-lake» (to ".virginia-lake")
# http://alessio.guglielmi.name/res/vl/
# http://alessio.guglielmi.name/res/vl/virginialake.sty
# http://alessio.guglielmi.name/res/vl/virginialake-manual.pdf

;; (find-fline "$S/http/alessio.guglielmi.name/res/vl/")
(code-pdf-page "virginialake" "$S/http/alessio.guglielmi.name/res/vl/virginialake-manual.pdf")
(code-pdf-text "virginialake" "$S/http/alessio.guglielmi.name/res/vl/virginialake-manual.pdf")
;; (find-virginialakepage)
;; (find-virginialaketext)




#####
#
# cancel
# 2015oct26
#
#####

# «cancel» (to ".cancel")
# (find-sh "locate cancel | grep tex")
# (code-pdf-page "cancel" "/usr/share/doc/texlive-doc/latex/cancel/cancel.pdf")
# (code-pdf-text "cancel" "/usr/share/doc/texlive-doc/latex/cancel/cancel.pdf")
# (find-cancelpage)
# (find-canceltext)
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/cancel/cancel.sty")
# http://charlesmartinreid.com/wiki/Cancel_Package

# (find-tlsh "find * | sort | grep cancel")

https://mailman.ntg.nl/pipermail/ntg-context/2008/035327.html
http://tug.ctan.org/tex-archive/macros/latex/contrib/cancel/cancel.pdf
https://ctan.org/pkg/cancel?lang=en





#####
#
# latex-recorder
# 2016feb15
#
#####

# «latex-recorder» (to ".latex-recorder")
# (find-fline "/usr/share/bug/texlive-lang-portuguese/script" "(pdf)latex -recorder ...")
# (find-man "1 tex")
# (find-man "1 tex" "-recorder")
# (find-man "1 tex" "-recorder" ".fls")
# http://tex.stackexchange.com/questions/245336/how-can-one-manually-add-a-line-to-the-pdflatex-recorder-fls-file
# https://tex.stackexchange.com/questions/45205/find-out-which-packages-are-used
# (find-angg "LUA/flsfiles.lua")

# (find-LATEX "2015-2-GA-P1-gab.tex")
# (find-LATEX "2015-2-GA-P1-gab.fls")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
-- (find-LATEX "2015-2-GA-P1-gab.fls")
bigstr = ee_readfile "~/LATEX/2015-2-GA-P1-gab.fls"
for li in bigstr:gmatch "[^\n]+" do
  local fn = li:match("^INPUT (.*)")
  if fn and
     not fn:match "/usr/share/" and
     not fn:match "/.texmf-var/" and
     not fn:match "%.aux$" and
     not fn:match "%.out$" and
     true
  then
    if fn:match "^%./" then fn = fn:sub(3) end
    print(fn)
  end
end

s = Set:new()
for fn in flsfiles_nontrivial "~/LATEX/2015-2-GA-P1-gab.fls" do
  print(fn)
  s:add(fn)
end
s:del "/home/edrx/dednat6/dednat6.lua"
= s:ksc()

ee_writefile("~/LATEX/2015-2-GA-P1-gab.fls", s:ksc().."\n")

fn = "/home/edrx/.texmf-var/web2c/luatex/lualatex.fmt"
= fn:match "/.texmf-var/"
= fn:match "/.texmf"
= fn:match "/.texmf-"

# (find-node "(reftex)Top")




#####
#
# latex-recorder on texlive-2017
# 2017jul10
#
#####

# «latex-recorder-2017» (to ".latex-recorder-2017")
# (find-fline "~/LATEX/2017-1-GA-material.fls")
# (find-fline "~/LATEX/2017-1-GA-material.fls" "INPUT dednat6/dednat6.lua")
# (find-fline "~/LATEX/dednat6/dednat6.lua")






#####
#
# ott
# 2016apr10
#
#####

# «ott» (to ".ott")
# http://www.cl.cam.ac.uk/~pes20/ott/
# http://www.cl.cam.ac.uk/~pes20/ott/ott_distro_0.25.tar.gz
#
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/ott_distro_0.25/
tar -C ~/usrc/ -xvzf \
  $S/http/www.cl.cam.ac.uk/~pes20/ott/ott_distro_0.25.tar.gz
cd     ~/usrc/ott_distro_0.25/

make |& tee om

rm -v ~/bin/ott
ln -s ~/usrc/ott_distro_0.25/bin/ott ~/bin/ott
# (find-zsh0 "laf $(w ott)")

#
# (code-c-d "ott" "~/usrc/ott_distro_0.25/")
# (find-ottfile "")
# (find-ottfile "README")
# (find-ottfile "Makefile")




#####
#
# array
# 2016apr17
#
#####

# «array» (to ".array")
# «halign» (to ".halign")
# (find-angg ".emacs" "source2e")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-source2epage (+ 10 328) "57.2      array and tabular environments")
# (find-source2etext (+ 10 328) "57.2      array and tabular environments")
# (find-source2epage (+ 8 445) "\\array")
# (find-source2etext (+ 8 445) "\\array")
# (find-source2epage (+ 8 240) "File C" "lttab.dtx")
# (find-source2etext (+ 8 240) "File C" "lttab.dtx")
# (find-source2epage (+ 8 240) "58     Tabbing, Tabular and Array Environments")
# (find-source2etext (+ 8 240) "58     Tabbing, Tabular and Array Environments")
# (find-source2etext (+ 8 240) "58     Tabbing, Tabular and Array Environments" "extended version")
# (find-source2epage (+ 8 247) "58.2    array and tabular environments")
# (find-source2etext (+ 8 247) "58.2    array and tabular environments")
# (find-kopkadaly4page (+ 12  95)  "4.8 Tables")

# «arraycolsep»  (to ".arraycolsep")

$\pmat{A&B\\C&D}
 \setlength{\arraycolsep}{0pt}
 \pmat{A&B\\C&D}
$

# (find-texbookpage (+ 12 361) "\\matrix")
# (find-texbooktext (+ 12 361) "\\matrix")
# (find-texbookpage (+ 12 354) "\\ialign")
# (find-texbooktext (+ 12 354) "\\ialign")
# (find-texbookpage (+ 12 194) "primitive \\halign")
# (find-texbooktext (+ 12 194) "primitive \\halign")
# (find-texbookpage (+ 12 235) "\\halign is really quite simple")
# (find-texbooktext (+ 12 235) "\\halign is really quite simple")
# (find-texbookpage (+ 12 237) "\\tabskip=")
# (find-texbooktext (+ 12 237) "\\tabskip=")
# (find-texbookpage (+ 12 240) "\\omit")
# (find-texbooktext (+ 12 240) "\\omit")

# Extended version:
# (find-tlsh "find * | sort | grep array.pdf")
# (find-tlfile "texmf-dist/doc/latex/tools/" "array.pdf")
# (code-pdf-page "array" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/array.pdf")
# (code-pdf-text "array" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/array.pdf")
# (find-arraypage)
# (find-arraytext)
# (find-arraypage 1 "\\setlength{\\extrarowheight}{1pt}")
# (find-arraytext 1 "\\setlength{\\extrarowheight}{1pt}")

# «arraystretch»  (to ".arraystretch")
# https://www.overleaf.com/learn/latex/Questions/How_do_I_change_column_or_row_separation_in_LaTeX_tables%3F
# https://tex.stackexchange.com/questions/10985/separate-arraystretch-value-for-every-table

# «delarray»  (to ".delarray")
# (find-LATEX "edrx21.sty" "psm-and-pmat" "\\def\\bmatt")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/")
(code-pdf-page "delarray" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/delarray.pdf")
(code-pdf-text "delarray" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/delarray.pdf")
;; (find-delarraypage)
;; (find-delarraytext)





# (find-latex-links "/tmp/foo")
# (defun e () (interactive) (find-fline "/tmp/foo.tex"))

\documentclass{article}
\usepackage{amsmath}
\begin{document}

$\begin{matrix}
 a & b & c \\
 d & \omit e & f \\
 \end{matrix}
$

\end{document}





#####
#
# tabbing
# 2016apr26
#
#####

# «tabbing» (to ".tabbing")
# (find-texbookpage (+ 12 231) "\\+")
# (find-texbooktext (+ 12 231) "\\+")
# (find-texbookpage (+ 12 234) "Computer programs present difficulties")
# (find-texbooktext (+ 12 234) "Computer programs present difficulties")
# (find-texbookpage (+ 11 339) "Appendix B: Basic Control Sequences")
# (find-texbooktext (+ 11 339) "Appendix B: Basic Control Sequences")
# (find-texbookpage (+ 12 354) "\\let\\+=")
# (find-texbooktext (+ 12 354) "\\let\\+=")
# (find-source2epage (+ 8 240) "58     Tabbing, Tabular and Array Environments")
# (find-source2etext (+ 8 240) "58     Tabbing, Tabular and Array Environments")
#
# (find-kopkadaly4page (+ 12  81) "4.6     Tabulator stops")
# (find-kopkadaly4text (+ 12  81) "4.6     Tabulator stops")
#
# http://www.tug.org/tutorials/latex2e/tabbing.html
# http://tex.stackexchange.com/questions/131469/framebox-and-tabbing-not-working-together
# http://stackoverflow.com/questions/5194321/creating-a-box-around-a-figure-that-includes-the-tabbing-environment


\begin{tabbing}
function \= fact(n : integer) : integer;\\
         \> begin \= \+ \\
               \> if \= n $>$ 1 then \+ \\
                        fact := n * fact(n-1) \- \\
                  else \+ \\
                        fact := 1; \-\- \\
            end;\\
\end{tabbing}



#####
#
# eqnarray
# 2016apr28
#
#####

# «eqnarray» (to ".eqnarray")
# (find-kopkadaly4page (+ 12 139) "eqnarray")
# (find-kopkadaly4text (+ 12 139) "eqnarray")
# (find-kopkadaly4page (+ 12 139) "\\nonumber")
# (find-kopkadaly4text (+ 12 139) "\\nonumber")
# (find-source2epage (+ 10 637) "eqnarray")
# (find-source2etext (+ 10 609) "eqnarray")
# (find-source2epage (+ 10 287) "eqnarray")
# (find-source2etext (+ 10 287) "eqnarray")
# (find-source2epage (+ 10 287) "\\lefteqn")
# (find-source2etext (+ 10 287) "\\lefteqn")



#####
#
# overset and underset
# 2016may27
#
#####

# «overset-and-underset» (to ".overset-and-underset")
# (find-kopkadaly4page (+ 12 262) "\\overset")
# (find-kopkadaly4text (+ 12 262) "\\overset")
# (find-kopkadaly4page (+ 12 262) "\\underset")
# (find-kopkadaly4text (+ 12 262) "\\underset")
# (find-source2epage (+ 8 214) "eqnarray")
# (find-source2etext (+ 8 214) "eqnarray")

# (to "amsmath")
# (find-amsmathpage 30 "\\overset")
# (find-amsmathtext 30 "\\overset")
# (find-amsmathpage 30 "\\underset")
# (find-amsmathtext 30 "\\underset")






#####
#
# AMS-LaTeX
# 2016may27
#
#####

# «amslatex» (to ".amslatex")
# (find-angg ".emacs" "find-amsmathpage")
# (find-angg ".emacs.papers" "amsldoc")

# (find-kopkadaly4page 270 "Chapter 12. Math Extensions with AMS-LATEX")
# (find-kopkadaly4text 270 "Chapter 12. Math Extensions with AMS-LATEX")

# (find-sh "locate ams | grep tex")
# (find-sh "locate amsmath")
# (find-zsh "dmissing amsmath")
# (find-zsh "dmissing ams | grep tex")
# (find-zsh "dmissing ams | grep tex | grep dtx")

# https://www.ctan.org/pkg/latex-base
# https://www.ctan.org/pkg/required
# https://www.ctan.org/pkg/amslatex
# http://mirrors.ctan.org/macros/latex/required/amsmath.zip
# http://mirrors.ctan.org/macros/latex/required/amslatex.zip

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/amslatex/")
rm -Rv ~/usrc/amslatex/
mkdir  ~/usrc/amslatex/
cd     ~/usrc/
unzip $S/http/mirrors.ctan.org/macros/latex/required/amslatex.zip
cd     ~/usrc/amslatex/

(code-c-d "amslatex" "~/usrc/amslatex/")
;; (find-amslatexfile "")



#####
#
# multicol
# 2019jul02
#
#####

# «multicol» (to ".multicol")
# (find-tlsh "find * | sort | grep multicol")
# https://ctan.org/pkg/multicol?lang=en
# (find-LATEX "2019ilha-grande-poster.tex" "columnsep")
# (find-LATEXgrep "grep --color=auto -nH --null -e 'usepackage{multicol}' *.tex")

;; (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/multicol.pdf")
;; (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/multicol.pdf")
(code-pdf-page "multicol" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/multicol.pdf")
(code-pdf-text "multicol" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/multicol.pdf")
;; (find-multicolpage)
;; (find-multicoltext)
# (find-multicolpage 2 "\\begin{multicols}{")
# (find-multicoltext 2 "\\begin{multicols}{")
# (find-multicolpage 4 "\\raggedcolumns")
# (find-multicoltext 4 "\\raggedcolumns")
# (find-multicolpage 5 "multicols*")
# (find-multicoltext 5 "multicols*")
# (find-multicolpage 7 "\\usepackage{multicol}")
# (find-multicoltext 7 "\\usepackage{multicol}")
# (find-multicolpage 8 "\\setlength{\\columnsep}{1.5pc}")
# (find-multicoltext 8 "\\setlength{\\columnsep}{1.5pc}")
# (find-multicolpage 8 "\\setlength\\columnseprule{.4pt}")
# (find-multicoltext 8 "\\setlength\\columnseprule{.4pt}")
# (find-multicolpage 17 "\\def\\columnseprulecolor{\\normalcolor}")
# (find-multicoltext 17 "\\def\\columnseprulecolor{\\normalcolor}")

https://stackoverflow.com/questions/1491717/how-to-display-a-content-in-two-column-layout-in-latex
https://www.reddit.com/r/LaTeX/comments/h0l3zg/how_to_use_properly_minipage_in_a_2_column/



#####
#
# \firstcol and \anothercol, for a poor man's single-page multicol
# 2021oct28
#
#####

# «firstcol-anothercol»  (to ".firstcol-anothercol")
# (find-LATEX "edrx21defs.tex" "firstcol-anothercol")
# (find-angg ".emacs" "cols")

\long\def\firstcol  #1{\begin{minipage}[t]{8cm} #1 \end{minipage}}
\long\def\anothercol#1{\qquad\firstcol{#1}}
\scalebox{0.8}{\firstcol{

\lipsum[2-3]

}\anothercol{

\lipsum[4-5]

}}





#####
#
# multicolumn
# 2016jun08
#
#####

# «multicolumn» (to ".multicolumn")
# (find-kopkadaly4page (+ 12 97) "\\multicolumn{num}{col}{text}")
# (find-kopkadaly4text (+ 12 97) "\\multicolumn{num}{col}{text}")
# (find-source2epage (+ 8 248) "\\multicolumn")
# (find-source2etext (+ 8 248) "\\multicolumn")
# (find-source2epage (+ 8 251) "\\multicolumn")
# (find-source2etext (+ 8 251) "\\multicolumn")

$\begin{array}{ccccccc}
 a & b & c & d & e & f & g \\
 a & b & c & d & e & f & g \\
 a & b & c & \multicolumn{2}{c}{de} & f & g \\
 a & b & c & d & e & f & g \\
 \end{array}
$




#####
#
# multirow
# 2020mar18
#
#####

# «multirow» (to ".multirow")
;; (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/multirow/")
;; (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/multirow/README")
;; (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/multirow/multirow.pdf")
;; (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/multirow/multirow.pdf")
(code-c-d      "multirow" "/usr/local/texlive/2019/texmf-dist/doc/latex/multirow/")
(code-pdf-page "multirow" "/usr/local/texlive/2019/texmf-dist/doc/latex/multirow/multirow.pdf")
(code-pdf-text "multirow" "/usr/local/texlive/2019/texmf-dist/doc/latex/multirow/multirow.pdf")
;; (find-multirowfile "")
;; (find-multirowpage)
;; (find-multirowtext)




#####
#
# \hss, \vss, \hfil, \hfill, \vfil, \vfill
# 2016oct16
#
#####

# «hss» (to ".hss")
# (find-texbookpage (+ 11 69) "12 Glue")
# (find-texbooktext (+ 11 69) "12 Glue")
# (find-source2efile "")
# (find-fline "~/usrc/luatex/beta-0.90.0/manual/")

# Are \hss and \vss primitives?
# Yes:
# (find-luatexrefpage (+ 4 127) "4.14.12.2 tex.extraprimitives")
# (find-luatexreftext (+ 4 127) "4.14.12.2 tex.extraprimitives")
# (find-luatexrefpage (+ 4 128) "hss")
# (find-luatexreftext (+ 4 128) "hss")




#####
#
# fmtutil
# 2017mar23
#
#####

# «fmtutil» (to ".fmtutil")
# (find-es "luatex" "luatex-0.95.0-fmtutil-email")
# (find-es "luatex" "luatex-0.95.0-fmtutil-email" "fmtutil --byengine luatex")
# (find-es "luatex" "luatex-0.95.0-fmtutil-email" "sudo mv -iv /usr/bin/luatex")
# (find-sh "locate fmtutil")
# (find-fline "~/.texmf-var/web2c/luatex/")

# (find-fline "/usr/bin/fmtutil")
# (find-fline "/usr/bin/fmtutil-sys")
# (find-fline "/usr/sbin/update-fmtutil")
# (find-man "1 fmtutil-sys")
# (find-man "1 fmtutil")
# (find-man "1 fmtutil" "--byengine enginename")
# (find-man "5 fmtutil.cnf")
# (find-man "8 update-fmtutil")
# (find-fline "/usr/share/texlive/debian/debianize-fmtutil")
# (find-fline "/usr/share/texlive/texmf-dist/scripts/texlive/fmtutil-sys.sh")
# (find-fline "/usr/share/texlive/texmf-dist/scripts/texlive/fmtutil.sh")
# (find-fline "/usr/share/texlive/texmf-dist/web2c/fmtutil-hdr.cnf")
# (find-fline "/var/lib/tex-common/fmtutil-cnf/texlive-base.list")
# (find-fline "/var/lib/tex-common/fmtutil-cnf/texlive-latex-base.list")
# (find-fline "/var/lib/tex-common/fmtutil-cnf/texlive-math-extra.list")
# (find-fline "/var/lib/texmf/web2c/fmtutil.cnf")
# (find-fline "/var/lib/texmf/web2c/fmtutil.cnf" "update-fmtutil")
# (find-fline "/etc/texmf/fmt.d/")

# (find-sh "apt-file find luatex")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/.texmf-var/web2c/luatex/")
laf   ~/.texmf-var/web2c/luatex/
rm -v ~/.texmf-var/web2c/luatex/*.fmt
rm -v ~/.texmf-var/web2c/luatex/*.log
fmtutil --byengine luatex   |& tee /tmp/o
grep 'fmtutil:' /tmp/o
laf   ~/.texmf-var/web2c/luatex/




#####
#
# Parsing a .aux file
# 2017abr14
#
#####

# «parse-aux-file» (to ".parse-aux-file")
# (find-LATEXfile               "2017planar-has.aux")
# (find-LATEXsh "grep toc        2017planar-has.aux")
# (find-LATEXsh "grep   newlabel 2017planar-has.aux")
# (find-LATEXsh "grep ^.newlabel 2017planar-has.aux")
# (find-LATEXsh "grep ^.newlabel 2017planar-has.aux | grep -v section")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
foo = getoutput "grep ^.newlabel ~/LATEX/2017planar-has.aux"
= foo
mysub = function (str) return str:sub(2, -2) end
for tag,rest in foo:gmatch "newlabel(%b{})(%b{})" do
  n,p,title,secn,emp = rest:match "{(%b{})(%b{})(%b{})(%b{})(%b{})}"
  if secn:match"section" then
    printf("(phap %2d %q)\n",   mysub(p), mysub(tag))
    printf("(pha     %q %q)\n",           mysub(tag), "phap")
  end
end


# «parse-aux-file-sajl» (to ".parse-aux-file-sajl")
# (setq last-kbd-macro (kbd "C-a C-SPC C-e M-w <down> M-2 M-e C-a % SPC C-y RET M-o"))

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
foo = getoutput "grep ^.newlabel ~/LATEX/2017planar-has-sajl.aux"
= foo
mysub = function (str) return str:sub(2, -2) end
for tag,rest in foo:gmatch "newlabel(%b{})(%b{})" do
  -- n,p,title,secn,emp = rest:match "{(%b{})(%b{})(%b{})(%b{})(%b{})}"
  n,p,title,secn,emp = rest:match "{(%b{})(%b{})}"
  -- print(tag, n, p)
  if n then
    printf("(phsp %2d %q)\n",   mysub(p), mysub(tag))
    printf("(phs     %q %q)\n",           mysub(tag), "phsp")
  end
end





#####
#
# \pagebreak and \linebreak
# 2017abr25
#
#####

# «pagebreak» (to ".pagebreak")
# (find-kopkadaly4page (+ 12 31) "\\linebreak[num]")
# (find-kopkadaly4text (+ 12 31) "\\linebreak[num]")
# (find-kopkadaly4page (+ 12 33) "\\pagebreak[num]")
# (find-kopkadaly4text (+ 12 33) "\\pagebreak[num]")
# (find-lshortpage (+ 14 17) "\\linebreak[n]")
# (find-lshorttext (+ 14 17) "\\linebreak[n]")




#####
#
# \thispagestyle
# 2017mai05
#
#####

# «thispagestyle» (to ".thispagestyle")
# (find-LATEX "edrxheadfoot.tex")
# (find-kopkadaly4page (+ 12  43) "\\thispagestyle{empty}")
# (find-kopkadaly4text (+ 12  43) "\\thispagestyle{empty}")
# (find-kopkadaly4page (+ 12 335) "\\thispagestyle")
# (find-kopkadaly4text (+ 12 335) "\\thispagestyle")
# (find-source2epage (+ 10 398) "\\thispagestyle")
# (find-source2etext (+ 10 398) "\\thispagestyle")



#####
#
# fancyvrb
# 2024apr28
#
#####

# «fancyvrb»  (to ".fancyvrb")
# (find-es "pygments" "fancyvrb")
# (find-sh "locate fancyvrb")
# (find-tlfile "texmf-dist/doc/latex/fancyvrb/")
# (find-tlfile "texmf-dist/doc/latex/fancyvrb/README")
# (code-pdf-page "fancyvrb" "/usr/local/texlive/2019/texmf-dist/doc/latex/fancyvrb/fancyvrb-doc.pdf")
# (code-pdf-text "fancyvrb" "/usr/local/texlive/2019/texmf-dist/doc/latex/fancyvrb/fancyvrb-doc.pdf")
# (find-fancyvrbpage)
# (find-fancyvrbtext)
# (find-fancyvrbpage 5 "\\begin{Verbatim}")
# (find-fancyvrbtext 5 "\\begin{Verbatim}")






#####
#
# fancyhdr
# 2023may25
#
#####

# «fancyhdr»        (to ".fancyhdr")
# «fancyhdr-Show2»  (to ".fancyhdr-Show2")
# (find-kopkadaly4page (+ 12 43) "fancyhdr")
# (find-kopkadaly4text (+ 12 43) "fancyhdr")
# (find-sh "locate fancyhdr")
# (code-pdf-page "fancyhdr" "/usr/local/texlive/2019/texmf-dist/doc/latex/fancyhdr/fancyhdr.pdf")
# (code-pdf-text "fancyhdr" "/usr/local/texlive/2019/texmf-dist/doc/latex/fancyhdr/fancyhdr.pdf")
# (find-fancyhdrpage)
# (find-fancyhdrtext)
# (find-fancyhdrpage 7 "\\thepage")
# (find-fancyhdrtext 7 "\\thepage")
# (find-fancyhdrpage 8 "page layout")
# (find-fancyhdrtext 8 "page layout")
# (find-fancyhdrpage 11 "\\renewcommand{\\headrulewidth}{0pt}")
# (find-fancyhdrtext 11 "\\renewcommand{\\headrulewidth}{0pt}")

 (find-angg "LUA/Show2.lua" "texbody")
 (find-code-show2 "~/LATEX/Show2.tex")
       (code-show2 "~/LATEX/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()
geometry = "paperwidth=148mm, paperheight=88mm, top=2cm"
geometry = geometryhead

outertexbody = Dang.from [=[
%\documentclass[twoside]{article}
\documentclass{article}
\usepackage[<<geometry>>]{geometry}
\usepackage{lipsum}
\usepackage{fancyhdr}
<<usepackages>>
<<defrepl>>
\begin{document}
\pagestyle{headings}
\pagestyle{fancy}
<<defs>>
<<texbody>>
<<repl>>
<<saysuccess>>
\end{document}
]=]

texbody = [[
\section{SA}
\lipsum[3-9]
\section{SB}
\lipsum[3-9]
\section{SC}
\lipsum[3-9]
\condrepl
]]

-- usepackages = nil
-- usepackages = [[ \usepackage{fancyhdr} ]]

= show()
= Show.log
= Show.bigstr
 (etv)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/ && REPL=1 lualatex Show2.tex
printmeaning "newpage"
printmeaning "@oddhead"
printmeaning "@evenhead"
printmeaning "leftmark"
printmeaning "@leftmark"
printmeaning "rightmark"
printmeaning "@rightmark"





#####
#
# edrxheadfoot.tex
# 2020sep14
#
#####

# «edrxheadfoot.tex»  (to ".edrxheadfoot.tex")
# (find-LATEX "edrxheadfoot.tex")

% Alternative:

\def\drafturl{http://angg.twu.net/LATEX/2020-1-C2.pdf}
\def\drafturl{http://angg.twu.net/2020.1-C2.html}
\def\draftfooter{\tiny \href{\drafturl}{\jobname{}} \ColorBrown{\shorttoday{} \hours}}




#####
#
# edrxheadfoot.tex: testing with Show2.lua
# 2023may24
#
#####

# «edrxheadfoot-Show2»  (to ".edrxheadfoot-Show2")
# (to "debug-chapter")
# (find-LATEX "2023headfoot.lua")
# (find-LATEX "edrxheadfoot.tex")
# (find-angg "LUA/Show2.lua" "texbody")
# (find-angg "LUA/tikz1.lua" "repl2")

 (find-code-show2 "~/LATEX/Show2.tex")
       (code-show2 "~/LATEX/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()

outertexbody = Dang.from [=[
\documentclass{book}
\usepackage{lipsum}
\usepackage[<<geometry>>]{geometry}
<<defrepl>>
\begin{document}
\pagestyle{empty}
<<texbody>>
<<saysuccess>>
\end{document}
]=]

texbody = [[
\section{SA}
\lipsum[3-9]
\section{SB}
\lipsum[3-9]
\section{SC}
\lipsum[3-9]
\condrepl
]]
= show()
= Show.log
= Show.bigstr
 (etv)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/ && REPL=1 lualatex Show2.tex
printmeaning "newpage"
printmeaning "@oddfoot"

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/ && REPL=1 lualatex Show2.tex
printmeaning "newpage"
printmeaning "@oddfoot"
printmeaning  "footertext"
printmeaning   "draftfooter"
printmeaning "@evenfoot"
printmeaning "@oddhead"
printmeaning "@evenhead"


  \def\@oddfoot{\hfil \footertext \hfil}
  \let\@evenfoot\@oddfoot
  \def\@oddhead{{\slshape\rightmark}\hfil\thepage}%
  \let\@mkboth\markboth

-- (find-TH "eev-tikz" "another-repl")

(find-angg "LUA/tikz1.lua" "repl")
(find-angg "LUA/tikz1.lua" "repl2")
(find-angg "LUA/tikz1.lua" "repl-tests")
(find-angg "LUA/Repl2.lua" "Repl2")
(find-angg "LUA/Repl2.lua" "Repl2-tests")
(find-angg "LUA/Repl2.lua" "getmeaning-tests")
(find-angg "LUA/Repl2.lua" "texrun-tests")


 (etv)



#####
#
# poster
# 2017mai08
#
#####

# «beamerposter» (to ".beamerposter")
# «sciposter» (to ".sciposter")

# (find-sh "apt-file find poster")
# (find-sh "apt-file find poster | grep texlive")
# (find-sh "apt-file find sciposter | grep texlive")
# (find-sh "apt-file find beamerposter | grep texlive")
# (find-fline "/usr/share/doc/texlive-doc/latex/sciposter/")
# (find-fline "/usr/share/doc/texlive-doc/latex/beamerposter/")




#####
#
# template-sajl
# 2017mai09
#
#####

# «template-sajl» (to ".template-sajl")
# (find-fline "~/tmp/template-sajl.zip")
# https://mail.google.com/mail/ca/u/0/#search/coniglio/15b0fef801ce4301 versao 1
# https://mail.google.com/mail/ca/u/0/#search/marcelo/15b0fef801ce4301 versao 2

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/sajl/")
rm -Rv /tmp/sajl/
mkdir  /tmp/sajl/
cd     /tmp/sajl/
unzip ~/tmp/template-sajl.zip

# (find-fline "~/LATEX/sajl/")
rm -Rv ~/LATEX/sajl/
mkdir  ~/LATEX/sajl/
cd     ~/LATEX/sajl/
unzip ~/tmp/template-sajl.zip

# (code-c-d "sajl" "/tmp/sajl/")
# (code-c-d "sajl" "~/LATEX/sajl/")
# (find-sajlfile "")
# (find-sajlfile "template-sajl.tex")
# (find-sajlfile "template-sajl.tex" "thebibliography")
# (find-LATEXfile "2017planar-has.bbl")
# (find-LATEXfile "2017planar-has.tex" "bibliographystyle")
# (find-kopkadaly4page (+ 12 310) "\\bibliographystyle{style}")
# (find-kopkadaly4text (+ 12 310) "\\bibliographystyle{style}")

# 2017jul25:
 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/sajl/")
rm -Rv /tmp/sajl/
mkdir  /tmp/sajl/
cd     /tmp/sajl/
rm -Rv /tmp/sajl-new/
mkdir  /tmp/sajl-new/
cd     /tmp/sajl-new/
unzip ~/tmp/template-sajl_2017jul18.zip
tkdiff /tmp/sajl/sajl.cls /tmp/sajl-new/sajl.cls






#####
#
# \newtheorem
# 2017jun17
#
#####

# «newtheorem» (to ".newtheorem")
# (find-LATEX "2020clops-and-tops.tex" "theorem")
# (find-kopkadaly4page (+ 12 80) "\\newtheorem")
# (find-kopkadaly4text (+ 12 80) "\\newtheorem")
# (find-kopkadaly4page (+ 12 181) "8.1       Counters")
# (find-kopkadaly4text (+ 12 181) "8.1       Counters")
# (find-kopkadaly4page (+ 12 280) "12.3.1 Extended theorem declarations")
# (find-kopkadaly4text (+ 12 280) "12.3.1 Extended theorem declarations")
# (find-kopkadaly4page (+ 12 281) "\\theoremstyle")
# (find-kopkadaly4text (+ 12 281) "\\theoremstyle")
# (find-lshortpage (+ 14 61) "3.9 Theorems, Lemmas, ...")
# (find-lshorttext (+ 14 61) "3.9 Theorems, Lemmas, ...")
# (find-lshortpage (+ 14 61) "\\begin{name}[text]")
# (find-lshorttext (+ 14 61) "\\begin{name}[text]")
# (find-source2epage (+ 11 690) "Index")
# (find-source2etext (+ 11 690) "Index")
# (find-source2epage (+ 11 436) "\\newtheorem")
# (find-source2etext (+ 11 436) "\\newtheorem")

\documentclass[oneside,12pt,a5paper]{article}
\begin{document}


\end{document}





#####
#
# The "theorem" package
# 2020nov17
#
#####

# «theorem»  (to ".theorem")
# (find-sh "locate theorem | grep tools")
# (code-pdf-page "theorem" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/theorem.pdf")
# (code-pdf-text "theorem" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/theorem.pdf")
# (find-theorempage)
# (find-theoremtext)



#####
#
# The "amsthm" package
# 2020nov17
#
#####

# «amsthm»  (to ".amsthm")
# (find-sh "locate amsthm | grep 2019")
# (find-sh "locate amscls | grep 2019")
# (code-pdf-page "amsthm" "/usr/local/texlive/2019/texmf-dist/doc/latex/amscls/amsthdoc.pdf")
# (code-pdf-text "amsthm" "/usr/local/texlive/2019/texmf-dist/doc/latex/amscls/amsthdoc.pdf")
# (find-amsthmpage)
# (find-amsthmtext)





#####
#
# lastpage
# 2017jun17
#
#####

# «lastpage» (to ".lastpage")
# (find-tlsh "find * | sort | grep lastpage")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/lastpage/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/lastpage/lastpage.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/lastpage/lastpage.pdf")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/lastpage/lastpage-example.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/lastpage/lastpage-example.pdf")

# (find-fline "/usr/share/doc/texlive-doc/latex/lastpage/")
# (find-fline "/usr/share/doc/texlive-doc/latex/lastpage/README.gz")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/lastpage/lastpage-example.pdf")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/lastpage/lastpage.pdf")
# (find-sh "locate lastpage")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/lastpage/")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/lastpage/lastpage.sty")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/lastpage/lastpage.sty" "AED:")





#####
#
# 12pt
# 2017jun24
#
#####

# «12pt» (to ".12pt")
# (find-angg ".emacs" "latexbase")
# https://tex.stackexchange.com/questions/5339/how-to-specify-font-size-less-than-10pt-or-more-than-12pt
# https://tex.stackexchange.com/questions/4139/how-to-change-font-size-mid-document
# https://texblog.org/2012/08/29/changing-the-font-size-in-latex/
# https://en.wikibooks.org/wiki/LaTeX/Text_Formatting#Sizing_text

# (find-classespage 2 "12pt")
# (find-classestext 2 "12pt")
# (find-latexbasefile "article.cls")
# (find-latexbasefile "size12.clo")
# (find-classespage 6 "\\@setfontsize")
# (find-classestext 6 "\\@setfontsize")


# (find-status   "texlive-latex-base")
# (find-vldifile "texlive-latex-base.list")
# (find-udfile   "texlive-latex-base/")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/base/")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/base/" "article.cls")
# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/base/" "size12.clo")
# (find-tlfile "")
# (find-tlsh "find * | sort")
# (find-tlsh "find * | sort | grep -e /article.")



# (find-LATEXfile "sajl.cls" "\\LoadClass[12pt]{article}")





#####
#
# \label
# 2017ago15
#
#####

# «label» (to ".label")
# (find-kopkadaly4page (+ 12 56) "\\label{name}" "\\ref{name}")
# (find-kopkadaly4text (+ 12 56) "\\label{name}" "\\ref{name}")
# (find-kopkadaly4page (+ 12 213) "9.2.1   Cross-references")
# (find-kopkadaly4text (+ 12 213) "9.2.1   Cross-references")

# (find-source2epage (+ 11 690) "Index")
# (find-source2etext (+ 11 690) "Index")
# (find-source2epage (+ 11 728) "  \\label")
# (find-source2etext (+ 11 728) "  \\label")
# (find-source2epage (+ 11 735) "  \\pageref")
# (find-source2etext (+ 11 735) "  \\pageref")
# (find-source2epage (+ 11 737) "  \\ref")
# (find-source2etext (+ 11 737) "  \\ref")

# (find-source2epage (+ 11 331) "  \\label")
# (find-source2etext (+ 11 331) "  \\label")
# (find-source2epage (+ 11 332) "\\refstepcounter")
# (find-source2etext (+ 11 332) "\\refstepcounter")

# (find-source2epage (+ 8 198) "File x" "ltxref.dtx")
# (find-source2etext (+ 8 198) "File x" "ltxref.dtx")
# (find-source2epage (+ 8 198) "\\label")
# (find-source2etext (+ 8 198) "\\label")
# \@currentlabel



# (find-source2etext (+ 8 240) "")





#####
#
# texlive-2016 and texlive-2017: index to the most important e-scripts
# 2017jun24
#
#####

# «texlive-2016» (to ".texlive-2016")
# (find-es "luatex" "texlive-2016")
# (find-es "luatex" "texlive-2017")

# https://www.tug.org/texlive/doc/texlive-en/texlive-en.html#tlportable
# https://www.preining.info/blog/2017/06/tex-live-2017-released/
# http://tug.org/texlive/tlmgr.html
# http://tug.org/pipermail/tex-live/2017-June/thread.html
# https://www.preining.info/talks/bachotex2017-sys-user.pdf




#####
#
# Notes on the texlive installer
# 2019aug03
#
#####

# «texlive-install» (to ".texlive-install")
# (find-efunction 'find-texlive-links)

# (find-texlive-links "20190802")
# (find-texlive-links "20190803")

 (eepitch-shell2)
 (eepitch-kill)
 (eepitch-shell2)
rm -Rfv ~/usrc/install-tl-20190803/
mkdir   ~/usrc/
tar  -C ~/usrc/ -xvzf   $S/http/mirror.ctan.org/systems/texlive/tlnet/install-tl-unx.tar.gz
cd      ~/usrc/install-tl-20190803/
sudo ./install-tl

cd      ~/usrc/install-tl-20190803/
install-tl --profile installation.profile

# (code-c-d "tlinstall" "~/usrc/install-tl-20190802/")
# (find-tlinstallfile "")
# https://www.tug.org/texlive/doc/install-tl.html

# (find-tlinstallsh "find")


Installing [0126/3831, time/total: 13:32/07:00:07]: apprendre-a-programmer-en-tex [31139k]
Installing [0127/3831, time/total: 15:09/05:56:34]: apprends-latex [2432k]
TLPDB::_install_package: downloading did not succeed
Installation failed.
Rerunning the installer will try to restart the installation.
Or you can restart by running the installer with:
  install-tl --profile installation.profile [EXTRA-ARGS]
./install-tl: Writing log in current directory: /home/edrx/usrc/install-tl-20190802/install-tl.log

# (find-asrootfile "/tmp/ZHXD4c1Y00/vNWnt5fQwG")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
sudo find /tmp/ZHXD4c1Y00





#####
#
# install-tl: the installation script for texlive
# 2019aug08
#
#####

# «install-tl» (to ".install-tl")
# (find-es "texlive" "install-tl")
# (find-texlive-links "20190807")
# (find-efunction 'find-texlive-links)






#####
#
# \displaystyle - that I usually abbreviate as \D
# 2017set10
#
#####

# «displaystyle» (to ".displaystyle")
# (find-texbookpage (+ 12 141) "\\displaystyle")
# (find-texbooktext (+ 12 141) "\\displaystyle")
# (find-texbookpage (+ 12 185) "Displayed Equations")
# (find-texbooktext (+ 12 185) "Displayed Equations")
# (find-LATEXfile "edrx21defs.tex" "\\D" "\\displaystyle")




#####
#
# Page numbers
# 2017set19
#
#####

# «page-numbers» (to ".page-numbers")
# (find-kopkadaly4page (+ 12 43) "\\thispagestyle{style}")
# (find-kopkadaly4text (+ 12 43) "\\thispagestyle{style}")
# (find-kopkadaly4page (+ 12 45) "3.2.3   Page numbering")
# (find-kopkadaly4text (+ 12 45) "3.2.3   Page numbering")
# (find-source2epage (+ 8 310) "ltpage.dtx" "65     Page styles and related commands")
# (find-source2etext (+ 8 310) "ltpage.dtx" "65     Page styles and related commands")
# (find-texbookpage (+ 12 21) "current page number" "\\count0")
# (find-texbooktext (+ 12 21) "current page number" "\\count0")




#####
#
# \mapsto, \mapsot, \mapfrom
# 2017set23
#
#####

# «mapsto» (to ".mapsto")
# (find-source2epage (+ 8 175) "42       The fontmath.ltx file")
# (find-source2etext (+ 8 175) "42       The fontmath.ltx file")
# (find-source2epage (+ 8 182) "\\def\\mapsto")
# (find-source2etext (+ 8 182) "\\def\\mapsto")
# (find-LATEXfile "edrx17defs.tex" "\\def\\mapsot")
# (find-stmaryrdpage 2 "\\mapsfrom")
# (find-stmaryrdtext 2 "\\mapsfrom")
# (find-stmaryrdpage 3 "\\mapsfromchar")
# (find-stmaryrdtext 3 "\\mapsfromchar")




#####
#
# \documentclass
# 2018jan21
#
#####

# «documentclass» (to ".documentclass")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-LATEXfile "2017yoneda.tex" "documentclass")
# (find-kopkadaly4page (+ 12 37)  "3.1 Document class")
# (find-kopkadaly4page (+ 12 39) "notitlepage")
# (find-kopkadaly4text (+ 12 39) "notitlepage")

# (find-LATEXfile "sajl.cls" "\\ProvidesClass{sajl}")

# (find-zsh "locate latex | grep class")
# https://tex.stackexchange.com/questions/782/what-are-the-available-documentclass-types-and-their-uses
# https://texblog.org/2013/02/13/latex-documentclass-options-illustrated/




#####
#
# \usepackage
# 2018jan22
#
#####

# «usepackage» (to ".usepackage")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page (+ 12 12) "\\usepackage in the preamble")
# (find-kopkadaly4text (+ 12 12) "\\usepackage in the preamble")
# (find-kopkadaly4page (+ 12 41) "\\usepackage{package}")
# (find-kopkadaly4text (+ 12 41) "\\usepackage{package}")





#####
#
# Understanding what \begin{document} and \end{document} do
# 2019dec24
#
#####

# «document» (to ".document")
# (find-source2epage (+ 10 63) "\\@nodocument")
# (find-source2etext (+ 10 63) "\\@nodocument")
# (find-source2epage (+ 10 64) "\\@notprerr")
# (find-source2etext (+ 10 64) "\\@notprerr")
# (find-source2epage (+ 10 83) "\\begin{document}")
# (find-source2etext (+ 10 83) "\\begin{document}")
# (find-source2epage (+ 10 85) "\\document")
# (find-source2etext (+ 10 85) "\\document")
# (find-source2epage (+ 10 92) "\\listfiles")
# (find-source2etext (+ 10 92) "\\listfiles")
# (find-source2epage (+ 10 267) "\\enddocument ==")
# (find-source2etext (+ 10 267) "\\enddocument ==")
# (find-source2epage (+ 10 267) "\\@@end")
# (find-source2etext (+ 10 267) "\\@@end")
# (find-source2epage (+ 10 267) "\\stop")
# (find-source2etext (+ 10 267) "\\stop")
# (find-texbookpage (+ 12 299) "forced to quit prematurely")
# (find-texbooktext (+ 12 299) "forced to quit prematurely")
# (find-texbookpage (+ 12 264) "When TEX sees an \\end command")
# (find-texbooktext (+ 12 264) "When TEX sees an \\end command")




#####
#
# Abstract
# 2018jan22
#
#####

# «abstract» (to ".abstract")
# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page (+ 12 55) "3.3.2   Abstract")
# (find-kopkadaly4text (+ 12 55) "3.3.2   Abstract")
# (find-classespage 37 "7.4.1   Abstract")
# (find-classestext 37 "7.4.1   Abstract")




#####
#
# catcodes
# 2018jan31
#
#####

# «catcode» (to ".catcode")
# (find-LATEX "edrxchars.tex")
# (find-angg ".emacs.papers" "texbook")
# (find-texbookpage (+ 12  37) "13" "Active character")
# (find-texbooktext (+ 12  37) "13" "Active character")
# (find-texbookpage (+ 12  39) "The format in Appendix B begins with \\catcode")
# (find-texbooktext (+ 12  39) "The format in Appendix B begins with \\catcode")
# (find-texbookpage (+ 12 343) "\\catcode`\\{=1")
# (find-texbooktext (+ 12 343) "\\catcode`\\{=1")

# (find-source2epage (+ 11 51) "\\makeatletter")
# (find-source2etext (+ 11 51) "\\makeatletter")
# (find-source2epage (+ 11 690) "Index")
# (find-source2etext (+ 11 690) "Index")
# (find-source2epage (+ 11 730) "\\makeatletter")
# (find-source2etext (+ 11 730) "\\makeatletter")



#####
#
# \varepsilon
# 2018mar08
#
#####

# «varepsilon» (to ".varepsilon")
# (find-texbookpage (+ 12 128) "\\varepsilon")
# (find-texbooktext (+ 12 128) "\\varepsilon")
# (find-texbookpage (+ 12 434) "\\varepsilon")
# (find-texbooktext (+ 12 434) "\\varepsilon")



#####
#
# varphi
# 2020may21
#
#####

# «varphi» (to ".varphi")
# (find-texbookpage (+ 12 128) "\\varphi,\\vartheta,\\varepsilon,\\varrho")
# (find-texbooktext (+ 12 128) "\\varphi,\\vartheta,\\varepsilon,\\varrho")
# (find-texbookpage (+ 12 434) "\\varphi")
# (find-texbooktext (+ 12 434) "\\varphi")






#####
#
# \section and friends
# 2018mar12
#
#####

# «section» (to ".section")
# (find-es "luatex" "show-section")
# (find-kopkadaly4page (+ 12 52) "3.3     Parts of the document")
# (find-kopkadaly4text (+ 12 52) "3.3     Parts of the document")
# (find-kopkadaly4page (+ 12 55) "3.3.3   Sections")
# (find-kopkadaly4text (+ 12 55) "3.3.3   Sections")
# (find-kopkadaly4page (+ 12 57) "\\setcounter{chapter}{2}")
# (find-kopkadaly4text (+ 12 57) "\\setcounter{chapter}{2}")
# (find-source2epage (+ 8 281) "Sectioning Commands")
# (find-source2etext (+ 8 281) "Sectioning Commands")
# (find-source2epage (+ 8 282) "\\@startsection")
# (find-source2etext (+ 8 282) "\\@startsection")
# (find-classespage 21 "7.2       Chapters and Sections")
# (find-classestext 21 "7.2       Chapters and Sections")
# (find-classespage 28 "7.2.7    Lower level headings")
# (find-classestext 28 "7.2.7    Lower level headings")
# (find-tlfile "texmf-dist/tex/latex/base/article.cls")
# (find-tlfile "texmf-dist/tex/latex/base/article.sty")
# (find-tlfile "texmf-dist/tex/latex/base/article.cls" "\\@startsection")

# (find-LATEX "2018-1-GA-material.tex" "Psection")

# (find-LATEXfile "2017-2-C2-material.toc")




#####
#
# Several styles of "\tocline"s
# 2024mar16
#
#####

# «tocline»  (to ".tocline")
# (find-LATEXgrep "grep --color=auto -nH --null -e tocline *")
# (find-LATEXgrep "grep --color=auto -nH --null -e myslide *")
# (find-LATEXfile "edrx17defs.tex" "\\def\\myslide")
# (find-LATEX "2022-2-C2-C3-ajuda.tex" "defs-toc")
# (find-LATEX "2022-2-C2-C3-ajuda.tex" "defs-toclines")
# (find-LATEX "2024-1-C3-intro.tex" "defs-toclines2")
# (find-angg "LUA/TocLines1.lua")
# (find-angg "LUA/TocLines2.lua")

\def\myslide#1#2{{\bf #1}}
\def\tocline#1#2{\par #1 \dotfill #2}



#####
#
# TocLines2
# 2024mar17
#
#####

# «TocLines2»  (to ".TocLines2")
# (find-LATEX "2024-1-C3-intro.tex" "defs-toclines2")
# (find-angg "LUA/TocLines2.lua")




#####
#
# \@dottedtocline
# 2018abr21
#
#####

# «dottedtocline» (to ".dottedtocline")
# (find-LATEX "2017yoneda.tex" "index-of-sections")
# (find-source2epage (+ 8 288) "\\@dottedtocline")
# (find-source2etext (+ 8 288) "\\@dottedtocline")
# (find-source2epage (+ 8 289) "\\def\\@dottedtocline")
# (find-source2etext (+ 8 289) "\\def\\@dottedtocline")
# (find-LATEXgrep "grep --color=auto -nH --null -e @dottedtocline *.tex")

% \newpage
% 
% Index of sections:
% 
% {\makeatletter
% \renewcommand*\l@section{\@dottedtocline{1}{1.5em}{2.3em}}
% \@starttoc{toc}
% }
% 
% \bsk





#####
#
# \hyperlink{page.2}{This points to page 2}
# 2023may29
#
#####

# «linktopage»          (to ".linktopage")
# «hyperref-hyperlink»  (to ".hyperref-hyperlink")
# (find-LATEX "2022-2-C2-C3-ajuda.tex" "defs-toc")
# (find-LATEX "2022-2-C2-C3-ajuda.tex" "toc")
# (find-hyperrefmanualpage 18 "\\hyperlink{name}{text}")
# (find-hyperrefmanualtext 18 "\\hyperlink{name}{text}")

\def\linktopage#1#2{\hyperlink{page.#1}{#2}}

 (show2-use "/tmp/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()
usepackages.hyperref = true
body = [[
  \def\linktopage#1#2{\hyperlink{page.#1}{#2}}
  \def\To#1{\linktopage{#1}{Link to page #1}}
  Page 1 (\To 2)
  \newpage
  Page 2 (\To 3)
  \newpage
  Page 3 (\To 1)
]]
= body:show()
 (etv)





#####
#
# \eqalign
# 2018abr24
#
#####

# «eqalign» (to ".eqalign")
# https://tex.stackexchange.com/questions/103062/problems-with-eqalign
# (find-texbookpage (+ 12 190) "\\eqalign")
# (find-texbooktext (+ 12 190) "\\eqalign")
# (find-texbookpage (+ 12 192) "\\eqalignno{")
# (find-texbooktext (+ 12 192) "\\eqalignno{")
# (find-kopkadaly4page (+ 12 271) "\\notag")
# (find-kopkadaly4text (+ 12 271) "\\notag")
# (find-kopkadaly4page (+ 12 271) "\\tag{mark}")
# (find-kopkadaly4text (+ 12 271) "\\tag{mark}")
# (find-kopkadaly4page (+ 12 275) "\\begin{align}" "\\notag")
# (find-kopkadaly4text (+ 12 275) "\\begin{align}" "\\notag")

# (find-sh "locate amsmath")
# (find-tlfile "texmf-dist/doc/latex/amsmath/")
# (find-tlfile "texmf-dist/doc/latex/amsmath/amsldoc.tex" "\\cn{tag}")
# (find-tlfile "texmf-dist/source/latex/amsmath/amsmath.dtx" "Implementing tags and labels")
# (find-tlfile "texmf-dist/source/latex/amsmath/amsmath.dtx" "Implementing tags and labels")
# (find-tlfile "texmf-dist/tex/latex/amsmath/amsmath.sty" "\\def\\tag@in@display")

# (code-pdf-page "amsmathsrc" "/usr/local/texlive/2017/texmf-dist/doc/latex/amsmath/amsmath.pdf")
# (code-pdf-text "amsmathsrc" "/usr/local/texlive/2017/texmf-dist/doc/latex/amsmath/amsmath.pdf")
# (find-amsmathsrcpage 53 "\\let\\tag\\tag@in@align")
# (find-amsmathsrctext 53 "\\let\\tag\\tag@in@align")
# (find-amsmathsrcpage)
# (find-amsmathsrctext)




#####
#
# \Huge and friends
# 2018mai05
#
#####

# «huge» (to ".huge")
# (find-kopkadaly4page (+ 12 63) "\\Huge")
# (find-kopkadaly4text (+ 12 63) "\\Huge")
# (find-lshortpage (+ 14 108) "Table 6.2: Font Sizes.")
# (find-lshorttext (+ 14 108) "Table 6.2: Font Sizes.")
# (find-classespage 9 "\\Huge")
# (find-classestext 9 "\\Huge")
# (find-classespage 56 "\\Huge")
# (find-classestext 56 "\\Huge")





#####
#
# Obsolete commands in LaTeX2e
# 2018mai05
#
#####

# «obsolete» (to ".obsolete")
# (find-tlfile "texmf-dist/doc/latex/l2tabu-english/")
# (find-fline "/usr/local/texlive/2017/texmf-dist/doc/latex/l2tabu-english/")
(code-pdf-page "l2tabu" "/usr/local/texlive/2017/texmf-dist/doc/latex/l2tabu-english/l2tabuen.pdf")
(code-pdf-text "l2tabu" "/usr/local/texlive/2017/texmf-dist/doc/latex/l2tabu-english/l2tabuen.pdf")
# (find-l2tabupage)
# (find-l2tabutext)
# (find-l2tabupage 9 "2.1.3 Centering text using \\centerline")
# (find-l2tabutext 9 "2.1.3 Centering text using \\centerline")
# (find-kopkadaly4page (+ 12 67) "\\begin{center}")
# (find-kopkadaly4text (+ 12 67) "\\begin{center}")



#####
#
# Title, \title and \maketitle
# 2018nov06
#
#####

# «title» (to ".title")
# (find-LATEXgrep "grep --color=auto -nH --null -e '\\\\title' *.tex")
# (find-LATEXgrep "grep --color=auto -nH -e 'eduardoochs@gmail.com' *.tex")

# (find-angg ".emacs.papers" "kopkadaly")
# (find-kopkadaly4page (+ 12  52) "3.3 Parts of the document")
# (find-kopkadaly4page (+ 12  53) "3.2 Sample title page")
# (find-source2epage (+ 10 368) "60.1     The Title")
# (find-source2etext (+ 10 368) "60.1     The Title")

# (find-tlsh "find * | sort | grep titling")

https://tex.stackexchange.com/questions/192771/two-maketitles-in-article

# (code-c-d      "titling" "/usr/local/texlive/2019/texmf-dist/doc/latex/titling/")
# (code-pdf-page "titling" "/usr/local/texlive/2019/texmf-dist/doc/latex/titling/titling.pdf")
# (code-pdf-text "titling" "/usr/local/texlive/2019/texmf-dist/doc/latex/titling/titling.pdf")
# (find-titlingfile "")
# (find-titlingpage)
# (find-titlingtext)

# (find-tlsh "find * | sort | grep title")
# (find-tlsh "find * | sort | grep title | grep pdf")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/titlepages/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/titlepages/titlepages.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/titlepages/titlepages.pdf")





#####
#
# latex-beginners-course
# 2018nov20
#
#####

# «latex-beginners-course» (to ".latex-beginners-course")
# https://github.com/uktug/latex-beginners-course
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgxvzLhhSrBVQMgqhCwDZDMFDSvzm

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/latex-beginners-course/
cd      ~/usrc/
git clone https://github.com/uktug/latex-beginners-course
cd      ~/usrc/latex-beginners-course/

make help
make all

# (find-fline "~/usrc/")
# (find-fline "~/usrc/latex-beginners-course/")

(code-c-d "latexbc" "~/usrc/latex-beginners-course/")
(code-pdf-page "latexbcs" "~/usrc/latex-beginners-course/slides.pdf")
(code-pdf-text "latexbcs" "~/usrc/latex-beginners-course/slides.pdf")
(code-pdf-page "latexbch" "~/usrc/latex-beginners-course/handouts.pdf")
(code-pdf-text "latexbch" "~/usrc/latex-beginners-course/handouts.pdf")
(code-pdf-page "latexbct" "~/usrc/latex-beginners-course/tutornotes.pdf")
(code-pdf-text "latexbct" "~/usrc/latex-beginners-course/tutornotes.pdf")
# (find-latexbcfile "")
# (find-latexbcfile "Makefile")
# (find-latexbcfile "Makefile_non_silent")
# (find-node "(make)Special Targets" ".SILENT")

;; (find-latexbcspage)
;; (find-latexbcstext)
;; (find-latexbchpage)
;; (find-latexbchtext)
;; (find-latexbctpage)
;; (find-latexbcttext)






#####
#
# \itemize
# 2019jan04
#
#####

# «itemize» (to ".itemize")
# (find-kopkadaly4page (+ 12  69)  "4.3 Lists")
# (find-kopkadaly4page (+ 12  69) "\\begin{itemize}")
# (find-kopkadaly4text (+ 12  69) "\\begin{itemize}")
# (find-kopkadaly4page (+ 12  70) "4.3.2   Sample enumerate")
# (find-kopkadaly4text (+ 12  70) "4.3.2   Sample enumerate")
# (find-kopkadaly4page (+ 12  74)  "4.4 Generalized lists")
# (find-source2epage (+ 11 361) "65     List, and related environments")
# (find-source2etext (+ 11 361) "65     List, and related environments")
# (find-source2epage (+ 11 291) "55     List, and related environments")
# (find-source2etext (+ 11 291) "55     List, and related environments")
# (find-source2epage (+ 11 374) "65.6      Itemize and Enumerate")
# (find-source2etext (+ 11 374) "65.6      Itemize and Enumerate")
# (find-source2epage (+ 11 304) "55.6      Itemize and Enumerate")
# (find-source2etext (+ 11 304) "55.6      Itemize and Enumerate")

# (find-tlsh "find * | sort | grep enumerate")
# (find-tlsh "find * | sort | grep etaremune")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/enumerate.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/enumerate.pdf")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/etaremune/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/etaremune/etaremune.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/etaremune/etaremune.pdf")



#####
#
# enumitem
# 2023apr05
#
#####

# «enumitem»  (to ".enumitem")
# (find-tlsh "find * | sort | grep enumitem")
# (find-LATEX "2023-C2-monitoria-edital.tex")

(code-c-d "enumitem" "/usr/local/texlive/2019/texmf-dist/doc/latex/enumitem/")
;; (find-enumitemfile "")
(code-pdf-page "enumitem" "/usr/local/texlive/2019/texmf-dist/doc/latex/enumitem/enumitem.pdf")
(code-pdf-text "enumitem" "/usr/local/texlive/2019/texmf-dist/doc/latex/enumitem/enumitem.pdf")
;; (find-enumitempage)
;; (find-enumitemtext)

https://tex.stackexchange.com/questions/78842/nested-enumeration-numbering
https://tex.stackexchange.com/questions/457314/how-to-get-three-nested-enumerations-in-latex




#####
#
# \begin{list}
# 2020feb21
#
#####

# «list» (to ".list")
# (find-LATEX "2020list-test.tex")
# (find-LATEX "2020hyp.tex" "myenumerate")
# (find-es "tex" "quotation")
# http://joshua.smcvt.edu/latex2e/list.html
# https://www.giss.nasa.gov/tools/latex/ltx-260.html

% https://tex.stackexchange.com/questions/390197/is-enumerate-default
%
\documentclass{article}
\begin{document}

\noindent Standard enumerated list: 
\begin{enumerate} 
  \item Item one
  \item Item two
  \item Item three
\end{enumerate}

Modified enumerated list without packages:
\begin{enumerate}
  \renewcommand{\labelenumi}{\alph{enumi})}
  \renewcommand{\theenumi}{\Alph{enumi}}
  \setlength\itemsep{-1ex}
  \setlength\labelwidth{-1cm}
  \setlength\labelsep{5ex}
  \item Item one
  \item Item two
  \item Item three
\end{enumerate}

Custom enumerated list:
\newcounter{mycounter}
\begin{list}{\textcircled{\scriptsize\arabic{mycounter}}}%
  {\usecounter{mycounter}
   \setlength\itemsep{2ex}
   \setlength\labelwidth{1em}
   \setlength\labelsep{1em}
   \setlength\leftmargin{0pt}}
  \item Item one
  \item Item two
  \item Item three
\end{list}

\end{document}






#####
#
# The Visual LaTeX FAQ, by Scott Pakin
# 2019jan04
#
#####

# «visuallatexfaq» (to ".visuallatexfaq")
;; (find-tlsh "find * | sort | grep visual")
;; (find-tlfile "texmf-dist/doc/latex/visualfaq/" "visualFAQ.pdf")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/visualfaq/")
;; file:///usr/local/texlive/2019/texmf-dist/doc/latex/visualfaq/visualFAQ.pdf
(code-pdf-page "visuallatexfaq" "/usr/local/texlive/2019/texmf-dist/doc/latex/visualfaq/visualFAQ.pdf")
(code-pdf-text "visuallatexfaq" "/usr/local/texlive/2019/texmf-dist/doc/latex/visualfaq/visualFAQ.pdf")
;; (find-visuallatexfaqpage)
;; (find-visuallatexfaqtext)

;; https://www.ctan.org/pkg/visualfaq
;; http://ctan.tug.org/get/info/visualFAQ/troubleshoot-vlf.pdf
;; http://ctan.tug.org/get/info/visualFAQ/visualFAQ.pdf





#####
#
# graphicx
# 2019jan04
#
#####

# «graphicx» (to ".graphicx")
# (find-angg ".emacs.papers" "latex-graphics")
# (find-tlsh "find * | sort | grep graphicx")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/graphics/")
(code-c-d      "graphicx" "/usr/local/texlive/2019/texmf-dist/doc/latex/graphics/")
(code-pdf-page "graphicx" "/usr/local/texlive/2019/texmf-dist/doc/latex/graphics/graphicx.pdf")
(code-pdf-text "graphicx" "/usr/local/texlive/2019/texmf-dist/doc/latex/graphics/graphicx.pdf")
;; (find-graphicxfile "")
;; (find-graphicxpage)
;; (find-graphicxtext)

# (find-kopkadaly4page (+ 12 154) "graphicx")
# (find-kopkadaly4text (+ 12 154) "graphicx")
# (find-kopkadaly4page (+ 12 155) "\\includegraphics")
# (find-kopkadaly4text (+ 12 155) "\\includegraphics")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/")
(code-pdf-page "grfext" "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/grfext.pdf")
(code-pdf-text "grfext" "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/grfext.pdf")
;; (find-grfextpage)
;; (find-grfexttext)




#####
#
# stackrel
# 2019jan05
#
#####

# «stackrel» (to ".stackrel")
# (find-tlsh "find * | sort | grep stackrel")
;; (find-stackrelfile "")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/")
(code-c-d      "stackrel" "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/")
(code-pdf-page "stackrel" "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/stackrel.pdf")
(code-pdf-text "stackrel" "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/stackrel.pdf")
;; (find-stackrelpage)
;; (find-stackreltext)




#####
#
# \shipout
# 2019jan07
#
#####

# «shipout» (to ".shipout")
# (find-texbookpage (+ 11 109) "15 How TEX Makes Lines into Pages")
# (find-texbooktext (+ 11 109) "15 How TEX Makes Lines into Pages")
# (find-texbookpage (+ 12 110) "on the main vertical list")
# (find-texbooktext (+ 12 110) "on the main vertical list")
# (find-texbookpage (+ 12 112) "discards a discardable")
# (find-texbooktext (+ 12 112) "discards a discardable")
# (find-texbookpage (+ 12 227) "\\shipout\\hbox")
# (find-texbooktext (+ 12 227) "\\shipout\\hbox")



#####
#
# \eject
# 2022jul24
#
#####

# «eject»  (to ".eject")
# (find-texbookpage (+ 12 457) "Index")
# (find-texbooktext (+ 12 457) "Index")
# (find-texbookpage (+ 12 464) "\\eject (force page break)")
# (find-texbooktext (+ 12 464) "\\eject (force page break)")
# (find-texbookpage (+ 12 109) "\\vfill\\eject")
# (find-texbooktext (+ 12 109) "\\vfill\\eject")
# (find-texbookpage (+ 12 353) "\\def\\eject")
# (find-texbooktext (+ 12 353) "\\def\\eject")





#####
#
# Packages for typesetting tableaux
# 2019jan16
#
#####

# «tableaux» (to ".tableaux")
# (find-tlfile "texmf-dist/doc/latex/prooftrees/")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/prooftrees/")
(code-pdf-page "prooftrees" "/usr/local/texlive/2019/texmf-dist/doc/latex/prooftrees/prooftrees.pdf")
(code-pdf-text "prooftrees" "/usr/local/texlive/2019/texmf-dist/doc/latex/prooftrees/prooftrees.pdf")
;; (find-prooftreespage)
;; (find-prooftreestext)





#####
#
# Squiggly arrows
# 2019jan19
#
#####

# «squiggly-arrows» (to ".squiggly-arrows")
# (find-es "tikz" "squiggly-arrows")
# http://www.sascha-frank.com/Arrow/latex-arrows.html




#####
#
# How TeX handles comments (TeXBook)
# 2021jun05
#
#####

# «comments»  (to ".comments")
# (find-texbookpage (+ 12 46) "State S" "Skipping blanks")
# (find-texbooktext (+ 12 46) "State S" "Skipping blanks")
# (find-texbookpage (+ 12 47) "If TEX sees a comment character")
# (find-texbooktext (+ 12 47) "If TEX sees a comment character")
# (find-texbookpage (+ 12 47) "spaces ignored at the beginning")
# (find-texbooktext (+ 12 47) "spaces ignored at the beginning")
# (find-texbookpage (+ 12 47) "state S" "skipping blanks")
# (find-texbooktext (+ 12 47) "state S" "skipping blanks")




#####
#
# The stix fonts
# 2019jan20
#
#####

# «stix» (to ".stix")
# https://www.stixfonts.org/
# (find-tlsh "find * | sort | grep stix")
# (find-tlsh "find * | sort | grep stix | grep pdf")
# (find-tlsh "find * | sort | grep xits")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/fonts/stix/")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/stix2/")
(code-pdf-page "stix"  "/usr/local/texlive/2019/texmf-dist/doc/fonts/stix/stix.pdf")
(code-pdf-text "stix"  "/usr/local/texlive/2019/texmf-dist/doc/fonts/stix/stix.pdf")
(code-pdf-page "stix2" "/usr/local/texlive/2019/texmf-dist/doc/latex/stix2/stix2.pdf")
(code-pdf-text "stix2" "/usr/local/texlive/2019/texmf-dist/doc/latex/stix2/stix2.pdf")
# (find-stixpage 1 "obsolete")
# (find-stixtext 1 "obsolete")
# (find-stixpage 11 "\\leftsquigarrow")
# (find-stixtext 11 "\\leftsquigarrow")

# (find-stix2page)
# (find-stix2text)
# (find-stix2page 3 "notext")
# (find-stix2text 3 "notext")

# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/fonts/stix2-otf/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/fonts/stix2-otf/STIX_2.0.0_stylistic_sets.pdf")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/fonts/stix/stix.pdf")




#####
#
# symbols
# 2019jan20
#
#####

# «symbols» (to ".symbols")
# (find-angg ".emacs.papers" "symbols")
# http://www.dimap.ufrn.br/pipermail/logica-l/2007-November/001842.html
# (find-tlsh "find * | sort | grep symbols")
# (find-tlsh "find * | sort | grep symbols | grep pdf")
# (find-tlfile "texmf-dist/doc/latex/comprehensive/" "symbols-a4.pdf")
# (find-tlfile "texmf-dist/doc/latex/maths-symbols/")
# (find-tlfile "texmf-dist/doc/latex/maths-symbols/README")

# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/comprehensive/source/")
# (find-tlfile "texmf-dist/doc/latex/comprehensive/source/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/latex-symbols/")
rm -Rv ~/usrc/latex-symbols/
mkdir  ~/usrc/latex-symbols/
cd     ~/usrc/latex-symbols/
cp -v /usr/local/texlive/2019/texmf-dist/doc/latex/comprehensive/source/* .

# (code-c-d "latexsymbols" "~/usrc/latex-symbols/")
# (find-latexsymbolsfile "")
# (find-latexsymbolsfile "symbols.tex")
# (find-latexsymbolsfile "symbols.tex" "To build this document")
# (find-latexsymbolsfile "symbols.tex" "mathabx")
# (find-latexsymbolsfile "symbols.tex" "\\renewcommand{\\bausquare}")

pdflatex symbols
makeindex -s gind.ist symbols
pdflatex symbols
pdflatex symbols

# ! Undefined control sequence.
# <argument> ...lse \noexpand \UniError {\bausquare 
#                                                   }\noexpand \fi }}
# l.88 \DeclareUniChar{\bausquare}{"00}




#####
#
# symbols-2001
# 2023mar06
#
#####

# «symbols-2001»  (to ".symbols-2001")
# David Carlisle, Scott Pakin, Alexander Holt: "The Great, Big List of LATEX Symbols" (2001)
# https://www3.nd.edu/~nmark/UsefulFacts/LaTeX_symbols.pdf
# (code-pdf-page "lsymbols" "$S/https/www3.nd.edu/~nmark/UsefulFacts/LaTeX_symbols.pdf")
# (code-pdf-text "lsymbols" "$S/https/www3.nd.edu/~nmark/UsefulFacts/LaTeX_symbols.pdf")
# (find-lsymbolspage)
# (find-lsymbolstext)




#####
#
# unimathsymbols
# 2020feb25
#
#####

# «unimathsymbols» (to ".unimathsymbols")
# http://milde.users.sourceforge.net/LUCR/Math/
# http://milde.users.sourceforge.net/LUCR/Math/unimathsymbols.pdf
# (code-pdf-page "unimathsymbols" "$S/http/milde.users.sourceforge.net/LUCR/Math/unimathsymbols.pdf")
# (code-pdf-text "unimathsymbols" "$S/http/milde.users.sourceforge.net/LUCR/Math/unimathsymbols.pdf")
# (find-unimathsymbolspage)
# (find-unimathsymbolstext)

# https://tex.stackexchange.com/questions/14/how-to-look-up-a-symbol-or-identify-a-math-symbol-or-character




#####
#
# The LaTeX Font Catalogue
# 2020feb25
#
#####

# «fontcatalogue» (to ".fontcatalogue")
# https://tug.org/FontCatalogue/
# https://tug.org/FontCatalogue/mathfonts.html
# https://tug.org/FontCatalogue/about.html
# https://tug.org/FontCatalogue/sansseriffonts.html



#####
#
# \settoheight
# 2019jan22
#
#####

# «settoheight» (to ".settoheight")
# https://en.wikibooks.org/wiki/LaTeX/Lengths
# (find-source2epage (+ 10 154) "\\settoheight")
# (find-source2etext (+ 10 154) "\\settoheight")




#####
#
# BaKoMa, TeXmaker, TeXniccenter, TeXworks, and TeXstudio
# 2019jan29
#
#####

# «bakoma» (to ".bakoma")
# http://www.bakoma-tex.com/
# http://www.bakoma-tex.com/menu/linux.php

# https://en.wikipedia.org/wiki/Comparison_of_TeX_editors
# https://tex.stackexchange.com/questions/339/latex-editors-ides

# «texniccenter» (to ".texniccenter")
# https://en.wikipedia.org/wiki/TeXnicCenter (for Windows only!)
# http://www.texniccenter.org/

# (find-tlfile "texmf-dist/doc/latex/cursolatex/")
# (find-tlfile "texmf-dist/doc/latex/cursolatex/" "texniccenter")
# (find-tlfile "texmf-dist/doc/latex/cursolatex/" "texstudio")



#####
#
# texmaker
# 2019sep12
#
#####

# «texmaker» (to ".texmaker")
# http://www.xm1math.net/texmaker/
# https://en.wikipedia.org/wiki/Texmaker
# https://tex.stackexchange.com/questions/tagged/texmaker?sort=faq
# (find-zsh "installeddebs | sort | grep texmaker")
# (find-zsh "availabledebs | sort | grep texmaker")
# (find-status   "texmaker")
# (find-vldifile "texmaker.list")
# (find-udfile   "texmaker/")
# (find-status   "texmaker-data")
# (find-vldifile "texmaker-data.list")
# (find-udfile   "texmaker-data/")
# (find-udfile "texmaker/html/")
# (find-fline "/usr/share/texmaker/" "usermanual_en.html")
# file:///usr/share/doc/texmaker/html/usermanual_en.html

# Options -> Configure TeXmaker -> Quick build -> Quick build command
#   Select the option "LuaLaTeX + View PDF"
# https://tex.stackexchange.com/questions/44040/biblatex-biber-texmaker-miktex

# lualatex -interaction=nonstopmode %.tex|biber %|lualatex -interaction=nonstopmode %.tex

# Options -> Configure TeXmaker -> Quick build -> User
#   Select the option "LuaLaTeX + View PDF"


lualatex % 

"Tools" menu:
Quick build : F1
Latex       : F2
View dvi    : F3
Dvi->PS     : F4
View PS     : F5
Pdflatex    : F6
View Pdf    : F7
PS->Pdf     : F8
Dvi->Pdf    : F9
View log    : F10
Bibtex      : F11
Make index  : F12



#####
#
# Instructions for compiling planar-has-1 with texmaker
# 2019sep17
#
#####

# «texmaker-planar-has-1» (to ".texmaker-planar-has-1")
# https://mail.google.com/mail/ca/u/0/#search/coniglio/KtbxLxgZcrDGxgbxmgFqVnWrWffBjhslCg
# (find-fline "~/tmp/TeXmaker-lualatex-biber-1.png")
# (find-fline "~/tmp/TeXmaker-lualatex-biber-2.png")
# (find-LATEX "2017planar-has-1.tex")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-latex-upload-links "2017planar-has-1" "/tmp/edrx-latex/")
cd ~/LATEX/
flsfiles-tgz 2017planar-has-1.fls 2017planar-has-1.tgz
flsfiles-zip 2017planar-has-1.fls 2017planar-has-1.zip
rm -rfv /tmp/2017planar-has-1.zip
rm -rfv /tmp/edrx-latex/
cp -v ~/LATEX/2017planar-has-1.zip /tmp/
mkdir    /tmp/edrx-latex/
unzip -d /tmp/edrx-latex/ /tmp/2017planar-has-1.zip
cd       /tmp/edrx-latex/

cp -v ~/LATEX/catsem-u.bib .
make -f ~/LATEX/2019.mk 2017planar-has-1.clean
cp -v ~/tmp/TeXmaker-lualatex-biber-1.png .
cp -v ~/tmp/TeXmaker-lualatex-biber-2.png .

rm -v  /tmp/ochs-planar-has-2019sep17.zip
zip -r /tmp/ochs-planar-has-2019sep17.zip *
# (find-fline "/tmp/")
# (find-fline "/tmp/ochs-planar-has-2019sep17.zip")

# (find-man "zip")
texmaker 2017planar-has-1.tex
# (find-es "screencasts" "yaxg")

# Options -> Configure TeXmaker -> Quick build -> Quick build command
#   Select the option "LuaLaTeX + View PDF"

lualatex 2017planar-has-1.tex
biber    2017planar-has-1
lualatex 2017planar-has-1.tex
# (find-pdf-page "/tmp/edrx-latex/2017planar-has-1.pdf")
# (find-fline    "/tmp/edrx-latex/")
# (find-fline    "/tmp/edrx-latex/2017planar-has-1.bbl")

cd /tmp/
cp -v ~/LATEX/2017planar-has-1.zip .
mkdir  /tmp/edrx-latex/
tar -C /tmp/edrx-latex/ -xvzf /tmp/2017planar-has-1.tgz
cd     /tmp/edrx-latex/
lualatex 2017planar-has-1.tex
# (find-pdf-page "/tmp/edrx-latex/2017planar-has-1.pdf")

texmaker 2017planar-has-1.tex




#####
#
# texstudio
# 2019aug20
#
#####

# «texstudio» (to ".texstudio")
# (find-es "dednat" "texstudio")
# https://en.wikipedia.org/wiki/TeXstudio
# https://github.com/texstudio-org/texstudio
# http://www.texstudio.org/
# http://texstudio.sf.net/
# (find-status   "texstudio")
# (find-vldifile "texstudio.list")
# (find-udfile   "texstudio/")
# (find-status   "texstudio-doc")
# (find-vldifile "texstudio-doc.list")
# (find-udfile   "texstudio-doc/")
# (find-fline "/usr/share/doc/texstudio/html/" "latex2e.html")
# (find-fline "/usr/share/doc/texstudio/html/" "usermanual_en.html")
# file:///usr/share/doc/texstudio/html/latex2e.html
# file:///usr/share/doc/texstudio/html/usermanual_en.html

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/ts/")
rm -Rv /tmp/ts/
mkdir  /tmp/ts/
cd     /tmp/ts/

cd ~/dednat6/
cp -aiv demo-minimal.tex dednat6load.lua dednat6/ /tmp/ts/

cd     /tmp/ts/
texstudio demo-minimal.tex

# Options -> Configure TeXstudio -> Build -> Default compiler -> LuaLaTeX
# Options -> Configure TeXstudio -> Show advanced options [turn on]
# Options -> Configure TeXstudio -> Build -> Build Options -> Show stdout -> Always




####
#
# TeXstudio: synctex
# 2019aug22
#
#####

# «texstudio-synctex» (to ".texstudio-synctex")
# https://tex.stackexchange.com/questions/157341/missing-jump-to-source-button-on-textudio
# https://mirocupak.com/best-development-setup-for-latex/

lualatex.exe -synctex=1 -interaction=nonstopmode %.tex




#####
#
# TeXworks
# 2019jan29
#
#####

# «texworks» (to ".texworks")
# (find-angg ".emacs.papers" "texworks")
# https://en.wikipedia.org/wiki/TeXworks
# http://www.tug.org/texworks/
# (find-tlsh "find * | sort | grep -i texworks")
# (find-tlfile "texmf-dist/doc/texworks/")
# (find-tlfile "texmf-dist/doc/texworks/README" "No other binaries are included")
# (find-zsh "installeddebs | sort | grep texworks")
# (find-zsh "availabledebs | sort | grep texworks")

# (find-status   "texworks")
# (find-vldifile "texworks.list")
# (find-udfile   "texworks/")
# (find-status   "texworks-help-en")
# (find-vldifile "texworks-help-en.list")
# (find-udfile   "texworks-help-en/")
# (find-fline "/usr/share/texworks-help/en/")
# file:///usr/share/texworks-help/en/index.html

# (find-status   "texworks-scripting-lua")
# (find-vldifile "texworks-scripting-lua.list")
# (find-udfile   "texworks-scripting-lua/")
# (find-status   "texworks-scripting-python")
# (find-vldifile "texworks-scripting-python.list")
# (find-udfile   "texworks-scripting-python/")

;; (find-fline "/usr/share/texworks-help/en/")
(code-pdf-page "texworksmanual" "/usr/share/texworks-help/en/TeXworks-manual.pdf")
(code-pdf-text "texworksmanual" "/usr/share/texworks-help/en/TeXworks-manual.pdf" 5)
;; (find-texworksmanualpage)
;; (find-texworksmanualtext)
;; (find-texworksmanualpage 3 "Contents")
;; (find-texworksmanualtext 3 "Contents")

# (find-man "1 texworks")

# Biber:
# https://tex.stackexchange.com/questions/154751/biblatex-with-biber-configuring-my-editor-to-avoid-undefined-citations




#####
#
# texmacs
# 2020may29
#
#####

# «texmacs» (to ".texmacs")
# https://www.texmacs.org/tmweb/home/welcome.en.html
# https://www.texmacs.org/tmweb/download/sources.en.html
# https://www.texmacs.org/tmweb/download/linux.en.html
# https://www.texmacs.org/tmweb/download/linux-packages.en.html#debian
# https://www.texmacs.org/tmweb/download/linux-repos.en.html#debian


apti texmacs


lsb_release -cs
Download the TeXmacs public key (into the auxiliary file apt-texmacs.asc):

curl --insecure https://ftp.texmacs.org/TeXmacs/tmftp/repos/apt/apt-texmacs.asc --output apt-texmacs.asc
Obtain root privileges:

sudo bash
Import the key in the apt keyring using

apt-key add apt-texmacs.asc
Remove the temporary key file:

rm apt-texmacs.asc
Add the texmacs repository in

add-apt-repository "deb http://ftp.texmacs.org/TeXmacs/tmftp/repos/apt/ stretch universe"
Update the package list:

apt-get update
Install TeXmacs:

apt-get install texmacs
Return to your regular account:

exit




#####
#
# synctex
# 2019jan29
#
#####

# «synctex» (to ".synctex")
# (find-tlsh "find * | sort | grep -i synctex")
# https://tex.stackexchange.com/questions/118489/what-exactly-is-synctex




#####
#
# magic-comments, a.k.a. "!TEX directives" (and "!BIB")
# 2019sep14
#
#####

# «magic-comments» (to ".magic-comments")
# https://tex.stackexchange.com/questions/236747/tell-texstudio-to-compile-a-particular-document-with-lualatex
# https://www.texdev.net/2011/03/24/texworks-magic-comments/
# https://tex.stackexchange.com/questions/78101/when-and-why-should-i-use-tex-ts-program-and-tex-encoding
# http://www.tug.org/TUGboat/tb32-1/tb100wright-texworks.pdf
# https://tex.stackexchange.com/questions/330664/general-processing-instructions-for-tex-editors?noredirect=1&lq=1
# http://texstudio.sourceforge.net/manual/current/usermanual_en.html#SECTION_TEXCOM




#####
#
# TUGBoat
# 2019feb04
#
#####

# «tugboat» (to ".tugboat")
# http://www.tug.org/TUGboat/
# http://www.tug.org/TUGboat/contents.html
# (find-tlsh "find * | sort | grep -i tug")
# (find-tlfile "texmf-dist/bibtex/bib/beebe/")
# (find-tlfile "texmf-dist/bibtex/bib/beebe/tugboat.bib")
# (find-tlfile "texmf-dist/bibtex/bib/beebe/tugboat.bib" "GNU emacs as a front end")
# (find-tlfile "texmf-dist/bibtex/bib/beebe/tugboat.bib" "Two extensions to GNU Emacs")
# (find-tlfile "texmf-dist/bibtex/bib/beebe/tugboat.bib" "previewer with" "an Emacs-type editor")
# (find-tlfile "texmf-dist/bibtex/bib/beebe/tugboat.bib" "tb91kastrup-emacs.pdf")
# (find-tlfile "texmf-dist/bibtex/bib/beebe/tugboat.bib" "An {Emacs}-based writing workflow")



#####
#
# ltugboat.cls
# 2019may21
#
#####

# «ltugboat.cls» (to ".ltugboat.cls")
# (find-tlsh "find * | sort | grep ltugboat")
# (find-tlfile "texmf-dist/tex/latex/tugboat/")
# (find-tlfile "texmf-dist/tex/latex/tugboat/ltugboat.cls")
# (find-tlfile "texmf-dist/tex/latex/tugboat/ltugboat.sty")



#####
#
# The PracTeX Journal
# 2020may24
#
#####

# «practex» (to ".practex")
# http://tug.org/pracjourn/archive.html
# http://tug.org/pracjourn/info.html




#####
#
# The lipsum package - Lorem Ipsum
# 2019feb06
#
#####

# «lipsum» (to ".lipsum")
# (find-angg ".emacs.papers" "lipsum")
# (find-tlsh "find * | sort | grep -i lipsum")
# (find-tlsh "find * | sort | grep -i lipsum | grep pdf")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/lipsum/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/lipsum/lipsum.sty")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/lipsum/lipsum.ltd.tex")

# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/lipsum/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/lipsum/lipsum.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/lipsum/lipsum.pdf")
(code-pdf-page "lipsum" "/usr/local/texlive/2019/texmf-dist/doc/latex/lipsum/lipsum.pdf")
(code-pdf-text "lipsum" "/usr/local/texlive/2019/texmf-dist/doc/latex/lipsum/lipsum.pdf")
;; (find-lipsumpage)
;; (find-lipsumtext)

\usepackage{lipsum}

To get the sentences four to eight from paragraphs three to nine, use
\lipsum[3-9][4-8].

# (find-fline "/usr/local/texlive/2019/texmf-dist/source/latex/kantlipsum/kantlipsum.dtx")




#####
#
# \string
# 2019feb11
#
#####

# «string» (to ".string")
# (find-es "diagxy" "how-diagxy-calls-xypic")
# (find-texbookpage (+ 12 40) "\\string")
# (find-texbooktext (+ 12 40) "\\string")



#####
#
# \ifx
# 2019feb19
#
#####

# «ifx» (to ".ifx")
# (find-texbookpage (+ 12 207) "\\else")
# (find-texbooktext (+ 12 207) "\\else")
# (find-texbookpage (+ 12 210) "\\ifx")
# (find-texbooktext (+ 12 210) "\\ifx")
# (find-texbookpage (+ 12 218) "\\ifx\\answer\\yes")
# (find-texbooktext (+ 12 218) "\\ifx\\answer\\yes")
# (find-texbookpage (+ 12 219) "\\ifx#1\\end")
# (find-texbooktext (+ 12 219) "\\ifx#1\\end")
# (find-texbookpage (+ 12 457) "Index")
# (find-texbooktext (+ 12 457) "Index")
# (find-texbookpage (+ 12 468) "\\if")
# (find-texbooktext (+ 12 468) "\\if")
# (find-texbookpage (+ 12 475) "\\relax")
# (find-texbooktext (+ 12 475) "\\relax")


#####
#
# \ifundefined
# 2023oct02
#
#####

# «ifundefined»  (to ".ifundefined")
# (find-LATEX "edrx21defs.tex" "ifundefined")
# (find-texbookpage (+ 12  40) "\\ifundefined")
# (find-texbooktext (+ 12  40) "\\ifundefined")
# (find-texbookpage (+ 12 308) "\\def\\ifundefined#1")
# (find-texbooktext (+ 12 308) "\\def\\ifundefined#1")

# (find-dn6 "preamble6.lua" "preamble1")
# (find-dn6 "preamble6.lua" "preamble1" "\\def\\ifdedundefined")

\ifundefined{FOO} NO \def\FOO{BAR} \else YES \fi
\ifundefined{FOO} NO \def\FOO{BAR} \else YES \fi


relax:
# (find-texbookpage (+ 12  23))
# (find-texbookpage (+ 12  25)) 
# (find-texbookpage (+ 12  71)) 
# (find-texbookpage (+ 12 240)) 
# (find-texbookpage (+ 12 468)) 276
# (find-texbookpage (+ 12 468)) 279
# (find-texbookpage (+ 12 468)) 307
# (find-texbookpage (+ 12 468)) 353





#####
#
# xpdf-windows-mac
# 2019mar06
#
#####

# «xpdf-windows-mac» (to ".xpdf-windows-mac")
# (find-es "texworks" "position")
# https://tug.org/pipermail/tex-live/2019-March/043227.html my question
# https://tug.org/pipermail/tex-live/2019-March/043229.html Stefan's answer
# https://tug.org/pipermail/tex-live/2019-March/043235.html Deimantas's answer
# https://mail.google.com/mail/ca/u/0/#sent/KtbxLxGPqDrmfrRRqzkPPHCPptsbqWPjXq

PDF viewer that accepts a "starting page" and runs on Windows and Macs

Hi list,

is there a PDF viewer - ideally something that comes with texlive, but
other ones are ok - that accepts a "starting page" option and that
runs on Windows and Macs?

Let me explain why I'm asking this. I'm going to give a course on
LaTeX and Lua and I'm going to use "elisp hyperlinks to pages of
PDFs", like the ones here,

  http://angg.twu.net/eev-intros/find-eev-quick-intro.html#9.3
  http://angg.twu.net/eev-intros/find-eev-quick-intro.html#9.4

a lot. The students are going to use machines with GNU/Linux, TeXLive,
Emacs and xpdf in the laboratory and I'm planning to sort of force
them to install something similar in their own computers, but it would
be great if I could create a setup that also works on Windows and
Macs...

  Cheers,
    Eduardo Ochs
    http://angg.twu.net/dednat6.html
    http://angg.twu.net/math-b.html




 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
texworks --version
texworks --help
texworks -p 10 ~/LATEX/falta-misandria-v.pdf
texworks       ~/LATEX/falta-misandria-v.pdf




#####
#
# Using the "list macros" of appendix D to select a subbox
# 2019mar08
#
#####

# «list-macros-select» (to ".list-macros-select")

% (find-texbookpage (+ 12 373) "D Dirty Tricks")
% (find-texbooktext (+ 12 373)   "Dirty Tricks")
% (find-texbookpage (+ 12 378) "2. List macros.")
% (find-texbooktext (+ 12 378) "2. List macros.")
% (find-texbookpage (+ 12 379) "by its position number")
% (find-texbooktext (+ 12 379) "by its position number")



#####
#
# eyes-mouth-stomach
# 2019mar08
#
#####

# «eyes-mouth-stomach» (to ".eyes-mouth-stomach")
# (find-texbookpage (+ 12 38) "mouth")
# (find-texbooktext (+ 12 38) "mouth")
# (find-texbookpage (+ 12 46) "State N       Beginning a new line")
# (find-texbooktext (+ 12 46) "State N       Beginning a new line")
# (find-texbookpage (+ 12 268) "gullet")
# (find-texbooktext (+ 12 268) "gullet")

# (find-sh "dict gullet")




#####
#
# abnt / abntex2
# 2019mar22
#
#####

# «abnt» (to ".abnt")
# (find-tlsh "find * | sort | grep abnt")




#####
#
# \vskip and \vspace
# 2019apr01
#
#####

# «vskip» (to ".vskip")
# (find-texbookpage (+ 12 24) "\\vskip 1in")
# (find-texbooktext (+ 12 24) "\\vskip 1in")
# (find-texbookpage (+ 12 480) "\\vskip, 24, 71, 85, 191, 281, 286")
# (find-texbooktext (+ 12 480) "\\vskip, 24, 71, 85, 191, 281, 286")
# (find-texbookpage (+ 12 281) "\\vskip")
# (find-texbooktext (+ 12 281) "\\vskip")
# (find-kopkadaly4page (+ 12 32) "2.7.3   Vertical spacing")
# (find-kopkadaly4text (+ 12 32) "2.7.3   Vertical spacing")




#####
#
# The "compositionality" style
# 2019apr22
#
#####

# «compositionality» (to ".compositionality")
# (find-LATEX "2019oxford-abs.tex" "compositionality")
# http://www.compositionality-journal.org/
# http://www.compositionality-journal.org/for-authors/
# https://github.com/Compositionality/latex-template/

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/compt/
mkdir   ~/usrc/compt/
cd      ~/usrc/compt/
git clone --depth 1 https://github.com/Compositionality/latex-template/
cd     ~/usrc/compt/latex-template/

# (code-c-d      "compt" "~/usrc/compt/latex-template/")
# (code-pdf-page "compt" "~/usrc/compt/latex-template/compositionality-template.pdf")
# (code-pdf-text "compt" "~/usrc/compt/latex-template/compositionality-template.pdf")
# (find-comptfile "")
# (find-comptfile "compositionality-template.tex")
# (find-comptfile "compositionality-template.tex" "\\begin{thebibliography}")
# (find-comptpage)
# (find-compttext)
# (find-comptpage 3 "DOI links are required")
# (find-compttext 3 "DOI links are required")
# (find-comptpage 3 "in your thebibliography environment")
# (find-compttext 3 "in your thebibliography environment")
# (find-comptpage 3 "\\bibitem{examplecitation}")
# (find-compttext 3 "\\bibitem{examplecitation}")




#####
#
# Finding the doi codes for books and articles
# 2019may01
#
#####

# «doi» (to ".doi")
# https://www.doi.org/
# https://academicanswers.waldenu.edu/faq/72610
# https://www.doi.org/factsheets/ISBN-A.html
# https://en.wikipedia.org/wiki/International_Standard_Book_Number
# https://academia.stackexchange.com/questions/69272/is-it-possible-to-get-doi-from-isbn-of-a-book
# http://tex.stackexchange.com/questions/3802/how-to-get-doi-links-in-bibliography
# https://tex.stackexchange.com/questions/6810/automatically-adding-doi-fields-to-a-hand-made-bibliography

Johnstone: Topos Theory
ISBN-10: 0123878500
ISBN-13: 978-0123878502

IDARCT:
https://link.springer.com/article/10.1007/s11787-013-0083-z




#####
#
# The problem with \normalsize in the compositionality class
# 2019apr26
#
#####

# «normalsize» (to ".normalsize")
# (to "huge")
# (find-source2epage (+ 10 648) "\\normalsize")
# (find-source2etext (+ 10 648) "\\normalsize")
# (find-source2epage (+ 10 261) "\\normalsize")
# (find-source2etext (+ 10 261) "\\normalsize")
# (find-classespage 7 "\\normalsize")
# (find-classestext 7 "\\normalsize")

# When I compile this
#   (find-LATEX "2019compttest.tex")
# with lualatex I get:

! LaTeX Error: The font size command \normalsize is not defined:
               there is probably something wrong with the class file.

% (find-es "tex" "normalsize")
\makeatletter
\renewcommand\normalsize{%
    \@setfontsize\normalsize\@xipt{13.6}%
    \abovedisplayskip 11\p@ \@plus3\p@ \@minus6\p@
    \abovedisplayshortskip \z@ \@plus3\p@
    \belowdisplayshortskip 6.5\p@ \@plus3.5\p@ \@minus3\p@
    \belowdisplayskip \abovedisplayskip
    \let\@listi\@listI}
\makeatother




#####
#
# mathpartir
# 2019may16
#
#####

# «mathpartir» (to ".mathpartir")
# https://tex.stackexchange.com/questions/468/what-is-the-best-package-out-there-to-typeset-proof-trees
# (find-tlsh "find * | sort | grep mathpartir")
# (code-c-d      "mathpartir" "/usr/local/texlive/2019/texmf-dist/doc/latex/mathpartir/")
# (code-pdf-page "mathpartir" "/usr/local/texlive/2019/texmf-dist/doc/latex/mathpartir/mathpartir.pdf")
# (code-pdf-text "mathpartir" "/usr/local/texlive/2019/texmf-dist/doc/latex/mathpartir/mathpartir.pdf")
# (find-mathpartirfile "")
# (find-mathpartirpage)
# (find-mathpartirtext)




#####
#
# ebproof
# 2019may17
#
#####

# «ebproof» (to ".ebproof")
# https://tex.stackexchange.com/questions/468/what-is-the-best-package-out-there-to-typeset-proof-trees
# (find-tlsh "find * | sort | grep ebproof")
# (code-c-d      "ebproof" "/usr/local/texlive/2019/texmf-dist/doc/latex/ebproof/")
# (code-pdf-page "ebproof" "/usr/local/texlive/2019/texmf-dist/doc/latex/ebproof/ebproof.pdf")
# (code-pdf-text "ebproof" "/usr/local/texlive/2019/texmf-dist/doc/latex/ebproof/ebproof.pdf")
# (find-ebprooffile "")
# (find-ebproofpage)
# (find-ebprooftext)




#####
#
# \rlap and \llap
# 2019may05
#
#####

# «rlap-and-llap» (to ".rlap-and-llap")
# (find-kopkadaly4page (+ 12 348) "\\rlap and \\llap")
# (find-kopkadaly4text (+ 12 348) "\\rlap and \\llap")
# (find-texbookpage (+ 12 82) "\\rlap" "right overlap")
# (find-texbooktext (+ 12 82) "\\rlap" "right overlap")
# (c2m232introp 3 "maxima")
# (c2m232introa   "maxima")
# (find-angg "LUA/Maxima1.lua")
# (find-LATEX "edrx21.sty" "maximablue-red")
# (find-LATEX "edrx21.sty" "maximablue-red" "llap")

 (find-code-show2 "~/LATEX/Show2.tex")
       (code-show2 "~/LATEX/Show2.tex")
 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
loadshow2()
middletexbody = middletexbody_bare
usepackages.edrx21 = true

texbody = [=[
\par \maximablue{(\%i1)\ foo}
\par \maximared {(\%o1)}{\frac12}
\par bletch
\noindent\par blep
\indent\par bloop

\par\indent a
\par\noindent b
\par\indent c

\vbox{%
\maximablue{(\%i1)\ foo}%
\maximared {(\%o1)}{\frac12}%
}

\def\hboxthreeindent{}

\vbox{%
\maximablue{(\%i1)\ foo}%
\maximared {(\%o1)}{\frac12}%
}


]=]

= show()
= Show.log
 (etv)






#####
#
# \oto
# 2019may06
#
#####

# «oto» (to ".oto")
% (find-es "tex" "rlap-and-llap")
% (find-symbolspage 29 "\\ovee")
% (find-symbolstext 29 "\\ovee")
% (find-texbookpage (+ 12 155) "\\mathbin, \\mathrel")
% (find-texbooktext (+ 12 155) "\\mathbin, \\mathrel")
% (find-texbookpage (+ 12 170) "rules for spacing in formulas")
% (find-texbooktext (+ 12 170) "rules for spacing in formulas")
% (find-texbookpage (+ 12 358) "joinrel")
% (find-texbooktext (+ 12 358) "joinrel")
% (find-kopkadaly4page (+ 12 375) "\\mathbin")
% (find-kopkadaly4text (+ 12 375) "\\mathbin")

\def\otoo#1#2{\rlap{$#1$}\hbox{$#2$}}
\def\oto{\mathbin{\otoo{\ominus}{\to}}}

\bhbox{$a \to  b$}

\bhbox{$a \mathbin{\hbox{$\to$}}  b$}

\bhbox{$a \oto b$}

\bhbox{$a \ominus b$}

\def\newoimp        #1{\mathbin{\ominus\mskip#1mu\to}}
\def\newoimptest#1{#1: \mathbin{\ominus\mskip#1mu\to}}

$\newoimptest{-20}$

$\newoimptest{-19}$

$\newoimptest{-18}$

$\newoimptest{-17}$

$\newoimptest{-10}$

$\newoimptest{-6}$

$\newoimptest{-2}$








#####
#
# arara - depends on Java =(
# 2019may26
#
#####

# «arara» (to ".arara")
# (find-tlsh "find * | sort | grep arara")
# (code-c-d      "araramanual" "/usr/local/texlive/2019/texmf-dist/doc/support/arara/")
# (code-pdf-page "araramanual" "/usr/local/texlive/2019/texmf-dist/doc/support/arara/arara-manual.pdf")
# (code-pdf-text "araramanual" "/usr/local/texlive/2019/texmf-dist/doc/support/arara/arara-manual.pdf" 9)
# (code-c-d      "arararules"  "/usr/local/texlive/2019/texmf-dist/scripts/arara/rules/")

# (find-araramanualfile "")
# (find-araramanualpage)
# (find-araramanualtext)
# (find-araramanualpage 4 "LATEX for administrative work")
# (find-araramanualtext 4 "LATEX for administrative work")
# (find-araramanualpage (+ 9 5) "REPL workflow")
# (find-araramanualtext (+ 9 5) "REPL workflow")
# (find-araramanualpage (+ 9 6) "written using the Java language")
# (find-araramanualtext (+ 9 6) "written using the Java language")

# (find-arararulesfile "")
# (find-arararulesfile "biber.yaml")
# (find-arararulesfile "lualatex.yaml")




#####
#
# asymptote
# 2019jun13
#
#####

# «asymptote» (to ".asymptote")
# (find-tlsh "find * | sort | grep asymptote")

# http://asymptote.sourceforge.net/
# http://asymptote.sourceforge.net/gallery/
# http://asymptote.sourceforge.net/links.html
# http://asymptote.sourceforge.net/asyRefCard.pdf
# http://sourceforge.net/projects/asymptote
# http://sourceforge.net/p/asymptote/discussion/409349


;; (find-fline "/usr/local/texlive/2019/texmf-dist/asymptote/")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/asymptote/")
(code-c-d "asy"   "/usr/local/texlive/2019/texmf-dist/asymptote/")
(code-c-d "asyex" "/usr/local/texlive/2019/texmf-dist/doc/asymptote/examples/")
;; (find-asyfile "")
;; (find-asyexfile "")

;; (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/asymptote/asymptote.pdf")
;; (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/asymptote/asymptote.pdf")
(code-pdf-page "asy" "/usr/local/texlive/2019/texmf-dist/doc/asymptote/asymptote.pdf")
(code-pdf-text "asy" "/usr/local/texlive/2019/texmf-dist/doc/asymptote/asymptote.pdf")
;; (find-asypage)
;; (find-asytext)
;; (find-asypage (+ 5 7) "asy-mode")
;; (find-asytext (+ 5 7) "asy-mode")
;; (find-asypage (+ 5 84) "7 LaTeX usage")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LATEX/
lualatex tmp.tex
laf tmp-*.asy
asy tmp-*.asy
lualatex tmp.tex

# (find-LATEXfile "tmp.tex")

# (find-zsh "apt-file search libOSMesa.so.8")
# (find-zsh "apt-file search libglut.so.3")
apti libosmesa6 freeglut3

# Asymptote figure in footnote:
# https://lists.gnu.org/archive/html/emacs-orgmode/2020-01/msg00202.html





#####
#
# Luke Smith
# 2019jun25
#
#####

# «luke-smith» (to ".luke-smith")
# https://lukesmith.xyz/latex.html
# https://lukesmith.xyz/videos.html#latex




#####
#
# Comparison of math fonts for LaTeX
# 2019jul02
#
#####

# «math-fonts-for-latex» (to ".math-fonts-for-latex")
# (find-angg ".emacs.papers" "freemathfonts")
# http://www.tug.org/pracjourn/2006-1/hartke/hartke.pdf
# https://texfaq.org/FAQ-psfchoice
# https://tug.org/FontCatalogue/mathfonts.html

# (find-tlsh "find * | sort | grep free-math-font-survey")
# https://ctan.org/pkg/free-math-font-survey
# http://linorg.usp.br/CTAN/info/Free_Math_Font_Survey/en/survey.pdf

;; (find-pdf-page "$S/http/www.tug.org/pracjourn/2006-1/hartke/hartke.pdf")
;; (find-pdf-text "$S/http/www.tug.org/pracjourn/2006-1/hartke/hartke.pdf")
(code-pdf-page "freemathfonts" "$S/http/www.tug.org/pracjourn/2006-1/hartke/hartke.pdf")
(code-pdf-text "freemathfonts" "$S/http/www.tug.org/pracjourn/2006-1/hartke/hartke.pdf")
;; (find-freemathfontspage)
;; (find-freemathfontstext)

# (find-freemathfontspage 4 "Figure 1" "Computer Modern")
# (find-freemathfontstext 4 "Figure 1" "Computer Modern")
# (find-freemathfontspage 5 "Figure 2: CM Bright (\\usepackage{cmbright}")
# (find-freemathfontstext 5 "Figure 2: CM Bright (\\usepackage{cmbright}")
# (find-freemathfontspage 6 "Figure 3: Concrete text with Euler math")
# (find-freemathfontstext 6 "Figure 3: Concrete text with Euler math")
# (find-freemathfontspage 7 "Figure 4:" "Concrete text with Concrete math")
# (find-freemathfontstext 7 "Figure 4:" "Concrete text with Concrete math")
# (find-freemathfontspage 7 "Figure 5: Iwona text and math")
# (find-freemathfontstext 7 "Figure 5: Iwona text and math")
# (find-freemathfontspage 8 "Figure 6: Kurier text and math")
# (find-freemathfontstext 8 "Figure 6: Kurier text and math")
# (find-freemathfontspage 8 "Figure 7:     Antykwa")
# (find-freemathfontstext 8 "Figure 7:     Antykwa")
# (find-freemathfontspage 9 "Figure 8: Antykwa Torunska text and math")
# (find-freemathfontstext 9 "Figure 8: Antykwa Torunska text and math")
# (find-freemathfontspage 10 "Figure 9: Kerkis text and math")
# (find-freemathfontstext 10 "Figure 9: Kerkis text and math")
# (find-freemathfontspage 11 "Figure 10: New Century Schoolbook with Millennial math")
# (find-freemathfontstext 11 "Figure 10: New Century Schoolbook with Millennial math")
# (find-freemathfontspage 11 "Figure 11: New Century Schoolbook with Fourier math")
# (find-freemathfontstext 11 "Figure 11: New Century Schoolbook with Fourier math")
# (find-freemathfontspage 12 "Figure 12: Palatino text with pxfonts math")
# (find-freemathfontstext 12 "Figure 12: Palatino text with pxfonts math")
# (find-freemathfontspage 13 "Figure 13: Palatino text with Pazo math")
# (find-freemathfontstext 13 "Figure 13: Palatino text with Pazo math")
# (find-freemathfontspage 13 "Figure 14: Palatino text with Euler math")
# (find-freemathfontstext 13 "Figure 14: Palatino text with Euler math")
# (find-freemathfontspage 14 "Figure 15: Times text with txfonts math")
# (find-freemathfontstext 14 "Figure 15: Times text with txfonts math")
# (find-freemathfontspage 15 "Figure 16: Times text with Belleek math")
# (find-freemathfontstext 15 "Figure 16: Times text with Belleek math")
# (find-freemathfontspage 15 "Figure 17: Times text with Symbol math")
# (find-freemathfontstext 15 "Figure 17: Times text with Symbol math")
# (find-freemathfontspage 16 "Figure 18: Omega Serif text with Omega math")
# (find-freemathfontstext 16 "Figure 18: Omega Serif text with Omega math")
# (find-freemathfontspage 17 "Figure 19: Arev Sans text with Arev math")
# (find-freemathfontstext 17 "Figure 19: Arev Sans text with Arev math")
# (find-freemathfontspage 18 "Figure 20: Bitstream Charter text with Math Design math")
# (find-freemathfontstext 18 "Figure 20: Bitstream Charter text with Math Design math")
# (find-freemathfontspage 18 "Figure 21: URW Garamond text with Math Design math")
# (find-freemathfontstext 18 "Figure 21: URW Garamond text with Math Design math")
# (find-freemathfontspage 19 "Figure 22: Utopia text with Fourier-GUTenberg math")
# (find-freemathfontstext 19 "Figure 22: Utopia text with Fourier-GUTenberg math")
# (find-freemathfontspage 19 "Figure 23: Utopia text with Math Design math")
# (find-freemathfontstext 19 "Figure 23: Utopia text with Math Design math")
# (find-freemathfontspage 22 "Figure 24: Sample LATEX file for fourier")
# (find-freemathfontstext 22 "Figure 24: Sample LATEX file for fourier")

in the caption of the sample figure. For example "\usepackage{fourier}" uses
Figure 2: CM Bright (\usepackage{cmbright}; output uses the hfbright fonts).
Figure 3: Concrete text with Euler math (\usepackage{ccfonts,eulervm}
Figure 4: Concrete text with Concrete math (\usepackage{ccfonts}
\usepackage[T1]{fontenc}). Note that Concrete does not have a bold font, so
Figure 5: Iwona text and math (\usepackage[math]{iwona}).
Figure 6: Kurier text and math (\usepackage[math]{kurier}).
Figure 7: Antykwa Póltawskiego text (\usepackage{antpolt} and \usepackage[QX]{fontenc}).
Figure 8: Antykwa Torunska text and math (\usepackage[math]{anttor}).
Figure 9: Kerkis text and math (\usepackage{kmath,kerkis}; the order of the
(\usepackage{millennial}).
(\usepackage{fouriernc}).
Figure 12: Palatino text with pxfonts math (\usepackage{pxfonts}).
Figure 13: Palatino text with Pazo math (\usepackage{mathpazo}).
Figure 14: Palatino text with Euler math (\usepackage{mathpple}).
Figure 15: Times text with txfonts math (\usepackage[varg]{txfonts}).
Figure 16: Times text with Belleek math (\usepackage{mathtime}; output uses
Figure 17: Times text with Symbol math (\usepackage{mathptmx}).
Figure 18: Omega Serif text with Omega math (\usepackage{mbtimes}).
Figure 19: Arev Sans text with Arev math (\usepackage{arev}).
(\usepackage[charter]{mathdesign}).
(\usepackage[garamond]{mathdesign}).
Figure 22: Utopia text with Fourier-GUTenberg math (\usepackage{fourier}).
(\usepackage[utopia]{mathdesign}).
\usepackage{fourier}
"\usepackage{fourier}" was changed for each sample to the package listed in


#####
#
# txfonts (Figures 15, 16 and 17 in freemathfonts)
# 2019jul05
#
#####

# «txfonts» (to ".txfonts")
# (to "math-fonts-for-latex")
;; (find-freemathfontspage 15 "Figure 17: Times text with Symbol math")
;; (find-freemathfontstext 15 "Figure 17: Times text with Symbol math")
;; (find-freemathfontstext 15 "Figure 17" "\\usepackage{mathptmx}")
;; (find-tlsh "find * | sort | grep txfonts")
;; (find-fline           "/usr/local/texlive/2019/texmf-dist/doc/fonts/txfonts/")
(code-c-d      "txfonts" "/usr/local/texlive/2019/texmf-dist/doc/fonts/txfonts/")
(code-pdf-page "txfonts" "/usr/local/texlive/2019/texmf-dist/doc/fonts/txfonts/txfontsdoc.pdf")
(code-pdf-text "txfonts" "/usr/local/texlive/2019/texmf-dist/doc/fonts/txfonts/txfontsdoc.pdf")
;; (find-txfontsfile "")
;; (find-txfontspage)
;; (find-txfontstext)




#####
#
# cmbright
# 2019jul02
#
#####

# «cmbright» (to ".cmbright")
# https://ctan.org/pkg/cmbright
# (find-tlsh "find * | sort | grep cmbright")
# (find-tlsh "find * | sort | grep hfbright")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/cmbright/cmbright.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/cmbright/cmbright.pdf")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/fonts/hfbright/")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/fonts/hfbright/README")

# (elp)
# (find-fline "~/LATEX/2019elephant-poster.log")

https://texfaq.org/FAQ-fontunavail
(EC) fonts, you can tell LaTeX to remove the restrictions; use the
type1cm or type1ec package as appropriate.

(/usr/local/texlive/2018/texmf-dist/tex/latex/cmbright/cmbright.sty

LaTeX Font Warning: Font shape `TU/cmbr/m/n' undefined
(Font)              using `TU/lmr/m/n' instead on input line 144.

# (find-tlsh "find * | sort | grep type1cm")
# (find-tlsh "find * | sort | grep type1ec")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/type1cm/type1cm-doc.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/type1cm/type1cm-doc.pdf")

type1cm
type1ec




#####
#
# arev
# 2019jul02
#
#####

# «arev» (to ".arev")




#####
#
# newtxsf
# 2019jul02
#
#####

# «newtxsf» (to ".newtxsf")
# (find-tlsh "find * | sort | grep newtxsf")
;; (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/fonts/newtxsf/newtxsf-doc.pdf")
;; (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/fonts/newtxsf/newtxsf-doc.pdf")




#####
#
# 14pt
# 2019jul02
#
#####

# «14pt» (to ".14pt")
# (find-tlsh "find * | sort | grep extsizes")
# (find-tlsh "find * | sort | grep extarticle")
# (find-LATEXgrep "grep --color=auto -nH --null -e extart *.tex")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/extsizes/")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/extsizes/README")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/extsizes/extsizes.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/extsizes/extsizes.pdf")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/tex/latex/extsizes/")
# https://tex.stackexchange.com/questions/70381/the-article-class-ignores-14pt
# https://texblog.org/2012/08/29/changing-the-font-size-in-latex/




#####
#
# \newlength
# 2019jul16
#
#####

# «newlength» (to ".newlength")
# (find-kopkadaly4page (+ 12 20) "\\setlength{\\parindent}{0.5cm}")
# (find-kopkadaly4text (+ 12 20) "\\setlength{\\parindent}{0.5cm}")
# (find-kopkadaly4page (+ 12 185) "\\newlength{\\new len cmd}")
# (find-kopkadaly4text (+ 12 185) "\\newlength{\\new len cmd}")
# (find-LATEXgrep "grep --color=auto -nH --null -e newlength *.tex *.sty")



#####
#
# LaTeX Error: Command `\square' already defined.
# 2019aug18
#
#####

# «square-already-defined» (to ".square-already-defined")
# https://tex.stackexchange.com/questions/434903/how-to-solve-latex-error-command-square-already-defined
# https://tex.stackexchange.com/questions/52554/how-to-resolve-conflicts-in-symbol-packages

(/usr/local/texlive/2019/texmf-dist/tex/latex/amsfonts/amsfonts.sty
! LaTeX Error: Command `\square' already defined.




#####
#
# latexmk
# 2019aug25
#
#####

# «latexmk» (to ".latexmk")
# http://personal.psu.edu/jcc8/software/latexmk-jcc/
# (find-tlsh "find * | sort | grep latexmk")
# (find-man "1 latexmk")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/support/latexmk/")
(code-c-d "latexmk" "/usr/local/texlive/2019/texmf-dist/doc/support/latexmk/")
;; (find-latexmkfile "")

;; (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/support/latexmk/latexmk.pdf")
;; (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/support/latexmk/latexmk.pdf")
(code-pdf-page "latexmk" "/usr/local/texlive/2019/texmf-dist/doc/support/latexmk/latexmk.pdf")
(code-pdf-text "latexmk" "/usr/local/texlive/2019/texmf-dist/doc/support/latexmk/latexmk.pdf")
;; (find-latexmkpage)
;; (find-latexmktext)




#####
#
# Amin Bandali's presentation poster
# 2019aug25
#
#####

# «poster-bandali» (to ".poster-bandali")
# https://bandali.eu.org/
# https://bandali.eu.org/publications
# https://bandali.eu.org/publications/cucsc-2017-slides.pdf
# https://bandali.eu.org/publications/eecs4080-poster.pdf
# https://github.com/notbandali/cucsc-2017
# (find-git-links "https://github.com/notbandali/cucsc-2017" "bandali")

# (find-fline "~/LOGS/2019aug25.emacsconf")
# (find-fline "~/LOGS/2019aug25.emacsconf" "Concourse T4")
# https://git.sr.ht/~bandali

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rfv ~/usrc/cucsc-2017/
cd      ~/usrc/
git clone https://github.com/notbandali/cucsc-2017
cd      ~/usrc/cucsc-2017/

git clean -dfx
git reset --hard

git branch --list -a
git for-each-ref
PAGER=cat git log --oneline --graph --all -20

# (find-fline "~/usrc/")
# (find-fline "~/usrc/cucsc-2017/")
# (find-gitk  "~/usrc/cucsc-2017/")

# (code-c-d "bandali" "~/usrc/cucsc-2017/")
# (find-bandalifile "")
# (find-bandalifile "README.md")

cd      ~/usrc/cucsc-2017/slides/
latexmk -xelatex slides.tex
latexmk -xelatex -pvc slides.tex

# (find-bandalifile "slides/slides.tex" "Concourse T4")
# (find-fline "~/LOGS/2019aug25.emacsconf")
# (find-fline "~/LOGS/2019aug25.emacsconf" "Concourse T4")




#####
#
# cases
# 2019sep11
#
#####

# «cases» (to ".cases")
# (find-LATEXgrep "grep --color -nH -e '{cases}' *.tex")
# (find-kopkadaly4page (+ 12 277) "\\begin{cases}")
# (find-kopkadaly4text (+ 12 277) "\\begin{cases}")
# (find-amsldocpage (+ 4 9) "\\begin{cases}")
# (find-amsldoctext (+ 4 9) "\\begin{cases}")
# (find-amsmathpage 36 "\\renewenvironment{cases}")
# (find-amsmathtext 36 "\\renewenvironment{cases}")



#####
#
# pictex
# 2019oct01
#
#####

# «pictex» (to ".pictex")
# (find-tlsh "find * | sort | grep pictex")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/pictexsum/")
(code-c-d      "pictex" "/usr/local/texlive/2019/texmf-dist/doc/latex/pictexsum/")
(code-pdf-page "pictex" "/usr/local/texlive/2019/texmf-dist/doc/latex/pictexsum/pictexsum.pdf")
(code-pdf-text "pictex" "/usr/local/texlive/2019/texmf-dist/doc/latex/pictexsum/pictexsum.pdf")
;; (find-pictexfile "")
;; (find-pictexpage)
;; (find-pictextext)

# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/generic/doc-pictex/Doc-PiCTeX.txt")




#####
#
# DCpic
# 2019oct01
#
#####

# «dcpic» (to ".dcpic")
# (find-angg ".emacs.papers" "dcpic")

# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/generic/dcpic/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/generic/dcpic/dcpic.sty")




#####
#
# foiltex
# 2019nov02
#
#####

# «foiltex» (to ".foiltex")
# (find-tlsh "find * | sort | grep foiltex")
# https://ctan.org/pkg/foiltex?lang=en
# https://github.com/tomfaulkenberry
# https://github.com/tomfaulkenberry/orgFoils





#####
#
# nonstopmode
# 2019nov19
#
#####

# «nonstopmode» (to ".nonstopmode")
# (find-es "tex" "texmaker-planar-has-1")
# (find-texbookpage (+ 12 32) "\\nonstopmode")
# (find-texbooktext (+ 12 32) "\\nonstopmode")
# (find-man "1 tex" "-interaction mode")
# (find-man "1 tex" "-interaction mode" "nonstopmode")
# (find-LATEXfile "2017planar-has-1.tex" "-interaction=nonstopmode")




#####
#
# Using LaTeX as a calculator
# 2020jan22
#
#####

# «calculator» (to ".calculator")
# https://tex.stackexchange.com/questions/248946/using-latex-as-calculator
# https://latex.org/forum/viewtopic.php?t=13544 Simple calculations package
# https://www.texdev.net/2018/12/09/floating-point-calculations-in-latex
# https://stackoverflow.com/questions/1219121/is-there-a-calculator-with-latex-syntax
# The calculator and calculus packages:
#   https://www.tug.org/TUGboat/tb33-3/tb105fuster.pdf
# (find-tlsh "find * | sort | grep xparse")
# (find-tlsh "find * | sort | grep expl3")
# (find-tlsh "find * | sort | grep pgfmath")
# (find-tlsh "find * | sort | grep /fp")
# (find-tlsh "find * | sort | grep /fp/")
# (find-tlsh "find * | sort | grep xfp")
# (find-tlsh "find * | sort | grep minifp")
# (find-tlsh "find * | sort | grep xint")
# (find-tlsh "find * | sort | grep calculator")
# (find-tlsh "find * | sort | grep latexcalc")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/l3packages/xparse/xparse.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/l3packages/xparse/xparse.pdf")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/l3kernel/expl3.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/l3kernel/expl3.pdf")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/fp/documentation.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/fp/documentation.pdf")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/l3packages/xfp/xfp.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/l3packages/xfp/xfp.pdf")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/generic/minifp/minifp.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/generic/minifp/minifp.pdf")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/generic/xint/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/generic/xint/xint.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/generic/xint/xint.pdf")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/calculator/calculator.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/calculator/calculator.pdf")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/fp/")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/fp/")
;; (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/fp/")
(code-c-d "fp" "/usr/local/texlive/2019/texmf-dist/doc/latex/fp/")
(code-c-d "fp" "/usr/local/texlive/2019/texmf-dist/tex/latex/fp/")
(code-pdf-page "fp" "/usr/local/texlive/2019/texmf-dist/doc/latex/fp/documentation.pdf")
(code-pdf-text "fp" "/usr/local/texlive/2019/texmf-dist/doc/latex/fp/documentation.pdf")
;; (find-fpfile "")
;; (find-fppage)
;; (find-fptext)
# (find-fppage 5 "\\FPeval")
# (find-fptext 5 "\\FPeval")





#####
#
# joseph-wright
# 2020jan22
#
#####

# «joseph-wright» (to ".joseph-wright")
# https://www.texdev.net/archive/




#####
#
# typewriter
# 2020jan22
#
#####

# «typewriter» (to ".typewriter")
# https://tex.stackexchange.com/users/1090/david-carlisle
# https://github.com/davidcarlisle/dpctex/tree/master/typewriter
# https://tex.stackexchange.com/questions/344214/use-latex-to-simulate-old-typewriter-written-texts/344272#344272
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/lualatex/typewriter/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/lualatex/typewriter/typewriter-guide.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/lualatex/typewriter/typewriter-guide.pdf")




#####
#
# \lhookdownarrow - a downwards "`->", for hyperdoctrines
# 2020jan29
#
#####

# «lhookdownarrow» (to ".lhookdownarrow")
# «mnsymbol»  (to ".mnsymbol")
# (find-LATEX "2020hyp.tex")

# (find-LATEX "edrx15.sty" "arrows")
# (find-LATEX "edrx15.sty" "arrows" "\\def\\ito{\\hookrightarrow}")
# (find-angg ".emacs.papers" "symbols")
# (find-symbolspage 72 "MnSymbol Arrows")
# (find-symbolstext 72 "MnSymbol Arrows")
# (find-symbolspage 73 "\\lhookdownarrow")
# (find-symbolstext 73 "\\lhookdownarrow")
# (find-tlsh "find * | sort | grep mnsymbol")
# (code-pdf-page "mnsymbol" "/usr/local/texlive/2019/texmf-dist/doc/latex/mnsymbol/MnSymbol.pdf")
# (code-pdf-text "mnsymbol" "/usr/local/texlive/2019/texmf-dist/doc/latex/mnsymbol/MnSymbol.pdf")
# (find-mnsymbolpage)
# (find-mnsymboltext)
# (find-mnsymbolpage 2 "\\lhookdownarrow")
# (find-mnsymboltext 2 "\\lhookdownarrow")


\usepackage{MnSymbol}

\def\dnito{\lhookdownarrow}

$\pmat{A \\ \dnito \\ B \\}
 \psm {A \\ \dnito \\ B \\}
$



#####
#
# mathabx (for a \supset symbol that looks like my \limp)
# 2020feb02
#
#####

# «mathabx» (to ".mathabx")
# (to "limp-abx")
# https://tex.stackexchange.com/questions/14386/importing-a-single-symbol-from-a-different-font
# (find-LATEX "2020mathabx.tex")
# (find-symbolspage 60 "mathabx Subset and Superset Relations")
# (find-symbolstext 60 "mathabx Subset and Superset Relations")
# https://ctan.org/pkg/mathabx
# https://ctan.org/pkg/mathabx-type1
# (find-tlsh "find * | sort | grep -i mathabx")
# (find-tlsh "find * | sort | grep -i mathabx | grep type1")
# (find-tlfile "texmf-dist/doc/fonts/mathabx/")
# (find-tlfile "texmf-dist/doc/fonts/mathabx/" "mathtest.pdf")
# (find-tlfile "texmf-dist/tex/generic/mathabx/")
# (find-tlfile "texmf-dist/tex/generic/mathabx/mathabx.sty")
# (code-pdf-page "mathabx" "/usr/local/texlive/2019/texmf-dist/doc/fonts/mathabx/mathtest.pdf")
# (code-pdf-text "mathabx" "/usr/local/texlive/2019/texmf-dist/doc/fonts/mathabx/mathtest.pdf")
# (find-mathabxpage 5 "Subset's and superset's signs (matha)")
# (find-mathabxtext 5 "Subset's and superset's signs (matha)")
# (find-mathabxpage 12 "\\usepackage")
# (find-mathabxtext 12 "\\usepackage")

# http://www-math.univ-poitiers.fr/~phan/metafont.html#mathabx
# http://www-math.univ-poitiers.fr/~phan/downloads/metafont/mathabx-1.0.tar.gz
# (find-fline "~/usrc/mathabx/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
rm -Rv ~/usrc/mathabx/
mkdir  ~/usrc/mathabx/
cd     ~/usrc/mathabx/
tar -xvzf $S/http/www-math.univ-poitiers.fr/~phan/downloads/metafont/mathabx-1.0.tar.gz

# (code-c-d "mathabxsrc" "~/usrc/mathabx/")
# (find-mathabxsrcfile "")
# (find-mathabxsrcgrep "grep --color -nRH --null -e subset *")
# (find-mathabxsrcgrep "grep --color -nRH --null -e supset *")
# (find-mathabxsrcgrep "grep --color -nRH --null -e \"Subset's\" *")
# (find-mathabxsrcfile "texinputs/mathabx.sty" "\\DeclareFontFamily{U}{matha}")
# (find-mathabxsrcfile "texinputs/mathabx.sty" "\\input mathabx.dcl")
# (find-mathabxsrcfile "texinputs/mathabx.dcl" "Subset's and superset's signs (matha)")

# (find-es "tex" "symbols")
# (find-es "tex" "symbols" "mathabx")
# (find-source2epage (+ 10 217) "\\DeclareMathSymbol")
# (find-source2etext (+ 10 217) "\\DeclareMathSymbol")


\usepackage[matha]{mathabx}

$P \supset Q$

http://www-math.univ-poitiers.fr/~phan/metafont.html#mathabx





#####
#
# mathabx-email
# 2020feb13
#
#####

# «mathabx-email» (to ".mathabx-email")
# https://mail.google.com/mail/ca/u/0/#sent/QgrcJHsblRrqJCwblZPrGZmwLWnGkZnCbPg

"Anthony Phan" <phan@math.univ-poitiers.fr>
Using a single character from Mathabx (the "thin \supset")

Hi Anthony,

is there a simple way to use a single character from Mathabx? To be
more precise, I would like to define

  \thinsupset

to be mathabx's "\supset", that is defined as this in
texinputs/mathabx.dcl:

  \DeclareMathSymbol{\supset}        {3}{matha}{"81}

I've spent some hours trying to understand mathabx.dcl, mathabx.sty,
the definitions of \DeclareFontFamily, \DeclareFontShape,
\DeclareSymbolFont in source2e.pdf, and the section of symbols.tex
that shows that characters from Mathabx - i.e., I tried this, and read
the sources...

  rm -Rv ~/usrc/latex-symbols/
  mkdir  ~/usrc/latex-symbols/
  cd     ~/usrc/latex-symbols/
  cp -v /usr/local/texlive/2019/texmf-dist/doc/latex/comprehensive/source/* .
  pdflatex symbols
  makeindex -s gind.ist symbols
  pdflatex symbols
  pdflatex symbols

but then I had an overdose of undigested/undigestible information and
ran out of mental space... I am the author of this,

  http://angg.twu.net/dednat6.html

but I never had to study the \DeclareFont* commands before...

I can't use \usepackage[matha]{mathabx} because it conflicts with
these \usepackages that I use in most of my .texs,

  \usepackage{amsmath}
  \usepackage{amsfonts}
  \usepackage{amssymb}

both when I use \usepackage[matha]{mathabx} before and after them...

The reason why I only need a "\thinsupset" is that it looks exactly
like the implication symbol in old texts on Logic - and instructions
for producing it would be a nice addition to:

  https://www.logicmatters.net/latex-for-logicians/
  https://www.logicmatters.net/latex-for-logicians/symbols/


Cheers, and (hopefully) thanks in advance,
  Eduardo Ochs
  eduardoochs@gmail.com
  http://angg.twu.net/math-b.html




P.S.: I can provide a detailed bug report on the incompatibility with
the AMS packages with minimal test cases if you want!




#####
#
# Using the \supset char of mathabx as a logical implication symbol
# 2020may02
#
#####

# «limp-abx» (to ".limp-abx")
# (to "mathabx")
# https://tex.stackexchange.com/questions/14386/importing-a-single-symbol-from-a-different-font
# https://mail.google.com/mail/ca/u/0/#sent/KtbxLxghkZDGbdzxHwLhzmMVrDfmDgrPlB
# Put this in the preamble:

% See: (find-es "tex" "limp-abx")
\DeclareFontFamily{U}{matha}{\hyphenchar\font45}
\DeclareFontShape{U}{matha}{m}{n}{
      <5> <6> <7> <8> <9> <10> gen * matha
      <10.95> matha10 <12> <14.4> <17.28> <20.74> <24.88> matha12
      }{}
\DeclareSymbolFont{matha}{U}{matha}{m}{n}
\DeclareMathSymbol{\thinsubset}{3}{matha}{"80}
\DeclareMathSymbol{\thinsupset}{3}{matha}{"81}

% Usage and test (in the body of the document):

\def\limp{\thinsupset}   % See: (find-es "tex" "limp-abx")

$A \limp B {\limp} C_
 {{A \limp B {\limp} C}_
  {A \limp B {\limp} C}}
$


 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/limp/")
rm -Rv /tmp/limp/
mkdir  /tmp/limp/
cd     /tmp/limp/

cat > limptest.tex <<'---'
\documentclass{article}
\DeclareFontFamily{U}{matha}{\hyphenchar\font45}
\DeclareFontShape{U}{matha}{m}{n}{
      <5> <6> <7> <8> <9> <10> gen * matha
      <10.95> matha10 <12> <14.4> <17.28> <20.74> <24.88> matha12
      }{}
\DeclareSymbolFont{matha}{U}{matha}{m}{n}
\DeclareMathSymbol{\thinsubset}{3}{matha}{"80}
\DeclareMathSymbol{\thinsupset}{3}{matha}{"81}
\def\limp{\thinsupset}   % Logical implication
\begin{document}

$A \supset B {\supset} C_
 {{A \supset B {\supset} C}_
  {A \supset B {\supset} C}}
$

$A \limp B {\limp} C_
 {{A \limp B {\limp} C}_
  {A \limp B {\limp} C}}
$

\end{document}
---
pdflatex limptest.tex

# (find-fline "/tmp/limp/")
# (find-pdf-page "/tmp/limp/limptest.pdf")











#####
#
# llncs (for my submission to Diagrams 2020)
# 2020feb06
#
#####

# «llncs» (to ".llncs")
# http://www.diagrams-conference.org/2020/index.php/calls/main-track/
# ftp://ftp.springernature.com/cs-proceeding/llncs/llncs2e.zip
# ftp://ftp.springernature.com/cs-proceeding/svproc/guidelines/Springer_Guidelines_for_Authors_of_Proceedings_CS.pdf

# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/llncsconf/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/llncsconf/example.pdf")
# https://github.com/latextemplates/LNCS
# https://github.com/samfcmc/llncs-article-template/tree/master/llncs2e
# https://github.com/samfcmc/llncs-article-template
# https://tex.stackexchange.com/questions/230889/some-questions-about-llncs2e-class

# (find-fline "$S/ftp/ftp.springernature.com/cs-proceeding/llncs/")
# (find-fline "$S/ftp/ftp.springernature.com/cs-proceeding/llncs/llncs2e.zip")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/llncs/")
rm -Rv ~/usrc/llncs/
mkdir  ~/usrc/llncs/
cd     ~/usrc/llncs/
unzip $S/ftp/ftp.springernature.com/cs-proceeding/llncs/llncs2e.zip

pdflatex samplepaper.tex

# (find-fline "~/usrc/llncs/")
# (code-c-d      "llncs"    "~/usrc/llncs/")
# (code-pdf-page "llncsdoc" "~/usrc/llncs/llncsdoc.pdf")
# (code-pdf-text "llncsdoc" "~/usrc/llncs/llncsdoc.pdf")
# (find-llncsdocpage)
# (find-llncsdoctext)

# (find-llncsfile "")
# (find-llncsfile "samplepaper.tex")
# (find-pdf-page "~/usrc/llncs/samplepaper.pdf")
# (find-pdf-text "~/usrc/llncs/samplepaper.pdf")
# (find-llncsfile "splncs04.bst")






#####
#
# The default for OverLeaf seems to be \nonstopmode
# 2020mar18
#
#####

# «overleaf-nonstopmode» (to ".overleaf-nonstopmode")
# (to "show_and_tracing")
# https://www.overleaf.com/learn/latex/TeX_engine_command_line_options_for_pdfTeX,_XeTeX_and_LuaTeX
#
#  -interaction=STRING     set interaction mode (STRING=batchmode/nonstopmode/
#                          scrollmode/errorstopmode)
#
# (find-texbookpage (+ 12 277) "\\errorstopmode | \\scrollmode")
# (find-texbooktext (+ 12 277) "\\errorstopmode | \\scrollmode")
# (find-texbookpage (+ 12 277) "| \\nonstopmode | \\batchmode")
# (find-texbooktext (+ 12 277) "| \\nonstopmode | \\batchmode")
# (find-sh "pdflatex --help" "-interaction=STRING")




#####
#
# tufte
# 2020apr01
#
#####

# «tufte» (to ".tufte")
# (find-tlsh "find * | sort | grep tufte")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/tufte-latex/")
# (code-pdf-page "tuftebook" "/usr/local/texlive/2019/texmf-dist/doc/latex/tufte-latex/sample-book.pdf")
# (code-pdf-text "tuftebook" "/usr/local/texlive/2019/texmf-dist/doc/latex/tufte-latex/sample-book.pdf")
# (code-pdf-page "tuftehandout" "/usr/local/texlive/2019/texmf-dist/doc/latex/tufte-latex/sample-handout.pdf")
# (code-pdf-text "tuftehandout" "/usr/local/texlive/2019/texmf-dist/doc/latex/tufte-latex/sample-handout.pdf")
# (find-tuftebookpage)
# (find-tuftebooktext)
# (find-tuftehandoutpage)
# (find-tuftehandouttext)

# (find-books "__cats/__cats.el" "bradley")
# (find-psne-arxiv-links "https://arxiv.org/pdf/1809.05923.pdf" "bradleywhatisact")

 (eepitch-shell2)
 (eepitch-kill)
 (eepitch-shell2)
mkdir -p $S/https/arxiv.org/e-print/
cp -v /tmp/1809.05923 $S/https/arxiv.org/e-print/1809.05923.tar
rm -Rv ~/usrc/arxiv-bradleywhatisact/
mkdir  ~/usrc/arxiv-bradleywhatisact/
cd     ~/usrc/arxiv-bradleywhatisact/
tar -xvf $S/https/arxiv.org/e-print/1809.05923.tar

pdflatex What_is_ACT.tex
pdflatex What_is_ACT.tex

# (find-booksgrep "grep --color -nH --null -e bradleywhatisact */*.el")
# (code-c-d "bradleywhatisact" "~/usrc/arxiv-bradleywhatisact/")
# (find-bradleywhatisactfile "")
# (find-bradleywhatisactfile "What_is_ACT.tex")
# (find-bradleywhatisactfile "What_is_ACT.tex" "tufte-handout-tai")

https://news.ycombinator.com/item?id=28775313 Show HN: IndiePaper - An easy way to write and sell self-published books (indiepaper.me)






#####
#
# ebgaramond
# 2020apr07
#
#####

# «ebgaramond» (to ".ebgaramond")
# Used by: (find-es "metapost" "euclid-byrne")
# http://www.georgduffner.at/ebgaramond/
# https://bitbucket.org/georgd/eb-garamond/src
# https://bitbucket.org/georgd/eb-garamond/src/master/
# https://bitbucket.org/georgd/eb-garamond/downloads/
# https://bitbucket.org/georgd/eb-garamond/downloads/EBGaramond-0.016.zip
# (find-fline "$S/https/bitbucket.org/georgd/eb-garamond/downloads/")
# (find-fline "$S/https/bitbucket.org/georgd/eb-garamond/downloads/EBGaramond-0.016.zip")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/usrc/EBGaramond-0.016/")
rm -Rv ~/usrc/EBGaramond-0.016/
mkdir  ~/usrc/EBGaramond-0.016/
unzip -d ~/usrc/ $S/https/bitbucket.org/georgd/eb-garamond/downloads/EBGaramond-0.016.zip
cd     ~/usrc/EBGaramond-0.016/

# (code-c-d "ebgaramond" "~/usrc/EBGaramond-0.016/")
# (find-ebgaramondfile "")
# (find-ebgaramondfile "README.markdown")
# (find-ebgaramondfile "README.xelualatex")



#####
#
# garamond
# 2022nov17
#
#####

# «garamond»  (to ".garamond")
# (find-telegachat "1487862914#207684" "Garamond Premier Pro")
# https://gist.github.com/tvwerkhoven/1119851/500d9b2f2d6de0357e816771f313f485e24be341
# https://mathweb.ucsd.edu/~msharpe/
# https://mathweb.ucsd.edu/~msharpe/mathsamples.pdf
# https://mjsharpe.github.io/tex-software/
# https://tex.stackexchange.com/questions/19898/getting-urw-garamond-and-the-license/20068#20068
# https://tex.stackexchange.com/questions/255709/why-shouldnt-i-use-getnonfreefonts-to-install-additional-fonts-why-shouldnt-i
# https://tex.stackexchange.com/questions/2798/adobe-garamond-pro-not-working-with-xelatex?rq=1
# https://tex.stackexchange.com/questions/57064/glyph-substitution-alternate-capital-q-in-urw-garamond-latex-mac-os-x
# https://tex.stackexchange.com/questions/57825/alternate-q-in-garamond-premier-pro-with-xelatex
# https://tex.stackexchange.com/questions/83707/adobe-garamond-and-latex-linux
# https://tug.org/FontCatalogue/garamond/
# https://www.reddit.com/r/LaTeX/comments/7sd7r8/how_to_use_garamond_in_latex/

# (find-es "x" "fc-list")
# (find-sh "fc-list | sort")
# (find-sh "fc-list | sort | grep -i gara")

[sudo] fc-cache -fv

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
fc-list
fc-list | grep -i gara 

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
ee_dofile "~/LUA/tikz1.lua"  -- (find-anchor "~/LUA/tikz1.lua")
texbody = Dang.from [=[
  \documentclass[landscape,a6paper]{book}
  \begin{document}
  Hello
  <<saysuccess>>
  \end{document}
]=]
show()
 (tikz-show)

texbody = Dang.from [=[
\documentclass{article}
\usepackage{fontspec}
\newopentypefeature{Contextuals}{NoAlternate}{-calt}
\defaultfontfeatures{Kerning=Uppercase,Mapping=tex-text,}
\setmainfont{Garamond Premier Pro}
\begin{document}
  Quad Qed

  \addfontfeatures{Contextuals=NoAlternate}
  Quad Qed
\end{document}
]=]
show()
 (tikz-show)

= Show.log




#####
#
# getnonfreefonts
# 2022nov17
#
#####

# «getnonfreefonts»  (to ".getnonfreefonts")
# http://www.tug.org/fonts/getnonfreefonts/
# https://tug.org/fonts/getnonfreefonts/getnonfreefonts.1.html

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/gnff/")
rm -Rv /tmp/gnff/
mkdir  /tmp/gnff/
cd     /tmp/gnff/
wget https://www.tug.org/fonts/getnonfreefonts/install-getnonfreefonts
sudo texlua install-getnonfreefonts

# (find-man "1 getnonfreefonts")
# (find-sh "getnonfreefonts --help")
sudo getnonfreefonts --sys --lsfonts
sudo getnonfreefonts --sys --all --debug --force --refreshmap
sudo getnonfreefonts --sys --all --refreshmap
# (find-fline "/usr/local/share/texmf")
# (find-fline "/usr/local/share/texmf/doc/man/man1/" "getnonfreefonts.man1.pdf")





#####
#
# unicode-math
# 2020may02
#
#####

# «unicode-math» (to ".unicode-math")
# (find-tlsh "find * | sort | grep unicode-math")
# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unicode-math.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unicode-math.pdf")
# (code-c-d      "unicodemath" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/")
# (code-pdf-page "unicodemath" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unicode-math.pdf")
# (code-pdf-text "unicodemath" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unicode-math.pdf")
# (code-pdf-page "unimathsymbols" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unimath-symbols.pdf")
# (code-pdf-text "unimathsymbols" "/usr/local/texlive/2019/texmf-dist/doc/latex/unicode-math/unimath-symbols.pdf")
# (find-unicodemathfile "")
# (find-unicodemathpage)
# (find-unicodemathtext)
# (find-unimathsymbolspage)
# (find-unimathsymbolstext)

# https://www.unicodeit.net/
# https://qaz.wtf/u/convert.cgi?text=Eu+tambem+uso+este+pra+Fraktur+e+outras+fontes



#####
#
# svg
# 2020may28
#
#####

# «svg» (to ".svg")
# (find-es "inkscape" "export-to-eps-of-pdf")
# https://www.ctan.org/tex-archive/graphics/svg
# https://tex.stackexchange.com/questions/2099/how-to-include-svg-diagrams-in-latex
# http://mirrors.ctan.org/info/svg-inkscape/InkscapePDFLaTeX.pdf
# https://tex.stackexchange.com/questions/158571/includesvg-does-not-detect-svg-file/158612#158612
# https://tex.stackexchange.com/questions/362240/includesvg-cannot-include-svg
# https://stackoverflow.com/questions/42787798/including-svg-into-latex

# (find-tlsh "find * | sort | grep svg")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/svg/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/svg-inkscape/")
(code-pdf-page "svginkscape" "/usr/local/texlive/2019/texmf-dist/doc/latex/svg-inkscape/InkscapePDFLaTeX.pdf")
(code-pdf-text "svginkscape" "/usr/local/texlive/2019/texmf-dist/doc/latex/svg-inkscape/InkscapePDFLaTeX.pdf")
# (find-svginkscapepage)
# (find-svginkscapetext)
# (find-svginkscapepage 2 "2.4.1. Using Inkscape's command line")
# (find-svginkscapetext 2 "2.4.1. Using Inkscape's command line")

(code-c-d      "svg" "/usr/local/texlive/2019/texmf-dist/doc/latex/svg/")
(code-pdf-page "svg" "/usr/local/texlive/2019/texmf-dist/doc/latex/svg/svg.pdf")
(code-pdf-text "svg" "/usr/local/texlive/2019/texmf-dist/doc/latex/svg/svg.pdf")
;; (find-svgfile "")
;; (find-svgpage)
;; (find-svgtext)





#####
#
# fira
# 2020jun03
#
#####

# «fira» (to ".fira")
# https://tug.org/FontCatalogue/firasansextralight/

# (find-tlsh "find * | sort | grep -i firasans")
# (find-tlsh "find * | sort | grep -i firasans | grep pdf")
# (find-tlsh "find * | sort | grep    FiraSans")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/fonts/fira/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/fonts/fira/README")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/fonts/fira/fira-samples.tex")
# (find-fline "/usr/local/texlive/2019/texmf-dist/tex/latex/fira/FiraSans.sty")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/fonts/fira/fira-samples.pdf")


\usepackage[sfdefault,extralight]{FiraSans} %% option 'sfdefault' activates Fira Sans as the default text font
\usepackage[T1]{fontenc}
\renewcommand*\oldstylenums[1]{{\firaoldstyle #1}}

\usepackage[sfdefault,extralight]{FiraSans}  % (find-es "tex" "fira")
\usepackage{lipsum}
%
% \begin{document}

\subsection*{ExtraLight}

Hello Q$\forall\exists$

{\firaextralight \lipsum[7]}

{\firaextralight \textit{\lipsum[9]}}

\subsection*{UltraLight}

{\firaultralight \lipsum[7]}

{\firaultralight \textit{\lipsum[9]}}

\subsection*{Thin}
{\firathin \lipsum[10]}

{\firathin \textit{\lipsum[12]}}

Hello





#####
#
# pythontex
# 2020jun06
#
#####

# «pythontex» (to ".pythontex")
# https://ctan.org/pkg/pythontex
# https://www.tug.org/TUGboat/tb34-3/tb108mertz.pdf
# https://tug.org/TUGboat/tb37-2/tb116poore.pdf

(code-pdf-page "pythontexgi" "$S/https/www.tug.org/TUGboat/tb34-3/tb108mertz.pdf")
(code-pdf-text "pythontexgi" "$S/https/www.tug.org/TUGboat/tb34-3/tb108mertz.pdf")
(code-pdf-page "pythontexa"  "$S/https/tug.org/TUGboat/tb37-2/tb116poore.pdf")
(code-pdf-text "pythontexa"  "$S/https/tug.org/TUGboat/tb37-2/tb116poore.pdf")
;; (find-pythontexgipage)
;; (find-pythontexgitext)
;; (find-pythontexgipage 1 "pdflatex -interaction nonstopmode")
;; (find-pythontexgitext 1 "pdflatex -interaction nonstopmode")
;; (find-pythontexgipage 2 "\\begin{pycode}")
;; (find-pythontexgitext 2 "\\begin{pycode}")

;; (find-pythontexapage)
;; (find-pythontexatext)

# (find-tlsh "find * | sort | grep pythontex")

(code-c-d      "pythontex"  "/usr/local/texlive/2019/texmf-dist/doc/latex/pythontex/")
(code-pdf-page "pythontex"  "/usr/local/texlive/2019/texmf-dist/doc/latex/pythontex/pythontex.pdf")
(code-pdf-text "pythontex"  "/usr/local/texlive/2019/texmf-dist/doc/latex/pythontex/pythontex.pdf")
(code-pdf-page "pythontexg" "/usr/local/texlive/2019/texmf-dist/doc/latex/pythontex/pythontex_gallery.pdf")
(code-pdf-text "pythontexg" "/usr/local/texlive/2019/texmf-dist/doc/latex/pythontex/pythontex_gallery.pdf")
(code-pdf-page "pythontexq" "/usr/local/texlive/2019/texmf-dist/doc/latex/pythontex/pythontex_quickstart.pdf")
(code-pdf-text "pythontexq" "/usr/local/texlive/2019/texmf-dist/doc/latex/pythontex/pythontex_quickstart.pdf")
;; (find-pythontexfile "")
;; (find-pythontexpage)
;; (find-pythontextext)
;; (find-pythontexgpage)
;; (find-pythontexgtext)
;; (find-pythontexqpage)
;; (find-pythontexqtext)




#####
#
# unravel
# 2020jun06
#
#####

# «unravel» (to ".unravel")
# (find-tlsh "find * | sort | grep unravel")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/unravel/")
(code-pdf-page "unravel" "/usr/local/texlive/2019/texmf-dist/doc/latex/unravel/unravel.pdf")
(code-pdf-text "unravel" "/usr/local/texlive/2019/texmf-dist/doc/latex/unravel/unravel.pdf")
;; (find-unravelpage)
;; (find-unraveltext)



#####
#
# bm
# 2020jul15
#
#####

# «bm»  (to ".bm")
# (find-tlsh "find * | sort | grep /bm")
# (find-tlsh "find * | sort | grep /bm.sty")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/")
# (code-pdf-page "bm" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/bm.pdf")
# (code-pdf-text "bm" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/bm.pdf")
# (find-bmpage)
# (find-bmtext)



#####
#
# microtype
# 2020jul18
#
#####

# «microtype»  (to ".microtype")
# (find-tlsh "find * | sort | grep microtype")
# (find-dednat6file "tugboat-rev2.tex" "microtype")

;; (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/microtype/")
(code-c-d "microtype" "/usr/local/texlive/2019/texmf-dist/doc/latex/microtype/")
(code-pdf-page "microtype" "/usr/local/texlive/2019/texmf-dist/doc/latex/microtype/microtype.pdf")
(code-pdf-text "microtype" "/usr/local/texlive/2019/texmf-dist/doc/latex/microtype/microtype.pdf")
;; (find-microtypepage)
;; (find-microtypetext)
;; (find-microtypefile "")




#####
#
# The TUG 2020 meeting (online)
# 2020jul25
#
#####

# «TUG2020»  (to ".TUG2020")
# https://tug.org/tug2020/
# https://tug.org/tug2020/program.html
# https://www.youtube.com/watch?v=JU7AqC-HHP4
# https://latex-ninja.com/
# https://topanswers.xyz/tex
# https://www.latex-tutorial.com/
# https://www.latex-tutorial.com/tutorials/





#####
#
# Paul Blain Levy: macros for mgsfastlam
# 2020aug16
#
#####

# «paul-blain-levy-macros»  (to ".paul-blain-levy-macros")
# https://mail.google.com/mail/ca/u/0/#sent/QgrcJHsbgZLxRWZbgZRbkPBhVLwTwhPGmdb
# (find-books "__comp/__comp.el" "levy-slides2018")
# (find-pbl2018page  8 "Typing rules for bool")
# (find-pbl2018text  8 "Typing rules for bool")
# (find-fline "~/LEVY/")
# (find-fline "~/LEVY/mgsfastlam.tex" "\\begin{prooftree}")
# (find-fline "~/LEVY/mgsfastlam.tex" "Typing rules for $\\ttbool$")
# (find-fline "~/LEVY/mgsfastlam.tex" "Typing rules for $\\ttbool$" "Elimination")
# (find-fline "~/LEVY/mymacros.tex" "\\ttmm")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
cd ~/LEVY/
pdflatex mgsfastlam.tex

Thanks!

They are a bit lower-level than I expected but your conventions for
typesetting words in \mathtt with accompanying whitespace are much
more elegant than my attempts to do something similar, that were quite
messy... I'm sure that they will save me several hours of work.

  Cheers =),
    E.




#####
#
# minted - highlighted source code for LaTeX
# 2020dec24
#
#####

# «minted»  (to ".minted")
# (find-es "minted" "git")
# (find-es "python" "pygments")
# (find-tlsh "find * | sort | grep minted")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/minted/")
# (find-fline "/usr/local/texlive/2019/texmf-dist/doc/latex/minted/README")
# (code-pdf-page "minted" "/usr/local/texlive/2019/texmf-dist/doc/latex/minted/minted.pdf")
# (code-pdf-text "minted" "/usr/local/texlive/2019/texmf-dist/doc/latex/minted/minted.pdf")
# (find-mintedpage)
# (find-mintedtext)

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
w minted

https://tex.stackexchange.com/questions/458627/how-do-i-display-unicode-characters-with-minted




#####
#
# chinese
# 2020dec29
#
#####

# «chinese»  (to ".chinese")
# (find-tlsh "find * | sort | grep foo")
# (find-tlsh "find * | sort | grep -i cjk")
# (find-tlsh "find * | sort | grep -i chinese")
# (find-LATEX "2020chinese.tex")
# https://www.tug.org/TUGboat/tb24-3/wong.pdf

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "/tmp/lshort-chinese-src/")
rm -Rv /tmp/lshort-chinese-src/
mkdir  /tmp/lshort-chinese-src/
cd     /tmp/lshort-chinese-src/
cp -iv /usr/local/texlive/2019/texmf-dist/doc/latex/lshort-chinese/src/* .
grep usepackage *.tex *.sty
make  |& tee om




#####
#
# reledmac
# 2021jun07
#
#####

# «reledmac»  (to ".reledmac")
# (find-tlsh "find * | sort | grep reledmac")
# (code-c-d "reledmac" "/usr/local/texlive/2019/texmf-dist/doc/latex/reledmac/")
# (find-reledmacfile "")
# (find-reledmacfile "examples/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/latex/reledmac/reledmac.pdf")
# (find-pdf-text "/usr/local/texlive/2019/texmf-dist/doc/latex/reledmac/reledmac.pdf")
# (code-pdf-page "reledmac" "/usr/local/texlive/2019/texmf-dist/doc/latex/reledmac/reledmac.pdf")
# (code-pdf-text "reledmac" "/usr/local/texlive/2019/texmf-dist/doc/latex/reledmac/reledmac.pdf")
# (find-reledmacpage)
# (find-reledmactext)




#####
#
# standalone
# 2021aug20
#
#####

# «standalone»  (to ".standalone")
# (find-es "xournal" "latex")
# (find-tlsh "find * | sort | grep standalone")
# (find-tlfile "")

(code-c-d      "standalone" "/usr/local/texlive/2019/texmf-dist/doc/latex/standalone/")
(code-pdf-page "standalone" "/usr/local/texlive/2019/texmf-dist/doc/latex/standalone/standalone.pdf")
(code-pdf-text "standalone" "/usr/local/texlive/2019/texmf-dist/doc/latex/standalone/standalone.pdf")
;; (find-standalonefile "")
;; (find-standalonefile "README")
;; (find-standalonepage)
;; (find-standalonetext)
# (find-standalonepage 11 "varwidth=width")
# (find-standalonetext 11 "varwidth=width")

# (find-LATEX "2021standalone.tex")

# https://sourceforge.net/p/standalone/tickets/5/




#####
#
# currfile
# 2021aug29
#
#####

# «currfile»  (to ".currfile")
# https://mail.google.com/mail/ca/u/0/#inbox/FMfcgzGkbDVrfBwrVPXGfQmjclCBQzlc
# (find-tlsh "find * | sort | grep currfile")
# (find-tlsh "find * | sort | grep kvoptio")
# (code-c-d      "currfile" "/usr/local/texlive/2019/texmf-dist/tex/latex/currfile/")
# (code-pdf-page "currfile" "/usr/local/texlive/2019/texmf-dist/doc/latex/currfile/currfile.pdf")
# (code-pdf-text "currfile" "/usr/local/texlive/2019/texmf-dist/doc/latex/currfile/currfile.pdf")
# (find-currfilefile "")
# (find-currfilefile "currfile-abspath.sty")
# (find-currfilefile "currfile.sty")
# (find-currfilepage)
# (find-currfiletext)

# (code-pdf-page "kvoptions" "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/kvoptions.pdf")
# (code-pdf-text "kvoptions" "/usr/local/texlive/2019/texmf-dist/doc/latex/oberdiek/kvoptions.pdf")
# (find-kvoptionspage)
# (find-kvoptionstext)



#####
#
# memoir
# 2021oct28
#
#####

# «memoir»  (to ".memoir")
# (find-tlsh "find * | sort | grep memoir")
# (find-tlfile "texmf-dist/doc/latex/memoir/")

# https://agrothendieck.github.io/divers/ps.pdf PURSUING STACKS
# https://github.com/thescrivener/PursuingStacks




#####
#
# mathchoice
# 2022feb14
#
#####

# «mathchoice»  (to ".mathchoice")
# (find-texbookpage (+ 12 151) "\\mathchoice")
# (find-texbooktext (+ 12 151) "\\mathchoice")
$$\mathchoice{a}{b}{c}{d} = \D \int_{\mathchoice{a}{b}{c}{d}} {\mathchoice{a}{b}{c}{d}} \, dx$$




#####
#
# natbib
# 2022mar08
#
#####

# «natbib»  (to ".natbib")
# (find-tlsh "find * | sort | grep natbib")
# (find-tlfile "texmf-dist/doc/latex/natbib/")
# (find-tlfile "texmf-dist/doc/latex/natbib/README.1st")
# (find-tlfile "texmf-dist/doc/latex/natbib/README.v831b")
# (code-pdf-page "natbib" "/usr/local/texlive/2019/texmf-dist/doc/latex/natbib/natnotes.pdf")
# (code-pdf-text "natbib" "/usr/local/texlive/2019/texmf-dist/doc/latex/natbib/natnotes.pdf")
# (find-natbibpage)
# (find-natbibtext)




#####
#
# meteor
# 2022mar08
#
#####

# «meteor»  (to ".meteor")
# (find-LATEXfile "2022meteor-test1.tex")
# (find-fline "~/METEOR/" "meteor_LaTeX_Template.zip")
# (find-fline "~/METEOR/tmp/")
# (find-fline "~/METEOR/tmp/chapter.bib")
# (find-fline "~/METEOR/tmp/chapter.bib.orig")
# (find-pdf-page "~/METEOR/tmp/chapter.pdf")
# (find-pdf-text "~/METEOR/tmp/chapter.pdf")
# (find-fline "~/METEOR/tmp/chapter.tex" "Springer SocPsych Style")
# (find-fline "~/METEOR/tmp/chapter.tex" "% For bibtex users:")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
# (find-fline "~/METEOR/tmp/")
rm -Rv ~/METEOR/tmp/
mkdir  ~/METEOR/tmp/
cd     ~/METEOR/tmp/
unzip  ~/METEOR/meteor_LaTeX_Template.zip

mv -v chapter.bib chapter.bib.orig
grep -v '^%' chapter.bib.orig > chapter.bib

pdflatex chapter.tex
bibtex   chapter
pdflatex chapter.tex




#####
#
# The Springer SocPsych Style
# 2022mar09
#
#####

# «socpsych»  (to ".socpsych")
# https://endnote.com/style_download/springer-socpsych-style/
# http://www.springer.com/cda/content/document/cda_downloaddocument/Key_Style_Points_SocPsychRef.pdf
# https://citationsy.com/styles/springer-socpsych-author-date





#####
#
# complex-tables
# 2022mar14
#
#####

# «complex-tables»  (to ".complex-tables")
# (find-LATEX "2022-plano-de-atividades-C2.tex")
# (find-LATEX "2022-plano-de-atividades-C3.tex")
https://tex.stackexchange.com/questions/164945/creating-complex-tables-with-multicolumn-on-different-lines-on-latex
https://www.youtube.com/watch?v=AZxBfKZunOw
https://www.youtube.com/watch?v=y7B7FbnJbas LaTex Tutorial 8: Advanced Tables
https://texblog.org/2012/12/21/multi-column-and-multi-row-cells-in-latex-tables/

# (code-pdf-page "tabularx" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/tabularx.pdf")
# (code-pdf-text "tabularx" "/usr/local/texlive/2019/texmf-dist/doc/latex/tools/tabularx.pdf")
# (find-tabularxpage)
# (find-tabularxtext)

# (find-tlsh "find * | sort | grep array")
# (find-tlsh "find * | sort | grep array | grep pdf")
# (find-tlsh "find * | sort | grep tabular")
# (find-tlsh "find * | sort | grep tabular | grep pdf")
# (find-tlsh "find * | sort | grep table")
# (find-tlsh "find * | sort | grep table | grep pdf")



#####
#
# multiple-pdfs
# 2022jul24
#
#####

# «multiple-pdfs»  (to ".multiple-pdfs")
# https://statatexblog.com/2021/02/12/produce-multiple-pdfs-in-latex-with-automated-cross-references/
# https://stackoverflow.com/questions/61875918/create-multiple-pdf-files-from-same-tex-file
# https://tex.stackexchange.com/questions/513320/output-to-multiple-pdf-documents-using-lualatex-and-toggles




#####
#
# noto
# 2022sep07
#
#####

# «noto»  (to ".noto")
# (find-tlsh "find * | sort | grep noto")
# (find-tlsh "find * | sort | grep /noto")
# https://tug.org/pipermail/tex-live/2022-September/048422.html noto
# https://tug.org/pipermail/tex-live/2022-September/048424.html collection-fontsextra
# https://ctan.org/pkg/noto
# (code-c-d "noto" "/usr/local/texlive/2019/texmf-dist/doc/fonts/noto/")
# (find-notofile "")
# (find-notofile "noto-samples.tex")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/fonts/noto/noto-samples.pdf")
# (find-sh "locate collection-fontsextra")



#####
#
# emoji
# 2022sep23
#
#####

# «emoji»  (to ".emoji")
# http://mirrors.ctan.org/macros/luatex/latex/emoji/emoji-doc.pdf
# (find-tlsh "find * | sort | grep emoji")
(find-angg ".emacs" "texlive")
# (code-c-d "tl"        "/usr/local/texlive/2019/")
# (code-c-d "tl"        "/usr/local/texlive/2021/")
# (find-tlfile "texmf-dist/doc/latex/emoji/")
(code-pdf-page "emoji" "/usr/local/texlive/2021/texmf-dist/doc/latex/emoji/emoji-doc.pdf")
(code-pdf-text "emoji" "/usr/local/texlive/2021/texmf-dist/doc/latex/emoji/emoji-doc.pdf")
# (find-emojipage)
# (find-emojitext)
# (find-emojipage 3 "slightly-smiling-face")
# (find-emojitext 3 "slightly-smiling-face")

\usepackage{emoji}                % (find-es "tex" "emoji")

# \emoji{slightly-smiling-face}
# \emoji{upside-down-face}




https://github.com/alecjacobson/coloremoji.sty





#####
#
# \edef
# 2022oct31
#
#####

# «edef»  (to ".edef")
# (find-texbookpage (+ 12 215) "\\edef")
# (find-texbooktext (+ 12 215) "\\edef")
# (find-texbookpage (+ 12 215) "\\edef\\a{\\double\\a}")
# (find-texbooktext (+ 12 215) "\\edef\\a{\\double\\a}")
# (find-texbookpage (+ 12 216) "\\toks0={\\c} \\edef\\a{\\b\\the\\toks0 \\d}")
# (find-texbooktext (+ 12 216) "\\toks0={\\c} \\edef\\a{\\b\\the\\toks0 \\d}")
# (find-luatexrefpage (+ 4 30) "\\toks0\\expandafter{\\the\\toks0 foo}")
# (find-luatexreftext (+ 4 30) "\\toks0\\expandafter{\\the\\toks0 foo}")
# (find-luatexrefpage (+ 4 190) "tex.toks")
# (find-luatexreftext (+ 4 190) "tex.toks")
# (find-luatexrefpage (+ 4 211) "scan_toks")
# (find-luatexreftext (+ 4 211) "scan_toks")




#####
#
# \expandafter
# 2022oct28
#
#####

# «expandafter»  (to ".expandafter")
# (find-LATEXgrep "grep --color=auto -nH --null -e expandafter *.tex")
# (find-dn6 "preamble6.lua" "preamble1" "\\expandafter")
# (find-texbookpage (+ 12 213) "\\expandafter")
# (find-texbooktext (+ 12 213) "\\expandafter")
# https://tex.stackexchange.com/questions/451/when-to-use-edef-noexpand-and-expandafter
# https://tex.stackexchange.com/questions/451/when-to-use-edef-noexpand-and-expandafter#comment19724_451 \@expandtwoargs
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work%3A_An_introduction_to_TeX_tokens
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work%3A_The_meaning_of_expansion
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work:_TeX_uses_temporary_token_lists
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work:_From_basic_principles_to_exploring_TeX%27s_source_code
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work:_A_detailed_macro_case_study
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work:_A_detailed_study_of_consecutive_%5Cexpandafter_commands
# https://www.overleaf.com/learn/latex/Articles/How_does_%5Cexpandafter_work%3A_A_detailed_study_of_consecutive_%5Cexpandafter_commands
# https://www.overleaf.com/learn/latex/A_six-part_series%3A_How_do_TeX_macros_actually_work%3F
# https://en.wikibooks.org/wiki/TeX/expandafter
# http://www.tug.org/TUGboat/Articles/tb09-1/tb20bechtolsheim.pdf

# (find-source2epage (+ 11 42) "\\@expandtwoargs")
# (find-source2etext (+ 11 42) "\\@expandtwoargs")
# (find-macros2epage 6 "\\@expandtwoargs")
# (find-macros2etext 6 "\\@expandtwoargs")

# (find-sh "locate macros2e")
# (find-tlsh "find * | sort | grep macros2e")
;; (find-macros2etext)


 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
ee_dofile "~/LUA/tikz1.lua"
repl = repl2
savetex()

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
  cd /tmp/ && lualatex tikz1.tex
texrun [=[ \def\bla{BLA} ]=]
= getmeaning("bla")


Andrew, just because I saw your example above: I recently discovered the LaTeX2e macro \@expandtwoargs\command{<arg1>}{<arg2>} which expands the two arguments using \edef before feeding it to \command. – 
Martin Scharrer
 Feb 15, 2011 at 17:38




#####
#
# sile
# 2022nov03
#
#####

# «sile»  (to ".sile")
# https://news.ycombinator.com/item?id=33449323 Sile: A Modern Rewrite of TeX (sile-typesetter.org)
# https://tug.org/TUGboat/tb38-1/tb118cozens.pdf SILE: A new typesetting system
# https://sile-typesetter.org/what-is-sile/
# http://www.youtube.com/watch?v=5BIP_N9qQm4 Introducing SILE: A New Typesetting System
# http://www.youtube.com/watch?v=t_kk20vlamo Simon Cozens - Global typesetting with SILE
# http://www.eprg.org/G53DOC/pdfs/knuth-plass-breaking.pdf
# https://cs.stanford.edu/~knuth/selected.html



#####
#
# monospaced
# 2022nov27
#
#####

# «monospaced»  (to ".monospaced")
# https://en.wikipedia.org/wiki/Monospaced_font
# https://tug.org/FontCatalogue/typewriterfonts.html
# https://tug.org/FontCatalogue/europeancomputermodernteletype/
# https://tug.org/FontCatalogue/computermodernteletype/
# https://tug.org/FontCatalogue/computermodernteletype/computermodernteletype.pdf
# https://tug.org/FontCatalogue/computermodernteletype/computermodernteletype.tex
# (find-fline "$S/https/tug.org/FontCatalogue/")

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
fcat_0  () { echo  https://tug.org/FontCatalogue/$1/; }
fcat_0l () { echo $S/https/tug.org/FontCatalogue/$1/; }
fcat_1  () { echo  https://tug.org/FontCatalogue/$1/$1.tex; }
fcat_1l () { echo $S/https/tug.org/FontCatalogue/$1/$1.tex; }
fcat_2  () { echo  https://tug.org/FontCatalogue/$1/$1.pdf; }
fcat_dl () {
  $2 mkdir -pv $(fcat_0l $1)
  $2 cd        $(fcat_0l $1)
  $2 wget -nc  $(fcat_1  $1)
  $2 ls -lAF   $(fcat_1l $1)
}
fcat_fpp () {
  echo "# (find-pdf-page \"~/usrc/FontCatalogue/$1.pdf\")"
}
fcat_try () {
  fcat_dl         $1
  cd     ~/usrc/FontCatalogue/
  cp -v $(fcat_1l $1) .
  pdflatex        $1.tex
  fcat_fpp        $1
}

# (find-fline "~/usrc/FontCatalogue/")
rm -Rv ~/usrc/FontCatalogue/
mkdir  ~/usrc/FontCatalogue/
cd     ~/usrc/FontCatalogue/
fcat_try computermodernteletype
fcat_try europeancomputermodernteletype
# (find-pdf-page "~/usrc/FontCatalogue/computermodernteletype.pdf")
# (find-pdf-page "~/usrc/FontCatalogue/europeancomputermodernteletype.pdf")

fcat_try lettergothic
# ! LaTeX Error: File `ulgothic.sty' not found.


https://tug.org/FontCatalogue/lettergothic/



#####
#
# reference-cards
# 2022dec09
#
#####

# «reference-cards»  (to ".reference-cards")
# https://lists.gnu.org/archive/html/help-gnu-emacs/2022-12/msg00255.html Jean Louis: reference cards
# https://tex.stackexchange.com/questions/99765/document-class-for-reference-cards
# https://michaelgoerz.net/refcards/
# https://stackoverflow.com/questions/1911516/how-to-make-cheat-sheets-in-latex
# http://clqr.boundp.org/index.html
# http://clqr.boundp.org/clqr-a4-booklet-all.pdf




#####
#
# mdframed
# 2022dec16
#
#####

# «mdframed»  (to ".mdframed")
# (find-tlsh "find * | sort | grep mdframed")
# (code-c-d      "mdframed" "/usr/local/texlive/2019/texmf-dist/doc/latex/mdframed/")
# (code-pdf-page "mdframed" "/usr/local/texlive/2019/texmf-dist/doc/latex/mdframed/mdframed.pdf")
# (code-pdf-text "mdframed" "/usr/local/texlive/2019/texmf-dist/doc/latex/mdframed/mdframed.pdf")
# (find-mdframedfile "")
# (find-mdframedpage)
# (find-mdframedtext)




#####
#
# debug-chapter
# 2023jan08
#
#####

# «debug-chapter»  (to ".debug-chapter")
# (to "edrxheadfoot-Show2")
# (find-angg "LUA/Repl2.lua" "getmeaning-tests")
# (find-fline "~/LATEX/2022on-the-missing.aux")

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
ee_dofile "~/LUA/tikz1.lua"  -- (find-anchor "~/LUA/tikz1.lua")
hello = [[
  \chapter{A}
  \chapter{B}
  \chapter{C}
]]
show()
 (tikz-show)

 (eepitch-lua51)
 (eepitch-kill)
 (eepitch-lua51)
ee_dofile "~/LUA/tikz1.lua"  -- (find-fline "~/LUA/tikz1.lua")
hello = [[
  \chapter{A}
  \chapter{B}
  \chapter{C}
]]
repl = repl2
savetex()

 (eepitch-shell)
 (eepitch-kill)
 (eepitch-shell)
  cd /tmp/ && lualatex tikz1.tex
printmeaning("newpage")
printmeaning("chapter")
printmeaning("secdef")
printmeaning("@chapter")
printmeaning("@schapter")
printmeaning("addcontentsline")




#####
#
# \sa and \ga
# 2023jul15
#
#####

# «sa-and-ga»  (to ".sa-and-ga")
# (find-LATEX "edrx21.sty" "sa-and-ga")

\def\sa#1#2{\expandafter\def\csname myarg#1\endcsname{#2}}
\def\ga#1{\csname myarg#1\endcsname}




#####
#
# \ensuremath
# 2023oct07
#
#####

# «ensuremath»  (to ".ensuremath")
# (find-kopkadaly4page (+ 12 541) "\\ensuremath{math cmds}")
# (find-kopkadaly4text (+ 12 541) "\\ensuremath{math cmds}")
# (find-source2epage (+ 10 288) "\\ensuremath")
# (find-source2etext (+ 10 288) "\\ensuremath")
# (find-LATEX "edrx21.sty" "myvcenter")





#####
#
# box-drawing-chars
# 2023nov26
#
#####

# «box-drawing-chars»  (to ".box-drawing-chars")
# (find-angg ".emacs.papers" "symbols")
# (find-sh "locate pmbox")
# https://tex.stackexchange.com/questions/281368/print-box-drawing-characters-with-pdflatex
# https://github.com/sphinx-doc/sphinx/issues/3706 LaTeX: automatic replacement of Unicode BOX DRAWINGS characters (and arguably others too) should be skipped with lualatex and xelatex #3706
# https://copyprogramming.com/howto/how-to-use-block-box-drawing-characters-in-latex
# https://stackoverflow.com/questions/54718201/unicode-box-drawing-does-not-render-correctly-in-browsers



#####
#
# visible-space
# 2024jan22
#
#####

# «visible-space»  (to ".visible-space")
# (find-kopkadaly4page (+ 12 463) "\\textvisiblespace")
# (find-kopkadaly4text (+ 12 463) "\\textvisiblespace")
# (find-symbolspage 14 "\\textvisiblespace")
# (find-symbolstext 14 "\\textvisiblespace")
# (find-texbookpage (+ 12 420) "visible space")
# (find-texbooktext (+ 12 420) "visible space")



# (find-tlsh "find * | sort | grep transparent")









# https://ctan.org/pkg/theatre?lang=en
# https://ctan.org/pkg/drama?lang=en
# (find-tlsh "find * | sort | grep theater")
# (find-tlsh "find * | sort | grep drama")
# (find-tlsh "find * | sort | grep dramatist")




# (find-fline    "/usr/share/doc/texlive-doc/latex/amscls/")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/amscls/amsdtx.pdf")

# (find-zsh "dmissing testmath")
# (find-fline    "/usr/share/doc/texlive-doc/latex/amsmath/")
# (find-pdf-page "/usr/share/doc/texlive-doc/latex/amsmath/testmath.pdf")


# (find-fline "/usr/share/texlive/texmf-dist/tex/latex/amsmath/")

;; (find-fline "/usr/share/doc/texlive-doc/latex/amsmath/")
;; (find-amsmathpage)
;; (find-amsmathtext)










\newlinechar=`^^J
\showthe\newlinechar
\newlinechar=-1
\showthe\newlinechar
%
\message{\the\newlinechar}


\message{Hello bar}
\message{Hello \the\wd0 bar}
\message{Hello \the\wd0{} bar}
\message{Hello \the\wd0\space bar}
\message{Hello \the\wd0\space bar foo}
\message{Hello \the\wd0\spac\spac bar foo}
\message{Hello \the\wd0\spac\spac bar f\nl oo}


# (find-texbookfile "texbook.tex" "&plain \\input story")
# (find-texbookfile "texbook.tex" "nonstopmode")

# (find-es "tex" "show_and_tracing")
# (find-plainsrcfile "plain.tex" "\\def\\space{ }")


{\catcode`\^^M=\active % these lines must end with %
  \gdef\obeylines{\catcode`\^^M\active \let^^M\par}%


% (find-texbookfile "texbook.tex" "^\\<integer parameter>" "^|\\newlinechar|")

http://edition.cnn.com/2009/WORLD/meast/05/08/kentucky.iraq.soldier.rape/index.html?iref=mpstoryview






# (find-lsrcgrep "grep -nH -e scriptsize base/*")
# (find-lsrcfile "base/classes.dtx" "\\begin{macro}{\\scriptsize}")



# (find-fline "/usr/share/texmf-tetex/source/latex/amslatex/math/")
/usr/share/texmf-tetex/source/latex/amslatex/math/amsmath.dtx
/usr/share/texmf-tetex/source/latex/amslatex/math/amsmath.sty
/usr/share/texmf-tetex/source/latex/amsmath/
/usr/share/texmf-tetex/source/latex/amsmath/00readme.txt
/usr/share/texmf-tetex/source/latex/amsmath/amsbsy.dtx










lucida
charter

#
# (eev-bounded)
cd /usr/share/texmf/source/latex/
# grep -i lucida $(find * -type f)
# grep -i charter $(find * -type f)
grep -i declarefixedfont $(find * -type f)

#
# (find-lsrcfile "psnfss/00readme.txt" "Charter")
# (find-lsrcfile "psnfss/psnfss2e.tex")
# (find-lsrcfile "psnfss/psnfss2e.tex" "\\caption{Font shapes supported")
# (find-pspage (ee-lsrcfile "psnfss/psnfss2e.pdf") 9)


http://www.accesspdf.com/pdftk/


# (find-fline "/usr/share/doc/texmf/tetex/")
# (find-fline "/usr/share/doc/texmf/tetex/TETEXDOC.tex.gz")
zxdvi /usr/share/doc/texmf/tetex/TETEXDOC.dvi.gz

# (find-fline "/usr/doc/texmf/")

# (find-fline "/usr/doc/texmf/help/faq/uktug-faq/")
# (find-w3 "/usr/doc/texmf/help/faq/uktug-faq/index.html")
# (find-w3 "/usr/doc/texmf/index.html")

# (find-fline "/usr/bin/MakeTeXPK")
# (find-fline "/usr/bin/mktexmf")
# (find-fline "/usr/bin/mktexpk")

# (find-status "mime-support")
# (find-vldifile "mime-support.list")
# (find-fline "/usr/doc/mime-support/")
# (find-fline "/usr/doc/mime-support/mailcap.txt.gz")

http://truben.no/latex/table/
http://www.youtube.com/watch?v=yplX3pYWlPo Steve Jobs
http://www.anovaordemmundial.com/2009/09/filme-o-mundo-segundo-monsanto.html


http://tug.org/TUGboat/Contents/contents34-1.html
https://www.ctan.org/pkg/quattrocento
https://www.vice.com/pt_br/article/jpn9v7/camille-paglia-discute-o-feminismo-contemporaneo

https://tex.stackexchange.com/questions/413770/how-to-control-the-vertical-skip-of-a-boxed-text

https://github.com/wspr/unicode-math/issues/


{
  # Unpack the zip file /tmp/ochs-planar-has.zip
  # in a clean directory
  rm -Rfv /tmp/ochs-planar-has/
  mkdir   /tmp/ochs-planar-has/
  cd      /tmp/ochs-planar-has/
  unzip   /tmp/ochs-planar-has.zip

  # Remake the PDF (using the Makefile):
  make veryclean
  make pdf         2>&1 | tee omp
  make clean
}



https://www.overleaf.com/blog/tex-live-upgrade-september-2019

https://tex.stackexchange.com/questions/13809/resizing-a-table-by-textheight
https://tex.stackexchange.com/users/2388/ulrike-fischer


https://electronics.stackexchange.com/questions/477264/monochromatic-leds

# (find-fline    "/usr/local/texlive/2019/texmf-dist/doc/lualatex/luamesh/")
# (find-pdf-page "/usr/local/texlive/2019/texmf-dist/doc/lualatex/luamesh/luamesh-doc.pdf")

# (find-tlsh "find * | sort | grep quran")
# (find-tlsh "find * | sort | grep quran-doc")
# (find-tlsh "find * | sort | grep quran.sty")
# https://tex.stackexchange.com/questions/497591/how-to-write-quran-via-latex
# http://linorg.usp.br/CTAN/macros/xetex/latex/quran/doc/quran-doc.tex
# (find-tlfile "texmf-dist/doc/xelatex/quran/")
# (find-tlfile "texmf-dist/tex/xelatex/quran/")
# (find-tlfile "texmf-dist/tex/xelatex/quran/qurantext-simple.def")

https://tex.stackexchange.com/questions/1319/showcase-of-beautiful-typography-done-in-tex-friends

https://github.com/jonsterling/latex-dieudonne

https://www.tug.org/TUGboat/tb41-1/tb127reviews-romano.pdf

http://www.eprg.org/G53DOC/pdfs/knuth-plass-breaking.pdf Breaking Paragraphs into Lines (1981)

https://dvisvgm.de/

https://tex.stackexchange.com/questions/246/when-should-i-use-input-vs-include
https://www.overleaf.com/learn/latex/A_six-part_series%3A_How_do_TeX_macros_actually_work%3F

https://www.tug.org/TUGboat/tb33-2/tb104verna.pdf Star TEX: The Next Generation - Didier Verna
https://mathpix.com/blog/image-to-latex-converter
https://github.com/aclements/latexrun

https://archive.org/details/lshort
https://texdoc.org/serve/visualFAQ.pdf/0

https://www.tug.org/twg/mactex/tutorials/ltxprimer-1.0.pdf
https://fanpu.io/blog/2023/latex-tips/

https://www.user.tu-berlin.de/laurmaedje/programmable-markup-language-for-typesetting.pdf
https://news.ycombinator.com/item?id=34491563 KeenType: Pure Java typesetting system (github.com/davejarvis)
https://news.ycombinator.com/item?id=34689213 Knuth-Plass Thoughts (github.com/jaroslov) - long river
https://github.com/latex3/latex2e/issues/194 Underbrace is a bit discontinuous #194
https://news.ycombinator.com/item?id=39137755 I don't always use LaTeX, but when I do, I compile to HTML (2013) (peterkrautzberger.org)
https://tex.stackexchange.com/questions/425098/which-opentype-math-fonts-are-available/425099#425099
https://tex.stackexchange.com/questions/425098/which-opentype-math-fonts-are-available

;; (find-elocus-links "C-c C-e" 'LaTeX-mode-map)
;; (find-efunctiondescr  'LaTeX-environment)
;; (find-efunction       'LaTeX-environment)




#  Local Variables:
#  coding:               utf-8-unix
#  End:
